-- name=int_button_collectibles2
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_button_collectibles2", interface.originhub );
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );
  private.collect_loaded = false;

  private.DIRECTION =  -1;
  private.MOUSE_OVER_ANIM_TIME = 0.3;
  private.MOVE_ANIM_POS_X_BEG =   -150;
  private.MOVE_ANIM_POS_X_END =   128;
  private.MOVE_ANIM_TIME      =  0.6;
  private.show  = false; --на экране или нет
  private.timer = 3; --время таймера

  private.WideScreenUpdate();

  ObjMultiSet({

    { "int_button_collectibles2", { pos_z = pos_z }},
    { "obj_int_button_collectibles2", { pos_x = private.MOVE_ANIM_POS_X_BEG }},
    { "obj_int_button_collectibles2_button", {event_mdown = function () private.GoCollectibles2() end} }, 
    { "obj_int_button_collectibles2_other", {event_mdown = function () public.Hide() end} },
 
  });

end;
--******************************************************************************************
function public.Destroy()

   MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );
 
end;
--******************************************************************************************
function public.Show ()

  ObjSet( "obj_int_button_collectibles2", { active = true, visible = true, input = true } );
  private.show = true;
  private.ShowAnim( "show");
  common_impl.TutorialShow( "tutorial_page_23" );
  
end;
--******************************************************************************************
function public.Hide ()

  ObjSet( "obj_int_button_collectibles2", { input = false } );
  private.show = false;
  private.HideAnim( "hide" );

end;
--******************************************************************************************
function private.WideScreenUpdate()

  local direction = private.DIRECTION or 0;

  if ( direction ~= 0 ) and ObjGet( "int_button_collectibles2" ) then
   
    local offset = 0.5 * ( GetAppWidth() - 1024 );
    local position =  0;
    local posx = position + ( direction * offset );
    local pos_obj = ObjGet( "obj_int_button_collectibles2_other" ).pos_x;
  
    ObjSet( "int_button_collectibles2", { pos_x = posx } );
    ObjSet( "obj_int_button_collectibles2_other", { pos_x = pos_obj - posx } );

  end;

end;
--******************************************************************************************
function private.EventAnimEnd ( event_id )

  if ( event_id == "show" ) then

    --ObjSet( "obj_int_button_collectibles2", { input = true } );
    ObjSet( "tmr_int_button_collectibles2_hide", { endtrig = public.Hide, time = private.timer, playing = true } );

  elseif ( event_id == "hide" ) then

    ObjSet( "obj_int_button_collectibles2", { active = true, visible = false } );
    --ObjSet( "obj_int_button_collectibles2", { input = false } );

  end;
  
end;
--******************************************************************************************
function private.GoCollectibles2 ()

  ObjSet( "tmr_common_anm", { active = false } );

  local func_after = function()

    common_impl.Lock(false);
    common_impl.EnterBonusRm( "rm_collectibles2" );

  end;
  
  if common.GetCurrentSubRoom() then

     common.CloseSubRoom();
     common_impl.Lock(true);
     ObjSet( "tmr_int_button_collectibles2_go_to_rm", { endtrig = func_after, time = 0.2, playing = true } );

  else

    func_after();

  end;

  ObjSet( "tmr_int_button_collectibles2_hide", { endtrig = public.Hide, time = 0.01, playing = true } );

end;
--******************************************************************************************
function private.ShowAnim ( event_id )

  local obj       = "obj_int_button_collectibles2";
  local func_end  = function () private.EventAnimEnd( event_id ); end;
  local tme       = private.MOVE_ANIM_TIME;

  private.SetCounter( ng_global.collectibles2.coin_count );

  ObjSet( "obj_int_button_collectibles2", { alp = 1 } );
  ObjStopAnimate( obj, "pos_x" ); 
  ObjSet( "tmr_int_button_collectibles2_hide", { playing = false } );

  ObjSet( "spr_int_button_collectibles2_frame_1", { pos_y = 0 } );
  ObjSet( "spr_int_button_collectibles2_frame_2", { pos_y = 0 } );

  local func_show_end = function ()

    AnimPlay( "anm_int_button_collectibles2_button_money", "DoAnim", func_end );

    private.ShowAnimCounter( ng_global.collectibles2.coin_count );

  end;

  local current_posx = ObjGet( obj ).pos_x; 
  local distance = math.abs( private.MOVE_ANIM_POS_X_BEG - current_posx );

  common_impl.PlayAudio( "sfx", "common/audio/aud_achievement_show", 0, "", 0 );

  if ( distance ~= 0 ) then

    local overtime = distance * ( tme / ( private.MOVE_ANIM_POS_X_END - private.MOVE_ANIM_POS_X_BEG ) );
    ObjAnimate( obj, "pos_x", 0, 0, func_show_end,
    {
      0.0,          2, current_posx,
      overtime,     2, private.MOVE_ANIM_POS_X_BEG,
      overtime+tme, 2, private.MOVE_ANIM_POS_X_END

    } );
  
  else
  
    ObjAnimate( obj, "pos_x", 0, 0, func_show_end,
    {
      0.0, 2, private.MOVE_ANIM_POS_X_BEG,
      tme, 2, private.MOVE_ANIM_POS_X_END

    } );
  
  end;

end;
--******************************************************************************************
function private.SetCounter ( coin_count )

  local units_old  = ( coin_count - 1 ) % 10;
  local scores_old = ( coin_count - 1 - units_old ) / 10;

  ObjSet( "txt_int_button_collectibles2_num_coins_unit",   { text = units_old } );
  ObjSet( "txt_int_button_collectibles2_num_coins_scores", { text = scores_old } );

end;
--******************************************************************************************
function private.ShowAnimCounter ( coin_count )

  local units_old  = ( coin_count - 1 ) % 10;
  local scores_old = ( coin_count - 1 - units_old ) / 10;

  local units_new  = coin_count % 10;
  local scores_new = ( coin_count - units_new ) / 10;

  ObjClone( "spr_int_button_collectibles2_frame_1", "_2", 1, "obj_int_button_collectibles2_button_crop" );

  ObjSet( "txt_int_button_collectibles2_num_coins_unit",   { text = units_old } );
  ObjSet( "txt_int_button_collectibles2_num_coins_unit_2", { text = units_new } );

  local func_anim_end = function ()

    ObjDelete( "spr_int_button_collectibles2_frame_1_2" );

    ObjSet( "spr_int_button_collectibles2_frame_1",        { pos_y = 0,  } );
    ObjSet( "txt_int_button_collectibles2_num_coins_unit", { text = units_new } );

  end;

  ObjAnimate( "spr_int_button_collectibles2_frame_1",   "pos_y", 0, 0, func_anim_end, { 0,0,0,  0.4,0,70 } );
  ObjAnimate( "spr_int_button_collectibles2_frame_1_2", "pos_y", 0, 0, "", { 0,0,-70,  0.4,0,0 } );

  if ( scores_old ~= scores_new ) then

    ObjClone( "spr_int_button_collectibles2_frame_2", "_2", 1, "obj_int_button_collectibles2_button_crop" );

    ObjSet( "txt_int_button_collectibles2_num_coins_scores",   { text = scores_old } );
    ObjSet( "txt_int_button_collectibles2_num_coins_scores_2", { text = scores_new } );

    local func_anim_2_end = function ()

      ObjDelete( "spr_int_button_collectibles2_frame_2_2" );

      ObjSet( "spr_int_button_collectibles2_frame_2",          { pos_y = 0,  } );
      ObjSet( "txt_int_button_collectibles2_num_coins_scores", { text = scores_new } );

    end;

    ObjAnimate( "spr_int_button_collectibles2_frame_2",   "pos_y", 0, 0, func_anim_2_end, { 0,0,  0,  0.4,0,70 } );
    ObjAnimate( "spr_int_button_collectibles2_frame_2_2", "pos_y", 0, 0, "", { 0,0,-70,  0.4,0,0 } );

  end;

end;
--******************************************************************************************
function private.HideAnim ( event_id )

  local obj           = "obj_int_button_collectibles2";
  local func_end      = function () private.EventAnimEnd( event_id ); end;
  local tme           = private.MOVE_ANIM_TIME;
  local current_posx  = private.MOVE_ANIM_POS_X_END;

  ObjStopAnimate( obj, "pos_x" ); 
  current_posx = ObjGet( obj ).pos_x; 

  common_impl.PlayAudio( "sfx", "common/audio/aud_achievement_hide", 0, "", 0 );  
  ObjAnimate( obj, "pos_x", 0, 0, func_end,
  {
    0.0, 1, current_posx,
    tme, 1, private.MOVE_ANIM_POS_X_BEG

  } );

  ObjSet( "tmr_int_button_collectibles2_hide", { playing = false } );

end;
--******************************************************************************************
function private.MouseEnter ()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_collectibles2_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1

  } );

  ObjSet( "tmr_int_button_collectibles2_hide", { active = false } );

end;
--******************************************************************************************
function private.MouseLeave ()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_collectibles2_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0

  } );

  ObjSet( "tmr_int_button_collectibles2_hide", { active = true } );

end;
--******************************************************************************************