-- name=int_button_hint_impl
function public.Init ()

  public.DIRECTION = 1;
  public.POSITION = 932;

  private.RELOAD_ANIM_FRAME_COUNT = 17;
  private.RELOAD_BEGIN_ANIM_TIME  = 0; -- время "ухода" жабы, зависит от тита лягушки
  private.RELOAD_ANIM_TIME  = 0; -- время "прихода" жабы, зависит от тита лягушки
  private.RELOAD_VID_FRAME_COUNT = 3600;
  private.BUTTON_MOUSE_OVER_ANIM_TIME = 0.3;
  private.SHOW_ANIM_TIME = 0.3;
  private.POS_X = 932;


  ObjSet("spr_int_button_hint_button_back", {
    event_mdown = int_button_hint.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  });

  ObjSet("obj_int_button_hint_button", {
    event_mdown = int_button_hint.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  });

end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then
    ObjSet( "int_button_hint_impl", { pos_x = public.POSITION } );
  else
    ObjSet( "int_button_hint_impl", { pos_x = public.POSITION + 171 } );
  end;

end;
--******************************************************************************************
function public.ShowAnim( event_id )

  local trg = function () int_button_hint.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "obj_int_button_hint_impl", "alp", 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

end;
--******************************************************************************************
function public.HideAnim( event_id )

  local trg = function () int_button_hint.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "obj_int_button_hint_impl", "alp", 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function public.ChangeToStatic()

  ObjSet( "obj_int_button_hint_static", { active = true, visible = true } );
  ObjSet( "anm_int_button_hint_static", { active = true, visible = true } );
  ObjSet( "anm_int_button_hint_providence_static", { active = true, visible = true } );
  ObjSet( "obj_int_button_hint_reload", { active = false, visible = false } );
  ObjSet( "anm_int_button_hint_loader", { active = false, visible = false } );
  ObjSet( "anm_int_button_hint_providence_loader", { active = false, visible = false } );
  ObjSet( "anm_int_button_hint_close", { active = false, visible = false } );
  ObjSet( "anm_int_button_hint_providence_close", { active = false, visible = false } );

  public.StartAnimStatic();
  AnimPlay( "anm_int_button_hint_static", "DoAnim", function () end );
  AnimPlay( "anm_int_button_hint_providence_static", "DoAnim", function () end );

end;
--******************************************************************************************
function public.ChangeToReload( is_begin )


  ObjSet( "obj_int_button_hint_static", { active = false, visible = false } );
  ObjSet( "anm_int_button_hint_loader", { active = true, visible = true } );
  ObjSet( "anm_int_button_hint_providence_loader", { active = true, visible = true } ); 

  ObjSet( "anm_int_button_hint_static", { active = false, visible = false } );
  ObjSet( "anm_int_button_hint_providence_static", { active = false, visible = false } );
  ObjSet( "obj_int_button_hint_reload", { active = true, visible = true } );

  if ( is_begin ) then

    public.ReloadAnim( true );    

  else

    public.ReloadAnim( false );

  end;

end;
--******************************************************************************************
function public.ReloadAnim( is_first )

  if ( is_first ) then

  else 

    

  end;

  if ( not ObjGet( "tmr_int_button_hint_reload" ) ) then
    return;
  end;

  local time_min    = int_button_hint.GetTimeMin();
  local time_remain = int_button_hint.GetTimeRemain();
  local time_full   = int_button_hint.GetTimeFull();

  local frame_count = private.RELOAD_ANIM_FRAME_COUNT;
  local vid_frame_count = private.RELOAD_VID_FRAME_COUNT;

  --  время на один фрейм
  local time_frame = time_full / frame_count;
  local vid_time_frame = time_full / vid_frame_count;  

  local time_current = time_full - time_remain;
  local frame_current = math.floor( time_current / time_frame );
  local vid_frame_current = math.floor( time_current / vid_time_frame );

  ObjSet( "anm_int_button_hint_active_hint_timer", { frame = frame_current } );
  ObjSet( "anm_int_button_hint_loader", { frame = vid_frame_current } );
  ObjSet( "anm_int_button_hint_providence_loader", { frame = vid_frame_current } );

  ObjSet( "tmr_int_button_hint_reload", { endtrig = "" });

  if ( frame_current < (frame_count) ) then

    local trg = "int_button_hint_impl.ReloadAnim();";    
    ObjSet( "tmr_int_button_hint_reload_anim", { endtrig = trg, time = time_min, playing = true } );

  else
    
    private.EndAnimReload();
    ObjSet( "anm_int_button_hint_loader", { active = false, visible = false } );
    ObjSet( "anm_int_button_hint_providence_loader", { active = false, visible = false } );

  end;

end;
--******************************************************************************************
-- конец анимации зарядки хинта
function private.EndAnimReload()

  int_button_hint.EventAnimEnd( 'reload' );
  AnimStop( "anm_int_button_hint_loader");
  AnimStop( "anm_int_button_hint_providence_loader");
  ObjSet( 'anm_int_button_hint_loader', { frame = 0 } );
  ObjSet( 'anm_int_button_hint_providence_loader', { frame = 0 } );
  ObjSet( 'obj_int_button_hint', { alp = 1 } );

end;
--******************************************************************************************
function public.SetHardcore( is_hardcore )

  if ( is_hardcore ) then

    ObjSet( "obj_int_button_hint_active",   { visible = false } );
    ObjSet( "obj_int_button_hint_hardcore", { active = true, visible = true } );
    --ObjSet( "obj_int_button_hint_button",   { input = false, visible = false } );

  else

    ObjSet( "obj_int_button_hint_hardcore", { active = false, visible = false } );
    ObjSet( "obj_int_button_hint_active",   { visible = true } );
    ObjSet( "obj_int_button_hint_button",   { input = true, visible = true } );

  end;

end;
--******************************************************************************************
-- старт анимации зарядки хинта
function public.StartAnimReload()

  PlaySfx( "assets/levels/common/audio/aud_hinton_sfx", 0, "", 0 );

  if ng_global.widget.hint_type_frog == 1 then

    PlaySfx( "assets/levels/common/audio/oth/aud_hinton_sfx", 0, "", 0 );

  elseif ng_global.widget.hint_type_frog == 2 then

    ObjSet( 'obj_int_button_hint', { pos_x = -15, pos_y = 32 } );
    ObjSet( "obj_anm_int_button_hint_reload", { pos_x = 58, pos_y = -77, ang = -4.25 } );
    ObjStopAnimate( "obj_anm_int_button_hint_reload", 7 );
    ObjStopAnimate( "obj_anm_int_button_hint_reload", 3 );
    ObjAnimate( "obj_anm_int_button_hint_reload", 7, 0, 0, "", { 0,3,-4.25, 0.5,3,0 });
    ObjAnimate( "obj_anm_int_button_hint_reload", 3, 0, 0, "", { 0,1,58,-77, 0.15,0,-7,-96, 0.3,1,-67,-71, 0.5,0,58,-77 });
    PlaySfx( "assets/levels/common/audio/oth/aud_hinton_sfx", 0, "", 0 );

  elseif ng_global.widget.hint_type_frog == 3 then

    PlaySfx( "assets/levels/common/audio/oth/aud_hinton_sfx", 0, "", 0 );

  elseif ng_global.widget.hint_type_frog == 4 then

    PlaySfx( "assets/levels/common/audio/oth/aud_hinton_sfx", 0, "", 0 );
    ObjStopAnimate( "obj_int_button_hint", 1 );
    ObjSet( "obj_int_button_hint", { pos_x = 2, pos_y = 32 } );
    local posy = ObjGet( "obj_int_button_hint" ).pos_y;
    ObjAnimate( "obj_int_button_hint", 1, 1, 0, "", { 0,3,posy, 0.5,3,posy-2, 1.5,3,posy+2, 2,3,posy });

  end; 

end;
--******************************************************************************************
-- конец анимации зарядки хинта
function private.EndAnimReload()

  int_button_hint.EventAnimEnd( 'reload' );
  AnimStop( "anm_int_button_hint_providence_loader");
  AnimStop( "anm_int_button_hint_loader");
  ObjSet( 'anm_int_button_hint_loader', { frame = 0 } );
  ObjSet( 'anm_int_button_hint_providence_loader', { frame = 0 } );
  ObjSet( 'obj_int_button_hint', { alp = 1 } );
  

end;
--******************************************************************************************
-- старт анимации "разрядки" хинта
function public.StartAnimReloadBegin()

  ObjSet( "anm_int_button_hint_active_hint_timer", { frame = 0 } );
  ObjSet( "anm_int_button_hint_loader", { active = false, visible = false } );  
  ObjSet( "anm_int_button_hint_close", { active = true, visible = true } );
  ObjSet( "anm_int_button_hint_static", { active = false, visible = false } );    
  ObjSet( "anm_int_button_hint_close", { alp = 1 } );
  ObjSet( "anm_int_button_hint_providence_loader", { active = false, visible = false } );  
  ObjSet( "anm_int_button_hint_providence_close", { active = true, visible = true } );
  ObjSet( "anm_int_button_hint_providence_static", { active = false, visible = false } );    
  ObjSet( "anm_int_button_hint_providence_close", { alp = 1 } );
  AnimStop( "anm_int_button_hint_close" );
  AnimStop( "anm_int_button_hint_providence_close" );
  local endtrig = function()

    ObjSet( 'anm_int_button_hint_close', { active = false, visible = false } );
    ObjSet( 'anm_int_button_hint_loader', { visible = true } );
    ObjSet( 'anm_int_button_hint_providence_close', { active = false, visible = false } );
    ObjSet( 'anm_int_button_hint_providence_loader', { visible = true } );

  end;

  AnimPlay( "anm_int_button_hint_close", "DoAnim", "*ObjSet( 'anm_int_button_hint_close', { active = false, visible = false } );ObjSet( 'anm_int_button_hint_loader', { visible = true } );");
  AnimPlay( "anm_int_button_hint_providence_close", "DoAnim", "*ObjSet( 'anm_int_button_hint_providence_close', { active = false, visible = false } );ObjSet( 'anm_int_button_hint_providence_loader', { visible = true } );");

end;
--******************************************************************************************
-- конец анимации "разрядки" хинта
function private.EndAnimReloadBegin()

  ObjStopAnimate( "obj_int_button_hint", 1 );
  ObjStopAnimate( "obj_int_button_hint", 3 );
  ObjStopAnimate( "obj_int_button_hint", 8 );
  ObjStopAnimate( "obj_anm_int_button_hint_reload", 3 );
  ObjStopAnimate( "obj_anm_int_button_hint_reload", 7 );

  ObjSet( "anm_int_button_hint_active_hint_timer", { frame = 0 } );
  ObjSet( 'anm_int_button_hint_reload_begin', { active  = false, visible = false, trg = "" } );
  ObjSet( 'obj_int_button_hint', { alp = 1 } );

end;
--******************************************************************************************
function private.MouseEnterAnim()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_hint_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.BUTTON_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_hint_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.BUTTON_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );


end;
--******************************************************************************************
-- старт анимации "статики" хинта
function public.StartAnimStatic()

  ObjSet( "anm_int_button_hint_active_hint_timer", { frame = private.RELOAD_ANIM_FRAME_COUNT } );

  ObjSet( "tmr_int_button_hint_reload", { playing = false } );


end;

--смена жабы для провидения и обратно
function public.ChangeToProvidence( flag )

  local end_trig = function()

    if flag then

     ObjSet( "obj_int_button_hint_static_not_providence", { visible = 0 } );
     ObjSet( "obj_int_button_hint_not_providence", { visible = 0 } );
     ObjSet( "obj_int_button_hint_static_providence", { visible = 1 } );
     ObjSet( "obj_int_button_hint_providence", { visible = 1 } );
     ObjSet( "spr_int_button_hint_button_back_providence", { visible = 1 } );

    else

     ObjSet( "obj_int_button_hint_static_not_providence", { visible = 1 } );
     ObjSet( "obj_int_button_hint_not_providence", { visible = 1 } );
     ObjSet( "obj_int_button_hint_static_providence", { visible = 0 } );
     ObjSet( "obj_int_button_hint_providence", { visible = 0 } );
     ObjSet( "spr_int_button_hint_button_back_providence", { visible = 0 } );

    end;

  end;

  ObjSet( "tmr_int_button_hint_change", { playing = true, time = 0.5, endtrig = end_trig } );
  AnimPlay( "anm_int_button_hint_change_providence", "DoAnim", "" );

end;