-- name=int_button_map_impl
--******************************************************************************************
function public.Init ()
  --
  public.DIRECTION = -1;
  public.POSITION = 80;

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  ObjSet("obj_int_button_map", {
    event_mdown = int_button_map.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  });

  ObjSet("spr_int_button_map_button", {
    event_mdown = int_button_map.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  });

end;
--******************************************************************************************
function private.MouseEnterAnim()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_map_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );
  ObjAnimate( "spr_int_button_map_icon", "pos_xy", 0, 0, "",
  {
    0.0, 1, ObjGet( "spr_int_button_map_icon" ).pos_x, ObjGet( "spr_int_button_map_icon" ).pos_y,
    tme, 1, 19, -10
  } );

  ObjAnimate( "spr_int_button_map_icon_2", "pos_xy", 0, 0, "",
  {
    0.0, 1, ObjGet( "spr_int_button_map_icon_2" ).pos_x, ObjGet( "spr_int_button_map_icon_2" ).pos_y,
    tme, 1, -13, -14
  } );

end;
--******************************************************************************************
function private.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT ); 
  local obj = "spr_int_button_map_button_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

  ObjAnimate( "spr_int_button_map_icon", "pos_xy", 0, 0, "",
  {
    0.0, 1, ObjGet( "spr_int_button_map_icon" ).pos_x, ObjGet( "spr_int_button_map_icon" ).pos_y,
    tme, 1, 10, -16
  } );

  ObjAnimate( "spr_int_button_map_icon_2", "pos_xy", 0, 0, "",
  {
    0.0, 1, ObjGet( "spr_int_button_map_icon_2" ).pos_x, ObjGet( "spr_int_button_map_icon_2" ).pos_y,
    tme, 1, -10, -15
  } );

end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then

    ObjSet( "int_button_map_impl", { pos_x = public.POSITION } );
  
  else

    ObjSet( "int_button_map_impl", { pos_x = public.POSITION - 171 } );

  end;

end;
--******************************************************************************************