-- name=int_button_providence
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_button_providence", "obj_int_panel_providence" );
  ObjSet( "int_button_providence", { pos_x = 0, pos_y = 0, pos_z = pos_z } );

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  ObjSet("obj_int_button_providence", {
    event_mdown = public.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  });

end;
--******************************************************************************************
function public.Destroy()

end;
--******************************************************************************************
function private.MouseEnterAnim()

  interface.InventoryOpen();

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_button_providence_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.MouseLeaveAnim()

  interface.InventoryClose();

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_button_providence_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function public.MouseDown()

  if not int_providence.show then

    ObjSet( "tmr_common_anm", { active = false } );

    local current_room = GetCurrentRoom();
    if ( current_room == "" or current_room == nil ) then
      current_room = ng_global.progress[ ng_global.currentprogress ].common.currentroom or "rm_pier";
    end;
    
    if ( common.GetObjectPrefix( current_room ) == "rm" ) then
      cmn.CallEventHandler( "clk_providence_"..common.GetObjectName( current_room ) );
    end;

    int_providence.Show();

  else

    ObjSet( "tmr_common_anm", { active = true } );
    int_providence.Hide();
    public.StopActiveProvidence();

  end;

end;
--******************************************************************************************
function public.StartLightProvidence()

  interface.InventoryOpen();

  ObjSet( "spr_int_button_providence", { alp = 0 } );

  local func = function()

    ObjSet( "anm_int_button_providence_open", { alp = 0 } );    
    ObjSet( "anm_int_button_providence_static", { alp = 1 } );
    AnimPlay( "anm_int_button_providence_static", "static", "" );

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_on", 0, "", 0 );

  ObjSet( "anm_int_button_providence_open", { alp = 1 } );
  AnimPlay( "anm_int_button_providence_open", "open", func );

end;
--******************************************************************************************
function public.StopLightProvidence()

  ObjSet( "anm_int_button_providence_static", { alp = 0 } );
  AnimStop( "anm_int_button_providence_static" );
  AnimStop( "anm_int_button_providence_open" );

  local func = function()

    ObjSet( "anm_int_button_providence_close", { alp = 0 } );    
    ObjSet( "spr_int_button_providence", { alp = 1 } );

  end;

  common_impl.StopAudio( "sfx", "common/audio/aud_providence_on", 0, "", 0 );

  ObjSet( "anm_int_button_providence_close", { alp = 1 } );
  AnimPlay( "anm_int_button_providence_close", "close", func );

end;
--******************************************************************************************
function public.StartActiveProvidence()

  ObjSet( "anm_int_button_providence_active", { alp = 1 } );
  AnimPlay( "anm_int_button_providence_active", "DoAnim", "" );

end;
--******************************************************************************************
function public.StopActiveProvidence()

  ObjSet( "anm_int_button_providence_active", { alp = 0 } );

end;
--******************************************************************************************