-- name=int_dialog_evidence
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_dialog_evidence", interface.originhub );
  ObjSet( "int_dialog_evidence", { pos_z = pos_z } );
  private.SHOW_ANIM_TIME = 0.5;
  private.SKIP_MOUSE_OVER_ANIM_TIME = 0.5;
  private.show = 0;
  private.show_obj = "";

  private.FuncHide = nil;

end;
--******************************************************************************************
function public.Destroy()

end;
--******************************************************************************************
function public.Show ( obj_name, func_hide, no_bbt )

  private.show_obj = "obj_evidence_"..obj_name;
  private.FuncHide = func_hide;

  ObjSet( "obj_int_dialog_evidence", { active = true, visible = true, alp = 0 } );

  ObjAttach( private.show_obj, "obj_int_dialog_evidence" );
  ObjSet( private.show_obj, { pos_x = 0, pos_y = 0 } );

  common_impl.Lock( true );

  local tme = private.SHOW_ANIM_TIME;
  local trg = function()

    common_impl.Lock( false );

    private.show = true;

    ObjSet( "obj_int_dialog_evidence", { input = true } );
    ObjSet( private.show_obj, { input = true } );

  end;

  if not no_bbt then
  
    common_impl.ShowBbt( "bbt_evidence_"..obj_name );

  end;

  ObjAnimate( "obj_int_dialog_evidence", "alp", 0, 0, trg, 
  { 
    0.0, 3, 0,
    tme, 3, 1
  } );
  
  if tostring(obj_name) == "evidence_2_4_progress" then
    if port.ios_lang() == "fr" then
      ObjSet( "spr_evidence_evidence_2_4_paper_big_deleted_2", { pos_x = 98, pos_y = 41 } );
      ObjSet( "txt_evidence_evidence_2_4_paper_big_new_text_2", { pos_x = 98, pos_y = 41 } );
    end;
    if port.ios_lang() == "ja" then
      ObjSet( "txt_evidence_evidence_2_4_paper_2",{ fontsize = 21 });
      ObjSet( "txt_evidence_evidence_2_4_paper_big_2",{ fontsize = 21 });
      ObjSet( "spr_evidence_evidence_2_4_paper_big_deleted_2", { pos_x = 54, pos_y = 44 } );
      ObjSet( "txt_evidence_evidence_2_4_paper_big_new_text_2", { pos_x = 54, pos_y = 44 } );
    end;
    if port.ios_lang() == "ru" then
      ObjSet( "spr_evidence_evidence_2_4_paper_big_deleted_2", { pos_x = -21, pos_y = 50 } );
      ObjSet( "txt_evidence_evidence_2_4_paper_big_new_text_2", { pos_x = -21, pos_y = 50 } );
    end;
  end;
  
end;
--******************************************************************************************
function public.Hide ()

  common_impl.Lock( true );
  local tme = private.SHOW_ANIM_TIME;

  local trg = function()

    common_impl.Lock( false );
    private.show = false;

    if ( private.FuncHide ) then

      private.FuncHide();

    end;

    ObjSet( "obj_int_dialog_evidence", { active = false, visible = false, input = false } );

    ObjDetach( private.show_obj );
    ObjSet( private.show_obj, { input = false } );

    private.FuncHide = nil;
    private.show_obj = nil;

  end;
  
  ObjAnimate( "obj_int_dialog_evidence", "alp", 0, 0, trg, 
  {  
    0.0, 3, 1,
    tme, 3, 0 
  } );
  
end;
--******************************************************************************************
function private.ExitMouseEnterAnim ()

  SetCursor( CURSOR_DOWN );

  local obj = "int_dialog_evidence_exit_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0, 2, alp,
    tme, 2, 1 
  } );
  
end;
--******************************************************************************************
function private.ExitMouseLeaveAnim ()

  SetCursor( CURSOR_DEFAULT );

  local obj = "int_dialog_evidence_exit_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0, 1, alp,
    tme, 1, 0  
  } );
  
end;
--******************************************************************************************
function private.CloseMouseEnterAnim()

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_dialog_evidence_close_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0, 2, alp,
    tme, 2, 1 
  } );
  
end;
--******************************************************************************************
function private.CloseMouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_dialog_evidence_close_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0, 1, alp,
    tme, 1, 0 
  } );
  
end;
--******************************************************************************************