-- name=int_evidence
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_evidence", interface.originhub );
  ObjSet( "int_evidence", { pos_z = pos_z } );

  private.show = false;
  private.SHOW_ANIM_TIME = 0.4;
  private.MOUSE_OVER_ANIM_TIME = 0.3

  private.click_1_7 = false;

  private.DCN_ARRAY = {

    { { name = "evidence_1_1", level = 1 }, { name = "evidence_1_2", level = 1 }, { name = "evidence_1_3", level = 1 } },
    { { name = "evidence_1_4", level = 1 }, { name = "evidence_1_5", level = 1 }, { name = "evidence_1_6", level = 1 } },
    { { name = "evidence_1_7", level = 1 }, { name = "evidence_1_8", level = 1 }, { name = "evidence_1_9", level = 1 } },
    { { name = "evidence_2_1", level = 2 }, { name = "evidence_2_2", level = 2 }, { name = "evidence_2_3", level = 2 } },
    { { name = "evidence_2_4", level = 2 }, { name = "evidence_2_5", level = 2 }, { name = "evidence_2_6", level = 2 } },
    { { name = "evidence_3_1", level = 3 }, { name = "evidence_3_2", level = 3 }, { name = "evidence_3_3", level = 3 } },
    { { name = "evidence_3_4", level = 3 }, { name = "evidence_3_5", level = 3 }, { name = "evidence_3_6", level = 3 } },
    { { name = "evidence_6_1", level = 7 }, { name = "evidence_6_2", level = 7 }, { name = "evidence_6_3", level = 7 } } --AK> tmp

  };

  for i = 1, #private.DCN_ARRAY do

    for j = 1, #private.DCN_ARRAY[ i ] do

      local object = private.DCN_ARRAY[ i ][ j ].name

      ObjSet( "obj_evidence_"..object.."_click", 
      {
        event_mdown = function () private[ "click_"..object ](); end,
        event_menter = function () SetCursor( CURSOR_LOUPE ); end,
        event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
      } );

      ObjSet( "obj_evidence_page"..i.."_"..object, 
      {
        event_mdown = function () private.ShowEvidence( object ); end,
        event_menter = function () SetCursor( CURSOR_LOUPE ); end,
        event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
      } );

    end;

  end;

  ObjSet( "obj_evidence_evidence_2_4_progress_clk", 
  {
    event_mdown = function () private[ "click_evidence_2_4_progress" ](); end,
    event_menter = function () SetCursor( CURSOR_LOUPE ); end,
    event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
  } );

  ObjSet( "obj_evidence_evidence_2_3_progress_clk", 
  {
    event_mdown = function () private[ "click_evidence_2_3_progress" ](); end,
    event_menter = function () SetCursor( CURSOR_LOUPE ); end,
    event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
  } );

  ObjSet( "obj_evidence_evidence_3_3_progress_clk", 
  {
    event_mdown = function () private[ "click_evidence_3_3_progress" ](); end,
    event_menter = function () SetCursor( CURSOR_LOUPE ); end,
    event_mleave = function () SetCursor( CURSOR_DEFAULT ); end
  } );

  ObjSet( "btn_evidence_down", 
  {
    event_mdown = function () private.ChangePage( 1 ); end,
    event_menter = function () private.MouseEnterAnim( "spr_evidence_down" ); end,
    event_mleave = function () private.MouseLeaveAnim( "spr_evidence_down" ); end
  } );

  ObjSet( "btn_evidence_up", 
  {
    event_mdown = function () private.ChangePage( -1 ); end,
    event_menter = function () private.MouseEnterAnim( "spr_evidence_up" ); end,
    event_mleave = function () private.MouseLeaveAnim( "spr_evidence_up" ); end
  } );

  ObjSet( "spr_evidence_pages_set_button_show", 
  {
    event_menter = function () private.MouseEnterAnim( "spr_evidence_pages_set_button_show" ); end,
    event_mleave = function () private.MouseLeaveAnim( "spr_evidence_pages_set_button_show" ); end
  } );

  ObjSet( "spr_evidence_close", 
  {
    event_mdown = function () public.Hide(); end,
    event_menter = function () private.MouseEnterAnim( "spr_evidence_close" ); end,
    event_mleave = function () private.MouseLeaveAnim( "spr_evidence_close" ); end
  } );
  
  port.VideoResizeInRoom("evidence");
  
end;
--******************************************************************************************
function public.Destroy ()

  --

end;
--******************************************************************************************
function public.Show ()

  if ( private.show ) then

    return;

  end;

  ObjSet( "obj_int_evidence", { active = true, visible = true, alp = 0 } );

  common_impl.HideDeployInv();

  if ( private.page_current ) then

    ObjDetach( "obj_evidence_page"..( private.page_current - 1 ) );
    ObjDetach( "obj_evidence_page"..( private.page_current + 1 ) );
    ObjDetach( "obj_evidence_page"..( private.page_current ) );

  end;

  private.Update();

  common_impl.TutorialShow ( "tutorial_page_11" );
  --[[common_impl.TutorialSetShown ("tutorial_page_11");]]

  local trg = function () 

    common_impl.Lock( false );
    private.show = true;
    ObjSet( "obj_int_evidence", { input = true } );
 
  end;

  local tme = private.SHOW_ANIM_TIME;
  common_impl.Lock( true );

  ObjAnimate( "obj_int_evidence", "alp", 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

end;
--******************************************************************************************
function public.Hide ()

  local trg = function () 

    common_impl.Lock( false );
    private.show = false;

    ObjSet( "obj_int_evidence", { input = false } );

    for j = 1, #private.DCN_ARRAY[ private.page_current ] do

      local object    = private.DCN_ARRAY[ private.page_current ][ j ].name;
    
      ObjSet( "txt_evidence_page"..private.page_current.."_title", { visible = false } );
      ObjSet( "spr_evidence_page"..private.page_current.."_small_"..object, { alp = 0 } );
      ObjSet( "txt_evidence_page"..private.page_current.."_small_"..object, { visible = false } );
      ObjSet( "spr_evidence_page"..private.page_current.."_small_"..object.."_prewiev", { alp = 0 } );
      ObjSet( "obj_evidence_page"..private.page_current.."_"..object, { input = false } );

    end;
  end;

  local tme = private.SHOW_ANIM_TIME;
  common_impl.Lock( true );

  ObjAnimate( "obj_int_evidence", "alp", 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function private.ShowEvidence ( event )

  local small_pic = "spr_diary_page"..ng_global.diary_current_page.."_small_"..event;

  ObjAnimate( small_pic, "alp", 0, 0, "",

  { 
    0.0, 0, 1, 
    0.3, 0, 0 

  } );

  ObjSet( "obj_evidence_"..event.."_click", { input = true } );
  
  
  
  if tostring(event) == "evidence_2_4" then
    if port.ios_lang() == "fr" then
      ObjSet( "txt_evidence_evidence_2_4_tmpobject_6", { pos_x = 101 } );
    end;
    if port.ios_lang() == "ja" then
      ObjSet( "txt_evidence_evidence_2_4_tmpobject_6", { pos_x = 68 } );
    end;
    if port.ios_lang() == "en" then
      ObjSet( "txt_evidence_evidence_2_4_tmpobject_6", { pos_x = 39 } );
    end;
  end;
    
  interface.DialogEvidenceShow( event, function () private.HideEvidence( event ); end )
  
end;
--******************************************************************************************
function private.HideEvidence ( event )

  local small_pic = "spr_diary_page"..ng_global.diary_current_page.."_small_"..event;

  ObjAnimate( small_pic, "alp", 0, 0, "", 
  { 
    0.0, 0, 0, 
    0.3, 0, 1 
  } );
  
end;
--******************************************************************************************
function public.GetList ()

  return private.DCN_ARRAY;

end;
--******************************************************************************************
-- function ---*** Buttons Actions ***--- () end;
--******************************************************************************************
function private.MouseEnterAnim ( sender )

  SetCursor( CURSOR_HAND );
  
  local obj = sender.."_focus";

  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;
  
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0, 0, alp, 
    tme, 0,  1
  } );

end;

-------------------------------------------------------------------------------------
function private.MouseLeaveAnim ( sender )

  SetCursor( CURSOR_DEFAULT );
  
  local obj = sender.."_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0, 0, alp, 
    tme, 0,  0
  } ); 

end;
--******************************************************************************************
-- function ---*** Update Evidence Diary ***--- () end;
--******************************************************************************************
--[[function public.SetPage ( name )

  local page = nil;
  for i = 1, #private.DCN_ARRAY do

    for j = 1, #private.DCN_ARRAY[ i ] do

      if ( name == private.DCN_ARRAY[ i ][ j ].name ) then

         page = i;  

      end;

    end;  

  end;

  ng_global.diary_current_page = page or ng_global.diary_current_page;

end;]]
--******************************************************************************************
--[[function public.CheckInvestigation ( page )

  local page        = page or ng_global.investigation;
  local chapter     = ng_global.progress[ prg ].common.chapter;
  local current_lvl = tonumber( string.sub( chapter, -1 ) );  

  local count = 0;
  for i = 1, #private.DCN_ARRAY[ page ] do

    if ( private.DCN_ARRAY[ page ][ i ].level == current_lvl ) then
    
      local event = "get_"..private.DCN_ARRAY[ page ][ i ].name;
      if ( cmn.IsEventDone( event ) ) then
        count = count + 1;
      end;

    elseif ( private.DCN_ARRAY[ page ][ i ].level < current_lvl ) then

      count = count + 1;

    end;

  end;

  if ( count == #private.DCN_ARRAY[ page ] ) then
    return true;
  end;   

  return false;

end;]]
--******************************************************************************************
function private.Update ( page, obj_attach )

  local page_current    = page or ng_global.investigation;
  private.page_current  = page_current;
   
  local chapter         = ng_global.progress[ ng_global.currentprogress ].common.chapter;
  local current_lvl     = tonumber( string.sub( chapter, -1 ) );
  local evidence_count  = 0; 
  local obj_attach = obj_attach or "obj_evidence_pages";

  ObjAttach( "obj_evidence_page"..page_current, obj_attach );
  ObjSet( "obj_evidence_page"..page_current, { pos_x = -512, pos_y = -386 } )

  for j = 1, #private.DCN_ARRAY[ page_current ] do

    local need_show = false;
    local object    = private.DCN_ARRAY[ page_current ][ j ].name  
    local event     = "get_"..object;

    if ( private.DCN_ARRAY[ page_current ][ j ].level == current_lvl ) then
    
      if ( cmn.IsEventDone( event ) ) then

        need_show = true;

      end;

    elseif ( private.DCN_ARRAY[ page_current ][ j ].level < current_lvl ) then

      need_show = true;

    end;

    if ( need_show ) then

      evidence_count = evidence_count + 1;

      ObjSet( "txt_evidence_page"..page_current.."_title", { visible = true } );

      ObjSet( "spr_evidence_page"..page_current.."_small_"..object, { alp = 1 } );
      ObjSet( "txt_evidence_page"..page_current.."_small_"..object, { visible = true } );
      ObjSet( "spr_evidence_page"..page_current.."_small_"..object.."_prewiev", { alp = 0 } );
      ObjSet( "obj_evidence_page"..page_current.."_"..object, { input = true } );

    else
    
      ObjSet( "spr_evidence_page"..page_current.."_small_"..object, { alp = 0 } );
      ObjSet( "txt_evidence_page"..page_current.."_small_"..object, { visible = false } );
      ObjSet( "spr_evidence_page"..page_current.."_small_"..object.."_prewiev", { alp = 1 } );
      ObjSet( "obj_evidence_page"..page_current.."_"..object, { input = false } );

    end;

  end;

  for j = 1, 3 do

    ObjSet( "spr_evidence_pages_set_scale_"..j, { alp = 0 } );

  end;
  for j = 1, evidence_count do

    ObjSet( "spr_evidence_pages_set_scale_"..j, { alp = 1 } );

  end;

  if ( evidence_count == #private.DCN_ARRAY[ page_current ] )  then

    local func_show = function ()

      common_impl.Lock( true );
      ObjAnimate( "spr_evidence_pages_set_button_show_press", "alp", 0, 0, function () public.ShowFlashBack( page_current ); common_impl.Lock( false ); end, 
      { 
        0, 0, 0, 
        0.15, 0, 1, 
        0.3, 0, 0 
      } );

    end;

    ObjSet( "spr_evidence_pages_set_button_show", 
    {
      visible = true, 
      input = true, 
      active = true, 
      event_mdown = func_show
    } );

  else

      ObjSet( "spr_evidence_pages_set_button_show", { visible = true, input = false, active = false } );

  end;

  ObjSet( "btn_evidence_up", {  active = true, input = true, color_r = 1, color_g = 1, color_b = 1  } );
  ObjSet( "btn_evidence_down", {  active = true, input = true, color_r = 1, color_g = 1, color_b = 1 } );

  if ( page_current == 1 ) then

    ObjSet( "btn_evidence_up", {  active = false, input = false, color_r = 0.5, color_g = 0.5, color_b = 0.5 } );
    ObjSet( "spr_evidence_up_focus", { alp = 0 } );

  end;
  if ( page_current == ng_global.investigation ) then
  
    ObjSet( "btn_evidence_down", { active = false, input = false, color_r = 0.5, color_g = 0.5, color_b = 0.5 } );
    ObjSet( "spr_evidence_down_focus", { alp = 0 } );

  end;

end;
--******************************************************************************************
function private.ChangePage ( side )
  
  if ( not ObjGet( "obj_evidence_pages_change" ) ) then

    ObjClone( "obj_evidence_pages", "_change", 1, "obj_int_evidence" );

  end;

  local start_y = ObjGet( "spr_evidence_pages_back" ).pos_y;

  local func_active = function ()

    common_impl.Lock( false );
    ObjDetach( "obj_evidence_page"..( private.page_current - side ) )

  end;

  ObjDetach( "obj_evidence_page"..private.page_current );
  ObjDetach( "obj_evidence_page"..( private.page_current + side ) )

  private.Update( private.page_current, "obj_evidence_pages_change" );

  common_impl.Lock( true );

  ObjAnimate( "obj_evidence_pages_change", "pos_y", 0, 0, "", 
  { 
    0.0, 0, 0, 
    0.6, 0, - 768 * side 
  } );

  private.page_current = private.page_current + side;

  private.Update( private.page_current );

  ObjAnimate( "obj_evidence_pages", "pos_y", 0, 0, func_active, 
  { 
    0.0, 0, 768 * side, 
    0.6, 0, 0  
  } );  

end;
--******************************************************************************************
-- function ---*** Evidence's Events ***--- () end;
--******************************************************************************************
function private.click_evidence_1_1 ()

  ObjSet( "obj_evidence_evidence_1_1_click", { input = false } );
  ObjSet( "spr_diary_evidence_1_1", { visible = false } );
  interface.DialogEvidenceHide();
  --common_impl.TutorialShow( "tutorial_page_9" );

end;
--******************************************************************************************
function private.click_evidence_1_2 ()

  --ObjSet( "spr_evidence_evidence_1_2",{ visible = false });
  ObjSet( "obj_evidence_evidence_1_2_click",{ input = false } );
  interface.DialogEvidenceHide();

end;
--******************************************************************************************
function private.click_evidence_1_3 ()

  if ( not private.count_click_1_3 ) then
    private.count_click_1_3 = 0;
  end;

  if ( private.count_click_1_3 == 0 ) then

    private.count_click_1_3 = 1;
    common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page_1", 0, "", 0 );
    ObjSet( "obj_evidence_evidence_1_3_click",{ input = false });
    ObjAnimate( "spr_evidence_evidence_big",   "alp", 0, 0, "", { 0, 0, 1, 0.3, 3, 0 } );
    ObjAnimate( "spr_evidence_evidence_open",  "alp", 0, 0, function () ObjSet( "obj_evidence_evidence_1_3_click",{ input = true } ); end, { 0, 0, 0, 0.1, 0, 0, 0.3, 3, 1 } );

  elseif ( private.count_click_1_3 == 1 ) then

    private.count_click_1_3 = 2;
    common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page_2", 0, "", 0 );
    ObjSet( "obj_evidence_evidence_1_3_click",{ input = false });
    ObjAnimate( "spr_evidence_evidence_open_txt",   "alp", 0, 0, "", { 0, 0, 1, 0.2,  3, 0 } );
    ObjAnimate( "spr_evidence_evidence_open_2",     "alp", 0, 0, function () ObjSet( "obj_evidence_evidence_1_3_click",{ input = true } ); end, { 0, 0, 0, 0.05, 0, 0, 0.2, 3, 1 } );

  elseif ( private.count_click_1_3 == 2 ) then
  
    private.count_click_1_3 = 0;

    local func_end = function ()

      common_impl.Lock( false );
      common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page_3", 0, "", 0 );
      ObjSet( "spr_evidence_evidence_1_3",{ visible = false } );
      ObjSet( "obj_evidence_evidence_1_3_click", { input = true } );

      interface.DialogEvidenceHide();

    end;

    common_impl.Lock( true );
    ObjAnimate( "spr_evidence_evidence_big",   "alp", 0, 0, "",       { 0, 0, 0, 0.1, 0, 0, 0.3, 3, 1 } );
    ObjAnimate( "spr_evidence_evidence_open",  "alp", 0, 0, func_end, { 0, 0, 1, 0.3, 3, 0 } );

  end;

end;
--******************************************************************************************
function private.click_evidence_1_4 ()
  --ObjSet( "spr_diary_evidence_1_4",{ visible = false });
  ObjSet( "obj_evidence_evidence_1_4_click",{ input = false } );
  interface.DialogEvidenceHide();

end;
--******************************************************************************************
function private.click_evidence_1_5 ()

  --ObjSet( "spr_diary_evidence_1_5",{ visible = false });
  ObjSet( "obj_evidence_evidence_1_5_click",{ input = false } );
  interface.DialogEvidenceHide();

end;
--******************************************************************************************
function private.click_evidence_1_6 ()

  --ObjSet( "spr_diary_evidence_1_6",{ visible = false });
  ObjSet( "obj_evidence_evidence_1_6_click",{ input = false } );
  interface.DialogEvidenceHide();

end;
--******************************************************************************************
ObjAnimate( "spr_evidence_evidence_1_7_1_bookmark", "ang", 1, 0, "", { 0, 3, -0.05, 1, 3, 0.05, 2, 3, -0.05 });
--******************************************************************************************
function private.click_evidence_1_7 ()

  local rand_mus = math.random(1,3)
  common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page_"..rand_mus, 0, "", 0 );
  
  if ( not private.count_click_1_7 ) then
    
    private.count_click_1_7 = true;
    ObjSet( "obj_evidence_evidence_1_7_click",{ input = false });
    ObjAnimate( "spr_evidence_evidence_1_7_1",   "alp", 0, 0, "", { 0, 0, 1, 0.6, 3, 0 } );
    ObjAnimate( "spr_evidence_evidence_1_7_2",  "alp", 0, 0, function () ObjSet( "obj_evidence_evidence_1_7_click",{ input = true } ); end, { 0, 0, 0, 0.1, 0, 0, 0.6, 3, 1 } );

  else
    
    ObjSet( "obj_evidence_evidence_1_7_click",{ input = false } );
    private.count_click_1_7 = false;

    ObjAnimate( "spr_evidence_evidence_1_7_2",   "alp", 0, 0, "", { 0, 0, 1, 0.6, 3, 0 } );
    ObjAnimate( "spr_evidence_evidence_1_7_1",  "alp", 0, 0, function () ObjSet( "obj_evidence_evidence_1_7_click",{ input = true } ); interface.DialogEvidenceHide();  end, { 0, 0, 0, 0.1, 0, 0, 0.6, 3, 1 } );

  end;
  


end;
--******************************************************************************************
function private.click_evidence_1_8 ()

  --ObjSet( "spr_diary_evidence_1_8",{ visible = false });
  ObjSet( "obj_evidence_evidence_1_8_click",{ input = false } );
  interface.DialogEvidenceHide();

end;
--******************************************************************************************
function private.click_evidence_1_9 ()

  --ObjSet( "spr_diary_evidence_1_9",{ visible = false });
  ObjSet( "obj_evidence_evidence_1_9_click",{ input = false } );
  interface.DialogEvidenceHide();

end;
--******************************************************************************************
function private.click_evidence_2_1 ()
  
  ObjSet( "obj_evidence_evidence_2_1_click",{ input = false } );
  interface.DialogEvidenceHide();

end;
--******************************************************************************************
function private.click_evidence_2_2 ()
  
  ObjSet( "obj_evidence_evidence_2_2_click",{ input = false } );
  interface.DialogEvidenceHide();

end;
--******************************************************************************************
function private.click_evidence_2_3 ()
  
  ObjSet( "obj_evidence_evidence_2_3_click",{ input = false } );
  interface.DialogEvidenceHide();

end;
--******************************************************************************************
function private.click_evidence_2_3_progress ()
  
  local func_end = function()
    interface.DialogEvidenceHide();
    interface.DialogVideoHide();
  end;

  ObjDelete( "spr_evidence_evidence_2_3_progress_tmpobject" );
  interface.DialogVideoShow( "vid_evidence_evidence_2_3", 1, func_end, 3 );  
  VidPlay( "vid_evidence_evidence_2_3", func_end );  
  ObjSet( "obj_evidence_evidence_2_3_progress_clk", { input = false } );  

end;
--******************************************************************************************
function private.click_evidence_2_4 ()
  
  ObjSet( "obj_evidence_evidence_2_4_progress_clk",{ input = false } );
  interface.DialogEvidenceHide();

end;
--******************************************************************************************
function private.click_evidence_2_4_progress ()
   
  if ( not private.count_click_2_4 ) then
    private.count_click_2_4 = 0;
  end;

  if ( private.count_click_2_4 == 0 ) then

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_letter_open", 0, "", 0 );

    ObjAnimate( "spr_evidence_evidence_2_4_closed", "alp", 0, 0, function () common_impl.Lock( false ); end, { 0, 0, 1, 0.3, 0, 0 } );
    ObjAnimate( "spr_evidence_evidence_2_4_opened", "alp", 0, 0, "", { 0, 0, 0, 0.3, 0, 1 } );
    ObjAnimate( "spr_evidence_evidence_2_4_paper_shadow", "alp", 0, 0, "", { 0, 0, 0, 0.3, 0, 1 } );
    ObjAnimate( "spr_evidence_evidence_2_4_paper",        "alp", 0, 0, "", { 0, 0, 0, 0.4, 0, 1 } );
    ObjAnimate( "spr_evidence_evidence_2_4_over",         "alp", 0, 0, "", { 0, 0, 0, 0.1, 0, 1 } );

    private.count_click_2_4 = private.count_click_2_4 + 1;

  elseif ( private.count_click_2_4 == 1 ) then

    common_impl.Lock( true );

    local func_anim = function()

         local func_after = function()

            common_impl.Lock( false );

            ObjMultiSet( {  

           { "obj_evidence_evidence_2_4_progress_clk", { input = false } },
           { "spr_evidence_evidence_2_4_paper_big", { input = true, alp = 1 } },
           { "spr_evidence_evidence_2_4_paper", { scale_x = 1, scale_y = 1 } },
         
            } );
    
            rm_nightsville.StartEvidenceMmg();

         end;

         ObjAnimate( "spr_evidence_evidence_2_4_paper_big", "alp", 0, 0, "", { 0, 0, 0, 0.4, 0, 1 } );
         ObjAnimate( "spr_evidence_evidence_2_4_paper", "alp", 0, 0, func_after, { 0, 0, 1, 0.4, 0, 0 } );

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_letter_paper", 0, "", 0 );

    ObjAnimate( "spr_evidence_evidence_2_4_paper", "pos_xy", 0, 0, func_anim, 
    { 
      0.0, 0, -8, -12, 
      0.3, 3, -21, -212, 
      0.5, 3, -21, -212, 
      0.8, 0, -8, -12 
    } );

    ObjAnimate( "spr_evidence_evidence_2_4_paper_shadow", "alp", 0, 0, "", { 0, 0, 1, 0.2, 0, 0 } );

    ObjAnimate( "spr_evidence_evidence_2_4_opened", "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 1, 0.5, 0, 0 } );
    ObjAnimate( "spr_evidence_evidence_2_4_over",   "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 1, 0.5, 0, 0 } );
    ObjAnimate( "spr_evidence_evidence_2_4_back",   "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 1, 0.5, 0, 0 } );

    private.count_click_2_4 = private.count_click_2_4 + 1

  else

    ObjSet( "obj_evidence_evidence_2_4_progress_clk",{ input = false } );
    interface.DialogEvidenceHide();

  end; 

end;
--******************************************************************************************
function private.click_evidence_2_5 ()
  
  ObjSet( "obj_evidence_evidence_2_5_click",{ input = false } );
  interface.DialogEvidenceHide();

end;
--******************************************************************************************
function private.click_evidence_2_6 ()
  
  ObjSet( "obj_evidence_evidence_2_6_click",{ input = false } );
  interface.DialogEvidenceHide();

end;
--******************************************************************************************
function private.click_evidence_3_1 ()
  
  ObjSet( "obj_evidence_evidence_3_1_click",{ input = false } );
  interface.DialogEvidenceHide();

end;
--******************************************************************************************
function private.click_evidence_3_2 ()
  
  ObjSet( "obj_evidence_evidence_3_2_click",{ input = false } );
  interface.DialogEvidenceHide();

end;
--******************************************************************************************
function private.click_evidence_3_3 ()
  
  DbgTrace("click_evidence_3_3 - private");   
  ObjSet( "obj_evidence_evidence_3_3_click",{ input = false } );
  interface.DialogEvidenceHide();

end;
--******************************************************************************************
function private.click_evidence_3_3_progress ()

  if ( not private.count_click_3_3 ) then
      
    private.count_click_3_3 = 1;
    rm_chamber.StartEvidenceMmg();

  elseif private.count_click_3_3 == 1 then

    ObjSet( "obj_evidence_evidence_3_3_progress_clk",{ input = false } );
    ObjSet( "int_dialog_evidence_exit",{ input = true } );
    ObjSet( "int_dialog_evidence", { pos_z = 20 } );
    interface.DialogEvidenceHide();

  end; 

end;
--******************************************************************************************
function private.click_evidence_3_4 ()
  
  ObjSet( "obj_evidence_evidence_3_4_click",{ input = false } );
  interface.DialogEvidenceHide();

end;
--******************************************************************************************
function private.click_evidence_3_5 ()
  
  ObjSet( "obj_evidence_evidence_3_5_click",{ input = false } );
  interface.DialogEvidenceHide();

end;
--******************************************************************************************
function private.click_evidence_3_6 ()
  
  ObjSet( "obj_evidence_evidence_3_6_click",{ input = false } );
  interface.DialogEvidenceHide();

end;
--******************************************************************************************
-- function ---*** Show Flashback's ***--- () end;
--******************************************************************************************
function public.ShowFlashBack ( num, func_end )

  local invst_num = num or ng_global.investigation;
  
  local trg_after = function ( skip )

    interface.DialogVideoHide();
    --[[interface.DiaryDcnHide()]]
    cmn.SetEventDone( "vid_evidence_"..invst_num );
    cmn.CallEventHandler( "vid_evidence_"..invst_num );
    common_impl.ShowBbt( "bbt_vid_evidence_"..invst_num, 1 );

    if ( tonumber( invst_num ) == 1 ) then --EE> временный костыль

      if ng_global.task_current == "examine_square" then

        interface.KeyTaskDone( "examine_square", true );

      end;   
      
    end;

    if ( tonumber( invst_num ) == 2 ) then
      local page_content7 = {1, 1, 1};
      common_impl.AddBookmarkDiary( 7, 1, page_content7);
    end;

    if ( tonumber( invst_num ) == 3 ) then
      local page_content8 = {1, 1, 1};
      common_impl.AddBookmarkDiary( 8, 1, page_content8);
    end;

    if ( tonumber( invst_num ) == 4 ) then
      common_impl.AddPageDiary( 5 );
    end;

    if ( tonumber( invst_num ) == 5 ) then
      common_impl.AddPageDiary( 6 );
    end;

    if ( tonumber( invst_num ) == 6 ) then
      common_impl.AddPageDiary( 9 );
    end;

    if ( tonumber( invst_num ) == 7 ) then
      common_impl.AddPageDiary( 11 );
    end;

    if ( func_end ) then

      func_end();

    end;

    if tonumber( invst_num ) ~= 7 then

      common_impl.PlayAudio( "mus", "common/audio/aud_enigma_mus", 0, "", 0 );

    else 

      common_impl.PlayAudio( "mus", "common/audio/aud_danger1_mus", 0, "", 0 );

    end;

    common_impl.StopAudio( "voc", "common/audio/aud_deduction_"..invst_num.."_voc", 0, "", 0 );

    if skip then

      common_impl.StopAudio( "mus", "common/audio/aud_deduction_mus", 0, "", 1 );
      common_impl.StopAudio( "sfx", "common/audio/aud_deduction_"..invst_num, 0, "", 1 );

    end;
    --cmn.GotoRoom( "rm_demo" );

  end;

  
  --ObjAttach( "vid_fb_evidence_page_"..invst_num, "int_evidence_dcn" );

  common_impl.PlayAudio( "voc", "common/audio/aud_deduction_"..invst_num.."_voc", 0, "", 0 );
  common_impl.PlayAudio( "sfx", "common/audio/aud_deduction_"..invst_num, 0, "", 0 );
  common_impl.PlayAudio( "mus", "common/audio/aud_deduction_mus", 1, "", 0 );
  
  ObjSet( "vid_fb_evidence_page_"..invst_num, { alp = 1, active = true, input = false, visible = true, pos_x = 512, pos_y = 384, frame = 0 } );
  interface.DialogVideoShow( "vid_fb_evidence_page_"..invst_num, 1, function() trg_after( 'skip' ); end, 3 );
  VidPlay( "vid_fb_evidence_page_"..invst_num, function() trg_after( nil ); end );
    
end;