-- name=int_investigation_button
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_investigation_button", interface.originhub );
  ObjSet( "int_investigation_button", { pos_z = pos_z } );
  ObjSet( "obj_int_investigation_button", { alp = 0 } );

  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  private.SHOW_ANIM_TIME = 0.5;
  private.SHOW_TIME = 0.3;
  private.SKIP_MOUSE_OVER_ANIM_TIME = 0.5;
  private.show = 0;
  private.show_obj = "";
  public.POSITION = 765;

  private.pos_show = 0;
  private.pos_hide = 228;
  private.panel_show = false;
  ng_global.SHOW_INVESTIGATION = false;

  private.WideScreenUpdate();

  private.evidence_list = interface.EvidenceGetList();

  private.questions_list = 
  {
    { start_event = "dlg_square_mother_1",      progress_icon = "icon_2",    end_event = "dlg_square_mother_2",               end_icon = "icon_lorein",   level = 1 },
    { start_event = "dlg_livingroom_george",    progress_icon = "icon_2",    end_event = "dlg_square_sheriff",                end_icon = "icon_lorein",   level = 1 },
    { start_event = "dlg_square_sheriff",       progress_icon = "icon_2",    end_event = "dlg_square_sem",                    end_icon = "icon_sherif",   level = 1 },
    { start_event = "dlg_area_joker",           progress_icon = "icon_2",    end_event = "dlg_nightsvilleentrance_company",   end_icon = "icon_boy",      level = 2 },
    { start_event = "dlg_nightsville_steward",  progress_icon = "icon_2",    end_event = "dlg_nightsville_suspicion",         end_icon = "icon_steward",  level = 2 },
    { start_event = "opn_mansion",              progress_icon = "icon_2",    end_event = "dlg_chamber_owlman_2",              end_icon = "icon_owlman",   level = 3 },
    { start_event = "dlg_fork_3_mary",          progress_icon = "icon_2",    end_event = "dlg_fork_3_end",                    end_icon = "icon_sherif",   level = 3 },
    { start_event = "",                         progress_icon = "",          end_event = "",                                  end_icon = "",              level = 5 }
  }

  ObjSet( "obj_int_investigation_button_panel_open", 
  {
    event_mdown   = function () private.CheckAnimPanel(); end,
    event_menter  = function () private.MouseEnterAnim( "panel_open_focus" ); end,
    event_mleave  = function () private.MouseLeaveAnim( "panel_open_focus" ) end
  } );

  ObjSet( "obj_int_investigation_use_investigation", 
  {
    event_mdown   = function () private.CheckAnimPanel(); end,
    event_menter  = function () SetCursor( CURSOR_HAND ) end,
    event_mleave  = function () SetCursor( CURSOR_DEFAULT ) end
  } );
  
  ObjSet( "obj_int_investigation_button_panel_button", {
    event_mdown   = function () private.ClkInvestigationButton(); end,
    event_menter  = function () private.MouseEnterAnim(); end,
    event_mleave  = function () private.MouseLeaveAnim(); end
  } );
  
  for i = 1, 3 do

    ObjSet( "obj_int_investigation_button_panel_slots_"..i.."_clk", {
      event_mdown   = function () private.EvidenceClick() end,
      event_menter  = function () private.EvidenceMouseEnterAnim( i ); end,
      event_mleave  = function () private.EvidenceMouseLeaveAnim( i ); end
    } );

  end;
 

  ObjSet( "obj_int_investigation_button_panel", { pos_x = private.pos_hide });
  ObjSet( "obj_int_investigation_button_title", { alp = 0 } );

  common_impl.hint[ "vid_evidence_1" ] = {
      type = "click",
      use_place = "obj_int_investigation_button_panel_button",
      room = "int_investigation_button",
      zz = "int_investigation_button",
      zz_gate = "int_investigation_button"
  };

  common_impl.hint[ "vid_evidence_2" ] = {
      type = "click",
      use_place = "obj_int_investigation_button_panel_button",
      room = "int_investigation_button",
      zz = "int_investigation_button",
      zz_gate = "int_investigation_button"
  };

  common_impl.hint[ "vid_evidence_3" ] = {
      type = "click",
      use_place = "obj_int_investigation_button_panel_button",
      room = "int_investigation_button",
      zz = "int_investigation_button",
      zz_gate = "int_investigation_button"
  };

  common_impl.hint[ "vid_evidence_4" ] = {
      type = "click",
      use_place = "obj_int_investigation_button_panel_button",
      room = "int_investigation_button",
      zz = "int_investigation_button",
      zz_gate = "int_investigation_button"
  };

  common_impl.hint[ "vid_evidence_5" ] = {
      type = "click",
      use_place = "obj_int_investigation_button_panel_button",
      room = "int_investigation_button",
      zz = "int_investigation_button",
      zz_gate = "int_investigation_button"
  };

  common_impl.hint[ "vid_evidence_6" ] = {
      type = "click",
      use_place = "obj_int_investigation_button_panel_button",
      room = "int_investigation_button",
      zz = "int_investigation_button",
      zz_gate = "int_investigation_button"
  };

  common_impl.hint[ "vid_evidence_7" ] = {
      type = "click",
      use_place = "obj_int_investigation_button_panel_button",
      room = "int_investigation_button",
      zz = "int_investigation_button",
      zz_gate = "int_investigation_button"
  };

end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
--AK> запускать в конце start_event 
function public.Show( update_flag )

  if ( private.active ) and ( not update_flag ) then

    return;

  end;

  private.active = true;

  ObjSet( "obj_int_investigation_button", { active = true, visible = true } );

  local trg = function () 

    ObjSet( "obj_int_investigation_button", { input = true } );

  end;

  local tme = private.SHOW_TIME;
  private.SetPanelState();

  ObjAnimate( "obj_int_investigation_button", "alp", 0, 0, trg,
  {
    0.0, 2, 0,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function public.Hide()

  if ( not private.active ) then

    return;

  end;

  private.active = false;

  local trg = function () 

    ObjSet( "obj_int_investigation_button", { active = false, visible = false, input = false } );

  end;

  local tme = private.SHOW_TIME;

  ObjAnimate( "obj_int_investigation_button", "alp", 0, 0, trg,
  {
    0.0, 2, 1,
    tme, 2, 0
  } );

end;
--******************************************************************************************
function private.WideScreenUpdate ()

  if ( not GetWideScreen() ) then
    ObjSet( "int_investigation_button", { pos_x = public.POSITION } );
  else
    ObjSet( "int_investigation_button", { pos_x = public.POSITION + 171 } );
  end;

end;
--******************************************************************************************
--function --*** Logic ***-- () end
--******************************************************************************************
function private.SetPanelState ()

  local current_invst   = ng_global.investigation or 1;
  local chapter         = ng_global.progress[ ng_global.currentprogress ].common.chapter;
  local current_lvl     = tonumber( string.sub( chapter, -1 ) );
  local evidence_count  = 0;

  local cur_list = private.questions_list[ current_invst ];

  if ( cmn.IsEventDone( cur_list.end_event ) ) or ( cur_list.level < current_lvl ) then

    ng_global.investigation = ng_global.investigation + 1;
    private.SetPanelState();
    return;

  end;

  if ( cur_list.start_event == "" ) or ( not cmn.IsEventDone( cur_list.start_event ) ) then

    ObjSet( "obj_int_investigation_button_action", { visible = false, input = false } );
    return;

  end;

  ObjSet( "obj_int_investigation_button_action", { visible = true, input = true } );

  for i = 1, #private.evidence_list[ current_invst ] do
  
    local event    = "get_"..private.evidence_list[ current_invst ][ i ].name;
    local object   = private.evidence_list[ current_invst ][ i ].name;
    local flag_get = false;

    if ( private.evidence_list[ current_invst ][ i ].level == current_lvl ) then
    
      if ( cmn.IsEventDone( event ) ) then

        flag_get = true;
        evidence_count = evidence_count + 1;

      end;

    elseif ( private.evidence_list[ current_invst ][ i ].level < current_lvl ) then

      flag_get = true;
      evidence_count = evidence_count + 1;

    end;

    if ( flag_get ) then
  
      ObjSet( "spr_int_investigation_button_panel_slots_light_"..i,     { alp = 0 } );
      ObjSet( "spr_int_investigation_button_panel_slots_"..i.."_icon_backlight",  { alp = 0 } );
      ObjSet( "spr_int_investigation_button_panel_slots_"..i.."_icon",  { visible  = true, res = "assets/interface/int_investigation_button/layers/"..object } );
      ObjSet( "obj_int_investigation_button_panel_slots_"..i.."_clk",   { event_mdown = function () private.EvidenceClick(); end; } );

    else
    
      ObjSet( "spr_int_investigation_button_panel_slots_light_"..i,     { alp = 1 } );
      ObjSet( "spr_int_investigation_button_panel_slots_"..i.."_icon_backlight",  { alp = 1, res = "assets/interface/int_investigation_button/layers/backlight_"..common.GetObjectName(object) } );
      ObjSet( "spr_int_investigation_button_panel_slots_"..i.."_icon",  { visible  = false });
      ObjSet( "obj_int_investigation_button_panel_slots_"..i.."_clk",   { event_mdown = function () common_impl.ShowBbt( "bbt_evidence_slots" ); end; } );

    end;
  
  end;

  for j = 1, evidence_count do
    ObjSet( "spr_int_investigation_button_back_lamp_"..j.."_light", { visible  = true, alp = 1 } );  
  end;

  if ( evidence_count == 3 ) then

    ObjSet( "obj_int_investigation_button_panel_button", { visible = true, input = true, alp = 1 } ); 
    ObjSet( "obj_int_investigation_button_panel_slots",  { visible = false, input = false } );

    ObjSet( "obj_int_investigation_button_panel", { pos_x = private.pos_show } );
    ObjSet( "obj_int_investigation_button_title", { alp = 1 } );
    private.panel_show = true;

  end;

  local icon = cur_list.progress_icon;
  ObjSet( "obj_int_investigation_button_panel_task", { alp = 0 } );

  if ( cmn.IsEventDone( "vid_evidence_"..current_invst ) ) then

    icon = cur_list.end_icon;
    ObjSet( "obj_int_investigation_button_panel_button", { visible = false, input = false, alp = 0 } );
    ObjSet( "obj_int_investigation_button_panel_task", { alp = 1 } );

  else 

    ObjSet( "obj_int_investigation_button_panel_task", { alp = 0 } );

  end;

  ObjSet( "spr_int_investigation_button_icon", { res = "assets/interface/int_investigation_button/layers/"..icon } );
  ObjSet( "spr_int_investigation_button_back", { res = "assets/interface/int_investigation_button/layers/"..icon } );
  ObjSet( "txt_int_investigation_button_title", { text = "txt_title_"..current_invst } );
  ObjSet( "txt_int_investigation_button_panel_task", { text = "str_investigation_question_"..current_invst} );
  ObjSet( "obj_int_investigation_button", { input = true } );

end;
--******************************************************************************************
function public.AddObject ( object_name, game_object_name, func_end )

  local invst_evidence_count  = 0;
  local current_evidence      = 0;
  local current_invst         = nil;  
  private.FuncEnd             = func_end;

  for i = 1, #private.evidence_list do

    for j = 1, #private.evidence_list[ i ] do

      if ( private.evidence_list[ i ][ j ].name == object_name ) then

        current_evidence  = j;
        current_invst     = i;
        break;

      end;

    end;

    if ( current_invst ) then break; end;

  end;

  if ( current_invst ) and ( current_invst ~= ng_global.investigation ) then

    ng_global.investigation = current_invst;

  end;

  private.SetPanelState();
  public.AnimShowPanel();

  local trg_end = function ()
 
    if ( private.FuncEnd ) then private.FuncEnd(); end;
    ObjSet( "obj_int_investigation_button_panel_slots_"..current_evidence.."_clk",   { event_mdown = function () private.EvidenceClick(); end; } );
    public.AnimHidePanel();

  end;

  local chapter     = ng_global.progress[ ng_global.currentprogress ].common.chapter;
  local current_lvl = tonumber( string.sub( chapter, -1 ) ); 

  for j = 1, #private.evidence_list[ current_invst ] do

    local object    = private.evidence_list[ current_invst ][ j ].name  
    local event     = "get_"..object;

    if ( private.evidence_list[ current_invst ][ j ].level == current_lvl ) then
    
      if ( cmn.IsEventDone( event ) ) then

        invst_evidence_count = invst_evidence_count + 1;

      end;

    elseif ( private.evidence_list[ current_invst ][ i ].level < current_lvl ) then

      invst_evidence_count = invst_evidence_count + 1;

    end;

  end;

  if ( invst_evidence_count == 2 ) then

    trg_end = function ()
      
      if ( private.FuncEnd ) then private.FuncEnd(); end;
      private.AddButtonAnim();

    end;

  end;
  
  local fly_obj = game_object_name.."_fly";
  ObjClone( game_object_name, "_fly", 1, "obj_int_investigation_button" );  --[[ObjGetRelations( game_object_name ).parent]]

  local pos = GetObjPosByObj( game_object_name, "obj_int_investigation_button" );
  ObjSet( fly_obj, { visible = true, input = false, pos_x = pos[ 1 ], pos_y = pos[ 2 ] } )

  local func_end = function ()
 
    ObjDelete( fly_obj );

    ObjAnimate( "spr_int_investigation_button_panel_slots_light_"..current_evidence,     "alp", 0, 0, trg_end, { 0, 0, 1, 0.3, 0, 0 } );
    ObjAnimate( "spr_int_investigation_button_panel_slots_"..current_evidence.."_icon",  "alp", 0, 0, "", { 0, 0, 0, 0.3, 0, 1 } );
    ObjAnimate( "spr_int_investigation_button_panel_slots_"..current_evidence.."_icon_backlight",  "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 0 } );
    ObjSet( "spr_int_investigation_button_panel_slots_"..current_evidence.."_icon",      { visible  = true, res = "assets/interface/int_investigation_button/layers/"..object_name } );

    ObjSet( "spr_int_investigation_button_back_lamp_"..( invst_evidence_count + 1 ).."_light",{ visible = true } );
    ObjAnimate( "spr_int_investigation_button_back_lamp_"..( invst_evidence_count + 1 ).."_light", "alp", 0, 0, "", { 0, 0, 0, 0.3, 0, 1 } );
    common_impl.PlayAudio( "sfx", "common/audio/aud_evidence_glow", 0, "", 0 );

  end;

  MsgSend( Command_Transporter_MoveObject,
  {
    type       = Trans_SceneToInventory,
    obj_name   = fly_obj,
    toobj_name = "obj_int_investigation_button_panel_slots_"..current_evidence,
    show       = false,
    end_trig   = func_end
  } );

end;
--******************************************************************************************
function private.AnimPanelToEnd ()

  common_impl.Lock( true );

  local func_end = function ()

    common_impl.Lock( false );
    ObjSet( "obj_int_investigation_button_panel_button", { visible = false, input = false, alp = 0 } );

  end;

  ObjAnimate( "obj_int_investigation_button_panel_button", "alp", 0, 0, func_end,
  {
    0.0, 0, 1,
    0.3, 0, 0
  } );  

  ObjAnimate( "obj_int_investigation_button_panel_task", "alp", 0, 0, "",
  {
    0.0, 0, 0,
    0.3, 0, 1
  } );

  ObjSet( "spr_int_investigation_button_icon", { res = "assets/interface/int_investigation_button/layers/"..private.questions_list[ ng_global.investigation ].end_icon } );
  ObjAnimate( "spr_int_investigation_button_icon", "alp", 0, 0, "",
  {
    0.0, 0, 0,
    0.3, 0, 1
  } );

end;
--******************************************************************************************
--AK> запускать в событии end_event или прописать проверку в SetEventDone
function public.ChangeInvestigation ()

  common_impl.Lock( true );

  local trg_after = function ()

    --if ng_global.investigation == 2 then

      common_impl.Lock( false );

    --end;
    private.panel_show = false;
    ng_global.investigation = ng_global.investigation + 1;
  
    for i = 1, 3 do

      ObjSet( "spr_int_investigation_button_panel_slots_light_"..i,     { alp = 1 } );
      ObjSet( "spr_int_investigation_button_panel_slots_"..i.."_icon",  { visible  = false });
      ObjSet( "obj_int_investigation_button_panel_slots_"..i.."_clk",   { event_mdown = function ()  end; } );

    end;

    ObjSet( "obj_int_investigation_button_panel_button", { visible = false, input = false, alp = 0 } ); 
    ObjSet( "obj_int_investigation_button_panel_slots",  { visible = true, input = true, alp = 1 } );
    private.SetPanelState();
  
  end;

  ObjSet( "obj_int_investigation_button", { input = false } );

  ObjAnimate( "obj_int_investigation_button_panel", "pos_x", 0, 0, trg_after, 
  { 
    0.0, 0, ObjGet( "obj_int_investigation_button_panel" ).pos_x,
    0.5, 3, private.pos_hide 
  } );
  
  ObjAnimate( "obj_int_investigation_button_title", "alp", 0, 0, "",
  {
    0.0, 0, ObjGet( "obj_int_investigation_button_title" ).alp,
    0.5, 0, 0
  } );

  for i = 1, 3 do

    ObjAnimate( "spr_int_investigation_button_back_lamp_"..i.."_light", "alp", 0, 0, "",
    {
      0.0, 0, 1,
      0.3, 0, 0
    } );
  
  end;

end;
--******************************************************************************************
--function --*** Buttons Events ***-- () end
--******************************************************************************************
function private.EvidenceClick ()

  ng_global.diary_current_page = ng_global.investigation
  private.CheckAnimPanel();
  interface.EvidenceScreenShow();
  
end;
--******************************************************************************************
function private.ClkInvestigationButton ()

  local func_end = function ()

    private.AnimPanelToEnd();

  end;

  interface.EvidenceFlashBackShow( nil, func_end );
  
end;
--******************************************************************************************
function private.MouseEnterAnim ( focus )

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_investigation_button_panel_button_focus";
  if ( focus ) then

    obj = "spr_int_investigation_button_"..focus

  end;
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "", { 0.0, 2, alp,  tme, 2, 1 } );

end;
--******************************************************************************************
function private.MouseLeaveAnim ( focus )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_investigation_button_panel_button_focus";
  if ( focus ) then

    obj = "spr_int_investigation_button_"..focus

  end;
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "", { 0.0, 1, alp,  tme, 1, 0 } );

end;
--******************************************************************************************
--function --*** Animations ***-- () end
--******************************************************************************************
function private.CheckAnimPanel ()

  if ( private.panel_show ) then

    public.AnimHidePanel();

  else

    public.AnimShowPanel();

  end;

end;
--******************************************************************************************
function private.EvidenceMouseEnterAnim ( number )

  SetCursor( CURSOR_HAND );

  local obj = "spr_int_investigation_button_panel_slots_"..number.."_icon_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "", { 0.0, 2, alp,  tme, 2, 1 } );

end;
--******************************************************************************************
function private.EvidenceMouseLeaveAnim ( number )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_int_investigation_button_panel_slots_"..number.."_icon_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.SKIP_MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "", { 0.0, 1, alp,  tme, 1, 0 } );

end;
--******************************************************************************************
function public.AnimShowPanel ()

  if ( private.panel_show ) then

    return;
    
  end;

  common_impl.Lock( true );
  
  local trg_after = function ()
  
    common_impl.Lock( false );
    private.panel_show = true;

    for i = 1, 7 do

       common_impl.hint[ "vid_evidence_"..i ].use_place = "obj_int_investigation_button_panel_button";

    end;
  
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_evidence_sign_move_in", 0, "", 0 );  

  ObjAnimate( "obj_int_investigation_button_panel", "pos_x", 0, 0, trg_after, 
  { 
    0.0, 0, private.pos_hide,
    0.5, 3, private.pos_show 
  } );
  
  ObjAnimate( "obj_int_investigation_button_title", "alp", 0, 0, "", 
  { 
    0.0, 0, 0,
    0.5, 3, 1 
  } );

end;
--******************************************************************************************
function public.AnimHidePanel ()

  common_impl.Lock( true);

  local trg_after = function ()
  
    common_impl.Lock( false );
    private.panel_show = false;

    for i = 1, 7 do

       common_impl.hint[ "vid_evidence_"..i ].use_place = "obj_int_investigation_button_panel_hint";

    end;
  
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_evidence_sign_move_out", 0, "", 0 );  
  ObjAnimate( "obj_int_investigation_button_panel", "pos_x", 0, 0, trg_after, 
  { 
    0.0, 0, private.pos_show,
    0.5, 3, private.pos_hide 
  } );

  ObjAnimate( "obj_int_investigation_button_title", "alp", 0, 0, "", 
  { 
    0.0, 0, 1,
    0.5, 3, 0 
  } );
  
end;
--******************************************************************************************
function private.AddButtonAnim ()

  common_impl.Lock( true );

  ObjSet( "obj_int_investigation_button_panel_button", { visible  = true, active = true } );

  local trg_after = function ()

    common_impl.Lock( false );

    ObjSet( "obj_int_investigation_button_panel_button", { input = true } ); 
    ObjSet( "obj_int_investigation_button_panel_slots",  { input = false } );

  end;

  ObjAnimate( "obj_int_investigation_button_panel_button", "alp", 0, 0, trg_after,
  {
    0.0, 0, 0,
    0.3, 0, 1
  } );

  ObjAnimate( "obj_int_investigation_button_panel_slots", "alp", 0, 0, "",
  {
    0.0, 0, 1,
    0.3, 0, 0
  } );

end;
--******************************************************************************************