-- name=int_map_impl
--******************************************************************************************
function public.Init ()

  public.DIRECTION = 0;

  private.SHOW_ANIM_TIME = 0.3;
  private.HIDE_ANIM_TIME = 0.3;

  private.POPUP_WINDOW_BACK_X = 0;
  private.POPUP_WINDOW_BACK_Y = 0;

  private.HUB_POPUP_WINDOW_X = 200;
  private.HUB_POPUP_WINDOW_Y = 0;

  private.MIN_END_Y = -280;
  
    private.screen = 
    {
      [ "basement"            ] = { screen = 1, visit = false, lock = false, activ = false },
      [ "livingroom"          ] = { screen = 1, visit = false, lock = false, activ = false },
      [ "office"              ] = { screen = 1, visit = false, lock = false, activ = false },
      [ "pier"                ] = { screen = 1, visit = false, lock = false, activ = false },
      [ "fork"                ] = { screen = 1, visit = false, lock = false, activ = false },
      [ "square"              ] = { screen = 1, visit = false, lock = false, activ = false },
      [ "abandoneddistrict"   ] = { screen = 1, visit = false, lock = false, activ = false },

      [ "area"                ] = { screen = 1, visit = false, lock = false, activ = false },
      [ "divarication"        ] = { screen = 1, visit = false, lock = false, activ = false },
      [ "glade"               ] = { screen = 2, visit = false, lock = false, activ = false },
      [ "mine_1"              ] = { screen = 2, visit = false, lock = false, activ = false },
      [ "mine_2"              ] = { screen = 2, visit = false, lock = false, activ = false },
      [ "mineentrance"        ] = { screen = 2, visit = false, lock = false, activ = false },
      [ "nightsville"         ] = { screen = 2, visit = false, lock = false, activ = false },
      [ "nightsvilleentrance" ] = { screen = 2, visit = false, lock = false, activ = false },

      [ "square_3"            ] = { screen = 1, visit = false, lock = false, activ = false },
      [ "fork_3"              ] = { screen = 1, visit = false, lock = false, activ = false },
      [ "pier_3"              ] = { screen = 1, visit = false, lock = false, activ = false },
      [ "mine_1_3"            ] = { screen = 2, visit = false, lock = false, activ = false },
      [ "mineentrance_3"      ] = { screen = 2, visit = false, lock = false, activ = false },
      [ "nightsville_3"       ] = { screen = 2, visit = false, lock = false, activ = false },
      [ "hallway"             ] = { screen = 2, visit = false, lock = false, activ = false },
      [ "mansion"             ] = { screen = 2, visit = false, lock = false, activ = false },
      [ "secretroom"          ] = { screen = 1, visit = false, lock = false, activ = false },
      [ "sheriffshouse"       ] = { screen = 1, visit = false, lock = false, activ = false },
      [ "wincards"            ] = { screen = 1, visit = false, lock = false, activ = false },
      [ "chamber"             ] = { screen = 2, visit = false, lock = false, activ = false },
     
      [ "fork_4"              ] = { screen = 3, visit = false, lock = false, activ = false },
      [ "square_4"            ] = { screen = 3, visit = false, lock = false, activ = false },
      [ "livingroom_4"        ] = { screen = 3, visit = false, lock = false, activ = false },
      [ "abandoneddistrict_4" ] = { screen = 3, visit = false, lock = false, activ = false },
      [ "sheriffshouse_4"     ] = { screen = 3, visit = false, lock = false, activ = false },
      [ "swamp"               ] = { screen = 3, visit = false, lock = false, activ = false },
      [ "deathtrap"           ] = { screen = 3, visit = false, lock = false, activ = false },
      [ "forgottenbastille"   ] = { screen = 3, visit = false, lock = false, activ = false },
      [ "swampmasterdwelling" ] = { screen = 3, visit = false, lock = false, activ = false },

    };

    private.save_rooms = 
    {
      [ "square"              ] = { level2 = "area",                level3 = "square_3",            levelext = "square_4" },
      [ "fork"                ] = { level2 = "divarication",        level3 = "fork_3",              levelext = "fork_4"   },
      [ "basement"            ] = { level2 = "basement_2",          level3 = "basement_3" },
      [ "livingroom"          ] = { level2 = "livingroom_2",        level3 = "livingroom_3",        levelext = "livingroom_4" },
      [ "office"              ] = { level2 = "office_2",            level3 = "office_3" },
      [ "pier"                ] = { level2 = "pier_2",              level3 = "pier_3" },
      [ "abandoneddistrict"   ] = { level2 = "abandoneddistrict_2", level3 = "abandoneddistrict_3", levelext = "abandoneddistrict_4" },

      [ "glade"               ] = { level3 = "glade_3" },
      [ "mine_1"              ] = { level3 = "mine_1_3" },
      [ "mine_2"              ] = { level3 = "mine_2_3" },
      [ "mineentrance"        ] = { level3 = "mineentrance_3" },
      [ "nightsville"         ] = { level3 = "nightsville_3" },
      [ "nightsvilleentrance" ] = { level3 = "nightsvilleentrance_3" },

      [ "sheriffshouse"       ] = { levelext = "sheriffshouse_4" },

    };

      private.anm_rooms = 
    {
      [ "area"                  ] = "square",
      [ "divarication"          ] = "fork",
      [ "basement_2"            ] = "basement",
      [ "livingroom_2"          ] = "livingroom", 
      [ "office_2"              ] = "office",
      [ "pier_2"                ] = "pier",            
      [ "abandoneddistrict_2"   ] = "abandoneddistrict",
      [ "square_3"              ] = "square",
      [ "fork_3"                ] = "fork",
      [ "basement_3"            ] = "basement",
      [ "livingroom_3"          ] = "livingroom", 
      [ "office_3"              ] = "office",
      [ "pier_3"                ] = "pier",            
      [ "abandoneddistrict_3"   ] = "abandoneddistrict",
      [ "nightsvilleentrance_3" ] = "nightsvilleentrance",
      [ "mineentrance_3"        ] = "mineentrance",  
      [ "nightsville_3"         ] = "nightsville", 
      [ "mine_1_3"              ] = "mine_1", 
      [ "mine_2_3"              ] = "mine_2", 
      [ "glade_3"               ] = "glade"
          
    };

  local table_multiset = {

    { "obj_map_btn_close", { 
        event_mdown = int_map.Close ,
        event_menter = function() private.ButtonEnter( "spr_map_btn_close_focus" ) end, 
        event_mleave = function() private.ButtonLeave( "spr_map_btn_close_focus" ) end } }, 

    { "obj_map_back_empty_clk", { 
        event_mdown = int_map.Close ,
        event_menter = function() SetCursor( CURSOR_DOWN ) end, 
        event_mleave = function() SetCursor( CURSOR_DEFAULT ) end } }, 

    { "obj_map_btn_diary", { 
      visible = true, input = true,
      event_mdown = interface.DiaryShow,
      event_menter = function() common_impl.DialogButtonMouseEnter( "map_btn_diary" ) end , 
      event_mleave = function() common_impl.DialogButtonMouseLeave( "map_btn_diary" ) end } } ,

    { "spr_map_btn_arrow_right", { 
        event_mdown = function() private.ArrowMDown( "arrow_right" ) end,
        event_menter = function() private.ArrowMEnter( "arrow_right" ); common_impl.SetCursor( CURSOR_HAND ) end,
        event_mleave = function() private.ArrowMLeave( "arrow_right" ); common_impl.SetCursor( CURSOR_DEFAULT ) end } },

    { "spr_map_btn_arrow_left", { 
        event_mdown = function() private.ArrowMDown( "arrow_left" ) end,
        event_menter = function() private.ArrowMEnter( "arrow_left" ); common_impl.SetCursor( CURSOR_HAND ) end,
        event_mleave = function() private.ArrowMLeave( "arrow_left" ); common_impl.SetCursor( CURSOR_DEFAULT ) end } },

  };

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local table_multiset_ce = {

      { "obj_map_btn_collectibles2", { 
          visible = true, input = true,
          event_mdown = function() private.ButtonDown( "rm_collectibles2" ); end,
          event_menter = function() common_impl.DialogButtonMouseEnter( "map_btn_collectibles2" ) end, 
          event_mleave = function() common_impl.DialogButtonMouseLeave( "map_btn_collectibles2" ) end } }, 

      { "obj_map_btn_collectibles", { 
          visible = true, input = true,
          event_mdown = function() private.ButtonDown( "rm_collectibles" ); end,
          event_menter = function() common_impl.DialogButtonMouseEnter( "map_btn_collectibles" ) end, 
          event_mleave = function() common_impl.DialogButtonMouseLeave( "map_btn_collectibles" ) end } }, 

      { "obj_map_btn_achiev", { 
          visible = true, input = true,
          event_mdown = function() private.ButtonDown( "rm_achievements" ); end,
          event_menter = function() common_impl.DialogButtonMouseEnter( "map_btn_achiev" ) end, 
          event_mleave = function() common_impl.DialogButtonMouseLeave( "map_btn_achiev" ) end } }, 

    };

    for i = 1, #table_multiset_ce do
    
      table.insert( table_multiset, table_multiset_ce[ i ] );

    end;

  end;

  for room, value in pairs( private.screen ) do    

    local obj = "obj_map_screen_"..private.screen[ room ].screen.."_"..room.."_marker";
    table.insert( table_multiset, { obj, { 
                                      event_mdown = function() private.MarkerMDown( room ) end 
                                      --,event_menter = function() private.MarkerMEnter( CURSOR_HAND, room ) end, 
                                      --event_mleave = function() private.MarkerMLeave( room ) end
                                      } } );
        
  end;
  
  ObjMultiSet( table_multiset );
  
  private.current_screen = 1;

  private.PlayAnims();

end;
--******************************************************************************************
function public.WideScreenUpdate ()

  if ( not GetWideScreen() ) then

    --

  else

    --

  end;

end;
--******************************************************************************************
private.pos_old_x = 36;
private.pos_old_y = -5;

function public.ShowAnim ( event_id )

  local trg = function () int_map.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  ObjAnimate( "int_map", "alp", 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

  private.current_screen = private.screen[ private.pos_player ].screen;
  private.SetCurrentScreen();
  ObjSet( "obj_map_marker_player_here", { visible = true } );

  ObjAttach( "obj_map_marker_player_here", "obj_map_screen_"..private.current_screen.."_"..private.pos_player.."_marker" );

  if private.pos_player == "secretroom" then
    ObjSet( "obj_map_marker_player_here", { pos_x = 20, pos_y = 0 } );
  else
    ObjSet( "obj_map_marker_player_here", { pos_x = private.pos_old_x, pos_y = private.pos_old_y } );
  end;
    
    
  for room, value in pairs( private.screen ) do
    private.CheckMapRoom( room );
  end;
    
  if ( ng_global.progress[ ng_global.currentprogress ].common.chapter == "levelext" ) then
    ObjSet( "spr_map_paper_overlap_right", { visible = false } );
    ObjSet( "spr_map_paper_overlap_left", { visible = false } );
    ObjSet( "spr_map_note", { res = "assets/interface/resources/map/layers/paper_over_add" } );
  end;

end;
--******************************************************************************************
function public.HideAnim ( event_id )

  local trg = function () 
    int_map.EventAnimEnd( event_id ); 
    ObjSet( "tmr_common_anm", { active = true } );
  end;
  local tme = private.HIDE_ANIM_TIME;

  common_impl.PlayAudio( "sfx", "common/audio/aud_closemap", 0, "", 0 );

  ObjAnimate( "int_map", "alp", 0, 0, trg,
  {
    0.0, 3, 1,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function public.UpdateGameMode ( msg, params )

  if ( params.mode == 3 and not ng_global.gamemode_custom[ "tasks" ] ) then
    
  end;

end;
--******************************************************************************************
-- function *** Buttons *** () end;
--******************************************************************************************
  function private.ButtonDown ( room )
    
    common_impl.EnterBonusRm( room );

    --interface.WidgetSetVisible( InterfaceWidget_Map, false, 0,5 ); 
    --interface.WidgetSetInput( InterfaceWidget_Map, false );

    common_impl.Lock( true );
    --int_map.Close();
  end;
--******************************************************************************************
  function private.ButtonEnter ( obj )

    local tme = 0.3;

    SetCursor( CURSOR_HAND );

    local alp = ObjGet( obj ).alp;
    ObjAnimate( obj, "alp", 0, 0, "", 
    { 
      0.0,                      0, alp, 
      tme *( 1 - alp ), 0,    1
    } );

  end;
  --******************************************************************************************
  function private.ButtonLeave ( obj )

    local tme = 0.3;

    SetCursor( CURSOR_DEFAULT );

    local alp = ObjGet( obj ).alp;
    ObjAnimate( obj, "alp", 0, 0, "", 
    { 
      0.0, 0, alp, 
      tme *alp , 0,    0
    } ); 

  end;
--******************************************************************************************
-- function *** Marker *** () end;
--******************************************************************************************
  local old_room_click = "empty";
  local map_popup_active = false;
  
  function private.MarkerMDown ( name )
    --DbgTrace("private.MarkerMDown name="..tostring(name).." map_popup_active="..tostring(map_popup_active).." old_room_click="..tostring(old_room_click));
    
    --ld.SoundClickBtn();
    if old_room_click ~= tostring(name) then
      map_popup_active = true;
      
      private.MarkerMEnter( CURSOR_HAND, name );
      
      ObjSet( "tmr_map_impl_popup", { endtrig = 
      function() 
        if map_popup_active == true then
          map_popup_active = false; 
          private.MarkerMLeave(name);         
        end; 
      end, time = 2, playing = 1 } );
 
      
      old_room_click = tostring(name);
    else
      
      if map_popup_active == true then
        map_popup_active = false; 
        private.MarkerMLeave(name);         
      end;
      
      local prg = ng_global.currentprogress;
      local chapter = ng_global.progress[ prg ].common.chapter;
      local room = name;

      if private.save_rooms[name] then
    
        if private.save_rooms[name][chapter] then

           room = private.save_rooms[name][chapter];

        end;

      end;

      if ( GetCurrentRoom() ~= "rm_"..room ) then
        cmn.GotoRoom( "rm_"..room );  
      end;
      int_map.Close();
    end;
  end;
  --******************************************************************************************
  function private.MarkerMEnter ( cur_type, name )

    ObjStopAnimate( "obj_map_popup_window", "pos_xy" );
    ObjStopAnimate( "obj_map_popup_window", "scale_xy" );
    ObjStopAnimate( "obj_map_popup_window", "alp" );

    local type = private.current_screen;  
    local obj = "obj_map_screen_"..private.current_screen.."_"..name.."_marker";
    local obj_root = "obj_map_screen_"..type; 
    
    local cur = cur_type or CURSOR_DEFAULT;

    local pos_beg_x = GetGameCursorPos()[ 1 ];
    local pos_beg_y = GetGameCursorPos()[ 2 ];

   
    if pos_beg_x>914 then
      pos_beg_x = 914;
    end;
    
    if pos_beg_x<100 then
      pos_beg_x = 100;
    end;
    
    pos_beg_x = pos_beg_x + private.HUB_POPUP_WINDOW_X;
    pos_beg_y = pos_beg_y + private.HUB_POPUP_WINDOW_Y;

    local pos_end_x = pos_beg_x + 0 ;
    local pos_end_y = pos_beg_y - 75 ;

    if ( pos_end_y < private.MIN_END_Y ) then
      pos_end_y = private.MIN_END_Y;
    end;

    local sc_x  = 0;
    local sc_y = 0;

    private.popup_window_beg_anim_x = pos_beg_x;
    private.popup_window_beg_anim_y = pos_beg_y;

    SetCursor( cur );

    ObjSet( "obj_map_popup_window", { 
            pos_x = pos_beg_x, 
            pos_y = pos_beg_y,
            alp = 0
          } );

    ObjSet( "spr_map_popup_window_back", { res = "" } );

    ObjSet( "spr_map_popup_window_ico", { res = "assets/interface/resources/map/layers/screen_"..type.."/"..name } );
  
    local popup_text_id = "pop_"..name;

    if ng_global.currentprogress == "ext" then
      popup_text_id = popup_text_id.."_ce";
    end;

    ObjSet( "txt_map_popup_window_ico_name", { text = popup_text_id } );

    ObjAnimate( "obj_map_popup_window", "alp", 0, 0, "",
    {
      0.0, 1, 0,
      0.2, 0, 1
    } );

    local marker_focus = "spr_map_screen_"..private.current_screen.."_"..name.."_focus";
    if ( ObjGet( marker_focus ) ) then
      ObjAnimate( marker_focus, "alp", 0, 0, "",
      {
        0.0, 1, 0,
        0.2, 0, 1
      } );
    end;

    ObjAnimate( "obj_map_popup_window", "pos_xy", 0, 0, "",
    {
      0.0, 1, pos_beg_x, pos_beg_y,
      0.2, 0, pos_end_x, pos_end_y
    } );

    ObjAnimate( "obj_map_popup_window", "scale_xy", 0, 0, "",
    {
      0.0, 1, sc_x, sc_y,
      0.2, 0, 1, 1
    } );

  end;
  --******************************************************************************************
  function private.MarkerMLeave ( name )

    ObjStopAnimate( "obj_map_popup_window", "pos_xy" );
    ObjStopAnimate( "obj_map_popup_window", "scale_xy" );
    ObjStopAnimate( "obj_map_popup_window", "alp" );
      
    local pos_beg_x = ObjGet( "obj_map_popup_window" ).pos_x;
    local pos_beg_y = ObjGet( "obj_map_popup_window" ).pos_y;

    local pos_end_x = private.popup_window_beg_anim_x;
    local pos_end_y = private.popup_window_beg_anim_y;
    
    local sc_beg_x = ObjGet( "obj_map_popup_window" ).scale_x;
    local sc_beg_y = ObjGet( "obj_map_popup_window" ).scale_y;
    local sc_end_x = 0;
    local sc_end_y = 0;
    local alph = ObjGet( "obj_map_popup_window" ).alp;

    SetCursor( CURSOR_DEFAULT );

    ObjAnimate( "obj_map_popup_window", "pos_xy", 0, 0, "",
    {
      0.0, 1, pos_beg_x, pos_beg_y,
      0.2, 0, pos_end_x, pos_end_y
    } );

    ObjAnimate( "obj_map_popup_window", "scale_xy", 0, 0, "",
    {
      0.0, 1, sc_beg_x, sc_beg_y,
      0.2, 0, sc_end_x, sc_end_y
    } );

    ObjAnimate( "obj_map_popup_window", "alp", 0, 0, "*ObjAttach( 'obj_map_popup_window', 'obj_map_general')",
    {
      0.0, 1, alph,
      0.2, 0, 0
    } );
    local marker_focus = "spr_map_screen_"..private.current_screen.."_"..name.."_focus";
    if ( ObjGet( marker_focus ) ) then
      ObjAnimate( marker_focus, "alp", 0, 0, "",
      {
        0.0, 1, alph,
        0.2, 0, 0
      } );
    end;

  end;
--******************************************************************************************
-- function *** Arrow *** () end;
--******************************************************************************************
  function private.ArrowMDown ( obj )
    --ld.SoundClickBtn();
    
    local old_screen = private.current_screen;
    local new_screen = 0;
    
    if ( string.find( obj, "arrow_left" ) or string.find( obj, "arrow_up" ) ) then

      private.current_screen = private.current_screen + 1;

    elseif ( string.find( obj, "arrow_right" ) or string.find( obj, "arrow_down" ) ) then

      private.current_screen = private.current_screen - 1;

    end;

    new_screen = private.current_screen;

    private.SetCurrentScreen();

    ObjSet( "obj_map_general", { input = true } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page_1", 0, "", 0 );

    ObjSet( "obj_map_screen_"..old_screen, { alp = 0 } );
    ObjSet( "obj_map_screen_"..new_screen, { alp = 1 } );


  end;
  --******************************************************************************************
 function private.ArrowMEnter ( obj )

    ObjSet( "spr_map_btn_"..obj.."_focus", { alp = 1 } );

 end;
  --******************************************************************************************
 function private.ArrowMLeave ( obj )

    ObjSet( "spr_map_btn_"..obj.."_focus", { alp = 0 } );

 end;
--******************************************************************************************
-- function *** LOGIC *** () end;
--******************************************************************************************
  function public.VisitMapRoom ( name )

    local current_screen = private.screen[ name ].screen;
    local current_lock = private.screen[ name ].lock;
   
    private.screen[ name ].visit = true;      
    private.pos_player = name; 
      
    ObjSet( "obj_map_screen_"..current_screen.."_"..name, { active = true, visible = true, input = true } );
    ObjSet( "spr_map_screen_"..current_screen.."_"..name.."_shadow", { visible = false } );
    ObjSet( "spr_map_screen_"..current_screen.."_"..name.."_unlock", { visible = true } );

  end;
  --******************************************************************************************
  function public.LockMapRoom ( name, lock )
    
    local current_screen = private.screen[ name ].screen;

    private.screen[ name ].lock = lock;

  end;
  --******************************************************************************************
  function public.ActiveTaskRoom ( name, active )

    local current_screen = private.screen[ name ].screen;

    local prg = ng_global.currentprogress;
    local chapter = ng_global.progress[ prg ].common.chapter;
    local room = name;
  
    if chapter ~= "level1" and private.anm_rooms[name] then

      name = private.anm_rooms[name];

    end;
        
    private.screen[ name ].activ = active;    

  end;
  --******************************************************************************************
  function private.CheckMapRoom ( room_name )

    local prg = ng_global.currentprogress;
    local chapter = ng_global.progress[ prg ].common.chapter;
    local room_name = room_name;
  
    if chapter ~= "level1" and private.anm_rooms[room_name] then

        room_name = private.anm_rooms[room_name];

    end;

    local current_screen = private.screen[ room_name ].screen;
    local current_lock = private.screen[ room_name ].lock;
    local current_visit = private.screen[ room_name ].visit;
    local current_activ = private.screen[ room_name ].activ;
    local table_multiset = {};
    
    if ( current_visit == true ) then

        table.insert( table_multiset, { "obj_map_screen_"..current_screen.."_"..room_name.."_marker", { visible = true } } );        
        --table.insert( table_multiset, { "spr_map_screen_"..current_screen.."_"..room_name.."_shadow", { visible = false } } );
        --table.insert( table_multiset, { "spr_map_screen_"..current_screen.."_"..room_name.."_unlock", { visible = true } } );

        if ( current_activ == true ) then
            
          table.insert( table_multiset, { "anm_map_screen_"..current_screen.."_"..room_name.."_marker_light", { visible = true } } );
          table.insert( table_multiset, { "anm_map_screen_"..current_screen.."_"..room_name.."_marker", { visible = false } } );

        else

          table.insert( table_multiset, { "anm_map_screen_"..current_screen.."_"..room_name.."_marker_light", { visible = false } } );
          table.insert( table_multiset, { "anm_map_screen_"..current_screen.."_"..room_name.."_marker", { visible = true } } );

        end;

        if ( current_lock == true ) then

          table.insert( table_multiset, { "anm_map_screen_"..current_screen.."_"..room_name.."_marker_blocked", { visible = true } } );
          table.insert( table_multiset, { "obj_map_screen_"..current_screen.."_"..room_name.."_marker", { input = false } } );
          table.insert( table_multiset, { "anm_map_screen_"..current_screen.."_"..room_name.."_marker", { visible = false } } );
          table.insert( table_multiset, { "anm_map_screen_"..current_screen.."_"..room_name.."_marker_light", { visible = false } } );

        else

          table.insert( table_multiset, { "anm_map_screen_"..current_screen.."_"..room_name.."_marker_blocked", { visible = false } } );
          table.insert( table_multiset, { "obj_map_screen_"..current_screen.."_"..room_name.."_marker", { input = true } } );
                  
        end;

    else

      table.insert( table_multiset, { "obj_map_screen_"..current_screen.."_"..room_name.."_marker", { visible = false, input = false } } );        

    end;
    ObjMultiSet( table_multiset );

  end;
  --******************************************************************************************
  function private.AnmRouteRoom ( )
    
    --необходима для показа карты, смены скринов
   
    for i = #game.progress_names, 1, -1 do

      if ( common.GetObjectPrefix( game.progress_names[ i ] ) == "opn" ) then

        local event_name = game.progress_names[ i ]
        local name = common.GetObjectName( event_name );
        local prg = ng_global.currentprogress;
        local chapter = ng_global.progress[ prg ].common.chapter;
        local done_flag = false;
        
        if chapter ~= "level1" and private.anm_rooms[name] then

          name = private.anm_rooms[name];
          done_flag = true;          

        end;

        local anm_route = "anm_map_screen_"..private.current_screen.."_"..name;
        
        if ( ObjGet( anm_route ) ) then
           
           AnimStop( anm_route );
           ObjSet( anm_route, { visible = false } );

           if ( cmn.IsEventDone( event_name ) ) then

             ObjSet( anm_route, { visible = true } );

             if ( not ng_global.progress[ ng_global.currentprogress ][ event_name ].anm_map and done_flag ~= true ) then

              ng_global.progress[ ng_global.currentprogress ][ event_name ].anm_map = true;  
                              
              AnimPlay( anm_route, "DoAnim", "" );
            
             elseif ( ng_global.progress[ ng_global.currentprogress ][ event_name ].anm_map or done_flag == true ) then

              AnimPlay( anm_route, "DoAnim_complete", "" );
              done_flag = false;
            
             end;

          end;

        end;

      end;

    end;

 

  end;
  --******************************************************************************************
  function private.SetCurrentScreen ( )--

    if ( private.screen["nightsvilleentrance"] ~= nil  ) then

      if ( private.screen["nightsvilleentrance"].visit == true ) then

          ObjSet( "obj_map_btn_arrow", { input = true, visible = true, active = true  } );

          if ( private.current_screen == 1 ) then
            
            ObjSet( "spr_map_btn_arrow_left", { input = true, alp = 1 } );
            ObjSet( "spr_map_btn_arrow_right", { input = false, alp = 0 } );
        
          elseif ( private.current_screen == 2 ) then

            ObjSet( "spr_map_btn_arrow_left", { input = false, alp = 0 } );
            ObjSet( "spr_map_btn_arrow_right", { input = true, alp = 1 } );
          
            
          elseif ( private.current_screen == 3 ) then

            ObjSet( "obj_map_btn_arrow", { input = false, visible = false, active = false } );

          end;

      else

        ObjSet( "obj_map_btn_arrow", { input = false, visible = false, active = false } );

      end;

    else

      ObjSet( "obj_map_btn_arrow", { input = false, visible = false, active = false } );

    end;
   
    for i = 1,3 do
      ObjSet( "obj_map_screen_"..i, { input = false, visible = false, active = false, alp = 1 } );
      ObjSet( "spr_int_map_back_"..i, { input = false, visible = false, active = false  } );
    end;

    ObjSet( "obj_map_screen_"..private.current_screen, { input = true, visible = true, active = true, alp = 1 } );
    ObjSet( "spr_int_map_back_"..private.current_screen, {  input = true, visible = true, active = true  } );

    private.AnmRouteRoom();

  end;
  --******************************************************************************************
  function private.PlayAnims ( )--

    local pos_y = ObjGet( "int_map_impl" ).pos_y;
    ObjAnimate( "int_map_impl", "pos_y", 1, 0, "", { 
      0, 3, pos_y, 
      1.6, 3, pos_y + 4, 
      3.2, 3, pos_y } );

  end;
  --******************************************************************************************