-- name=int_providence_eye
--******************************************************************************************
function public.Init ( pos_z )

  ObjAttach( "int_providence_eye", interface.originhub );
  ObjSet( "int_providence_eye", { pos_z = pos_z } );

  ObjSet("ted_providence_eye", { event_mdown = public.Hide });
  public.show_eye = false;

end;
--******************************************************************************************
function public.Destroy()

end;
--******************************************************************************************
function private.Show()

  common_impl.Lock( true );

  ObjSet( "anm_providence_eye", { scale_y = 0, alp = 0, active = true } );

  local func = function()

    common_impl.Lock( false );

    ObjSet( "ted_providence_eye", { input = true } );
    
  end;

  AnimPlay( "anm_providence_eye", "DoAnim", "" );
  ObjAnimate( "anm_providence_eye", "alp", 0, 0, func, { 0, 0, 0,   0.3, 0, 0.7 } );
  ObjAnimate( "anm_providence_eye", "scale_y", 0, 0, func, { 0, 0, 0,   0.3, 3, 1, 1 } );

end;
--******************************************************************************************
function public.Hide()

  local func = function()

    ObjSet( "anm_providence_eye", { active = false } );

  end;

  public.show_eye = false;

  ObjSet( "ted_providence_eye", { input = false } );

  ObjAnimate( "anm_providence_eye", "alp", 0, 0, func, { 0, 0, 0.7,   0.3, 0, 0 } );

end;
--******************************************************************************************
function public.CheckShow()

  local show = false;
  local room = common.GetObjectName( common.GetCurrentRoom() );
  local prg = ng_global.currentprogress;
  local chapter         = ng_global.progress[ ng_global.currentprogress ].common.chapter;
  local current_lvl     = tonumber( string.sub( chapter, -1 ) );

  if ( current_lvl == 1 ) then

    if ( ng_global.progress[ "std" ][ "dlg_fork_ancient" ] and not cmn.IsEventDone( "dlg_fork_ancient" )) then

      return;

    end;

  end;

  local events = int_providence.GetEvents( room );

  if not events then

    return;

  end;

  if ng_global.progress[ prg ][ "opn_"..room ] then

    if ( not ng_global.progress[ prg ][ "opn_"..room ].eye ) then

      ng_global.progress[ prg ][ "opn_"..room ].eye = true;
      show = true;

    end;

    for i = 1, #events do

      if ( ng_global.progress[ prg ][ events[ i ] ] and cmn.IsEventDone( events[ i ] ) ) then

        if ( not ng_global.progress[ prg ][ events[ i ] ].eye ) then

          ng_global.progress[ prg ][ events[ i ] ].eye = true;
          show = true;

        end;

      end;

    end;

  end;

  if ( show ) then

    public.show_eye = true;
    private.Show();

  end;

end;
--******************************************************************************************