-- name=interface_impl

function public.Init ()

    private.Init_Deploy();
    public.Init_DialogHint();
    public.Init_BtnProvide();
    public.Init_Provide();
    public.Init_ProvideEye();
    public.Init_Lock();
    private.Init_InvestigationButton();
    private.Init_Evidence();
    private.Init_Diary();
    private.Init_Slider();
    private.Init_Task();
    private.Init_Achievements();
    private.Init_BtnCollectibles2();
    private.Init_BtnCollectibles();
    private.Init_BtnMorph();
    private.Init_BtnTimer();
end;
--******************************************************************************************
function private.Init_Deploy()

  function interface.DeployInvAdd(pos_z)

    InterfaceWidget_Deploy_Inv = "InterfaceWidget_Deploy_Inv";
    interface.CustomWidgetAdd( InterfaceWidget_Deploy_Inv, "assets/interface/int_deploy_inv", "int_deploy_inv",pos_z );

  end;

  function interface.GetCurrentInv()

    if _G[ "int_deploy_inv" ] then
      if int_deploy_inv.IsOnScreen() then  
        return int_deploy_inv.GetCurrentName();
      end;      
    end;
    return "";

  end;

  -------------------------------------------------------------------------------------

  function interface.DeployInvShow( inv_obj )
    
    if _G[ "int_deploy_inv" ] then

      int_deploy_inv.Show( inv_obj );

    end;

  end;

  -------------------------------------------------------------------------------------

  function interface.DeployInvHide()

    --common_impl.DeleteHintFx()
  
    if _G[ "int_deploy_inv" ] then

      int_deploy_inv.Hide();

    end;
    
  end;

end;
--******************************************************************************************
function public.Init_DialogHint()

  -------------------------------------------------------------------------------------
  function interface.DialogHintAdd()

    InterfaceWidget_Dialog_Hint = "InterfaceWidget_Dialog_Hint";
    interface.CustomWidgetAdd( InterfaceWidget_Dialog_Hint, "assets/interface/int_dialog_hint", "int_dialog_hint" );

  end;

  -------------------------------------------------------------------------------------

  function interface.DialogHintShow( dlg_room )

    dlg_room = dlg_room;  
    int_dialog_hint.Show( dlg_room );

  end;

  -------------------------------------------------------------------------------------

  function interface.DialogHintHide()

    int_dialog_hint.Hide();

  end;

end;
--******************************************************************************************
function public.Init_BtnProvide()

  -------------------------------------------------------------------------------------
  function interface.BtnProvideAdd(pos_z)

    InterfaceWidget_Btn_Providence = "InterfaceWidget_Btn_Providence";
    interface.CustomWidgetAdd( InterfaceWidget_Btn_Providence, "assets/interface/int_button_providence", "int_button_providence", pos_z );

  end;

  -------------------------------------------------------------------------------------
  function interface.PanelProvideAdd(pos_z)

    InterfaceWidget_Panel_Providence = "InterfaceWidget_Panel_Providence";
    interface.CustomWidgetAdd( InterfaceWidget_Panel_Providence, "assets/interface/int_panel_providence", "int_panel_providence", pos_z );

  end;

  -------------------------------------------------------------------------------------

  function interface.PanelProvideShow()

    if _G[ "int_panel_providence" ] then

        int_panel_providence.Show();

    end;

  end;

  -------------------------------------------------------------------------------------

  function interface.PanelProvideAnimShow( func_end )

    if _G[ "int_panel_providence" ] then

      ObjSet( "int_panel_providence", { active = true, visible = true, input = true } );
      interface.InventoryOpen();
      AnimPlay( "anm_panel_providence", "DoAnim", func_end );
      ObjAnimate( "spr_int_inventory",            "pos_x", 0, 0, "", { 0,0,0, 0.5,3,-87 } );
      ObjAnimate( "obj_int_inventory_providence", "pos_x", 0, 0, "", { 0,0,-87, 0.5,3,0 } );
      ObjAnimate( "spr_int_inventory_side_right", "alp",   0, 0, "", { 0,0,1, 1.2,0,1, 1.3,0,0 } );

    end;

  end;

  -------------------------------------------------------------------------------------

  function interface.ProvidePanelItemAdd( item_name, object_name, func_end )

    object_name = object_name or "";
    trigger_end = trigger_end or "";
  
    if ( _G[ "cheater" ] ) then
      if ( object_name ~= "" ) and ( cheater.is_progress_executing_now ) then
  
        ObjDelete( object_name );
        object_name = "";
  
      end;
    end;

    if _G[ "int_panel_providence" ] then

      int_panel_providence.AddObject( item_name, object_name, false, func_end );

    end;

  end;

  -------------------------------------------------------------------------------------

  function interface.ProvidePanelSilhouetteAdd( item_name, object_name, func_end )

    object_name = object_name or "";
    trigger_end = trigger_end or "";
  
    if ( _G[ "cheater" ] ) then
      if ( object_name ~= "" ) and ( cheater.is_progress_executing_now ) then
  
        ObjDelete( object_name );
        object_name = "";
  
      end;
    end;

    if _G[ "int_panel_providence" ] then

      int_panel_providence.AddObject( item_name, object_name, true, func_end );

    end;

  end;

  -------------------------------------------------------------------------------------

  function interface.ProvidePanelItemRemove( item_name )

    if _G[ "int_panel_providence" ] then

      int_panel_providence.DeleteObject( item_name );

    end;

  end;

  -------------------------------------------------------------------------------------

  function interface.PanelProvideHide()

    if _G[ "int_panel_providence" ] then

      int_panel_providence.Hide();

    end;

  end;

end;
--******************************************************************************************
function public.Init_Provide()

  -------------------------------------------------------------------------------------
  function interface.ProvideAdd(pos_z)

    InterfaceWidget_Providence = "InterfaceWidget_Providence";
    interface.CustomWidgetAdd( InterfaceWidget_Providence, "assets/interface/int_providence", "int_providence", pos_z );

  end;

  -------------------------------------------------------------------------------------

end;
--******************************************************************************************
function public.Init_ProvideEye()

  -------------------------------------------------------------------------------------
  function interface.ProvideEyeAdd(pos_z)

    InterfaceWidget_ProvidenceEye = "InterfaceWidget_ProvidenceEye";
    interface.CustomWidgetAdd( InterfaceWidget_ProvidenceEye, "assets/interface/int_providence_eye", "int_providence_eye", pos_z );

  end;

  -------------------------------------------------------------------------------------

end;
--******************************************************************************************
function public.Init_Lock()

  function interface.LockAdd()

    InterfaceWidget_Lock = "InterfaceWidget_Lock";
    interface.CustomWidgetAdd( InterfaceWidget_Lock, "assets/interface/int_lock", "int_lock",1490 );

    ------------------------------------------------------------------------------------

    function interface.LockShow()

      if _G[ "int_lock" ] then

        int_lock.Show();

      end;

    end;

    ------------------------------------------------------------------------------------

    function interface.LockHide()

      if _G[ "int_lock" ] then

          int_lock.Hide();

      end;

    end;

  end;

end;
--******************************************************************************************
function private.Init_InvestigationButton ()

  function interface.InvestigationButtonAdd ( pos_z )

    InterfaceWidget_InvestigationButton = "InterfaceWidget_InvestigationButton";
    interface.CustomWidgetAdd( InterfaceWidget_InvestigationButton, "assets/interface/int_investigation_button", "int_investigation_button", pos_z );

  end;

  function interface.InvestigationButtonItemAdd ( object_name, game_object_name, func_end )

    common_impl.PlayAudio( "sfx", "common/audio/aud_evidence_fly", 0, "", 0 );
    int_investigation_button.AddObject( object_name, game_object_name, func_end );

  end;

  function interface.InvestigationButtonCheck ()

    local event_exist = true;

    if ( event_show_investigation ) and ( not cmn.IsEventDone( event_show_investigation ) ) then

      event_exist = false;

    end;

    if ( event_exist ) and ( prefix ~= "ho" ) and ( prefix ~= "mg" ) then

      local prefix = common.GetObjectPrefix( common.GetCurrentRoom() );

      if ( prefix ~= "ho" ) and ( prefix ~= "mg" ) then

        int_investigation_button.Show();

      else

        int_investigation_button.Hide();

      end;

    end;

  end;

end;
--******************************************************************************************
function private.Init_Evidence ()

  function interface.EvidenceAdd ( pos_z )

    InterfaceWidget_Evidence = "InterfaceWidget_Evidence";
    interface.CustomWidgetAdd( InterfaceWidget_Evidence, "assets/interface/int_evidence", "int_evidence", pos_z );

  end;
  ------------------------------------------------------------------------------------

  function interface.EvidenceScreenShow ()
      
    int_evidence.Show();

  end;

  ------------------------------------------------------------------------------------

  function interface.EvidenceScreeHide ()

     int_evidence.Hide();

  end;

  ------------------------------------------------------------------------------------

  function interface.EvidenceFlashBackShow ( num, func_end )

     int_evidence.ShowFlashBack( num, func_end );

  end;

  ------------------------------------------------------------------------------------

  function interface.EvidenceGetList ()

    return int_evidence.GetList();

  end;

  ------------------------------------------------------------------------------------

  function interface.DialogEvidenceAdd ( pos_z )

    InterfaceWidget_Dialog_Evidence = "InterfaceWidget_Dialog_Evidence";
    interface.CustomWidgetAdd( InterfaceWidget_Dialog_Evidence, "assets/interface/int_dialog_evidence", "int_dialog_evidence", pos_z );

  end;

  ------------------------------------------------------------------------------------

  function interface.DialogEvidenceShow ( name_obj, func_end, no_bbt )
    
    common_impl.HideCurrentInterface();
    int_dialog_evidence.Show( name_obj, func_end, no_bbt );

  end;

  ------------------------------------------------------------------------------------

  function interface.DialogEvidenceHide ()

    common_impl.ShowCurrentInterface();
    int_dialog_evidence.Hide();

  end;

end;
--******************************************************************************************
function private.Init_Slider ()

  function interface.SliderAdd (pos_z)

    InterfaceWidget_Slider = "InterfaceWidget_Slider";
    interface.CustomWidgetAdd( InterfaceWidget_Slider, "assets/interface/int_slider", "int_slider", pos_z );

  end;

end;
--******************************************************************************************
function private.Init_Task ()

  function interface.ButtonTaskAdd ( pos_z )

    InterfaceWidget_Button_Task = "InterfaceWidget_Button_Task";
    interface.CustomWidgetAdd( InterfaceWidget_Button_Task, "assets/interface/int_button_task", "int_button_task", pos_z );

  end;
  ------------------------------------------------------------------------------------
  function interface.DialogTaskAdd ( pos_z )

    InterfaceWidget_Dialog_Task = "InterfaceWidget_Dialog_Task";
    interface.CustomWidgetAdd( InterfaceWidget_Dialog_Task, "assets/interface/int_dialog_task", "int_dialog_task", pos_z );

  end;
  ------------------------------------------------------------------------------------
  function interface.DialogTaskShow ( task, state, func_end )
    
    local data = { task = task, state = state, func_end = func_end };

    if ( not int_dialog_task.show ) then 
     
      if ( _G[ "int_dialog_task" ] ) then

         int_dialog_task.Show( data );

      end;

    else

      interface.DialogTaskHide();

    end;

  end;
  ------------------------------------------------------------------------------------
  function interface.DialogTaskHide ()

    if ( int_dialog_task.show ) then

      if ( _G[ "int_dialog_task" ] ) then

         int_dialog_task.Hide();

      end;

    end;
    
  end;
  ------------------------------------------------------------------------------------
  function interface.KeyTaskAdd ( task_name, runtime, func_end )

    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "text" ] ) then    
      return;
    end; 

    ng_global.task_current = task_name;
    int_button_task.Update( true, task_name );
    common_impl.PlayAudio( "sfx", "common/audio/aud_global_task", 0, "", 0 );
    
    interface.DialogTaskShow( task_name, "new_task", func_end );

  end;
  ------------------------------------------------------------------------------------
  function interface.KeyTaskDone ( task_name, runtime, func_end )

    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "text" ] ) then    
      return;
    end; 

    if ( runtime ) then

      interface.DialogTaskShow( task_name, "done_task", func_end );  

    end;

    int_button_task.Update( false, "none" );
    ng_global.task_current = "none";
  
  end;
  ------------------------------------------------------------------------------------
  function interface.KeyUpdate ()

    local active = false;
    if ( ng_global.task_current ) and ( ng_global.task_current ~= "none" ) then
      active = true;
    end;

    int_button_task.Update( active, ng_global.task_current );
  
  end;
  ------------------------------------------------------------------------------------

end;
--******************************************************************************************
function private.Init_Achievements ()

  function interface.AchievementsAdd ( pos_z )

    InterfaceWidget_achievements = "InterfaceWidget_achievements";
    interface.CustomWidgetAdd( InterfaceWidget_achievements, "assets/interface/int_achievements", "int_achievements", pos_z );

  end;
  ------------------------------------------------------------------------------------
  function interface.ShowAchievements ( name )

    int_achievements.Show( name );
      if port.isPortable() == 1 then
        if name ~= "puzzle" and 
           name ~= "morphing" then
           iOS_LogEvents(8,name);
        end;
      end;

  end;
  ------------------------------------------------------------------------------------

end;
--******************************************************************************************
function private.Init_BtnCollectibles2 ()

  function interface.BtnCollectibles2Add ( pos_z )

    InterfaceWidget_collectibles2 = "InterfaceWidget_collectibles2";
    interface.CustomWidgetAdd( InterfaceWidget_collectibles2, "assets/interface/int_button_collectibles2", "int_button_collectibles2", pos_z );

  end;
  ------------------------------------------------------------------------------------
  ------------------------------------------------------------------------------------

end;
--******************************************************************************************
function private.Init_BtnCollectibles ()

  function interface.BtnCollectiblesAdd ( pos_z )

    InterfaceWidget_collectibles = "InterfaceWidget_collectibles";
    interface.CustomWidgetAdd( InterfaceWidget_collectibles, "assets/interface/int_button_collectibles", "int_button_collectibles", pos_z );

  end;
  ------------------------------------------------------------------------------------
  ------------------------------------------------------------------------------------

end;

--******************************************************************************************
function private.Init_BtnMorph ()

  function interface.BtnMorphAdd ( pos_z )

    InterfaceWidget_morph = "InterfaceWidget_morph";
    interface.CustomWidgetAdd( InterfaceWidget_morph, "assets/interface/int_button_morph", "int_button_morph", pos_z );

  end;
  ------------------------------------------------------------------------------------
  function interface.ShowMorph ()
   
    int_button_morph.Show();

  end;
  ------------------------------------------------------------------------------------

end;
--******************************************************************************************
function private.Init_Diary()

  function interface.DiaryAdd(pos_z)

    InterfaceWidget_Diary = "InterfaceWidget_Diary";
    interface.CustomWidgetAdd( InterfaceWidget_Diary, "assets/interface/int_diary", "int_diary",pos_z );

  end;

  ------------------------------------------------------------------------------------

  function interface.DiaryShow()
    
    if int_diary.show == 0 then 
     
      if _G[ "int_diary" ] then

         int_diary.Show();

      end;

    else

      interface.DiaryHide();

    end;

  end;

  ------------------------------------------------------------------------------------

  function interface.DiaryHide()

    if int_diary.show == 1 then

      if _G[ "int_diary" ] then

         int_diary.Hide();

      end;

    end;
    
  end;

end;
--******************************************************************************************
function private.Init_BtnTimer ()

  function interface.ButtonTimerAdd ( pos_z )

    InterfaceWidget_Button_Timer = "InterfaceWidget_Button_Timer";
    interface.CustomWidgetAdd( InterfaceWidget_Button_Timer, "assets/interface/int_button_timer", "int_button_timer", pos_z );

  end;
  ------------------------------------------------------------------------------------

end;
--******************************************************************************************
