-- name=ho_search
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "search" );
  game.relations[ "ho_search" ].exitroom = "rm_livingroom";
  local table_multiset = {};

    table.insert( table_multiset, { "spr_search_lighter", { event_mdown = function() private.TaskComplete( 'lighter' ) end } } );
    table.insert( table_multiset, { "spr_search_purse", { event_mdown = function() private.TaskComplete( 'purse' ) end } } );
    table.insert( table_multiset, { "spr_search_ring_big", { event_mdown = function() private.TaskComplete( 'ring', 'spr_search_ring_big' ) end } } );
    table.insert( table_multiset, { "spr_search_hand_ring", { event_mdown = function() private.TaskComplete( 'ring', 'spr_search_hand_ring' ) end } } );
    table.insert( table_multiset, { "spr_search_ring", { event_mdown = function() private.TaskComplete( 'ring' ) end } } );
    table.insert( table_multiset, { "spr_search_skull", { event_mdown = function() private.TaskComplete( 'skull' ) end } } );
    table.insert( table_multiset, { "spr_search_key", { event_mdown = function() private.TaskComplete( 'key' ) end } } );
    table.insert( table_multiset, { "spr_search_star", { event_mdown = function() private.TaskComplete( 'star' ) end } } );
    table.insert( table_multiset, { "spr_search_butterfly_2", { event_mdown = function() private.TaskComplete( 'butterfly_2' ) end } } );
    table.insert( table_multiset, { "spr_search_glove", { event_mdown = function() private.TaskComplete( 'glove' ) end } } );
    table.insert( table_multiset, { "spr_search_knuckles", { event_mdown = function() private.TaskComplete( 'knuckles' ) end } } );
    table.insert( table_multiset, { "spr_search_medallion_close", { event_mdown = function() private.ClkMedallion() end } } );
    table.insert( table_multiset, { "spr_search_coin", { event_mdown = function() private.TaskComplete( 'coin' ) end } } );
    table.insert( table_multiset, { "spr_search_ruby", { event_mdown = function() private.TaskComplete( 'ruby' ) end } } );
    table.insert( table_multiset, { "spr_search_picture", { event_mdown = function() private.TaskComplete( 'picture' ) end } } );
    table.insert( table_multiset, { "spr_search_scissors", { event_startdrag = function() private.GetItem( 'scissors' ) end, event_dragdrop = function() private.unmark_picture() end } } );
    table.insert( table_multiset, { "spr_search_blade", { event_startdrag = function() private.GetItem( 'blade' ) end, event_dragdrop = function() private.unmark_ruby() end } } );

  for i = 1, 5 do
    table.insert( table_multiset, { "spr_search_button_"..i, { event_mdown = function() private.ClkButton( i ) end } } );
  end;

  private.jacket_count = 0;
  table.insert( table_multiset, { "obj_search_clk_sleeve", { event_mdown = function() private.ClkSleeve() end } } );
  table.insert( table_multiset, { "obj_search_clk_butterfly", { event_mdown = function() private.ClkButterfly() end } } );
  table.insert( table_multiset, { "spr_search_butterfly_1", { event_mdown = function() private.ClkButterfly() end } } );
  table.insert( table_multiset, { "obj_search_clk_jacket", { event_mdown = function() private.ClkJacket() end } } );
  table.insert( table_multiset, { "obj_search_hint_jacket", { event_mdown = function() private.ClkJacket() end } } );

  ObjMultiSet(table_multiset);
--------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------
  local unmark_star = function () 

    ObjMultiSet({
      {"spr_search_sleeve_2", { alp = 0 }},
      {"spr_search_star", { input = true }},
    }); 
      
  end;

  cmn.AddSubscriber( "unmark_star", unmark_star, "ho_search" ); 
 --------------------------------------------------------------------------------------------------
  local unmark_butterfly_2 = function () 

    ObjMultiSet({
      {"obj_search_hand_with_butterfly", { input = true }},
      {"spr_search_butterfly_2", { input = true }},
      {"spr_search_butterfly_1", { input = false }},
      {"obj_search_hand_with_butterfly", { alp = 1 }},
      {"obj_search_left_hand", { alp = 0 }},
      {"obj_search_clk_jacket", { input = false }},
      {"obj_search_clk_butterfly", { pos_x = 379, pos_y = 497 }},
    })

  end;

  cmn.AddSubscriber( "unmark_butterfly_2", unmark_butterfly_2, "ho_search" ); 
--------------------------------------------------------------------------------------------------
  local unmark_glove = function () 

    if ng_global.progress["std"]["win_search"].open_jacket ~= false then
      ObjMultiSet({
        {"obj_search_close_jacket", { alp = 0, input = false }},
        {"obj_search_open_jacket", { alp = 1, input = true } },
        {"obj_search_clk_butterfly", { input = false }},
        {"obj_search_clk_jacket", { pos_x = 63, pos_y = 388 }},
        {"obj_search_hint_jacket", { input = false }},
        {"spr_search_glove", { input = true }},
        {"spr_search_knuckles", { input = true }},
        {"spr_search_medallion_close", { input = true }},
        {"spr_search_butterfly_1", { input = false }},
        {"spr_search_key", { input = false }},
      });
    

      if private.IsFound( 'ruby' ) ~= true and private.IsFound( 'picture' ) == true and not cmn.IsUnmarkedTask( "search", "ruby" ) then
         ObjSet( "obj_search_use_scissors_2", { input = true } );
         ObjSet( "obj_search_hint_ruby", { input = true } );
      end;

    end;  

  end;

  cmn.AddSubscriber( "unmark_glove", unmark_glove, "ho_search" ); 
--------------------------------------------------------------------------------------------------
  local unmark_coin = function ()
 
    ObjMultiSet({
      {"spr_search_medallion_close", { alp = 0, input = false }},
      {"spr_search_medallion_open", { alp = 1 }},
      {"spr_search_coin", { input = true }},
    });
        
  end;

  cmn.AddSubscriber( "unmark_coin", unmark_coin, "ho_search" ); 
--------------------------------------------------------------------------------------------------
  local unmark_ruby = function () 

    ObjMultiSet({
      {"spr_search_ruby_open", { alp = 1 } },
      {"spr_search_ruby", { input = true }},
    });

    ObjDelete( "spr_search_ruby_close" );
    ObjDelete( "obj_search_use_scissors_2" );

    ObjDelete( "spr_search_scissors" );
    ObjDelete( "obj_search_hint_ruby" );
    ObjDelete( "anm_search_scissors_2" );
   

  end;

  cmn.AddSubscriber( "unmark_ruby", unmark_ruby, "ho_search" ); 
--------------------------------------------------------------------------------------------------
  local unmark_picture = function () 

    ObjSet( "spr_search_picture", { input = true } );
    ObjDelete( "obj_search_use_scissors_1" );
    ObjDelete( "spr_search_rope_1" );
    ObjDelete( "spr_search_rope_2" );
    ObjSet( "spr_search_cutrope", { alp = 1 } );
    ObjDelete( "obj_search_hint_picture" );
    ObjDelete( "anm_search_scissors_1" );
        
  end;

  cmn.AddSubscriber( "unmark_picture", unmark_picture, "ho_search" ); 
--------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------
  local start_search_func = function ()

      if not ( cmn.IsEventDone( "win_search" ) ) then

        if ( cmn.IsUnmarkedTask( "search", "star" ) ) then
          unmark_star();
        end;

        if ( cmn.IsUnmarkedTask( "search", "glove" ) ) then
          unmark_glove();
        end;

        if ( cmn.IsUnmarkedTask( "search", "knuckles" ) ) then
          unmark_glove();
        end;

        if ( cmn.IsUnmarkedTask( "search", "coin" ) ) then
          unmark_coin();
        end;

        if ( cmn.IsUnmarkedTask( "search", "butterfly_2" ) ) then
          unmark_butterfly_2();
        end;

        if ( cmn.IsUnmarkedTask( "search", "ruby" ) ) then
          unmark_ruby();
        end;

        if ( cmn.IsUnmarkedTask( "search", "picture" ) ) then
          unmark_picture();
        end;

      end;

  end;    
  
  cmn.AddSubscriber( "win_search", start_search_func, "ho_search" );
--------------------------------------------------------------------------------------------
 common_impl.hint[ "win_search" ] = {
    type = "win",
    room = "rm_livingroom",
    zz = "ho_search",
    zz_gate = "gho_livingroom_search"
  };
  local win_search_func = function ()

    if ( cmn.IsEventDone( "win_search" ) ) then
      interface.InventoryItemAdd( "inv_picture", "spr_search_win" );
      ObjSet( "spr_pictureframe_plus_light", { alp = 1 } );
      ObjDelete( "gho_livingroom_search" );
  
    else

       local ho_found = ng_global.progress[ "std" ][ "win_search" ].found;
        
        for i = 1, #ho_found, 1 do
          ObjDelete( ho_found[ i ][ "object" ] );

          local task_name = ho_found[ i ][ "task" ];

          private.CompleteTaskFunctions( task_name )

        end;
            
    end;

  end;
  cmn.AddSubscriber( "win_search", win_search_func );

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_search" ) ) then

    cmn.InitHo( "search" );

    ng_global.progress["std"]["win_search"].open_jacket = false;
    
    ng_global.progress["std"]["win_search"].buttons = { 0, 0, 0, 0, 0 };
    ng_global.progress["std"]["win_search"].done_task_count = 0;

    cmn.SetEventDone( "opn_search" );
    cmn.SetMarkedTask( "search", "star" );
    cmn.SetMarkedTask( "search", "butterfly_2" );
    cmn.SetMarkedTask( "search", "glove" );
    cmn.SetMarkedTask( "search", "knuckles" );
    cmn.SetMarkedTask( "search", "coin" );
    cmn.SetMarkedTask( "search", "ruby" );
    cmn.SetMarkedTask( "search", "picture" );
      
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "lighter",          1, 0, { { "spr_search_lighter" } } );
  interface.TaskPanelTaskAdd( ho_items, "purse",          1, 0, { { "spr_search_purse" } } );
  interface.TaskPanelTaskAdd( ho_items, "ring",          3, 0, { { "spr_search_ring" }, { "spr_search_ring_big" }, { "spr_search_hand_ring" } }  );
  interface.TaskPanelTaskAdd( ho_items, "skull",          1, 0, { { "spr_search_skull" } } );
  interface.TaskPanelTaskAdd( ho_items, "key",          1, 0, { { "spr_search_key" } } );
  interface.TaskPanelTaskAdd( ho_items, "star",          1, 1, { { "spr_search_star" }, { "obj_search_clk_sleeve" } } );
  interface.TaskPanelTaskAdd( ho_items, "butterfly_2",          1, 1, { { "spr_search_butterfly_1" } ,{ "spr_search_butterfly_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "glove",          1, 1, { { "obj_search_hint_jacket" } , { "spr_search_glove" } } );
  interface.TaskPanelTaskAdd( ho_items, "knuckles",          1, 1, { { "obj_search_hint_jacket" } ,{ "spr_search_knuckles" } } );
  interface.TaskPanelTaskAdd( ho_items, "coin",          1, 1, { { "obj_search_hint_jacket" }, { "spr_search_medallion_close" } , { "spr_search_coin" } } );
  interface.TaskPanelTaskAdd( ho_items, "ruby",          1, 1, { { "obj_search_hint_jacket" }, { "obj_search_hint_ruby", "obj_search_use_scissors_2" } , { "spr_search_ruby" } } );
  interface.TaskPanelTaskAdd( ho_items, "picture",          1, 1, { { "obj_search_hint_picture" , "obj_search_use_scissors_1" } ,{ "spr_search_picture" } } );
      
  interface.TaskPanelShow( ho_items );
 
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );  

  interface.InvestigationButtonCheck();

end;
--*********************************************************************************************************************
function public.Open ()
  
  common_impl.VisitMapRoom( "livingroom" );
  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();

  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();
    
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

  local item_object_name = "obj_"..common.GetObjectName( item_name );

  ObjDelete( item_object_name );

  interface.ItemPanelTryToComplete();

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.CompleteTaskFunctions( task_name )

  local table_multiset = {};

  table.insert( table_multiset, { "tmr_search_anim", { playing = 0 } } );
  common_impl.Lock(false);

  
  if task_name == "purse" then  

    ObjDelete( "spr_search_purse_shadow" );

  elseif task_name == "star" then   

    ObjDelete( "obj_search_clk_sleeve" );

  elseif task_name == "butterfly_2" then   

    ObjDelete( "obj_search_hand_with_butterfly" ); 
    ObjDelete( "spr_search_butterfly_1" );
    ObjDelete( "obj_search_clk_butterfly" );

    table.insert( table_multiset, { "obj_search_left_hand", { alp = 1 } } );
    table.insert( table_multiset, { "obj_search_clk_jacket", { input = true } } );

    if private.IsFound( 'coin' ) ~= true or private.IsFound( 'glove' ) ~= true or private.IsFound( 'knuckles' ) ~= true or private.IsFound( 'ruby' ) ~= true then
      ObjSet( "obj_search_hint_jacket", { input = true } );
    end;   

  elseif task_name == "glove" or task_name == "knuckles" or task_name == "coin" or task_name == "ruby" then

    private.jacket_count = private.jacket_count + 1;

  elseif task_name == "picture" then

    if not cmn.IsUnmarkedTask( "search", "ruby" ) and ng_global.progress["std"]["win_search"].open_jacket ~= false then

      ObjSet( "obj_search_hint_ruby", { input = true } );
      ObjSet( "obj_search_use_scissors_2", { input = true } );

    end;  

  end;

  if private.jacket_count == 4 then 

    private.jacket_count = 0;
    table.insert( table_multiset, { "obj_search_close_jacket", { alp = 1, input = true } } );

    ObjDelete( "obj_search_open_jacket" ); 
    ObjDelete( "obj_search_clk_jacket" );
     
    for i = 1, 5 do
      table.insert( table_multiset, {  "spr_search_button_"..i, { input = true } } );
    end;

    if private.IsFound( "key" ) ~= true then
      table.insert( table_multiset, { "spr_search_key", { input = true }  } );
    end;

    if private.IsFound( 'butterfly_2' ) == false and not cmn.IsUnmarkedTask(  "search", "butterfly_2" ) or private.IsFound( 'butterfly_2' ) == true then 
      table.insert( table_multiset, { "obj_search_clk_butterfly", { input = true } } );
      table.insert( table_multiset, { "spr_search_butterfly_1", { input = true } } );
     
    end;
    

  end;
    
  ObjMultiSet(table_multiset);

end;
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name, object_name )

  local object = "";

  if object_name then

    object = tostring( object_name );

  else

    object = "spr_search_"..task_name;

  end;
  
  ObjSet( object, { pos_z = 1 } );

  cmn.HoTaskFind( object, task_name );

  ng_global.progress["std"]["win_search"].done_task_count = ng_global.progress["std"]["win_search"].done_task_count + 1;
  
  if ( ng_global.progress["std"]["win_search"].done_task_count < 14 ) then

    if task_name ~= "purse" and task_name ~= "star" then

      common_impl.Lock(true);

      ObjSet( "tmr_search_anim", { playing = 1, time = 0.8, endtrig = function() private.CompleteTaskFunctions( task_name ) end; } );

    else

      private.CompleteTaskFunctions( task_name );

    end;

  end;

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------
function private.GetItem( name )

  local table_multiset = {};
  table.insert( table_multiset, { "obj_search_use_objects", { pos_z = 20 } } );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  if name == "scissors" then

    table.insert( table_multiset, { "spr_search_scissors", { pos_z = 20 } } );
    table.insert( table_multiset, { "spr_search_scissors_shadow", { alp = 0 } } );
     
  end;

  ObjMultiSet(table_multiset);

end;
-----------------------------------------------
function private.IsFound( task_name )

  local task_name = tostring( task_name );

  local ho_found = ng_global.progress[ "std" ][ "win_search" ].found;
  local task_found = false;
        
        for i = 1, #ho_found, 1 do
          
          local task = ho_found[ i ][ "task" ];

          if task == task_name then
             task_found = true;
             break;
          end;

        end;

   return task_found;  

end;
-----------------------------------------------

function private.ClkSleeve()

  local trg_after_open = function()

    common_impl.Lock(false);
  
    ObjSet( "spr_search_star", { input = true } );
    cmn.UnmarkTask( "search", "star" );


  end;

  local trg_after_close = function()

    common_impl.Lock(false);

    ObjSet( "spr_search_star", { input = false } );
    cmn.SetMarkedTask( "search", "star" );
    interface.TaskPanelTaskMark( "search", "star" );

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_ho_search_hand_2", 0, "", 0 );

  if ObjGet( "spr_search_sleeve_2" ).alp == 1 then
    ObjAnimate( "spr_search_sleeve_2", "alp", 0, 0, trg_after_open, { 0,0,1, 0.3,0,0 } );   
  else
    ObjAnimate( "spr_search_sleeve_2", "alp", 0, 0, trg_after_close, { 0,0,0, 0.3,0,1 } );        
  end;

end;

-----------------------------------------------
function private.ClkButterfly()


  local trg_after_open = function()

    common_impl.Lock(false);

    ObjMultiSet({
        
      {"spr_search_butterfly_2", { input = true }},
      {"obj_search_hand_with_butterfly", { input = true }},
      {"spr_search_butterfly_1", { input = false }},
      {"obj_search_clk_butterfly", { pos_x = 379, pos_y = 497 }},
      {"obj_search_clk_jacket", { input = false }},
      {"obj_search_hint_jacket", { input = false }},
    });

    cmn.UnmarkTask( "search", "butterfly_2" );
   
  end;

  local trg_after_close = function()
    common_impl.Lock(false);
    ObjMultiSet({
     
      {"obj_search_hand_with_butterfly", { input = false }},
      {"spr_search_butterfly_2", { input = false }},
      {"spr_search_butterfly_1", { input = true }},
      {"obj_search_clk_butterfly", { pos_x = 4, pos_y = 563 }},
      {"obj_search_clk_jacket", { input = true }},
    })

    if private.IsFound( 'coin' ) ~= true or private.IsFound( 'glove' ) ~= true or private.IsFound( 'knuckles' ) ~= true or private.IsFound( 'ruby' ) ~= true then
      ObjSet( "obj_search_hint_jacket", { input = true } );
    end;


    cmn.SetMarkedTask( "search", "butterfly_2" );
    interface.TaskPanelTaskMark( "search", "butterfly_2" );

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_ho_search_hand_1", 0, "", 0 );

  if ObjGet( "obj_search_hand_with_butterfly" ).alp == 0 then

    ObjAnimate( "obj_search_hand_with_butterfly", "alp", 0, 0, trg_after_open, { 0,0,0, 0.3,0,1 } ); 
    ObjAnimate( "obj_search_left_hand", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } ); 
   
  else

    ObjAnimate( "obj_search_hand_with_butterfly", "alp", 0, 0, trg_after_close, { 0,0,1, 0.3,0,0 } ); 
    ObjAnimate( "obj_search_left_hand", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
          
  end;

end;

-----------------------------------------------

function private.ClkJacket()

local butterfly_found = private.IsFound( 'butterfly_2' );
local glove_found = private.IsFound( 'glove' );
local coin_found = private.IsFound( 'coin' );
local knuckles_found = private.IsFound( 'knuckles' );

local trg_after_open = function()

    common_impl.Lock(false);
    ng_global.progress["std"]["win_search"].open_jacket = true;

    ObjMultiSet({
      {"obj_search_open_jacket", { input = true }},
      {"obj_search_clk_jacket", { pos_x = 63, pos_y = 388 }},
      {"obj_search_close_jacket", { input = false }},
      {"obj_search_clk_butterfly", { input = false }},
      {"obj_search_hint_jacket", { input = false }},
      {"spr_search_butterfly_1", { input = false }},
      {"spr_search_key", { input = false }}
    });
    
    
    if glove_found == false then
        cmn.UnmarkTask( "search", "glove" );
        ObjSet( "spr_search_glove", { input = true } );
    end;

    if knuckles_found == false then
        cmn.UnmarkTask( "search", "knuckles" );
        ObjSet( "spr_search_knuckles", { input = true } );
    end;

    if coin_found == false then

      if  ObjGet( "spr_search_medallion_open" ).alp == 1 then
        cmn.UnmarkTask( "search", "coin" );
        ObjSet( "spr_search_coin", { input = true } );

      else

        ObjSet( "spr_search_medallion_close", { input = true } );

      end;
      
    end;

    if private.IsFound( 'ruby' ) ~= true and private.IsFound( 'picture' ) == true then
      if cmn.IsUnmarkedTask( "search", "ruby" ) then
        ObjSet( "spr_search_ruby", { input = true } );
        ObjSet( "obj_search_hint_ruby", { input = true } );
      else
        ObjSet( "obj_search_use_scissors_2", { input = true } );
        ObjSet( "obj_search_hint_ruby", { input = true } );
      end;
    end;
   

  end;

  local trg_after_close = function()

    common_impl.Lock(false);

    ng_global.progress["std"]["win_search"].open_jacket = false;

    ObjMultiSet({
      {"obj_search_open_jacket", { input = false }},
      {"obj_search_close_jacket", { input = true }},
      {"obj_search_clk_jacket", { pos_x = 397, pos_y = 411 }},
      {"spr_search_glove", { input = false }},
      {"spr_search_knuckles", { input = false }},
      {"spr_search_medallion_close", { input = false }},
      {"spr_search_ruby", { input = false }},
      {"obj_search_hint_ruby", { input = false } },
      {"obj_search_use_scissors_2", { input = false }},
      {"spr_search_handleft_overlap", { alp = 1 }}
    });
       
    if butterfly_found == false then ObjSet( "obj_search_clk_butterfly", { input = true } ); ObjSet( "spr_search_butterfly_1", { input = true }); end;

    if private.IsFound( "key" ) ~= true then
      ObjSet( "spr_search_key", { input = true, alp = 1 }  );
    end;

    if glove_found == false then

      cmn.SetMarkedTask( "search", "glove" );
      interface.TaskPanelTaskMark( "search", "glove" );

    end;

    if coin_found == false then

      cmn.SetMarkedTask( "search", "coin" );
      interface.TaskPanelTaskMark( "search", "coin" );
      ObjSet( "spr_search_coin", { input = false } );
      
    end;

    if knuckles_found == false then

      cmn.SetMarkedTask( "search", "knuckles" );
      interface.TaskPanelTaskMark( "search", "knuckles" );

    end;

    if private.IsFound( 'coin' ) ~= true or private.IsFound( 'glove' ) ~= true or private.IsFound( 'knuckles' ) ~= true  or private.IsFound( 'ruby' ) ~= true then
      ObjSet( "obj_search_hint_jacket", { input = true } );
    end;

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_ho_search_open", 0, "", 0 );

 -- common_impl.PlayAudio( "sfx", "common/audio/aud_ho_search_george", 0, "", 0 );

  if ObjGet( "obj_search_close_jacket" ).alp == 1 then

    ObjAnimate( "obj_search_close_jacket", "alp", 0, 0, trg_after_open, { 0,0,1, 0.3,0,0 } );  
    ObjAnimate( "obj_search_open_jacket", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );   
 
  else

    ObjAnimate( "obj_search_close_jacket", "alp", 0, 0, trg_after_close, { 0,0,0, 0.3,0,1 } );  
    ObjAnimate( "obj_search_open_jacket", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );   
       
  end;


end;

----------------------------------------------------------------------------
function private.ClkMedallion()

  local trg_after_open = function()

    common_impl.Lock(false);

    ObjMultiSet({
      {"spr_search_coin", { input = true }},
      {"spr_search_medallion_close", { input = false }},
    });

    cmn.UnmarkTask( "search", "coin" );

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_ho_search_amulet", 0, "", 0 );

  if ObjGet( "spr_search_medallion_close" ).alp == 1 then

    ObjAnimate( "spr_search_medallion_close", "alp", 0, 0, trg_after_open, { 0,0,1, 0.3,0,0 } ); 
    ObjAnimate( "spr_search_medallion_open", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
         
  end; 

end;

----------------------------------------------------------------------------
function private.unmark_picture() 
 
  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_search_scissors", "obj_search_use_scissors_1" ) ) then

    common_impl.Lock(true);
    
    ObjSet( "spr_search_scissors", { alp = 0 } );

    local func_after = function()

      common_impl.Lock(false);
  
      cmn.UnmarkTask( "search", "picture" );
      cmn.CallEventHandler( "unmark_picture" );
      ObjSet( "spr_search_scissors", { alp = 1 } );

    end;

    local func_voc = function()

      local func_after_voc = function()

         VidStop( "vid_search_thief_2" );
         ObjSet( "vid_search_thief_2", { alp = 0 } );
         ObjSet( "vid_search_thief", { alp = 1, looped = true } );
         VidPlay( "vid_search_thief", "" );
      
      end;

      common_impl.PlayAudio( "sfx", "common/audio/aud_ho_search_george", 0, "", 0 );

      ObjSet( "vid_search_thief_2", { alp = 1 } );
      ObjSet( "vid_search_thief", { alp = 0, playing = false } );
      VidPlay( "vid_search_thief_2", "" );
      ObjSet( "tmr_search_voc", { playing = true, time = 2.0, endtrig = func_after_voc } );

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_ho_search_rope", 0, "", 0 );

    ObjSet( "anm_search_scissors_1", { alp = 1 } );
    ObjSet( "spr_search_rope_1", { alp = 0 } );
    ObjSet( "spr_search_rope_2", { alp = 0 } );

    AnimPlay( "anm_search_scissors_1", "DoAnim", func_after );
    ObjSet( "tmr_search_voc", { time = 0.7, playing = true, endtrig = func_voc } );

  elseif ( common.ApplyObj( "spr_search_scissors", "obj_search_use_scissors_2" ) and ObjGet( "obj_search_use_scissors_2" ).input == true  ) then

    common_impl.Lock(true);
    
    ObjSet( "spr_search_scissors", { alp = 0 } );

    local func_after = function()

      common_impl.Lock(false);
  
      cmn.UnmarkTask( "search", "ruby" );
      cmn.CallEventHandler( "unmark_ruby" );
   
    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_ho_search_razor", 0, "", 0 );
    
    ObjSet( "anm_search_scissors_2", { alp = 1 } );
    ObjSet( "spr_search_ruby_close", { alp = 0 } );

    AnimPlay( "anm_search_scissors_2", "DoAnim", func_after );
     
  else

    ObjMultiSet({
      {"spr_search_scissors", { pos_z = 0 }}
    });
      
  end;

end;
----------------------------------------------------------------------------
ObjAnimate( "spr_search_chain_2", "ang", 1, 0, "", { 0,0,-0.02, 1.5,0,0.02, 3,0,-0.02 } );
ObjAnimate( "spr_search_chain_1", "ang", 1, 0, "", { 0,0,0.06, 2,0,-0.06, 4,0,0.06 } );
ObjAnimate( "spr_search_key", "ang", 1, 0, "", { 0,0,-0.02, 3,0,0.06, 6,0,-0.02 } );
ObjAnimate( "spr_search_ring", "ang", 1, 0, "", { 0,0,0, 2,0,-0.13, 4,0,0 } );
ObjAnimate( "spr_search_glove", "ang", 1, 0, "", { 0,0,-0.03, 2.5,0,0.03, 5,0,-0.03 } );
ObjAnimate( "spr_search_light", "alp", 1, 0, "", { 0,0,0.5, 3,0,1, 6,0,0.5 } );


