-- name=ho_stock
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "stock" );
  game.relations[ "ho_stock" ].exitroom = "rm_pier";

  ObjMultiSet( {

  { "spr_stock_tube", { event_mdown = function() private.TaskComplete( 'tube', "sew" ) end } },
  { "spr_stock_box", { event_mdown = function() private.TaskComplete( 'box', "pen" ) end } },
  { "spr_stock_boots", { event_mdown = function() private.TaskComplete( 'boots', "sew" ) end } },
  { "spr_stock_screw", { event_mdown = function() private.TaskComplete( 'screw', "pen_1" ) end } },
  { "spr_stock_float", { event_mdown = function() private.TaskComplete( 'float', "sew" ) end } },
  { "spr_stock_starfish", { event_mdown = function() private.TaskComplete( 'starfish', "pen_1" ) end } },
  { "spr_stock_hat", { event_mdown = function() private.TaskComplete( 'hat', "canister" ) end } },
  { "spr_stock_hook", { event_mdown = function() private.TaskComplete( 'hook', "pen" ) end } },
  { "spr_stock_net", { event_mdown = function() private.TaskComplete( 'net', "canister" ) end } },
  { "spr_stock_owl", { event_mdown = function() private.TaskComplete( 'owl', "canister" ) end } },
  { "spr_stock_ship", { event_mdown = function() private.TaskComplete( 'ship', "pen_1" ) end } },
  { "spr_stock_harpoon", { event_mdown = function() private.TaskComplete( 'harpoon', "pen" ) end } },
  { "spr_stock_stalk_2", { event_mdown = function() private.TaskComplete( 'harpoon', "pen" ) end } },
  { "spr_stock_stalk", { event_startdrag = function() private.GetItem( 'stalk' ) end, event_dragdrop = function() private.unmark_harpoon() end } },
  { "spr_stock_hammer", { event_startdrag = function() private.GetItem( 'hammer' ) end, event_dragdrop = function() private.unmark_ship() end } },

  { "spr_stock_taskpanel_item_canister", { event_startdrag = function() private.GetGasolinesawItem( 'canister' ) end ,event_dragdrop = function() private.UseItem( 'canister' ) end } },
  { "spr_stock_taskpanel_item_pen_1", {  event_startdrag = function() private.GetGasolinesawItem( 'pen_1' )  end, event_dragdrop = function() private.UseItem( 'pen_1' ) end } },
  { "spr_stock_taskpanel_item_pen", {  event_startdrag = function() private.GetGasolinesawItem( 'pen' )  end, event_dragdrop = function() private.UseItem( 'pen' ) end } },
  { "spr_stock_taskpanel_item_sew", {  event_startdrag = function() private.GetGasolinesawItem( 'sew' )  end, event_dragdrop = function() private.UseItem( 'sew' ) end } }

  } );
-----ANIMS----------------------------------------------------------------------------------------
  ObjAnimate( "spr_stock_anim_net", "ang", 1, 0, "", { 0,0,0.02, 2,0,-0.02, 4,0,0.02 } );
  ObjAnimate( "spr_stock_anim_net_1", "ang", 1, 0, "", { 0,0,-0.02, 3,0,0.02, 6,0,-0.02 } );
  ObjAnimate( "spr_stock_rope_2", "ang", 1, 0, "", { 0,0,0.02, 2,0,-0.02, 4,0,0.02 } );
  ObjAnimate( "spr_stock_rope", "ang", 1, 0, "", { 0,0,0.03, 3.5,0,-0.03, 7,0,0.03 } );
  ObjAnimate( "spr_stock_rope_1", "ang", 1, 0, "", { 0,0,-0.03, 2.5,0,0.03, 5,0,-0.03 } );
  ObjAnimate( "spr_stock_bush_4", "ang", 1, 0, "", { 0,0,0.02, 2,0,-0.02, 4,0,0.02 } );
  ObjAnimate( "spr_stock_bush_2", "ang", 1, 0, "", { 0,0,-0.02, 3,0,0.02, 6,0,-0.02 } );

  ObjAnimate( "spr_stock_light_1", "alp", 1, 0, "", { 0,0,0.5, 2,0,1, 4,0,0.5 } );
  ObjAnimate( "spr_stock_light_2", "alp", 1, 0, "", { 0,0,0.5, 2.5,0,1, 5,0,0.5 } );
  ObjAnimate( "spr_stock_light_4", "alp", 1, 0, "", { 0,0,0.5, 3.5,0,1, 7,0,0.5 } );
  ObjAnimate( "spr_stock_light_3", "alp", 1, 0, "", { 0,0,0.5, 1.5,0,1, 3,0,0.5 } );
  ObjAnimate( "spr_stock_light_5", "alp", 1, 0, "", { 0,0,0.5, 3,0,1, 6,0,0.5 } );
--------------------------------------------------------------------------------------------------
  private.taskpanel = 
  {
    canister = { "spr_stock_net",    "spr_stock_owl",      "spr_stock_hat" },
    pen_1 = { "spr_stock_ship",   "spr_stock_screw",    "spr_stock_starfish" },
    pen = { "spr_stock_hook",   "spr_stock_box",      "spr_stock_harpoon" },
    sew = { "spr_stock_tube",   "spr_stock_float",    "spr_stock_boots" }
  }
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_stock" ] = {
        type = "win",
        room = "rm_pier",
        zz = "ho_stock",
        zz_gate = "gho_pier_stock"
    };

  local win_stock_func = function ()

    if ( cmn.IsEventDone( "win_stock" ) ) then

      interface.InventoryItemAdd( "inv_gasolinesaw", "spr_stock_win" );      
      ObjSet( "inv_gasolinesaw", { drag = false });

    end;

  end;
  cmn.AddSubscriber( "win_stock", win_stock_func );
  
  --------------------------------------------------------------------------------------------------
  local win_stock_func = function ()

    local table_multiset = {};
    if ( not cmn.IsEventDone( "win_stock" ) ) then

      local ho_progress = ng_global.progress[ "std" ][ "win_stock" ];
      for key, value in pairs( private.taskpanel ) do

        local flag_complete = true;
        for i = 1, #private.taskpanel[ key ] do

          if ( not ho_progress.items[ private.taskpanel[ key ][ i ] ] ) then
            flag_complete = false;
            break;
          end;

        end;

        if ( ho_progress.parts[ key ] )then
          
          ObjDelete( "obj_stock_taskpanel_item_"..key );
          if ( key == "canister" ) then   

            ObjDelete( "vid_stock_can" );
            table.insert( table_multiset, { "spr_stock_gasolinesaw_"..key, { alp = 0 } } );     
            table.insert( table_multiset, { "spr_stock_gasolinesaw_cover", { alp = 1 } } );

          else           
            table.insert( table_multiset, { "spr_stock_gasolinesaw_"..key, { alp = 1 } } );
          end;
          ObjDelete( "spr_stock_gasolinesaw_"..key.."_light" );
          
        elseif ( flag_complete ) then

          table.insert( table_multiset, { "spr_stock_taskpanel_item_"..key, { input = true } } );
          table.insert( table_multiset, { "obj_stock_use_item_"..key.."_hint", { input = true } } );         
          ObjDelete( "spr_stock_taskpanel_part_"..key );         
         
        end;

      end;

      for j = 1, #ng_global.progress["std"]["win_stock"].found do

        local name = tostring( ng_global.progress[ "std" ][ "win_stock" ].found[ j ][ "task" ] );
       
        ObjDelete( "spr_stock_taskpanel_"..name.."_inv" );
        ObjDelete( "spr_stock_"..name );
        ObjDelete( "spr_stock_"..name.."_shadow" );

      end;

    end;
    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset )
    end;

  end;
  cmn.AddSubscriber( "win_stock", win_stock_func, "ho_stock" );
  
  --------------------------------------------------------------------------------------------------
  local win_stock_pier = function ()

    if ( cmn.IsEventDone( "win_stock" ) ) then
      
      ObjDelete( "gho_pier_stock" );

    end;

  end;
  cmn.AddSubscriber( "win_stock", win_stock_pier, "rm_pier" );
  
  --------------------------------------------------------------------------------------------------
  local unmark_ship = function () 
   
    ObjDelete( "spr_stock_bottle" );
    ObjDelete( "spr_stock_hammer" );
    ObjDelete( "obj_stock_use_hammer" );
    ObjDelete( "vid_stock_bottle" );
    ObjSet( "spr_stock_bottle_1", { alp = 1, input = true } );

  end;

  cmn.AddSubscriber( "unmark_ship", unmark_ship, "ho_stock" );  

  --------------------------------------------------------------------------------------------------
  local unmark_harpoon = function () 
   
    ObjDelete( "spr_stock_stalk" );
    ObjDelete( "obj_stock_use_stalk" );
    ObjSet( "spr_stock_stalk_2", { alp = 1, input = true } );
    ObjSet( "spr_stock_harpoon", { input = true } );

  end;

  cmn.AddSubscriber( "unmark_harpoon", unmark_harpoon, "ho_stock" );  
  --------------------------------------------------------------------------------------------------
  local start_stock_func = function ()
        
      if not cmn.IsEventDone( "win_stock" ) then
       
        if ( cmn.IsUnmarkedTask( "stock", "ship" ) ) then
          unmark_ship();
        end;

        if ( cmn.IsUnmarkedTask( "stock", "harpoon" ) ) then
          unmark_harpoon();
      
        end;

      end;

  end;    
  
  cmn.AddSubscriber( "win_stock", start_stock_func, "ho_stock" );  


end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_stock" ) ) then

    cmn.InitHo( "stock" );
   
    cmn.SetEventDone( "opn_stock" );
    cmn.SetMarkedTask( "stock", "ship" );
    cmn.SetMarkedTask( "stock", "harpoon" );
    cmn.SetMarkedTask( "stock", "canister" );
    cmn.SetMarkedTask( "stock", "pen_1" );
    cmn.SetMarkedTask( "stock", "pen" );
    cmn.SetMarkedTask( "stock", "sew" );

    ng_global.progress["std"]["win_stock"].items = {};
    ng_global.progress["std"]["win_stock"].parts = {};
    
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "tube",          1, 0, { { "spr_stock_tube" } } );
  interface.TaskPanelTaskAdd( ho_items, "boots",          1, 0, { { "spr_stock_boots" } } );
  interface.TaskPanelTaskAdd( ho_items, "screw",          1, 0, { { "spr_stock_screw" } } );
  interface.TaskPanelTaskAdd( ho_items, "ship",          1, 1, {{"spr_stock_hammer", "spr_stock_ship" }, {"spr_stock_ship"} } );
  interface.TaskPanelTaskAdd( ho_items, "box",          1, 0, { { "spr_stock_box" } } );
  interface.TaskPanelTaskAdd( ho_items, "float",          1, 0, { { "spr_stock_float" } } );
  interface.TaskPanelTaskAdd( ho_items, "starfish",          1, 0, { { "spr_stock_starfish" } } );
  interface.TaskPanelTaskAdd( ho_items, "hat",          1, 0, { { "spr_stock_hat" } } );
  interface.TaskPanelTaskAdd( ho_items, "hook",          1, 0, { { "spr_stock_hook" } } );
  interface.TaskPanelTaskAdd( ho_items, "net",          1, 0, { { "spr_stock_net" } } );
  interface.TaskPanelTaskAdd( ho_items, "harpoon",          1, 1, { { "spr_stock_stalk","spr_stock_harpoon"  }, { "spr_stock_harpoon" } } );
  interface.TaskPanelTaskAdd( ho_items, "owl",          1, 0, { { "spr_stock_owl" } } );
  interface.TaskPanelTaskAdd( ho_items, "canister",          1, 1, { { "spr_stock_taskpanel_item_canister", "obj_stock_use_item_canister_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "pen_1",          1, 1, { { "spr_stock_taskpanel_item_pen_1", "obj_stock_use_item_pen_1_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "pen",          1, 1, { { "spr_stock_taskpanel_item_pen", "obj_stock_use_item_pen_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "sew",          1, 1, { { "spr_stock_taskpanel_item_sew", "obj_stock_use_item_sew_hint" } } );
  
  interface.TaskPanelShow( ho_items );
  int_taskpanel_impl.HideTextPanel( "stock" );

  ObjSet( "obj_stock_taskpanel", { visible = true, input = true, pos_z = 1, pos_x = -190, pos_y = 37 } );  

  common_impl.TutorialShow( "tutorial_page_5" );

  --common_impl.EnvPlay( { "common/audio/aud_pier_env" }, "", 0.5 );
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

  if cmn.IsEventDone( "get_evidence_1_1" ) then

    interface.InvestigationButtonCheck();

  end;

end;
--*********************************************************************************************************************
function public.PreClose()

 interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Open ()
  
  common_impl.VisitMapRoom( "pier" );
  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();
  int_taskpanel_impl.ShowTextPanel( "stock" );
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name, part )

  cmn.HoTaskFind( "spr_stock_"..task_name, task_name );

  local func_after = function()

    --common_impl.Lock(false);

    if ( task_name == "harpoon" or task_name == "ship" ) then

      ObjSet( "spr_stock_"..task_name, { input = false } );
  
    end;
  
    
  end;

  private.check_task( "spr_stock_"..task_name, part )   

  --common_impl.Lock(true);

  ObjAnimate( "spr_stock_taskpanel_"..task_name.."_inv", "alp", 0, 0, func_after, { 0,3,1,  0.8,3,0 } );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  common_impl.PlayAudio("sfx","common/audio/aud_get_inv_sfx");
  ObjSet( "spr_stock_"..name, { pos_z = 20 } );
  ObjSet( "spr_stock_"..name.."_shadow", { visible = false } );

end;

----------------------------------------------------------------------------

function private.unmark_ship() 
 
  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_stock_hammer", "obj_stock_use_hammer" ) ) then

    common_impl.Lock(true);
    
    ObjSet( "spr_stock_hammer", { alp = 0 } );

    local func_after = function()

      common_impl.Lock(false);
  
      cmn.UnmarkTask( "stock", "ship" );
      cmn.CallEventHandler( "unmark_ship" );

    end;

    common_impl.PlayAudio("sfx","common/audio/aud_ho_stock_hammer");
    ObjSet( "vid_stock_bottle", { active = true, alp = 1 });
    ObjSet( "spr_stock_bottle", {  alp = 0 });
    VidPlay( "vid_stock_bottle", func_after );

  else

    ObjSet( "spr_stock_hammer", { pos_z = 0 } );
    ObjSet( "spr_stock_hammer_shadow", { visible = true } );
        
  end;

end;
----------------------------------------------------------------------------

function private.unmark_harpoon() 
 
  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_stock_stalk", "obj_stock_use_stalk" ) ) then

    common_impl.Lock(true);
    
    ObjSet( "spr_stock_stalk", { alp = 0 } );

    local func_after = function()

      common_impl.Lock(false);
  
      cmn.UnmarkTask( "stock", "harpoon" );
      cmn.CallEventHandler( "unmark_harpoon" );

    end;
    
    ObjAnimate( "spr_stock_stalk_2", "alp", 0, 0, func_after, { 0,3,0,  0.4,3,1 } );
    common_impl.PlayAudio( "sfx","common/audio/aud_ho_stock_peak" );
    
  else

    ObjSet( "spr_stock_stalk", { pos_z = 2 } );
    ObjSet( "spr_stock_stalk_shadow", { visible = true } );
        
  end;

end;
-------------------------------------------------------------------------
-------------------------------------------------------------------------
function private.check_task( obj, part )

  local ho_progress = ng_global.progress[ ng_global.currentprogress ][ "win_stock" ];
  
  ho_progress.items[ obj ] = true;
  local flag_complete = true;
  for i = 1, #private.taskpanel[ part ] do

    if ( not ho_progress.items[ private.taskpanel[ part ][ i ] ] ) then

      flag_complete = false;
      break;

    end;

  end;

  if ( flag_complete ) then    
    
    local func_after = function()
    
      --common_impl.Lock(false);

      ObjSet( "spr_stock_taskpanel_item_"..part, { input = true } );
      ObjSet( "obj_stock_use_item_"..part.."_hint", { input = true } );      

      common_impl.TutorialShow( "tutorial_page_7" );      

    end;

    --common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_ho_panel_off", 0, "", 0 );

    ObjAnimate( "spr_stock_taskpanel_part_"..part, "pos_y", 0, 0, func_after, { 0,0,10, 1.3,0,90 } );

    if ObjGet( "obj_stock_arrow_target" ) then

      ObjAttach( "obj_stock_arrow_target", "spr_stock_taskpanel_item_"..part );

    end;
  
    common_impl.TutorialSetShown("tutorial_page_5");

  end;
  
end;

-------------------------------------------------------------------------------------
function private.GetGasolinesawItem( name )

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  local item = "obj_stock_taskpanel_item_"..name;
  
  ObjSet( item, { pos_z = 5 } );

end;
-------------------------------------------------------------------------------------
function private.UseItem( name )

  local item = "spr_stock_taskpanel_item_"..name;
  
  if ( ObjIntersect( item, "obj_stock_use_canister" ) ) then

    ObjDelete( item );

    local func_after = function()

      common_impl.Lock(false);
      cmn.HoTaskFind( "spr_stock_gasolinesaw_"..name.."_hint", name, true );
      ng_global.progress[ ng_global.currentprogress ][ "win_stock" ].parts[ name ] = true;
      common_impl.TutorialSetShown("tutorial_page_7");

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio("sfx","common/audio/aud_ho_stock_chainsaw_"..name );   

    if ( name == "canister" ) then

      ObjSet( "vid_stock_can", { active = true, alp = 1 });
      VidPlay( "vid_stock_can", "" );
      ObjAnimate( "spr_stock_gasolinesaw_cover", "alp", 0, 0, func_after,
      {
        0.0,  0,  0,
        2.2,  0,  0,
        2.5,  0,  1
      } ); 

      ObjAnimate( "spr_stock_funnel", "alp", 0, 0, "",
      {
        0.0,  0,  0,
        0.1,  0,  1,
        2.0,  0,  1,
        2.1,  0,  0
      } ); 
  
     ObjAnimate( "spr_stock_funnel_over_vid", "alp", 0, 0, "",
      {
        0.0,  0,  0,
        0.1,  0,  1,
        2.0,  0,  1,
        2.1,  0,  0
      } );    

    else 

      ObjAnimate( "spr_stock_gasolinesaw_"..name, "alp", 0, 0, func_after, 
      { 
        0.0,  0,  0,
        0.3,  0,  1
      } );      

    end;
    
    ObjAnimate( "spr_stock_gasolinesaw_"..name.."_light", "alp", 0, 0, "", 
    { 
      0.0,  0,  1,
      0.3,  0,  0
    } ); 
  
  else

    ObjSet( "obj_stock_taskpanel_item_"..name, { pos_z = 1 } );
   
  end;

end;
----------------------------------------------------------------------------