-- name=ho_trash
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "trash" );
  game.relations[ "ho_trash" ].exitroom = "rm_abandoneddistrict";

  --------------------------------------------------------------------------------------------
  -- function win_trash () end;
  --------------------------------------------------------------------------------------------
 common_impl.hint[ "win_trash" ] = {
    type = "win",
    room = "rm_abandoneddistrict",
    zz = "ho_trash",
    zz_gate = "gho_abandoneddistrict_trash"
  };
  local win_trash_func = function ()

    if ( cmn.IsEventDone( "win_trash" ) ) then

      interface.InventoryItemAdd( "inv_attractionlevel", "spr_trash_win" );      
            
    end;

  end;
  cmn.AddSubscriber( "win_trash", win_trash_func );
--------------------------------------------------------------------------------------------------
  local start_trash_func = function ()

    if ( not cmn.IsEventDone( "win_trash" ) ) then
             
      common_impl.ProcessHoStart( "trash" );
      local ho_found = ng_global.progress[ "std" ][ "win_trash" ].found;

      for i = 1, #ho_found do

        local name = common.GetObjectName( ho_found[ i ].item );
        ObjSet( "spr_"..name, { alp = 1 } );
        ObjSet( "obj_"..name, { input = false } );

      end;

    end;


  end;    
  
  cmn.AddSubscriber( "win_trash", start_trash_func, "ho_trash" );  

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_trash" ) ) then

    cmn.InitHo( "trash" );

    cmn.SetEventDone( "opn_trash" );    
      
  end;

  local ho_items = {};

  interface.ItemPanelItemAdd( ho_items, "crab" );
  interface.ItemPanelItemAdd( ho_items, "dagger" );
  interface.ItemPanelItemAdd( ho_items, "dove" );
  interface.ItemPanelItemAdd( ho_items, "feather" );
  interface.ItemPanelItemAdd( ho_items, "flags" );
  interface.ItemPanelItemAdd( ho_items, "flute" );
  interface.ItemPanelItemAdd( ho_items, "garland" );
  interface.ItemPanelItemAdd( ho_items, "lollipop_tail" );
  interface.ItemPanelItemAdd( ho_items, "handle" );
  interface.ItemPanelItemAdd( ho_items, "stone" );
  interface.ItemPanelItemAdd( ho_items, "coin" );
  interface.ItemPanelItemAdd( ho_items, "glass");
  
  interface.ItemPanelShow( ho_items );

  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

  interface.InvestigationButtonCheck();

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.VisitMapRoom( "abandoneddistrict" );

  common_impl.PassingHoStart();

  common_impl.TutorialShow( "tutorial_page_19" );

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.ItemPanelHide();
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();

end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

  common_impl.TutorialSetShown( "tutorial_page_20" );
  common_impl.TutorialSetShown( "tutorial_page_21" );
  common_impl.TutorialShow( "tutorial_page_22" );

  local name = common.GetObjectName( item_name );
  local item_object_name = "obj_"..name;
  local item_spr_name = "spr_"..name;

  ObjSet( item_object_name, { input = false } );

  ObjSet( item_spr_name, { alp = 1 } );

  common_impl.PlayAudio( "sfx", "common/audio/aud_ho_"..name, 0, "", 0 );
  
  if ( name == "trash_coin" ) then

    local func_end = function()

      common_impl.Lock(false);
      ObjSet( "obj_trash_gates", { input = true } );

    end;

    common_impl.Lock(true);
    ObjSet( "obj_trash_gates", { input = false } );

    ObjAnimate( "spr_trash_coin_anm", "pos_xy", 0, 0, "", { 
      0,   0, 9, -8, 
      0.2, 0, 9, -8, 
      0.8, 0, 17, 39 
    } );

    ObjAnimate( "spr_trash_coin_anm", "alp", 0, 0, func_end, { 
      0,   0, 0, 
      0.2, 0, 1, 
      0.8, 0, 1,
      1.0, 0, 0 
    } );

  elseif ( name == "trash_handle" ) then

    local func_end = function()

      common_impl.Lock(false);
      ObjSet( "obj_trash_gates", { input = true } );

    end;

    common_impl.Lock(true);
    ObjSet( "obj_trash_gates", { input = false } );

    ObjAnimate( "spr_trash_thermos", "pos_xy", 0, 0, func_end, { 
      0.0, 0, 700, 400, 
      0.4, 0, 700, 400,
      1.0, 0, 622, 442,
      1.7, 0, 622, 442,
      2.3, 0, 700, 390 
    } );

    ObjAnimate( "spr_trash_thermos", "ang", 0, 0, "", { 
      0.0, 0, 0, 
      0.4, 0, 0, 
      1.0, 0, 1.43,
      1.7, 0, 1.43,
      2.3, 0, 0 
    } );

    ObjAnimate( "spr_trash_thermos", "alp", 0, 0, "", { 
      0.0, 0, 1, 
      2.1, 0, 1,
      2.3, 0, 0 
    } );

    ObjAnimate( "spr_trash_coffee_anm", "alp", 0, 0, "", { 
      0.0, 0, 0, 
      1.2, 0, 0,
      1.0, 0, 1,
      1.3, 0, 1,
      1.4, 0, 0       
    } );

    ObjAnimate( "spr_trash_coffee_anm_2", "alp", 0, 0, "", { 
      0.0, 0, 0, 
      1.0, 0, 0,
      1.4, 0, 1,
      1.5, 0, 1,
      1.6, 0, 0       
    } );

    ObjAnimate( "spr_trash_thermos_cover", "pos_y", 0, 0, "", { 
      0,   0, -118, 
      0.3, 0, -161      
    } );

    ObjAnimate( "spr_trash_thermos_cover", "alp", 0, 0, "", { 
      0,   0, 1, 
      0.25, 0, 1,
      0.3, 0, 0      
    } );

    ObjAnimate( "spr_trash_handle", "alp", 0, 0, "", { 
      0,   0, 0, 
      1.4, 0, 0,
      1.6, 0, 1      
    } );
    


  end;

  interface.ItemPanelTryToComplete();

end;

  ObjAnimate( "spr_trash_chicken", "scale_x", 1, 0, "", { 0,0,1, 1.5,0,0.97, 3,0,1 } );
  ObjAnimate( "spr_trash_horse", "scale_x", 1, 0, "", { 0,0,1, 2,0,0.96, 4,0,1 } );
  ObjAnimate( "spr_trash_light", "alp", 1, 0, "", { 0,0,0, 2.5,0,1, 5,0,0 } );
 
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************