-- name=mg_safe
--*********************************************************************************************************************
function public.Init()
 
  private.room_objname = "mg_safe";
  private.nums = {2,3,5,7,11,13,17,19,23,29};
  --------------------------------------------------------------------------------------------
  ObjMultiSet({ 
  --{ "spr_safe_code_1_drag", { event_drag = function() private.Circle_drag("spr_safe_code_1"); end }},
  --{ "spr_safe_code_1_drag", { event_startdrag = function() private.Circle_startdrag("spr_safe_code_1","spr_safe_code_1_drag"); end  }},
  --{ "spr_safe_code_1_drag", { event_dragdrop = function() private.Circle_dragdrop("spr_safe_code_1","spr_safe_code_1_drag"); end }},
  --{ "spr_safe_code_2_drag", { event_drag = function() private.Circle_drag("spr_safe_code_2"); end }},
  --{ "spr_safe_code_2_drag", { event_startdrag = function() private.Circle_startdrag("spr_safe_code_2","spr_safe_code_2_drag"); end }},
  --{ "spr_safe_code_2_drag", { event_dragdrop = function() private.Circle_dragdrop("spr_safe_code_2","spr_safe_code_2_drag"); end }},
  --{ "spr_safe_code_1_drag", { event_menter = function() private.CircleMenter(1); end }},
  --{ "spr_safe_code_1_drag", { event_mleave = function() private.CircleLeave(1); end }},
  --{ "spr_safe_code_2_drag", { event_menter = function() private.CircleMenter(2); end }},
  --{ "spr_safe_code_2_drag", { event_mleave = function() private.CircleLeave(2); end }},
  { "spr_safe_code_1_drag", { event_mdown = function() private.Circle_rotate("spr_safe_code_1","spr_safe_code_1_drag"); end }},
  { "spr_safe_code_2_drag", { event_mdown = function() private.Circle_rotate("spr_safe_code_2","spr_safe_code_2_drag"); end }},
  { "spr_safe_chestpiece", { event_mdown = private.get_chestpiece }},
  { "spr_safe_pictureframe", { event_mdown = private.get_pictureframe }},
  { "obj_safe_clk_poster", { event_mdown = function () common_impl.NoteScale( "open", "spr_safe_poster" ); common_impl.ShowBbt( 'bbt_safe_clk_poster', 1 ); end } },    
  { "spr_safe_poster_big", { event_mdown = function () common_impl.NoteScale( "close", "spr_safe_poster" ) end } },  
  }); 
  
  ObjSet("spr_safe_code_1_drag",{ drag = false});
  ObjSet("spr_safe_code_2_drag",{ drag = false});
  
  for i = 1,3 do

    ObjMultiSet({
    { "spr_safe_gbutton_"..i, { event_mdown = function() private.Gbutton_clk(i); end }},
    { "spr_safe_rbutton_"..i, { event_mdown = function() private.Rbutton_clk(i); end }},
    { "spr_safe_gbutton_"..i, { event_menter = function() private.ButtonMenter("g",i) end}},
    { "spr_safe_rbutton_"..i, { event_menter = function() private.ButtonMenter("r",i) end}},
    { "spr_safe_gbutton_"..i, { event_mleave = function() private.ButtonLeave("g") end}},
    { "spr_safe_rbutton_"..i, { event_mleave = function() private.ButtonLeave("r") end}}
    });

  end;

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_safe = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

  local mas_parent_gfx = 

    {
    private.room_objname,

    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_safe", update_game_mode_safe, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chestpiece() end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chestpiece" ] = {
    type = "get",
    get_obj = "gfx_safe_chestpiece",
    room = "rm_basement",
    zz = "mg_safe",
    zz_gate = "gmg_basement_safe"
  };


  local get_chestpiece_inv = function ()
  
    interface.InventoryItemAdd( "inv_chestpiece", "spr_safe_chestpiece" );
    
  end;

  local get_chestpiece_loc = function ()
      
    ObjDelete( "gfx_safe_chestpiece" );

  end;

  cmn.AddSubscriber( "get_chestpiece", get_chestpiece_inv );
  cmn.AddSubscriber( "get_chestpiece", get_chestpiece_loc, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pictureframe() end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pictureframe" ] = {
    type = "get",
    get_obj = "gfx_safe_pictureframe",
    room = "rm_basement",
    zz = "mg_safe",
    zz_gate = "gmg_basement_safe"

  };

  local get_pictureframe_inv = function ()
  
    interface.InventoryItemAdd( "inv_pictureframe", "spr_safe_pictureframe" );
    ObjSet( "inv_pictureframe", { drag = false });


  end;

  local get_pictureframe_closezz = function ()
  
    ObjDelete( "spr_safe_pictureframe_shadow" );
    ObjDelete( "gfx_safe_pictureframe" );

  end;
  
  cmn.AddSubscriber( "get_pictureframe", get_pictureframe_inv );
  cmn.AddSubscriber( "get_pictureframe", get_pictureframe_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_safe() end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_safe" ] = {
    type = "win",
    use_place = "mg_safe",
    room = "rm_basement",    
    zz = "mg_safe",
    zz_gate = "gmg_basement_safe"
};

  local win_safe_rm_basement = function ()
    
    if ( cmn.IsEventDone("win_safe") ) then
      ObjMultiSet({
      {"spr_basement_chestpiece", {input = true, visible = true, active = true }},
      {"spr_basement_pictureframe", {input = true, visible = true, active = true }},
      {"obj_basement_safe_open", {alp = 1 }}
      });      

    end;

  end;

  local win_safe_loc = function ()

    if ( cmn.IsEventDone("win_safe") ) then

      ObjSet( "obj_safe_mmg_parts", { input = false } );
      ObjSet( "spr_safe_open", { input = true, visible = true } );
      ObjSet( "spr_safe_chestpiece" , { input = true, visible = true } );

    else

      private.LoadMGState();
      private.Gbuttons = {};
      private.Rbuttons = {};

      for i = 1,3 do

        private.Gbuttons[i] = ng_global.progress["std"]["win_safe"].Gbuttons[i];
        private.Rbuttons[i] = ng_global.progress["std"]["win_safe"].Rbuttons[i];

      end;

      private.R_win = ng_global.progress["std"]["win_safe"].R_win;
      private.G_win = ng_global.progress["std"]["win_safe"].G_win;

    end;

  end;

  cmn.AddSubscriber( "win_safe", win_safe_rm_basement, "rm_basement" );
  cmn.AddSubscriber( "win_safe", win_safe_loc, private.room_objname );
----------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Open () 

  int_slider.InitSlider( private.room_objname );
  common_impl.VisitMapRoom( "basement" );
  
end;
--*********************************************************************************************************************
function public.PreOpen ()


  if  ObjGet( "spr_safe_poster_big" ).input == true then

    ObjSet( "spr_safe_poster_big", { input = 0, alp = 0 } );
    ObjSet( "spr_safe_poster", { alp = 1 } );
    
  end;

  if ( not cmn.IsEventStart( "win_safe" ) ) then

    private.ng_var_Init();
    private.LoadMGState();

  end;

  if ( not cmn.IsEventDone( "win_safe" ) ) then

    cmn.MiniGameShow( "safe" );
    common_impl.PassingMgStart( "safe" );

  end;

  interface.InvestigationButtonCheck();

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.PreClose()

  if ( not cmn.IsEventDone( "win_safe" ) ) then
    cmn.MiniGameHide();
    common_impl.PassingMgStop( "safe" );
  end;
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.get_pictureframe()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_pictureframe" );
  cmn.CallEventHandler( "get_pictureframe" );

end;
--------------------------------------------------------------------------------------------
function private.get_chestpiece()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_chestpiece" );
  cmn.CallEventHandler( "get_chestpiece" );

end;
--*********************************************************************************************************************
function private.GetDefaultState()

  local state = { 0, 0, 0 };

  return state;

end;
--*********************************************************************************************************************
function private.WinEnd()

  cmn.SetEventDone( "win_safe" );
  cmn.CallEventHandler( "win_safe" );

end;
--*********************************************************************************************************************
function private.Win(func_after)

  cmn.MiniGameHide();
  common_impl.PassingMgWin( "safe" );

  local func_end = function ()
    
    if ( func_after ) then
      
      func_after();

    end;

    common_impl.Lock(false);

    private.WinEnd(); 

  end;
  
  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_safe_win", 0, "", 0 );
 
  ObjSet( "spr_safe_open", { visible = true } );
  ObjSet( "spr_safe_chestpiece", { visible = true } );
  ObjAnimate( "spr_safe_open_lock", "alp", 0, 0, "", { 0, 1, 0,  1, 1, 0,  1.3, 1, 1} );  
  ObjAnimate( "spr_safe_open", "alp", 0, 0, func_end, { 0, 0, 0,    1.5, 0, 0,  2.0, 1, 1});
  ObjAnimate( "spr_safe_chestpiece", "alp", 0, 0, "", { 0, 0, 0,    1.5, 0, 0,  2.0, 1, 1});

end;
--*********************************************************************************************************************
-- functions *** mg_safe *** () end;
--*********************************************************************************************************************
function private.Circle_startdrag(circle_obj_name,drag_obj_name)

  local num = 2;

  if ( circle_obj_name == "spr_safe_code_1" ) then 
    num = 1; 
  end;

  ObjSet("spr_safe_add_code_"..num,{alp = 1});

  private.coords_begin = GetGameCursorPos();
  


  private.dragobj_coords = {ObjGet( drag_obj_name).pos_x,ObjGet( drag_obj_name).pos_y};

  ObjSet( drag_obj_name, { pos_x = private.coords_begin[1], pos_y = private.coords_begin[2] } );

  private.start_ang = ObjGet( circle_obj_name ).ang;

  private.atan = math.atan2( private.coords_begin[1] - private.dragobj_coords[1] ,private.coords_begin[2] - private.dragobj_coords[2] );

  private.num_seg = private.seg_number(private.start_ang);

end;
-----------------------------------------------------------------------------
function private.Circle_rotate(circle_obj_name,drag_obj_name)
  
  private.dragobj_coords = {ObjGet( drag_obj_name).pos_x,ObjGet( drag_obj_name).pos_y};

  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_safe_release", 0, "", 0 );

  ObjSet( drag_obj_name,{ pos_x = private.dragobj_coords[1], pos_y = private.dragobj_coords[2] });

  local objname = circle_obj_name;
  local obj_ang = ObjGet(objname).ang + 0.628; 

  if ( obj_ang > 6.28 ) then obj_ang = obj_ang - 6.28 end;
  if ( obj_ang < 0 ) then obj_ang = obj_ang + 6.28 end;

  num_seg = private.seg_number(obj_ang);

  ObjSet(objname, {ang = num_seg*0.628});

  private.SavePos();
  
end;
--------------------------------------------------------------------------------------------
function private.Circle_drag(circle_obj_name)
  
  common_impl.SetCursor(CURSOR_HAND);

  private.coords_end = GetGameCursorPos();

  if tostring(GetPlatform()) == "android" then
    private.coords_end[2] = private.coords_end[2] + 100;
  end;
    
  private.coords_end[1] = private.coords_end[1] - ObjGet(circle_obj_name).pos_x;
  private.coords_end[2] = private.coords_end[2] - ObjGet(circle_obj_name).pos_y;

  private.circle_ang = math.atan2( private.coords_end[1],private.coords_end[2] ) - private.atan;

  local cur_ang = ObjGet( circle_obj_name ).ang;
  
  ObjSet( circle_obj_name, { ang = private.circle_ang + private.start_ang  } );

  local num_seg = private.seg_number(private.circle_ang + private.start_ang);
  
  if (  private.num_seg ~= num_seg ) then

    private.num_seg = num_seg;
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_safe_rotate", 0, "", 0 );
   
  end;

end;
--------------------------------------------------------------------------------------------
function private.Circle_dragdrop(circle_obj_name,drag_obj_name)
  
  common_impl.SetCursor(CURSOR_DEFAULT);

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_safe_release", 0, "", 0 );

  ObjSet( drag_obj_name,{ pos_x = private.dragobj_coords[1], pos_y = private.dragobj_coords[2] });

  local objname = circle_obj_name;
  local obj_ang = ObjGet(objname).ang 

  if ( obj_ang > 6.28 ) then obj_ang = obj_ang - 6.28 end;
  if ( obj_ang < 0 ) then obj_ang = obj_ang + 6.28 end;

  num_seg = private.seg_number(obj_ang);

  ObjSet(objname, {ang = num_seg*0.628});

  private.SavePos();

end;
--------------------------------------------------------------------------------------------
function private.SavePos()

  ng_global.progress["std"]["win_safe"].G_ang = ObjGet("spr_safe_code_1").ang;
  ng_global.progress["std"]["win_safe"].R_ang = ObjGet("spr_safe_code_2").ang;

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.Gbutton_clk(num)

  common_impl.Lock(true);

  func_after_dasapear = function ()

    func_after_apear  = function () 

      common_impl.Lock(false);

      if ( private.Check_button_win( "g" ) ) then
        
        local func_after_anim = function ()

          private.G_win = true;

          for i = 1 ,3 do

            ObjSet("spr_safe_gbutton_"..i,{ input = false } );
 
          end;

          if ( private.CheckWin() ) then
            
            local func_after_win = function ()

              ng_global.progress["std"]["win_safe"].Gbuttons[num] = private.Gbuttons[num];
              ng_global.progress["std"]["win_safe"].G_win = private.G_win;

            end;

            private.Win(func_after_win);

          else

            ng_global.progress["std"]["win_safe"].Gbuttons[num] = private.Gbuttons[num];
            ng_global.progress["std"]["win_safe"].G_win = private.G_win;

          end;

        end;   
       
      private.Anim_lock( "g", func_after_anim )

      else

         ng_global.progress["std"]["win_safe"].Gbuttons[num] = private.Gbuttons[num];

      end;


    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_safe_click", 0, "", 0 );

    private.Gbuttons[num] = private.Gbuttons[num] + 1;

    if  private.Gbuttons[num] > 5 then

      private.Gbuttons[num] = 1;

    end;

    ObjSet("spr_safe_gbutton_"..num,{res = "assets/levels/level1/mg_safe/layers/button_"..private.Gbuttons[num]});
    ObjAnimate("spr_safe_gbutton_"..num, "alp", 0, 0, func_after_apear, {0, 3, 0.4, 0.05, 3, 1});

  end;

  ObjAnimate("spr_safe_gbutton_"..num, "alp", 0, 0, func_after_dasapear, {0, 3, 1, 0.05, 3, 0.4});

end;
-----------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------
function private.Rbutton_clk(num)

  common_impl.Lock(true);

  func_after_dasapear = function ()

    func_after_apear  = function () 

      common_impl.Lock(false);

      if ( private.Check_button_win( "r" ) ) then
        
        local func_after_anim = function ()

          private.R_win = true;

          for i = 1 ,3 do

            ObjSet("spr_safe_rbutton_"..i,{input = false});
 
          end;
          
          if ( private.CheckWin() ) then

              local func_after_win = function ()

                ng_global.progress["std"]["win_safe"].Rbuttons[num] = private.Rbuttons[num];
                ng_global.progress["std"]["win_safe"].R_win = private.R_win;

              end;

              private.Win(func_after_win);

          else

            ng_global.progress["std"]["win_safe"].Rbuttons[num] = private.Rbuttons[num];
            ng_global.progress["std"]["win_safe"].R_win = private.R_win;

          end;

        end;   
       
      private.Anim_lock( "r", func_after_anim )

      else

         ng_global.progress["std"]["win_safe"].Rbuttons[num] = private.Rbuttons[num];

      end;


    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_safe_click", 0, "", 0 );

    private.Rbuttons[num] = private.Rbuttons[num] + 1;

    if  private.Rbuttons[num] > 10

    then 

      private.Rbuttons[num] = 1;

    end;

    ObjSet("txt_safe_r"..num,{text = tostring(private.nums[private.Rbuttons[num]])});
    ObjAnimate("spr_safe_rbutton_"..num, "alp", 0, 0, func_after_apear, {0, 3, 0.4, 0.05, 3, 1});

  end;

  ObjAnimate("spr_safe_rbutton_"..num, "alp", 0, 0, func_after_dasapear, {0, 3, 1, 0.05, 3, 0.4});

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.Check_button_win(color)

  local win_mas = {5,2,2};
  local cur_mas = private.Gbuttons;

  if ( color == "r" ) then

    win_mas = {1,4,10};
    cur_mas = private.Rbuttons;
 
  end;

  for i = 1, #win_mas do

    if ( win_mas[i] ~= cur_mas[i] ) then

      return false; 

    end;

  end;

  return true;

end;
--------------------------------------------------------------------------------------------
function private.Anim_lock( color, func_after )

  local func_end = function ()

    common_impl.Lock( false );

    if ( func_after ) then

      func_after();

    end;

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_safe_true", 0, "", 0 );

  --Colors = g and r-------------
  ObjAnimate("spr_safe_"..color.."lock_1", "pos_xy", 0, 1, "", {0, 3, 0,0,   0.5, 3, 0,0, 0.8, 3, -1,68});
  ObjAnimate("spr_safe_"..color.."lock_2", "pos_xy", 0, 1, func_end, {0, 3, 0,0,   0.5, 3, 0,0, 0.8, 3, -1,68});

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.CheckWin()

  if ( private.R_win and private.G_win ) then

    return true;
    
  else 

    return false;
    
  end;

  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.Reset()

  private.ng_var_Init();
  private.LoadMGState();

end;
--------------------------------------------------------------------------------------------
function public.Skip()
  port.skip_mg = true;
  common_impl.Lock(true);
  private.Gbuttons = {5,2,2};
  private.Rbuttons = {4,10,5};
  private.R_win = true;
  private.G_win = true;

  local endtrig = function()
 
    private.Skip_end();

  end;

  for i = 1,3 do

    ObjAnimate("spr_safe_gbutton_"..i, "alp", 0, 0, "", {0, 3, 1, 0.05, 3, 0.4});
    ObjAnimate("spr_safe_rbutton_"..i, "alp", 0, 0, endtrig, {0, 3, 1, 0.05, 3, 0.4});

    endtrig = nil;

  end;

end;
--------------------------------------------------------------------------------------------
function private.Skip_end()

  

  local endtrig = function()

    common_impl.Lock(false);
    private.Anim_lock("r", private.Win );
    private.Anim_lock("g");
    
  end;

  for i = 1,3 do

    ObjMultiSet({
    { "spr_safe_gbutton_"..i,{res = "assets/levels/level1/mg_safe/layers/button_"..private.Gbuttons[i]} },
    { "txt_safe_r"..i,{text = tostring(private.nums[private.Rbuttons[i]])} },
    });
    ObjAnimate("spr_safe_gbutton_"..i, "alp", 0, 0, "", {0, 3, 0.4, 0.05, 3, 1});
    ObjAnimate("spr_safe_rbutton_"..i, "alp", 0, 0, endtrig, {0, 3, 0.4, 0.05, 3, 1});
    endtrig = nil;

  end;

end;
--------------------------------------------------------------------------------------------
function private.ng_var_Init()

    ng_global.progress["std"]["win_safe"].Gbuttons = {3,1,4};
    ng_global.progress["std"]["win_safe"].Rbuttons = {8,9,10};
    ng_global.progress["std"]["win_safe"].R_win = false;
    ng_global.progress["std"]["win_safe"].G_win = false;
    ng_global.progress["std"]["win_safe"].G_ang = 4.396;
    ng_global.progress["std"]["win_safe"].R_ang = 3.768;
    
    private.Gbuttons = {3,1,4};
    private.Rbuttons = {8,9,10};
    private.R_win = false;
    private.G_win = false;

end;
--------------------------------------------------------------------------------------------
function private.LoadMGState()

  local table_multiset = {};

  for i = 1,3 do

    table.insert( table_multiset, { "txt_safe_r"..i,{text = tostring(private.nums[ng_global.progress["std"]["win_safe"].Rbuttons[i]])}} );
    table.insert( table_multiset, { "spr_safe_gbutton_"..i,{res = "assets/levels/level1/mg_safe/layers/button_"..ng_global.progress["std"]["win_safe"].Gbuttons[i]}} );

  end;

  table.insert( table_multiset, { "spr_safe_code_1", {ang = ng_global.progress["std"]["win_safe"].G_ang }} );
  table.insert( table_multiset, { "spr_safe_code_2", {ang = ng_global.progress["std"]["win_safe"].R_ang }} );

  if ( ng_global.progress["std"]["win_safe"].G_win ) then

    for i =1 ,3 do
      table.insert( table_multiset, { "spr_safe_gbutton_"..i,{input = false } } );
    end;

    table.insert( table_multiset, { "spr_safe_glock_1", {pos_x = 319, pos_y = 178 }} );
    table.insert( table_multiset, { "spr_safe_glock_2", {pos_x = 518, pos_y = 179 }} );

  else 

    for i =1 ,3 do
      table.insert( table_multiset, { "spr_safe_gbutton_"..i,{input = true} } ); 
    end;

    table.insert( table_multiset, { "spr_safe_glock_1", {pos_x = 320, pos_y = 110 }} );
    table.insert( table_multiset, { "spr_safe_glock_2", {pos_x = 519, pos_y = 111 }} );

  end;

  if ( ng_global.progress["std"]["win_safe"].R_win ) then 

    for i =1 ,3 do
      table.insert( table_multiset, { "spr_safe_rbutton_"..i,{input = false} } );  
    end;

    table.insert( table_multiset,  { "spr_safe_rlock_1", {pos_x = 469, pos_y = 601 } } );
    table.insert( table_multiset,  { "spr_safe_rlock_2", {pos_x = 666, pos_y = 601 } } );

  else
    
    for i =1 ,3 do

      table.insert( table_multiset, { "spr_safe_rbutton_"..i,{input = true} } );
 
    end;

    table.insert( table_multiset,  { "spr_safe_rlock_1", { pos_x = 470, pos_y = 533 } } );
    table.insert( table_multiset,  { "spr_safe_rlock_2", { pos_x = 667, pos_y = 533 } } );

  end;

  ObjMultiSet(table_multiset);

end;
--------------------------------------------------------------------------------------------
function private.CircleMenter(num)
  common_impl.SetCursor(CURSOR_HAND);
  ObjSet("spr_safe_add_code_"..num,{alp = 1});
end;
--------------------------------------------------------------------------------------------
function private.CircleLeave(num)

  common_impl.SetCursor(CURSOR_DEFAULT);
  ObjSet("spr_safe_add_code_"..num,{alp = 0});

end;
--------------------------------------------------------------------------------------------
function private.ButtonMenter(color,num)

  common_impl.SetCursor(CURSOR_HAND);
  ObjSet( "spr_safe_add_"..color.."button",{alp = 1});
  ObjAttach( "spr_safe_add_"..color.."button","spr_safe_"..color.."button_"..num);

end;
--------------------------------------------------------------------------------------------
function private.ButtonLeave(color)

  common_impl.SetCursor(CURSOR_DEFAULT);
  ObjSet( "spr_safe_add_"..color.."button",{alp = 0});

end;
--------------------------------------------------------------------------------------------
function private.seg_number(ang)

  local num_seg = math.floor (ang/0.628);
  local rest = math.fmod (ang, 0.628);
  if ( rest > 0.314 ) then num_seg = num_seg + 1 end;
  return num_seg;

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------