-- name=mg_superpuzzle
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_superpuzzle";
  ObjSet( "spr_superpuzzle_trunkemblem", { event_mdown = private.get_trunkemblem });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_superpuzzle = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

  local mas_parent_gfx = 

    {
    private.room_objname,

    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_superpuzzle", update_game_mode_superpuzzle, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_trunkemblem () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_trunkemblem" ] = {
    type = "get",
    get_obj = "spr_superpuzzle_trunkemblem",
    room = "rm_abandoneddistrict",
    zz = "mg_superpuzzle",
    zz_gate = "gmg_abandoneddistrict_superpuzzle"
  };
  local get_trunkemblem_inv = function ()
  
    interface.InventoryItemAdd( "inv_trunkemblem", "spr_superpuzzle_trunkemblem" );    

  end;
  
  local get_trunkemblem_closemg = function ()
  
    ObjDelete( "gfx_superpuzzle_trunkemblem" );
    ObjDelete( "spr_superpuzzle_owl_2_shadow" );

  end;

  local get_trunkemblem_abandoneddistrict = function ()
  
    ObjDelete( "gmg_abandoneddistrict_superpuzzle" );
  
  end;
  
  cmn.AddSubscriber( "get_trunkemblem", get_trunkemblem_inv );
  cmn.AddSubscriber( "get_trunkemblem", get_trunkemblem_closemg, private.room_objname );
  cmn.AddSubscriber( "get_trunkemblem", get_trunkemblem_abandoneddistrict, "rm_abandoneddistrict" );
  --------------------------------------------------------------------------------------------
  -- function win_superpuzzle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_superpuzzle" ] = {
    type = "win",
    room = "rm_abandoneddistrict",
    zz = "mg_superpuzzle",
    zz_gate = "gmg_abandoneddistrict_superpuzzle"
  };

  local win_superpuzzle = function ()

    local table_multiset = {};

    private.sky_state  = ng_global.progress[ "std" ][ "win_superpuzzle" ].sky_state;
    private.rope       = ng_global.progress[ "std" ][ "win_superpuzzle" ].rope;
    private.items_done = ng_global.progress[ "std" ][ "win_superpuzzle" ].items_done;
    private.prison     = ng_global.progress[ "std" ][ "win_superpuzzle" ].prison;  
    private.mills      = ng_global.progress[ "std" ][ "win_superpuzzle" ].mills;  
    private.owl        = ng_global.progress[ "std" ][ "win_superpuzzle" ].owl;  
    private.picture    = ng_global.progress[ "std" ][ "win_superpuzzle" ].picture;  
    private.weapons    = ng_global.progress[ "std" ][ "win_superpuzzle" ].weapons; 

    if ( cmn.IsEventDone( "win_superpuzzle" ) ) then  
          
      table.insert( table_multiset, { "spr_superpuzzle_trunkemblem", { input = 1, active = 1, alp = 1 }} );
      table.insert( table_multiset, { "spr_superpuzzle_shelf", { input = true, alp = 1 }} );
      table.insert( table_multiset, { "btn_superpuzzle_window_sky_change", { input = false }} );

    else
        
      --
      
    end
  
    private.SkySet();

    if ( private.rope.win ) then

      private.RopeWinSet();
      
    else

      for i = 1, #private.rope.current_list do
        
        if ( private.rope.current_list[ i ] ~= 0 ) then

          table.insert( table_multiset, { "spr_superpuzzle_rope_"..private.rope.current_list[ i ], { pos_y = -130 } } );
      
        end;

      end;

    end;

    for i = 1, #private.items_list do
      
      local name = private.items_list[ i ];

      if ( private.items_done[ name ] ) then

        private.items_func_done[ name ]();

      end;

    end;

    if ( private.prison.win ) then

      private.PrisonWinSet();
      
    else

      for i = 1, #private.prison.current_list do
        
        local ang = math.pi / 5 * ( private.prison.current_list[ i ] );          
        table.insert( table_multiset, { "spr_superpuzzle_circle_"..i, { ang = ang } } );

      end;

    end;

    ------
    if ( private.mills.win ) then

      private.MillsWinSet();
      
    end;

    for i = 1, #private.mills.current_list do
      
      local ang = private.mills.ang[ i ];          
      table.insert( table_multiset, { "obj_superpuzzle_element_mills_"..private.mills.current_list[ i ], { ang = ang } } );

    end;
    ------

    if ( private.owl.win ) then

      private.OwlWinSet();
      
    else

      for i = 1, 3 do
      
        for j = 1, 3 do
            
          local pos = private.owl.pos[ i ][ j ];
          local number = private.owl.current_list[ i ][ j ];
                    
          table.insert( table_multiset, { "spr_superpuzzle_puzzle_"..number, { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } } );

        end;
      
      end;

    end;

    if ( private.picture.win ) then

      private.PictureWinSet();
      
    else

      --
         
    end;

    if ( private.weapons.win ) then

      private.WeaponsWinSet();
      
    else

      for i = 1, #private.weapons.done_list do
     
        local name = private.weapons.done_list[ i ];

        table.insert( table_multiset, { "spr_superpuzzle_"..name.."_1", { input = false, alp = 0 } } );
        table.insert( table_multiset, { "spr_superpuzzle_"..name.."_2", { input = false, alp = 0 } } );

      end;

    end;

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;

  end;

  cmn.AddSubscriber( "win_superpuzzle", win_superpuzzle, private.room_objname );  

  --------------------------------------------------------------------------------------------------------------

  local table_multiset = {};
  table.insert( table_multiset, { "btn_superpuzzle_window_sky_change", { event_mdown = function ()

    private.SkyChange();
    private.SkySet();

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_click_light", 0, "", 0 );

    if ( private.sky_state == "moon" ) then

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_night", 0, "", 0 );

      if ( not private.items_done[ "key" ] ) then

        common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_guards_sleep", 0, "", 0 );

      end;

    else

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_day", 0, "", 0 );

      if ( not private.items_done[ "key" ] ) then

        common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_guards_awake", 0, "", 0 );

      end;

    end;

  end} } );

  table.insert( table_multiset, { "spr_superpuzzle_ax",            { event_mdown = function () private.ItemMDown( "ax" ); end,            event_dragdrop = function () private.ItemDragDrop( "ax" ); end } } );
  table.insert( table_multiset, { "spr_superpuzzle_bridge_1",      { event_mdown = function () private.ItemMDown( "bridge_1" ); end,      event_dragdrop = function () private.ItemDragDrop( "bridge_1" ); end } } );
  table.insert( table_multiset, { "spr_superpuzzle_bridge_2",      { event_mdown = function () private.ItemMDown( "bridge_2" ); end,      event_dragdrop = function () private.ItemDragDrop( "bridge_2" ); end } } );
  table.insert( table_multiset, { "spr_superpuzzle_bridge_3",      { event_mdown = function () private.ItemMDown( "bridge_3" ); end,      event_dragdrop = function () private.ItemDragDrop( "bridge_3" ); end } } );
  table.insert( table_multiset, { "spr_superpuzzle_bridge",        { event_mdown = function () private.ItemMDown( "bridge" ); end,        event_dragdrop = function () private.ItemDragDrop( "bridge" ); end } } );
  table.insert( table_multiset, { "spr_superpuzzle_key",           { event_mdown = function () private.ItemMDown( "key" ); end,           event_dragdrop = function () private.ItemDragDrop( "key" ); end } } );
  table.insert( table_multiset, { "spr_superpuzzle_little_man",    { event_mdown = function () private.ItemMDown( "little_man" ); end,    event_dragdrop = function () private.ItemDragDrop( "little_man" ); end } } );
  table.insert( table_multiset, { "spr_superpuzzle_element_mills", { event_mdown = function () private.ItemMDown( "element_mills" ); end, event_dragdrop = function () private.ItemDragDrop( "element_mills" ); end } } );
  table.insert( table_multiset, { "spr_superpuzzle_puzzle_2_1",    { event_mdown = function () private.ItemMDown( "puzzle_2_1" ); end,    event_dragdrop = function () private.ItemDragDrop( "puzzle_2_1" ); end } } );
  table.insert( table_multiset, { "spr_superpuzzle_owl",           { event_mdown = function () private.ItemMDown( "owl" ); end,           event_dragdrop = function () private.ItemDragDrop( "owl" ); end } } );
  table.insert( table_multiset, { "spr_superpuzzle_rifle_item",    { event_mdown = function () private.ItemMDown( "rifle_item" ); end,    event_dragdrop = function () private.ItemDragDrop( "rifle_item" ); end } } );
  table.insert( table_multiset, { "obj_superpuzzle_window_5_click",{ event_mdown = private.WeaponsDoorClk } } );

  local func_guardian_click = function ()

    private.PrisonQuardianClick();
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_guards_touch", 0, "", 0 );

  end;

  table.insert( table_multiset, { "obj_superpuzzle_window_1_guardian_click_1",{ event_mdown = func_guardian_click } } );
  table.insert( table_multiset, { "obj_superpuzzle_window_1_guardian_click_2",{ event_mdown = func_guardian_click } } );

  for i = 1, 3 do
        
    table.insert( table_multiset, { "spr_superpuzzle_rope_"..i, { event_mdown = function () private.RopePull( i ); end } } );

  end;

  for i = 1, 3 do

    table.insert( table_multiset, { "spr_superpuzzle_circle_"..i, { event_mdown = function () private.PrisonClick( i ); end } } );

  end;

  for i = 1, 4 do

    table.insert( table_multiset, { "obj_superpuzzle_element_mills_"..i, { event_mdown = function () private.MillsClick( i ); end } } );

  end;

  for i = 1, 8 do
        
    table.insert( table_multiset, { "spr_superpuzzle_puzzle_"..i, { event_mdown = function () private.OwlClick( i ); end } } );

  end;

  for i = 1, 3 do
        
    table.insert( table_multiset, { "btn_superpuzzle_picture_"..i, { event_mdown = function () private.PictureClick( i ); end } } );

  end;  

  --------------------------------------------------------------------------------------------------------------
  private.sky_state = "sun";

  private.rope = {}
  private.rope.win_list = { 2, 3, 1 };
  private.rope.current_list = { 0, 0, 0 };
  private.rope.index = 1;

  private.items_done = {};
  private.items_list = { "ax", "bridge_1", "bridge_2", "bridge_3", "bridge", "key", "little_man", "element_mills", 
    "puzzle_2_1", "owl", "rifle_item" 
  };
  private.items_func_done = {};
  private.items_func_done.ax            = private.ItemDoneAx;
  private.items_func_done.bridge_1      = private.ItemDoneBridge1;
  private.items_func_done.bridge_2      = private.ItemDoneBridge2;
  private.items_func_done.bridge_3      = private.ItemDoneBridge3;
  private.items_func_done.bridge        = private.ItemDoneBridge;
  private.items_func_done.key           = private.ItemDoneKey;
  private.items_func_done.little_man    = private.ItemDoneLittleMan;
  private.items_func_done.element_mills = private.ItemDoneElementMills;
  private.items_func_done.puzzle_2_1    = private.ItemDonePuzzle;
  private.items_func_done.owl           = private.ItemDoneOwl;
  private.items_func_done.rifle_item    = private.ItemDoneRifle;

  private.change_list = { "picture_1_1", "picture_1_2", "picture_1_3", "picture_2_1", "picture_2_2", "picture_2_3", 
    "bridge", "bridge_1", "bridge_2", "bridge_3", "picture_3_1", "picture_3_2", "picture_3_3", "curtain", "door", 
    "element_mills", "element_mills_5", "gun", "key", "knife", "little_man", "little_man_2", "machete", "mmg", 
    "circle_1", "circle_2", "circle_3", "mmg_1_over", "mmg_1_over_2", "mmg_2_over", "open_door", "pistol", 
    "puzzle_over", "revolver", "shotgun", "trees", "little_man_owl", "rifle_item", "panel", "owl"
  };

  private.prison = {};
  private.prison.win_list = { 5, 1, 6 };
  private.prison.current_list = { 0, 0, 0 };

  private.mills = {};
  private.mills.win_list = { 1, 4, 3, 2 };
  private.mills.current_list = { 2, 3, 4, 1 };
  private.mills.ang = { 0, 1.57, 3.14, 4.71 };

  private.mills_prev_name = "";

  private.owl = {};
  private.owl.win_list = { 
    { 1, 2, 3 }, 
    { 4, 5, 0 }, 
    { 6, 7, 8 } 
  };
  private.owl.current_list = { 
    { 4, 1, 3 }, 
    { 0, 2, 5 }, 
    { 6, 7, 8 } 
  };
  private.owl.pos = { 
    { { -85, -90 }, { 0, -90 }, { 85, -90 } }, 
    { { -85,   0 }, { 0,   0 }, { 85,   0 } },  
    { { -85,  90 }, { 0,  90 }, { 85,  90 } }
  };

  for i = 1, 3 do
  
    for j = 1, 3 do
        
      local pos = private.owl.pos[ i ][ j ];
      local number = private.owl.current_list[ i ][ j ];
    
      ObjSet( "spr_superpuzzle_puzzle_"..number, { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } );

    end;
  
  end;

  private.picture = {};
  private.picture.win_list = { 3, 3, 3 };
  private.picture.current_list = { 2, 3, 1 };

  private.weapons_list = { "gun_1", "gun_2", "knife_1", "knife_2", "machete_1", "machete_2", 
    "pistol_1", "pistol_2", "revolver_1", "revolver_2", "shotgun_1", "shotgun_2"  
  };

  private.weapons = {};
  private.weapons.win_pair_count = 6;
  private.weapons.pair_count = 0;
  private.weapons.done_list = {};

  private.weapons_prev_name = "";

  for i = 1, #private.weapons_list do

    ObjClone ( "spr_superpuzzle_"..private.weapons_list[ i ], "_light", 0, "spr_superpuzzle_"..private.weapons_list[ i ] );
    table.insert( table_multiset, { "spr_superpuzzle_"..private.weapons_list[ i ].."_light", { alp = 0, ang = 0, color_r = 0, color_g = 0, pos_x = 0, pos_y = 0, scale_x = 1, input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle_"..private.weapons_list[ i ], { event_mdown = function () private.WeaponsClick( private.weapons_list[ i ] ); end } } );

  end;

  private.extra_change_list = { 
    { name = "rope",     count = 3 },
    { name = "door_1",   count = 2 },
    { name = "gun",      count = 2 },
    { name = "knife",    count = 2 },
    { name = "machete",  count = 2 },
    { name = "pistol",   count = 2 },
    { name = "revolver", count = 2 },
    { name = "shotgun",  count = 2 },
    { name = "crowd",    count = 3 },
    { name = "puzzle_2", count = 1 }
  };

  private.only_list = {};
  private.only_list.sun = { "grid", "light" };

  private.only_list.moon = { "puzzle_1", "puzzle_2", "puzzle_3", "puzzle_4", "puzzle_5", "puzzle_6", 
    "puzzle_7", "puzzle_8" 
  };

  private.only_list_anim = {};
  private.only_list_anim.sun = { "guardian" };
  private.only_list_anim.moon = { "guardian_2", "guardian_4" };

  ObjMultiSet( table_multiset );

  private.SkySet();

  private.Animations();

end;  
--*********************************************************************************************************************
function public.Open() 

  common_impl.VisitMapRoom( "abandoneddistrict" );
  if not cmn.IsEventDone( "win_superpuzzle" ) then

    int_slider.InitSlider( private.room_objname );
    cmn.MiniGameShow();
    common_impl.PassingMgStart();

  end;

  common_impl.PlayAudio( "mus", "common/audio/aud_enigma_mus", 0, "", 0 );

  common_impl.PlayAudio( "env", "common/audio/aud_mg_superpuzzle_env", 1, "", 0.5 );

  ObjSet( "tmr_superpuzzle_env", { playing = 1, time = 10, endtrig = function () 

    common_impl.StopAudio( "env", "common/audio/aud_mg_superpuzzle_env", 10 );

  end } );

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  local ang = 0.03;

  ObjSet( "spr_superpuzzle_rope_1", { ang = ang } );
  ObjSet( "spr_superpuzzle_rope_2", { ang = - ang } );
  ObjSet( "spr_superpuzzle_rope_3", { ang = ang } );

  ObjAnimate( "spr_superpuzzle_rope_1", "ang", 1, 0, "", { 0,3,  ang,   1.0,3, - ang, 2.0,3,   ang } );
  ObjAnimate( "spr_superpuzzle_rope_2", "ang", 1, 0, "", { 0,3, - ang,  1.2,3,   ang, 2.4,3, - ang } );
  ObjAnimate( "spr_superpuzzle_rope_3", "ang", 1, 0, "", { 0,3,  ang,   1.1,3, - ang, 2.2,3,   ang } );

  if ( not cmn.IsEventStart( "win_superpuzzle" ) ) then
    
    ng_global.progress[ "std" ][ "win_superpuzzle" ].sky_state  = private.sky_state;
    ng_global.progress[ "std" ][ "win_superpuzzle" ].rope       = private.rope;
    ng_global.progress[ "std" ][ "win_superpuzzle" ].items_done = private.items_done;
    ng_global.progress[ "std" ][ "win_superpuzzle" ].prison     = private.prison;
    ng_global.progress[ "std" ][ "win_superpuzzle" ].mills      = private.mills;
    ng_global.progress[ "std" ][ "win_superpuzzle" ].owl        = private.owl;
    ng_global.progress[ "std" ][ "win_superpuzzle" ].picture    = private.picture;
    ng_global.progress[ "std" ][ "win_superpuzzle" ].weapons    = private.weapons;

  end;

  interface.InvestigationButtonCheck();

end;
--*********************************************************************************************************************
function public.Close()

  ObjSet( "tmr_superpuzzle_env", { playing = 0 } );
  common_impl.StopAudio( "env", "common/audio/aud_mg_superpuzzle_env", 1.0 );

end;
--*********************************************************************************************************************
function public.PreClose()

  cmn.MiniGameHide();
  common_impl.PassingMgStop();
  
end;
--*********************************************************************************************************************
function public.Reset()

  private.RopeResetSet();
  private.ItemResetSet();
  private.PrisonResetSet();
  private.MillsResetSet();
  private.OwlResetSet();
  private.PictureResetSet();
  private.WeaponsResetSet();

  private.sky_state = "sun";
  ng_global.progress[ "std" ][ "win_superpuzzle" ].sky_state = private.sky_state;

  private.SkySet();

  ObjSet( "txt_superpuzzle_panel", { text = "" } );  

end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  private.rope.win    = true;
  private.prison.win  = true;
  private.mills.win   = true;
  private.owl.win     = true;
  private.picture.win = true;
  private.weapons.win = true;
  
  for i = 1, #private.items_list do
    
    local name = private.items_list[ i ];
    private.items_done[ name ] = true;

  end;

  private.Win();

end;
--*********************************************************************************************************************
function private.Win()

  cmn.MiniGameHide();

  cmn.SetEventDone( "win_superpuzzle" );
  cmn.CallEventHandler( "win_superpuzzle" );
  common_impl.PassingMgWin();

  common_impl.Lock( true );

  local func_end = function ()

    common_impl.Lock( false );

  end;

  ObjSet( "spr_superpuzzle_trunkemblem", { active = true } );

  ObjAnimate( "spr_superpuzzle_curtain", "pos_y", 0, 0, func_end, 
  { 
    0,   3, -320,  
    0.7, 3, 0,  
    1.4, 3, -320 
  } );   

  ObjAnimate( "spr_superpuzzle_shelf", "alp", 0, 0, "", { 0,3,0,  0.7,3,0,  0.7,3,1 } );

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_win", 0, "", 0 );

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
  function private.get_trunkemblem()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_trunkemblem" );
    cmn.CallEventHandler( "get_trunkemblem" );
    cmn.GotoRoom( "rm_abandoneddistrict" );

  end;
--*********************************************************************************************************************
-- function *** Sky ***() end
--*********************************************************************************************************************
  function private.SkyChange()

    if ( private.sky_state == "moon" ) then

      private.sky_state = "sun";

    else

      private.sky_state = "moon";

    end;

    ng_global.progress[ "std" ][ "win_superpuzzle" ].sky_state = private.sky_state;

  end;
  --*********************************************************************************************************************
  function private.SkySet()

    local table_multiset = {};
    table.insert( table_multiset, { "spr_superpuzzle_sun",  { visible = false, active = false } } );
    table.insert( table_multiset, { "spr_superpuzzle_moon", { visible = false, active = false } } );
    
    local res = "assets/levels/level1/mg_superpuzzle/layers/"

    local old_sky_state = "";

    if ( private.sky_state == "moon" ) then

      old_sky_state = "sun";

    else

      old_sky_state = "moon";

    end;

    if ( private.sky_state == "sun") then

      table.insert( table_multiset, { "spr_superpuzzle_sun",  { visible = true, active = true } } );
      table.insert( table_multiset, { "spr_superpuzzle_black", { visible = false } } );

    else
      
      table.insert( table_multiset, { "spr_superpuzzle_moon", { visible = true, active = true } } );
      table.insert( table_multiset, { "spr_superpuzzle_black", { visible = true } } );
      res = res.."night/";

    end;

    for i = 1, #private.change_list do
      
      local name = private.change_list[ i ];
      table.insert( table_multiset, { "spr_superpuzzle_"..name, { res = res..name } } );

    end;

    for i = 1, #private.extra_change_list do

      local obj = private.extra_change_list[ i ];

      for c = 1, obj.count do
        
        table.insert( table_multiset, { "spr_superpuzzle_"..obj.name.."_"..c, { res = res..obj.name } } );

      end;

    end;

    for i = 1, #private.only_list[ old_sky_state ] do
      
      local name = private.only_list[ old_sky_state ][ i ];
      table.insert( table_multiset, { "spr_superpuzzle_"..name, { visible = false, active = false } } );

    end;

    for i = 1, #private.only_list[ private.sky_state ] do
      
      local name = private.only_list[ private.sky_state ][ i ];
      table.insert( table_multiset, { "spr_superpuzzle_"..name, { visible = true, active = true } } );

    end;

    if ( private.owl.win ) and ( not private.items_done[ "owl" ] ) then

      table.insert( table_multiset, { "spr_superpuzzle_owl", { input = true } } );

    end;

    for i = 1, #private.only_list_anim[ old_sky_state ] do
      
      local name = private.only_list_anim[ old_sky_state ][ i ];
      table.insert( table_multiset, { "anm_superpuzzle_"..name, { visible = false, active = false } } );

      if ( name == "guardian_2" ) and ( not private.items_done[ "key" ] ) then
    
        ObjSet( "anm_superpuzzle_guardian_4", { alp = 0 } );

      end;

      AnimStop( "anm_superpuzzle_"..name );

    end;

    for i = 1, #private.only_list_anim[ private.sky_state ] do
      
      local name = private.only_list_anim[ private.sky_state ][ i ];
      table.insert( table_multiset, { "anm_superpuzzle_"..name, { visible = true, active = true} } );

      local func_end = nil;

      if ( name == "guardian_2" ) and ( not private.items_done[ "key" ] ) then
    
        func_end = function ()

          ObjSet( "anm_superpuzzle_guardian_2", { visible = false } );
          ObjSet( "anm_superpuzzle_guardian_4", { alp = 1 } );
          AnimPlay( "anm_superpuzzle_guardian_4", "DoAnim", "" );

        end;

      end;

      AnimPlay( "anm_superpuzzle_"..name, "DoAnim", func_end );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
--  function *** Mmg Rope ***() end
--*********************************************************************************************************************
  function private.RopePull ( number )

    common_impl.Lock( true );

    private.rope.current_list[ private.rope.index ] = number;
    
    ObjSet( "spr_superpuzzle_rope_"..number, { input = false } );

    ObjAnimate( "spr_superpuzzle_rope_"..number, "pos_y", 0, 0, private.RopePullEnd, 
    { 
      0,   3, -150,  
      0.4, 3, -130 
    } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_rope", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.RopePullEnd ()

    common_impl.Lock( false );

    local flag_win = true;

    for i = 1, #private.rope.win_list do
      
      if ( private.rope.current_list[ i ] ~= private.rope.win_list[ i ] ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.RopeWinAnim();

    elseif ( private.rope.index == #private.rope.win_list ) then

      private.RopeResetAnim();

    else

      private.rope.index = private.rope.index + 1;

    end;

  end;
  --*********************************************************************************************************************
  function private.RopeWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.rope.win = true;

      ng_global.progress[ "std" ][ "win_superpuzzle" ].rope = private.rope;

      private.RopeWinSet();

      private.ZoomScene ();

    end;

    ObjAnimate( "obj_superpuzzle_window_2_ropes", "pos_y", 0, 0, "", 
    { 
      0,   3, 0,  
      0.7, 3, -220 
    } );    

    ObjAnimate( "spr_superpuzzle_curtain", "pos_y", 0, 0, func_end, 
    { 
      0,   3, 0,  
      0.7, 3, 0,  
      1.4, 3, -320 
    } );   

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_rope_win", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.RopeWinSet ()

    ObjSet( "obj_superpuzzle_window_2_ropes", { visible = false, input = false, active = false } );
    ObjSet( "spr_superpuzzle_curtain",        { pos_y = -320 } );  
    ObjSet( "spr_superpuzzle_ax",             { input = true } );  

    ObjSet( "txt_superpuzzle_panel",          { text = "str_superpuzzle_panel_1" } );  

  end;
  --*********************************************************************************************************************
  function private.RopeResetAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.RopeResetSet();

    end;

    for i = 1, #private.rope.win_list do

      if ( i ~= 1 ) then

        func_end = "";

      end;

      ObjAnimate( "spr_superpuzzle_rope_"..i, "pos_y", 0, 0, func_end, 
      { 
        0,   3, -130,  
        0.4, 3, -150 
      } );    

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_rope_wrong", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.RopeResetSet ()

    private.rope.index = 1;
    private.rope.current_list = { 0, 0, 0 };
    private.rope.win = false;

    ng_global.progress[ "std" ][ "win_superpuzzle" ].rope = private.rope;
    local table_multiset = {};
    table.insert( table_multiset, { "obj_superpuzzle_window_2_ropes", { visible = true, input = true, active = true, pos_y = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle_curtain", { pos_y = 0 } } );

    for i = 1, #private.rope.win_list do 
      
      table.insert( table_multiset, { "spr_superpuzzle_rope_"..i, { input = true, pos_y = -150 } } );

    end;

    ObjMultiSet( table_multiset );

  end;
--*********************************************************************************************************************
-- function *** Use Items ***() end
--*********************************************************************************************************************
  function private.ItemMDown ( sender )

    local obj_name = "spr_superpuzzle_"..sender;

    private.item_parent = ObjGetRelations( obj_name ).parent;
    private.item_pos_z  = ObjGet( obj_name ).pos_z;

    ObjAttach( obj_name, "mg_superpuzzle" )
    ObjSet( obj_name, { pos_z = 10 } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.ItemDragDrop ( sender )

    local obj_name = "spr_superpuzzle_"..sender;

    ObjAttach( obj_name, private.item_parent )
    ObjSet( obj_name, { pos_z = private.item_pos_z } );

    if ( sender == "ax" and common.ApplyObj( obj_name, "obj_superpuzzle_window_3_use_axe" ) ) then

      common_impl.Lock( true );

      ObjSet( obj_name, { active = false, input = false, visible = false } );

      local func_end = function ()
      
        common_impl.Lock( false );

        private.items_done[ "ax" ] = true;
    
        private.ItemDoneAx();
      
      end;

      ObjAnimate( "spr_superpuzzle_trees", "pos_x", 0, 0, func_end, { 0,3,0,  1.0,3, -280 } );

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_axe", 0, "", 0 );

    ---------------------------------------------------------------------------

    elseif ( sender == "bridge_1" and common.ApplyObj( obj_name, "obj_superpuzzle_window_3_use_bridge" ) ) then
    
      private.items_done[ "bridge_1" ] = true;
      private.ItemDoneBridge1();

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_bridge_parts", 0, "", 0 );

    ---------------------------------------------------------------------------

    elseif ( sender == "bridge_2" and common.ApplyObj( obj_name, "obj_superpuzzle_window_3_use_bridge" ) ) then
    
      private.items_done[ "bridge_2" ] = true;
      private.ItemDoneBridge2();

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_bridge_parts", 0, "", 0 );

    ---------------------------------------------------------------------------

    elseif ( sender == "bridge_3" and common.ApplyObj( obj_name, "obj_superpuzzle_window_3_use_bridge" ) ) then
    
      private.items_done[ "bridge_3" ] = true;
      private.ItemDoneBridge3();

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_bridge_parts", 0, "", 0 );

    ---------------------------------------------------------------------------

    elseif ( sender == "bridge" and common.ApplyObj( obj_name, "obj_superpuzzle_window_2_use_bridge" ) and
             private.sky_state == "sun" ) then
    
      common_impl.Lock( true );

      local func_end = function ()
      
        common_impl.Lock( false );

        private.items_done[ "bridge" ] = true;
      
        ObjSet( "txt_superpuzzle_panel", { text = "str_superpuzzle_panel_2" } );

        local func_zoom_end = function ()

          private.ItemDoneBridge();

        end;

        local func_after_zoom_in = function ()

          common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_people", 0, "", 0 );

        end;

        private.ZoomScene( func_zoom_end, "anm_superpuzzle_crowd", "unknown", func_after_zoom_in )

      end;

      ObjSet( "spr_superpuzzle_bridge_over", { alp = 1 } );
      ObjSet( "spr_superpuzzle_bridge", { pos_x = 511, pos_y = 427, scale_x = 1.1, scale_y = 1.1, input = false } );
      ObjAttach( "spr_superpuzzle_bridge", "obj_superpuzzle_window_2" );

      ObjAnimate( "spr_superpuzzle_key", "pos_y", 0, 0, func_end, { 0,3,-220,  1.0,3, -60 } );

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_bridge", 0, "", 0 );
      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_key", 0, "", 0 );

    ---------------------------------------------------------------------------

    elseif ( sender == "key" and common.ApplyObj( obj_name, "obj_superpuzzle_window_1_use_key" ) and
             private.sky_state == "moon" ) then
    
      common_impl.Lock( true );

      local func_end = function ()
      
        common_impl.Lock( false );

        private.items_done[ "key" ] = true;
      
        private.ItemDoneKey();
      
      end;

      ObjSet( "spr_superpuzzle_key", { pos_x = -2, pos_y = -4, input = false } );
      ObjAttach( "spr_superpuzzle_key", "spr_superpuzzle_door" );
      
      ObjSet( "anm_superpuzzle_guardian_2", { alp = 0 } );
      ObjSet( "anm_superpuzzle_guardian_4", { alp = 0 } );
      ObjSet( "anm_superpuzzle_guardian_3", { alp = 1 } );

      ObjAnimate( "spr_superpuzzle_door",         "alp", 0, 0, func_end, { 0,3,1,  1.0,3,0 } );
      ObjAnimate( "spr_superpuzzle_mmg_1_over_2", "alp", 0, 0, "", { 0,3,0,  1.0,3,1 } );

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_use_key", 0, "", 0 );

    ---------------------------------------------------------------------------

    elseif ( sender == "little_man" and common.ApplyObj( obj_name, "obj_superpuzzle_window_2_use_little_man" ) and
             private.sky_state == "sun" ) then
    
      common_impl.Lock( true );

      local func_end = function ()
      
        common_impl.Lock( false );

        private.items_done[ "little_man" ] = true;
      
        private.ItemDoneLittleMan();
      
        private.ZoomScene();

      end;

      ObjSet( "spr_superpuzzle_little_man", { visible = false, input = false } );

      ObjAnimate( "spr_superpuzzle_little_man_2", "scale_x", 0, 0, func_end, { 0,3,0,  0.5,3,0,  1.0,1,1 } );
      ObjAnimate( "spr_superpuzzle_unknown",      "scale_x", 0, 0, "", { 0,3,1,  0.5,3,0 } );

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_man", 0, "", 0 );

    ---------------------------------------------------------------------------

    elseif ( sender == "element_mills" and common.ApplyObj( obj_name, "obj_superpuzzle_window_3_use_element_mills" ) ) then
    
      common_impl.Lock( true );

      local func_end = function ()
      
        common_impl.Lock( false );

        private.items_done[ "element_mills" ] = true;
      
        private.ItemDoneElementMills();
      
      end;

      ObjSet( "spr_superpuzzle_element_mills", { visible = false } );
      ObjSet( "obj_superpuzzle_window_3_mills_parts", { visible = true } );

      ObjAnimate( "spr_superpuzzle_picture_2_"..private.picture.current_list[ 2 ], "scale_y", 0, 0, func_end, 
      { 
        0,   3, 0,  
        0.3, 3, 1 
      } );   

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_rotate", 0, "", 0 );
      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_windmill", 0, "", 0 );

    ---------------------------------------------------------------------------

    elseif ( sender == "puzzle_2_1" and common.ApplyObj( obj_name, "obj_superpuzzle_window_4_use_puzzle_2_1" ) and
             private.sky_state == "moon" ) then
    
      private.items_done[ "puzzle_2_1" ] = true;
      private.ItemDonePuzzle();

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_use_tag", 0, "", 0 );

    ---------------------------------------------------------------------------

    elseif ( sender == "owl" and common.ApplyObj( obj_name, "obj_superpuzzle_window_2_use_owl" ) and
             private.items_done[ "little_man" ] and private.sky_state == "sun" ) then
    
      common_impl.Lock( true );

      local func_end = function ()
      
        common_impl.Lock( false );

        private.items_done[ "owl" ] = true;
      
        private.ItemDoneOwl();
      
        private.ZoomScene();

      end;

      ObjSet( "spr_superpuzzle_owl", { alp = 0 } );

      ObjAnimate( "spr_superpuzzle_little_man_owl", "scale_x", 0, 0, func_end, { 0,3,0,  0.5,3,0,  1.0,1,1 } );
      ObjAnimate( "spr_superpuzzle_little_man_2",   "scale_x", 0, 0, "", { 0,3,1,  0.5,3,0 } );

      ObjAnimate( "spr_superpuzzle_picture_3_"..private.picture.current_list[ 3 ], "scale_y", 0, 0, "", 
      { 
        0,   3, 0,  
        0.3, 3, 1 
      } );   

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_rotate", 0, "", 0 );
      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_owl", 0, "", 0 );

    ---------------------------------------------------------------------------

    elseif ( sender == "rifle_item" and common.ApplyObj( obj_name, "obj_superpuzzle_window_2_use_rifle_item" ) and
             private.sky_state == "sun" ) then

      local func_anim_end = function ()

        private.items_done[ "rifle_item" ] = true;
        private.ItemDoneRifle();
        private.Win();

      end;

      ObjSet( "txt_superpuzzle_panel",         { text = "str_superpuzzle_panel_5" } );
      ObjSet( "anm_superpuzzle_sheriff",        { visible = true,  active = true,  alp = 1 } );
      ObjSet( "anm_superpuzzle_crowd",          { visible = false, active = false, alp = 0 } );
      ObjSet( "spr_superpuzzle_little_man_owl", { alp = 0 } );
      ObjSet( "spr_superpuzzle_crowd_1",        { alp = 1 } );
      ObjSet( "spr_superpuzzle_crowd_2",        { alp = 1 } );
      ObjSet( "spr_superpuzzle_crowd_3",        { alp = 1 } );
      ObjSet( "spr_superpuzzle_rifle_item",     { alp = 0 } );

      private.ZoomScene( func_anim_end, "anm_superpuzzle_sheriff" )

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_rifle", 0, "", 0 );

    end;

  end;
  --*********************************************************************************************************************
  function private.ItemDoneAx ()

    local table_multiset = {};
    table.insert( table_multiset, { "spr_superpuzzle_ax",                    { active = false, input = false, visible = false } } );
    table.insert( table_multiset, { "spr_superpuzzle_trees",                 { active = false, visible = false } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_3_bridge_parts", { input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_3_use_axe",      { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_3_use_bridge",   { input = true } } );
    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemDoneBridge1 ()

    local table_multiset = {};  
    table.insert( table_multiset, { "spr_superpuzzle_bridge_1", { pos_x = 81, pos_y = 280, input = false } } );

    if ( private.items_done[ "bridge_2" ] and 
         private.items_done[ "bridge_3" ] ) then

      table.insert( table_multiset, { "obj_superpuzzle_window_3_bridge_parts", { visible = false, active = false } } );
      table.insert( table_multiset, { "spr_superpuzzle_bridge", { visible = true, input = true, active = true } } );
      table.insert( table_multiset, { "obj_superpuzzle_window_3_use_bridge", { input = false } } );
      table.insert( table_multiset, { "obj_superpuzzle_window_2_use_bridge", { input = true } } );

    end;
    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemDoneBridge2 ()

    local table_multiset = {};  
    table.insert( table_multiset, { "spr_superpuzzle_bridge_2", { pos_x = 147, pos_y = 279, input = false } } );

    if ( private.items_done[ "bridge_1" ] and 
         private.items_done[ "bridge_3" ] ) then

      table.insert( table_multiset, { "obj_superpuzzle_window_3_bridge_parts", { visible = false, active = false } } );
      table.insert( table_multiset, { "spr_superpuzzle_bridge", { visible = true, input = true, active = true } } );
      table.insert( table_multiset, { "obj_superpuzzle_window_3_use_bridge", { input = false } } );
      table.insert( table_multiset, { "obj_superpuzzle_window_2_use_bridge", { input = true } } );

    end;
    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemDoneBridge3 ()

    local table_multiset = {};  
    table.insert( table_multiset, { "spr_superpuzzle_bridge_3", { pos_x = 109, pos_y = 270, input = false } } );

    if ( private.items_done[ "bridge_1" ] and 
         private.items_done[ "bridge_2" ] ) then

      table.insert( table_multiset, { "obj_superpuzzle_window_3_bridge_parts", { visible = false, active = false } } );
      table.insert( table_multiset, { "spr_superpuzzle_bridge", { visible = true, input = true, active = true } } );
      table.insert( table_multiset, { "obj_superpuzzle_window_3_use_bridge", { input = false } } );
      table.insert( table_multiset, { "obj_superpuzzle_window_2_use_bridge", { input = true } } );

    end;
    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemDoneBridge ()

    local table_multiset = {};
    table.insert( table_multiset, { "spr_superpuzzle_bridge",              { pos_x = 511, pos_y = 427, scale_x = 1.1, scale_y = 1.1, input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle_bridge_over",         { alp = 1 } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_2_use_bridge", { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_1_use_key",    { input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle_key",                 { pos_y = -60, input = true } } );
    table.insert( table_multiset, { "txt_superpuzzle_panel",               { text = "str_superpuzzle_panel_2" } } );

    table.insert( table_multiset, { "spr_superpuzzle_unknown",             { pos_x = 143 } } );
    table.insert( table_multiset, { "anm_superpuzzle_crowd",               { frame = 266 } } );

    ObjMultiSet( table_multiset );
    ObjAttach( "spr_superpuzzle_bridge", "obj_superpuzzle_window_2" );

  end;
  --*********************************************************************************************************************
  function private.ItemDoneKey ()

    local table_multiset = {};
    table.insert( table_multiset, { "obj_superpuzzle_window_1_use_key", { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle_key", { pos_x = -2, pos_y = -4, input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle_door", { visible = false } } );
    table.insert( table_multiset, { "spr_superpuzzle_mmg_1_over_2", { alp = 1 } } );
    table.insert( table_multiset, { "anm_superpuzzle_guardian",   { alp = 0 } } );
    table.insert( table_multiset, { "anm_superpuzzle_guardian_2", { alp = 0 } } );
    table.insert( table_multiset, { "anm_superpuzzle_guardian_3", { alp = 1 } } );
    table.insert( table_multiset, { "anm_superpuzzle_guardian_4", { alp = 0 } } );

    table.insert( table_multiset, { "obj_superpuzzle_window_1_guardian_click_1", { input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_1_guardian_click_2", { input = true } } );

    table.insert( table_multiset, { "obj_superpuzzle_window_1_prison", { input = true } } );
    ObjAttach( "spr_superpuzzle_key", "spr_superpuzzle_door" );
    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemDoneLittleMan ()

    local table_multiset = {};
    table.insert( table_multiset, { "spr_superpuzzle_little_man",              { visible = false, input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle_little_man_2",            { scale_x = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle_unknown",                 { scale_x = 0 } } );
    table.insert( table_multiset, { "txt_superpuzzle_panel",                   { text = "str_superpuzzle_panel_3" } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_2_use_little_man", { input = false } } );

    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemDoneElementMills ()

    local table_multiset = {};
    table.insert( table_multiset, { "spr_superpuzzle_element_mills", { visible = false, input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_3_mills_parts", { visible = true, input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_3_use_element_mills", { input = false } } );

    if ( not private.items_done[ "little_man" ] ) then

      table.insert( table_multiset, { "spr_superpuzzle_little_man", { input = true } } );
      table.insert( table_multiset, { "obj_superpuzzle_window_2_use_little_man", { input = true } } );

    end;

    table.insert( table_multiset, { "btn_superpuzzle_picture_2", { input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle_picture_2_"..private.picture.current_list[ 2 ], { scale_y = 1 } } );

    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemDonePuzzle ()

    local table_multiset = {};
    table.insert( table_multiset, { "spr_superpuzzle_puzzle_2", { alp = 1 } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_4_puzzles", { input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_4_use_puzzle_2_1", { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle_puzzle_2_1", { alp = 0, input = false } } );
    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemDoneOwl ()

    local table_multiset = {};
    table.insert( table_multiset, { "spr_superpuzzle_little_man_owl",   { scale_x = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle_little_man_2",     { scale_x = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_2_use_owl", { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle_owl",              { alp = 0, input = false } } );
    table.insert( table_multiset, { "btn_superpuzzle_picture_3",        { input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle_picture_3_"..private.picture.current_list[ 3 ], { scale_y = 1 } } );
    table.insert( table_multiset, { "txt_superpuzzle_panel",            { text = "str_superpuzzle_panel_4" } } );
    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemDoneRifle ()

    local table_multiset = {};
    table.insert( table_multiset, { "obj_superpuzzle_window_2_use_rifle_item",   { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle_rifle_item",                { alp = 0, input = false  } } );

    table.insert( table_multiset, { "anm_superpuzzle_sheriff",  { visible = true,  active = true,  alp = 1, frame = 210  } } );
    table.insert( table_multiset, { "anm_superpuzzle_crowd",    { visible = false, active = false, alp = 0  } } );

    table.insert( table_multiset, { "spr_superpuzzle_little_man_owl",  { alp = 0  } } );
    table.insert( table_multiset, { "spr_superpuzzle_crowd_1",  { alp = 1  } } );
    table.insert( table_multiset, { "spr_superpuzzle_crowd_2",  { alp = 1  } } );
    table.insert( table_multiset, { "spr_superpuzzle_crowd_3",  { alp = 1  } } );

    table.insert( table_multiset, { "txt_superpuzzle_panel",                     { text = "str_superpuzzle_panel_5" } } );
    ObjMultiSet( table_multiset )

  end;
  --*********************************************************************************************************************
  function private.ItemResetSet ()

    private.items_done[ "ax" ]            = false;
    private.items_done[ "bridge_1" ]      = false;
    private.items_done[ "bridge_2" ]      = false;
    private.items_done[ "bridge_3" ]      = false;
    private.items_done[ "bridge" ]        = false;
    private.items_done[ "key" ]           = false;
    private.items_done[ "little_man" ]    = false;
    private.items_done[ "element_mills" ] = false;
    private.items_done[ "puzzle_2_1" ]    = false;
    private.items_done[ "owl" ]           = false;
    private.items_done[ "rifle_item" ]    = false;


    ng_global.progress[ "std" ][ "win_superpuzzle" ].items_done = private.items_done;

    local table_multiset = {};
    table.insert( table_multiset, { "spr_superpuzzle_ax",                    { active = true, input = false, visible = true } } );
    table.insert( table_multiset, { "spr_superpuzzle_trees",                 { pos_x = 0, active = true, visible = true } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_3_use_axe",      { input = true } } );

    table.insert( table_multiset, { "obj_superpuzzle_window_3_use_bridge",   { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_3_bridge_parts", { input = false, visible = true, active = true } } );
    table.insert( table_multiset, { "spr_superpuzzle_bridge_1",              { pos_x = 263, pos_y = 284, input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle_bridge_2",              { pos_x = 91,  pos_y = 208, input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle_bridge_3",              { pos_x = 211, pos_y = 241, input = true } } );
    table.insert( table_multiset, { "spr_superpuzzle_bridge",                { visible = false, input = false, active = false, pos_x = 114, pos_y = 283, scale_x = 1, scale_y = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle_bridge_over",           { alp = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle_unknown",               { pos_x = 220 } } );
    table.insert( table_multiset, { "anm_superpuzzle_crowd",                 { frame = 0 } } );


    table.insert( table_multiset, { "obj_superpuzzle_window_2_use_bridge",   { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_1_use_key",      { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle_key",                   { pos_x = 82, pos_y = -220, input = false } } );

    table.insert( table_multiset, { "spr_superpuzzle_door",                  { visible = true, alp = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle_open_door",             { visible = false, alp = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle_mmg_1_over_2",          { alp = 0 } } );

    table.insert( table_multiset, { "anm_superpuzzle_guardian_2",            { alp = 1, visible = true } } );
    table.insert( table_multiset, { "anm_superpuzzle_guardian",              { alp = 1, visible = true } } );
    table.insert( table_multiset, { "anm_superpuzzle_guardian_3",            { alp = 0 } } );
    table.insert( table_multiset, { "anm_superpuzzle_guardian_4",            { alp = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_1_guardian_click_1", { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_1_guardian_click_2", { input = false } } );

    table.insert( table_multiset, { "obj_superpuzzle_window_1_prison",        { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle_little_man",             { visible = true, input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle_little_man_2",           { scale_x = 0 } } );
    table.insert( table_multiset, { "spr_superpuzzle_unknown",                { scale_x = 1 } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_2_use_little_man",{ input = false } } );

    table.insert( table_multiset, { "spr_superpuzzle_element_mills",              { visible = true, input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_3_mills_parts",       { visible = false, input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_3_use_element_mills", { input = false } } );

    table.insert( table_multiset, { "spr_superpuzzle_puzzle_2",                { alp = 0 } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_4_puzzles",        { input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_4_use_puzzle_2_1", { input = false } } );

    table.insert( table_multiset, { "spr_superpuzzle_owl",                     { alp = 0, input = false } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_2_use_owl",        { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle_little_man_owl",          { scale_x = 0, alp = 1 } } );
    table.insert( table_multiset, { "obj_superpuzzle_window_2_use_rifle_item", { input = false } } );
    table.insert( table_multiset, { "spr_superpuzzle_rifle_item",              { alp = 1, input = false  } } );

    table.insert( table_multiset, { "anm_superpuzzle_sheriff",                 { visible = false, active = false, alp = 0, frame = 0  } } );
    table.insert( table_multiset, { "anm_superpuzzle_crowd",                   { visible = true,  active = true,  alp = 1, frame = 0  } } );

    table.insert( table_multiset, { "spr_superpuzzle_crowd_1",                 { alp = 0  } } );
    table.insert( table_multiset, { "spr_superpuzzle_crowd_2",                 { alp = 0  } } );
    table.insert( table_multiset, { "spr_superpuzzle_crowd_3",                 { alp = 0  } } );

    ObjAttach( "spr_superpuzzle_bridge", "obj_superpuzzle_window_3" );
    ObjAttach( "spr_superpuzzle_key", "obj_superpuzzle_window_2_crop" );

    ObjMultiSet( table_multiset )

  end;
--*********************************************************************************************************************
-- function *** Mmg Prison ***() end
--*********************************************************************************************************************
  function private.PrisonClick ( number )

    common_impl.Lock( true );

    local name = "spr_superpuzzle_circle_"..number;

    local ang_old = ObjGet( name ).ang;
    local ang_new = math.pi / 5 * ( private.prison.current_list[ number ] + 1 );

    local func_end = function ()

      private.PrisonClickEnd( number );

    end;

    ObjAnimate( name, "ang", 0, 0, func_end, 
    { 
      0,   3, ang_old,  
      0.1, 3, ang_new 
    } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_wheel", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.PrisonClickEnd ( number )

    common_impl.Lock( false );

    private.prison.current_list[ number ] = private.prison.current_list[ number ] + 1;
    
    if ( private.prison.current_list[ number ] > 9 ) then

      private.prison.current_list[ number ] = 0;

    end;

    local name = "spr_superpuzzle_circle_"..number;
    local ang_new = math.pi / 5 * ( private.prison.current_list[ number ] );

    ObjSet( name, { ang = ang_new } );

    local flag_win = true;

    for i = 1, #private.prison.win_list do
      
      if ( private.prison.current_list[ i ] ~= private.prison.win_list[ i ] ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.PrisonWinAnim();

    else

      ng_global.progress[ "std" ][ "win_superpuzzle" ].prison = private.prison;

    end;

  end;
  --*********************************************************************************************************************
  function private.PrisonWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.prison.win = true;

      ng_global.progress[ "std" ][ "win_superpuzzle" ].prison = private.prison;

      private.PrisonWinSet();

    end;

    ObjSet( "spr_superpuzzle_open_door", { visible = true } );  

    ObjAnimate( "obj_superpuzzle_window_1_prison", "alp", 0, 0, "", 
    { 
      0,   3, 1,  
      0.5, 3, 0 
    } );    

    ObjAnimate( "spr_superpuzzle_mmg_1_over_2", "alp", 0, 0, "", 
    { 
      0,   3, 1,  
      0.5, 3, 0 
    } );    

    ObjAnimate( "spr_superpuzzle_open_door", "alp", 0, 0, func_end, 
    { 
      0,   3, 0,  
      0.5, 3, 1 
    } );   

    ObjAnimate( "spr_superpuzzle_picture_1_"..private.picture.current_list[ 1 ], "scale_y", 0, 0, "", 
    { 
      0,   3, 0,  
      0.3, 3, 1 
    } );   

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_rotate", 0, "", 0 );
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_wheel_win", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.PrisonWinSet ()

    ObjSet( "obj_superpuzzle_window_1_prison",     { visible = false, input = false, active = false } );
    ObjSet( "spr_superpuzzle_mmg_1_over_2",        { alp = 0 } );
    ObjSet( "spr_superpuzzle_open_door",           { visible = true, alp = 1 } ); 

    ObjSet( "btn_superpuzzle_picture_1",           { input = true } );
    ObjSet( "spr_superpuzzle_picture_1_"..private.picture.current_list[ 1 ], { scale_y = 1 } );
   
    if ( not private.items_done[ "element_mills" ] ) then

      ObjSet( "spr_superpuzzle_element_mills",              { input = true } );  
      ObjSet( "obj_superpuzzle_window_3_use_element_mills", { input = true } );

    end;

  end;
  --*********************************************************************************************************************
  function private.PrisonResetSet ()

    private.prison.current_list = { 0, 0, 0 };
    private.prison.win = false;

    ng_global.progress[ "std" ][ "win_superpuzzle" ].prison = private.prison;

    ObjSet( "obj_superpuzzle_window_1_prison",           { visible = true, input = false, active = true, alp = 1 } );
    ObjSet( "spr_superpuzzle_mmg_1_over_2",              { alp = 0 } );
    ObjSet( "spr_superpuzzle_open_door",                 { visible = false, alp = 0 } );  
    ObjSet( "obj_superpuzzle_window_3_use_element_mills",{ input = false } );
    ObjSet( "spr_superpuzzle_element_mills",             { input = false } );  
    
    for i = 1, #private.prison.win_list do 

      ObjSet( "spr_superpuzzle_circle_"..i, { ang = 0 } );

    end;

  end;
  --*********************************************************************************************************************
  function private.PrisonQuardianClick ()

    AnimPlay( "anm_superpuzzle_guardian_3", "DoAnim", "" );

  end;
--*********************************************************************************************************************
-- function *** Mmg Mills ***() end
--*********************************************************************************************************************
  function private.MillsClick ( name )

    local obj_name = "obj_superpuzzle_element_mills_"..name;
   
    if ( private.mills_prev_name == name ) then

      ObjSet( "spr_superpuzzle_element_mills_"..name.."_light", { alp = 0 } );
      private.mills_prev_name = "";

    elseif ( private.mills_prev_name ~= "" ) then

      local obj_name_prev = "obj_superpuzzle_element_mills_"..private.mills_prev_name;

      local number_current = private.MillsGetNumber( name );
      local number_prev    = private.MillsGetNumber( private.mills_prev_name );

      local func_end = function ()

        private.MillsClickEnd( number_current, number_prev );

      end;

      common_impl.Lock( true );

      ObjAnimate( obj_name, "ang", 0, 0, "", 
      { 
        0,   3, private.mills.ang[ number_current ],  
        0.4, 3, private.mills.ang[ number_prev ]
      } );

      ObjAnimate( obj_name_prev, "ang", 0, 0, func_end, 
      { 
        0,   3, private.mills.ang[ number_prev ],  
        0.4, 3, private.mills.ang[ number_current ]  
      } );

      ObjSet( "spr_superpuzzle_element_mills_"..private.mills_prev_name.."_light", { alp = 0 } );

      private.mills_prev_name = "";

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_windmill_move", 0, "", 0 );

    else

      ObjSet( "spr_superpuzzle_element_mills_"..name.."_light", { alp = 1 } );
      private.mills_prev_name = name;

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_windmill_click", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.MillsClickEnd ( name_current, name_prev )

    common_impl.Lock( false );

    private.mills.current_list[ name_current ], private.mills.current_list[ name_prev ] =
    private.mills.current_list[ name_prev ], private.mills.current_list[ name_current ];

    local flag_win = true;
    
    for i = 1, #private.mills.current_list do
      
      if ( private.mills.current_list[ i ] ~= private.mills.win_list[ i ]) then

        flag_win = false;
        break;

      end

    end;

    if ( flag_win ) then

      private.MillsWinAnim();

    else

      ng_global.progress[ "std" ][ "win_superpuzzle" ].mills = private.mills;

    end;

  end;
  --*********************************************************************************************************************
  function private.MillsGetNumber ( number )

    for i = 1, #private.mills.current_list do
      
      if ( private.mills.current_list[ i ] == number ) then

        return i;

      end;

    end;

    return 0;

  end;
  --*********************************************************************************************************************
  function private.MillsWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.mills.win = true;
      private.mills.current_list = private.mills.win_list;

      ng_global.progress[ "std" ][ "win_superpuzzle" ].mills = private.mills;

      private.MillsWinSet();

    end;

    ObjSet( "spr_superpuzzle_puzzle_2_1", { pos_x = -9 } );
    ObjAnimate( "spr_superpuzzle_puzzle_2_1", "pos_y", 0, 0, func_end, { 0,3,-205,  0.5,3,90 } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_tag", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.MillsWinSet ()

     ObjSet( "obj_superpuzzle_window_3_mills_parts",    { input = false } );

    if ( not private.items_done[ "puzzle_2_1" ] ) then

      ObjSet( "spr_superpuzzle_puzzle_2_1",              { input = true, pos_y = 90 } );
      ObjSet( "obj_superpuzzle_window_4_use_puzzle_2_1", { input = true } );
   
      ObjAttach( "spr_superpuzzle_puzzle_2_1", "obj_superpuzzle_window_3_crop" );

    end;
   
  end;
  --*********************************************************************************************************************
  function private.MillsResetSet ()

    private.mills.current_list = { 2, 3, 4, 1 };
    private.mills.win = false;

    private.mills_prev_name = "";
    
    ng_global.progress[ "std" ][ "win_superpuzzle" ].mills = private.mills;

    ObjSet( "spr_superpuzzle_puzzle_2_1", { alp = 1, pos_y = -205, input = false } );
    ObjSet( "obj_superpuzzle_window_4_use_puzzle_2_1", { input = false } );

    ObjAttach( "spr_superpuzzle_puzzle_2_1", "obj_superpuzzle_window_3_crop" );

    for i = 1, #private.mills.current_list do
      
      local ang = private.mills.ang[ i ];      
      ObjSet( "obj_superpuzzle_element_mills_"..private.mills.current_list[ i ], { ang = ang } );    

    end;

  end;
--*********************************************************************************************************************
-- function *** Mmg Owl ***() end
--*********************************************************************************************************************
  function private.OwlClick ( number )

    if ( private.sky_state == "sun") then

      return;

    end;

    local index = private.OwlGetIndex( number );
    local index_empty = private.OwlGetEmpty( index );

    if ( index_empty ) then

      common_impl.Lock( true );

      local name = "spr_superpuzzle_puzzle_"..number;

      local obj = ObjGet( name );

      local ind_i = index_empty[ 1 ];
      local ind_j = index_empty[ 2 ];

      local pos_x_new = private.owl.pos[ ind_i ][ ind_j ][ 1 ];
      local pos_y_new = private.owl.pos[ ind_i ][ ind_j ][ 2 ];

      local func_end = function ()

        private.OwlClickEnd( index, index_empty );

      end;

      ObjAnimate( name, "pos_xy", 0, 0, func_end, 
      { 
        0,   3, obj.pos_x, obj.pos_y, 
        0.2, 3, pos_x_new, pos_y_new
      } );

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_tag_move", 0, "", 0 );

    end;

  end;
  --*********************************************************************************************************************
  function private.OwlClickEnd ( index, index_new )
    
    common_impl.Lock( false );

    private.owl.current_list[ index[1]     ][ index[2] ],
    private.owl.current_list[ index_new[1] ][ index_new[2] ] =

    private.owl.current_list[ index_new[1] ][ index_new[2] ],
    private.owl.current_list[ index[1]     ][ index[2] ];

    local flag_win = true;

    for i = 1, 3 do
    
      for j = 1, 3 do
          
        if ( private.owl.current_list[ i ][ j ] ~= private.owl.win_list[ i ][ j ] ) then

          flag_win = false;
          break;

        end;

      end;
    
    end;

    if ( flag_win ) then

      private.OwlWinAnim();

    else

      ng_global.progress[ "std" ][ "win_superpuzzle" ].owl = private.owl;

    end;

  end;
  --*********************************************************************************************************************
  function private.OwlGetIndex ( number )

    for i = 1, 3 do
    
      for j = 1, 3 do
          
        if ( private.owl.current_list[ i ][ j ] == number ) then

          return { i, j };

        end;

      end;
    
    end;

  end;
  --*********************************************************************************************************************
  function private.OwlGetEmpty ( index )

    local offset = { { -1, 0 }, { 1, 0 }, { 0, -1 }, { 0, 1 } };

    for i = 1, #offset do
      
      local i_cur = index[ 1 ] + offset[ i ][ 1 ];
      local j_cur = index[ 2 ] + offset[ i ][ 2 ];

      if ( i_cur > 0 ) and ( i_cur <= 3 ) and 
         ( j_cur > 0 ) and ( j_cur <= 3 ) and
         ( private.owl.current_list[ i_cur ][ j_cur ] == 0 ) then

        return { i_cur, j_cur };

      end;

    end;

    return false;

  end;
  --*********************************************************************************************************************
  function private.OwlWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.owl.win = true;

      ng_global.progress[ "std" ][ "win_superpuzzle" ].owl = private.owl;

      private.OwlWinSet();

    end;

    ObjAnimate( "obj_superpuzzle_window_4_puzzles", "alp", 0, 0, "", 
    { 
      0,   3, 1,  
      0.5, 3, 0 
    } );    

    ObjAnimate( "spr_superpuzzle_owl", "alp", 0, 0, func_end, 
    { 
      0,   3, 0,  
      0.5, 3, 1 
    } );   

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_tag_win", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.OwlWinSet ()

    ObjSet( "obj_superpuzzle_window_4_puzzles", { visible = false, input = false } );
      
    if ( not private.items_done[ "owl" ] ) then

      ObjSet( "spr_superpuzzle_owl", { alp = 1, input = true } );

    end;

  end;
  --*********************************************************************************************************************
  function private.OwlResetSet ()

    private.owl.current_list = { 
      { 4, 1, 3 }, 
      { 0, 2, 5 }, 
      { 6, 7, 8 } 
    };

    private.owl.win = false;

    ng_global.progress[ "std" ][ "win_superpuzzle" ].owl = private.owl;

    ObjSet( "obj_superpuzzle_window_4_puzzles", { visible = true, alp = 1 } );
    ObjSet( "spr_superpuzzle_owl",              { alp = 0, input = false } );

    for i = 1, 3 do
    
      for j = 1, 3 do
          
        local pos = private.owl.pos[ i ][ j ];
        local number = private.owl.current_list[ i ][ j ];
      
        ObjSet( "spr_superpuzzle_puzzle_"..number, { pos_x = pos[ 1 ], pos_y = pos[ 2 ] } );

      end;
    
    end;

  end;
--*********************************************************************************************************************
-- function *** Mmg Picture ***() end
--*********************************************************************************************************************
  function private.PictureClick ( number )

    common_impl.Lock( true );

    local old_number = private.picture.current_list[ number ];
    local new_number = private.picture.current_list[ number ] + 1;

    if ( new_number > 3 ) then

      new_number = 1;
    
    end;

    local old_name = "spr_superpuzzle_picture_"..number.."_"..old_number;
    local new_name = "spr_superpuzzle_picture_"..number.."_"..new_number;

    local func_end = function ()

      private.PictureClickEnd( number );

    end;

    ObjAnimate( old_name, "scale_y", 0, 0, "", 
    { 
      0,   3, 1,  
      0.2, 3, 0 
    } );

    ObjAnimate( new_name, "scale_y", 0, 0, func_end, 
    { 
      0,   3, 0,  
      0.2, 3, 0,
      0.4, 3, 1  
    } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_rotate", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.PictureClickEnd ( number )

    common_impl.Lock( false );

    private.picture.current_list[ number ] = private.picture.current_list[ number ] + 1;
    
    if ( private.picture.current_list[ number ] > 3 ) then

      private.picture.current_list[ number ] = 1;

    end;

    local flag_win = true;

    for i = 1, #private.picture.win_list do
      
      if ( private.picture.current_list[ i ] ~= private.picture.win_list[ i ] ) then

        flag_win = false;
        break;

      end;

    end;

    if ( flag_win ) then

      private.PictureWinAnim();

    else

      ng_global.progress[ "std" ][ "win_superpuzzle" ].picture = private.picture;

    end;

  end;
  --*********************************************************************************************************************
  function private.PictureWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.picture.win = true;

      ng_global.progress[ "std" ][ "win_superpuzzle" ].picture = private.picture;

      private.PictureWinSet();

    end;

    ObjAnimate( "spr_superpuzzle_door_1_1", "pos_x", 0, 0, "", 
    { 
      0,   3, -68,  
      0.5, 3, -200 
    } );    

    ObjAnimate( "spr_superpuzzle_door_1_2", "pos_x", 0, 0, func_end, 
    { 
      0,   3, 65,  
      0.5, 3, 200 
    } );   

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_rotate_win", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.PictureWinSet ()

    ObjSet( "obj_superpuzzle_window_5_weapons", { input = true } );
    ObjSet( "spr_superpuzzle_door_1_1",         { pos_x = -200 } );  
    ObjSet( "spr_superpuzzle_door_1_2",         { pos_x =  200 } );  

    ObjSet( "btn_superpuzzle_picture_1", { input = false } );  
    ObjSet( "btn_superpuzzle_picture_2", { input = false } );  
    ObjSet( "btn_superpuzzle_picture_3", { input = false } );  

    ObjSet( "obj_superpuzzle_window_5_click", { input = false } );  

    for i = 1,3 do
      
      for j = 1,3 do
        
        ObjSet( "spr_superpuzzle_picture_"..i.."_"..j, { scale_y = 0 } );

      end;

      ObjSet( "spr_superpuzzle_picture_"..i.."_"..private.picture.win_list[ i ], { scale_y = 1 } );

    end;

  end;
  --*********************************************************************************************************************
  function private.PictureResetSet ()

    private.picture.current_list = { 2, 3, 1 };
    private.picture.win = false;

    ng_global.progress[ "std" ][ "win_superpuzzle" ].picture = private.picture;

    ObjSet( "obj_superpuzzle_window_5_weapons", { input = false } );
    ObjSet( "spr_superpuzzle_door_1_1",         { pos_x = -68 } );  
    ObjSet( "spr_superpuzzle_door_1_2",         { pos_x =  65 } );  
    
    ObjSet( "obj_superpuzzle_window_5_click",   { input = true } );  
   
    for i = 1, 3 do
   
      for j = 1, 3 do 

        ObjSet( "spr_superpuzzle_picture_"..i.."_"..j, { scale_y = 0 } );

      end;

      ObjSet( "btn_superpuzzle_picture_"..i, { input = false } );
    
    end;

  end;
--*********************************************************************************************************************
-- function *** Mmg Weapons ***() end
--*********************************************************************************************************************
  function private.WeaponsClick ( name )

    local obj_name = "spr_superpuzzle_"..name;
   
    if ( private.weapons_prev_name == name ) then

      ObjSet( obj_name.."_light", { alp = 0 } );
      private.weapons_prev_name = "";

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_weapons_wrong", 0, "", 0 );

    elseif ( private.weapons_prev_name ~= "" ) then

      local name_1 = common.GetObjectPrefix( private.weapons_prev_name );
      local name_2 = common.GetObjectPrefix( name );
      local obj_name_prev = "spr_superpuzzle_"..private.weapons_prev_name;

      if ( name_1 == name_2 ) then

        local func_end = function ()

          private.WeaponsClickEnd( name_2 );

        end;

        common_impl.Lock( true );

        ObjAnimate( obj_name, "alp", 0, 0, "", 
        { 
          0,   3, 1,  
          0.4, 3, 0 
        } );

        ObjAnimate( obj_name_prev, "alp", 0, 0, func_end, 
        { 
          0,   3, 1,  
          0.4, 3, 0  
        } );

        common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_weapons_true", 0, "", 0 );

      else

        ObjSet( obj_name_prev.."_light", { alp = 0 } );

        common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_weapons_wrong", 0, "", 0 );

      end;

      private.weapons_prev_name = "";

    else

      ObjSet( obj_name.."_light", { alp = 0.94 } );
      private.weapons_prev_name = name;

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_weapons_select", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.WeaponsClickEnd ( name )

    common_impl.Lock( false );

    ObjSet( "spr_superpuzzle_"..name.."_1", { input = false } );
    ObjSet( "spr_superpuzzle_"..name.."_2", { input = false } );

    table.insert( private.weapons.done_list, name );

    private.weapons.pair_count = private.weapons.pair_count + 1;
    
    if ( private.weapons.pair_count == private.weapons.win_pair_count ) then

      private.WeaponsWinAnim();

    else

      ng_global.progress[ "std" ][ "win_superpuzzle" ].weapons = private.weapons;

    end;

  end;
  --*********************************************************************************************************************
  function private.WeaponsWinAnim ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      private.weapons.win = true;

      ng_global.progress[ "std" ][ "win_superpuzzle" ].weapons = private.weapons;

      private.WeaponsWinSet();

    end;

    ObjAnimate( "spr_superpuzzle_rifle_item", "pos_y", 0, 0, func_end, 
    { 
      0,   3, -200,  
      0.5, 3, 0 
    } );   

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_weapons_win", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.WeaponsWinSet ()

    ObjSet( "obj_superpuzzle_window_5_weapons", { visible = false, input = false } );

    if ( not private.items_done[ "rifle_item" ] ) then

      ObjSet( "obj_superpuzzle_window_2_use_rifle_item", { input = true } );
      ObjSet( "spr_superpuzzle_rifle_item",              { pos_y = 0, input = true } ); 

    end;
   
  end;
  --*********************************************************************************************************************
  function private.WeaponsResetSet ()

    private.weapons.pair_count = 0;
    private.weapons.done_list = {};
    private.weapons.win = false;
    private.weapons_prev_name = "";

    ng_global.progress[ "std" ][ "win_superpuzzle" ].weapons = private.weapons;

    ObjSet( "obj_superpuzzle_window_5_weapons",        { visible = true, input = false } );
    ObjSet( "obj_superpuzzle_window_2_use_rifle_item", { input = false } );
    ObjSet( "spr_superpuzzle_rifle_item",              { pos_y = -200, input = false } ); 

    for i = 1, #private.weapons_list do
   
      ObjSet( "spr_superpuzzle_"..private.weapons_list[ i ], { input = true, alp = 1 } );
      ObjSet( "spr_superpuzzle_"..private.weapons_list[ i ].."_light", { alp = 0 } );
    
    end;

  end;
  --*********************************************************************************************************************
  function private.WeaponsDoorClk ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

    end;

    ObjAnimate( "spr_superpuzzle_door_1_1", "pos_x", 0, 0, "", 
    { 
      0,   3, -68,  
      0.2, 3, -75,
      0.4, 3, -68 
    } );    

    ObjAnimate( "spr_superpuzzle_door_1_2", "pos_x", 0, 0, func_end, 
    { 
      0,   3, 65,  
      0.2, 3, 75,
      0.4, 3, 65 
    } );  

  end;
--*********************************************************************************************************************
-- function *** INFO ***() end
--*********************************************************************************************************************
  function public.GetInfo ()

    local postfix;

    if ( not private.rope.win )                         then postfix = "1_1";
    elseif ( not private.items_done[ "ax" ] )           then postfix = "1_2";
    elseif ( not private.items_done[ "bridge" ] )       then postfix = "1_3";
    elseif ( not private.prison.win )                   then postfix = "1_4";
    elseif ( not private.mills.win )                    then postfix = "1_5";
    elseif ( not private.items_done[ "little_man" ] )   then postfix = "1_6";
    elseif ( not private.owl.win )                      then postfix = "1_7";
    elseif ( not private.items_done[ "owl" ] )          then postfix = "1_8";
    elseif ( not private.picture.win )                  then postfix = "1_9";
    elseif ( not private.weapons.win )                  then postfix = "1_10";
    elseif ( not private.items_done[ "rifle_item" ] )   then postfix = "1_11";
    end;

    return postfix;

  end;
--*********************************************************************************************************************
-- function *** Zoom ***() end
--*********************************************************************************************************************
  function private.ZoomScene ( func_end, anim_name, extra_anim, func_after_zoom_in )

    common_impl.Lock( true );

    local scale = 1.3;

    local func_step_3 = function ()

      common_impl.Lock( false );

      if ( func_end ) then

        func_end();

      end;

    end;

    local func_step_2 = function ()

      ObjAnimate( "mg_superpuzzle", "scale_xy", 0, 0, func_step_3, { 
        0.0, 3, scale, scale, 
        0.5, 3,     1,     1  
      } );

      ObjAnimate( "mg_superpuzzle", "pos_xy", 0, 0, "", { 
        0.0, 3, -150, -130,
        0.5, 3,    0,    0  
      } );

      common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_out", 0, "", 0 );

    end;  

    local func_step_1 = function ()

      if ( anim_name ) then

        AnimPlay( anim_name, "DoAnim", func_step_2 );

        if ( extra_anim == "unknown" ) then

          ObjAnimate( "spr_superpuzzle_unknown", "pos_x", 0, 0, "", { 
            0.0,   3, 220,  
            4.0,   3, 220,  
            4.5,   3, 143
          } );

        end;

        if ( func_after_zoom_in ) then

          func_after_zoom_in();

        end;

      else

        ObjAnimate( "mg_superpuzzle", "scale_xy", 0, 0, func_step_2, { 
          0,   3, scale, scale,  
          2.0, 3, scale, scale
        } );

      end;

    end;  

    ObjAnimate( "mg_superpuzzle", "scale_xy", 0, 0, func_step_1, { 
      0,   3,     1,     1,  
      0.5, 3, scale, scale
    } );


    ObjAnimate( "mg_superpuzzle", "pos_xy", 0, 0, "", { 
      0,   3,    0,    0,  
      0.5, 3, -150, -130
    } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_in", 0, "", 0 );

  end;
--*********************************************************************************************************************
-- function *** Animations ***() end
--*********************************************************************************************************************
  function private.Animations ()

    ObjAnimate( "spr_superpuzzle_light", "alp", 1, 0, "", { 0,3,1,  0.8,3,0.5,  1.5,3,0.7,  2.2,3,1 } );

    for c = 1, 7 do
      
      ObjAnimate( "spr_superpuzzle_cogwheel_"..c, "ang", 1, 0, "", { 0,0,0,   13,0, ( math.pow ( -1, c) * 6.28 ) } );

    end;

  end;
--*********************************************************************************************************************