-- name=level1

function public.Start ( param )

  --interface.WidgetAdd( InterfaceWidget_Pause, 10000000 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 12 );

  if IsCollectorsEdition() then
    interface.WidgetAdd( InterfaceWidget_BtnGuide, 13 );

  end;


  interface.WidgetAdd( InterfaceWidget_BtnHint, 9  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 10 );

  interface.WidgetAdd( InterfaceWidget_Effects, 11 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 7 );

  interface.WidgetAdd( InterfaceWidget_DialogHo );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8);

  interface.WidgetAdd( InterfaceWidget_ItemPanel );
  interface.WidgetAdd( InterfaceWidget_Popup );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 31 );
  interface.WidgetAdd( InterfaceWidget_Dialog);

  interface.WidgetAdd( InterfaceWidget_DialogVideo );
  interface.WidgetAdd( InterfaceWidget_DialogStory );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 8 );
  if (tostring(GetPlatform())~= "ios") then
    interface.WidgetAdd( InterfaceWidget_StrategyGuide );
  end;
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial );

  interface.WidgetAdd( InterfaceWidget_Map, 26  );

  interface.PanelNotificationAdd();
  interface.DeployInvAdd( 9 );
  interface.DialogHintAdd();
  interface.PanelProvideAdd( 10 );
  interface.BtnProvideAdd( 0 );
  interface.EvidenceAdd( 18 );
  interface.DialogEvidenceAdd( 20 );
  interface.InvestigationButtonAdd( 17 ); 
  interface.SliderAdd( -1 );
  interface.ProvideAdd( 8 );
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );  
  interface.DiaryAdd( 28 );
  interface.ProvideEyeAdd( 30 );
  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then


    interface.BtnCollectibles2Add( 25 );
    interface.BtnCollectiblesAdd( 25 );
    interface.AchievementsAdd( 25 );
    interface.BtnMorphAdd( 25 );

  end;

  private.Init();

  ModLoad( "assets/levels/level1/mod_level1_inv" );
  level1_inv.Init();

  common.LevelLoad( "level1", "std", "rm_pier", param, private.menu_moduls );

  common_impl.Collectibles2CoinsLoad();
  common_impl.UpdatePerformanceMode();


  private.TutorialSetParams();
  interface.KeyUpdate();

  event_show_investigation = "get_evidence_1_1";
  interface.InvestigationButtonCheck();

  if ( cmn.IsEventDone( "dlg_fork_ancient" ) ) then
    interface.PanelProvideShow();
  end

end;
    
function private.Init ()

  game = {};
  game.room_names =
  {
     "rm_pier"
    ,"ho_stock"
    ,"rm_fork"
    ,"rm_square"
    ,"rm_livingroom"
    ,"mg_uppershelf"
    ,"rm_office"
    ,"rm_basement"
    ,"mg_safe"
    ,"ho_search"
    ,"rm_abandoneddistrict"
    ,"ho_trash"
    ,"mg_superpuzzle"
    --    ,"rm_demo"
  };

  game.progress_names_room =
  {
   { "beg_level1" }
  ,{ "see_intro" }
  ,{ "opn_pier" }
  ,{ "get_collect_item_1_1" }
  ,{ "get_collect_morph_item_1_1" }
  ,{ "get_elf",                                   "rm_pier",              { "opn_pier" } }
  ,{ "use_elf_1",                                 "rm_pier",              { "get_elf" } }
  ,{ "get_hoisthandle",                           "rm_pier",              { "use_elf_1" } }
  ,{ "get_oilcan",                                "rm_pier",              { "opn_pier" } }
  ,{ "use_oilcan_1",                              "rm_pier",              { "get_oilcan" } }
  ,{ "clk_heck",                                  "rm_pier",              { "use_oilcan_1" } }
  ,{ "use_hoisthandle",                           "rm_pier",              { "clk_heck" } }
  ,{ "clk_hoisthandle",                           "rm_pier",              { "use_hoisthandle" } }
  ,{ "opn_stock",                                 "rm_pier",              { "clk_hoisthandle" } }
  ,{ "win_stock",                                 "rm_pier",              { "clk_hoisthandle" } }
  ,{ "use_oilcan_2" }
  ,{ "get_workinggasolinesaw" }
  ,{ "get_emblemelement1",                        "rm_pier",              { "opn_pier" } }  
  ,{ "get_corkscrew",                             "rm_pier",              { "opn_pier" } }
  ,{ "use_workinggasolinesaw",                    "rm_pier",              { "get_workinggasolinesaw" } }
  ,{ "opn_fork",                                  "rm_pier",              { "use_workinggasolinesaw" } }
  ,{ "get_collect_morph_item_1_2" }
  ,{ "vid_fork_ancient",                          "rm_fork",              { "opn_fork" } }
  ,{ "dlg_fork_ancient",                          "rm_fork",              { "vid_fork_ancient" } }
  ,{ "clk_fork_providence_1",                     "rm_fork",              { "dlg_fork_ancient" } }
  ,{ "clk_fork_providence_2",                     "rm_fork",              { "dlg_fork_ancient" } }
  ,{ "clk_fork_providence_3",                     "rm_fork",              { "dlg_fork_ancient" } }
  ,{ "vid_fork_providence",                       "rm_fork",              { "clk_fork_providence_1", "clk_fork_providence_2", "clk_fork_providence_3" } }
  ,{ "clk_shore",                                 "rm_fork",              { "vid_fork_providence" } }
  ,{ "get_object_1_silhouette" }--никогда не выполнится
  ,{ "get_object_1",                              "rm_fork",              { "clk_shore" } }
  ,{ "get_boards",                                "rm_fork",              { "clk_shore" } }
  ,{ "clk_alligator",                             "rm_fork",              { "get_boards" } }
  ,{ "use_boards",                                "rm_fork",              { "get_boards" } }

  ,{ "opn_square",                                "rm_fork",              { "use_boards" } }
  ,{ "get_collect_morph_item_1_3" }
  ,{ "dlg_square_mother_1",                       "rm_square",            { "opn_square" } }
  ,{ "get_evidence_1_1" }--poster
  ,{ "opn_livingroom",                            "rm_square",            { "dlg_square_mother_1" } }
  ,{ "get_collect_morph_item_1_4" }
  ,{ "clk_livingroom_providence_1",               "rm_livingroom",        { "opn_livingroom" } }
  ,{ "clk_livingroom_providence_2",               "rm_livingroom",        { "opn_livingroom" } }
  ,{ "clk_livingroom_providence_3",               "rm_livingroom",        { "opn_livingroom" } }
  ,{ "use_livingroom_providence_invitem_1",       "rm_livingroom",        { "get_object_1", "opn_livingroom" } }
  ,{ "vid_livingroom_providence",                 "rm_livingroom",        { "use_livingroom_providence_invitem_1" } }
  ,{ "get_scissors",                              "rm_livingroom",        { "opn_livingroom" } }
  ,{ "use_scissors_1",                            "rm_fork",              { "get_scissors" } }
  ,{ "get_fishinghook",                           "rm_fork",              { "use_scissors_1" } }
  ,{ "use_fishinghook",                           "rm_livingroom",        { "get_fishinghook" } }
  ,{ "get_matches",                               "rm_livingroom",        { "use_fishinghook" } }
  ,{ "get_papercode",                             "rm_livingroom",        { "use_fishinghook" } }
  ,{ "use_papercode",                             "rm_square",            { "get_papercode" } }
  ,{ "win_garage",                                "rm_square",            { "use_papercode" } }
  ,{ "get_pyrotechinics",                         "rm_square",            { "win_garage" } }
  ,{ "use_pyrotechinics",                         "rm_fork",              { "get_pyrotechinics" } }
  ,{ "use_matches",                               "rm_fork",              { "use_pyrotechinics" } }
  ,{ "get_emblemelement2",                        "rm_fork",              { "use_matches" } }
  ,{ "get_hammer",                                "rm_fork",              { "use_matches" } }
  ,{ "clk_jacket",                                "rm_livingroom",        { "vid_livingroom_providence" } }
  ,{ "clk_books1",                                "rm_livingroom",        { "vid_livingroom_providence" } }
  ,{ "clk_books2",                                "rm_livingroom",        { "clk_books1" } }
  ,{ "clk_books3",                                "rm_livingroom",        { "clk_books2" } }
  ,{ "get_emblemelement3",                        "rm_livingroom",        { "clk_books3"} }
  ,{ "use_elf_2",                                 "rm_livingroom",        { "clk_books3", "use_elf_1" } }
  ,{ "get_evidence_1_2",                          "rm_livingroom",        { "use_elf_2" } }--hlor
  ,{ "use_emblemelement1",                        "rm_pier",              { "get_emblemelement1" } }
  ,{ "use_emblemelement2",                        "rm_pier",              { "get_emblemelement2" } }
  ,{ "use_emblemelement3",                        "rm_pier",              { "get_emblemelement3" } }
  ,{ "win_uppershelf",                            "rm_pier",              { "use_emblemelement1", "use_emblemelement2", "use_emblemelement3" } }
  ,{ "get_evidence_1_3",                          "rm_pier",              { "win_uppershelf" } }--diary
  ,{ "vid_evidence_1" }
  ,{ "dlg_square_mother_2",                       "rm_square",            { "vid_evidence_1" } }
  ,{ "get_officekey",                             "rm_pier",              { "dlg_square_mother_2" } }
  ,{ "use_officekey",                             "rm_livingroom",        { "get_officekey" } }
  ,{ "clk_officekey",                             "rm_livingroom",        { "use_officekey" } }
  ,{ "opn_office",                                "rm_livingroom",        { "clk_officekey" } }
  ,{ "get_prv_statuette_silhouette" }
  ,{ "get_prv_criminalsbag_silhouette" }
  ,{ "get_ruler",                                 "rm_office",            { "opn_office" } }
  ,{ "use_ruler",                                 "rm_livingroom",        { "get_ruler" } }
  ,{ "dlg_livingroom_george",                     "rm_livingroom",        { "use_ruler" } }
  ,{ "get_bag",                                   "rm_livingroom",        { "use_ruler" } }
  ,{ "get_zipperslider",                          "rm_livingroom",        { "use_ruler" } }
  ,{ "use_zipperslider" }
  ,{ "use_oilcan_3" }
  ,{ "clk_zipperslider" }
  ,{ "get_pliers" }
  ,{ "get_prv_statuette" }  
  ,{ "get_prv_criminalsbag" }  
  ,{ "clk_office_providence_1",                   "rm_office",            { "opn_office" } }
  ,{ "clk_office_providence_2",                   "rm_office",            { "get_prv_criminalsbag" } }
  ,{ "use_office_providence_invitem_2",           "rm_office",            { "get_prv_statuette" } }
  ,{ "use_office_providence_invitem_1",           "rm_office",            { "get_prv_statuette" } }
  ,{ "vid_office_providence",                     "rm_office",            { "clk_office_providence_1", "clk_office_providence_2", "use_office_providence_invitem_2", "use_office_providence_invitem_1"} }
  ,{ "win_mg_wall",                               "rm_office",            { "vid_office_providence"} }
  ,{ "get_collect_morph_item_1_5" }   
  ,{ "use_pliers",                                "rm_fork",              { "get_pliers" } }
  ,{ "get_ring",                                  "rm_fork",              { "use_pliers" } }
  ,{ "use_ring",                                  "rm_office",            { "get_ring", "win_mg_wall" } }
  ,{ "clk_floor_ring",                            "rm_office",            { "use_ring" } }  
  ,{ "opn_basement",                              "rm_office",            { "clk_floor_ring" } }
  ,{ "get_collect_morph_item_1_6" }
  ,{ "get_collect_item_1_2" }
  ,{ "clk_providence_basement" } 
  ,{ "get_scythe",                                "rm_basement",          { "opn_basement" } }
  
  ,{ "get_evidence_1_4",                          "rm_basement",          { "opn_basement" } }
  ,{ "clk_rag",                                   "rm_basement",          { "opn_basement" } }
  ,{ "win_safe",                                  "rm_basement",          { "clk_rag" } }
  ,{ "get_chestpiece",                            "rm_basement",          { "win_safe" } }
  ,{ "get_pictureframe",                          "rm_basement",          { "win_safe" } }
  ,{ "use_chestpiece",                            "rm_office",            { "get_chestpiece" } }
  ,{ "win_chest",                                 "rm_office",            { "use_chestpiece" } }
  ,{ "get_briefcasekey",                          "rm_office",            { "win_chest" } }
  ,{ "use_scythe",                                "rm_fork",              { "get_scythe" } }
  ,{ "get_handle",                                "rm_fork",              { "use_scythe" } }
  ,{ "use_scissors_2",                            "rm_fork",              { "use_scythe" } }  
  ,{ "get_brokenspade",                           "rm_fork",              { "use_scissors_2" } }
  ,{ "use_briefcasekey",                          "rm_fork",              { "get_briefcasekey" } }
  ,{ "get_screwdriver",                           "rm_fork",              { "use_briefcasekey" } }
  ,{ "get_nails",                                 "rm_fork",              { "use_briefcasekey" } }
  ,{ "use_handle" }
  ,{ "use_nails" }
  ,{ "use_hammer" }
  ,{ "get_spade" }
  ,{ "use_spade",                                 "rm_fork",              { "get_spade" } }
  ,{ "clk_box",                                   "rm_fork",              { "use_spade" } }
  ,{ "clk_dictaphone",                            "rm_fork",              { "clk_box" } }
  ,{ "get_cassette",                              "rm_fork",              { "clk_dictaphone" } }
  ,{ "use_screwdriver_1",                         "rm_livingroom",        { "get_screwdriver" } }
  ,{ "get_batteries",                             "rm_livingroom",        { "use_screwdriver_1" } }
  ,{ "use_batteries",                             "rm_basement",          { "get_batteries" } }
  ,{ "use_cassette",                              "rm_basement",          { "get_cassette" } }
  ,{ "clk_cassette",                              "rm_basement",          { "use_cassette" } }
  ,{ "clk_button_on",                             "rm_basement",          { "clk_cassette" } }
  ,{ "opn_casette_tape",                          "rm_basement",          { "clk_button_on" } }
  ,{ "get_evidence_1_5",                          "rm_basement",          { "clk_button_on" } }
  ,{ "dlg_livingroom_search",                     "rm_livingroom",        { "get_evidence_1_5" } }
  ,{ "opn_search",                                "rm_livingroom",        { "dlg_livingroom_search" } }
  ,{ "win_search",                                "rm_livingroom",        { "dlg_livingroom_search" } }
  ,{ "use_picture"}
  ,{ "get_evidence_1_6" }
  ,{ "vid_evidence_2" }
  ,{ "dlg_square_after_search",                   "rm_square",            { "vid_evidence_2" } }
  ,{ "vid_square_comeback",                       "rm_square",            { "dlg_square_after_search" } }
  ,{ "dlg_square_sheriff",                        "rm_square",            { "vid_square_comeback" } }
  ,{ "opn_abandoneddistrict",                     "rm_square",            { "dlg_square_sheriff" } }
  ,{ "get_collect_morph_item_1_7" }
  ,{ "clk_lantern_burned",                        "rm_abandoneddistrict", { "opn_abandoneddistrict" } }
  ,{ "get_prv_knife_silhouette" }
  ,{ "get_prv_hat_silhouette" }
  ,{ "get_collect_item_1_3" }
  ,{ "clk_abandoneddistrict_providence_1",        "rm_abandoneddistrict", { "opn_abandoneddistrict" } }
  ,{ "clk_abandoneddistrict_providence_2",        "rm_abandoneddistrict", { "opn_abandoneddistrict" } }
  ,{ "get_prv_knife",                             "rm_abandoneddistrict", { "opn_abandoneddistrict" } }
  ,{ "get_lantern",                               "rm_abandoneddistrict", { "opn_abandoneddistrict" } }
  ,{ "clk_open_lantern" }
  ,{ "use_matches_2" }
  ,{ "clk_close_lantern" }
  ,{ "get_litlantern" }
  ,{ "use_litlantern",                            "rm_abandoneddistrict", { "get_litlantern" } }
  ,{ "get_prv_hat",                               "rm_abandoneddistrict", { "use_litlantern" } }
  ,{ "use_abandoneddistrict_providence_invitem_1","rm_abandoneddistrict", { "get_prv_knife" } }
  ,{ "use_abandoneddistrict_providence_invitem_2","rm_abandoneddistrict", { "get_prv_hat" } }
  ,{ "vid_abandoneddistrict_providence",          "rm_abandoneddistrict", { "use_abandoneddistrict_providence_invitem_1", "use_abandoneddistrict_providence_invitem_2"} }
  ,{ "opn_trash",                                 "rm_abandoneddistrict", { "vid_abandoneddistrict_providence" } }
  ,{ "win_trash",                                 "rm_abandoneddistrict", { "vid_abandoneddistrict_providence" } }
  ,{ "clk_shutter",                               "rm_abandoneddistrict", { "get_prv_hat" } }
  ,{ "use_attractionlevel",                       "rm_abandoneddistrict", { "clk_shutter" } }
  ,{ "get_button",                                "rm_abandoneddistrict", { "use_attractionlevel" } }
  ,{ "get_monogram",                              "rm_abandoneddistrict", { "use_attractionlevel" } }
  ,{ "opn_zoom_armchair",                         "rm_livingroom",        { "get_monogram" } }
  ,{ "use_button",                                "rm_livingroom",        { "get_button" } }
  ,{ "clk_button",                                "rm_livingroom",        { "use_button" } }
  ,{ "get_cryptex",                               "rm_livingroom",        { "clk_button" } }
  ,{ "win_cryptex" }
  ,{ "get_micronote" }
  ,{ "use_monogram",                              "rm_livingroom",        { "get_monogram" } }
  ,{ "get_clockhands",                            "rm_livingroom",        { "use_monogram" } }
  ,{ "get_brokenglasses",                         "rm_livingroom",        { "use_monogram" } }
  ,{ "use_screwdriver_3" }
  ,{ "get_lens1" }
  ,{ "use_clockhands",                            "rm_office",            { "get_clockhands" } }
  ,{ "win_setofdrawers",                          "rm_office",            { "use_clockhands" } }
  ,{ "get_figurine",                              "rm_office",            { "win_setofdrawers" } }
  ,{ "get_magnifier",                             "rm_office",            { "win_setofdrawers" } }
  ,{ "get_evidence_1_7",                          "rm_office",            { "win_setofdrawers" } }
  ,{ "use_screwdriver_4" }
  ,{ "get_lens2" }
  ,{ "use_lens1",                                 "rm_office",            { "get_lens1" } }
  ,{ "use_lens2",                                 "rm_office",            { "get_lens2" } }
  ,{ "use_micronote",                             "rm_office",            { "get_micronote" } }
  ,{ "get_evidence_1_8",                          "rm_office",            { "use_lens1", "use_lens2", "use_micronote" } }
  ,{ "use_figurine",                              "rm_abandoneddistrict", { "get_figurine" } }
  ,{ "win_superpuzzle",                           "rm_abandoneddistrict", { "use_figurine" } }
  ,{ "get_trunkemblem",                           "rm_abandoneddistrict", { "win_superpuzzle" } }
  ,{ "use_trunkemblem",                           "rm_abandoneddistrict", { "get_trunkemblem" } }
  ,{ "get_evidence_1_9",                          "rm_abandoneddistrict", { "use_trunkemblem" } }
  ,{ "vid_evidence_3" }
  ,{ "dlg_square_sem",                            "rm_square",            { "vid_evidence_3" } }
  ,{ "vid_square_oulmen",                         "rm_square",            { "dlg_square_sem" } }


  };

  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
  
  game.relations = {};

  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      "rm_collectibles2",
      "rm_collectibles",
      "rm_achievements",
    }
    for i = 1, #menu_moduls_ce do
      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );
    end;

  end;

  common_impl.CheckPrgRules();

end;

function private.TutorialSetParams()

if not ng_global.progress[ "std" ][ "see_tutorial" ] then

  ng_global.progress[ "std" ][ "see_tutorial" ] = {};
  ng_global.progress[ "std" ][ "see_tutorial" ].done  = 0;
  ng_global.progress[ "std" ][ "see_tutorial" ].start = 0;
  ng_global.progress[ "std" ][ "see_tutorial" ].state = {};
  ng_global.progress[ "std" ][ "see_tutorial" ].state.no  = 0;
  ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
  ng_global.progress[ "std" ][ "see_tutorial" ].func = function()
    --
  end;
    local offset = 0;

    if ( GetWideScreen() ) then

      offset = 0.5 * ( GetAppWidth() - 1024 );
      

    end;


      ng_global.progress[ "std" ][ "see_tutorial" ].state.pages = {

      [ "tutorial_page_1" ] = { shown = 0, noskip = true, posx = 512, posy = 200, arrows = {} } , -- Показать туториал? 

      [ "tutorial_page_2" ] = { shown = 0, noskip = false, posx = 512, posy = 170, arrows = { 
                                                                              { pos_x = 430, pos_y = 400, ang =  3.14 }
                                                                            } },   -- туториал на подбор пса

      [ "tutorial_page_3" ] = { shown = 0, noskip = false, posx = 512, posy = 100, arrows = { 
                                                                              { pos_x = 600, pos_y = 270, ang =  -2.3}
                                                                            } },   -- туториал на открытие зз
      [ "tutorial_page_4" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = 400, pos_y = 380, ang =  2.3},
                                                                              { pos_x = 0, pos_y = -100, ang =  -3.14, target = "inv_elf" }
                                                                            } },   -- туториал на примение
      [ "tutorial_page_5" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = 600, pos_y = 400, ang =  -2.3}
                                                                             --{ pos_x = 572, pos_y = 270, ang =  -2.3}
                                                                            } },   -- туториал на пилу в хо
      [ "tutorial_page_6" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              --{ pos_x = 512, pos_y = 500, ang =  3.14}
                                                                            } },   -- туториал предметы в хо
      [ "tutorial_page_7" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                               { pos_x = 0, pos_y = -100, ang =  3.14, target = "obj_stock_arrow_target" },
                                                                               { pos_x = 610, pos_y = 420, ang =  -2.3}
                                                                            } },   -- туториал на примене части пилы
      [ "tutorial_page_8" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = 0, pos_y = -100, ang =  3.14, target = "inv_gasolinesaw"  }
                                                                            } },   -- туториал на плюсовой объект
      [ "tutorial_page_9" ] = { shown = 0, noskip = true, posx = 512, posy = 400, arrows = { 
                                                                              --{ pos_x = 512, pos_y = 500, ang =  2.3 }
                                                                            } },   -- туториал на дедкцию
      [ "tutorial_page_10" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = -100, pos_y = 100, ang =  -0.8, target = "obj_int_investigation_button_back"  }
                                                                            } },   -- туториал на дедкцию
      [ "tutorial_page_11" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              --{ pos_x = 0, pos_y = -60, ang =  3.14 }
                                                                            } },   -- туториал на дедкцию
      [ "tutorial_page_12" ] = { shown = 0, noskip = true, posx = 760, posy = 500, arrows = { 
                                                                              { pos_x = 0, pos_y = -60, ang =  3.14, target = "obj_int_button_providence" }
                                                                            } },   -- туториал на открытие провид
      [ "tutorial_page_13" ] = { shown = 0, noskip = false, posx = 512, posy = 150, arrows = { 
                                                                              { pos_x = 0, pos_y = -60, ang =  3.14, target = "spr_fork_providence_plate" },
                                                                              { pos_x = 0, pos_y = -110, ang =  3.14, target = "spr_fork_providence_timber" },
                                                                              { pos_x = 0, pos_y = -60, ang =  3.14, target = "spr_fork_providence_bush" }
                                                                            } },   -- тутор в провид
      [ "tutorial_page_14" ] = { shown = 0, noskip = true, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = -50, pos_y = -60, ang =  3.14, target = "spr_int_panel_providence" },
                                                                            } },   -- туториал при открытии провидения после получения применяемого предмета  

      [ "tutorial_page_15" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = -60, pos_y = -60, ang =  -2.3, target = "obj_livingroom_providence_use_invitem_1" },
                                                                              { pos_x = 0, pos_y = -60, ang =  3.14, target = "inv_object_1" }
                                                                            } },   -- туториал при открытии провидения после получения применяемого предмета  
      [ "tutorial_page_18" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = 100, pos_y = 0, ang =  1.72, target = "spr_focus_arrow_right" },
                                                                              --{ pos_x = 100, pos_y = 0, ang =  1.72, target = "spr_focus_arrow_left" }
                                                                            } },   -- туториал на слайдер 
      [ "tutorial_page_19" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                            } },   -- туториал на хо

      [ "tutorial_page_20" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = 0, pos_y = -50, ang =  3.14, target = "itm_trash_dagger" }
                                                                            } },   -- туториал на подбор вишни

      [ "tutorial_page_21" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                              { pos_x = 0, pos_y = -80, ang =  3.14, target = "obj_trash_dagger" }
                                                                            } },   -- туториал на применение вишни
      [ "tutorial_page_22" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = { 
                                                                            } },  -- туториал на ассоциации в хо
      [ "tutorial_page_23" ] = { shown = 0, noskip = true, posx = 512, posy = 200, arrows = {
                                                                              { pos_x = 160, pos_y = -80, ang =  2.36, target = "obj_int_button_collectibles2" }
                                                                            } },  -- туториал на подбор монетки
      [ "tutorial_page_24" ] = { shown = 0, noskip = false, posx = 512, posy = 200, arrows = {
                                                                              { pos_x = 300, pos_y = 650, ang =  -3.14 }
                                                                            } }  -- туториал на  хо лвл3
   };
    --end;
  end;
end;
function Test ()
    
  local profiles = GetProfileList();

  local cheater = false;

  for i = 1, #profiles, 1 do

    if ( profiles[ i ] == "CHEATER" ) then

      cheater = true;

    end;

  end;

  AddProfile( "CHEATER" );
  SetCurrentProfile( "CHEATER" );

  if ( not cheater ) then

    ng_global.gamemode = 0;
    ng_global.currentprogress = "std";
    ng_global.progress = {};
    ng_global.progress[ "std" ] = {};
    ng_global.progress[ "std" ].common = {};
    ng_global.progress[ "std" ].common.hinttimer = 0;

    SaveProfiles();

  end;

end;
