-- name=level1_inv
--*********************************************************************************************************************
function public.Init ()

  if port.isPortable() == 1 then
    port.InventoryPopupInit("level1_inv_hub");
    port.VideoResizeInRoom("level1_inv");
  end;

  private.init_gasolinesaw();
  private.init_bag();
  private.brokenspade_init();
  private.pictureframe_init();
  private.lantern_init();
  private.cryptex_init();
  private.magnifier_init();
  private.brokenglasses_init();

  public.deploy_inventory = {
    { "brokenspade", { "use_nails", "use_handle", "use_hammer" }, "get_spade" },
    { "pictureframe", { "use_picture" }, "get_evidence_1_6" },
    { "lantern", { "use_matches_2", "clk_open_lantern", "clk_close_lantern" }, "get_litlantern" },
    { "cryptex", { "win_cryptex" }, "get_micronote" },
    { "magnifier", { "use_screwdriver_4" }, "get_lens2" },
    { "brokenglasses", { "use_screwdriver_3" }, "get_lens1" },
    { "gasolinesaw", { "use_oilcan_2" }, "get_workinggasolinesaw" },    
    { "bag", { "use_zipperslider", "use_oilcan_3", "clk_zipperslider" }, "get_prv_statuette" },
    { "bag", { "use_zipperslider", "use_oilcan_3", "clk_zipperslider" }, "get_pliers" },
  };
  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_level1_inv_deploy = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    common_impl.TurnChildGfx( {"level1_inv_deploy" }, "level1_inv_deploy", visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_level1_inv_deploy", update_game_mode_level1_inv_deploy, nil );

end;
--*********************************************************************************************************************
function private.StringDivide(string)  

  local table = {}
  local id = 1
  local il = 1
  for i = 1, string.len(string) do
    if string.sub(string,i,i) == "_" then
      table[id] = string.sub(string,il,i-1)
      il = i+1
      id = id + 1
    end
    if i == string.len(string) then
      table[id] = string.sub(string,il,i)
      il = i+1
      id = id + 1
    end
  end
  return table;

end;
--*********************************************************************************************************************
function private.ObjIntersectCheck( obj_to_apply, obj_to_check, obj_complex_inv )

  local obj_complex_inv = obj_complex_inv or "deploy_inv_"..private.StringDivide( obj_to_check )[2];  
  return interface.GetCurrentInv() == obj_complex_inv and ObjIntersect( obj_to_apply, obj_to_check );

end;
--*********************************************************************************************************************
-- function *** brokenspade *** () end;
--*********************************************************************************************************************
function private.brokenspade_init()

  -------------------------------------------------------------------------------------------
  common_impl.hint[ "get_spade" ] = {
      type = "get",
      get_obj = "obj_deploy_spade",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenspade",
      zz_gate = "inv_brokenspade"
  };
  function get_spade_inv ()

    interface.InventoryItemRemove( "inv_brokenspade" );
    interface.InventoryItemAdd( "inv_spade", "obj_deploy_spade" );
    ObjDelete( "gfx_deploy_spade" );

  end;
  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_spade", get_spade_inv );
  -------------------------------------------------------------------------------------------

  common_impl.hint[ "use_handle" ] = {
      type = "use",
      inv_obj = "inv_handle",
      use_place = "obj_brokenspade_use_handle",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenspade",
      zz_gate = "inv_brokenspade"
  };
  function use_handle_inv ()

    interface.InventoryItemRemove( "inv_handle" );

  end;
  function use_handle_inv_end ()

    ObjSet( "inv_brokenspade", { res = "assets/levels/level1/inv_deploy/inv_brokenspade/inv/inv_brokenspade_2" } );

  end;
  function use_handle_beg ()

    ObjDelete( "obj_brokenspade_use_handle" );

  end;
  function use_handle_end ()

    ObjSet( "obj_brokenspade_use_nails", { input = true, visible = true, active = true } );
    ObjSet( "spr_deploy_brokenspade_stick", { alp = 1, pos_x = 101, pos_y = -85 } );
    ObjSet( "spr_deploy_brokenspade_shadow", { alp = 1 } );

    if ( not cmn.IsEventDone( "get_nails" ) ) then 
       ObjSet( "spr_brokenspade_plus_light", { alp = 0 } );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_handle", use_handle_beg, "inv_brokenspade" );
  cmn.AddSubscriber( "use_handle", use_handle_inv );
  cmn.AddSubscriber( "use_handle", use_handle_inv_end );
  cmn.AddSubscriber( "use_handle", use_handle_end, "inv_brokenspade" );
  cmn.AddSubscriber( "use_handle_inv", use_handle_inv );
  cmn.AddSubscriber( "use_handle_inv_end", use_handle_inv_end );
  cmn.AddSubscriber( "use_handle_beg", use_handle_beg, "inv_brokenspade" );
  cmn.AddSubscriber( "use_handle_end", use_handle_end, "inv_brokenspade" );
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_nails" ] = {
      type = "use",
      inv_obj = "inv_nails",
      use_place = "obj_brokenspade_use_nails",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenspade",
      zz_gate = "inv_brokenspade"
  };
  function use_nails_inv ()

    interface.InventoryItemRemove( "inv_nails" );

  end;
  function use_nails_inv_end ()

    ObjSet( "inv_brokenspade", { res = "assets/levels/level1/inv_deploy/inv_brokenspade/inv/inv_brokenspade_3" } );

  end;

  function use_nails_beg ()

    ObjDelete( "obj_brokenspade_use_nails" );

  end;
  function use_nails_end ()

    ObjSet( "obj_brokenspade_use_hammer", { input = true, visible = true, active = true } );
    ObjSet( "spr_deploy_brokenspade_nail_1", { alp = 1 } );
    ObjSet( "spr_deploy_brokenspade_nail_2", { alp = 1 } );
 
     if ( not cmn.IsEventDone( "get_hammer" ) )  then
       ObjSet( "spr_brokenspade_plus_light", { alp = 0 } );
     end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_nails", use_nails_beg, "inv_brokenspade");
  cmn.AddSubscriber( "use_nails", use_nails_inv );
  cmn.AddSubscriber( "use_nails", use_nails_inv_end );
  cmn.AddSubscriber( "use_nails", use_nails_end, "inv_brokenspade" );
  cmn.AddSubscriber( "use_nails_inv", use_nails_inv );
  cmn.AddSubscriber( "use_nails_inv_end", use_nails_inv_end );
  cmn.AddSubscriber( "use_nails_beg", use_nails_beg, "inv_brokenspade" );
  cmn.AddSubscriber( "use_nails_end", use_nails_end, "inv_brokenspade" );
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hammer" ] = {
      type = "use",
      inv_obj = "inv_hammer",
      use_place = "obj_brokenspade_use_hammer",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenspade",
      zz_gate = "inv_brokenspade"
  };
  function use_hammer_inv ()

    interface.InventoryItemRemove( "inv_hammer" );
    
  end;
  function use_hammer_inv_end ()

    ObjSet( "inv_brokenspade", { res = "assets/levels/level1/inv_deploy/inv_brokenspade/inv/inv_spade" } );

  end;
  function use_hammer_beg ()

    ObjDelete( "obj_brokenspade_use_hammer" );

  end;
  function use_hammer_end ()

    ObjSet( "obj_deploy_spade", { input = true } );
    ObjSet( "spr_deploy_brokenspade_nail_1", { pos_x = 39, pos_y = -38 } );
    ObjSet( "spr_deploy_brokenspade_nail_2", { pos_x = 81, pos_y = -65 } );
    ObjSet( "gfx_deploy_spade", { active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hammer", use_hammer_beg, "inv_brokenspade" );
  cmn.AddSubscriber( "use_hammer", use_hammer_inv );
  cmn.AddSubscriber( "use_hammer", use_hammer_inv_end );
  cmn.AddSubscriber( "use_hammer", use_hammer_end, "inv_brokenspade" );
  cmn.AddSubscriber( "use_hammer_inv", use_hammer_inv );
  cmn.AddSubscriber( "use_hammer_inv_end", use_hammer_inv_end );
  cmn.AddSubscriber( "use_hammer_beg", use_hammer_beg, "inv_brokenspade" );
  cmn.AddSubscriber( "use_hammer_end", use_hammer_end, "inv_brokenspade" );
  --------------------------------------------------------------------------------------------
  ObjSet( "obj_deploy_spade", { event_mdown = level1_inv.get_spade });
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.use_handle()

  local item = "inv_handle";

  if (  private.ObjIntersectCheck( item, "obj_brokenspade_use_handle" ) )  then

    cmn.CallEventHandler( "use_handle_inv" );
    cmn.CallEventHandler( "use_handle_beg", "inv_brokenspade" );

    local func_end = function ()

      common_impl.Lock(false);

      cmn.SetEventDone( "use_handle" );
      cmn.CallEventHandler( "use_handle_end", "inv_brokenspade" );
      cmn.CallEventHandler( "use_handle_inv_end" );
    
    end;

    common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_shovel_stick", 0, "", 0 );

      ObjAnimate( "spr_deploy_brokenspade_stick", "alp", 0, 0, "",
    { 
      0.0, 0, 0, 
      0.3, 0, 1
    } );

     ObjAnimate( "spr_deploy_brokenspade_stick", "pos_xy", 0, 0, func_end,
    { 
      0.0, 0, 196,-150, 
      0.3, 0, 196, -150,
      0.7, 0, 101,-85
    } );


  else
    
    --WrongApply();  

  end;

end;
--*********************************************************************************************************************

function public.use_nails()

  local item = "inv_nails";

  if ( cmn.IsEventDone( "use_handle" ) and private.ObjIntersectCheck( item, "obj_brokenspade_use_nails" ))  then

    cmn.CallEventHandler( "use_nails_beg", "inv_brokenspade" );
    cmn.CallEventHandler( "use_nails_inv" );

    local func_end = function ()

      common_impl.Lock(false);

      cmn.SetEventDone( "use_nails" );
      cmn.CallEventHandler( "use_nails_end", "inv_brokenspade" );
      cmn.CallEventHandler( "use_nails_inv_end" );
    
    end;

    common_impl.Lock(true);

     common_impl.PlayAudio( "sfx", "common/audio/aud_shovel_nails", 0, "", 0 );

     ObjAnimate( "spr_deploy_brokenspade_nail_1", "alp", 0, 0, "",
    { 
      0.0, 0, 0, 
      0.3, 0, 1
    } );

    ObjAnimate( "spr_deploy_brokenspade_nail_2", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0, 
      0.3, 0, 0,
      0.6, 0, 1
    } );

  else
    
    --WrongApply();  

  end;

end;
--*********************************************************************************************************************
function public.use_hammer()

  local item = "inv_hammer";

  if ( cmn.IsEventDone( "use_nails" ) and private.ObjIntersectCheck( item, "obj_brokenspade_use_hammer" ) )  then

    cmn.CallEventHandler( "use_hammer_beg", "inv_brokenspade" );
    cmn.CallEventHandler( "use_hammer_inv" );

    local func_end = function ()

      common_impl.Lock(false);
      
      cmn.SetEventDone( "use_hammer" );
      cmn.CallEventHandler( "use_hammer_end", "inv_brokenspade" );
      cmn.CallEventHandler( "use_hammer_inv_end" );
    
    end;


     common_impl.Lock(true);

     common_impl.PlayAudio( "sfx", "common/audio/aud_shovel_hammer", 0, "", 0 );

     ObjAnimate( "spr_deploy_brokenspade_hammer", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0, 
      0.3, 0, 1,
      2.0, 0, 1,
      2.1, 0, 0
    } );

    ObjAnimate( "spr_deploy_brokenspade_hammer", "ang", 0, 0, "",
    { 
      0.0, 0, -0.08, 
      0.3, 0, -0.08,
      0.5, 0, -0.19,
      0.7, 0, 0.12,
      0.9, 0, -0.08,
      1.5, 0, -0.08,
      1.7, 0, -0.19,
      1.9, 0, 0.15,
      2.1, 0, -0.08
    } );

    ObjAnimate( "spr_deploy_brokenspade_hammer", "pos_xy", 0, 0, "",
    { 
      0.0, 0, -52, -21, 
      0.3, 0, -52, -21,
      0.5, 0, -52, -21,
      0.7, 0, -52, -21,
      0.9, 0, -52, -21,
      1.5, 0, -7, -47,
      1.7, 0, -7, -47,
      1.9, 0, -7, -47,
      2.1, 0, -7, -47
    } );

     ObjAnimate( "spr_deploy_brokenspade_nail_1", "pos_xy", 0, 0, "",
    { 
      0.0, 0, 34, -42, 
      0.5, 0, 34, -42,
      0.7, 0, 39, -38
    } );

    ObjAnimate( "spr_deploy_brokenspade_nail_2", "pos_xy", 0, 0, "",
    { 
      0.0, 0, 77, -69, 
      1.7, 0, 77, -69,
      1.9, 0, 81, -65
    } );

  else
    
    --WrongApply();  

  end;

end;
--*********************************************************************************************************************

--*********************************************************************************************************************
function public.get_spade()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_spade" );
  cmn.CallEventHandler( "get_spade", "inv_brokenspade" );
  common_impl.HideDeployInv();

end;
--*********************************************************************************************************************
-- function *** pictureframe *** () end;
--*********************************************************************************************************************
function private.pictureframe_init()
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_evidence_1_6" ] = {
      type = "get",
      get_obj = "obj_pictureframe_picture",
      room = "int_deploy_inv",
      zz = "deploy_inv_pictureframe",
      zz_gate = "inv_pictureframe"
  };
  -------------------------------------------------------------------------------------------
  function get_evidence_1_6_inv()

    interface.InventoryItemRemove( "inv_pictureframe" );
    --interface.InventoryItemAdd( "inv_dcn_framedpicture", "obj_pictureframe_picture" );
    ObjDelete( "gfx_deploy_picture" );

  end;
  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_evidence_1_6", get_evidence_1_6_inv );
   --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_picture" ] = {
      type = "use",
      inv_obj = "inv_picture",
      use_place = "obj_pictureframe_use_picture",
      room = "int_deploy_inv",
      zz = "deploy_inv_pictureframe",
      zz_gate = "inv_pictureframe"
  };
  function use_picture_inv ()

    interface.InventoryItemRemove( "inv_picture" );

  end;
  function use_picture_beg ()

    ObjDelete( "obj_pictureframe_use_picture" );

  end;
  function use_picture_end ()

    ObjSet( "spr_deploy_dcn_framedpicture", { alp = 1 } );
    ObjDelete( "spr_deploy_pictureframe_after" );
    ObjSet( "obj_pictureframe_picture", { input = true } );
    ObjSet( "gfx_deploy_picture", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_picture", use_picture_beg, "inv_pictureframe" );
  cmn.AddSubscriber( "use_picture", use_picture_inv );
  cmn.AddSubscriber( "use_picture", use_picture_end, "inv_pictureframe" );
  cmn.AddSubscriber( "use_picture_inv", use_picture_inv );
  cmn.AddSubscriber( "use_picture_beg", use_picture_beg, "inv_pictureframe" );
  cmn.AddSubscriber( "use_picture_end", use_picture_end, "inv_pictureframe" );
  --------------------------------------------------------------------------------------------
  ObjSet( "obj_pictureframe_picture", { event_mdown = level1_inv.get_evidence_1_6 });
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.use_picture()

  local item = "inv_picture";

  if (  private.ObjIntersectCheck( item, "obj_pictureframe_use_picture" ) )  then

    cmn.CallEventHandler( "use_picture_inv" );
    cmn.CallEventHandler( "use_picture_beg", "inv_pictureframe" );

    local func_end = function ()
      
      common_impl.Lock(false);

      cmn.SetEventDone( "use_picture" );
      cmn.CallEventHandler( "use_picture_end", "inv_pictureframe" );
    
    end;

    common_impl.Lock(true);  

    common_impl.PlayAudio( "sfx", "common/audio/aud_frame_picture", 0, "", 0 );

    ObjAnimate( "spr_deploy_dcn_framedpicture", "alp", 0, 0, func_end, { 0,0,0, 0.3,0,1 } );  

  else
    
    --WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.get_evidence_1_6()

  if ( not cmn.IsEventDone( "get_evidence_1_6" ) ) then

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    interface.InvestigationButtonItemAdd( "evidence_1_6", "obj_pictureframe_picture" );

    cmn.SetEventDone( "get_evidence_1_6" );
    cmn.CallEventHandler( "get_evidence_1_6", "inv_pictureframe" );

    ObjDelete( "obj_pictureframe_picture" );

    common_impl.HideDeployInv();

  end;

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** lantern *** () end;
--*********************************************************************************************************************
function private.lantern_init()
 
  -------------------------------------------------------------------------------------------
  common_impl.hint[ "get_litlantern" ] = {
      type = "get",
      get_obj = "spr_deploy_lantern",
      room = "int_deploy_inv",
      zz = "deploy_inv_lantern",
      zz_gate = "inv_lantern"
  };
  function get_litlantern_inv()

    interface.InventoryItemRemove( "inv_lantern" );
    interface.InventoryItemAdd( "inv_litlantern", "spr_deploy_lantern" );

  end;

  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_litlantern", get_litlantern_inv );
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_matches_2" ] = {
      type = "use",
      inv_obj = "inv_matches",
      use_place = "obj_deploy_lantern_clk_close",
      room = "int_deploy_inv",
      zz = "deploy_inv_lantern",
      zz_gate = "inv_lantern"
  };
  function use_matches_2_inv ()

    interface.InventoryItemRemove( "inv_matches" );

  end;
  function use_matches_2_inv_end ()

    ObjSet( "spr_lantern_plus_add_light_2" ,{alp=1} );

  end;
  function use_matches_2_beg ()

    ObjDelete( "obj_lantern_use_matches" );

  end;
  function use_matches_2_end ()

    ObjSet( "obj_deploy_lantern_clk_close", { input = true } );
    ObjSet( "spr_deploy_lantern_add", { alp = 1 } );
    ObjSet( "spr_deploy_lantern_open_add", { alp = 1 } );
    ObjSet( "spr_deploy_candle_add", { alp = 1 } );
    ObjSet( "spr_deploy_lantern_close_add", { alp = 1 } );
    ObjSet( "vid_deploy_inv_lantern_candle_light", { playing = true, looped = true, alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_matches_2", use_matches_2_beg, "inv_lantern" );
  cmn.AddSubscriber( "use_matches_2", use_matches_2_inv );
  cmn.AddSubscriber( "use_matches_2", use_matches_2_inv_end );
  cmn.AddSubscriber( "use_matches_2", use_matches_2_end, "inv_lantern" );
  cmn.AddSubscriber( "use_matches_2_inv", use_matches_2_inv );
  cmn.AddSubscriber( "use_matches_2_inv_end", use_matches_2_inv_end );
  cmn.AddSubscriber( "use_matches_2_beg", use_matches_2_beg, "inv_lantern" );
  cmn.AddSubscriber( "use_matches_2_end", use_matches_2_end, "inv_lantern" );
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "clk_open_lantern" ] = {
      type = "click",
      use_place = "obj_deploy_lantern_clk_open",
      room = "int_deploy_inv",
      zz = "deploy_inv_lantern",
      zz_gate = "inv_lantern"
  };

  function clk_open_lantern_inv ()

    ObjSet( "inv_lantern", { res = "assets/levels/level1/inv_deploy/inv_lantern/inv/inv_lantern_2" } );

  end;
  function clk_open_lantern_beg ()

    ObjDelete( "obj_deploy_lantern_clk_open" );

  end;
  function clk_open_lantern_end ()

    ObjSet( "spr_deploy_lantern_close", { alp = 0 } );
    ObjSet( "spr_deploy_lantern_open", { alp = 1 } );
    ObjSet( "obj_lantern_use_matches", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_open_lantern", clk_open_lantern_beg, "inv_lantern" );
  cmn.AddSubscriber( "clk_open_lantern", clk_open_lantern_end, "inv_lantern" );
  cmn.AddSubscriber( "clk_open_lantern", clk_open_lantern_inv );
  cmn.AddSubscriber( "clk_open_lantern_beg", clk_open_lantern_beg, "inv_lantern" );
  cmn.AddSubscriber( "clk_open_lantern_end", clk_open_lantern_end, "inv_lantern" );
  cmn.AddSubscriber( "clk_open_lantern_inv", clk_open_lantern_inv );
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "clk_close_lantern" ] = {
      type = "click",
      use_place = "obj_deploy_lantern_clk_close",
      room = "int_deploy_inv",
      zz = "deploy_inv_lantern",
      zz_gate = "inv_lantern"
  };
  function clk_close_lantern_beg ()

    ObjDelete( "obj_deploy_lantern_clk_close" );

  end;
  --------------------------------------------------------------------------------------------
  function clk_close_lantern_end ()

    ObjSet( "spr_deploy_lantern_close", { alp = 1 } );
    ObjDelete( "spr_deploy_lantern_open" );
    ObjSet( "spr_deploy_lantern", { input = 1 } );
    ObjDelete( "vid_deploy_inv_lantern_use_matches_2" );
    ObjDelete( "vid_deploy_inv_lantern_fire" );

  end;  
  --------------------------------------------------------------------------------------------
  function clk_close_lantern_inv ()
    
    ObjSet( "spr_litlantern_invlight", { active = true, visible = true } );

  end;
  --------------------------------------------------------------------------------------------
  function clk_close_lantern_inv_end ()

    ObjSet( "inv_lantern", { res = "assets/levels/level1/inv_deploy/inv_lantern/inv/inv_lantern" } );
    ObjSet( "spr_lantern_plus_add_light", { alp = 1 } );
    ObjDelete( "spr_lantern_plus_add_light_2" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_close_lantern", clk_close_lantern_beg, "inv_lantern" );
  cmn.AddSubscriber( "clk_close_lantern", clk_close_lantern_end, "inv_lantern" );
  cmn.AddSubscriber( "clk_close_lantern", clk_close_lantern_inv);
  cmn.AddSubscriber( "clk_close_lantern", clk_close_lantern_inv_end);
  cmn.AddSubscriber( "clk_close_lantern_beg", clk_close_lantern_beg, "inv_lantern" );
  cmn.AddSubscriber( "clk_close_lantern_end", clk_close_lantern_end, "inv_lantern" );
  cmn.AddSubscriber( "clk_close_lantern_inv", clk_close_lantern_inv);
  cmn.AddSubscriber( "clk_close_lantern_inv_end", clk_close_lantern_inv_end);
  --------------------------------------------------------------------------------------------
  ObjSet( "spr_deploy_lantern", { event_mdown = level1_inv.get_litlantern });
  ObjSet( "obj_deploy_lantern_clk_open", { event_mdown = level1_inv.clk_open_lantern });
  ObjSet( "obj_deploy_lantern_clk_close", { event_mdown = level1_inv.clk_close_lantern });
  ObjAnimate( "spr_litlantern_invlight", "alp", 1, 0, "", { 0,0,0.5, 1.5,0,1, 3,0,0.5 } );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.use_matches_2()

  local item = "inv_matches";

  if ( not cmn.IsEventDone( "use_matches_2" ) and cmn.IsEventDone( "use_matches" ) and cmn.IsEventDone( "clk_open_lantern" ) 
       and private.ObjIntersectCheck( item, "obj_lantern_use_matches" ) )  then

    cmn.CallEventHandler( "use_matches_2_beg", "inv_lantern" );
    cmn.CallEventHandler( "use_matches_2_inv" );

    local func_after = function ()
      common_impl.Lock(false);
      cmn.SetEventDone( "use_matches_2" );
      cmn.CallEventHandler( "use_matches_2_end", "inv_lantern" );
      cmn.CallEventHandler( "use_matches_2_inv_end" );
    
    end;
    common_impl.Lock(true);
    ObjSet( "vid_deploy_inv_lantern_use_matches_2", { alp = 1 } );
    ObjSet( "vid_deploy_inv_lantern_fire", { alp = 1 } );
    VidPlay( "vid_deploy_inv_lantern_use_matches_2","" );
    VidPlay( "vid_deploy_inv_lantern_fire","" ); 
    ObjSet( "tmr_deploy_inv_lantern_vid", { playing = true, time = 2.3, endtrig =  func_after });  
    common_impl.PlayAudio( "sfx", "common/audio/aud_lantern_match", 0, "", 0 );
    ObjAnimate( "spr_deploy_lantern_add", "alp", 0, 0, "",      { 0, 0, 0,    2.3, 0, 0,   3, 1, 1});
    ObjAnimate( "spr_deploy_lantern_open_add", "alp", 0, 0, "", { 0, 0, 0,    2.3, 0, 0,   3, 1, 1});
    ObjAnimate( "spr_deploy_candle_add", "alp", 0, 0, "",       { 0, 0, 0,    2.3, 0, 0,   3, 1, 1});

    return true;

  else
    
    --WrongApply();  

  end;

end;
----------------------------------------------------------------------------------------------------------------------------
function public.get_litlantern()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_litlantern" );
  cmn.CallEventHandler( "get_litlantern", "inv_lantern" );
  common_impl.HideDeployInv();

end;
function public.clk_open_lantern()
 
  cmn.CallEventHandler( "clk_open_lantern_beg", "inv_lantern" );

    local func_after = function ()

     common_impl.Lock(false);

     cmn.SetEventDone( "clk_open_lantern" );
     cmn.CallEventHandler( "clk_open_lantern_end", "inv_lantern" );
     cmn.CallEventHandler( "clk_open_lantern_inv" );

    end;

  common_impl.Lock(true);

  ObjAnimate( "spr_deploy_lantern_close", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );

  ObjAnimate( "spr_deploy_lantern_open", "alp", 0, 0, "", 
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );

  common_impl.PlayAudio( "sfx", "common/audio/aud_lantern_open", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function public.clk_close_lantern()
 
  cmn.CallEventHandler( "clk_close_lantern_beg", "inv_lantern" );

    local func_after = function ()

     common_impl.Lock(false);
          
     cmn.SetEventDone( "clk_close_lantern" );
     cmn.CallEventHandler( "clk_close_lantern_end", "inv_lantern" );
     cmn.CallEventHandler( "clk_close_lantern_inv" );
     cmn.CallEventHandler( "clk_close_lantern_inv_end" );
    end;

  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_lantern_close", 0, "", 0 );
  ObjAnimate( "spr_deploy_lantern_close", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );

  ObjAnimate( "spr_deploy_lantern_open", "alp", 0, 0, "", 
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );
  

end;
--*********************************************************************************************************************
-- function *** cryptex *** () end;
--*********************************************************************************************************************
function private.cryptex_init()

  private.numbers = { 1, 7, 12, 14 };

  common_impl.hint[ "get_micronote" ] = {
      type = "get",
      get_obj = "spr_deploy_micronote",
      room = "int_deploy_inv",
      zz = "deploy_inv_cryptex",
      zz_gate = "inv_cryptex"
  };
  function get_micronote_inv()

    interface.InventoryItemRemove( "inv_cryptex" );
    interface.InventoryItemAdd( "inv_micronote", "spr_deploy_micronote" );
    ObjDelete( "spr_deploy_cryptex_cover_2" );
    ObjDelete( "spr_deploy_cryptex_cover_1" );

  end;

  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_micronote", get_micronote_inv );
  --*********************************************************************************************************************

  common_impl.hint[ "win_cryptex" ] = {
      type = "win",
      use_place = "spr_deploy_cryptex",
      room = "int_deploy_inv",
      zz = "deploy_inv_cryptex",
      zz_gate = "inv_cryptex"
  };

  local win_cryptex = function ()  

      for i = 1, 4 do

        private.numbers[i] = ng_global.progress["std"]["win_cryptex"].numbers[i];

        ObjSet( "spr_deploy_cryptex_part_"..i, { res = "assets/levels/level1/inv_deploy/inv_cryptex/layers/part_"..ng_global.progress["std"]["win_cryptex"].numbers[i] } );

        if ng_global.progress["std"]["win_cryptex"].numbers[i] == 1 or ng_global.progress["std"]["win_cryptex"].numbers[i] == 5
         or ng_global.progress["std"]["win_cryptex"].numbers[i] == 9 or ng_global.progress["std"]["win_cryptex"].numbers[i] == 13  then

          ObjSet( "spr_deploy_cryptex_part_"..i.."_up", { res = "assets/levels/level1/inv_deploy/inv_cryptex/layers/part_"..( ng_global.progress["std"]["win_cryptex"].numbers[i] + 3 ) } );

        else

          ObjSet( "spr_deploy_cryptex_part_"..i.."_up", { res = "assets/levels/level1/inv_deploy/inv_cryptex/layers/part_"..( ng_global.progress["std"]["win_cryptex"].numbers[i] - 1 ) } );

        end;

      end;

      if cmn.IsEventDone( "win_cryptex" ) then

        ObjSet( "spr_deploy_micronote", { input = 1 } ); 
        ObjSet( "obj_deploy_mmg", { input = 0 } );
        ObjDelete( "spr_deploy_cryptex" );

      end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_cryptex", win_cryptex, "inv_cryptex" );
  --------------------------------------------------------------------------------------------
  ObjSet( "spr_deploy_micronote", { event_mdown = level1_inv.get_micronote });
  ObjSet( "spr_deploy_cryptex_part_1", { event_mdown = function() level1_inv.clk_cryptex_part( 1 ) end });
  ObjSet( "spr_deploy_cryptex_part_2", { event_mdown = function() level1_inv.clk_cryptex_part( 2 ) end });
  ObjSet( "spr_deploy_cryptex_part_3", { event_mdown = function() level1_inv.clk_cryptex_part( 3 ) end });
  ObjSet( "spr_deploy_cryptex_part_4", { event_mdown = function() level1_inv.clk_cryptex_part( 4 ) end });
  ObjSet( "inv_cryptex", { event_mdown = function() private.show_cryptex() end });
  --------------------------------------------------------------------------------------------

end;
--------------------------------------------------------------------------------------------
function private.show_cryptex()

  if ( not cmn.IsEventDone( "win_cryptex" ) ) then
    cmn.MiniGameShow( 'cryptex' );
    common_impl.PassingMgStart( 'cryptex' );
  end;
  common_impl.ShowDeployInv('inv_cryptex');

end;
--------------------------------------------------------------------------------------------
function public.get_micronote()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_micronote" );
  cmn.CallEventHandler( "get_micronote", "inv_cryptex" );
  common_impl.HideDeployInv();

end;
--------------------------------------------------------------------------------------------
function public.clk_cryptex_part( number )

  local clk_cryptex_part_end = function ()

    if private.numbers[number] ~= 1 and private.numbers[number] ~= 5
          and private.numbers[number] ~= 9 and private.numbers[number] ~= 13 then
      
        ObjSet( "spr_deploy_cryptex_part_"..number.."_up", { res = "assets/levels/level1/inv_deploy/inv_cryptex/layers/part_"..( private.numbers[number] - 1 ) } );
             
    else  

        ObjSet( "spr_deploy_cryptex_part_"..number.."_up", { res = "assets/levels/level1/inv_deploy/inv_cryptex/layers/part_"..( private.numbers[number] + 3 ) } );

    end;

    public.check_win_cryptex();

  end;

  local func_after = function ()

     common_impl.Lock(false);
    
     if private.numbers[number] ~= 1 and private.numbers[number] ~= 5
        and private.numbers[number] ~= 9 and private.numbers[number] ~= 13 then
    
       private.numbers[number] = private.numbers[number] - 1;
           
     else  

       private.numbers[number] = private.numbers[number] + 3;

     end;

     ObjSet( "spr_deploy_cryptex_part_"..number, { res = "assets/levels/level1/inv_deploy/inv_cryptex/layers/part_"..private.numbers[number], pos_y = -4 } );
    
     for i = 1, 4 do

      ng_global.progress["std"]["win_cryptex"].numbers[i] = private.numbers[i];

     end;

     clk_cryptex_part_end();
               
  end;
 
  common_impl.Lock(true);

  local coord_y = ObjGet( "spr_deploy_cryptex_part_"..number ).pos_y;
    
   ObjAnimate( "spr_deploy_cryptex_part_"..number, "pos_y", 0, 0, func_after, 
  { 
    0.0, 0, coord_y, 
    0.5, 0, ( coord_y + 160 )
  } );

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_cryptex_wheel", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function public.check_win_cryptex()
  
  private.win_cryptex = { 2, 6, 10, 14 };

  local win_count = 0;

  for i = 1, 4 do

    if ng_global.progress["std"]["win_cryptex"].numbers[i] == private.win_cryptex[i] then

      win_count = win_count + 1;

    end;

  end;

  if win_count == 4 then

    public.anim_win_cryptex();

  end;

end;
--------------------------------------------------------------------------------------------
function public.anim_win_cryptex()
  
   cmn.MiniGameHide( "cryptex" );
   common_impl.PassingMgWin( "cryptex" );
   cmn.SetEventDone( "win_cryptex" );

   local func_after = function()

    common_impl.Lock(false);

    cmn.CallEventHandler( "win_cryptex", "inv_cryptex" );

   end;

   common_impl.Lock(true);

   ObjAnimate( "spr_deploy_cryptex", "pos_x", 0, 0, func_after, 
  { 
    0.0, 0, -13, 
    1, 0, 303
  } );

  ObjAnimate( "spr_deploy_cryptex", "alp", 0, 0,"", 
  { 
    0.0, 0, 1, 
    0.8, 0, 1,
    1.0, 0, 0
  } );

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_cryptex_win", 0, "", 0 );

end;
--*********************************************************************************************************************
-- function *** magnifier *** () end;
--*********************************************************************************************************************
function private.magnifier_init()

  -------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lens2" ] = {
      type = "get",
      get_obj = "spr_deploy_lens2",
      room = "int_deploy_inv",
      zz = "deploy_inv_magnifier",
      zz_gate = "inv_magnifier"
  };
  function get_lens2_inv ()

    interface.InventoryItemRemove( "inv_magnifier" );
    interface.InventoryItemAdd( "inv_lens2", "spr_deploy_lens2" );
    ObjDelete( "gfx_deploy_lens2" );

  end;

  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_lens2", get_lens2_inv );
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriver_4" ] = {
      type = "use",
      inv_obj = "inv_screwdriver",
      use_place = "obj_magnifier_use_screwdriver",
      room = "int_deploy_inv",
      zz = "deploy_inv_magnifier",
      zz_gate = "inv_magnifier"
  };
  function use_screwdriver_4_inv ()

    interface.InventoryItemRemove( "inv_screwdriver" );

  end;
  function use_screwdriver_4_beg ()

    ObjDelete( "obj_magnifier_use_screwdriver" );

  end;
  function use_screwdriver_4_end ()

    ObjSet( "spr_deploy_lens2", { input = true, pos_x = 0, pos_y = 0 } );
    ObjSet( "gfx_deploy_lens2", { active = true } );
    ObjDelete( "spr_deploy_magnifier_1" );
    ObjDelete( "spr_deploy_magnifier_2" );
    ObjDelete( "spr_deploy_magnifier_handle" );
    ObjDelete( "spr_deploy_magnifier_handle_shadow" );
    ObjDelete( "spr_deploy_magnifier_handle_over" );
    ObjDelete( "spr_deploy_magnifier_handle_over_shadow" );
    ObjDelete( "vid_magnifier_use_screwdriver" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screwdriver_4", use_screwdriver_4_beg, "inv_magnifier" );
  cmn.AddSubscriber( "use_screwdriver_4", use_screwdriver_4_inv );
  cmn.AddSubscriber( "use_screwdriver_4", use_screwdriver_4_end, "inv_magnifier"  );
  cmn.AddSubscriber( "use_screwdriver_4_inv", use_screwdriver_4_inv );
  cmn.AddSubscriber( "use_screwdriver_4_beg", use_screwdriver_4_beg, "inv_magnifier"  );
  cmn.AddSubscriber( "use_screwdriver_4_end", use_screwdriver_4_end, "inv_magnifier"  );
  --------------------------------------------------------------------------------------------
  ObjSet( "spr_deploy_len", { event_mdown = level1_inv.get_lens1 });
  ObjSet( "spr_deploy_lens2", { event_mdown = level1_inv.get_lens2 });
  ObjSet( "obj_magnifier_use_screwdriver", { event_mdown = level1_inv.clk_magnifier });
  --------------------------------------------------------------------------------------------

end;
--------------------------------------------------------------------------------------------
function public.get_lens2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_lens2" );
  cmn.CallEventHandler( "get_lens2", "inv_magnifier" );
  common_impl.HideDeployInv();

end;
--------------------------------------------------------------------------------------------
function public.use_screwdriver_4()

  local item = "inv_screwdriver";

  if ( cmn.IsEventDone( "get_lens1" ) and not cmn.IsEventDone( "use_screwdriver_4" ) 
       and private.ObjIntersectCheck( item, "obj_magnifier_use_screwdriver" ) )  then
    
    cmn.CallEventHandler( "use_screwdriver_4_inv" );
    cmn.CallEventHandler( "use_screwdriver_4_beg", "inv_magnifier" );
    common_impl.Lock( true );

    local endtrig = function ()

      local func_end = function ()

        common_impl.Lock(false);
        cmn.SetEventDone( "use_screwdriver_4" );
        cmn.CallEventHandler( "use_screwdriver_4_end", "inv_magnifier" );

      end;

      ObjAnimate( "spr_deploy_magnifier_handle", "alp", 0, 0, "",
      { 
        0.0, 0, 1, 
        0.8, 0, 1,
        1.0, 0, 0
      } );

      ObjAnimate( "spr_deploy_magnifier_handle", "pos_xy", 0, 0, "",
      { 
        0.0, 0, -40, -50, 
        0.3, 0, -40, -50,
        1.0, 0, 66, 28
        
      } );

      ObjAnimate( "spr_deploy_magnifier_handle_over", "alp", 0, 0, "",
      { 
        0.0, 0, 1, 
        0.8, 0, 1,
        1.0, 0, 0
      } );

      ObjAnimate( "spr_deploy_magnifier_handle_over", "pos_xy", 0, 0, "",
      { 
        0.0, 0, 4, -26, 
        0.3, 0, 4, -26,
        1.0, 0, 112, 52
        
      } );

      ObjAnimate( "spr_deploy_magnifier_handle_over_shadow", "alp", 0, 0, "",
      { 
        0.0, 0, 1, 
        0.8, 0, 1,
        1.0, 0, 0
      } );

      ObjAnimate( "spr_deploy_magnifier_handle_over_shadow", "pos_xy", 0, 0, "",
      { 
        0.0, 0, 40, -3, 
        0.3, 0, 40, -3,
        1.0, 0, 150, 73
        
      } );

      ObjAnimate( "spr_deploy_magnifier_handle_shadow", "alp", 0, 0, "",
      { 
        0.0, 0, 1, 
        0.3, 0, 1,
        0.4, 0, 0
      } );

      ObjAnimate( "spr_deploy_magnifier_2", "alp", 0, 0, "",
      { 
        0.0, 0, 1, 
        1.5, 0, 1,
        1.7, 0, 0
      } );

      ObjAnimate( "spr_deploy_magnifier_2", "pos_xy", 0, 0, "",
      { 
        0.0, 0, 8, -31, 
        1.0, 0, 8, -31,
        1.7, 0, 102, 166
        
      } );

       ObjAnimate( "spr_deploy_magnifier_1", "alp", 0, 0, "",
      { 
        0.0, 0, 1, 
        1.5, 0, 1,
        1.7, 0, 0
      } );

      ObjAnimate( "spr_deploy_magnifier_1", "pos_xy", 0, 0, "",
      { 
        0.0, 0, -32, -37, 
        1.0, 0, -32, -37,
        1.7, 0, -174, -203
        
      } );

      ObjAnimate( "spr_deploy_lens2", "pos_xy", 0, 0, func_end,
      { 
        0.0, 0, -123, -117, 
        1.7, 0, -123, -117,
        2.1, 0, 0, 0
      } );

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_screwdriver_magnifier", 0, "", 0 );
    ObjSet( "vid_magnifier_use_screwdriver", { alp = 1 } );
    VidPlay( "vid_magnifier_use_screwdriver", "" );
    ObjAnimate( "vid_magnifier_use_screwdriver", "alp", 0, 0, endtrig,
    { 
      0.0, 0, 1, 
      1.8, 0, 1,
      2.0, 0, 0
    } );

    return true;

  else
    
    --WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.clk_magnifier()
 
   common_impl.ShowBbt( 'bbt_magnifier_use_screwdriver' );

   local func_after = function ()

     common_impl.Lock(false);
        
   end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_very_small_metall", 0, "", 0 );

  ObjAnimate( "spr_deploy_magnifier_1", "ang", 0, 0, func_after, 
  { 
    0.0, 0, 0.0, 
    0.1, 0, -0.01,
    0.3, 0, 0.01,
    0.4, 0, 0.0
  } );

   ObjAnimate( "spr_deploy_magnifier_2", "ang", 0, 0, "", 
  { 
    0.0, 0, 0.0, 
    0.1, 0, 0.01,
    0.3, 0, -0.01,
    0.4, 0, 0.0
  } );

  ObjAnimate( "spr_deploy_lens2", "ang", 0, 0, "", 
  { 
    0.0, 0, 0.0, 
    0.1, 0, -0.01,
    0.3, 0, 0.01,
    0.4, 0, 0.0
  } );

   ObjAnimate( "spr_deploy_magnifier_handle", "ang", 0, 0, "", 
  { 
    0.0, 0, 0.0, 
    0.1, 0, -0.01,
    0.3, 0, 0.01,
    0.4, 0, 0.0
  } );
   

end;
--*********************************************************************************************************************
-- function *** brokenglasses *** () end;
--*********************************************************************************************************************
function private.brokenglasses_init()

  -------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lens1" ] = {
      type = "get",
      get_obj = "spr_deploy_len",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenglasses",
      zz_gate = "inv_brokenglasses"
  };
  function get_lens1_inv()

    interface.InventoryItemRemove( "inv_brokenglasses" );
    interface.InventoryItemAdd( "inv_lens1", "spr_deploy_len" );
    ObjDelete( "gfx_deploy_len" );

  end;
  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_lens1", get_lens1_inv );
  -------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriver_3" ] = {
      type = "use",
      inv_obj = "inv_screwdriver",
      use_place = "obj_brokenglasses_use_screwdriver",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokenglasses",
      zz_gate = "inv_brokenglasses"
  };
  function use_screwdriver_3_beg ()

    ObjDelete( "obj_brokenglasses_use_screwdriver" );
    ObjDelete( "spr_deploy_bolt_1" );
    ObjDelete( "spr_deploy_bolt_2" );

  end;
  function use_screwdriver_3_end ()

    ObjSet( "spr_deploy_len", { input = true } );
    ObjSet( "gfx_deploy_len", { active = true } );
    ObjDelete( "spr_deploy_lens1" );
    ObjDelete( "spr_deploy_brokenglasses" );
    ObjDelete( "spr_deploy_lens_over" );
    ObjDelete( "spr_deploy_lens_shadow" );
    ObjDelete( "spr_deploy_bolt_1" );
    ObjDelete( "spr_deploy_bolt_2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screwdriver_3", use_screwdriver_3_beg, "inv_brokenglasses" );
  cmn.AddSubscriber( "use_screwdriver_3", use_screwdriver_3_end, "inv_brokenglasses"  );
  cmn.AddSubscriber( "use_screwdriver_3_beg", use_screwdriver_3_beg, "inv_brokenglasses"  );
  cmn.AddSubscriber( "use_screwdriver_3_end", use_screwdriver_3_end, "inv_brokenglasses"  );

end;
--*********************************************************************************************************************
function public.get_lens1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_lens1" );
  cmn.CallEventHandler( "get_lens1", "inv_brokenglasses" );
  common_impl.HideDeployInv();

end;
--*********************************************************************************************************************
function public.use_screwdriver_3()

  local item = "inv_screwdriver";

  if ( not cmn.IsEventDone( "use_screwdriver_3" ) 
       and private.ObjIntersectCheck( item, "obj_brokenglasses_use_screwdriver" ) )  then

    cmn.CallEventHandler( "use_screwdriver_3_beg", "inv_brokenglasses" );

    local func_end = function ()

      local func_end2 = function ()

        common_impl.Lock(false);

        cmn.SetEventDone( "use_screwdriver_3" );
        cmn.CallEventHandler( "use_screwdriver_3_end", "inv_brokenglasses" );
      
      end;

      ObjAnimate( "spr_deploy_lens_over", "alp", 0, 0, "",
      { 
        0.0, 0, 1, 
        0.3, 0, 0
      } );
    
       ObjAnimate( "spr_deploy_brokenglasses", "ang", 0, 0, "",
      { 
        0.0, 0, 0, 
        0.3, 0, 0,
        1.0, 0, -0.38
      } );

      
       ObjAnimate( "spr_deploy_brokenglasses", "alp", 0, 0, "",
      { 
        0.0, 0, 1, 
        0.8, 0, 1,
        1.0, 0, 0
      } );

       ObjAnimate( "spr_deploy_lens1", "ang", 0, 0, "",
      { 
        0.0, 0, 0, 
        1.3, 0, 0,
        2.0, 0, -0.34
      } );
      
       ObjAnimate( "spr_deploy_lens1", "alp", 0, 0, func_end2,
      { 
        0.0, 0, 1, 
        1.8, 0, 1,
        2.0, 0, 0
      } );

       ObjAnimate( "spr_deploy_lens_shadow", "alp", 0, 0, "",
      { 
        0.0, 0, 1, 
        1.0, 0, 1,
        1.3, 0, 0
      } );

      return true;

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_screwdriver_glasses", 0, "", 0 );
    ObjSet( "vid_inv_brokenglasses_use_screwdriver", {alp = 1} );
    VidPlay( "vid_inv_brokenglasses_use_screwdriver", "")
    ObjAnimate( "vid_inv_brokenglasses_use_screwdriver", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1, 
      6.0, 0, 1,
      6.3, 0, 0
    } );

    return true;

  else
    
    --WrongApply();  

  end;

end;
-------------------------------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** gasolinesaw *** () end;
--*********************************************************************************************************************
function private.init_gasolinesaw()

  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_oilcan_2" ] = {
      type = "use",
      inv_obj = "inv_oilcan",
      use_place = "obj_gasolinesaw_use_oilcan",
      room = "int_deploy_inv",
      zz = "deploy_inv_gasolinesaw",
      zz_gate = "inv_gasolinesaw"
  };
  
  function use_oilcan_2_beg ()
    
    ObjDelete( "obj_gasolinesaw_use_oilcan" );

  end;
  function use_oilcan_2_end ()
    
    ObjSet( "spr_deploy_workinggasolinesaw", { input = true } );
    ObjSet( "gfx_deploy_workinggasolinesaw", { active = true } );
    ObjDelete( "anm_deploy_use_oilcan_2" );

  end;

  cmn.AddSubscriber( "use_oilcan_2", use_oilcan_2_beg, "inv_gasolinesaw" );
  cmn.AddSubscriber( "use_oilcan_2", use_oilcan_2_end, "inv_gasolinesaw" );
  cmn.AddSubscriber( "use_oilcan_2_beg", use_oilcan_2_beg, "inv_gasolinesaw" );
  cmn.AddSubscriber( "use_oilcan_2_end", use_oilcan_2_end, "inv_gasolinesaw" );
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_workinggasolinesaw" ] = {
      type = "get",
      get_obj = "spr_deploy_workinggasolinesaw",
      room = "int_deploy_inv",
      zz = "deploy_inv_gasolinesaw",
      zz_gate = "inv_gasolinesaw"
  };
  function get_workinggasolinesaw_inv()

    interface.InventoryItemRemove( "inv_gasolinesaw" );
    interface.InventoryItemAdd( "inv_workinggasolinesaw", "spr_deploy_workinggasolinesaw" );

  end;
  cmn.AddSubscriber( "get_workinggasolinesaw", get_workinggasolinesaw_inv );
  --------------------------------------------------------------------------------------------
  ObjSet( "spr_deploy_workinggasolinesaw", { event_mdown = public.get_workinggasolinesaw });
  ObjAnimate( "spr_deploy_brokengasolinesaw_brokenchain_1_1", "ang", 1, 0, "", { 0,0,-0.01, 1.5,0,0.05, 3,0,-0.01 } );
  --------------------------------------------------------------------------------------------
end;
-------------------------------------------------------------------------------------------
function public.get_workinggasolinesaw()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_workinggasolinesaw" );
  cmn.CallEventHandler( "get_workinggasolinesaw", "inv_gasolinesaw" );
  common_impl.HideDeployInv();

end;
-------------------------------------------------------------------------------------------
function public.use_oilcan_2()

  local item = "inv_oilcan";

  if (  private.ObjIntersectCheck( item, "obj_gasolinesaw_use_oilcan" ) and not cmn.IsEventDone( "use_oilcan_2" ) and cmn.IsEventDone( "use_oilcan_1" ) )  then

    cmn.CallEventHandler( "use_oilcan_2_beg", "inv_gasolinesaw" );

    local func_after = function ()
      
      common_impl.Lock(false);
      cmn.SetEventDone( "use_oilcan_2" );
      cmn.CallEventHandler( "use_oilcan_2_end", "inv_gasolinesaw" );
      
    end;

    common_impl.Lock(true);
    common_impl.PlayAudio("sfx","common/audio/aud_use_oiler_chainsaw" );
    AnimPlay( "anm_deploy_use_oilcan_2", "DoAnim", func_after );

    return true; 

  end;

end;
--*********************************************************************************************************************
-- function *** corkscrew *** () end;
--*********************************************************************************************************************
function public.use_corkscrew()

  if ( common.ApplyObj( "inv_corkscrew", "obj_table_use_fishinghook", true ) ) then
    common_impl.ShowBbt( 'bbt_livingroom_wrong_corkscrew' );
  else 
    common_impl.WrongApply();
  end;

end
--*********************************************************************************************************************
-- function *** bag *** () end;
--*********************************************************************************************************************
function private.init_bag()
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_zipperslider" ] = {
      type = "use",
      inv_obj = "inv_zipperslider",
      use_place = "obj_bag_use_zipperslider",
      room = "int_deploy_inv",
      zz = "deploy_inv_bag",
      zz_gate = "inv_bag"
  };
  function use_zipperslider_inv ()

    interface.InventoryItemRemove( "inv_zipperslider" );

  end;
  function use_zipperslider_inv_end ()

    ObjSet( "inv_bag", { res = "assets/levels/level1/inv_deploy/inv_bag/inv/inv_criminalsbag_2" } );

  end;
  function use_zipperslider_beg ()

    ObjDelete( "obj_bag_use_zipperslider" );

  end;
  function use_zipperslider_end ()
    
    ObjSet( "spr_deploy_bag_dogin", { alp = 1 } );

    if ( cmn.IsEventDone( "use_oilcan_3" ) ) then

      ObjSet( "obj_bag_clk_zipperslider", { input = true } );
    
    end;
    
  end;
  cmn.AddSubscriber( "use_zipperslider", use_zipperslider_beg, "inv_bag" );
  cmn.AddSubscriber( "use_zipperslider", use_zipperslider_inv );
  cmn.AddSubscriber( "use_zipperslider", use_zipperslider_inv_end );
  cmn.AddSubscriber( "use_zipperslider", use_zipperslider_end, "inv_bag" );
  cmn.AddSubscriber( "use_zipperslider_inv", use_zipperslider_inv );
  cmn.AddSubscriber( "use_zipperslider_inv_end", use_zipperslider_inv_end );
  cmn.AddSubscriber( "use_zipperslider_beg", use_zipperslider_beg, "inv_bag" );
  cmn.AddSubscriber( "use_zipperslider_end", use_zipperslider_end, "inv_bag" );
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_oilcan_3" ] = {
      type = "use",
      inv_obj = "inv_oilcan",
      use_place = "obj_bag_use_oilcan",
      room = "int_deploy_inv",
      zz = "deploy_inv_bag",
      zz_gate = "inv_bag"
  };
  function use_oilcan_3_inv ()

    interface.InventoryItemRemove( "inv_oilcan" );

  end;
  function use_oilcan_3_beg ()

    ObjDelete( "obj_bag_use_oilcan" );

  end;
  function use_oilcan_3_end ()

    ObjDelete( "spr_deploy_bag_rust" ); 
    ObjDelete( "spr_deploy_bag_drop" );
    ObjDelete( "spr_deploy_bag_oiler" );
    
    if ( cmn.IsEventDone( "use_zipperslider" ) ) then

      ObjSet( "obj_bag_clk_zipperslider", { input = true } );
    
    end;

  end;
  cmn.AddSubscriber( "use_oilcan_3", use_oilcan_3_beg, "inv_bag" );
  cmn.AddSubscriber( "use_oilcan_3", use_oilcan_3_inv );
  cmn.AddSubscriber( "use_oilcan_3", use_oilcan_3_end, "inv_bag" );
  cmn.AddSubscriber( "use_oilcan_3_inv", use_oilcan_3_inv );
  cmn.AddSubscriber( "use_oilcan_3_beg", use_oilcan_3_beg, "inv_bag" );
  cmn.AddSubscriber( "use_oilcan_3_end", use_oilcan_3_end, "inv_bag" );
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_zipperslider" ] = {
      type = "click",
      use_place = "obj_bag_clk_zipperslider",
      room = "int_deploy_inv",
      zz = "deploy_inv_bag",
      zz_gate = "inv_bag"
  };

  function clk_zipperslider_inv ()

    ObjSet( "inv_bag", { res = "assets/levels/level1/inv_deploy/inv_bag/inv/inv_criminalsbag_3" } );

  end;
  function clk_zipperslider_beg ()

    ObjDelete( "obj_bag_clk_zipperslider" );

  end;
  function clk_zipperslider_end ()

    ObjSet( "obj_bag_pliers", { input = true, active = true } );
    ObjSet( "spr_deploy_bag_statuette", { input = true, active = true } );
    ObjSet( "spr_deploy_bag_open", { input = true } );
    ObjSet( "spr_deploy_bag_open", { alp = 1 } );
    ObjDelete( "spr_deploy_bag_close" ); 
    ObjDelete( "spr_deploy_bag_dogin" ); 

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_zipperslider", clk_zipperslider_beg, "inv_bag" );
  cmn.AddSubscriber( "clk_zipperslider", clk_zipperslider_end, "inv_bag" );
  cmn.AddSubscriber( "clk_zipperslider", clk_zipperslider_inv );
  cmn.AddSubscriber( "clk_zipperslider_beg", clk_zipperslider_beg, "inv_bag" );
  cmn.AddSubscriber( "clk_zipperslider_end", clk_zipperslider_end, "inv_bag" );
  cmn.AddSubscriber( "clk_zipperslider_inv", clk_zipperslider_inv );
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pliers" ] = {
      type = "get",
      get_obj = "obj_bag_pliers_input",
      room = "int_deploy_inv",
      zz = "deploy_inv_bag",
      zz_gate = "inv_bag"
  };
  function get_pliers_inv()

    interface.InventoryItemAdd( "inv_pliers", "spr_deploy_bag_pliers" );
    ObjSet( "inv_bag", { res = "assets/levels/level1/inv_deploy/inv_bag/inv/inv_criminalsbag_5" } );

  end;
  function get_pliers()

    ObjDelete( "obj_bag_pliers_input" );
    ObjDelete( "gfx_deploy_bag_pliers" );
    ObjDelete( "spr_deploy_bag_pliers_shadow" );

    if cmn.IsEventDone( "get_prv_statuette" ) then
      ObjSet( "spr_bag_plus_light", { alp = 0 } );
    end;

  end;

  cmn.AddSubscriber( "get_pliers", get_pliers_inv );
  cmn.AddSubscriber( "get_pliers", get_pliers, "inv_bag" );
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_prv_statuette" ] = {
      type = "get",
      get_obj = "obj_bag_statuette_input",
      room = "int_deploy_inv",
      zz = "deploy_inv_bag",
      zz_gate = "inv_bag"
  };
  function get_prv_statuette_inv()

    interface.ProvidePanelItemAdd( "inv_prv_statuette", "spr_deploy_bag_statuette" );
    ObjSet( "inv_bag", { res = "assets/levels/level1/inv_deploy/inv_bag/inv/inv_criminalsbag_4" } );

  end;

  function get_prv_statuette()

    ObjDelete( "obj_bag_statuette_input" );
    ObjDelete( "gfx_deploy_bag_statuette" );

    if cmn.IsEventDone( "get_pliers" ) then
      ObjSet( "spr_bag_plus_light", { alp = 0 } );
    end;

  end;

  cmn.AddSubscriber( "get_prv_statuette", get_prv_statuette_inv );
  cmn.AddSubscriber( "get_prv_statuette", get_prv_statuette, "inv_bag" );
  --------------------------------------------------------------------------------------------
  function get_prv_criminalsbag_inv()

    interface.InventoryItemRemove( "inv_bag" );
    interface.ProvidePanelItemAdd( "inv_prv_criminalsbag", "spr_deploy_bag_open" );

  end;

  function get_prv_criminalsbag()

    ObjDelete( "spr_deploy_bag" );

  end;

  cmn.AddSubscriber( "get_prv_criminalsbag", get_prv_criminalsbag_inv );
  cmn.AddSubscriber( "get_prv_criminalsbag", get_prv_criminalsbag, "inv_bag" );
  --------------------------------------------------------------------------------------------
  ObjSet( "spr_deploy_bag_pliers", { event_mdown = public.get_pliers });
  ObjSet( "spr_deploy_bag_statuette", { event_mdown = public.get_prv_statuette });
  ObjSet( "obj_bag_clk_zipperslider", { event_mdown = level1_inv.clk_zipperslider });
  --------------------------------------------------------------------------------------------
end;
-------------------------------------------------------------------------------------------
function public.get_prv_statuette()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_prv_statuette" );
  cmn.CallEventHandler( "get_prv_statuette", "inv_bag" );

  if ( cmn.IsEventDone("get_pliers") ) then

    public.get_prv_criminalsbag();

  end;

end;
-------------------------------------------------------------------------------------------
function public.get_pliers()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_pliers" );
  cmn.CallEventHandler( "get_pliers", "inv_bag" );

  if ( cmn.IsEventDone("get_prv_statuette") ) then

    public.get_prv_criminalsbag();

  end;

end;
-------------------------------------------------------------------------------------------
function public.get_prv_criminalsbag()

  cmn.SetEventDone( "get_prv_criminalsbag" );
  cmn.CallEventHandler( "get_prv_criminalsbag", "inv_bag" );

  common_impl.HideDeployInv();

end;
-------------------------------------------------------------------------------------------
function public.use_zipperslider()

  local item = "inv_zipperslider";

  if ( private.ObjIntersectCheck( item, "obj_bag_use_zipperslider" ) )  then

    cmn.CallEventHandler( "use_zipperslider_inv", "inv_bag" );
    cmn.CallEventHandler( "use_zipperslider_beg", "inv_bag" );

    local func_end = function ()

        common_impl.Lock( false );
        cmn.SetEventDone( "use_zipperslider" );
        cmn.CallEventHandler( "use_zipperslider_end", "inv_bag" );
        cmn.CallEventHandler( "use_zipperslider_inv_end" );

    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_bag_zipper", 0, "", 0 );

    ObjAnimate( "spr_deploy_bag_dogin", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0, 
      0.3, 0, 1
    } );

  else
    
    --WrongApply();  

  end;

end;
-------------------------------------------------------------------------------------------
function public.use_oilcan_3()

  local item = "inv_oilcan";

  if ( not cmn.IsEventDone( "use_oilcan_3" ) 
       and private.ObjIntersectCheck( item, "obj_bag_use_oilcan" ) )  then

    cmn.CallEventHandler( "use_oilcan_3_inv" );
    cmn.CallEventHandler( "use_oilcan_3_beg", "inv_bag" );

    local func_end = function ()

        common_impl.Lock( false );
        cmn.SetEventDone( "use_oilcan_3" );
        cmn.CallEventHandler( "use_oilcan_3_end", "inv_bag" );

    end;  

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_bag_oiler", 0, "", 0 );

    ObjAnimate( "spr_deploy_bag_rust", "alp", 0, 0, func_end,
    { 
      0.0, 0, 1, 
      1.3, 0, 1,
      1.6, 0, 0
    } );

    ObjAnimate( "spr_deploy_bag_drop", "pos_y", 0, 0, "",
    { 
      0.0, 0, -83, 
      0.8, 0, -83,
      1.3, 0, -70
    } );

    ObjAnimate( "spr_deploy_bag_drop", "alp", 0, 0, "",
    { 
      0.0, 0, 0, 
      0.5, 0, 0,
      0.8, 0, 1,
      1.3, 0, 1,
      1.6, 0, 0
    } );

    ObjAnimate( "spr_deploy_bag_oiler", "pos_xy", 0, 0, "",
    { 
      0.0, 0, 879, -201, 
      0.5, 0, 179, -119,
      1.1, 0, 179, -119,
      1.6, 0, 879, -201
    } );

    return true;

  end;

end;
-------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------
function private.clk_zipperslider_anim()

  local func_end = function ()

     common_impl.Lock(false);

     cmn.SetEventDone( "clk_zipperslider" );
     cmn.CallEventHandler( "clk_zipperslider_end", "inv_bag" );
     cmn.CallEventHandler( "clk_zipperslider_inv" );

  end;

  ObjAnimate( "spr_deploy_bag_dogin", "alp", 0, 0, "",
  { 
    0.0, 0, 1, 
    0.3, 0, 0
  } );

  ObjAnimate( "spr_deploy_bag_close", "alp", 0, 0, "",
  { 
    0.0, 0, 1, 
    0.3, 0, 0
  } );

  ObjAnimate( "spr_deploy_bag_open", "alp", 0, 0, func_end,
  { 
    0.0, 0, 0, 
    0.3, 0, 1
  } );

end;
-------------------------------------------------------------------------------------------
        
function public.clk_zipperslider()
 
  cmn.CallEventHandler( "clk_zipperslider_beg", "inv_bag" );

  local func_after = function ()

     private.clk_zipperslider_anim();

  end;

  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_bag_open", 0, "", 0 );

  ObjAnimate( "spr_deploy_bag_dogin", "pos_xy", 0, 0, func_after,
  { 
    0.0, 0, -183, -17, 
    0.3, 0, -141, -32,
    0.6, 0,  -44, -55,
    1.0, 0,   56, -81,
    1.4, 0,  122, -111,
    1.7, 0,  190, -137
  } );

  ObjAnimate( "spr_deploy_bag_dogin", "ang", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.3, 0, -0.27
  } );

end;
--******************************************************************************************************
function public.Skip( event )

  if ( event == "win_cryptex" ) then
    public.anim_win_cryptex();
  end;

end;
--******************************************************************************************************
function public.Reset( event )

  if ( event == "win_cryptex" ) then
    
    private.numbers = { 1, 7, 12, 14 };
    local numbers_up = { 4, 6, 11, 13 };    
    for i = 1, 4 do

      ObjSet( "spr_deploy_cryptex_part_"..i, { res = "assets/levels/level1/inv_deploy/inv_cryptex/layers/part_"..private.numbers[i], pos_y = -4 } );
      ObjSet( "spr_deploy_cryptex_part_"..i.."_up", { res = "assets/levels/level1/inv_deploy/inv_cryptex/layers/part_"..numbers_up[i] } );
      ng_global.progress[ "std" ][ "win_cryptex" ].numbers[ i ] = private.numbers[ i ];

    end;

  end;
  

end;

