-- name=rm_abandoneddistrict
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_abandoneddistrict";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_trunk", "room_hub" );
  ObjAttach( "zz_attraction", "room_hub" );

  local enter_func = function () common_impl.SetCursor( CURSOR_GET ) end;
  local leave_func = function () common_impl.SetCursor( CURSOR_DEFAULT ) end;

  ObjMultiSet({
    { "spr_trunk_prv_knife", { event_mdown = private.get_prv_knife }},
    { "spr_trunk_evidence_1_9", { event_mdown = private.get_evidence_1_9 }},
    { "spr_attraction_button", { event_mdown = private.get_button }},
    { "spr_attraction_monogram", { event_mdown = private.get_monogram }},
    { "spr_attraction_prv_hat", { event_mdown = private.get_prv_hat }},
    { "obj_attraction_clk_arm", { event_mdown = private.clk_shutter }},
    { "spr_abandoneddistrict_lantern", { event_mdown = private.get_lantern }},
    { "obj_abandoneddistrict_clk_lantern_burned", { event_mdown = private.clk_lantern_burned }},
    { "obj_abandoneddistrict_providence_item_1",  { event_mdown = function() int_providence.Thinking( "providence_1", "obj_abandoneddistrict_providence_item_1" ) end }},
    { "obj_abandoneddistrict_providence_item_2",  { event_mdown = function() int_providence.Thinking( "providence_2", "obj_abandoneddistrict_providence_item_2" ) end }},
    { "obj_abandoneddistrict_use_providence_invitem_1", { event_mdown = private.get_prv_knife_silhouette }},
    { "obj_abandoneddistrict_use_providence_invitem_2", { event_mdown = private.get_prv_hat_silhouette }},
    { "spr_abandoneddistrict_providence_bank",     
      { 
        input = true, 
        drag = true,         
        event_startdrag = private.drag_bank, 
        event_dragdrop = private.drop_bank, 
        event_menter = enter_func, 
        event_mleave = leave_func 
      }},
    { "spr_abandoneddistrict_providence_rope",  
      { 
        input = true, 
        drag = true,         
        event_startdrag = private.drag_rope, 
        event_dragdrop = private.drop_rope, 
        event_menter = enter_func, 
        event_mleave = leave_func 
      }},
    { "spr_trunk_coin",{event_mdown = function() private.get_coin10() end  }},
    { "spr_abandoneddistrict_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_1_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_abandoneddistrict_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_7" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
 });

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_abandoneddistrict = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gho_abandoneddistrict_trash",
      "gmg_abandoneddistrict_superpuzzle",
      "gzz_abandoneddistrict_trunk",
      "gzz_abandoneddistrict_attraction",
      "gzz_abandoneddistrict_goaf",
    };
    for i = 1, #gates do
    
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 

      {
        private.room_objname,
        "zz_trunk",
        "zz_attraction",
      
      };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_abandoneddistrict", update_game_mode_abandoneddistrict, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_abandoneddistrict = function ()
    
    local effects_table = 
    {
      "obj_abandoneddistrict_anims",
      "spr_abandoneddistrict_plate",
      "spr_abandoneddistrict_flag_1",
      "spr_abandoneddistrict_flag_2" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_abandoneddistrict", update_performance_mode_abandoneddistrict, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_abandoneddistrict () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_abandoneddistrict" ] = {
    type = "click",
    use_place = "grm_square_abandoneddistrict",
    room = "rm_square"
  };

  local opn_abandoneddistrict_map = function ()

    common_impl.VisitMapRoom( "abandoneddistrict" );

  end;
  cmn.AddSubscriber( "opn_abandoneddistrict", opn_abandoneddistrict_map, nil );

  --------------------------------------------------------------------------------------------
  -- function get_coins () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_10 = function ()

    ObjDelete( "obj_trunk_coin" );

  end;
  cmn.AddSubscriber( "get_coin_10", get_collect_coin_10, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_prv_knife () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_prv_knife" ] = {
    type = "get",
    get_obj = "spr_trunk_prv_knife",
    room = private.room_objname,
    zz = "zz_trunk",
    zz_gate = "gzz_abandoneddistrict_trunk"
  };
  local get_prv_knife_inv = function ()

    interface.ProvidePanelItemAdd( "inv_prv_knife", "spr_trunk_prv_knife" );
  
  end;
  
  local get_prv_knife_closezz = function ()
  
    ObjDelete( "spr_abandoneddistrict_knife_2" );
    ObjDelete( "gfx_trunk_prv_knife" );
    ObjDelete( "spr_trunk_prv_knife_shadow" );
    if ( cmn.IsEventDone( "get_lantern" ) and cmn.IsEventDone( "get_evidence_1_9" ) and common_impl.IsGetCoin("get_coin_10") ) then
      ObjDelete( "gzz_abandoneddistrict_trunk" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_prv_knife", get_prv_knife_inv );
  cmn.AddSubscriber( "get_prv_knife", get_prv_knife_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lantern () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lantern" ] = {
    type = "get",
    get_obj = "spr_abandoneddistrict_lantern",
    room = private.room_objname
  };
  local get_lantern_inv = function ()
  
    interface.InventoryItemAdd( "inv_lantern", "spr_abandoneddistrict_lantern" );
    ObjSet( "inv_lantern", { drag = false });

  end;
  
  local get_lantern_closezz = function ()

    ObjDelete( "gfx_abandoneddistrict_lantern" );
    if ( cmn.IsEventDone( "get_prv_knife" ) and cmn.IsEventDone( "get_evidence_1_9" ) and common_impl.IsGetCoin("get_coin_10") ) then
      ObjDelete( "gzz_abandoneddistrict_trunk" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_lantern", get_lantern_inv );
  cmn.AddSubscriber( "get_lantern", get_lantern_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_evidence_1_9 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_evidence_1_9" ] = {
    type = "get",
    get_obj = "spr_trunk_evidence_1_9",
    room = private.room_objname,
    zz = "zz_trunk",
    zz_gate = "gzz_abandoneddistrict_trunk"
  };
  local get_evidence_1_9_inv = function ()
  
    --int_investigation_button.SetDcn( 1, 3 );
    --ObjSet( "obj_diary_page1_evidence_1_9", { alp = 1, visible = true, input = true } );
    
  end;
  
  local get_evidence_1_9_closezz = function ()
  
    ObjDelete( "spr_trunk_evidence_1_9" );
    ObjDelete( "spr_trunk_evidence_1_9_shadow" );
    ObjDelete( "spr_abandoneddistrict_tickets" );
    if ( cmn.IsEventDone( "get_prv_knife" ) and cmn.IsEventDone( "get_lantern" ) and common_impl.IsGetCoin("get_coin_10") ) then
      ObjDelete( "gzz_abandoneddistrict_trunk" );
    end;
    
  end;
  
  cmn.AddSubscriber( "get_evidence_1_9", get_evidence_1_9_inv );
  cmn.AddSubscriber( "get_evidence_1_9", get_evidence_1_9_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_button () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_button" ] = {
    type = "get",
    get_obj = "spr_attraction_button",
    room = private.room_objname,
    zz = "zz_attraction",
    zz_gate = "gzz_abandoneddistrict_attraction"
  };
  local get_button_inv = function ()
  
    interface.InventoryItemAdd( "inv_button", "spr_attraction_button" );
  
  end;
  
  local get_button_closezz = function ()

    ObjDelete( "spr_attraction_button_shadow" );
    ObjDelete( "spr_abandoneddistrict_obj"    );

    ObjDelete( "gfx_attraction_button" );
    if ( cmn.IsEventDone( "get_monogram" ) and cmn.IsEventDone( "get_prv_hat" ) and cmn.IsEventDone( "use_figurine" )) then
      ObjDelete( "gzz_abandoneddistrict_attraction" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_button", get_button_inv );
  cmn.AddSubscriber( "get_button", get_button_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_monogram () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_monogram" ] = {
    type = "get",
    get_obj = "spr_attraction_monogram",
    room = private.room_objname,
    zz = "zz_attraction",
    zz_gate = "gzz_abandoneddistrict_attraction"
  };
  local get_monogram_inv = function ()
  
    interface.InventoryItemAdd( "inv_monogram", "spr_attraction_monogram" );

  end;
  
  local get_monogram_closezz = function ()
  
    ObjDelete( "spr_attraction_monogram_shadow" );
    ObjDelete( "gfx_attraction_monogram" );
    if ( cmn.IsEventDone( "get_button" ) and cmn.IsEventDone( "get_prv_hat" ) and cmn.IsEventDone( "use_figurine" )) then
      ObjDelete( "gzz_abandoneddistrict_attraction" );
    end;
  
  end;

  local get_monogram_loc = function ()
  
    ObjSet( "anm_livingroom_window", { alp = 1, playing = true });
    ObjDelete( "grd_livingroom_curtain" );
    ObjDelete( "obj_livingroom_george_bbt" );

  end;

  cmn.AddSubscriber( "get_monogram", get_monogram_inv );
  cmn.AddSubscriber( "get_monogram", get_monogram_closezz, private.room_objname );
  cmn.AddSubscriber( "get_monogram", get_monogram_loc, "rm_livingroom" );
  --------------------------------------------------------------------------------------------
  -- function get_prv_hat () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_prv_hat" ] = {
    type = "get",
    get_obj = "spr_attraction_prv_hat",
    room = private.room_objname,
    zz = "zz_attraction",
    zz_gate = "gzz_abandoneddistrict_attraction"
  };
  local get_prv_hat_inv = function ()

    interface.ProvidePanelItemAdd( "inv_prv_hat", "spr_attraction_prv_hat" );
  
  end;
  
  local get_prv_hat_closezz = function ()

    ObjSet( "obj_attraction_clk_arm", { input = true, active = true } );
    ObjDelete( "gfx_attraction_prv_hat" );
    if ( cmn.IsEventDone( "get_button" ) and cmn.IsEventDone( "get_monogram" ) and cmn.IsEventDone( "use_figurine" )) then
      ObjDelete( "gzz_abandoneddistrict_attraction" );
    end;
    ObjDelete( "spr_abandoneddistrict_hat_2_light" );
    ObjDelete( "spr_attraction_prv_hat_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_prv_hat", get_prv_hat_inv );
  cmn.AddSubscriber( "get_prv_hat", get_prv_hat_closezz, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function get_collect_item_1_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_1_3 = function ()
  
    ObjDelete( "obj_abandoneddistrict_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_1_3", get_collect_item_1_3, private.room_objname );
   --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_7 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_7 = function ()
  
    ObjDelete( "obj_abandoneddistrict_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_7", get_collect_morph_item_1_7, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_prv_knife_silhouette () end;
  --------------------------------------------------------------------------------------------
  local get_prv_knife_silhouette_inv = function ()
  
    interface.ProvidePanelSilhouetteAdd( "inv_prv_knife", "spr_abandoneddistrict_providence_knife_silhouette" );

  end;
  
  local get_prv_knife_silhouette_closezz = function ()

    ObjSet( "spr_abandoneddistrict_providence_knife_silhouette", { alp = 1 } );
    ObjSet( "obj_abandoneddistrict_use_providence_invitem_1", { event_mdown = function() int_providence.Thinking( "providence_invitem_1", "obj_abandoneddistrict_use_providence_invitem_1" ); end; } )

  end;

  local get_prv_knife_silhouette_notadd = function ()

    ObjSet( "obj_abandoneddistrict_use_providence_invitem_1", { event_mdown = function() int_providence.Thinking( "providence_invitem_1", "obj_abandoneddistrict_use_providence_invitem_1" ); end; } )

  end;
  
  cmn.AddSubscriber( "get_prv_knife_silhouette", get_prv_knife_silhouette_inv );
  cmn.AddSubscriber( "get_prv_knife_silhouette", get_prv_knife_silhouette_closezz, private.room_objname );
  cmn.AddSubscriber( "get_prv_knife", get_prv_knife_silhouette_notadd, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_prv_hat_silhouette () end;
  --------------------------------------------------------------------------------------------
  local get_prv_hat_silhouette_inv = function ()
  
    interface.ProvidePanelSilhouetteAdd( "inv_prv_hat", "spr_abandoneddistrict_providence_hat_silhouette" );

  end;
  
  local get_prv_hat_silhouette_closezz = function ()

    ObjSet( "spr_abandoneddistrict_providence_hat_silhouette", { alp = 1 } );
    ObjSet( "obj_abandoneddistrict_use_providence_invitem_2", { event_mdown = function() int_providence.Thinking( "providence_invitem_2", "obj_abandoneddistrict_use_providence_invitem_2" ); end; } )

  end;

  local get_prv_hat_silhouette_notadd = function ()

    ObjSet( "obj_abandoneddistrict_use_providence_invitem_2", { event_mdown = function() int_providence.Thinking( "providence_invitem_2", "obj_abandoneddistrict_use_providence_invitem_2" ); end; } )

  end;
  
  cmn.AddSubscriber( "get_prv_hat_silhouette", get_prv_hat_silhouette_inv );
  cmn.AddSubscriber( "get_prv_hat_silhouette", get_prv_hat_silhouette_closezz, private.room_objname );
  cmn.AddSubscriber( "get_prv_hat", get_prv_hat_silhouette_notadd, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_trunkemblem () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_trunkemblem" ] = {
      type = "use",
      inv_obj = "inv_trunkemblem",
      use_place = "obj_trunk_use_trunkemblem",
      room = private.room_objname,
      zz = "zz_trunk",
      zz_gate = "gzz_abandoneddistrict_trunk"
  };
  local use_trunkemblem_inv = function ()
  
    interface.InventoryItemRemove( "inv_trunkemblem" );
  
  end;
  local use_trunkemblem_beg = function ()
  
    ObjDelete( "obj_trunk_use_trunkemblem" );
  
  end;
  local use_trunkemblem_end = function ()

    ObjSet( "spr_trunk_open", { input = true } );  
    ObjSet( "spr_trunk_evidence_1_9", { input = true } );
    ObjSet( "spr_trunk_open", { alp = 1 } );
    ObjSet( "spr_abandoneddistrict_box_open", { alp = 1 } );
    ObjDelete( "spr_trunk_owl" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_trunkemblem", use_trunkemblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_trunkemblem", use_trunkemblem_inv );
  cmn.AddSubscriber( "use_trunkemblem", use_trunkemblem_end, private.room_objname );
  cmn.AddSubscriber( "use_trunkemblem_inv", use_trunkemblem_inv, private.room_objname );
  cmn.AddSubscriber( "use_trunkemblem_beg", use_trunkemblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_trunkemblem_end", use_trunkemblem_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_figurine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_figurine" ] = {
      type = "use",
      inv_obj = "inv_figurine",
      use_place = "obj_attraction_use_figurine",
      room = private.room_objname,
      zz = "zz_attraction",
      zz_gate = "gzz_abandoneddistrict_attraction"
  };
  local use_figurine_inv = function ()
  
    interface.InventoryItemRemove( "inv_figurine" );
  
  end;
  local use_figurine_beg = function ()
  
    ObjDelete( "obj_attraction_use_figurine" );
  
  end;
  local use_figurine_end = function ()
  
    if ( cmn.IsEventDone( "get_button" ) and cmn.IsEventDone( "get_monogram" ) and cmn.IsEventDone( "get_prv_hat" )) then
      ObjDelete( "gzz_abandoneddistrict_attraction" );
      ObjSet( "gmg_abandoneddistrict_superpuzzle", { input = 1, active = 1, visible = 1 } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_figurine", use_figurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_figurine", use_figurine_inv );
  cmn.AddSubscriber( "use_figurine", use_figurine_end, private.room_objname );
  cmn.AddSubscriber( "use_figurine_inv", use_figurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_figurine_beg", use_figurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_figurine_end", use_figurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_attractionlevel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_attractionlevel" ] = {
      type = "use",
      inv_obj = "inv_attractionlevel",
      use_place = "obj_attraction_use_attractionlevel",
      room = private.room_objname,
      zz = "zz_attraction",
      zz_gate = "gzz_abandoneddistrict_attraction"
  };
  local use_attractionlevel_inv = function ()
  
    interface.InventoryItemRemove( "inv_attractionlevel" );
  
  end;
  local use_attractionlevel_beg = function ()
  
    ObjDelete( "obj_attraction_use_attractionlevel" );
  
  end;
  local use_attractionlevel_end = function ()
  
    ObjSet( "spr_attraction_monogram", { input = true, visible = true, active = true } );
    ObjSet( "spr_attraction_button", { input = true, visible = true, active = true } );
    ObjSet( "spr_attraction_over_3", { alp = 1, input = 1 } );
    ObjSet( "spr_abandoneddistrict_automatic_open_2", { alp = 1 } );
    ObjSet( "obj_attraction_use_figurine", { input = 1, active = 1 } );

    ObjSet( "spr_abandoneddistrict_obj", { alp = 1 } );

    ObjDelete( "spr_abandoneddistrict_automatic_open_1" );
    ObjDelete( "spr_attraction_curtain_1" );
    ObjDelete( "spr_attraction_curtain_2" );
    ObjDelete( "obj_attraction_use_attractionlevel" );
    ObjSet( "spr_attraction_curtain_3", { alp = 1 } ); 
    ObjSet( "obj_attraction_use_figurine", { input = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_attractionlevel", use_attractionlevel_beg, private.room_objname );
  cmn.AddSubscriber( "use_attractionlevel", use_attractionlevel_inv );
  cmn.AddSubscriber( "use_attractionlevel", use_attractionlevel_end, private.room_objname );
  cmn.AddSubscriber( "use_attractionlevel_inv", use_attractionlevel_inv, private.room_objname );
  cmn.AddSubscriber( "use_attractionlevel_beg", use_attractionlevel_beg, private.room_objname );
  cmn.AddSubscriber( "use_attractionlevel_end", use_attractionlevel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_litlantern () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_litlantern" ] = {
      type = "use",
      inv_obj = "inv_litlantern",
      use_place = "obj_abandoneddistrict_use_litlantern",
      room = private.room_objname
  };
  local use_litlantern_inv = function ()
  
    interface.InventoryItemRemove( "inv_litlantern" );
  
  end;
  local use_litlantern_beg = function ()
  
    ObjDelete( "obj_abandoneddistrict_use_litlantern" );
  
  end;
  local use_litlantern_end = function ()
  
    ObjSet( "gzz_abandoneddistrict_attraction", { input = true, active = true } );
    ObjSet( "spr_abandoneddistrict_lantern_used", { alp = 1 } );

    ObjMultiSet( {
      { "spr_abandoneddistrict_light_4",        { alp = 0.8 } },
      { "spr_abandoneddistrict_light_5",        { alp = 0.6 } },
      { "spr_abandoneddistrict_automatic_over", { alp = 1.0 } },
    });

    ObjSet( "spr_abandoneddistrict_rope_over", { alp = 0 } );
    ObjSet( "spr_abandoneddistrict_rope_over_light", { alp = 1 } );
    ObjDelete( "spr_abandoneddistrict_hat_2" );
    ObjSet( "spr_abandoneddistrict_hat_2_light", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_litlantern", use_litlantern_beg, private.room_objname );
  cmn.AddSubscriber( "use_litlantern", use_litlantern_inv );
  cmn.AddSubscriber( "use_litlantern", use_litlantern_end, private.room_objname );
  cmn.AddSubscriber( "use_litlantern_inv", use_litlantern_inv, private.room_objname );
  cmn.AddSubscriber( "use_litlantern_beg", use_litlantern_beg, private.room_objname );
  cmn.AddSubscriber( "use_litlantern_end", use_litlantern_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_abandoneddistrict_providence_invitem_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_abandoneddistrict_providence_invitem_1" ] = {
      type = "use",
      inv_obj = "inv_prv_knife",
      use_place = "obj_abandoneddistrict_use_providence_invitem_1",
      room = private.room_objname,
      zz = "int_button_providence",
      zz_gate = "obj_int_button_providence"
  };
  local use_abandoneddistrict_providence_invitem_1_inv = function ()
  
    interface.ProvidePanelItemRemove( "inv_prv_knife" );
  
  end;
  local use_abandoneddistrict_providence_invitem_1_beg = function ()
  
    ObjDelete( "obj_abandoneddistrict_use_providence_invitem_1" );
  
  end;
  local use_abandoneddistrict_providence_invitem_1_end = function ()
  
    ObjSet( "spr_abandoneddistrict_providence_knife_used", { alp = 1 } );
    ObjSet( "spr_abandoneddistrict_knife", { alp = 1 } );  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_abandoneddistrict_providence_invitem_1", use_abandoneddistrict_providence_invitem_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_abandoneddistrict_providence_invitem_1", use_abandoneddistrict_providence_invitem_1_inv );
  cmn.AddSubscriber( "use_abandoneddistrict_providence_invitem_1", use_abandoneddistrict_providence_invitem_1_end, private.room_objname );
  cmn.AddSubscriber( "use_abandoneddistrict_providence_invitem_1_inv", use_abandoneddistrict_providence_invitem_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_abandoneddistrict_providence_invitem_1_beg", use_abandoneddistrict_providence_invitem_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_abandoneddistrict_providence_invitem_1_end", use_abandoneddistrict_providence_invitem_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_abandoneddistrict_providence_invitem_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_abandoneddistrict_providence_invitem_2" ] = {
      type = "use",
      inv_obj = "inv_prv_hat",
      use_place = "obj_abandoneddistrict_use_providence_invitem_2",
      room = private.room_objname,
      zz = "int_button_providence",
      zz_gate = "obj_int_button_providence"
  };
  local use_abandoneddistrict_providence_invitem_2_inv = function ()
  
    interface.ProvidePanelItemRemove( "inv_prv_hat" );
  
  end;
  local use_abandoneddistrict_providence_invitem_2_beg = function ()
  
    ObjDelete( "obj_abandoneddistrict_use_providence_invitem_2" );
  
  end;
  local use_abandoneddistrict_providence_invitem_2_end = function ()
  
    ObjSet( "spr_abandoneddistrict_providence_hat_used", { alp = 1 } );
    ObjSet( "spr_abandoneddistrict_hat", { alp = 1 } );  
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_abandoneddistrict_providence_invitem_2", use_abandoneddistrict_providence_invitem_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_abandoneddistrict_providence_invitem_2", use_abandoneddistrict_providence_invitem_2_inv );
  cmn.AddSubscriber( "use_abandoneddistrict_providence_invitem_2", use_abandoneddistrict_providence_invitem_2_end, private.room_objname );
  cmn.AddSubscriber( "use_abandoneddistrict_providence_invitem_2_inv", use_abandoneddistrict_providence_invitem_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_abandoneddistrict_providence_invitem_2_beg", use_abandoneddistrict_providence_invitem_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_abandoneddistrict_providence_invitem_2_end", use_abandoneddistrict_providence_invitem_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_providence_abandoneddistrict () end;
  --------------------------------------------------------------------------------------------
  local clk_providence_abandoneddistrict = function ()
  
    if ( not cmn.IsEventDone( "clk_abandoneddistrict_providence_1" ) or not cmn.IsEventDone( "clk_abandoneddistrict_providence_2" ) 
         or ( cmn.IsEventDone( "get_prv_knife" ) and not cmn.IsEventDone( "use_abandoneddistrict_providence_invitem_1" ) )
         or ( cmn.IsEventDone( "get_prv_hat" ) and not cmn.IsEventDone( "use_abandoneddistrict_providence_invitem_2" ) ) ) then
      int_button_providence.StartActiveProvidence();
    end;
  
  end;
  
  cmn.AddSubscriber( "clk_providence_abandoneddistrict", clk_providence_abandoneddistrict, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_abandoneddistrict_providence_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_abandoneddistrict_providence_1" ] = {
    type = "click",
    inv_obj = "spr_abandoneddistrict_providence_bank",
    use_place = "obj_abandoneddistrict_providence_item_1",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"
  };
  local clk_abandoneddistrict_providence_1_beg = function ()
  
    ObjSet( "obj_abandoneddistrict_providence_item_1", { input = false } );
  
  end;
  local clk_abandoneddistrict_providence_1_end = function ()
  
    ObjDelete( "obj_abandoneddistrict_providence_item_1" );
    ObjDelete( "spr_abandoneddistrict_providence_bank" );
    ObjSet( "spr_abandoneddistrict_providence_bank_used", { alp = 1 } );

    ObjDelete( "spr_abandoneddistrict_bank" );
    ObjSet( "spr_abandoneddistrict_bank_used", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_abandoneddistrict_providence_1", clk_abandoneddistrict_providence_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_abandoneddistrict_providence_1", clk_abandoneddistrict_providence_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_abandoneddistrict_providence_1_beg", clk_abandoneddistrict_providence_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_abandoneddistrict_providence_1_end", clk_abandoneddistrict_providence_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_shutter () end;
  --------------------------------------------------------------------------------------------  
  common_impl.hint[ "clk_shutter" ] = {
    type = "click",
    use_place = "obj_attraction_clk_arm",
    room = private.room_objname,
    zz = "zz_attraction",
    zz_gate = "gzz_abandoneddistrict_attraction"
  };
  
  local clk_shutter = function ()

    ObjDelete( "spr_attraction_shutter_2" );
    ObjDelete( "spr_attraction_shutter_1" );
    ObjSet( "obj_attraction_use_attractionlevel", { input = true, visible = true, active = true } );
    ObjDelete( "obj_attraction_clk_arm" );
    ObjDelete( "spr_abandoneddistrict_pen_1" );
    ObjDelete( "spr_attraction_arm_1" );  
    ObjSet( "spr_abandoneddistrict_pen_2", { alp = 1 } );
    ObjSet( "spr_abandoneddistrict_automatic_open_1", { alp = 1 } );
    ObjSet( "spr_attraction_arm_2", { alp = 1 } );

  end;

  cmn.AddSubscriber( "clk_shutter", clk_shutter, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_lantern_burned () end;
  --------------------------------------------------------------------------------------------  
  common_impl.hint[ "clk_lantern_burned" ] = {
    type = "click",
    use_place = "obj_abandoneddistrict_clk_lantern_burned",
    room = private.room_objname
  };
  
  local clk_lantern_burned = function ()

    ObjSet( "spr_abandoneddistrict_light_4", { alp = 0 } );
    ObjSet( "spr_abandoneddistrict_light_5", { alp = 0 } );
    ObjSet( "spr_abandoneddistrict_automatic_over", { alp = 0 } );

    ObjSet( "spr_abandoneddistrict_lantern", { input  = true } );
    ObjSet( "gfx_abandoneddistrict_lantern", { active = true } );

    ObjDelete( "obj_abandoneddistrict_clk_lantern_burned" );
    ObjSet( "spr_abandoneddistrict_hat_2_light", { alp = 0 });--не удалять
    ObjSet( "spr_abandoneddistrict_hat_2", { alp = 1 });

  end;

  cmn.AddSubscriber( "clk_lantern_burned", clk_lantern_burned, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_abandoneddistrict_providence_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_abandoneddistrict_providence_2" ] = {
    type = "click",
    inv_obj = "spr_abandoneddistrict_providence_rope",
    use_place = "obj_abandoneddistrict_providence_item_2",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"
  };
  local clk_abandoneddistrict_providence_2_beg = function ()
  
    ObjSet( "obj_abandoneddistrict_providence_item_2", { input = false } );
  
  end;
  local clk_abandoneddistrict_providence_2_end = function ()
  
    ObjDelete( "obj_abandoneddistrict_providence_item_2" );
    ObjDelete( "spr_abandoneddistrict_providence_rope" );
    ObjSet( "spr_abandoneddistrict_providence_rope_used", { alp = 1 } );

    ObjDelete( "spr_abandoneddistrict_rope" );
    ObjDelete( "obj_abandoneddistrict_rope_over" );
    ObjSet( "spr_abandoneddistrict_rope_used", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_abandoneddistrict_providence_2", clk_abandoneddistrict_providence_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_abandoneddistrict_providence_2", clk_abandoneddistrict_providence_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_abandoneddistrict_providence_2_beg", clk_abandoneddistrict_providence_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_abandoneddistrict_providence_2_end", clk_abandoneddistrict_providence_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_trash () end;
  --------------------------------------------------------------------------------------------
  local win_trash_loc = function ()

    if ( cmn.IsEventDone( "win_trash" ) ) then
      
      ObjDelete( "gho_abandoneddistrict_trash" );
            
    end;

  end;
  cmn.AddSubscriber( "win_trash", win_trash_loc, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_abandoneddistrict_providence () end;
  --------------------------------------------------------------------------------------------
  local vid_abandoneddistrict_providence_end = function ()

    ObjSet( "gho_abandoneddistrict_trash", { input = true, active = true } );

  end;
  
  cmn.AddSubscriber( "vid_abandoneddistrict_providence", vid_abandoneddistrict_providence_end, private.room_objname  );
  cmn.AddSubscriber( "vid_abandoneddistrict_providence_end", vid_abandoneddistrict_providence_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  local vid_abandoneddistrict_providence_p2 = function ()

    VidStop( "vid_abandoneddistrict_providence_p1" );
    ObjSet( "vid_abandoneddistrict_providence_p2", { playing = true } );

  end;
  
  cmn.AddSubscriber( "vid_abandoneddistrict_providence_p2", vid_abandoneddistrict_providence_p2, private.room_objname  );
  --------------------------------------------------------------------------------------------
  local vid_abandoneddistrict_providence_p3 = function ()

    VidStop( "vid_abandoneddistrict_providence_p2" );
    ObjSet( "vid_abandoneddistrict_providence_p3", { playing = true } );

  end;
  
  cmn.AddSubscriber( "vid_abandoneddistrict_providence_p3", vid_abandoneddistrict_providence_p3, private.room_objname  );
  --------------------------------------------------------------------------------------------
  local vid_abandoneddistrict_providence_p4 = function ()

    VidStop( "vid_abandoneddistrict_providence_p3" );
    VidPlay( "vid_abandoneddistrict_providence_p4", private.vid_abandoneddistrict_providence_end );

  end;
  
  cmn.AddSubscriber( "vid_abandoneddistrict_providence_p4", vid_abandoneddistrict_providence_p4, private.room_objname  );


end;
--********************************************************************************************************************
--*********************************************************************************************************************
function public.Load()

    ObjAnimate( "spr_attraction_light", "alp", 1, 0, "", { 0,0,1, 1,0,1, 2,0,1 } );

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_abandoneddistrict();

  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

  if not cmn.IsEventDone( "vid_abandoneddistrict_providence" ) then
  
    int_button_providence.StartLightProvidence();

  end;

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();
  common_impl.EnvPlay( { "common/audio/aud_abandoneddistrict_env" }, "", 0.5 );

  interface.InvestigationButtonCheck();

end;
--*********************************************************************************************************************
function public.Close()

  --common_impl.StopAudio( "env", "common/audio/aud_abandoneddistrict_env", 0.2 );
  if ( not cmn.IsEventDone( "vid_abandoneddistrict_providence" ) ) then

    int_button_providence.StopLightProvidence();

  end;

end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_trunkemblem()

  local item = "inv_trunkemblem";

  if ( common.ApplyObj( item, "obj_trunk_use_trunkemblem", true ) ) then

    cmn.CallEventHandler( "use_trunkemblem_inv" );
    cmn.CallEventHandler( "use_trunkemblem_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_trunkemblem" );
      cmn.CallEventHandler( "use_trunkemblem_end" );
    
    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_owl_amulet", 0, "", 0 );
    common_impl.Lock(true);

    ObjAnimate( "spr_trunk_owl", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_trunk_open", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.0,
      0.6, 0, 1.0
    } );

  elseif common.ApplyObj( item, "gzz_abandoneddistrict_trunk", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_trunk", nil, { 512, 384 } );

  else

    common_impl.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_figurine()

  local item = "inv_figurine";

  if ( common.ApplyObj( item, "obj_attraction_use_figurine", true ) ) then

    cmn.CallEventHandler( "use_figurine_inv" );
    cmn.CallEventHandler( "use_figurine_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_figurine" );
      cmn.CallEventHandler( "use_figurine_end" );
      if ( cmn.IsEventDone( "get_button" ) and cmn.IsEventDone( "get_monogram" ) and cmn.IsEventDone( "get_prv_hat" )) then
        common.CloseSubRoom();
        cmn.GotoRoom( 'mg_superpuzzle' );
      end;
    
    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_guardian", 0, "", 0 );
    ObjAnimate( "spr_attraction_solder", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

  elseif common.ApplyObj( item, "gzz_abandoneddistrict_attraction", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_attraction", nil, { 512, 384 } );

  else

    common_impl.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_attractionlevel()

  local item = "inv_attractionlevel";

  if ( common.ApplyObj( item, "obj_attraction_use_attractionlevel", true ) and cmn.IsEventDone( "clk_shutter" ) ) then

    cmn.CallEventHandler( "use_attractionlevel_inv" );
    cmn.CallEventHandler( "use_attractionlevel_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_attractionlevel" );
      cmn.CallEventHandler( "use_attractionlevel_end" );

    end;

    common_impl.Lock(true);
    ObjAnimate( "spr_attraction_token", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_attraction_token", "pos_x", 0, 0, "",
    { 
      0.0, 0, 153, 
      0.3, 0, 153,
      1.3, 0, 93
    } );    

    ObjAnimate( "spr_attraction_curtain_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 1.0,
      1.3, 0, 1.0,
      1.6, 0, 0.0
    } );

    ObjAnimate( "spr_attraction_curtain_2", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0,
      1.3, 0, 1.0,
      1.6, 0, 0.0
    } );
    ObjAnimate( "spr_attraction_curtain_3", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0,
      1.3, 0, 0.0,
      1.6, 0, 1.0
    } );

    ObjAnimate( "spr_attraction_over_3", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0,
      1.3, 0, 0.0,
      1.6, 0, 1.0
    } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_coin", 0, "", 0 );

  elseif common.ApplyObj( item, "gzz_abandoneddistrict_attraction", false ) and cmn.IsEventDone( "clk_shutter" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_attraction", nil, { 512, 384 } );

  else

    common_impl.WrongApply(); 

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_litlantern()

  local item = "inv_litlantern";

  if ( common.ApplyObj( item, "obj_abandoneddistrict_use_litlantern", false ) ) then

    cmn.CallEventHandler( "use_litlantern_inv" );
    cmn.CallEventHandler( "use_litlantern_beg" );

    local func_after = function ()

      common_impl.Lock( false );

      cmn.SetEventDone( "use_litlantern" );
      cmn.CallEventHandler( "use_litlantern_end" );
      
      ObjAnimate( "spr_abandoneddistrict_light_4", "alp", 1, 0, "", { 0,0,0.8,  3.0,0,1,  6.0,0,0.8 } );
      ObjAnimate( "spr_abandoneddistrict_light_5", "alp", 1, 0, "", { 0,0,0.6,  3.0,0,1,  6.0,0,0.6 } );

    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_lantern", 0, "", 0 );

    ObjAnimate( "spr_abandoneddistrict_light_4", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.8
    } );
    ObjAnimate( "spr_abandoneddistrict_light_5", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.6
    } );
    ObjAnimate( "spr_abandoneddistrict_automatic_over", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_abandoneddistrict_lantern_used", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

  else

    common_impl.WrongApply();   

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_abandoneddistrict_providence_invitem_1()

  local item = "inv_prv_knife";

  if ( ObjIntersect( item, "obj_abandoneddistrict_use_providence_invitem_1" ) and int_providence.show ) then

    cmn.CallEventHandler( "use_abandoneddistrict_providence_invitem_1_inv" );
    cmn.CallEventHandler( "use_abandoneddistrict_providence_invitem_1_beg" );

    local func_after = function ()

      common_impl.Lock( false );      
      cmn.CallEventHandler( "use_abandoneddistrict_providence_invitem_1_end" );

      if cmn.IsEventDone( "clk_abandoneddistrict_providence_1" ) and cmn.IsEventDone( "clk_abandoneddistrict_providence_2" ) and cmn.IsEventDone( "use_abandoneddistrict_providence_invitem_2" ) then

         private.anim_providence( function() cmn.SetEventDone( "use_abandoneddistrict_providence_invitem_1" ); end );

      else 

        if ( cmn.IsEventDone( "clk_abandoneddistrict_providence_1" ) and cmn.IsEventDone( "clk_abandoneddistrict_providence_2" ) and             
             ( not cmn.IsEventDone( "get_prv_hat" ) or cmn.IsEventDone( "use_abandoneddistrict_providence_invitem_2" ) ) ) then
          int_button_providence.StopActiveProvidence();
        end;
        cmn.SetEventDone( "use_abandoneddistrict_providence_invitem_1" );

      end;
    
    end;

    common_impl.Lock( true );

    ObjAnimate( "spr_abandoneddistrict_providence_knife_used", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_providence_knife", 0, "", 0 );

  else

    common_impl.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_abandoneddistrict_providence_invitem_2()

  local item = "inv_prv_hat";

  if ( ObjIntersect( item, "obj_abandoneddistrict_use_providence_invitem_2" ) and int_providence.show ) then

    cmn.CallEventHandler( "use_abandoneddistrict_providence_invitem_2_inv" );
    cmn.CallEventHandler( "use_abandoneddistrict_providence_invitem_2_beg" );

    local func_after = function ()

      common_impl.Lock( false );      
      cmn.CallEventHandler( "use_abandoneddistrict_providence_invitem_2_end" );

      if cmn.IsEventDone( "clk_abandoneddistrict_providence_1" ) and cmn.IsEventDone( "clk_abandoneddistrict_providence_2" ) and cmn.IsEventDone( "use_abandoneddistrict_providence_invitem_1" ) then

         private.anim_providence( function() cmn.SetEventDone( "use_abandoneddistrict_providence_invitem_2" ); end );
      
      else 

        if ( cmn.IsEventDone( "clk_abandoneddistrict_providence_1" ) and cmn.IsEventDone( "clk_abandoneddistrict_providence_2" ) and
             ( not cmn.IsEventDone( "get_prv_knife" ) or cmn.IsEventDone( "use_abandoneddistrict_providence_invitem_1" ) ) ) then
          int_button_providence.StopActiveProvidence();
        end;
        cmn.SetEventDone( "use_abandoneddistrict_providence_invitem_2" );

      end;
    
    end;

    common_impl.Lock( true );

    ObjAnimate( "spr_abandoneddistrict_providence_hat_used", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_providence_hat", 0, "", 0 );

  else

    common_impl.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.get_coin10()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_10");
    cmn.CallEventHandler("get_coin_10");
      if ( cmn.IsEventDone( "get_prv_knife" ) and cmn.IsEventDone( "get_lantern" ) and cmn.IsEventDone("get_evidence_1_9") ) then
      common.CloseSubRoom();
    end;

  end;
    
  common_impl.PlayEffectHO( "spr_trunk_coin", func_after );
end;
--------------------------------------------------------------------------------------------
function private.get_prv_knife()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  cmn.SetEventDone( "get_prv_knife" );
  cmn.CallEventHandler( "get_prv_knife" );

end;
--------------------------------------------------------------------------------------------
function private.get_lantern()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_lantern" );
  cmn.CallEventHandler( "get_lantern" );

end;
--------------------------------------------------------------------------------------------
function private.get_evidence_1_9()

  common_impl.PlayAudio( "sfx", "common/audio/aud_evidence_open", 0, "", 0 );

  local func_end = function ()

    interface.InvestigationButtonItemAdd( "evidence_1_9", "spr_trunk_evidence_1_9" );

    cmn.SetEventDone( "get_evidence_1_9" );
    cmn.CallEventHandler( "get_evidence_1_9" );

    if ( cmn.IsEventDone( "get_prv_knife" ) and cmn.IsEventDone( "get_lantern" ) ) then
      common.CloseSubRoom();
    end;
  
  end;

  interface.DialogEvidenceShow( "evidence_1_9", func_end )

end;
--------------------------------------------------------------------------------------------
function private.get_button()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_button" );
  cmn.CallEventHandler( "get_button" );

end;
--------------------------------------------------------------------------------------------
function private.get_monogram()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_monogram" );
  cmn.CallEventHandler( "get_monogram" );
  cmn.CallEventHandler( "get_monogram_loc" );

end;
--------------------------------------------------------------------------------------------
function private.get_prv_hat()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );

  cmn.SetEventDone( "get_prv_hat" );
  cmn.CallEventHandler( "get_prv_hat" );

end;
--------------------------------------------------------------------------------------------
function private.get_prv_knife_silhouette()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );

  cmn.SetEventDone( "get_prv_knife_silhouette" );
  cmn.CallEventHandler( "get_prv_knife_silhouette" );

end;
--------------------------------------------------------------------------------------------
function private.get_prv_hat_silhouette()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );

  cmn.SetEventDone( "get_prv_hat_silhouette" );
  cmn.CallEventHandler( "get_prv_hat_silhouette" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_abandoneddistrict_providence_1()

  cmn.CallEventHandler( "clk_abandoneddistrict_providence_1_beg" );

  local func_after = function ()

    common_impl.Lock( false );    
    cmn.CallEventHandler( "clk_abandoneddistrict_providence_1_end" );

    if cmn.IsEventDone( "clk_abandoneddistrict_providence_2" ) and cmn.IsEventDone( "use_abandoneddistrict_providence_invitem_1" ) and cmn.IsEventDone( "use_abandoneddistrict_providence_invitem_2" ) then

      private.anim_providence( function() cmn.SetEventDone( "clk_abandoneddistrict_providence_1" ); end );

    else

      if ( cmn.IsEventDone( "clk_abandoneddistrict_providence_2" ) and
           ( not cmn.IsEventDone( "get_prv_knife" ) or cmn.IsEventDone( "use_abandoneddistrict_providence_invitem_1" ) ) and 
           ( not cmn.IsEventDone( "get_prv_hat" ) or cmn.IsEventDone( "use_abandoneddistrict_providence_invitem_2" ) ) ) then
        int_button_providence.StopActiveProvidence();
      end;
      cmn.SetEventDone( "clk_abandoneddistrict_providence_1" );

    end;
  
  end;

  common_impl.Lock( true );
  ObjSet( "spr_abandoneddistrict_providence_bank", { alp = 0 } );
  ObjAnimate( "spr_abandoneddistrict_providence_bank_used", "alp", 0, 0, func_after, { 0, 0, 0, 0.1, 0, 0, 0.3, 0, 1 } );
  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_junk", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.clk_abandoneddistrict_providence_2()

  cmn.CallEventHandler( "clk_abandoneddistrict_providence_2_beg" );

  local func_after = function ()

    common_impl.Lock( false );    
    cmn.CallEventHandler( "clk_abandoneddistrict_providence_2_end" );

    if cmn.IsEventDone( "clk_abandoneddistrict_providence_1" ) and cmn.IsEventDone( "use_abandoneddistrict_providence_invitem_1" ) and cmn.IsEventDone( "use_abandoneddistrict_providence_invitem_2" ) then

      private.anim_providence( function() cmn.SetEventDone( "clk_abandoneddistrict_providence_2" ); end );

    else 

      if ( cmn.IsEventDone( "clk_abandoneddistrict_providence_1" ) and
           ( not cmn.IsEventDone( "get_prv_knife" ) or cmn.IsEventDone( "use_abandoneddistrict_providence_invitem_1" ) ) and 
           ( not cmn.IsEventDone( "get_prv_hat" ) or cmn.IsEventDone( "use_abandoneddistrict_providence_invitem_2" ) ) ) then
        int_button_providence.StopActiveProvidence();
      end;
      cmn.SetEventDone( "clk_abandoneddistrict_providence_2" );

    end;
  
  end;

  common_impl.Lock( true );
  ObjSet( "spr_abandoneddistrict_providence_rope", { alp = 0 } );
  ObjAnimate( "spr_abandoneddistrict_providence_rope_used", "alp", 0, 0, func_after, { 0, 0, 0, 0.1, 0, 0, 0.3, 0, 1 } );
  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_rope", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.anim_providence( func_execute )

  common_impl.ShowBbt( "bbt_providence_allitems" );

  int_button_providence.StopActiveProvidence();

  local array_objects = {
    "spr_abandoneddistrict_providence_bank_used",
    "spr_abandoneddistrict_providence_hat_used",
    "spr_abandoneddistrict_providence_rope_used",
    "spr_abandoneddistrict_providence_knife_used" }

  local func_end = function()

    for i = 1, #array_objects do
      ObjAttach( array_objects[ i ], "rm_abandoneddistrict_providence" );
      ObjSet( array_objects[ i ], { alp = 1 } );
    end;
    common_impl.Lock( false );    
    private.vid_abandoneddistrict_providence( func_execute );

  end;
  
  common_impl.Lock( true );
  for i = 1, #array_objects do
    
    common_impl.PlayEffectHO( array_objects[ i ], func_end, 3, "assets/interface/resources/effect_mask" );
    func_end = nil;

  end;
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_ready", 0, "", 0 );

end;

--*********************************************************************************************************************
function private.clk_shutter()

  common_impl.Lock( true );

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_shutter" );
    cmn.CallEventHandler( "clk_shutter" );

  end;

  ObjAnimate( "spr_attraction_arm_1", "alp", 0, 0, "",
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );

  ObjAnimate( "spr_attraction_arm_2", "alp", 0, 0, "",
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );

  ObjAnimate( "spr_attraction_shutter_2", "pos_y", 0, 0, func_after,
  { 
    0.0, 0, 113, 
    0.3, 0, 113,
    1.1, 0, 300
  } );
  ObjAnimate( "spr_attraction_shutter_1", "pos_y", 0, 0, "",
  { 
    0.0, 0, -51, 
    0.3, 0, -51,
    1.1, 0, -320
  } );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_attraction", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.clk_lantern_burned ()
  
  local func_end = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_lantern_burned" );
    cmn.CallEventHandler( "clk_lantern_burned" );

  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_lantern", 0, "", 0 );

  ObjAnimate( "spr_abandoneddistrict_light_4", "alp", 0, 0, "",
  { 
    0.0, 0, 0.8, 
    0.3, 0, 0.2,
    0.6, 0, 0.8, 
    0.9, 0, 0.2,
    1.2, 0, 0.8, 
    1.5, 0, 0.0
  } );
  ObjAnimate( "spr_abandoneddistrict_light_5", "alp", 0, 0, "",
  { 
    0.0, 0, 0.6, 
    0.3, 0, 0.2,
    0.6, 0, 0.6, 
    0.9, 0, 0.0,
    1.2, 0, 0.6, 
    1.5, 0, 0.0
  } );
  ObjAnimate( "spr_abandoneddistrict_automatic_over", "alp", 0, 0, func_end,
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.2,
    0.6, 0, 0.8, 
    0.9, 0, 0.2,
    1.2, 0, 0.8, 
    1.5, 0, 0.0
  } );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.drag_bank ()

  ObjSet( "spr_abandoneddistrict_providence_bank", { pos_z = 10 } );

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

end;
-------------------------------------------------------------------------------------
function private.drop_bank ()

  local item = "spr_abandoneddistrict_providence_bank";

  ObjSet( item, { pos_z = 0 } );

  if ( ObjIntersect( item, "obj_abandoneddistrict_providence_item_1" ) ) then

    private.clk_abandoneddistrict_providence_1();

  end;

end;
-------------------------------------------------------------------------------------
function private.drag_rope ()

  ObjSet( "spr_abandoneddistrict_providence_rope", { pos_z = 10 } );

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

end;
-------------------------------------------------------------------------------------
function private.drop_rope ()

  local item = "spr_abandoneddistrict_providence_rope";

  ObjSet( item, { pos_z = 0 } );

  if ( ObjIntersect( item, "obj_abandoneddistrict_providence_item_2" ) ) then

    private.clk_abandoneddistrict_providence_2();

  end;

end;
-------------------------------------------------------------------------------------
function private.opn_abandoneddistrict ()

  if not ( cmn.IsEventDone( "opn_abandoneddistrict" ) ) then
    cmn.SetEventDone( "opn_abandoneddistrict" );
  end;

  cmn.CallEventHandler( "opn_abandoneddistrict" ); 

end;
-------------------------------------------------------------------------------------
function private.vid_abandoneddistrict_providence ( func_execute )

  interface.BBTHide();

  private.func_providence = func_execute;
  int_button_providence.StopLightProvidence();  
  common_impl.StopAllMus();
  VidPlay( "vid_abandoneddistrict_providence_p1", "" );  
  interface.DialogVideoShow( "vid_abandoneddistrict_providence", 1, private.vid_abandoneddistrict_providence_end, 3, 4 ); 
  common_impl.PlayAudio( "mus", "common/audio/aud_providence_mus", 1, "", 0.5 );   
  common_impl.PlayAudio( "sfx", "common/audio/aud_abandoneddistrict_providence_p1", 0, "", 0.5 ); 

end;
-------------------------------------------------------------------------------------
function private.vid_abandoneddistrict_providence_end ()  

  --for i = 1, 4 do
  --  VidStop( "vid_abandoneddistrict_providence_p"..i );
  --end;

  interface.DialogVideoHide();
  common_impl.ShowBbt( 'bbt_providence_level1_4_end' );
  
  cmn.SetEventDone( "vid_abandoneddistrict_providence" );
  cmn.CallEventHandler( "vid_abandoneddistrict_providence_end" );
  common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment3_mus", 0, "", 0 );
  common_impl.StopAudio( "mus", "common/audio/aud_providence_mus", 0.2 ); 
  common_impl.StopAudio( "sfx", "common/audio/aud_abandoneddistrict_providence_p4", 0.2 ); 
  int_providence.Hide();

  if ( private.func_providence ) then
    private.func_providence();
    private.func_providence = nil;
  end;
  
end;
--*********************************************************************************************************************
ObjAnimate( "spr_abandoneddistrict_liana_1", "ang", 1, 0, "", { 0.0, 0, -0.03,  2.5, 0, 0.03,  5.0, 0, -0.03 } );
ObjAnimate( "spr_abandoneddistrict_liana_2", "ang", 1, 0, "", { 0.0, 0, 0.03,   3.0, 0, -0.03, 6.0, 0, 0.03 } );
ObjAnimate( "spr_abandoneddistrict_liana_3", "ang", 1, 0, "", { 0.0, 0, -0.03,  3.5, 0, 0.03,  7.0, 0, -0.03 } );
ObjAnimate( "spr_abandoneddistrict_liana_4", "ang", 1, 0, "", { 0.0, 0, 0.06,   2.7, 0, 0.02,  5.4, 0, 0.06 } );
ObjAnimate( "spr_abandoneddistrict_plate", "ang", 1, 0, "", { 0.0, 0, 0.02,   2.7, 0, 0,  5.4, 0, 0.02 } );

ObjAnimate( "spr_abandoneddistrict_light_1", "alp", 1, 0, "", { 0,0,0.3,  1.7,0,1,  3.4,0,0.3 } );
ObjAnimate( "spr_abandoneddistrict_light_2", "alp", 1, 0, "", { 0,0,0.3,  1.5,0,1,  3,0,0.3 } );
ObjAnimate( "spr_abandoneddistrict_light_3", "alp", 1, 0, "", { 0,0,0.3,  1.0,0,1,  2.0,0,0.3 } );
ObjAnimate( "spr_abandoneddistrict_flag_1", "scale_xy", 1, 0, "", { 0,0,1,1,  2,0,0.9,0.9,  4.0,0,1,1 } );
ObjAnimate( "spr_abandoneddistrict_flag_2", "scale_xy", 1, 0, "", { 0,0,1,1,  2,0,0.9,0.9,  4.0,0,1,1 } );
