-- name=rm_basement
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_basement";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_bedsidetable", "room_hub" );
  private.Init_Subroom();  

  ObjSet( "gzz_basement_bedsidetable", { event_mdown = function () 
    cmn.GotoSubRoom( "zz_bedsidetable", nil, { 512, 384 } );
    end;
  } );

  ObjMultiSet( {

    { "spr_bedsidetable_evidence_1_4",    { event_mdown = private.get_evidence_1_4 }},
    { "spr_bedsidetable_evidence_1_5",    { event_mdown = private.get_evidence_1_5 }},
    { "spr_basement_scythe",              { event_mdown = private.get_scythe       }},

    { "obj_bedsidetable_clk_cassette",    { event_mdown = function () private.clk_cassette()  end } },
    { "obj_bedsidetable_clk_button",      { event_mdown = function () private.clk_button_on() end } },
    { "obj_bedsidetable_clk_button_bbt",  { event_mdown = function () common_impl.ShowBbt( 'bbt_basement_mmg_bedsidetable' );  end } },

    { "spr_bedsidetable_coin",            { event_mdown = function () private.get_coin9() end } },
    { "spr_basement_rag",                 { event_mdown = private.clk_rag }},

    { "spr_basement_collect_item",        { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_1_2" );     end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_basement_collect_morph_item",  { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_6" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  });
  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_basement = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true; 
 
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then   
 
      visible_sparkle_area = false;

    end;

    local visible_sparkle_ho = true;  

    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then 
   
      visible_sparkle_ho = false;

    end;

    local gates = 
    {
      "gmg_basement_safe",
      "gzz_basement_bedsidetable"
    };

    for i = 1, #gates do
    
      local name = gates[ i ];

      if ( common.GetObjectPrefix( name ) == "gho" ) then
        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );

      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then   
     
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );

      end;

    end;

    local mas_parent_gfx = 

      {
        private.room_objname,
        "zz_bedsidetable",
      
      };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;

  end;

  cmn.AddSubscriber( "update_game_mode_basement", update_game_mode_basement, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_basement = function ()
    
    local effects_table = 
    {
      "obj_basement_anims",
      "obj_basement_light" 
    }

    local active = true;

    if ( GetPerformanceMode() == 1 ) then

      active = false;

    end;

    for i = 1, #effects_table do

      ObjSet( effects_table[ i ], { active = active } )

    end;

  end;

  cmn.AddSubscriber( "update_performance_mode_basement", update_performance_mode_basement, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_basement () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_basement" ] = {
    type = "click",
    use_place = "grm_office_basement",
    room = "rm_office"
  };

  local opn_basement_map = function ()

    common_impl.VisitMapRoom( "basement" );

  end;

  cmn.AddSubscriber( "opn_basement", opn_basement_map, nil );
  --------------------------------------------------------------------------------------------
  -- function get_chestpiece() end;
  --------------------------------------------------------------------------------------------
  local get_chestpiece_loc = function ()
      
    ObjDelete( "spr_basement_chestpiece" );

  end;
  
  cmn.AddSubscriber( "get_chestpiece", get_chestpiece_loc, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pictureframe() end;
  --------------------------------------------------------------------------------------------
  local get_pictureframe_loc = function ()
  
    ObjDelete( "spr_basement_pictureframe_over" );
    ObjDelete( "spr_basement_pictureframe" );
    ObjDelete( "spr_basement_pictureframe_shadow" );

  end;
    
  cmn.AddSubscriber( "get_pictureframe", get_pictureframe_loc, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coin() end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_9 = function ()

    ObjDelete( "obj_bedsidetable_coin" );

    if ( cmn.IsEventDone( "get_evidence_1_5" ) and  cmn.IsEventDone( "get_evidence_1_4" )) then

      ObjDelete( "gzz_basement_bedsidetable" );

    end;
 
  end;

  cmn.AddSubscriber( "get_coin_9", get_collect_coin_9, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_evidence_1_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_evidence_1_4" ] = {
    type = "get",
    get_obj = "spr_bedsidetable_evidence_1_4",
    room = private.room_objname,
    zz = "zz_bedsidetable",
    zz_gate = "gzz_basement_bedsidetable"
  };

  local get_evidence_1_4_inv = function ()

    ObjDelete( "spr_bedsidetable_paper1_shadow1" );
    ObjDelete( "spr_bedsidetable_paper1_shadow2" );

  end;
  
  local get_evidence_1_4_closezz = function ()
    
    ObjDelete( "spr_bedsidetable_evidence_1_4" );
    ObjDelete( "spr_basement_bedsidetable_paper" );

    if ( cmn.IsEventDone( "get_evidence_1_5" ) and common_impl.IsGetCoin("get_coin_9")) then

        ObjDelete( "gzz_basement_bedsidetable" );

    end;

  end;

  cmn.AddSubscriber( "get_evidence_1_4", get_evidence_1_4_inv );
  cmn.AddSubscriber( "get_evidence_1_4", get_evidence_1_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_evidence_1_5 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_evidence_1_5" ] = {
    type = "get",
    get_obj = "spr_bedsidetable_evidence_1_5",
    room = private.room_objname,
    zz = "zz_bedsidetable",
    zz_gate = "gzz_basement_bedsidetable"
  };

  local get_evidence_1_5_inv = function ()
  
    ObjSet( "obj_dlg_livingroom_search", { input = true });
    ObjDelete( "spr_bedsidetable_cassette" );

  end;
  
  local get_evidence_1_5_closezz = function ()
  
    ObjDelete( "spr_bedsidetable_evidence_1_5" );
    ObjDelete( "gfx_bedsidetable_evidence_1_5" );

    if ( cmn.IsEventDone( "get_evidence_1_4" ) and common_impl.IsGetCoin("get_coin_9")) then

        ObjDelete( "gzz_basement_bedsidetable" );

    end;
  
  end;

  cmn.AddSubscriber( "get_evidence_1_5", get_evidence_1_5_inv );
  cmn.AddSubscriber( "get_evidence_1_5", get_evidence_1_5_closezz, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function get_collect_item_1_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_1_2 = function ()
  
    ObjDelete( "obj_basement_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_1_2", get_collect_item_1_2, private.room_objname );
   --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_6 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_6 = function ()
  
    ObjDelete( "obj_basement_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_6", get_collect_morph_item_1_6, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cassette () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cassette" ] = {
      type = "use",
      inv_obj = "inv_cassette",
      use_place = "obj_bedsidetable_use_cassette",
      room = private.room_objname,
      zz = "zz_bedsidetable",
      zz_gate = "gzz_basement_bedsidetable"
  };

  local use_cassette_inv = function ()
  
    interface.InventoryItemRemove( "inv_cassette" );
  
  end;

  local use_cassette_beg = function ()
  
    ObjDelete( "obj_bedsidetable_use_cassette" );
  
  end;

  local use_cassette_end = function ()

    ObjSet("obj_bedsidetable_clk_cassette",{ alp = 1, input = true });
    ObjSet("obj_bedsidetable_cassette",    { alp = 1 });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cassette", use_cassette_beg, private.room_objname );
  cmn.AddSubscriber( "use_cassette", use_cassette_inv );
  cmn.AddSubscriber( "use_cassette", use_cassette_end, private.room_objname );
  cmn.AddSubscriber( "use_cassette_inv", use_cassette_inv, private.room_objname );
  cmn.AddSubscriber( "use_cassette_beg", use_cassette_beg, private.room_objname );
  cmn.AddSubscriber( "use_cassette_end", use_cassette_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_batteries () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_batteries" ] = {
      type = "use",
      inv_obj = "inv_batteries",
      use_place = "obj_bedsidetable_use_batteries",
      room = private.room_objname,
      zz = "zz_bedsidetable",
      zz_gate = "gzz_basement_bedsidetable"
  };
  local use_batteries_inv = function ()
  
    interface.InventoryItemRemove( "inv_batteries" );
  
  end;
  local use_batteries_beg = function ()
  
    ObjDelete( "obj_bedsidetable_use_batteries" );
  
  end;
  local use_batteries_end = function ()
  
    ObjMultiSet({
      {"spr_bedsidetable_batteries",              { alp = 1 } },
      {"spr_bedsidetable_batteries_inner_shadow", { alp = 1 } },
      {"spr_bedsidetable_batteries_shadow",       { alp = 1 } },
      {"spr_basement_taperecorder_accum",         { alp = 1 } },
      --{"spr_bedsidetable_light2",                 { alp = 1 } },
      });

    if (cmn.IsEventDone( "use_batteries" )  and  
        cmn.IsEventDone( "clk_cassette"))    then
        
        ObjMultiSet({
        { "obj_bedsidetable_clk_button" ,{ alp = 1, input = true } },
        { "spr_bedsidetable_light1" ,{ alp = 1 } },
        --{ "spr_bedsidetable_light2" ,{ alp = 0 } },
        });
        ObjDelete("spr_bedsidetable_light2");
        ObjDelete("obj_bedsidetable_clk_button_bbt");

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_batteries", use_batteries_beg, private.room_objname );
  cmn.AddSubscriber( "use_batteries", use_batteries_inv );
  cmn.AddSubscriber( "use_batteries", use_batteries_end, private.room_objname );
  cmn.AddSubscriber( "use_batteries_inv", use_batteries_inv, private.room_objname );
  cmn.AddSubscriber( "use_batteries_beg", use_batteries_beg, private.room_objname );
  cmn.AddSubscriber( "use_batteries_end", use_batteries_end, private.room_objname );

end;
  --------------------------------------------------------------------------------------------
  -- function get_scythe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_scythe" ] = {
    type = "get",
    get_obj = "obj_basement_scythe_hint",
    room = "rm_basement";
  };
  local get_scythe_inv = function ()
  
    interface.InventoryItemAdd( "inv_scythe", "spr_basement_scythe" );
  
  end;
  
  local get_scythe_closezz = function ()
  
    ObjDelete( "gfx_basement_scythe" );
    ObjDelete( "spr_basement_scythe_shadow" );
    ObjDelete( "obj_basement_scythe_hint" );
    
  end;
  
  cmn.AddSubscriber( "get_scythe", get_scythe_inv );
  cmn.AddSubscriber( "get_scythe", get_scythe_closezz, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function clk_casset () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_cassette" ] = {
    type = "click",
    use_place = "obj_bedsidetable_clk_cassette",
    room = "rm_basement",
    zz = "zz_bedsidetable",
    zz_gate = "gzz_basement_bedsidetable"
  };

  local clk_cassette_beg = function ()
  
    ObjDelete( "obj_bedsidetable_clk_cassette" );
  
  end;

  local clk_cassette_end = function ()

    ObjMultiSet({
    { "obj_bedsidetable_cassette" ,     { alp = 0 } },
    { "spr_basement_taperecorder_open" ,{ alp = 0 } },
    { "spr_bedsidetable_opened_cover" , { alp = 0 } },

    });

    if (cmn.IsEventDone( "use_batteries" )  and  
        cmn.IsEventDone( "clk_cassette"))    then

        ObjMultiSet({

        { "obj_bedsidetable_clk_button" ,{ alp = 1, input = true } },
        { "spr_bedsidetable_light1" ,{ alp = 1 } },
        --{ "spr_bedsidetable_light2" ,{ alp = 0 } },
        });
        ObjDelete("spr_bedsidetable_light2");
        ObjDelete("obj_bedsidetable_clk_button_bbt");

    end;


  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_cassette", clk_cassette_beg, private.room_objname );
  cmn.AddSubscriber( "clk_cassette", clk_cassette_end, private.room_objname );
  cmn.AddSubscriber( "clk_cassette_beg", clk_cassette_beg, private.room_objname );
  cmn.AddSubscriber( "clk_cassette_end", clk_cassette_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_button_on () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_button_on" ] = {
    type = "click",
    use_place = "obj_bedsidetable_clk_button",
    room = "rm_basement",
    zz = "zz_bedsidetable",
    zz_gate = "gzz_basement_bedsidetable"
  };

  local clk_button_on_beg = function ()
  
    ObjDelete( "obj_bedsidetable_clk_button" );
    ObjSet( "spr_basement_taperecorder_open" ,{ alp = 1 } );
  
  end;

  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_button_on", clk_button_on_beg, private.room_objname );
  cmn.AddSubscriber( "clk_button_on_beg", clk_button_on_beg, private.room_objname );
  --------------------------------------------------------------------------------------------
 --------------------------------------------------------------------------------------------
  -- function clk_rag () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_rag" ] = {
    type = "click",
    use_place = "spr_basement_rag",
    room = "rm_basement"
  };

  local clk_rag_end = function ()

    ObjDelete( "spr_basement_rag" );
    ObjSet( "spr_basement_rag_1", { alp = 1 });
    ObjSet( "gmg_basement_safe", { active = true, visible = true, input = true });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_rag", clk_rag_end, private.room_objname );
  cmn.AddSubscriber( "clk_rag_end", clk_rag_end, private.room_objname );
 --------------------------------------------------------------------------------------------
  local opn_casette_tape_beg = function ()
  
  end;
  
  local opn_casette_tape_end = function ()

    ObjDelete("vid_bedsidetable_casset");
    ObjDelete("spr_bedsidetable_picked_button");

    ObjMultiSet({
      { "spr_bedsidetable_evidence_1_5", { alp = 1, input = true, visible = true, active = true } },
      { "spr_bedsidetable_opened_cover", { alp = 1 } },
      { "spr_bedsidetable_cassette",     { alp = 0 } },
      { "obj_bedsidetable_cassette",     { alp = 1 } },
      { "spr_bedsidetable_light1" ,      { alp = 0 } },
      { "spr_bedsidetable_light2" ,      { alp = 1 } },
    });

  end;
  
  cmn.AddSubscriber( "opn_casette_tape", opn_casette_tape_beg, private.room_objname );
  cmn.AddSubscriber( "opn_casette_tape", opn_casette_tape_end, private.room_objname );
  cmn.AddSubscriber( "opn_casette_tape_beg", opn_casette_tape_beg, private.room_objname );
  cmn.AddSubscriber( "opn_casette_tape_end", opn_casette_tape_end, private.room_objname );
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function private.Init_Subroom()

  -------------------------------------------------------------------------------------------- 
  subroom.Define( "zz_bedsidetable" );
  --------------------------------------------------------------------------------------------
  function zz_bedsidetable.PreOpen()

  end;
  --------------------------------------------------------------------------------------------
  function zz_bedsidetable.PreClose()

  end;
  --------------------------------------------------------------------------------------------

end;

--*********************************************************************************************************************
function public.Open()

  private.opn_basement();

  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();
  common_impl.EnvPlay( { "common/audio/aud_cellar_env" }, "", 0.5 );

  interface.InvestigationButtonCheck();

end;
--*********************************************************************************************************************
function public.Close()

  --common_impl.StopAudio( "env", "common/audio/aud_cellar_env", 0.2 );

end;
--*********************************************************************************************************************
function public.PreClose()

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_cassette()

  local item = "inv_cassette";

  if ( common.ApplyObj( item, "obj_bedsidetable_use_cassette", true ) ) then

    cmn.CallEventHandler( "use_cassette_inv" );
    cmn.CallEventHandler( "use_cassette_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_cassette" );
      cmn.CallEventHandler( "use_cassette_end" );

    end;

    common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_tape", 0, "", 0 );

    ObjAnimate( "obj_bedsidetable_cassette", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 1.0
    } );
    ObjAnimate( "spr_bedsidetable_opened_cover", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.6, 0, 1.0
    } );

  elseif common.ApplyObj( item, "gzz_basement_bedsidetable", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bedsidetable", nil, { 512, 384 } );

  else

    common_impl.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_batteries()

  local item = "inv_batteries";

  if ( common.ApplyObj( item, "obj_bedsidetable_use_batteries", true ) ) then

    cmn.CallEventHandler( "use_batteries_inv" );
    cmn.CallEventHandler( "use_batteries_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_batteries" );
      cmn.CallEventHandler( "use_batteries_end" );

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_battery", 0, "", 0 );

    ObjAnimate( "spr_bedsidetable_batteries", "alp", 0, 0,func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_bedsidetable_batteries_inner_shadow", "alp", 0, 0,"",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_bedsidetable_batteries_shadow", "alp", 0, 0,"",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_bedsidetable_light2", "alp", 0, 0,"",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    
    private.LightAnimation();

  elseif common.ApplyObj( item, "gzz_basement_bedsidetable", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bedsidetable", nil, { 512, 384 } );

  else

    common_impl.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.get_coin9()

  local func_after = function ()

    common_impl.GetCoinDone("get_coin_9");
    cmn.CallEventHandler("get_coin_9");

    if ( cmn.IsEventDone( "get_evidence_1_5" ) and  cmn.IsEventDone( "get_evidence_1_4" )) then

      common.CloseSubRoom();

    end;
  
  end;
    
  common_impl.PlayEffectHO( "spr_bedsidetable_coin", func_after );
end;
--------------------------------------------------------------------------------------------
function private.get_scythe()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_scythe" );
  cmn.CallEventHandler( "get_scythe" );

end;
--------------------------------------------------------------------------------------------
function private.get_evidence_1_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_evidence_open", 0, "", 0 );

  local func_end = function ()

    interface.InvestigationButtonItemAdd( "evidence_1_4", "spr_bedsidetable_evidence_1_4" );

    cmn.SetEventDone( "get_evidence_1_4" );
    cmn.CallEventHandler( "get_evidence_1_4" );

    if ( cmn.IsEventDone( "get_evidence_1_5" ) and common_impl.IsGetCoin("get_coin_9") ) then

      common.CloseSubRoom();

    end;
  
  end;

  interface.DialogEvidenceShow( "evidence_1_4", func_end );

end;
--------------------------------------------------------------------------------------------
function private.get_evidence_1_5()

  common_impl.PlayAudio( "sfx", "common/audio/aud_evidence_open", 0, "", 0 );

  local func_end = function ()

    interface.InvestigationButtonItemAdd( "evidence_1_5", "spr_bedsidetable_evidence_1_5", function() interface.KeyTaskAdd( "talk_george", true, function()cmn.SetEventDone( "get_evidence_1_5" ) end ); end );

    cmn.CallEventHandler( "get_evidence_1_5" );

    if ( cmn.IsEventDone( "get_evidence_1_4" ) and common_impl.IsGetCoin("get_coin_9") ) then

      common.CloseSubRoom();

    end;
  
  end;

  interface.DialogEvidenceShow( "evidence_1_5", func_end );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_cassette()

  cmn.CallEventHandler( "clk_cassette_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_cassette" );
    cmn.CallEventHandler( "clk_cassette_end" );

    common_impl.Lock(false);
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_recorder_cover", 0, "", 0 );

  common_impl.Lock(true);

  ObjAnimate( "obj_bedsidetable_cassette", "alp", 0, 0, func_after,
  { 
    0.0, 0, 1.0,
    0.3, 0, 0.0
  } );
  ObjAnimate( "spr_bedsidetable_opened_cover", "alp", 0, 0, "",
  { 
    0.0, 0, 1.0,
    0.3, 0, 0.0
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_rag()

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_cloth_cellar", 0, "", 0 );
  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_rag" );
    cmn.CallEventHandler( "clk_rag_end" );

  end;
 
  common_impl.Lock( true );

  ObjAnimate( "spr_basement_rag", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );

  ObjAnimate( "spr_basement_rag_1", "alp", 0, 0, "", 
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_button_on()
  
  if ( not cmn.IsEventDone ( "clk_button_on" ) and cmn.IsEventDone ( "use_batteries" ) and cmn.IsEventDone ( "clk_cassette" ) ) then

    cmn.CallEventHandler( "clk_button_on_beg" );
    common_impl.PlayAudio( "sfx", "common/audio/aud_recorder_play", 0, "", 0 );
    private.opn_casette_tape(); 

  end;

end;

--------------------------------------------------------------------------------------------
-- function clk_providence () end;
--------------------------------------------------------------------------------------------
local clk_providence_basement = function()

  if ( not cmn.IsEventDone ( "clk_providence_basement" ) ) then

    ObjSet( "vid_basement_providence", { alp = 1, active = true, input = false, visible = true } );
    ObjSet( private.room_objname, { input = false } );
    ObjAttach( "vid_basement_providence", private.room_objname );
    
    local func_after = function ()

      interface.DialogVideoHide();
      ObjSet( private.room_objname, { input = true } );
      cmn.SetEventDone( "clk_providence_basement" );
      common_impl.StopAudio( "sfx", "common/audio/aud_basement_pugalka", 0.2 );
      common_impl.ShowBbt( 'bbt_vid_basement_providence', 1 );
      common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment1_mus", 0, "", 0 );

    end;

    --common_impl.PlayAudio( "sfx", "common/audio/aud_square_threat", 0, "", 0 );
    common_impl.StopAllMus();
    interface.DialogVideoShow( "vid_basement_providence", 1, func_after, 3 );
    common_impl.PlayAudio( "sfx", "common/audio/aud_basement_pugalka", 0, "", 0 );    
    VidPlay( "vid_basement_providence", func_after ); 

  end;

end;

cmn.AddSubscriber( "clk_providence_basement", clk_providence_basement, private.room_objname );

--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_basement()

  if not ( cmn.IsEventDone( "opn_basement" ) ) then

    cmn.SetEventDone( "opn_basement" );
    common_impl.PlayAudio( "mus", "common/audio/aud_scary_mus", 0, "", 0 );

  end;

  cmn.CallEventHandler( "opn_basement" ); 

end;
--------------------------------------------------------------------------------------------
function private.BbtRecorder( number )

  if ( number > 3 ) then

    return;

  end;

  common_impl.ShowBbt( 'bbt_basement_recorder_voc_'..number );

  ObjSet( "tmr_bedsidetable_recorder", { playing = 1, time = 5, endtrig = function () 

    private.BbtRecorder( number + 1 );

  end; } );

end;
--------------------------------------------------------------------------------------------
function private.opn_casette_tape()

  if ( not cmn.IsEventDone("opn_casette_tape") ) then
 
    local func_after = function()

      local func_end = function()

        interface.DialogVideoHide();
        common_impl.StopAudio( "env", "common/audio/aud_recorder_tape", 0 );
        common_impl.StopAudio( "voc", "common/audio/aud_recorder_voc", 1, "", 0.5 );
        common_impl.PlayAudio( "mus", "common/audio/aud_adventure2_mus", 0, "", 0 );
        common_impl.PlayAudio( "sfx", "common/audio/aud_recorder_open", 0, "", 0 );
        cmn.CallEventHandler( "opn_casette_tape_end" );
        cmn.SetEventDone( "opn_casette_tape" );
        cmn.SetEventDone( "clk_button_on" );

        VidStop( "vid_bedsidetable_casset");
        ObjSet( "vid_bedsidetable_casset", { alp = 0 });

        common_impl.Lock( false );

      end;

      cmn.CallEventHandler( "opn_casette_tape_beg" );

      common_impl.PlayAudio( "env", "common/audio/aud_recorder_tape", 1, "", 0 );
      common_impl.PlayAudio( "voc", "common/audio/aud_recorder_voc",  0, "", 0 );

      private.BbtRecorder( 1 );     

      ObjAnimate( "spr_bedsidetable_picked_button", "alp", 0, 0, func_end,
      { 
        0.0,  0, 1.0, 
        14.0, 0, 1.0,
        14.3, 0, 0.0,
      } ); 

    end;

    common_impl.Lock( true );

    ObjSet( "vid_bedsidetable_casset", { alp = 1 });
    VidPlay( "vid_bedsidetable_casset", "" );

    ObjAnimate( "spr_bedsidetable_picked_button", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } ); 

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.LightAnimation()

  ObjAnimate( "spr_bedsidetable_light2", "alp", 1, 0, "",
  { 
    0.0, 0, 1.0, 
    1.0, 0, 0.7,
    2.0, 0, 1.0,
  } ); 

end;
--*********************************************************************************************************************
---- function *** NO PROGRESS ANIMATION *** () end;
--*********************************************************************************************************************
  ObjMultiSet({
    {"spr_basement_grass",     { scale_x = 1, scale_y = 1 }},
    {"spr_basement_horse",     { ang = 0.1   }},
    {"spr_basement_plane",     { ang = -0.06 }},
    {"obj_basement_light",     { ang = -0.06 }},
    {"spr_basement_grass_2",   { ang = 0.04  }},
    {"spr_basement_light_add", { alp = 1 }},
    {"spr_basement_fabric1",   { scale_x = 1, scale_y = 1 }},
    {"spr_basement_fabric2",   { scale_x = 1, scale_y = 1 }}, 
  });

  ObjAnimate( "spr_basement_grass", "scale_xy", 1, 0, "",
  { 
    0.0, 0, 1, 1, 
    1.6, 0, 0.98,0.98,
    3.2, 0, 1, 1
  } );

  ObjAnimate( "spr_basement_horse", "ang", 1, 0, "",
  { 
    0.0, 3, 0.1, 
    1.5, 3, -0.1,
    3.0, 3, 0.1
  } );

  ObjAnimate( "spr_basement_plane", "ang", 1, 0, "",
  { 
    0.0, 3, -0.06, 
    1.7, 3, 0.06,
    3.4, 3, -0.06
  } );

  ObjAnimate( "obj_basement_light", "ang", 1, 0, "",
  { 
    0.0, 3, -0.06, 
    1.9, 3, 0.06,
    3.8, 3, -0.06
  } );

  ObjAnimate( "spr_basement_grass_2", "ang", 1, 0, "",
  { 
    0.0, 3, 0.04, 
    2.0, 3, -0.04,
    4.0, 3, 0.04
  } );

  ObjAnimate( "spr_basement_light_add", "alp", 1, 0, "",
  { 
    0.0, 0, 1, 
    1.2, 0, 0.5,
    2.4, 0, 1
  } );

  ObjAnimate( "spr_basement_fabric1", "scale_xy", 1, 0, "",
  { 
    0.0, 0, 1.0, 1.0, 
    1.7, 0, 0.97, 0.97,
    3.4, 0, 1.0, 1.0
  } );

  ObjAnimate( "spr_basement_fabric2", "scale_xy", 1, 0, "",
  { 
    0.0, 0, 1.0, 1.0, 
    1.7, 0, 0.97, 0.97,
    3.4, 0, 1.0, 1.0
  } );