-- name=rm_fork
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_fork";
  private.character = 1;
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_pickuptruck", "room_hub" );
  ObjAttach( "zz_shore", "room_hub" );
  ObjAttach( "zz_pointer", "room_hub" );
  ObjAttach( "zz_bridge", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet( {
    { "spr_pickuptruck_handle", { event_mdown = private.get_handle } },
    { "spr_pickuptruck_brokenspade", { event_mdown = private.get_brokenspade } },
    { "spr_pickuptruck_screwdriver", { event_mdown = private.get_screwdriver } },
    { "spr_pickuptruck_nails", { event_mdown = private.get_nails } },
    { "spr_shore_hammer", { event_mdown = private.get_hammer } },
    { "spr_shore_emblemelement2", { event_mdown = private.get_emblemelement2 } },
    { "spr_shore_boards", { event_mdown = private.get_boards } },
    { "spr_shore_fishinghook_after", { event_mdown = private.get_fishinghook } },
    { "spr_shore_object", { event_mdown = private.get_object_1 } },
    { "spr_shore_ring", { event_mdown = private.get_ring } },
    { "spr_pointer_cassette", { event_mdown = private.get_cassette } },
    { "obj_fork_providence_item_2", { event_mdown = function() int_providence.Thinking( "providence_2", "obj_fork_providence_item_2" ) end } },
    { "obj_fork_providence_item_1", { event_mdown = function() int_providence.Thinking( "providence_1", "obj_fork_providence_item_1" ) end } },
    { "obj_vid_fork_ancient", { event_mdown = private.vid_fork_ancient } },
    { "obj_pointer_clk_box", { event_mdown = private.clk_box } },
    { "obj_pickuptruck_clk_lock", { event_mdown = function() private.clk_lock() end } },
    { "obj_pickuptruck_clk_door", { event_mdown = private.clk_door } },
    { "obj_pointer_clk_dictaphone", { event_mdown = private.clk_dictaphone } },
    { "obj_pickuptruck_use_scythe", {event_mdown = private.clk_brab } },
    { "obj_pickuptruck_use_scissors", { event_mdown = private.clk_cover } },
    { "obj_pickuptruck_use_briefcasekey", { event_mdown = private.clk_close_case } },
    { "obj_barrier_clk_barrier", { event_mdown = private.clk_barrier } },
    { "spr_pointer_tablet_1", { event_mdown = function() private.clk_tablet( 1 ) end } },
    { "spr_pointer_tablet_2", { event_mdown = function() private.clk_tablet( 2 ) end } },
    { "spr_pointer_tablet_1",{event_mdown = private.clk_pointer1} },
    { "spr_pointer_tablet_2",{event_mdown = private.clk_pointer2} },
    { "obj_fork_clk_shore",{event_mdown = private.clk_shore} },
    { "spr_shore_metal_note",{ event_mdown = function() common_impl.NoteScale( 'open', 'spr_shore_metal_note' ); common_impl.ShowBbt( 'bbt_shore_metal_note', 1 ); end } },
    { "spr_shore_metal_note_big",{event_mdown = function() common_impl.NoteScale( 'close', 'spr_shore_metal_note' ); end } },
    { "obj_fork_providence_item_3",{event_mdown = function() int_providence.Thinking( "providence_invitem_1", "obj_fork_providence_item_3" ) end } },
    { "obj_shore_use_pliers",{event_mdown = function() private.Ring_clk() end } },
    { "obj_shore_clk_case",{event_mdown = function() common_impl.ShowBbt( "bbt_shore_clk_case", 1 ) end } },
    { "spr_pointer_coin",{event_mdown = function() private.get_coin1() end } },
    { "spr_pickuptruck_coin",{event_mdown = function() private.get_coin2() end } },
    { "spr_shore_coin",{event_mdown = function() private.get_coin3() end } },
    { "spr_fork_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_2" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "obj_shore_use_pyrotechinics",{ event_mdown = private.clk_alligator_hit } },
    { "spr_fork_providence_bush",   { input = true, drag = true, event_startdrag = private.drag_bush, event_dragdrop = private.drop_bush } },
    { "spr_fork_providence_plate",   { input = true, drag = true, event_startdrag = private.drag_plate, event_dragdrop = private.drop_plate } },
    { "spr_fork_providence_timber", { input = true, drag = true, event_startdrag = private.drag_timber, event_dragdrop = private.drop_timber } },

  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_fork = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    local gates = {
    "gzz_fork_pickuptruck",
    "gzz_fork_shore",
    "gzz_fork_pointer",
    "gzz_fork_bridge",
    "gzz_fork_barrier"
    }
    for i = 1, #gates do
    
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 

      {
        private.room_objname,
        "zz_bridge",
        "zz_pointer",
        "zz_shore",
        "zz_pickuptruck",
      
      };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_fork", update_game_mode_fork, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_fork = function ()
    
    local effects_table = 
    {
      "obj_fork_anims",
      "vid_shore_water", 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;
   
    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_fork", update_performance_mode_fork, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_fork () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_fork" ] = {
    type = "click",
    use_place = "grm_pier_fork",
    room = "rm_pier"
  };

  local opn_fork_map = function ()

    common_impl.VisitMapRoom( "fork" );

  end;
  local opn_fork_rm = function ()

    if ng_global.progress["std"]["opn_fork"].silhouette then

      ObjDelete( "spr_fork_silhuette" ); 
      ObjDelete( "obj_fork_bbt_owlman" );   

    end;

  end;

  cmn.AddSubscriber( "opn_fork", opn_fork_map, nil );
  cmn.AddSubscriber( "opn_fork", opn_fork_rm, "rm_fork" );
  --------------------------------------------------------------------------------------------
  -- function get_coins () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_1 = function ()
 
    ObjDelete( "obj_pointer_coin" );

    if cmn.IsEventDone( "get_cassette" ) then
      ObjDelete( "gfx_pointer_cassette" );
      ObjDelete( "gzz_fork_pointer" );
    end;
    
  end;
  cmn.AddSubscriber( "get_coin_1", get_collect_coin_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  local get_collect_coin_2 = function ()

    ObjDelete( "obj_pickuptruck_coin" );

    if cmn.IsEventDone("get_screwdriver") and cmn.IsEventDone("get_brokenspade") and cmn.IsEventDone("get_nails") and cmn.IsEventDone("get_handle") then
      ObjDelete( "gzz_fork_pickuptruck" );
    end;
 
  end;
  cmn.AddSubscriber( "get_coin_2", get_collect_coin_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  local get_collect_coin_3 = function ()

    ObjDelete( "obj_shore_coin" );
   
    if cmn.IsEventDone("get_ring") then
      ObjDelete( "gzz_fork_shore" );
    end;

  end;
  cmn.AddSubscriber( "get_coin_3", get_collect_coin_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_handle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_handle" ] = {
    type = "get",
    get_obj = "spr_pickuptruck_handle",
    room = private.room_objname,
    zz = "zz_pickuptruck",
    zz_gate = "gzz_fork_pickuptruck"
  };
  local get_handle_inv = function ()
  
    interface.InventoryItemAdd( "inv_handle", "spr_pickuptruck_handle" );
    ObjSet( "spr_brokenspade_plus_light", { alp = 1 } );
  
  end;
  
  local get_handle_closezz = function ()
  
    ObjDelete( "gfx_pickuptruck_handle" );
    ObjDelete( "spr_pickuptruck_handle_shadow" );
    if cmn.IsEventDone("get_screwdriver") and common_impl.IsGetCoin("get_coin_2")
    and  cmn.IsEventDone("get_brokenspade") and cmn.IsEventDone("get_nails") then
      ObjDelete( "gzz_fork_pickuptruck" );
    end;

  end;
  
  cmn.AddSubscriber( "get_handle", get_handle_inv );
  cmn.AddSubscriber( "get_handle", get_handle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenspade () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokenspade" ] = {
    type = "get",
    get_obj = "spr_pickuptruck_brokenspade",
    room = private.room_objname,
    zz = "zz_pickuptruck",
    zz_gate = "gzz_fork_pickuptruck"
  };
  local get_brokenspade_inv = function ()
  
    interface.InventoryItemAdd( "inv_brokenspade", "spr_pickuptruck_brokenspade" );
    ObjSet( "inv_brokenspade", { drag = 0 });

  end;
  
  local get_brokenspade_closezz = function ()
  
    ObjDelete( "gfx_pickuptruck_brokenspade" );
    ObjDelete( "spr_pickuptruck_brokenspade_shadow" );
    ObjDelete( "spr_pickuptruck_brokenspade_over" );
    if cmn.IsEventDone("get_screwdriver") and common_impl.IsGetCoin("get_coin_2")
    and  cmn.IsEventDone("get_handle") and cmn.IsEventDone("get_nails") then
      ObjDelete( "gzz_fork_pickuptruck" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_brokenspade", get_brokenspade_inv );
  cmn.AddSubscriber( "get_brokenspade", get_brokenspade_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_screwdriver () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_screwdriver" ] = {
    type = "get",
    get_obj = "obj_screwdiver_hint",
    room = private.room_objname,
    zz = "zz_pickuptruck",
    zz_gate = "gzz_fork_pickuptruck"
  };
  local get_screwdriver_inv = function ()
  
    interface.InventoryItemAdd( "inv_screwdriver", "spr_pickuptruck_screwdriver" );
    if ( not cmn.IsEventDone( "use_screwdriver2_2" ) or cmn.IsEventDone( "get_knife" ) ) then
      ObjSet( "spr_remotecontrol_plus_light", { visible = true } );
    end;
  
  end;
  
  local get_screwdriver_closezz = function ()
  
    ObjDelete( "gfx_pickuptruck_screwdriver" );
    ObjDelete( "spr_pickuptruck_screwdriver_shadow" );
    if cmn.IsEventDone("get_brokenspade") and common_impl.IsGetCoin("get_coin_2") 
    and  cmn.IsEventDone("get_handle") and cmn.IsEventDone("get_nails") then
      ObjDelete( "gzz_fork_pickuptruck" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_screwdriver", get_screwdriver_inv );
  cmn.AddSubscriber( "get_screwdriver", get_screwdriver_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hammer () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hammer" ] = {
    type = "get",
    get_obj = "spr_shore_hammer",
    room = private.room_objname,
    zz = "zz_shore",
    zz_gate = "gzz_fork_shore"
  };
  local get_hammer_inv = function ()
  
    interface.InventoryItemAdd( "inv_hammer", "spr_shore_hammer" );
     
  end;
  
  local get_hammer_closezz = function ()
  
    ObjDelete( "gfx_shore_hammer" );
    ObjDelete( "spr_shore_hammer_shadow" );
    if cmn.IsEventDone("get_ring") and cmn.IsEventDone("get_boards") and  cmn.IsEventDone("get_fishinghook") and common_impl.IsGetCoin("get_coin_3") then
      ObjDelete( "gzz_fork_shore" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_hammer", get_hammer_inv );
  cmn.AddSubscriber( "get_hammer", get_hammer_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_emblemelement2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_emblemelement2" ] = {
    type = "get",
    get_obj = "spr_shore_emblemelement2",
    room = private.room_objname,
    zz = "zz_shore",
    zz_gate = "gzz_fork_shore"
  };
  local get_emblemelement2_inv = function ()
  
    interface.InventoryItemAdd( "inv_emblemelement2", "spr_shore_emblemelement2" );
  
  end;
  
  local get_emblemelement2_closezz = function ()
    ObjDelete("spr_shore_part_emblem_shadow");
    ObjDelete( "gfx_shore_emblemelement2" );
      
  end;
  
  cmn.AddSubscriber( "get_emblemelement2", get_emblemelement2_inv );
  cmn.AddSubscriber( "get_emblemelement2", get_emblemelement2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_nails () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_nails" ] = {
    type = "get",
    get_obj = "spr_pickuptruck_nails",
    room = private.room_objname,
    zz = "zz_pickuptruck",
    zz_gate = "gzz_fork_pickuptruck"
  };
  local get_nails_inv = function ()
  
    interface.InventoryItemAdd( "inv_nails", "spr_pickuptruck_nails" );
    ObjSet( "spr_brokenspade_plus_light", { alp = 1 } );
  
  end;
  
  local get_nails_closezz = function ()
  
    ObjDelete( "gfx_pickuptruck_nails" );
    ObjDelete( "spr_pickuptruck_nails_shadow" );
    if cmn.IsEventDone("get_screwdriver") and cmn.IsEventDone("get_brokenspade")
    and  cmn.IsEventDone("get_handle") and common_impl.IsGetCoin("get_coin_2") then
      ObjDelete( "gzz_fork_pickuptruck" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_nails", get_nails_inv );
  cmn.AddSubscriber( "get_nails", get_nails_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_boards () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_boards" ] = {
    type = "get",
    get_obj = "spr_shore_boards",
    room = private.room_objname,
    zz = "zz_shore",
    zz_gate = "gzz_fork_shore"
  };
  local get_boards_inv = function ()
  
    interface.InventoryItemAdd( "inv_boards", "spr_shore_boards" );
  
  end;
  
  local get_boards_closezz = function ()
  
    ObjDelete( "gfx_shore_boards" );
    ObjDelete( "spr_shore_boards_shadow" );
    ObjDelete( "spr_shore_board_overshadow" );

    ObjSet( "vid_fork_alligator_static", { active = true, visible = true } );
  
  end;
  
  cmn.AddSubscriber( "get_boards", get_boards_inv );
  cmn.AddSubscriber( "get_boards", get_boards_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fishinghook () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fishinghook" ] = {
    type = "get",
    get_obj = "spr_shore_fishinghook_after",
    room = private.room_objname,
    zz = "zz_shore",
    zz_gate = "gzz_fork_shore"
  };
  local get_fishinghook_inv = function ()
  
    interface.InventoryItemAdd( "inv_fishinghook", "spr_shore_fishinghook_after" );
  
  end;
  
  local get_fishinghook_closezz = function ()
  
    ObjDelete( "gfx_shore_fishinghook" );
  
  end;
  
  cmn.AddSubscriber( "get_fishinghook", get_fishinghook_inv );
  cmn.AddSubscriber( "get_fishinghook", get_fishinghook_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_object () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_object_1" ] = {
    type = "get",
    get_obj = "spr_shore_object",
    room = private.room_objname,
    zz = "zz_shore",
    zz_gate = "gzz_fork_shore"
  };
  local get_object_1_inv = function ()
  
    interface.ProvidePanelItemAdd( "inv_object_1", "spr_shore_object" );
  
  end;
  
  local get_object_1_closezz = function ()
  
    ObjDelete( "gfx_shore_object" );
    ObjDelete( "spr_shore_plane_shadow" );
    ObjSet( "spr_shore_boards", { input = true } );

  end;
  
  cmn.AddSubscriber( "get_object_1", get_object_1_inv );
  cmn.AddSubscriber( "get_object_1", get_object_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ring () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ring" ] = {
    type = "get",
    get_obj = "spr_shore_ring",
    room = private.room_objname,
    zz = "zz_shore",
    zz_gate = "gzz_fork_shore"
  };
  local get_ring_inv = function ()

    interface.InventoryItemAdd( "inv_ring", "spr_shore_ring" );

  end;

  local get_ring_closezz = function ()

    ObjDelete( "gfx_shore_ring" );
    ObjDelete( "spr_shore_ring_shadow" );
    ObjDelete( "spr_shore_over_ring" );

    if ( cmn.IsEventDone( "get_boards" ) and cmn.IsEventDone( "get_object_1" ) and 
         cmn.IsEventDone( "get_hammer" ) and cmn.IsEventDone( "get_emblemelement2" ) and common_impl.IsGetCoin("get_coin_3") ) then

      ObjDelete( "gzz_fork_shore" );

    end;

  end;
  
  cmn.AddSubscriber( "get_ring", get_ring_inv );
  cmn.AddSubscriber( "get_ring", get_ring_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_cassette () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cassette" ] = {
    type = "get",
    get_obj = "spr_pointer_cassette",
    room = private.room_objname,
    zz = "zz_pointer",
    zz_gate = "gzz_fork_pointer"
  };
  local get_cassette_inv = function ()
  
    interface.InventoryItemAdd( "inv_cassette", "spr_pointer_cassette" );
  
  end;
  
  local get_cassette_closezz = function ()

    ObjDelete( "spr_pointer_cassette_shadow" );

    if common_impl.IsGetCoin("get_coin_1") then
      ObjDelete( "gfx_pointer_cassette" );
      ObjDelete( "gzz_fork_pointer" );
    end;

  end;
  
  cmn.AddSubscriber( "get_cassette", get_cassette_inv );
  cmn.AddSubscriber( "get_cassette", get_cassette_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scythe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_scythe" ] = {
      type = "use",
      inv_obj = "inv_scythe",
      use_place = "obj_pickuptruck_use_scythe",
      room = private.room_objname,
      zz = "zz_pickuptruck",
      zz_gate = "gzz_fork_pickuptruck"
  };
  local use_scythe_inv = function ()
  
    interface.InventoryItemRemove( "inv_scythe" );
  
  end;
  local use_scythe_beg = function ()
  
    ObjDelete( "obj_pickuptruck_use_scythe" );
  
  end;
  local use_scythe_end = function ()

    ObjSet("obj_pickuptruck_clk_text", { input = true });
    ObjSet( "obj_pickuptruck_use_scissors", { input = true, visible = true, active = true } );
    ObjSet( "obj_pickuptruck_handle", { input = true, alp = 1 } );
    ObjDelete( "obj_pickuptruck_barb" );
    ObjDelete( "spr_pickuptruck_split" );
    ObjDelete("spr_fork_grass");
    ObjDelete("spr_fork_grass_sh");
    ObjDelete("obj_pickuptruck_barb");
    ObjDelete("anm_pickuptruck_scythe");
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scythe", use_scythe_beg, private.room_objname );
  cmn.AddSubscriber( "use_scythe", use_scythe_inv );
  cmn.AddSubscriber( "use_scythe", use_scythe_end, private.room_objname );
  cmn.AddSubscriber( "use_scythe_inv", use_scythe_inv, private.room_objname );
  cmn.AddSubscriber( "use_scythe_beg", use_scythe_beg, private.room_objname );
  cmn.AddSubscriber( "use_scythe_end", use_scythe_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scissors () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_scissors_2" ] = {
      type = "use",
      inv_obj = "inv_scissors",
      use_place = "obj_pickuptruck_use_scissors",
      room = private.room_objname,
      zz = "zz_pickuptruck",
      zz_gate = "gzz_fork_pickuptruck"
  };
  local use_scissors_2_inv = function ()

    if cmn.IsEventDone( "use_scissors_1" ) then
  
      interface.InventoryItemRemove( "inv_scissors" );

    end;
  
  end;
  local use_scissors_2_beg = function ()
  
    ObjDelete( "obj_pickuptruck_use_scissors" );
  
  end;
  local use_scissors_2_end = function ()

    ObjDelete("spr_fork_awning");
    ObjSet("spr_fork_awning_op", {alp = 1});
    ObjSet( "obj_pickuptruck_brokenspade", { input = true, alp = 1 } );
    ObjDelete( "anm_pickuptruck_scissors" );
    ObjDelete( "grd_pickuptruck_cover" );
    ObjSet( "spr_pickuptruck_awning_open", { alp = 1 } );
    ObjSet( "obj_pickuptruck_lock", { alp = 1 } );
    ObjSet( "obj_pickuptruck_use_briefcasekey", { input = true } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scissors_2", use_scissors_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_scissors_2", use_scissors_2_inv );
  cmn.AddSubscriber( "use_scissors_2", use_scissors_2_end, private.room_objname );
  cmn.AddSubscriber( "use_scissors_2_inv", use_scissors_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_scissors_2_beg", use_scissors_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_scissors_2_end", use_scissors_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_briefcasekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_briefcasekey" ] = {
      type = "use",
      inv_obj = "inv_briefcasekey",
      use_place = "obj_pickuptruck_use_briefcasekey",
      room = private.room_objname,
      zz = "zz_pickuptruck",
      zz_gate = "gzz_fork_pickuptruck"
  };
  local use_briefcasekey_inv = function ()
      
      interface.InventoryItemRemove( "inv_briefcasekey" );
  
  end;
  local use_briefcasekey_beg = function ()
  
    ObjDelete( "obj_pickuptruck_use_briefcasekey" );
  
  end;
  local use_briefcasekey_end = function ()

    ObjDelete("spr_fork_case");
    ObjSet("spr_fork_case_op", { alp = 1 });    
    ObjSet( "spr_pickuptruck_open_case", { input = true, alp = 1 });

    if  not ng_global.progress["std"]["opn_fork"].op_door then

      ObjSet( "obj_pickuptruck_screwdriver", { input = false } );

    end;

    ObjDelete( "spr_pickuptruck_key" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_briefcasekey", use_briefcasekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_briefcasekey", use_briefcasekey_inv );
  cmn.AddSubscriber( "use_briefcasekey", use_briefcasekey_end, private.room_objname );
  cmn.AddSubscriber( "use_briefcasekey_inv", use_briefcasekey_inv, private.room_objname );
  cmn.AddSubscriber( "use_briefcasekey_beg", use_briefcasekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_briefcasekey_end", use_briefcasekey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scissors () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_scissors_1" ] = {
      type = "use",
      inv_obj = "inv_scissors",
      use_place = "obj_shore_use_scissors",
      room = private.room_objname,
      zz = "zz_shore",
      zz_gate = "gzz_fork_shore"
  };

  local use_scissors_1_inv = function ()

    if cmn.IsEventDone( "use_scissors_2" ) then
  
      interface.InventoryItemRemove( "inv_scissors" );

    end;
  
  end;

  local use_scissors_1_beg = function ()
  
    ObjDelete( "obj_shore_use_scissors" );
  
  end;
  local use_scissors_1_end = function ()
  
    ObjSet( "spr_shore_fishinghook_after", { input = true, visible = true, active = true, alp = 1 } );
    ObjSet( "gfx_shore_fishinghook", { active = true } );
    ObjDelete( "spr_shore_fishinghook" );
    ObjSet( "spr_shore_sealline", { active = false, ang = -0.07 } );
    ObjDelete( "anm_shore_scissors" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scissors_1", use_scissors_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_scissors_1", use_scissors_1_end, private.room_objname );
  cmn.AddSubscriber( "use_scissors_1_beg", use_scissors_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_scissors_1_end", use_scissors_1_end, private.room_objname );
  cmn.AddSubscriber( "use_scissors_1", use_scissors_1_inv );
  cmn.AddSubscriber( "use_scissors_1_inv", use_scissors_1_inv, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pyrotechinics () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pyrotechinics" ] = {
      type = "use",
      inv_obj = "inv_pyrotechinics",
      use_place = "obj_shore_use_pyrotechinics",
      room = private.room_objname,
      zz = "zz_shore",
      zz_gate = "gzz_fork_shore"
  };
  local use_pyrotechinics_inv = function ()
  
    interface.InventoryItemRemove( "inv_pyrotechinics" );
  
  end;
  local use_pyrotechinics_end = function ()
  
    ObjSet( "spr_shore_pyrotechinics", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pyrotechinics", use_pyrotechinics_inv );
  cmn.AddSubscriber( "use_pyrotechinics", use_pyrotechinics_end, private.room_objname );
  cmn.AddSubscriber( "use_pyrotechinics_inv", use_pyrotechinics_inv, private.room_objname );
  cmn.AddSubscriber( "use_pyrotechinics_end", use_pyrotechinics_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_matches_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_matches" ] = {
      type = "use",
      inv_obj = "inv_matches",
      use_place = "obj_shore_use_pyrotechinics",
      room = private.room_objname,
      zz = "zz_shore",
      zz_gate = "gzz_fork_shore"
  };
  local use_matches_beg = function ()
  
    ObjDelete( "obj_shore_use_pyrotechinics" );
  
  end;
  local use_matches_end = function ()
  
    ObjSet( "obj_shore_use_pliers", { input = true, visible = true, active = true } );
    ObjSet( "spr_shore_hammer", { input = true } );
    ObjSet( "spr_shore_emblemelement2", { input = true } );
    ObjSet( "gfx_shore_hammer", { active = true } );
    ObjSet( "gfx_shore_emblemelement2", { active = true } );
    ObjDelete( "spr_shore_matches" );
    ObjDelete( "spr_shore_pyrotechinics" );
    ObjDelete( "vid_fork_alligator_static" ); 
    ObjDelete( "vid_shore_alligator_static" ); 
    ObjDelete( "vid_shore_alligator_on_hit" ); 
    ObjDelete( "vid_shore_alligator_explosion" ); 
    ObjSet( "spr_shore_debris", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_matches", use_matches_beg, private.room_objname );
  cmn.AddSubscriber( "use_matches", use_matches_end, private.room_objname );
  cmn.AddSubscriber( "use_matches_beg", use_matches_beg, private.room_objname );
  cmn.AddSubscriber( "use_matches_end", use_matches_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pliers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pliers" ] = {
      type = "use",
      inv_obj = "inv_pliers",
      use_place = "obj_shore_use_pliers",
      room = private.room_objname,
      zz = "zz_shore",
      zz_gate = "gzz_fork_shore"
  };
  local use_pliers_inv = function ()
  
    interface.InventoryItemRemove( "inv_pliers" );
  
  end;
  local use_pliers_beg = function ()
  
    ObjDelete( "obj_shore_use_pliers" );
  
  end;
  local use_pliers_end = function ()
  
    ObjSet( "spr_shore_ring", { input = true, visible = true, active = true } );
    ObjSet( "gfx_shore_ring", { visible = true, active = true});
    ObjDelete( "spr_shore_ring_over" );
    ObjSet( "spr_shore_ring_over_2", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pliers", use_pliers_beg, private.room_objname );
  cmn.AddSubscriber( "use_pliers", use_pliers_inv );
  cmn.AddSubscriber( "use_pliers", use_pliers_end, private.room_objname );
  cmn.AddSubscriber( "use_pliers_inv", use_pliers_inv, private.room_objname );
  cmn.AddSubscriber( "use_pliers_beg", use_pliers_beg, private.room_objname );
  cmn.AddSubscriber( "use_pliers_end", use_pliers_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spade () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spade" ] = {
      type = "use",
      inv_obj = "inv_spade",
      use_place = "obj_pointer_use_spade",
      room = private.room_objname,
      zz = "zz_pointer",
      zz_gate = "gzz_fork_pointer"
  };
  local use_spade_inv = function ()
  
    interface.InventoryItemRemove( "inv_spade" );
  
  end;
  local use_spade_beg = function ()
  
    ObjDelete( "obj_pointer_use_spade" );

  
  end;
  local use_spade_end = function ()
  
    ObjSet( "obj_pointer_clk_box", { input = true, visible = true, active = true } );
    ObjDelete( "anm_pointer_shovel" ); 

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spade", use_spade_beg, private.room_objname );
  cmn.AddSubscriber( "use_spade", use_spade_inv );
  cmn.AddSubscriber( "use_spade", use_spade_end, private.room_objname );
  cmn.AddSubscriber( "use_spade_inv", use_spade_inv, private.room_objname );
  cmn.AddSubscriber( "use_spade_beg", use_spade_beg, private.room_objname );
  cmn.AddSubscriber( "use_spade_end", use_spade_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_boards () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_boards" ] = {
      type = "use",
      inv_obj = "inv_boards",
      use_place = "obj_bridge_use_boards",
      room = private.room_objname,
      zz = "zz_bridge",
      zz_gate = "gzz_fork_bridge"
  };
  local use_boards_inv = function ()
  
    interface.InventoryItemRemove( "inv_boards" );
  
  end;
  local use_boards_beg = function ()
  
    ObjDelete( "obj_bridge_use_boards" );
    ObjDelete( "vid_bridge_owlman" );
  
  end;
  local use_boards_end = function ()
  
    ObjSet( "grm_fork_square", { input = true, active = true } );
    ObjDelete( "gzz_fork_bridge" );
    ObjSet( "spr_bridge_board", { alp = 1 } );
    ObjSet("spr_fork_board", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_boards", use_boards_beg, private.room_objname );
  cmn.AddSubscriber( "use_boards", use_boards_inv );
  cmn.AddSubscriber( "use_boards", use_boards_end, private.room_objname );
  cmn.AddSubscriber( "use_boards_inv", use_boards_inv, private.room_objname );
  cmn.AddSubscriber( "use_boards_beg", use_boards_beg, private.room_objname );
  cmn.AddSubscriber( "use_boards_end", use_boards_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_alligator () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_alligator" ] = {
    type = "click",
    use_place = "spr_shore_object",
    room = private.room_objname,
    zz = "zz_shore",
    zz_gate = "gzz_fork_shore"
  };

  local clk_alligator_end = function ()
  
    ObjSet( "obj_shore_use_pyrotechinics", {active = true, input = true, visible = true});
    ObjSet( "obj_shore_use_scissors", {active = true, input = true, visible = true});
    ObjDelete( "vid_shore_alligator" );
    ObjSet( "vid_shore_alligator_static", { active = true, alp = 1, playing = true, looped = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_alligator", clk_alligator_end, private.room_objname );
  cmn.AddSubscriber( "clk_alligator_end", clk_alligator_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_box () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_box" ] = {
    type = "click",
    use_place = "obj_pointer_clk_box",
    room = private.room_objname,
    zz = "zz_pointer",
    zz_gate = "gzz_fork_pointer"
  };
  local clk_box_beg = function ()
  
    ObjDelete("obj_pointer_clk_box");
  
  end;
  local clk_box_end = function ()
  
    ObjSet("obj_pointer_clk_dictaphone", {active = true, input = true, visible = true});
    ObjDelete( "obj_pointer_box_closed" );  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_box", clk_box_beg, private.room_objname );
  cmn.AddSubscriber( "clk_box", clk_box_end, private.room_objname );
  cmn.AddSubscriber( "clk_box_beg", clk_box_beg, private.room_objname );
  cmn.AddSubscriber( "clk_box_end", clk_box_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_shore () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_shore" ] = {
    type = "click",
    use_place = "obj_fork_clk_shore",
    room = private.room_objname,
    zz = "zz_shore",
    zz_gate = "gzz_fork_shore"
  };
  local clk_shore_beg = function ()
  
    ObjDelete("obj_fork_clk_shore");
  
  end;
  local clk_shore_end = function ()
  
    ObjSet( "anm_fork_shore_open", { alp = 1, playing = 1 } );
    ObjDelete( "anm_fork_shore_close" );  
    ObjDelete( "anm_fork_shore_unlock" );  
    ObjSet( "gzz_fork_shore", { input = true, active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_shore", clk_shore_beg, private.room_objname );
  cmn.AddSubscriber( "clk_shore", clk_shore_end, private.room_objname );
  cmn.AddSubscriber( "clk_shore_beg", clk_shore_beg, private.room_objname );
  cmn.AddSubscriber( "clk_shore_end", clk_shore_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_dictaphone () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_dictaphone" ] = {
    type = "click",
    use_place = "obj_pointer_clk_dictaphone",
    room = private.room_objname,
    zz = "zz_pointer",
    zz_gate = "gzz_fork_pointer"
  };
  local clk_dictaphone_beg = function ()
  
    ObjDelete("obj_pointer_clk_dictaphone");
  
  end;
  local clk_dictaphone_end = function ()
  
    ObjSet("spr_pointer_cassette", {active = true, input = true, visible = true});
    ObjDelete( "spr_pointer_rag" );
    ObjSet( "spr_pointer_rag_opened", {alp = 1} );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_dictaphone", clk_dictaphone_beg, private.room_objname );
  cmn.AddSubscriber( "clk_dictaphone", clk_dictaphone_end, private.room_objname );
  cmn.AddSubscriber( "clk_dictaphone_beg", clk_dictaphone_beg, private.room_objname );
  cmn.AddSubscriber( "clk_dictaphone_end", clk_dictaphone_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_providence_fork () end;
  --------------------------------------------------------------------------------------------
  local clk_providence_fork = function ()
  
    if ( not cmn.IsEventDone( "clk_fork_providence_1" ) or not cmn.IsEventDone( "clk_fork_providence_2" ) or not cmn.IsEventDone( "clk_fork_providence_3" ) ) then
      int_button_providence.StartActiveProvidence();
    end;
  
  end;
  
  cmn.AddSubscriber( "clk_providence_fork", clk_providence_fork, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_fork_providence_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_fork_providence_3" ] = {
    type = "click",
    inv_obj = "spr_fork_providence_plate",
    use_place = "obj_fork_providence_item_3",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"
  };
  local clk_fork_providence_3_beg = function ()
  
    ObjSet( "obj_fork_providence_item_3", { input = false } );
  
  end;
  local clk_fork_providence_3_end = function ()
  
    ObjDelete( "obj_fork_providence_item_3" );
    ObjDelete( "spr_fork_providence_plate" );
    ObjDelete( "spr_fork_plate_2" );
    ObjSet( "spr_fork_providence_plate_used", { alp = 1 } );
    ObjDelete( "spr_fork_providence_plate" );
    ObjSet( "spr_fork_plate", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_fork_providence_3", clk_fork_providence_3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_fork_providence_3", clk_fork_providence_3_end, private.room_objname );
  cmn.AddSubscriber( "clk_fork_providence_3_beg", clk_fork_providence_3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_fork_providence_3_end", clk_fork_providence_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_fork_providence_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_fork_providence_2" ] = {
    type = "click",
    inv_obj = "spr_fork_providence_bush",
    use_place = "obj_fork_providence_item_2",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"
  };
  local clk_fork_providence_2_beg = function ()
  
    ObjSet( "obj_fork_providence_item_2", { input = false } );
  
  end;
  local clk_fork_providence_2_end = function ()
  
    ObjDelete( "obj_fork_providence_item_2" );

    ObjDelete( "spr_fork_providence_bush" );
    ObjSet( "spr_fork_providence_bush_used", { alp = 1 } );
    ObjDelete( "spr_fork_bush" );
    ObjSet( "spr_fork_bush_2", { alp = 1 } );
    ObjSet( "gzz_fork_pickuptruck", { active = true, input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_fork_providence_2", clk_fork_providence_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_fork_providence_2", clk_fork_providence_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_fork_providence_2_beg", clk_fork_providence_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_fork_providence_2_end", clk_fork_providence_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_fork_providence_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_fork_providence_1" ] = {
    type = "click",
    inv_obj = "spr_fork_providence_timber",
    use_place = "obj_fork_providence_item_1",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"
  };
  local clk_fork_providence_1_beg = function ()
  
    ObjSet( "obj_fork_providence_item_1", { input = false } );
  
  end;
  local clk_fork_providence_1_end = function ()
  
    ObjDelete( "obj_fork_providence_item_1" );
    ObjDelete( "spr_fork_providence_timber" );
    ObjSet( "spr_fork_providence_timber_used", { alp = 1 } );
    ObjSet( "spr_fork_timber", { pos_x = 770, pos_y = 613, ang = 0.13 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_fork_providence_1", clk_fork_providence_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_fork_providence_1", clk_fork_providence_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_fork_providence_1_beg", clk_fork_providence_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_fork_providence_1_end", clk_fork_providence_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_fork_providence () end;
  --------------------------------------------------------------------------------------------
  local vid_fork_providence_beg = function ()

    local params = { "right" };
    int_slider.Unlock( private.room_objname, params )

  end;
  local vid_fork_providence_end = function ()
   
    ObjSet( "obj_fork_clk_shore", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_fork_providence", vid_fork_providence_beg, private.room_objname );
  cmn.AddSubscriber( "vid_fork_providence", vid_fork_providence_end, private.room_objname  );
  cmn.AddSubscriber( "vid_fork_providence_beg", vid_fork_providence_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_fork_providence_end", vid_fork_providence_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  local vid_fork_providence_p2 = function ()

    VidStop( "vid_fork_providence_p1" );
    ObjSet( "vid_fork_providence_p2", { playing = true } );
        
  end;
  
  cmn.AddSubscriber( "vid_fork_providence_p2", vid_fork_providence_p2, private.room_objname );
  --------------------------------------------------------------------------------------------
  local vid_fork_providence_p3 = function ()

    VidStop( "vid_fork_providence_p2" );
    ObjSet( "vid_fork_providence_p3", { playing = true } );
    
  end;
  
  cmn.AddSubscriber( "vid_fork_providence_p3", vid_fork_providence_p3, private.room_objname );
  --------------------------------------------------------------------------------------------
  local vid_fork_providence_p4 = function ()

    VidStop( "vid_fork_providence_p3" );
    ObjSet( "vid_fork_providence_p4", { playing = true } ); 

  end;
  
  cmn.AddSubscriber( "vid_fork_providence_p4", vid_fork_providence_p4, private.room_objname );
  --------------------------------------------------------------------------------------------
  local vid_fork_providence_p5 = function ()

    VidStop( "vid_fork_providence_p4" );    
    VidPlay( "vid_fork_providence_p5", private.vid_fork_providence_end );

  end;
  
  cmn.AddSubscriber( "vid_fork_providence_p5", vid_fork_providence_p5, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_fork_ancient () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_fork_ancient" ] = {

      type = "click",
      use_place = "obj_vid_fork_ancient",
      room = private.room_objname
  };
  local vid_fork_ancient_beg = function ()

    ObjDelete( "obj_vid_fork_ancient" );

  end;
  local vid_fork_ancient_end = function ()

    ObjSet( "obj_dlg_fork_ancient", { input = true } );
    ObjSet( "anm_fork_ancient", { alp = 1 } );

  end;

  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "vid_fork_ancient", vid_fork_ancient_beg, private.room_objname );
  cmn.AddSubscriber( "vid_fork_ancient", vid_fork_ancient_end, private.room_objname  );
  cmn.AddSubscriber( "vid_fork_ancient_beg", vid_fork_ancient_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_fork_ancient_end", vid_fork_ancient_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function dlg_fork_ancient () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_fork_ancient" ] = {

      type = "click",
      use_place = "obj_dlg_fork_ancient_focus",
      room = private.room_objname
  };
  local dlg_fork_ancient_end = function ()

    ObjDelete( "obj_dlg_fork_ancient" );
    ObjDelete( "anm_fork_ancient" );
    --ObjSet( "spr_int_button_providence_light", { active = 1 } );
    
  end;
  local dlg_fork_ancient_inv = function ()

    ObjSet( "spr_int_panel_providence", { alp = 1 } );
    ObjDelete( "anm_panel_providence" );
    common_impl.Collectibles2_unlock_crs("Old_Man");

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_fork_ancient", dlg_fork_ancient_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_fork_ancient", dlg_fork_ancient_inv  );
  cmn.AddSubscriber( "dlg_fork_ancient_end", dlg_fork_ancient_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_fork_ancient_inv", dlg_fork_ancient_inv  );

  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_2 = function ()
  
    ObjDelete( "obj_fork_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_2", get_collect_morph_item_1_2, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load()

  if cmn.IsEventDone("use_scissors_2") then

    if ng_global.progress["std"]["opn_fork"].op_door then 

      ObjSet("spr_fork_door_open", {alp = 1});
      ObjSet("spr_fork_door", {alp = 0});
       ObjMultiSet( {
      { "obj_pickuptruck_clk_lock", { input = false } },
      { "obj_pickuptruck_handle", { input = false } },
      { "obj_pickuptruck_clk_door", { input = true } },
      { "spr_pickuptruck_lock_close", { alp = 0 } },
      { "spr_pickuptruck_lock_open", { alp = 1 } },
      { "spr_pickuptruck_close_door", { alp = 0 } },
      { "spr_pickuptruck_open_door", { alp = 1 } },
      });

    else

      ObjSet("obj_pickuptruck_clk_lock", {input = true });
      ObjAttach("obj_screwdiver_hint","obj_pickuptruck_clk_lock" );

    end;

  end;

end;
--********************************************************************************************************************
function private.Init_Subroom()

  common_impl.hint.position_slider[ "gzz_fork_pickuptruck" ] = { "mid" };
  common_impl.hint.position_slider[ "gzz_fork_shore" ] = { "right" };
  common_impl.hint.position_slider[ "gzz_fork_pointer" ] = { "mid" };
  common_impl.hint.position_slider[ "gzz_fork_bridge" ] = { "right" };
  common_impl.hint.position_slider[ "gzz_fork_barrier" ] = { "mid" };

  subroom.Define( "zz_shore" );
  --------------------------------------------------------------------------------------------
  function zz_shore.Open()

    if cmn.IsEventDone( "get_boards" ) and not cmn.IsEventDone( "clk_alligator" ) then

      private.clk_alligator();

    end;

  end;
  -------------------------------------------------------------------------------------------- 
  function zz_shore.PreOpen()

    common_impl.fork = {}
    common_impl.fork.note = "close";

    if cmn.IsEventDone( "clk_alligator" ) and not cmn.IsEventDone( "use_matches" ) then

      common_impl.PlayAudio( "env", "common/audio/aud_alligator_zz_env", 1, "", 0 );
      common_impl.StopAudio( "env", "common/audio/aud_alligator_loc_env", 0.2 );

    end;

  end;
  --------------------------------------------------------------------------------------------  
  function zz_shore.PreClose()

    if cmn.IsEventDone( "clk_alligator" ) and not cmn.IsEventDone( "use_matches" ) then

      common_impl.PlayAudio( "env", "common/audio/aud_alligator_loc_env", 1, "", 0 );
      common_impl.StopAudio( "env", "common/audio/aud_alligator_zz_env", 0.2 );

    end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_shore.Close()

    ObjSet( "spr_shore_metal_note_big", { input = 0, alp = 0 } );
    ObjSet( "spr_shore_metal_note", { alp = 1 } );
    common_impl.fork.note = "close";

  end;
  --------------------------------------------------------------------------------------------
  subroom.Define( "zz_bridge" );
  --------------------------------------------------------------------------------------------
  function zz_bridge.Open()

    if ( not ng_global.progress["std"]["opn_fork"].anm_feather ) then

      ng_global.progress["std"]["opn_fork"].anm_feather = true; 

      common_impl.PlayAudio( "sfx", "common/audio/aud_feathers_bridge", 0, "", 0 );
      
      AnimPlay( "amn_bridge_feathers", "DoAnim", "" );

      ObjSet( "vid_bridge_owlman" ,{alp = 1});
      VidPlay( "vid_bridge_owlman", "" );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_bridge.PreOpen()

    if ( ng_global.progress["std"]["opn_fork"].anm_feather ) then
      ObjSet( "amn_bridge_feathers", { visible = false } );
    end;

  end;
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_fork();

  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

  if ( cmn.IsEventDone( "dlg_fork_ancient" ) and not cmn.IsEventDone( "vid_fork_providence" ) ) then
  
    int_button_providence.StartLightProvidence();

  end;

  if ( not cmn.IsEventDone( "vid_fork_ancient" ) ) then
    common_impl.PlayTimer( private.vid_fork_ancient );
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.MorphItemMorphing();

  common_impl.EnvPlay( { "common/audio/aud_fork_env" }, "", 0.5 );
  if cmn.IsEventDone( "clk_alligator" ) and not cmn.IsEventDone( "use_matches" ) then

    common_impl.PlayAudio( "env", "common/audio/aud_alligator_loc_env", 1, "", 0 );

  end;

  if cmn.IsEventDone( "get_evidence_1_1" ) then

    interface.InvestigationButtonCheck();

  end;

end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );
  common_impl.StopAudio( "env", "common/audio/aud_alligator_loc_env", 0.2 );

end;
--*********************************************************************************************************************
function public.PreClose()

  if ( not cmn.IsEventDone( "vid_fork_providence" ) ) then

    int_button_providence.StopLightProvidence();

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
function public.use_scythe()

  local item = "inv_scythe";

  if ( common.ApplyObj( item, "obj_pickuptruck_use_scythe", true ) ) then

    cmn.CallEventHandler( "use_scythe_inv" );
    cmn.CallEventHandler( "use_scythe_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_scythe" );
      cmn.CallEventHandler( "use_scythe_end" );
    
    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_scythe", 0, "", 0 );
    ObjSet( "anm_pickuptruck_scythe", { alp = 1 } );
    ObjSet( "obj_pickuptruck_barb", { alp = 0 } );
    AnimPlay( "anm_pickuptruck_scythe", "DoAnim", func_after );

  elseif common.ApplyObj( item, "gzz_fork_pickuptruck", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pickuptruck", nil, { 512, 384 } );

  else

    common_impl.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_scissors_2()

  local item = "inv_scissors";

  if ( common.ApplyObj( item, "obj_pickuptruck_use_scissors", true ) and not cmn.IsEventDone( "use_scissors_2" ) and cmn.IsEventDone( "use_scythe" ) ) then
      
    cmn.CallEventHandler( "use_scissors_2_inv" );
    cmn.CallEventHandler( "use_scissors_2_beg" );

    ObjSet("obj_pickuptruck_clk_lock", { input = true });
    ng_global.progress["std"]["opn_fork"].op_door = false;

    local func_after = function ()

      cmn.SetEventDone( "use_scissors_2" );
      cmn.CallEventHandler( "use_scissors_2_end" );

      common_impl.Lock(false);
    
    end;

    common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_scissors_pickup_cloth", 0, "", 0 );

    AnimPlay( "anm_pickuptruck_scissors", "DoAnim", "" );

    ObjAnimate( "grd_pickuptruck_cover", "alp", 0, 0, func_after, { 0,0,1, 4,0,1, 4.3,0,0  } );

    ObjAnimate( "spr_pickuptruck_awning_open", "alp", 0, 0, "", { 0,0,0, 4,0,0, 4.3,0,1  } );

    ObjAnimate( "obj_pickuptruck_brokenspade", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      4.0, 0, 0.0,
      4.3, 0, 1.0
    } );

    ObjAnimate( "obj_pickuptruck_lock", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      4.0, 0, 0.0,
      4.3, 0, 1.0
    } );

    return true;

  elseif ( common.ApplyObj( item, "obj_pickuptruck_use_scythe", true ) ) then

    common_impl.ShowBbt( 'bbt_pickuptruck_wrong_use_scissors', 1 );

    return true;
      

  elseif common.ApplyObj( item, "gzz_fork_pickuptruck", false ) and not cmn.IsEventDone( "use_scissors_2" ) and cmn.IsEventDone( "use_scythe" ) then
  
    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pickuptruck", nil, { 512, 384 } );

  else

    return false;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_briefcasekey()

  local item = "inv_briefcasekey";

  if ( common.ApplyObj( item, "obj_pickuptruck_use_briefcasekey", true ) and ( cmn.IsEventDone( "use_scissors_2" ) ) ) then

    local func_use = function ()

      cmn.CallEventHandler( "use_briefcasekey_beg" );

      local func_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_briefcasekey" );
      cmn.CallEventHandler( "use_briefcasekey_end" );
      
      end;

      common_impl.Lock(true);
      common_impl.PlayAudio( "sfx", "common/audio/aud_use_case_key", 0, "", 0 );

      ObjAnimate( "spr_pickuptruck_key", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0,
        0.6, 0, 0.0
      } );

      ObjAnimate( "spr_pickuptruck_open_case", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 0.0,
        0.6, 0, 1.0
      } );

    end;

    cmn.CallEventHandler( "use_briefcasekey_inv" );

    if ( ng_global.progress["std"]["opn_fork"].op_door ) then

      func_use();

    else

      private.clk_lock( func_use );

    end;

    

  elseif common.ApplyObj( item, "gzz_fork_pickuptruck", false ) and cmn.IsEventDone( "use_scissors_2" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pickuptruck", nil, { 512, 384 } );

  else

    common_impl.WrongApply(); 

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_scissors_1()

  local item = "inv_scissors";

  if ( common.ApplyObj( item, "obj_shore_use_scissors", true ) and not cmn.IsEventDone( "use_scissors_1" ) )and common_impl.fork.note == "close" then
   
    cmn.CallEventHandler( "use_scissors_1_inv" );
    cmn.CallEventHandler( "use_scissors_1_beg" );

    local func_after = function ()

      common_impl.Lock(false);

      cmn.SetEventDone( "use_scissors_1" );
      cmn.CallEventHandler( "use_scissors_1_end" );
      ObjSet( "obj_shore_scissors", { alp = 1 } );
            
    end;

    common_impl.Lock(true);

    ObjSet( "anm_shore_scissors", { alp = 1 } );
    ObjSet( "obj_shore_scissors", { alp = 0 } );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_scissors", 0, "", 0 );
    AnimPlay( "anm_shore_scissors", "DoAnim", func_after );

    return true;

  elseif common.ApplyObj( item, "gzz_fork_shore", false ) and not cmn.IsEventDone( "use_scissors_1" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shore", nil, { 512, 384 } );

    return true;

  else

    return false;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pyrotechinics()

  local item = "inv_pyrotechinics";
  
  if ( common.ApplyObj( item, "obj_shore_use_pyrotechinics", true ) ) and common_impl.fork.note == "close" then

    cmn.CallEventHandler( "use_pyrotechinics_inv" );
    cmn.CallEventHandler( "use_pyrotechinics_beg" );

    local func_after = function ()

      common_impl.Lock(false);

      cmn.SetEventDone( "use_pyrotechinics" );
      cmn.CallEventHandler( "use_pyrotechinics_end" );

    end;


    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_explosives", 0, "", 0 );

    ObjAnimate( "spr_shore_pyrotechinics", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  elseif common.ApplyObj( item, "gzz_fork_shore", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shore", nil, { 512, 384 } );

  else

    common_impl.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_matches()

  local item = "inv_matches";

  if ( common.ApplyObj( item, "obj_shore_use_pyrotechinics", true ) and cmn.IsEventDone( "use_pyrotechinics" ) and not cmn.IsEventDone( "use_matches" ) ) and common_impl.fork.note == "close" then

    cmn.CallEventHandler( "use_matches_beg" );
    common_impl.StopAudio( "env", "common/audio/aud_alligator_zz_env", 0.2 ); 
    local func_after = function ()

      common_impl.Lock(false);

      cmn.SetEventDone( "use_matches" );
      cmn.CallEventHandler( "use_matches_end" );

      common_impl.PlayAudio( "mus", "common/audio/aud_adventure2_mus", 0, "", 0 );
      
    end;

    common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_explosion_scare_alligator", 0, "", 0 );

    ObjSet( "spr_shore_pyrotechinics", { alp = 0 });
    ObjSet( "vid_shore_alligator_static", { active = false, alp = 0 });
    ObjSet( "vid_shore_alligator_explosion", { active = true, alp = 1 });
    VidPlay( "vid_shore_alligator_explosion", func_after );

    return true;

  elseif common.ApplyObj( item, "gzz_fork_shore", false ) and cmn.IsEventDone( "use_pyrotechinics" ) and not cmn.IsEventDone( "use_matches" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shore", nil, { 512, 384 } ); 

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pliers()

  local item = "inv_pliers";

  if ( common.ApplyObj( item, "obj_shore_use_pliers", true ) ) then

    cmn.CallEventHandler( "use_pliers_inv" );
    cmn.CallEventHandler( "use_pliers_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_pliers" );
      cmn.CallEventHandler( "use_pliers_end" );

      private.get_ring();
    
    end;

    common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_pliers", 0, "", 0 );

     ObjAnimate( "spr_shore_nippers_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      1.0, 0, 1.0,
      1.2, 0, 0.0
    } );
  
    ObjAnimate( "spr_shore_nippers_2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      1.0, 0, 1.0,
      1.2, 0, 0.0
    } );

    ObjAnimate( "spr_shore_nippers_1", "ang", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.0,
      0.6, 0, -0.12,
      1.0, 0, 0.0
    } );

    ObjAnimate( "spr_shore_nippers_2", "ang", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.0,
      0.6, 0, 0.12,
      1.0, 0, 0.0
    } );

    ObjAnimate( "spr_shore_ring_over", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.8, 0, 1.0,
      1.0, 0, 0.0
    } );

    ObjAnimate( "spr_shore_ring_over_2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.8, 0, 0.0,
      1.0, 0, 1.0
    } );

  elseif common.ApplyObj( item, "gzz_fork_shore", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shore", nil, { 512, 384 } );

  else

    common_impl.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_spade()

  local item = "inv_spade";

  if ( common.ApplyObj( item, "obj_pointer_use_spade", true ) ) then

    cmn.CallEventHandler( "use_spade_inv" );
    cmn.CallEventHandler( "use_spade_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_spade" );
      cmn.CallEventHandler( "use_spade_end" );
    
    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_shovel", 0, "", 0 );

    AnimPlay( "anm_pointer_shovel", "DoAnim", func_after );

  elseif common.ApplyObj( item, "gzz_fork_pointer", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pointer", nil, { 512, 384 } );

  else

    common_impl.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_spade_elf() 

  if common.ApplyObj( "inv_elf", "obj_pointer_use_spade", true ) then

   --здесь нужна ббт на фрустацию DR
    local func_after = function ()

      common_impl.ShowBbt( 'bbt_pointer_use_elf_wrong' );
      common_impl.Lock( false );
      ObjSet( "vid_pointer_elf_wrong", { alp = 0, frame = 0 } );
      ObjSet( "vid_pointer_elf_wrong_shadow", { alp = 0, frame = 0 } );
      ObjCreate( "spr_pointer_elf", "spr" );
      ObjSet( "spr_pointer_elf", { pos_x = 33, pos_y = 131, input = 0, res = "assets/levels/level1/rm_fork/zz_pointer/layers/elf" } );
      ObjAttach( "spr_pointer_elf", "zz_pointer" );
      interface.InventoryItemAdd( "inv_elf", "spr_pointer_elf" );
      
    end;

    common_impl.Lock( true );
    interface.InventoryItemRemove( "inv_elf" );
    ObjSet( "vid_pointer_elf_wrong", { alp = 1 } );
    ObjSet( "vid_pointer_elf_wrong_shadow", { alp = 1 } );
    common_impl.PlayAudio( "sfx", "common/audio/aud_pointer_elf", 0, "", 0 );  
    VidPlay( "vid_pointer_elf_wrong", func_after );
    VidPlay( "vid_pointer_elf_wrong_shadow", "" );

    return true;

   else

    --common_impl.WrongApply();  

   end;

end;
--------------------------------------------------------------------------------------------
function public.use_boards()

  local item = "inv_boards";

  if ( common.ApplyObj( item, "obj_bridge_use_boards", true ) ) then

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_boards", 0, "", 0.2 );

    cmn.CallEventHandler( "use_boards_inv" );
    cmn.CallEventHandler( "use_boards_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      interface.KeyTaskDone( "goto_willowswille" ,true );
      cmn.SetEventDone( "use_boards" );
      cmn.CallEventHandler( "use_boards_end" );
      common.CloseSubRoom();

    end;

    common_impl.Lock(true);
    ObjAnimate( "spr_bridge_board", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

  elseif common.ApplyObj( item, "gzz_fork_bridge", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bridge", nil, { 512, 384 } );

  else

    common_impl.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.get_coin1()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_1");
    cmn.CallEventHandler("get_coin_1");

    if cmn.IsEventDone( "get_cassette" ) then
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_pointer_coin", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_coin2()

  local func_after = function ()

    common_impl.GetCoinDone("get_coin_2");
    cmn.CallEventHandler("get_coin_2");

    if cmn.IsEventDone("get_screwdriver") and cmn.IsEventDone("get_brokenspade") 
    and cmn.IsEventDone("get_nails") and cmn.IsEventDone("get_handle") then

      common.CloseSubRoom();

    end;

  end;

  common_impl.PlayEffectHO( "spr_pickuptruck_coin", func_after );
  
end;
--------------------------------------------------------------------------------------------
function private.get_coin3()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_3");
    cmn.CallEventHandler("get_coin_3");

    if cmn.IsEventDone("get_ring") then
      common.CloseSubRoom();
    end;

  end;
    
  common_impl.PlayEffectHO( "spr_shore_coin", func_after );

end;
--------------------------------------------------------------------------------------------
function private.get_handle()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_handle" );
  cmn.CallEventHandler( "get_handle" );
  if cmn.IsEventDone("get_screwdriver")
  and  cmn.IsEventDone("get_brokenspade") and cmn.IsEventDone("get_nails") and common_impl.IsGetCoin("get_coin_2") then
      common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_brokenspade()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_brokenspade" );
  cmn.CallEventHandler( "get_brokenspade" );
  if cmn.IsEventDone("get_screwdriver") and common_impl.IsGetCoin("get_coin_2")
  and  cmn.IsEventDone("get_handle") and cmn.IsEventDone("get_nails") then
      common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_screwdriver()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_screwdriver" );
  cmn.CallEventHandler( "get_screwdriver" );

  if cmn.IsEventDone("get_brokenspade") and common_impl.IsGetCoin("get_coin_2")
  and  cmn.IsEventDone("get_handle") and cmn.IsEventDone("get_nails") then
      common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_hammer()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hammer" );
  cmn.CallEventHandler( "get_hammer" );

  if cmn.IsEventDone("get_ring") and cmn.IsEventDone("get_boards") and cmn.IsEventDone("get_fishinghook") and
     cmn.IsEventDone("get_hammer") and cmn.IsEventDone("get_emblemelement2")  then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_emblemelement2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_emblemelement2" );
  cmn.CallEventHandler( "get_emblemelement2" );
  if cmn.IsEventDone("get_ring") and cmn.IsEventDone("get_boards") and cmn.IsEventDone("get_fishinghook") and
     cmn.IsEventDone("get_hammer") and cmn.IsEventDone("get_emblemelement2")  then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_nails()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_nails" );
  cmn.CallEventHandler( "get_nails" );
  if cmn.IsEventDone("get_screwdriver") and cmn.IsEventDone("get_brokenspade") 
  and  cmn.IsEventDone("get_handle") and common_impl.IsGetCoin("get_coin_2") then
      common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_boards()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_boards" );
  cmn.CallEventHandler( "get_boards" );

  private.clk_alligator();

end;
--------------------------------------------------------------------------------------------
function private.get_fishinghook()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_fishinghook" );
  cmn.CallEventHandler( "get_fishinghook" );

  if cmn.IsEventDone("get_ring") and cmn.IsEventDone("get_boards") and cmn.IsEventDone("get_fishinghook") and
     cmn.IsEventDone("get_hammer") and cmn.IsEventDone("get_emblemelement2")  then

    common.CloseSubRoom()

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_object_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_object_1" );
  cmn.CallEventHandler( "get_object_1" );

  common_impl.TutorialShow( "tutorial_page_14" );

end;
--------------------------------------------------------------------------------------------
function private.get_ring()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_ring" );
  cmn.CallEventHandler( "get_ring" );

  if cmn.IsEventDone("get_ring") and cmn.IsEventDone("get_boards") and cmn.IsEventDone("get_fishinghook") and
     cmn.IsEventDone("get_hammer") and cmn.IsEventDone("get_emblemelement2") and common_impl.IsGetCoin("get_coin_3")  then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.get_cassette()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_cassette" );
  cmn.CallEventHandler( "get_cassette" );

  if common_impl.IsGetCoin("get_coin_1") then
    common.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
-------------------------------------------------------------------------------------------
function private.clk_pointer1()

  local func_after  = function ()
    common_impl.Lock(false);
  end;
  common_impl.Lock(true)
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_wooden_arrows", 0, "", 0 );
  common_impl.ShowBbt( 'bbt_pointer_clk_tablet' );
  ObjAnimate("spr_pointer_tablet_1", "ang", 0, 0, func_after, {0, 2, 0, 0.3, 3, 0.02,    0.6, 2, 0.0});

end;
-------------------------------------------------------------------------------------------
function private.clk_pointer2()

  local func_after  = function ()
    common_impl.Lock(false);
  end;
  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_wooden_arrows", 0, "", 0 );
  common_impl.ShowBbt( 'bbt_pointer_clk_tablet' );
  ObjAnimate("spr_pointer_tablet_2", "ang", 0, 0, func_after, {0, 1, 0, 0.3, 3, -0.02,    0.6, 3, 0.0});
end;
-------------------------------------------------------------------------------------------
function private.clk_brab()

  common_impl.ShowBbt( 'bbt_pickuptruck_use_scythe' );
  common_impl.Lock(true);
  local func_after = function ()
    common_impl.Lock(false);
  end;
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_weed", 0, "", 0 );
  AnimPlay( "anm_pickuptruck_barb_click", "DoAnim", func_after );

end;
-------------------------------------------------------------------------------------------
function private.clk_cover()

  common_impl.ShowBbt( 'bbt_pickuptruck_use_scissors' );
  
  common_impl.Lock(true);

  GridPlay( "grd_pickuptruck_cover","*common_impl.Lock(false);" );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_clothes", 0, "", 0 );

end;
-------------------------------------------------------------------------------------------
function private.clk_close_case()
  
  common_impl.Lock(true);
  local func_after = function ()
    private.clk_close_case_end();
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_case_cover", 0, "", 0 );

  ObjAnimate( "spr_pickuptruck_close_case" , "pos_y", 0, 0, func_after, 
  {
    0.0, 0, 55,
    0.3, 0, 57,
    0.6, 0, 55
  });

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_very_small_metal", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.clk_barrier()
  
  common_impl.Lock(true);
  local func_after = function ()
    common_impl.Lock(false);
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_nightsville_gate", 0, "", 0 );
  AnimPlay( "anm_barrier_barrier", "DoAnim", func_after );
  common_impl.ShowBbt( 'bbt_barrier_clk_barrier', 1 );

end;
--------------------------------------------------------------------------------------------
function private.clk_close_case_end()
  
  common_impl.Lock(false);
  common_impl.ShowBbt( 'bbt_pickuptruck_use_briefcasekey' );

end;
--------------------------------------------------------------------------------------------
function private.clk_lock ( func_end )

  common_impl.Lock(true);
  local func_after = function ()

    private.clk_lock_anim( func_end );

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_open_pickup_door", 0, "", 0 );

  ObjAnimate( "spr_pickuptruck_lock_close", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );

  ObjAnimate( "spr_pickuptruck_lock_open", "alp", 0, 0, "", 
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );

end;

function private.clk_lock_anim( func_end )

  local func_after = function ()

    common_impl.Lock(false);

    ng_global.progress["std"]["opn_fork"].op_door = true;
    ObjSet("spr_fork_door_open", {alp = 1});
    ObjSet("spr_fork_door", {alp = 0});
    ObjAttach("obj_screwdiver_hint","spr_pickuptruck_screwdriver" );
    ObjSet("obj_pickuptruck_clk_lock", { input = false });
    ObjSet("obj_pickuptruck_handle", { input = false });
    ObjSet("obj_pickuptruck_clk_door", { input = true });
    if cmn.IsEventDone( "use_briefcasekey" ) then

      ObjSet( "obj_pickuptruck_screwdriver", { input = true } );

    end;

    if ( func_end ) then 
      func_end() 
    end;
  
  end;

  ObjAnimate( "spr_pickuptruck_lock_open", "alp", 0, 0, "", 
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );

  ObjAnimate( "spr_pickuptruck_close_door", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );

  ObjAnimate( "spr_pickuptruck_open_door", "alp", 0, 0, "", 
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );

end;

function private.clk_door()

  common_impl.Lock(true);

  local func_after = function ()

    private.clk_door_anim();

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_close_pickup_door", 0, "", 0 );

  ObjAnimate( "spr_pickuptruck_lock_open", "alp", 0, 0, "", 
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );

  ObjAnimate( "spr_pickuptruck_close_door", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );

  ObjAnimate( "spr_pickuptruck_open_door", "alp", 0, 0, "", 
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );

end;

function private.clk_door_anim()

  local func_after = function ()

    common_impl.Lock(false);

    ng_global.progress["std"]["opn_fork"].op_door = false;
    ObjSet("spr_fork_door_open", {alp = 0});
    ObjSet("spr_fork_door", {alp = 1});
    ObjSet("obj_pickuptruck_clk_lock", { input = true });
    ObjSet("obj_pickuptruck_handle", { input = true });
    ObjSet("obj_pickuptruck_clk_door", { input = false });
    ObjAttach("obj_screwdiver_hint","obj_pickuptruck_clk_lock" );
    if cmn.IsEventDone( "use_briefcasekey" ) then

      ObjSet( "obj_pickuptruck_screwdriver", { input = false } );

    end;

  end;

  ObjAnimate( "spr_pickuptruck_lock_close", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );

  ObjAnimate( "spr_pickuptruck_lock_open", "alp", 0, 0, "", 
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_alligator()

  local func_after = function ()

    common_impl.Lock(false);
    cmn.SetEventDone( "clk_alligator" );
    cmn.CallEventHandler( "clk_alligator_end" );
    common_impl.ShowBbt( 'bbt_vid_fork_alligator', 1 );
    common_impl.PlayAudio( "env", "common/audio/aud_alligator_zz_env", 1, "", 0 );
    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment1_mus", 0, "", 0 );

  end;

  common_impl.Lock(true);

  VidPlay( "vid_shore_alligator", func_after );
  common_impl.PlayAudio( "sfx", "common/audio/aud_shore_alligator", 0, "", 0 );
 
end;
--------------------------------------------------------------------------------------------
function private.clk_alligator_hit()

  local func_after = function ()

    common_impl.Lock(false);
    ObjSet( "vid_shore_alligator_static", { active = true, alp = 1 });
    ObjSet( "vid_shore_alligator_on_hit", { active = false, alp = 0 });
    if ( not cmn.IsEventDone( "use_pyrotechinics" ) ) then

      common_impl.ShowBbt( 'bbt_obj_shore_use_pyrotechinics' );

    elseif ( cmn.IsEventDone( "use_pyrotechinics" ) and not cmn.IsEventDone( "use_matches" ) ) then

      common_impl.ShowBbt( 'bbt_obj_shore_use_matches' );

    end;

  end;

  common_impl.Lock(true);

  ObjSet( "vid_shore_alligator_static", { active = false, alp = 0 });
  ObjSet( "vid_shore_alligator_on_hit", { active = true, alp = 1 });
  VidPlay( "vid_shore_alligator_on_hit", func_after );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_alligator", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.clk_box()

  cmn.CallEventHandler( "clk_box_beg" );

  local func_after = function ()

    common_impl.Lock(false);
    cmn.SetEventDone( "clk_box" );
    cmn.CallEventHandler( "clk_box_end" );
  
  end;

  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_casket", 0, "", 0 );

  ObjAnimate( "obj_pointer_box_closed", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1.0,
    0.4, 0, 0.0
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_dictaphone()

  cmn.CallEventHandler( "clk_dictaphone_beg" );

  local func_after = function ()

    common_impl.Lock(false);
    cmn.SetEventDone( "clk_dictaphone" );
    cmn.CallEventHandler( "clk_dictaphone_end" );
  
  end;

  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_casket_cloth", 0, "", 0 );

  ObjAnimate( "spr_pointer_rag", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );
  ObjAnimate( "spr_pointer_rag_opened", "alp", 0, 0, "", 
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_shore()

  cmn.CallEventHandler( "clk_shore_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_shore" );
    cmn.CallEventHandler( "clk_shore_end" );
    common_impl.Lock( false );
  
  end;

  common_impl.Lock( true );

  ObjSet( "anm_fork_shore_close", { alp = 0 } );
  ObjSet( "anm_fork_shore_unlock", { alp = 1 } );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_weed_near_bridge", 0, "", 0 );
  AnimPlay( "anm_fork_shore_unlock", "DoAnim", func_after );

end;
--------------------------------------------------------------------------------------------

function private.clk_fork_providence_2()

  cmn.CallEventHandler( "clk_fork_providence_2_beg" );

  local func_after = function ()

    cmn.CallEventHandler( "clk_fork_providence_2_end" );

    common_impl.Lock( false );
    if cmn.IsEventDone( "clk_fork_providence_1" ) and cmn.IsEventDone( "clk_fork_providence_3" ) then

      private.anim_providence( function() cmn.SetEventDone( "clk_fork_providence_2" ); end );

    else
      cmn.SetEventDone( "clk_fork_providence_2" );
    end;
  
  end;

  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_fork_tree", 0, "", 0 );
  ObjSet( "spr_fork_providence_bush", { alp = 0 } );
  --ObjAnimate( "spr_fork_providence_bush",      "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 0 } );
  ObjAnimate( "spr_fork_providence_bush_used", "alp", 0, 0, func_after, { 0, 0, 0, 0.1, 0, 0, 0.3, 0, 1 } );

end;
--------------------------------------------------------------------------------------------
function private.clk_fork_providence_1()

  cmn.CallEventHandler( "clk_fork_providence_1_beg" );

  local func_after = function ()

    cmn.CallEventHandler( "clk_fork_providence_1_end" );

    common_impl.Lock( false );

    if cmn.IsEventDone( "clk_fork_providence_2" ) and cmn.IsEventDone( "clk_fork_providence_3" ) then

      private.anim_providence( function()cmn.SetEventDone( "clk_fork_providence_1" ); end );

    else
      cmn.SetEventDone( "clk_fork_providence_1" );
    end;
  
  end;

  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_fork_log", 0, "", 0 );
  ObjSet( "spr_fork_providence_timber", { alp = 0 } );
  --ObjAnimate( "spr_fork_providence_timber",      "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 0 } );
  ObjAnimate( "spr_fork_providence_timber_used", "alp", 0, 0, func_after, { 0, 0, 0, 0.1, 0, 0, 0.3, 0, 1 } );

end;
--------------------------------------------------------------------------------------------
function private.clk_fork_providence_3()

  cmn.CallEventHandler( "clk_fork_providence_3_beg" );

  local func_after = function ()

    cmn.CallEventHandler( "clk_fork_providence_3_end" );
    common_impl.Lock( false );

    if cmn.IsEventDone( "clk_fork_providence_2" ) and cmn.IsEventDone( "clk_fork_providence_1" ) then

      private.anim_providence( function() cmn.SetEventDone( "clk_fork_providence_3" ); end );

    else
      cmn.SetEventDone( "clk_fork_providence_3" );
    end;
  
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_fork_log", 0, "", 0 );
  ObjSet( "spr_fork_providence_plate", { alp = 0 } );
  --ObjAnimate( "spr_fork_providence_timber",      "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 0 } );
  ObjAnimate( "spr_fork_providence_plate_used", "alp", 0, 0, func_after, { 0, 0, 0, 0.1, 0, 0, 0.3, 0, 1 } );

end;
--------------------------------------------------------------------------------------------
function private.anim_providence( func_execute )

  common_impl.ShowBbt( "bbt_providence_allitems" );
  int_button_providence.StopActiveProvidence();

  local array_objects = {
    "spr_fork_providence_plate_used",
    "spr_fork_providence_bush_used",
    "spr_fork_providence_timber_used" }

  local func_end = function()

    for i = 1, #array_objects do
      ObjAttach( array_objects[ i ], "rm_fork_providence" );
      ObjSet( array_objects[ i ], { alp = 1 } );
    end;
    common_impl.Lock( false );    
    private.vid_fork_providence( func_execute );

  end;
  
  common_impl.Lock( true );
  for i = 1, #array_objects do
    common_impl.PlayEffectHO( array_objects[ i ], func_end, 3, "assets/interface/resources/effect_mask" );
    func_end = nil;
  end;
  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_ready", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.Ring_clk()

  local endtrig = function ()
    common_impl.Lock(false);
  end;
  common_impl.ShowBbt( 'bbt_shore_use_pliers' );
  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_ring", 0, "", 0 );
  ObjAnimate("spr_shore_ring", "ang", 0, 0, endtrig, {0, 3, 0,  0.2, 3,-0.1,   0.6, 3,0.1, 0.8, 3,0 });

end;
--*********************************************************************************************************************
-------------------------------------------------------------------------------------
function private.drag_timber ()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_fork_providence_timber", { pos_z = 10 } );

end;
-------------------------------------------------------------------------------------
function private.drop_timber ()

  local item = "spr_fork_providence_timber";

  ObjSet( item, { pos_z = 0 } );

  if ( ObjIntersect( item, "obj_fork_providence_item_1" ) ) then

    private.clk_fork_providence_1();

  end;

end;
-------------------------------------------------------------------------------------
function private.drag_bush ()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_fork_providence_bush", { pos_z = 10 } );

end;
-------------------------------------------------------------------------------------
function private.drop_bush ()

  local item = "spr_fork_providence_bush";

  ObjSet( item, { pos_z = 0 } );

  if ( ObjIntersect( item, "obj_fork_providence_item_2" ) ) then

    private.clk_fork_providence_2();

  end;

end;
-------------------------------------------------------------------------------------
function private.drag_plate ()

   common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_fork_providence_plate", { pos_z = 10 } );

end;
-------------------------------------------------------------------------------------
function private.drop_plate ()

  local item = "spr_fork_providence_plate";

  ObjSet( item, { pos_z = 0 } );

  if ( ObjIntersect( item, "obj_fork_providence_item_3" ) ) then

    private.clk_fork_providence_3();

  end;

end;
-------------------------------------------------------------------------------------
function private.vid_fork_ancient()

  cmn.CallEventHandler( "vid_fork_ancient_beg" );
  ObjSet( "vid_fork_ancient", { alp = 1, active = true, input = false, visible = true } );
  ObjSet( "rm_fork", { input = false } );
  ObjAttach( "vid_fork_ancient", "rm_fork" );
  
  local func_after = function ( skip )

    interface.DialogVideoHide();
    ObjSet( "rm_fork", { input = true } );
    cmn.SetEventDone( "vid_fork_ancient" );
    cmn.CallEventHandler( "vid_fork_ancient_end" );
  
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_fork_ancient", 0, "", 0.5 );
    
    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment3_mus", 0, "", 0 );
    common_impl.ShowBbt( 'bbt_vid_fork_ancient', 1 );

  end;

  common_impl.StopAllMus();
  common_impl.StopTimer();

  interface.DialogVideoShow( "vid_fork_ancient", 1, function() func_after( 'skip' ); end, 3 );
  common_impl.PlayAudio( "sfx", "common/audio/aud_fork_ancient", 0, "", 0.5 );
  VidPlay( "vid_fork_ancient", function() func_after( nil ); end ); 

end;

-------------------------------------------------------------------------------------

function private.vid_fork_providence ( func_execute )

  interface.BBTHide();

  private.func_providence = func_execute;
  int_button_providence.StopLightProvidence();
  cmn.CallEventHandler( "vid_fork_providence_beg" );

  common_impl.StopAllMus();
  VidPlay( "vid_fork_providence_p1", "" );
  interface.DialogVideoShow( "vid_fork_providence", 1, private.vid_fork_providence_end, 3, 5 );    
  common_impl.PlayAudio( "sfx", "common/audio/aud_fork_providence_p1", 0, "", 0.5 ); 
  common_impl.PlayAudio( "mus", "common/audio/aud_providence_mus", 1, "", 0.5 ); 

end;
-------------------------------------------------------------------------------------
function private.vid_fork_providence_end ()

  interface.DialogVideoHide();  
  int_providence.Hide();
  common_impl.Lock(false);

  cmn.SetEventDone( "vid_fork_providence" );
  cmn.CallEventHandler( "vid_fork_providence_end" );

  AnimPlay( "anm_fork_slider_unlock", "DoAnim", "" );

  int_slider.InitSlider( private.room_objname );
  common_impl.TutorialShow( "tutorial_page_18" );
  --common_impl.ShowBbt( 'bbt_after_providence_1', 1 );
  common_impl.ShowBbt( 'bbt_providence_level1_1_end' );
  common_impl.StopAudio( "mus", "common/audio/aud_providence_mus", 0.2 ); 
  common_impl.StopAudio( "sfx", "common/audio/aud_fork_providence_p5", 0.2 ); 
  common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment2_mus", 0, "", 0 );

  if ( private.func_providence ) then

    private.func_providence();
    private.func_providence = nil;

  end;
 
end;
--*********************************************************************************************************************
-- DIALOG CHARACTER
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if count_txt == 3 then 

    ObjSet( "anm_fork_ancient_character_2", { alp = 1 } ); 
    ObjSet( "anm_fork_ancient_character_2_fx", { alp = 1 } ); 
    ObjSet( "anm_fork_ancient_character", { alp = 0 } );
    AnimStop( "anm_fork_ancient_character" );
    ObjSet( "anm_fork_ancient", { active = false } );

    local func_after = function()

      ObjSet( "anm_fork_ancient_character", { alp = 0 } );
      ObjSet( "spr_fork_ancient_over", { alp = 0 } );
      AnimStop( "anm_fork_ancient_character" ); 
      ObjSet( "anm_fork_ancient_character_3", { alp = 1 } ); 
      common_impl.PlayAudio( "sfx", "common/audio/aud_blind_hide", 0, "", 0.5 );
      AnimPlay( "anm_fork_ancient_character_3", "DoAnim", common_impl.DialogCharacterHide );
      ObjSet( "vid_fork_ancient_3", { alp = 0, playing = 0 } );
      
    end;  

    local func_after_2 = function()

      ObjSet( "anm_fork_ancient_character_2", { alp = 0 } ); 
      ObjSet( "anm_fork_ancient_character_2_fx", { alp = 0 } ); 
      ObjSet( "anm_fork_ancient_character", { alp = 1 } ); 
      AnimPlay( "anm_fork_ancient_character", "DoAnim","" );  
           
    end;  

    common_impl.PlayAudio( "sfx", "common/audio/aud_blind_cast_providence", 0, "", 0.5 );

    AnimPlay( "anm_fork_ancient_character_2", "DoAnim", func_after_2 );
    AnimPlay( "anm_fork_ancient_character_2_fx", "DoAnim", "" );

    ObjSet( "tmr_fork_ancient_anm", { time = 10, playing = 1, endtrig = func_after } );
  
  end;  

end;
--*********************************************************************************************************************
function public.character_click()
  
  common_impl.dialog_character_loc = "anm_fork_ancient";
  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "ancient", 4, nil, nil, true, "character_click_end" );

end;

ObjSet( "obj_dlg_fork_ancient", { event_mdown = public.character_click } );
ObjSet( "obj_dlg_fork_ancient_focus", { event_mdown = public.character_click } );
--*********************************************************************************************************************
function public.character_click_end()

  cmn.CallEventHandler( "dlg_fork_ancient_end" );

  common_impl.StopAudio( "sfx", "common/audio/aud_blind_hide", 0, "", 0.5 );
  common_impl.StopAudio( "sfx", "common/audio/aud_blind_cast_providence", 0, "", 0.5 );
  
  AnimStop( "anm_fork_ancient_character_3");
  ObjSet( "anm_fork_ancient_character_3", { alp = 0 } );
  ObjSet( "tmr_fork_ancient_anm", { playing = 0 } ); 

  local func_after = function()

    cmn.SetEventDone( "dlg_fork_ancient" );
    common_impl.Lock(false);
    common_impl.TutorialShow( "tutorial_page_12" );
   
    int_providence_eye.CheckShow();
    int_button_providence.StartLightProvidence();

    ObjSet( "spr_int_inventory_side_right", { visible = false } );

    cmn.CallEventHandler( "dlg_fork_ancient_inv" );

    local page_content2 = {1, 1, 1};
    common_impl.AddBookmarkDiary( 2, 1, page_content2);

  end;

  common_impl.PlayAudio( "mus", "common/audio/aud_adventure2_mus", 0, "", 0 );

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_show_inv_add", 0, "", 0 );

  interface.PanelProvideAnimShow( func_after );

end;
--*********************************************************************************************************************
function private.opn_fork()

  if not ( cmn.IsEventDone( "opn_fork" ) ) then
    cmn.SetEventDone( "opn_fork" );
  end;

  cmn.CallEventHandler( "opn_fork" ); 

end;
--*********************************************************************************************************************
function private.clk_tablet( index )

  common_impl.Lock(true);
   
  local pos_x = ObjGet( "obj_pointer_tablet_"..index ).pos_x;
  local pos_x_end = pos_x;
  if ( index == 1 ) then
    pos_x_end = pos_x_end - 2;
  else 
    pos_x_end = pos_x_end + 2;
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_wooden_arrows", 0, "", 0 );
  ObjAnimate( "obj_pointer_tablet_"..index, "pos_x", 0, 0, function() common_impl.Lock(false); end,
  { 
    0.0, 0, pos_x, 
    0.3, 0, pos_x_end,
    0.6, 0, pos_x
  } );
 
end;
--*********************************************************************************************************************
function public.SilhueteEscape()

  local trg_after = function ()

    common_impl.Lock( false );
    ng_global.progress["std"]["opn_fork"].silhouette = true;
    cmn.CallEventHandler( "use_fishinghook_silhuette" );

  end;

    common_impl.Lock( true );
    ObjSet( "obj_fork_bbt_owlman",{ input = true, visible = true, active = true } );
    ObjSet( "spr_fork_silhuette", { input = 0 } );
    ObjAnimate( "spr_fork_silhuette", "alp", 0, 0, trg_after, { 0,0,1, 0.5,0,0 } );

end;
--*********************************************************************************************************************
  ObjAnimate( "spr_shore_sealline", "ang", 1, 0, "", { 0,0,-0.11, 2.5,0,-0.05, 5,0,-0.11 } );
  ObjAnimate( "spr_shore_reed_1", "ang", 1, 0, "", { 0,0,0.02, 2,0,-0.02, 4,0,0.02 } );
  ObjAnimate( "spr_shore_reed_2", "ang", 1, 0, "", { 0,0,-0.03, 1.5,0,0.03, 3,0,-0.03 } );
  ObjAnimate( "spr_shore_reed_3", "ang", 1, 0, "", { 0,0,0.04, 1.0,0,-0.04, 2.0,0,0.04 } );
  ObjAnimate( "spr_shore_bush_2", "ang", 1, 0, "", { 0,0,-0.02, 2,0,0, 4,0,-0.02 } );
  ObjAnimate( "spr_shore_bush_3", "ang", 1, 0, "", { 0,0,0.04, 2.5,0,-0.04, 5,0,0.04 } );
  ObjAnimate( "spr_shore_bush_4", "ang", 1, 0, "", { 0,0,0, 3,0,0.04, 6,0,0 } );
  ObjAnimate( "spr_shore_chest", "ang", 1, 0, "", { 0,0,-0.05, 3.5,0,0.05, 7,0,-0.05 } );

  ObjAnimate( "spr_shore_light", "alp", 1, 0, "", { 0,0,0, 1.5,0,1, 3,0,0 } );
  ObjAnimate( "spr_shore_light_2", "alp", 1, 0, "", { 0,0,0.5, 2,0,1, 4,0,0.5 } );
  ObjAnimate( "spr_shore_add_berth", "alp", 1, 0, "", { 0,0,0, 2,0,1, 4,0,0 } );
  ObjAnimate( "spr_shore_hook_light", "alp", 1, 0, "", { 0,0,0.5, 2,0,1, 4,0,0.5 } );