-- name=rm_livingroom
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_livingroom";
  private.character = 1;
  private.dialog_voices_time = {};
  private.start_dial_game = false;
  private.dial_game_coords = { { -16, -65 }, { 31, -6 }, { 17,-95 }, { 20, -92 } }; --координаты Y маленьких документов для анимации
  private.big_coords = {}; --координаты развернутых документов
  private.little_coords = {}; --координаты свернутых документов
  private.dial_game_state = { 0,0,0 };
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_table", "room_hub" );
  ObjAttach( "zz_wardrobe", "room_hub" );
  ObjAttach( "zz_door", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet( {
    { "spr_table_scissors", { event_mdown = private.get_scissors } },
    { "spr_table_matches", { event_mdown = private.get_matches } },
    { "spr_table_papercode", { event_mdown = private.get_papercode } },
    { "spr_table_batteries", { event_mdown = private.get_batteries } },
    { "spr_table_cryptex", { event_mdown = private.get_cryptex } },
    { "spr_wardrobe_emblemelement3", { event_mdown = private.get_emblemelement3 } },
    { "spr_wardrobe_evidence_1_2", { event_mdown = private.get_evidence_1_2 } },
    { "spr_wardrobe_bag", { event_mdown = private.get_bag } },
    { "spr_wardrobe_zipperslider", { event_mdown = private.get_zipperslider } },
    { "spr_wardrobe_clockhands", { event_mdown = private.get_clockhands } },
    { "spr_wardrobe_brokenglasses", { event_mdown = private.get_brokenglasses } },
    { "obj_wardrobe_clk_books1", { event_mdown = private.clk_books1 } },
    { "obj_wardrobe_clk_books2", { event_mdown = private.clk_books2 } },
    { "obj_wardrobe_clk_books3", { event_mdown = private.clk_books3 } },
    { "obj_livingroom_clk_sightlamp", { event_mdown = private.clk_sightlamp } },
    { "obj_livingroom_clk_sightvas", { event_mdown = private.clk_sightvas } },
    { "obj_livingroom_clk_sighsplinter1", { event_mdown = private.clk_sighsplinter1 } },
    { "obj_livingroom_clk_sighsplinter2", { event_mdown = private.clk_sighsplinter2 } },
    { "obj_livingroom_clk_sighsplinter3", { event_mdown = private.clk_sighsplinter3 } },
    { "obj_wardrobe_clk_door", { event_mdown = private.clk_door } },
    { "obj_wardrobe_use_ruler", { event_mdown = private.clk_door } },
    { "spr_wardrobe_jacket", { event_mdown = private.clk_jacket } },
    { "spr_door_handle", { event_mdown = private.clk_handle } },
    { "obj_door_clk_officekey", { event_mdown = private.clk_officekey } },
    { "obj_table_use_fishinghook", { event_mdown = private.clk_closedtable } },
    { "obj_table_use_screwdriver", { event_mdown = private.clk_closedbaterries } },
    { "obj_door_use_officekey", { event_mdown = function() common_impl.ShowBbt( 'bbt_door_use_officekey' ); end; } },
    { "obj_table_use_button", { event_mdown = function() private.clk_spring(); end; } },
    { "obj_livingroom_use_providence_invitem_1", { event_mdown = private.get_object_1_silhouette } },
    { "obj_livingroom_providence_item_1", { event_mdown = function() int_providence.Thinking( "providence_1", "obj_livingroom_providence_item_1" ) end } },
    { "obj_livingroom_providence_item_2", { event_mdown = function() int_providence.Thinking( "providence_2", "obj_livingroom_providence_item_2" ) end } },
    { "obj_livingroom_providence_item_2_focus", { event_mdown = function() int_providence.Thinking( "providence_2", "obj_livingroom_providence_item_2_focus" ) end } },
    { "obj_livingroom_providence_item_3", { event_mdown = function() int_providence.Thinking( "providence_3", "obj_livingroom_providence_item_3" ) end } },
    { "obj_dlg_livingroom_search", { event_mdown =  private.dlg_search_click } },
    { "obj_dlg_livingroom_search_focus", { event_mdown =  private.dlg_search_click } },
    { "obj_dlg_livingroom_george", { event_mdown =  private.dlg_george_click } },
    { "obj_dlg_livingroom_george_focus", { event_mdown =  private.dlg_george_click } },
    { "spr_table_coin",{event_mdown = function() private.get_coin5() end } },
    { "spr_wardrobe_coin",{event_mdown = function() private.get_coin6() end } },
    { "obj_table_clk_button", {event_mdown = function() private.clk_button() end }},
    { "spr_livingroom_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_4" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "obj_wardrobe_use_monogram", { event_mdown = private.clk_suitcase } },
    { "spr_livingroom_providence_lamp",  { input = true, drag = true, event_startdrag = private.get_lamp, event_dragdrop = private.drop_lamp, event_menter = function () common_impl.SetCursor( CURSOR_GET ) end, event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_livingroom_providence_vase",  { input = true, drag = true, event_startdrag = private.get_vase, event_dragdrop = private.drop_vase, event_menter = function () common_impl.SetCursor( CURSOR_GET ) end, event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_livingroom_providence_glass", { input = true, drag = true, event_startdrag = private.get_glass, event_dragdrop = private.drop_glass, event_menter = function () common_impl.SetCursor( CURSOR_GET ) end, event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_livingroom_dial_purse_close", { event_mdown = private.ClkPurse } },
    { "spr_livingroom_dial_1_little", { event_mdown = function() private.ClkDocument( 1, "up" )end; } },
    { "spr_livingroom_dial_2_little", { event_mdown = function() private.ClkDocument( 2, "up" )end; } },
    { "spr_livingroom_dial_3_little", { event_mdown = function() private.ClkDocument( 3, "up" )end; } },
    { "obj_livingroom_clk_pickup", { event_mdown = function() private.ClkCar()end; } }
  } );
  ObjAnimate( "spr_livingroom_plane", "ang", 1, 0, "",{ 0.0, 3, -0.15, 1.5, 3, 0.15,3.0, 3, -0.15} );

 --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_livingroom = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gho_livingroom_search",
      "gzz_livingroom_table",
      "gzz_livingroom_wardrobe",
      "gzz_livingroom_door",
    };
    for i = 1, #gates do
    
      local name = gates[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 

      {
        private.room_objname,
        "zz_table",
        "zz_wardrobe",
        "zz_door"
      
      };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_livingroom", update_game_mode_livingroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_livingroom = function ()
    
    local effects_table = 
    {
      "anm_livingroom_window",
      "spr_livingroom_light",
      "spr_livingroom_ball_hotspot",
      "spr_livingroom_chandelier",
      "spr_table_bear_paw_1",
      "spr_table_bear_paw_2",
      "spr_table_light",
      "spr_livingroom_ball",
      "anm_livingroom_window",
      "grd_livingroom_curtain",
      "spr_door_light_close",
      "spr_door_light",
      "spr_livingroom_plane",
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_livingroom", update_performance_mode_livingroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_livingroom () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_livingroom" ] = {
    type = "click",
    use_place = "grm_square_livingroom",
    room = "rm_square"
  };

  local opn_livingroom_map = function ()

    common_impl.VisitMapRoom( "livingroom" );

  end;
  cmn.AddSubscriber( "opn_livingroom", opn_livingroom_map, nil );
  --------------------------------------------------------------------------------------------
  -- function opn_zoom_armchair () end;
  --------------------------------------------------------------------------------------------
  local opn_zoom_armchair = function ()

    ObjSet( "anm_livingroom_window", { alp = 1, playing = true });
    ObjDelete( "anm_livingroom_george" );

  end;
  cmn.AddSubscriber( "opn_zoom_armchair", opn_zoom_armchair, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coins () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_5 = function ()

    ObjDelete( "obj_table_coin" );
    
    if cmn.IsEventDone("get_cryptex") then

      ObjDelete( "gzz_livingroom_table" );
      
    end;
 
  end;
  cmn.AddSubscriber( "get_coin_5", get_collect_coin_5, private.room_objname );  
  --------------------------------------------------------------------------------------------
  local get_collect_coin_6 = function ()

    ObjDelete( "obj_wardrobe_coin" );

    if cmn.IsEventDone("get_brokenglasses") and  cmn.IsEventDone("get_clockhands") then

      ObjDelete( "gzz_livingroom_wardrobe" );

    end;
 
  end;
  cmn.AddSubscriber( "get_coin_6", get_collect_coin_6, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function get_scissors () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_scissors" ] = {
    type = "get",
    get_obj = "spr_table_scissors",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_livingroom_table"
  };
  local get_scissors_inv = function ()
  
    interface.InventoryItemAdd( "inv_scissors", "spr_table_scissors" );
  
  end;
  
  local get_scissors_closezz = function ()
  
    ObjDelete( "gfx_table_scissors" );
    ObjDelete( "spr_table_scissors_shadow" );
    ObjDelete( "spr_livingroom_zz_table_scissors" );
  end;

  local get_scissors_rm = function ()
  
    if not ng_global.progress["std"]["opn_fork"].silhouette then

      ObjSet( "spr_fork_silhuette",{ event_menter = rm_fork.SilhueteEscape, input = true, visible = true } );

    end;

  end;
  
  cmn.AddSubscriber( "get_scissors", get_scissors_inv );
  cmn.AddSubscriber( "get_scissors", get_scissors_closezz, private.room_objname );
  cmn.AddSubscriber( "get_scissors", get_scissors_rm, "rm_fork" );
  --------------------------------------------------------------------------------------------
  -- function get_matches () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_matches" ] = {
    type = "get",
    get_obj = "spr_table_matches",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_livingroom_table"
  };
  local get_matches_inv = function ()
  
    interface.InventoryItemAdd( "inv_matches", "spr_table_matches" );
  
  end;
  
  local get_matches_closezz = function ()
  
    ObjDelete( "gfx_table_matches" );
    ObjDelete( "spr_table_matches_shadow" );

  end;
  
  cmn.AddSubscriber( "get_matches", get_matches_inv );
  cmn.AddSubscriber( "get_matches", get_matches_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_papercode () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_papercode" ] = {
    type = "get",
    get_obj = "spr_table_papercode",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_livingroom_table"
  };
  local get_papercode_inv = function ()
  
    interface.InventoryItemAdd( "inv_papercode", "spr_table_papercode" );
  
  end;
  
  local get_papercode_closezz = function ()
  
    ObjDelete( "gfx_table_papercode" );
    ObjDelete( "spr_table_papercode_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_papercode", get_papercode_inv );
  cmn.AddSubscriber( "get_papercode", get_papercode_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_batteries () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_batteries" ] = {
    type = "get",
    get_obj = "spr_table_batteries",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_livingroom_table"
  };
  local get_batteries_inv = function ()
  
    interface.InventoryItemAdd( "inv_batteries", "spr_table_batteries" );
  
  end;
  
  local get_batteries_closezz = function ()
    ObjDelete( "spr_livingroom_zz_table_battery" );
    ObjDelete( "gfx_table_batteries" );
    ObjSet( "obj_table_bear", { active = false } );
  
  end;
  
  cmn.AddSubscriber( "get_batteries", get_batteries_inv );
  cmn.AddSubscriber( "get_batteries", get_batteries_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cryptex () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cryptex" ] = {
    type = "get",
    get_obj = "spr_table_cryptex",
    room = private.room_objname,
    zz = "zz_table",
    zz_gate = "gzz_livingroom_table"
  };
  local get_cryptex_inv = function ()
  
    interface.InventoryItemAdd( "inv_cryptex", "spr_table_cryptex" );
    ObjSet( "inv_cryptex", { drag = false });

  end;
  
  local get_cryptex_closezz = function ()
  
    ObjDelete( "gfx_table_cryptex" );
    ObjDelete("spr_table_cryptex_shadow");
    if ( cmn.IsEventDone("get_batteries") and cmn.IsEventDone("get_matches") and common_impl.IsGetCoin("get_coin_5")
    and cmn.IsEventDone("get_papercode") and  cmn.IsEventDone("get_scissors") )then

      ObjDelete( "gzz_livingroom_table" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_cryptex", get_cryptex_inv );
  cmn.AddSubscriber( "get_cryptex", get_cryptex_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_emblemelement3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_emblemelement3" ] = {
    type = "get",
    get_obj = "spr_wardrobe_emblemelement3",
    room = private.room_objname,
    zz = "zz_wardrobe",
    zz_gate = "gzz_livingroom_wardrobe"
  };
  local get_emblemelement3_inv = function ()
  
    interface.InventoryItemAdd( "inv_emblemelement3", "spr_wardrobe_emblemelement3" );
  
  end;
  
  local get_emblemelement3_closezz = function ()

    ObjDelete("spr_livingroom_zz_wardrobe_emblem");
    ObjDelete( "spr_wardrobe_emblemelement3_shadow" );
    ObjDelete( "gfx_wardrobe_emblemelement3" );
    if ( cmn.IsEventDone("get_brokenglasses") and cmn.IsEventDone("get_clockhands") 
    and cmn.IsEventDone("get_zipperslider") and cmn.IsEventDone("get_evidence_1_2") 
    and cmn.IsEventDone("get_bag") and common_impl.IsGetCoin("get_coin_6") ) then

      ObjDelete( "gzz_livingroom_wardrobe" );

    end; 

  end;
  
  cmn.AddSubscriber( "get_emblemelement3", get_emblemelement3_inv );
  cmn.AddSubscriber( "get_emblemelement3", get_emblemelement3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_object () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_evidence_1_2" ] = {
    type = "get",
    get_obj = "spr_wardrobe_evidence_1_2",
    room = private.room_objname,
    zz = "zz_wardrobe",
    zz_gate = "gzz_livingroom_wardrobe"
  };
  
  local get_evidence_1_2_inv = function ()

    --
    
  end;

  local get_evidence_1_2_closezz = function ()

    ObjDelete( "spr_wardrobe_evidence_1_2_shadow_2" );
    ObjDelete( "spr_wardrobe_evidence_1_2" );
    ObjDelete( "gfx_wardrobe_evidence_1_2" );
    if ( cmn.IsEventDone("get_brokenglasses") and cmn.IsEventDone("get_clockhands") 
    and cmn.IsEventDone("get_zipperslider") and cmn.IsEventDone("get_emblemelement3") 
    and cmn.IsEventDone("get_bag") and common_impl.IsGetCoin("get_coin_6")) then

      ObjDelete( "gzz_livingroom_wardrobe" );

    end; 
    ObjDelete( "spr_livingroom_zz_wardrobe_bottle");

  end;

  cmn.AddSubscriber( "get_evidence_1_2", get_evidence_1_2_inv );
  cmn.AddSubscriber( "get_evidence_1_2", get_evidence_1_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bag () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bag" ] = {
    type = "get",
    get_obj = "spr_wardrobe_bag",
    room = private.room_objname,
    zz = "zz_wardrobe",
    zz_gate = "gzz_livingroom_wardrobe"
  };
  local get_bag_inv = function ()
  
    interface.InventoryItemAdd( "inv_bag", "spr_wardrobe_bag" );
    ObjSet( "inv_bag", { drag = 0 });

  end;
  
  local get_bag_closezz = function ()
    ObjDelete("spr_livingroom_zz_wardrobe_bag");
    ObjDelete("spr_wardrobe_bag_sh");
    ObjDelete( "gfx_wardrobe_bag" );
    ObjDelete( "spr_wardrobe_bag_over" );
    if ( cmn.IsEventDone("get_brokenglasses") and cmn.IsEventDone("get_clockhands") 
    and cmn.IsEventDone("get_zipperslider") and cmn.IsEventDone("get_evidence_1_2") 
    and cmn.IsEventDone("get_emblemelement3") and common_impl.IsGetCoin("get_coin_6")) then

      ObjDelete( "gzz_livingroom_wardrobe" );

    end;
    ObjDelete("spr_wardrobe_bag_sh");
  end;
  
  cmn.AddSubscriber( "get_bag", get_bag_inv );
  cmn.AddSubscriber( "get_bag", get_bag_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_zipperslider () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_zipperslider" ] = {
    type = "get",
    get_obj = "spr_wardrobe_zipperslider",
    room = private.room_objname,
    zz = "zz_wardrobe",
    zz_gate = "gzz_livingroom_wardrobe"
  };
  local get_zipperslider_inv = function ()
  
    interface.InventoryItemAdd( "inv_zipperslider", "spr_wardrobe_zipperslider" );
    ObjSet( "spr_bag_plus_light", { alp = 1 } );  
  
  end;
  
  local get_zipperslider_closezz = function ()
    ObjDelete("spr_livingroom_roller");
    ObjDelete( "gfx_wardrobe_zipperslider" );
    ObjDelete("spr_wardrobe_zipperslider_shadow");
    if ( cmn.IsEventDone("get_brokenglasses") and cmn.IsEventDone("get_clockhands") 
    and cmn.IsEventDone("get_bag") and cmn.IsEventDone("get_evidence_1_2") 
    and cmn.IsEventDone("get_emblemelement3") and common_impl.IsGetCoin("get_coin_6")) then

      ObjDelete( "gzz_livingroom_wardrobe" );

    end;

  end;
  
  cmn.AddSubscriber( "get_zipperslider", get_zipperslider_inv );
  cmn.AddSubscriber( "get_zipperslider", get_zipperslider_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_clockhands () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_clockhands" ] = {
    type = "get",
    get_obj = "spr_wardrobe_clockhands",
    room = private.room_objname,
    zz = "zz_wardrobe",
    zz_gate = "gzz_livingroom_wardrobe"
  };
  local get_clockhands_inv = function ()
  
    interface.InventoryItemAdd( "inv_clockhands", "spr_wardrobe_clockhands" );
  
  end;
  
  local get_clockhands_closezz = function ()
    ObjDelete("spr_livingroom_zz_wardrobe_arrows");
    ObjDelete( "gfx_wardrobe_clockhands" );
    ObjDelete("spr_wardrobe_clockhands_shadow");
    if ( cmn.IsEventDone("get_zipperslider") and cmn.IsEventDone("get_brokenglasses") 
    and cmn.IsEventDone("get_bag") and cmn.IsEventDone("get_evidence_1_2") 
    and cmn.IsEventDone("get_emblemelement3") and common_impl.IsGetCoin("get_coin_6") ) then

      ObjDelete( "gzz_livingroom_wardrobe" );

    end;

  end;
  
  cmn.AddSubscriber( "get_clockhands", get_clockhands_inv );
  cmn.AddSubscriber( "get_clockhands", get_clockhands_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenglasses () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokenglasses" ] = {
    type = "get",
    get_obj = "spr_wardrobe_brokenglasses",
    room = private.room_objname,
    zz = "zz_wardrobe",
    zz_gate = "gzz_livingroom_wardrobe"
  };
  local get_brokenglasses_inv = function ()
  
    interface.InventoryItemAdd( "inv_brokenglasses", "spr_wardrobe_brokenglasses" );
    ObjSet( "inv_brokenglasses", { drag = false });

  end;
  
  local get_brokenglasses_closezz = function ()
    ObjDelete("spr_livingroom_zz_wardrobe_glasses");
    ObjDelete( "gfx_wardrobe_brokenglasses" );
    ObjDelete("spr_wardrobe_brokenglasses_shadow");
    if ( cmn.IsEventDone("get_zipperslider") and cmn.IsEventDone("get_clockhands") 
    and cmn.IsEventDone("get_bag") and cmn.IsEventDone("get_evidence_1_2") 
    and cmn.IsEventDone("get_emblemelement3") and common_impl.IsGetCoin("get_coin_6")) then

      ObjDelete( "gzz_livingroom_wardrobe" );

    end;

  end;
  
  cmn.AddSubscriber( "get_brokenglasses", get_brokenglasses_inv );
  cmn.AddSubscriber( "get_brokenglasses", get_brokenglasses_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_object_1_silhouette () end;
  --------------------------------------------------------------------------------------------
  local get_object_1_silhouette_inv = function ()
  
    interface.ProvidePanelSilhouetteAdd( "inv_object_1", "spr_livingroom_providence_plane_silhouette" );

  end;
  
  local get_object_1_silhouette_closezz = function ()

    ObjSet( "spr_livingroom_providence_plane_silhouette", { alp = 1 } );
    ObjSet( "obj_livingroom_use_providence_invitem_1", { event_mdown = function() int_providence.Thinking( "providence_invitem_1", "obj_livingroom_use_providence_invitem_1" ); end; } )

  end;

  local get_object_1_silhouette_notadd = function ()

    ObjSet( "obj_livingroom_use_providence_invitem_1", { event_mdown = function() int_providence.Thinking( "providence_invitem_1", "obj_livingroom_use_providence_invitem_1" ); end; } )

  end;
  
  cmn.AddSubscriber( "get_object_1_silhouette", get_object_1_silhouette_inv );
  cmn.AddSubscriber( "get_object_1_silhouette", get_object_1_silhouette_closezz, private.room_objname );
  cmn.AddSubscriber( "get_object_1", get_object_1_silhouette_notadd, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriver_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriver_1" ] = {
      type = "use",
      inv_obj = "inv_screwdriver",
      use_place = "obj_table_use_screwdriver",
      room = private.room_objname,
      zz = "zz_table",
      zz_gate = "gzz_livingroom_table"
  };
  --local use_screwdriver_1_inv = function ()
  --
  --  interface.InventoryItemRemove( "inv_screwdriver" );
  --
  --end;
  local use_screwdriver_1_beg = function ()
  
    ObjDelete( "obj_table_use_screwdriver" );
  
  end;
  local use_screwdriver_1_end = function ()
  
    ObjSet( "spr_table_batteries", { input = true } );
    ObjSet( "gfx_table_batteries", { active = true } );
    ObjDelete( "spr_table_bear_cover" );
    ObjDelete( "spr_livingroom_zz_table_cover" );

    ObjDelete("vid_table_screw");
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screwdriver_1", use_screwdriver_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_1", use_screwdriver_1_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_1_beg", use_screwdriver_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver_1_end", use_screwdriver_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fishinghook () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fishinghook" ] = {
      type = "use",
      inv_obj = "inv_fishinghook",
      use_place = "obj_table_use_fishinghook",
      room = private.room_objname,
      zz = "zz_table",
      zz_gate = "gzz_livingroom_table"
  };
  local use_fishinghook_inv = function ()
  
    interface.InventoryItemRemove( "inv_fishinghook" );
  
  end;
  local use_fishinghook_beg = function ()
  
    ObjDelete( "obj_table_use_fishinghook" );
  
  end;
  local use_fishinghook_end = function ()
  
    ObjSet( "spr_table_matches", { input = true } );
    ObjSet( "gfx_table_matches", { active = true } );
    ObjSet( "spr_table_papercode", { input = true } );
    ObjSet( "gfx_table_papercode", { active = true } );
    ObjSet( "obj_table_use_button", { input = true } );
    ObjSet( "spr_table_open", { alp = 1 } );
    ObjDelete( "spr_table_hook_over" );
    ObjDelete( "spr_table_close" );
    ObjDelete( "anm_table_open" );
    ObjSet( "spr_livingroom_zz_table_open", {alp = 1} );

  end;

  local use_fishinghook_silhuette = function ()

    

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fishinghook", use_fishinghook_beg, private.room_objname );
  cmn.AddSubscriber( "use_fishinghook", use_fishinghook_inv );
  cmn.AddSubscriber( "use_fishinghook", use_fishinghook_end, private.room_objname );
  cmn.AddSubscriber( "use_fishinghook", use_fishinghook_silhuette, "rm_fork" );
  cmn.AddSubscriber( "use_fishinghook_silhuette", use_fishinghook_silhuette, "rm_fork" );
  cmn.AddSubscriber( "use_fishinghook_inv", use_fishinghook_inv, private.room_objname );
  cmn.AddSubscriber( "use_fishinghook_beg", use_fishinghook_beg, private.room_objname );
  cmn.AddSubscriber( "use_fishinghook_end", use_fishinghook_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_button" ] = {
      type = "use",
      inv_obj = "inv_button",
      use_place = "obj_table_use_button",
      room = private.room_objname,
      zz = "zz_table",
      zz_gate = "gzz_livingroom_table"
  };
  local use_button_inv = function ()
  
    interface.InventoryItemRemove( "inv_button" );
  
  end;
  local use_button_beg = function ()
  
    ObjDelete( "obj_table_use_button" );
  
  end;
  local use_button_end = function ()

    ObjMultiSet({

      { "obj_table_clk_button", { input = true, active = true } },
      { "spr_table_open_button_1", {alp = 1} };

    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_button", use_button_beg, private.room_objname );
  cmn.AddSubscriber( "use_button", use_button_inv );
  cmn.AddSubscriber( "use_button", use_button_end, private.room_objname );
  cmn.AddSubscriber( "use_button_inv", use_button_inv, private.room_objname );
  cmn.AddSubscriber( "use_button_beg", use_button_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_end", use_button_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_button () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_button" ] = {
      type = "click",
      use_place = "obj_table_clk_button",
      room = private.room_objname,
      zz = "zz_table",
      zz_gate = "gzz_livingroom_table"
  };

  local clk_button = function ()

    ObjMultiSet({

      { "spr_table_cryptex_shadow", {alp = 1} },
      { "spr_table_cryptex", { input = true } },
      { "gfx_table_cryptex", { active = true } },
      { "spr_table_open_button_2", { alp = 1 } },

    });

    ObjDelete("obj_table_clk_button");
    ObjDelete("spr_table_open_button_1");
    ObjDelete( "spr_table_open_crypt_cover" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_button", clk_button, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_2" ] = {
      type = "use",
      inv_obj = "inv_elf",
      use_place = "obj_wardrobe_use_elf",
      room = private.room_objname,
      zz = "zz_wardrobe",
      zz_gate = "gzz_livingroom_wardrobe"
  };

  local use_elf_2_beg = function ()
  
    ObjDelete( "obj_wardrobe_use_elf" );
  
  end;

  local use_elf_2_end = function ()

    ObjDelete( "vid_wardrobe_use_elf" );  
    ObjSet( "spr_wardrobe_evidence_1_2", { input = true, visible = true, active = true } );
    ObjSet( "spr_wardrobe_evidence_1_2_shadow_2"  , {alp = 1});
    ObjSet( "spr_livingroom_zz_wardrobe_bottle" , {alp = 1});
    ObjDelete( "spr_wardrobe_evidence_1_2_dark" );
    ObjDelete( "spr_wardrobe_evidence_1_2_shadow" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_2", use_elf_2_beg, private.room_objname );
  --cmn.AddSubscriber( "use_elf_2", use_elf_2_inv );
  --cmn.AddSubscriber( "use_elf_2", use_elf_2_add );
  cmn.AddSubscriber( "use_elf_2", use_elf_2_end, private.room_objname );
  --cmn.AddSubscriber( "use_elf_2_inv", use_elf_2_inv, private.room_objname );
  --cmn.AddSubscriber( "use_elf_2_add", use_elf_2_add, private.room_objname );
  cmn.AddSubscriber( "use_elf_2_beg", use_elf_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_2_end", use_elf_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ruler () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ruler" ] = {
      type = "use",
      inv_obj = "inv_ruler",
      use_place = "obj_wardrobe_use_ruler",
      room = private.room_objname,
      zz = "zz_wardrobe",
      zz_gate = "gzz_livingroom_wardrobe"
  };
  local use_ruler_inv = function ()
  
    interface.InventoryItemRemove( "inv_ruler" );
  
  end;
  local use_ruler_beg = function ()
  
    ObjDelete( "obj_wardrobe_use_ruler" );
  
  end;
  local use_ruler_end = function ()
    ObjSet("spr_livingroom_zz_wardrobe_close_case", {alp = 1});
    ObjSet("spr_livingroom_zz_wardrobe_open", { alp = 1} );
    ObjSet("spr_livingroom_roller", { alp = 1});
    ObjSet("spr_livingroom_zz_wardrobe_bag", { alp = 1 });
    ObjDelete("spr_wardrobe_line");
    ObjDelete("spr_wardrobe_latch_over1");
    ObjDelete( "spr_wardrobe_jacket" );
    ObjDelete("spr_wardrobe_latch");
    ObjDelete("spr_wardrobe_latch_over2");
    ObjSet( "spr_wardrobe_bag", { input = true, visible = true, active = true } );
    ObjSet( "spr_wardrobe_zipperslider", { input = true, visible = true, active = true } );
    ObjSet( "obj_wardrobe_use_monogram", { input = true, visible = true, active = true } );
    ObjSet("obj_wardrobe_open_doors", {alp = 1 });
    ObjDelete("obj_wardrobe_clk_door");
    ObjSet( "obj_dlg_livingroom_george", { input = true } );
    ObjSet( "anm_livingroom_george", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ruler", use_ruler_beg, private.room_objname );
  cmn.AddSubscriber( "use_ruler", use_ruler_inv );
  cmn.AddSubscriber( "use_ruler", use_ruler_end, private.room_objname );
  cmn.AddSubscriber( "use_ruler_inv", use_ruler_inv, private.room_objname );
  cmn.AddSubscriber( "use_ruler_beg", use_ruler_beg, private.room_objname );
  cmn.AddSubscriber( "use_ruler_end", use_ruler_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_monogram () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_monogram" ] = {
      type = "use",
      inv_obj = "inv_monogram",
      use_place = "obj_wardrobe_use_monogram",
      room = private.room_objname,
      zz = "zz_wardrobe",
      zz_gate = "gzz_livingroom_wardrobe"
  };
  local use_monogram_inv = function ()
  
    interface.InventoryItemRemove( "inv_monogram" );
  
  end;
  local use_monogram_beg = function ()
  
    ObjDelete( "obj_wardrobe_use_monogram" );
    ObjSet( "spr_wardrobe_clockhands", { visible = true, active = true } );
    ObjSet( "spr_wardrobe_brokenglasses", { visible = true, active = true } );

  end;
  local use_monogram_end = function ()
    
    ObjSet( "spr_wardrobe_clockhands", { input = true, alp = 1 } );
    ObjSet( "spr_wardrobe_brokenglasses", { input = true, alp = 1 } ); 
    ObjSet( "spr_wardrobe_monogram", { alp = 1 } ); 
    ObjSet("spr_wardrobe_suitcase_open" , { alp = 1, input = true });
    ObjSet("spr_livingroom_zz_wardrobe_glasses", { alp = 1});
    ObjSet("spr_livingroom_zz_wardrobe_arrows", { alp = 1});
    ObjSet("spr_livingroom_zz_wardrobe_open_case", { alp = 1});
    ObjSet("spr_livingroom_zz_wardrobe_letters" , { alp = 1 });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_monogram", use_monogram_beg, private.room_objname );
  cmn.AddSubscriber( "use_monogram", use_monogram_inv );
  cmn.AddSubscriber( "use_monogram", use_monogram_end, private.room_objname );
  cmn.AddSubscriber( "use_monogram_inv", use_monogram_inv, private.room_objname );
  cmn.AddSubscriber( "use_monogram_beg", use_monogram_beg, private.room_objname );
  cmn.AddSubscriber( "use_monogram_end", use_monogram_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_officekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_officekey" ] = {
      type = "use",
      inv_obj = "inv_officekey",
      use_place = "obj_door_use_officekey",
      room = private.room_objname,
      zz = "zz_door",
      zz_gate = "gzz_livingroom_door"
  };
  local use_officekey_inv = function ()
  
    interface.InventoryItemRemove( "inv_officekey" );
  
  end;
  local use_officekey_beg = function ()
  
    ObjDelete( "obj_door_use_officekey" );
  
  end;
  local use_officekey_end = function ()
  
    ObjSet( "spr_door_key_1", { alp = 1 } );
    ObjDelete( "spr_door_light_close" );
    ObjSet( "obj_door_clk_officekey", { input = true } );
    ObjSet("spr_livingroom_zz_door_key", { alp = 1});
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_officekey", use_officekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_officekey", use_officekey_inv );
  cmn.AddSubscriber( "use_officekey", use_officekey_end, private.room_objname );
  cmn.AddSubscriber( "use_officekey_inv", use_officekey_inv, private.room_objname );
  cmn.AddSubscriber( "use_officekey_beg", use_officekey_beg, private.room_objname );
  cmn.AddSubscriber( "use_officekey_end", use_officekey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_livingroom_providence_invitem_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_livingroom_providence_invitem_1" ] = {
    type = "use",
    inv_obj = "inv_object_1",
    use_place = "obj_livingroom_use_providence_invitem_1",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"
  };
 local use_livingroom_providence_invitem_1_inv = function ()
  
    interface.ProvidePanelItemRemove( "inv_object_1" );
  
  end;

  local use_livingroom_providence_invitem_1_beg = function ()
  
    ObjDelete( "obj_livingroom_use_providence_invitem_1" );
  
  end;

  local use_livingroom_providence_invitem_1_end = function ()
  
    ObjSet( "spr_livingroom_providence_plane_used", { alp = 1 } );
    ObjSet( "spr_livingroom_plane", { visible = 1 } ); 
 
  end;

  cmn.AddSubscriber( "use_livingroom_providence_invitem_1", use_livingroom_providence_invitem_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_livingroom_providence_invitem_1", use_livingroom_providence_invitem_1_inv );
  cmn.AddSubscriber( "use_livingroom_providence_invitem_1", use_livingroom_providence_invitem_1_end, private.room_objname );
  cmn.AddSubscriber( "use_livingroom_providence_invitem_1_inv", use_livingroom_providence_invitem_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_livingroom_providence_invitem_1_beg", use_livingroom_providence_invitem_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_livingroom_providence_invitem_1_end", use_livingroom_providence_invitem_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_books () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_books1" ] = {
      type = "click",
      use_place = "obj_wardrobe_clk_books1",
      room = private.room_objname,
      zz = "zz_wardrobe",
      zz_gate = "gzz_livingroom_wardrobe"
  };
  local clk_books1_beg = function ()
  
    ObjDelete( "obj_wardrobe_clk_books1" );
  
  end;
  local clk_books1_end = function ()

    ObjDelete( "spr_livingroom_zz_wardrobe_books" );
    ObjDelete( "spr_wardrobe_books" );
    ObjSet( "obj_wardrobe_clk_books2", { input = true } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_books1", clk_books1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_books1", clk_books1_end, private.room_objname );
  cmn.AddSubscriber( "clk_books1_beg", clk_books1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_books1_end", clk_books1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
 --------------------------------------------------------------------------------------------
  -- function clk_jacket () end;
  --------------------------------------------------------------------------------------------
  local clk_jacket_beg = function ()
  
    ObjDelete( "obj_wardrobe_clk_jacket" );
  
  end;
  local clk_jacket_end = function ()
    
    ObjDelete( "spr_wardrobe_jacket" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_jacket", clk_jacket_beg, private.room_objname );
  cmn.AddSubscriber( "clk_jacket", clk_jacket_end, private.room_objname );
  cmn.AddSubscriber( "clk_jacket_beg", clk_jacket_beg, private.room_objname );
  cmn.AddSubscriber( "clk_jacket_end", clk_jacket_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
 common_impl.hint[ "clk_books2" ] = {
      type = "click",
      use_place = "obj_wardrobe_clk_books2",
      room = private.room_objname,
      zz = "zz_wardrobe",
      zz_gate = "gzz_livingroom_wardrobe"
 };
 local clk_books2_beg = function ()
  
   ObjDelete( "obj_wardrobe_clk_books2" );
  
 end;
 local clk_books2_end = function ()

   ObjDelete( "spr_livingroom_zz_wardrobe_books_2" );

   ObjDelete( "spr_wardrobe_books_2" );
   ObjSet( "obj_wardrobe_clk_books3", { input = true } );
   ObjSet("spr_livingroom_zz_wardrobe_emblem", { alp = 1 });
 end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_books2", clk_books2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_books2", clk_books2_end, private.room_objname );
  cmn.AddSubscriber( "clk_books2_beg", clk_books2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_books2_end", clk_books2_end, private.room_objname );
--------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_books3" ] = {
      type = "click",
      use_place = "obj_wardrobe_clk_books3",
      room = private.room_objname,
      zz = "zz_wardrobe",
      zz_gate = "gzz_livingroom_wardrobe"
  };
  local clk_books3_beg = function ()
  
    ObjDelete( "obj_wardrobe_clk_books3" );
  
  end;
  local clk_books3_end = function ()

    ObjDelete( "spr_wardrobe_books_3" );
    ObjSet( "obj_wardrobe_use_elf", { active = true, input = true, visible = true });
    ObjSet( "spr_wardrobe_emblemelement3", { active = true, input = true, visible = true });
    ObjDelete( "spr_livingroom_zz_wardrobe_books_1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_books3", clk_books3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_books3", clk_books3_end, private.room_objname );
  cmn.AddSubscriber( "clk_books3_beg", clk_books3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_books3_end", clk_books3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_officekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_officekey" ] = {
      type = "click",
      use_place = "obj_door_clk_officekey",
      room = private.room_objname,
      zz = "zz_door",
      zz_gate = "gzz_livingroom_door"
  };
  local clk_officekey_beg = function ()
  
    ObjDelete( "obj_door_clk_officekey" );
  
  end;
  local clk_officekey_end = function ()

    ObjMultiSet({
    {"grm_livingroom_office", { input = true, active = true }},
    {"spr_livingroom_zz_door_add_open", { alp = 1 }}, 
    {"spr_livingroom_zz_door_open", { alp = 1 }},
    });
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_livingroom_office_focus");
    end;
    ObjDelete( "gzz_livingroom_door" );
    ObjDelete("spr_livingroom_zz_door_add_keyhole");
    ObjDelete("spr_livingroom_zz_door_key");

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_officekey", clk_officekey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_officekey", clk_officekey_end, private.room_objname );
  cmn.AddSubscriber( "clk_officekey_beg", clk_officekey_beg, private.room_objname );
  cmn.AddSubscriber( "clk_officekey_end", clk_officekey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_providence_livingroom () end;
  --------------------------------------------------------------------------------------------
  local clk_providence_livingroom = function ()
  
    if ( not cmn.IsEventDone( "clk_livingroom_providence_1" ) or not cmn.IsEventDone( "clk_livingroom_providence_2" ) or not cmn.IsEventDone( "clk_livingroom_providence_3" ) 
         or ( cmn.IsEventDone( "get_object_1" ) and not cmn.IsEventDone( "use_livingroom_providence_invitem_1" ) ) ) then
      int_button_providence.StartActiveProvidence();
    end;
  
  end;
  
  cmn.AddSubscriber( "clk_providence_livingroom", clk_providence_livingroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_livingroom_providence_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_livingroom_providence_1" ] = {
    type = "use",
    inv_obj = "spr_livingroom_providence_lamp",
    inv_obj = "spr_livingroom_providence_lamp",
    use_place = "obj_livingroom_providence_item_1",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"
  };

  local clk_livingroom_providence_1_beg = function ()
  
    ObjSet( "obj_livingroom_providence_item_1", { input = false } );
  
  end;
  local clk_livingroom_providence_1_end = function ()
  
    ObjDelete( "obj_livingroom_providence_item_1" );
    ObjDelete( "spr_livingroom_providence_lamp" );
    ObjSet( "spr_livingroom_providence_lamp_used", { alp = 1 } );

    ObjDelete( "spr_livingroom_lamp" );
    ObjSet( "spr_livingroom_lamp_used", { alp = 1 } );  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_livingroom_providence_1", clk_livingroom_providence_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_livingroom_providence_1", clk_livingroom_providence_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_livingroom_providence_1_beg", clk_livingroom_providence_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_livingroom_providence_1_end", clk_livingroom_providence_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_livingroom_providence_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_livingroom_providence_2" ] = {
    type = "use",
    inv_obj = "spr_livingroom_providence_vase",
    inv_obj = "spr_livingroom_providence_vase",
    use_place = "obj_livingroom_providence_item_2",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"
  };
  local clk_livingroom_providence_2_beg = function ()
  
    ObjSet( "obj_livingroom_providence_item_2", { input = false } );
  
  end;
  local clk_livingroom_providence_2_end = function ()
  
    ObjDelete( "obj_livingroom_providence_item_2" );
  ObjDelete( "spr_livingroom_providence_vase" );
    ObjSet( "spr_livingroom_providence_vase_used", { alp = 1 } );

    ObjDelete( "spr_livingroom_vase" );
    ObjSet( "spr_livingroom_vase_used", { alp = 1 } );  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_livingroom_providence_2", clk_livingroom_providence_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_livingroom_providence_2", clk_livingroom_providence_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_livingroom_providence_2_beg", clk_livingroom_providence_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_livingroom_providence_2_end", clk_livingroom_providence_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_livingroom_providence_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_livingroom_providence_3" ] = {
    type = "use",
    inv_obj = "spr_livingroom_providence_glass",
    inv_obj = "spr_livingroom_providence_glass",
    use_place = "obj_livingroom_providence_item_3",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"
  };
  local clk_livingroom_providence_3_beg = function ()
  
    ObjSet( "obj_livingroom_providence_item_3", { input = false } );
  
  end;
  local clk_livingroom_providence_3_end = function ()
  
    ObjDelete( "obj_livingroom_providence_item_3" );
    ObjDelete( "spr_livingroom_providence_glass" );
    ObjDelete( "spr_livingroom_providence_window" );
  
    ObjDelete( "spr_livingroom_glass" );
    ObjDelete( "spr_livingroom_window" );  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_livingroom_providence_3", clk_livingroom_providence_3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_livingroom_providence_3", clk_livingroom_providence_3_end, private.room_objname );
  cmn.AddSubscriber( "clk_livingroom_providence_3_beg", clk_livingroom_providence_3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_livingroom_providence_3_end", clk_livingroom_providence_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_livingroom_providence () end;
  --------------------------------------------------------------------------------------------  
  local vid_livingroom_providence_beg = function ()

    ObjDelete("spr_livingroom_books");
    ObjMultiSet({
    {"spr_livingroom_zz_wardrobe_books_1", {alp = 1}},
    {"spr_livingroom_zz_wardrobe_books", {alp = 1}},
    {"spr_livingroom_zz_wardrobe_books_2", {alp = 1}},
    });

  end;   
  
  local vid_livingroom_providence_end = function ()

    ObjDelete("spr_livingroom_books");
    ObjDelete("spr_livingroom_ball_hotspot");
    ObjMultiSet({
    {"gzz_livingroom_wardrobe", { input = true, active = true }},
    {"obj_livingroom_ball", { pos_x = 151, pos_y = 3 }},
    });
   
  end;

  cmn.AddSubscriber( "vid_livingroom_providence", vid_livingroom_providence_beg, private.room_objname );
  cmn.AddSubscriber( "vid_livingroom_providence", vid_livingroom_providence_end, private.room_objname  );
  cmn.AddSubscriber( "vid_livingroom_providence_beg", vid_livingroom_providence_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_livingroom_providence_end", vid_livingroom_providence_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  
  local vid_livingroom_providence_p2 = function ()

    VidStop( "vid_livingroom_providence_p1" );
    ObjSet( "vid_livingroom_providence_p2", { playing = true } );    

  end;   

  cmn.AddSubscriber( "vid_livingroom_providence_p2", vid_livingroom_providence_p2, private.room_objname );
  --------------------------------------------------------------------------------------------
  local vid_livingroom_providence_p3 = function ()

    VidStop( "vid_livingroom_providence_p2" );
    ObjSet( "vid_livingroom_providence_p3", { playing = true } );

  end;   

  cmn.AddSubscriber( "vid_livingroom_providence_p3", vid_livingroom_providence_p3, private.room_objname );
  --------------------------------------------------------------------------------------------
  local vid_livingroom_providence_p4 = function ()

    VidStop( "vid_livingroom_providence_p3" );
    VidPlay( "vid_livingroom_providence_p4", private.vid_livingroom_providence_end );    

  end;   

  cmn.AddSubscriber( "vid_livingroom_providence_p4", vid_livingroom_providence_p4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_livingroom_search () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_livingroom_search" ] = {

      type = "click",
      use_place = "obj_dlg_livingroom_search_focus",
      room = private.room_objname
  };

  local dlg_livingroom_search_end = function ()

    ObjDelete( "obj_dlg_livingroom_search" );
    ObjSet( "gho_livingroom_search", { active = true, input = true } );

  end;  

  cmn.AddSubscriber( "dlg_livingroom_search", dlg_livingroom_search_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_livingroom_search_end", dlg_livingroom_search_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function dlg_livingroom_george () end;
  --------------------------------------------------------------------------------------------
   common_impl.hint[ "dlg_livingroom_george" ] = {

      type = "click",
      use_place = "obj_dlg_livingroom_george_focus",
      room = private.room_objname
  };

  local dlg_livingroom_george_end = function ()

    ObjDelete( "obj_dlg_livingroom_george" );
    ObjSet( "obj_livingroom_george_bbt", { input = true });
   
  end;

  cmn.AddSubscriber( "dlg_livingroom_george", dlg_livingroom_george_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_livingroom_george_end", dlg_livingroom_george_end, private.room_objname  );

  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_4 = function ()
  
    ObjDelete( "obj_livingroom_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_4", get_collect_morph_item_1_4, private.room_objname );


end;
--*********************************************************************************************************************
function public.Load()

end;
--********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_table" );

  function zz_table.Open()

    private.StopAnims();

  end;

  subroom.Define( "zz_wardrobe" );

  function zz_wardrobe.Open()

    private.StopAnims();

  end;

  subroom.Define( "zz_door" );

  function zz_door.Open()

    private.StopAnims();

  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_livingroom();

  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

  if ( not cmn.IsEventDone( "vid_livingroom_providence" ) ) then

    int_button_providence.StartLightProvidence();

  end;

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.MorphItemMorphing();

  common_impl.EnvPlay( { "common/audio/aud_livingroom_env" }, "", 0.2 );

  if ( cmn.IsEventDone( "opn_livingroom" ) ) then

    ObjSet( "anm_livingroom_feathers", { visible = false, active = false } );
    
  end;

  if ( cmn.IsEventDone( "get_monogram" ) and not cmn.IsEventDone( "opn_zoom_armchair" ) ) then

    private.zoom_armchair();

  end;

  local chance = math.random( 1,5 );

  if chance == 3 then

    local endfunc = "";
    local chance = math.random( 1,5 );
    
      if chance == 1 then

        endfunc = function ()  AnimPlay( "anm_livingroom_birds_1", "DoAnim", "" ); common_impl.PlayAudio( "sfx", "common/audio/aud_crow_window", 0, "", 0 ); end;
       
      end;
    
      common_impl.PlayAudio( "sfx", "common/audio/aud_crows_window", 0, "", 0 );

      AnimPlay( "anm_livingroom_birds_2", "DoAnim", endfunc );

  end;
  
  interface.InvestigationButtonCheck();

end;
--*********************************************************************************************************************
function public.Close()

  private.StopAnims();

end;
--*********************************************************************************************************************
function public.PreClose()

  if ( not cmn.IsEventDone( "vid_livingroom_providence" ) ) then

    int_button_providence.StopLightProvidence();

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_screwdriver_1()

  local item = "inv_screwdriver";

  if ( common.ApplyObj( item, "obj_table_use_screwdriver", true ) and not cmn.IsEventDone( "use_screwdriver_1" ) ) then

    cmn.CallEventHandler( "use_screwdriver_1_beg" );
   
    local func_vid = function ()

      local func_after = function ()

        common_impl.Lock(false);

        cmn.SetEventDone( "use_screwdriver_1" );
        cmn.CallEventHandler( "use_screwdriver_1_end" );
      
      end;

        ObjAnimate( "spr_table_bear_cover", "alp", 0, 0, func_after,
        { 
          0.0, 0, 1.0, 
          0.3, 0, 1.0,
        } );

    end;

    common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_screwdriver_bear", 0, "", 0 );  
    VidPlay( "vid_table_screw", func_vid );

    return true;

  elseif common.ApplyObj( item, "gzz_livingroom_table", false ) and not cmn.IsEventDone( "use_screwdriver_1" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_table", nil, { 512, 384 } );

    return true;

  else

    --WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fishinghook()

  local item = "inv_fishinghook";

  if ( common.ApplyObj( item, "obj_table_use_fishinghook", true ) ) then

    cmn.CallEventHandler( "use_fishinghook_inv" );
    cmn.CallEventHandler( "use_fishinghook_beg" );

    local func_after = function ()

      common_impl.Lock(false);

      cmn.SetEventDone( "use_fishinghook" );
      cmn.CallEventHandler( "use_fishinghook_end" );
      ng_global.progress["std"]["opn_fork"].silhouette = true;
      ObjSet( "spr_fork_silhuette", { alp = 0 } );
      cmn.CallEventHandler( "use_fishinghook_silhuette" );
    
    end;

    common_impl.Lock(true);
    
    ObjSet( "anm_table_open", { alp = 1 } );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_hook", 0, "", 0 );
    AnimPlay( "anm_table_open", "DoAnim", func_after );

  elseif common.ApplyObj( item, "gzz_livingroom_table", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_table", nil, { 512, 384 } );

  else

    common_impl.WrongApply(); 

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_button()

  local item = "inv_button";

  if ( common.ApplyObj( item, "obj_table_use_button", true ) ) then

    cmn.CallEventHandler( "use_button_inv" );
    cmn.CallEventHandler( "use_button_beg" );

    local func_after = function ()

      common_impl.Lock(false);

      cmn.SetEventDone( "use_button" );
      cmn.CallEventHandler( "use_button_end" );
    
    end;

    common_impl.Lock(true);

    ObjAnimate( "spr_table_open_button_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,

    } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_handle_nightstand", 0, "", 0 );

  elseif common.ApplyObj( item, "gzz_livingroom_table", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_table", nil, { 512, 384 } );


  else

    common_impl.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_elf_2()

  local item = "inv_elf";

  if ( common.ApplyObj( item, "obj_wardrobe_use_elf", true ) and not cmn.IsEventDone( "use_elf_2" ) and cmn.IsEventDone( "use_elf_1" ) 
        and cmn.IsEventDone( "get_emblemelement3" ) ) then

    cmn.CallEventHandler( "use_elf_2_beg" );
    interface.InventoryItemRemove( "inv_elf" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_elf_2" );
      cmn.CallEventHandler( "use_elf_2_end" );
      ObjSet( "spr_wardrobe_elf", { alp = 1 } );
      interface.InventoryItemAdd( "inv_elf", "spr_wardrobe_elf" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_elf_wardrobe", 0, "", 0 );
    VidPlay( "vid_wardrobe_use_elf", func_after); 

    return true;

  elseif common.ApplyObj( item, "gzz_livingroom_wardrobe", false ) and not cmn.IsEventDone( "use_elf_2" ) and cmn.IsEventDone( "use_elf_1" ) 
         and cmn.IsEventDone( "get_emblemelement3" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wardrobe", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ruler()

  local item = "inv_ruler";

  if ( common.ApplyObj( item, "obj_wardrobe_use_ruler", true ) ) then

    cmn.CallEventHandler( "use_ruler_inv" );
    cmn.CallEventHandler( "use_ruler_beg" );

    local func_after = function ()

        common.CloseSubRoom();
        private.use_ruler_vid();

    end;
    common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_ruler", 0, "", 0 );

    ObjAnimate("spr_wardrobe_line", "pos_xy", 0, 0, func_after, {0,3,115,-83,  0.5,3,3,-168, 1.0,3,3,-168, 1.2,3,115,-83,});
    ObjAnimate("spr_wardrobe_line", "ang", 0, 0, "", { 0,3,0, 0.5,3,-0.78, 1,3,-0.88, 1.2,3,0});
    ObjAnimate("spr_wardrobe_line", "alp", 0, 0, "", {0, 3, 0, 0.1, 3, 1});
    ObjAnimate("spr_wardrobe_latch", "ang", 0, 0, "", {0,3,0, 0.5,3,0, 1,3,0.24 });

  elseif common.ApplyObj( item, "gzz_livingroom_wardrobe", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wardrobe", nil, { 512, 384 } );

  else 

    common_impl.WrongApply();

  end;

end;

function private.use_ruler_vid()

  local func_after = function ()

    common_impl.Lock(false);
    interface.DialogVideoHide();
    cmn.SetEventDone( "use_ruler" );
    cmn.CallEventHandler( "use_ruler_end" );
    common_impl.ShowBbt( 'bbt_vid_livingroom_criminal', 1 );
    interface.KeyTaskDone( "enter_office" ,true );
    common_impl.StopAudio( "sfx", "common/audio/aud_livingroom_criminal", 0, "", 0 );
    common_impl.PlayAudio( "mus", "common/audio/aud_danger1_mus", 0, "", 0 );

  end;
    
  ObjSet( "vid_livingroom_criminal", { alp = 1, active = 1, input = 1 } );
  ObjAttach( "vid_livingroom_criminal", private.room_objname );
  common_impl.StopAllMus();
  interface.DialogVideoShow( "vid_livingroom_criminal", 1, func_after, 3 );
  VidPlay( "vid_livingroom_criminal", func_after ); 
  common_impl.PlayAudio( "sfx", "common/audio/aud_livingroom_criminal", 0, "", 0 );


end;
--------------------------------------------------------------------------------------------
function public.use_monogram()

  local item = "inv_monogram";

  if common.ApplyObj( item, "gzz_livingroom_wardrobe", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wardrobe", nil, { 512, 384 } );

  elseif ( common.ApplyObj( item, "obj_wardrobe_use_monogram", true ) ) then

    cmn.CallEventHandler( "use_monogram_inv" );
    cmn.CallEventHandler( "use_monogram_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_monogram" );
      cmn.CallEventHandler( "use_monogram_end" );

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_initials", 0, "", 0 );

    ObjAnimate( "spr_wardrobe_suitcase_open", "alp", 0, 0, func_after,
    { 
        0.0, 0, 0.0,
        1.0, 0, 0.0, 
        1.3, 0, 1.0
    } );

    
    ObjAnimate( "spr_wardrobe_monogram", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.6, 0, 1.0
    } );

  else

    common_impl.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.use_officekey()

  local item = "inv_officekey";

  if ( common.ApplyObj( item, "obj_door_use_officekey", true ) ) then

    cmn.CallEventHandler( "use_officekey_inv" );
    cmn.CallEventHandler( "use_officekey_beg" );

    local func_after = function ()

      common_impl.Lock(false);
    
      cmn.SetEventDone( "use_officekey" );
      cmn.CallEventHandler( "use_officekey_end" );
    
    end;

    common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_office_key", 0, "", 0 );

    ObjAnimate( "spr_door_key_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_door_light_close", "alp", 0, 0,"",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );

  elseif common.ApplyObj( item, "gzz_livingroom_door", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_door", nil, { 512, 384 } );

  else

    common_impl.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_livingroom_providence_invitem_1()

  local item = "inv_object_1";

  if ( ObjIntersect( item, "obj_livingroom_use_providence_invitem_1" ) and int_providence.show ) then

    cmn.CallEventHandler( "use_livingroom_providence_invitem_1_inv" );
    cmn.CallEventHandler( "use_livingroom_providence_invitem_1_beg" );
    

    local func_after = function ()

      common_impl.Lock(false);

      cmn.CallEventHandler( "use_livingroom_providence_invitem_1_end" );

      if cmn.IsEventDone( "clk_livingroom_providence_1" ) and cmn.IsEventDone( "clk_livingroom_providence_2" ) 
       and cmn.IsEventDone( "clk_livingroom_providence_3" ) then

        private.anim_providence( function() cmn.SetEventDone( "use_livingroom_providence_invitem_1" ); end );

      else

        if ( cmn.IsEventDone( "clk_livingroom_providence_2" ) and cmn.IsEventDone( "clk_livingroom_providence_1" ) and cmn.IsEventDone( "clk_livingroom_providence_3" ) ) then
          int_button_providence.StopActiveProvidence();
        end;
        cmn.SetEventDone( "use_livingroom_providence_invitem_1" );

      end;

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_providence_livingroom_plane", 0, "", 0 );
    ObjAnimate( "spr_livingroom_providence_plane_used", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );


  else

    common_impl.WrongApply();  

  end;
   
     
end;
 
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
------------------------------------------------------------------------------------------------------------------------
function private.get_coin5()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_5");
    cmn.CallEventHandler("get_coin_5");
    
    if cmn.IsEventDone("get_cryptex") then

      common.CloseSubRoom();
      
    end;
    
  end;
  
  common_impl.PlayEffectHO( "spr_table_coin", func_after );

end;
------------------------------------------------------------------------------------------------------------------------
function private.get_coin6()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_6");
    cmn.CallEventHandler("get_coin_6");

    if  cmn.IsEventDone("get_brokenglasses") and  cmn.IsEventDone("get_clockhands") then

      common.CloseSubRoom();

    end;

  end;
    
  common_impl.PlayEffectHO( "spr_wardrobe_coin", func_after );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.get_scissors()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_scissors" );
  cmn.CallEventHandler( "get_scissors" );
  if ( cmn.IsEventDone("get_cryptex") and cmn.IsEventDone("get_papercode")
  and cmn.IsEventDone("get_batteries") and  cmn.IsEventDone("get_matches") )then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_matches()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_matches" );
  cmn.CallEventHandler( "get_matches" );
  if ( cmn.IsEventDone("get_cryptex") and cmn.IsEventDone("get_papercode")
  and cmn.IsEventDone("get_batteries") and  cmn.IsEventDone("get_scissors") ) then

    common.CloseSubRoom()

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_papercode()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_papercode" );
  cmn.CallEventHandler( "get_papercode" );
  if ( cmn.IsEventDone("get_cryptex") and cmn.IsEventDone("get_matches")
  and cmn.IsEventDone("get_batteries") and  cmn.IsEventDone("get_scissors") ) then

    common.CloseSubRoom()

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_batteries()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_batteries" );
  cmn.CallEventHandler( "get_batteries" );
  if ( cmn.IsEventDone("get_cryptex") and cmn.IsEventDone("get_matches")
  and cmn.IsEventDone("get_papercode") and  cmn.IsEventDone("get_scissors") ) then

    common.CloseSubRoom()

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_cryptex()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_cryptex" );
  cmn.CallEventHandler( "get_cryptex" );

  ng_global.progress["std"]["win_cryptex"].numbers = { 1, 7, 12, 14 }
  
  if ( cmn.IsEventDone("get_batteries") and cmn.IsEventDone("get_matches")
  and cmn.IsEventDone("get_papercode") and  cmn.IsEventDone("get_scissors") and common_impl.IsGetCoin("get_coin_5") ) then
    
    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_emblemelement3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  cmn.SetEventDone( "get_emblemelement3" );
  cmn.CallEventHandler( "get_emblemelement3" );

end;
--------------------------------------------------------------------------------------------
function private.get_evidence_1_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_evidence_open", 0, "", 0 );

  local func_end = function ()

    interface.InvestigationButtonItemAdd( "evidence_1_2", "spr_wardrobe_evidence_1_2" );

    cmn.SetEventDone( "get_evidence_1_2" );
    cmn.CallEventHandler( "get_evidence_1_2" );
  
  end;

  interface.DialogEvidenceShow( "evidence_1_2", func_end )
  --ObjSet( "spr_square_evidence_1_1", { alp = 1, scale_x = 0.2, scale_y = 0.2 } );

end;
--------------------------------------------------------------------------------------------
function private.get_bag()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_bag" );
  cmn.CallEventHandler( "get_bag" );

end;
--------------------------------------------------------------------------------------------
function private.get_zipperslider()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_zipperslider" );
  cmn.CallEventHandler( "get_zipperslider" );

end;
--------------------------------------------------------------------------------------------
function private.get_clockhands()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_clockhands" );
  cmn.CallEventHandler( "get_clockhands" );
  if ( cmn.IsEventDone("get_zipperslider") and cmn.IsEventDone("get_brokenglasses") 
  and cmn.IsEventDone("get_bag") and cmn.IsEventDone("get_evidence_1_2") 
  and cmn.IsEventDone("get_emblemelement3")) then

   common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_brokenglasses()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_brokenglasses" );
  cmn.CallEventHandler( "get_brokenglasses" );
  if ( cmn.IsEventDone("get_zipperslider") and cmn.IsEventDone("get_clockhands") 
  and cmn.IsEventDone("get_bag") and cmn.IsEventDone("get_evidence_1_2") 
  and cmn.IsEventDone("get_emblemelement3")) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_object_1_silhouette()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );

  cmn.SetEventDone( "get_object_1_silhouette" );
  cmn.CallEventHandler( "get_object_1_silhouette" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_button()

  local func_after = function ()

    common_impl.Lock(false);

    cmn.SetEventDone( "clk_button" );
    cmn.CallEventHandler( "clk_button" );
  
  end;

  common_impl.Lock(true);

  ObjAnimate( "spr_table_open_button_1", "alp", 0, 0, "",
  { 
    0.0, 3, 1.0,
    0.3, 3, 0.8

  } );

  ObjAnimate( "spr_table_open_button_2", "alp", 0, 0, "",
  { 
    0.0, 3, 0.0,
    0.3, 3, 1.0
  } );
  
  ObjAnimate( "spr_table_open_crypt_cover", "alp", 0, 0, func_after,
  { 
    0.0, 0, 1.0, 
    0.3, 0, 1.0,
    0.6, 0, 0.0
  } );

  ObjAnimate( "spr_table_cryptex_shadow", "alp", 0, 0, "",
  { 
    0.0, 0, 0.0, 
    0.3, 0, 0.0,
    0.6, 0, 1.0
  } );

  common_impl.PlayAudio( "sfx", "common/audio/aud_open_second_bottom_nightstand", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.clk_closedtable()

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_medium_door", 0, "", 0 );

  common_impl.ShowBbt( 'bbt_use_fishinghook' );
  common_impl.Lock(true);
 
  ObjAnimate( "spr_table_close", "pos_xy", 0, 0, "*common_impl.Lock(false);", 
  { 
    0.0, 0, 48, 164, 
    0.1, 0, 46, 166,
    0.2, 0, 48, 164
  } );

end;
--*********************************************************************************************************************
function private.clk_closedbaterries()

  common_impl.ShowBbt( 'bbt_use_screwdriver_1' );
  common_impl.Lock(true);
 
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_very_small_metall", 0, "", 0 );

  ObjAnimate( "spr_table_bear_cover", "pos_x", 0, 0, "*common_impl.Lock(false);", 
  { 
    0.0, 0, 178, 
    0.1, 0, 179,
    0.2, 0, 177,
    0.3, 0, 178    
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_books1()
  cmn.CallEventHandler( "clk_books1_beg" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "clk_books1" );
      cmn.CallEventHandler( "clk_books1_end" );
  
    end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_books", 0, "", 0 );
  common_impl.Lock( true );
  ObjAnimate( "spr_wardrobe_books", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1.0, 
    0.5, 0, 0.0
  } );

  --interface.BlockSubroomClose( true );

end;
--------------------------------------------------------------------------------------------
function private.clk_jacket()

  cmn.CallEventHandler( "clk_jacket_beg" );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_wardrobe_cloth", 0, "", 0 );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "clk_jacket" );
      cmn.CallEventHandler( "clk_jacket_end" );

      common_impl.ShowBbt( 'bbt_wardrobe_clk_jacket', 1 );
  
    end;

  common_impl.Lock(true);
  ObjAnimate( "spr_wardrobe_jacket", "ang", 0, 0, func_after, 
  { 
    0.0, 0, 0.0, 
    0.5, 0, -0.58
  } );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_door()

  common_impl.ShowBbt( 'bbt_wardrobe_use_ruler' );
  local func_after = function ()

    common_impl.Lock(false);

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_wardrobe", 0, "", 0 );

  ObjAnimate( "spr_wardrobe_latch_over1", "ang", 0, 0, "", 
  { 
    0.0, 0, 0.0, 
    0.3, 0, 0.003,
    0.6, 0, -0.003
  } );

 ObjAnimate( "spr_wardrobe_latch_over1", "pos_y", 0, 1, func_after, 
  { 
    0.0, 3, 0.0, 
    0.3, 3, 1.0,
    0.6, 3, 0.0
  } );
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.clk_books2()

  cmn.CallEventHandler( "clk_books2_beg" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "clk_books2" );
      cmn.CallEventHandler( "clk_books2_end" );
  
    end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_books", 0, "", 0.2 );
 
  common_impl.Lock( true );

  ObjAnimate( "spr_wardrobe_books_2", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1.0, 
    0.5, 0, 0.0
  } );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.clk_books3()

  cmn.CallEventHandler( "clk_books3_beg" );

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_books3" );
    cmn.CallEventHandler( "clk_books3_end" );

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_books", 0, "", 0.2 );

  common_impl.Lock( true );
  ObjAnimate( "spr_wardrobe_books_3", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1.0, 
    0.5, 0, 0.0
  } );

end;

function private.ClkCar()

  common_impl.Lock( true );

  local func_after = function ()

    common_impl.Lock( false );

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_toy_car", 0, "", 0.2 );

  AnimPlay( "anm_livingroom_pickup", "DoAnim", func_after );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.clk_livingroom_providence_1()

  cmn.CallEventHandler( "clk_livingroom_providence_1_beg" );

  local func_after = function ()

    common_impl.Lock(false);

    cmn.CallEventHandler( "clk_livingroom_providence_1_end" );
    common_impl.Lock( false );

    if cmn.IsEventDone( "clk_livingroom_providence_2" )
      and cmn.IsEventDone( "clk_livingroom_providence_3" ) and cmn.IsEventDone( "use_livingroom_providence_invitem_1" ) then

      private.anim_providence( function() cmn.SetEventDone( "clk_livingroom_providence_1" ); end );

    else 

      if ( cmn.IsEventDone( "clk_livingroom_providence_2" ) and cmn.IsEventDone( "clk_livingroom_providence_3" ) and
         ( not cmn.IsEventDone( "get_object_1" ) or cmn.IsEventDone( "use_livingroom_providence_invitem_1" ) ) ) then
        int_button_providence.StopActiveProvidence();
      end;

      cmn.SetEventDone( "clk_livingroom_providence_1" );

    end;

  end;

  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_livingroom_lamp", 0, "", 0 );
  ObjSet( "spr_livingroom_providence_lamp", { alp = 0 } );
  ObjAnimate( "spr_livingroom_providence_lamp_used", "alp", 0, 0, func_after, { 0, 0, 0,    0.1, 0, 0,   0.3, 0, 1 } );

end;
--------------------------------------------------------------------------------------------
function private.clk_livingroom_providence_2()

  cmn.CallEventHandler( "clk_livingroom_providence_2_beg" );

    local func_after = function ()

      cmn.CallEventHandler( "clk_livingroom_providence_2_end" );
      common_impl.Lock( false );

      if cmn.IsEventDone( "clk_livingroom_providence_1" )  
        and cmn.IsEventDone( "clk_livingroom_providence_3" ) and cmn.IsEventDone( "use_livingroom_providence_invitem_1" ) then

          private.anim_providence( function() cmn.SetEventDone( "clk_livingroom_providence_2" ); end );

      else 

        if ( cmn.IsEventDone( "clk_livingroom_providence_1" ) and cmn.IsEventDone( "clk_livingroom_providence_3" ) and
           ( not cmn.IsEventDone( "get_object_1" ) or cmn.IsEventDone( "use_livingroom_providence_invitem_1" ) ) ) then
          int_button_providence.StopActiveProvidence();
        end;
        cmn.SetEventDone( "clk_livingroom_providence_2" );

      end;
    
    end;

  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_livingroom_jug", 0, "", 0 );
  ObjSet( "spr_livingroom_providence_vase", { alp = 0 } );
  ObjAnimate( "spr_livingroom_providence_vase_used", "alp", 0, 0, func_after, { 0, 0, 0,   0.1, 0, 0,    0.3, 0, 1 } );

end;
--------------------------------------------------------------------------------------------
function private.clk_livingroom_providence_3()

  cmn.CallEventHandler( "clk_livingroom_providence_3_beg" );

    local func_after = function ()

      cmn.CallEventHandler( "clk_livingroom_providence_3_end" );

      common_impl.Lock( false );

      if cmn.IsEventDone( "clk_livingroom_providence_1" ) and cmn.IsEventDone( "clk_livingroom_providence_2" ) 
         and cmn.IsEventDone( "use_livingroom_providence_invitem_1" ) then

          private.anim_providence( function() cmn.SetEventDone( "clk_livingroom_providence_3" ); end );

      else 

        if ( cmn.IsEventDone( "clk_livingroom_providence_2" ) and cmn.IsEventDone( "clk_livingroom_providence_1" ) and
           ( not cmn.IsEventDone( "get_object_1" ) or cmn.IsEventDone( "use_livingroom_providence_invitem_1" ) ) ) then
          int_button_providence.StopActiveProvidence();
        end;
        cmn.SetEventDone( "clk_livingroom_providence_3" );

      end;
    
    end;

  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_livingroom_debris", 0, "", 0 );
  ObjSet( "spr_livingroom_providence_glass", { alp = 0 } );
  ObjAnimate( "spr_livingroom_providence_window", "alp", 0, 0, func_after, { 0, 0, 1,    0.3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.anim_providence( func_execute )

  common_impl.ShowBbt( "bbt_providence_allitems" );

  int_button_providence.StopActiveProvidence();

  local array_objects = {
    "spr_livingroom_providence_vase_used",
    "spr_livingroom_providence_plane_used",
    "spr_livingroom_providence_lamp_used" }

  local func_end = function()

    for i = 1, #array_objects do
      ObjAttach( array_objects[ i ], "rm_livingroom_providence" );
      ObjSet( array_objects[ i ], { alp = 1 } );
    end;
    common_impl.Lock( false );    
    private.vid_livingroom_providence( func_execute );

  end;
  
  common_impl.Lock( true );
  for i = 1, #array_objects do
    
    common_impl.PlayEffectHO( array_objects[ i ], func_end, 3, "assets/interface/resources/effect_mask" );
    func_end = nil;

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_ready", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.clk_officekey()
 
  cmn.CallEventHandler( "clk_officekey_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "clk_officekey" );
      cmn.CallEventHandler( "clk_officekey_end" );
      common.CloseSubRoom();
  
    end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_office_key", 0, "", 0 );

  ObjAnimate( "spr_door_key_1", "alp", 0, 0, "", 
  { 
    0.0, 0, 1, 
    0.3, 0, 0
  } );

  ObjAnimate( "spr_door_key_2", "alp", 0, 0, "", 
  { 
    0.0, 0, 0, 
    0.3, 0, 1
  } );

  ObjAnimate( "spr_door_open", "alp", 0, 0, "", 
  { 
    0.0, 0, 0, 
    1.1, 0, 0,
    1.3, 0, 1
  } );

  
  ObjAnimate( "obj_door_close", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1, 
    1.1, 0, 1,
    1.3, 0, 0
  } );

  ObjAnimate( "spr_door_handle", "ang", 0, 0, "", 
  { 
    0.0, 0, 0, 
    0.3, 0, 0,
    0.7, 0, -0.22,
    1.1, 0, 0
  } );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.zoom_armchair()

  ObjSet( "anm_livingroom_george", { visible = false, active = false } );

  local func_after = function()

    local func_after_2 = function()

      common_impl.Lock( false );
      common_impl.ShowBbt( 'bbt_livingroom_armchair' );
      cmn.SetEventDone( "opn_zoom_armchair" );
      cmn.CallEventHandler( "opn_zoom_armchair" );
      
    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_out", 0, "", 0 );
    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment3_mus", 0, "", 0 );

    ObjAnimate( private.room_objname, "scale_xy", 0, 0, func_after_2,
    { 
      0.0, 1, 1.5,1.5, 
      1.0, 1, 1.0,1.0
    } );

    ObjAnimate( private.room_objname, "pos_xy", 0, 0, "",
    { 
      0.0, 1, -400,-200, 
      1.0, 1, 0, 0
    } );

  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_in", 0, "", 0 );

  ObjAnimate( private.room_objname, "scale_xy", 0, 0, func_after,
  { 
    0.0, 1, 1.0,1.0, 
    1.0, 1, 1.5,1.5
  } );

  ObjAnimate( private.room_objname, "pos_xy", 0, 0, "",
  { 
    0.0, 1,  0, 0, 
    1.0, 1, -400,-200
  } );

end;
--*********************************************************************************************************************
function private.get_lamp()

  local item = "spr_livingroom_providence_lamp";
  local res = "assets/levels/level1/rm_livingroom/layers/providence/lamp";
  private.old_z = ObjGet( item ).pos_z;
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( item, { res = res, pos_z = 20 } );

end;
--*********************************************************************************************************************
function private.drop_lamp()

  local item = "spr_livingroom_providence_lamp";
  local res = "assets/levels/level1/rm_livingroom/layers/providence/lamp_2";

  if ( ObjIntersect( item, "obj_livingroom_providence_item_1" ) ) then

    private.clk_livingroom_providence_1();

  end;

  ObjSet( item, { res = res, pos_z = private.old_z } );

end;
-------------------------------------------------------------------------------------
function private.get_vase()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_livingroom_providence_vase", { pos_z = 10 } );

end;
-------------------------------------------------------------------------------------
function private.drop_vase()

  local item = "spr_livingroom_providence_vase";
  
  ObjSet( item, { pos_z = 0 } );

  if ( ObjIntersect( item, "obj_livingroom_providence_item_2" ) or ObjIntersect( item, "obj_livingroom_providence_item_2_focus" ) ) then

    private.clk_livingroom_providence_2();

  end;

end;
-------------------------------------------------------------------------------------
function private.get_glass()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_livingroom_providence_glass", { pos_z = 10 } );

end;
-------------------------------------------------------------------------------------
function private.drop_glass()

  local item = "spr_livingroom_providence_glass";
  
  ObjSet( item, { pos_z = 0 } );

  if ( ObjIntersect( item, "obj_livingroom_providence_item_3" ) ) then

    private.clk_livingroom_providence_3();

  end;

end;
-------------------------------------------------------------------------------------
-- DIALOG CHARACTER
--*********************************************************************************************************************
-------------------------------------------------------------------------------------
function private.CheckWinDialGame()

  local count = 0;

  for i = 1, #private.dial_game_state do

    if private.dial_game_state[i] == 1 then

      count = count + 1;
    
    end;

  end;

  if count == 3 then 
    
    public.DialGameEnd();

  end;


end;
-------------------------------------------------------------------------------------
function public.DialGameEnd()

   local func_after = function()

    common_impl.Lock( false );

    ObjSet( "obj_livingroom_george_mmg", { input = false, pos_z = 1,alp = 0 } ); 
    ObjAttach( "obj_livingroom_george_mmg", "obj_livingroom_george_characters" );

    if not common_impl.frases[1] then common_impl.frases = { 5 }; common_impl.dial_icons = { 'stop' }; end;
    
    common_impl.DialogCharacterShowDialogQuestions( #common_impl.frases ); 

   end;
    
    common_impl.Lock( true );
    ObjAnimate( "obj_livingroom_george_mmg", "alp", 0, 0, func_after, { 0,0,1, 0.3,0,0 } ); 

    common_impl.PlayAudio( "sfx", "common/audio/aud_interactive_end", 0, "", 0 );
 
end;
-------------------------------------------------------------------------------------
function private.ClkDocument( number, mode )

  local func_after = function()

    common_impl.Lock( false );
    
    if mode == "up" then

      ObjSet( "spr_livingroom_dial_"..number.."_little", { event_mdown = function() private.ClkDocument( number, "open" )end; } );

    elseif mode == "down" then

      ObjSet( "spr_livingroom_dial_"..number.."_little", { event_mdown = function() private.ClkDocument( number, "up" )end; } );

    elseif mode == "open" then

      ObjSet( "spr_livingroom_dial_"..number.."_big", { input = true, event_mdown = function() private.ClkDocument( number, "close" )end; } );
      ObjSet( "spr_livingroom_dial_"..number.."_little", { input = false, scale_x = 1, scale_y = 1, alp = 0 } );

    elseif mode == "close" then

      ObjSet( "spr_livingroom_dial_"..number.."_big", { input = false, scale_x = 1, scale_y = 1, alp = 0, pos_x = private.big_coords.pos_x, pos_y = private.big_coords.pos_y } );
      ObjSet( "spr_livingroom_dial_"..number.."_little", { input = true, event_mdown = function() private.ClkDocument( number, "down" )end; } );
      private.dial_game_state[number] = 1;
      private.CheckWinDialGame();

    end;

  end;

  common_impl.Lock( true );

  private.big_coords = ObjGet( "spr_livingroom_dial_"..number.."_big" );
  private.little_coords = ObjGet( "spr_livingroom_dial_"..number.."_little" );

  if mode == "up" then

    common_impl.PlayAudio( "sfx", "common/audio/aud_touch_papers_move", 0, "", 0 );

    ObjAnimate( "spr_livingroom_dial_"..number.."_little", "pos_y", 0, 0, func_after, { 0,0,private.dial_game_coords[number][1], 0.3,0,private.dial_game_coords[number][2] } );
    if number == 3 then
       ObjAnimate( "spr_livingroom_dial_paper_shadow", "pos_y", 0, 0, "", { 0,0,private.dial_game_coords[4][1], 0.3,0,private.dial_game_coords[4][2] } );
    end;

    for i = 1, 3 do
      if i ~= number and ObjGet( "spr_livingroom_dial_"..i.."_little" ).pos_y == private.dial_game_coords[i][2] then
        private.ClkDocument( i, "down" );
      end;    
    end;

  elseif mode == "down" then

     common_impl.PlayAudio( "sfx", "common/audio/aud_touch_papers_move", 0, "", 0 );

     ObjAnimate( "spr_livingroom_dial_"..number.."_little", "pos_y", 0, 0, func_after, { 0,0,private.dial_game_coords[number][2], 0.3,0,private.dial_game_coords[number][1] } );
     if number == 3 then
       ObjAnimate( "spr_livingroom_dial_paper_shadow", "pos_y", 0, 0, "", { 0,0,private.dial_game_coords[4][2], 0.3,0,private.dial_game_coords[4][1] } );
     end;
  
  elseif mode == "open" then

     common_impl.PlayAudio( "sfx", "common/audio/aud_paper_open", 0, "", 0 );

     ObjAnimate( "spr_livingroom_dial_"..number.."_little", "scale_xy", 0, 0, func_after, { 0,0,1,1, 0.3,0,0,0 } );
     ObjAnimate( "spr_livingroom_dial_"..number.."_big", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );

  elseif mode == "close" then

     common_impl.PlayAudio( "sfx", "common/audio/aud_paper_close", 0, "", 0 );
 
     ObjAnimate( "spr_livingroom_dial_"..number.."_little", "alp", 0, 0, func_after, { 0,0,0, 0.3,0,1 } );
     ObjAnimate( "spr_livingroom_dial_"..number.."_big", "scale_xy", 0, 0, "", { 0,0,1,1, 0.3,0,0,0 } );
     ObjAnimate( "spr_livingroom_dial_"..number.."_big", "pos_xy", 0, 0, "", { 0,0,private.big_coords.pos_x,private.big_coords.pos_y, 0.3,0,private.little_coords.pos_x,private.little_coords.pos_y } );

  end;


end;
-------------------------------------------------------------------------------------
function private.ClkPurse()

  local func_after = function()

      common_impl.Lock( false );

      ObjSet( "spr_livingroom_dial_purse_open", { input = true } ); 
      ObjSet( "spr_livingroom_dial_purse_close", { input = false } ); 
      ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = rm_livingroom.DialGameEnd } );

   end;
  
    common_impl.Lock( true );
    
    
   common_impl.PlayAudio( "sfx", "common/audio/aud_purse_open_buckle", 0, "", 0 );
   ObjAnimate( "spr_livingroom_dial_purse_open", "alp", 0, 0, func_after, { 0,0,0, 0.3,0,1 } );
   ObjAnimate( "spr_livingroom_dial_purse_close", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } ); 

end;
-------------------------------------------------------------------------------------
function private.DialMmgStart()

  common_impl.StopAllVoc();
  common_impl.DialogCharacterStopAllVid();

  local func_after = function()
    common_impl.Lock( false );  
  end;

  ObjSet( "obj_livingroom_george_mmg", { input = true, pos_z = 101, pos_x = 450, pos_y = 350 } ); 
  ObjAttach( "obj_livingroom_george_mmg", "int_dialog_character_impl" );
  ObjSet( "obj_int_dialog_character_input", { input = false } );
  common_impl.Lock( true );
  ObjAnimate( "obj_livingroom_george_mmg", "alp", 0, 0, func_after, { 0,0,0, 0.3,0,1 } ); 
  ObjAnimate( "obj_int_dialog_character", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } ); 

  common_impl.PlayAudio( "sfx", "common/audio/aud_interactive_begin", 0, "", 0 );

end;
-------------------------------------------------------------------------------------
function private.CheckFrase()
  
  
  if common_impl.dialog_character_select == 2 then

     ObjSet( "obj_int_dialog_character_input", { event_mdown = private.DialMmgStart } );

  end;

end;
-------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )

  if dlg_name == "search" then

    if count_txt == 1 then common_impl.continue_visible = false; common_impl.frases = { 1 }; common_impl.dial_icons = { 'loupe' }; common_impl.DialogCharacterShowDialogQuestions( 1, 4 );  
    end;

  elseif dlg_name == "george" then

    private.CheckFrase();
   
    if count_txt == 1 then common_impl.frases = { 2, 3, 4 }; common_impl.dial_icons = { 'george', 'cabinet', 'oliver' }; common_impl.DialogCharacterShowDialogQuestions( 3, 2 ); common_impl.continue_visible = false; 
    elseif count_txt == 2 and common_impl.dialog_character_select ~= 2 then common_impl.DialogCharacterShowDialogQuestions( 2, private.dialog_voices_time[ common_impl.dialog_character_select ] );  
    elseif count_txt == 3 and common_impl.dialog_character_select ~= 2 then common_impl.DialogCharacterShowDialogQuestions( 1, private.dialog_voices_time[ common_impl.dialog_character_select ] ); 
    elseif count_txt == 4 and common_impl.dialog_character_select ~= 2 then common_impl.frases = { 5 }; common_impl.dial_icons = { 'stop' }; common_impl.DialogCharacterShowDialogQuestions( 1, private.dialog_voices_time[ common_impl.dialog_character_select ] ); common_impl.continue_visible = false;  
    end;
    
  end;

end;
-------------------------------------------------------------------------------------
function private.dlg_search_click()

  ObjAttach( "dlg_livingroom_search", "rm_livingroom" );

  common_impl.AddPageDiary( 3 );
  common_impl.continue_visible = false; 
  common_impl.dialog_character_loc = "anm_livingroom_george";
  common_impl.DialogCharacterStart( "search", 3, nil, nil, true, "dlg_search_click_end" );

end;
-------------------------------------------------------------------------------------
function public.dlg_search_click_end() 

  cmn.SetEventDone( "dlg_livingroom_search" );
  cmn.CallEventHandler( "dlg_livingroom_search_end" );

  interface.KeyTaskDone(  "talk_george" ,true );

end;
-------------------------------------------------------------------------------------
function private.dlg_george_click()

  ObjAttach( "dlg_livingroom_george", "rm_livingroom" );
  common_impl.dialog_character_loc = "anm_livingroom_george";
  common_impl.continue_visible = false;
  private.dialog_voices_time = { false, 2, 6, 6, 3 };
  common_impl.DialogCharacterStart( "george", 6, nil, nil, true, "dlg_george_click_end" );

end;
-------------------------------------------------------------------------------------
function public.dlg_george_click_end()

  cmn.SetEventDone( "dlg_livingroom_george" );
  cmn.CallEventHandler( "dlg_livingroom_george_end" ); 
  
  common_impl.Lock( true );

  local func_after = function()

    common_impl.Lock( false );
    int_investigation_button.Show( true );
    ObjSet( "obj_livingroom_george_mmg", { input = false, pos_z = 1,alp = 0 } ); 
    ObjAttach( "obj_livingroom_george_mmg", "obj_livingroom_george_characters" );
    common_impl.ShowBbt( 'bbt_dlg_george_click', 1 );

  end;

  local tmr_func_lock = function ()
   
    common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_in", 0, "", 0 );
    ObjSet( "tmr_livingroom_zoomlock", { playing = false } ); 

  end;

  ObjSet( "tmr_livingroom_zoomlock", { playing = true, time = 0.32, endtrig = tmr_func_lock } );

  local tmr_after = function()

    common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_out", 0, "", 0 );
    ObjSet( "tmr_livingroom_zoomout_snd", { playing = false } ); 

  end;

  ObjSet( "tmr_livingroom_zoomout_snd", {playing = true, time = 1.4, endtrig = tmr_after } ); 

  ObjAnimate( private.room_objname, "scale_xy", 0, 0, "",
    { 
      0.0, 1, 1.0,1.0, 
      1.0, 1, 1.5,1.5,
      1.4, 3, 1.5,1.5,
      2.4, 3, 1.0,1.0
    } );
    
    ObjAnimate( private.room_objname, "pos_xy", 0, 0, func_after,
    { 
      0.0, 1, 0.0,0.0, 
      1.0, 1, -600,-200,
      1.4, 3, -600,-200,
      2.4, 3, 0,0
    } );


end;
--------------------------------------------------------------------------------------

function private.opn_livingroom()

  if ( not ( cmn.IsEventDone( "opn_livingroom" ) ) ) then

    local func_after = function()
       
      common_impl.ShowBbt( 'bbt_livingroom_feathers' );

    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_scary_mus", 0, "", 0 );
    cmn.SetEventDone( "opn_livingroom" );    
    ObjSet( "anm_livingroom_feathers", { visible = true } );
    AnimPlay( "anm_livingroom_feathers", "DoAnim", func_after );
    common_impl.PlayAudio( "sfx", "common/audio/aud_feathers_room", 0, "", 0 );

  end;

  cmn.CallEventHandler( "opn_livingroom" ); 

end;

-------------------------------------------------------------------------------------

function private.vid_livingroom_providence( func_execute )

  interface.BBTHide();

  private.func_providence = func_execute;

  int_button_providence.StopLightProvidence();

  cmn.CallEventHandler( "vid_livingroom_providence_beg" );  
    
  common_impl.StopAllMus();

  VidPlay( "vid_livingroom_providence_p1", "" ); 
  common_impl.PlayAudio( "sfx", "common/audio/aud_livingroom_providence_p1", 0, "", 0.5 ); 
  interface.DialogVideoShow( "vid_livingroom_providence", 1, function() private.vid_livingroom_providence_end(); end , 3, 4 );
  common_impl.PlayAudio( "mus", "common/audio/aud_providence_mus", 1, "", 0.5 );   
  
end;
-------------------------------------------------------------------------------------
function private.vid_livingroom_providence_end( )
    
  local func_after = function ()

    common_impl.Lock( false );

    cmn.SetEventDone( "vid_livingroom_providence" );
    cmn.CallEventHandler( "vid_livingroom_providence_end" );

    common_impl.ShowBbt( 'bbt_providence_level1_2_end' );

    if ( private.func_providence ) then

      private.func_providence();
      private.func_providence = nil;

    end;
    
  end;    

  common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_in", 0, "", 0 );
  common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0, "", 0 );
  common_impl.StopAudio( "mus", "common/audio/aud_providence_mus", 0.2 ); 
  common_impl.StopAudio( "sfx", "common/audio/aud_livingroom_providence_p4", 0.2 ); 
  
  ObjSet( "obj_livingroom_ball", { pos_x = 151, pos_y = 3 } );
  ObjSet( "spr_livingroom_ball_hotspot", { visible = false } );

  ObjAnimate( private.room_objname, "scale_xy", 0, 0, "",
  { 
    0.0, 1, 1.0,1.0, 
    1.0, 1, 1.5,1.5,
    1.4, 3, 1.5,1.5,
    2.4, 3, 1.0,1.0
  } );
  
  ObjAnimate( private.room_objname, "pos_xy", 0, 0, func_after,
  { 
    0.0, 1, 0.0,0.0, 
    1.0, 1, -600,-200,
    1.4, 3, -600,-200,
    2.4, 3, 0,0
  } );

  local tmr_after = function()

    common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_out", 0, "", 0 );

  end;

  ObjSet( "tmr_livingroom_zoomout_snd", {playing = true, time = 1.4, endtrig = tmr_after } ); 

  int_providence.Hide();
  
  local tmr_func_lock = function ()

    common_impl.Lock( true );    

  end;

  ObjSet( "tmr_livingroom_zoomlock", {playing = true, time = 0.32, endtrig = tmr_func_lock } );

  interface.DialogVideoHide();
  
  common_impl.StopAudio( "sfx", "common/audio/aud_livingroom_providence", 0.2 );
  
end;
-----------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
function private.clk_handle()

  common_impl.Lock(true);
  common_impl.ShowBbt( 'bbt_door_use_officekey' );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_door_handle" );
  
  ObjAnimate( "spr_door_handle", "ang", 0, 0, "*common_impl.Lock(false);", { 0,0,0, 0.2,0,-0.04, 0.4,0,0 } );

end;
-------------------------------------------------------------------------------------
function private.clk_spring()

  common_impl.Lock(true);
  common_impl.ShowBbt( 'bbt_table_use_button' );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_spring" );
  
  ObjAnimate( "spr_table_spring", "scale_y", 0, 0, "*common_impl.Lock(false);", { 0,0,1, 0.2,0,0.9, 0.4,0,1 } );
  ObjAnimate( "spr_table_spring", "pos_y", 0, 0, "", { 0,0,-45, 0.2,0,-46, 0.4,0,-45 } );

end;

-------------------------------------------------------------------------------------
function private.clk_suitcase()

  common_impl.Lock(true);
  common_impl.ShowBbt( 'bbt_wardrobe_use_monogram' );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_case_cover" );
  
  ObjAnimate( "spr_wardrobe_suitcase_cover", "pos_xy", 0, 0, "*common_impl.Lock(false);", { 0,0,60,51, 0.3,3,59,50, 0.6,0,60,51 } );

end;
--*********************************************************************************************************************
function private.StopAnims()

  AnimStop( "anm_livingroom_birds_1" );
  AnimStop( "anm_livingroom_birds_2" );

  common_impl.StopAudio( "sfx", "common/audio/aud_crow_window", 1.5 );
  common_impl.StopAudio( "sfx", "common/audio/aud_crows_window", 1.5 );

end;
-----------------------------------------------Anims-------------------------------------------------------------------
ObjAnimate( "spr_door_light_close", "alp", 1, 0, "", { 0,0,0.5, 2,0,1, 4,0,0.5 } );
ObjAnimate( "spr_door_light", "alp", 1, 0, "", { 0,0,0, 1.5,0,1, 3,0,0 } );
-----------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
--*********************************************************************************************************************
ObjAnimate( "spr_table_bear_paw_1", "ang", 1, 0, "", { 0,0,-0.02, 1,0,0.02, 2,0,-0.02 } );
ObjAnimate( "spr_table_bear_paw_2", "ang", 1, 0, "", { 0,0,0.05, 1.5,0,-0.05, 3,0,0.05 } );
ObjAnimate( "spr_table_light", "alp", 1, 0, "", { 0,0,0, 2,0,1, 4,0,0 } );
ObjAnimate( "spr_livingroom_light", "alp", 1, 0, "", { 0,0,0.5, 2,0,1, 4,0,0.5 } );
ObjAnimate( "spr_livingroom_ball", "ang", 1, 0, "", { 0,0,0.1, 2.5,0,-0.05, 5,0,0.1 } );
ObjAnimate( "spr_livingroom_ball_hotspot", "alp", 1, 0, "", { 0,0,0.5, 2,0,1, 4,0,0.5 } );
ObjAnimate( "spr_livingroom_chandelier", "ang", 1, 0, "", { 0,0,-0.03, 2,0,0.03, 4,0,-0.03 } );
