-- name=rm_office
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_office";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_setofdrawers", "room_hub" );
  ObjAttach( "zz_floor", "room_hub" );
  ObjAttach( "zz_chest", "room_hub" );

  private.Init_Subroom();
  private.Init_Mg_Wall();
  private.Init_Anims();

  --------------------------------------------------------------------------------------------
  --private.coord_mas = {};
  private.chest_obj = 0;

  private.start_mas = { 1, 3, 5, 10, 7, 2, 9, 12, 11, 4, 6, 8 };

  --[[for i = 1,3 do

    for j = 1,4 do

      private.coord_mas[number] = {};
      private.coord_mas[number][1] = ( start_pos_x + step_x * ( j - 1 ) );
      private.coord_mas[number][2] = ( start_pos_y + step_y * ( i - 1 ));

      number = number + 1;

    end;

  end;]]

  for i = 1,12 do

    ObjSet( "spr_chest_mmg_part_"..i, { event_mdown =  function() private.ClkPart( i ) end } );    

  end;
  
  --------------------------------------------------------------------------------------------

  ObjMultiSet( {

  { "obj_clock1_clk" , { event_mdown = function() private.clk_arrow(1) end } },
  { "obj_clock2_clk" , {event_mdown = function() private.clk_arrow(2) end } },
  { "spr_setofdrawers_ruler", { event_mdown = private.get_ruler } },
  { "spr_setofdrawers_figurine", { event_mdown = private.get_figurine } },
  { "spr_setofdrawers_magnifier", { event_mdown = private.get_magnifier } },
  { "spr_chest_briefcasekey", { event_mdown = private.get_briefcasekey } },
  { "obj_setofdrawers_diary", { event_mdown = private.get_evidence_1_7 } },
  { "obj_office_providence_item_1", { event_mdown = private.clk_office_providence_1 } },
  { "obj_office_providence_item_2", { event_mdown = function() int_providence.Thinking( "providence_2", "obj_office_providence_item_2" ) end } },
  { "obj_office_use_providence_invitem_1", { event_mdown = private.get_prv_statuette_silhouette } },
  { "obj_office_use_providence_invitem_2", { event_mdown = private.get_prv_criminalsbag_silhouette } },
  { "obj_chest_clk_mmg", { event_mdown = private.OpenChestMemo } },
  { "obj_chest_clk_mmg_close", { event_mdown = private.CloseChestMemo } },
  { "obj_chest_turn_memo", { event_mdown = private.TurnChestMemo } },
  { "obj_dcn_microscope_clk", { event_mdown = private.get_evidence_1_8 } },
  { "spr_floor_open", { event_mdown = private.clk_floor_ring } },
  { "spr_office_providence_plafond_1",{ input = true, drag = true, event_startdrag = private.drag_plafond, event_dragdrop = private.drop_plafond, event_menter = function () common_impl.SetCursor( CURSOR_GET ) end, event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "spr_chest_coin",{event_mdown = function() private.get_coin7() end } },
  { "spr_setofdrawers_coin",{event_mdown = function() private.get_coin8() end } },
  { "spr_office_evidence_lens",{event_drag = private.DragLens, event_dragdrop = private.DropLens } },
  { "spr_office_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_5" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "obj_office_window_clk", { event_mdown = function() common_impl.ShowBbt( 'bbt_office_window_clk' ) end;} },
 } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_office = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    { 
      "gzz_office_setofdrawers",
      "gzz_office_floor",
      "gzz_office_chest",
    }
    for i = 1, #gates do
    
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 

      {
        private.room_objname,
        "zz_setofdrawers",
        "zz_floor",
        "zz_chest"
      
      };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_office", update_game_mode_office, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_office = function ()
    
    local effects_table = 
    {
      "obj_office_anim" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_office", update_performance_mode_office, private.room_objname );
  --------------------------------------------------------------------------------------------
  ----------------------------------------------------------------------------------------------
  common_impl.hint[ "win_setofdrawers" ] = {

      type = "win",    
      room = private.room_objname,
      use_place = "spr_setofdrawers_clockhands_1",
      zz_gate = "gzz_office_setofdrawers",
      zz = "zz_setofdrawers"

  };

  local win_setofdrawers = function ()

      if ( cmn.IsEventDone( "win_setofdrawers" ) ) then  

        ObjDelete("obj_setofdrawers_clock");

        ObjMultiSet( {

          { "spr_setofdrawers_figurine" , { input = true, visible = true, active = true, alp = 1 } },
          { "spr_setofdrawers_magnifier", { input = true, visible = true, active = true ,alp = 1 } },
          { "obj_setofdrawers_diary",     { input = true, visible = true, active = true, alp = 1 } },

          { "spr_setofdrawers_magnifier_shadow", { alp = 1 } },
          { "spr_setofdrawers_figurine_shadow",  { alp = 1 } },
          { "obj_setofdrawers_clock_open",       { alp = 1 } },

          { "spr_office_setofdrawers_clock_op",  { alp = 1 } },
          { "spr_office_setofdrawers_blog",      { alp = 1 } },
          { "spr_office_setofdrawers_magnifier", { alp = 1 } },
          { "spr_office_setofdrawers_statuette", { alp = 1 } },

        } );
      else
        
        for num = 1, 2 do
     
          local ar_ang = 3.14/6*ng_global.progress["std"]["win_setofdrawers"].arrows[num];
          if num == 1 then ar_ang = ar_ang - 2.13 else ar_ang = ar_ang - 2.71 end;
          ObjSet("spr_setofdrawers_clockhands_"..num, {ang = ar_ang });
      
        end;

      end;
 end;
 cmn.AddSubscriber( "win_setofdrawers", win_setofdrawers, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function opn_office () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_office" ] = {
    type = "click",
    use_place = "grm_livingroom_office",
    room = "rm_livingroom"
  };

  local opn_office_map = function ()

    common_impl.VisitMapRoom( "office" );

  end;
  cmn.AddSubscriber( "opn_office", opn_office_map, nil );
----------------------------------------------------------------------------------------------
  -- function get_coins () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_7 = function ()

    ObjDelete( "obj_chest_coin" );

    if cmn.IsEventDone("get_briefcasekey") then
      ObjDelete( "gzz_office_chest" );
    end;

  end;
  cmn.AddSubscriber( "get_coin_7", get_collect_coin_7, private.room_objname );
  --------------------------------------------------------------------------------------------
  local get_collect_coin_8 = function ()

    ObjDelete( "obj_setofdrawers_coin" );
    
  if ( cmn.IsEventDone( "get_evidence_1_7" ) and cmn.IsEventDone( "get_evidence_1_8" ) and cmn.IsEventDone( "get_ruler" )
  and cmn.IsEventDone( "get_figurine" ) and cmn.IsEventDone( "get_magnifier" )) then
     ObjDelete( "gzz_office_setofdrawers" );
  end;    

  end;
  cmn.AddSubscriber( "get_coin_8", get_collect_coin_8, private.room_objname );
----------------------------------------------------------------------------------------------
  -- function get_ruler () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ruler" ] = {
    type = "get",
    get_obj = "spr_setofdrawers_ruler",
    room = private.room_objname,
    zz = "zz_setofdrawers",
    zz_gate = "gzz_office_setofdrawers"
  };

  local get_ruler_inv = function ()
  
    interface.InventoryItemAdd( "inv_ruler", "spr_setofdrawers_ruler" );
  
  end;
  
  local get_ruler_closezz = function ()

    ObjDelete("spr_setofdrawers_ruler_shadow");
    ObjDelete( "gfx_setofdrawers_ruler" );

    if ( cmn.IsEventDone( "get_figurine" ) and cmn.IsEventDone( "get_magnifier" ) and common_impl.IsGetCoin("get_coin_8") 
    and cmn.IsEventDone( "get_evidence_1_7" ) and cmn.IsEventDone( "get_evidence_1_8" )) then
       ObjDelete( "gzz_office_setofdrawers" );
    end;

  end;
  
  cmn.AddSubscriber( "get_ruler", get_ruler_inv );
  cmn.AddSubscriber( "get_ruler", get_ruler_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_figurine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_figurine" ] = {
    type = "get",
    get_obj = "spr_setofdrawers_figurine",
    room = private.room_objname,
    zz = "zz_setofdrawers",
    zz_gate = "gzz_office_setofdrawers"
  };
  local get_figurine_inv = function ()
  
    interface.InventoryItemAdd( "inv_figurine", "spr_setofdrawers_figurine" );
  
  end;
  
  local get_figurine_closezz = function ()

    ObjDelete( "spr_setofdrawers_figurine_shadow" );
    ObjDelete( "gfx_setofdrawers_figurine" ); 
    ObjDelete( "spr_office_setofdrawers_statuette" ); 

    if ( cmn.IsEventDone( "get_ruler" ) and cmn.IsEventDone( "get_magnifier" ) and common_impl.IsGetCoin("get_coin_8")
    and cmn.IsEventDone( "get_evidence_1_7" ) and cmn.IsEventDone( "get_evidence_1_8" )) then
       ObjDelete( "gzz_office_setofdrawers" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_figurine", get_figurine_inv );
  cmn.AddSubscriber( "get_figurine", get_figurine_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_magnifier () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_magnifier" ] = {
    type = "get",
    get_obj = "spr_setofdrawers_magnifier",
    room = private.room_objname,
    zz = "zz_setofdrawers",
    zz_gate = "gzz_office_setofdrawers"
  };
  local get_magnifier_inv = function ()
  
    interface.InventoryItemAdd( "inv_magnifier", "spr_setofdrawers_magnifier" );
    ObjSet( "inv_magnifier", { drag = false });

  end;
  
  local get_magnifier_closezz = function ()

    ObjDelete( "spr_setofdrawers_magnifier_shadow" );
    ObjDelete( "gfx_setofdrawers_magnifier" );
    ObjDelete( "spr_office_setofdrawers_magnifier" );   

    if ( cmn.IsEventDone( "get_ruler" ) and cmn.IsEventDone( "get_figurine" ) and common_impl.IsGetCoin("get_coin_8")
    and cmn.IsEventDone( "get_evidence_1_7" ) and cmn.IsEventDone( "get_evidence_1_8" )) then
       ObjDelete( "gzz_office_setofdrawers" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_magnifier", get_magnifier_inv );
  cmn.AddSubscriber( "get_magnifier", get_magnifier_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_evidence_1_7 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_evidence_1_7" ] = {
    type = "get",
    get_obj = "obj_setofdrawers_dcn_photo_hint",
    room = private.room_objname,
    zz = "zz_setofdrawers",
    zz_gate = "gzz_office_setofdrawers"
  };
  
  local get_evidence_1_7_closezz = function ()

    ObjDelete( "spr_setofdrawers_book");
    ObjDelete( "spr_setofdrawers_book_shadow");
    ObjDelete( "obj_setofdrawers_diary");
    ObjDelete( "spr_office_setofdrawers_blog");

    if ( cmn.IsEventDone( "get_ruler" ) and cmn.IsEventDone( "get_figurine" ) and common_impl.IsGetCoin("get_coin_8")
    and cmn.IsEventDone( "get_magnifier" ) and cmn.IsEventDone( "get_evidence_1_8" )) then

        ObjDelete( "gzz_office_setofdrawers" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_evidence_1_7", get_evidence_1_7_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_evidence_1_8 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_evidence_1_8" ] = {
    type = "get",
    get_obj = "obj_dcn_magnifiednote_hint",
    room = private.room_objname,
    zz = "zz_setofdrawers",
    zz_gate = "gzz_office_setofdrawers"
  };
  
  local get_evidence_1_8_closezz = function ()
  
    ObjDelete( "obj_dcn_microscope_clk" );
    ObjDelete( "spr_setofdrawers_sheet_shadow");
    ObjDelete( "spr_setofdrawers_sheet");
   
    if ( cmn.IsEventDone( "get_ruler" ) and cmn.IsEventDone( "get_figurine" ) and common_impl.IsGetCoin("get_coin_8")
    and cmn.IsEventDone( "get_magnifier" ) and cmn.IsEventDone( "get_evidence_1_7" )) then

       ObjDelete( "gzz_office_setofdrawers" );

    end;
  
  end;

  local get_evidence_1_8_evidence = function ()

     ObjSet( "spr_evidence_evidence_1_8", { res = "assets/interface/resources/evidence/page3/layers/note_2" } );

  end;
  
  cmn.AddSubscriber( "get_evidence_1_8", get_evidence_1_8_closezz, private.room_objname );
  cmn.AddSubscriber( "get_evidence_1_8_closezz", get_evidence_1_8_closezz, private.room_objname );
  cmn.AddSubscriber( "get_evidence_1_8", get_evidence_1_8_evidence );
  --------------------------------------------------------------------------------------------
  -- function get_briefcasekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_briefcasekey" ] = {
    type = "get",
    get_obj = "spr_chest_briefcasekey",
    room = private.room_objname,
    zz = "zz_chest",
    zz_gate = "gzz_office_chest"
  };
  local get_briefcasekey_inv = function ()
  
    interface.InventoryItemAdd( "inv_briefcasekey", "spr_chest_briefcasekey" );
  
  end;
  
  local get_briefcasekey_closezz = function ()

    ObjDelete( "spr_chest_briefcasekey_shadow" );
    ObjDelete( "gfx_chest_briefcasekey" );

    if common_impl.IsGetCoin("get_coin_7") then

      ObjDelete( "gzz_office_chest" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_briefcasekey", get_briefcasekey_inv );
  cmn.AddSubscriber( "get_briefcasekey", get_briefcasekey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_prv_statuette_silhouette () end;
  --------------------------------------------------------------------------------------------
  local get_prv_statuette_silhouette_inv = function ()
  
    interface.ProvidePanelSilhouetteAdd( "inv_prv_statuette", "spr_office_providence_statuette_silhouette" );

  end;
  
  local get_prv_statuette_silhouette_closezz = function ()

    ObjSet( "spr_office_providence_statuette_silhouette", { alp = 1 } );
    ObjSet( "obj_office_use_providence_invitem_1", { event_mdown = function() int_providence.Thinking( "providence_invitem_1", "obj_office_use_providence_invitem_1" ) end } )

  end;

  local get_prv_statuette_silhouette_notadd = function ()

    ObjSet( "obj_office_use_providence_invitem_1", { event_mdown = function() int_providence.Thinking( "providence_invitem_1", "obj_office_use_providence_invitem_1" ) end } )

  end;
  
  cmn.AddSubscriber( "get_prv_statuette_silhouette", get_prv_statuette_silhouette_inv );
  cmn.AddSubscriber( "get_prv_statuette_silhouette", get_prv_statuette_silhouette_closezz, private.room_objname );
  cmn.AddSubscriber( "get_prv_statuette", get_prv_statuette_silhouette_notadd, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_prv_criminalsbag_silhouette () end;
  --------------------------------------------------------------------------------------------
  local get_prv_criminalsbag_silhouette_inv = function ()
  
    interface.ProvidePanelSilhouetteAdd( "inv_prv_criminalsbag", "spr_office_providence_bag_silhouette" );

  end;
  
  local get_prv_criminalsbag_silhouette_closezz = function ()

    ObjSet( "spr_office_providence_bag_silhouette", { alp = 1 } );
    ObjSet( "obj_office_use_providence_invitem_2", { event_mdown = function() int_providence.Thinking( "providence_invitem_2", "obj_office_use_providence_invitem_2" ) end } )

  end;

  local get_prv_criminalsbag_silhouette_notadd = function ()

    ObjSet( "obj_office_use_providence_invitem_2", { event_mdown = function() int_providence.Thinking( "providence_invitem_2", "obj_office_use_providence_invitem_2" ) end } )

  end;
  
  cmn.AddSubscriber( "get_prv_criminalsbag_silhouette", get_prv_criminalsbag_silhouette_inv );
  cmn.AddSubscriber( "get_prv_criminalsbag_silhouette", get_prv_criminalsbag_silhouette_closezz, private.room_objname );
  cmn.AddSubscriber( "get_prv_criminalsbag", get_prv_criminalsbag_silhouette_notadd, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_clockhands () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_clockhands" ] = {
      type = "use",
      inv_obj = "inv_clockhands",
      use_place = "obj_setofdrawers_use_clockhands",
      room = private.room_objname,
      zz = "zz_setofdrawers",
      zz_gate = "gzz_office_setofdrawers"
  };
  local use_clockhands_inv = function ()
  
    interface.InventoryItemRemove( "inv_clockhands" );
  
  end;

  local use_clockhands_beg = function ()
  
    ObjDelete( "obj_setofdrawers_use_clockhands" );
    ObjSet( "obj_setofdrawers_clock" ,{ active = 1, input = 1, visible = 1 } );

  end;

  local use_clockhands_end = function ()

    ObjSet("obj_setofdrawers_clock" ,{alp = 1} );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_clockhands", use_clockhands_beg, private.room_objname );
  cmn.AddSubscriber( "use_clockhands", use_clockhands_inv );
  cmn.AddSubscriber( "use_clockhands", use_clockhands_end, private.room_objname );
  cmn.AddSubscriber( "use_clockhands_inv", use_clockhands_inv, private.room_objname );
  cmn.AddSubscriber( "use_clockhands_beg", use_clockhands_beg, private.room_objname );
  cmn.AddSubscriber( "use_clockhands_end", use_clockhands_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lens1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lens1" ] = {
      type = "use",
      inv_obj = "inv_lens1",
      use_place = "obj_setofdrawers_use_lens",
      room = private.room_objname,
      zz = "zz_setofdrawers",
      zz_gate = "gzz_office_setofdrawers"
  };
  local use_lens1_inv = function ()
  
    interface.InventoryItemRemove( "inv_lens1" );
  
  end;
  local use_lens1_beg = function ()
    
    if ( cmn.IsEventDone( "use_lens2" ) ) then
      
      ObjDelete( "obj_setofdrawers_use_lens" );
    else
      ObjSet( "obj_setofdrawers_use_lens",{ event_mdown = function () common_impl.ShowBbt( 'bbt_setofdrawers_use_lens2' )  end }  );
    end;

  end;
  local use_lens1_end = function ()

    ObjSet("spr_setofdrawers_glass1" , {alp = 0.4});

    if ( cmn.IsEventDone( "use_micronote" ) and cmn.IsEventDone( "use_lens2" ) ) then
      ObjSet( "obj_dcn_microscope_clk", { input = 1, visible = 1, active = 1 });
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lens1", use_lens1_beg, private.room_objname );
  cmn.AddSubscriber( "use_lens1", use_lens1_inv );
  cmn.AddSubscriber( "use_lens1", use_lens1_end, private.room_objname );
  cmn.AddSubscriber( "use_lens1_inv", use_lens1_inv, private.room_objname );
  cmn.AddSubscriber( "use_lens1_beg", use_lens1_beg, private.room_objname );
  cmn.AddSubscriber( "use_lens1_end", use_lens1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lens2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lens2" ] = {
      type = "use",
      inv_obj = "inv_lens2",
      use_place = "obj_setofdrawers_use_lens",
      room = private.room_objname,
      zz = "zz_setofdrawers",
      zz_gate = "gzz_office_setofdrawers"
  };

  local use_lens2_inv = function ()
  
    interface.InventoryItemRemove( "inv_lens2" );
  
  end;

  local use_lens2_beg = function ()
  
    if ( cmn.IsEventDone( "use_lens1" ) ) then

      ObjDelete( "obj_setofdrawers_use_lens" );
    else
      ObjSet( "obj_setofdrawers_use_lens",{ event_mdown = function () common_impl.ShowBbt( 'bbt_setofdrawers_use_lens2' )  end }  );
    end;

  end;

  local use_lens2_end = function ()

    ObjSet("spr_setofdrawers_glass2" , {alp = 0.4})

    if ( cmn.IsEventDone( "use_micronote" ) and cmn.IsEventDone( "use_lens1" ) ) then
      ObjSet( "obj_dcn_microscope_clk", { input = 1, visible = 1, active = 1 });
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lens2", use_lens2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lens2", use_lens2_inv );
  cmn.AddSubscriber( "use_lens2", use_lens2_end, private.room_objname );
  cmn.AddSubscriber( "use_lens2_inv", use_lens2_inv, private.room_objname );
  cmn.AddSubscriber( "use_lens2_beg", use_lens2_beg, private.room_objname );
  cmn.AddSubscriber( "use_lens2_end", use_lens2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_micronote () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_micronote" ] = {
      type = "use",
      inv_obj = "inv_micronote",
      use_place = "obj_setofdrawers_use_micronote",
      room = private.room_objname,
      zz = "zz_setofdrawers",
      zz_gate = "gzz_office_setofdrawers"
  };
  local use_micronote_inv = function ()
  
    interface.InventoryItemRemove( "inv_micronote" );
  
  end;
  local use_micronote_beg = function ()
  
    ObjDelete( "obj_setofdrawers_use_micronote" );
  
  end;
  local use_micronote_end = function ()

    
    ObjSet("spr_setofdrawers_sheet" , { alp = 1 });
    ObjSet("spr_setofdrawers_sheet_shadow" , { alp = 1 });

    if ( cmn.IsEventDone( "use_lens1" ) and cmn.IsEventDone( "use_lens2" ) ) then
      ObjSet( "obj_dcn_microscope_clk", { input = 1, visible = 1, active = 1 });
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_micronote", use_micronote_beg, private.room_objname );
  cmn.AddSubscriber( "use_micronote", use_micronote_inv );
  cmn.AddSubscriber( "use_micronote", use_micronote_end, private.room_objname );
  cmn.AddSubscriber( "use_micronote_inv", use_micronote_inv, private.room_objname );
  cmn.AddSubscriber( "use_micronote_beg", use_micronote_beg, private.room_objname );
  cmn.AddSubscriber( "use_micronote_end", use_micronote_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ring () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ring" ] = {
      type = "use",
      inv_obj = "inv_ring",
      use_place = "obj_floor_use_ring",
      room = private.room_objname,
      zz = "zz_floor",
      zz_gate = "gzz_office_floor"
  };
  local use_ring_inv = function ()
  
    interface.InventoryItemRemove( "inv_ring" );
  
  end;
  local use_ring_beg = function ()
  
    ObjDelete( "obj_floor_use_ring" );
  
  end;
  local use_ring_end = function ()
      
    ObjSet( "spr_floor_ring", { alp = 1 } );
    ObjSet( "spr_floor_open", { input = true } );    
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ring", use_ring_beg, private.room_objname );
  cmn.AddSubscriber( "use_ring", use_ring_inv );
  cmn.AddSubscriber( "use_ring", use_ring_end, private.room_objname );
  cmn.AddSubscriber( "use_ring_inv", use_ring_inv, private.room_objname );
  cmn.AddSubscriber( "use_ring_beg", use_ring_beg, private.room_objname );
  cmn.AddSubscriber( "use_ring_end", use_ring_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chestpiece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chestpiece" ] = {
      type = "use",
      inv_obj = "inv_chestpiece",
      use_place = "obj_chest_use_chestpiece",
      room = private.room_objname,
      zz = "zz_chest",
      zz_gate = "gzz_office_chest"
  };
  local use_chestpiece_inv = function ()
  
    interface.InventoryItemRemove( "inv_chestpiece" );
  
  end;
  local use_chestpiece_beg = function ()
  
    ObjDelete( "obj_chest_use_chestpiece" );
  
  end;
  local use_chestpiece_end = function ()
  
    ObjSet( "obj_chest_clk_mmg", {input = 1} );
    ObjSet( "spr_chest_mg_zz", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chestpiece", use_chestpiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_chestpiece", use_chestpiece_inv );
  cmn.AddSubscriber( "use_chestpiece", use_chestpiece_end, private.room_objname );
  cmn.AddSubscriber( "use_chestpiece_inv", use_chestpiece_inv, private.room_objname );
  cmn.AddSubscriber( "use_chestpiece_beg", use_chestpiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_chestpiece_end", use_chestpiece_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_providence_office () end;
  --------------------------------------------------------------------------------------------
  local clk_providence_office = function ()
  
    if ( not cmn.IsEventDone( "clk_office_providence_1" ) or not cmn.IsEventDone( "clk_office_providence_1" ) 
         or ( cmn.IsEventDone( "get_prv_statuette" ) and not cmn.IsEventDone( "use_office_providence_invitem_1" ) )
         or ( cmn.IsEventDone( "get_prv_criminalsbag" ) and not cmn.IsEventDone( "use_office_providence_invitem_2" ) ) ) then
      int_button_providence.StartActiveProvidence();
    end;
  
  end;
  
  cmn.AddSubscriber( "clk_providence_office", clk_providence_office, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_office_providence_invitem_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_office_providence_invitem_2" ] = {
    type = "use",
    inv_obj = "inv_prv_criminalsbag",
    use_place = "obj_office_use_providence_invitem_2",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"  
  };

  local use_office_providence_invitem_2_inv = function ()
  
    interface.ProvidePanelItemRemove( "inv_prv_criminalsbag" );
  
  end;
  local use_office_providence_invitem_2_beg = function ()
  
    ObjDelete( "obj_office_use_providence_invitem_2" );
  
  end;
  local use_office_providence_invitem_2_end = function ()
  
     ObjSet( "spr_office_providence_bag", { alp = 1 } );
     ObjSet( "spr_office_bag", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_office_providence_invitem_2", use_office_providence_invitem_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_office_providence_invitem_2", use_office_providence_invitem_2_inv );
  cmn.AddSubscriber( "use_office_providence_invitem_2", use_office_providence_invitem_2_end, private.room_objname );
  cmn.AddSubscriber( "use_office_providence_invitem_2_inv", use_office_providence_invitem_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_office_providence_invitem_2_beg", use_office_providence_invitem_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_office_providence_invitem_2_end", use_office_providence_invitem_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_office_providence_invitem_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_office_providence_invitem_1" ] = {
    type = "use",
    inv_obj = "inv_prv_statuette",
    use_place = "obj_office_use_providence_invitem_1",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"  
  };

  local use_office_providence_invitem_1_inv = function ()
  
    interface.ProvidePanelItemRemove( "inv_prv_statuette" );
  
  end;
  local use_office_providence_invitem_1_beg = function ()
  
    ObjDelete( "obj_office_use_providence_invitem_1" );
  
  end;
  local use_office_providence_invitem_1_end = function ()
  
     ObjSet( "spr_office_providence_statuette", { alp = 1 } );
     ObjSet( "spr_office_statuette_2", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_office_providence_invitem_1", use_office_providence_invitem_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_office_providence_invitem_1", use_office_providence_invitem_1_inv );
  cmn.AddSubscriber( "use_office_providence_invitem_1", use_office_providence_invitem_1_end, private.room_objname );
  cmn.AddSubscriber( "use_office_providence_invitem_1_inv", use_office_providence_invitem_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_office_providence_invitem_1_beg", use_office_providence_invitem_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_office_providence_invitem_1_end", use_office_providence_invitem_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_office_providence_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_office_providence_1" ] = {
    type = "click",
    use_place = "obj_office_providence_item_1",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"  
  };

  local clk_office_providence_1_beg = function ()
  
    ObjDelete( "obj_office_providence_item_1" );
  
  end;
  local clk_office_providence_1_end = function ()
  
    ObjDelete( "spr_office_providence_item_1" );
    ObjSet( "spr_office_providence_item_2", { alp = 1 } );

    ObjDelete( "spr_office_cabinet" );
    ObjSet( "spr_office_cabinet_2", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_office_providence_1", clk_office_providence_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_office_providence_1", clk_office_providence_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_office_providence_1_beg", clk_office_providence_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_office_providence_1_end", clk_office_providence_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_office_providence_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_office_providence_2" ] = {
    type = "click",
    use_place = "obj_office_providence_item_2",
    inv_obj = "spr_office_providence_plafond_1",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"   
  };

  local clk_office_providence_2_beg = function ()
  
    ObjDelete( "obj_office_providence_item_2" );
  
  end;
  local clk_office_providence_2_end = function ()
  
    ObjDelete( "spr_office_providence_plafond_1" );
    ObjSet( "spr_office_providence_plafond_2", { alp = 1 } );

    ObjDelete( "spr_office_plafond_1" );
    ObjSet( "spr_office_plafond_2", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_office_providence_2", clk_office_providence_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_office_providence_2", clk_office_providence_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_office_providence_2_beg", clk_office_providence_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_office_providence_2_end", clk_office_providence_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_office_providence () end;
  --------------------------------------------------------------------------------------------
  local vid_office_providence_beg = function ()

    local params = { "right" };
    int_slider.Unlock( private.room_objname, params );    

  end;
  local vid_office_providence_end = function ()

    ObjSet( "obj_office_over", { input = true } );

    for i = 1, 4 do

      ObjSet( "spr_office_brick_"..i, { alp = 1, input = true } );

    end;

  end;

  cmn.AddSubscriber( "vid_office_providence", vid_office_providence_beg, private.room_objname );
  cmn.AddSubscriber( "vid_office_providence", vid_office_providence_end, private.room_objname  );
  cmn.AddSubscriber( "vid_office_providence_beg", vid_office_providence_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_office_providence_end", vid_office_providence_end, private.room_objname  );
  --------------------------------------------------------------------------------------------  
  local vid_office_providence_p2 = function ()

    VidStop( "vid_office_providence_p1" );  
    ObjSet( "vid_office_providence_p2", { playing = true } );    

  end;

  cmn.AddSubscriber( "vid_office_providence_p2", vid_office_providence_p2, private.room_objname );
  --------------------------------------------------------------------------------------------  
  local vid_office_providence_p3 = function ()

    VidStop( "vid_office_providence_p2" );  
    ObjSet( "vid_office_providence_p3", { playing = true } );    

  end;

  cmn.AddSubscriber( "vid_office_providence_p3", vid_office_providence_p3, private.room_objname );
  --------------------------------------------------------------------------------------------  
  local vid_office_providence_p4 = function ()

    VidStop( "vid_office_providence_p3" );  
    VidPlay( "vid_office_providence_p4", private.vid_office_providence_end );  

  end;

  cmn.AddSubscriber( "vid_office_providence_p4", vid_office_providence_p4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_5 = function ()
  
    ObjDelete( "obj_office_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_5", get_collect_morph_item_1_5, private.room_objname );
  --------------------------------------------------------------------------------------------
   --function win_chest end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_chest" ] = {

      type = "win",    
      use_place = "obj_chest_clk_mmg",
      room = private.room_objname,
      zz_gate = "gzz_office_chest",
      zz = "zz_chest"
  };

  local win_chest_func = function ()

      if ( cmn.IsEventDone( "win_chest" ) ) then  
        
      ObjMultiSet( {

        { "gfx_chest_briefcasekey",     { avtive = 1 } },
        { "obj_chest_open",             { alp = 1, input = 1 } },
        { "spr_office_chest_cover_up",  { alp = 1 }},

      } );

        ObjDelete("spr_office_chest_cover");
        ObjDelete( "spr_chest_note_big" );
        ObjDelete( "obj_chest_clk_mmg" );

      else

        private.LoadChestPeaceState();

      end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_chest", win_chest_func, private.room_objname );

  --------------------------------------------------------------------------------------------
   --function win_mg_wall end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mg_wall" ] = {

      type = "click",    
      use_place = "obj_office_hint",
      zz = "slider_right",
      room = private.room_objname
  };

  local win_mg_wall_func = function ()

      if ( cmn.IsEventDone( "win_mg_wall" ) ) then  
        
        ObjDelete( "obj_office_over" );
        ObjSet( "gzz_office_floor", { input = true, active = true } );
        ObjSet( "obj_office_picture_bbt", { input = true } );

      end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_mg_wall", win_mg_wall_func, private.room_objname );
  --------------------------------------------------------------------------------------------
-- function clk_floor_ring () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_floor_ring" ] = {
    type = "click",
    use_place = "spr_floor_open",
    room = private.room_objname,
    zz = "zz_floor",
    zz_gate = "gzz_office_floor"  
  };

  local clk_floor_ring_beg = function ()
      
  
  end;
  local clk_floor_ring_end = function ()
  
    ObjDelete( "gzz_office_floor" );
    ObjSet( "grm_office_basement", { input = true, active = true } );
    ObjSet( "spr_office_floor_door", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_floor_ring", clk_floor_ring_beg, private.room_objname );
  cmn.AddSubscriber( "clk_floor_ring", clk_floor_ring_end, private.room_objname );
  cmn.AddSubscriber( "clk_floor_ring_beg", clk_floor_ring_beg, private.room_objname );
  cmn.AddSubscriber( "clk_floor_ring_end", clk_floor_ring_end, private.room_objname );
--*********************************************************************************************************************
--*********************************************************************************************************************
end;
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()

  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

  private.opn_office();
  if ( not cmn.IsEventDone( "vid_office_providence" ) ) then

    int_button_providence.StartLightProvidence();

  end;

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.EnvPlay( { "common/audio/aud_office_env" }, "", 0.5 );
  common_impl.MorphItemMorphing();

  interface.InvestigationButtonCheck();

  if not ng_global.progress[ "std" ][ "clk_office_providence_1" ].showanim then

    ObjAnimate("spr_office_providence_item_1_add", "alp", 0, 0, "", { 0, 3, 0, 0.4, 3, 1, 0.8,3,0, 1.2,1,1, 1.6,3,0 });
    ng_global.progress[ "std" ][ "clk_office_providence_1" ].showanim = true;

  end

end;
--*********************************************************************************************************************
function public.Close()

  --common_impl.StopAudio( "env", "common/audio/aud_office_env", 0.2 );

  int_slider.CloseSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreClose()

  if ( not cmn.IsEventDone( "vid_office_providence" ) ) then

    int_button_providence.StopLightProvidence();

  end;

end;
--*********************************************************************************************************************
--function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
------------------------------------------------------------------------------------------
function public.use_clockhands()

  local item = "inv_clockhands";

  if ( common.ApplyObj( item, "obj_setofdrawers_use_clockhands", true ) ) then

    cmn.CallEventHandler( "use_clockhands_inv" );
    cmn.CallEventHandler( "use_clockhands_beg" );

    local func_end = function ()

      common_impl.Lock(false);
      cmn.CallEventHandler( "use_clockhands_mid" ); 
      cmn.SetEventDone( "use_clockhands" );
      cmn.CallEventHandler( "use_clockhands_end" );
      cmn.MiniGameShow( "setofdrawers" );
      common_impl.PassingMgStart( "setofdrawers" )

    end;
    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_arrows", 0, "", 0 );
    ObjAnimate( "obj_setofdrawers_clock", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.5, 0, 1.0
    } );
    
  elseif common.ApplyObj( item, "gzz_office_setofdrawers", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_setofdrawers", nil, { 512, 384 } );

  else

    common_impl.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lens1()

  local item = "inv_lens1";

  if ( common.ApplyObj( item, "obj_setofdrawers_use_lens", true ) ) then

    cmn.CallEventHandler( "use_lens1_inv" );
    cmn.CallEventHandler( "use_lens1_beg" );

    local func_end = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_lens1" );
      cmn.CallEventHandler( "use_lens1_end" );
    
    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_lens", 0, "", 0 );
    ObjAnimate( "spr_setofdrawers_glass1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.4
    } );

  elseif common.ApplyObj( item, "gzz_office_setofdrawers", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_setofdrawers", nil, { 512, 384 } );

  else

    common_impl.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lens2()

  local item = "inv_lens2";

  if ( common.ApplyObj( item, "obj_setofdrawers_use_lens", true ) ) then

    cmn.CallEventHandler( "use_lens2_inv" );
    cmn.CallEventHandler( "use_lens2_beg" );

    local func_end = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_lens2" );
      cmn.CallEventHandler( "use_lens2_end" );

    end;

  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_use_lens", 0, "", 0 );
  ObjAnimate( "spr_setofdrawers_glass2", "alp", 0, 0, func_end,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 0.4
  } );

  elseif common.ApplyObj( item, "gzz_office_setofdrawers", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_setofdrawers", nil, { 512, 384 } );

  else

    common_impl.WrongApply(); 

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_micronote()

  local item = "inv_micronote";

  if ( common.ApplyObj( item, "obj_setofdrawers_use_micronote", true ) )then

    cmn.CallEventHandler( "use_micronote_inv" );
    cmn.CallEventHandler( "use_micronote_beg" );

    local func_end = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_micronote" );
      cmn.CallEventHandler( "use_micronote_end" );

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_micro_note", 0, "", 0 );
    ObjAnimate( "spr_setofdrawers_sheet", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_setofdrawers_sheet_shadow", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
    if not cmn.IsEventDone( "use_lens1" ) and not cmn.IsEventDone( "use_lens2" ) then
      common_impl.ShowBbt( 'bbt_setofdrawers_use_note_without_lens', 1 );
    end;

  elseif common.ApplyObj( item, "gzz_office_setofdrawers", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_setofdrawers", nil, { 512, 384 } );

  else

    common_impl.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ring()

  local item = "inv_ring";

  if ( common.ApplyObj( item, "obj_floor_use_ring", true ) and cmn.IsEventDone( "win_mg_wall" ) ) then

    cmn.CallEventHandler( "use_ring_inv" );
    cmn.CallEventHandler( "use_ring_beg" );

    local func_end = function ()

      common_impl.Lock(false);

      cmn.SetEventDone( "use_ring" );
      cmn.CallEventHandler( "use_ring_end" );
    
    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_lion_ring", 0, "", 0 );

    common_impl.Lock(true);

    ObjAnimate( "spr_floor_ring", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.4, 0, 1.0
    } );

  elseif common.ApplyObj( item, "gzz_office_floor", false ) and cmn.IsEventDone( "win_mg_wall" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_floor", nil, { 512, 384 } );

  else

    common_impl.WrongApply(); 

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_chestpiece()

  local item = "inv_chestpiece";

  if ( common.ApplyObj( item, "obj_chest_use_chestpiece",true ) ) then

    cmn.CallEventHandler( "use_chestpiece_inv" );
    cmn.CallEventHandler( "use_chestpiece_beg" );

   local func_end = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_chestpiece" );
      cmn.CallEventHandler( "use_chestpiece_end" );
    
    end;

   common_impl.Lock(true); 
   common_impl.PlayAudio( "sfx", "common/audio/aud_use_mosaic", 0, "", 0 );
   ObjAnimate( "spr_chest_mg_zz", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

  elseif common.ApplyObj( item, "gzz_office_chest", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_chest", nil, { 512, 384 } );

  else

    common_impl.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_office_providence_invitem_2()

  local item = "inv_prv_criminalsbag";

  if ( ObjIntersect( item, "obj_office_use_providence_invitem_2" ) and int_providence.show ) then

    cmn.CallEventHandler( "use_office_providence_invitem_2_inv" );
    cmn.CallEventHandler( "use_office_providence_invitem_2_beg" );

    local func_end = function ()

      common_impl.Lock(false); 

      cmn.CallEventHandler( "use_office_providence_invitem_2_end" );

      if cmn.IsEventDone( "clk_office_providence_1" ) and cmn.IsEventDone( "clk_office_providence_2" ) and cmn.IsEventDone( "use_office_providence_invitem_1" ) then

        private.anim_providence( function() cmn.SetEventDone( "use_office_providence_invitem_2" ); end );

      else

        if ( cmn.IsEventDone( "clk_office_providence_1" ) and cmn.IsEventDone( "clk_office_providence_2" ) and
           ( not cmn.IsEventDone( "get_prv_statuette" ) or cmn.IsEventDone( "use_office_providence_invitem_1" ) ) ) then

          int_button_providence.StopActiveProvidence();

        end;

        cmn.SetEventDone( "use_office_providence_invitem_2" );

      end;

    end;

    common_impl.Lock(true); 
    common_impl.PlayAudio( "sfx", "common/audio/aud_providence_bag", 0, "", 0 );

    ObjAnimate( "spr_office_providence_bag", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

  else

    common_impl.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_office_providence_invitem_1()

  local item = "inv_prv_statuette";

  if ( ObjIntersect( item, "obj_office_use_providence_invitem_1" ) and int_providence.show ) then

    cmn.CallEventHandler( "use_office_providence_invitem_1_inv" );
    cmn.CallEventHandler( "use_office_providence_invitem_1_beg" );

    local func_end = function ()

      common_impl.Lock(false); 

      cmn.CallEventHandler( "use_office_providence_invitem_1_end" );

      if cmn.IsEventDone( "clk_office_providence_1" ) and cmn.IsEventDone( "clk_office_providence_2" ) and cmn.IsEventDone( "use_office_providence_invitem_2" ) then

        private.anim_providence( function() cmn.SetEventDone( "use_office_providence_invitem_1" ); end );

      else 

        if ( cmn.IsEventDone( "clk_office_providence_1" ) and  cmn.IsEventDone( "clk_office_providence_2" ) and          
           ( not cmn.IsEventDone( "get_prv_criminalsbag" ) or cmn.IsEventDone( "use_office_providence_invitem_2" ) )  ) then

          int_button_providence.StopActiveProvidence();

        end;

        cmn.SetEventDone( "use_office_providence_invitem_1" );

      end;

    end;

    common_impl.Lock(true); 
    common_impl.PlayAudio( "sfx", "common/audio/aud_providence_statue", 0, "", 0 );

    ObjAnimate( "spr_office_providence_statuette", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

  else

    common_impl.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_coin7()


  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_7");
    cmn.CallEventHandler("get_coin_7");

    if cmn.IsEventDone("get_briefcasekey") then
      common.CloseSubRoom();
    end;

  end;
    
  common_impl.PlayEffectHO( "spr_chest_coin", func_after );

end;
--------------------------------------------------------------------------------------------
function private.get_coin8()
  
  local func_after = function ()

    common_impl.GetCoinDone("get_coin_8");
    cmn.CallEventHandler("get_coin_8");
    
    if ( cmn.IsEventDone( "get_evidence_1_7" ) and cmn.IsEventDone( "get_evidence_1_8" ) and cmn.IsEventDone( "get_ruler" )
    and cmn.IsEventDone( "get_figurine" ) and cmn.IsEventDone( "get_magnifier" )) then
       common.CloseSubRoom();
    end;

  end;

  common_impl.PlayEffectHO( "spr_setofdrawers_coin", func_after );
end;
--------------------------------------------------------------------------------------------
function private.get_ruler()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  cmn.SetEventDone( "get_ruler" );
  cmn.CallEventHandler( "get_ruler" );
  if ( cmn.IsEventDone( "get_evidence_1_8" ) and cmn.IsEventDone( "get_figurine" ) and common_impl.IsGetCoin("get_coin_8") 
  and cmn.IsEventDone( "get_magnifier" ) and cmn.IsEventDone( "get_evidence_1_7" )) then
     common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_figurine()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  cmn.SetEventDone( "get_figurine" );
  cmn.CallEventHandler( "get_figurine" );
  if ( cmn.IsEventDone( "get_evidence_1_8" ) and cmn.IsEventDone( "get_ruler" ) and common_impl.IsGetCoin("get_coin_8") 
  and cmn.IsEventDone( "get_magnifier" ) and cmn.IsEventDone( "get_evidence_1_7" )) then
     common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_magnifier()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  cmn.SetEventDone( "get_magnifier" );
  cmn.CallEventHandler( "get_magnifier" );
  if ( cmn.IsEventDone( "get_evidence_1_8" ) and cmn.IsEventDone( "get_ruler" ) and common_impl.IsGetCoin("get_coin_8") 
  and cmn.IsEventDone( "get_figurine" ) and cmn.IsEventDone( "get_evidence_1_7" )) then
     common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_evidence_1_7()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_evidence_open", 0, "", 0 );

  local func_end = function ()

    interface.InvestigationButtonItemAdd( "evidence_1_7", "obj_evidence_evidence_1_7" );

    cmn.SetEventDone( "get_evidence_1_7" );
    cmn.CallEventHandler( "get_evidence_1_7" );

    if ( cmn.IsEventDone( "get_evidence_1_7" ) and cmn.IsEventDone( "get_ruler" ) and common_impl.IsGetCoin("get_coin_8")
    and cmn.IsEventDone( "get_figurine" ) and cmn.IsEventDone( "get_magnifier" )) then
       common.CloseSubRoom();
    end;
  
  end;

  interface.DialogEvidenceShow( "evidence_1_7", func_end )

end;
--------------------------------------------------------------------------------------------
function private.get_evidence_1_8()
  
  local func_end = function ()

    interface.InvestigationButtonItemAdd( "evidence_1_8", "spr_evidence_evidence_1_8" );

    cmn.SetEventDone( "get_evidence_1_8" );
    cmn.CallEventHandler( "get_evidence_1_8" );

    if ( cmn.IsEventDone( "get_evidence_1_7" ) and cmn.IsEventDone( "get_ruler" ) and common_impl.IsGetCoin("get_coin_8")
    and cmn.IsEventDone( "get_figurine" ) and cmn.IsEventDone( "get_magnifier" )) then

       common.CloseSubRoom();

    end;
  
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_evidence_open", 0, "", 0 );

  interface.DialogEvidenceShow( "evidence_1_8", func_end );
  ObjAttach( "spr_office_evidence_lens", "obj_evidence_evidence_1_8" );
  common_impl.SetCursor( CURSOR_NULL );
  ObjStartDrag( "spr_office_evidence_lens" );

end;
--------------------------------------------------------------------------------------------
function private.get_briefcasekey()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  cmn.SetEventDone( "get_briefcasekey" );
  cmn.CallEventHandler( "get_briefcasekey" );

  if common_impl.IsGetCoin("get_coin_7") then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_prv_statuette_silhouette()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );
  cmn.SetEventDone( "get_prv_statuette_silhouette" );
  cmn.CallEventHandler( "get_prv_statuette_silhouette" );

end;
--------------------------------------------------------------------------------------------
function private.get_prv_criminalsbag_silhouette()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );
  cmn.SetEventDone( "get_prv_criminalsbag_silhouette" );
  cmn.CallEventHandler( "get_prv_criminalsbag_silhouette" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_arrow(num)

  ng_global.progress["std"]["win_setofdrawers"].arrows[num] = ng_global.progress["std"]["win_setofdrawers"].arrows[num] - 1;

  local ar_ang = 3.14/6*ng_global.progress["std"]["win_setofdrawers"].arrows[num];

  if num == 1 then ar_ang = ar_ang - 2.13 else ar_ang = ar_ang - 2.71 end;

  ObjSet("spr_setofdrawers_clockhands_"..num, {ang = ar_ang });

  if ng_global.progress["std"]["win_setofdrawers"].arrows[num] < - 12 then 
    ng_global.progress["std"]["win_setofdrawers"].arrows[num] = ng_global.progress["std"]["win_setofdrawers"].arrows[num] +12;  
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_clock_click", 0, "", 0 );
  private.CheckWin_setofdrawers();

end;
--------------------------------------------------------------------------------------------
function private.clk_office_providence_1()

  cmn.CallEventHandler( "clk_office_providence_1_beg" );

  local func_after = function ()

    common_impl.Lock(false);    
    cmn.CallEventHandler( "clk_office_providence_1_end" );

    if cmn.IsEventDone( "clk_office_providence_2" ) and cmn.IsEventDone( "use_office_providence_invitem_2" ) and cmn.IsEventDone( "use_office_providence_invitem_1" ) then

        private.anim_providence( function() cmn.SetEventDone( "clk_office_providence_1" ); end );

    else

      if ( cmn.IsEventDone( "clk_office_providence_2" ) and 
         ( not cmn.IsEventDone( "get_prv_statuette" ) or cmn.IsEventDone( "use_office_providence_invitem_1" ) ) and
         ( not cmn.IsEventDone( "get_prv_criminalsbag" ) or cmn.IsEventDone( "use_office_providence_invitem_2" ) )  ) then

        int_button_providence.StopActiveProvidence();

      end;

      cmn.SetEventDone( "clk_office_providence_1" );

    end;
  
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_cabinet", 0, "", 0 );

  ObjAnimate( "spr_office_providence_item_1", "alp", 0, 0, "", 
  { 
    0.0, 0, 1.0, 
    0.4, 0, 0.0
  } );

  ObjAnimate( "spr_office_providence_item_2", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 0.0, 
    0.4, 0, 1.0
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_office_providence_2()

  cmn.CallEventHandler( "clk_office_providence_2_beg" );

  local func_after = function ()

    common_impl.Lock(false);    
    cmn.CallEventHandler( "clk_office_providence_2_end" );

    if cmn.IsEventDone( "clk_office_providence_1" ) and cmn.IsEventDone( "use_office_providence_invitem_2" ) and cmn.IsEventDone( "use_office_providence_invitem_1" ) then

        private.anim_providence( function() cmn.SetEventDone( "clk_office_providence_2" ); end );

    else 

      if ( cmn.IsEventDone( "clk_office_providence_1" ) and 
         ( not cmn.IsEventDone( "get_prv_statuette" ) or cmn.IsEventDone( "use_office_providence_invitem_1" ) ) and
         ( not cmn.IsEventDone( "get_prv_criminalsbag" ) or cmn.IsEventDone( "use_office_providence_invitem_2" ) )  ) then

        int_button_providence.StopActiveProvidence();

      end;

      cmn.SetEventDone( "clk_office_providence_2" );

    end;
  
  end;

  common_impl.Lock(true);
  ObjSet( "spr_office_providence_plafond_1", { alp = 0 } );
  ObjAnimate( "spr_office_providence_plafond_2", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );

end;
--------------------------------------------------------------------------------------------
function private.anim_providence( func_execute )

  int_button_providence.StopActiveProvidence();

  common_impl.ShowBbt( "bbt_providence_allitems" );

  local array_objects = {
    "spr_office_providence_plafond_2",
    "spr_office_providence_bag",
    "spr_office_providence_statuette",
    "spr_office_providence_item_2" }

  local func_end = function()

    for i = 1, #array_objects do
      ObjAttach( array_objects[ i ], "rm_office_providence" );
      ObjSet( array_objects[ i ], { alp = 1 } );
    end;
    common_impl.Lock( false );    
    private.vid_office_providence( func_execute );

  end;
  
  common_impl.Lock( true );
  for i = 1, #array_objects do
    
    common_impl.PlayEffectHO( array_objects[ i ], func_end, 3, "assets/interface/resources/effect_mask" );
    func_end = nil;

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_ready", 0, "", 0 );

end;
-------------------------------------------------------------------------------------
function private.drag_plafond ()

  ObjSet( "spr_office_providence_plafond_1", { pos_z = 10 } );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

end;
-------------------------------------------------------------------------------------
function private.drop_plafond ()

  local item = "spr_office_providence_plafond_1";

  ObjSet( item, { pos_z = 0 } );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_lampshade", 0, "", 0 );

  if ( ObjIntersect( item, "obj_office_providence_item_2" ) ) then

    private.clk_office_providence_2();

  end;

end;
--------------------------------------------------------------------------------------------
function private.clk_floor_ring ()

  cmn.CallEventHandler( "clk_floor_ring_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_floor_ring" );
    cmn.CallEventHandler( "clk_floor_ring_end" );
    common_impl.Lock( false );
    common.CloseSubRoom();
  
  end;
  
  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_lion_ring", 0, "", 0 );

  ObjAnimate( "spr_floor_open", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 0.0, 
    0.5, 0, 1.0
  } );

  ObjAnimate( "spr_floor_ring", "alp", 0, 0, "", 
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_office ()

  if not ( cmn.IsEventDone( "opn_office" ) ) then
    cmn.SetEventDone( "opn_office" );
    common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0, "", 0 );
  end;

  cmn.CallEventHandler( "opn_office" ); 

end;
-------------------------------------------------------------------------------------
function private.DragLens ()
  
  local pos = GetObjPosByObj( "spr_office_evidence_lens", "spr_evidence_evidence_1_8_lens" )
  --DbgTrace( "pos = "..pos[ 1 ].."  "..pos[ 2 ] );
  local crop_x = - ObjGet( "spr_evidence_evidence_1_8_lens" ).croprect_w / 2 + pos[ 1 ];
  local crop_y = - ObjGet( "spr_evidence_evidence_1_8_lens" ).croprect_h / 2 + pos[ 2 ];

  ObjSet( "spr_evidence_evidence_1_8_lens", { alp = 1, croprect_x = crop_x, croprect_y = crop_y } );

end;
-------------------------------------------------------------------------------------
function private.DropLens ()

  ObjSet( "spr_evidence_evidence_1_8_lens", { visible = false } );
  ObjDetach( "spr_office_evidence_lens" );

end;
-------------------------------------------------------------------------------------

function private.vid_office_providence ( func_execute )

  interface.BBTHide();
  private.func_providence = func_execute;
  cmn.CallEventHandler( "vid_office_providence_beg" );
  
  common_impl.StopAllMus();
  VidPlay( "vid_office_providence_p1", "" );   
  interface.DialogVideoShow( "vid_office_providence", 1, private.vid_office_providence_end, 3, 4 ); 
  common_impl.PlayAudio( "mus", "common/audio/aud_providence_mus", 1, "", 0.5 );
  common_impl.PlayAudio( "sfx", "common/audio/aud_office_providence_p1", 0, "", 0.5 );   

end;
-------------------------------------------------------------------------------------

function private.vid_office_providence_end ()

  interface.DialogVideoHide();  
  int_providence.Hide();
  int_button_providence.StopLightProvidence();
  common_impl.ShowBbt( 'bbt_providence_level1_3_end' );
  common_impl.StopAudio( "sfx", "common/audio/aud_office_providence", 0.2 );
  common_impl.StopAudio( "mus", "common/audio/aud_providence_mus", 0.2 ); 
  common_impl.StopAudio( "sfx", "common/audio/aud_office_providence_p4", 0.2 ); 
  cmn.SetEventDone( "vid_office_providence" );
  cmn.CallEventHandler( "vid_office_providence_end" );

  int_slider.InitSlider( private.room_objname );

  if ( private.func_providence ) then
    private.func_providence();
    private.func_providence = nil;
  end;

end;
--*********************************************************************************************************************
function private.ClkPart ( sender )

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_box_click", 0, "", 0 );

  if private.chest_obj == 0 then  --AK>first clk

    local trg_after = function ()

      private.chest_obj = sender;
      common_impl.Lock( false );

    end;

    ObjSet( "spr_chest_mmg_part_"..sender, { pos_z = 5 } );

    ObjAnimate("spr_chest_mmg_part_"..sender, "scale_xy", 0, 0, trg_after, 
    {
      0.0, 3, 1.0, 1.0, 
      0.3, 3, 1.2, 1.2 
    });

  elseif private.chest_obj == sender then --AK>double clk

    local trg_after = function ()

      private.chest_obj = 0;
      common_impl.Lock( false );
 
    end;

    ObjAnimate( "spr_chest_mmg_part_"..sender, "scale_xy", 0, 0, trg_after, 
    {
      0.0, 3, 1.2, 1.2, 
      0.3, 3, 1.0, 1.0 
    });
    ObjSet( "spr_chest_mmg_part_"..sender, { pos_z = 0 } );

  else --AK>change pieces

    local trg_after = function ()

      ObjSet( "spr_chest_mmg_part_"..private.chest_obj, { pos_z = 0 } );
      ObjSet( "spr_chest_mmg_part_"..sender, { pos_z = 0 } );

      local right_pos = 0;
      local wrong_element = {};

      for i = 1,12 do

        if ( ng_global.progress[ "std" ][ "win_chest" ].current_pos[ i ] == i ) then

          right_pos = right_pos + 1;

        else 

          if wrong_element[1] then

            wrong_element[2] = i 

          else 

            wrong_element[1] = i

          end;

        end;

      end;

     if ( right_pos == 10 ) and 
        ( sender == wrong_element[ 1 ] and wrong_element[ 2 ] == private.chest_obj ) or
        ( sender == wrong_element[ 2 ] and wrong_element[ 1 ] == private.chest_obj ) then

        private.Win();

     else

        local temp = ng_global.progress[ "std" ][ "win_chest" ].current_pos[ sender ];
        ng_global.progress[ "std" ][ "win_chest" ].current_pos[ sender ] = ng_global.progress[ "std" ][ "win_chest" ].current_pos[ private.chest_obj ];
        ng_global.progress[ "std" ][ "win_chest" ].current_pos[ private.chest_obj ] = temp;

        private.chest_obj = 0;
        common_impl.Lock( false );

     end;

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_box_move", 0, "", 0 );

    ObjSet( "spr_chest_mmg_part_"..sender, { pos_z = 4 } );  
  
    ObjAnimate( "spr_chest_mmg_part_"..sender, "scale_xy", 0, 0, "", 
    { 
      0.0, 3, 1.0, 1, 
      0.3, 3, 1.2, 1.2, 
      1.0, 3, 1.2, 1.2, 
      1.3, 3, 1.0, 1  
    } );

    ObjAnimate( "spr_chest_mmg_part_"..private.chest_obj, "scale_xy", 0, 0, trg_after, 
    {
      0.0, 3, 1.2, 1.2, 
      1.0, 3, 1.2, 1.2,
      1.3, 3, 1.0, 1.0  
    });

    local fst_obj = ObjGet( "spr_chest_mmg_part_"..private.chest_obj );
    local sec_obj = ObjGet( "spr_chest_mmg_part_"..sender );
  
    ObjAnimate( "spr_chest_mmg_part_"..sender, "pos_xy", 0, 0, "", 
    {
      0.0, 3, sec_obj.pos_x, sec_obj.pos_y, 
      0.3, 3, sec_obj.pos_x, sec_obj.pos_y, 
      1.0, 3, fst_obj.pos_x, fst_obj.pos_y 
    });
    ObjAnimate( "spr_chest_mmg_part_"..private.chest_obj, "pos_xy", 0, 0, "", 
    {
      0.0, 3, fst_obj.pos_x, fst_obj.pos_y, 
      0.3, 3, fst_obj.pos_x, fst_obj.pos_y, 
      1.0, 3, sec_obj.pos_x, sec_obj.pos_y 
    });

  end;

end;
--*********************************************************************************************************************
function private.LoadChestPeaceState ()

  local start_pos_x = -169;
  local start_pos_y = -108;
  local step_x = 112;
  local step_y = 109;
  local number = 1;
  
  for i = 1,12 do

    local pos = ng_global.progress[ "std" ][ "win_chest" ].current_pos[ i ];

    local line = math.floor ( ( pos - 1 )/4 );
    local col = ( pos - 1 ) % 4;

    ObjSet( "spr_chest_mmg_part_"..i, 
    { 
      pos_x = start_pos_x + col * step_x,
      pos_y = start_pos_y + line * step_y,
    } );
  end;

end;
--*********************************************************************************************************************
function private.Win ()

  common_impl.Lock(true);

  local func_after = function ()

    common_impl.Lock(false);
    PlaySfx( "assets/levels/common/audio/aud_mg_win", 0, 0 );
    cmn.MiniGameHide( "chest" );
    cmn.SetEventDone( "win_chest" );
    cmn.CallEventHandler( "win_chest" );
    common_impl.PassingMgWin( "chest" )

  end;

  local func_aud_after = function()

   common_impl.PlayAudio( "sfx", "common/audio/aud_mg_box_win", 0, "", 0 );

  end;
  
  ObjAnimate( "obj_chest_open", "alp", 0, 0, func_after, 
  {
    0.0,0,0,
    1.1,0,0,
    1.5,0,1
  });

  ObjAnimate( "spr_chest_note_big", "alp", 0, 0, func_aud_after,
  { 
    0.0, 0, 1.0, 
    0.7, 3, 1.0,
    1.1, 3, 0.0
  } );

end;
----------------------------------------------------------------
function private.Win_setofdrawers()

  common_impl.Lock(true);
  local func_after = function ()

    common_impl.Lock(false);
    PlaySfx( "assets/levels/common/audio/aud_mg_win", 0, 0 );
    cmn.MiniGameHide( "setofdrawers" );
    cmn.SetEventDone( "win_setofdrawers" );
    cmn.CallEventHandler( "win_setofdrawers" );
    common_impl.PassingMgWin( "setofdrawers" )

  end;
    
    ObjSet( "spr_setofdrawers_figurine", { input = true, visible = true, active = true } );
    ObjSet( "spr_setofdrawers_magnifier", { input = true, visible = true, active = true  } );
    ObjSet( "obj_setofdrawers_diary", { input = true, visible = true, active = true} );

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_clock_win", 0, "", 0 );
    ObjAnimate( "obj_setofdrawers_clock_open", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.5, 0, 1.0
    } );

    ObjAnimate( "spr_setofdrawers_figurine", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.5, 0, 1.0
    } );

    ObjAnimate( "obj_setofdrawers_clock", "alp", 0, 0, "",
    { 
      1.0, 0, 0.0, 
      0.5, 0, 0.0

    } );

    ObjAnimate( "spr_setofdrawers_magnifier", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.5, 0, 1.0
    } );

    ObjAnimate( "obj_setofdrawers_diary", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.5, 0, 1.0
    } );

    ObjAnimate( "spr_setofdrawers_magnifier_shadow", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.5, 0, 1.0
    } );

    ObjAnimate( "spr_setofdrawers_figurine_shadow", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.5, 0, 1.0
    } );

end;
-----------------------------------------------------------------
function public.Reset( event )

  if cmn.IsEventDone( "use_chestpiece" ) and not cmn.IsEventDone( "win_chest" ) then
  
    for i = 1,12 do

      ng_global.progress[ "std" ] [ "win_chest" ].current_pos[ i ] = private.start_mas[ i ];

    end;

    private.LoadChestPeaceState();

  end;

  if cmn.IsEventDone( "use_clockhands" ) and not cmn.IsEventDone( "win_setofdrawers" ) then

    ng_global.progress["std"]["win_setofdrawers"].arrows = {0,-8};

    ObjSet("spr_setofdrawers_clockhands_1", {ang = -2.13});
    ObjSet("spr_setofdrawers_clockhands_2", {ang = -6.9});
    
  end;
  

end;
-----------------------------------------------------------------
function public.Skip( event ) 

  if cmn.IsEventDone( "use_chestpiece" ) and not cmn.IsEventDone( "win_chest" ) then

    local start_pos_x = -169;
    local start_pos_y = -108;
    local step_x = 112;
    local step_y = 109;
    local number = 1;

    common_impl.Lock(true);

    ObjAnimate( "spr_chest_note_big", "alp", 0, 0, private.Win, {0,0,1,  1,0,1});

    for i = 1,12 do

      local line = math.floor ( ( i - 1 )/4 )
      local col = ( i - 1 ) % 4;
      local obj_get = ObjGet( "spr_chest_mmg_part_"..i )

      ObjAnimate( "spr_chest_mmg_part_"..i, "pos_xy", 0, 0, "", 
      { 
        0, 1, obj_get.pos_x,              obj_get.pos_y,
        1, 1, start_pos_x + col * step_x, start_pos_y + line * step_y
      } );

    end;

  end;

  
  if cmn.IsEventDone( "use_clockhands" ) and not cmn.IsEventDone( "win_setofdrawers" ) then

    common_impl.Lock(true);
    ObjAnimate("spr_setofdrawers_clockhands_2", "ang", 0, 0, private.Win_setofdrawers, {0, 3, ObjGet("spr_setofdrawers_clockhands_2").ang,   1, 3, 0});
    ObjAnimate("spr_setofdrawers_clockhands_1", "ang", 0, 0, "", {0, 3, ObjGet("spr_setofdrawers_clockhands_1").ang,   1, 3, 0});

  end;

end;
-------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------
function private.OpenChestMemo()


  if ( not ng_global.progress[ "std" ] [ "win_chest" ].current_pos ) then

    ng_global.progress[ "std" ] [ "win_chest" ].current_pos = {}

    for i = 1,12 do

      ng_global.progress[ "std" ] [ "win_chest" ].current_pos[ i ] = private.start_mas[ i ];

    end;

    private.LoadChestPeaceState();

  end;


  common_impl.Lock(true);
  
  local func_end = function ()

    common_impl.Lock(false);
    ObjSet( "spr_chest_note_big", { input = true } );
    cmn.MiniGameShow( 'chest' );
    common_impl.PassingMgStart( "chest" )

  end;

  ObjAnimate( "spr_chest_note_big", "alp", 0, 0, func_end, 
  { 
    0,3,0,
    0.4,3,1
  } );

end;
-------------------------------------------------------------------------------------
function private.CloseChestMemo()


  common_impl.Lock(true);
  local func_end = function ()

    common_impl.Lock(false);
    ObjSet( "spr_chest_note_big", { input = false } );
    cmn.MiniGameHide( 'chest' );
    common_impl.PassingMgStop( "chest" )

  end;

  ObjAnimate( "spr_chest_note_big", "alp", 0, 0, func_end, 
  { 
    0,3,1,
    0.4,3,0
  } );

end;
-------------------------------------------------------------------------------------
function private.TurnChestMemo()

  --common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page", 0, "", 0 );
  common_impl.ShowBbt( 'bbt_chest_clk_drawings', 1 );

end;
----------------------------------------------------------------
function private.CheckWin_setofdrawers()

  if ng_global.progress["std"]["win_setofdrawers"].arrows[1] == -8 and ng_global.progress["std"]["win_setofdrawers"].arrows[2] == -7 then
    private.Win_setofdrawers();
  end;

end;
-----------------------------------------------------------------------------------
--********************************************************************************************************************
function private.Init_Subroom()
  
  common_impl.hint.position_slider[ "gzz_office_setofdrawers" ] = { "mid" };
  common_impl.hint.position_slider[ "gzz_office_floor" ] = { "right" };
  common_impl.hint.position_slider[ "gzz_office_chest" ] = { "mid" };

  subroom.Define( "zz_chest" );

  function zz_chest.PreOpen()

    if cmn.IsEventDone( "use_chestpiece" ) and not cmn.IsEventDone( "win_chest" ) then

      ObjSet( "obj_chest_clk_mmg", { input = 1 } );
      ObjSet( "spr_chest_note_big", { alp = 0, input = 0 } );

    end;

  end;

  function zz_chest.Close()

    if ( ObjGet( "spr_chest_note_big" ) ) and ( ObjGet( "spr_chest_note_big" ).input ) then

      ObjSet( "spr_chest_note_big", { input = false, alp = 0 } );

    end;

  end;

  function zz_chest.PreClose()

    if cmn.IsEventDone( "use_chestpiece" ) and not cmn.IsEventDone( "win_chest" )
    and ObjGet( "spr_chest_note_big" ) and  ObjGet( "spr_chest_note_big" ).input then

      cmn.MiniGameHide( 'chest' );
      common_impl.PassingMgStop( "chest" )

    end;

  end;

  subroom.Define( "zz_setofdrawers" );
  
  function zz_setofdrawers.PreOpen()

    if ( not ng_global.progress["std"]["win_setofdrawers"].arrows ) then
 
      ng_global.progress["std"]["win_setofdrawers"].arrows = {0,-8};

    end;

    if ( cmn.IsEventDone( "use_clockhands" )) and not cmn.IsEventDone( "win_setofdrawers" ) then
    
      cmn.MiniGameShow( 'setofdrawers' );
      common_impl.PassingMgStart( "setofdrawers" )
      
    end;

  end;

  function zz_setofdrawers.PreClose()

    if ( cmn.IsEventDone( "use_clockhands" )) and not cmn.IsEventDone( "win_setofdrawers" ) then

      cmn.MiniGameHide( 'setofdrawers' );
      common_impl.PassingMgStop( "setofdrawers" )

    end;

  end;

end;
--********************************************************************************************************************
function private.Init_Mg_Wall ()
  
  private.password = { 3, 1, 4, 2 };
  private.current_symbol = 1;

  for i = 1, 4 do

    ObjSet( "spr_office_brick_"..i, 
    {
      event_mdown = function () private.clk_office_brick( i ); end,
      event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end
    } )

  end;
  ObjAttach( "obj_office_hint", "spr_office_brick_"..private.password[ 1 ] );

  function private.clk_office_brick ( id )

    if ( id == private.password[ private.current_symbol ] ) then

      private.current_symbol = private.current_symbol + 1;
      ObjSet( "spr_office_brick_"..id, { alp = 0, input = false } );

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_wall_true", 0, "", 0 );

      if ( private.current_symbol == 5 ) then
        private.win_mg_wall();
      else
        ObjAttach( "obj_office_hint", "spr_office_brick_"..private.password[ private.current_symbol ] );
      end;      

    else

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_wall_wrong", 0, "", 0 );

      for i = 1, 4 do
        ObjSet( "spr_office_brick_"..i, { alp = 1, input = true } );
      end;
      private.current_symbol = 1;
      ObjAttach( "obj_office_hint", "spr_office_brick_"..private.password[ 1 ] );

    end;

  end;

  function private.win_mg_wall()

    local func_end = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "win_mg_wall" );
      cmn.CallEventHandler( "win_mg_wall" );

    end;

    local func_after = function ()

      local tmr_after = function ()

        common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_out", 0, "", 0 ); 

      end;
      ObjSet( "tmr_office_zoomout_basement", {playing = true, time = 1.4, endtrig = tmr_after } );
      common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_in", 0, "", 0 );
      ObjAnimate( "rm_office", "scale_xy", 0, 0, "",
      { 
        0.0, 1, 1.0,1.0, 
        1.0, 0, 1.3,1.3,
        1.4, 0, 1.3,1.3,
        2.4, 3, 1.0,1.0

      } );
      
      ObjAnimate( "rm_office", "pos_xy", 0, 0, func_end,
      { 
        0.0, 1, 0.0,0.0, 
        1.0, 0, -300,-250,
        1.4, 0, -300,-250,
        2.4, 3, 0,0
      } );

    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_wall_click", 0, "", 0 );

    ObjSet( "vid_office_wall", { alp = 1 } );
    ObjSet( "obj_office_over", { alp = 0 } );

    VidPlay( "vid_office_wall", func_after );

  end;

end;
--*********************************************************************************************************************
function private.Init_Anims ()

  ObjAnimate( "spr_office_light_window", "alp", 1, 0, "",
  { 
    0.0, 0, 1.0, 
    1.3, 0, 0.5,
    2.6, 0, 1.0
  } );

  ObjAnimate( "spr_office_lamplight", "alp", 1, 0, "",
  { 
    0.0, 0, 1.0, 
    0.6, 0, 0.5,
    1.2, 0, 1.0
  } );

  ObjAnimate( "spr_office_chandelier", "ang", 1, 0, "",
  { 
    0.0, 3, -0.1, 
    3.0, 3, 0.1,
    6.0, 3, -0.1
  } );

end;
