-- name=rm_pier
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_pier";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_hut", "room_hub" );
  ObjAttach( "zz_storage", "room_hub" );
  ObjAttach( "zz_gates", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet( {
    { "spr_hut_hoisthandle", { event_mdown = private.get_hoisthandle } },
    { "spr_hut_oilcan", { event_mdown = private.get_oilcan } },
    { "spr_gates_emblemelement1", { event_mdown = private.get_emblemelement1 } },    
    { "spr_gates_corkscrew", { event_mdown = private.get_corkscrew } },
    { "vid_pier_elf", { event_mdown = private.get_elf } },
    { "obj_storage_clk_heck", { event_mdown = function () private.clk_heck(); end } },
    { "obj_storage_use_oilcan", { event_mdown = function () private.clk_grille() end } },
    { "obj_storage_clk_hoisthandle", { event_mdown = function () private.clk_hoisthandle() end } },
    { "obj_storage_clk_stock", { event_mdown = function() common_impl.ShowBbt( 'bbt_storage_clk_stock' ); end } },
    { "obj_gates_use_workinggasolinesaw", { event_mdown = function () private.clk_latch(); common_impl.ShowBbt( 'bbt_use_workinggasolinesaw' ); end } },    
    { "obj_pier_clk_poster", { event_mdown = function () common_impl.NoteScale( "open", "spr_pier_poster" ); common_impl.ShowBbt( 'bbt_pier_clk_poster', 1 ); end } },    
    { "spr_pier_poster_big", { event_mdown = function () common_impl.NoteScale( "close", "spr_pier_poster" ) end } },    
    { "spr_pier_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_1_1" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_pier_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_1" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
 } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_pier = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gho_pier_stock",
      "gmg_pier_uppershelf",
      "gzz_pier_hut",
      "gzz_pier_storage",
      "gzz_pier_gates"
    }
    for i = 1, #gates do
    
      local name = gates[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 

      {
        private.room_objname,
        "zz_hut",
        "zz_storage",
        "zz_gates"
      
      };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_pier", update_game_mode_pier, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_pier = function ()
    
    local effects_table = 
    {
      "obj_pier_anim" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;
    
    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_pier", update_performance_mode_pier, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_pier () end;
  --------------------------------------------------------------------------------------------
  local opn_pier_map = function ()

    common_impl.VisitMapRoom( "pier" );

  end;

  local opn_pier_end = function ()

    ObjMultiSet({
      { "vid_pier_elf", { input = true, alp = 1 } },
      { "vid_pier_elf_sh", { alp = 1 } },
    }); 
     
    ObjDelete( "vid_pier_elf_going" );

  end;

  cmn.AddSubscriber( "opn_pier", opn_pier_map, nil );
  cmn.AddSubscriber( "opn_pier_map", opn_pier_map, nil );
  cmn.AddSubscriber( "opn_pier", opn_pier_end, private.room_objname );
  cmn.AddSubscriber( "opn_pier_end", opn_pier_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hoisthandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hoisthandle" ] = {
    type = "get",
    get_obj = "spr_hut_hoisthandle",
    room = private.room_objname,
    zz = "zz_hut",
    zz_gate = "gzz_pier_hut"
  };
  local get_hoisthandle_inv = function ()
  
    interface.InventoryItemAdd( "inv_hoisthandle", "spr_hut_hoisthandle" );
  
  end;
  
  local get_hoisthandle_closezz = function ()
  
    ObjDelete( "gfx_hut_hoisthandle" );
    ObjDelete( "spr_hut_hoisthandle_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_hoisthandle", get_hoisthandle_inv );
  cmn.AddSubscriber( "get_hoisthandle", get_hoisthandle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_oilcan () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_oilcan" ] = {
    type = "get",
    get_obj = "spr_hut_oilcan",
    room = private.room_objname,
    zz = "zz_hut",
    zz_gate = "gzz_pier_hut"
  };
  local get_oilcan_inv = function ()
  
    interface.InventoryItemAdd( "inv_oilcan", "spr_hut_oilcan" );
  
  end;
  
  local get_oilcan_closezz = function ()
  
    ObjDelete( "gfx_hut_oilcan" ); 
    ObjDelete( "spr_hut_oilcan_shadow" );
    ObjDelete( "spr_pier_oiler" );
  end;
  
  cmn.AddSubscriber( "get_oilcan", get_oilcan_inv );
  cmn.AddSubscriber( "get_oilcan", get_oilcan_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_emblemelement1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_emblemelement1" ] = {
    type = "get",
    get_obj = "spr_gates_emblemelement1",
    room = private.room_objname,
    zz = "zz_gates",
    zz_gate = "gzz_pier_gates"
  };
  local get_emblemelement1_inv = function ()
  
    interface.InventoryItemAdd( "inv_emblemelement1", "spr_gates_emblemelement1" );
  
  end;
  
  local get_emblemelement1_closezz = function ()
  
    ObjDelete( "gfx_gates_emblemelement1" );
    ObjDelete( "spr_gates_emblemelement1_shadow" );
    ObjSet( "obj_gates_note", { input = true });
    ObjDelete("spr_pier_owl");
  end;
  
  cmn.AddSubscriber( "get_emblemelement1", get_emblemelement1_inv );
  cmn.AddSubscriber( "get_emblemelement1", get_emblemelement1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_corkscrew () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_corkscrew" ] = {
    type = "get",
    get_obj = "spr_gates_corkscrew",
    room = private.room_objname,
    zz = "zz_gates",
    zz_gate = "gzz_pier_gates"
  };
  local get_corkscrew_inv = function ()
  
    interface.InventoryItemAdd( "inv_corkscrew", "spr_gates_corkscrew" );
  
  end;
  
  local get_corkscrew_closezz = function ()
    ObjDelete("spr_pier_corkscrew");
    ObjDelete( "gfx_gates_corkscrew" );
    ObjDelete( "spr_gates_corkscrew_shadow" );
    ObjDelete( "spr_gates_corkscrew_over" );

  end;
  
  cmn.AddSubscriber( "get_corkscrew", get_corkscrew_inv );
  cmn.AddSubscriber( "get_corkscrew", get_corkscrew_closezz, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function get_elf () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_elf" ] = {
    type = "get",
    get_obj = "vid_pier_elf",
    room = private.room_objname
  };
  local get_elf_inv = function ()
  
    interface.InventoryItemAdd( "inv_elf", "vid_pier_elf" );
  
  end;
  
  local get_elf_closezz = function ()
  
    ObjDelete( "gfx_pier_elf" );
    ObjDelete( "vid_pier_elf_sh" );
  end;
  
  cmn.AddSubscriber( "get_elf", get_elf_inv );
  cmn.AddSubscriber( "get_elf", get_elf_closezz, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function get_collect_item_1_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_1_1 = function ()
  
    ObjDelete( "obj_pier_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_1_1", get_collect_item_1_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_1 = function ()
  
    ObjDelete( "obj_pier_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_1", get_collect_morph_item_1_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_1" ] = {
      type = "use",
      inv_obj = "inv_elf",
      use_place = "obj_hut_use_elf",
      room = private.room_objname,
      zz = "zz_hut",
      zz_gate = "gzz_pier_hut"
  };
  local use_elf_1_beg = function ()
  
    ObjDelete( "obj_hut_use_elf" );
  
  end;
  local use_elf_1_end = function ()

   ObjDelete( "vid_hut_use_elf" ); 
   ObjMultiSet( {

    {  "obj_hut_hoisthandle", { input = true, alp = 1 }},
    {  "gfx_hut_hoisthandle", { active = true } },
    } );
    ObjDelete("spr_pier_eyes");
    ObjDelete( "spr_hut_eye_add" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_1", use_elf_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_1", use_elf_1_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_1_beg", use_elf_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_1_end", use_elf_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_emblemelement1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_emblemelement1" ] = {
      type = "use",
      inv_obj = "inv_emblemelement1",
      use_place = "obj_hut_use_emblemelement",
      room = private.room_objname,
      zz = "zz_hut",
      zz_gate = "gzz_pier_hut"
  };
  local use_emblemelement1_inv = function ()
  
    interface.InventoryItemRemove( "inv_emblemelement1" );
  
  end;
  local use_emblemelement1_beg = function ()

    if ( cmn.IsEventDone( "use_emblemelement2") and cmn.IsEventDone( "use_emblemelement3")) then
      ObjDelete( "obj_hut_use_emblemelement" );
    end;
  
  end;
  local use_emblemelement1_end = function ()
  
    ObjMultiSet({
    { "spr_hut_owl_1", { alp = 1 }},
    { "spr_pier_owl_2", { alp = 1 }}, 
    });
    
    if ( cmn.IsEventDone( "use_emblemelement2") and cmn.IsEventDone( "use_emblemelement3")) then

      ObjDelete( "gzz_pier_hut" );
      ObjMultiSet({
        {"gmg_pier_uppershelf", { input = true, active = true }},
        {"spr_hut_cover_up", { alp = 1 }},
        {"spr_pier_mg", { alp = 1 }}
      });
      ObjDelete( "spr_hut_cover" );
      ObjDelete("spr_pier_door");
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_emblemelement1", use_emblemelement1_beg, private.room_objname );
  cmn.AddSubscriber( "use_emblemelement1", use_emblemelement1_inv );
  cmn.AddSubscriber( "use_emblemelement1", use_emblemelement1_end, private.room_objname );
  cmn.AddSubscriber( "use_emblemelement1_inv", use_emblemelement1_inv, private.room_objname );
  cmn.AddSubscriber( "use_emblemelement1_beg", use_emblemelement1_beg, private.room_objname );
  cmn.AddSubscriber( "use_emblemelement1_end", use_emblemelement1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_emblemelement2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_emblemelement2" ] = {
      type = "use",
      inv_obj = "inv_emblemelement2",
      use_place = "obj_hut_use_emblemelement",
      room = private.room_objname,
      zz = "zz_hut",
      zz_gate = "gzz_pier_hut"
  };
  local use_emblemelement2_inv = function ()
  
    interface.InventoryItemRemove( "inv_emblemelement2" );
  
  end;
  local use_emblemelement2_beg = function ()
  
    if ( cmn.IsEventDone( "use_emblemelement1") and cmn.IsEventDone( "use_emblemelement3")) then
      ObjDelete( "obj_hut_use_emblemelement" );
    end;
  
  end;
  local use_emblemelement2_end = function ()
  
    ObjMultiSet({
    { "spr_hut_owl_2", { alp = 1 }},
    { "spr_pier_wing_1", { alp = 1 }},
    });
    
    if ( cmn.IsEventDone( "use_emblemelement1") and cmn.IsEventDone( "use_emblemelement3")) then

      
      ObjDelete( "gzz_pier_hut" );
      ObjMultiSet({
        {"gmg_pier_uppershelf", { input = true, active = true } },
        {"spr_hut_cover_up", { alp = 1 }},
        {"spr_pier_mg", { alp = 1 }}
      });

      ObjDelete( "spr_hut_cover" );
      ObjDelete("spr_pier_door");
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_emblemelement2", use_emblemelement2_beg, private.room_objname );
  cmn.AddSubscriber( "use_emblemelement2", use_emblemelement2_inv );
  cmn.AddSubscriber( "use_emblemelement2", use_emblemelement2_end, private.room_objname );
  cmn.AddSubscriber( "use_emblemelement2_inv", use_emblemelement2_inv, private.room_objname );
  cmn.AddSubscriber( "use_emblemelement2_beg", use_emblemelement2_beg, private.room_objname );
  cmn.AddSubscriber( "use_emblemelement2_end", use_emblemelement2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_emblemelement3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_emblemelement3" ] = {
      type = "use",
      inv_obj = "inv_emblemelement3",
      use_place = "obj_hut_use_emblemelement",
      room = private.room_objname,
      zz = "zz_hut",
      zz_gate = "gzz_pier_hut"
  };
  local use_emblemelement3_inv = function ()
  
    interface.InventoryItemRemove( "inv_emblemelement3" );
  
  end;
  local use_emblemelement3_beg = function ()
  
    if ( cmn.IsEventDone( "use_emblemelement1") and cmn.IsEventDone( "use_emblemelement2")) then
      ObjDelete( "obj_hut_use_emblemelement" );
    end;
  
  end;
  local use_emblemelement3_end = function ()
  
    ObjMultiSet({
    { "spr_hut_owl_3", { alp = 1 }},
    { "spr_pier_wing_2", { alp = 1 }},
    });
    
    
    if ( cmn.IsEventDone( "use_emblemelement1") and cmn.IsEventDone( "use_emblemelement2")) then
      
      ObjDelete( "gzz_pier_hut" );
      ObjMultiSet({
        {"gmg_pier_uppershelf", { input = true, active = true }},
        {"spr_hut_cover_up", { alp = 1 }},
        {"spr_pier_mg", { alp = 1 }}
      });
      ObjDelete( "spr_hut_cover" );
      ObjDelete("spr_pier_door");
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_emblemelement3", use_emblemelement3_beg, private.room_objname );
  cmn.AddSubscriber( "use_emblemelement3", use_emblemelement3_inv );
  cmn.AddSubscriber( "use_emblemelement3", use_emblemelement3_end, private.room_objname );
  cmn.AddSubscriber( "use_emblemelement3_inv", use_emblemelement3_inv, private.room_objname );
  cmn.AddSubscriber( "use_emblemelement3_beg", use_emblemelement3_beg, private.room_objname );
  cmn.AddSubscriber( "use_emblemelement3_end", use_emblemelement3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hoisthandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hoisthandle" ] = {
      type = "use",
      inv_obj = "inv_hoisthandle",
      use_place = "obj_storage_use_hoisthandle",
      room = private.room_objname,
      zz = "zz_storage",
      zz_gate = "gzz_pier_storage"
  };
  local use_hoisthandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_hoisthandle" );
  
  end;
  local use_hoisthandle_beg = function ()
  
    ObjDelete( "obj_storage_use_hoisthandle" );
  
  end;
  local use_hoisthandle_end = function ()

    ObjMultiSet({
      {"obj_storage_clk_hoisthandle", { input = true }},
      {"spr_storage_handle", { alp = 1 }},
      {"spr_pier_handle", { alp = 1 }},
    });


  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hoisthandle", use_hoisthandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_hoisthandle", use_hoisthandle_inv );
  cmn.AddSubscriber( "use_hoisthandle", use_hoisthandle_end, private.room_objname );
  cmn.AddSubscriber( "use_hoisthandle_inv", use_hoisthandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_hoisthandle_beg", use_hoisthandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_hoisthandle_end", use_hoisthandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_oilcan_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_oilcan_1" ] = {
      type = "use",
      inv_obj = "inv_oilcan",
      use_place = "obj_storage_use_oilcan",
      room = private.room_objname,
      zz = "zz_storage",
      zz_gate = "gzz_pier_storage"
  };
  local use_oilcan_1_beg = function ()
  
    ObjDelete( "obj_storage_use_oilcan" );
  
  end;
  local use_oilcan_1_end = function ()
  
    ObjSet( "obj_storage_clk_heck", { input = true, visible = true } ); 
    ObjDelete( "spr_storage_rust" );
    ObjDelete( "spr_storage_oiler" );
    ObjDelete( "spr_storage_oil" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_oilcan_1", use_oilcan_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_oilcan_1", use_oilcan_1_end, private.room_objname );
  cmn.AddSubscriber( "use_oilcan_1_beg", use_oilcan_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_oilcan_1_end", use_oilcan_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_workinggasolinesaw () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_workinggasolinesaw" ] = {
      type = "use",
      inv_obj = "inv_workinggasolinesaw",
      use_place = "obj_gates_use_workinggasolinesaw",
      room = private.room_objname,
      zz = "zz_gates",
      zz_gate = "gzz_pier_gates"
  };
  local use_workinggasolinesaw_inv = function ()
  
    interface.InventoryItemRemove( "inv_workinggasolinesaw" );
    
  end;
  local use_workinggasolinesaw_beg = function ()
  
    ObjDelete( "obj_gates_use_workinggasolinesaw" );
    ObjDelete( "obj_gates_timber" );
  
  end;
  local use_workinggasolinesaw_end = function ()
  
    ObjDelete( "gzz_pier_gates" );
    ObjMultiSet({
    { "grm_pier_fork", { input = true, active = true}}, 
    { "spr_pier_open_gate", { alp = 1}},    
    } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_pier_fork_focus");
    end;    
    ObjDelete( "spr_gates_saw" );
    ObjDelete("spr_pier_closed_gate");
  end;

  local use_workinggasolinesaw_end_inv = function ()

    interface.InventoryItemAdd( "inv_brokengasolinesaw");
    ObjSet( "inv_brokengasolinesaw", { drag = false });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_workinggasolinesaw", use_workinggasolinesaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_workinggasolinesaw", use_workinggasolinesaw_inv );
  cmn.AddSubscriber( "use_workinggasolinesaw", use_workinggasolinesaw_end_inv );
  cmn.AddSubscriber( "use_workinggasolinesaw", use_workinggasolinesaw_end, private.room_objname );
  cmn.AddSubscriber( "use_workinggasolinesaw_inv", use_workinggasolinesaw_inv, private.room_objname );
  cmn.AddSubscriber( "use_workinggasolinesaw_end_inv", use_workinggasolinesaw_end_inv, private.room_objname );
  cmn.AddSubscriber( "use_workinggasolinesaw_beg", use_workinggasolinesaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_workinggasolinesaw_end", use_workinggasolinesaw_end, private.room_objname );

 --------------------------------------------------------------------------------------------
  -- function clk_heck () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_heck" ] = {
    type = "click",
    use_place = "obj_storage_clk_heck",
    room = private.room_objname,
    zz = "zz_storage",
    zz_gate = "gzz_pier_storage"    
  };

  local clk_heck_beg = function ()
  
    ObjDelete( "obj_storage_clk_heck" );
  
  end;
  local clk_heck_end = function ()
  
    ObjMultiSet({
    { "obj_storage_use_hoisthandle", { input = true, visible = true }},
    { "spr_pier_grille_2", { alp = 1}},
    { "spr_storage_over_open", { alp = 1 }},
    });
     
    ObjDelete( "spr_storage_over" );
    ObjDelete( "obj_storage_latch" );
    ObjDelete( "obj_storage_heck" );
    ObjDelete("spr_pier_grille_1");
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_heck", clk_heck_beg, private.room_objname );
  cmn.AddSubscriber( "clk_heck", clk_heck_end, private.room_objname );
  cmn.AddSubscriber( "clk_heck_beg", clk_heck_beg, private.room_objname );
  cmn.AddSubscriber( "clk_heck_end", clk_heck_end, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function clk_hoisthandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_hoisthandle" ] = {
    type = "click",
    use_place = "obj_storage_clk_hoisthandle",
    room = private.room_objname,
    zz = "zz_storage",
    zz_gate = "gzz_pier_storage"    
  };

  local clk_hoisthandle_beg = function ()
  
    ObjDelete( "obj_storage_clk_hoisthandle" );
  
  end;
  local clk_hoisthandle_end = function ()
  
    ObjMultiSet({ 
    {"gho_pier_stock", { input = true, active = true }},
    {"spr_pier_boat_1", { alp = 1 }},
    {"spr_pier_ho", { alp = 1 }}, 
    } ); 
    ObjDelete( "gzz_pier_storage" );
    ObjDelete("spr_pier_boat_2");
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_hoisthandle", clk_hoisthandle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_hoisthandle", clk_hoisthandle_end, private.room_objname );
  cmn.AddSubscriber( "clk_hoisthandle_beg", clk_hoisthandle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_hoisthandle_end", clk_hoisthandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  local get_evidence_1_3_pier = function ()

    ObjDelete( "gmg_pier_uppershelf" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_evidence_1_3", get_evidence_1_3_pier, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_intro () end;
  --------------------------------------------------------------------------------------------
  local see_intro = function ()

    ObjSet( "rm_pier", { color_r = 1, color_g = 1, color_b = 1 } );

  end;

  cmn.AddSubscriber( "see_intro", see_intro, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load()
  
  ObjAnimate("obj_storage_boat", "ang", 1, 0, "", { 0, 3, -0.01,     1.5, 3, 0.01,    3, 3, -0.01 });

end;
--********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_hut" );
  
  function zz_hut.PreOpen()

    if cmn.IsEventDone( "get_elf" ) and not cmn.IsEventDone( "use_elf_1" ) then

      common_impl.TutorialShow("tutorial_page_4");

    end;

  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_pier();

  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

  if not( cmn.IsEventDone("use_elf_1") ) then

      ObjAnimate( "spr_hut_eye_add", "alp", 1, 0, "",
      { 
        0.0, 0, 1.0, 
        0.5, 0, 0.5,
        1.0, 0, 1.0
      } ); 
 
  end;

  ObjAnimate( "spr_gates_light", "alp", 1, 0, "",
  { 
    0.0, 0, 1.0, 
    0.5, 0, 0.5,
    1.0, 0, 1.0
  } );

  if cmn.IsEventDone( "win_stock" ) and not cmn.IsEventDone( "use_oilcan_2" ) then

    common_impl.TutorialShow( "tutorial_page_8" );

  end;

  if not cmn.IsEventDone( "get_elf" ) and cmn.IsEventDone( "opn_pier" ) then

    common_impl.PlayAudio( "env", "common/audio/aud_elf_stat", 1, "", 0.5 );

  end;

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();

  if ( not cmn.IsEventDone( "see_intro" ) ) then
    
     
    
    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 0 );

    end;

    ObjSet( "rm_pier", { color_r = 0, color_g = 0, color_b = 0 } );
    ObjAttach( "tmr_pier_intro", private.room_objname);
    ObjSet( "tmr_pier_intro",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.SeeIntro(); end
    } );

  else

    common_impl.EnvPlay( { "common/audio/aud_pier_env" }, "", 0.5 );

  end;

  ObjSet( "spr_pier_poster_big", { input = 0, alp = 0 } );
  ObjSet( "spr_pier_poster", { alp = 1 } );
  if common_impl.pier then

    common_impl.pier.note = "close";

  else 

    common_impl.pier = {}
    common_impl.pier.note = "close";

  end;

  if cmn.IsEventDone( "get_evidence_1_1" ) then

    interface.InvestigationButtonCheck();

  end;

end;
--*********************************************************************************************************************
function public.Close()
  --common_impl.StopAudio( "env", "common/audio/aud_pier_env", 0.2 );
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_elf()

  local item = "inv_elf";

  if ( common.ApplyObj( item, "obj_hut_use_elf", true ) and not cmn.IsEventDone( "use_elf_1" ) ) then

    cmn.CallEventHandler( "use_elf_1_beg" );
    interface.InventoryItemRemove( "inv_elf" );
    local func_after = function ()

      common_impl.Lock(false);
      common_impl.TutorialSetShown("tutorial_page_4");
      cmn.SetEventDone( "use_elf_1" );
      cmn.CallEventHandler( "use_elf_1_end" );
      interface.InventoryItemAdd( "inv_elf" );
      ObjSet( "spr_hut_eye_add", { alp = 1, active = true; } );
      ObjSet( "spr_hut_elf", { alp = 1 } );
      interface.InventoryItemAdd( "inv_elf", "spr_hut_elf" );

    end;

  interface.InventoryItemRemove( "inv_elf" );
  common_impl.Lock(true);
  ObjAnimate("spr_hut_eye_add", "alp", 0, 0, "",  { 0, 3, ObjGet( "spr_hut_eye_add" ).alp,    3.3, 3, 1,    3.6, 3, 0});

  VidPlay( "vid_hut_use_elf", func_after );
  common_impl.PlayAudio( "sfx", "common/audio/aud_hut_elf", 0, "", 0 );    

  return true;

  elseif common.ApplyObj( item, "gzz_pier_hut", false ) and not cmn.IsEventDone( "use_elf_1" ) and common_impl.pier.note == "close" then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_hut", nil, { 512, 384 } )

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_emblemelement1()

  local item = "inv_emblemelement1";


  if ( common.ApplyObj( item, "obj_hut_use_emblemelement", true ) ) then

    cmn.CallEventHandler( "use_emblemelement1_inv" );
    cmn.CallEventHandler( "use_emblemelement1_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_emblemelement1" );
      cmn.CallEventHandler( "use_emblemelement1_end" );
      if ( cmn.IsEventDone( "use_emblemelement3") and cmn.IsEventDone( "use_emblemelement2")) then
        common.CloseSubRoom();
        cmn.GotoRoom( 'mg_uppershelf' );
      end;
      
    end;

    common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_owl_part", 0, "", 0.2 );

    if ( cmn.IsEventDone( "use_emblemelement3") and cmn.IsEventDone( "use_emblemelement2")) then

      ObjAnimate( "spr_hut_owl_1", "alp", 0, 0, "*common_impl.PlayAudio( 'sfx', 'common/audio/aud_owl_open', 0, '', 0.2 );",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      ObjAnimate( "spr_hut_cover", "alp", 0, 0, func_after,
      { 
        0.0, 0, 1, 
        0.3, 0, 1, 
        0.6, 0, 0
      } );

      ObjAnimate( "spr_hut_cover_up", "alp", 0, 0, "",
      { 
        0.0, 0, 0, 
        0.3, 0, 0, 
        0.6, 0, 1
      } );

    else 

      ObjAnimate( "spr_hut_owl_1", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

    end;

  elseif common.ApplyObj( item, "gzz_pier_hut", false ) and common_impl.pier.note == "close" then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_hut", nil, { 512, 384 } )

  else

    common_impl.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_emblemelement2()

  local item = "inv_emblemelement2";

  if ( common.ApplyObj( item, "obj_hut_use_emblemelement", true ) ) then

    cmn.CallEventHandler( "use_emblemelement2_inv" );
    cmn.CallEventHandler( "use_emblemelement2_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_emblemelement2" );
      cmn.CallEventHandler( "use_emblemelement2_end" );
      if ( cmn.IsEventDone( "use_emblemelement1") and cmn.IsEventDone( "use_emblemelement3")) then
        common.CloseSubRoom();
        cmn.GotoRoom( 'mg_uppershelf' );
      end;

    end;

    common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_owl_part", 0, "", 0.2 );

    if ( cmn.IsEventDone( "use_emblemelement1") and cmn.IsEventDone( "use_emblemelement3")) then

      ObjAnimate( "spr_hut_owl_2", "alp", 0, 0, "*common_impl.PlayAudio( 'sfx', 'common/audio/aud_owl_open', 0, '', 0.2 );",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      ObjAnimate( "spr_hut_cover", "alp", 0, 0, func_after,
      { 
        0.0, 0, 1, 
        0.3, 0, 1, 
        0.6, 0, 0
      } );

      ObjAnimate( "spr_hut_cover_up", "alp", 0, 0, "",
      { 
        0.0, 0, 0, 
        0.3, 0, 0, 
        0.6, 0, 1
      } );

    else 

      ObjAnimate( "spr_hut_owl_2", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

    end;

  elseif common.ApplyObj( item, "gzz_pier_hut", false ) and common_impl.pier.note == "close" then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_hut", nil, { 512, 384 } );

  else

    common_impl.WrongApply(); 

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_emblemelement3()

  local item = "inv_emblemelement3";

  if ( common.ApplyObj( item, "obj_hut_use_emblemelement", true ) ) and common_impl.pier.note == "close" then

    cmn.CallEventHandler( "use_emblemelement3_inv" );
    cmn.CallEventHandler( "use_emblemelement3_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_emblemelement3" );
      cmn.CallEventHandler( "use_emblemelement3_end" );
      if ( cmn.IsEventDone( "use_emblemelement1") and cmn.IsEventDone( "use_emblemelement2")) then
        common.CloseSubRoom();
        cmn.GotoRoom( 'mg_uppershelf' );
      end;

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_owl_part", 0, "", 0.2 );
    common_impl.Lock(true);

    if ( cmn.IsEventDone( "use_emblemelement1") and cmn.IsEventDone( "use_emblemelement2")) then


      ObjAnimate( "spr_hut_owl_3", "alp", 0, 0, "*common_impl.PlayAudio( 'sfx', 'common/audio/aud_owl_open', 0, '', 0.2 );",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      ObjAnimate( "spr_hut_cover", "alp", 0, 0, func_after,
      { 
        0.0, 0, 1, 
        0.3, 0, 1, 
        0.6, 0, 0
      } );

      ObjAnimate( "spr_hut_cover_up", "alp", 0, 0, "",
      { 
        0.0, 0, 0, 
        0.3, 0, 0, 
        0.6, 0, 1
      } );

    else

      ObjAnimate( "spr_hut_owl_3", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

    end;

  elseif common.ApplyObj( item, "gzz_pier_hut", false ) and common_impl.pier.note == "close" then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_hut", nil, { 512, 384 } );

  else

    common_impl.WrongApply(); 

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hoisthandle()

  local item = "inv_hoisthandle";

  if ( common.ApplyObj( item, "obj_storage_use_hoisthandle", true ) and cmn.IsEventDone("use_oilcan_1") and cmn.IsEventDone("clk_heck") ) then

    cmn.CallEventHandler( "use_hoisthandle_inv" );
    cmn.CallEventHandler( "use_hoisthandle_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_hoisthandle" );
      cmn.CallEventHandler( "use_hoisthandle_end" );

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_hoist_handle", 0, "", 0.5 );
    common_impl.Lock(true);

    ObjAnimate( "spr_storage_handle", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

  elseif common.ApplyObj( item, "gzz_pier_storage", false ) and cmn.IsEventDone("use_oilcan_1") and cmn.IsEventDone("clk_heck") and common_impl.pier.note == "close" then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_storage", nil, { 512, 384 } );
  
  else

    common_impl.WrongApply();  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_oilcan()

  
  local item = "inv_oilcan";

  if ( common.ApplyObj( item, "obj_storage_use_oilcan", true ) and not cmn.IsEventDone( "use_oilcan_1" ) ) then

    cmn.CallEventHandler( "use_oilcan_1_inv" );
    cmn.CallEventHandler( "use_oilcan_1_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_oilcan_1" );
      cmn.CallEventHandler( "use_oilcan_1_end" );
      cmn.CallEventHandler( "use_oilcan_1_add" );

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_oiler_cell", 0, "", 0.5 );
    common_impl.Lock(true);
    ObjAnimate( "spr_storage_oiler", "pos_xy", 0, 0, func_after,
    { 
      0.0, 0, -345, 21, 
      0.5, 0, -5, 55,
      1.2, 0, -5, 55,
      1.5, 0, -5, 55,
      2.0, 0, -345, 21
    } );

    ObjAnimate( "spr_storage_oil", "alp", 0, 0, "",
    { 
      0.0, 0, 0, 
      0.5, 0, 0,
      0.8, 0, 1,
      1.2, 0, 1,
      1.5, 0, 0
    } );

    ObjAnimate( "spr_storage_oil", "pos_y", 0, 0, "",
    { 
      0.0, 0, 83, 
      0.8, 0, 83,
      1.2, 0, 103
    } );

    ObjAnimate( "spr_storage_rust", "alp", 0, 0, "",
    { 
      0.0, 0, 1, 
      1.2, 0, 1,
      1.5, 0, 0
    } );

    return true;

  elseif common.ApplyObj( item, "gzz_pier_storage", false ) and not cmn.IsEventDone( "use_oilcan_1" ) and common_impl.pier.note == "close" then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_storage", nil, { 512, 384 } );
    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_workinggasolinesaw()

  local item = "inv_workinggasolinesaw";

  if common.ApplyObj( item, "gzz_pier_gates", false ) and cmn.IsEventDone( "get_corkscrew" ) and cmn.IsEventDone( "get_emblemelement1" ) and common_impl.pier.note == "close" then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_gates", nil, { 512, 384 } );

  elseif ( common.ApplyObj( item, "obj_gates_use_workinggasolinesaw", true ) and cmn.IsEventDone( "get_corkscrew" ) and cmn.IsEventDone( "get_emblemelement1" ) ) then

    cmn.CallEventHandler( "use_workinggasolinesaw_inv" );
    cmn.CallEventHandler( "use_workinggasolinesaw_beg" );

    local func_after = function ()

      common_impl.Lock(false );
      common_impl.PlayAudio( "sfx", "common/audio/aud_open_fork_gate", 0, "", 0 );
      cmn.SetEventDone( "use_workinggasolinesaw" );
      cmn.CallEventHandler( "use_workinggasolinesaw_end" );
      cmn.CallEventHandler( "use_workinggasolinesaw_end_inv" );
      common.CloseSubRoom();
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_gates_motorsaw", 0, "", 0 );

    ObjSet( "vid_gates_use_workinggasolinesaw", { alp = 1 } );
    VidPlay( "vid_gates_use_workinggasolinesaw", func_after );

  else

    common_impl.WrongApply(); 

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_hoisthandle()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hoisthandle" );
  cmn.CallEventHandler( "get_hoisthandle" );

end;
--------------------------------------------------------------------------------------------
function private.get_oilcan()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_oilcan" );
  cmn.CallEventHandler( "get_oilcan" );

end;
--------------------------------------------------------------------------------------------
function private.get_emblemelement1()

  iOS_RateMe();
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_emblemelement1" );
  cmn.CallEventHandler( "get_emblemelement1" );

end;
--------------------------------------------------------------------------------------------
function private.get_corkscrew()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_corkscrew" );
  cmn.CallEventHandler( "get_corkscrew" );

end;
--------------------------------------------------------------------------------------------
function private.get_elf()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  common_impl.TutorialShow( "tutorial_page_3" );

  common_impl.StopAudio( "env", "common/audio/aud_elf_stat", 0.2 );

  local page_content1 = {1, 1, 1};
  common_impl.AddBookmarkDiary( 1, 1, page_content1);
  cmn.SetEventDone( "get_elf" );
  cmn.CallEventHandler( "get_elf" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_heck()

  cmn.CallEventHandler( "clk_heck_beg" );

  local func_after = function ()

    common_impl.Lock(false);
    cmn.SetEventDone( "clk_heck" );
    cmn.CallEventHandler( "clk_heck_end" );
  
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_cell_door", 0, "", 0 );
  common_impl.Lock(true);

  ObjAnimate( "obj_storage_heck", "pos_xy", 0, 0, "", 
  { 
    0.0, 0, 105, 135, 
    0.3, 0, 105, 130
  } );
  
  ObjAnimate( "obj_storage_heck", "alp", 0, 0, "", 
  { 
    0.0, 0, 1, 
    0.3, 0, 1,
    0.6, 0, 0
  } );

  ObjAnimate( "obj_storage_latch", "alp", 0, 0, "", 
  { 
    0.0, 0, 1, 
    0.3, 0, 1,
    0.6, 0, 0
  } );
  
  ObjAnimate( "spr_storage_over_open", "alp", 0, 0, "", 
  { 
    0.0, 0, 0, 
    0.3, 0, 0,
    0.6, 0, 1
  } );

  ObjAnimate( "spr_storage_over", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1, 
    0.3, 0, 1,
    0.6, 0, 0
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_hoisthandle()

  cmn.CallEventHandler( "clk_hoisthandle_beg" );

  local func_after = function ()

    common_impl.Lock(false);
    cmn.SetEventDone( "clk_hoisthandle" );
    cmn.CallEventHandler( "clk_hoisthandle_end" );
    common.CloseSubRoom();
  
  end;

  common_impl.Lock(true);
  ObjSet( "obj_storage_boat", { alp = 0 });
  ObjSet( "spr_storage_cap_3", { alp = 0 } );
  ObjSet( "vid_storage_clk_handle", { alp = 1 });
  ObjSet( "spr_storage_handle", { alp = 0 });
  VidPlay( "vid_storage_clk_handle", func_after );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_hoist_handle", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.clk_latch()

  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_gate_plank", 0, "", 0 );
  local pos_x = ObjGet( "obj_gates_timber_parts" ).pos_x;
  ObjAnimate( "obj_gates_timber_parts", "pos_x", 0, 0, "",
  { 
    0.0, 0, pos_x, 
    0.3, 0, pos_x + 2,
    0.6, 0, pos_x
  } );

  pos_x = ObjGet( "obj_gates_corkscrew" ).pos_x;
  ObjAnimate( "obj_gates_corkscrew", "pos_x", 0, 0, "",
  { 
    0.0, 0, pos_x, 
    0.3, 0, pos_x + 2,
    0.6, 0, pos_x
  } );

  pos_x = ObjGet( "obj_gates_emblemelement1" ).pos_x;
  ObjAnimate( "obj_gates_emblemelement1", "pos_x", 0, 0, function() common_impl.Lock(false); end,
  { 
    0.0, 0, pos_x, 
    0.3, 0, pos_x + 2,
    0.6, 0, pos_x
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_grille()

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_small_metal", 0, "", 0 );

  common_impl.ShowBbt( 'bbt_storage_use_oilcan' );
  ObjAnimate("spr_storage_over", "pos_y", 0, 1, private.clk_grille_end, { 0, 3, 0,    0.15, 3, 1,    0.3, 3, 0});

  ObjAnimate("obj_storage_heck", "pos_y", 0, 1, "",                     { 0, 3, 0,    0.15, 3, 1,    0.3, 3, 0});
  ObjAnimate("obj_storage_latch", "pos_y", 0, 1, "",                    { 0, 3, 0,    0.15, 3, 1,    0.3, 3, 0});
  ObjAnimate("spr_storage_rust", "pos_y", 0, 1, "",                     { 0, 3, 0,    0.15, 3, 1,    0.3, 3, 0});
  common_impl.Lock(true);

end;
--------------------------------------------------------------------------------------------
function private.clk_grille_end()

  common_impl.Lock(false);

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_pier()

  local func_end = nil;
  if not ( cmn.IsEventDone( "opn_pier" ) ) then

    ObjSet( "obj_pier_gates", { input = false } );
    ObjSet( "obj_pier_clk_poster", { input = false } );
    
  end;

  cmn.CallEventHandler( "opn_pier_map" ); 

  local pages = ng_global.progress[ "std" ][ "see_tutorial" ].state.pages;

  if ng_global.progress[ "std" ][ "see_tutorial" ].start == 0 and 
     cmn.IsEventDone( "see_intro" ) then

    common_impl.TutorialShow( "tutorial_page_1" );

  end;

end;
--------------------------------------------------------------------------------------------
function private.SeeIntro()

  ObjDelete( "tmr_pier_intro" ); 
  ObjSet( "vid_pier_intro", { alp = 1, active = true, visible = true } );
  ObjAttach( "vid_pier_intro", "rm_pier" );
  local func_after = function ( skip )

    interface.DialogVideoHide();
    common_impl.ShowBbt( "bbt_first_enter" );
    cmn.SetEventDone( "see_intro" );
    cmn.CallEventHandler( "see_intro" );

    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_pier_intro", 0.2 );
      
    end;

    common_impl.StopAudio( "voc", "common/audio/aud_pier_intro_voc", 0.2 );
    common_impl.EnvPlay( { "common/audio/aud_pier_env" }, "", 0.5 );
   
    local func_after = function()

      cmn.CallEventHandler( "opn_pier_end" ); 

      ObjSet( "obj_pier_gates", { input = true } );
      ObjSet( "obj_pier_clk_poster", { input = true } );
      common_impl.PlayAudio( "env", "common/audio/aud_elf_stat", 1, "", 0 );  
      common_impl.AddPageDiary( 1 );

    end;
  
    common_impl.PlayAudio( "sfx", "common/audio/aud_elf_pier", 0, "", 0 ); 
    cmn.SetEventDone( "opn_pier" ); 
    common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0, "", 0 );
      
    VidPlay( "vid_pier_elf_going", func_after   );

    interface.KeyTaskAdd( "goto_willowswille", true, function () common_impl.TutorialShow( "tutorial_page_1" ); end );

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_pier_intro", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/aud_pier_intro_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_pier_intro", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_pier_intro", function() func_after( nil ); end );

end;
--*********************************************************************************************************************