-- name=rm_square
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_square";
  private.character_1 = 1;
  private.character_2 = 1;
  private.character_3 = 1;
  private.character_4 = 1;
  private.character_5 = 1;
  private.del_anim = true;
  private.bx = 0;
  private.by = 0;
  private.nums = {4,2,5,7};
  private.win = {2,7,4,3};
  private.init = {4,2,5,7};
  private.voices = 1;
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_garage", "room_hub" );
  ObjAttach( "zz_car", "room_hub" );
  private.Init_Subroom();
  private.dialog_voices_time = {};

  ObjMultiSet( {
    { "spr_garage_pyrotechinics", { event_mdown = private.get_pyrotechinics } },
    { "obj_vid_square_comeback", { event_mdown = private.vid_square_comeback } },
    { "gzz_square_garage", { event_mdown = function () 
      cmn.GotoSubRoom( "zz_garage", nil, { 512, 384 } );
    end;
    } },
    { "gzz_square_car", { event_mdown = function () cmn.GotoSubRoom( "zz_car", nil, { 512, 384 } ); end; } },
    { "spr_car_door", { event_mdown = function () common_impl.ShowBbt( 'bbt_car_clk_door' );private.ClickCarHandle(); end } },
    { "obj_garage_button_1", { event_mdown = function () private.clk_button( 1 ); end } },
    { "obj_garage_button_2", { event_mdown = function () private.clk_button( 2 ); end } },
    { "obj_garage_button_3", { event_mdown = function () private.clk_button( 3 ); end } },
    { "obj_garage_button_4", { event_mdown = function () private.clk_button( 4 ); end } },
    { "spr_garage_door", { event_mdown = function () private.clk_garage_door(); end } },
    { "obj_square_clk_garage_open", { event_mdown = private.clk_open_garage } },
    { "obj_square_clk_after_mother_1", { event_mdown = private.clk_characters_1 } },
    { "obj_square_clk_after_sheriff", { event_mdown = function() common_impl.ShowBbt( 'bbt_square_clk_after_sheriff', 1 ) end; } },
    { "obj_square_poster_clk", { event_mdown = function () common_impl.NoteScale( "open", "grd_square_poster" ); common_impl.ShowBbt( 'bbt_square_poster_clk', 1 ); end } },
    { "spr_square_poster_big", { event_mdown = function () common_impl.NoteScale( "close", "grd_square_poster" ) end } },
    { "spr_square_poster_big1", { event_mdown = function () common_impl.NoteScale( "close", "grd_square_poster" ) end } },
    { "obj_dlg_square_mother_2", { event_mdown = private.dlg_mother_2_click } },
    { "obj_dlg_square_mother_2_focus", { event_mdown = private.dlg_mother_2_click } },
    { "obj_dlg_square_mother_1", { event_mdown = private.dlg_mother_1_click } },
    { "obj_dlg_square_mother_1_focus", { event_mdown = private.dlg_mother_1_click } },
    { "obj_dlg_square_after_search", { event_mdown = private.dlg_after_search_click } },
    { "obj_dlg_square_after_search_focus", { event_mdown = private.dlg_after_search_click } },
    { "obj_dlg_square_sheriff", { event_mdown = private.dlg_sheriff_click } },
    { "obj_dlg_square_sheriff_focus", { event_mdown = private.dlg_sheriff_click } },
    { "obj_dlg_square_sem", { event_mdown = private.dlg_sem_click } },
    { "obj_dlg_square_sem_focus", { event_mdown = private.dlg_sem_click } },
    { "spr_garage_coin", {event_mdown = function() private.get_coin4() end } },
    { "spr_square_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_square_dial_key_1", { event_mdown = function() private.ClkKey( 1 ) end; } },
    { "spr_square_dial_key_2", { event_mdown = function() private.ClkKey( 2 ) end; } },
    { "spr_square_dial_key_3", { event_mdown = function() private.ClkKey( 3 ) end; } },
    { "spr_square_dial_officekey", { event_mdown = private.get_officekey } }
} );

  ObjAnimate( "spr_car_light", "alp", 1, 0, "", { 0,0,0, 0.5,0,1, 1,0,0 } );
  ObjAnimate( "spr_car_button_light", "alp", 1, 0, "", { 0,0,0, 0.5,0,0.5, 1,0,0 } );

  common_impl.hint[ "win_garage" ] = {

      type = "win",    
      room = private.room_objname,
      use_place = "obj_garage_button",
      zz_gate = "gzz_square_garage",
      zz = "zz_garage"

  };

  local win_garage = function ()

      if ( cmn.IsEventDone( "win_garage" ) ) then  
        
          ObjMultiSet({
          { "obj_garage_button", { input = false }},
          { "spr_square_box", { alp = 1 }}, 
          { "spr_square_garage_open", { alp = 1 }},
          { "anm_square_garage_open", { alp = 1 }},
          { "spr_square_zz_garage_open_refl", { alp = 1 }},
          { "obj_garage_pyrotechinics", { input = true, active = true, alp = 1 }},
          });
          
          ObjDelete( "spr_garage_door" );
          ObjDelete( "anm_garage_open_door" );
        
          for i = 1, 4 do

            ObjSet("spr_garage_number_"..i, {res = "assets/levels/level1/rm_square/zz_garage/layers/"..private.win[i]});

          end;

      else

          for i = 1, 4 do
         
              private.nums[i] = ng_global.progress["std"]["win_garage"].nums[i];

          end;

          for i = 1, 4 do

            ObjSet("spr_garage_number_"..i, { res = "assets/levels/level1/rm_square/zz_garage/layers/"..private.nums[i]});

            if ( ( private.nums[i] ) == 7 ) then

              ObjSet("spr_garage_number_"..i.."_next", { res = "assets/levels/level1/rm_square/zz_garage/layers/1"});
            
            else  

              ObjSet("spr_garage_number_"..i.."_next", { res = "assets/levels/level1/rm_square/zz_garage/layers/"..private.nums[i]+1});  
            
            end; 

          end;
        
      end;

  end;

  cmn.AddSubscriber( "win_garage", win_garage, private.room_objname );
  --------------------------------------------------------------------------------------------
  local get_collect_coin_4 = function ()

    ObjDelete( "obj_garage_coin" );

  if cmn.IsEventDone("get_pyrotechinics") then
     ObjDelete( "gzz_square_garage" );
     ObjSet( "obj_square_clk_garage_open", { input = true } );
  end;

  end;
  cmn.AddSubscriber( "get_coin_4", get_collect_coin_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------  
  common_impl.hint[ "get_pyrotechinics" ] = {
    type = "get",
    get_obj = "spr_garage_pyrotechinics",
    room = private.room_objname,
    zz = "zz_garage",
    zz_gate = "gzz_square_garage"
  };
  local get_pyrotechinics_inv = function ()
  
    interface.InventoryItemAdd( "inv_pyrotechinics", "spr_garage_pyrotechinics" );
  
  end;
  
  local get_pyrotechinics_closezz = function ()

  if common_impl.IsGetCoin("get_coin_4") then
    ObjSet( "obj_square_clk_garage_open", { input = true } );
    ObjDelete( "gzz_square_garage" );
  end;

    ObjDelete("spr_square_box");
    ObjDelete( "gfx_garage_pyrotechinics" );
    ObjDelete( "spr_garage_pyrotechinics_shadow" );
    
  end;
  
  cmn.AddSubscriber( "get_pyrotechinics", get_pyrotechinics_inv );
  cmn.AddSubscriber( "get_pyrotechinics", get_pyrotechinics_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_officekey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_officekey" ] = {
    type = "get",
    get_obj = "spr_square_mother_2_key",
    room = private.room_objname
  };
  local get_officekey_inv = function ()
  
    interface.InventoryItemAdd( "inv_officekey", "spr_square_dial_officekey" );
  
  end;
  
  local get_officekey_closezz = function ()
  
    
  end;
  
  cmn.AddSubscriber( "get_officekey", get_officekey_inv );
  cmn.AddSubscriber( "get_officekey", get_officekey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_evidence_1_1 () end;
  --------------------------------------------------------------------------------------------
  local get_evidence_1_1_inv = function ()

    --
    
  end;    
  cmn.AddSubscriber( "get_evidence_1_1", get_evidence_1_1_inv );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_3 = function ()
  
    ObjDelete( "obj_square_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_3", get_collect_morph_item_1_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_evidence_1 () end;
  --------------------------------------------------------------------------------------------
  local vid_evidence_1 = function ()

    ObjSet( "obj_dlg_square_mother_2", { active = true, input = true, visible = true } );
    
  end;    
  cmn.AddSubscriber( "vid_evidence_1", vid_evidence_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_evidence_2 () end;
  --------------------------------------------------------------------------------------------
  local vid_evidence_2 = function ()

    ObjSet( "obj_dlg_square_after_search", { active = true, visible = true, input = true } )
    
  end;    
  cmn.AddSubscriber( "vid_evidence_2", vid_evidence_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_evidence_3 () end;
  --------------------------------------------------------------------------------------------
  local vid_evidence_3 = function ()

    ObjSet( "obj_dlg_square_sem", { active = true, visible = true, input = true });
    
  end;    
  cmn.AddSubscriber( "vid_evidence_3", vid_evidence_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_square () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_square" ] = {
      type = "click",      
      use_place = "grm_fork_square",
      room = "rm_fork"
  };

  local opn_square_map = function ()

    common_impl.VisitMapRoom( "square" );

  end;
  cmn.AddSubscriber( "opn_square", opn_square_map, nil );
  --------------------------------------------------------------------------------------------
  -- function use_papercode () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_papercode" ] = {
      type = "use",
      inv_obj = "inv_papercode",
      use_place = "obj_garage_use_papercode",
      room = private.room_objname,
      zz = "zz_garage",
      zz_gate = "gzz_square_garage"
  };
  local use_papercode_inv = function ()
  
    interface.InventoryItemRemove( "inv_papercode" );
  
  end;
  local use_papercode_beg = function ()
  
    ObjDelete( "obj_garage_use_papercode" );
  
  end;
  local use_papercode_end = function ()
    
    ObjMultiSet({
    { "obj_garage_button", { input = true  }},
    { "spr_garage_list", { alp = 1  }},
    { "spr_square_note", { alp = 1  }},
    });
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_papercode", use_papercode_beg, private.room_objname );
  cmn.AddSubscriber( "use_papercode", use_papercode_inv );
  cmn.AddSubscriber( "use_papercode", use_papercode_end, private.room_objname );
  cmn.AddSubscriber( "use_papercode_inv", use_papercode_inv, private.room_objname );
  cmn.AddSubscriber( "use_papercode_beg", use_papercode_beg, private.room_objname );
  cmn.AddSubscriber( "use_papercode_end", use_papercode_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_square_mother_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_square_mother_1" ] = {

      type = "click",
      use_place = "obj_dlg_square_mother_1_focus",
      room = private.room_objname
  };

  local dlg_square_mother_1_end = function ()

    ObjDelete( "anm_square_citizens" );
    ObjDelete( "obj_dlg_square_mother_1" );
    ObjSet( "grm_square_livingroom", { active = true, input = true });
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_square_livingroom_focus");
    end;
    ObjDelete("anm_square_sheriff");
    ObjSet("anm_square_pers_2", { alp = 1} );
    ObjSet( "obj_square_clk_after_mother_1", { input = true } );

    common_impl.Collectibles2_unlock_crs( "Sheriff_Connors" );
    common_impl.Collectibles2_unlock_crs( "Lorrain_Johnsons" );
    common_impl.Collectibles2_unlock_crs( "Mary_Johnson" );

  end;
  local dlg_square_mother_1_loc = function ()

    if private.del_anim == true then

      ObjDelete( "anm_square_citizens_leave" );

    end;

    ObjSet( "anm_square_door_open_static", { alp = 1, playing = true } );
    ObjDelete( "anm_square_door_open" );
    --ObjSet( "grm_square_livingroom", { active = true, input = true, visible = true });
    --ObjDelete("anm_square_sheriff");
    --ObjSet("anm_square_pers_2", { alp = 1} );
    --ObjSet( "obj_square_clk_after_mother_1", { input = true } );

  end;

  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "dlg_square_mother_1", dlg_square_mother_1_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_square_mother_1", dlg_square_mother_1_loc, private.room_objname  );
  cmn.AddSubscriber( "dlg_square_mother_1_loc", dlg_square_mother_1_loc, private.room_objname  );
  cmn.AddSubscriber( "dlg_square_mother_1_end", dlg_square_mother_1_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function dlg_square_mother_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_square_mother_2" ] = {

      type = "click",
      use_place = "obj_dlg_square_mother_2_focus",
      room = private.room_objname
  };

  local dlg_square_mother_2_end = function ()

    ObjDelete( "obj_dlg_square_mother_2" );
  
  end;

  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "dlg_square_mother_2", dlg_square_mother_2_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_square_mother_2_end", dlg_square_mother_2_end, private.room_objname  );

  --------------------------------------------------------------------------------------------
  -- function dlg_square_after_search () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_square_after_search" ] = {

      type = "click",
      use_place = "obj_dlg_square_after_search_focus",
      room = private.room_objname
  };

  local dlg_square_after_search_end = function ()

    ObjDelete( "obj_dlg_square_after_search" );
    ObjSet( "obj_vid_square_comeback", { active = true, input = true, visible = true });

  end;
  local dlg_square_after_search_invest_button = function ()

    ObjSet( "obj_int_investigation_button", { active = false, input = false, visible = false } );

  end;

  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_square_after_search", dlg_square_after_search_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_square_after_search_end", dlg_square_after_search_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_square_after_search", dlg_square_after_search_invest_button  );
  cmn.AddSubscriber( "dlg_square_after_search_end", dlg_square_after_search_invest_button  );

  --------------------------------------------------------------------------------------------
  -- function vid_square_comeback () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_square_comeback" ] = {

      type = "click",
      use_place = "obj_vid_square_comeback",
      room = private.room_objname
  };

  local vid_square_comeback_beg = function ()

    ObjDelete( "obj_vid_square_comeback" );

  end;

  local vid_square_comeback_end = function ()

    ObjSet( "obj_dlg_square_sheriff", { active = true, input = true, visible = true } );
    ObjSet( "anm_square_citizens_2", { alp = 1, playing = true } );
    ObjSet( "anm_square_citizens_police", { alp = 1, playing = true } );
    ObjDelete( "anm_square_pers_2" );
    ObjDelete( "obj_square_clk_after_mother_1" );
    ObjDelete( "gzz_square_garage" )
    ObjDelete( "obj_square_clk_garage_open" );

  end;

  cmn.AddSubscriber( "vid_square_comeback", vid_square_comeback_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_square_comeback", vid_square_comeback_end, private.room_objname  );
  cmn.AddSubscriber( "vid_square_comeback_beg", vid_square_comeback_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_square_comeback_end", vid_square_comeback_end, private.room_objname  );
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "dlg_square_sem" ] = {

      type = "click",
      use_place = "obj_dlg_square_sem_focus",
      room = private.room_objname
  };

  local vid_square_oulmen_end = function ()

    ObjDelete( "obj_dlg_square_sem" );
    common_impl.Collectibles2_unlock_crs( "Sam_Templton" );

  end;
  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "vid_square_oulmen", vid_square_oulmen_end, private.room_objname  );
  cmn.AddSubscriber( "vid_square_oulmen_end", vid_square_oulmen_end, private.room_objname  );

  common_impl.hint[ "dlg_square_sheriff" ] = {

      type = "click",
      use_place = "obj_dlg_square_sheriff_focus",
      room = private.room_objname
  };

  local dlg_square_sheriff_end = function ()

    ObjDelete( "obj_dlg_square_sheriff" );
    ObjDelete( "spr_square_abandoneddistrict_gates" );
    ObjDelete( "obj_square_not_gate" );
    ObjSet( "grm_square_abandoneddistrict", { active = true, input = true });
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_square_abandoneddistrict_focus");
    end;
    ObjSet( "obj_square_abandoneddistrict_gates_open", { alp = 1, active = 1 });
    ObjSet( "obj_square_clk_after_sheriff", { input = true } );

  end;
  local dlg_square_sheriff_invest_button = function ()

    ObjSet( "obj_int_investigation_button", { active = true, input = true, visible = true } );

  end;

  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_square_sheriff", dlg_square_sheriff_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_square_sheriff_end", dlg_square_sheriff_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_square_sheriff", dlg_square_sheriff_invest_button  );
  cmn.AddSubscriber( "dlg_square_sheriff_end", dlg_square_sheriff_invest_button  );


  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_square = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gzz_square_garage",
      "gzz_square_car",
    };
    for i = 1, #gates do
    
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 

      {
        private.room_objname,
        "zz_garage",
        "zz_car",

      };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_square", update_game_mode_square, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_square = function ()
    
    local effects_table = 
    {
      "obj_square_anims",
      "grd_square_poster",
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;


  end;
  cmn.AddSubscriber( "update_performance_mode_square", update_performance_mode_square, private.room_objname );
end;

--*********************************************************************************************************************
function public.Load()
end;
--********************************************************************************************************************
function private.Init_Subroom ()
  
  subroom.Define( "zz_garage" );
  --------------------------------------------------------------------------------------------
  function zz_garage.PreOpen ()

    common_impl.StopAllVoc();
    AnimStop( "anm_square_cat" );
    common_impl.StopAudio( "sfx", "common/audio/aud_cat_and_crows", 1 );
    ObjSet( "obj_square_clk_after_mother_1", { input = true } )
    ObjSet( "tmr_square_voices", { playing = 0 } );
    if ( cmn.IsEventDone( "use_papercode" ) and not cmn.IsEventDone( "win_garage" )) then

      cmn.MiniGameShow( "garage" );
      common_impl.PassingMgStart( "garage" )

    end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_garage.PreClose()

    if ( cmn.IsEventStart( "win_garage" ) and not cmn.IsEventDone( "win_garage" ) ) then

      cmn.MiniGameHide( "garage" );
      common_impl.PassingMgStop( "garage" )

    end;

  end;
  --------------------------------------------------------------------------------------------
  subroom.Define( "zz_car" );
  --------------------------------------------------------------------------------------------
  function zz_car.PreOpen()

    AnimStop( "anm_square_cat" );
    common_impl.StopAudio( "sfx", "common/audio/aud_cat_and_crows", 1 );

    ObjSet( "spr_car_door", { input = 1 } );
    ObjSet( "spr_car_door_handle", { scale_x = 1 } );

    common_impl.StopAllVoc();
    ObjSet( "obj_square_clk_after_mother_1", { input = true } )
    ObjSet( "tmr_square_voices", { playing = 0 } );

  end;
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_square();

  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );
  
  --AK> if not get first evidence !!!Change dialog charackter!!!
  if ( cmn.IsEventDone( "dlg_square_mother_1" ) and ( not cmn.IsEventDone( "get_evidence_1_1" ) ) ) then

    private.get_evidence_1_1();

  end;  
  
  if ( cmn.IsEventDone( "dlg_square_sem" ) and ( not cmn.IsEventDone( "vid_square_oulmen" ) ) ) then

    private.vid_square_oulmen();

  end; 

  if ( cmn.IsEventDone( "dlg_square_after_search" ) and not cmn.IsEventDone( "vid_square_comeback" ) ) then
    private.vid_square_comeback();
  end;


end;
--*********************************************************************************************************************
function public.PreOpen()

  private.Play_anm_cat();
  common_impl.MorphItemMorphing();

  ObjSet( "spr_square_poster_big", { input = 0, alp = 0 } );
  ObjSet( "grd_square_poster", { alp = 1 } );

  if common_impl.square then

    common_impl.square.note = "close";

  else 

    common_impl.square = {}
    common_impl.square.note = "close";

  end; 

  common_impl.EnvPlay( { "common/audio/aud_square_env" }, "", 0.5 );

  if not cmn.IsEventDone( "dlg_square_mother_1" ) or cmn.IsEventDone( "vid_square_comeback" ) then

    common_impl.PlayAudio( "env", "common/audio/aud_square_people_env", 1, "", 0.5 );

  end;

  if cmn.IsEventDone( "get_evidence_1_1" ) then

    interface.InvestigationButtonCheck();

  end;
  if ( not cmn.IsEventDone( "dlg_square_mother_1" ) ) then
    common_impl.PlayTimer( private.dlg_mother_1_click );
  end;

end;
--*********************************************************************************************************************
function public.Close()

  --common_impl.StopAudio( "env", "common/audio/aud_square_env", 0.2 );
  common_impl.StopAudio( "sfx", "common/audio/aud_cat_and_crows", 1 );
  common_impl.StopAudio( "env", "common/audio/aud_square_people_env", 0.2 );
  AnimStop( "anm_square_cat" ); 
  common_impl.StopAllVoc();
  ObjSet( "obj_square_clk_after_mother_1", { input = true } )
  ObjSet( "tmr_square_voices", { playing = 0 } );

end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_papercode()

  local item = "inv_papercode";

  if ( common.ApplyObj( item, "obj_garage_use_papercode", true ) ) then

    cmn.CallEventHandler( "use_papercode_inv" );
    cmn.CallEventHandler( "use_papercode_beg" );

    local trg_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_papercode" );
      cmn.CallEventHandler( "use_papercode_end" );
      cmn.MiniGameShow( "garage" );
      common_impl.PassingMgStart( "garage" )
      
      ng_global.progress["std"]["win_garage"].nums = {4,2,5,7};

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_garagelock_code", 0, "", 0.5 );

    ObjAnimate( "spr_garage_list", "alp", 0, 0, trg_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

  elseif common.ApplyObj( item, "gzz_square_garage", false ) and common_impl.square.note == "close" then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_garage", nil, { 512, 384 } );

  else 

    common_impl.WrongApply();  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_coin4()

  local func_after = function ()
  
    common_impl.GetCoinDone("get_coin_4");
    cmn.CallEventHandler("get_coin_4");

    if cmn.IsEventDone("get_pyrotechinics") then
      common.CloseSubRoom();
    end;

  end;
  
  common_impl.PlayEffectHO( "spr_garage_coin", func_after );

end;
--------------------------------------------------------------------------------------------
function private.get_pyrotechinics()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_pyrotechinics" );
  cmn.CallEventHandler( "get_pyrotechinics" );

  if common_impl.IsGetCoin("get_coin_4") then
    common.CloseSubRoom();
  end;
end;
--------------------------------------------------------------------------------------------
function private.get_officekey()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  common_impl.PlayAudio( "sfx", "common/audio/aud_interactive_end", 0, "", 0 );

  common_impl.DialogCharacterHide();
  
  cmn.SetEventDone( "get_officekey" );
  cmn.CallEventHandler( "get_officekey" );
  
end;
--------------------------------------------------------------------------------------------
function private.get_evidence_1_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_evidence_open", 0, "", 0 );

  local func_end = function ()

    int_investigation_button.Show( true );
    interface.InvestigationButtonItemAdd( "evidence_1_1", "spr_square_evidence_1_1" );

    interface.KeyTaskAdd( "examine_square" );

    cmn.SetEventDone( "get_evidence_1_1" );
    cmn.CallEventHandler( "get_evidence_1_1" );
  
  end;

  interface.DialogEvidenceShow( "evidence_1_1", func_end )
  ObjSet( "spr_square_evidence_1_1", { alp = 1, scale_x = 0.2, scale_y = 0.2 } );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_garage_door()

  local trg_after = function ()
    common_impl.Lock( false);
  end;
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_big_metal", 0, "", 0 );
  common_impl.ShowBbt( 'bbt_garage_clk_door' );
  ObjAnimate("spr_garage_door", "pos_x", 0, 0, trg_after, {0, 3, 41, 0.15, 3, 43,  0.3, 3, 41});
  common_impl.Lock(true);

end;
-------------------------------------------------------------------------------------
function private.ClickCarHandle()

  ObjSet( "spr_car_door", { input = 0 } )

  local func_after = function()

    common_impl.Lock(false);
    ObjSet( "spr_car_door", { input = 1 } )    

  end;

  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_police_car_handle", 0, "", 0 );
  ObjAnimate( "spr_car_door_handle", "scale_x", 0, 0, func_after, { 0,0,1, 0.2,0,0.8, 0.4,0,1 } );
  ObjAnimate( "spr_car_door_handle_shadow", "pos_y", 0, 0, "", { 0,0,198, 0.2,0,204, 0.4,0,198 } );

end;
-------------------------------------------------------------------------------------
function private.clk_open_garage()

  local trg_after = function ()

    common_impl.Lock( false);
    common_impl.ShowBbt( 'bbt_square_open_garage', 1 );

  end;

  common_impl.Lock(true);

  AnimPlay( "anm_square_garage_open", "DoAnim", trg_after ); 
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_garage_door_open", 0, "", 0 );
 
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function public.ClkDlgPhoto( mode )

  local trg_after = function()

    common_impl.Lock( false);

    ObjSet( "obj_int_dialog_character_input", { event_mdown = function() int_dialog_character.ContinueClick( false ) end } );

    common_impl.frases = { 1, 2 };
    common_impl.dial_icons = { 'owlman', 'oliver' };
    common_impl.DialogCharacterShowDialogQuestions( 2 );

  end;

  if mode == 'open' then

    ObjSet( "anm_square_mother_1_photo", { alp = 0 } );
    ObjSet( "anm_square_mother_1_mother", { alp = 1 } );

    common_impl.Lock(true);

    local func_end = function()
      AnimPlay( "anm_square_evidence_1_1", "DoAnim", function() common_impl.Lock( false); end );
    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_show_photo", 0, "", 0 );
    ObjAnimate( "spr_square_evidence_1_1", "scale_xy", 0, 0, "", { 0,3,0.35,0.35, 0.4,3,0.9,0.9 }  );
    ObjAnimate( "spr_square_evidence_1_1", "pos_xy", 0, 0, func_end, { 0,3,168,276, 0.4,3,0,0 }  );
    ObjSet( "spr_square_evidence_1_1", { alp = 1 } );    
    ObjSet( "obj_int_dialog_character_input", { event_mdown = function() rm_square.ClkDlgPhoto( 'close' ) end } );

  elseif mode == 'close' then

    common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_paper_close", 0, "", 0 );
    ObjAnimate( "spr_square_evidence_1_1", "scale_xy", 0, 0, "", { 0,3,0.9,0.9, 0.3,3,1,1 });
    ObjAnimate( "spr_square_evidence_1_1", "alp", 0, 0, trg_after, { 0,3,1, 0.3,3,0 });

  elseif mode == 'start' then

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_to_us", 0, "", 0 );
    ObjSet( "anm_square_mother_1_photo", { alp = 1 } );
    ObjSet( "anm_square_mother_1_mother", { alp = 0 } );
    ObjSet( "obj_int_dialog_character_input", { event_mdown = function() rm_square.ClkDlgPhoto( 'open' ) end } );
    common_impl.continue_visible = false;

  end;

end;
--*********************************************************************************************************************
function public.ClickDlgKeys( )

   local func_after = function()
      common_impl.Lock( false );
      ObjSet( "anm_square_mother_2_mother_key", { alp = 0 } ); 
      ObjSet( "anm_square_mother_2_mother", { alp = 1 } ); 
   end;

   common_impl.StopAllVoc();
   common_impl.DialogCharacterStopAllVid();
  
   ObjSet( "obj_square_mother_2_mmg", { input = true, pos_z = 101, pos_x = 700, pos_y = 350 } ); 
   ObjAttach( "obj_square_mother_2_mmg", "int_dialog_character_impl" );
   ObjSet( "obj_int_dialog_character_input", { input = false } );

   common_impl.Lock( true );

   common_impl.PlayAudio( "sfx", "common/audio/aud_interactive_begin", 0, "", 0 );

   ObjAnimate( "obj_square_mother_2_mmg", "alp", 0, 0, func_after, { 0,0,0, 0.1,0,1 } );
   ObjAnimate( "obj_int_dialog_character", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );  


end;
-------------------------------------------------------------------------------------
function private.ClkKey( number )

  local func_after = function()

    common_impl.Lock( false );
    ObjSet( "spr_square_dial_key_"..number, { input = false } );
  
    if number ~= 1 then
      
      ObjSet( "spr_square_dial_key_"..( number - 1 ), { input = true } );     

    else

      ObjSet( "spr_square_dial_officekey", { input = true } );

    end;
   
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_lorraine_keys", 0, "", 0 );

  ObjAnimate( "spr_square_dial_key_"..number, "alp", 0, 0, func_after, { 0,0,1, 0.3,0,0 } );
  ObjAnimate( "spr_square_dial_thrown_"..number, "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );

  if number == 1 then 
    ObjAnimate( "spr_square_dial_officekey_shadow", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
  end;
  

end;
-------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  
  if dlg_name == "mother_1" then

    if count_txt == 2 then rm_square.ClkDlgPhoto( 'start' );
    elseif count_txt == 3 and common_impl.continue_answer ~= true then  common_impl.DialogCharacterShowDialogQuestions( #common_impl.frases, private.dialog_voices_time[ common_impl.dialog_character_select ] ); 
    elseif count_txt == 4 and common_impl.continue_answer ~= true then  common_impl.DialogCharacterShowDialogQuestions( #common_impl.frases, private.dialog_voices_time[ common_impl.dialog_character_select ] );
    --elseif count_txt == 5 and common_impl.continue_answer ~= true and #common_impl.frases ~= 0 then common_impl.DialogCharacterShowDialogQuestions( #common_impl.frases, private.dialog_voices_time[ common_impl.dialog_character_select ] );
    elseif count_txt == 5 then  common_impl.continue_visible = true; 
    elseif count_txt == 6 then  common_impl.continue_visible = false; common_impl.frases = { 5 }; common_impl.dial_icons = { 'loupe' }; common_impl.DialogCharacterShowDialogQuestions( 1, 10 ); 
                                common_impl.DialogCharacterChangeCharacters( "mother_1", "mother", "sheriff" ); 
    elseif count_txt == 7 then  common_impl.DialogCharacterChangeCharacters( "mother_1", "sheriff", "mother" );
    end;

  elseif dlg_name == "mother_2" then

    if count_txt == 1 then common_impl.continue_visible = false; common_impl.frases = { 1 }; common_impl.dial_icons = { 'key' }; common_impl.DialogCharacterShowDialogQuestions( 1, 3 ); 
    elseif count_txt == 3 then
  
       ObjSet( "anm_square_mother_2_mother_key", { alp = 1 } ); 
       ObjSet( "spr_square_mother_2_key", { alp = 1 } ); 
       ObjSet( "anm_square_mother_2_mother", { alp = 0 } ); 
       ObjSet( "obj_int_dialog_character_input", { event_mdown = function() rm_square.ClickDlgKeys() end } );
       
       common_impl.PlayAudio( "sfx", "common/audio/aud_get_to_us", 0, "", 0 );
         
    end;

  elseif dlg_name == "after_search" then

    if count_txt == 1 then common_impl.continue_visible = false; common_impl.frases = { 1 };  common_impl.dial_icons = { 'george' }; common_impl.DialogCharacterShowDialogQuestions( 1, 3 );  
    elseif count_txt == 2 then common_impl.continue_visible = false; common_impl.frases = { 2 }; common_impl.dial_icons = { 'loupe' }; common_impl.DialogCharacterShowDialogQuestions( 1, 7 ); 
    end;

  elseif dlg_name == "sheriff" then

    if count_txt == 1 then common_impl.continue_visible = false; common_impl.frases = { 1 };  common_impl.dial_icons = { 'loupe' }; common_impl.DialogCharacterShowDialogQuestions( 1, 11 ); 
    elseif count_txt == 2 then common_impl.DialogCharacterChangeCharacters( "sheriff", "sheriff", "mother" );
    elseif count_txt == 3 then common_impl.DialogCharacterChangeCharacters( "sheriff", "mother", "sheriff" );
    end;

  elseif dlg_name == "sem" then

    if count_txt == 1 then common_impl.continue_visible = false; common_impl.frases = { 1 }; common_impl.dial_icons = { 'hands' };common_impl.DialogCharacterShowDialogQuestions( 1, 2 ); 
                           common_impl.DialogCharacterChangeCharacters( "sem", false, "sheriff" ); 
    elseif count_txt == 2 then common_impl.DialogCharacterChangeCharacters( "sem", "sheriff" , "mother" ); 
    elseif count_txt == 3 then common_impl.continue_visible = false; common_impl.frases = { 2 };  common_impl.dial_icons = { 'stop' }; common_impl.DialogCharacterShowDialogQuestions( 1, 14 ); common_impl.continue_visible = false;
                               common_impl.DialogCharacterChangeCharacters( "sem", "mother", "sheriff" );
    end;
  
  end;

end;
--*********************************************************************************************************************
-- dlg_mother_1
--*********************************************************************************************************************
function private.dlg_mother_1_click()

  ObjAttach( "dlg_square_mother_1", "rm_square" );
  private.del_anim = false

  common_impl.StopTimer();

  common_impl.dialog_character_loc = "obj_square_pers";
  common_impl.DialogCharacterStart( "mother_1", 8, nil, nil, true, "dlg_mother_1_click_end" );

  private.dialog_voices_time = { 9, 6, 7, false, 7 };

  local endtrig = function ()

    ObjDelete("anm_square_sheriff");
    ObjSet("spr_square_pers_2", { alp = 1} );

  end;

  ObjSet( "tmr_square_fordial", { playing = 1, time = 0.3, endtrig = endtrig } );

end;
-------------------------------------------------------------------------------------
function public.dlg_mother_1_click_end()

  cmn.SetEventDone( "dlg_square_mother_1" );
  cmn.CallEventHandler( "dlg_square_mother_1_end" ); 
  
  local endtrig = function () 

    common_impl.AddPageDiary( 2 );
    
    local page_content3 = {1, 1, 1};
    common_impl.AddBookmarkDiary( 3, 1, page_content3);

    local page_content4 = {1, 1, 1};
    common_impl.AddBookmarkDiary( 4, 1, page_content4);

    local page_content5 = {1, 1, 1};
    common_impl.AddBookmarkDiary( 5, 1, page_content5);

    local page_content6 = {1, 1, 1};
    common_impl.AddBookmarkDiary( 6, 1, page_content6);

    common_impl.Lock( false );

    private.del_anim = true; 
    cmn.CallEventHandler( "dlg_square_mother_1_loc" ); 
    private.get_evidence_1_1();
    --AnimPlay( "anm_square_door_open_static", "DoAnim", "" );

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_square_people_leave", 0, "", 0 );
  ObjSet( "anm_square_citizens_leave", { alp = 1 } );
  AnimPlay( "anm_square_door_open", "DoAnim", "" );
  AnimPlay( "anm_square_citizens_leave", "DoAnim", endtrig );
  common_impl.StopAudio( "env", "common/audio/aud_square_people_env", 0.2 );

end;
--*********************************************************************************************************************
-- dlg_mother_2
--*********************************************************************************************************************
function private.dlg_mother_2_click()

  ObjAttach( "dlg_square_mother_2", "rm_square" );
  common_impl.dialog_character_loc = "obj_square_pers";
  common_impl.continue_visible = false;
  common_impl.DialogCharacterStart( "mother_2", 4, nil, nil, true, "dlg_mother_2_click_end" );

end;
-------------------------------------------------------------------------------------
function public.dlg_mother_2_click_end() 

  cmn.SetEventDone( "dlg_square_mother_2" );
  cmn.CallEventHandler( "dlg_square_mother_2_end" ); 

  int_investigation_button.ChangeInvestigation(); --AK> возможно пережелать под interface.ChangeInvestigation

  if not cmn.IsEventDone( "get_officekey" ) then
    private.get_officekey();
  end;

  ObjSet( "obj_int_dialog_character", { alp = 1 } );  

  ObjAttach( "obj_square_mother_2_mmg", "obj_square_mother_2_characters" );
  interface.KeyTaskAdd( "enter_office", true );

end;
--*********************************************************************************************************************
-- dlg_after_search
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.dlg_after_search_click()

  ObjAttach( "dlg_square_after_search", "rm_square" );
  common_impl.dialog_character_loc = "obj_square_pers";
  common_impl.continue_visible = false; 
  common_impl.DialogCharacterStart( "after_search", 4, nil, nil, true, "dlg_after_search_click_end" );

end;
-------------------------------------------------------------------------------------
function public.dlg_after_search_click_end() 

  cmn.SetEventDone( "dlg_square_after_search" );
  cmn.CallEventHandler( "dlg_square_after_search_end" ); 
  
  private.vid_square_comeback();

end;
-------------------------------------------------------------------------------------
function private.zoom_to_abandoneddistrict ()
      
  local func_after = function ()

    private.zoom_to_abandoneddistrict_end();  

  end;

  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_in", 0, "", 0 );

  ObjAnimate( private.room_objname, "scale_xy", 0, 0, "",
  { 
    0.0, 1, 1.0,1.0, 
    1.0, 1, 1.7,1.7,
    1.4, 3, 1.7,1.7,

  } );
  
  ObjAnimate( private.room_objname, "pos_xy", 0, 0, func_after,
  { 
    0.0, 1,  0.0, 0, 
    1.0, 1,  120, -200,
    1.4, 3,  120, -200,

  } );

end;

function private.zoom_to_abandoneddistrict_end ()

  common_impl.ShowBbt( 'bbt_square_after_dlg_sheriff', 1 );
  local func_after = function () 

    common_impl.Lock(false);

    int_investigation_button.ChangeInvestigation();
    int_investigation_button.Show( true );
  
  end;
   
  common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_out", 0, "", 0 );

  ObjAnimate( private.room_objname, "scale_xy", 0, 0, "",
  { 

    0.0, 3, 1.7,1.7,
    1.0, 3, 1.0,1.0

  } );
  
  ObjAnimate( private.room_objname, "pos_xy", 0, 0, func_after,
  { 
    0.0, 3,  120, -200,
    1.0, 3,    0, 0

  } );
  
end;
--*********************************************************************************************************************
-- dlg_sheriff
--*********************************************************************************************************************
-------------------------------------------------------------------------------------
function private.dlg_sheriff_click()

  ObjAttach( "dlg_square_sheriff", "rm_square" );
  common_impl.dialog_character_loc = "obj_square_pers";
  common_impl.continue_visible = false; 
  common_impl.DialogCharacterStart( "sheriff", 4, nil, nil, true, "dlg_sheriff_click_end" );

end;
-------------------------------------------------------------------------------------
function public.dlg_sheriff_click_end() 

  cmn.SetEventDone( "dlg_square_sheriff" );
  cmn.CallEventHandler( "dlg_square_sheriff_end" );

  private.zoom_to_abandoneddistrict();
  DbgTrace( ng_global.investigation );

end;
--*********************************************************************************************************************
-- dlg_sem
--*********************************************************************************************************************
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
function private.dlg_sem_click()

  ObjAttach( "dlg_square_sem", "rm_square" );
  common_impl.dialog_character_loc = "obj_square_pers";
  common_impl.continue_visible = false; 
  common_impl.DialogCharacterStart( "sem", 5, nil, nil, true, "dlg_sem_click_end" );

end;
-------------------------------------------------------------------------------------
function public.dlg_sem_click_end() 

  cmn.SetEventDone( "dlg_square_sem" );
  cmn.CallEventHandler( "dlg_square_sem_end" );
  
  common_impl.AddPageDiary( 4 );
  int_investigation_button.ChangeInvestigation();
  private.vid_square_oulmen();

end;
-------------------------------------------------------------------------------------
function private.clk_characters_1()

  common_impl.StopAllVoc();
  common_impl.ShowBbt( 'bbt_square_after_mother_1', 1 );
  common_impl.PlayAudio( "voc", "common/audio/aud_loraine_"..private.voices.."_voc", 0, "", 0 );
  ObjSet( "obj_square_clk_after_mother_1", { input =false } )
  
  ObjSet( "tmr_square_voices", { playing = 1, time = 3, endtrig = "*ObjSet( 'obj_square_clk_after_mother_1', { input = true } );" } );

  private.voices = private.voices + 1;
  if private.voices == 3 then 
     private.voices = 1;
  end;

end;

--*********************************************************************************************************************
-- vid_square_comeback
--*********************************************************************************************************************
function private.vid_square_comeback()

  cmn.CallEventHandler( "vid_square_comeback_beg" );
  ObjSet( "vid_square_comeback", { alp = 1, active = true, input = false, visible = true } );
  ObjSet( private.room_objname, { input = false } );
  ObjAttach( "vid_square_comeback", private.room_objname );
  ObjSet( "obj_int_investigation_button", { input = false } );

  local func_after = function ( skip )

    --ObjSet( "obj_int_investigation_button", { input = true } );
    interface.DialogVideoHide();
    ObjSet( private.room_objname, { input = true } );
    cmn.SetEventDone( "vid_square_comeback" );
    cmn.CallEventHandler( "vid_square_comeback_end" );
    common_impl.ShowBbt( 'bbt_vid_square_comeback', 1 );
    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment2_mus", 0, "", 0 );
    common_impl.PlayAudio( "env", "common/audio/aud_square_people_env", 1, "", 0.5 );

    if skip then

       common_impl.StopAudio( "sfx", "common/audio/aud_square_comeback", 0.2 );

    end;

  end;

  common_impl.StopAllMus();
  common_impl.PlayAudio( "sfx", "common/audio/aud_square_comeback", 0, "", 0 );
  interface.DialogVideoShow( "vid_square_comeback", 1, function() func_after( 'skip' ); end, 3  );
  VidPlay( "vid_square_comeback",  function() func_after( nil ); end ); 

end;
--*********************************************************************************************************************
-- vid_square_oulmen
--*********************************************************************************************************************
function private.vid_square_oulmen ()

  ObjSet( "vid_square_oulmen", { alp = 1, active = true, input = false, visible = true } );
  ObjSet( private.room_objname, { input = false } );
  ObjAttach( "vid_square_oulmen", private.room_objname );
  
  local func_after = function ( skip )

    interface.DialogVideoHide();
    ObjSet( private.room_objname, { input = true } );
    cmn.SetEventDone( "vid_square_oulmen" );
    cmn.SetEventDone( "dlg_square_sem" );
    cmn.CallEventHandler( "vid_square_oulmen_end" );
    common_impl.PlayAudio( "mus", "common/audio/aud_mt8_maintheme_mus", 0, "", 0 );

    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_square_oulmen", 0.2 );

    end;

--    if ( IsSurveyEdition() ) or ( IsDemoEdition() ) then
--
--      common.GotoRoom( "rm_demo" );
--
--    else
    if (iOS_IsBought() == 1) then

      ng_global.progress[ ng_global.currentprogress ].common.currentroom = "rm_area";
      common.LevelSwitch( "level2" );
    else
      common.LevelSwitch("menu","unlock");
    end;

  end;
  
  common_impl.StopAllMus();
  common_impl.PlayAudio( "sfx", "common/audio/aud_square_oulmen", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/aud_square_oulmen_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_square_oulmen", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_square_oulmen",  function() func_after( nil ); end ); 

end;
-------------------------------------------------------------------------------------
function private.opn_square()

  if not ( cmn.IsEventDone( "opn_square" ) ) then
    cmn.SetEventDone( "opn_square" );
    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment3_mus", 0, "", 0 );
  end;

  cmn.CallEventHandler( "opn_square" ); 

end;
--*********************************************************************************************************************
-----------------------------MMG---------------------------------------------------
-----------------------------------------------------------------------------------
--*********************************************************************************************************************
function private.clk_button( num )

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_garagelock_wheel", 0, "", 0.5 );

  bx = ObjGet("obj_garage_button_"..num).pos_x;
  by = ObjGet("obj_garage_button_"..num).pos_y;

  local trg_after = function ()

    private.clk_button_end(num);

  end;
  common_impl.Lock(true);
  ObjAnimate("obj_garage_button_"..num, "pos_xy", 0, 0, trg_after, 
  {
    0.0,0,   bx,    by,
    0.3,0,   bx + 12,    by + 56
  });
 
end;
-----------------------------------------------------------------------------------
function private.clk_button_end(num)

  if (private.nums[num] == 7) then

    private.nums[num] = 1;    

  else

    private.nums[num] = private.nums[num]+1;

  end;

  ObjSet("obj_garage_button_"..num, { pos_x = bx, pos_y = by });

  ObjSet("spr_garage_number_"..num, { res = "assets/levels/level1/rm_square/zz_garage/layers/"..private.nums[num] });

  if ( ( private.nums[num] ) == 7 ) then

    ObjSet("spr_garage_number_"..num.."_next", {res = "assets/levels/level1/rm_square/zz_garage/layers/1"});

  else  

    ObjSet("spr_garage_number_"..num.."_next", {res = "assets/levels/level1/rm_square/zz_garage/layers/"..private.nums[num]+1})  
  
  end;

  bx = 0;
  by = 0;

  if ( private.CheckWin() ) then

    private.WinAnim();

  else 

    common_impl.Lock( false);
    ng_global.progress["std"]["win_garage"].nums[num] = private.nums[num];

  end;

end;
-----------------------------------------------------------------------------------
function public.Skip( event )

  local mg_name = common.GetCurrentSubRoom();
  
  if ( mg_name == "zz_garage" ) then

    for i = 1, 4 do

      ObjSet("spr_garage_number_"..i, {res = "assets/levels/level1/rm_square/zz_garage/layers/"..private.win[i]});

    end;

    private.WinAnim();

  end;

end;
-----------------------------------------------------------------------------------
function public.Reset( event )

  local mg_name = common.GetCurrentSubRoom();
  
  if ( mg_name == "zz_garage" ) then

    for i = 1, 4 do

      ObjSet("spr_garage_number_"..i, { res = "assets/levels/level1/rm_square/zz_garage/layers/"..private.init[i] });

      if ((private.init[i]) == 7) then

        ObjSet("spr_garage_number_"..i.."_next", {res = "assets/levels/level1/rm_square/zz_garage/layers/1"})

      else  

        ObjSet("spr_garage_number_"..i.."_next", {res = "assets/levels/level1/rm_square/zz_garage/layers/"..private.init[i]+1})  
     
      end; 

    end;

    for i = 1, 4 do

      private.nums[i] = private.init[i];
      ng_global.progress["std"]["win_garage"].nums[i] = private.init[i];

    end;

  end;

end;
-----------------------------------------------------------------------------------
function private.WinAnim()

  local trg_after = function ()
    private.Win();
  end;
  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_garagelock_win", 0, "", 0 );

  ObjSet( "spr_garage_door", { alp = 0 } );
  ObjSet( "anm_garage_open_door", { alp = 1 } );
  AnimPlay( "anm_garage_open_door", "DoAnim", trg_after );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_garage_door_open", 0, "", 0 );
end;
-----------------------------------------------------------------------------------
function private.Win ()
  
  common_impl.Lock( false);
  PlaySfx( "assets/levels/common/audio/aud_mg_win", 0, 0 );
  cmn.MiniGameHide( "garage" );
  cmn.SetEventDone( "win_garage" );
  cmn.CallEventHandler( "win_garage" );
  common_impl.PassingMgWin( "garage" )

end;
-----------------------------------------------------------------------------------
function private.CheckWin()

  local win = true;
  for i = 1, 4 do

    if ( private.nums[i] ~= private.win[i]) then

      win = false;

    end;

  end;

  return win;

end;
------------------------------------------------------------------------------------
function private.Play_anm_cat()

  local table_multiset = {};

  table.insert( table_multiset, { "anm_square_cat", { playing = false, visible = false } } );

  if ( cmn.IsEventDone( "dlg_square_mother_1" ) and not ng_global.progress["std"]["opn_square"].anm_cat  )   then

    ng_global.progress["std"]["opn_square"].anm_cat = true;

    common_impl.PlayAudio( "sfx", "common/audio/aud_cat_and_crows", 0, "", 0 );
    
    table.insert( table_multiset,  { "anm_square_cat", { playing = true, frame = 1, visible = true } } );

  elseif ng_global.progress["std"]["opn_square"].anm_cat then

    local chance = math.random(1,6);

    if ( chance == 1) then

      table.insert( table_multiset,  { "anm_square_cat", { playing = true, frame = 1, visible = true } } );
      common_impl.PlayAudio( "sfx", "common/audio/aud_cat_and_crows", 0, "", 0 );
    end;
 
  end;

  ObjMultiSet(table_multiset);
  -- аним стартует при заходе в локу если вып диалог №1 а потом шанс 1/6
end;
--*********************************************************************************************************************

ObjAnimate( "spr_square_index", "scale_x", 1, 0, "", { 0.0,0,1, 1.5,0,0.93, 3.0,0,1 } );
ObjAnimate( "spr_square_abandoneddistrict_gates_open_1", "scale_x", 1, 0, "", { 0.0,0,1, 2.0,1,0.95, 4.0,3,1 } );
ObjAnimate( "spr_square_abandoneddistrict_gates_open_2", "scale_x", 1, 0, "", { 0.0,0,1, 2.0,1,0.93, 4.0,3,1 } );