-- name=ho_intreehole
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "intreehole" );
  game.relations[ "ho_intreehole" ].exitroom = "rm_mineentrance";
  private.room_objname = "ho_intreehole";
  --------------------------------------------------------------------------------------------------
   local table_multiset = {};

   table.insert( table_multiset, { "spr_intreehole_beetle", { event_mdown = function() private.TaskComplete( 'beetle', 3 ) end } } );
   table.insert( table_multiset, { "spr_intreehole_bird", { event_mdown = function() private.TaskComplete( 'bird', 2 ) end } } );
   table.insert( table_multiset, { "spr_intreehole_bow_knot", { event_mdown = function() private.TaskComplete( 'bow_knot', 11 ) end } } );
   table.insert( table_multiset, { "spr_intreehole_feather", { event_mdown = function() private.TaskComplete( 'feather', 9 ) end } } );
   table.insert( table_multiset, { "spr_intreehole_flower", { event_mdown = function() private.TaskComplete( 'flower', 10 ) end } } );
   table.insert( table_multiset, { "spr_intreehole_fragment_mirror", { event_mdown = function() private.TaskComplete( 'fragment_mirror', 7 ) end } } );
   table.insert( table_multiset, { "spr_intreehole_matches", { event_mdown = function() private.TaskComplete( 'matches', 5 ) end } } );
   table.insert( table_multiset, { "spr_intreehole_mushroom", { event_mdown = function() private.TaskComplete( 'mushroom', 4 ) end } } );
   table.insert( table_multiset, { "spr_intreehole_photo", { event_mdown = function() private.TaskComplete( 'photo', 12 ) end } } );
   table.insert( table_multiset, { "spr_intreehole_pin", { event_mdown = function() private.TaskComplete( 'pin', 8 ) end } } );
   table.insert( table_multiset, { "spr_intreehole_ring", { event_mdown = function() private.TaskComplete( 'ring', 1 ) end } } );
   table.insert( table_multiset, { "spr_intreehole_soldier", { event_mdown = function() private.TaskComplete( 'soldier', 6 ) end } } );
   table.insert( table_multiset, { "obj_intreehole_clk_doll_1", { event_mdown = function() private.clk_doll( 1 ) end } } );
   table.insert( table_multiset, { "obj_intreehole_clk_doll_2", { event_mdown = function() private.clk_doll( 2 ) end } } );
   table.insert( table_multiset, { "obj_intreehole_note", { event_mdown = function() private.TaskComplete( 'note_big' ) end } } );
    
  for i = 1, 12 do

   table.insert( table_multiset, { "spr_intreehole_piece_"..i, { event_mdown = function() private.ClkPiece( i ) end } } );

  end;

  ObjMultiSet(table_multiset);
  --------------------------------------------------------------------------------------------
  -- function win_intreehole () end;
  --------------------------------------------------------------------------------------------  
  common_impl.hint[ "win_intreehole" ] = {
      type = "win",
      room = "rm_mineentrance",
      zz = "ho_intreehole",
      zz_gate = "gho_mineentrance_intreehole"
  };
  
  local win_intreehole_func = function ()

    if ( cmn.IsEventDone( "win_intreehole" ) ) then

       ObjDelete( "gho_mineentrance_intreehole" );

    end;

  end;
  cmn.AddSubscriber( "win_intreehole", win_intreehole_func, "rm_mineentrance" );
  --------------------------------------------------------------------------------------------------
  local start_intreehole_func = function ()

    if ( cmn.IsEventStart( "win_intreehole" ) ) then

      local ho_found = ng_global.progress[ "std" ][ "win_intreehole" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
      end;

    end;

  end;
  cmn.AddSubscriber( "win_intreehole", start_intreehole_func, private.room_objname );  
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_intreehole" ) ) then
  
  cmn.InitHo( "intreehole" );
  cmn.SetEventDone( "opn_intreehole" );
  ng_global.progress["std"]["win_intreehole"].pieces = { 0,0,0,0,0,0,0,0,0,0,0,0 };
  ng_global.progress["std"]["win_intreehole"].puzzles = { 0,0,0,0,0,0,0,0,0,0,0,0 };
  ng_global.progress["std"]["win_intreehole"].objects_counter = 12;
  ng_global.progress["std"]["win_intreehole"].puzzle_counter = 12;
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "beetle",          1, 0, { { "spr_intreehole_beetle" } } );
  interface.TaskPanelTaskAdd( ho_items, "bird",          1, 0, { { "spr_intreehole_bird" } } );
  interface.TaskPanelTaskAdd( ho_items, "bow_knot",          1, 0, { { "spr_intreehole_bow_knot" } } );
  interface.TaskPanelTaskAdd( ho_items, "feather",          1, 0, { { "spr_intreehole_feather" } } );
  interface.TaskPanelTaskAdd( ho_items, "flower",          1, 0, { { "spr_intreehole_flower" } } );
  interface.TaskPanelTaskAdd( ho_items, "fragment_mirror",          1, 0, { { "spr_intreehole_fragment_mirror" } } );
  interface.TaskPanelTaskAdd( ho_items, "matches",          1, 0, { { "spr_intreehole_matches" } } );
  interface.TaskPanelTaskAdd( ho_items, "mushroom",          1, 0, { { "spr_intreehole_mushroom" } } );
  interface.TaskPanelTaskAdd( ho_items, "photo",          1, 0, { { "spr_intreehole_photo" } } );
  interface.TaskPanelTaskAdd( ho_items, "pin",          1, 0, { { "spr_intreehole_pin" } } );
  interface.TaskPanelTaskAdd( ho_items, "ring",          1, 0, { { "spr_intreehole_ring" } } );
  interface.TaskPanelTaskAdd( ho_items, "soldier",          1, 0, { { "spr_intreehole_soldier" } } );


  interface.TaskPanelTaskAdd( ho_items, "piece_1",          1, 0, { { "spr_intreehole_piece_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_2",          1, 0, { { "spr_intreehole_piece_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_3",          1, 0, { { "spr_intreehole_piece_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_4",          1, 0, { { "spr_intreehole_piece_4" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_5",          1, 0, { { "spr_intreehole_piece_5" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_6",          1, 0, { { "spr_intreehole_piece_6" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_7",          1, 0, { { "spr_intreehole_piece_7" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_8",          1, 0, { { "spr_intreehole_piece_8" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_9",          1, 0, { { "spr_intreehole_piece_9" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_10",          1, 0, { { "spr_intreehole_piece_10" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_11",          1, 0, { { "spr_intreehole_piece_11" } } );
  interface.TaskPanelTaskAdd( ho_items, "piece_12",          1, 0, { { "spr_intreehole_piece_12" } } );   
  
  interface.TaskPanelTaskAdd( ho_items, "note_big",          1, 0, {  { "obj_intreehole_note" }, { "obj_intreehole_note" } } );  
  
  interface.TaskPanelShow( ho_items );


  for i = 1, #ng_global.progress["std"]["win_intreehole"].pieces do
    if ng_global.progress["std"]["win_intreehole"].pieces[i] == 1 then
      ObjSet( "spr_intreehole_piece_"..i, { input = true } );
    end;   
  end;

  for i = 1, #ng_global.progress["std"]["win_intreehole"].puzzles do
    if ng_global.progress["std"]["win_intreehole"].puzzles[i] == 1 then
      ObjDelete( "spr_intreehole_piece_"..i );
      ObjDelete( "spr_intreehole_piece_"..i.."_shadow" );
      ObjSet( "spr_intreehole_puzzle_"..i, { alp = 1 } );
    end;   
  end;
 
  if ng_global.progress["std"]["win_intreehole"].objects_counter == 0 then

    ObjAttach( "txt_intreehole_task", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel", { alp = 0 } );

    if ng_global.progress["std"]["win_intreehole"].puzzle_counter == 0 then

      ObjSet( "obj_intreehole_note", { input = true } );
      ObjDelete( "obj_intreehole_note_bbt" );
      ObjSet( "txt_intreehole_task", { alp = 1, text = "str_evidence_2_2" } ); 

    else 

     ObjSet( "txt_intreehole_task", { alp = 1, param0 = ng_global.progress["std"]["win_intreehole"].puzzle_counter } );
         
    end;

  end;

  interface.InvestigationButtonCheck();

  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

  common_impl.PlayAudio( "env", "common/audio/aud_ho_intreehole_env", 1, "", 0.5 );

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();

  common_impl.StopAudio( "env", "common/audio/aud_ho_intreehole_env", 1 );

end;
--*********************************************************************************************************************
function public.Open()

  common_impl.VisitMapRoom( "mineentrance" );
  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.Close()

  common_impl.PassingHoStop();

  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0, "", 0.5 );

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();

  ObjDetach( "txt_intreehole_task");
  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  
end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name, piece_number )
  
  ng_global.progress["std"]["win_intreehole"].objects_counter = ng_global.progress["std"]["win_intreehole"].objects_counter - 1;
  
  if piece_number then

    cmn.HoTaskFind( "spr_intreehole_"..task_name, task_name );
    ObjSet( "spr_intreehole_piece_"..piece_number, { input = true } );
    ng_global.progress["std"]["win_intreehole"].pieces[ piece_number ] = 1;

  else
    
    cmn.HoTaskFind( "spr_intreehole_puzzle_over", task_name );
    ObjAnimate( "obj_intreehole_note", "alp", 0, 0, "", { 0,0,1, 1,0,0 } );

  end;

  if ng_global.progress["std"]["win_intreehole"].objects_counter == 0 then
    
    ObjAttach( "txt_intreehole_task", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel", { alp = 0 } );
    ObjSet( "txt_intreehole_task", { alp = 1, param0 = ng_global.progress["std"]["win_intreehole"].puzzle_counter } );
    
  end;
 
end;
--------------------------------------------------------------------------------------------
function private.ClkPiece( number )

  local old_coords = ObjGet( "spr_intreehole_piece_"..number );
  local new_coords = ObjGet( "spr_intreehole_puzzle_"..number );

  ObjSet( "spr_intreehole_piece_"..number, { pos_z = 5, input = false } );
  ObjSet( "spr_intreehole_piece_"..number.."_shadow", { alp = 0 } );

  local func_after = function()

    ng_global.progress["std"]["win_intreehole"].puzzle_counter = ng_global.progress["std"]["win_intreehole"].puzzle_counter - 1;
    ng_global.progress["std"]["win_intreehole"].puzzles[number] = 1;
    ObjSet( "txt_intreehole_task", { param0 = ng_global.progress["std"]["win_intreehole"].puzzle_counter } );

    cmn.HoTaskFind( "spr_intreehole_puzzle_"..number.."_clone", "piece_"..number );

    common_impl.PlayAudio( "sfx", "common/audio/aud_ho_intreehole_paper_set", 0, "", 0 );

    if ng_global.progress["std"]["win_intreehole"].puzzle_counter == 0 then
      ObjSet( "obj_intreehole_note", { input = true } );
      ObjDelete( "obj_intreehole_note_bbt" );
      ObjSet( "txt_intreehole_task", { text = "str_evidence_2_2" } ); 
    end;
    
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_ho_intreehole_paper_click", 0, "", 0 );
  
  ObjAnimate( "spr_intreehole_piece_"..number, "pos_xy", 0, 0, func_after, { 0,0,old_coords.pos_x, old_coords.pos_y,   0.5,0,new_coords.pos_x, new_coords.pos_y } );
  ObjAnimate( "spr_intreehole_piece_"..number, "ang", 0, 0, "", { 0,0,0,   0.5,0,7.5 } );
  ObjAnimate( "spr_intreehole_piece_"..number, "alp", 0, 0, "", { 0,0,1, 0.4,0,1, 0.5,0,0 } );
  ObjAnimate( "spr_intreehole_puzzle_"..number, "alp", 0, 0, "", { 0,0,0, 0.4,0,0, 0.5,0,1 } );  

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.CompleteAnimFunc()

  local func_end = function()

    int_investigation_button.Show( true );
    interface.InvestigationButtonItemAdd( "evidence_2_6", "spr_intreehole_win", function() ObjDelete( "spr_intreehole_win" ); end );
    cmn.SetEventDone( "get_evidence_2_6" );

  end;

  interface.DialogEvidenceShow( "evidence_2_6", func_end, true );
  

end;
--------------------------------------------------------------------------------------------
function private.clk_doll( number )

  common_impl.ShowBbt( 'bbt_intreehole_clk_dolls', 1 );

  common_impl.PlayAudio( "sfx", "common/audio/aud_ho_intreehole_figure_"..number, 0, "", 0 );
  
  ObjSet( "obj_intreehole_clk_doll_"..number, { input = false } );
  
  local func_after = function()

     ObjSet( "obj_intreehole_clk_doll_"..number, { input = true } );

  end;

  AnimPlay( "anm_intreehole_doll_"..number, "DoAnim", func_after );

end;
