-- name=ho_inventory
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "inventory" );
  game.relations[ "ho_inventory" ].exitroom = "rm_mine_2";
  --------------------------------------------------------------------------------------------------
  
  ObjMultiSet( {
  
  { "spr_inventory_anvil", { event_mdown = function() private.TaskComplete( 'anvil' ) end } },
  { "spr_inventory_bowler", { event_mdown = function() private.TaskComplete( 'bowler' ) end } },
  { "spr_inventory_carbine", { event_mdown = function() private.TaskComplete( 'carbine' ) end } },
  { "spr_inventory_drawing_2", { event_mdown = function() private.TaskComplete( 'drawing_2' ) end } },
  { "spr_inventory_flask", { event_mdown = function() private.TaskComplete( 'flask' ) end } },
  { "spr_inventory_folder", { event_mdown = function() private.TaskComplete( 'folder' ) end } },
  { "spr_inventory_fork", { event_mdown = function() private.TaskComplete( 'fork' ) end } },
  { "spr_inventory_glove_2", { event_mdown = function() private.TaskComplete( 'glove_2' ) end } },
  { "spr_inventory_hammer", { event_mdown = function() private.TaskComplete( 'hammer' ) end } },
  { "spr_inventory_mask", { event_mdown = function() private.TaskComplete( 'mask' ) end } },
  { "spr_inventory_mug", { event_mdown = function() private.TaskComplete( 'mug' ) end } },
  { "spr_inventory_rope", { event_mdown = function() private.TaskComplete( 'rope' ) end } },
  { "spr_inventory_coal", { event_startdrag = function() private.GetItem( 'coal' ) end, event_dragdrop = function() private.unmark_drawing() end } },
  { "spr_inventory_glove", { event_startdrag = function() private.GetItem( 'glove' ) end, event_dragdrop = function() private.unmark_glove_2() end } }

  } );
  
  common_impl.hint[ "win_inventory" ] = {
      type = "win",
      room = "rm_mine_2",
      zz = "ho_inventory",
      zz_gate = "gho_mine_2_inventory"
  };
  
  local win_inventory_func = function ()

    if ( cmn.IsEventDone( "win_inventory" ) ) then
      interface.InventoryItemAdd( "inv_slingshotframe", "spr_inventory_win" );
    end;

  end;
  cmn.AddSubscriber( "win_inventory", win_inventory_func );

  --------------------------------------------------------------------------------------------------
  local unmark_drawing = function () 
   
    ObjSet( "spr_inventory_drawing", { alp = 1 } );
    ObjSet( "spr_inventory_drawing_2", { input = true } ); 
    ObjDelete( "spr_inventory_coal" );
    ObjDelete( "spr_inventory_coal_shadow" ); 
    ObjDelete( "obj_inventory_use_coal" );    

  end;

  cmn.AddSubscriber( "unmark_drawing", unmark_drawing, "ho_inventory" );  
  --------------------------------------------------------------------------------------------------
  local unmark_glove_2 = function () 
   
    ObjSet( "spr_inventory_glove_3", { alp = 1 } );
    ObjSet( "spr_inventory_glove_2", { input = true } ); 
    ObjDelete( "spr_inventory_glove" );
    ObjDelete( "spr_inventory_glove_shadow" ); 
    ObjDelete( "obj_inventory_use_glove" ); 

  end;

  cmn.AddSubscriber( "unmark_glove_2", unmark_glove_2, "ho_inventory" );  
  --------------------------------------------------------------------------------------------------
  local start_inventory_func = function ()

    if ( cmn.IsEventStart( "win_inventory" ) ) then

      local ho_found = ng_global.progress[ "std" ][ "win_inventory" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
      end;

    end;

    if not cmn.IsEventDone( "win_inventory" ) then

      if cmn.IsUnmarkedTask( "inventory", "drawing_2" ) then
          unmark_drawing();
      end;

      if cmn.IsUnmarkedTask( "inventory", "glove_2" ) then
          unmark_glove_2();
      end;

    end;

  end;

  local end_inventory_rm = function ()
  
    if ( cmn.IsEventDone( "win_inventory" ) ) then
      ObjDelete( "gho_mine_2_inventory" );
    end;

  end;
 
  cmn.AddSubscriber( "win_inventory", start_inventory_func, "ho_inventory" );  
  cmn.AddSubscriber( "win_inventory", end_inventory_rm, "rm_mine_2" );  

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_inventory" ) ) then
  
    cmn.InitHo( "inventory" );
    cmn.SetEventDone( "opn_inventory" );
    cmn.SetMarkedTask( "inventory", "drawing_2" );
    cmn.SetMarkedTask( "inventory", "glove_2" );
     
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "anvil",          1, 0, { { "spr_inventory_anvil" } } );
  interface.TaskPanelTaskAdd( ho_items, "bowler",          1, 0, { { "spr_inventory_bowler" } } );
  interface.TaskPanelTaskAdd( ho_items, "rope",          1, 0, { { "spr_inventory_rope" } } );
  interface.TaskPanelTaskAdd( ho_items, "carbine",          1, 0, { { "spr_inventory_carbine" } } );
  interface.TaskPanelTaskAdd( ho_items, "drawing_2",          1, 1, {  { "spr_inventory_coal", "obj_inventory_use_coal" } ,{ "spr_inventory_drawing_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "flask",          1, 0, { { "spr_inventory_flask" } } );
  interface.TaskPanelTaskAdd( ho_items, "folder",          1, 0, { { "spr_inventory_folder" } } );
  interface.TaskPanelTaskAdd( ho_items, "fork",          1, 0, { { "spr_inventory_fork" } } );
  interface.TaskPanelTaskAdd( ho_items, "glove_2",          1, 1, { { "spr_inventory_glove", "obj_inventory_use_glove" }, { "spr_inventory_glove_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "hammer",          1, 0, { { "spr_inventory_hammer" } } );
  interface.TaskPanelTaskAdd( ho_items, "mask",          1, 0, { { "spr_inventory_mask" } } );
  interface.TaskPanelTaskAdd( ho_items, "mug",          1, 0, { { "spr_inventory_mug" } } );
  

  interface.TaskPanelShow( ho_items );

  interface.InvestigationButtonCheck();

  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );
  common_impl.PlayAudio( "env", "common/audio/aud_ho_inventory_env", 1, "", 0.5 );

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Open ()
  
  common_impl.VisitMapRoom( "mine_2" );
  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();

  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0, "", 0.5 );
  common_impl.PlayAudio( "env", "common/audio/aud_ho_inventory_env", 0.5 );

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();
  
end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  ObjSet( "spr_inventory_"..task_name, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_inventory_"..task_name, task_name );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_inventory_"..name, { pos_z = 20 } );

  ObjSet( "spr_inventory_"..name.."_shadow", { alp = 0 } );



end;

--------------------------------------------------------------------------------------------
----------------------------------------------------------------------------

function private.unmark_drawing() 
 
  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_inventory_coal", "obj_inventory_use_coal" ) ) then

    common_impl.Lock(true);
    
    ObjSet( "spr_inventory_coal", { alp = 0 } );

    local func_after = function()

      common_impl.Lock(false);
  
      cmn.UnmarkTask( "inventory", "drawing_2" );
      cmn.CallEventHandler( "unmark_drawing" );

    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_ho_inventory_chalk", 0, "", 0 );

    ObjAnimate( "spr_inventory_drawing", "alp", 0, 0, func_after, { 0,3,0,  0.4,3,1 } );
   
  else

    ObjSet( "spr_inventory_coal", { pos_z = 0 } );
    ObjSet( "spr_inventory_coal_shadow", { alp = 1 } );
        
  end;

end;
----------------------------------------------------------------------------

function private.unmark_glove_2() 
 
  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_inventory_glove", "obj_inventory_use_glove" ) ) then

    common_impl.Lock(true);
    
    ObjSet( "spr_inventory_glove", { alp = 0 } );

    local func_after = function()

      common_impl.Lock(false);
  
      cmn.UnmarkTask( "inventory", "glove_2" );
      cmn.CallEventHandler( "unmark_glove_2" );

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_ho_inventory_glove", 0, "", 0 );
    
    ObjAnimate( "spr_inventory_glove_3", "alp", 0, 0, func_after, { 0,3,0,  0.4,3,1 } );
   
  else

    ObjSet( "spr_inventory_glove", { pos_z = 0 } );
    ObjSet( "spr_inventory_glove_shadow", { alp = 1 } );
        
  end;

end;
--***************************************************************************************************************

ObjAnimate( "spr_inventory_light_1", "alp", 1, 0, "", { 0,0,0, 1.5,0,1, 3,0,0 } );
ObjAnimate( "spr_inventory_light_2", "alp", 1, 0, "", { 0,0,0.5, 1,0,1, 2,0,0.5 } );

ObjAnimate( "spr_inventory_light_3", "alp", 1, 0, "", { 0,0,0, 2,0,1, 4,0,0 } );
ObjAnimate( "spr_inventory_light_4", "alp", 1, 0, "", { 0,0,0.3, 1.5,0,1, 3,0,0.3 } );
ObjAnimate( "spr_inventory_light_5", "alp", 1, 0, "", { 0,0,0.3, 2.5,0,1, 5,0,0.3 } );
