-- name=mg_gate
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_gate";

  for i = 1, 10 do

    ObjSet( "spr_gate_cogs_"..i, { event_startdrag = function() private.DragCogwheel( i ); common_impl.PlayAudio( 'sfx', 'common/audio/aud_mg_gate_get_gear', 0, '', 0 ); end, event_dragdrop = function() private.DropCogwheel( i ) end; } );
    ObjSet( "spr_gate_cogs_"..i.."_intersect", { event_mdown = function() ObjStartDrag( "spr_gate_cogs_"..i ); private.DragCogwheel( i ) end, event_dragdrop = function() private.DropCogwheel( i ) end; } );

  end;

  private.coords = { { 58,61 }, { 105,184 }, { 84,327 }, { 149,450 }, { 272,246 }, { 874,139 }, { 869, 262 }, { 954,351 }, { 968,503 }, { 836, 461 } };
  private.number = 0;
  private.state = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 };
  private.win = { 6, 9, 7, 2, 10, 1, 5, 3, 8, 4 };
  private.numstate = { };
  --------------------------------------------------------------------------------------------
  -- function win_gate () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_gate" ] = {
    type = "win",
    room = "rm_nightsvilleentrance",
    zz = "mg_gate",
    zz_gate = "gmg_nightsvilleentrance_gate"
  };

  local win_gate = function ()

    if ( cmn.IsEventDone( "win_gate" ) ) then  

      ObjSet( "obj_gate_mg", { input = false } );
      
    else

      for i = 1, #ng_global.progress[ "std" ][ "win_gate" ].numstate do
        ObjSet( "spr_gate_cogs_"..ng_global.progress[ "std" ][ "win_gate" ].numstate[i], { pos_x = private.coords[i][1], pos_y = private.coords[i][2]  } );
      end;

    end;

  end;

  local win_gate_rm = function ()

    if ( cmn.IsEventDone( "win_gate" ) ) then  

      ObjMultiSet({ 
        { "grm_nightsvilleentrance_nightsville", { input = true, active = true }},
        { "spr_nightsvilleentrance_open", { alp = 1 }}
      });
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_nightsvilleentrance_nightsville_focus");
      end;  
      ObjDelete( "gmg_nightsvilleentrance_gate" ); 
      ObjDelete( "anm_nightsvilleentrance_kids" );
      ObjDelete( "obj_nightsvilleentrance_bbt_kids" );
      ObjDelete( "anm_nightsvilleentrance_kid" ); 
      ObjDelete( "anm_nightsvilleentrance_dog" ); 

    end;
    
  end;

  cmn.AddSubscriber( "win_gate", win_gate, private.room_objname );
  cmn.AddSubscriber( "win_gate", win_gate_rm, private.room_objname );
  cmn.AddSubscriber( "win_gate", win_gate_rm, "rm_nightsvilleentrance" );
  
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Open() 
  
  common_impl.VisitMapRoom( "nightsvilleentrance" );
  if not cmn.IsEventDone( "win_gate" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();

    for j = 1, 10 do

      private.numstate[j] = ng_global.progress[ "std" ][ "win_gate" ].numstate[j];
      
    end;

    private.CheckWin();
   
  end;
  
  int_slider.InitSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_gate" ) ) then

    ng_global.progress[ "std" ][ "win_gate" ].numstate = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
    
  end;

  common_impl.PlayAudio( "env", "common/audio/aud_mg_gate_broken_gears_env", 1, "", 0 );
  
  interface.InvestigationButtonCheck();

end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_gate" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()


  ng_global.progress[ "std" ][ "win_gate" ].numstate = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };
  private.numstate = { 1, 2, 3, 4, 5, 6, 7, 8, 9, 10 };

  for i = 1, #ng_global.progress[ "std" ][ "win_gate" ].numstate do
     ObjSet( "spr_gate_cogs_"..ng_global.progress[ "std" ][ "win_gate" ].numstate[i], { pos_x = private.coords[i][1], pos_y = private.coords[i][2], input = true  } );
     ObjSet( "spr_gate_cogs_"..ng_global.progress[ "std" ][ "win_gate" ].numstate[i].."_light", { visible = false  } );
  end;
  

end;
--*********************************************************************************************************************
function public.Skip()
port.skip_mg = true;
  common_impl.Lock( true );

  for i = 1, 10 do

    local number = private.win[i];
    local get = ObjGet( "spr_gate_cogs_"..number );

    ObjAnimate( "spr_gate_cogs_"..number, "pos_xy", 0, 0, "", { 0,0,get.pos_x,get.pos_y, 0.5,0,private.coords[i][1], private.coords[i][2] } );
    ObjSet( "spr_gate_cogs_"..number.."_light", { visible = true } );

  end;

  ObjSet( "tmr_gate_win", { playing = 1, time = 0.5, endtrig = private.Win } );
  
end;
--*********************************************************************************************************************
function private.WinEnd()

  
  cmn.MiniGameHide();
  cmn.SetEventDone( "win_gate" );
  common_impl.PassingMgWin();

  common_impl.Lock( false );
  cmn.CallEventHandler( "win_gate" );
  
  common_impl.GotoRm( "nightsvilleentrance" );

end;
--*********************************************************************************************************************
function private.Win()

  ObjMultiSet( {

  { "obj_gate_mg", { alp = 0 } },
  { "anm_gate_loop", { alp = 0 } },
  { "obj_gate_decor", { alp = 0 } },
  { "anm_gate_win", { alp = 1 } },
  { "spr_gate_wings", { alp = 0 } }

  } );

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_gate_win", 0, "", 0 );

  common_impl.StopAudio( "env", "common/audio/aud_mg_gate_broken_gears_env", 0.5 );
  
  AnimPlay( "anm_gate_win", "DoAnim", private.WinEnd );

end;
--*********************************************************************************************************************
private.pos_start_drag_x = 0;
private.pos_start_drag_y = 0;

function private.DragCogwheel( number )

  ObjSet( "spr_gate_cogs_"..number, { pos_z = 5 } );
  
  private.pos_start_drag_x = ObjGet( "spr_gate_cogs_"..number ).pos_x;
  private.pos_start_drag_y = ObjGet( "spr_gate_cogs_"..number ).pos_y;
  
  for i = 1, #private.coords do

    if ObjGet( "spr_gate_cogs_"..number ).pos_x == private.coords[i][1] and ObjGet( "spr_gate_cogs_"..number ).pos_y == private.coords[i][2] then

       private.number = i;

       break;

    end;

  end;
 
end;
--*********************************************************************************************************************
function private.DropCogwheel( number )
    
  local new_number = 0;
  local change_flag = false;
  local param_old = GetGameCursorPos();

  if (tostring(GetPlatform()) == "ios") or (tostring(GetPlatform()) == "android") then
    param_old[2] = param_old[2]+50;
  end;
  
  local func_after = function( num )

    common_impl.Lock( false );

    --ObjStartDrag( "spr_gate_cogs_"..new_number );
    
    ObjSet("spr_gate_cogs_"..num,{ pos_x = private.pos_start_drag_x, pos_y = private.pos_start_drag_y });
    private.DropCogwheel(num);
    
    common_impl.SetCursor( CURSOR_HAND );
    private.state[new_number] = 0;
       
    if private.CheckWin() == true then

      private.Win();

    end;

  end;

  for i = 1, 10 do

    if ( common.ApplyObj( "spr_gate_cogs_"..number.."_intersect", "spr_gate_cogs_"..i.."_intersect" ) and i ~= number and ObjGet( "spr_gate_cogs_"..i ).input == true ) then
       
        local param_new = ObjGet( "spr_gate_cogs_"..i );  
        new_number = i;
        change_flag = true;

        common_impl.Lock( true );

        for j = 1, #private.coords do

          if param_new.pos_x == private.coords[j][1] and param_new.pos_y == private.coords[j][2] then

             private.numstate[j] = number;

             if private.numstate[j] == private.win[j] then

              common_impl.PlayAudio( "sfx", "common/audio/aud_mg_gate_set_gear_true", 0, "", 0 );

             else

              common_impl.PlayAudio( "sfx", "common/audio/aud_mg_gate_set_gear", 0, "", 0 );

             end;

          end;

        end;

        ObjSet( "spr_gate_cogs_"..i, { pos_z = 5 } );
        ObjSet( "spr_gate_cogs_"..number, { pos_z = 0 } );

        ObjAnimate( "spr_gate_cogs_"..number, "pos_xy", 0, 0, function() func_after(i) end, { 0,0,param_old[1],param_old[2], 0.3,0,param_new.pos_x,param_new.pos_y } ); 
        ObjAnimate( "spr_gate_cogs_"..i, "pos_xy", 0, 0, "", { 0,0,param_new.pos_x,param_new.pos_y, 0.3,0,param_old[1],param_old[2] } );    

        break;

    end;

  end;


  if change_flag == false then

    common_impl.Lock( true );

    local func_2_after = function()

      common_impl.Lock( false );
      ObjSet( "spr_gate_cogs_"..number, { pos_z = 0 } );
      common_impl.SetCursor( CURSOR_DEFAULT );
      private.numstate[private.number] = number;
      

      if private.CheckWin() == true then

        private.Win();

      else

        for j = 1, 10 do

          ng_global.progress[ "std" ][ "win_gate" ].numstate[j] = private.numstate[j];

        end;      

      end;

    end;

    if private.win[private.number] == number then

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_gate_set_gear_true", 0, "", 0 );

    else

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_gate_set_gear", 0, "", 0 );

    end;

    ObjAnimate( "spr_gate_cogs_"..number, "pos_xy", 0, 0, func_2_after, { 0,0,param_old[1],param_old[2], 0.4,0, private.coords[private.number][1], private.coords[private.number][2] } ); 
    
  end;

end;
--*********************************************************************************************************************
function private.CheckWin()

  local win_counter = 0;

  for i = 1, #ng_global.progress[ "std" ][ "win_gate" ].numstate do
   
    if private.numstate[i] == private.win[i] then

      ObjSet( "spr_gate_cogs_"..private.numstate[i], { input = false } );
      ObjSet( "spr_gate_cogs_"..private.numstate[i].."_light", { visible = true } );
      win_counter = win_counter + 1;

    end;
  end;

  if win_counter == 10 then

    return true;
  
  end;

end;