-- name=mg_key
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_key";
  private.pos_x_cur = 0;
  private.pos_x_cur = 0;
  private.current_point = { 1, 1 }
  private.sequence = { { 1,1 } ,{ 1,2 }, { 2,3 }, { 1,4 }, { 1,5 }, { 2,5 }, { 3,6 }, { 2,7 }, { 1,7 }, { 1,8 }, { 2,8 }, { 2,9 }, { 1,9 }, { 1,10 }, { 2,10 }, { 2,11 }, { 2,12 }, { 1,12 } };
  private.drill_pos_x = { -28, 9, 39, 72};
  private.win_comb = { { true, 3 }, { false, 3 }, { true, 1 }, { true, 2 }}; 
  
  ObjMultiSet({ 

    { "spr_key_key", { event_mdown = private.get_hydrantwrench }},
    { "obj_key_clk_lever", { event_mdown = private.clk_lever }},
    { "obj_key_clk_drill_next", { event_mdown = function () private.clk_drill( -1 ) end,
                                  event_menter = function () private.change_drill_menter( "spr_key_clk_drill_next_focus" ) end,
                                  event_mleave = function () private.change_drill_mleave( "spr_key_clk_drill_next_focus" ) end  }},
    { "obj_key_clk_drill_previous", { event_mdown = function () private.clk_drill( 1 ) end,

                                  event_menter = function () private.change_drill_menter( "spr_key_clk_drill_previous_focus" ) end,
                                  event_mleave = function () private.change_drill_mleave( "spr_key_clk_drill_previous_focus" ) end  }},

    { "obj_key_arrow_clk_left", { event_mdown = function () private.clk_arrow('left') end; }},
    { "obj_key_arrow_clk_right", { event_mdown = function () private.clk_arrow('right') end; }},
    { "obj_key_arrow_clk_press", { event_mdown = private.clk_press }},
    { "obj_key_light_1_1", { event_mdown = function () private.clk_pen(1,1) end, event_drag = function () private.drag_pen(1,1) end, event_dragdrop = function () private.drop_pen(1,1) end; }},
    { "obj_key_picture_clk", { event_mdown = private.picture_clk } },
  });

  ObjSet("obj_key_light_1_1",{ input = 0, drag = false });
  ObjSet("obj_key_glow",{ input = 1, drag = false });
  ObjSet("obj_key_input",{ input = 0, drag = false });
  
  ObjSet( "spr_key_point_glow_1_2", {
    event_mdown = function () private.clk_pen(1,2) end,
    input = true
  });
  ObjSet( "spr_key_point_glow_2_1", {
    event_mdown = function () private.clk_pen(2,1) end,
    input = true
  });
  ObjSet( "spr_key_point_glow_2_2", {
    event_mdown = function () private.clk_pen(2,2) end,
    input = true
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_key = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 

      {
        private.room_objname,
      };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_key", update_game_mode_key, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hydrantwrench () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hydrantwrench" ] = {
    type = "get",
    get_obj = "spr_key_key",
    room = "rm_nightsville",
    zz = "mg_key",
    zz_gate = "gmg_nightsville_key"
  };
    
  local get_hydrantwrench_inv = function ()
  
    interface.InventoryItemAdd( "inv_hydrantwrench", "spr_key_key" );
  
  end;
  
  local get_hydrantwrench_closezz = function ()
  
    ObjDelete( "gfx_key_hydrantwrench" );
  
  end;

  local get_hydrantwrench_nightsville = function ()
  
    ObjDelete( "gmg_nightsville_key" );
 
  end;
  
  cmn.AddSubscriber( "get_hydrantwrench", get_hydrantwrench_inv );
  cmn.AddSubscriber( "get_hydrantwrench", get_hydrantwrench_closezz, private.room_objname );
  cmn.AddSubscriber( "get_hydrantwrench", get_hydrantwrench_nightsville, "rm_nightsville" );
  --------------------------------------------------------------------------------------------
  -- function win_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_key" ] = {
    type = "click",
    room = "rm_nightsville",
    use_place = "gmg_nightsville_key"
  };

  local win_key = function ()

  private.LoadMK();

    if ( cmn.IsEventDone( "win_key" ) ) then

      ObjMultiSet({

       { "spr_key_note_big", { alp = 0, input = false } },
       { "obj_key_clk_lever", { input = false } },
       { "obj_key_clk_drill", { input = false } },
       { "obj_key_arrow_clk_left", { input = false } },
       { "obj_key_arrow_clk_right", { input = false } },
       { "obj_key_arrow_clk_press", { input = false } },
       { "gfx_key_key", { active = true } },
       { "spr_key_key", { input = true } },
       { "obj_key_picture_clk", { input = false } },
       { "spr_key_keypicture_right", { alp = 1} },
      });

    else

      if ( ng_global.progress[ "std" ][ "win_key" ].current_num == 18 ) then

        ObjMultiSet({
          { "spr_key_note_big", { alp = 0, input = false } },
          { "spr_key_keypicture_right", { alp = 1} },
        });
        
        private.InitMakingKey(); 


      else
        if ( ng_global.progress[ "std" ][ "win_key" ].current_num > 1 ) then
          private.LoadPaint();
          private.ShowChoice();
        end;       
      end;

    end;

  end;

  cmn.AddSubscriber( "win_key", win_key, private.room_objname );
  
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Open() 

  common_impl.VisitMapRoom( "nightsville" );
  if not cmn.IsEventDone( "win_key" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_key" ) ) then

    ng_global.progress[ "std" ][ "win_key" ].lever = false;
    ng_global.progress[ "std" ][ "win_key" ].current_num = 1;
    ng_global.progress[ "std" ][ "win_key" ].drill_pos = 1;
    ng_global.progress[ "std" ][ "win_key" ].drill_type = 1;
    ng_global.progress[ "std" ][ "win_key" ].done_cells = { false, false, false, false }; 
    private.LoadMK();
  end;

  private.done_cells = {};
  private.lever = ng_global.progress[ "std" ][ "win_key" ].lever;
  for i = 1, #ng_global.progress[ "std" ][ "win_key" ].done_cells do
    
    private.done_cells[i] = ng_global.progress[ "std" ][ "win_key" ].done_cells[i];

  end;

  interface.InvestigationButtonCheck();

end;
--*********************************************************************************************************************
function public.Close()
  
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_key" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
function public.Reset()

  if ( ng_global.progress[ "std" ][ "win_key" ].current_num == 18 ) then

  local end_func = function ()

    local table_multiset = {};

    common_impl.Lock(false);

    private.WrongAnim();

    ng_global.progress[ "std" ][ "win_key" ].done_cells = { false, false, false, false }; 

    for i = 1 ,#ng_global.progress[ "std" ][ "win_key" ].done_cells do

      table.insert( table_multiset, { "spr_key_key_part_"..i, { alp = 1 } } );

    end;

    ObjMultiSet( table_multiset );

  end;
  
  common_impl.Lock(true); 
 
  ObjSet( "spr_key_note_big", { alp = 1, input = true } );

  ObjAnimate( "spr_key_note_big", "pos_xy", 0, 0, "",
  {
    0.0, 3, 200, 400,
    0.3, 3, 512, 384
  });

  ObjAnimate( "spr_key_note_big", "scale_xy", 0, 0, end_func,
  {
    0.0, 3, 0.0, 0.0,
    0.3, 3, 1.0, 1.0,
    0.5, 3, 1.0, 1.0

  });
  else

    private.WrongAnim();

  end;
  
end;
--*********************************************************************************************************************
function public.Skip()
port.skip_mg = true;
  local end_func = function ()
    
    local func_after = function ()

      private.Win();

      ObjSet( "obj_key_picture_clk", { input = false } );

      ng_global.progress[ "std" ][ "win_key" ].done_cells = { true, true, true, true };

    end;
    
    ObjAnimate( "spr_key_keypicture_right", "alp", 0, 0, "", { 0, 2, ObjGet( "spr_key_keypicture_right" ).alp,  0.2, 2, 1 });

    for i = 1, #ng_global.progress[ "std" ][ "win_key" ].done_cells do

      local obj_name = "spr_key_key_part_"..i;
      local obj_alp = ObjGet( obj_name ).alp;

      ObjAnimate( obj_name, "alp", 0, 0, func_after, { 0, 2, obj_alp,  0.2, 2, 0 });
      func_after = nil;

    end;

  end;

  if ng_global.progress[ "std" ][ "win_key" ].current_num == 18 then

    end_func();

  else

    private.AnimPaintWin(end_func);
  
  end;
 

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.get_hydrantwrench()

  cmn.SetEventDone( "get_hydrantwrench" );
  cmn.CallEventHandler( "get_hydrantwrench" );
  cmn.GotoRoom( "rm_nightsville" );

end;
--*********************************************************************************************************************
-- function *** CLK FUNCTION *** () end;
--*********************************************************************************************************************
function private.clk_lever()

  local func_after = function ()

    common_impl.Lock( false );
    ng_global.progress[ "std" ][ "win_key" ].lever = private.lever;
  
  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_key_lift", 0, "", 0 );
  
  if ( not private.lever ) then

    private.lever = true;

    ObjAnimate( "spr_key_lever", "pos_y", 0, 0, "",
    { 
      0.0, 0, ObjGet("spr_key_lever").pos_y, 
      0.5, 0, 393
    } );

    ObjAnimate( "obj_key_move", "pos_y", 0, 0, func_after,
    { 
      0.0, 0, ObjGet("obj_key_move").pos_y, 
      0.5, 0, 17
    } );
  
  else

    private.lever = false;

    ObjAnimate( "spr_key_lever", "pos_y", 0, 0, "",
    { 
      0.0, 0, ObjGet("spr_key_lever").pos_y, 
      0.5, 0, 349
    } );

    ObjAnimate( "obj_key_move", "pos_y", 0, 0, func_after,
    { 
      0.0, 0, ObjGet("obj_key_move").pos_y, 
      0.5, 0, 4
    } );
 
  end;

end;
--------------------------------------------------------------------------------------------
function private.clk_drill( num )

  local dril_type = ng_global.progress[ "std" ][ "win_key" ].drill_type;
  local dril_cur = "spr_key_drill_"..dril_type;
  
  num = tonumber( num );
   
  if ( ( dril_type > 2 ) and ( num > 0 ) ) then
    dril_type = dril_type - 3;
  end;

  if ( ( dril_type < 2 ) and ( num < 0 )  ) then
    dril_type = dril_type + 3;
  end;

  dril_type = dril_type + tonumber( num );

  local next_dril = "spr_key_drill_"..dril_type;
  local next_dril_y = ObjGet( next_dril ).y;
  local dril_cur_y = ObjGet( dril_cur ).y;
  
  local end_func = function()

    common_impl.Lock( false ); 
    ng_global.progress[ "std" ][ "win_key" ].drill_type = dril_type;
    
  end;
  local end_func2 = function ()

  ObjMultiSet({
    { next_dril, { pos_y = next_dril_y, alp = 1 } },
    { dril_cur, { pos_y = dril_cur_y, alp = 0 } }
  })

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_key_touch_drill", 0, "", 0 );

  ObjAnimate( dril_cur, "pos_y", 0, 1, end_func2, { 0.0, 3, 0,  0.5, 3, -100 });
  ObjAnimate( next_dril, "pos_y", 0, 1, end_func, { 0.0, 0, 0, 0.7, 3, -100, 1.2, 3, 0 });
  
end;
--------------------------------------------------------------------------------------------
function private.clk_arrow( arrow )

  local cur_pos =  private.drill_pos_x[ ng_global.progress[ "std" ][ "win_key" ].drill_pos ];
  local next_pos =  private.drill_pos_x[ng_global.progress[ "std" ][ "win_key" ].drill_pos - 1];
  
  if ( arrow == 'right' ) then

    next_pos = private.drill_pos_x[ng_global.progress[ "std" ][ "win_key" ].drill_pos + 1];

  end;

  local func_after = function ()

    common_impl.Lock( false );

    if ( arrow == 'right' ) then 

      ng_global.progress[ "std" ][ "win_key" ].drill_pos = ng_global.progress[ "std" ][ "win_key" ].drill_pos + 1 ;

    else
      
      ng_global.progress[ "std" ][ "win_key" ].drill_pos = ng_global.progress[ "std" ][ "win_key" ].drill_pos - 1;

    end;

  end;

  if ( next_pos ) then

    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_key_machine_move", 0, "", 0 );

    ObjAnimate( "obj_key_drill", "pos_x", 0, 0, func_after, { 0, 3, cur_pos, 0.4, 3, next_pos});

  end;

  ObjAnimate( "spr_key_arrow_"..arrow, "color_rgb", 0, 0, "", 
  { 
    0.0, 3, 1.0, 1.0, 1.0, 
    0.1, 3, 0.5, 0.5, 0.5,
    0.2, 3, 1.0, 1.0, 1.0
  });

end;
--------------------------------------------------------------------------------------------
function private.clk_press()

   ObjAnimate( "spr_key_button_press", "color_rgb", 0, 0, "", 
  { 
    0.0, 3, 1.0, 1.0, 1.0, 
    0.1, 3, 0.5, 0.5, 0.5,
    0.2, 3, 1.0, 1.0, 1.0
  });

  if not ng_global.progress[ "std" ][ "win_key" ].done_cells[ng_global.progress[ "std" ][ "win_key" ].drill_pos] then

    local dril_name = "spr_key_drill_"..ng_global.progress[ "std" ][ "win_key" ].drill_type;
    local key_pos_y = ObjGet("spr_key_key_wrong").pos_y;
  ----
    local win_func_after = function ()

      private.done_cells[ng_global.progress[ "std" ][ "win_key" ].drill_pos] = true;
      ng_global.progress[ "std" ][ "win_key" ].done_cells[ng_global.progress[ "std" ][ "win_key" ].drill_pos] = true;

      if private.CheckWin() then 
        private.Win(); 
      end;

      common_impl.Lock( false );  
      
    end;
  ----
    local lose_func_after = function ()

      local func_set_key = function ()

        local func_end = function()

          common_impl.Lock( false );

          ObjMultiSet({
            { "spr_key_key", { alp = 1 } },
            { "spr_key_keydummy", { alp = 0 } }
          });

        end;

        ObjSet( "spr_key_key_wrong", { pos_y = key_pos_y, alp = 0 });

        ObjAnimate( "spr_key_keydummy" , "alp", 0, 0, func_end, { 0, 0, 0,  0.5, 0, 1 });


      end;

      ObjAnimate( "spr_key_key_wrong" , "pos_y", 0, 0, func_set_key, { 0, 1, key_pos_y,  1, 1, 1000,  });
      
      table_multiset = {};

      for i = 1, #ng_global.progress[ "std" ][ "win_key" ].done_cells do

        ng_global.progress[ "std" ][ "win_key" ].done_cells[i] = false;
        table.insert( table_multiset, { "spr_key_key_part_"..i, { alp = 1 } } );
        
      end;

      ObjMultiSet(table_multiset);

    end;
  ----
    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_key_red", 0, "", 0 );

    ObjAnimate( dril_name, "pos_y", 0, 1, "", { 0, 1, 0,  0.5, 2, 32, 1.0, 2, 32, 1.5, 2, 0 });

    if ( private.CheckMakeCell() ) then

      ObjAnimate( "spr_key_key_part_"..ng_global.progress[ "std" ][ "win_key" ].drill_pos , "alp", 0, 0, win_func_after, { 0, 1, 1,  0.5, 2, 1,  1.0, 2, 0,  1.5, 2, 0 });

    else

      local func_sound = function()

        common_impl.PlayAudio( "sfx", "common/audio/aud_mg_key_breaks", 0, "", 0 );

      end;

      ObjAnimate( "spr_key_key" , "alp", 0, 0, func_sound, { 0, 1, 1,   0.5, 2, 1,    0.5, 2, 0 });
      ObjAnimate( "spr_key_keydummy" , "alp", 0, 0, "", { 0, 1, 0,   0.5, 2, 0,    0.5, 2, 1,    1.0, 2, 0 });
      ObjAnimate( "spr_key_key_wrong" , "alp", 0, 0, lose_func_after, { 0, 1, 0,  0.5, 2, 0,  1.0, 2, 1 });

     
    end;
  end;
end;
--*********************************************************************************************************************
-- function *** WIN FUNCTION *** () end;
--*********************************************************************************************************************
function private.Win()
  cmn.MiniGameHide();
  cmn.SetEventDone( "win_key" );
  cmn.CallEventHandler( "win_key" );
  common_impl.PassingMgWin();

end;
-----------------------------------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** OTHER FUNCTION *** () end;
--*********************************************************************************************************************
--получаем начальные координаты дамика
private.old = { 1, 1 };
function private.returnBackPoint()
  
  local current_point = private.sequence[ng_global.progress[ "std" ][ "win_key" ].current_num];
  private.old[1] = current_point[1];
  private.old[2] = current_point[2];

  ObjSet("obj_key_light_1_1",{ pos_x = ObjGet("spr_key_point_glow_"..current_point[1].."_"..current_point[2]).pos_x});
  ObjSet("obj_key_light_1_1",{ pos_y = ObjGet("spr_key_point_glow_"..current_point[1].."_"..current_point[2]).pos_y});
  
  
end;

function private.clk_pen( i, j )
  
  DbgTrace("private.clk_pen("..tostring(i)..","..tostring(j)..")");
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_key_click", 0, "", 0 );

  
  private.pos_x_cur = ObjGet( "obj_key_light_1_1" ).pos_x;
  private.pos_y_cur = ObjGet( "obj_key_light_1_1" ).pos_y;

  ObjSet("obj_key_light_1_1",{ pos_x = ObjGet("spr_key_point_glow_"..i.."_"..j).pos_x});
  ObjSet("obj_key_light_1_1",{ pos_y = ObjGet("spr_key_point_glow_"..i.."_"..j).pos_y});

  
  private.drag_pen( i, j );
  private.drop_pen( i, j);
  
end;

function private.drag_pen( i, j )

  common_impl.SetCursor( CURSOR_GET );

  local taken_number = tonumber( i );--номер взятого кольца
  local connect_number = tonumber( j ); --номер кольца на втором конце веревки

    if ObjIntersect( "obj_key_light_1_1", "obj_key_input" ) then--если мы не выходим за границу

      local cur_pos = GetGameCursorPos();
      pos_x1 = cur_pos[ 1 ]-512;
      pos_y1 = cur_pos[ 2 ]-384;

      pos_x2 = ObjGet( "obj_key_light_1_1" ).pos_x;--получаем координаты второго
      pos_y2 = ObjGet( "obj_key_light_1_1" ).pos_y;

      dx = pos_x1 - pos_x2;
      dy = pos_y1 - pos_y2;
      s = math.sqrt(dx^2+dy^2);--длина веревки, соединенная с данным
      angl = (math.atan2(dy,dx))*(-1) - 1.57; 
      lenght = 42;--коэффициент

      ObjSet( "tmr_key_line", 
      { 
        playing = true, 
        time = 0.01,  
        endtrig = function() private.drag_pen(i, j) end ;
      } );

      ObjSet( "spr_key_line", { alp = 1 } );
      ObjSet( "spr_key_line",--изменение параметров веревки
        {
         pos_x = pos_x1,
         pos_y = pos_y1,
         ang = angl, 
         scale_y = s / lenght,
        } );

    else 

      private.drag_line_stop();

    end;

end;

function private.drag_line_stop()

  ObjSet( "tmr_key_line", { playing = 0 } );
  ObjSet( "spr_key_line", { alp = 0 } );
  
end;
-----------------------------------------------------------------------------------
function private.drop_pen( i, j)
  DbgTrace("private.drop_pen()");
  common_impl.SetCursor( CURSOR_DEFAULT );
  local name = "obj_key_light_1_1";
  local star = {};
  local old = {};
  old[1] = private.old[1];
  old[2] = private.old[2];

  --[[поиск куда бросили ]]
  local pos = GetGameCursorPos();
  DbgTrace("pos[1]:"..tostring(pos[1]).." pos[2]:"..tostring(pos[2]));
  pos[1] = pos[ 1 ]-512;
  pos[2] = pos[ 2 ]-384;
  
    if  tostring(GetPlatform()) == "android" then
     pos[2] = pos[2] - 100;
    elseif tostring(GetPlatform()) == "ios" then
      if port.isTablet() == 0 then
        pos[2] = pos[2] - 75;
      else
        pos[2] = pos[2] - 50;
      end;
    end;
    DbgTrace("pos[1]:"..tostring(pos[1]).." pos[2]:"..tostring(pos[2]));

  ObjSet(name ,{pos_x = pos[1] , pos_y = pos[2] });
  local pos_name = GetObjPosByObj(name,"ne_origin");
  local pos_spr = GetObjPosByObj("spr_key_point_glow_"..i.."_"..j,"ne_origin");
  
  DbgTrace("name pos_x:"..tostring(pos_name[1]).." pos_y:"..tostring(pos_name[2]));
  DbgTrace("spr_key_point_glow_"..tostring(i).."_"..tostring(j).." pos_x:"..tostring(pos_spr[1]).." pos_y:"..tostring(pos_spr[2]));
  
  --for i = 1, 3 do  
  --  for j = 1, 12 do  
  --    if common.ApplyObj( name, "spr_key_point_glow_"..i.."_"..j ) then
  --      star[1] = i;
  --      star[2] = j;
  --    end;
  --  end;
  --end;
  star[1] = i;
  star[2] = j;
  
  local pos_star = { 
    private.pos_x_cur, 
    private.pos_y_cur
  };

  if star[1] and star[2] then

    local pos_star_2 = { 
      ObjGet( "spr_key_point_glow_"..star[1].."_"..star[2] ).pos_x, 
      ObjGet( "spr_key_point_glow_"..star[1].."_"..star[2] ).pos_y 
    };
    
    DbgTrace("MakeLine");
    private.MakeLine( pos_star, pos_star_2, star[1],star[2], old[1],old[2] );
    
 
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_key_true", 0, "", 0 );
    
  else
    DbgTrace("WrongAnim");
 
    private.WrongAnim( i, j);
    
  end;
    private.drag_line_stop();
end;
-----------------------------------------------------------------------------------
function private.MakeLine( elem_1, elem_2, i, j, n, m, save )
  
  DbgTrace("MakeLine i="..tostring(i).." =j"..tostring(j).." n="..tostring(n).." m="..tostring(m));
  local pos_x1 = elem_1[ 1 ];
  local pos_y1 = elem_1[ 2 ];

  local pos_x2 = elem_2[ 1 ]--получаем координаты второго элемента
  local pos_y2 = elem_2[ 2 ];

  local offset_x = 0;
  local offset_y = 0;

  local wrong = false;

  if ( i-n == 1 and j-m == 1) then -- { 1,1; 2,2 }

    offset_x = 25;
    offset_y = 23;

  elseif( i-n == 0 and j-m == 1 ) then -- { 1,1; 1,2 }
  
    offset_x = 22;
    offset_y = 0;

  elseif( i-n == 1 and j-m == 0 ) then -- { 1,1; 2,1 }

    offset_x = 2;
    offset_y = 25;

  elseif( i-n == 2 and j-m == 1 ) then -- { 1,1; 3,2 }

    offset_x = 22;
    offset_y = 40;

  elseif ( i-n == -1 and j-m == -1) then -- { 2,2; 1,1 }

    offset_x = -25;
    offset_y = -23;

  elseif( i-n == 0 and j-m == -1 ) then -- { 1,2; 1,1 }
    
    offset_x = -22;
    offset_y = 0;

  elseif( i-n == -1 and j-m == 0 ) then -- { 2,1; 1,1 }

    offset_x = 1;
    offset_y = -25;

  elseif( i-n == -2 and j-m == -1 ) then -- { 3,2; 1,1 }

    offset_x = -22;
    offset_y = -40;

  elseif ( i-n == -1 and j-m == 1 ) then -- { 2,1; 1,2 }

    offset_x = 25;
    offset_y = -23;

  elseif ( i-n == 1 and j-m == -1 ) then -- { 1,2; 2,1 }

    offset_x = -25;
    offset_y = 23;

  elseif( i-n == -2 and j-m == 1 ) then -- { 3,1; 1,2 }

    offset_x = 22;
    offset_y = -40;

  elseif( i-n == 2 and j-m == -1 ) then -- { 1,2; 3,1 }

    offset_x = -22;
    offset_y = 40;

  else wrong = true; 

  end;

  local dx = pos_x1 - pos_x2;
  local dy = pos_y1 - pos_y2;
  local s = math.sqrt(dx^2+dy^2);--длина веревки, соединенная с данным кольцом
  local angl = (math.atan2(dy,dx))*(-1) - 1.57; 
  local lenght = 42;--коэффициент

  ObjSet( "spr_key_line", { alp = 0 } );

  DbgTrace("wrong = "..tostring(wrong));
  if wrong == false then
  
    local funcMakeLine = function() 
      DbgTrace("funcMakeLine");
      ObjCreate( "spr_key_line_"..i.."_"..j, "spr" );
      ObjAttach( "spr_key_line_"..i.."_"..j, "obj_key_line" );
      ObjSet( "spr_key_line_"..i.."_"..j,
        {
         res = "assets/levels/level2/mg_key/layers/thread",
         pos_x =  pos_x1 + offset_x,
         pos_y =  pos_y1 + offset_y,
         ang = angl, 
         scale_y = s / lenght,
         color_r = 0,
         color_g = 0,
         color_b = 0
        } );  

      local pos_star = { 
      private.pos_x_cur, 
      private.pos_y_cur
      };

      local pos_star_2 = { 
      ObjGet( "spr_key_point_glow_"..i.."_"..j ).pos_x, 
      ObjGet( "spr_key_point_glow_"..i.."_"..j ).pos_y 
      };

      ObjSet( "obj_key_light_1_1", { 
      pos_x = pos_star_2[1],
      pos_y = pos_star_2[2],
      event_down = function () private.clk_pen(i,j) end,
      event_drag = function () private.drag_pen(i,j) end,
      event_dragdrop = function () private.drop_pen(i,j) end;

    }); 
    end;
  
    if i == private.sequence[ng_global.progress[ "std" ][ "win_key" ].current_num + 1][1] and j == private.sequence[ng_global.progress[ "std" ][ "win_key" ].current_num + 1][2] then

      if ( not save ) then

        if private.CheckPaintWin() then

          local end_func = function ()

            ng_global.progress[ "std" ][ "win_key" ].current_num = ng_global.progress[ "std" ][ "win_key" ].current_num + 1;

          end;

          private.RightAnim();
          private.AnimPaintWin(end_func);
          private.InitMakingKey();

        else
          
          funcMakeLine();
          --private.clk_pen(i,j);
          ng_global.progress[ "std" ][ "win_key" ].current_num = ng_global.progress[ "std" ][ "win_key" ].current_num + 1;
          private.ShowChoice(true,true);
          

        end;

      else

        ng_global.progress[ "std" ][ "win_key" ].current_num = ng_global.progress[ "std" ][ "win_key" ].current_num + 1; 
        funcMakeLine();
      end; 

    elseif not save then
      DbgTrace("WrongAnim = 1");
      private.WrongAnim(i,j);

    end;
  
  else

    if not save then 
  
      DbgTrace("WrongAnim = 2");
      private.WrongAnim(i,j);

    end; 

  end;

end;
-----------------------------------------------------------------------------------
function private.ShowChoice(not_save,startdrag)

  local current_point = private.sequence[ng_global.progress[ "std" ][ "win_key" ].current_num];

  local previous_name = {};
  
  if private.sequence[ng_global.progress[ "std" ][ "win_key" ].current_num - 1] then

    local previous_point = private.sequence[ng_global.progress[ "std" ][ "win_key" ].current_num - 1];
    previous_name = "spr_key_point_glow_"..( previous_point[1]).."_"..( previous_point[2]);

  end;
  
  local glow_name = {};
  
  private.old[1] = current_point[1];
  private.old[2] = current_point[2];
  
  ObjSet("obj_key_light_1_1",{ pos_x = ObjGet("spr_key_point_glow_"..current_point[1].."_"..current_point[2]).pos_x});
  ObjSet("obj_key_light_1_1",{ pos_y = ObjGet("spr_key_point_glow_"..current_point[1].."_"..current_point[2]).pos_y});

  
  table.insert( glow_name, "spr_key_point_glow_"..( current_point[1] - 1 ).."_"..( current_point[2]) );
  table.insert( glow_name, "spr_key_point_glow_"..( current_point[1] + 1 ).."_"..( current_point[2]) );
  table.insert( glow_name, "spr_key_point_glow_"..( current_point[1] ).."_"..( current_point[2]+1 ) );
  table.insert( glow_name, "spr_key_point_glow_"..( current_point[1] + 1 ).."_"..( current_point[2] + 1 ) );
  table.insert( glow_name, "spr_key_point_glow_"..( current_point[1] - 1 ).."_"..( current_point[2] + 1 ) );

  if ( not_save ) then

    common_impl.Lock( true );

  end;

  local func_after = function()

    if startdrag then

      --ObjStartDrag( "obj_key_light_1_1" );
      
    end;

    common_impl.Lock( false );

  end;

  for i = 1, 3 do

    for j = 1, 12 do

        if ObjGet( "spr_key_point_glow_"..i.."_"..j ).alp == 1 then
          
          if ( not_save ) then
            ObjAnimate( "spr_key_point_glow_"..i.."_"..j, "alp", 0, 0, "", { 0,0,1, 0.2,0,0 } );
          else
            ObjSet( "spr_key_point_glow_"..i.."_"..j, { alp = 0 } );
          end;

          ObjSet( "spr_key_point_glow_"..i.."_"..j, {
            input = false
          });
          
        end;

    end;
  
  end;
  
    for i = 1, #glow_name do

      if (  ObjGet( glow_name[i])  and ( previous_name ~= glow_name[i] ) and  not ( glow_name[i] == "spr_key_point_glow_3_12" and ng_global.progress[ "std" ][ "win_key" ].current_num == 17 ) ) then

        if ( not_save ) then 

          ObjAnimate( glow_name[i], "alp", 0, 0, func_after, { 0,0,0, 0.2,0,1 } );
          local str = ObjGet(glow_name[i]).name;
          local num1 = tonumber(string.sub(str,20,20));
          local num2 = tonumber(string.sub(str,22));
          
          ObjSet( glow_name[i], {
          event_mdown = function () private.clk_pen(num1,num2) end,
          input = true
          }); 
          
          func_after = nil;

        else

          ObjSet( glow_name[i], { alp = 1 } );
          local str = ObjGet(glow_name[i]).name;
          local num1 = tonumber(string.sub(str,20,20));
          local num2 = tonumber(string.sub(str,22));
          
          ObjSet( glow_name[i], {
          event_mdown = function () private.clk_pen(num1,num2) end,
          input = true
          }); 
          
        end;

      end;

    end;
    DbgTrace("============ShowChoice=======================");
          
end;
------------------------------------------------------------------------------------
function private.State_point_glow()
  --fix
  local current_point = private.sequence[ng_global.progress[ "std" ][ "win_key" ].current_num];

  for i = 1, 3 do

    for j = 1, 12 do

      if ObjGet( "spr_key_point_glow_"..i.."_"..j ).alp == 1 then

        ObjSet( "spr_key_point_glow_"..i.."_"..j, { alp = 0 } ); 

      end;

    end;

    ObjSet( "spr_key_point_glow_"..i.."_"..(current_point[2] + 1 ), { alp = 1 } );
      
   end;

   if current_point[1] ~= 3 then

     ObjSet( "spr_key_point_glow_"..( current_point[1] + 1 ).."_"..current_point[2], { alp = 1 } );
    
   end;   
   DbgTrace("---------------State_point_glow------------------");
end;
-----------------------------------------------------------------------------------
function private.WrongAnim( i, j)

  private.drag_line_stop();
  common_impl.Lock( true );

  local func_after = function()
  
    ObjSet( "spr_key_point_glow_"..i.."_"..j,{ color_g = 1 });
    ObjSet( "spr_key_point_glow_"..i.."_"..j,{ color_b = 1 });
    common_impl.Lock( false );

  end;

  if not (i) then
    common_impl.Lock( false );
    local lines = ObjGetRelations( "obj_key_line" ).childs;

    for i = 1, #lines do
  
      ObjDelete( lines[i] );
  
    end;
  
    ng_global.progress[ "std" ][ "win_key" ].current_num = 1;
    private.old[1] = 1;
    private.old[2] = 1;
    
    private.ShowChoice(true);
    
  else
    
    private.returnBackPoint();
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_key_wrong", 0, "", 0 );

    --ObjAnimate( "spr_key_glow_wrong", "alp", 0, 0, func_after, { 0,0,0, 0.2,0,1, 0.4,0,0 } );
    ObjSet( "spr_key_point_glow_"..i.."_"..j,{ color_g = 0 });
    ObjSet( "spr_key_point_glow_"..i.."_"..j,{ color_b = 0 });
    
    ObjAnimate( "spr_key_point_glow_"..i.."_"..j, "alp", 0, 0, func_after, { 0,0,0, 0.2,0,1, 0.4,0,0, 0.6,0,1, 0.8,0,0, 1.0,0,1, 1.2,0,0, 1.4,0,1} );

    ObjSet( "obj_key_light_1_1", { 
    --pos_x = -115,
    --pos_y = -59,
      event_down = function () private.clk_pen(1,1) end,
      event_drag = function () private.drag_pen(1,1) end,
      event_dragdrop = function () private.drop_pen(1,1) end;
    });

    local lines = ObjGetRelations( "obj_key_line" ).childs;

  --  for i = 1, #lines do
  --
  --    ObjDelete( lines[i] );
  --
  --  end;
  --
  --  ng_global.progress[ "std" ][ "win_key" ].current_num = 1;
  --  
  --  private.ShowChoice(true);
  end;
end;
-----------------------------------------------------------------------------------
function private.RightAnim()

  ObjAnimate( "spr_key_glow_norm", "alp", 0, 0, "", { 0,0,0, 0.2,0,1, 0.4,0,0 } );

end
-----------------------------------------------------------------------------------
function private.CheckPaintWin()
  
  if ( ng_global.progress[ "std" ][ "win_key" ].current_num == 17 ) then

    return true;

  end;

end;
-------------------------------------------------------------------------------------
function private.CheckMakeCell()

  local win_comb = private.win_comb[ng_global.progress[ "std" ][ "win_key" ].drill_pos];
  
  if ( win_comb[1] == ng_global.progress[ "std" ][ "win_key" ].lever 
   and win_comb[2] == ng_global.progress[ "std" ][ "win_key" ].drill_type ) then

    return true;

  end;

end;
--------------------------------------------------------------------------------------
function private.CheckWin()
  
  for i = 1, #ng_global.progress[ "std" ][ "win_key" ].done_cells  do

    if not ng_global.progress[ "std" ][ "win_key" ].done_cells[i] then

      return false;

    end;

  end;

  return true;

end;
-------------------------------------------------------------------------------------
function private.AnimPaintWin( end_func )

  local end_func = function ()
    
    common_impl.Lock(false);

    if end_func then

      end_func();

    end;

  end; 

  common_impl.Lock(false);

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_key_win", 0, "", 0 );

  ObjAnimate( "spr_key_note_big", "pos_xy", 0, 0, "",
  {
    0.0, 3, 512, 384,
    0.7, 3, 512, 384,
    1.0, 3, 200, 400
  });

  ObjAnimate( "spr_key_note_big", "scale_xy", 0, 0, end_func,
  {
    0.0, 3, 1.0, 1.0,
    0.7, 3, 1.0, 1.0,
    1.0, 3, 0.0, 0.0
  });

end;
-------------------------------------------------------------------------------------
function private.InitMakingKey()

  table_multiset = {};
  table.insert( table_multiset, { "obj_key_picture_clk", { input = false } } );
  table.insert( table_multiset, { "obj_key_clk_lever", { input = true } } );
  table.insert( table_multiset, { "obj_key_clk_drill", { input = true } } );
  table.insert( table_multiset, { "obj_key_arrow_clk_left", { input = true } } );
  table.insert( table_multiset, { "obj_key_arrow_clk_right", { input = true } } );
  table.insert( table_multiset, { "obj_key_arrow_clk_press", { input = true } } );
  table.insert( table_multiset, { "spr_key_keypicture_right", { alp = 1 } } );

  ObjMultiSet(table_multiset);

end;
-------------------------------------------------------------------------------------
function private.LoadMK()

 local table_multiset = {};

   for i = 1, #ng_global.progress[ "std" ][ "win_key" ].done_cells do

    if ng_global.progress[ "std" ][ "win_key" ].done_cells[i] then
  
      table.insert( table_multiset, { "spr_key_key_part_"..i, { alp = 0 } } );

    end;

  end;

  if ng_global.progress[ "std" ][ "win_key" ].lever then

    table.insert( table_multiset, { "spr_key_lever", { pos_y = 393 } } );
    table.insert( table_multiset, { "obj_key_move", { pos_y = 17 } } );

  else

    table.insert( table_multiset, { "spr_key_lever", { pos_y = 349 } } );
    table.insert( table_multiset, { "obj_key_move", { pos_y = 4 } } );

  end;

  table.insert( table_multiset, { "obj_key_drill", { pos_x = private.drill_pos_x[ng_global.progress[ "std" ][ "win_key" ].drill_pos] } } );
  table.insert( table_multiset, { "spr_key_drill_"..ng_global.progress[ "std" ][ "win_key" ].drill_type, { alp = 1 } } );

  ObjMultiSet(table_multiset);  

end;
-------------------------------------------------------------------------------------
function private.LoadPaint()

  local num = ng_global.progress[ "std" ][ "win_key" ].current_num;

  ng_global.progress[ "std" ][ "win_key" ].current_num = 1;

  local pos_star = { -114,-58 };

   for i = 2, num do

    local pos_star_2 = {

      ObjGet( "spr_key_point_glow_"..private.sequence[i][1].."_"..private.sequence[i][2] ).pos_x, 
      ObjGet( "spr_key_point_glow_"..private.sequence[i][1].."_"..private.sequence[i][2] ).pos_y 

    };

    private.MakeLine( pos_star, pos_star_2, private.sequence[i][1],private.sequence[i][2], private.sequence[i-1][1],private.sequence[i-1][2], true );

    pos_star = pos_star_2;
    
  end;

  ObjSet( "spr_key_note_big", { alp = 1, input  = true } );

end;
----------------------------------------------------------------------------------------
function private.picture_clk()
  
  local end_func = function ()

    common_impl.Lock( false );

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_paper_open", 0, "", 0 );

  ObjSet( "spr_key_note_big", { alp = 1, input = true } );  

  common_impl.Lock( true );

  ObjAnimate( "spr_key_note_big", "pos_xy", 0, 0, "",
  {
    0.0, 3, 200, 400,
    0.3, 3, 512, 384
  });

  ObjAnimate( "spr_key_note_big", "scale_xy", 0, 0, end_func,
  {
    0.0, 3, 0.0, 0.0,
    0.3, 3, 1.0, 1.0,

  });
  
end;
-------------------------------------------------------------------------------------   
function private.change_drill_menter( obj )

  local obj_alp = ObjGet( obj ).alp;
  
  local time = ( 1 - obj_alp )*0.3;

  ObjAnimate( obj, "alp", 0, 0, "", { 0, 3, obj_alp, time, 3, 1 });

end;

function private.change_drill_mleave( obj )

  local obj_alp = ObjGet( obj ).alp;
  
  local time = obj_alp*0.3;

  ObjAnimate( obj, "alp", 0, 0, "", { 0, 3, obj_alp, time, 3, 0 });

end;