-- name=level2
 
function public.Start ( param )
  
  --interface.WidgetAdd( InterfaceWidget_Pause, 1800 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 12 );

  if IsCollectorsEdition() then

    interface.WidgetAdd( InterfaceWidget_BtnGuide, 13 );

  end;


  interface.WidgetAdd( InterfaceWidget_BtnHint, 9  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 10 );

  interface.WidgetAdd( InterfaceWidget_Effects, 11 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 7 );

  interface.WidgetAdd( InterfaceWidget_DialogHo );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8);

  interface.WidgetAdd( InterfaceWidget_ItemPanel );
  interface.WidgetAdd( InterfaceWidget_Popup );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog );

  interface.WidgetAdd( InterfaceWidget_DialogVideo );
  interface.WidgetAdd( InterfaceWidget_DialogStory );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 8 );

  if (tostring(GetPlatform())~= "ios") then
    interface.WidgetAdd( InterfaceWidget_StrategyGuide );
  end;
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial );

  interface.WidgetAdd( InterfaceWidget_Map, 26  );

  interface.PanelNotificationAdd();
  interface.DeployInvAdd( 9 );
  interface.DialogHintAdd();
  interface.PanelProvideAdd( 10 );
  interface.BtnProvideAdd( 0 );
  interface.EvidenceAdd( 18 );
  interface.DialogEvidenceAdd( 20 );
  interface.InvestigationButtonAdd( 17 ); 
  interface.SliderAdd( -1 );
  interface.ProvideAdd( 8 );
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );  
  interface.DiaryAdd( 28 );
  interface.ProvideEyeAdd( 30 );
  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then


    interface.BtnCollectibles2Add( 25 );
    interface.BtnCollectiblesAdd( 25 );
    interface.AchievementsAdd( 25 );
    interface.BtnMorphAdd( 25 );

  end;

  private.Init();
  ModLoad( "assets/levels/level2/mod_level2_inv" );
  level2_inv.Init();
  common.LevelLoad( "level2", "std", "rm_area", param, private.menu_moduls );
  common_impl.SetMorphEventDone();
  common_impl.SetCollectEventDone();

  common_impl.Collectibles2CoinsLoad();
  common_impl.UpdatePerformanceMode();


  private.TutorialSetParams();
  interface.KeyUpdate();

  event_show_investigation = "beg_level2";

  interface.InvestigationButtonCheck();
  
  interface.PanelProvideShow();

end;
    
function private.Init ()

  game = {};
  game.room_names =
  {
   "rm_area"
  ,"rm_pier_2"
  ,"rm_basement_2"
  ,"rm_divarication"
  ,"rm_nightsvilleentrance"
  ,"rm_glade"
  ,"ho_littlehouse"
  ,"mg_gate"
  ,"rm_nightsville"
  ,"rm_mineentrance"
  ,"mg_key"
  ,"ho_intreehole"
  ,"rm_mine_1"
  ,"mg_superpuzzle_2"
  ,"rm_mine_2"
  ,"rm_livingroom_2"
  ,"rm_office_2"
  ,"ho_inventory"
  ,"rm_abandoneddistrict_2"
  };

  game.progress_names_room =
  {
  { "beg_level2" }
  ,{ "opn_basement_2" }
  ,{ "opn_area" }
  ,{ "opn_office_2" }
  ,{ "opn_livingroom_2" }
  ,{ "opn_pier_2" }
  ,{ "opn_abandoneddistrict_2" }
  ,{ "vid_area_oulmen",                       "rm_area",                   { "opn_area" }}
  ,{ "dlg_area_joker",                        "rm_area",                   { "vid_area_oulmen" }}
  ,{ "get_owl",                               "rm_area",                   { "dlg_area_joker" }}
  ,{ "opn_divarication",                      "rm_area",                   { "get_owl" }}
  ,{ "use_owl",                               "rm_divarication",           { "opn_divarication" }}
  ,{ "get_hacksaw",                           "rm_divarication",           { "use_owl" }}
  ,{ "get_gun",                               "rm_divarication",           { "use_owl" }}
  ,{ "use_hacksaw",                           "rm_divarication",           { "get_hacksaw" }}

  ,{ "opn_nightsvilleentrance",               "rm_divarication",           { "use_hacksaw" }}
  ,{ "get_collect_morph_item_2_1" }
  ,{ "vid_nightsvilleentrance_child",         "rm_nightsvilleentrance",    { "opn_nightsvilleentrance" }}
  ,{ "dlg_nightsvilleentrance_child",         "rm_nightsvilleentrance",    { "vid_nightsvilleentrance_child" }}
  ,{ "get_evidence_2_1",                      "rm_nightsvilleentrance",    { "dlg_nightsvilleentrance_child" }}

  ,{ "clk_providence_rope",                   "rm_nightsvilleentrance",    { "get_evidence_2_1" }}
  ,{ "clk_providence_bone",                   "rm_nightsvilleentrance",    { "get_evidence_2_1" }}
  ,{ "clk_providence_stick",                  "rm_nightsvilleentrance",    { "get_evidence_2_1" }}

  ,{ "get_prv_carrot_silhouette",             "rm_nightsvilleentrance",    { "get_evidence_2_1" }}
  ,{ "get_prv_carrot",                        "rm_nightsvilleentrance",    { "clk_providence_rope","clk_providence_bone","clk_providence_stick","get_prv_carrot_silhouette" }}
  ,{ "get_knife",                             "rm_nightsvilleentrance",    { "get_prv_carrot" }}
  ,{ "use_providence_carrot",                 "rm_nightsvilleentrance",    { "get_knife" }}
  ,{ "vid_nightsvilleentrance_providence",    "rm_nightsvilleentrance",    { "use_providence_carrot" }}
  ,{ "clk_nightsvilleentrance_bushes",        "rm_nightsvilleentrance",    { "get_evidence_2_1" }}
  ,{ "get_pikepole",                          "rm_nightsvilleentrance",    { "vid_nightsvilleentrance_providence" }}
  ,{ "use_elf_4",                             "rm_nightsvilleentrance",    { "get_pikepole" }}
  ,{ "use_knife_1",                           "rm_nightsvilleentrance",    { "use_elf_4" }}
  ,{ "clk_log",                               "rm_nightsvilleentrance",    { "use_knife_1" }}
  ,{ "clk_rope",                              "rm_nightsvilleentrance",    { "clk_log" }}
  ,{ "use_pikepole",                          "rm_divarication",           { "clk_rope" }}
  ,{ "get_plates",                            "rm_divarication",           { "use_pikepole" }}
  ,{ "use_plates",                            "rm_nightsvilleentrance",    { "get_plates" }}

  ,{ "opn_glade",                             "rm_nightsvilleentrance",    { "use_plates" }}
  ,{ "get_collect_morph_item_2_2" }
  ,{ "vid_glade_wolves",                      "rm_glade",                  { "opn_glade" }}
  ,{ "get_collect_item_2_1" }
  ,{ "get_cartridge",                         "rm_glade",                  { "vid_glade_wolves" }}
  ,{ "clk_gun_open",                          }
  ,{ "use_cartridge",                         }
  ,{ "clk_gun_close",                         }
  ,{ "get_loadedgun",                         }
  ,{ "use_loadedgun",                         "rm_glade",                  { "get_loadedgun" }}
  ,{ "use_elf_5",                             "rm_glade",                  { "use_loadedgun" }}
  ,{ "get_secateurs",                         "rm_glade",                  { "use_elf_5" }}
  ,{ "use_secateurs",                         "rm_nightsvilleentrance",    { "get_secateurs" }}
  ,{ "clk_hole_bag",                          "rm_nightsvilleentrance",    { "use_secateurs" }}
  ,{ "get_file",                              "rm_nightsvilleentrance",    { "clk_hole_bag" }}
  ,{ "use_file",                              "rm_glade",                  { "get_file" }}

 ,{ "get_videotape",                         "rm_glade",                  { "use_file" }}
  ,{ "get_hairpin",                           "rm_glade",                  { "use_file" }}
  ,{ "use_knife_2",                           "rm_glade",                  { "get_videotape","get_hairpin" }}
  ,{ "get_flashlight",                        "rm_glade",                  { "use_knife_2" }}
  ,{ "get_bottle",                            "rm_glade",                  { "use_knife_2" }}
  ,{ "get_coin",                              "rm_glade",                  { "use_knife_2" }}
  ,{ "use_corkscrew",                         }
  ,{ "get_evidence_2_2",                      }
  ,{ "use_hairpin",                           "rm_nightsvilleentrance",    { "get_hairpin" }}
  ,{ "get_bandage",                           "rm_nightsvilleentrance",    { "use_hairpin" }}
  ,{ "get_medicine",                          "rm_nightsvilleentrance",    { "use_hairpin" }}
  ,{ "use_coin",                              "rm_glade",                  { "get_coin" }}
  ,{ "win_trap",                              "rm_glade",                  { "use_coin" }}

  ,{ "get_spring",                            "rm_glade",                  { "win_trap" }}
  ,{ "use_bandage",                           "rm_glade",                  { "win_trap" }}
  ,{ "use_medicine",                          "rm_glade",                  { "win_trap" }}
  ,{ "get_emblem",                            "rm_glade",                  { "use_medicine" }}
  ,{ "clk_spring",                            "rm_glade",                  { "get_spring" }}
  ,{ "use_spring",                            "rm_glade",                  { "clk_spring", "get_spring" }}
  ,{ "use_emblem",                            "rm_glade",                  { "get_emblem" }}
  ,{ "opn_littlehouse",                       "rm_glade",                  { "use_spring","use_emblem" }}
  ,{ "win_littlehouse",                       "rm_glade",                  { "use_spring","use_emblem" }}
  ,{ "clk_camera_open",                       }
  ,{ "use_videotape",                         }
  ,{ "clk_camera_close",                      }
  ,{ "get_evidence_2_3",                      }
  ,{ "vid_evidence_4",                        }
  ,{ "dlg_nightsvilleentrance_company",       "rm_nightsvilleentrance",    { "vid_evidence_4" }}
  ,{ "get_mechanismpart",                     "rm_nightsvilleentrance",    { "dlg_nightsvilleentrance_company" }}
  ,{ "use_mechanismpart",                     "rm_nightsvilleentrance",    { "get_mechanismpart" }}
  ,{ "win_gate",                              "rm_nightsvilleentrance",    { "use_mechanismpart" }}

  ,{ "opn_nightsville",                       "rm_nightsvilleentrance",    { "win_gate" }}
  ,{ "get_collect_morph_item_2_3" }
  ,{ "vid_nightsville_attack",                "rm_nightsville",            { "opn_nightsville" }}
  ,{ "dlg_nightsville_steward",               "rm_nightsville",            { "vid_nightsville_attack" }}
  ,{ "get_evidence_2_4",                      "rm_nightsville",            { "dlg_nightsville_steward" }}

  ,{ "clk_trash",                             "rm_nightsville",            { "dlg_nightsville_steward" }}
  ,{ "clk_trash_2",                           "rm_nightsville",            { "clk_trash" }}

  ,{ "get_axeblade",                          "rm_nightsville",            { "clk_trash_2" }}
  ,{ "get_hanky",                             "rm_nightsville",            { "clk_trash_2" }}

  ,{ "opn_mineentrance",                      "rm_nightsville",            { "dlg_nightsville_steward" }}
  ,{ "get_collect_morph_item_2_4" }
  ,{ "get_collect_item_2_2" }
  ,{ "clk_providence_trailer",                "rm_mineentrance",           { "opn_mineentrance" }}
  ,{ "clk_providence_deadbolt",               "rm_mineentrance",           { "opn_mineentrance" }}

  ,{ "clk_tarpaulin",                         "rm_mineentrance",           { "opn_mineentrance" }}
  ,{ "get_magnet",                            "rm_mineentrance",           { "clk_tarpaulin" }}

  ,{ "use_magnet_1",                          "rm_nightsville",            { "get_magnet" }}
  ,{ "get_brokenkey",                         "rm_nightsville",            { "use_magnet_1" }}

  ,{ "get_tweezers",                          "rm_nightsville",            { "dlg_nightsville_steward" }}
  ,{ "use_brokenkey",                         "rm_nightsville",            { "get_brokenkey" }}
  ,{ "win_key",                               "rm_nightsville",            { "use_brokenkey" }}
  ,{ "get_hydrantwrench",                     "rm_nightsville",            { "win_key" }}

  ,{ "use_hydrantwrench",                     "rm_nightsville",            { "get_hydrantwrench" }}
  ,{ "clk_hydrantwrench",                     "rm_nightsville",            { "use_hydrantwrench" }}
  ,{ "get_prv_sledgehammer_silhouette",       "rm_nightsville",            }
  ,{ "get_prv_sledgehammer",                  "rm_nightsville",            { "clk_hydrantwrench" }}
  ,{ "get_crowbar",                           "rm_nightsville",            { "clk_hydrantwrench" }}
  ,{ "get_chestpart",                         "rm_nightsville",            { "clk_hydrantwrench" }}
  ,{ "use_crowbar_1",                         "rm_nightsville",            { "get_crowbar" }}
  ,{ "use_magnet_2",                          "rm_nightsville",            { "use_crowbar_1" }}
  
  ,{ "get_prv_valve_silhouette"               }
  ,{ "get_prv_valve",                         "rm_nightsville",            { "use_magnet_2" }}

  ,{ "use_providence_valve",                  "rm_mineentrance",           { "get_prv_valve" }}
  ,{ "use_providence_sledgehammer",           "rm_mineentrance",           { "get_prv_valve" }}
  ,{ "vid_mineentrance_providence",           "rm_mineentrance",           { "get_prv_valve" }}

  ,{ "use_chestpart",                         "rm_mineentrance",           { "get_chestpart" }}
  ,{ "win_chestpart",                         "rm_mineentrance",           { "use_chestpart" }}
  ,{ "get_evidence_2_5",                      "rm_mineentrance",           { "win_chestpart" }}
  ,{ "use_hanky",                             "rm_mineentrance",           { "get_hanky" }}
  ,{ "get_bulb",                              "rm_mineentrance",           { "use_hanky" }}
  ,{ "use_bulb",                              }
  ,{ "get_workingflashlight",                 }
  ,{ "use_workingflashlight",                 "rm_mineentrance",           { "get_workingflashlight" }}
  ,{ "opn_intreehole",                        "rm_mineentrance",           { "use_workingflashlight" }}
  ,{ "win_intreehole",                        "rm_mineentrance",           { "use_workingflashlight" }}
  ,{ "get_evidence_2_6",                      "rm_mineentrance",           { "win_intreehole" }} --получаем по прохождении ХО

  ,{ "vid_evidence_5" }

  ,{ "dlg_nightsville_suspicion",             "rm_nightsville",           { "vid_evidence_5" }}--диалог подозрение
  ,{ "vid_mineentrance_explosion",            "rm_mineentrance",           { "dlg_nightsville_suspicion" }}--ролик взрыв

  ,{ "get_axehandle",                         "rm_mineentrance",           { "opn_mineentrance", "vid_mineentrance_explosion" }}
  ,{ "get_screwdriver_2",                       "rm_mineentrance",           { "opn_mineentrance", "vid_mineentrance_explosion" }}
  ,{ "use_axehandle",                         }
  ,{ "get_axe",                               }
  ,{ "use_axe",                               "rm_mineentrance",           { "get_axe" }}
  ,{ "use_crowbar_2",                         "rm_mineentrance",           { "use_axe" }}

  ,{ "opn_mine_1",                            "rm_mineentrance",           { "use_crowbar_2" }}
  ,{ "get_collect_morph_item_2_5" }
  ,{ "vid_mine_1_danger",                     "rm_mine_1",                 { "opn_mine_1" }}--ролик человек в беде
  ,{ "get_collect_item_2_3" }
  ,{ "use_screwdriver2_1",                    "rm_mine_1",                 { "vid_mine_1_danger" }}
  ,{ "get_wounddevice",                       "rm_mine_1",                 { "opn_mine_1" }}
  ,{ "get_jack",                              "rm_mine_1",                 { "opn_mine_1" }}


  ,{ "use_knife_3",                           }
  ,{ "get_electricaltape",                    }
  ,{ "use_jack",                              "rm_mineentrance",           { "get_jack" }}
  ,{ "use_elf_7",                             "rm_mineentrance",           { "use_jack" }}
  ,{ "get_receiverpieces",                    "rm_mineentrance",           { "use_elf_7" }}
  ,{ "use_tweezers",                          }
  ,{ "get_fuse",                              }
  ,{ "use_crowbar_3",                         "rm_mine_1",                 { "opn_mine_1" }}
  ,{ "get_remotecontrol",                     "rm_mine_1",                 { "use_crowbar_3" }}
  ,{ "use_screwdriver2_2",                    }
  ,{ "use_knife_4",                           }
  ,{ "get_tumblerswitch",                     }

  ,{ "use_electricaltape",                    "rm_mine_1",                 { "get_electricaltape" }}
  ,{ "use_tumblerswitch",                     "rm_mine_1",                 { "get_tumblerswitch" }}
  ,{ "use_fuse",                              "rm_mine_1",                 { "get_fuse", "use_electricaltape" }}
  ,{ "clk_tumblerswitch",                     "rm_mine_1",                 { "use_tumblerswitch" }}
  ,{ "win_superpuzzle_2",                     "rm_mine_1",                 { "get_electricaltape", "get_fuse", "use_tumblerswitch" }}  --суперпазл2
  ,{ "see_fireextinguishing",                 "rm_mine_1",                 { "win_superpuzzle_2" }}
  ,{ "get_clippers",                          "rm_mine_1",                 { "see_fireextinguishing" }}
  ,{ "use_clippers",                          "rm_mineentrance",           { "get_clippers" }}
  ,{ "get_chain",                             "rm_mineentrance",           { "use_clippers" }}

  ,{ "use_chain",                             "rm_mine_1",                 { "get_chain" }}

  ,{ "use_knife_5",                           "rm_mine_1",                 { "use_chain" }}
  ,{ "clk_knife_5",                           "rm_mine_1",                 { "use_knife_5" }}

  ,{ "win_carriage",                          "rm_mine_1",                 { "clk_knife_5" }}
  ,{ "clk_knife_6",                           "rm_mine_1",                 { "win_carriage" }}
  ,{ "anm_mine_1_chain",                      "rm_mine_1",                 { "clk_knife_6" }}

  ,{ "opn_mine_2",                            "rm_mine_1",                 { "anm_mine_1_chain" }}
  ,{ "get_collect_morph_item_2_6" }
  ,{ "vid_mine_2_kevin",                      "rm_mine_2",                 { "opn_mine_2" }}  --ролик кевин
  ,{ "get_inventorykey",                      "rm_mine_2",                 { "vid_mine_2_kevin" }}
  ,{ "use_inventorykey",                      "rm_mine_2",                 { "get_inventorykey" }}
  ,{ "clk_inventorykey",                      "rm_mine_2",                 { "use_inventorykey" }}
  ,{ "opn_inventory" }
  ,{ "win_inventory",                          "rm_mine_2",                 { "clk_inventorykey" }}  
  ,{ "use_slingshotframe",                    "rm_mine_2",                 { "win_inventory" }}
  ,{ "use_clippers_2",                        "rm_mine_2",                 { "opn_mine_2" }}
  ,{ "vid_mine_2_savior",                     "rm_mine_2",                 { "use_clippers_2", "use_slingshotframe" }}  --ролик спасение
  ,{ "vid_mine_1_goaf",                     "rm_mine_2",                 { "vid_mine_2_savior" }}  --обвал
  ,{ "dlg_mine_1_saved",                      "rm_mine_1",                 { "vid_mine_2_savior" }}  --диалог спасенный
  ,{ "get_collect_morph_item_1_1" }
  ,{ "get_collect_morph_item_1_2" }
  ,{ "get_collect_morph_item_1_3" }
  ,{ "get_collect_morph_item_1_4" }
  ,{ "get_collect_morph_item_1_5" }
  ,{ "get_collect_morph_item_1_6" }
  ,{ "get_collect_item_1_1" }
  ,{ "get_collect_item_1_2" }
  ,{ "get_collect_morph_item_1_7" }
  ,{ "get_collect_item_1_3" }
  };
  
  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
  
  game.relations = {};
  private.menu_moduls = { "rm_credits" };

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      "rm_collectibles2",
      "rm_collectibles",
      "rm_achievements",
    }
    for i = 1, #menu_moduls_ce do
      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );
    end;

  end;
  common_impl.CheckPrgRules();

end;


function private.TutorialSetParams()

  if not ng_global.progress[ "std" ][ "see_tutorial" ] then

    ng_global.progress[ "std" ][ "see_tutorial" ] = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].done  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].start = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state = {};
    ng_global.progress[ "std" ][ "see_tutorial" ].state.no  = 0;
    ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
    ng_global.progress[ "std" ][ "see_tutorial" ].func = function()
      --
    end;

  end;

end;
