-- name=level2_inv
--*********************************************************************************************************************
function public.Init ()

  if port.isPortable() == 1 then
    port.InventoryPopupInit("level2_inv_hub");
    port.VideoResizeInRoom("level2_inv");
  end;
  private.init_gun();
  private.init_bottle();
  private.init_camera();
  private.init_axeblade();
  private.init_flashlight();
  private.init_receiverpieces();
  private.init_wounddevice();
  private.init_remotecontrol();
  private.init_brokengasolinesaw_2();

  public.deploy_inventory = {
    { "gun", { "clk_gun_close", "use_cartridge" }, "get_loadedgun" },
    { "bottle", { "use_corkscrew" }, "get_evidence_2_2" },
    { "camera", { "clk_camera_close", "use_videotape" }, "get_evidence_2_3" },
    { "axeblade", { "use_axehandle" }, "get_axe" },
    { "flashlight", { "use_bulb" }, "get_workingflashlight" },
    { "receiverpieces", { "use_tweezers" }, "get_fuse" },
    { "wounddevice", { "use_knife_3" }, "get_electricaltape" },    
    { "remotecontrol", { "use_knife_4", "use_screwdriver2_2" }, "get_tumblerswitch" }
  };

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_level2_inv_deploy = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    common_impl.TurnChildGfx( {"level2_inv_deploy" }, "level2_inv_deploy", visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_level2_inv_deploy", update_game_mode_level2_inv_deploy, nil );

end;
--*********************************************************************************************************************
function private.StringDivide(string)  

  local table = {}
  local id = 1
  local il = 1
  for i = 1, string.len(string) do
    if string.sub(string,i,i) == "_" then
      table[id] = string.sub(string,il,i-1)
      il = i+1
      id = id + 1
    end
    if i == string.len(string) then
      table[id] = string.sub(string,il,i)
      il = i+1
      id = id + 1
    end
  end
  return table;

end;
--*********************************************************************************************************************
function private.ObjIntersectCheck( obj_to_apply, obj_to_check, obj_complex_inv )

  local obj_complex_inv = obj_complex_inv or "deploy_inv_"..private.StringDivide( obj_to_check )[2];  
  return interface.GetCurrentInv() == obj_complex_inv and ObjIntersect( obj_to_apply, obj_to_check );

end;
--*********************************************************************************************************************
-- function *** gun *** () end;
--*********************************************************************************************************************
function private.init_gun()

  common_impl.hint[ "get_loadedgun" ] = {
      type = "get",
      get_obj = "spr_deploy_gun_handle",
      room = "int_deploy_inv",
      zz = "deploy_inv_gun",
      zz_gate = "inv_gun"
  };

  function get_loadedgun_inv ()

    interface.InventoryItemRemove( "inv_gun" );
    interface.InventoryItemAdd( "inv_loadedgun", "obj_deploy_gun_gun" );
    ObjDelete( "gfx_deploy_gun_gun" );

  end;
  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_loadedgun", get_loadedgun_inv );
  --------------------------------------------------------------------------------------------
  ObjSet( "spr_deploy_gun_barrel_1", { event_mdown = level2_inv.get_loadedgun });
  ObjSet( "spr_deploy_gun_handle",   { event_mdown = level2_inv.get_loadedgun });
  --------------------------------------------------------------------------------------------
  -------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cartridge" ] = {
      type = "use",
      inv_obj = "inv_cartridge",
      use_place = "obj_gun_use_cartridge",
      room = "int_deploy_inv",
      zz = "deploy_inv_gun",
      zz_gate = "inv_gun"
  };
  function use_cartridge_inv ()

    interface.InventoryItemRemove( "inv_cartridge" );

  end;
  function use_cartridge_beg ()

    ObjDelete( "obj_gun_use_cartridge" );

  end;
  function use_cartridge_end ()

    ObjSet( "obj_gun_clk_gun_close", { input = true } );
    ObjSet( "spr_deploy_gun_patron", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cartridge", use_cartridge_beg, "inv_gun");
  cmn.AddSubscriber( "use_cartridge", use_cartridge_inv );
  cmn.AddSubscriber( "use_cartridge", use_cartridge_end, "inv_gun" );
  cmn.AddSubscriber( "use_cartridge_inv", use_cartridge_inv );
  cmn.AddSubscriber( "use_cartridge_beg", use_cartridge_beg, "inv_gun" );
  cmn.AddSubscriber( "use_cartridge_end", use_cartridge_end, "inv_gun" );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "clk_gun_open" ] = {
    type = "click",
    use_place = "obj_gun_clk_gun_open",
    room = "int_deploy_inv",
    zz = "deploy_inv_gun",
    zz_gate = "inv_gun" 
  };
  function clk_gun_open_beg ()

    ObjDelete( "obj_gun_clk_gun_open" );

  end;
  function clk_gun_open_end ()

    ObjSet( "spr_deploy_gun_barrel_1", { alp = 0 } );
    ObjSet( "spr_deploy_gun_barrel_2", { alp = 1 } );
    ObjSet( "obj_gun_use_cartridge",   { input = true } );

  end;
  function clk_gun_plus ()

    if ( not cmn.IsEventDone( "get_cartridge" ) ) then
      ObjSet( "spr_gun_plus_light", { visible = false } );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_gun_open", clk_gun_open_beg, "inv_gun");
  cmn.AddSubscriber( "clk_gun_open", clk_gun_plus );
  cmn.AddSubscriber( "clk_gun_open", clk_gun_open_end, "inv_gun" );
  cmn.AddSubscriber( "clk_gun_open_beg", clk_gun_open_beg, "inv_gun" );
  cmn.AddSubscriber( "clk_gun_open_end", clk_gun_open_end, "inv_gun" );
  cmn.AddSubscriber( "clk_gun_open_end", clk_gun_plus, "inv_gun" );
  --------------------------------------------------------------------------------------------

  ObjSet( "obj_gun_clk_gun_open", { event_mdown = level2_inv.clk_gun_open });

  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "clk_gun_close" ] = {
    type = "click",
    use_place = "obj_gun_clk_gun_close",
    room = "int_deploy_inv",
    zz = "deploy_inv_gun",
    zz_gate = "inv_gun" 
  };

  function clk_gun_close_beg ()

    ObjDelete( "obj_gun_clk_gun_close" );

  end;
  function clk_gun_close_end ()

    ObjSet( "spr_deploy_gun_barrel_1", { alp = 1 } );
    ObjSet( "spr_deploy_gun_barrel_2", { alp = 0 } );
    ObjSet( "obj_deploy_gun_gun",      { input = true } );
    ObjSet( "gfx_deploy_gun_gun",      { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_gun_close", clk_gun_close_beg, "inv_gun");
  cmn.AddSubscriber( "clk_gun_close", clk_gun_close_end, "inv_gun" );
  cmn.AddSubscriber( "clk_gun_close_beg", clk_gun_close_beg, "inv_gun" );
  cmn.AddSubscriber( "clk_gun_close_end", clk_gun_close_end, "inv_gun" );
  --------------------------------------------------------------------------------------------

  ObjSet( "obj_gun_clk_gun_close", { event_mdown = level2_inv.clk_gun_close });
  --------------------------------------------------------------------------------------------

end;

--------------------------------------------------------------------------------------------
function public.get_loadedgun()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_loadedgun" );
  cmn.CallEventHandler( "get_loadedgun", "inv_gun" );
  common_impl.HideDeployInv();

end;
--------------------------------------------------------------------------------------------
function public.use_cartridge()

  local item = "inv_cartridge";

  if ( private.ObjIntersectCheck( item, "obj_gun_use_cartridge" ) and 
       cmn.IsEventDone( "clk_gun_open" ) )  then

    cmn.CallEventHandler( "use_cartridge_inv" );
    cmn.CallEventHandler( "use_cartridge_beg", "inv_gun" );

    local func_end = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_cartridge" );
      cmn.CallEventHandler( "use_cartridge_end", "inv_gun" );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_rifle_load", 0, "", 0 );
    ObjAnimate( "spr_deploy_gun_patron", "alp", 0, 0, func_end, { 0,3,0,  0.4,3,1 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.clk_gun_open()

  common_impl.Lock( true );

  local func_end = function ()

    cmn.SetEventDone( "clk_gun_open" );
    cmn.CallEventHandler( "clk_gun_open_end", "inv_gun" );

    common_impl.Lock( false );

  end;

  cmn.CallEventHandler( "clk_gun_open_beg", "inv_gun" );

  common_impl.PlayAudio( "sfx", "common/audio/aud_rifle_open", 0, "", 0 );

  ObjAnimate( "spr_deploy_gun_barrel_1", "alp", 0, 0, func_end, { 0,3,1,  0.4,3,0 } );
  ObjAnimate( "spr_deploy_gun_barrel_2", "alp", 0, 0, "", { 0,3,0,  0.4,3,1 } );

end;
--------------------------------------------------------------------------------------------
function public.clk_gun_close()

  common_impl.Lock( true );

  local func_end = function ()

    cmn.SetEventDone( "clk_gun_close" );
    cmn.CallEventHandler( "clk_gun_close_end", "inv_gun" );

    common_impl.Lock( false );

  end;

  cmn.CallEventHandler( "clk_gun_close_beg", "inv_gun" );

  common_impl.PlayAudio( "sfx", "common/audio/aud_rifle_close", 0, "", 0 );

  ObjAnimate( "spr_deploy_gun_barrel_1", "alp", 0, 0, func_end, { 0,3,0,  0.4,3,1 } );
  ObjAnimate( "spr_deploy_gun_barrel_2", "alp", 0, 0, "",       { 0,3,1,  0.4,3,0 } );

end;
--*********************************************************************************************************************
-- function *** bottle *** () end;
--*********************************************************************************************************************
function private.init_bottle()

  common_impl.hint[ "get_evidence_2_2" ] = {
      type = "get",
      get_obj = "spr_deploy_evidence_2_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_bottle",
      zz_gate = "inv_bottle"
  };

  function get_evidence_2_2_inv ()

    interface.InventoryItemRemove( "inv_bottle" );
    ObjDelete( "spr_deploy_evidence_2_2" );
    ObjDelete( "gfx_deploy_evidence_2_2" );

  end;
  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_evidence_2_2", get_evidence_2_2_inv );
  -------------------------------------------------------------------------------------------
  common_impl.hint[ "use_corkscrew" ] = {
      type = "use",
      inv_obj = "inv_corkscrew_2",
      use_place = "obj_bottle_use_corkscrew",
      room = "int_deploy_inv",
      zz = "deploy_inv_bottle",
      zz_gate = "inv_bottle"
  };
  function use_corkscrew_inv ()

    interface.InventoryItemRemove( "inv_corkscrew_2" );

  end;
  function use_corkscrew_beg ()

    ObjDelete( "obj_bottle_use_corkscrew" );

  end;
  function use_corkscrew_end ()

    ObjSet( "spr_deploy_evidence_2_2", { input = true, alp = 1 } );
    ObjSet( "gfx_deploy_evidence_2_2", { active = true } );

    ObjDelete( "spr_deploy_bottle_note_sh" );
    ObjDelete( "spr_deploy_bottle_bottle_1" );
    ObjDelete( "spr_deploy_bottle_over" );
    ObjDelete( "spr_deploy_bottle_note" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_corkscrew", use_corkscrew_beg, "inv_bottle");
  cmn.AddSubscriber( "use_corkscrew",use_corkscrew_inv );
  cmn.AddSubscriber( "use_corkscrew", use_corkscrew_end, "inv_bottle" );
  cmn.AddSubscriber( "use_corkscrew_inv", use_corkscrew_inv );
  cmn.AddSubscriber( "use_corkscrew_beg", use_corkscrew_beg, "inv_bottle" );
  cmn.AddSubscriber( "use_corkscrew_end", use_corkscrew_end, "inv_bottle" );
  --------------------------------------------------------------------------------------------

  ObjSet( "spr_deploy_evidence_2_2", { event_mdown = level2_inv.get_evidence_2_2 });
  --------------------------------------------------------------------------------------------

end;

--------------------------------------------------------------------------------------------
function public.get_evidence_2_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page", 0, "", 0 );

  local func_end = function ()

    ObjSet( "spr_deploy_evidence_2_2", { pos_x = 512, pos_y = 384 } );
    interface.InvestigationButtonItemAdd( "evidence_2_2", "spr_deploy_evidence_2_2" );

    cmn.SetEventDone( "get_evidence_2_2" );
    cmn.CallEventHandler( "get_evidence_2_2", "inv_bottle" );
  
  end;

  interface.DialogEvidenceShow( "evidence_2_2", func_end );
  common_impl.HideDeployInv();

end;
--------------------------------------------------------------------------------------------
function public.use_corkscrew()

  local item = "inv_corkscrew_2";

  if (  private.ObjIntersectCheck( item, "obj_bottle_use_corkscrew" ) )  then

    cmn.CallEventHandler( "use_corkscrew_inv" );
    cmn.CallEventHandler( "use_corkscrew_beg", "inv_bottle" );

    local vid_after = function ()
      
      local func_end = function ()

        common_impl.Lock( false );
        cmn.SetEventDone( "use_corkscrew" );
        cmn.CallEventHandler( "use_corkscrew_end", "inv_bottle" );
        
      end;

      ObjSet( "vid_deploy_bottle_use_corkscrew", { alp = 0 } );
      ObjSet( "obj_deploy_bottle", { alp = 1 } );
      ObjAnimate( "spr_deploy_bottle_note_sh", "alp",    0, 0, "", { 0,3,1, 0.4,3,0 } );
      ObjAnimate( "spr_deploy_bottle_note",    "pos_xy", 0, 0, "", { 0,3,57,-4, 0.4,3,7,0,  1.0,3,-240,156  } );
      ObjAnimate( "spr_deploy_bottle_bottle_1", "alp",   0, 0, "", { 0,3,1, 1.0,3,1, 1.4,3,0 } );
      ObjAnimate( "spr_deploy_bottle_over",     "alp",   0, 0, "", { 0,3,1, 1.0,3,1, 1.4,3,0 } );
      ObjAnimate( "spr_deploy_bottle_note",     "alp",   0, 0, "", { 0,3,1, 1.4,3,1, 1.8,3,0 } );
      ObjAnimate( "spr_deploy_evidence_2_2",    "alp",   0, 0, func_end, { 0,3,0, 1.4,3,0, 1.8,3,1 } );

    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_corkscrew", 0, "", 0 );
    VidPlay( "vid_deploy_bottle_use_corkscrew", vid_after );
    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** camera *** () end;
--*********************************************************************************************************************
function private.init_camera()

  common_impl.hint[ "get_evidence_2_3" ] = {
      type = "get",
      get_obj = "spr_deploy_evidence_2_3",
      room = "int_deploy_inv",
      zz = "deploy_inv_camera",
      zz_gate = "inv_camera"
  };

  function get_evidence_2_3_inv ()

    interface.InventoryItemRemove( "inv_camera" );
    ObjDelete( "spr_deploy_evidence_2_3" );
    ObjDelete( "gfx_deploy_evidence_2_3" );
    
  end;
  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_evidence_2_3", get_evidence_2_3_inv );
  -------------------------------------------------------------------------------------------
  common_impl.hint[ "use_videotape" ] = {
      type = "use",
      inv_obj = "inv_videotape",
      use_place = "obj_camera_use_videotape",
      room = "int_deploy_inv",
      zz = "deploy_inv_camera",
      zz_gate = "inv_camera"
  };
  function use_videotape_inv ()

    interface.InventoryItemRemove( "inv_videotape" );

  end;
  function use_videotape_beg ()

    ObjDelete( "obj_camera_use_videotape" );

  end;
  function use_videotape_end ()

    ObjSet( "spr_deploy_camera_cassette", { alp = 1 } );
    ObjSet( "obj_camera_clk_camera_close", { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_videotape", use_videotape_beg, "inv_camera");
  cmn.AddSubscriber( "use_videotape",use_videotape_inv );
  cmn.AddSubscriber( "use_videotape", use_videotape_end, "inv_camera" );
  cmn.AddSubscriber( "use_videotape_inv", use_videotape_inv );
  cmn.AddSubscriber( "use_videotape_beg", use_videotape_beg, "inv_camera" );
  cmn.AddSubscriber( "use_videotape_end", use_videotape_end, "inv_camera" );
  --------------------------------------------------------------------------------------------

  ObjSet( "spr_deploy_evidence_2_3", { event_mdown = level2_inv.get_evidence_2_3 });
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "clk_camera_open" ] = {
    type = "click",
    use_place = "obj_camera_clk_camera_open",
    room = "int_deploy_inv",
    zz = "deploy_inv_camera", 
    zz_gate = "inv_camera"
  };
  function clk_camera_open_beg ()

    ObjDelete( "obj_camera_clk_camera_open" );

  end;
  function clk_camera_open_end ()

    ObjSet( "spr_deploy_camera_cover",    { alp = 0 } );
    ObjSet( "spr_deploy_camera_cover_op", { alp = 1 } );
    ObjSet( "obj_camera_use_videotape",   { input = true } );

  end;
  function clk_camera_open_plus ()

    if ( not cmn.IsEventDone( "get_videotape" ) ) then
      ObjSet( "spr_camera_plus_light", { visible = false } );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_camera_open", clk_camera_open_beg, "inv_camera");
  cmn.AddSubscriber( "clk_camera_open", clk_camera_open_end, "inv_camera" );
  cmn.AddSubscriber( "clk_camera_open", clk_camera_open_plus );
  cmn.AddSubscriber( "clk_camera_open_beg", clk_camera_open_beg, "inv_camera" );
  cmn.AddSubscriber( "clk_camera_open_end", clk_camera_open_end, "inv_camera" );
  cmn.AddSubscriber( "clk_camera_open_end", clk_camera_open_plus, "inv_camera" );
  --------------------------------------------------------------------------------------------
  
  ObjSet( "obj_camera_clk_camera_open", { event_mdown = level2_inv.clk_camera_open });

  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------

  common_impl.hint[ "clk_camera_close" ] = {
    type = "click",
    use_place = "obj_camera_clk_camera_close",
    room = "int_deploy_inv",
    zz = "deploy_inv_camera",
    zz_gate = "inv_camera"
  };

  function clk_camera_close_beg ()

    ObjDelete( "obj_camera_clk_camera_close" );

  end;
  function clk_camera_close_end ()

    --ObjSet( "spr_deploy_evidence_2_3",    { input = true } );
    ObjSet( "spr_deploy_camera_cover",    { alp = 1 } );
    ObjSet( "spr_deploy_camera_cover_op", { alp = 0 } );
    ObjSet( "spr_deploy_camera_button",   { alp = 1 } );
    ObjSet( "gfx_deploy_evidence_2_3",    { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_camera_close", clk_camera_close_beg, "inv_camera");
  cmn.AddSubscriber( "clk_camera_close", clk_camera_close_end, "inv_camera" );
  cmn.AddSubscriber( "clk_camera_close_beg", clk_camera_close_beg, "inv_camera" );
  cmn.AddSubscriber( "clk_camera_close_end", clk_camera_close_end, "inv_camera" );
  --------------------------------------------------------------------------------------------

  ObjSet( "obj_camera_clk_camera_close", { event_mdown = level2_inv.clk_camera_close });
  --------------------------------------------------------------------------------------------

end;

--------------------------------------------------------------------------------------------
function public.get_evidence_2_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page", 0, "", 0 );

  local func_end = function ()

    interface.DialogVideoHide();
    ObjSet( "spr_deploy_evidence_2_3", { pos_x = 559, pos_y = 354 } ); 
    interface.InvestigationButtonItemAdd( "evidence_2_3", "spr_deploy_evidence_2_3" );
    common_impl.StopAudio( "sfx", "common/audio/aud_camera_video", 0, "", 0 ); 
    common_impl.StopAudio( "voc", "common/audio/aud_camera_video_voc", 0, "", 0 ); 
    common_impl.ShowBbt( 'bbt_evidence_evidence_2_3_progress', 1 );
    cmn.SetEventDone( "get_evidence_2_3" );
    cmn.SetEventDone( "clk_camera_close" );
    cmn.CallEventHandler( "get_evidence_2_3", "inv_bottle" );
    common_impl.PlayAudio( "mus", "common/audio/aud_adventure2_mus", 0, "", 0 );
  
  end;

  common_impl.StopAllMus();
  interface.DialogVideoShow( "vid_evidence_evidence_2_3", 1, func_end, 3 ); 
  common_impl.PlayAudio( "sfx", "common/audio/aud_camera_video", 0, "", 0 ); 
  common_impl.PlayAudio( "voc", "common/audio/aud_camera_video_voc", 0, "", 0 ); 
  VidPlay( "vid_evidence_evidence_2_3", func_end ); 
  --interface.DialogEvidenceShow( "evidence_2_3_progress", func_end, true );
  common_impl.HideDeployInv();

end;
--------------------------------------------------------------------------------------------
function public.use_videotape()

  local item = "inv_videotape";

  if ( private.ObjIntersectCheck( item, "obj_camera_use_videotape" ) and 
       cmn.IsEventDone( "clk_camera_open" ) )  then

    cmn.CallEventHandler( "use_videotape_inv" );
    cmn.CallEventHandler( "use_videotape_beg", "inv_camera" );

    local func_end = function ()
      
      common_impl.Lock( false );
      cmn.SetEventDone( "use_videotape" );
      cmn.CallEventHandler( "use_videotape_end", "inv_camera" );
      
    end;
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_tape", 0, "", 0 );

    common_impl.Lock( true );
    ObjAnimate( "spr_deploy_camera_cassette", "alp", 0, 0, func_end, { 0,3,0,  0.4,3,1 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.clk_camera_open()

  common_impl.Lock( true );

  local func_end = function ()

    cmn.SetEventDone( "clk_camera_open" );
    cmn.CallEventHandler( "clk_camera_open_end", "inv_camera" );

    common_impl.Lock( false );

  end;

  cmn.CallEventHandler( "clk_camera_open_beg", "inv_camera" );

  common_impl.PlayAudio( "sfx", "common/audio/aud_recorder_open", 0, "", 0 );

  ObjAnimate( "spr_deploy_camera_cover", "alp", 0, 0, func_end, { 0,3,1,  0.4,3,0 } );
  ObjAnimate( "spr_deploy_camera_cover_op", "alp", 0, 0, "", { 0,3,0,  0.4,3,1 } );

end;
--------------------------------------------------------------------------------------------
function public.clk_camera_close()

  common_impl.Lock( true );

  local func_end = function ()
    
    cmn.CallEventHandler( "clk_camera_close_end", "inv_camera" );
    public.get_evidence_2_3();
    common_impl.Lock( false );

  end;

  cmn.CallEventHandler( "clk_camera_close_beg", "inv_camera" );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_recorder_cover", 0, "", 0 );

  local func_sound = function()

    common_impl.PlayAudio( 'sfx', 'common/audio/aud_recorder_play', 0, '', 0 );
   
  end;

  ObjSet( "tmr_camera_sound", { playing = true, time = 0.4, endtrig = func_sound } );

  ObjAnimate( "spr_deploy_camera_cover_op", "alp", 0, 0, "",       { 0,3,1,  0.4,3,0 } );
  ObjAnimate( "spr_deploy_camera_cover",    "alp", 0, 0, "",       { 0,3,0,  0.4,3,1 } );
  ObjAnimate( "spr_deploy_camera_button",   "alp", 0, 0, func_end, { 0,3,0,  0.4,3,0,  0.8,3,1 } );

end;
--*********************************************************************************************************************
-- function *** axeblade *** () end;
--*********************************************************************************************************************
function private.init_axeblade()

  common_impl.hint[ "get_axe" ] = {
      type = "get",
      get_obj = "spr_deploy_axeblade_axe_1",
      room = "int_deploy_inv",
      zz = "deploy_inv_axeblade",
      zz_gate = "inv_axeblade"
  };

  function get_axe_inv ()

    interface.InventoryItemRemove( "inv_axeblade" );
    interface.InventoryItemAdd( "inv_axe", "obj_deploy_axeblade_axe" );    

  end;

  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_axe", get_axe_inv );
  -------------------------------------------------------------------------------------------
  ObjSet( "spr_deploy_axeblade_axe_handle", { event_mdown = level2_inv.get_axe });
  ObjSet( "spr_deploy_axeblade_axe_1",      { event_mdown = level2_inv.get_axe });
  --------------------------------------------------------------------------------------------
  -------------------------------------------------------------------------------------------
  common_impl.hint[ "use_axehandle" ] = {
      type = "use",
      inv_obj = "inv_axehandle",
      use_place = "obj_axeblade_use_axehandle",
      room = "int_deploy_inv",
      zz = "deploy_inv_axeblade",
      zz_gate = "inv_axeblade"
  };
  function use_axehandle_inv ()

    interface.InventoryItemRemove( "inv_axehandle" );

  end;
  function use_axehandle_beg ()

    ObjDelete( "obj_axeblade_use_axehandle" );

  end;
  function use_axehandle_end ()

    ObjSet( "spr_deploy_axeblade_axe_handle", { alp = 1, pos_x = -91, pos_y = -41 } );
    ObjSet( "obj_deploy_axeblade_axe",        { input = true } );
    ObjSet( "gfx_axe_axeblade",               { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_axehandle", use_axehandle_beg, "inv_axeblade");
  cmn.AddSubscriber( "use_axehandle",use_axehandle_inv );
  cmn.AddSubscriber( "use_axehandle", use_axehandle_end, "inv_axeblade" );
  cmn.AddSubscriber( "use_axehandle_inv", use_axehandle_inv );
  cmn.AddSubscriber( "use_axehandle_beg", use_axehandle_beg, "inv_axeblade" );
  cmn.AddSubscriber( "use_axehandle_end", use_axehandle_end, "inv_axeblade" );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
end;

--------------------------------------------------------------------------------------------
function public.get_axe()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjDelete( "gfx_axe_axeblade" );
  cmn.SetEventDone( "get_axe" );
  cmn.CallEventHandler( "get_axe", "inv_axeblade" );
  common_impl.HideDeployInv();

end;
--------------------------------------------------------------------------------------------
function public.use_axehandle()

  local item = "inv_axehandle";

  if ( private.ObjIntersectCheck( item, "obj_axeblade_use_axehandle" ) )  then

    cmn.CallEventHandler( "use_axehandle_inv" );
    cmn.CallEventHandler( "use_axehandle_beg", "inv_axeblade" );

    local func_end = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_axehandle" );
      cmn.CallEventHandler( "use_axehandle_end", "inv_axeblade" );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_axe_insert", 0, "", 0 );
    ObjAnimate( "spr_deploy_axeblade_axe_handle", "alp",    0, 0, "", { 0,3,0,  0.4,3,1 } );
    ObjAnimate( "spr_deploy_axeblade_axe_handle", "pos_xy", 0, 0, func_end, { 0,3,-168,33, 0.4,3,-168,33,  1.0,3,-91,-41 } );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** flashlight *** () end;
--*********************************************************************************************************************
function private.init_flashlight()

  common_impl.hint[ "get_workingflashlight" ] = {
      type = "get",
      get_obj = "obj_flashlight_workingflashlight_get",
      room = "int_deploy_inv",
      zz = "deploy_inv_flashlight",
      zz_gate = "inv_flashlight"
  };

  function get_workingflashlight_inv ()

    interface.InventoryItemRemove( "inv_flashlight" );
    interface.InventoryItemAdd( "inv_workingflashlight", "obj_flashlight_workingflashlight_get" );
    ObjDelete( "gfx_flashlight_workingflashlight" );

  end;

  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_workingflashlight", get_workingflashlight_inv );
  -------------------------------------------------------------------------------------------
  ObjSet( "obj_flashlight_workingflashlight_get", { event_mdown = level2_inv.get_workingflashlight });
  --------------------------------------------------------------------------------------------
  -------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bulb" ] = {
      type = "use",
      inv_obj = "inv_bulb",
      use_place = "obj_flashlight_use_bulb",
      room = "int_deploy_inv",
      zz = "deploy_inv_flashlight",
      zz_gate = "inv_flashlight"
  };
  function use_bulb_inv ()

    interface.InventoryItemRemove( "inv_bulb" );

  end;
  function use_bulb_beg ()

    ObjDelete( "obj_flashlight_use_bulb" );

  end;
  function use_bulb_end ()
    
    ObjDelete( "anm_deploy_flashlight_flashlight_static" );
    ObjDelete( "anm_deploy_flashlight_flashlight_use" );

    ObjSet( "anm_deploy_flashlight_flashlight_static_works",  { active = true, visible = true, alp = 1, playing = true } );
    ObjSet( "gfx_flashlight_workingflashlight",               { active = true } );
    ObjSet( "obj_flashlight_workingflashlight_get",           { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bulb", use_bulb_beg, "inv_flashlight");
  cmn.AddSubscriber( "use_bulb", use_bulb_inv );
  cmn.AddSubscriber( "use_bulb", use_bulb_end, "inv_flashlight" );
  cmn.AddSubscriber( "use_bulb_inv", use_bulb_inv );
  cmn.AddSubscriber( "use_bulb_beg", use_bulb_beg, "inv_flashlight" );
  cmn.AddSubscriber( "use_bulb_end", use_bulb_end, "inv_flashlight" );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
end;

--------------------------------------------------------------------------------------------
function public.get_workingflashlight()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_workingflashlight" );
  cmn.CallEventHandler( "get_workingflashlight", "inv_flashlight" );
  common_impl.HideDeployInv();

end;
--------------------------------------------------------------------------------------------
function public.use_bulb()

  local item = "inv_bulb";

  if ( private.ObjIntersectCheck( item, "obj_flashlight_use_bulb" ) )  then

    cmn.CallEventHandler( "use_bulb_inv" );
    cmn.CallEventHandler( "use_bulb_beg", "inv_flashlight" );

    local func_end = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_bulb" );
      cmn.CallEventHandler( "use_bulb_end", "inv_flashlight" );
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_flashlight_lamp", 0, "", 0 );
    ObjSet( "anm_deploy_flashlight_flashlight_static", { visible = false, active = true  } );
    ObjSet( "anm_deploy_flashlight_flashlight_use",    { visible = true, active = true, alp = 1 } );
    AnimPlay( "anm_deploy_flashlight_flashlight_use", "DoAnim", func_end );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** receiverpieces *** () end;
--*********************************************************************************************************************
function private.init_receiverpieces()

  common_impl.hint[ "get_fuse" ] = {
      type = "get",
      get_obj = "obj_deploy_receiverpieces_fuse",
      room = "int_deploy_inv",
      zz = "deploy_inv_receiverpieces",
      zz_gate = "inv_receiverpieces"
  };

  function get_fuse_inv ()

    interface.InventoryItemRemove( "inv_receiverpieces" );
    interface.InventoryItemAdd( "inv_fuse", "obj_deploy_receiverpieces_fuse" );    

  end;

  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_fuse", get_fuse_inv );
  -------------------------------------------------------------------------------------------
  ObjSet( "obj_deploy_receiverpieces_fuse", { event_mdown = level2_inv.get_fuse });
  --------------------------------------------------------------------------------------------
  -------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tweezers" ] = {
      type = "use",
      inv_obj = "inv_tweezers",
      use_place = "obj_receiverpieces_use_tweezers",
      room = "int_deploy_inv",
      zz = "deploy_inv_receiverpieces",
      zz_gate = "inv_receiverpieces"
  };
  function use_tweezers_inv ()

    --interface.InventoryItemRemove( "inv_tweezers" );

  end;
  function use_tweezers_beg ()

    ObjDelete( "obj_receiverpieces_use_tweezers" );

  end;
  function use_tweezers_end ()
    
    ObjDelete( "anm_deploy_receiverpieces_receiverpieces_static" );
    ObjDelete( "anm_deploy_receiverpieces_receiverpieces_use" );

    ObjSet( "anm_deploy_receiverpieces_receiverpieces_static_works",  { active = true, visible = true, alp = 1, playing = true } );
    ObjSet( "gfx_deploy_receiverpieces_fuse",        { active = true } );
    ObjSet( "obj_deploy_receiverpieces_fuse",        { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tweezers", use_tweezers_beg, "inv_receiverpieces");
  cmn.AddSubscriber( "use_tweezers", use_tweezers_inv );
  cmn.AddSubscriber( "use_tweezers", use_tweezers_end, "inv_receiverpieces" );
  cmn.AddSubscriber( "use_tweezers_inv", use_tweezers_inv );
  cmn.AddSubscriber( "use_tweezers_beg", use_tweezers_beg, "inv_receiverpieces" );
  cmn.AddSubscriber( "use_tweezers_end", use_tweezers_end, "inv_receiverpieces" );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
end;

--------------------------------------------------------------------------------------------
function public.get_fuse()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_fuse" );
  cmn.CallEventHandler( "get_fuse", "inv_receiverpieces" );
  common_impl.HideDeployInv();
  ObjDelete( "gfx_deploy_receiverpieces_fuse" );

end;
--------------------------------------------------------------------------------------------
function public.use_tweezers()

  local item = "inv_tweezers";

  if ( common.ApplyObj( item, "obj_fireequipment_use_magnet", true ) ) then

    common_impl.ShowBbt( 'bbt_wrongapply_tweezers' );
    return true;
    
  elseif ( private.ObjIntersectCheck( item, "obj_receiverpieces_use_tweezers" ) )  then

    interface.InventoryItemRemove( "inv_tweezers" );
    cmn.CallEventHandler( "use_tweezers_inv" );
    cmn.CallEventHandler( "use_tweezers_beg", "inv_receiverpieces" );

    local func_end = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_tweezers" );
      cmn.CallEventHandler( "use_tweezers_end", "inv_receiverpieces" );
      interface.InventoryItemAdd( "inv_tweezers" );

    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_reciever_tweezers", 0, "", 0 );

    ObjSet( "anm_deploy_receiverpieces_receiverpieces_static", { visible = false, active = true  } );
    ObjSet( "anm_deploy_receiverpieces_receiverpieces_use",    { visible = true, active = true, alp = 1 } );
    AnimPlay( "anm_deploy_receiverpieces_receiverpieces_use", "DoAnim", func_end );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** wounddevice *** () end;
--*********************************************************************************************************************
function private.init_wounddevice()

  common_impl.hint[ "get_electricaltape" ] = {
      type = "get",
      get_obj = "obj_deploy_wounddevice_electricaltape",
      room = "int_deploy_inv",
      zz = "deploy_inv_wounddevice",
      zz_gate = "inv_wounddevice"
  };

  function get_electricaltape_inv ()

    interface.InventoryItemRemove( "inv_wounddevice" );
    interface.InventoryItemAdd( "inv_electricaltape", "obj_deploy_wounddevice_electricaltape" );
    ObjDelete( "gfx_deploy_wounddevice_electricaltape" );

  end;

  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_electricaltape", get_electricaltape_inv );
  -------------------------------------------------------------------------------------------
  ObjSet( "obj_deploy_wounddevice_electricaltape", { event_mdown = level2_inv.get_electricaltape });
  --------------------------------------------------------------------------------------------
  -------------------------------------------------------------------------------------------
  common_impl.hint[ "use_knife_3" ] = {
      type = "use",
      inv_obj = "inv_knife",
      use_place = "obj_wounddevice_use_knife_3",
      room = "int_deploy_inv",
      zz = "deploy_inv_wounddevice",
      zz_gate = "inv_wounddevice"
  };
  function use_knife_3_inv ()

    --interface.InventoryItemRemove( "inv_knife" );

  end;
  function use_knife_3_beg ()

    ObjDelete( "obj_wounddevice_use_knife_3" );

  end;
  function use_knife_3_end ()
    
    ObjDelete( "anm_deploy_wounddevice_wounddevice_static" );
    ObjDelete( "anm_deploy_wounddevice_wounddevice_use" );

    ObjSet( "anm_deploy_wounddevice_wounddevice_works",     { active = true, visible = true, alp = 1, playing = true } );
    ObjSet( "gfx_deploy_wounddevice_electricaltape",        { active = true } );
    ObjSet( "obj_deploy_wounddevice_electricaltape",        { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_knife_3", use_knife_3_beg, "inv_wounddevice");
  cmn.AddSubscriber( "use_knife_3", use_knife_3_inv );
  cmn.AddSubscriber( "use_knife_3", use_knife_3_end, "inv_wounddevice" );
  cmn.AddSubscriber( "use_knife_3_inv", use_knife_3_inv );
  cmn.AddSubscriber( "use_knife_3_beg", use_knife_3_beg, "inv_wounddevice" );
  cmn.AddSubscriber( "use_knife_3_end", use_knife_3_end, "inv_wounddevice" );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
end;

--------------------------------------------------------------------------------------------
function public.get_electricaltape()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_electricaltape" );
  cmn.CallEventHandler( "get_electricaltape", "inv_wounddevice" );
  common_impl.HideDeployInv();

end;
--------------------------------------------------------------------------------------------
function public.use_knife_3()

  local item = "inv_knife";

  if ( private.ObjIntersectCheck( item, "obj_wounddevice_use_knife_3" ) and 
       not cmn.IsEventDone( "use_knife_3" )  )  then

    cmn.CallEventHandler( "use_knife_3_inv" );
    cmn.CallEventHandler( "use_knife_3_beg", "inv_wounddevice" );

    local func_end = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_knife_3" );
      cmn.CallEventHandler( "use_knife_3_end", "inv_wounddevice" );
      
    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_broken_device_knife", 0, "", 0 );

    common_impl.Lock( true );
    ObjSet( "anm_deploy_wounddevice_wounddevice_static", { visible = false, active = true  } );
    ObjSet( "anm_deploy_wounddevice_wounddevice_use",    { visible = true, active = true, alp = 1 } );
    AnimPlay( "anm_deploy_wounddevice_wounddevice_use", "DoAnim", func_end );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** remotecontrol *** () end;
--*********************************************************************************************************************
function private.init_remotecontrol()

  common_impl.hint[ "get_tumblerswitch" ] = {
      type = "get",
      get_obj = "obj_deploy_remotecontrol_tumblerswitch",
      room = "int_deploy_inv",
      zz = "deploy_inv_remotecontrol",
      zz_gate = "inv_remotecontrol"
  };

  function get_tumblerswitch_inv ()

    interface.InventoryItemRemove( "inv_remotecontrol" );
    interface.InventoryItemAdd( "inv_tumblerswitch", "obj_deploy_remotecontrol_tumblerswitch" );
    ObjDelete( "gfx_deploy_remotecontrol_tumblerswitch" );

  end;

  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_tumblerswitch", get_tumblerswitch_inv );
  -------------------------------------------------------------------------------------------
  ObjSet( "obj_deploy_remotecontrol_tumblerswitch", { event_mdown = level2_inv.get_tumblerswitch });
  --------------------------------------------------------------------------------------------
  -------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriver2_2" ] = {
      type = "use",
      inv_obj = "inv_screwdriver2",
      use_place = "obj_remotecontrol_use_screwdriver2_2",
      room = "int_deploy_inv",
      zz = "deploy_inv_remotecontrol",
      zz_gate = "inv_remotecontrol"
  };
  function use_screwdriver2_2_inv ()

    if ( cmn.IsEventDone( "use_screwdriver2_1" ) ) then
      
      interface.InventoryItemRemove( "inv_screwdriver2" );
  
    end;
    if ( not cmn.IsEventDone( "get_knife" ) ) then

      ObjSet( "spr_remotecontrol_plus_light", { visible = false } );
  
    end;

  end;
  function use_screwdriver2_2_beg ()

    ObjDelete( "obj_remotecontrol_use_screwdriver2_2" );

  end;
  function use_screwdriver2_2_end ()
    
    ObjSet( "obj_remotecontrol_use_knife_4",        { input = true } );
    ObjDelete( "anm_deploy_remotecontrol_remotecontrol_aftervid" );
    ObjDelete( "spr_deploy_remotecontrol_remotecontrol_bolt_1" );
    ObjDelete( "spr_deploy_remotecontrol_remotecontrol_bolt_2" );
    ObjDelete( "vid_deploy_remotecontrol_use_screwdriver" );
    ObjDelete( "anm_deploy_remotecontrol_remotecontrol_static" );
    ObjSet( "anm_deploy_remotecontrol_remotecontrol_aftervid_1", { alp = 1 } );


  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screwdriver2_2", use_screwdriver2_2_beg, "inv_remotecontrol");
  cmn.AddSubscriber( "use_screwdriver2_2", use_screwdriver2_2_inv );
  cmn.AddSubscriber( "use_screwdriver2_2", use_screwdriver2_2_end, "inv_remotecontrol" );
  cmn.AddSubscriber( "use_screwdriver2_2_inv", use_screwdriver2_2_inv );
  cmn.AddSubscriber( "use_screwdriver2_2_beg", use_screwdriver2_2_beg, "inv_remotecontrol" );
  cmn.AddSubscriber( "use_screwdriver2_2_end", use_screwdriver2_2_end, "inv_remotecontrol" );
  --------------------------------------------------------------------------------------------
  -------------------------------------------------------------------------------------------
  common_impl.hint[ "use_knife_4" ] = {
      type = "use",
      inv_obj = "inv_knife",
      use_place = "obj_remotecontrol_use_knife_4",
      room = "int_deploy_inv",
      zz = "deploy_inv_remotecontrol",
      zz_gate = "inv_remotecontrol"
  };
  function use_knife_4_inv ()

    --interface.InventoryItemRemove( "inv_knife" );

  end;
  function use_knife_4_beg ()

    ObjDelete( "obj_remotecontrol_use_knife_4" );

  end;
  function use_knife_4_end ()
    
    ObjDelete( "anm_deploy_remotecontrol_remotecontrol_use" );
    ObjDelete( "anm_deploy_remotecontrol_remotecontrol_aftervid_1" );
    ObjSet( "anm_deploy_remotecontrol_remotecontrol_works",  { active = true, visible = true, alp = 1, playing = true } );
    ObjSet( "gfx_deploy_remotecontrol_tumblerswitch",        { active = true } );
    ObjSet( "obj_deploy_remotecontrol_tumblerswitch",        { input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_knife_4", use_knife_4_beg, "inv_remotecontrol");
  cmn.AddSubscriber( "use_knife_4", use_knife_4_inv );
  cmn.AddSubscriber( "use_knife_4", use_knife_4_end, "inv_remotecontrol" );
  cmn.AddSubscriber( "use_knife_4_inv", use_knife_4_inv );
  cmn.AddSubscriber( "use_knife_4_beg", use_knife_4_beg, "inv_remotecontrol" );
  cmn.AddSubscriber( "use_knife_4_end", use_knife_4_end, "inv_remotecontrol" );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
end;

--------------------------------------------------------------------------------------------
function public.get_tumblerswitch()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_tumblerswitch" );
  cmn.CallEventHandler( "get_tumblerswitch", "inv_remotecontrol" );
  common_impl.HideDeployInv();

end;
--------------------------------------------------------------------------------------------
function public.use_screwdriver2_2()

  local item = "inv_screwdriver2";

  if ( private.ObjIntersectCheck( item, "obj_remotecontrol_use_screwdriver2_2" ) and 
       not cmn.IsEventDone( "use_screwdriver2_2" ) )  then

    common_impl.Lock( true );
    cmn.CallEventHandler( "use_screwdriver2_2_inv" );
    cmn.CallEventHandler( "use_screwdriver2_2_beg", "inv_remotecontrol" );

    local func_end = function ()

      local func_end_2 = function ()

        common_impl.Lock( false );
        cmn.SetEventDone( "use_screwdriver2_2" );
        cmn.CallEventHandler( "use_screwdriver2_2_end", "inv_remotecontrol" );

      end;

      ObjSet( "anm_deploy_remotecontrol_remotecontrol_aftervid", { alp = 1 });
      AnimPlay( "anm_deploy_remotecontrol_remotecontrol_aftervid", "DoAnim", func_end_2 );
      
    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_remotecontrol_hex", 0, "", 0 );

    ObjAnimate( "spr_deploy_remotecontrol_remotecontrol_bolt_1", "alp", 0, 0, "", { 0, 0, 1, 0.2, 0, 0 });
    ObjAnimate( "spr_deploy_remotecontrol_remotecontrol_bolt_2", "alp", 0, 0, "", { 0, 0, 1, 0.2, 0, 0 });
    ObjAnimate( "vid_deploy_remotecontrol_use_screwdriver", "alp", 0, 0, "", { 0, 2, 0, 0.2, 2, 1 });
    ObjSet( "vid_deploy_remotecontrol_use_screwdriver", { playing = true, endtrig = func_end  });

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_knife_4()

  local item = "inv_knife";

  if ( private.ObjIntersectCheck( item, "obj_remotecontrol_use_knife_4" ) and 
       not cmn.IsEventDone( "use_knife_4" ) and 
       cmn.IsEventDone( "use_screwdriver2_2" )  )  then

    cmn.CallEventHandler( "use_knife_4_inv" );
    cmn.CallEventHandler( "use_knife_4_beg", "inv_remotecontrol" );

    local func_end = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_knife_4" );
      cmn.CallEventHandler( "use_knife_4_end", "inv_remotecontrol" );
      
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_remotecontrol_knife", 0, "", 0 );

    ObjSet( "anm_deploy_remotecontrol_remotecontrol_aftervid_1", { alp = 0  } );
    ObjSet( "anm_deploy_remotecontrol_remotecontrol_use",    { visible = true, active = true, alp = 1 } );
    AnimPlay( "anm_deploy_remotecontrol_remotecontrol_use", "DoAnim", func_end );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** brokengasolinesaw_2 *** () end;
--*********************************************************************************************************************
function private.init_brokengasolinesaw_2()

  ObjAnimate( "spr_deploy_brokengasolinesaw_brokenchain_2_1", "ang", 1, 0, "", { 0,0,-0.01, 1.5,0,0.05, 3,0,-0.01 } );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------