-- name=rm_abandoneddistrict_2
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_abandoneddistrict_2";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_trunk_2", "room_hub" );  

  local enter_func = function () common_impl.SetCursor( CURSOR_GET ) end;
  local leave_func = function () common_impl.SetCursor( CURSOR_DEFAULT ) end;

  ObjMultiSet({    
    { "spr_trunk_2_evidence_1_9", { event_mdown = private.get_evidence_1_9 }},
    { "spr_trunk_2_coin",{event_mdown = function() private.get_coin10() end  }},
    { "spr_abandoneddistrict_2_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_1_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_abandoneddistrict_2_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_7" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
 });

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_abandoneddistrict_2 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gzz_abandoneddistrict_2_trunk_2",      
      "gzz_abandoneddistrict_2_goaf",
    };
    for i = 1, #gates do
    
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_trunk_2",

    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_abandoneddistrict_2", update_game_mode_abandoneddistrict_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_abandoneddistrict_2 = function ()
    
    local effects_table = 
    {
      "obj_abandoneddistrict_2_anims",
      "spr_abandoneddistrict_2_plate",
      "spr_abandoneddistrict_2_flag_1",
      "spr_abandoneddistrict_2_flag_2"  
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_abandoneddistrict_2", update_performance_mode_abandoneddistrict_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_abandoneddistrict_2 () end;
  --------------------------------------------------------------------------------------------
  local opn_abandoneddistrict_2_map = function ()

    common_impl.VisitMapRoom( "abandoneddistrict" );

  end;
  cmn.AddSubscriber( "opn_abandoneddistrict_2", opn_abandoneddistrict_2_map, nil );
  --------------------------------------------------------------------------------------------
  -- function get_coins () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_10 = function ()

    ObjDelete( "obj_trunk_2_coin" );
    ObjDelete( "gzz_abandoneddistrict_2_trunk_2" );

  end;
  cmn.AddSubscriber( "get_coin_10", get_collect_coin_10, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function get_collect_item_1_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_1_3 = function ()
  
    ObjDelete( "obj_abandoneddistrict_2_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_1_3", get_collect_item_1_3, private.room_objname );
   --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_7 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_7 = function ()
  
    ObjDelete( "obj_abandoneddistrict_2_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_7", get_collect_morph_item_1_7, private.room_objname );

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_abandoneddistrict_2();

  --int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();
  common_impl.EnvPlay( { "common/audio/aud_abandoneddistrict_env" }, "", 0.5 );

  interface.InvestigationButtonCheck();

end;
--*********************************************************************************************************************
function public.Close()

  --common_impl.StopAudio( "env", "common/audio/aud_abandoneddistrict_2_env", 0.2 );

end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.get_coin10()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_10");
    cmn.CallEventHandler("get_coin_10");
 
    common.CloseSubRoom();
   

  end;
    
  common_impl.PlayEffectHO( "spr_trunk_2_coin", func_after );
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_abandoneddistrict_2 ()
  
   cmn.CallEventHandler( "opn_abandoneddistrict_2" ); 

end;
--*********************************************************************************************************************
ObjAnimate( "spr_abandoneddistrict_2_liana_1", "ang", 1, 0, "", { 0.0, 0, -0.03,  2.5, 0, 0.03,  5.0, 0, -0.03 } );
ObjAnimate( "spr_abandoneddistrict_2_liana_2", "ang", 1, 0, "", { 0.0, 0, 0.03,   3.0, 0, -0.03, 6.0, 0, 0.03 } );
ObjAnimate( "spr_abandoneddistrict_2_liana_3", "ang", 1, 0, "", { 0.0, 0, -0.03,  3.5, 0, 0.03,  7.0, 0, -0.03 } );
ObjAnimate( "spr_abandoneddistrict_2_liana_4", "ang", 1, 0, "", { 0.0, 0, 0.06,   2.7, 0, 0.02,  5.4, 0, 0.06 } );
ObjAnimate( "spr_abandoneddistrict_2_plate", "ang", 1, 0, "", { 0.0, 0, 0.02,   2.7, 0, 0,  5.4, 0, 0.02 } );

ObjAnimate( "spr_abandoneddistrict_2_light_1", "alp", 1, 0, "", { 0,0,0.3,  1.7,0,1,  3.4,0,0.3 } );
ObjAnimate( "spr_abandoneddistrict_2_light_2", "alp", 1, 0, "", { 0,0,0.3,  1.5,0,1,  3,0,0.3 } );
ObjAnimate( "spr_abandoneddistrict_2_light_3", "alp", 1, 0, "", { 0,0,0.3,  1.0,0,1,  2.0,0,0.3 } );
ObjAnimate( "spr_abandoneddistrict_2_flag_1", "scale_xy", 1, 0, "", { 0,0,1,1,  2,0,0.9,0.9,  4.0,0,1,1 } );
ObjAnimate( "spr_abandoneddistrict_2_flag_2", "scale_xy", 1, 0, "", { 0,0,1,1,  2,0,0.9,0.9,  4.0,0,1,1 } );
