-- name=rm_area
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_area";
  ObjAttach( "zz_auto", "room_hub" );
  private.dial_mmg_coords = { { { 134, 143 }, { 101, 126 }, 0 }, { { -141, 128 }, { -102, 84 }, 0 } };
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "gzz_area_auto", { event_mdown = function () cmn.GotoSubRoom( "zz_auto", nil, { 512, 384 } ); end; } },
    { "spr_auto_door", { event_mdown = function () common_impl.ShowBbt( 'bbt_car_clk_door' );private.ClickCarHandle(); end } },
    { "obj_area_clk_garage_open", { event_mdown = private.clk_open_garage } },
    { "obj_area_poster_clk", { event_mdown = function () common_impl.NoteScale( "open", "grd_area_poster" ) end } },
    { "spr_area_poster_big", { event_mdown = function () common_impl.NoteScale( "close", "grd_area_poster" ) end } },
    { "spr_area_poster_big1", { event_mdown = function () common_impl.NoteScale( "close", "grd_area_poster" ) end } },
    { "obj_vid_area_oulmen", { event_mdown = private.vid_area_oulmen } },
    { "obj_dlg_area_joker", { event_mdown = private.dlg_area_joker } },
    { "obj_dlg_area_joker_focus", { event_mdown = private.dlg_area_joker } },
    { "spr_area_joker_mmg_part_2", { event_startdrag = function() private.JokerDialPartDrag( 2 ); end ,event_dragdrop = function() private.JokerDialPartDrop( 2 ); end } },
    { "spr_area_joker_mmg_part_3", { event_startdrag = function() private.JokerDialPartDrag( 3 ); end, event_dragdrop = function() private.JokerDialPartDrop( 3 ); end } },
    { "spr_area_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    
  });

  ObjAnimate( "spr_auto_light", "alp", 1, 0, "", { 0,0,0, 0.5,0,1, 1,0,0 } );
  ObjAnimate( "spr_auto_button_light", "alp", 1, 0, "", { 0,0,0, 0.5,0,0.5, 1,0,0 } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_area = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_area_auto",
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;
  
  end;

  local mas_parent_gfx = 

      {
        private.room_objname,
        "zz_auto",
      
      };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_area", update_game_mode_area, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_area = function ()

  local effects_table = 
  {
    "anm_area_light",
    "anm_area_light",
    "spr_area_index_shadow",
    "spr_area_index",
    "anm_area_citizens_police",
    "anm_area_citizens_dodik",
    "anm_area_citizens_2",
    "grd_area_poster",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_area", update_performance_mode_area, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_area () end;
  --------------------------------------------------------------------------------------------
  local opn_area_map = function ()

    common_impl.VisitMapRoom( "square" );

  end;
  cmn.AddSubscriber( "opn_area", opn_area_map, nil );
  --------------------------------------------------------------------------------------------
  -- function beg_level2 () end;
  --------------------------------------------------------------------------------------------
  local beg_level2 = function ()

    ObjSet( "spr_int_panel_providence", { alp = 1 } );
    interface.InventoryItemAdd( "inv_elf_2" );
    interface.InventoryItemAdd( "inv_corkscrew_2" );
    interface.InventoryItemAdd( "inv_brokengasolinesaw_2" );
    ObjSet( "inv_brokengasolinesaw_2", { drag = false });

  end;
  cmn.AddSubscriber( "beg_level2", beg_level2 );
  --------------------------------------------------------------------------------------------
  -- function get_owl () end;
  --------------------------------------------------------------------------------------------
  local get_owl_inv = function ()
  
    interface.InventoryItemAdd( "inv_owl", "spr_area_joker_mmg_part_1" );
  
  end;
  local get_owl_closezz = function ()
  
  end;
  
  cmn.AddSubscriber( "get_owl", get_owl_inv );
  cmn.AddSubscriber( "get_owl", get_owl_closezz, private.room_objname );
   --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_3 = function ()
  
    ObjDelete( "obj_area_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_3", get_collect_morph_item_1_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_area_joker () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_area_joker" ] = {

      type = "click",
      use_place = "obj_dlg_area_joker_focus",
      room = private.room_objname
  };

  local dlg_area_joker_end = function ()

    ObjDelete( "obj_dlg_area_joker" );
    ObjDelete( "anm_area_joker" );
    ObjDelete( "anm_area_citizens_dodik" );
    ObjSet( "obj_area_jump", { alp = 1, input = true });
 
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_area_joker", dlg_area_joker_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_area_joker_end", dlg_area_joker_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function vid_area_oulmen () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_area_oulmen" ] = {

      type = "click",
      use_place = "obj_vid_area_oulmen",
      room = private.room_objname
  };
  local vid_area_oulmen_beg = function ()

    ObjDelete( "obj_vid_area_oulmen" );

  end;
  local vid_area_oulmen_end = function ()

    ObjMultiSet({ 
      { "obj_dlg_area_joker", { input = true }},
      { "anm_area_citizens_dodik", { alp = 1 }},
      { "rm_area", { color_r = 1, color_g = 1, color_b = 1 }}
    });

  end;

  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "vid_area_oulmen", vid_area_oulmen_beg, private.room_objname );
  cmn.AddSubscriber( "vid_area_oulmen", vid_area_oulmen_end, private.room_objname  );
  cmn.AddSubscriber( "vid_area_oulmen_beg", vid_area_oulmen_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_area_oulmen_end", vid_area_oulmen_end, private.room_objname  );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_auto" );
  
  function zz_auto.PreOpen()

    ObjSet( "spr_auto_door", { input = 1 } );
    ObjSet( "spr_auto_door_handle", { scale_x = 1 } );

    common_impl.StopAudio( "sfx", "common/audio/aud_cat_and_crows", 1 );
    AnimStop( "anm_area_cat" ); 

  end;
  
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_area();
  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

  if cmn.IsEventDone( "dlg_area_joker" ) then

      local rand = math.random( 1, 5 );
      
      if rand == 3 then 

        private.change_dodik( true );

      else

        private.change_dodik();

      end;

  end;


end;
--*********************************************************************************************************************
function public.PreOpen()

  private.Play_anm_cat();
  common_impl.MorphItemMorphing();

  if ( not cmn.IsEventDone( "beg_level2" ) ) then

    cmn.SetEventDone( "beg_level2" );
    cmn.SetEventDone( "opn_basement_2" );
    cmn.CallEventHandler( "beg_level2" );
    ng_global.investigation = 4;
    common_impl.UpdateGameMode( ng_global.gamemode );

  end;

  common_impl.EnvPlay( { "common/audio/aud_square_env" }, "", 0.5 );
  common_impl.PlayAudio( "env", "common/audio/aud_square_people_env", 1, "", 0.5 );

  --запускать сразу
  if ( not cmn.IsEventDone( "vid_area_oulmen" ) ) then
    private.vid_area_oulmen();
  end;

  interface.InvestigationButtonCheck();

end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );
  common_impl.StopAudio( "env", "common/audio/aud_square_people_env", 0.2 );
  common_impl.StopAudio( "sfx", "common/audio/aud_cat_and_crows", 1 );
  AnimStop( "anm_area_cat" ); 

  AnimStop( "anm_area_jump" );
  common_impl.StopAudio( "sfx", "common/audio/aud_idiot", 0, "", 0 );

end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.get_owl()
    DbgTrace("private.get_owl");
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  cmn.SetEventDone( "get_owl" );
  cmn.CallEventHandler( "get_owl" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_open_garage()

  local trg_after = function ()

    common_impl.Lock(false);

  end;

  common_impl.Lock(true);

  AnimPlay( "anm_area_garage_open", "DoAnim", trg_after ); 
 
end;
function private.ClickCarHandle()

  ObjSet( "spr_auto_door", { input = 0 } )

  local trg_after = function()

    ObjSet( "spr_auto_door", { input = 1 } )    

  end;
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_police_car_handle", 0, "", 0 );
  ObjAnimate( "spr_auto_door_handle", "scale_x", 0, 0, trg_after, { 0,0,1, 0.2,0,0.8, 0.4,0,1 } );
  ObjAnimate( "spr_auto_door_handle_shadow", "pos_y", 0, 0, trg_after, { 0,0,198, 0.2,0,204, 0.4,0,198 } );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if dlg_name == "joker" then

    local func_anim_change = function()

      ObjSet( "tmr_area_dlg_anim", { playing = false } );
    

      ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = private.ClkJokerDial } );
    
    end;

    if count_txt == 1 then 

      common_impl.continue_visible = false; 
      common_impl.frases = { 1 }; 
      common_impl.dial_icons = { 'owlman' };
      common_impl.DialogCharacterShowDialogQuestions( 1, 11 );       
      ObjSet( "anm_area_joker_joker_1", { alp = 0 } );
      ObjSet( "obj_area_joker_anm_2", { alp = 1 } ); 
      common_impl.DialogCharacterChangeCharacters( "joker", false, "sheriff" );
    
    elseif count_txt == 2 then 
      

      common_impl.continue_visible = false; 
      common_impl.DialogCharacterChangeCharacters( "joker", "sheriff", "joker" );
      ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = func_anim_change } );
      ObjSet( "tmr_area_dlg_anim", { playing = true, time = 1, endtrig = func_anim_change } );
     
    
    elseif count_txt == 3 then 

      common_impl.continue_visible = true;
      common_impl.DialogCharacterChangeCharacters( "joker", "sheriff", "joker" );
    
    elseif count_txt == 4 then 

      common_impl.continue_visible = false; 
      common_impl.frases = { 3 }; 
      common_impl.dial_icons = { 'loupe' };
      common_impl.DialogCharacterChangeCharacters( "joker", "joker", "sheriff" ); 
      common_impl.DialogCharacterShowDialogQuestions( 1, 5 ); 

    elseif count_txt == 6 then 

     ObjSet( "spr_area_joker_mmg_part_1", { alp = 1 } ); 
     ObjSet( "obj_area_joker_mmg", { pos_x = -500, pos_y = -130 } ); 
     ObjSet( "spr_int_dialog_character_bot", { alp = 0 } );
     ObjSet( "txt_int_dialog_character", { alp = 0 } );

    end;
  
  end;

end;
--*********************************************************************************************************************
function private.GetJokerDialOwl()

    local func_after = function()
      common_impl.Lock( false );
      common_impl.DialogCharacterMmgHide( "joker", "JokerDialMmgEnd"  );

    end;

   common_impl.Lock( true );

    ObjAnimate( "spr_area_joker_mmg_part_1", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
    ObjAnimate( "spr_area_joker_mmg_part_1", "scale_xy", 0, 0, func_after, { 0,0,1,1, 0.3,0,1.05,1.05 } );


end;
--*********************************************************************************************************************
function private.ClkJokerDial()

  common_impl.DialogCharacterMmgShow( "joker", 400, 200  );

  ObjAnimate( "obj_area_joker_sheriff", "color_rgb", 0, 0, "", { 0,0,1,1,1, 0.3,0,0.5,0.5,0.5 } );
  ObjAnimate( "obj_area_joker_joker", "color_rgb", 0, 0, "", { 0,0,1,1,1, 0.3,0,0.5,0.5,0.5 } );
  ObjAnimate( "obj_area_joker_mmg", "color_rgb", 0, 0, "", { 0,0,0.4,0.4,0.4, 0.3,0,1,1,1 } );
  ObjAnimate( "obj_area_joker_joker", "scale_xy", 0, 0, "", { 0,0,1.05,1.05, 0.3,0,1,1 } );

  ObjSet( "anm_area_joker_joker_1", { alp = 1 } );
  ObjSet( "anm_area_joker_joker_2", { alp = 0 } ); 
  ObjSet( "spr_area_joker_joker_over", { alp = 0 } ); 
  ObjSet( "spr_area_joker_sheriff_over", { alp = 0 } ); 

end;
--*********************************************************************************************************************
function public.JokerDialMmgEnd()
    common_impl.frases = { 2 }; 
    common_impl.dial_icons = { 'willowsville' };
    common_impl.DialogCharacterShowDialogQuestions( 1 ); 

end;
--*********************************************************************************************************************
function private.JokerDialPartDrag( number )

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_area_joker_mmg_part_"..number, { pos_z = 5 } );

end;
--*********************************************************************************************************************
function private.JokerDialPartDrop( number )

   if ( ObjIntersect( "spr_area_joker_mmg_part_"..number, "obj_area_joker_mmg_use_part_"..number ) ) then

      local func_after = function()

        common_impl.Lock( false );
        ObjSet( "spr_area_joker_mmg_part_"..number, { input = false, pos_z = 0 } );
        ObjDelete( "obj_area_joker_mmg_use_part_"..number );
        private.dial_mmg_coords[number-1][3] = 1;

        if private.dial_mmg_coords[1][3] == 1 and private.dial_mmg_coords[2][3] then

        ObjSet( "spr_area_joker_mmg_part_1", { event_mdown = function() private.GetJokerDialOwl(); end } );

        end;

      end;

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_owl_insert_part", 0, "", 0 );

      ObjAnimate( "spr_area_joker_mmg_part_"..number, "pos_xy", 0, 0, func_after, { 0,0,private.dial_mmg_coords[number-1][1][1],private.dial_mmg_coords[number-1][1][2],
                                                                            0.4,0,private.dial_mmg_coords[number-1][2][1],private.dial_mmg_coords[number-1][2][2] } );


   else

      ObjSet( "spr_area_joker_mmg_part_"..number, { pos_z = 0 } );

   end;

end;
--*********************************************************************************************************************
function private.vid_area_oulmen()

  cmn.CallEventHandler( "vid_area_oulmen_beg" );
  ObjSet( "rm_area", { color_r = 0, color_g = 0, color_b = 0 } );
  ObjSet( "vid_area_oulmen", { alp = 1, active = true, input = false, visible = true } );

  local widget_settings = {}

  if IsCollectorsEdition() then

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnGuide,
      InterfaceWidget_BtnMenu
    }

  else

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnMenu
    }

  end;
  
  local trg_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_area_oulmen" );
    cmn.CallEventHandler( "vid_area_oulmen_end" );
    common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0, "", 0 );
    common_impl.ShowBbt( 'bbt_area_after_owlman', 1 );
 
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_area_oulmen", 0.5 );

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

  end;

  for i = 1, #widget_settings do

    interface.WidgetSetVisible( widget_settings[i], 0 );

  end;
  
  common_impl.StopAllMus();

  interface.DialogVideoShow( "vid_area_oulmen", 1, function() trg_after ( 'skip' ); end , 3 );
  common_impl.PlayAudio( "sfx", "common/audio/aud_area_oulmen", 0, "", 0.5 );
  VidPlay( "vid_area_oulmen", function() trg_after( nil ); end ); 

end;
--*********************************************************************************************************************
function private.dlg_area_joker()

  ObjAttach( "dlg_area_joker", "rm_area" );
  ObjSet( "anm_area_citizens_dodik", { alp = 0 } );
  common_impl.dialog_character_loc = "obj_area_dlg_characters";
  common_impl.DialogCharacterStart( "joker", 6, nil, nil, true, "dlg_area_joker_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_area_joker_end()

  cmn.SetEventDone( "dlg_area_joker" );
  cmn.CallEventHandler( "dlg_area_joker_end" );
  ObjSet( "spr_int_dialog_character_bot", { alp = 1 } );
  ObjSet( "txt_int_dialog_character", { alp = 1 } );
  ObjAttach( "obj_area_joker_mmg", "obj_area_joker_characters" );
  ObjSet( "obj_area_joker_mmg", { alp = 0, input = false } );
  common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0, "", 0 );
  cmn.CallEventHandler( "dlg_area_joker_end" );
  int_investigation_button.Show( true );
  for i = 2,3 do

    ObjSet( "spr_area_joker_mmg_part_"..i, { pos_x = private.dial_mmg_coords[i-1][2][1], pos_y = private.dial_mmg_coords[i-1][2][2] } );

  end;
  ObjSet( "spr_area_joker_mmg_part_1", { alp = 1 } );
  DbgTrace("public.dlg_area_joker_end");
  private.get_owl();
  interface.KeyTaskAdd( "goto_nightsville" );
  
  private.change_dodik( true );

end;
------------------------------------------------------------------------------------
function private.Play_anm_cat()

  local table_multiset = {};

  table.insert( table_multiset, { "anm_area_cat", { playing = false, visible = false } } );

  local chance = math.random(1,10);

    if ( chance == 1) then

      table.insert( table_multiset,  { "anm_area_cat", { playing = true, frame = 1, visible = true } } );
      common_impl.PlayAudio( "sfx", "common/audio/aud_cat_and_crows", 0, "", 0 );

    end;

  ObjMultiSet(table_multiset);

end;
--*********************************************************************************************************************
function private.opn_area()

  if not ( cmn.IsEventDone( "opn_area" ) ) then


    local open_rooms = { "pier_2", "area", "divarication", "livingroom_2", "office_2", "basement_2", "abandoneddistrict_2" };

    for i = 1, #open_rooms do

      cmn.SetEventDone( "opn_"..open_rooms[i] );
      cmn.CallEventHandler( "opn_"..open_rooms[i] ); 

    end;
   
    ng_global.progress[ "std" ][ "opn_divarication" ].riverbank_enter = 0;

  end;

   cmn.CallEventHandler( "opn_area" ); 
    
end;
--*********************************************************************************************************************
function private.change_dodik( param )

 if ( param ) then

    common_impl.PlayAudio( "sfx", "common/audio/aud_idiot", 0, "", 0 );

    ObjMultiSet({

      { "anm_area_jump", { alp = 1, playing = true, frame = 0, endtrig = function () private.change_dodik() end } },
      { "anm_area_stand", { alp = 0 } },

    });

 else

    ObjMultiSet({

      { "anm_area_stand", { alp = 1, playing = true, frame = 0, endtrig = function () private.change_dodik( true ) end } },
      { "anm_area_jump", { alp = 0 } },

    });

 end;


end;