-- name=rm_basement_2
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_basement_2";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();  

  ObjMultiSet( {
    { "gzz_basement_2_bedsidetable_2", { event_mdown = function () cmn.GotoSubRoom( "zz_bedsidetable_2", nil, { 512, 384 } ); end; } },
    { "spr_bedsidetable_2_coin",            { event_mdown = function () private.get_coin9() end } },
    { "spr_basement_2_collect_item",        { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_1_2" );     end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_basement_2_collect_morph_item",  { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_6" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  });
  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_basement_2 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true; 
 
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then   
 
      visible_sparkle_area = false;

    end;

    local visible_sparkle_ho = true;  

    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then 
   
      visible_sparkle_ho = false;

    end;

    local gates = 
    {      
      "gzz_basement_2_bedsidetable_2"
    };

    for i = 1, #gates do
    
      local name = gates[ i ];

      if ( common.GetObjectPrefix( name ) == "gho" ) then
        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );

      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then   
     
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );

      end;

    end;

    local mas_parent_gfx = 

      {
        private.room_objname
      
      };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;

  end;

  cmn.AddSubscriber( "update_game_mode_basement_2", update_game_mode_basement_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_basement_2 = function ()
    
    local effects_table = 
    {
      "obj_basement_2_anims",
      "obj_basement_2_light"
    }

    local active = true;

    if ( GetPerformanceMode() == 1 ) then

      active = false;

    end;

    for i = 1, #effects_table do

      ObjSet( effects_table[ i ], { active = active } )

    end;

  end;

  cmn.AddSubscriber( "update_performance_mode_basement_2", update_performance_mode_basement_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_basement_2 () end;
  --------------------------------------------------------------------------------------------
  local opn_basement_2_map = function ()

    common_impl.VisitMapRoom( "basement" );

  end;

  cmn.AddSubscriber( "opn_basement_2", opn_basement_2_map, nil );
  --------------------------------------------------------------------------------------------
  -- function get_coin() end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_9 = function ()

    ObjDelete( "obj_bedsidetable_2_coin" );
    ObjDelete( "gzz_basement_2_bedsidetable_2" );

  end;

  cmn.AddSubscriber( "get_coin_9", get_collect_coin_9, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function get_collect_item_1_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_1_2 = function ()
  
    ObjDelete( "obj_basement_2_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_1_2", get_collect_item_1_2, private.room_objname );
   --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_6 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_6 = function ()
  
    ObjDelete( "obj_basement_2_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_6", get_collect_morph_item_1_6, private.room_objname );

end;
--*********************************************************************************************************************
function private.Init_Subroom()

  ObjAttach( "zz_bedsidetable_2", "room_hub" );
  --------------------------------------------------------------------------------------------

end;

--*********************************************************************************************************************
function public.Open()

  private.opn_basement_2();

  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();
  common_impl.EnvPlay( { "common/audio/aud_cellar_env" }, "", 0.5 );

  interface.InvestigationButtonCheck();

  ObjAnimate( "spr_basement_2_grass", "scale_xy", 1, 0, "",
  { 
    0.0, 0, 1, 1, 
    1.6, 0, 0.98,0.98,
    3.2, 0, 1, 1
  } );

  ObjAnimate( "spr_basement_2_horse", "ang", 1, 0, "",
  { 
    0.0, 3, 0.1, 
    1.5, 3, -0.1,
    3.0, 3, 0.1
  } );

  ObjAnimate( "spr_basement_2_plane", "ang", 1, 0, "",
  { 
    0.0, 3, -0.06, 
    1.7, 3, 0.06,
    3.4, 3, -0.06
  } );

  ObjAnimate( "obj_basement_2_light", "ang", 1, 0, "",
  { 
    0.0, 3, -0.06, 
    1.9, 3, 0.06,
    3.8, 3, -0.06
  } );

  ObjAnimate( "spr_basement_2_grass_2", "ang", 1, 0, "",
  { 
    0.0, 3, 0.04, 
    2.0, 3, -0.04,
    4.0, 3, 0.04
  } );

  ObjAnimate( "spr_basement_2_light_add", "alp", 1, 0, "",
  { 
    0.0, 0, 1, 
    1.2, 0, 0.5,
    2.4, 0, 1
  } );

  ObjAnimate( "spr_basement_2_fabric1", "scale_xy", 1, 0, "",
  { 
    0.0, 0, 1.0, 1.0, 
    1.7, 0, 0.97, 0.97,
    3.4, 0, 1.0, 1.0
  } );

  ObjAnimate( "spr_basement_2_fabric2", "scale_xy", 1, 0, "",
  { 
    0.0, 0, 1.0, 1.0, 
    1.7, 0, 0.97, 0.97,
    3.4, 0, 1.0, 1.0
  } );


end;
--*********************************************************************************************************************
function public.Close()

  --common_impl.StopAudio( "env", "common/audio/aud_cellar_env", 0.2 );

end;
--*********************************************************************************************************************
function public.PreClose()

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.get_coin9()

  local func_after = function ()

    common_impl.GetCoinDone("get_coin_9");
    cmn.CallEventHandler("get_coin_9");

    common.CloseSubRoom();

  
  end;
    
  common_impl.PlayEffectHO( "spr_bedsidetable_2_coin", func_after );
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_basement_2()

   cmn.CallEventHandler( "opn_basement_2" ); 
 
end;
--*********************************************************************************************************************
