-- name=rm_divarication
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_divarication";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_riverbank", "room_hub" );
  ObjAttach( "zz_tollgate", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_riverbank_hacksaw", { event_mdown = private.get_hacksaw }},
    { "spr_riverbank_gun", { event_mdown = private.get_gun }},
    { "obj_riverbank_plates_big", { event_mdown = private.get_plates }},
    { "obj_tollgate_use_hacksaw", { event_mdown = private.clk_barrier } },
    { "spr_riverbank_coin",{event_mdown = function() private.get_coin3() end } },
    { "spr_riverbank_metal_note",{ event_mdown = function() common_impl.NoteScale( 'open', 'spr_riverbank_metal_note' ); common_impl.ShowBbt( 'bbt_shore_metal_note', 1 ); end } },
    { "spr_riverbank_metal_note_big",{event_mdown = function() common_impl.NoteScale( 'close', 'spr_riverbank_metal_note' ); end } },
    { "spr_pointer_2_coin", { event_mdown = private.get_coin1 } },
    { "spr_pickup_coin", { event_mdown = private.get_coin2 } },
    { "spr_pointer_2_tablet_1",{event_mdown = private.clk_pointer1} },
    { "spr_pointer_2_tablet_2",{event_mdown = private.clk_pointer2} },
    { "spr_divarication_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_2" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_divarication = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_divarication_riverbank",
    "gzz_divarication_pickup",
    "gzz_divarication_pointer_2",
    "gzz_divarication_tollgate"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;    

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_tollgate",
      "zz_riverbank",     
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_divarication", update_game_mode_divarication, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_divarication = function ()

  local effects_table = 
  {
    "obj_divarication_anims",
    "vid_riverbank_water",
    "obj_riverbank_anims",
    "obj_riverbank_plates_small"
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_divarication", update_performance_mode_divarication, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_divarication () end;
  --------------------------------------------------------------------------------------------
  local opn_divarication_map = function ()

    common_impl.VisitMapRoom( "fork" );

  end;
  cmn.AddSubscriber( "opn_divarication", opn_divarication_map, nil );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_2 = function ()
  
    ObjDelete( "obj_divarication_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_2", get_collect_morph_item_1_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coins () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_1 = function ()
 
    ObjDelete( "obj_pointer_2_coin" );
    ObjDelete( "gzz_divarication_pointer_2" );
    
  end;
  cmn.AddSubscriber( "get_coin_1", get_collect_coin_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  local get_collect_coin_2 = function ()

    ObjDelete( "obj_pickup_coin" );
    ObjDelete( "gzz_divarication_pickup" );
 
  end;
  cmn.AddSubscriber( "get_coin_2", get_collect_coin_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  local get_collect_coin_3 = function ()

    ObjDelete( "obj_riverbank_coin" );

    if cmn.IsEventDone( "get_plates" ) and cmn.IsEventDone( "get_gun" )  then
      ObjDelete( "gzz_divarication_riverbank" );
    end;

  end;
  cmn.AddSubscriber( "get_coin_3", get_collect_coin_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hacksaw () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hacksaw" ] = {
    type = "get",
    get_obj = "spr_riverbank_hacksaw",
    room = private.room_objname,
    zz = "zz_riverbank",
    zz_gate = "gzz_divarication_riverbank"
  };
    
  local get_hacksaw_inv = function ()
  
    interface.InventoryItemAdd( "inv_hacksaw", "spr_riverbank_hacksaw" );
  
  end;
  
  local get_hacksaw_closezz = function ()
  
    ObjDelete( "gfx_riverbank_hacksaw" );
    ObjDelete( "spr_riverbank_hacksaw_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_hacksaw", get_hacksaw_inv );
  cmn.AddSubscriber( "get_hacksaw", get_hacksaw_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gun () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gun" ] = {
    type = "get",
    get_obj = "spr_riverbank_gun",
    room = private.room_objname,
    zz = "zz_riverbank",
    zz_gate = "gzz_divarication_riverbank"
  };
    
  local get_gun_inv = function ()
  
    interface.InventoryItemAdd( "inv_gun", "spr_riverbank_gun" );
    ObjSet( "inv_gun", { drag = false });

  end;
  
  local get_gun_closezz = function ()
  
    ObjDelete( "gfx_riverbank_gun" );
    ObjDelete( "spr_riverbank_gun_shadow" );
    if ( cmn.IsEventDone( "get_plates" ) and common_impl.IsGetCoin( "get_coin_3" ) ) then
      ObjDelete( "gzz_divarication_riverbank" );
    end;

  end;
  
  cmn.AddSubscriber( "get_gun", get_gun_inv );
  cmn.AddSubscriber( "get_gun", get_gun_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_plates () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_plates" ] = {
    type = "get",
    get_obj = "obj_riverbank_plates_big",
    room = private.room_objname,
    zz = "zz_riverbank",
    zz_gate = "gzz_divarication_riverbank"
  };
    
  local get_plates_inv = function ()
  
    interface.InventoryItemAdd( "inv_plates", "obj_riverbank_plates_big" );
  
  end;
  
  local get_plates_closezz = function ()
  
    ObjDelete( "gfx_riverbank_plates" );
    ObjDelete( "spr_riverbank_plate_1_shadow" );
    ObjDelete( "spr_riverbank_plate_2_shadow" );
    ObjDelete( "spr_riverbank_plate_3_shadow" );

    if ( cmn.IsEventDone( "get_gun" ) and common_impl.IsGetCoin( "get_coin_3" ) ) then
      ObjDelete( "gzz_divarication_riverbank" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_plates", get_plates_inv );
  cmn.AddSubscriber( "get_plates", get_plates_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_owl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_owl" ] = {
    type = "use",
    inv_obj = "inv_owl",
    use_place = "obj_riverbank_use_owl",
    room = private.room_objname,
    zz = "zz_riverbank",
    zz_gate = "gzz_divarication_riverbank"
  };
  local use_owl_inv = function ()
  
    interface.InventoryItemRemove( "inv_owl" );
  
  end;
  local use_owl_beg = function ()
  
    ObjDelete( "obj_riverbank_use_owl" );
  
  end;
  local use_owl_end = function ()
  
    ObjSet( "spr_riverbank_gun", { active = true, input = true });
    ObjSet( "spr_riverbank_hacksaw", { active = true, input = true });
    ObjSet( "obj_riverbank_chest_bbt", { input = true });
    ObjSet( "spr_riverbank_chest_open", { alp = 1 } );
    ObjDelete( "spr_riverbank_chest_close" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_owl", use_owl_beg, private.room_objname );
  cmn.AddSubscriber( "use_owl", use_owl_inv );
  cmn.AddSubscriber( "use_owl", use_owl_end, private.room_objname );
  cmn.AddSubscriber( "use_owl_inv", use_owl_inv, private.room_objname );
  cmn.AddSubscriber( "use_owl_beg", use_owl_beg, private.room_objname );
  cmn.AddSubscriber( "use_owl_end", use_owl_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pikepole () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pikepole" ] = {
    type = "use",
    inv_obj = "inv_pikepole",
    use_place = "obj_riverbank_use_pikepole",
    room = private.room_objname,
    zz = "zz_riverbank",
    zz_gate = "gzz_divarication_riverbank"
  };
  local use_pikepole_inv = function ()
  
    interface.InventoryItemRemove( "inv_pikepole" );
  
  end;

  local use_pikepole_beg = function ()
    
    ObjDelete( "obj_riverbank_plates_small" );
  
  end;

  local use_pikepole_end = function ()
  
    ObjDelete( "anm_riverbank_use_gaff" );
    ObjSet( "obj_riverbank_plates_big", { active = true, input = true, alp = 1 } );  
     
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pikepole", use_pikepole_beg, private.room_objname );
  cmn.AddSubscriber( "use_pikepole", use_pikepole_inv );
  cmn.AddSubscriber( "use_pikepole", use_pikepole_end, private.room_objname );
  cmn.AddSubscriber( "use_pikepole_inv", use_pikepole_inv, private.room_objname );
  cmn.AddSubscriber( "use_pikepole_beg", use_pikepole_beg, private.room_objname );
  cmn.AddSubscriber( "use_pikepole_end", use_pikepole_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hacksaw () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hacksaw" ] = {
    type = "use",
    inv_obj = "inv_hacksaw",
    use_place = "obj_tollgate_use_hacksaw",
    room = private.room_objname,
    zz = "zz_tollgate",
    zz_gate = "gzz_divarication_tollgate"
  };
  local use_hacksaw_inv = function ()
  
    interface.InventoryItemRemove( "inv_hacksaw" );
  
  end;
  local use_hacksaw_beg = function ()

    ObjDelete( "anm_tollgate_barrier" );
    ObjDelete( "obj_tollgate_use_hacksaw" );
  
  end;
  local use_hacksaw_end = function ()
  
    ObjDelete( "gzz_divarication_tollgate" );
    ObjDelete( "spr_divarication_chain_1" );
    ObjDelete( "spr_divarication_barrier_close" );

    ObjMultiSet({
      { "spr_divarication_barrier_open", { alp = 1 } },
      { "grm_divarication_nightsvilleentrance", { input = true, active = true } }
    });
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_divarication_nightsvilleentrance_focus");
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hacksaw", use_hacksaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_hacksaw", use_hacksaw_inv );
  cmn.AddSubscriber( "use_hacksaw", use_hacksaw_end, private.room_objname );
  cmn.AddSubscriber( "use_hacksaw_inv", use_hacksaw_inv, private.room_objname );
  cmn.AddSubscriber( "use_hacksaw_beg", use_hacksaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_hacksaw_end", use_hacksaw_end, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  common_impl.hint.position_slider[ "gzz_divarication_riverbank" ] = { "right" };
  common_impl.hint.position_slider[ "gzz_divarication_tollgate" ] = { "mid" };

  subroom.Define( "zz_riverbank" );

  function zz_riverbank.Open()

    common_impl.divarication = {}
    common_impl.divarication.note = "close";

    if ng_global.progress[ "std" ][ "opn_divarication" ].riverbank_enter == 0 then

      common_impl.ShowBbt( 'bbt_riverbank_first_enter', 1 );

      ng_global.progress[ "std" ][ "opn_divarication" ].riverbank_enter = 1;

    end;
    
  end;

  function zz_riverbank.Close()

    ObjSet( "spr_riverbank_metal_note_big", { input = 0, alp = 0 } );
    ObjSet( "spr_riverbank_metal_note", { alp = 1 } );
    common_impl.divarication.note = "close";

  end;

end;
--*********************************************************************************************************************
function public.Open()

  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

  private.opn_divarication();

end;
--*********************************************************************************************************************
function public.PreOpen()

  interface.InvestigationButtonCheck();

  common_impl.MorphItemMorphing();

  common_impl.EnvPlay( { "common/audio/aud_fork_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
function public.use_owl()

  local item = "inv_owl";

  if ( common.ApplyObj( item, "obj_riverbank_use_owl", true ) ) then

    cmn.CallEventHandler( "use_owl_inv" );
    cmn.CallEventHandler( "use_owl_beg" );

    local trg_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_owl" );
      cmn.CallEventHandler( "use_owl_end" );
   
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_owl_case", 0, "", 0 );

    ObjAnimate( "spr_riverbank_chest_owl", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_riverbank_chest_open", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.0,
      0.6, 0, 1.0
    } );

     ObjAnimate( "spr_riverbank_chest_close", "alp", 0, 0, trg_after,
    { 
      0.0, 0, 1.0, 
      0.3, 0, 1.0,
      0.6, 0, 0.0
    } );

    return true;

  elseif common.ApplyObj( item, "gzz_divarication_riverbank", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_riverbank", nil, { 512, 384 } );

    return true;   

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pikepole()

  local item = "inv_pikepole";

  if ( common.ApplyObj( item, "obj_riverbank_use_pikepole", true ) ) and common_impl.divarication.note == "close" then

    cmn.CallEventHandler( "use_pikepole_inv" );
    cmn.CallEventHandler( "use_pikepole_beg" );

    local trg_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_pikepole" );
      cmn.CallEventHandler( "use_pikepole_end" );
    
    end;

    common_impl.Lock( true );

    ObjSet( "anm_riverbank_use_gaff", { visible = true } )
    AnimPlay( "anm_riverbank_use_gaff", "DoAnim", trg_after )
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_peak", 0, "", 0 );

    return true;

  elseif common.ApplyObj( item, "gzz_divarication_riverbank", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_riverbank", nil, { 512, 384 } ); 
  
    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hacksaw()

  local item = "inv_hacksaw";

  if ( common.ApplyObj( item, "obj_tollgate_use_hacksaw", true ) ) then

    cmn.CallEventHandler( "use_hacksaw_inv" );
    cmn.CallEventHandler( "use_hacksaw_beg" );

    common_impl.Lock(true);

    local func_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_hacksaw" );
      cmn.CallEventHandler( "use_hacksaw_end" );
      common.CloseSubRoom();
    
    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_hacksaw", 0, "", 0 );

    ObjMultiSet({
      { "anm_tollgate_use_saw", { playing = true, endtrig = func_after, alp = 1 } }, 
    });

    return true;

  elseif common.ApplyObj( item, "gzz_divarication_tollgate", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tollgate", nil, { 512, 384 } );

    return true;  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.get_coin1()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_1");
    cmn.CallEventHandler("get_coin_1");
    common.CloseSubRoom();

  end;

  common_impl.PlayEffectHO( "spr_pointer_2_coin", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_coin2()

  local func_after = function ()

    common_impl.GetCoinDone("get_coin_2");
    cmn.CallEventHandler("get_coin_2");
      
    common.CloseSubRoom();

  end;

  common_impl.PlayEffectHO( "spr_pickup_coin", func_after );
  
end;
--------------------------------------------------------------------------------------------
function private.get_coin3()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_3" );
    cmn.CallEventHandler( "get_coin_3" );

    if cmn.IsEventDone( "get_plates" ) and cmn.IsEventDone( "get_gun" ) then
      common.CloseSubRoom();
    end;

  end;
    
  common_impl.PlayEffectHO( "spr_riverbank_coin", func_after );

end;
----------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.get_hacksaw()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hacksaw" );
  cmn.CallEventHandler( "get_hacksaw" );

end;
--------------------------------------------------------------------------------------------
function private.get_gun()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_gun" );
  cmn.CallEventHandler( "get_gun" );
  if ( cmn.IsEventDone( "get_plates" ) and  common_impl.IsGetCoin("get_coin_3") ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_plates()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_plates" );
  cmn.CallEventHandler( "get_plates" );

  if ( cmn.IsEventDone( "get_gun" ) and  common_impl.IsGetCoin("get_coin_3") ) then
    common.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_barrier()
  
  common_impl.Lock(true);
  local func_after = function ()
    common_impl.Lock(false);
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_nightsville_gate", 0, "", 0 );
  AnimPlay( "anm_tollgate_barrier", "DoAnim", func_after );
  common_impl.ShowBbt( 'bbt_barrier_clk_barrier', 1 );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_divarication()

   cmn.CallEventHandler( "opn_divarication" );   

end;
--*********************************************************************************************************************
function private.clk_pointer1()

  local func_after  = function ()
    common_impl.Lock(false);
  end;

  common_impl.Lock(true)
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_wooden_arrows", 0, "", 0 );
  common_impl.ShowBbt( 'bbt_pointer_clk_tablet' );
  ObjAnimate("spr_pointer_2_tablet_1", "ang", 0, 0, func_after, {0, 2, 0, 0.3, 3, 0.02,    0.6, 2, 0.0});

end;
-------------------------------------------------------------------------------------------
function private.clk_pointer2()

  local func_after  = function ()
    common_impl.Lock(false);
  end;

  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_wooden_arrows", 0, "", 0 );
  common_impl.ShowBbt( 'bbt_pointer_clk_tablet' );
  ObjAnimate("spr_pointer_2_tablet_2", "ang", 0, 0, func_after, {0, 1, 0, 0.3, 3, -0.02,    0.6, 3, 0.0});

end;
-------------------------------------------------------------------------------------------

  local ang_pl1 = 0.03;
  local ang_pl2 = 0.04;
  local ang_pl3 = 0.02;

  ObjAnimate( "spr_riverbank_reed_1", "ang", 1, 0, "", { 0,0,0.02, 2,0,-0.02, 4,0,0.02 } );
  ObjAnimate( "spr_riverbank_reed_2", "ang", 1, 0, "", { 0,0,-0.03, 1.5,0,0.03, 3,0,-0.03 } );
  ObjAnimate( "spr_riverbank_reed_3", "ang", 1, 0, "", { 0,0,0.04, 1.0,0,-0.04, 2.0,0,0.04 } );
  ObjAnimate( "spr_riverbank_bush_2", "ang", 1, 0, "", { 0,0,-0.02, 2,0,0, 4,0,-0.02 } );
  ObjAnimate( "spr_riverbank_bush_3", "ang", 1, 0, "", { 0,0,0.04, 2.5,0,-0.04, 5,0,0.04 } );
  ObjAnimate( "spr_riverbank_bush_4", "ang", 1, 0, "", { 0,0,0, 3,0,0.04, 6,0,0 } );
  ObjAnimate( "spr_riverbank_light", "alp", 1, 0, "", { 0,0,0, 1.5,0,1, 3,0,0 } );
  ObjAnimate( "spr_riverbank_light_2", "alp", 1, 0, "", { 0,0,0.5, 2,0,1, 4,0,0.5 } );

  ObjAnimate( "obj_riverbank_plates_small", "scale_xy", 1, 1, "", { 0, 3, 1, 1, 2, 3, 1.01, 1.01, 3, 3, 1,1 } );

  ObjAnimate( "spr_riverbank_plate_small_3", "ang", 1, 0, "", { 0,0,-ang_pl3, 1.4,0,ang_pl3, 2.8,0,-ang_pl3 } );
  ObjAnimate( "spr_riverbank_plate_small_2", "ang", 1, 0, "", { 0,0,0.0, 1.3,0,-ang_pl2, 2.6,0,0.0 } );
  ObjAnimate( "spr_riverbank_plate_small_1", "ang", 1, 0, "", { 0,0,-ang_pl1, 1.6,0,0.00, 3.2,0,-ang_pl1 } );

