-- name=rm_glade
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_glade";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_treehouse", "room_hub" );
  ObjAttach( "zz_treehouse_2", "room_hub" );
  ObjAttach( "zz_mailbox", "room_hub" );
  ObjAttach( "zz_trap", "room_hub" );
  private.Init_Subroom();
  private.Init_Mmg_Trap();
  
  ObjMultiSet({ 
    { "spr_treehouse_2_secateurs", { event_mdown = private.get_secateurs    }},
    { "obj_mailbox_use_file", { event_mdown = private.AnmLock    }},
    { "spr_mailbox_cartridge", { event_mdown = private.get_cartridge    }},
    { "spr_mailbox_hairpin",       { event_mdown = private.get_hairpin      }},
    { "spr_mailbox_videotape",     { event_mdown = private.get_videotape    }},
    { "spr_mailbox_flashlight",    { event_mdown = private.get_flashlight   }},
    { "spr_mailbox_bottle",        { event_mdown = private.get_bottle       }},
    { "spr_mailbox_coin_small",          { event_mdown = private.get_coin         }},
    { "spr_trap_spring",           { event_mdown = private.get_spring       }},
    { "spr_trap_emblem",           { event_mdown = private.get_emblem       }},
    { "grd_treehouse_2_spring",    { event_mdown = private.clk_spring }},
    { "obj_trap_clk_mmg",          { event_mdown = function() private.clk_trap_mmg ('open'); end  }},
    { "spr_trap_coin",             { event_mdown = private.get_coin12 } },
    { "spr_mailbox_coin",          { event_mdown = private.get_coin13 } },

    { "spr_glade_collect_item",    { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_2_1" );     end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_glade_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_2" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    
  });

  ObjAnimate( "spr_glade_treehouse_open_light", "alp", 1, 0, "", { 0, 0, 1,   3, 0, 0,   6, 0, 1 } );
  ObjAnimate( "spr_glade_house", "alp", 1, 0, "", { 0, 0, 1,   2.5, 0, 0,   5, 0, 1 } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_glade = function ()
  
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gzz_glade_treehouse",
      "gzz_glade_mailbox",
      "gzz_glade_trap",
      "gzz_glade_treehouse_2",
      "gho_glade_littlehouse"
    };
    for i = 1, #gates do

      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
      table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 

      {
        private.room_objname,
        "zz_treehouse",
        "zz_treehouse_2",
        "zz_mailbox",
        "zz_trap",
      
      };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;

  cmn.AddSubscriber( "update_game_mode_glade", update_game_mode_glade, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_glade = function ()

  local effects_table = 
  {
    "obj_glade_anim",
    "obj_glade_trap",
    "anm_trap_grass",
    "anm_trap_dog_bandage",
    "anm_trap_dog",
    "anm_trap_treeshadow",
    "anm_treehouse_leaf"
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_glade", update_performance_mode_glade, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_glade () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_glade" ] = {
    type = "click",
    use_place = "grm_nightsvilleentrance_glade",
    room = "rm_nightsvilleentrance",
    zz = "slider_right"
  };

  local opn_glade_map = function ()

    common_impl.VisitMapRoom( "glade" );

  end;
  cmn.AddSubscriber( "opn_glade", opn_glade_map, nil );

  --------------------------------------------------------------------------------------------
  -- function get_collect_item_2_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_2_1 = function ()
  
    ObjDelete( "obj_glade_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_2_1", get_collect_item_2_1, private.room_objname );
   --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_2 = function ()
  
    ObjDelete( "obj_glade_morph" );
    ObjDelete( "spr_glade_morph_over" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_2", get_collect_morph_item_2_2, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_secateurs () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_secateurs" ] = {
    type = "get",
    get_obj = "spr_treehouse_2_secateurs",
    room = private.room_objname,
    zz = "zz_treehouse_2",
    zz_gate = "gzz_glade_treehouse_2"
  };
    
  local get_secateurs_inv = function ()
  
    interface.InventoryItemAdd( "inv_secateurs", "spr_treehouse_2_secateurs" );
  
  end;
  
  local get_secateurs_closezz = function ()

    ObjDelete( "spr_treehouse_2_secateurs_shadow" );   
    ObjDelete( "gfx_treehouse_2_secateurs" );
  
  end;
  
  cmn.AddSubscriber( "get_secateurs", get_secateurs_inv );
  cmn.AddSubscriber( "get_secateurs", get_secateurs_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cartridge () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cartridge" ] = {
    type = "get",
    get_obj = "spr_mailbox_cartridge",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_glade_mailbox"
  };
    
  local get_cartridge_inv = function ()
  
    interface.InventoryItemAdd( "inv_cartridge", "spr_mailbox_cartridge" );
    ObjSet( "spr_gun_plus_light", { visible = true } );
  
  end;
  
  local get_cartridge_closezz = function ()

    ObjDelete( "spr_mailbox_cartridge_shadow" );     
    ObjDelete( "gfx_mailbox_cartridge" );
    ObjDelete( "spr_glade_mailbox_carridge" );
  
  end;
  
  cmn.AddSubscriber( "get_cartridge", get_cartridge_inv );
  cmn.AddSubscriber( "get_cartridge", get_cartridge_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hairpin () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hairpin" ] = {
    type = "get",
    get_obj = "spr_mailbox_hairpin",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_glade_mailbox"
  };
    
  local get_hairpin_inv = function ()
  
    interface.InventoryItemAdd( "inv_hairpin", "spr_mailbox_hairpin" );
  
  end;
  
  local get_hairpin_closezz = function ()
  
    ObjDelete( "spr_mailbox_hairpin_shadow" );
    ObjDelete( "gfx_mailbox_hairpin" );

    if (cmn.IsEventDone( "get_videotape" ) and cmn.IsEventDone( "get_hairpin" )) then
      ObjSet("obj_mailbox_use_knife", { input = true, visible = true, active = true } );
    end;

    if ( cmn.IsEventDone( "get_videotape" ) and cmn.IsEventDone( "get_flashlight" ) and cmn.IsEventDone( "get_bottle" )
    and cmn.IsEventDone( "get_coin" ) and common_impl.IsGetCoin( "get_coin_13" ) ) then
      ObjDelete( "gzz_glade_mailbox" );
    end;

  end;
  
  cmn.AddSubscriber( "get_hairpin", get_hairpin_inv );
  cmn.AddSubscriber( "get_hairpin", get_hairpin_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_videotape () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_videotape" ] = {
    type = "get",
    get_obj = "spr_mailbox_videotape",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_glade_mailbox"
  };
    
  local get_videotape_inv = function ()
  
    interface.InventoryItemAdd( "inv_videotape", "spr_mailbox_videotape" );
    ObjSet( "spr_camera_plus_light", { visible = true } );

  end;
  
  local get_videotape_closezz = function ()
  
    ObjDelete( "spr_mailbox_cassette_shadow_up" );
    ObjDelete( "spr_mailbox_cassette_shadow" );

    ObjDelete( "gfx_mailbox_videotape" );
    ObjDelete( "spr_glade_mailbox_casset" )
    
    if (cmn.IsEventDone( "get_videotape" ) and cmn.IsEventDone( "get_hairpin" )) then
      ObjSet("obj_mailbox_use_knife", { input = true, visible = true, active = true } );
    end;

    if ( cmn.IsEventDone( "get_hairpin" )    and 
         cmn.IsEventDone( "get_flashlight" ) and 
         cmn.IsEventDone( "get_bottle" )     and
         cmn.IsEventDone( "get_coin" ) and common_impl.IsGetCoin( "get_coin_13" ) )     then

      ObjDelete( "gzz_glade_mailbox" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_videotape", get_videotape_inv );
  cmn.AddSubscriber( "get_videotape", get_videotape_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_flashlight () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_flashlight" ] = {
    type = "get",
    get_obj = "spr_mailbox_flashlight",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_glade_mailbox"
  };
    
  local get_flashlight_inv = function ()
  
    interface.InventoryItemAdd( "inv_flashlight", "spr_mailbox_flashlight" );
    ObjSet( "inv_flashlight", { drag = false });
    if ( not cmn.IsEventDone( "get_bulb" ) ) then
      ObjSet( "spr_flashlight_plus_light", { visible = false } );
    end;

  end;
  
  local get_flashlight_closezz = function ()
  
    ObjDelete( "spr_mailbox_flashlight_shasdow" );

    ObjDelete( "gfx_mailbox_flashlight" );

    if ( cmn.IsEventDone( "get_hairpin" )   and 
         cmn.IsEventDone( "get_videotape" ) and 
         cmn.IsEventDone( "get_bottle" )    and 
         cmn.IsEventDone( "get_coin" ) and common_impl.IsGetCoin( "get_coin_13" ) )    then

      ObjDelete( "gzz_glade_mailbox" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_flashlight", get_flashlight_inv );
  cmn.AddSubscriber( "get_flashlight", get_flashlight_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bottle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bottle" ] = {
    type = "get",
    get_obj = "spr_mailbox_bottle",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_glade_mailbox"
  };
    
  local get_bottle_inv = function ()
  
    interface.InventoryItemAdd( "inv_bottle", "spr_mailbox_bottle" );
    ObjSet( "inv_bottle", { drag = false });

  end;
  
  local get_bottle_closezz = function ()
  
    ObjDelete( "gfx_mailbox_bottle" );
    ObjDelete( "spr_mailbox_bottle_shadow" );

    if ( cmn.IsEventDone( "get_hairpin" )    and 
         cmn.IsEventDone( "get_videotape" )  and 
         cmn.IsEventDone( "get_flashlight" ) and 
         cmn.IsEventDone( "get_coin" ) and common_impl.IsGetCoin( "get_coin_13" ) )     then

      ObjDelete( "gzz_glade_mailbox" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_bottle", get_bottle_inv );
  cmn.AddSubscriber( "get_bottle", get_bottle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coin () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_coin" ] = {
    type = "get",
    get_obj = "spr_mailbox_coin_small",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_glade_mailbox"
  };
    
  local get_coin_inv = function ()
  
    interface.InventoryItemAdd( "inv_coin", "spr_mailbox_coin_small" );
  
  end;
  
  local get_coin_closezz = function ()
  
    ObjDelete( "gfx_mailbox_coin" );

    if ( cmn.IsEventDone( "get_hairpin" )    and 
         cmn.IsEventDone( "get_videotape" )  and 
         cmn.IsEventDone( "get_flashlight" ) and
         cmn.IsEventDone( "get_bottle" ) and common_impl.IsGetCoin( "get_coin_13" ) )   then

      ObjDelete( "gzz_glade_mailbox" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_coin", get_coin_inv );
  cmn.AddSubscriber( "get_coin", get_coin_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_spring () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_spring" ] = {
    type = "get",
    get_obj = "spr_trap_spring",
    room = private.room_objname,
    zz = "zz_trap",
    zz_gate = "gzz_glade_trap"
  };
    
  local get_spring_inv = function ()
  
    interface.InventoryItemAdd( "inv_spring", "spr_trap_spring" );
  
  end;
  
  local get_spring_closezz = function ()

    ObjDelete( "gfx_trap_spring" );
    ObjDelete( "spr_trap_spring_shadow" );
    ObjDelete( "spr_glade_trap_spring" );
    if ( cmn.IsEventDone( "get_emblem" ) and common_impl.IsGetCoin( "get_coin_12" ) ) then
      ObjDelete( "gzz_glade_trap" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_spring", get_spring_inv );
  cmn.AddSubscriber( "get_spring", get_spring_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_emblem () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_emblem" ] = {
    type = "get",
    get_obj = "spr_trap_emblem",
    room = private.room_objname,
    zz = "zz_trap",
    zz_gate = "gzz_glade_trap"
  };
    
  local get_emblem_inv = function ()
  
    interface.InventoryItemAdd( "inv_emblem", "spr_trap_emblem" );
  
  end;
  
  local get_emblem_closezz = function ()
  
    ObjDelete( "spr_glade_trap_amulet" );
    ObjDelete( "spr_trap_emblem_shadow" );
    ObjDelete( "gfx_trap_emblem" );
    if ( cmn.IsEventDone( "get_spring" ) and common_impl.IsGetCoin( "get_coin_12" ) ) then
      ObjDelete( "gzz_glade_trap" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_emblem", get_emblem_inv );
  cmn.AddSubscriber( "get_emblem", get_emblem_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coins () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_12 = function ()
 
    ObjDelete( "obj_trap_coin" );

    if ( cmn.IsEventDone( "get_emblem" ) and cmn.IsEventDone( "get_spring" ) ) then      
      ObjDelete( "gzz_glade_trap" );
    end;
    
  end;
  cmn.AddSubscriber( "get_coin_12", get_collect_coin_12, private.room_objname );
--------------------------------------------------------------------------------------------
  local get_collect_coin_13 = function ()
 
    ObjDelete( "obj_mailbox_coin" );

    if ( cmn.IsEventDone( "get_hairpin" )   and 
         cmn.IsEventDone( "get_flashlight" )   and
         cmn.IsEventDone( "get_videotape" ) and 
         cmn.IsEventDone( "get_bottle" )    and 
         cmn.IsEventDone( "get_coin" ))    then      
      ObjDelete( "gzz_glade_mailbox" );
    end;
    
  end;
  cmn.AddSubscriber( "get_coin_13", get_collect_coin_13, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_5 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_5" ] = {
    type = "use",
    inv_obj = "inv_elf_2",
    use_place = "obj_treehouse_use_elf",
    room = private.room_objname,
    zz = "zz_treehouse",
    zz_gate = "gzz_glade_treehouse"
  };
  local use_elf_5_beg = function ()
  
    ObjDelete( "obj_treehouse_use_elf" );
  
  end;
  local use_elf_5_end = function ()
  
    ObjMultiSet({ 
      
      { "obj_treehouse_2_use_emblem", { input = true } },
      { "spr_treehouse_2_secateurs", { input = true, visible = true, active = true } },
      { "gzz_glade_treehouse_2", { input = true, active = true } },
      { "anm_glade_staircase", { visible = true, active = true } },

    });

    ObjDelete( "gzz_glade_treehouse" );
    ObjDelete( "vid_treehouse_use_elf_5" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_5", use_elf_5_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_5", use_elf_5_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_5_beg", use_elf_5_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_5_end", use_elf_5_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_spring () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_spring" ] = {
    type = "use",
    inv_obj = "inv_spring",
    use_place = "obj_treehouse_2_use_spring",
    room = private.room_objname,
    zz = "zz_treehouse_2",
    zz_gate = "gzz_glade_treehouse_2"
  };
  local use_spring_inv = function ()
  
    interface.InventoryItemRemove( "inv_spring" );
  
  end;
  local use_spring_beg = function ()
  
    ObjDelete( "obj_treehouse_2_use_spring" );
  
  end;
  local use_spring_end = function ()
  
    ObjSet( "spr_treehouse_2_spring", {alp = 1 } );
    if ( cmn.IsEventDone( "use_emblem" ) ) then
      ObjDelete( "gzz_glade_treehouse_2" );
      ObjSet( "gho_glade_littlehouse", { input = true, active = true } );
      ObjSet( "spr_glade_treehouse_open", { visible = true, active = true } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_spring", use_spring_beg, private.room_objname );
  cmn.AddSubscriber( "use_spring", use_spring_inv );
  cmn.AddSubscriber( "use_spring", use_spring_end, private.room_objname );
  cmn.AddSubscriber( "use_spring_inv", use_spring_inv, private.room_objname );
  cmn.AddSubscriber( "use_spring_beg", use_spring_beg, private.room_objname );
  cmn.AddSubscriber( "use_spring_end", use_spring_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_emblem () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_emblem" ] = {
    type = "use",
    inv_obj = "inv_emblem",
    use_place = "obj_treehouse_2_use_emblem",
    room = private.room_objname,
    zz = "zz_treehouse_2",
    zz_gate = "gzz_glade_treehouse_2"
  };
  local use_emblem_inv = function ()
  
    interface.InventoryItemRemove( "inv_emblem" );
  
  end;
  local use_emblem_beg = function ()
  
    ObjDelete( "obj_treehouse_2_use_emblem" );
  
  end;
  local use_emblem_end = function ()
  
    if ( cmn.IsEventDone( "use_spring" ) ) then

      ObjDelete( "gzz_glade_treehouse_2" );
      ObjSet( "gho_glade_littlehouse", { input = true, active = true } );
      ObjSet( "spr_glade_treehouse_open", { visible = true, active = true } );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_emblem", use_emblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_emblem", use_emblem_inv );
  cmn.AddSubscriber( "use_emblem", use_emblem_end, private.room_objname );
  cmn.AddSubscriber( "use_emblem_inv", use_emblem_inv, private.room_objname );
  cmn.AddSubscriber( "use_emblem_beg", use_emblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_emblem_end", use_emblem_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_knife_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_knife_2" ] = {
    type = "use",
    inv_obj = "inv_knife",
    use_place = "obj_mailbox_use_knife",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_glade_mailbox"
  };
  local use_knife_2_beg = function ()
  
    ObjDelete( "obj_mailbox_use_knife" );
  
  end;
  local use_knife_2_end = function ()
  
    ObjDelete( "anm_mailbox_use_knife" );

    ObjMultiSet({ 
      { "obj_mailbox_open_bag",   { input = true,visible = true, active = true, alp = 1 } }, 
      --{ "spr_mailbox_flashlight", { input = true, visible = true, active = true } },
      --{ "spr_mailbox_bottle",     { input = true, visible = true, active = true } },
      --{ "spr_mailbox_coin_small",       { input = true, visible = true, active = true } }
    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_knife_2", use_knife_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_knife_2", use_knife_2_end, private.room_objname );
  cmn.AddSubscriber( "use_knife_2_beg", use_knife_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_knife_2_end", use_knife_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_file () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_file" ] = {
    type = "use",
    inv_obj = "inv_file",
    use_place = "obj_mailbox_use_file",
    room = private.room_objname,
    zz = "zz_mailbox",
    zz_gate = "gzz_glade_mailbox"
  };
  local use_file_inv = function ()
  
    interface.InventoryItemRemove( "inv_file" );
  
  end;
  local use_file_beg = function ()
  
    ObjDelete( "obj_mailbox_use_file" );
  
  end;
  local use_file_end = function ()
  
    ObjDelete( "anm_mailbox_use_file" );
    ObjDelete( "obj_mailbox_close" );
    ObjMultiSet({ 
      { "obj_mailbox_open",      { input = true, alp = 1 } },
      { "spr_glade_mailbox_open",   { visible = true } },      
    });

    ObjDelete( "spr_glade_mailbox_lock" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_file", use_file_beg, private.room_objname );
  cmn.AddSubscriber( "use_file", use_file_inv );
  cmn.AddSubscriber( "use_file", use_file_end, private.room_objname );
  cmn.AddSubscriber( "use_file_inv", use_file_inv, private.room_objname );
  cmn.AddSubscriber( "use_file_beg", use_file_beg, private.room_objname );
  cmn.AddSubscriber( "use_file_end", use_file_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bandage () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bandage" ] = {
    type = "use",
    inv_obj = "inv_bandage",
    use_place = "obj_trap_use_bandage",
    room = private.room_objname,
    zz = "zz_trap",
    zz_gate = "gzz_glade_trap"
  };
  local use_bandage_inv = function ()
  
    interface.InventoryItemRemove( "inv_bandage" );
  
  end;
  local use_bandage_beg = function ()
  
    ObjDelete( "obj_trap_use_bandage" );
  
  end;
  local use_bandage_end = function ()
     
    ObjDelete( "anm_trap_dog" );
    ObjDelete( "anm_glade_dog" );
   
    if ( cmn.IsEventDone( "use_medicine" ) ) then

      ObjSet( "spr_trap_emblem", { input = true, visible = true, active = true } );
      ObjSet( "spr_glade_trap_trap", { visible = true } );  
  
    else

      ObjSet( "anm_trap_dog_bandage", { playing = true, visible = true } );
      ObjSet( "obj_trap_use_medicine", { pos_x = 39, pos_y = -113 } );
      ObjSet( "anm_glade_dog_bandage", { alp = 1 } );  

    end;
  
  end;

  local use_bandage_loc = function ()

    if ( cmn.IsEventDone( "use_medicine" ) ) then

      ObjSet( "anm_nightsvilleentrance_dog", { alp = 1, playing = true } );
 
    end;

  end;

  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bandage", use_bandage_beg, private.room_objname );
  cmn.AddSubscriber( "use_bandage", use_bandage_inv );
  cmn.AddSubscriber( "use_bandage", use_bandage_end, private.room_objname );
  cmn.AddSubscriber( "use_bandage", use_bandage_loc, "rm_nightsvilleentrance" );
  cmn.AddSubscriber( "use_bandage_inv", use_bandage_inv, private.room_objname );
  cmn.AddSubscriber( "use_bandage_beg", use_bandage_beg, private.room_objname );
  cmn.AddSubscriber( "use_bandage_end", use_bandage_end, private.room_objname );
  cmn.AddSubscriber( "use_bandage_loc", use_bandage_loc, "rm_nightsvilleentrance" );
  --------------------------------------------------------------------------------------------
  -- function use_medicine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_medicine" ] = {
    type = "use",
    inv_obj = "inv_medicine",
    use_place = "obj_trap_use_medicine",
    room = private.room_objname,
    zz = "zz_trap",
    zz_gate = "gzz_glade_trap"
  };
  local use_medicine_inv = function ()
  
    interface.InventoryItemRemove( "inv_medicine" );
  
  end;
  local use_medicine_beg = function ()
  
    ObjDelete( "obj_trap_use_medicine" );
  
  end;
  local use_medicine_end = function ()

    ObjDelete( "anm_trap_use_medicine" );
  
    if ( cmn.IsEventDone("use_bandage") ) then      
      ObjDelete( "anm_glade_dog" );  
      ObjDelete( "anm_trap_dog_bandage" ); 
      ObjSet( "spr_trap_emblem", { input = true, visible = true, active = true } );       
      ObjSet( "spr_glade_trap_trap", { visible = true } );   
      ObjDelete( "anm_glade_dog_bandage" );
    end;
  
  end;

  local use_medicine_loc = function ()

    if ( cmn.IsEventDone( "use_bandage" ) ) then

      ObjSet( "anm_nightsvilleentrance_dog", { alp = 1, playing = true  } );
 
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_medicine", use_medicine_beg, private.room_objname );
  cmn.AddSubscriber( "use_medicine", use_medicine_inv );
  cmn.AddSubscriber( "use_medicine", use_medicine_end, private.room_objname );
  cmn.AddSubscriber( "use_medicine", use_medicine_loc, "rm_nightsvilleentrance" );
  cmn.AddSubscriber( "use_medicine_inv", use_medicine_inv, private.room_objname );
  cmn.AddSubscriber( "use_medicine_beg", use_medicine_beg, private.room_objname );
  cmn.AddSubscriber( "use_medicine_end", use_medicine_end, private.room_objname );
  cmn.AddSubscriber( "use_medicine_loc", use_medicine_loc, "rm_nightsvilleentrance" );
  --------------------------------------------------------------------------------------------
  -- function use_coin () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_coin" ] = {
    type = "use",
    inv_obj = "inv_coin",
    use_place = "obj_trap_use_coin",
    room = private.room_objname,
    zz = "zz_trap",
    zz_gate = "gzz_glade_trap"
  };
  local use_coin_inv = function ()
  
    interface.InventoryItemRemove( "inv_coin" );
  
  end;
  local use_coin_beg = function ()
  
    ObjDelete( "obj_trap_use_coin" );
  
  end;
  local use_coin_end = function ()
  
   ObjDelete( "anm_trap_use_coin" );
   ObjSet( "spr_trap_trap_plate", { alp = 1 } );
   ObjSet( "obj_trap_clk_mmg", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_coin", use_coin_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin", use_coin_inv );
  cmn.AddSubscriber( "use_coin", use_coin_end, private.room_objname );
  cmn.AddSubscriber( "use_coin_inv", use_coin_inv, private.room_objname );
  cmn.AddSubscriber( "use_coin_beg", use_coin_beg, private.room_objname );
  cmn.AddSubscriber( "use_coin_end", use_coin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_loadedgun () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_loadedgun" ] = {
    type = "use",
    inv_obj = "inv_loadedgun",
    use_place = "obj_glade_use_loadedgun",
    room = private.room_objname
  };
  local use_loadedgun_inv = function ()
  
    interface.InventoryItemRemove( "inv_loadedgun" );
  
  end;
  local use_loadedgun_beg = function ()
  
    ObjDelete( "obj_glade_use_loadedgun" );
  
  end;
  local use_loadedgun_end = function ()
  
    ObjSet( "gzz_glade_treehouse", { input = true, active = true } );
    ObjSet( "gzz_glade_trap", { input = true, active = true } );
    ObjSet( "anm_glade_dog", { alp = 1 } );
    ObjDelete( "anm_glade_dog_wolf" );
    ObjDelete( "vid_glade_gun" );
      
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_loadedgun", use_loadedgun_beg, private.room_objname );
  cmn.AddSubscriber( "use_loadedgun", use_loadedgun_inv );
  cmn.AddSubscriber( "use_loadedgun", use_loadedgun_end, private.room_objname );
  cmn.AddSubscriber( "use_loadedgun_inv", use_loadedgun_inv, private.room_objname );
  cmn.AddSubscriber( "use_loadedgun_beg", use_loadedgun_beg, private.room_objname );
  cmn.AddSubscriber( "use_loadedgun_end", use_loadedgun_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_glade_wolves () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_glade_wolves" ] = {

      type = "click",
      use_place = "obj_vid_glade_wolves",
      room = private.room_objname
  };
  local vid_glade_wolves_beg = function ()

    ObjDelete( "obj_vid_glade_wolves" );

  end;
  local vid_glade_wolves_end = function ()

   ObjSet( "rm_glade", { color_r = 1, color_g = 1, color_b = 1 });
  end;

  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "vid_glade_wolves", vid_glade_wolves_beg, private.room_objname );
  cmn.AddSubscriber( "vid_glade_wolves", vid_glade_wolves_end, private.room_objname  );
  cmn.AddSubscriber( "vid_glade_wolves_beg", vid_glade_wolves_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_glade_wolves_end", vid_glade_wolves_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function clk_spring () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_spring" ] = {
    type = "click",
    use_place = "obj_treehouse_2_spring_hint",
    room = private.room_objname,
    zz = "zz_treehouse_2",
    zz_gate = "gzz_glade_treehouse_2"
  };
    
  
  local clk_spring_loc = function ()

    ObjDelete( "grd_treehouse_2_spring" );
    ObjSet( "obj_treehouse_2_use_spring", { input = true } );
    ObjSet( "spr_treehouse_2_springs_1",  { alp = 1 } );
 
  end;
    
  cmn.AddSubscriber( "clk_spring", clk_spring_loc, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_littlehouse () end;
  --------------------------------------------------------------------------------------------
  local win_littlehouse_loc = function ()

    if cmn.IsEventDone( "win_littlehouse" ) then

      ObjDelete( "gho_glade_littlehouse" );

    end;

  end;
  cmn.AddSubscriber( "win_littlehouse", win_littlehouse_loc, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_trap () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_trap" ] = {

      type = "win",    
      room = private.room_objname,
      use_place = "obj_trap_clk_mmg",
      zz_gate = "gzz_glade_trap",
      zz = "zz_trap"

  };

  local win_trap = function ()

      if ( cmn.IsEventDone( "win_trap" ) ) then  

        ObjSet( "obj_trap_use_bandage", { input = true, visible = true, active = true } );
        ObjSet( "obj_trap_use_medicine", { input = true, visible = true, active = true } );
        ObjSet( "spr_trap_spring", { input = true, pos_x = 77, pos_y = 170, ang = 0.8, pos_z = 2 } );
        ObjSet( "spr_trap_spring_shadow", { alp = 1, pos_z = 1 } );
        ObjSet( "spr_glade_trap_spring", { alp = 1 } );
        ObjDelete( "obj_trap_mmg" );
        ObjDelete( "obj_trap_clk_mmg" );
        ObjDelete( "spr_trap_trap_part_shadow" );
        ObjDelete( "spr_trap_trap_part" );  
        ObjDelete( "spr_trap_trap_over" );          

      else
        
        for i = 1, #ng_global.progress["std"]["win_trap"].press do

          if ng_global.progress["std"]["win_trap"].press[i] == 1 then

            ObjSet( "spr_trap_mmg_part_"..i, { alp = 0, input = false } );
            ObjSet( "spr_trap_mmg_part_"..i.."_press", { alp = 1 } );
            ObjSet( "spr_trap_mmg_ind_"..i, { pos_y = private.mmg_trap[i][2] } );

          end;

        end;

      end;
 end;
 cmn.AddSubscriber( "win_trap", win_trap, private.room_objname );  
  --------------------------------------------------------------------------------------------
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_trap" );

  function zz_trap.PreOpen()

    if ( ng_global.progress["std"]["win_trap"] ) then

      if ( not ng_global.progress["std"]["win_trap"].press ) then

        ng_global.progress["std"]["win_trap"].press = { 0, 0, 0, 0 };

      end;

    end;

    if not cmn.IsEventDone( "use_bandage" ) or not cmn.IsEventDone( "use_medicine" ) then

      common_impl.PlayAudio( "env", "common/audio/aud_wounded_dog_zz_env", 1, "", 0 );
      common_impl.StopAudio( "env", "common/audio/aud_wounded_dog_loc_env", 0.5 );
  
    end;

  end;

  function zz_trap.PreClose()

    if ( cmn.IsEventDone( "use_coin" )) and not cmn.IsEventDone( "win_trap" ) then

      private.clk_trap_mmg( 'close' );

    end;

    if not cmn.IsEventDone( "use_bandage" ) or not cmn.IsEventDone( "use_medicine" ) then

      common_impl.PlayAudio( "env", "common/audio/aud_wounded_dog_loc_env", 1, "", 0 );
      common_impl.StopAudio( "env", "common/audio/aud_wounded_dog_zz_env", 0.5 );
  
    end;    

  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_glade();

  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();

  interface.InvestigationButtonCheck();
  
  common_impl.EnvPlay( { "common/audio/aud_glade_env" }, "", 0.5 );

  if cmn.IsEventDone( "vid_glade_wolves" ) and ( not cmn.IsEventDone( "use_bandage" ) or not cmn.IsEventDone( "use_medicine" ) ) then

    common_impl.PlayAudio( "env", "common/audio/aud_wounded_dog_loc_env", 1, "", 0 );
  
  end;

  if not cmn.IsEventDone( "use_loadedgun" ) and cmn.IsEventDone( "vid_glade_wolves" ) then

    common_impl.PlayAudio( "env", "common/audio/aud_wolves_env", 1, "", 0 );

  end;

  if ( not cmn.IsEventDone( "vid_glade_wolves" ) ) then
     private.vid_glade_wolves();
  end;

end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_elf_5()

  local item = "inv_elf_2";

  if ( common.ApplyObj( item, "obj_treehouse_use_elf", true ) ) then

    interface.InventoryItemRemove( "inv_elf_2" );
    cmn.CallEventHandler( "use_elf_5_inv" );
    cmn.CallEventHandler( "use_elf_5_beg" );

    local func_after = function ()
      common_impl.Lock( false );
      interface.InventoryItemAdd( "inv_elf_2" );
      cmn.SetEventDone( "use_elf_5" );
      cmn.CallEventHandler( "use_elf_5_end" );
      common.CloseSubRoom();
    
    end;

    common_impl.Lock( true );

    ObjSet( "vid_treehouse_use_elf_5", { alp = 1, playing = true, endtrig = func_after } );
    common_impl.PlayAudio( "sfx", "common/audio/aud_treehouse_elf", 0, "", 0 );

    return true;

  elseif ( common.ApplyObj( item, "gzz_glade_treehouse", false ) and cmn.IsEventDone( "vid_glade_wolves" ) )then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_treehouse", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_spring()

  local item = "inv_spring";

  if ( common.ApplyObj( item, "obj_treehouse_2_use_spring", true ) and ( cmn.IsEventDone( "clk_spring" ) ) ) then

    cmn.CallEventHandler( "use_spring_inv" );
    cmn.CallEventHandler( "use_spring_beg" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_spring" );
      cmn.CallEventHandler( "use_spring_end" );
      if ( cmn.IsEventDone( "use_emblem" ) ) then
        common.CloseSubRoom();
      end;
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_spring", 0, "", 0 );

    ObjAnimate( "spr_treehouse_2_spring", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  elseif ( common.ApplyObj( item, "gzz_glade_treehouse_2", false ) and ( cmn.IsEventDone( "clk_spring" ) ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_treehouse_2", nil, { 512, 384 } );

    return true;   

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_emblem()

  local item = "inv_emblem";

  if ( common.ApplyObj( item, "obj_treehouse_2_use_emblem", true ) ) then

    cmn.CallEventHandler( "use_emblem_inv" );
    cmn.CallEventHandler( "use_emblem_beg" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_emblem" );
      cmn.CallEventHandler( "use_emblem_end" );
      if ( cmn.IsEventDone( "use_spring" ) ) then
        common.CloseSubRoom();
      end;

    end;

    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_owl_part", 0, "", 0 );

    ObjAnimate( "spr_treehouse_2_emblem", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
      
    return true;    

  elseif common.ApplyObj( item, "gzz_glade_treehouse_2", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_treehouse_2", nil, { 512, 384 } );

    return true;   

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_knife_2()

  local item = "inv_knife";

  if ( common.ApplyObj( item, "obj_mailbox_use_knife", true ) and cmn.IsEventDone("use_file")
       and cmn.IsEventDone( "get_hairpin" ) and cmn.IsEventDone( "get_videotape" )) then

    --interface.InventoryItemRemove( "inv_knife" );
    cmn.CallEventHandler( "use_knife_2_beg" );

    local func_after = function ()

      --interface.InventoryItemAdd( "inv_knife" );
      cmn.SetEventDone( "use_knife_2" );
      cmn.CallEventHandler( "use_knife_2_end" );
      --common.CloseSubRoom();
      common_impl.Lock(false);
    
    end;

    common_impl.Lock(true);

    ObjSet( "anm_mailbox_use_knife", { alp = 1 } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_knife_package", 0, "", 0 );
   
    AnimPlay( "anm_mailbox_use_knife", "DoAnim", func_after );

    return true;

  elseif ( common.ApplyObj( item, "gzz_glade_mailbox", false ) and cmn.IsEventDone("use_file") 
      and cmn.IsEventDone("get_hairpin") and cmn.IsEventDone("get_hairpin")) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_mailbox", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_file()

  local item = "inv_file";

  if ( common.ApplyObj( item, "obj_mailbox_use_file", true ) ) then

    cmn.CallEventHandler( "use_file_inv" );
    cmn.CallEventHandler( "use_file_beg" );

    local func_after = function ()

      local func_after2 = function ()

        cmn.SetEventDone( "use_file" );
        cmn.CallEventHandler( "use_file_end" );
        common_impl.Lock(false);

      end;

      ObjAnimate( "obj_mailbox_open", "alp", 0,0, func_after2, { 0,0,0, 0.4,1,1} );
      ObjAnimate( "anm_mailbox_use_file", "alp", 0,0, "", { 0,0,1, 0.4,1,0} );
    
    end;

    common_impl.Lock(true);

    ObjSet( "anm_mailbox_use_file", { alp = 1 } );
    ObjSet( "obj_mailbox_close", { alp = 0 } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_file", 0, "", 0 );
   
    AnimPlay( "anm_mailbox_use_file", "DoAnim", func_after );
   
    return true;

  elseif common.ApplyObj( item, "gzz_glade_mailbox", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_mailbox", nil, { 512, 384 } );

    return true;   

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bandage()

  local item = "inv_bandage";

  if ( common.ApplyObj( item, "obj_trap_use_bandage", true ) and cmn.IsEventDone( "win_trap" ) ) then

    cmn.CallEventHandler( "use_bandage_inv" );
    cmn.CallEventHandler( "use_bandage_beg" );

   local func_after = function ()

      local func_end = function()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_bandage" );
        cmn.CallEventHandler( "use_bandage_end" );
        cmn.CallEventHandler( "use_bandage_loc" );

      end;
      ObjDelete( "anm_trap_use_bandage" );
      if ( cmn.IsEventDone("use_medicine") ) then

        ObjSet( "anm_trap_dog_leaves", { alp = 1 } );      
        AnimPlay( "anm_trap_dog_leaves", "DoAnim", func_end );
        common_impl.PlayAudio( "sfx", "common/audio/aud_dog_recovered", 0, "", 0 );
        common_impl.StopAudio( "env", "common/audio/aud_wounded_dog_zz_env", 0.5 );
        interface.KeyTaskDone( "save_dog" ,true );

      else 
        func_end();
      end;
          
    end;

    common_impl.Lock( true );

    ObjSet( "anm_trap_dog", { alp = 0 } );

    ObjSet( "anm_trap_use_bandage", { alp = 1 } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_bandage", 0, "", 0 );

    AnimPlay( "anm_trap_use_bandage", "DoAnim", func_after );

    return true;

  elseif ( common.ApplyObj( item, "gzz_glade_trap", false  ) and cmn.IsEventDone( "win_trap" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_trap", nil, { 512, 384 } );

    return true;   

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_medicine()

  local item = "inv_medicine";

  if ( common.ApplyObj( item, "obj_trap_use_medicine", true ) and cmn.IsEventDone( "win_trap" ) ) then

    cmn.CallEventHandler( "use_medicine_inv" );
    cmn.CallEventHandler( "use_medicine_beg" );

    local dog_name = "anm_trap_dog";
    if ( cmn.IsEventDone("use_bandage") ) then
      dog_name = "anm_trap_dog_bandage";
    end;

    local func_after = function ()

      local func_end = function()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_medicine" );
        cmn.CallEventHandler( "use_medicine_end" );
        cmn.CallEventHandler( "use_medicine_loc" );

      end;

      ObjDelete( "anm_trap_use_medicine" );
      if ( cmn.IsEventDone("use_bandage") ) then
        ObjSet( "anm_trap_dog_leaves", { alp = 1 } );      
        AnimPlay( "anm_trap_dog_leaves", "DoAnim", func_end );
        common_impl.PlayAudio( "sfx", "common/audio/aud_dog_recovered", 0, "", 0 );
        common_impl.StopAudio( "env", "common/audio/aud_wounded_dog_zz_env", 0.5 );
        interface.KeyTaskDone( "save_dog", true );
      else
        ObjSet( dog_name, { alp = 1 } );
        func_end();
      end;
          
    end;

    common_impl.Lock( true );

    ObjSet( dog_name, { alp = 0 } );
    ObjSet( "anm_trap_use_medicine", { alp = 1 } );

    if ( cmn.IsEventDone( "use_bandage" ) ) then

      ObjSet( "anm_trap_use_medicine", { res = "assets/levels/level2/rm_glade/zz_trap/anims/anm_trap_use_potion_bandage" } );

    end;

    AnimPlay( "anm_trap_use_medicine", "DoAnim", func_after );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_aids", 0, "", 0 );

    return true;
  
  elseif ( common.ApplyObj( item, "gzz_glade_trap", false ) and cmn.IsEventDone( "win_trap" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_trap", nil, { 512, 384 } );

    return true;   

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_coin()

  local item = "inv_coin";

  if ( common.ApplyObj( item, "obj_trap_use_coin", true ) and cmn.IsEventDone( "use_loadedgun" ) ) then

    cmn.CallEventHandler( "use_coin_inv" );
    cmn.CallEventHandler( "use_coin_beg" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_coin" );
      cmn.CallEventHandler( "use_coin_end" );
      ObjDelete( "anm_trap_use_coin" );

    end;

    common_impl.Lock( true );
    ObjSet( "anm_trap_use_coin", { visible = true } );
    AnimPlay( "anm_trap_use_coin", "DoAnim", func_after );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_coin_trap", 0, "", 0 );

    return true;

  elseif common.ApplyObj( item, "gzz_glade_trap", false ) and cmn.IsEventDone( "use_loadedgun" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_trap", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_loadedgun()

  local item = "inv_loadedgun";

  if ( common.ApplyObj( item, "obj_glade_use_loadedgun" ) ) then

    cmn.CallEventHandler( "use_loadedgun_inv" );
    cmn.CallEventHandler( "use_loadedgun_beg" );

    local func_after = function ( skip )

      interface.DialogVideoHide();
      cmn.SetEventDone( "use_loadedgun" );
      cmn.CallEventHandler( "use_loadedgun_end" );
      common_impl.StopAudio( "env", "common/audio/aud_wolves_env", 0.5 );
      common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0, "", 0 );

      if skip then

        common_impl.StopAudio( "sfx", "common/audio/aud_glade_gun", 0.5 );  

      end;

    end;

    common_impl.StopAllMus();
    ObjSet( "vid_glade_wolves", { alp = 1, active = true, input = false, visible = true } );
  
    common_impl.PlayAudio( "sfx", "common/audio/aud_glade_gun", 0, "", 0 );  

    interface.DialogVideoShow( "vid_glade_gun", 1, function() func_after( 'skip' ) end, 3 );
    VidPlay( "vid_glade_gun", function() func_after( nil ) end ); 

    return true;  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_secateurs()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_secateurs" );
  cmn.CallEventHandler( "get_secateurs" );

end;
--------------------------------------------------------------------------------------------
function private.get_cartridge()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_cartridge" );
  cmn.CallEventHandler( "get_cartridge" );

end;
--------------------------------------------------------------------------------------------
function private.get_hairpin()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hairpin" );
  cmn.CallEventHandler( "get_hairpin" );

  if ( cmn.IsEventDone( "get_videotape" ) and cmn.IsEventDone( "get_coin" ) and cmn.IsEventDone( "get_flashlight" )
  and cmn.IsEventDone( "get_bottle" ) and common_impl.IsGetCoin( "get_coin_13" ) ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_videotape()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_videotape" );
  cmn.CallEventHandler( "get_videotape" );

  if ( cmn.IsEventDone( "get_hairpin" )   and 
       cmn.IsEventDone( "get_coin" )      and 
       cmn.IsEventDone( "get_flashlight" )and 
       cmn.IsEventDone( "get_bottle" ) and common_impl.IsGetCoin( "get_coin_13" ) )   then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_flashlight()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_flashlight" );
  cmn.CallEventHandler( "get_flashlight" );


  if ( cmn.IsEventDone( "get_hairpin" )   and 
       cmn.IsEventDone( "get_coin" )      and 
       cmn.IsEventDone( "get_flashlight" )and 
       cmn.IsEventDone( "get_bottle" ) and common_impl.IsGetCoin( "get_coin_13" ) )   then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_bottle()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_bottle" );
  cmn.CallEventHandler( "get_bottle" );


  if ( cmn.IsEventDone( "get_hairpin" )   and 
       cmn.IsEventDone( "get_coin" )      and 
       cmn.IsEventDone( "get_flashlight" )and 
       cmn.IsEventDone( "get_bottle" ) and common_impl.IsGetCoin( "get_coin_13" ) )   then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_coin()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_coin" );
  cmn.CallEventHandler( "get_coin" );

  if ( cmn.IsEventDone( "get_hairpin" )   and 
       cmn.IsEventDone( "get_coin" )      and 
       cmn.IsEventDone( "get_flashlight" )and 
       cmn.IsEventDone( "get_bottle" ) and common_impl.IsGetCoin( "get_coin_13" ) )   then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_spring()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_spring" );
  cmn.CallEventHandler( "get_spring" );

  if ( cmn.IsEventDone( "get_emblem" ) and common_impl.IsGetCoin( "get_coin_12" )  ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_emblem()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_emblem" );
  cmn.CallEventHandler( "get_emblem" );

  if ( cmn.IsEventDone( "get_spring" ) and common_impl.IsGetCoin( "get_coin_12" )  ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_coin12()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_12");
    cmn.CallEventHandler("get_coin_12");

    if ( cmn.IsEventDone( "get_emblem" ) and cmn.IsEventDone( "get_spring" ) ) then
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_trap_coin", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_coin13()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_13");
    cmn.CallEventHandler("get_coin_13");

    if ( cmn.IsEventDone( "get_hairpin" ) and cmn.IsEventDone( "get_coin" ) ) then    
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_mailbox_coin", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_spring()

  local func_end  = function()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_spring" );
    cmn.CallEventHandler( "clk_spring" );

  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_spring_tree", 0, "", 0 );
  ObjAnimate( "grd_treehouse_2_spring",    "alp", 0, 0, func_end, { 0, 0, 1, 0.2, 0, 0 } );
  ObjAnimate( "spr_treehouse_2_springs_1", "alp", 0, 0, "",       { 0, 0, 0, 0.2, 0, 1 } );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.vid_glade_wolves()

  cmn.CallEventHandler( "vid_glade_wolves_beg" );
  ObjSet( "vid_glade_wolves", { alp = 1, active = true, input = false, visible = true } );
  ObjSet( "rm_glade", { color_r = 0, color_g = 0, color_b = 0 } );
  
  local func_after = function ( skip )

    common_impl.ShowBbt( 'bbt_glade_wolves' );

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_glade_wolves" );
    cmn.CallEventHandler( "vid_glade_wolves_end" );  
    common_impl.PlayAudio( "env", "common/audio/aud_wolves_env", 1, "", 0 );
    common_impl.PlayAudio( "env", "common/audio/aud_wounded_dog_loc_env", 1, "", 0 );
    common_impl.PlayAudio( "mus", "common/audio/aud_danger1_mus", 0, "", 0 );

    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_glade_wolves", 0.5 );  

    end;

  end;

  common_impl.StopAllMus();
  common_impl.StopTimer();

  common_impl.PlayAudio( "sfx", "common/audio/aud_glade_wolves", 0, "", 0 );  
  interface.DialogVideoShow( "vid_glade_wolves", 1, function() func_after( 'skip' ) end, 3 );
  VidPlay( "vid_glade_wolves", function() func_after( nil ) end ); 

end;
--*********************************************************************************************************************
function private.opn_glade()

  if not ( cmn.IsEventDone( "opn_glade" ) ) then
    cmn.SetEventDone( "opn_glade" );
  end;
    cmn.CallEventHandler( "opn_glade" ); 

end;
--*********************************************************************************************************************
function private.AnmLock()

  common_impl.ShowBbt( 'bbt_mailbox_use_file' );  

  common_impl.Lock( true );

  local pos_y = ObjGet( "spr_mailbox_lock" ).pos_y;

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_very_small_metall", 0, "", 0 );

  ObjAnimate( "spr_mailbox_lock", "pos_y", 0, 0, function() common_impl.Lock( false ) end, { 
    0, 0, pos_y,
    0.1, 0, pos_y - 2,
    0.2, 0, pos_y,
    0.3, 0, pos_y -2,
    0.4, 0, pos_y } );

end;
--*********************************************************************************************************************
-- function *** MMG *** () end;
--********************************************************************************************************************
-----------------------------------------------------------------
function public.Reset( event )

  if cmn.IsEventDone( "use_coin" ) and not cmn.IsEventDone( "win_trap" ) then
  
     ng_global.progress["std"]["win_trap"].press = { 0, 0, 0, 0 };

     for i = 1, 4 do

       ObjSet( "spr_trap_mmg_part_"..i, { alp = 1, input = true } );
       ObjSet( "spr_trap_mmg_part_"..i.."_press", { alp = 0 } );
       ObjSet( "spr_trap_mmg_ind_"..i, { pos_y = private.mmg_trap[i][1] } );

     end;
  
  end;

end;
-----------------------------------------------------------------
function public.Skip( event ) 

   if cmn.IsEventDone( "use_coin" ) and not cmn.IsEventDone( "win_trap" ) then

    local func_after = function()

      common_impl.Lock( false );
      private.win_trap();

    end;

    common_impl.Lock( true );

       for number = 1, 4 do
         
        ObjAnimate( "spr_trap_mmg_part_"..number, "alp", 0, 0, "", { 0,0,ObjGet("spr_trap_mmg_part_"..number).alp, 0.2,0,0 } );
        ObjAnimate( "spr_trap_mmg_part_"..number.."_press", "alp", 0, 0, "", { 0,0,ObjGet("spr_trap_mmg_part_"..number.."_press").alp, 0.2,0,1 } );
        ObjAnimate( "spr_trap_mmg_ind_"..number, "pos_y", 0, 0, "", { 0,0,ObjGet("spr_trap_mmg_ind_"..number).pos_y, 0.2,0,private.mmg_trap[number][2] } );

       end;
       
       ObjAnimate( "spr_trap_mmg_over", "alp", 0, 0, func_after, { 0,0,1, 0.5,0,1 } );
  
   end;

  

end;
-----------------------------------------------------------------
function private.Init_Mmg_Trap ()
  
  private.mmg_trap = { { -137, -116, 4 }, { -148, -129, 1 }, { -160, -142, 2, 4 }, { -171, -150  } }; --1. координата y1, 2. координата y2, 3. зависимые части

  for i = 1, 4 do

    ObjSet( "spr_trap_mmg_part_"..i, 
    {
      event_mdown = function () private.clk_trap_part( 'down', i ); end,
      event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
      event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end
    } )

  end;
  

  function private.clk_trap_mmg( mode )

    local func_after_open = function()

      common_impl.Lock( false );

      ObjSet( "obj_trap_clk_mmg", { input = false } );
      ObjSet( "obj_trap_mmg",     { input = true  } );
      cmn.MiniGameShow( "trap" );
      common_impl.PassingMgStart( "trap" );

    end;

    local func_after_close = function()

      common_impl.Lock( false );

      ObjSet( "obj_trap_clk_mmg", { input = true   } );
      ObjSet( "obj_trap_mmg",     { input = false  } );
      cmn.MiniGameHide( "trap" );
      common_impl.PassingMgStop( "trap" );

    end;
      
      common_impl.Lock( true );

      if mode == "open" and ObjGet( "obj_trap_mmg" ).alp == 0 then

        ObjAnimate( "obj_trap_mmg", "alp", 0, 0, func_after_open, { 0,0,0, 0.3,0,1 } );

      elseif mode == "close" and ObjGet( "obj_trap_mmg" ).alp == 1 then 

        ObjAnimate( "obj_trap_mmg", "alp", 0, 0, func_after_close, { 0,0,1, 0.3,0,0 } );

      end;    

  end;


    function private.clk_trap_part( mode, number )

        local func_after = function()

          common_impl.Lock( false );

          if mode == "down" then

            ng_global.progress["std"]["win_trap"].press[number] = 1;
            ObjSet( "spr_trap_mmg_part_"..number, { input = false } );
        
          end;
              
          if mode == "up" then

            ng_global.progress["std"]["win_trap"].press[number] = 0;
            ObjSet( "spr_trap_mmg_part_"..number, { input = true } );

            private.need_up = false;

          end; 

          if private.need_up ~= true then

              private.check_win_trap();

          end;

        end;

        common_impl.Lock( true );

        if mode == "down" then

          common_impl.PlayAudio( "sfx", "common/audio/aud_trap_on", 0, "", 0 );

          ObjAnimate( "spr_trap_mmg_part_"..number, "alp", 0, 0, func_after, { 0,0,1, 0.2,0,0 } );
          ObjAnimate( "spr_trap_mmg_part_"..number.."_press", "alp", 0, 0, "", { 0,0,0, 0.2,0,1 } );

          ObjAnimate( "spr_trap_mmg_ind_"..number, "pos_y", 0, 0, "", { 0,0,private.mmg_trap[number][1], 0.2,0,private.mmg_trap[number][2] } );

          for i = 3, #private.mmg_trap[number] do

             if i and ng_global.progress["std"]["win_trap"].press[private.mmg_trap[number][i]] == 1 then
              
                private.clk_trap_part( 'up', private.mmg_trap[number][i] );
                private.need_up = true;
                          
             end;

          end;
             
       
        elseif mode == "up" then

          common_impl.PlayAudio( "sfx", "common/audio/aud_trap_off", 0, "", 0 );

          ObjAnimate( "spr_trap_mmg_part_"..number, "alp", 0, 0, func_after, { 0,0,0, 0.2,0,1 } );
          ObjAnimate( "spr_trap_mmg_part_"..number.."_press", "alp", 0, 0, "", { 0,0,1, 0.2,0,0 } );   

          ObjAnimate( "spr_trap_mmg_ind_"..number, "pos_y", 0, 0, "", { 0,0,private.mmg_trap[number][2], 0.2,0,private.mmg_trap[number][1] } );     

        end;
   
    end;

    function private.check_win_trap()
       
       local win_count = 0;

       for i = 1, #ng_global.progress["std"]["win_trap"].press do

          if ng_global.progress["std"]["win_trap"].press[i] == 1 then

            win_count = win_count + 1; 
                 
          end;              

       end;

       if win_count == 4 then

          private.win_trap();

       end;

    end;
 

    function private.win_trap()

      local func_end = function ()
         
        cmn.MiniGameHide( "trap" );
        common_impl.Lock( false );
        cmn.SetEventDone( "win_trap" );
        cmn.CallEventHandler( "win_trap" );
        ObjDelete( "anm_trap_win" );
        common_impl.PassingMgWin( "trap" );

      end;

      common_impl.Lock( true );
      ObjSet( "anm_trap_win", { visible = true } );
      ObjSet( "obj_trap_mmg", { visible = false } );
      common_impl.PlayAudio( "sfx", "common/audio/aud_trap_win", 0, "", 0 );
      AnimPlay( "anm_trap_win", "DoAnim", func_end );

    end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  