-- name=rm_livingroom_2
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_livingroom_2";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_table_2", "room_hub" );
  ObjAttach( "zz_wardrobe_2", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet( {
    { "spr_table_2_coin",{event_mdown = function() private.get_coin5() end } },
    { "spr_wardrobe_2_coin",{event_mdown = function() private.get_coin6() end } },
    { "spr_livingroom_2_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_4" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "obj_livingroom_2_clk_pickup", { event_mdown = function() private.ClkCar()end; } }
  } );

  ObjAnimate( "spr_livingroom_2_plane", "ang", 1, 0, "",{ 0.0, 3, -0.15, 1.5, 3, 0.15,3.0, 3, -0.15} );

 --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_livingroom_2 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
      "gzz_livingroom_2_wardrobe_2",
      "gzz_livingroom_2_door_2",
    };
    for i = 1, #gates do
    
      local name = gates[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_table_2",
      "zz_wardrobe_2",
      "zz_gates"
    
    };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_livingroom_2", update_game_mode_livingroom_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_livingroom_2 = function ()
    
    local effects_table = 
    {
      "anm_livingroom_2_window",
      "spr_livingroom_2_light",
      "spr_livingroom_2_ball_hotspot",
      "spr_livingroom_2_chandelier",
      "spr_table_2_bear_paw_1",
      "spr_table_2_bear_paw_2",
      "spr_table_2_light",
      "spr_livingroom_2_ball",
      "anm_livingroom_2_window",
      "grd_livingroom_2_curtain",
      "spr_livingroom_plane",
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_livingroom_2", update_performance_mode_livingroom_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  local get_collect_coin_5 = function ()

    ObjDelete( "obj_table_2_coin" );
    ObjDelete( "gzz_livingroom_2_table_2" );

  end;
  cmn.AddSubscriber( "get_coin_5", get_collect_coin_5, private.room_objname );  
  --------------------------------------------------------------------------------------------
  local get_collect_coin_6 = function ()

    ObjDelete( "obj_wardrobe_coin" );
    ObjDelete( "gzz_livingroom_2_wardrobe_2" );

  end;
  cmn.AddSubscriber( "get_coin_6", get_collect_coin_6, private.room_objname );  
  --------------------------------------------------------------------------------------------  
  local get_collect_morph_item_1_4 = function ()

    ObjDelete( "obj_livingroom_2_morph" );

  end;

  cmn.AddSubscriber( "get_collect_morph_item_1_4", get_collect_morph_item_1_4, private.room_objname );

  local opn_livingroom_2_map = function ()

    common_impl.VisitMapRoom( "livingroom" );

  end;
  cmn.AddSubscriber( "opn_livingroom_2", opn_livingroom_2_map, nil );
  --------------------------------------------------------------------------------------------  

end;
--*********************************************************************************************************************
function public.Load()

end;
--********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_table_2" );

  function zz_table_2.Open()

    private.StopAnims();

  end;

  subroom.Define( "zz_wardrobe_2" );

  function zz_wardrobe_2.Open()

    private.StopAnims();

  end;

end;
--*********************************************************************************************************************
function public.Open()

  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.MorphItemMorphing();
  private.opn_livingroom_2 ()

  common_impl.EnvPlay( { "common/audio/aud_livingroom_env" }, "", 0.2 );

  local chance = math.random( 1,5 );

  if chance == 3 then

    local endfunc = "";
    local chance = math.random( 1,5 );
    
      if chance == 1 then

        endfunc = function ()  AnimPlay( "anm_livingroom_2_birds_1", "DoAnim", "" ); common_impl.PlayAudio( "sfx", "common/audio/aud_crow_window", 0, "", 0 ); end;
       
      end;
    
      common_impl.PlayAudio( "sfx", "common/audio/aud_crows_window", 0, "", 0 );

      AnimPlay( "anm_livingroom_2_birds_2", "DoAnim", endfunc );

  end;
  
  interface.InvestigationButtonCheck();

end;
--*********************************************************************************************************************
function public.Close()

  private.StopAnims();

end;
--*********************************************************************************************************************
function private.opn_livingroom_2 ()

   cmn.CallEventHandler( "opn_livingroom_2" ); 

end;

function private.get_coin5()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_5");
    cmn.CallEventHandler("get_coin_5");
    
   common.CloseSubRoom();

  end;
  
  common_impl.PlayEffectHO( "spr_table_2_coin", func_after );

end;
------------------------------------------------------------------------------------------------------------------------
function private.get_coin6()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_6");
    cmn.CallEventHandler("get_coin_6");
    common.CloseSubRoom();

  end;
    
  common_impl.PlayEffectHO( "spr_wardrobe_2_coin", func_after );
end;
------------------------------------------------------------------------------------------------------------------------
function private.ClkCar()

  common_impl.Lock( true );

  local func_after = function ()

    common_impl.Lock( false );

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_toy_car", 0, "", 0.2 );

  AnimPlay( "anm_livingroom_2_pickup", "DoAnim", func_after );

end;
--*********************************************************************************************************************
function private.StopAnims()

  AnimStop( "anm_livingroom_2_birds_1" );
  AnimStop( "anm_livingroom_2_birds_2" );

  common_impl.StopAudio( "sfx", "common/audio/aud_crow_window", 1.5 );
  common_impl.StopAudio( "sfx", "common/audio/aud_crows_window", 1.5 );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-----------------------------------------------Anims-------------------------------------------------------------------
--*********************************************************************************************************************
ObjAnimate( "spr_table_2_bear_paw_1", "ang", 1, 0, "", { 0,0,-0.02, 1,0,0.02, 2,0,-0.02 } );
ObjAnimate( "spr_table_2_bear_paw_2", "ang", 1, 0, "", { 0,0,0.05, 1.5,0,-0.05, 3,0,0.05 } );
ObjAnimate( "spr_table_2_light", "alp", 1, 0, "", { 0,0,0, 2,0,1, 4,0,0 } );
ObjAnimate( "spr_livingroom_2_light", "alp", 1, 0, "", { 0,0,0.5, 2,0,1, 4,0,0.5 } );
ObjAnimate( "spr_livingroom_2_ball", "ang", 1, 0, "", { 0,0,0.1, 2.5,0,-0.05, 5,0,0.1 } );
ObjAnimate( "spr_livingroom_2_ball_hotspot", "alp", 1, 0, "", { 0,0,0.5, 2,0,1, 4,0,0.5 } );
ObjAnimate( "spr_livingroom_2_chandelier", "ang", 1, 0, "", { 0,0,-0.03, 2,0,0.03, 4,0,-0.03 } );
