-- name=rm_mine_1
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_mine_1";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_fireextinguishing", "room_hub" );
  ObjAttach( "zz_winch", "room_hub" );
  ObjAttach( "zz_controlunit", "room_hub" );
  ObjAttach( "zz_carriage", "room_hub" );
  private.Init_Subroom();
  --------------------------------------------------------------------------------------------
  private.countChips = 24;
  private.numberChips = { 1,  2,      4,  5,  6, 
                              8,  9, 10, 11, 12, 
                         13, 14, 15,     17, 18, 
                         19,     21, 22, 23, 
                         25, 26, 27, 28,     30};
  ----------------------------------------------------------
  private.countRightWay = 12;
  private.rightWay = {  8,  2, 
                        4,  5, 11, 17, 
                       15, 14, 
                       26, 27, 28, 
                       30             };
  private.rightWayLight = { 0, 2,0,0,0, 17,0, 14,0,0, 28}
  --------------------------------------------------------------------------------------------

  local table_multiset = {
    {"spr_winch_remotecontrol", { event_mdown = private.get_remotecontrol }},
    {"spr_carriage_clippers",   { event_mdown = private.get_clippers      }},
    {"spr_mine_1_jack",         { event_mdown = private.get_jack          }},
    {"spr_mine_1_wounddevice",  { event_mdown = private.get_wounddevice   }},
    {"spr_fireextinguishing_button",           { event_mdown = private.clk_fireextinguishing_button }},
    {"obj_fireextinguishing_use_screwdriver",  { event_mdown = private.clk_fireextinguishing_panel  }},    
    {"obj_controlunit_clk_tumblerswitch",      { event_mdown = private.clk_tumblerswitch   }},
    {"obj_winch_clk_knife_5",  { event_mdown = private.clk_knife_5   }},
    {"obj_winch_clk_knife_6",  { event_mdown = private.clk_knife_6   }},
    {"spr_winch_mmg_cover",    { event_mdown = private.clk_cover     }},
    {"obj_winch_use_crowbar_3", { event_mdown = private.use_crowbar_3 }},
    {"obj_winch_use_knife",     { event_mdown = private.use_knife_5   }},
    {"obj_winch_mmg_cover",     { event_mdown = private.coverAnimation  }},
    {"obj_vid_mine_1_danger",   { event_mdown = private.vid_mine_1_danger }},
    {"obj_carriage_use_chain",  { event_mdown = private.AnimCarriage }},
    {"spr_carriage_carriage",   { event_mdown = private.AnimCarriage }},
    {"obj_dlg_mine_1_saved",    { event_mdown = private.dlg_mine_1_saved }},
    {"obj_dlg_mine_1_saved_focus",    { event_mdown = private.dlg_mine_1_saved }},
    {"spr_controlunit_coin",   { event_mdown = private.get_coin18 } },
    {"spr_winch_coin",         { event_mdown = private.get_coin19 } },
    {"spr_carriage_hook",      { event_mdown = private.AnimHook          }},
    {"obj_controlunit_use_electricaltape",      { event_mdown = private.clk_eltape          }},


    { "spr_mine_1_collect_item",    { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_2_3" );     end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_mine_1_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_5" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },

  }
  
  for i = 1,private.countChips do 
 
    table.insert( table_multiset, {"spr_winch_chip_"..private.numberChips[i], {  event_mdown = function () private.Rotate( private.numberChips[i] ); end }} );

  end;

  ObjMultiSet( table_multiset );

  ObjAnimate( "spr_mine_1_wire2", "ang", 1, 0, "", { 
    0, 0, 0, 
    2, 1, 0.05,
    6, 3, -0.05,
    8, 2, 0 } );

  -----------------------------------------------------------------------------------
  private.NumberOfElements = 30;
  private.RightPositions = 12;
  ----------------------------------------------------------
  private.WinPositions =  {  0, 1, 0, 1, 1, 0,
                             0, 1, 0, 0, 1, 0,
                             0, 1, 1, 0, 1, 0,
                             0, 0, 0, 0, 0, 0,
                             0, 1, 1, 1, 0, 1 };

  private.FirstPositions = { 1, 3, 0, 2, 4, 1,
                             0, 2, 2, 1, 2, 1,
                             1, 4, 2, 0, 1, 1,
                             1, 0, 1, 1, 1, 0,
                             1, 3, 1, 2, 0, 4 };
  ----------------------------------------------------------
  private.Type = { 2, 2, 0, 1, 2, 1,
                   0, 2, 1, 2, 1, 1,
                   1, 2, 1, 0, 2, 1,
                   1, 0, 2, 1, 1, 0,
                   2, 2, 1, 1, 0, 2 };
  ----------------------------------------------------------
  private.angTube = {0, -1.58, - 3.14, -4.71, -6.28 };

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mine_1 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;

  local gates = 
  {
    "gzz_mine_1_carriage",
    "gzz_mine_1_controlunit",
    "gzz_mine_1_winch",
    "gzz_mine_1_fireextinguishing",
    "gmg_mine_1_superpuzzle_2"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_fireextinguishing",
      "zz_winch",
      "zz_controlunit",
      "zz_carriage",
    
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );   

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_mine_1", update_game_mode_mine_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_mine_1 = function ()

  local effects_table = 
  {
    "obj_mine_1_anim",
    "anm_mine_1_kevin",
    "obj_mine_1_anim_2"
  } 

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_mine_1", update_performance_mode_mine_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_mine_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_mine_1" ] = {
    type = "click",
    use_place = "grm_mineentrance_mine_1",
    room = "rm_mineentrance"
  };

  local opn_mine_1_map = function ()

    common_impl.VisitMapRoom( "mine_1" );
    if cmn.IsEventDone( "vid_mine_2_savior" ) then
      common_impl.LockMapRoom( "mine_2", true );
    end;
    

  end;
  local opn_mine_1_del_dlg_mine_2 = function ()

    if cmn.IsEventDone( "vid_mine_2_savior" ) then

      ObjDelete( "anm_mine_2_kevin_1" );

    end; 

  end;
  cmn.AddSubscriber( "opn_mine_1", opn_mine_1_del_dlg_mine_2, private.room_objname );
  cmn.AddSubscriber( "opn_mine_1", opn_mine_1_map, nil );

  --------------------------------------------------------------------------------------------
  -- function get_collect_item_2_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_2_3 = function ()
  
    ObjDelete( "obj_mine_1_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_2_3", get_collect_item_2_3, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_5 = function ()
  
    ObjDelete( "obj_mine_1_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_5", get_collect_morph_item_2_5, private.room_objname );


  --------------------------------------------------------------------------------------------
  -- function get_remotecontrol () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_remotecontrol" ] = {
    type = "get",
    get_obj = "spr_winch_remotecontrol",
    room = private.room_objname,
    zz = "zz_winch",
    zz_gate = "gzz_mine_1_winch"
  };
    
  local get_remotecontrol_inv = function ()
  
    interface.InventoryItemAdd( "inv_remotecontrol", "spr_winch_remotecontrol" );
    ObjSet( "inv_remotecontrol", { drag = false } );
    if ( not cmn.IsEventDone( "get_screwdriver_2" ) ) then
      ObjSet( "spr_remotecontrol_plus_light", { visible = false } );
    end;

  end;
  
  local get_remotecontrol_closezz = function ()
  
    ObjDelete( "gfx_winch_remotecontrol" );
    ObjDelete( "spr_mine_1_console" );
  
  end;
  
  cmn.AddSubscriber( "get_remotecontrol", get_remotecontrol_inv );
  cmn.AddSubscriber( "get_remotecontrol", get_remotecontrol_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_clippers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_clippers" ] = {
    type = "get",
    get_obj = "spr_carriage_clippers",
    room = private.room_objname,
    zz = "zz_carriage",
    zz_gate = "gzz_mine_1_carriage"
  };
    
  local get_clippers_inv = function ()
  
    interface.InventoryItemAdd( "inv_clippers", "spr_carriage_clippers" );
  
  end;
  
  local get_clippers_closezz = function ()
  
    ObjDelete( "gfx_carriage_clippers" );
    ObjDelete( "spr_mine_1_nippers" );
    ObjDelete( "spr_carriage_clippers_shadow" );

    if ( cmn.IsEventDone( "get_clippers" ) and cmn.IsEventDone( "use_chain" )) then

        ObjDelete( "gzz_mine_1_carriage" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_clippers", get_clippers_inv );
  cmn.AddSubscriber( "get_clippers", get_clippers_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_jack () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_jack" ] = {
    type = "get",
    get_obj = "spr_mine_1_jack",
    room = private.room_objname

  };
    
  local get_jack_inv = function ()
  
    interface.InventoryItemAdd( "inv_jack", "spr_mine_1_jack" );
  
  end;
  
  local get_jack_closezz = function ()
  
    ObjDelete( "gfx_mine_1_jack" );
    ObjDelete( "gzz_mine_1_mine_1" );
    ObjDelete( "spr_mine_1_jack_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_jack", get_jack_inv );
  cmn.AddSubscriber( "get_jack", get_jack_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_wounddevice () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wounddevice" ] = {
    type = "get",
    get_obj = "spr_mine_1_wounddevice",
    room = private.room_objname

  };
    
  local get_wounddevice_inv = function ()
  
    interface.InventoryItemAdd( "inv_wounddevice", "spr_mine_1_wounddevice" );
    ObjSet( "inv_wounddevice", { drag = false } );  
    if ( not cmn.IsEventDone( "get_knife" ) ) then
      ObjSet( "spr_wounddevice_plus_light", { visible = false } );
    end;

  end;
  
  local get_wounddevice_closezz = function ()
  
    ObjDelete( "gfx_mine_1_wounddevice" );
    ObjDelete( "gzz_mine_1_mine_1" );
    ObjDelete( "spr_mine_1_wounddevice_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_wounddevice", get_wounddevice_inv );
  cmn.AddSubscriber( "get_wounddevice", get_wounddevice_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coins () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_18 = function ()
 
    ObjDelete( "obj_controlunit_coin" );

    if cmn.IsEventDone("clk_tumblerswitch") then
      ObjDelete( "gzz_mine_1_controlunit" );
    end;
    
  end;
  cmn.AddSubscriber( "get_coin_18", get_collect_coin_18, private.room_objname );
  --------------------------------------------------------------------------------------------
  local get_collect_coin_19 = function ()
 
    ObjDelete( "obj_winch_coin" );

    if cmn.IsEventDone("clk_knife_6") then
      ObjDelete( "gzz_mine_1_winch" );
    end;
    
  end;
  cmn.AddSubscriber( "get_coin_19", get_collect_coin_19, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_screwdriver2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_screwdriver2_1" ] = {
    type = "use",
    inv_obj = "inv_screwdriver2",
    use_place = "obj_fireextinguishing_use_screwdriver",
    room = private.room_objname,
    zz = "zz_fireextinguishing",
    zz_gate = "gzz_mine_1_fireextinguishing"
  };
  local use_screwdriver2_1_inv = function ()
  
    if ( cmn.IsEventDone( "use_screwdriver2_2" ) ) then
      
      interface.InventoryItemRemove( "inv_screwdriver2" );
  
    end;

  end;
  local use_screwdriver2_1_beg = function ()
  
    ObjDelete( "obj_fireextinguishing_use_screwdriver" );
  
  end;
  local use_screwdriver2_1_end = function ()

    ObjDelete( "spr_fireextinguishing_panel" );
    ObjDelete( "vid_fireextinguishing_hex"   );

    ObjSet( "spr_mine_1_mg", { alp = 1 } );
    ObjSet( "obj_fireextinguishing_no_active", { input = true } );
  
    if ( cmn.IsEventDone( "clk_tumblerswitch" ) ) then

      ObjDelete( "gzz_mine_1_fireextinguishing" );
      ObjSet( "gmg_mine_1_superpuzzle_2", { input = true, active = true } );

    end;    

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_screwdriver2_1", use_screwdriver2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver2_1", use_screwdriver2_1_inv );
  cmn.AddSubscriber( "use_screwdriver2_1", use_screwdriver2_1_end, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver2_1_inv", use_screwdriver2_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver2_1_beg", use_screwdriver2_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_screwdriver2_1_end", use_screwdriver2_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_knife_5 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_knife_5" ] = {
    type = "use",
    inv_obj = "inv_knife",
    use_place = "obj_winch_use_knife",
    room = private.room_objname,
    zz = "zz_winch",
    zz_gate = "gzz_mine_1_winch"
  };
  local use_knife_5_inv = function ()
  
    interface.InventoryItemRemove( "inv_knife" );
  
  end;
  local use_knife_5_beg = function ()
  
    ObjDelete( "obj_winch_use_knife" );
  
  end;
  local use_knife_5_end = function ()
  
    ObjSet( "obj_winch_clk_knife_5", { input = true } );
    ObjSet( "spr_winch_knife_1",     { alp = 1 } );
    ObjSet( "spr_mine_1_knife_1",     { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_knife_5", use_knife_5_beg, private.room_objname );
  cmn.AddSubscriber( "use_knife_5", use_knife_5_inv );
  cmn.AddSubscriber( "use_knife_5", use_knife_5_end, private.room_objname );
  cmn.AddSubscriber( "use_knife_5_inv", use_knife_5_inv, private.room_objname );
  cmn.AddSubscriber( "use_knife_5_beg", use_knife_5_beg, private.room_objname );
  cmn.AddSubscriber( "use_knife_5_end", use_knife_5_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crowbar_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_crowbar_3" ] = {
    type = "use",
    inv_obj = "inv_crowbar",
    use_place = "obj_winch_use_crowbar_3",
    room = private.room_objname,
    zz = "zz_winch",
    zz_gate = "gzz_mine_1_winch"
  };
  local use_crowbar_3_inv = function ()
  
    --interface.InventoryItemRemove( "inv_crowbar" );
  
  end;
  local use_crowbar_3_beg = function ()
  
    ObjDelete( "obj_winch_use_crowbar_3" );
  
  end;
  local use_crowbar_3_end = function ()
  
    ObjSet( "spr_winch_remotecontrol", { input = true, active = true } );
    ObjDelete( "spr_mine_1_piece" );

    ObjDelete( "spr_winch_crowbar_1" );
    ObjDelete( "obj_winch_crowbar" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crowbar_3", use_crowbar_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_3", use_crowbar_3_inv );
  cmn.AddSubscriber( "use_crowbar_3", use_crowbar_3_end, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_3_inv", use_crowbar_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_3_beg", use_crowbar_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_3_end", use_crowbar_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_electricaltape () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_electricaltape" ] = {
    type = "use",
    inv_obj = "inv_electricaltape",
    use_place = "obj_controlunit_use_electricaltape",
    room = private.room_objname,
    zz = "zz_controlunit",
    zz_gate = "gzz_mine_1_controlunit"
  };
  local use_electricaltape_inv = function ()
  
    interface.InventoryItemRemove( "inv_electricaltape" );
  
  end;

  local use_electricaltape_beg = function ()
  
    ObjDelete( "obj_controlunit_use_electricaltape" );
  
  end;

  local use_electricaltape_end = function ()

    ObjDelete( "spr_controlunit_wire_turn" );
    ObjDelete( "anm_controlunit_sparks"    );
    ObjDelete( "anm_controlunit_clk"    );
  
    ObjMultiSet({ 
      { "obj_controlunit_use_fuse",   { active = true, visible = true, input = true }},
      { "spr_controlunit_wire_clued", { alp = 1 }},
      { "spr_mine_1_controlunit",     { alp = 1 }}
    }); 
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_electricaltape", use_electricaltape_beg, private.room_objname );
  cmn.AddSubscriber( "use_electricaltape", use_electricaltape_inv );
  cmn.AddSubscriber( "use_electricaltape", use_electricaltape_end, private.room_objname );
  cmn.AddSubscriber( "use_electricaltape_inv", use_electricaltape_inv, private.room_objname );
  cmn.AddSubscriber( "use_electricaltape_beg", use_electricaltape_beg, private.room_objname );
  cmn.AddSubscriber( "use_electricaltape_end", use_electricaltape_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fuse () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fuse" ] = {
    type = "use",
    inv_obj = "inv_fuse",
    use_place = "obj_controlunit_use_fuse",
    room = private.room_objname,
    zz = "zz_controlunit",
    zz_gate = "gzz_mine_1_controlunit"
  };
  local use_fuse_inv = function ()
  
    interface.InventoryItemRemove( "inv_fuse" );
  
  end;
  local use_fuse_beg = function ()
  
    ObjDelete( "obj_controlunit_use_fuse" );
  
  end;
  local use_fuse_end = function ()

    ObjSet( "obj_controlunit_fuse", { alp = 1 } );
    ObjSet( "spr_mine_1_fuse", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fuse", use_fuse_beg, private.room_objname );
  cmn.AddSubscriber( "use_fuse", use_fuse_inv );
  cmn.AddSubscriber( "use_fuse", use_fuse_end, private.room_objname );
  cmn.AddSubscriber( "use_fuse_inv", use_fuse_inv, private.room_objname );
  cmn.AddSubscriber( "use_fuse_beg", use_fuse_beg, private.room_objname );
  cmn.AddSubscriber( "use_fuse_end", use_fuse_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tumblerswitch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tumblerswitch" ] = {
    type = "use",
    inv_obj = "inv_tumblerswitch",
    use_place = "obj_controlunit_use_tumblerswitch",
    room = private.room_objname,
    zz = "zz_controlunit",
    zz_gate = "gzz_mine_1_controlunit"
  };
  local use_tumblerswitch_inv = function ()
  
    interface.InventoryItemRemove( "inv_tumblerswitch" );
  
  end;
  local use_tumblerswitch_beg = function ()
  
    ObjDelete( "obj_controlunit_use_tumblerswitch" );
  
  end;
  local use_tumblerswitch_end = function ()

    ObjMultiSet({ 
      { "spr_mine_1_light_green_lamp",     { alp = 1 }},
      { "obj_controlunit_remotecontrol",     { alp = 1 }},
      { "obj_controlunit_clk_tumblerswitch", { input = true }}
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tumblerswitch", use_tumblerswitch_beg, private.room_objname );
  cmn.AddSubscriber( "use_tumblerswitch", use_tumblerswitch_inv );
  cmn.AddSubscriber( "use_tumblerswitch", use_tumblerswitch_end, private.room_objname );
  cmn.AddSubscriber( "use_tumblerswitch_inv", use_tumblerswitch_inv, private.room_objname );
  cmn.AddSubscriber( "use_tumblerswitch_beg", use_tumblerswitch_beg, private.room_objname );
  cmn.AddSubscriber( "use_tumblerswitch_end", use_tumblerswitch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chain () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chain" ] = {
    type = "use",
    inv_obj = "inv_chain",
    use_place = "obj_carriage_use_chain",
    room = private.room_objname,
    zz = "zz_carriage",
    zz_gate = "gzz_mine_1_carriage"
  };
  local use_chain_inv = function ()
  
    interface.InventoryItemRemove( "inv_chain" );
  
  end;
  local use_chain_beg = function ()
  
    ObjDelete( "obj_carriage_use_chain" );

  end;
  local use_chain_end = function ()

    ObjMultiSet({ 
      { "spr_carriage_chain",           { alp = 1 }},
      { "spr_carriage_chain_shadow",    { alp = 1 }},
      { "vid_winch_chain_zz",           { alp = 1 }},
      { "vid_mine_1_chain",             { alp = 1 }},

      { "spr_carriage_carriage", { event_mdown = "", event_menter = "", event_mleave = "" } },
      { "anm_mine_1_carrige", { visible = true } },
    });
    ObjDelete( "gzz_mine_1_carriage" );

    if ( cmn.IsEventDone( "get_clippers" ) and cmn.IsEventDone( "use_chain" )) then

        ObjDelete( "gzz_mine_1_carriage" );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chain", use_chain_beg, private.room_objname );
  cmn.AddSubscriber( "use_chain", use_chain_inv );
  cmn.AddSubscriber( "use_chain", use_chain_end, private.room_objname );
  cmn.AddSubscriber( "use_chain_inv", use_chain_inv, private.room_objname );
  cmn.AddSubscriber( "use_chain_beg", use_chain_beg, private.room_objname );
  cmn.AddSubscriber( "use_chain_end", use_chain_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_knife_5 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_knife_5" ] = {
    type = "click",
    use_place = "obj_winch_clk_knife_5",
    room = "rm_mine_1",
    zz = "zz_winch",
    zz_gate = "gzz_mine_1_winch"
  };

  local clk_knife_5_beg = function ()
  
    ObjDelete( "obj_winch_clk_knife_5" );
  
  end;

  local clk_knife_5_end = function ()

    ObjMultiSet({ 
      { "spr_winch_knife_1",         { alp = 0 }},
      { "spr_mine_1_knife_2",        { alp = 1 }},
      { "spr_mine_1_knife_1",        { alp = 0 }},
      { "spr_winch_knife_2",         { alp = 1 }},
      { "spr_winch_back_mmg",        { alp = 1 }},
      { "obj_winch_chip_mmg",        { alp = 1, input = true }},
      { "obj_winch_chip_mmg_light",  { alp = 1 }}
    });
    ObjDelete( "obj_winch_mmg_cover" );
    ObjDelete( "spr_winch_mmg_cover" );
    ObjDelete( "spr_mine_1_cover_winch" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_knife_5", clk_knife_5_beg, private.room_objname );
  cmn.AddSubscriber( "clk_knife_5", clk_knife_5_end, private.room_objname );
  cmn.AddSubscriber( "clk_knife_5_beg", clk_knife_5_beg, private.room_objname );
  cmn.AddSubscriber( "clk_knife_5_end", clk_knife_5_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_knife_6 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_knife_6" ] = {
    type = "click",
    use_place = "obj_winch_clk_knife_6",
    room = "rm_mine_1",
    zz = "zz_winch",
    zz_gate = "gzz_mine_1_winch"
  };

  local clk_knife_6_beg = function ()
  
    ObjDelete( "obj_winch_clk_knife_6" );
    ObjDelete( "spr_mine_1_carriage_small" );
  
    ObjSet( "spr_mine_1_knife_2", { alp = 1 } );
    ObjDelete( "spr_mine_1_knife_1" );    

  end;

  local clk_knife_6_end = function ()

    if ( cmn.IsEventDone( "use_chain" )) then

      ObjDelete( "spr_winch_knife_1" );
      ObjMultiSet({ 
        { "spr_winch_knife_2", { alp = 1 }}
      });
      VidStop( "vid_winch_chain_zz" );

      if common_impl.IsGetCoin( "get_coin_19" ) then
        ObjDelete( "gzz_mine_1_winch" );
      end;

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_knife_6", clk_knife_6_beg, private.room_objname );
  cmn.AddSubscriber( "clk_knife_6", clk_knife_6_end, private.room_objname );
  cmn.AddSubscriber( "clk_knife_6_beg", clk_knife_6_beg, private.room_objname );
  cmn.AddSubscriber( "clk_knife_6_end", clk_knife_6_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_tumblerswitch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_tumblerswitch" ] = {
      type = "click",
      use_place = "obj_controlunit_clk_tumblerswitch",
      room = private.room_objname,
      zz = "zz_controlunit",
      zz_gate = "gzz_mine_1_controlunit"  
  };
  local clk_tumblerswitch_beg = function ()
    
    ObjDelete(  "obj_controlunit_clk_tumblerswitch" );
    if common_impl.IsGetCoin( "get_coin_18" ) then
      ObjDelete( "gzz_mine_1_controlunit" );
    end;
    
  end;
  local clk_tumblerswitch_end = function ()

    ObjDelete( "anm_mine_1_light" );
    ObjDelete( "spr_fireextinguishing_text1_add" );
    ObjMultiSet({
      { "spr_fireextinguishing_text2_add", { alp = 1 } },
      { "spr_controlunit_remotecontrol_off", { ang = 1 } },
    });
    
    if ( cmn.IsEventDone( "use_screwdriver2_1" ) ) then
      ObjDelete( "gzz_mine_1_fireextinguishing" );
      ObjSet( "gmg_mine_1_superpuzzle_2", { input = true, active = true } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_tumblerswitch", clk_tumblerswitch_beg, private.room_objname );
  cmn.AddSubscriber( "clk_tumblerswitch", clk_tumblerswitch_end, private.room_objname );
  cmn.AddSubscriber( "clk_tumblerswitch_beg", clk_tumblerswitch_beg, private.room_objname );
  cmn.AddSubscriber( "clk_tumblerswitch_end", clk_tumblerswitch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function see_fireextinguishing () end
  --------------------------------------------------------------------------------------------

  local see_fireextinguishing_beg = function ()

    ObjDelete( "anm_mine_1_fire" );

  end;


  cmn.AddSubscriber( "see_fireextinguishing", see_fireextinguishing_beg, private.room_objname ); 
  cmn.AddSubscriber( "see_fireextinguishing_beg", see_fireextinguishing_beg, private.room_objname );  
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function win_carriage () end
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_carriage" ] = {

      type = "win",    
      use_place = "spr_winch_back_mmg",
      room = private.room_objname,
      zz = "zz_winch",
      zz_gate = "gzz_mine_1_winch",

  };
  local win_carriage = function ()

    if ( cmn.IsEventDone( "win_carriage" ) ) then  

      ObjDelete("spr_winch_back_mmg");
      ObjDelete("obj_winch_chip_mmg");
      ObjDelete("obj_winch_chip_mmg_light");

      ObjMultiSet( {
        { "spr_office_setofdrawers_statuette", { alp = 1 } },
        { "spr_winch_knife_1",                 { alp = 1 } },
        { "spr_winch_knife_2",                 { alp = 0 } },
        { "spr_mine_1_knife_1",                 { alp = 1 } },
        { "spr_mine_1_knife_2",                 { alp = 0 } },
        { "obj_winch_clk_knife_6",             { alp = 1, input = true } },
      } );

    end;

  end;

  cmn.AddSubscriber( "win_carriage", win_carriage, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_mine_1_danger () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_mine_1_danger" ] = {

      type = "click",
      use_place = "obj_vid_mine_1_danger",
      room = private.room_objname
  };
  local vid_mine_1_danger_beg = function ()

    ObjDelete( "obj_vid_mine_1_danger" );

  end;
  local vid_mine_1_danger_end = function ()

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_mine_1_danger", vid_mine_1_danger_beg, private.room_objname );
  cmn.AddSubscriber( "vid_mine_1_danger", vid_mine_1_danger_end, private.room_objname  );
  cmn.AddSubscriber( "vid_mine_1_danger_beg", vid_mine_1_danger_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_mine_1_danger_end", vid_mine_1_danger_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function vid_mine_1_goaf () end;
  --------------------------------------------------------------------------------------------
  local vid_mine_1_goaf = function ()

    ObjSet( "spr_mine_1_logjam", { visible = true } );
    ObjDelete( "grm_mine_1_mine_2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_mine_1_goaf", vid_mine_1_goaf, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_mine_1_saved () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_mine_1_saved" ] = {

      type = "click",
      use_place = "obj_dlg_mine_1_saved_focus",
      room = private.room_objname
  };

  local dlg_mine_1_saved_end = function ()

    ObjDelete( "obj_dlg_mine_1_saved" );
    ObjDelete( "anm_mine_1_saved" );
    interface.InventoryItemAdd( "inv_map_2", "spr_mine_1_saved_mmg_map" );
    --ObjSet( "spr_nightsvilleentrance_evidence_2_1", { alp = 1 } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_mine_1_saved", dlg_mine_1_saved_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_mine_1_saved_end", dlg_mine_1_saved_end, private.room_objname  );

  --------------------------------------------------------------------------------------------
  -- function anm_mine_1_chain () end;
  --------------------------------------------------------------------------------------------
  local anm_mine_1_chain_end = function ()

    VidStop( "vid_mine_1_chain" );
    ObjMultiSet( {
      { "grm_mine_1_mine_2", { alp = 1, input = true, active = true }},
      { "anm_mine_1_carrige", { playing = true, animfunc = "DoAnimComplete", visible = true }}
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "anm_mine_1_chain", anm_mine_1_chain_end, private.room_objname  );
  cmn.AddSubscriber( "anm_mine_1_chain_end", anm_mine_1_chain_end, private.room_objname  );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_winch" );
  --------------------------------------------------------------------------------------------
  function zz_winch.PreOpen()

    if ( cmn.IsEventDone( "clk_knife_5" ) and not cmn.IsEventDone( "win_carriage" )) then

        for i = 1, private.NumberOfElements do

          private.RotateOpen(i);

        end;
        private.skip_winch = 0;
        cmn.MiniGameShow( "carriage" );
        common_impl.PassingMgStart( "carriage" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_winch.PreClose()

    cmn.MiniGameHide( "carriage" );
    common_impl.PassingMgStop( "carriage" );

  end;

  function zz_winch.Close()

    local func_after = function()

      common_impl.Lock( false );
      cmn.SetEventDone( "anm_mine_1_chain" );
      cmn.CallEventHandler( "anm_mine_1_chain_end" );

    end;

    if ( cmn.IsEventDone( "clk_knife_6" ) and not cmn.IsEventDone( "anm_mine_1_chain" ) ) then

      common_impl.Lock( true );
      AnimPlay( "anm_mine_1_carrige", "DoAnim", func_after );
      VidPlay( "vid_mine_1_chain", "" );

    end;

  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_mine_1();

  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

  if ( not cmn.IsEventDone( "see_fireextinguishing" ) and cmn.IsEventDone( "win_superpuzzle_2" ) ) then
    private.AnimFireExtinguishing();
  elseif not cmn.IsEventDone( "win_superpuzzle_2" ) then
    common_impl.PlayAudio( "env", "common/audio/aud_mine1_fire_env", 1, "", 0.5 );
  end;

  if ( not cmn.IsEventDone( "vid_mine_1_danger" ) ) then
    common_impl.PlayTimer( private.vid_mine_1_danger, 3 );
  end;

  common_impl.EnvPlay( { "common/audio/aud_mine1_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing(); 

  interface.InvestigationButtonCheck();
  ObjAnimate("spr_mine_1_light_green_lamp", "alp", 1, 0, "", {0,0,1, 2,0,0.87, 4,0,1});

  if ( cmn.IsEventDone( "clk_knife_6" ) and not cmn.IsEventDone( "anm_mine_1_chain" ) ) then

    local func_after = function()

      common_impl.Lock( false );
      cmn.SetEventDone( "anm_mine_1_chain" );
      cmn.CallEventHandler( "anm_mine_1_chain_end" );

    end;

    common_impl.Lock( true );
    AnimPlay( "anm_mine_1_carrige", "DoAnim", func_after );
    VidPlay( "vid_mine_1_chain", "" );

  end;

  if ( cmn.IsEventDone( "vid_mine_2_savior" ) and not cmn.IsEventDone( "vid_mine_1_goaf" ) ) then

    local func_after = function ( skip )

      common_impl.ShowBbt( 'bbt_mine_1_goaf' );

      interface.DialogVideoHide();
      cmn.SetEventDone( "vid_mine_1_goaf" );
      cmn.CallEventHandler( "vid_mine_1_goaf" );

      if skip then

        common_impl.StopAudio( "sfx", "common/audio/aud_mine_1_goaf", 0.5 );

      end;

    end;

    common_impl.StopTimer();
    common_impl.StopAllMus();
    common_impl.PlayAudio( "sfx", "common/audio/aud_mine_1_goaf", 0, "", 0 );
    
    interface.DialogVideoShow( "vid_mine_1_goaf", 1, function() func_after( 'skip' ) end, 3 );
    VidPlay( "vid_mine_1_goaf", function() func_after( nil ) end );

  end;

end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );

  common_impl.StopAudio( "env", "common/audio/aud_mine1_fire_env", 0.5 );

end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_screwdriver2_1()

  local item = "inv_screwdriver2";

  if ( common.ApplyObj( item, "obj_fireextinguishing_use_screwdriver", true ) ) then

    cmn.CallEventHandler( "use_screwdriver2_1_inv" );
    cmn.CallEventHandler( "use_screwdriver2_1_beg" );

    local func_after = function ()
      
      local func_after_2 = function ()
        common_impl.Lock( false );
        cmn.SetEventDone( "use_screwdriver2_1" );
        cmn.CallEventHandler( "use_screwdriver2_1_end" );
        if ( cmn.IsEventDone( "clk_tumblerswitch" ) ) then
          common.CloseSubRoom();
          cmn.GotoRoom( 'mg_superpuzzle_2' );
        end;

        if ( cmn.IsEventDone( "clk_tumblerswitch" ) ) then

          common.CloseSubRoom();
          cmn.GotoRoom( 'mg_superpuzzle_2' );

        end;

      end;

      ObjAnimate( "spr_fireextinguishing_panel", "alp", 0, 0, func_after_2,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0,
      } );
      

    end;
    
    common_impl.Lock( true );
    VidPlay("vid_fireextinguishing_hex", func_after ); 
    common_impl.PlayAudio( "sfx", "common/audio/aud_fireextinguishing_hex", 0, "", 0 );

    return true;

  elseif ( common.ApplyObj( item, "gzz_mine_1_fireextinguishing", false ) and cmn.IsEventDone( "vid_mine_1_danger" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fireextinguishing", nil, { 512, 384 } );

    return true;   

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_knife_5()

  local item = "inv_knife";

  if ( common.ApplyObj( item, "obj_winch_use_knife", true ) and cmn.IsEventDone( "use_chain" ) ) then

    cmn.CallEventHandler( "use_knife_5_inv" );
    cmn.CallEventHandler( "use_knife_5_beg" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_knife_5" );
      cmn.CallEventHandler( "use_knife_5_end" );
  
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_knife_winch", 0, "", 0 );

    ObjAnimate( "spr_winch_knife_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  elseif ( common.ApplyObj( item, "obj_winch_use_knife", true ) and not cmn.IsEventDone( "use_chain" ) ) then

    local func_end = function ()

      common_impl.Lock( false );
  
    end;

    common_impl.Lock( true );
    common_impl.ShowBbt( 'bbt_winch_use_knife_wrong' );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_knife_winch_wrong", 0, "", 0 );

    ObjAnimate( "spr_winch_knife_1", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0.0, 
      0.2, 0, 1.0,
      0.8, 0, 1.0, 
      1.0, 0, 0.0
    } );

    ObjAnimate( "spr_winch_knife_1", "pos_xy", 0, 0, "",
    { 
      0.0,  0, 178, -146,
      0.2,  0, 178, -146,
      0.35, 0, 181, -139,
      0.5,  0, 178, -146,
      0.65, 0, 181, -139,
      0.8,  0, 178, -146,
      1.0,  0, 178, -146
    } );

    return true;

  elseif ( common.ApplyObj( item, "gzz_mine_1_winch", false ) and cmn.IsEventDone( "vid_mine_1_danger" ) and ObjGet( "obj_winch_use_knife" ).input ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_winch", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_crowbar_3()

  local item = "inv_crowbar";

  if ( common.ApplyObj( item, "obj_winch_use_crowbar_3", true ) ) then

    cmn.CallEventHandler( "use_crowbar_3_inv" );
    cmn.CallEventHandler( "use_crowbar_3_beg" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_crowbar_3" );
      cmn.CallEventHandler( "use_crowbar_3_end" );

    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_crowbar_winch", 0, "", 0 );

    ObjAnimate( "obj_winch_crowbar", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.95, 0, 1.0,
      1.2, 0, 0.0
    } );
  
    ObjAnimate( "spr_winch_crowbar_1", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.95, 0, 1.0,
      1.2, 0, 0.0
    } );

    ObjAnimate( "spr_winch_crowbar_1", "ang", 0, 0, "", 
    {
      0.0, 0, 0.0,
      0.35, 0, 0.0,
      0.65, 1, -0.2
    } );

    ObjAnimate( "spr_winch_crowbar_2", "ang", 0, 0, "", 
    {
      0.0, 0, 0.0,
      0.35, 0, 0.0,
      0.65, 1, -0.2
    } );

    ObjAnimate( "spr_winch_crowbar_1", "pos_xy", 0, 0, "", 
    {
      0.0, 0, -32, 222,
      0.35, 0, -32, 222,
      0.65, 1, -22, 232
    } );

    ObjAnimate( "obj_winch_crowbar", "pos_xy", 0, 0, "", 
    {
      0.0, 0, 0.0, 0.0,
      0.35, 0, 0.0, 0.0, 
      0.65, 1, 10, 10
    } );

    ObjAnimate( "spr_winch_piece", "pos_xy", 0, 0, "",
    { 
      0.0, 0, -89, 175,
      0.35, 0, -89, 175,
      0.65, 0, -79, 185
    } );

    ObjAnimate( "spr_winch_piece", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.65, 0, 1.0,
      0.95, 0, 0.0,
      1.2, 0, 0.0
    } );

    return true;

  elseif ( common.ApplyObj( item, "gzz_mine_1_winch", false ) and cmn.IsEventDone( "vid_mine_1_danger" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_winch", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_electricaltape()

  local item = "inv_electricaltape";

  if ( common.ApplyObj( item, "obj_controlunit_use_electricaltape", true ) ) then

    cmn.CallEventHandler( "use_electricaltape_inv" );
    cmn.CallEventHandler( "use_electricaltape_beg" );

    local func_after = function ()
      
      common_impl.Lock( false );
      cmn.SetEventDone( "use_electricaltape" );
      cmn.CallEventHandler( "use_electricaltape_end" );
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_tape_wires", 0, "", 0 );

    ObjAnimate( "spr_controlunit_wire_turn", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );

    ObjAnimate( "spr_controlunit_wire_clued", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  elseif ( common.ApplyObj( item, "gzz_mine_1_controlunit", false ) and cmn.IsEventDone( "vid_mine_1_danger" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_controlunit", nil, { 512, 384 } );

    return true;   

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fuse()

  local item = "inv_fuse";

  if ( common.ApplyObj( item, "obj_controlunit_use_fuse", true ) and cmn.IsEventDone( "use_electricaltape" )) then

    cmn.CallEventHandler( "use_fuse_inv" );
    cmn.CallEventHandler( "use_fuse_beg" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_fuse" );
      cmn.CallEventHandler( "use_fuse_end" );
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_fuse", 0, "", 0 );

    ObjAnimate( "obj_controlunit_fuse", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  elseif ( common.ApplyObj( item, "gzz_mine_1_controlunit", false ) and cmn.IsEventDone( "vid_mine_1_danger" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_controlunit", nil, { 512, 384 } );

    return true;   

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tumblerswitch()

  local item = "inv_tumblerswitch";

  if ( common.ApplyObj( item, "obj_controlunit_use_tumblerswitch", true ) ) then

    cmn.CallEventHandler( "use_tumblerswitch_inv" );
    cmn.CallEventHandler( "use_tumblerswitch_beg" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_tumblerswitch" );
      cmn.CallEventHandler( "use_tumblerswitch_end" );
    
    end;

    common_impl.Lock( true );
  
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_switch", 0, "", 0 );

    ObjAnimate( "obj_controlunit_remotecontrol", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  elseif ( common.ApplyObj( item, "gzz_mine_1_controlunit", false ) and cmn.IsEventDone( "vid_mine_1_danger" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_controlunit", nil, { 512, 384 } );

    return true;   

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_chain()

  local item = "inv_chain";

  if ( common.ApplyObj( item, "obj_carriage_use_chain", true ) ) then

    cmn.CallEventHandler( "use_chain_inv" );
    cmn.CallEventHandler( "use_chain_beg" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_chain" );
      cmn.CallEventHandler( "use_chain_end" );
      
      if ( cmn.IsEventDone( "get_clippers" ) and cmn.IsEventDone( "use_chain" )) then

        common.CloseSubRoom();

      end;
        
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_chain", 0, "", 0 );

    ObjAnimate( "spr_carriage_chain", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_carriage_chain_shadow", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );    

    return true;

  elseif ( common.ApplyObj( item, "gzz_mine_1_carriage", false ) and cmn.IsEventDone( "vid_mine_1_danger" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_carriage", nil, { 512, 384 } );

    return true;   

  end;

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_remotecontrol()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_remotecontrol" );
  cmn.CallEventHandler( "get_remotecontrol" );

end;
--------------------------------------------------------------------------------------------
function private.get_clippers()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_clippers" );
  cmn.CallEventHandler( "get_clippers" );

  if ( cmn.IsEventDone( "get_clippers" ) and cmn.IsEventDone( "use_chain" )) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_jack()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_jack" );
  cmn.CallEventHandler( "get_jack" );

end;
--------------------------------------------------------------------------------------------
function private.get_wounddevice()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_wounddevice" );
  cmn.CallEventHandler( "get_wounddevice" );

end;
--------------------------------------------------------------------------------------------
function private.get_coin18()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_18");
    cmn.CallEventHandler("get_coin_18");

    if cmn.IsEventDone("clk_tumblerswitch") then
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_controlunit_coin", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_coin19()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_19");
    cmn.CallEventHandler("get_coin_19");

    if cmn.IsEventDone("clk_knife_6") then
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_winch_coin", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_knife_5()

  cmn.CallEventHandler( "clk_knife_5_beg" );

  local func_after = function ()

    cmn.SetEventDone( "clk_knife_5" );
    cmn.CallEventHandler( "clk_knife_5_end" );

    cmn.MiniGameShow( "carriage" );
    common_impl.PassingMgStart( "carriage" );

    ng_global.progress["std"]["win_carriage"].PlayerPositions = { 1, 3, 0, 2, 4, 1,
                                                                  0, 2, 2, 1, 2, 1,
                                                                  1, 4, 2, 0, 1, 1,
                                                                  1, 0, 1, 1, 1, 0,
                                                                  1, 3, 1, 2, 0, 4 };
    common_impl.Lock( false );
  
  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_knife_winch", 0, "", 0 );

  ObjAnimate( "spr_winch_knife_1", "alp", 0, 0, "",
  { 
    0.0, 0, 1.0,
    0.3, 0, 0.0
  } );
  ObjAnimate( "spr_winch_knife_2", "alp", 0, 0, "",
  { 
    0.0, 0, 0.0,
    0.3, 0, 1.0
  } );

  ObjAnimate( "spr_winch_mmg_cover", "pos_y", 0, 0, "",
  { 
    0.0, 0, 113,
    0.3, 0, 113,
    0.8, 0, 354
  } );

  ObjAnimate( "spr_winch_mmg_cover", "scale_y", 0, 0, "",
  { 
    0.0, 0, 1,
    0.3, 0, 1,
    0.8, 0, 0.6
  } );

  ObjAnimate( "spr_winch_back_mmg",       "alp", 0, 0, func_after, { 0,3,0,  0.8,3,0, 1.2,3,1 } );
  ObjAnimate( "obj_winch_chip_mmg",       "alp", 0, 0, "", { 0,3,0,  0.8,3,0, 1.2,3,1 } );
  ObjAnimate( "obj_winch_chip_mmg_light", "alp", 0, 0, "", { 0,3,0,  0.8,3,0, 1.2,3,1 } );

end;
---------------------------------------------------------------------------------------------
function private.clk_knife_6()

  if ( cmn.IsEventDone( "use_chain" )) then

    cmn.CallEventHandler( "clk_knife_6_beg" );

    local func_after = function ()

        local func_end = function()

          common_impl.Lock( false );
          common.CloseSubRoom();
          cmn.SetEventDone( "clk_knife_6" );
          cmn.CallEventHandler( "clk_knife_6_end" );
          
        end;

        --if common_impl.IsGetCoin( "get_coin_19" ) then
        --  common.CloseSubRoom(); 
        --end;

        common_impl.PlayAudio( "sfx", "common/audio/aud_trolley_move", 0, "", 0 );

        VidPlay( "vid_winch_chain_zz", "" ); 
        ObjSet( "tmr_winch_play_chain", { playing = true, time = 0.5, endtrig = func_end });   
 
    end;

    common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_touch_knife_winch_on", 0, "", 0 );

    ObjAnimate( "spr_winch_knife_1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 1.0,
      0.3, 0, 0.0
    } );
    ObjAnimate( "spr_winch_knife_2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0,
      0.3, 0, 1.0
    } );
 
  end;

end;
---------------------------------------------------------------------------------------------
function private.clk_tumblerswitch()

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_tumblerswitch" );
    cmn.CallEventHandler( "clk_tumblerswitch_end" );
    if common_impl.IsGetCoin( "get_coin_18" ) then

      common.CloseSubRoom();    

    end;

    if ( cmn.IsEventDone( "use_screwdriver2_1" ) ) then

      local func_end = function()

        common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_out", 0, "", 0 );

        ObjAnimate( private.room_objname, "scale_xy", 0, 0, "",
        { 

          0.0, 3, 1.5,1.5,
          1.0, 3, 1.0,1.0

        } );
        
        ObjAnimate( private.room_objname, "pos_xy", 0, 0, function() common_impl.Lock( false ); end,
        { 
          0.0, 3,  -112, -98,
          1.0, 3,  0, 0

        } );

      end;

      common.CloseSubRoom();

      common_impl.Lock( true );
      common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_in", 0, "", 0 );

      ObjAnimate( private.room_objname, "scale_xy", 0, 0, "",
      { 
        0.0, 1, 1.0,1.0, 
        1.0, 1, 1.5,1.5,
        1.4, 3, 1.5,1.5,

      } );
      
      ObjAnimate( private.room_objname, "pos_xy", 0, 0, func_end,
      { 
        0.0, 1,  0.0, 0, 
        1.0, 1,  -112, -98,
        1.4, 3,  -112, -98,

      } );

    end;

  end;

  common_impl.Lock( true );

  if ( cmn.IsEventDone("use_electricaltape") and cmn.IsEventDone("use_fuse") ) then

    cmn.CallEventHandler( "clk_tumblerswitch_beg" );

    common_impl.PlayAudio( "sfx", "common/audio/aud_touch_swith_on", 0, "", 0 );

    ObjAnimate( "spr_controlunit_remotecontrol_off", "ang", 0, 0, func_after,
      { 
        0.0, 0, 0.0, 
        0.05, 0, 1.0,
        0.4, 0, 1.0
      } );

  else 

    common_impl.PlayAudio( "sfx", "common/audio/aud_touch_switch", 0, "", 0 );

    ObjAnimate( "spr_controlunit_remotecontrol_off", "ang", 0, 0, "common_impl.ShowBbt( 'bbt_controlunit_clk_switch' );common_impl.Lock( false );",
      { 
        0.0, 0, 0.0, 
        0.05, 0, 1.0,
        0.3, 0, 1.0,
        0.35, 0, 0.0
      } );

  end;

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_mine_1()

  if not ( cmn.IsEventDone( "opn_mine_1" ) ) then
    cmn.SetEventDone( "opn_mine_1" );
    interface.KeyTaskDone( "get_to_mine", true );
  end;
    cmn.CallEventHandler( "opn_mine_1" ); 

end;
--*********************************************************************************************************************
function private.dlg_mine_1_saved()

  ObjAttach( "dlg_mine_1_saved", private.room_objname );
  common_impl.continue_visible = false; 
  common_impl.dialog_character_loc = "obj_mine_1_kevin"; 
  private.dialog_voices_time = { 5, 5, 9 };
  common_impl.DialogCharacterStart( "saved", 6, nil, nil, true, "dlg_mine_1_saved_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_mine_1_saved_end()

  ObjSet( "obj_mine_1_saved_mmg", { visible = true } );
  ObjAttach( "spr_mine_1_saved_mmg_map", "rm_mine_1" );
  ObjSet( "spr_mine_1_saved_mmg_map", { alp = 1, pos_x = 512, pos_y = 384 } );
  ObjDelete( "spr_mine_1_saved_mmg_scroll" );
  
  cmn.CallEventHandler( "dlg_mine_1_saved_end" );


  local func_end = function()

    cmn.SetEventDone( "dlg_mine_1_saved" );
    ng_global.progress[ ng_global.currentprogress ].common.currentroom = "rm_mine_1_3";
    common.LevelSwitch( "level3" );
    common_impl.Lock( false );

  end;

  common_impl.Lock( true );

  ObjSet( "tmr_mine_1_anim", { playing = true, time = 1, endtrig = func_end } );

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if dlg_name == "saved" then

    if count_txt == 1 then 

      common_impl.continue_visible = false; 
      common_impl.frases = { 1, 2, 3 }; 
      common_impl.dial_icons = { 'george', 'owlman', 'ability' };
      common_impl.DialogCharacterShowDialogQuestions( 3, 4 ); 
    
    elseif count_txt == 2 then 

      common_impl.continue_visible = false; 
      common_impl.DialogCharacterShowDialogQuestions( 2, private.dialog_voices_time[ common_impl.dialog_character_select ]  ); 
    
    elseif count_txt == 3 then 

      common_impl.continue_visible = false; 
      common_impl.DialogCharacterShowDialogQuestions( 1, private.dialog_voices_time[ common_impl.dialog_character_select ]  ); 

    elseif count_txt == 5 then 

      ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = private.ClkSavedScroll } );
      ObjSet( "anm_mine_1_saved_map_hand", { alp = 1 } );
      ObjSet( "anm_mine_1_saved_sample_hand", { alp = 0 } );

    end;    
  
  end;  

end;
--*********************************************************************************************************************
function private.ClkSavedScroll()

  common_impl.DialogCharacterMmgShow( "saved", 250, 150  );
  ObjSet( "anm_mine_1_saved_map_hand", { alp = 0 } );
  ObjSet( "anm_mine_1_saved_sample_hand", { alp = 1 } );
  local table_multiset ={ { "obj_mine_1_saved_mmg", { visible = true, input = true } } }; 
  
  for i = 1, 5 do

    table.insert( table_multiset, { "spr_mine_1_saved_mmg_part"..i, { 
      event_mdown = function() private.ClkSavedPart( i ) end, 
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } } );

  end;

  ObjMultiSet( table_multiset );

end;
--*********************************************************************************************************************
function private.ClkSavedPart( num )

  local func_end = function()
    
    if ( num == 5 ) then

      local func = function()
        
        common_impl.Lock( false );     
        ObjDelete( "spr_mine_1_saved_mmg_scroll" ); 
        ObjSet( "spr_mine_1_saved_mmg_map", { input = true, event_mdown = private.GetSavedMap } );   

      end;

      ObjAnimate( "spr_mine_1_saved_mmg_scroll", "alp", 0, 0, "", { 0, 0, 1, 0.3, 0, 0 } );
      ObjAnimate( "spr_mine_1_saved_mmg_map", "alp", 0, 0, func, { 0, 0, 0, 0.3, 0, 1 } );

    else
      common_impl.Lock( false );
    end;

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_mine_1_saved_mmg_part"..num, { input = false } );
  ObjSet( "spr_mine_1_saved_mmg_part"..( num + 1 ), { input = true } );

  ObjAnimate( "spr_mine_1_saved_mmg_part"..num, "alp", 0, 0, func_end, { 0, 0, 1, 0.3, 0, 0 } );
  ObjAnimate( "spr_mine_1_saved_mmg_part"..( num + 1 ), "alp", 0, 0, "", { 0, 0, 0, 0.3, 0, 1 } );

end;
--*********************************************************************************************************************
function private.GetSavedMap( )

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  common_impl.DialogCharacterMmgHide( "saved", "dlg_mine_1_saved_end"  );     
  common_impl.DialogCharacterHide();  

end;
--*********************************************************************************************************************
------------------------------------------------------------------------------------------------------------------------
function private.vid_mine_1_danger()

  cmn.CallEventHandler( "vid_mine_1_danger_beg" );
  ObjSet( "vid_mine_1_danger", { alp = 1, active = true, input = false, visible = true } );

  if int_dialog_task.show == true then
   int_dialog_task.Hide();
  end;
  
  local func_after = function ( skip )

    common_impl.ShowBbt( 'bbt_mine_1_danger' );

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_mine_1_danger" );
    cmn.CallEventHandler( "vid_mine_1_danger_end" );
    interface.KeyTaskAdd( "save_man" );
    common_impl.PlayAudio( "mus", "common/audio/aud_adventure2_mus", 0, "", 0 );

    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_mine_1_danger", 0.5 );
      common_impl.StopAudio( "voc", "common/audio/aud_mine_1_danger_voc", 0.5 );

    end;

  end;

  common_impl.StopTimer();
  common_impl.StopAllMus();
  common_impl.PlayAudio( "sfx", "common/audio/aud_mine_1_danger", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/aud_mine_1_danger_voc", 0, "", 0 );
  
  interface.DialogVideoShow( "vid_mine_1_danger", 1, function() func_after( 'skip' ) end, 3 );
  VidPlay( "vid_mine_1_danger", function() func_after( nil ) end ); 

end;
--------------------------------------------------------------------------------------------
function private.clk_fireextinguishing_button()

  local endfunc = function ()

    common_impl.Lock(false);

    ObjSet("vid_fireextinguishing_tv", { alp = 0 })
    VidStop("vid_fireextinguishing_tv");

  end;
  
  common_impl.Lock(true);

  ObjSet("vid_fireextinguishing_tv", { alp = 1 });
  VidPlay("vid_fireextinguishing_tv","")

  common_impl.ShowBbt( 'bbt_fireextinguishing_no_energy', 1 );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_button_no_energy", 0, "", 0 );

  ObjAnimate( "spr_fireextinguishing_button", "alp", 0, 0, "", 
  {
    0.0, 3, 0, 
    0.3, 3, 1,
    0.6, 3, 0
  });

  ObjAnimate( "obj_fireextinguishing_status_screen", "alp", 0, 0, endfunc, 
  {
    0.0, 3, 0, 
    0.3, 3, 1,
    1.0, 3, 1,
    1.3, 3, 0
  });

end;
--------------------------------------------------------------------------------------------
function private.clk_fireextinguishing_panel()
  
  local endfunc = function ()

    common_impl.Lock( false );

  end;

  common_impl.Lock( true );

  common_impl.ShowBbt( "bbt_fireextinguishing_use_screwdriver" );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_fireextinguishing_cover", 0, "", 0 );

  ObjAnimate( "spr_fireextinguishing_panel", "pos_xy", 0, 1, endfunc, 
  {
    0.0, 3, 0,0, 
    0.3, 3, 1,1,
    0.6, 3, 0,0
  });
  
end;
--*********************************************************************************************************************
function private.coverAnimation()

  local func_after = function ()

    common_impl.Lock(false);

  end;

  common_impl.Lock(true);

  common_impl.ShowBbt( 'bbt_winch_clk_cover', 1 );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_small_metal", 0, "", 0 );

  ObjAnimate( "spr_winch_mmg_cover",     "pos_xy", 0, 0, func_after, 
  { 
    0.0, 0, 236, 113,    
    0.2, 0, 236, 116,
    0.4, 0, 236, 113,
  } );

end;
--*********************************************************************************************************************
function private.AnimCarriage()

  common_impl.Lock( true );
  common_impl.ShowBbt( 'bbt_carriage_use_chain' );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_trolley_hook", 0, "", 0 );

  ObjAnimate( "spr_carriage_carriage", "pos_xy", 0, 0, function() common_impl.Lock( false ); end, {
    0, 3, 14, 9,
    1.0, 3, -12, 20,
    2.0, 3, 14, 9 } );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  ObjAnimate( "spr_carriage_light_1",     "alp", 1, 0, "", { 0,3,1,     0.8,3,0.5,  1.5,3,0.7,  2.2,3,1 } );
  ObjAnimate( "spr_carriage_light_2",     "alp", 1, 0, "", { 0,3,1,     0.8,3,0.5,  1.5,3,0.7,  2.2,3,1 } );
  ObjAnimate( "spr_carriage_hook",        "ang", 1, 0, "", { 0,0,-0.01, 2.5,0,0.01, 5,0,-0.01 } );
  ObjAnimate( "spr_carriage_hook_shadow", "ang", 1, 0, "", { 0,0,-0.01, 2.5,0,0.01, 5,0,-0.01 } )
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG *** () end;
--*********************************************************************************************************************
function private.win_carriage ()

  cmn.MiniGameHide( "carriage" );
  cmn.SetEventDone( "win_carriage" );
  cmn.CallEventHandler( "win_carriage" );
  common_impl.PassingMgWin( "carriage" );

end;
--------------------------------------------------------------------------------------------------------------
function private.AnimFireExtinguishing ( )

  local func_end = function()

    common_impl.Lock( false );
    cmn.SetEventDone( "see_fireextinguishing" );
    cmn.CallEventHandler( "see_fireextinguishing" );
    ObjDelete( "anm_mine_1_fireextinguish" );
    common_impl.PlayAudio( "mus", "common/audio/aud_enigma_mus", 0, "", 0 );

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_fire_extinguishing_system_on", 0, "", 0 );
  common_impl.StopAudio( "env", "common/audio/aud_mine1_fire_env", 1 );
 
  common_impl.Lock( true );
  cmn.CallEventHandler( "see_fireextinguishing_beg" );
  ObjSet( "anm_mine_1_fireextinguish", { visible = true } );
  AnimPlay( "anm_mine_1_fireextinguish", "DoAnim", func_end );  

end;
--------------------------------------------------------------------------------------------------------------
function public.Skip ( event )

  private.skip_winch = 1;

  for i = 1,private.NumberOfElements do 

    ng_global.progress["std"]["win_carriage"].PlayerPositions[i] = private.WinPositions[i];

    if (private.Type[i]~=0) then

      private.RotateSR( i );
      --private.RotateOpen( i );

    end;

  end;

end;
--------------------------------------------------------------------------------------------------------------
function public.Reset ( event )

  for i = 1, private.NumberOfElements do

    ng_global.progress["std"]["win_carriage"].PlayerPositions[i] = private.FirstPositions[i];

    if (private.Type[i]~=0) then

      private.RotateSR( i );
      --private.RotateOpen( i );

    end;

  end;

end;
--------------------------------------------------------------------------------------------------------------
function private.Rotate ( position )

  local type = private.Type[position];
  local rotate = ng_global.progress["std"]["win_carriage"].PlayerPositions[position];

  local func_after = function ()

    if ( type == 1 ) then
  
      if ( rotate == 1 ) then 
        ng_global.progress["std"]["win_carriage"].PlayerPositions[position] = 2;

      elseif ( rotate == 2 ) then 
        ng_global.progress["std"]["win_carriage"].PlayerPositions[position] = 1;
      end;

    elseif ( type == 2 ) then

      if ( rotate == 4 ) then 
        ng_global.progress["std"]["win_carriage"].PlayerPositions[position] = 1;
        ObjSet("spr_winch_chip_"..position, {ang = 0});
      else
        ng_global.progress["std"]["win_carriage"].PlayerPositions[position] = rotate + 1;
      end;

    end;

    common_impl.Lock(false);

    private.Check();

  end;

  common_impl.Lock(true);

  local angNow = ObjGet("spr_winch_chip_"..position).ang;
  local angNew;

  if ( type == 1 ) then

    if ( rotate == 1 ) then 
      angNew = private.angTube[2];
    elseif ( rotate == 2 ) then 
      angNew = private.angTube[1];
    end;

  elseif ( type == 2 ) then
      angNew = private.angTube[rotate+1]
  end;

  if private.skip_winch ~= 1 then

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_winch_rotate", 0, "", 0 );

  end;

  ObjAnimate("spr_winch_chip_"..position,"ang",0, 0, func_after, { 0.0,0,angNow, 0.3,0,angNew } ) ;

end;
--------------------------------------------------------------------------------------------------------------
function private.RotateSR ( position )

  local func_after = function ()

    common_impl.Lock(false);
    private.Check();

  end;

  local type = private.Type[position];
  local rotate = ng_global.progress["std"]["win_carriage"].PlayerPositions[position];

  common_impl.Lock(true);

  local angNow = ObjGet("spr_winch_chip_"..position).ang;
  local angNew;

  if ( type == 1 ) then
    if ( rotate == 1 ) then 
      angNew = private.angTube[1];
    elseif ( rotate == 2 ) then 
      angNew = private.angTube[2];
    end;

  elseif ( type == 2 ) then
    angNew = private.angTube[rotate];
  end;

  if private.skip_winch ~= 1 then

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_winch_rotate", 0, "", 0 );

  end;

  ObjAnimate("spr_winch_chip_"..position,"ang",0, 0, func_after, { 0.0,0,angNow, 0.3,0,angNew } ) ;

end;
--------------------------------------------------------------------------------------------------------------
function private.RotateOpen ( position )

  local type = private.Type[position];
  local rotate = ng_global.progress["std"]["win_carriage"].PlayerPositions[position];

  local angNew;

  if ( type == 1 ) then

    if ( rotate == 1 ) then 
      angNew = private.angTube[1];
    elseif ( rotate == 2 ) then 
      angNew = private.angTube[2];
    end;

  elseif ( type == 2 ) then
    angNew = private.angTube[rotate];
  end;

  ObjSet("spr_winch_chip_"..position,{ ang = angNew } ) ;
  private.Check();

end;
--------------------------------------------------------------------------------------------------------------
function private.Check ()

  local func_after = function ()

    common_impl.Lock(false);
    private.WinAnim();

  end;

  local count = 0;

  for i = 1,private.countRightWay do

    if ( private.WinPositions[private.rightWay[i]] ~= 0 ) then

      if ( private.WinPositions[private.rightWay[i]] == ng_global.progress["std"]["win_carriage"].PlayerPositions[private.rightWay[i]] ) then

        if( ObjGet("spr_winch_chip_"..private.rightWay[i].."_add").alp < 1 ) then

            ObjAnimate("spr_winch_chip_"..private.rightWay[i].."_add","alp",0, 0, "", { 0.0,0,0, 0.3,0,1 } ) ;  

            if private.skip_winch ~= 1 then
              common_impl.PlayAudio( "sfx", "common/audio/aud_mg_winch_micro_on", 0, "", 0 );
            end;

            if ( private.rightWay[i] == private.rightWayLight[i] ) then

              ObjAnimate("spr_winch_cpu_add_"..private.rightWayLight[i],"alp",0, 0, "", { 0.0,0,0, 0.3,0,1 } ) ; 

              if private.skip_winch ~= 1 then
                common_impl.PlayAudio( "sfx", "common/audio/aud_mg_winch_lamp_on", 0, "", 0 );
              end;

            end;

        end;
        
        count = count + 1;     

      else

        if( ObjGet("spr_winch_chip_"..private.rightWay[i].."_add").alp > 0 ) then

          ObjAnimate("spr_winch_chip_"..private.rightWay[i].."_add","alp",0, 0, "", { 0.0,0,1, 0.3,0,0 } ) ;
          common_impl.PlayAudio( "sfx", "common/audio/aud_mg_winch_micro_off", 0, "", 0 );

          for j=i,private.countRightWay do

              if( ObjGet("spr_winch_chip_"..private.rightWay[j].."_add").alp > 0 ) then

                ObjAnimate("spr_winch_chip_"..private.rightWay[j].."_add","alp",0, 0, "", { 0.0,0,1, 0.3,0,0 } ) ;

                if ( private.rightWay[j] == private.rightWayLight[j] ) then

                  ObjAnimate("spr_winch_cpu_add_"..private.rightWayLight[j],"alp",0, 0, "", { 0.0,0,1, 0.3,0,0 } ) ;
                  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_winch_lamp_off", 0, "", 0 ); 

                end;

              end;

          end;

        end;

        break;

      end;

    end;

  end;

  if( count == private.RightPositions ) then

    common_impl.Lock(true);
    ObjAnimate("spr_winch_chip_24_add","alp",0, 0, "",         { 0.0,0,0, 0.3,0,1 } ) ; 
    ObjAnimate("spr_winch_cpu_add_30", "alp",0, 0, func_after, { 0.0,0,0, 0.3,0,1 } ) ; 

  end;

end;
--------------------------------------------------------------------------------------------------------------
function private.WinAnim ()

  local func_after = function ()

    common_impl.Lock(false);
    private.win_carriage();

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_winch_win", 0, "", 0 );

  common_impl.Lock(true);
  ObjAnimate( "spr_winch_back_mmg",       "alp",0, 0, "",         { 0.0,0,1, 0.6,0,1, 0.9,0,0 } ) ; 
  ObjAnimate( "obj_winch_chip_mmg",       "alp",0, 0, "",         { 0.0,0,1, 0.6,0,1, 0.9,0,0 } ) ; 
  ObjAnimate( "obj_winch_chip_mmg_light", "alp",0, 0, func_after, { 0.0,0,1, 0.6,0,1, 0.9,0,0 } ) ; 


end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--                                             Light_Animations
--*********************************************************************************************************************
ObjAnimate( "spr_mine_1_light_small_1", "alp", 1, 0, "", 

  { 
    0.0, 3, 1.0, 
    0.3, 3, 0.2, 
    4.0, 3, 1.0, 
    4.0, 3, 0.0, 
    4.1, 3, 0.6, 
    4.2, 3, 0.0, 
    4.3, 3, 0.1, 
    7.4, 3, 1.0, 
    7.6, 3, 0.6, 
    8.0, 3, 1.0, 

  });

ObjAnimate( "spr_mine_1_light_small_2", "alp", 1, 0, "", 

  { 
    0.0, 3, 1.0, 
    2.0, 3, 0.1, 
    4.1, 3, 1.0, 
    6.0, 3, 0.3, 
    8.1, 3, 0.9, 
    9.2, 3, 0.3, 
    15.3, 3, 1.0, 

  });

ObjAnimate( "spr_mine_1_light_great_1", "alp", 1, 0, "", 

  { 
     0.0, 3, 1.0, 
     4.0, 3, 0.1, 
     7.1, 3, 1.0, 
    16.0, 3, 0.3, 
    21.1, 3, 0.9, 
    23.2, 3, 0.3, 
    25.3, 3, 1.0, 

  });

ObjAnimate( "spr_mine_1_light_great_2", "alp", 1, 0, "", 

  { 
    0.0, 3, 1.0, 
    7.0, 3, 1.0,
    7.1, 3, 0.0,
    7.2, 3, 1.0, 
    7.3, 3, 0.0, 
    7.4, 3, 1.0, 
    7.5, 3, 0.0,
    7.6, 3, 1.0, 
    7.7, 3, 0.0,
    7.8, 3, 1.0, 
   15.4, 3, 1.0,   

  });

--*********************************************************************************************************************
--*********************************************************************************************************************
function private.AnimHook ()

  common_impl.ShowBbt( 'bbt_carriage_clk_hook' );

  local func_after = function ()

    common_impl.Lock(false);
  
  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_trolley_hook", 0, "", 0 );
  
  ObjAnimate( "spr_carriage_hook", "ang", 0, 0, func_after, 
  { 
     0.0, 0, 0, 
     0.3, 0, -0.30,
     0.6, 0, 0, 
     0.9, 0, -0.15,
     1.2, 0, 0, 

  });
  ObjAnimate( "spr_carriage_hook_shadow", "ang", 0, 0, "", 
  { 
     0.0, 0, 0, 
     0.3, 0, -0.30,
     0.6, 0, 0, 
     0.9, 0, -0.15,
     1.2, 0, 0, 

  });

end;

--*********************************************************************************************************************
function private.clk_eltape ()

  local func_after = function ()

    common_impl.Lock(false);
    ObjSet( "obj_controlunit_use_electricaltape", { input = true });
    common_impl.ShowBbt( 'bbt_controlunit_use_electricaltape' );

  end;

  common_impl.Lock(true);
  ObjSet( "obj_controlunit_use_electricaltape", { input = false });
  AnimPlay( "anm_controlunit_clk", "DoAnim", func_after );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_electicity", 0, "", 0 );

end;
--*********************************************************************************************************************