-- name=rm_mineentrance
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_mineentrance";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_cart", "room_hub" );
  ObjAttach( "zz_treehole", "room_hub" );
  ObjAttach( "zz_trailr", "room_hub" );
  ObjAttach( "zz_collapse", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 

    { "obj_cart_clk_tarpaulin", { event_mdown = private.clk_tarpaulin    }},
    { "spr_cart_circles_1",     { event_mdown = private.changePosition1  }},
    { "spr_cart_circles_2",     { event_mdown = private.changePosition2  }},
    { "spr_cart_circles_3",     { event_mdown = private.changePosition3  }},

    { "spr_cart_magnet",        { event_mdown = private.get_magnet       }},
    { "spr_cart_evidence_2_5",  { event_mdown = private.get_evidence_2_5 }},

    { "spr_cart_bulb",               { event_mdown = private.get_bulb }},
    { "spr_cart_chain",              { event_mdown = private.get_chain }},
    { "spr_trailr_axehandle",        { event_mdown = private.get_axehandle }},
    { "spr_trailr_screwdriver",      { event_mdown = private.get_screwdriver_2 }},
    { "spr_trailr_receiverpieces_2",   { event_mdown = private.get_receiverpieces }},

    { "obj_mineentrance_prv_item_1", { event_mdown = function() int_providence.Thinking( "providence_1", "obj_mineentrance_prv_item_1" ) end } },
    { "obj_mineentrance_prv_item_2", { event_mdown = function() int_providence.Thinking( "providence_2", "obj_mineentrance_prv_item_2" ) end } },

    { "obj_mineentrance_providence_use_prv_item_1", { event_mdown = private.get_prv_sledgehammer_silhouette }},
    { "obj_mineentrance_providence_use_prv_item_2", { event_mdown = private.get_prv_valve_silhouette        }},    
    { "spr_trailr_light_add",                       { event_mdown = private.RadioAddLight                   }},
    { "spr_mineentrance_prv_trailer",               { event_startdrag = private.drag_trailer, event_dragdrop = private.drop_trailer   }},
    { "spr_mineentrance_prv_deadbolt",              { event_startdrag = private.drag_deadbolt, event_dragdrop = private.drop_deadbolt }},    
    { "obj_mineentrance_clk_grm_mine", { event_mdown = private.vid_mineentrance_explosion }},
    { "obj_trailr_clk_trailr",         { event_mdown = private.clk_trailr }},
    { "obj_trailr_use_jack",           { event_mdown = private.clk_trailr }},
    { "spr_cart_coin",                 { event_mdown = private.get_coin16 } },
    { "spr_trailr_coin",               { event_mdown = private.get_coin17 } },

    { "spr_mineentrance_collect_item",    { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_2_2" );     end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_mineentrance_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_4" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
 
  });

  private.angPositions1  = {0, -0.80, -1.58, -2.36, -3.14, -3.92, -4.70, -5.48, -6.31};
  private.angPositions2  = {0, -0.78, -1.56, -2.34, -3.12, -3.90, -4.68, -5.46, -6.29};
  private.angPositions3  = {0, -0.77, -1.57, -2.33, -3.11, -3.89, -4.67, -5.45, -6.28};

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mineentrance = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_mineentrance_trailr",
    "gzz_mineentrance_collapse",
    "gzz_mineentrance_treehole",
    "gzz_mineentrance_cart",
    "gho_mineentrance_intreehole"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
    private.room_objname,
    "zz_cart",
    "zz_treehole",
    "zz_trailr",
    "zz_collapse",
    
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_mineentrance", update_game_mode_mineentrance, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_mineentrance = function ()

  local effects_table = 
  {
    "obj_mineentrance_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_mineentrance", update_performance_mode_mineentrance, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_mineentrance () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_mineentrance" ] = {
    type = "click",
    use_place = "grm_nightsville_mineentrance",
    room = "rm_nightsville"
  };

  local opn_mineentrance_map = function ()

    common_impl.VisitMapRoom( "mineentrance" );

  end;
  cmn.AddSubscriber( "opn_mineentrance", opn_mineentrance_map, nil );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_2_2 = function ()
  
    ObjDelete( "obj_mineentrance_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_2_2", get_collect_item_2_2, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_4 = function ()
  
    ObjDelete( "obj_mineentrance_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_4", get_collect_morph_item_2_4, private.room_objname );

  -------------------------------------------------------------------------------------------- 
  -- function get_prv_sledgehammer_silhouette () end;
  --------------------------------------------------------------------------------------------
  local get_prv_sledgehammer_silhouette_inv = function ()
  
    interface.ProvidePanelSilhouetteAdd( "inv_prv_sledgehammer", "spr_mineentrance_prv_sledgehammer_silhouette" );

  end;
  
  local get_prv_sledgehammer_silhouette_closezz = function ()

    ObjSet( "spr_mineentrance_prv_sledgehammer_silhouette", { alp = 1 } );    
    ObjSet( "obj_mineentrance_providence_use_prv_item_1", { event_mdown = function() int_providence.Thinking( "providence_prv_item_1", "obj_mineentrance_providence_use_prv_item_1" ) end } )

  end;

  local get_prv_sledgehammer_silhouette_notadd = function ()

    ObjSet( "obj_mineentrance_providence_use_prv_item_1", { event_mdown = function() int_providence.Thinking( "providence_prv_item_1", "obj_mineentrance_providence_use_prv_item_1" ) end } )

  end;
  
  cmn.AddSubscriber( "get_prv_sledgehammer_silhouette", get_prv_sledgehammer_silhouette_inv );
  cmn.AddSubscriber( "get_prv_sledgehammer_silhouette", get_prv_sledgehammer_silhouette_closezz, private.room_objname );
  cmn.AddSubscriber( "get_prv_sledgehammer", get_prv_sledgehammer_silhouette_notadd, private.room_objname ); 
  --------------------------------------------------------------------------------------------
  -- function get_prv_valve_silhouette () end;
  --------------------------------------------------------------------------------------------
  local get_prv_valve_silhouette_inv = function ()
  
    interface.ProvidePanelSilhouetteAdd( "inv_prv_valve", "spr_mineentrance_prv_valve_silhouette" );

  end;
  
  local get_prv_valve_silhouette_closezz = function ()

    ObjSet( "spr_mineentrance_prv_valve_silhouette", { alp = 1 } );    
    ObjSet( "obj_mineentrance_providence_use_prv_item_2",        { event_mdown = function() int_providence.Thinking( "providence_prv_item_2", "obj_mineentrance_providence_use_prv_item_2" ) end } );

  end;

  local get_prv_valve_silhouette_notadd = function ()

    ObjSet( "obj_mineentrance_providence_use_prv_item_2",        { event_mdown = function() int_providence.Thinking( "providence_prv_item_2", "obj_mineentrance_providence_use_prv_item_2" ) end } );

  end;
  
  cmn.AddSubscriber( "get_prv_valve_silhouette", get_prv_valve_silhouette_inv );
  cmn.AddSubscriber( "get_prv_valve_silhouette", get_prv_valve_silhouette_closezz, private.room_objname );
  cmn.AddSubscriber( "get_prv_valve", get_prv_valve_silhouette_notadd, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function get_magnet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_magnet" ] = {
    type = "get",
    get_obj = "spr_cart_magnet",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_mineentrance_cart"
  };
    
  local get_magnet_inv = function ()
  
    interface.InventoryItemAdd( "inv_magnet", "spr_cart_magnet" );
  
  end;
  
  local get_magnet_closezz = function ()
  
    ObjDelete( "spr_cart_magnet_shadow" );

    ObjDelete( "gfx_cart_magnet" );
    ObjDelete( "spr_mineentrance_cart_magnet" );

    if cmn.IsEventDone("get_bulb") and cmn.IsEventDone("get_magnet")  
      and cmn.IsEventDone("get_evidence_2_5") and cmn.IsEventDone("get_chain") and common_impl.IsGetCoin( "get_coin_16" ) then
      ObjDelete( "gzz_mineentrance_cart" );
    end;

  end;
  
  cmn.AddSubscriber( "get_magnet", get_magnet_inv );
  cmn.AddSubscriber( "get_magnet", get_magnet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_evidence_2_5 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_evidence_2_5" ] = {
    type = "get",
    get_obj = "spr_cart_evidence_2_5",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_mineentrance_cart"
  };    
  
  local get_evidence_2_5_closezz = function ()
  
    ObjDelete( "gfx_cart_evidence_2_5" );
    ObjDelete( "spr_cart_evidence_2_5" );
    ObjDelete( "spr_cart_box" );
    ObjDelete( "spr_mineentrance_cart_box" );
    ObjDelete( "spr_mineentrance_cart_box_opened" );

    if cmn.IsEventDone("get_bulb") and cmn.IsEventDone("get_magnet") 
       and cmn.IsEventDone("get_evidence_2_5") and cmn.IsEventDone("get_chain") and common_impl.IsGetCoin( "get_coin_16" ) then
      ObjDelete( "gzz_mineentrance_cart" );
    end;
  
  end;
    
  cmn.AddSubscriber( "get_evidence_2_5", get_evidence_2_5_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bulb () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bulb" ] = {
    type = "get",
    get_obj = "spr_cart_bulb",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_mineentrance_cart"
  };
    
  local get_bulb_inv = function ()
  
    interface.InventoryItemAdd( "inv_bulb", "spr_cart_bulb" );
    ObjSet( "spr_flashlight_plus_light", { visible = true } );
  
  end;
  
  local get_bulb_closezz = function ()
  
    ObjDelete( "gfx_cart_bulb" );
    ObjDelete( "spr_mineentrance_cart_lightbulb" );

    if cmn.IsEventDone("get_bulb") and cmn.IsEventDone("get_magnet")  
       and cmn.IsEventDone("get_evidence_2_5") and cmn.IsEventDone("get_chain") 
       and common_impl.IsGetCoin( "get_coin_16" ) then
      ObjDelete( "gzz_mineentrance_cart" );
    end;

  end;
  
  cmn.AddSubscriber( "get_bulb", get_bulb_inv );
  cmn.AddSubscriber( "get_bulb", get_bulb_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chain () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chain" ] = {
    type = "get",
    get_obj = "spr_cart_chain",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_mineentrance_cart"
  };
    
  local get_chain_inv = function ()
  
    interface.InventoryItemAdd( "inv_chain", "spr_cart_chain" );
  
  end;
  
  local get_chain_closezz = function ()
  
    ObjDelete( "gfx_cart_chain" );
    ObjDelete( "spr_mineentrance_cart_chain" );

    if cmn.IsEventDone("get_bulb") and cmn.IsEventDone("get_magnet")  and cmn.IsEventDone("get_evidence_2_5") 
       and cmn.IsEventDone("get_chain") and common_impl.IsGetCoin( "get_coin_16" ) then
      ObjDelete( "gzz_mineentrance_cart" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_chain", get_chain_inv );
  cmn.AddSubscriber( "get_chain", get_chain_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_axehandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_axehandle" ] = {
    type = "get",
    get_obj = "spr_trailr_axehandle",
    room = private.room_objname,
    zz = "zz_trailr",
    zz_gate = "gzz_mineentrance_trailr"
  };
    
  local get_axehandle_inv = function ()
  
    interface.InventoryItemAdd( "inv_axehandle", "spr_trailr_axehandle" );    
    ObjSet( "spr_axeblade_plus_light", { visible = true } );    
  
  end;
  
  local get_axehandle_closezz = function ()
  
    ObjDelete( "spr_trailr_axe_cap"   );
    ObjDelete( "gfx_trailr_axehandle" );

    ObjSet( "obj_trailr_use_jack", { input = true });


    if ( cmn.IsEventDone( "get_screwdriver_2" )     and          
         cmn.IsEventDone( "get_receiverpieces" )
         and common_impl.IsGetCoin( "get_coin_17" ) ) then

        ObjDelete( "gzz_mineentrance_trailr" );

    end;
    
  
  end;
  
  cmn.AddSubscriber( "get_axehandle", get_axehandle_inv );
  cmn.AddSubscriber( "get_axehandle", get_axehandle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_screwdriver_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_screwdriver_2" ] = {
    type = "get",
    get_obj = "spr_trailr_screwdriver",
    room = private.room_objname,
    zz = "zz_trailr",
    zz_gate = "gzz_mineentrance_trailr"
  };
    
  local get_screwdriver_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_screwdriver2", "spr_trailr_screwdriver" );
  
  end;
  
  local get_screwdriver_2_closezz = function ()
  
    ObjDelete( "gfx_trailr_screwdriver"        );
    ObjDelete( "spr_trailr_screwdriver_shadow" );

    if ( cmn.IsEventDone( "get_axehandle" ) and
         cmn.IsEventDone( "get_receiverpieces" )and 
         common_impl.IsGetCoin( "get_coin_17" )) then

        ObjDelete( "gzz_mineentrance_trailr" );

    end;

  end;
  
  cmn.AddSubscriber( "get_screwdriver_2", get_screwdriver_2_inv );
  cmn.AddSubscriber( "get_screwdriver_2", get_screwdriver_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_receiverpieces () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_receiverpieces" ] = {
    type = "get",
    get_obj = "spr_trailr_receiverpieces_2",
    room = private.room_objname,
    zz = "zz_trailr",
    zz_gate = "gzz_mineentrance_trailr"
  };
    
  local get_receiverpieces_inv = function ()
  
    interface.InventoryItemAdd( "inv_receiverpieces", "spr_trailr_receiverpieces_2" );
    ObjSet( "inv_receiverpieces", { drag = false } );
    if ( not cmn.IsEventDone( "get_tweezers" ) ) then
      ObjSet( "spr_receiverpieces_plus_light", { visible = false } );
    end;
  
  end;
  
  local get_receiverpieces_closezz = function ()
  
    ObjDelete( "spr_trailr_radio_2_sh"            );
    ObjDelete( "spr_trailr_radio_2_add"           );
    ObjDelete( "spr_mineentrance_trailer_radio" );
    ObjDelete( "gfx_trailr_receiverpieces_2"      );

    if ( cmn.IsEventDone( "get_screwdriver_2" )     and 
         cmn.IsEventDone( "get_axehandle" ) 
         and common_impl.IsGetCoin( "get_coin_17" ) ) then

        ObjDelete( "gzz_mineentrance_trailr" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_receiverpieces", get_receiverpieces_inv );
  cmn.AddSubscriber( "get_receiverpieces", get_receiverpieces_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coins () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_16 = function ()
 
    ObjDelete( "obj_cart_coin" );

    if cmn.IsEventDone("get_bulb") and cmn.IsEventDone("get_magnet")  
      and cmn.IsEventDone("get_evidence_2_5") and cmn.IsEventDone("get_chain") then
      ObjDelete( "gzz_mineentrance_cart" );
    end;
    
  end;
  cmn.AddSubscriber( "get_coin_16", get_collect_coin_16, private.room_objname );
  --------------------------------------------------------------------------------------------
  local get_collect_coin_17 = function ()
 
    ObjDelete( "obj_trailr_coin" );

    if ( cmn.IsEventDone( "get_screwdriver_2" )     and 
         cmn.IsEventDone( "get_axehandle"   )     and
         cmn.IsEventDone( "get_receiverpieces" )) then
      ObjDelete( "gzz_mineentrance_trailr" );
    end;
    
  end;
  cmn.AddSubscriber( "get_coin_17", get_collect_coin_17, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hanky () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hanky" ] = {
    type = "use",
    inv_obj = "inv_hanky",
    use_place = "obj_cart_use_hanky",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_mineentrance_cart"
  };
  local use_hanky_inv = function ()
  
    interface.InventoryItemRemove( "inv_hanky" );
  
  end;
  local use_hanky_beg = function ()
  
    ObjDelete( "obj_cart_use_hanky" );
  
  end;
  local use_hanky_end = function ()

   ObjDelete("anm_cart_lightbulb");
  
   ObjMultiSet({ 
      { "spr_cart_bulb", { input = true, active = true }},    
    })

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hanky", use_hanky_beg, private.room_objname );
  cmn.AddSubscriber( "use_hanky", use_hanky_inv );
  cmn.AddSubscriber( "use_hanky", use_hanky_end, private.room_objname );
  cmn.AddSubscriber( "use_hanky_inv", use_hanky_inv, private.room_objname );
  cmn.AddSubscriber( "use_hanky_beg", use_hanky_beg, private.room_objname );
  cmn.AddSubscriber( "use_hanky_end", use_hanky_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chestpart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chestpart" ] = {
    type = "use",
    inv_obj = "inv_chestpart",
    use_place = "obj_cart_use_chestpart",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_mineentrance_cart"
  };
  local use_chestpart_inv = function ()
  
    interface.InventoryItemRemove( "inv_chestpart" );
  
  end;
  local use_chestpart_beg = function ()
  
    ObjDelete( "obj_cart_use_chestpart" );
  
  end;
  local use_chestpart_end = function ()
  
    --ObjSet( "spr_cart_key", { input = true, visible = true, active = true } );
    ObjSet( "obj_cart_mmg" ,{ alp = 1, input = 1 });
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chestpart", use_chestpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_chestpart", use_chestpart_inv );
  cmn.AddSubscriber( "use_chestpart", use_chestpart_end, private.room_objname );
  cmn.AddSubscriber( "use_chestpart_inv", use_chestpart_inv, private.room_objname );
  cmn.AddSubscriber( "use_chestpart_beg", use_chestpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_chestpart_end", use_chestpart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_clippers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_clippers" ] = {
    type = "use",
    inv_obj = "inv_clippers",
    use_place = "obj_cart_use_clippers",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_mineentrance_cart"
  };
  local use_clippers_inv = function ()
  
    --interface.InventoryItemRemove( "inv_clippers" );
  
  end;
  local use_clippers_beg = function ()
  
    ObjDelete( "obj_cart_use_clippers" );
  
  end;
  local use_clippers_end = function ()
  
    ObjDelete( "anm_cart_nippers" );
    ObjSet("spr_cart_chain",{input = true, active = true});  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_clippers", use_clippers_beg, private.room_objname );
  cmn.AddSubscriber( "use_clippers", use_clippers_inv );
  cmn.AddSubscriber( "use_clippers", use_clippers_end, private.room_objname );
  cmn.AddSubscriber( "use_clippers_inv", use_clippers_inv, private.room_objname );
  cmn.AddSubscriber( "use_clippers_beg", use_clippers_beg, private.room_objname );
  cmn.AddSubscriber( "use_clippers_end", use_clippers_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_workingflashlight () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_workingflashlight" ] = {
    type = "use",
    inv_obj = "inv_workingflashlight",
    use_place = "obj_treehole_use_workingflashlight",
    room = private.room_objname,
    zz = "zz_treehole",
    zz_gate = "gzz_mineentrance_treehole"
  };
  local use_workingflashlight_inv = function ()
  
    interface.InventoryItemRemove( "inv_workingflashlight" );
  
  end;
  local use_workingflashlight_beg = function ()
  
    ObjDelete( "obj_treehole_use_workingflashlight" );
    ObjDelete( "gzz_mineentrance_treehole" );
  
  end;
  local use_workingflashlight_end = function ()

    ObjDelete( "spr_mineentrance_treehole_dark" );
    ObjSet( "spr_mineentrance_treehole_light", { alp = 1 } );
    ObjSet( "gho_mineentrance_intreehole",     { input = true, active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_workingflashlight", use_workingflashlight_beg, private.room_objname );
  cmn.AddSubscriber( "use_workingflashlight", use_workingflashlight_inv );
  cmn.AddSubscriber( "use_workingflashlight", use_workingflashlight_end, private.room_objname );
  cmn.AddSubscriber( "use_workingflashlight_inv", use_workingflashlight_inv, private.room_objname );
  cmn.AddSubscriber( "use_workingflashlight_beg", use_workingflashlight_beg, private.room_objname );
  cmn.AddSubscriber( "use_workingflashlight_end", use_workingflashlight_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_7 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_7" ] = {
    type = "use",
    inv_obj = "inv_elf_2",
    use_place = "obj_trailr_use_elf",
    room = private.room_objname,
    zz = "zz_trailr",
    zz_gate = "gzz_mineentrance_trailr"
  };
  local use_elf_7_inv = function ()
 
  end;
  local use_elf_7_beg = function ()
  
    ObjDelete( "obj_trailr_use_elf" );
    ObjDelete( "obj_trailr_radio_1" );

  end;
  local use_elf_7_end = function ()

    ObjDelete( "vid_trailr_use_elf_7" );
    ObjSet( "obj_trailr_radio_2", { input = true, active = true, visible = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_7", use_elf_7_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_7", use_elf_7_inv );
  cmn.AddSubscriber( "use_elf_7", use_elf_7_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_7_inv", use_elf_7_inv, private.room_objname );
  cmn.AddSubscriber( "use_elf_7_beg", use_elf_7_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_7_end", use_elf_7_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_jack () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_jack" ] = {
    type = "use",
    inv_obj = "inv_jack",
    use_place = "obj_trailr_use_jack",
    room = private.room_objname,
    zz = "zz_trailr",
    zz_gate = "gzz_mineentrance_trailr"
  };
  local use_jack_inv = function ()
  
    interface.InventoryItemRemove( "inv_jack" );
  
  end;
  local use_jack_beg = function ()
  
    ObjDelete( "obj_trailr_use_jack" );
    ObjDelete( "obj_trailr_clk_trailr" );

    ObjMultiSet({ 
      { "spr_trailr_body_baza", { alp = 0 }},
      { "spr_trailr_body_1",    { alp = 0 }},
      { "spr_trailr_body_2",    { alp = 0 }},
    });
  
  end;
  local use_jack_end = function ()
  
    ObjDelete( "anm_trailr_jack" );

    ObjMultiSet({
      { "obj_trailr_use_elf",   { input = 1 }},
      { "spr_trailr_body_baza", { pos_x = 8,   pos_y = -151 , ang = 0.22, alp = 1 }},
      { "spr_trailr_body_1",    { pos_x = -45, pos_y = -179 , ang = 0.22, alp = 1 }},
      { "spr_trailr_body_2",    { pos_x = 247, pos_y = -195 , ang = 0.08, alp = 1 }},
      { "spr_mineentrance_trailer_3",     { alp = 1 }},
      { "spr_mineentrance_trailer_radio", { alp = 1 }},
      { "obj_trailr_jack",                { alp = 1 }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_jack", use_jack_beg, private.room_objname );
  cmn.AddSubscriber( "use_jack", use_jack_inv );
  cmn.AddSubscriber( "use_jack", use_jack_end, private.room_objname );
  cmn.AddSubscriber( "use_jack_inv", use_jack_inv, private.room_objname );
  cmn.AddSubscriber( "use_jack_beg", use_jack_beg, private.room_objname );
  cmn.AddSubscriber( "use_jack_end", use_jack_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crowbar_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_crowbar_2" ] = {
    type = "use",
    inv_obj = "inv_crowbar",
    use_place = "obj_collapse_use_crowbar",
    room = private.room_objname,
    zz = "zz_collapse",
    zz_gate = "gzz_mineentrance_collapse"
  };
  local use_crowbar_2_inv = function ()
  
    --interface.InventoryItemRemove( "inv_crowbar" );
  
  end;
  local use_crowbar_2_beg = function ()
  
    ObjDelete( "obj_collapse_use_crowbar" );
  
  end;
  local use_crowbar_2_end = function ()
  
    --ObjDelete( "anm_collapse_scrap" );
    ObjDelete( "gzz_mineentrance_collapse" );
    ObjDelete( "spr_nightsville_stones" );

    ObjMultiSet({
      {"grm_mineentrance_mine_1", { input = true, active = true, visible = true }},
    });
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_mineentrance_mine_1_focus");
    end;

    ObjDelete( "spr_mineentrance_collaps_stones" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crowbar_2", use_crowbar_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_2", use_crowbar_2_inv );
  cmn.AddSubscriber( "use_crowbar_2", use_crowbar_2_end, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_2_inv", use_crowbar_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_2_beg", use_crowbar_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_2_end", use_crowbar_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_axe () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_axe" ] = {
    type = "use",
    inv_obj = "inv_axe",
    use_place = "obj_collapse_use_axe",
    room = private.room_objname,
    zz = "zz_collapse",
    zz_gate = "gzz_mineentrance_collapse"
  };
  local use_axe_inv = function ()
  
    interface.InventoryItemRemove( "inv_axe" );
  
  end;
  local use_axe_beg = function ()
  
    ObjDelete( "obj_collapse_use_axe" );
  
  end;
  local use_axe_end = function ()
  
    ObjSet( "obj_collapse_use_crowbar", { input = true, visible = true, active = true } );

    ObjDelete( "spr_mineentrance_collaps_wood" );
    ObjDelete( "anm_collapse_axe"              );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_axe", use_axe_beg, private.room_objname );
  cmn.AddSubscriber( "use_axe", use_axe_inv );
  cmn.AddSubscriber( "use_axe", use_axe_end, private.room_objname );
  cmn.AddSubscriber( "use_axe_inv", use_axe_inv, private.room_objname );
  cmn.AddSubscriber( "use_axe_beg", use_axe_beg, private.room_objname );
  cmn.AddSubscriber( "use_axe_end", use_axe_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_providence_valve () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_providence_valve" ] = {
    type = "use",
    inv_obj = "inv_prv_valve",
    use_place = "obj_mineentrance_providence_use_prv_item_2",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"
  };
  local use_providence_valve_inv = function ()
  
    interface.ProvidePanelItemRemove( "inv_prv_valve" );

  end;
  local use_providence_valve_beg = function ()
  
    ObjDelete( "obj_mineentrance_providence_use_prv_item_2" );
  
  end;
  local use_providence_valve_end = function ()
  
    ObjSet( "spr_mineentrance_prv_valve_used", { alp = 1 } );
    ObjSet( "spr_mineentrance_valve",          { alp = 1 } );
    ObjDelete( "spr_mineentrance_prv_valve_light" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_providence_valve", use_providence_valve_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_valve", use_providence_valve_inv );
  cmn.AddSubscriber( "use_providence_valve", use_providence_valve_end, private.room_objname );
  cmn.AddSubscriber( "use_providence_valve_inv", use_providence_valve_inv, private.room_objname );
  cmn.AddSubscriber( "use_providence_valve_beg", use_providence_valve_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_valve_end", use_providence_valve_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_providence_sledgehammer () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_providence_sledgehammer" ] = {
    type = "use",
    inv_obj = "inv_prv_sledgehammer",
    use_place = "obj_mineentrance_providence_use_prv_item_1",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"
  };
  local use_providence_sledgehammer_inv = function ()
  
    interface.ProvidePanelItemRemove( "inv_prv_sledgehammer" );
  
  end;
  local use_providence_sledgehammer_beg = function ()
  
    ObjDelete( "obj_mineentrance_providence_use_prv_item_1" );
  
  end;
  local use_providence_sledgehammer_end = function ()
  
    ObjSet( "spr_mineentrance_prv_sledgehammer_used", { alp = 1 } );

    ObjDelete( "spr_mineentrance_prv_sledgehammer_light" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_providence_sledgehammer", use_providence_sledgehammer_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_sledgehammer", use_providence_sledgehammer_inv );
  cmn.AddSubscriber( "use_providence_sledgehammer", use_providence_sledgehammer_end, private.room_objname );
  cmn.AddSubscriber( "use_providence_sledgehammer_inv", use_providence_sledgehammer_inv, private.room_objname );
  cmn.AddSubscriber( "use_providence_sledgehammer_beg", use_providence_sledgehammer_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_sledgehammer_end", use_providence_sledgehammer_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_providence_trailer () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_providence_trailer" ] = {
    type = "click",
    inv_obj = "spr_mineentrance_prv_trailer",
    use_place = "obj_mineentrance_prv_item_1",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence" 
  };
  local clk_providence_trailer_beg = function ()
  
    ObjDelete(  "obj_mineentrance_prv_item_1" );
  
  end;
  local clk_providence_trailer_end = function ()
  
    ObjDelete( "spr_mineentrance_prv_trailer" );
    ObjDelete( "spr_mineentrance_prv_trailer_light" );
    ObjSet( "spr_mineentrance_prv_trailer_used", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_providence_trailer", clk_providence_trailer_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_trailer", clk_providence_trailer_end, private.room_objname );
  cmn.AddSubscriber( "clk_providence_trailer_beg", clk_providence_trailer_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_trailer_end", clk_providence_trailer_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_providence_deadbolt () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_providence_deadbolt" ] = {
    type = "click",
    inv_obj = "spr_mineentrance_prv_deadbolt",
    use_place = "obj_mineentrance_prv_item_2",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"    
  };
  local clk_providence_deadbolt_beg = function ()
  
    ObjDelete(  "obj_mineentrance_prv_item_2" );
  
  end;
  local clk_providence_deadbolt_end = function ()
  
    ObjDelete( "spr_mineentrance_prv_deadbolt"       );
    ObjDelete( "spr_mineentrance_prv_deadbolt_light" );

    ObjSet( "spr_mineentrance_prv_deadbolt_used", { alp = 1 } );
    ObjSet( "spr_mineentrance_prv_valve_light", { alp = 1 } );
    ObjSet( "obj_mineentrance_providence_use_prv_item_2", { input = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_providence_deadbolt", clk_providence_deadbolt_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_deadbolt", clk_providence_deadbolt_end, private.room_objname );
  cmn.AddSubscriber( "clk_providence_deadbolt_beg", clk_providence_deadbolt_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_deadbolt_end", clk_providence_deadbolt_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_providence_mineentrance () end;
  --------------------------------------------------------------------------------------------
  local clk_providence_mineentrance = function ()
  
    if ( not cmn.IsEventDone( "clk_providence_deadbolt" ) or not cmn.IsEventDone( "clk_providence_trailer" )
         or ( cmn.IsEventDone( "get_prv_valve" ) and not cmn.IsEventDone( "use_providence_valve" ) ) 
         or ( cmn.IsEventDone( "get_prv_sledgehammer" ) and not cmn.IsEventDone( "use_providence_sledgehammer" ) ) ) then

        int_button_providence.StartActiveProvidence();

    end;
  
  end;
  
  cmn.AddSubscriber( "clk_providence_mineentrance", clk_providence_mineentrance, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_tarpaulin () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_tarpaulin" ] = {
    type = "click",
    use_place = "obj_cart_clk_tarpaulin",
    room = private.room_objname,
    zz = "zz_cart",
    zz_gate = "gzz_mineentrance_cart"

  };
  local clk_tarpaulin_beg = function ()
  
    ObjDelete( "obj_cart_clk_tarpaulin" );
  
  end;
  local clk_tarpaulin_end = function ()
 
    ObjSet( "spr_cart_tarpaulin_2", { alp = 1 } );
    ObjSet( "obj_cart_open",        { alp = 1 } );
    ObjSet( "spr_mineentrance_cart_tarpaulin_2",        { alp = 1 } );
    ObjDelete( "spr_mineentrance_cart_tarpaulin_1" );
    ObjDelete( "spr_cart_tarpaulin_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_tarpaulin", clk_tarpaulin_beg, private.room_objname );
  cmn.AddSubscriber( "clk_tarpaulin", clk_tarpaulin_end, private.room_objname );
  cmn.AddSubscriber( "clk_tarpaulin_beg", clk_tarpaulin_beg, private.room_objname );
  cmn.AddSubscriber( "clk_tarpaulin_end", clk_tarpaulin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
   --function fire remove end;
  --------------------------------------------------------------------------------------------
  
  local see_fireextinguishing = function ()

    ObjDelete( "anm_mineentrance_fire" );

  end;

  cmn.AddSubscriber( "see_fireextinguishing", see_fireextinguishing, private.room_objname ); 
  --------------------------------------------------------------------------------------------
   --function win_chest end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_chestpart" ] = {

      type = "win",    
      use_place = "obj_cart_mmg",
      room = private.room_objname,
      zz_gate = "gzz_mineentrance_cart",
      zz = "zz_cart"
  };

  local win_chestpart_func = function ()

      if ( cmn.IsEventDone( "win_chestpart" ) ) then  
        

        ObjMultiSet({ 
          { "spr_cart_evidence_2_5",            { alp = 1, input = true }},
          { "spr_cart_box",                     {          input = true }},
          { "spr_mineentrance_cart_box_opened", { alp = 1               }},

        });


        ObjDelete( "obj_cart_mmg" );
        ObjDelete( "spr_cart_circles" );
        --ObjDelete( "spr_cart_box" );

      end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_chestpart", win_chestpart_func, private.room_objname );
  --------------------------------------------------------------------------------------------


  -- function vid_mineentrance_providence () end;
  --------------------------------------------------------------------------------------------  
  
  local vid_mineentrance_prv_end = function ()

    ObjSet( "gzz_mineentrance_treehole", { input = true, active = true } );
   
  end;

  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_mineentrance_providence", vid_mineentrance_prv_end, private.room_objname  );
  cmn.AddSubscriber( "vid_mineentrance_prv_end", vid_mineentrance_prv_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  local vid_mineentrance_providence_p2 = function ()

    VidStop( "vid_mineentrance_providence_p1" );
    ObjSet( "vid_mineentrance_providence_p2", { playing = true } );    

  end;   

  cmn.AddSubscriber( "vid_mineentrance_providence_p2", vid_mineentrance_providence_p2, private.room_objname );
  --------------------------------------------------------------------------------------------
  local vid_mineentrance_providence_p3 = function ()

    VidStop( "vid_mineentrance_providence_p2" );
    ObjSet( "vid_mineentrance_providence_p3", { playing = true } );

  end;   

  cmn.AddSubscriber( "vid_mineentrance_providence_p3", vid_mineentrance_providence_p3, private.room_objname );
  --------------------------------------------------------------------------------------------
  local vid_mineentrance_providence_p4 = function ()

    VidStop( "vid_mineentrance_providence_p3" );
    ObjSet( "vid_mineentrance_providence_p4", { playing = true } );    

  end;   

  cmn.AddSubscriber( "vid_mineentrance_providence_p4", vid_mineentrance_providence_p4, private.room_objname );
  --------------------------------------------------------------------------------------------
  local vid_mineentrance_providence_p5 = function ()

    VidStop( "vid_mineentrance_providence_p4" );
    VidPlay( "vid_mineentrance_providence_p5", private.vid_mineentrance_providence_end );    

  end;   

  cmn.AddSubscriber( "vid_mineentrance_providence_p5", vid_mineentrance_providence_p5, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_mineentrance_explosion () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_mineentrance_explosion" ] = {

      type = "click",
      use_place = "obj_mineentrance_clk_grm_mine",
      room = private.room_objname
  };
  local vid_mineentrance_explosion_beg = function ()

    ObjDelete( "obj_mineentrance_clk_grm_mine" );

  end;
  local vid_mineentrance_explosion_end = function ()

  ObjDelete( "obj_mineentrance_clk_enter" );
  ObjMultiSet({ 
    { "gzz_mineentrance_trailr",   { input = true, active = true }},
    { "gzz_mineentrance_collapse", { input = true, active = true }},
    { "obj_mineentrance_collaps",  { alp = 1 }},
    { "obj_mineentrance_after",    { alp = 1 }},

    { "spr_nightsville_logjam",    { alp = 1 } },
    { "spr_nightsville_stones",    { alp = 1 } },
  });

    ObjDelete( "obj_mineentrance_trailer_prev" );
    ObjDelete( "spr_mineentrance_valve"        );

  end;

  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "vid_mineentrance_explosion", vid_mineentrance_explosion_beg, private.room_objname );
  cmn.AddSubscriber( "vid_mineentrance_explosion", vid_mineentrance_explosion_end, private.room_objname  );
  cmn.AddSubscriber( "vid_mineentrance_explosion_beg", vid_mineentrance_explosion_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_mineentrance_explosion_end", vid_mineentrance_explosion_end, private.room_objname  );
  ----------------------------------------------------------------------------------------------
  -- function win_cart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_cart" ] = {

      type = "win",    
      room = private.room_objname,
      --use_place = "spr_setofdrawers_clockhands_1",
      zz_gate = "gzz_mineentrance_cart",
      zz = "zz_cart"

  };

  local win_cart = function ()

      if ( cmn.IsEventDone( "win_cart" ) ) then  
       
      else

      end;

 end;
 cmn.AddSubscriber( "win_cart", win_cart, private.room_objname );  

end;
--*********************************************************************************************************************
function public.Load()

  if ( cmn.IsEventDone( "win_intreehole" ) and not cmn.IsEventDone( "get_evidence_2_6" ) ) then
    cmn.SetEventDone( "get_evidence_2_6" );
  end;

end;
--*********************************************************************************************************************
function private.Init_Subroom()

  -------------------------------------------------------------------------------------------- 
  subroom.Define( "zz_cart" );
  subroom.Define( "zz_trailr" );
  --------------------------------------------------------------------------------------------
  function zz_cart.PreOpen()

    if ( cmn.IsEventDone( "use_chestpart" ) and not cmn.IsEventDone( "win_chestpart" )) then

      cmn.MiniGameShow( "chestpart" );
      common_impl.PassingMgStart( "chestpart" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_cart.PreClose()

    cmn.MiniGameHide( "chestpart" );
    common_impl.PassingMgStop( "chestpart" );

  end;
  --------------------------------------------------------------------------------------------
  function zz_trailr.PreOpen()

  end;
  --------------------------------------------------------------------------------------------
  function zz_trailr.PreClose()

  end;
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_mineentrance();

  int_providence_eye.CheckShow();

  if ( not cmn.IsEventDone( "vid_mineentrance_providence" ) ) then

    int_button_providence.StartLightProvidence();

  end;

  if cmn.IsEventDone( "use_crowbar_2" ) and not cmn.IsEventDone( "see_fireextinguishing" ) then

    common_impl.PlayAudio( "env", "common/audio/aud_mineentrance_fire_env", 1 );

  end;

  int_slider.InitSlider( private.room_objname );

  common_impl.EnvPlay( { "common/audio/aud_mineentrance_env" }, "", 0.5 );


end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();
  interface.InvestigationButtonCheck();

end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreClose()

  if ( not cmn.IsEventDone( "vid_mineentrance_providence" ) ) then

    int_button_providence.StopLightProvidence();

  end;

  common_impl.StopAudio( "env", "common/audio/aud_mineentrance_fire_env", 0.5 );

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_hanky()

  local item = "inv_hanky";

  if ( common.ApplyObj( item, "obj_cart_use_hanky", true ) ) then

    cmn.CallEventHandler( "use_hanky_inv" );
    cmn.CallEventHandler( "use_hanky_beg" );

    local func_after = function ()
      
      local func_end = function ()

        common_impl.Lock( false );
        cmn.SetEventDone( "use_hanky" );
        cmn.CallEventHandler( "use_hanky_end" );

        private.get_bulb();

      end;

      ObjAnimate( "anm_cart_lightbulb", "alp", 0, 0, func_end,  { 0.0, 0, 1, 0.3, 0, 0 } );
      
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_rag", 0, "", 0 );

    AnimPlay( "anm_cart_lightbulb", "DoAnim", func_after );
    
    return true;
    
  elseif common.ApplyObj( item, "gzz_mineentrance_cart", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cart", nil, { 512, 384 } );

    return true;   

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_chestpart()

  local item = "inv_chestpart";

  if ( common.ApplyObj( item, "obj_cart_use_chestpart", true ) and cmn.IsEventDone( "clk_tarpaulin" ) ) then

    cmn.CallEventHandler( "use_chestpart_inv" );
    cmn.CallEventHandler( "use_chestpart_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_chestpart" );
      cmn.CallEventHandler( "use_chestpart_end" );

      cmn.MiniGameShow("chestpart");
      common_impl.PassingMgStart( "chestpart" );
      ng_global.progress["std"]["win_chestpart"].startPosition1 = 5;
      ng_global.progress["std"]["win_chestpart"].startPosition2 = 3;
      ng_global.progress["std"]["win_chestpart"].startPosition3 = 7;
      common_impl.Lock( false );

  end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_chest_part", 0, "", 0 );

    ObjAnimate( "spr_cart_circles", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "obj_cart_mmg", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.0,
      0.6, 0, 1.0
    } );

    return true;

  elseif common.ApplyObj( item, "gzz_mineentrance_cart", false ) and cmn.IsEventDone( "clk_tarpaulin" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cart", nil, { 512, 384 } );

    return true;   

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_clippers()

  local item = "inv_clippers";

  if ( common.ApplyObj( item, "obj_cart_use_clippers", true ) ) then

    cmn.CallEventHandler( "use_clippers_inv" );
    cmn.CallEventHandler( "use_clippers_beg" );

    local func_after = function ()

      local func_end = function ()

        cmn.SetEventDone( "use_clippers" );
        cmn.CallEventHandler( "use_clippers_end" );
        private.get_chain();
        common_impl.Lock( false );

      end;

     ObjAnimate( "anm_cart_nippers", "alp", 0, 0, func_end,  { 0.0, 0, 1, 0.3, 0, 0 } );

    end; 

    common_impl.Lock( true );

    AnimPlay( "anm_cart_nippers", "DoAnim", func_after );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_nippers_chain", 0, "", 0 );
    
    return true;

  elseif common.ApplyObj( item, "gzz_mineentrance_cart", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cart", nil, { 512, 384 } );

    return true;   

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_workingflashlight()

  local item = "inv_workingflashlight";

  if ( common.ApplyObj( item, "obj_treehole_use_workingflashlight", true ) ) then

    cmn.CallEventHandler( "use_workingflashlight_inv" );
    cmn.CallEventHandler( "use_workingflashlight_beg" );

    local func_after = function ()
      
      common_impl.Lock( false );
      cmn.SetEventDone( "use_workingflashlight" );
      cmn.CallEventHandler( "use_workingflashlight_end" );
      common.CloseSubRoom();
    
    end;
    
    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_flashlight", 0, "", 0 );

    ObjAnimate( "spr_treehole_over", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.6, 0, 1.0
    } );
  
    return true;

  elseif common.ApplyObj( item, "gzz_mineentrance_treehole", false ) and cmn.IsEventDone( "vid_mineentrance_providence" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_treehole", nil, { 512, 384 } );

    return true;   

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_elf_7()

  local item = "inv_elf_2";

  if ( common.ApplyObj( item, "obj_trailr_use_elf", true ) and cmn.IsEventDone( "use_jack" ) ) then
    
    local endfunc = function ()

      cmn.SetEventDone( "use_elf_7" );
      cmn.CallEventHandler( "use_elf_7_end" );
      interface.InventoryItemAdd( "inv_elf_2", "spr_trailr_elf" );
      common_impl.Lock( false );
      ObjSet( "spr_trailr_elf", { alp = 1 } );
    end;    

    cmn.CallEventHandler( "use_elf_7_inv" );
    cmn.CallEventHandler( "use_elf_7_beg" ); 

    common_impl.Lock( true );
    interface.InventoryItemRemove( "inv_elf_2" );
    ObjSet( "vid_trailr_use_elf_7", { alp = 1, playing = true, endtrig = endfunc } );
    common_impl.PlayAudio( "sfx", "common/audio/aud_trailr_elf", 0, "", 0 );
    
    return true;

  elseif ( common.ApplyObj( item, "gzz_mineentrance_trailr", false ) and ObjGet( "gzz_mineentrance_trailr" ).input  ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_trailr", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_jack()

  local item = "inv_jack";

  if ( common.ApplyObj( item, "obj_trailr_use_jack", true ) and cmn.IsEventDone( "get_axehandle" )) then

    cmn.CallEventHandler( "use_jack_inv" );
    cmn.CallEventHandler( "use_jack_beg" );

    local func_after = function ()
      
      common_impl.Lock( false );
      cmn.SetEventDone( "use_jack" );
      cmn.CallEventHandler( "use_jack_end" );
    
    end;

    common_impl.Lock( true );

    AnimPlay( "anm_trailr_jack", "DoAnim", func_after );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_jack", 0, "", 0 );

    return true;

  elseif common.ApplyObj( item, "gzz_mineentrance_trailr", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_trailr", nil, { 512, 384 } );

    return true;   

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_crowbar_2()

  local item = "inv_crowbar";

  if ( common.ApplyObj( item, "obj_collapse_use_crowbar", true ) and cmn.IsEventDone( "use_axe" ) ) then

    cmn.CallEventHandler( "use_crowbar_2_inv" );
    cmn.CallEventHandler( "use_crowbar_2_beg" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_crowbar_2" );
      cmn.CallEventHandler( "use_crowbar_2_end" );
      common.CloseSubRoom();
      common_impl.PlayAudio( "env", "common/audio/aud_mineentrance_fire_env", 1 );
    
    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_crowbar_stones", 0, "", 0 );

    AnimPlay( "anm_collapse_scrap", "DoAnim", func_after );

    return true; 

  elseif common.ApplyObj( item, "gzz_mineentrance_collapse", false )  and cmn.IsEventDone( "use_axe" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_collapse", nil, { 512, 384 } );

    return true; 

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_axe()

  local item = "inv_axe";

  if ( common.ApplyObj( item, "obj_collapse_use_axe", true ) ) then

    cmn.CallEventHandler( "use_axe_inv" );
    cmn.CallEventHandler( "use_axe_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.SetEventDone( "use_axe" );
      cmn.CallEventHandler( "use_axe_end" );
    
    end;

    common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_axe_logs", 0, "", 0 );

    AnimPlay( "anm_collapse_axe", "DoAnim", func_after ); 

    return true; 

  elseif common.ApplyObj( item, "gzz_mineentrance_collapse", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_collapse", nil, { 512, 384 } ); 

    return true; 

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_providence_valve()

  local item = "inv_prv_valve";

  if ( ObjIntersect( item, "obj_mineentrance_providence_use_prv_item_2") and int_providence.show and cmn.IsEventDone( "clk_providence_deadbolt" ) ) then

    cmn.CallEventHandler( "use_providence_valve_inv" );
    cmn.CallEventHandler( "use_providence_valve_beg" );
    
    local func_after = function ()

      common_impl.Lock(false);
      cmn.CallEventHandler( "use_providence_valve_end" );

      if cmn.IsEventDone( "clk_providence_deadbolt" ) and cmn.IsEventDone( "clk_providence_trailer" ) and 
          cmn.IsEventDone( "use_providence_sledgehammer" ) then

          private.anim_providence( function() cmn.SetEventDone( "use_providence_valve" ); end );

      else 

        if ( cmn.IsEventDone( "clk_providence_deadbolt" ) and cmn.IsEventDone( "clk_providence_trailer" ) and             
            (cmn.IsEventDone( "use_providence_valve" ) or not cmn.IsEventDone( "get_prv_sledgehammer" ) )) then
          int_button_providence.StopActiveProvidence();
        end;
        cmn.SetEventDone( "use_providence_valve" );

      end;

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_providence_valve", 0, "", 0 );

    ObjAnimate( "spr_mineentrance_prv_valve_used", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_providence_sledgehammer()

  local item = "inv_prv_sledgehammer";

  if ( ObjIntersect( item, "obj_mineentrance_providence_use_prv_item_1" ) and int_providence.show ) then

    cmn.CallEventHandler( "use_providence_sledgehammer_inv" );
    cmn.CallEventHandler( "use_providence_sledgehammer_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.CallEventHandler( "use_providence_sledgehammer_end" );

      if cmn.IsEventDone( "clk_providence_deadbolt" ) and cmn.IsEventDone( "clk_providence_trailer" ) and 
          cmn.IsEventDone( "use_providence_valve" ) then

          private.anim_providence( function() cmn.SetEventDone( "use_providence_sledgehammer" ); end );

      else 

        if ( cmn.IsEventDone( "clk_providence_deadbolt" ) and cmn.IsEventDone( "clk_providence_trailer" ) and             
            (cmn.IsEventDone( "use_providence_sledgehammer" ) or not cmn.IsEventDone( "get_prv_valve" ) )) then
          int_button_providence.StopActiveProvidence();
        end;
        cmn.SetEventDone( "use_providence_sledgehammer" );

      end;

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_providence_hammer", 0, "", 0 );

    ObjAnimate( "spr_mineentrance_prv_sledgehammer_used", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_magnet()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_magnet" );
  cmn.CallEventHandler( "get_magnet" );
  
  if cmn.IsEventDone("get_bulb") 
     and cmn.IsEventDone("get_evidence_2_5") and cmn.IsEventDone("get_chain")
     and common_impl.IsGetCoin( "get_coin_16" ) then
     common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_prv_sledgehammer_silhouette()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );

  cmn.SetEventDone( "get_prv_sledgehammer_silhouette" );
  cmn.CallEventHandler( "get_prv_sledgehammer_silhouette" );

end;
--------------------------------------------------------------------------------------------
function private.get_prv_valve_silhouette()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );

  cmn.SetEventDone( "get_prv_valve_silhouette" );
  cmn.CallEventHandler( "get_prv_valve_silhouette" );

end;
--------------------------------------------------------------------------------------------
function private.get_evidence_2_5()

  common_impl.PlayAudio( "sfx", "common/audio/aud_evidence_open", 0, "", 0 );

  if cmn.IsEventDone("get_bulb") and cmn.IsEventDone("get_magnet") and cmn.IsEventDone("get_chain")
     and common_impl.IsGetCoin( "get_coin_16" ) then

     common.CloseSubRoom();

  end;

  local func_end = function ()

    interface.InvestigationButtonItemAdd( "evidence_2_5", "spr_cart_box" );

    cmn.SetEventDone( "get_evidence_2_5" );
    cmn.CallEventHandler( "get_evidence_2_5" );
  
  end;

  interface.DialogEvidenceShow( "evidence_2_5", func_end );

end;
--------------------------------------------------------------------------------------------
function private.get_bulb()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_bulb" );
  cmn.CallEventHandler( "get_bulb" );

  if cmn.IsEventDone("get_magnet")  
     and cmn.IsEventDone("get_evidence_2_5") and cmn.IsEventDone("get_chain")
     and common_impl.IsGetCoin( "get_coin_16" ) then
     common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_chain()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_chain" );
  cmn.CallEventHandler( "get_chain" );

  if cmn.IsEventDone("get_bulb") and cmn.IsEventDone("get_magnet")  
     and cmn.IsEventDone("get_evidence_2_5") 
      and common_impl.IsGetCoin( "get_coin_16" ) then
     common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_axehandle()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_axehandle" );
  cmn.CallEventHandler( "get_axehandle" );
  if ( cmn.IsEventDone( "get_screwdriver_2" )     and 
       cmn.IsEventDone( "get_receiverpieces" )
       and common_impl.IsGetCoin( "get_coin_17" ) ) then

      common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_screwdriver_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_screwdriver_2" );
  cmn.CallEventHandler( "get_screwdriver_2" );


  if ( cmn.IsEventDone( "get_axehandle" )     and 
       cmn.IsEventDone( "get_receiverpieces" )
       and common_impl.IsGetCoin( "get_coin_17" ) ) then

      common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_receiverpieces()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_receiverpieces" );
  cmn.CallEventHandler( "get_receiverpieces" );

  if ( cmn.IsEventDone( "get_screwdriver_2" )     and 
       cmn.IsEventDone( "get_axehandle" )
       and common_impl.IsGetCoin( "get_coin_17" )) then

      common.CloseSubRoom();

  end;


end;
--------------------------------------------------------------------------------------------
function private.get_coin16()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_16");
    cmn.CallEventHandler("get_coin_16");

    if cmn.IsEventDone("get_bulb") and cmn.IsEventDone("get_magnet")  
      and cmn.IsEventDone("get_evidence_2_5") and cmn.IsEventDone("get_chain") then
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_cart_coin", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_coin17()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_17");
    cmn.CallEventHandler("get_coin_17");

    if ( cmn.IsEventDone( "get_screwdriver_2" )     and 
         cmn.IsEventDone( "get_axehandle" ) and
         cmn.IsEventDone( "get_receiverpieces" )) then
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_trailr_coin", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_providence_trailer()

  cmn.CallEventHandler( "clk_providence_trailer_beg" );

  local func_after = function ()

    common_impl.Lock(false);

    cmn.CallEventHandler( "clk_providence_trailer_end" );

    if cmn.IsEventDone( "clk_providence_deadbolt" ) and cmn.IsEventDone( "use_providence_valve" ) 
       and cmn.IsEventDone( "use_providence_sledgehammer" ) then

      private.anim_providence( function() cmn.SetEventDone( "clk_providence_trailer" ); end );

    else 

      if ( cmn.IsEventDone( "clk_providence_deadbolt" ) and
      ( not cmn.IsEventDone( "get_prv_valve" ) or cmn.IsEventDone( "use_providence_valve" ) ) and
      ( not cmn.IsEventDone( "get_prv_sledgehammer" ) or cmn.IsEventDone( "use_providence_sledgehammer" ) ) ) then

        int_button_providence.StopActiveProvidence();

      end;

      cmn.SetEventDone( "clk_providence_trailer" );

    end;

  end;

  common_impl.Lock(true);
   

  ObjSet( "spr_mineentrance_prv_trailer", { alp = 0 } );
  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_cart", 0, "", 0 );
  ObjAnimate( "spr_mineentrance_prv_trailer_used", "alp", 0, 0, func_after, { 0, 0, 0, 0.1, 0, 0, 0.3, 0, 1 } );

end;
--------------------------------------------------------------------------------------------
function private.clk_providence_deadbolt()

  cmn.CallEventHandler( "clk_providence_deadbolt_beg" );
  
  local func_after = function ()

    common_impl.Lock(false);

    cmn.CallEventHandler( "clk_providence_deadbolt_end" );

    if cmn.IsEventDone( "clk_providence_trailer" ) and cmn.IsEventDone( "use_providence_valve" ) 
       and cmn.IsEventDone( "use_providence_sledgehammer" ) then

      private.anim_providence( function() cmn.SetEventDone( "clk_providence_deadbolt" ); end );

    else 

      if ( cmn.IsEventDone( "clk_providence_trailer" ) and
      ( not cmn.IsEventDone( "get_prv_valve" ) or cmn.IsEventDone( "use_providence_valve" ) ) and
      ( not cmn.IsEventDone( "get_prv_sledgehammer" ) or cmn.IsEventDone( "use_providence_sledgehammer" ) ) ) then

        int_button_providence.StopActiveProvidence();

      end;

      cmn.SetEventDone( "clk_providence_deadbolt" );

    end;

  end;

  common_impl.Lock(true);
  ObjSet( "spr_mineentrance_prv_deadbolt", { alp = 0 } );
  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_lock", 0, "", 0 );
  ObjAnimate( "spr_mineentrance_prv_deadbolt_used", "alp", 0, 0, func_after, { 0, 0, 0, 0.1, 0, 0, 0.3, 0, 1 } );

end;
--------------------------------------------------------------------------------------------
function private.anim_providence( func_execute )

  common_impl.ShowBbt( "bbt_providence_allitems" );

  int_button_providence.StopActiveProvidence();

  local array_objects = {
    "spr_mineentrance_prv_deadbolt_used",
    "spr_mineentrance_prv_valve_used",
    "spr_mineentrance_prv_sledgehammer_used",
    "spr_mineentrance_prv_trailer_used" }

  local func_end = function()

    for i = 1, #array_objects do
      ObjAttach( array_objects[ i ], "rm_mineentrance_providence" );
      ObjSet( array_objects[ i ], { alp = 1 } );
    end;
    common_impl.Lock( false );    
    private.vid_mineentrance_providence( func_execute );

  end;
  
  common_impl.Lock( true );
  for i = 1, #array_objects do
     common_impl.PlayEffectHO( array_objects[ i ], func_end, 3, "assets/interface/resources/effect_mask" );
     func_end = nil;
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_ready", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.clk_tarpaulin()

  cmn.CallEventHandler( "clk_tarpaulin_beg" );

  local func_after = function ()

    common_impl.Lock(false);
    cmn.SetEventDone( "clk_tarpaulin" );
    cmn.CallEventHandler( "clk_tarpaulin_end" );

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_cart_cloth", 0, "", 0 );

  common_impl.Lock(true);
  ObjAnimate( "spr_cart_tarpaulin_1", "alp", 0, 0, func_after, { 0.0, 0, 1, 0.3, 0, 0 } );
  ObjAnimate( "spr_cart_tarpaulin_2", "alp", 0, 0, "",         { 0.0, 0, 0, 0.3, 0, 1 } );
  ObjAnimate( "obj_cart_open",        "alp", 0, 0, "",         { 0.0, 0, 0, 0.3, 0, 1 } );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
-------------------------------------------------------------------------------------
function private.drag_trailer ()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_mineentrance_prv_trailer", { pos_z = 10 } );

end;
-------------------------------------------------------------------------------------
function private.drop_trailer ()

  local item = "spr_mineentrance_prv_trailer";

  ObjSet( item, { pos_z = 0 } );

  if ( ObjIntersect( item, "obj_mineentrance_prv_item_1" ) ) then

    private.clk_providence_trailer();

  end;

end;
-------------------------------------------------------------------------------------
function private.drag_deadbolt ()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_mineentrance_prv_deadbolt", { pos_z = 10 } );

end;
-------------------------------------------------------------------------------------
function private.drop_deadbolt ()

  local item = "spr_mineentrance_prv_deadbolt";

  ObjSet( item, { pos_z = 0 } );

  if ( ObjIntersect( item, "obj_mineentrance_prv_item_2" ) ) then

    private.clk_providence_deadbolt();

  end;

end;
--*********************************************************************************************************************
function private.vid_mineentrance_providence( func_execute )

  interface.BBTHide();

  private.func_providence = func_execute;

  int_button_providence.StopLightProvidence();
  
  common_impl.StopAllMus();
  common_impl.PlayAudio( "sfx", "common/audio/aud_mineentrance_providence_p1", 0, "", 0 );

  VidPlay( "vid_mineentrance_providence_p1", "" ); 
  common_impl.PlayAudio( "mus", "common/audio/aud_providence_mus", 1, "", 0.5 ); 
  interface.DialogVideoShow( "vid_mineentrance_providence", 1, function() private.vid_mineentrance_providence_end(); end , 3, 5 ); 

end;

function private.vid_mineentrance_providence_end( )
  
  common_impl.StopAudio( "sfx", "common/audio/aud_mineentrance_providence_p1", 0.2 );
  int_providence.Hide();
  interface.DialogVideoHide();
  common_impl.StopAudio( "mus", "common/audio/aud_providence_mus", 1 ); 
  common_impl.ShowBbt( 'bbt_providence_level2_2_end' );  
  common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0, "", 0 );

  local func_after = function()

    local func_end = function()

      if ( private.func_providence ) then

        private.func_providence();
        private.func_providence = nil;

      end;

      cmn.SetEventDone( "vid_mineentrance_providence" );
      cmn.CallEventHandler( "vid_mineentrance_prv_end" );
      common_impl.Lock( false );

    end;    

    common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_out", 0, "", 0 );

    ObjAnimate( private.room_objname, "scale_xy", 0, 0, "",
    { 

      0.0, 3, 1.5,1.5,
      1.0, 3, 1.0,1.0

    } );
    
    ObjAnimate( private.room_objname, "pos_x", 0, 0, func_end,
    { 
      0.0, 3,  -596,
      1.0, 3,  0

    } );

  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_in", 0, "", 0 );
  ObjAnimate( private.room_objname, "scale_xy", 0, 0, "",
  { 
    0.0, 1, 1.0,1.0, 
    1.0, 1, 1.5,1.5,
    1.4, 3, 1.5,1.5,

  } );
  
  ObjAnimate( private.room_objname, "pos_x", 0, 0, func_after,
  { 
    0.0, 1,  0,
    1.0, 1,  -596,
    1.4, 3,  -596,

  } );
  
end;
--*********************************************************************************************************************
function private.vid_mineentrance_explosion()

  cmn.CallEventHandler( "vid_mineentrance_explosion_beg" );
  
  local func_after = function ( skip )

    common_impl.ShowBbt( 'bbt_mineentrance_explosion' );

    interface.DialogVideoHide();    
    cmn.SetEventDone( "vid_mineentrance_explosion" );
    cmn.CallEventHandler( "vid_mineentrance_explosion_end" );
    common_impl.PlayAudio( "mus", "common/audio/aud_scary_mus", 0, "", 0 );
    
    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_mineentrance_explosion", 0.5 );

    end;
  
  end;
  
  common_impl.StopAllMus();
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mineentrance_explosion", 0, "", 0 );
  interface.DialogVideoShow( "vid_mineentrance_explosion", 1, function() func_after( 'skip' ) end, 3 );
  --common_impl.PlayAudio( "sfx", "common/audio/aud_area_oulmen", 0, "", 0.5 );
  VidPlay( "vid_mineentrance_explosion", function() func_after( nil ) end ); 

end;

--*********************************************************************************************************************
function private.opn_mineentrance()

  if not ( cmn.IsEventDone( "opn_mineentrance" ) ) then
    cmn.SetEventDone( "opn_mineentrance" );
    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment3_mus", 0, "", 0 );
  end;
    cmn.CallEventHandler( "opn_mineentrance" ); 

end;

--*********************************************************************************************************************
--******************** MMG ********************************************************************************************
--*********************************************************************************************************************
------------------------------------------------------------------------------------------
function private.win_chestpart ()

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_chest_win", 0, "", 0 );

  cmn.MiniGameHide( "chestpart" );
  cmn.SetEventDone( "win_chestpart" );
  cmn.CallEventHandler( "win_chestpart" );
  common_impl.PassingMgWin( "chestpart" );
 
end;
------------------------------------------------------------------------------------------
function private.changePosition2()

  local func_after = function ()
  
    common_impl.Lock(false);
    ng_global.progress["std"]["win_chestpart"].startPosition2 = ng_global.progress["std"]["win_chestpart"].startPosition2 + 1;
    
    if (ng_global.progress["std"]["win_chestpart"].startPosition2 == 9) then
        ng_global.progress["std"]["win_chestpart"].startPosition2 = 1 ;
        ObjSet("spr_cart_circles_2", {ang = 0});
    end; 

    private.checkPosition();

  end;

  common_impl.Lock(true);

  local nowPosition = ng_global.progress["std"]["win_chestpart"].startPosition2;
  local start  = ObjGet("spr_cart_circles_2").ang;
  local finish = private.angPositions2[nowPosition+1];

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_chest_click", 0, "", 0 );

  ObjAnimate( "spr_cart_circles_2", "ang", 0, 0, func_after,
  { 
    0.0, 0, start, 
    0.3, 0, finish,
  } );

end;
------------------------------------------------------------------------------------------
function private.changePosition1()

  local func_after = function ()
  
    common_impl.Lock(false);
    ng_global.progress["std"]["win_chestpart"].startPosition1 = ng_global.progress["std"]["win_chestpart"].startPosition1 + 1;
    
    if (ng_global.progress["std"]["win_chestpart"].startPosition1 == 9) then
        ng_global.progress["std"]["win_chestpart"].startPosition1 = 1 ;
        ObjSet("spr_cart_circles_1", {ang = 0});
    end; 

    private.checkPosition();

  end;

  common_impl.Lock(true);
  local nowPosition = ng_global.progress["std"]["win_chestpart"].startPosition1;
  local start  = ObjGet("spr_cart_circles_1").ang;
  local finish = private.angPositions1[nowPosition+1]

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_chest_click", 0, "", 0 );

  ObjAnimate( "spr_cart_circles_1", "ang", 0, 0, func_after,
  { 
    0.0, 0, start, 
    0.3, 0, finish,
  } );

end;
------------------------------------------------------------------------------------------
function private.changePosition3()

  local func_after = function ()
  
    common_impl.Lock(false);
    ng_global.progress["std"]["win_chestpart"].startPosition3 = ng_global.progress["std"]["win_chestpart"].startPosition3 + 1;
    
    if (ng_global.progress["std"]["win_chestpart"].startPosition3 == 9) then
        ng_global.progress["std"]["win_chestpart"].startPosition3 = 1 ;
        ObjSet("spr_cart_circles_3", {ang = 0});
    end; 

    private.checkPosition();

  end;

  common_impl.Lock(true);
  local nowPosition = ng_global.progress["std"]["win_chestpart"].startPosition3;
  local start  = ObjGet("spr_cart_circles_3").ang;
  local finish = private.angPositions3[nowPosition+1]

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_chest_click", 0, "", 0 );

  ObjAnimate( "spr_cart_circles_3", "ang", 0, 0, func_after,
  { 
    0.0, 0, start, 
    0.3, 0, finish,
  } );

end;
------------------------------------------------------------------------------------------
function private.checkPosition()

  local func_after = function ()

    private.win_chestpart();
    common_impl.Lock(false);

  end;

  if (ng_global.progress["std"]["win_chestpart"].startPosition2 == 9 or
      ng_global.progress["std"]["win_chestpart"].startPosition2 == 1) and

      (ng_global.progress["std"]["win_chestpart"].startPosition1 == 9 or
      ng_global.progress["std"]["win_chestpart"].startPosition1 == 1) and

      (ng_global.progress["std"]["win_chestpart"].startPosition3 == 9 or
      ng_global.progress["std"]["win_chestpart"].startPosition3 == 1) then
      
      common_impl.Lock(true);
      ObjAnimate( "obj_cart_mmg", "alp", 0, 0, func_after,  { 0.0, 0, 1, 0.6, 0, 1, 0.9, 0, 0 } );

  end;

end;
------------------------------------------------------------------------------------------
function private.clk_trailr()

  local func_after = function ()

    common_impl.Lock( false );
    common_impl.ShowBbt( 'bbt_trailr_use_jack' );

  end;

  common_impl.Lock( true );
 
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_big_metal", 0, "", 0 );

  ObjAnimate( "obj_trailr_body", "pos_y", 0, 0, func_after, { 0,3,-1, 0.2,3,-3, 0.4,3,-1 } );

end;
------------------------------------------------------------------------------------------
function public.Skip( event )

  local func_after = function ()

    common_impl.Lock(false);
    ng_global.progress["std"]["win_chestpart"].startPosition1 = 1;
    ng_global.progress["std"]["win_chestpart"].startPosition2 = 1;
    ng_global.progress["std"]["win_chestpart"].startPosition3 = 1;
    private.checkPosition();

  end;

  common_impl.Lock(true);

  local start1  = ObjGet("spr_cart_circles_1").ang;
  local finish1 = private.angPositions1[1];

  local start2  = ObjGet("spr_cart_circles_2").ang;
  local finish2 = private.angPositions2[1];

  local start3  = ObjGet("spr_cart_circles_3").ang;
  local finish3 = private.angPositions3[1];

  ObjAnimate( "spr_cart_circles_1", "ang", 0, 0, func_after,
  { 
    0.0, 0, start1, 
    0.3, 0, finish1,
  } );

  ObjAnimate( "spr_cart_circles_2", "ang", 0, 0, "",
  { 
    0.0, 0, start2, 
    0.3, 0, finish2,
  } );


  ObjAnimate( "spr_cart_circles_3", "ang", 0, 0, "",
  { 
    0.0, 0, start3, 
    0.3, 0, finish3,
  } );

end;
------------------------------------------------------------------------------------------
function public.Reset( event )

  local func_after = function ()

    common_impl.Lock(false);

    ng_global.progress["std"]["win_chestpart"].startPosition1 = 5;
    ng_global.progress["std"]["win_chestpart"].startPosition2 = 3;
    ng_global.progress["std"]["win_chestpart"].startPosition3 = 7;

    private.checkPosition();

  end;

  common_impl.Lock(true);

  local start1  = ObjGet("spr_cart_circles_1").ang;
  local finish1 = private.angPositions1[5];

  local start2  = ObjGet("spr_cart_circles_2").ang;
  local finish2 = private.angPositions2[3];

  local start3  = ObjGet("spr_cart_circles_3").ang;
  local finish3 = private.angPositions3[7];

  ObjAnimate( "spr_cart_circles_1", "ang", 0, 0, func_after,
  { 
    0.0, 0, start1, 
    0.3, 0, finish1,
  } );
  ObjAnimate( "spr_cart_circles_2", "ang", 0, 0, "",
  { 
    0.0, 0, start2, 
    0.3, 0, finish2,
  } );
  ObjAnimate( "spr_cart_circles_3", "ang", 0, 0, "",
  { 
    0.0, 0, start3, 
    0.3, 0, finish3,
  } );

end;
------------------------------------------------------------------------------------------
------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function private.RadioAddLight()

  ObjAnimate( "spr_trailr_radio_1_add", "alp", 1, 0, "",
  { 
    --0.0, 0, 1.0, 
    --0.3, 0, 0.7,
    --0.6, 0, 1.0,
    0.0, 0, 1.0, 
    0.3, 0, 0.8,
    0.6, 0, 0.6,
    0.9, 0, 0.8,
    1.2, 0, 1.0,
  } );

end;
--*********************************************************************************************************************