-- name=rm_nightsville
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_nightsville";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_pavement", "room_hub" );
  ObjAttach( "zz_fireequipment", "room_hub" );
  ObjAttach( "zz_workshop", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_pavement_axe", { event_mdown = private.get_axeblade }},
    { "spr_pavement_hanky", { event_mdown = private.get_hanky }},
    { "spr_pavement_prv_valve", { event_mdown = private.get_prv_valve }},
    { "spr_fireequipment_crowbar", { event_mdown = private.get_crowbar }},
    { "spr_fireequipment_prv_sledgehammer", { event_mdown = private.get_prv_sledgehammer }},
    { "spr_fireequipment_chestpart", { event_mdown = private.get_chestpart }},
    { "spr_fireequipment_brokenkey", { event_mdown = private.get_brokenkey }},
    { "spr_workshop_tweezers", { event_mdown = private.get_tweezers }},
    { "obj_dlg_nightsville_steward", { event_mdown = private.dlg_nightsville_steward }},
    { "obj_dlg_nightsville_steward_focus", { event_mdown = private.dlg_nightsville_steward }},
    { "obj_pavement_clk_trash", { event_mdown = private.clk_trash }},
    { "obj_pavement_clk_trash_2", { event_mdown = private.clk_trash_2 }},
    { "obj_fireequipment_use_magnet",{ event_mdown = function() common_impl.ShowBbt( 'bbt_fireequipment_use_magnet' ); end }},
    { "obj_pavement_use_magnet",{ event_mdown = private.AnmCrab }},
    { "obj_fireequipment_clk_key",{ event_mdown = private.clk_hydrantwrench }},
    { "obj_dlg_nightsville_suspicion",   { event_mdown = private.dlg_nightsville_suspicion }},
    { "obj_dlg_nightsville_suspicion_focus",   { event_mdown = private.dlg_nightsville_suspicion }},
    { "obj_fireequipment_use_hydrantwrench" ,{ event_mdown = function() common_impl.ShowBbt( 'bbt_fireequipment_use_hydrantwrench' ); private.DoorAnimation() end }},
    { "spr_fireequipment_coin",          { event_mdown = private.get_coin14 } },
    { "spr_pavement_coin",          { event_mdown = private.get_coin15 } },
    { "spr_nightsville_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
 
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_nightsville = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_nightsville_workshop",
    "gzz_nightsville_fireequipment",
    "gzz_nightsville_pavement",
    "gmg_nightsville_key"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_pavement",
      "zz_storage",
      "zz_workshop"
    
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_nightsville", update_game_mode_nightsville, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_nightsville = function ()

  local effects_table = 
  {
    "anm_nightsville_light",
    "anm_nightsville_characters",
    "anm_pavern_grass",
    "obj_workshop_anims"
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_nightsville", update_performance_mode_nightsville, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_nightsville () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_nightsville" ] = {
    type = "click",
    use_place = "grm_nightsvilleentrance_nightsville",
    room = "rm_nightsvilleentrance"
  };

  local opn_nightsville_map = function ()

    common_impl.VisitMapRoom( "nightsville" );

  end;
  cmn.AddSubscriber( "opn_nightsville", opn_nightsville_map, nil );
  
  --------------------------------------------------------------------------------------------
  -- function get_axeblade () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_axeblade" ] = {
    type = "get",
    get_obj = "spr_pavement_axe",
    room = private.room_objname,
    zz = "zz_pavement",
    zz_gate = "gzz_nightsville_pavement"
  };
    
  local get_axeblade_inv = function ()
  
    interface.InventoryItemAdd( "inv_axeblade", "spr_pavement_axe" );
    ObjSet( "inv_axeblade", { drag = false });
    if ( not cmn.IsEventDone( "get_axehandle" ) ) then
      ObjSet( "spr_axeblade_plus_light", { visible = false } );
    end; 
  
  end;
  
  local get_axeblade_closezz = function ()

    ObjDelete( "gfx_pavement_axe" );
    ObjDelete( "spr_nightsville_pavement_ax" );
    ObjDelete( "spr_pavement_ax_shadow" );
    ObjSet( "spr_pavement_hanky", { input = true, visible = true } );
  
  end;
  
  cmn.AddSubscriber( "get_axeblade", get_axeblade_inv );
  cmn.AddSubscriber( "get_axeblade", get_axeblade_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hanky () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hanky" ] = {
    type = "get",
    get_obj = "spr_pavement_hanky",
    room = private.room_objname,
    zz = "zz_pavement",
    zz_gate = "gzz_nightsville_pavement"
  };
    
  local get_hanky_inv = function ()
  
    interface.InventoryItemAdd( "inv_hanky", "spr_pavement_hanky" );
  
  end;
  
  local get_hanky_closezz = function ()
  
    ObjDelete( "gfx_pavement_hanky" );
    ObjDelete( "spr_nightsville_pavement_shawl" );
    ObjDelete( "spr_pavement_hanky_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_hanky", get_hanky_inv );
  cmn.AddSubscriber( "get_hanky", get_hanky_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_prv_valve () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_prv_valve" ] = {
    type = "get",
    get_obj = "spr_pavement_prv_valve",
    room = private.room_objname,
    zz = "zz_pavement",
    zz_gate = "gzz_nightsville_pavement"
  };
    
  local get_prv_valve_inv = function ()

    interface.ProvidePanelItemAdd( "inv_prv_valve", "spr_pavement_prv_valve" );

  end;
  
  local get_prv_valve_closezz = function ()
  
    if ( common_impl.IsGetCoin( "get_coin_15" ) ) then
      ObjDelete( "gzz_nightsville_pavement" );
    end;
    ObjDelete( "gfx_pavement_prv_valve" );
  
  end;
  
  cmn.AddSubscriber( "get_prv_valve", get_prv_valve_inv );
  cmn.AddSubscriber( "get_prv_valve", get_prv_valve_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_evidence_2_4 () end;
  --------------------------------------------------------------------------------------------
  local get_evidence_2_4 = function ()
  
   
  end;
    
  cmn.AddSubscriber( "get_evidence_2_4", get_evidence_2_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_3 = function ()
  
    ObjDelete( "obj_nightsville_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_3", get_collect_morph_item_2_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_crowbar () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crowbar" ] = {
    type = "get",
    get_obj = "spr_fireequipment_crowbar",
    room = private.room_objname,
    zz = "zz_fireequipment",
    zz_gate = "gzz_nightsville_fireequipment"
  };
    
  local get_crowbar_inv = function ()
  
    interface.InventoryItemAdd( "inv_crowbar", "spr_fireequipment_crowbar" );
  
  end;
  
  local get_crowbar_closezz = function ()
  
    ObjDelete( "gfx_fireequipment_crowbar" );
    ObjDelete( "spr_fireequipment_crowbar_shadow" );

    ObjDelete( "spr_nightsville_fireequipment_scrap" );

    if ( cmn.IsEventDone("get_brokenkey") and cmn.IsEventDone("get_chestpart") 
    and cmn.IsEventDone("get_prv_sledgehammer") and common_impl.IsGetCoin( "get_coin_14" ) ) then
      ObjDelete( "gzz_nightsville_fireequipment" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_crowbar", get_crowbar_inv );
  cmn.AddSubscriber( "get_crowbar", get_crowbar_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_prv_sledgehammer () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_prv_sledgehammer" ] = {
    type = "get",
    get_obj = "spr_fireequipment_prv_sledgehammer",
    room = private.room_objname,
    zz = "zz_fireequipment",
    zz_gate = "gzz_nightsville_fireequipment"
  };
    
  local get_prv_sledgehammer_inv = function ()
      
    interface.ProvidePanelItemAdd( "inv_prv_sledgehammer", "spr_fireequipment_prv_sledgehammer" );
  
  end;
  
  local get_prv_sledgehammer_closezz = function ()
  
    ObjDelete( "gfx_fireequipment_prv_sledgehammer" );
    ObjDelete( "spr_fireequipment_prv_sledgehammer_shadow" );

    ObjDelete( "spr_nightsville_fireequipment_hammer" );

    if ( cmn.IsEventDone("get_brokenkey") and cmn.IsEventDone("get_chestpart") 
    and cmn.IsEventDone("get_crowbar")  and common_impl.IsGetCoin( "get_coin_14" ) ) then
      ObjDelete( "gzz_nightsville_fireequipment" );
    end
  
  end;
  
  cmn.AddSubscriber( "get_prv_sledgehammer", get_prv_sledgehammer_inv );
  cmn.AddSubscriber( "get_prv_sledgehammer", get_prv_sledgehammer_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chestpart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chestpart" ] = {
    type = "get",
    get_obj = "spr_fireequipment_chestpart",
    room = private.room_objname,
    zz = "zz_fireequipment",
    zz_gate = "gzz_nightsville_fireequipment"
  };
    
  local get_chestpart_inv = function ()
  
    interface.InventoryItemAdd( "inv_chestpart", "spr_fireequipment_chestpart" );
  
  end;
  
  local get_chestpart_closezz = function ()
  
    ObjDelete( "gfx_fireequipment_chestpart" );
    ObjDelete( "spr_fireequipment_chestpart_shadow" );

    ObjDelete( "spr_nightsville_fireequipment_box" );

    if ( cmn.IsEventDone("get_prv_sledgehammer") and cmn.IsEventDone("get_brokenkey") 
    and cmn.IsEventDone("get_crowbar") and common_impl.IsGetCoin( "get_coin_14" ) ) then
      ObjDelete( "gzz_nightsville_fireequipment" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_chestpart", get_chestpart_inv );
  cmn.AddSubscriber( "get_chestpart", get_chestpart_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokenkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokenkey" ] = {
    type = "get",
    get_obj = "spr_fireequipment_brokenkey",
    room = private.room_objname,
    zz = "zz_fireequipment",
    zz_gate = "gzz_nightsville_fireequipment"
  };
    
  local get_brokenkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_brokenkey", "spr_fireequipment_brokenkey" );
  
  end;
  
  local get_brokenkey_closezz = function ()
  
    ObjDelete( "gfx_fireequipment_brokenkey" );
    ObjDelete( "spr_fireequipment_brokenkey_shadow" );

    if ( cmn.IsEventDone("get_prv_sledgehammer") and cmn.IsEventDone("get_chestpart") 
    and cmn.IsEventDone("get_crowbar") and common_impl.IsGetCoin( "get_coin_14" ) ) then
      ObjDelete( "gzz_nightsville_fireequipment" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_brokenkey", get_brokenkey_inv );
  cmn.AddSubscriber( "get_brokenkey", get_brokenkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tweezers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tweezers" ] = {
    type = "get",
    get_obj = "spr_workshop_tweezers",
    room = private.room_objname,
    zz = "zz_workshop",
    zz_gate = "gzz_nightsville_workshop"
  };
    
  local get_tweezers_inv = function ()
  
    interface.InventoryItemAdd( "inv_tweezers", "spr_workshop_tweezers" );
    ObjSet( "spr_receiverpieces_plus_light", { visible = true } );
  
  end;
  
  local get_tweezers_closezz = function ()
  
    ObjDelete( "spr_workshop_tweezers_shadow" );
    ObjDelete( "gfx_workshop_tweezers" );

    ObjDelete( "spr_nightsville_workshop_tongs" );

    if ( cmn.IsEventDone( "use_brokenkey" ) ) then
      ObjDelete( "gzz_nightsville_workshop" );
      ObjSet( "gmg_nightsville_key", { active = true, input = true });
    end;
  
  end;
  
  cmn.AddSubscriber( "get_tweezers", get_tweezers_inv );
  cmn.AddSubscriber( "get_tweezers", get_tweezers_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coins () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_14 = function ()
 
    ObjDelete( "obj_fireequipment_coin" );

    if ( cmn.IsEventDone("get_prv_sledgehammer") and cmn.IsEventDone("get_chestpart") 
    and cmn.IsEventDone("get_crowbar") and cmn.IsEventDone("get_brokenkey") ) then    
      ObjDelete( "gzz_nightsville_fireequipment" );
    end;
    
  end;
  cmn.AddSubscriber( "get_coin_14", get_collect_coin_14, private.room_objname );
  --------------------------------------------------------------------------------------------
  local get_collect_coin_15 = function ()
 
    ObjDelete( "obj_pavement_coin" );

    if ( cmn.IsEventDone("get_prv_valve") ) then    
      ObjDelete( "gzz_nightsville_pavement" );
    end;
    
  end;
  cmn.AddSubscriber( "get_coin_15", get_collect_coin_15, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_trash () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_trash" ] = {
    type = "click",
    use_place = "spr_pavement_mining_trash_2",
    room = private.room_objname,
    zz = "zz_pavement",
    zz_gate = "gzz_nightsville_pavement"
  };

  local clk_trash = function ()
  
    ObjDelete( "spr_pavement_mining_trash_2" );
    ObjSet( "obj_pavement_clk_trash_2", { input = 1 } );
    ObjDelete( "obj_pavement_clk_trash" );

  end;

  cmn.AddSubscriber( "clk_trash", clk_trash, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_trash_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_trash_2" ] = {
    type = "click",
    use_place = "spr_pavement_mining_trash",
    room = private.room_objname,
    zz = "zz_pavement",
    zz_gate = "gzz_nightsville_pavement"
  };

  local clk_trash = function ()
  
    ObjDelete( "spr_pavement_mining_trash" );
    ObjDelete( "obj_pavement_clk_trash_2" );

    ObjDelete( "spr_nightsville_pavement_things" );

    ObjSet( "gfx_pavement_axe", { active = true } );
    ObjSet( "spr_pavement_axe", { input = true, visible = true } );

  end;

  cmn.AddSubscriber( "clk_trash_2", clk_trash, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crowbar_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_crowbar_1" ] = {
    type = "use",
    inv_obj = "inv_crowbar",
    use_place = "obj_pavement_use_crowbar",
    room = private.room_objname,
    zz = "zz_pavement",
    zz_gate = "gzz_nightsville_pavement"
  };
  local use_crowbar_1_inv = function ()
  
    --interface.InventoryItemRemove( "inv_crowbar" );
  
  end;
  local use_crowbar_1_beg = function ()
  
    ObjDelete( "obj_pavement_use_crowbar" );
  
  end;
  local use_crowbar_1_end = function ()
  
    ObjDelete( "spr_pavement_board_1" );
    ObjDelete( "anm_pavement_crowbar" );

    ObjMultiSet({ 
      { "spr_pavement_board_2",    { alp = 1 }},
      { "obj_pavement_use_magnet", { input = true }},

      { "spr_nightsville_pavement_board" , { alp = 1 }},
      { "spr_nightsville_pavement_valve" , { alp = 1 }},

    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crowbar_1", use_crowbar_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_1", use_crowbar_1_inv );
  cmn.AddSubscriber( "use_crowbar_1", use_crowbar_1_end, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_1_inv", use_crowbar_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_1_beg", use_crowbar_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_1_end", use_crowbar_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magnet_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_magnet_2" ] = {
    type = "use",
    inv_obj = "inv_magnet",
    use_place = "obj_pavement_use_magnet",
    room = private.room_objname,
    zz = "zz_pavement",
    zz_gate = "gzz_nightsville_pavement"
  };
  local use_magnet_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_magnet" );
  
  end;
  local use_magnet_2_beg = function ()
  
    ObjDelete( "obj_pavement_use_magnet" );
  
  end;
  local use_magnet_2_end = function ()
  
    ObjSet( "spr_pavement_prv_valve", { input = true, visible = true, active = true } );
    ObjDelete( "anm_pavement_magnet" );
    ObjDelete( "spr_nightsville_pavement_valve" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magnet_2", use_magnet_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_2", use_magnet_2_inv );
  cmn.AddSubscriber( "use_magnet_2", use_magnet_2_end, private.room_objname );
  cmn.AddSubscriber( "use_magnet_2_inv", use_magnet_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_magnet_2_beg", use_magnet_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_2_end", use_magnet_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magnet_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_magnet_1" ] = {
    type = "use",
    inv_obj = "inv_magnet",
    use_place = "obj_fireequipment_use_magnet",
    room = private.room_objname,
    zz = "zz_fireequipment",
    zz_gate = "gzz_nightsville_fireequipment"
  };
  local use_magnet_1_beg = function ()
  
    ObjDelete( "obj_fireequipment_use_magnet" );
  
  end;
  local use_magnet_1_end = function ()
  
    ObjDelete( "spr_fireequipment_magnit" );
    ObjDelete( "spr_nightsville_fireequipment_key" );    

    ObjSet( "obj_fireequipment_use_hydrantwrench", { input = true, visible = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magnet_1", use_magnet_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_1", use_magnet_1_end, private.room_objname );
  cmn.AddSubscriber( "use_magnet_1_beg", use_magnet_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_magnet_1_end", use_magnet_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hydrantwrench () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hydrantwrench" ] = {
    type = "use",
    inv_obj = "inv_hydrantwrench",
    use_place = "obj_fireequipment_use_hydrantwrench",
    room = private.room_objname,
    zz = "zz_fireequipment",
    zz_gate = "gzz_nightsville_fireequipment"
  };
  local use_hydrantwrench_inv = function ()
  
    interface.InventoryItemRemove( "inv_hydrantwrench" );
  
  end;
  local use_hydrantwrench_beg = function ()
  
    ObjDelete( "obj_fireequipment_use_hydrantwrench" );
  
  end;
  local use_hydrantwrench_end = function ()
  
    ObjMultiSet({ 
      { "obj_fireequipment_clk_key", { input = true } },
      { "obj_fireequipment_key_2", { alp = 1 } }
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hydrantwrench", use_hydrantwrench_beg, private.room_objname );
  cmn.AddSubscriber( "use_hydrantwrench", use_hydrantwrench_inv );
  cmn.AddSubscriber( "use_hydrantwrench", use_hydrantwrench_end, private.room_objname );
  cmn.AddSubscriber( "use_hydrantwrench_inv", use_hydrantwrench_inv, private.room_objname );
  cmn.AddSubscriber( "use_hydrantwrench_beg", use_hydrantwrench_beg, private.room_objname );
  cmn.AddSubscriber( "use_hydrantwrench_end", use_hydrantwrench_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_hydrantwrench () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_hydrantwrench" ] = {
    type = "click",
    use_place = "obj_fireequipment_clk_key",
    room = private.room_objname,
    zz = "zz_fireequipment",
    zz_gate = "gzz_nightsville_fireequipment"
  };

  local clk_hydrantwrench_beg = function ()
  
    ObjDelete( "obj_fireequipment_clk_key" );
  
  end;
  local clk_hydrantwrench_end = function ()
  
    ObjDelete( "spr_fireequipment_door_closed" );
    ObjDelete( "obj_fireequipment_key_2" );
    ObjDelete( "obj_fireequipment_key_3" );
    ObjDelete( "spr_fireequipment_override_3" );

    ObjMultiSet( { 
      { "obj_fireequipment_prv_sledgehammer", { input = true, active = true }},
      { "obj_fireequipment_chestpart", { input = true, active = true }},
      { "obj_fireequipment_crowbar", { input = true, active = true }},
      { "spr_fireequipment_door_open", { alp = 1 }},

      { "spr_nightsville_fireequipment_openfire_shield", { alp = 1 } },
      { "spr_nightsville_fireequipment_hammer",          { alp = 1 } },
      { "spr_nightsville_fireequipment_scrap",           { alp = 1 } },
      { "spr_nightsville_fireequipment_box",             { alp = 1 } },
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_hydrantwrench", clk_hydrantwrench_beg, private.room_objname );
  cmn.AddSubscriber( "clk_hydrantwrench", clk_hydrantwrench_end, private.room_objname );
  cmn.AddSubscriber( "clk_hydrantwrench_beg", clk_hydrantwrench_beg, private.room_objname );
  cmn.AddSubscriber( "clk_hydrantwrench_end", clk_hydrantwrench_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_brokenkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_brokenkey" ] = {
    type = "use",
    inv_obj = "inv_brokenkey",
    use_place = "obj_workshop_use_brokenkey",
    room = private.room_objname,
    zz = "zz_workshop",
    zz_gate = "gzz_nightsville_workshop"
  };
  local use_brokenkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_brokenkey" );
  
  end;
  local use_brokenkey_beg = function ()
  
    ObjDelete( "obj_workshop_use_brokenkey" );
  
  end;
  local use_brokenkey_end = function ()
  
    if ( cmn.IsEventDone( "get_tweezers" ) ) then
      ObjDelete( "gzz_nightsville_workshop" );
      ObjSet( "gmg_nightsville_key", { active = true, input = true });
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_brokenkey", use_brokenkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_brokenkey", use_brokenkey_inv );
  cmn.AddSubscriber( "use_brokenkey", use_brokenkey_end, private.room_objname );
  cmn.AddSubscriber( "use_brokenkey_inv", use_brokenkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_brokenkey_beg", use_brokenkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_brokenkey_end", use_brokenkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_nightsville_attack () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_nightsville_attack" ] = {

      type = "click",
      use_place = "obj_vid_nightsville_attack",
      room = private.room_objname
  };
  local vid_nightsville_attack_beg = function ()

    ObjDelete( "obj_vid_nightsville_attack" );

  end;
  local vid_nightsville_attack_end = function ()

    ObjSet( "obj_dlg_nightsville_steward", { input = true } );
    ObjSet( "obj_nightsville_characters", { alp = 1 } );

  end;

  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "vid_nightsville_attack", vid_nightsville_attack_beg, private.room_objname );
  cmn.AddSubscriber( "vid_nightsville_attack", vid_nightsville_attack_end, private.room_objname  );
  cmn.AddSubscriber( "vid_nightsville_attack_beg", vid_nightsville_attack_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_nightsville_attack_end", vid_nightsville_attack_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function dlg_nightsville_steward () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_nightsville_steward" ] = {

      type = "click",
      use_place = "obj_dlg_nightsville_steward_focus",
      room = private.room_objname
  };

  local dlg_nightsville_steward_end = function ()

    ObjDelete( "obj_dlg_nightsville_steward" );
    ObjDelete( "anm_nightsvilleentrance_child" );
    ObjSet( "grm_nightsville_mineentrance", { active = true, input = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_nightsville_mineentrance_focus");
    end;
    common_impl.Collectibles2_unlock_crs( "Bernadette_Collins" );

 end;
 --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_nightsville_steward", dlg_nightsville_steward_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_nightsville_steward_end", dlg_nightsville_steward_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function vid_evidence_5 () end;
  --------------------------------------------------------------------------------------------
  local vid_evidence_5 = function ()

    ObjMultiSet({
     { "obj_dlg_nightsville_suspicion", { input = true } },
    });

  end;    
  cmn.AddSubscriber( "vid_evidence_5", vid_evidence_5, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function dlg_nightsville_suspicion () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_nightsville_suspicion" ] = {

      type = "click",
      use_place = "obj_dlg_nightsville_suspicion_focus",
      room = private.room_objname
  };

  local dlg_nightsville_suspicion_end = function ()

    ObjDelete( "obj_dlg_nightsville_suspicion" );
    ObjDelete( "anm_nightsville_suspicion" );
    ObjSet( "obj_mineentrance_clk_grm_mine", { input = true } );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_nightsville_suspicion", dlg_nightsville_suspicion_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_nightsville_suspicion_end", dlg_nightsville_suspicion_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_nightsville_suspicion", dlg_nightsville_suspicion_end, "rm_mineentrance"  );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_nightsville();

  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

  if ( cmn.IsEventDone( "dlg_nightsville_steward" ) and ( not cmn.IsEventDone( "get_evidence_2_4" ) ) ) then

    interface.DialogEvidenceShow( "evidence_2_4_progress", func_end );

  end; 

end;
--*********************************************************************************************************************
function public.PreOpen()

  interface.InvestigationButtonCheck();
  
  common_impl.MorphItemMorphing(); 

  if not cmn.IsEventDone( "vid_nightsville_attack" ) then

     public.vid_nightsville_attack();

  elseif cmn.IsEventDone( "vid_nightsville_attack" ) and not cmn.IsEventDone( "dlg_nightsville_steward" ) then

     private.dlg_nightsville_steward();

  end;

  common_impl.EnvPlay( { "common/audio/aud_nightsville_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_crowbar_1()

  local item = "inv_crowbar";

  if ( common.ApplyObj( item, "obj_pavement_use_crowbar", true ) ) then

    cmn.CallEventHandler( "use_crowbar_1_inv" );
    cmn.CallEventHandler( "use_crowbar_1_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_crowbar_1" );
      cmn.CallEventHandler( "use_crowbar_1_end" );    
      common_impl.Lock( false );

    end;

    ObjSet( "spr_pavement_board_1", { visible = false } );
    ObjSet( "anm_pavement_crowbar", { visible = true } );
    
    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_crowbar", 0, "", 0 );

    AnimPlay( "anm_pavement_crowbar", "DoAnim", func_after );
    
    return true;

  elseif common.ApplyObj( item, "gzz_nightsville_pavement", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pavement", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_magnet_2()

  local item = "inv_magnet";

  if ( common.ApplyObj( item, "obj_pavement_use_magnet", true ) ) and cmn.IsEventDone( "use_crowbar_1" ) then

    cmn.CallEventHandler( "use_magnet_2_inv" );
    cmn.CallEventHandler( "use_magnet_2_beg" );

    local func_after = function ()
      
      cmn.SetEventDone( "use_magnet_2" );
      cmn.CallEventHandler( "use_magnet_2_end" ); 
      private.get_prv_valve();
      common_impl.Lock( false );

    end;  

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_magnet_valve", 0, "", 0 );

    ObjSet( "anm_pavement_magnet", { visible = true } );
    ObjSet( "spr_pavement_prv_valve", { visible = false } );
    AnimPlay( "anm_pavement_magnet", "DoAnim", func_after );

    return true;

  elseif common.ApplyObj( item, "gzz_nightsville_pavement", false ) and cmn.IsEventDone( "use_crowbar_1" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pavement", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_magnet_1()

  local item = "inv_magnet";

  if ( common.ApplyObj( item, "obj_fireequipment_use_magnet", true ) )  then

    interface.InventoryItemRemove( "inv_magnet" );
    cmn.CallEventHandler( "use_magnet_1_beg" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_magnet_1" );
      cmn.CallEventHandler( "use_magnet_1_end" );
      interface.InventoryItemAdd( "inv_magnet" );
      private.get_brokenkey();

    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_magnet_key", 0, "", 0 );

    ObjAnimate( "spr_fireequipment_magnit", "pos_xy", 0, 0, "",
    { 
      0.0, 0, 340, 84, 
      0.5, 0, -9, 154,
      0.8, 0, -9, 154,
      1.3, 0, 340, 84
    } );

    ObjSet( "obj_fireequipment_brokenkey", { active = true });
    ObjAnimate( "spr_fireequipment_brokenkey", "pos_xy", 0, 0, func_after,
    { 
      0.0, 0, -29, 5, 
      0.5, 0, -29, 5,
      0.8, 0, -29, 5,
      1.1, 0, 7,   26
    } );

    return true;

  elseif common.ApplyObj( item, "gzz_nightsville_fireequipment", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fireequipment", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hydrantwrench()

  local item = "inv_hydrantwrench";

  if ( common.ApplyObj( item, "obj_fireequipment_use_hydrantwrench", true ) and cmn.IsEventDone( "use_magnet_1" ) ) then

    cmn.CallEventHandler( "use_hydrantwrench_inv" );
    cmn.CallEventHandler( "use_hydrantwrench_beg" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_hydrantwrench" );
      cmn.CallEventHandler( "use_hydrantwrench_end" )
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_key_fire_cabinet", 0, "", 0 );

    ObjAnimate( "obj_fireequipment_key_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 1.0
    } );

    return true;

  elseif common.ApplyObj( item, "gzz_nightsville_fireequipment", false ) and cmn.IsEventDone( "use_magnet_1" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fireequipment", nil, { 512, 384 } );

    return true;  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_brokenkey()

  local item = "inv_brokenkey";

  if ( common.ApplyObj( item, "obj_workshop_use_brokenkey", true ) ) then

    cmn.CallEventHandler( "use_brokenkey_inv" );
    cmn.CallEventHandler( "use_brokenkey_beg" );

    --local func_after = function ()

      cmn.SetEventDone( "use_brokenkey" );
      cmn.CallEventHandler( "use_brokenkey_end" );
      if ( cmn.IsEventDone( "get_tweezers" ) ) then
        common.CloseSubRoom();
        cmn.GotoRoom( 'mg_key' );
      end;
    
    --end;
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_key_insert", 0, "", 0 );

    --ObjAnimate( "spr", "alp", 0, 0, func_after,
    --{ 
    --  0.0, 0, 0.0, 
    --  0.3, 0, 1.0
    --} );

    return true;

  elseif common.ApplyObj( item, "gzz_nightsville_workshop", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_workshop", nil, { 512, 384 } );

   return true;   

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_axeblade()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_axeblade" );
  cmn.CallEventHandler( "get_axeblade" );

end;
--------------------------------------------------------------------------------------------
function private.get_hanky()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_hanky" );
  cmn.CallEventHandler( "get_hanky" );

end;
--------------------------------------------------------------------------------------------
function private.get_prv_valve()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );

  cmn.SetEventDone( "get_prv_valve" );
  cmn.CallEventHandler( "get_prv_valve" );

  if ( common_impl.IsGetCoin( "get_coin_15" ) ) then
    common.CloseSubRoom();
  end;

  ObjDelete( "spr_pavement_prv_valve_over" );

end;
--------------------------------------------------------------------------------------------
function private.get_crowbar()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_crowbar" );
  cmn.CallEventHandler( "get_crowbar" );
  if ( cmn.IsEventDone("get_brokenkey") and cmn.IsEventDone("get_chestpart") 
  and cmn.IsEventDone("get_prv_sledgehammer") and common_impl.IsGetCoin( "get_coin_14" ) ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_prv_sledgehammer()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );

  cmn.SetEventDone( "get_prv_sledgehammer" );
  cmn.CallEventHandler( "get_prv_sledgehammer" );
  if ( cmn.IsEventDone("get_brokenkey") and cmn.IsEventDone("get_chestpart") 
  and cmn.IsEventDone("get_crowbar") and common_impl.IsGetCoin( "get_coin_14" ) ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_chestpart()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_chestpart" );
  cmn.CallEventHandler( "get_chestpart" );
  if ( cmn.IsEventDone("get_brokenkey") and cmn.IsEventDone("get_prv_sledgehammer") 
  and cmn.IsEventDone("get_crowbar") and common_impl.IsGetCoin( "get_coin_14" ) ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_brokenkey()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_brokenkey" );
  cmn.CallEventHandler( "get_brokenkey" );
  if ( cmn.IsEventDone("get_chestpart") and cmn.IsEventDone("get_prv_sledgehammer") 
  and cmn.IsEventDone("get_crowbar") and common_impl.IsGetCoin( "get_coin_14" ) ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_tweezers()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_tweezers" );
  cmn.CallEventHandler( "get_tweezers" );
  if ( cmn.IsEventDone( "use_brokenkey" ) ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_coin14()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_14");
    cmn.CallEventHandler("get_coin_14");

    if ( cmn.IsEventDone("get_prv_sledgehammer") and cmn.IsEventDone("get_chestpart") 
    and cmn.IsEventDone("get_crowbar") and cmn.IsEventDone("get_brokenkey") ) then   
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_fireequipment_coin", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_coin15()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_15");
    cmn.CallEventHandler("get_coin_15");

    if ( cmn.IsEventDone( "get_prv_valve" ) ) then   
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_pavement_coin", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_hydrantwrench()

  cmn.CallEventHandler( "clk_hydrantwrench_beg" );

  local func_after = function ()

    local trg_end = function()

      common_impl.Lock( false );
      cmn.SetEventDone( "clk_hydrantwrench" );
      cmn.CallEventHandler( "clk_hydrantwrench_end" );

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_touch_key_fire_cabinet", 0, "", 0 );

    ObjAnimate( "obj_fireequipment_key_3", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );

    ObjAnimate( "spr_fireequipment_door_open", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_fireequipment_door_closed", "alp", 0, 0, trg_end,
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );

    ObjAnimate( "spr_fireequipment_override_3", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
  
  end;

  common_impl.Lock( true );

  ObjAnimate( "obj_fireequipment_key_2", "alp", 0, 0, "",
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );

  ObjAnimate( "obj_fireequipment_key_3", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0
  } );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.clk_trash()

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_trash" );
    cmn.CallEventHandler( "clk_trash" );

  end;

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_junk_bridge", 0, "", 0 );

  ObjAnimate("spr_pavement_mining_trash_2", "alp", 0, 0, func_after, { 0,3,1, 0.4,3,0 });

end;
--*********************************************************************************************************************
function private.clk_trash_2()

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_trash_2" );
    cmn.CallEventHandler( "clk_trash_2" );

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_junk_bridge", 0, "", 0 );

  ObjAnimate("spr_pavement_mining_trash", "alp", 0, 0, func_after, { 0,3,1, 0.4,3,0 });

end;
--*********************************************************************************************************************
function public.StartEvidenceMmg()

   ObjMultiSet( {  
   
   { "spr_evidence_evidence_2_4_mmg_plate_1", { input = false, event_mdown = function() private.ClkMmgOption(1); end } },
   { "spr_evidence_evidence_2_4_mmg_plate_2", { input = false, event_mdown = function() private.ClkMmgOption(2); end } },
   { "spr_evidence_evidence_2_4_mmg_plate_3", { input = false, event_mdown = function() private.ClkMmgOption(3); end } },
   { "spr_evidence_evidence_2_4_paper_big_deleted_1", { event_mdown = function() private.WordMouseEnter(1); end } },
   { "spr_evidence_evidence_2_4_paper_big_deleted_2", { event_mdown = function() private.WordMouseEnter(2); end } },
   { "obj_evidence_evidence_2_4_mmg", { event_mleave = function() --private.WordMouseLeave(); 
    end } },


   });

   private.evidence_mmg = { 0, 0, 0, } -- 1 - current, 2 -  state 1, 3 -  state 2 

end;
--*********************************************************************************************************************
function private.WordMouseLeave( mode )

  local coords = GetGameCursorPos();

  ObjCreate( "obj_evidence_evidence_2_4_check_leave", "obj" );

  ObjAttach( "obj_evidence_evidence_2_4_check_leave", "spr_evidence_evidence_2_4_paper_big" );

  ObjSet( "obj_evidence_evidence_2_4_check_leave", { pos_x = coords[1]-512, pos_y = coords[2]-384, pos_z = 50, input = true,
                                                     inputrect_init = true, inputrect_w = 1, inputrect_h = 1 } );
                                                    -- res = "assets/levels/level2/rm_nightsville/layers/evidence", alp = 1, visible = true } );

  local intersect = false;

  if mode ~= "enter" then

    for i = 1, 3 do

      if ( ObjIntersect( "obj_evidence_evidence_2_4_check_leave",  "spr_evidence_evidence_2_4_mmg_plate_"..i ) ) then

        intersect = true;
       
      end;

    end;

  else

    for i = 1, 3 do

      if ( ObjIntersect( "obj_evidence_evidence_2_4_check_leave",  "obj_evidence_evidence_2_4_mmg" ) ) then

        intersect = true;
       
      end;

    end;

  end;

  ObjDelete( "obj_evidence_evidence_2_4_check_leave" );

  if intersect ~= true then

    private.WordMouseLeaveAnim();

  end;


end;
--*********************************************************************************************************************
function private.WordMouseLeaveAnim()

  local func_after = function()

    common_impl.Lock( false );
    ObjSet( "obj_evidence_evidence_2_4_mmg", { input = false } );
    ObjSet( "spr_evidence_evidence_2_4_paper_big_deleted_1", { input = true } );
    ObjSet( "spr_evidence_evidence_2_4_paper_big_deleted_2", { input = true } );
  
  end;

  common_impl.Lock( true );

  ObjAnimate( "spr_evidence_evidence_2_4_mmg_plate_1", "scale_xy", 0, 0, "", { 0,3,1,1, 0.2,3,0,0 } );
  ObjAnimate( "spr_evidence_evidence_2_4_mmg_plate_2", "scale_xy", 0, 0, "", { 0,3,1,1, 0.2,3,0,0 } );
  ObjAnimate( "spr_evidence_evidence_2_4_mmg_plate_3", "scale_xy", 0, 0, func_after, { 0,3,-1,1, 0.2,3,0,0 } );

end;

private.WordMouseEnterDown = false;
--*********************************************************************************************************************
function private.WordMouseEnter( number )

  if private.WordMouseEnterDown ~= true then
    
    private.WordMouseEnterDown = true;
    local coords = { { -17, -196 }, { 20, -117 } };

    ObjMultiSet( {  
     
     { "txt_evidence_evidence_2_4_mmg_plate_1", { text =  "str_evidence_2_4_word_"..number.."_option_1", fontcolor_r = 0, fontcolor_g = 0, fontcolor_b = 0 } },
     { "txt_evidence_evidence_2_4_mmg_plate_2", { text =  "str_evidence_2_4_word_"..number.."_option_2", fontcolor_r = 0, fontcolor_g = 0, fontcolor_b = 0 } },
     { "txt_evidence_evidence_2_4_mmg_plate_3", { text =  "str_evidence_2_4_word_"..number.."_option_3", fontcolor_r = 0, fontcolor_g = 0, fontcolor_b = 0 } },
     { "obj_evidence_evidence_2_4_mmg", { alp = 1, pos_x = coords[number][1], pos_y = coords[number][2] } },
   
     });

     local func_after = function()

      common_impl.Lock( false );
      private.evidence_mmg[1] = number;
    
      for i = 1, 3 do

       ObjSet( "spr_evidence_evidence_2_4_mmg_plate_"..i, { input = true } );

      end;

      private.WordMouseLeave( "enter" );

     end;

      common_impl.Lock( true );

      ObjSet( "obj_evidence_evidence_2_4_mmg", { input = true } );

      common_impl.PlayAudio( "sfx", "common/audio/aud_letter_clouds", 0, "", 0 );

      ObjSet( "spr_evidence_evidence_2_4_paper_big_deleted_"..number, { input = false } );    

      ObjAnimate( "spr_evidence_evidence_2_4_mmg_plate_1", "pos_xy", 0, 0, "", { 0,3,15,130, 0.2,3,-66,100 } );
      ObjAnimate( "spr_evidence_evidence_2_4_mmg_plate_2", "pos_xy", 0, 0, "", { 0,3,15,130, 0.2,3,15,130, 0.4,3,2,53 } );
      ObjAnimate( "spr_evidence_evidence_2_4_mmg_plate_3", "pos_xy", 0, 0, "", { 0,3,15,130, 0.4,3,15,130, 0.6,3,88,100 } );  

      ObjAnimate( "spr_evidence_evidence_2_4_mmg_plate_1", "scale_xy", 0, 0, "", { 0,3,0,0, 0.2,3,1,1 } );
      ObjAnimate( "spr_evidence_evidence_2_4_mmg_plate_2", "scale_xy", 0, 0, "", { 0,3,0,0, 0.2,3,0,0, 0.4,0,1,1 } );
      ObjAnimate( "spr_evidence_evidence_2_4_mmg_plate_3", "scale_xy", 0, 0, func_after, { 0,3,0,0, 0.4,3,0,0, 0.6,0,-1,1 } );
  --
--
  end;
end;
--*********************************************************************************************************************
function private.ClkMmgOption( number )

  local win = { { 1,0,0 }, { 0,1,0 } }

  if win[private.evidence_mmg[1]][number] == 1 then

    local func_after = function()

      common_impl.Lock( false );
      ObjDelete( "spr_evidence_evidence_2_4_paper_big_deleted_"..number );
      ObjSet( "obj_evidence_evidence_2_4_mmg", { input = false } );
      private.evidence_mmg[number + 1] = 1;

      if  private.evidence_mmg[2] == 1 and private.evidence_mmg[3] == 1 then

        ObjSet( "obj_evidence_evidence_2_4_progress_clk",{ input = true } );

      end;
      
      private.WordMouseEnterDown = false;
   
     end;

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_letter_true_cloud", 0, "", 0 );
      
      ObjAnimate( "txt_evidence_evidence_2_4_paper_big_new_text_"..number, "alp", 0, 0, "", { 0,3,0, 0.3,3,1 } );  
      ObjAnimate( "spr_evidence_evidence_2_4_paper_big_deleted_"..number, "alp", 0, 0, func_after, { 0,3,1, 0.3,3,0 } );
      ObjAnimate( "obj_evidence_evidence_2_4_mmg", "alp", 0, 0, "", { 0,3,1, 0.3,3,0 } );  
      
  else

    ObjSet( "txt_evidence_evidence_2_4_mmg_plate_"..number, { fontcolor_r = 0.78, fontcolor_g = 0.02, fontcolor_b = 0 } );  
    common_impl.PlayAudio( "sfx", "common/audio/aud_letter_wrong_cloud", 0, "", 0 );

  end;
 

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if dlg_name == "steward" then

      local func_after_anim_1 = function()

        ObjSet( "anm_nightsville_steward_steward_weapon", { alp = 0 } );
        ObjSet( "anm_nightsville_steward_steward", { alp = 1 } );
        common_impl.PlayAudio( "sfx", "common/audio/aud_get_to_us", 0, "", 0 );
       
      end;
       
      local func_after_anim_2 = function()

        ObjSet( "anm_nightsville_steward_steward", { alp = 0 } );
        ObjSet( "anm_nightsville_steward_letter", { alp = 1 } );
        common_impl.PlayAudio( "sfx", "common/audio/aud_get_to_us", 0, "", 0 );

      end;
    
     if count_txt == 1 then 

        common_impl.continue_visible = false; 
        common_impl.frases = { 2, 3 }; 
        common_impl.dial_icons = { 'nightsville', 'owlman' };
        common_impl.DialogCharacterShowDialogQuestions( 2, 6 );

        common_impl.DialogCharacterChangeCharacters( "steward", "steward", "sem", 0.95 ); 

     elseif count_txt == 2 then 

        func_after_anim_1();

        common_impl.continue_visible = false; 
        common_impl.DialogCharacterShowDialogQuestions( 1, 6 );

        if common_impl.dialog_character_select == 3 then 

          common_impl.DialogCharacterChangeCharacters( "steward", "sem", "steward" ); 
    
        end;

     elseif count_txt == 3 then 

        common_impl.continue_visible = true; 
      
        if common_impl.dialog_character_select == 3 then 

          common_impl.DialogCharacterChangeCharacters( "steward", "sem", "steward" ); 

        elseif common_impl.dialog_character_select == 2 then 

          common_impl.DialogCharacterChangeCharacters( "steward", "steward", "sem", 0.95 ); 
    
        end;
   
     elseif count_txt == 4 then

       common_impl.continue_visible = true; 

       func_after_anim_2();

       if common_impl.dialog_character_select == 2 then 

          common_impl.DialogCharacterChangeCharacters( "steward", "sem", "steward" ); 
    
       end;
     
     end;
  
  elseif dlg_name == "suspicion" then

    if count_txt == 1 then 

        common_impl.continue_visible = false; 
        common_impl.frases = { 1 }; 
        common_impl.dial_icons = { 'george' };
        common_impl.DialogCharacterShowDialogQuestions( 1, 2 );

        common_impl.DialogCharacterChangeCharacters( "suspicion", false, "steward" ); 

    elseif count_txt == 2 then 

        common_impl.continue_visible = false; 
        common_impl.frases = { 2 }; 
        common_impl.dial_icons = { 'mine' };
        common_impl.DialogCharacterShowDialogQuestions( 1, 9 );

    end;

  end;

end;
--------------------------------------------------------------------------------------------
function private.AnmCrab()
  
  common_impl.ShowBbt( 'bbt_pavement_use_magnet' );
  ObjSet( "anm_pavement_crab_clk", { visible = true } );
  ObjSet( "anm_pavement_crab_static", { visible = false } );
  common_impl.Lock( true );

  local func_end = function()

    common_impl.Lock( false );
    ObjSet( "anm_pavement_crab_clk", { visible = false } );
    ObjSet( "anm_pavement_crab_static", { visible = true } );
    AnimPlay( "anm_pavement_crab_static", "DoAnim", "" );

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_crab", 0, "", 0 );

  AnimPlay( "anm_pavement_crab_clk", "DoAnim", func_end );

end;
--------------------------------------------------------------------------------------------
function public.vid_nightsville_attack()

  cmn.CallEventHandler( "vid_nightsville_attack_beg" );
  ObjSet( "vid_nightsville_attack", { alp = 1, active = true, input = false, visible = true } );
  
  local func_after = function ( skip )

    common_impl.ShowBbt( 'bbt_nightsville_attack' );

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_nightsville_attack" );
    cmn.CallEventHandler( "vid_nightsville_attack_end" );
    private.dlg_nightsville_steward();
    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment1_mus", 0, "", 0 );

    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_nightsville_attack", 0.5 );
      common_impl.StopAudio( "voc", "common/audio/aud_nightsville_attack_voc", 0.5 );

    end;

  end;
  
  common_impl.StopAllMus();
  common_impl.PlayAudio( "sfx", "common/audio/aud_nightsville_attack", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/aud_nightsville_attack_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_nightsville_attack", 1, function() func_after( 'skip' ) end, 3 );
  --common_impl.PlayAudio( "sfx", "common/audio/aud_area_oulmen", 0, "", 0.5 );
  VidPlay( "vid_nightsville_attack", function() func_after( nil ) end ); 

end;
--*********************************************************************************************************************
function private.dlg_nightsville_steward()

  ObjAttach( "dlg_nightsville_steward", private.room_objname );
  common_impl.dialog_character_loc = "obj_nightsville_characters";
  common_impl.DialogCharacterStart( "steward", 5, nil, nil, true, "dlg_nightsville_steward_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_nightsville_steward_end()

  common_impl.Lock( false );
  
  cmn.CallEventHandler( "dlg_nightsville_steward_end" );

  -- private.dialog_voices_time = { voice_1_time, voice_2_time, ... , voice_n_time  };  время войсов
  -- для нескольких вариантов ответа время передается как private.dialog_voices_time[ common_impl.dialog_character_select ] 
 
  local page_content = { 1, 1, 1 };
  common_impl.AddBookmarkDiary( 10, 1, page_content );

  local func_end = function ()

    cmn.SetEventDone( "dlg_nightsville_steward" );

    int_investigation_button.Show( true );
    interface.InvestigationButtonItemAdd( "evidence_2_4", "spr_evidence_evidence_2_4_paper_big" );
    
    cmn.SetEventDone( "get_evidence_2_4" );
    cmn.CallEventHandler( "get_evidence_2_4" );

    common_impl.ShowBbt( 'bbt_nightsville_2_sem' );

  end;

  interface.DialogEvidenceShow( "evidence_2_4_progress", func_end );

end;
--*********************************************************************************************************************
function private.dlg_nightsville_suspicion()

  ObjAttach( "dlg_nightsville_suspicion", private.room_objname );
  common_impl.dialog_character_loc = "obj_nightsville_characters";
  common_impl.DialogCharacterStart( "suspicion", 4, nil, nil, true, "dlg_nightsville_suspicion_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_nightsville_suspicion_end()

  int_investigation_button.ChangeInvestigation();

  cmn.SetEventDone( "dlg_nightsville_suspicion" );
  cmn.CallEventHandler( "dlg_nightsville_suspicion_end" );
  
  interface.KeyTaskAdd( "get_to_mine" );

end;
--------------------------------------------------------------------------------------------
function private.opn_nightsville()

  if not ( cmn.IsEventDone( "opn_nightsville" ) ) then
    cmn.SetEventDone( "opn_nightsville" );
  end;
    cmn.CallEventHandler( "opn_nightsville" ); 

end;
--*********************************************************************************************************************
ObjAnimate("spr_workshop_light", "alp", 1, 0, "", { 0,3,1, 3,3,0.6, 6,3,1 });
ObjAnimate("spr_workshop_chain_1", "ang", 1, 0, "", { 0,3,0.05, 3,3,-0.05, 6,3,0.05 });
ObjAnimate("spr_workshop_chain_2", "ang", 1, 0, "", { 0,3,-0.05, 2,3,0.05, 4,3,-0.05 });
ObjAnimate("spr_workshop_chain_3", "ang", 1, 0, "", { 0,3,-0.03, 3.5,3,0.03, 7,3,-0.03 });
ObjAnimate("spr_workshop_chain_hook", "ang", 1, 0, "", { 0,3,-0.03, 3.5,3,0.03, 7,3,-0.03 });
ObjAnimate("spr_workshop_chain_4", "scale_x", 1, 0, "", { 0,3,1, 3,3,0.85, 6,3,1 });
ObjAnimate("spr_workshop_chain_5", "scale_y", 1, 0, "", { 0,3,1, 2,3,0.85, 4,3,1 });
ObjAnimate("spr_workshop_chain_6", "scale_xy", 1, 0, "", { 0,3,1,1, 3.5,3,0.9,0.9, 7,3,1,1 });
--*********************************************************************************************************************
function private.DoorAnimation()

  local func_end = function ()

    common_impl.Lock( false );

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_fireequipment_door", 0, "", 0 );

  ObjAnimate("spr_fireequipment_door_closed", "pos_x", 0, 0, func_end, 
    { 0.0, 1, -2,
      0.2, 1, -3,
      0.4, 1, -2,
      0.6, 1, -1,
      0.8, 1, -2,        
    });
end;