-- name=rm_nightsvilleentrance
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_nightsvilleentrance";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_hole", "room_hub" );
  ObjAttach( "zz_dangerousbridge", "room_hub" );
  ObjAttach( "zz_entrance", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_hole_prv_carrot",                      { event_mdown = private.get_prv_carrot   }},
    { "spr_hole_knife",                           { event_mdown = private.get_knife        }},
    { "spr_hole_file",                            { event_mdown = private.get_file         }},
    { "spr_hole_bandage",                         { event_mdown = private.get_bandage      }},
    { "spr_hole_medicine",                        { event_mdown = private.get_medicine     }},
    { "spr_dangerousbridge_pikepole",             { event_mdown = private.get_pikepole     }},
    { "spr_nightsvilleentrance_evidence_2_1",     { event_mdown = private.get_evidence_2_1 }},    
    { "obj_vid_nightsvilleentrance_child",        { event_mdown = private.vid_nightsvilleentrance_child   }},
    { "obj_dlg_nightsvilleentrance_child",        { event_mdown = private.dlg_nightsvilleentrance_child   }},
    { "obj_dlg_nightsvilleentrance_child_focus",  { event_mdown = private.dlg_nightsvilleentrance_child   }},
    { "obj_dlg_nightsvilleentrance_company",      { event_mdown = private.dlg_nightsvilleentrance_company }},
    { "obj_dlg_nightsvilleentrance_company_focus",{ event_mdown = private.dlg_nightsvilleentrance_company }},
    { "obj_nightsvilleentrance_prv_item_2",       { event_mdown = function() int_providence.Thinking( "providence_2", "obj_nightsvilleentrance_prv_item_2" ) end }},
    { "obj_nightsvilleentrance_prv_item_1",       { event_mdown = function() int_providence.Thinking( "providence_1", "obj_nightsvilleentrance_prv_item_1" ) end }},
    { "obj_nightsvilleentrance_prv_item_3",       { event_mdown = function() int_providence.Thinking( "providence_3", "obj_nightsvilleentrance_prv_item_3" ) end }},
    { "obj_nightsvilleentrance_use_prv_item_1",   { event_mdown = private.get_prv_carrot_silhouette }},
    { "obj_entrance_use_mechanismpart",           { event_mdown = private.clk_door      }},
    { "obj_hole_clk_bag",                         { event_mdown = private.clk_hole_bag  }},
    { "obj_dangerousbridge_clk_log",              { event_mdown = private.clk_log       }},
    { "obj_dangerousbridge_clk_rope",             { event_mdown = private.clk_rope      }},
    { "obj_dangerousbridge_use_knife",            { event_mdown = private.anm_log       }},
    { "spr_nightsvilleentrance_prv_bone",         { event_startdrag = private.drag_bone, event_dragdrop = private.drop_bone   }},
    { "spr_nightsvilleentrance_prv_rope",         { event_startdrag = private.drag_rope, event_dragdrop = private.drop_rope   }},
    { "spr_nightsvilleentrance_prv_stick",        { event_startdrag = private.drag_stick, event_dragdrop = private.drop_stick }},
    { "obj_nightsvilleentrance_clk_bushes",       { event_mdown = function() private.clk_bushes() end   }},
    { "spr_hole_cover_firstaid" ,                 { event_mdown = function() private.CoverAnimation() end }},
    { "spr_nightsvilleentrance_child_paper_1" ,   { event_mdown = function() private.ClickDlgPaper( 1 ) end }},
    { "spr_nightsvilleentrance_child_paper_2" ,   { event_mdown = function() private.ClickDlgPaper( 2 ) end }},
    { "obj_nightsvilleentrance_company_mmg_clk_1" ,   { event_mdown = function() private.ClkCompanyDialPart( 1 ) end }},
    { "obj_nightsvilleentrance_company_mmg_clk_2" ,   { event_mdown = function() private.ClkCompanyDialPart( 2 ) end }},
    { "obj_nightsvilleentrance_company_mmg_clk_3" ,   { event_mdown = function() private.ClkCompanyDialPart( 3 ) end }},
    { "spr_hole_coin",                            { event_mdown = private.get_coin11 } },
    { "spr_nightsvilleentrance_child_paper_3" ,   { event_mdown = function() private.ClickDlgPaper( 3 ) end }},
    { "spr_nightsvilleentrance_child_clock" ,   { event_mdown = function() private.ClkDlgClock() end }},
    { "obj_hole_use_secateurs" ,                  { event_mdown = private.anm_branches }},
    { "grm_nightsvilleentrance_nightsville" ,     { event_mdown = function() cmn.GotoRoom( 'rm_nightsville' ); private.first_gate_to_nightsville(); end }},
    { "spr_nightsvilleentrance_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_1" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
 
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_nightsvilleentrance = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gmg_nightsvilleentrance_gate",
    "gzz_nightsvilleentrance_hole",
    "gzz_nightsvilleentrance_dangerousbridge",
    "gzz_nightsvilleentrance_entrance"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_hole",
      "zz_dangerousbridge",
      "zz_entrance",
    
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_nightsvilleentrance", update_game_mode_nightsvilleentrance, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_nightsvilleentrance = function ()

  local effects_table = 
  {
    "obj_nightsvilleentrance_anims",
    "anm_nightsvilleentrance_bushes",
    "anm_nightsvilleentrance_bushes_open",
    "vid_dangerousbridge_water",
    "anm_dangerousbridge_bridge",
    "anm_hightsvilleentrance_bushes_1",
    "anm_hightsvilleentrance_bushes_2",
    "anm_dangerousbridge_bridge",
    "anm_dangerousbridge_bridge_broken_2",
    "anm_dangerousbridge_bridge_broken_1",
    "spr_entrance_bush_1",
    "spr_entrance_bush_2"
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_nightsvilleentrance", update_performance_mode_nightsvilleentrance, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_nightsvilleentrance () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_nightsvilleentrance" ] = {
    type = "click",
    use_place = "grm_divarication_nightsvilleentrance",
    room = "rm_divarication"
  };

  local opn_nightsvilleentrance_map = function ()

    common_impl.VisitMapRoom( "nightsvilleentrance" );

  end;
  cmn.AddSubscriber( "opn_nightsvilleentrance", opn_nightsvilleentrance_map, nil );
  --------------------------------------------------------------------------------------------
  -- function get_prv_carrot_silhouette () end;
  --------------------------------------------------------------------------------------------
  local get_prv_carrot_silhouette_inv = function ()
  
    interface.ProvidePanelSilhouetteAdd( "inv_prv_carrot", "spr_nightsvilleentrance_prv_carrot_silhouette" );

  end;
  
  local get_prv_carrot_silhouette_closezz = function ()

    ObjSet( "spr_nightsvilleentrance_prv_carrot_silhouette", { alp = 1 } );    
    ObjSet( "obj_nightsvilleentrance_use_prv_item_1", { event_mdown = function() int_providence.Thinking( "providence_prv_item_1", "obj_nightsvilleentrance_use_prv_item_1" ) end } )

  end;

  local get_prv_carrot_silhouette_notadd = function ()

    ObjSet( "obj_nightsvilleentrance_use_prv_item_1", { event_mdown = function() int_providence.Thinking( "providence_prv_item_1", "obj_nightsvilleentrance_use_prv_item_1" ) end } )

  end;
  
  cmn.AddSubscriber( "get_prv_carrot_silhouette", get_prv_carrot_silhouette_inv );
  cmn.AddSubscriber( "get_prv_carrot_silhouette", get_prv_carrot_silhouette_closezz, private.room_objname );
  cmn.AddSubscriber( "get_prv_carrot", get_prv_carrot_silhouette_notadd, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_prv_carrot () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_prv_carrot" ] = {
    type = "get",
    get_obj = "spr_hole_prv_carrot",
    room = private.room_objname,
    zz = "zz_hole",
    zz_gate = "gzz_nightsvilleentrance_hole"
  };
    
  local get_prv_carrot_inv = function ()
      
    interface.ProvidePanelItemAdd( "inv_prv_carrot", "spr_hole_prv_carrot" );

  end;
  
  local get_prv_carrot_closezz = function ()

    ObjDelete( "spr_nightsvilleentrance_hole_carrot" );
    ObjDelete( "spr_hole_prv_carrot_shadow" );
    ObjDelete( "gfx_hole_prv_carrot" );    
  
  end;
  
  cmn.AddSubscriber( "get_prv_carrot", get_prv_carrot_inv );
  cmn.AddSubscriber( "get_prv_carrot", get_prv_carrot_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_knife () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_knife" ] = {
    type = "get",
    get_obj = "spr_hole_knife",
    room = private.room_objname,
    zz = "zz_hole",
    zz_gate = "gzz_nightsvilleentrance_hole"
  };
    
  local get_knife_inv = function ()
  
    interface.InventoryItemAdd( "inv_knife", "spr_hole_knife" );
    ObjSet( "spr_wounddevice_plus_light", { visible = true } );
    ObjSet( "spr_remotecontrol_plus_light", { visible = true } );
  
  end;
  
  local get_knife_closezz = function ()
  
    ObjDelete( "gfx_hole_knife" );
    ObjDelete( "spr_nightsvilleentrance_hole_knife" );    
  
  end;
  
  cmn.AddSubscriber( "get_knife", get_knife_inv );
  cmn.AddSubscriber( "get_knife", get_knife_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_file () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_file" ] = {
    type = "get",
    get_obj = "spr_hole_file",
    room = private.room_objname,
    zz = "zz_hole",
    zz_gate = "gzz_nightsvilleentrance_hole"
  };
    
  local get_file_inv = function ()
  
    interface.InventoryItemAdd( "inv_file", "spr_hole_file" );
  
  end;
  
  local get_file_closezz = function ()
  
    ObjDelete( "gfx_hole_file" );
    ObjDelete( "spr_hole_file_shadow" );
    ObjDelete( "spr_nightsvilleentrance_hole_file" );

    ObjSet( "spr_hole_cover_firstaid", { input = 1 });
  
  end;
  
  cmn.AddSubscriber( "get_file", get_file_inv );
  cmn.AddSubscriber( "get_file", get_file_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bandage () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bandage" ] = {
    type = "get",
    get_obj = "spr_hole_bandage",
    room = private.room_objname,
    zz = "zz_hole",
    zz_gate = "gzz_nightsvilleentrance_hole"
  };
    
  local get_bandage_inv = function ()
  
    interface.InventoryItemAdd( "inv_bandage", "spr_hole_bandage" );
  
  end;
  
  local get_bandage_closezz = function ()
  
    ObjDelete( "gfx_hole_bandage" );
    ObjDelete( "spr_hole_bandage_shadow" );
    
    ObjMultiSet({ 
      { "spr_nightsvilleentrance_hole_over_box",   { alp = 1 }},
      { "spr_nightsvilleentrance_hole_over_box_3", { alp = 1 }},
    });

    if ( cmn.IsEventDone("get_medicine") and common_impl.IsGetCoin("get_coin_11") ) then
      ObjDelete( "gzz_nightsvilleentrance_hole" );
    end;

  end;
  
  cmn.AddSubscriber( "get_bandage", get_bandage_inv );
  cmn.AddSubscriber( "get_bandage", get_bandage_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_medicine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_medicine" ] = {
    type = "get",
    get_obj = "spr_hole_medicine",
    room = private.room_objname,
    zz = "zz_hole",
    zz_gate = "gzz_nightsvilleentrance_hole"
  };
    
  local get_medicine_inv = function ()
  
    interface.InventoryItemAdd( "inv_medicine", "spr_hole_medicine" );
  
  end;
  
  local get_medicine_closezz = function ()

    ObjDelete( "spr_hole_medicine_shadow" );
    ObjDelete( "gfx_hole_medicine" );

    ObjSet( "spr_nightsvilleentrance_hole_over_box_2", { alp = 1 } );

    if ( cmn.IsEventDone("get_bandage") and common_impl.IsGetCoin("get_coin_11") ) then
      ObjDelete( "gzz_nightsvilleentrance_hole" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_medicine", get_medicine_inv );
  cmn.AddSubscriber( "get_medicine", get_medicine_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pikepole () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pikepole" ] = {
    type = "get",
    get_obj = "spr_dangerousbridge_pikepole",
    room = private.room_objname,
    zz = "zz_dangerousbridge",
    zz_gate = "gzz_nightsvilleentrance_dangerousbridge"
  };
    
  local get_pikepole_inv = function ()
  
    interface.InventoryItemAdd( "inv_pikepole", "spr_dangerousbridge_pikepole" );
  
  end;
  
  local get_pikepole_closezz = function ()
  
    ObjDelete( "gfx_dangerousbridge_pikepole" );
    ObjDelete( "spr_dangerousbridge_pikepole_shadow" );
    ObjDelete( "spr_dangerousbridge_pikepole_cap" );
  
  end;
  
  cmn.AddSubscriber( "get_pikepole", get_pikepole_inv );
  cmn.AddSubscriber( "get_pikepole", get_pikepole_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_evidence_2_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_evidence_2_1" ] = {
    type = "get",
    get_obj = "spr_nightsvilleentrance_evidence_2_1",
    room = private.room_objname,
    zz = "zz_nightsvilleentrance",
    zz_gate = "gzz_nightsvilleentrance_nightsvilleentrance"
  };
  
  local get_evidence_2_1_closezz = function ()
  
    ObjDelete( "spr_nightsvilleentrance_evidence_2_1" );
  
  end;
    
  cmn.AddSubscriber( "get_evidence_2_1", get_evidence_2_1_closezz, private.room_objname );
   --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_1 = function ()
  
    ObjDelete( "obj_nightsvilleentrance_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_1", get_collect_morph_item_2_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_mechanismpart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_mechanismpart" ] = {
    type = "get",
    get_obj = "spr_nightsvilleentrance_company_wheel",
    room = private.room_objname,
    zz = "zz_nightsvilleentrance",
    zz_gate = "gzz_nightsvilleentrance_nightsvilleentrance"
  };
    
  local get_mechanismpart_inv = function ()
  
    interface.InventoryItemAdd( "inv_mechanismpart", "spr_nightsvilleentrance_company_wheel" );
  
  end;
  
  local get_mechanismpart_closezz = function ()
  
    ObjDelete( "gfx_nightsvilleentrance_mechanismpart" );
    ObjDelete( "gzz_nightsvilleentrance_nightsvilleentrance" );
  
  end;
  
  cmn.AddSubscriber( "get_mechanismpart", get_mechanismpart_inv );
  cmn.AddSubscriber( "get_mechanismpart", get_mechanismpart_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coins () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_11 = function ()
 
    ObjDelete( "obj_hole_coin" );

    if ( cmn.IsEventDone( "get_medicine" ) and cmn.IsEventDone( "get_bandage" ) ) then      
      ObjDelete( "gzz_nightsvilleentrance_hole" );
    end;
    
  end;
  cmn.AddSubscriber( "get_coin_11", get_collect_coin_11, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_secateurs () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_secateurs" ] = {
    type = "use",
    inv_obj = "inv_secateurs",
    use_place = "obj_hole_use_secateurs",
    room = private.room_objname,
    zz = "zz_hole",
    zz_gate = "gzz_nightsvilleentrance_hole"
  };
  local use_secateurs_inv = function ()
  
    interface.InventoryItemRemove( "inv_secateurs" );
  
  end;
  local use_secateurs_beg = function ()
  
    ObjDelete( "obj_hole_use_secateurs" );
    ObjDelete( "anm_hole_pruner_2" );
    ObjSet( "anm_hole_foliage", { visible = true } );
  
  end;
  local use_secateurs_end = function ()

    ObjDelete( "anm_hole_pruner" );
    ObjDelete( "spr_nightsvilleentrance_hole_brush" );

    ObjMultiSet({ 
      { "obj_hole_clk_bag",                     { input = true }},
      { "spr_nightsvilleentrance_hole_brush_2", { alp = 1      }},
    });

    --ObjSet( "spr_hole_open_bag", { input = true , alp = 1 } );
    --ObjSet( "spr_hole_file", { input = true, visible = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_secateurs", use_secateurs_beg, private.room_objname );
  cmn.AddSubscriber( "use_secateurs", use_secateurs_inv );
  cmn.AddSubscriber( "use_secateurs", use_secateurs_end, private.room_objname );
  cmn.AddSubscriber( "use_secateurs_inv", use_secateurs_inv, private.room_objname );
  cmn.AddSubscriber( "use_secateurs_beg", use_secateurs_beg, private.room_objname );
  cmn.AddSubscriber( "use_secateurs_end", use_secateurs_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hairpin () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hairpin" ] = {
    type = "use",
    inv_obj = "inv_hairpin",
    use_place = "obj_hole_use_hairpin",
    room = private.room_objname,
    zz = "zz_hole",
    zz_gate = "gzz_nightsvilleentrance_hole"
  };
  local use_hairpin_inv = function ()
  
    interface.InventoryItemRemove( "inv_hairpin" );
  
  end;

  local use_hairpin_beg = function ()
  
    ObjDelete( "obj_hole_use_hairpin" );
    
  end;

  local use_hairpin_end = function ()

    ObjDelete( "spr_hole_hairpin_overlap" );
    ObjDelete( "spr_hole_hairpin" );
    ObjDelete( "spr_hole_cover_firstaid" );
    ObjDelete( "anm_hole_hairpin" );

    ObjMultiSet({ 
      { "spr_hole_open_firstaid", { input = true, alp = 1 }},
      { "spr_nightsvilleentrance_hole_op_box",  { alp = 1 }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hairpin", use_hairpin_beg, private.room_objname );
  cmn.AddSubscriber( "use_hairpin", use_hairpin_inv );
  cmn.AddSubscriber( "use_hairpin", use_hairpin_end, private.room_objname );
  cmn.AddSubscriber( "use_hairpin_inv", use_hairpin_inv, private.room_objname );
  cmn.AddSubscriber( "use_hairpin_beg", use_hairpin_beg, private.room_objname );
  cmn.AddSubscriber( "use_hairpin_end", use_hairpin_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_plates () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_plates" ] = {
    type = "use",
    inv_obj = "inv_plates",
    use_place = "obj_dangerousbridge_use_plates",
    room = private.room_objname,
    zz = "zz_dangerousbridge",
    zz_gate = "gzz_nightsvilleentrance_dangerousbridge"
  };
  local use_plates_inv = function ()
  
    interface.InventoryItemRemove( "inv_plates" );
  
  end;
  local use_plates_beg = function ()
  
    ObjDelete( "obj_dangerousbridge_use_plates" );
  
  end;
  local use_plates_end = function ()
  
    ObjSet( "anm_dangerousbridge_bridge_after_use", { active = true, visible = true } );
    ObjDelete( "obj_dangerousbridge_board" );
    ObjDelete( "spr_dangerousbridge_broken" );

    if ( cmn.IsEventDone( "get_pikepole" ) and cmn.IsEventDone( "clk_rope" ) ) then

      ObjDelete( "gzz_nightsvilleentrance_dangerousbridge" ); 
      ObjMultiSet({
        { "grm_nightsvilleentrance_glade", { input = true, active = true }}
      });
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_nightsvilleentrance_glade_focus");
    end;
      
    end
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_plates", use_plates_beg, private.room_objname );
  cmn.AddSubscriber( "use_plates", use_plates_inv );
  cmn.AddSubscriber( "use_plates", use_plates_end, private.room_objname );
  cmn.AddSubscriber( "use_plates_inv", use_plates_inv, private.room_objname );
  cmn.AddSubscriber( "use_plates_beg", use_plates_beg, private.room_objname );
  cmn.AddSubscriber( "use_plates_end", use_plates_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_knife_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_knife_1" ] = {
    type = "use",
    inv_obj = "inv_knife",
    use_place = "obj_dangerousbridge_use_knife",
    room = private.room_objname,
    zz = "zz_dangerousbridge",
    zz_gate = "gzz_nightsvilleentrance_dangerousbridge"
  };
  local use_knife_1_beg = function ()
  
    ObjDelete( "obj_dangerousbridge_use_knife" );
    ObjDelete( "anm_dangerousbridge_false_use" );
  
  end;
  local use_knife_1_end = function ()
  
    ObjDelete( "anm_dangerousbridge_knife" );
    ObjDelete( "spr_dangerousbridge_over_log" );

    ObjMultiSet({ 

      { "spr_dangerousbridge_sharpened", { alp = 1      }},
      { "obj_dangerousbridge_clk_log",   { input = true }},
      { "obj_dangerousbridge_log",   { alp = 1 }},

    });

  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_knife_1", use_knife_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_knife_1", use_knife_1_end, private.room_objname );
  cmn.AddSubscriber( "use_knife_1_beg", use_knife_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_knife_1_end", use_knife_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_4" ] = {
    type = "use",
    inv_obj = "inv_elf_2",
    use_place = "obj_dangerousbridge_use_elf",
    room = private.room_objname,
    zz = "zz_dangerousbridge",
    zz_gate = "gzz_nightsvilleentrance_dangerousbridge"
  };
  local use_elf_4_beg = function ()
  
    ObjDelete( "obj_dangerousbridge_use_elf"         );
    ObjDelete( "anm_dangerousbridge_bridge_broken_1" ); 

    ObjMultiSet({ 
      { "spr_dangerousbridge_broken", {alp = 1}},
      { "obj_dangerousbridge_rope",   {alp = 1}},
      { "vid_dangerousbridge_elf",    {alp = 1}},
    });
  
  end;
  local use_elf_4_end = function ()
  
    ObjDelete( "spr_dangerousbridge_broken");
    ObjDelete( "obj_dangerousbridge_rope"  );
    ObjDelete( "vid_dangerousbridge_elf"   );

    ObjSet( "obj_dangerousbridge_bridge_broken_2", { alp = 1 } );

    if ( cmn.IsEventDone( "clk_log" ) ) then

      ObjSet( "obj_dangerousbridge_clk_rope", { input = true } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_4", use_elf_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_4", use_elf_4_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_beg", use_elf_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_4_end", use_elf_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_mechanismpart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_mechanismpart" ] = {
    type = "use",
    inv_obj = "inv_mechanismpart",
    use_place = "obj_entrance_use_mechanismpart",
    room = private.room_objname,
    zz = "zz_entrance",
    zz_gate = "gzz_nightsvilleentrance_entrance"
  };
  local use_mechanismpart_inv = function ()
  
    interface.InventoryItemRemove( "inv_mechanismpart" );
  
  end;
  local use_mechanismpart_beg = function ()
  
    ObjDelete( "obj_entrance_use_mechanismpart" );
  
  end;
  local use_mechanismpart_end = function ()
  
   
    ObjDelete( "gzz_nightsvilleentrance_entrance" );

    ObjMultiSet({ 
      { "gmg_nightsvilleentrance_gate", { input = true, active = true }},
      { "spr_nightsvilleentrance_entrance_cogwheel", { alp = 1 }},
    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_mechanismpart", use_mechanismpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_mechanismpart", use_mechanismpart_inv );
  cmn.AddSubscriber( "use_mechanismpart", use_mechanismpart_end, private.room_objname );
  cmn.AddSubscriber( "use_mechanismpart_inv", use_mechanismpart_inv, private.room_objname );
  cmn.AddSubscriber( "use_mechanismpart_beg", use_mechanismpart_beg, private.room_objname );
  cmn.AddSubscriber( "use_mechanismpart_end", use_mechanismpart_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_providence_carrot () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_providence_carrot" ] = {
    type = "use",
    inv_obj = "inv_prv_carrot",
    use_place = "obj_nightsvilleentrance_use_prv_item_1",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence" 
  };
  local use_providence_carrot_inv = function ()
  
    interface.ProvidePanelItemRemove( "inv_prv_carrot" );
  
  end;
  local use_providence_carrot_beg = function ()
  
    ObjDelete( "obj_nightsvilleentrance_use_prv_item_1" );
  
  end;
  local use_providence_carrot_end = function ()
  
    ObjSet( "spr_nightsvilleentrance_prv_carrot_used", { alp = 1 } );
    ObjDelete( "spr_nightsvilleentrance_prv_carrot_light" );
    ObjSet( "spr_nightsvilleentrance_carrot", { visible = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_providence_carrot", use_providence_carrot_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_carrot", use_providence_carrot_inv );
  cmn.AddSubscriber( "use_providence_carrot", use_providence_carrot_end, private.room_objname );
  cmn.AddSubscriber( "use_providence_carrot_inv", use_providence_carrot_inv, private.room_objname );
  cmn.AddSubscriber( "use_providence_carrot_beg", use_providence_carrot_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_carrot_end", use_providence_carrot_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_hole_bag () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_hole_bag" ] = {

      type = "click",
      use_place = "obj_hole_clk_bag",
      room = private.room_objname,
      zz = "zz_hole",
      zz_gate = "gzz_nightsvilleentrance_hole"   
  };
  local clk_hole_bag_beg = function ()
  
    ObjDelete(  "obj_hole_clk_bag" );
  
  end;
  local clk_hole_bag_end = function ()

    ObjMultiSet({ 
      { "obj_hole_use_hairpin", { input = true                                }},
      { "spr_hole_open_bag",    { input = true, alp = 1                       }},
      { "spr_hole_file",        { input = true, visible = true, active = true }},

      { "spr_nightsvilleentrance_hole_file", { alp = 1                        }},
    });
    ObjDelete( "spr_nightsvilleentrance_hole_backpack" );


  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_hole_bag", clk_hole_bag_beg, private.room_objname );
  cmn.AddSubscriber( "clk_hole_bag", clk_hole_bag_end, private.room_objname );
  cmn.AddSubscriber( "clk_hole_bag_beg", clk_hole_bag_beg, private.room_objname );
  cmn.AddSubscriber( "clk_hole_bag_end", clk_hole_bag_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_log () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_log" ] = {
      type = "click",
      use_place = "obj_dangerousbridge_clk_log",
      room = private.room_objname,
      zz = "zz_dangerousbridge",
      zz_gate = "gzz_nightsvilleentrance_dangerousbridge"   
  };
  local clk_log_beg = function ()
    
    ObjDelete(  "obj_dangerousbridge_clk_log" );
    
  end;
  local clk_log_end = function ()

    ObjMultiSet({ 
      { "obj_dangerousbridge_log_2",                      { alp = 1 }},
      { "spr_nightsvilleentrance_dangerousbridge_post_2", { alp = 1 }},
      { "obj_dangerousbridge_over_pikepole", { input = true } },
    });

    ObjDelete( "spr_nightsvilleentrance_dangerousbridge_post_1" );

    ObjDelete( "obj_dangerousbridge_log" );

    if ( cmn.IsEventDone( "use_elf_4" ) ) then
      ObjSet( "obj_dangerousbridge_clk_rope", { input = true } );
    end;
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_log", clk_log_beg, private.room_objname );
  cmn.AddSubscriber( "clk_log", clk_log_end, private.room_objname );
  cmn.AddSubscriber( "clk_log_beg", clk_log_beg, private.room_objname );
  cmn.AddSubscriber( "clk_log_end", clk_log_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_rope () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_rope" ] = {
      type = "click",
      use_place = "obj_dangerousbridge_clk_rope",
      room = private.room_objname,
      zz = "zz_dangerousbridge",
      zz_gate = "gzz_nightsvilleentrance_dangerousbridge"   
  };
  local clk_rope_beg = function ()
    
    ObjDelete(  "obj_dangerousbridge_clk_rope" );
    
  end;
  local clk_rope_end = function ()

    ObjMultiSet({ 
      { "spr_dangerousbridge_rope_4", { alp = 1 }},
      --{ "spr_dangerousbridge_rope_5", { alp = 1 }},
      { "obj_dangerousbridge_bridge", { alp = 1 }},
    });

    ObjDelete( "obj_dangerousbridge_bridge_broken_2" );

    --ObjDelete(  "obj_dangerousbridge_rope" );
    --ObjDelete(  "spr_dangerousbridge_broken" );

    if ( cmn.IsEventDone( "get_pikepole" ) and cmn.IsEventDone( "use_plates" )) then
      ObjDelete( "gzz_nightsvilleentrance_dangerousbridge" ); 
      ObjSet( "grm_nightsvilleentrance_glade", { input = true, active = true } );
    end;
     
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_rope", clk_rope_beg, private.room_objname );
  cmn.AddSubscriber( "clk_rope", clk_rope_end, private.room_objname );
  cmn.AddSubscriber( "clk_rope_beg", clk_rope_beg, private.room_objname );
  cmn.AddSubscriber( "clk_rope_end", clk_rope_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_providence_rope () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_providence_rope" ] = {
    type = "use",
    inv_obj = "spr_nightsvilleentrance_prv_rope",
    use_place = "obj_nightsvilleentrance_prv_item_1",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"    
  };
  local clk_providence_rope_beg = function ()
  
    ObjDelete(  "obj_nightsvilleentrance_prv_item_1" );
  
  end;
  local clk_providence_rope_end = function ()
  
    ObjDelete( "spr_nightsvilleentrance_prv_rope" );
    ObjDelete( "spr_nightsvilleentrance_prv_rope_light" );
    ObjSet( "spr_nightsvilleentrance_prv_rope_used", { alp = 1 } );    
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_providence_rope", clk_providence_rope_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_rope", clk_providence_rope_end, private.room_objname );
  cmn.AddSubscriber( "clk_providence_rope_beg", clk_providence_rope_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_rope_end", clk_providence_rope_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_providence_bone () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_providence_bone" ] = {
    type = "click",
    inv_obj = "spr_nightsvilleentrance_prv_bone",
    use_place = "obj_nightsvilleentrance_prv_item_2",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"  
  };
  local clk_providence_bone_beg = function ()
  
    ObjDelete(  "obj_nightsvilleentrance_prv_item_2" );
  
  end;
  local clk_providence_bone_end = function ()

    ObjDelete( "spr_nightsvilleentrance_prv_bone" );
    ObjDelete( "spr_nightsvilleentrance_prv_bone_light" );
    ObjSet( "spr_nightsvilleentrance_prv_bone_used", { alp = 1 } );
    ObjSet( "spr_nightsvilleentrance_bone", { visible = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_providence_bone", clk_providence_bone_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_bone", clk_providence_bone_end, private.room_objname );
  cmn.AddSubscriber( "clk_providence_bone_beg", clk_providence_bone_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_bone_end", clk_providence_bone_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_providence_stick () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_providence_stick" ] = {
    type = "click",
    inv_obj = "spr_nightsvilleentrance_prv_stick",
    use_place = "obj_nightsvilleentrance_prv_item_3",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"      
  };
  local clk_providence_stick_beg = function ()
  
    ObjDelete(  "obj_nightsvilleentrance_prv_item_3" );
  
  end;
  local clk_providence_stick_end = function ()
  
    ObjDelete( "spr_nightsvilleentrance_prv_stick" );
    ObjDelete( "spr_nightsvilleentrance_prv_stick_light" );
    ObjSet( "spr_nightsvilleentrance_prv_stick_used", { alp = 1 } );
    ObjSet( "spr_nightsvilleentrance_collar", { visible = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_providence_stick", clk_providence_stick_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_stick", clk_providence_stick_end, private.room_objname );
  cmn.AddSubscriber( "clk_providence_stick_beg", clk_providence_stick_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_stick_end", clk_providence_stick_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_providence_nightsvilleentrance () end;
  --------------------------------------------------------------------------------------------
  local clk_providence_nightsvilleentrance = function ()
  
    if ( not cmn.IsEventDone( "clk_providence_rope" ) or not cmn.IsEventDone( "clk_providence_bone" ) or not cmn.IsEventDone( "clk_providence_stick" ) 
         or ( cmn.IsEventDone( "get_prv_carrot" ) and not cmn.IsEventDone( "use_providence_carrot" ) ) ) then

        int_button_providence.StartActiveProvidence();

    end;
  
  end;
  
  cmn.AddSubscriber( "clk_providence_nightsvilleentrance", clk_providence_nightsvilleentrance, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_nightsvilleentrance_child () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_nightsvilleentrance_child" ] = {

      type = "click",
      use_place = "obj_dlg_nightsvilleentrance_child_focus",
      room = private.room_objname
  };

  local dlg_nightsvilleentrance_child_end = function ()

    ObjDelete( "obj_dlg_nightsvilleentrance_child" );
    ObjDelete( "anm_nightsvilleentrance_child" );
    common_impl.Collectibles2_unlock_crs( "Jack_Foster" );    

  end;
  --------------------------------------------------------------------------------------------
  -- function clk_nightsvilleentrance_bushes () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_nightsvilleentrance_bushes" ] = {
    type = "click",
    use_place = "obj_nightsvilleentrance_clk_bushes",
    room = private.room_objname,
    zz = "slider_right"
  };
  local clk_nightsvilleentrance_bushes = function ()

    ObjDelete( "obj_nightsvilleentrance_clk_bushes" );
    ObjDelete(  "anm_nightsvilleentrance_bushes" );
    ObjDelete(  "anm_nightsvilleentrance_bushes_unlock" );

    ObjMultiSet({ 
      { "anm_nightsvilleentrance_bushes_open",     { alp = 1, playing = true }},
      { "gzz_nightsvilleentrance_dangerousbridge", { input = true, active = true }},
    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_nightsvilleentrance_bushes", clk_nightsvilleentrance_bushes, private.room_objname );

  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_nightsvilleentrance_child", dlg_nightsvilleentrance_child_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_nightsvilleentrance_child_end", dlg_nightsvilleentrance_child_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function dlg_nightsvilleentrance_company () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_nightsvilleentrance_company" ] = {

      type = "click",
      use_place = "obj_dlg_nightsvilleentrance_company_focus",
      room = private.room_objname
  };

  local dlg_nightsvilleentrance_company_end = function ()

    ObjDelete( "obj_dlg_nightsvilleentrance_company" );
    ObjDelete( "anm_nightsvilleentrance_company" );
       
  end;

  local dlg_nightsvilleentrance_company = function ()

    ObjDelete( "anm_nightsvilleentrance_kids" );
    ObjDelete( "anm_nightsvilleentrance_kid" );
    ObjDelete( "anm_nightsvilleentrance_dog" );
    ObjDelete( "obj_nightsvilleentrance_bbt_kids" );   
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_nightsvilleentrance_company", dlg_nightsvilleentrance_company_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_nightsvilleentrance_company", dlg_nightsvilleentrance_company, private.room_objname  );
  cmn.AddSubscriber( "dlg_nightsvilleentrance_company_end", dlg_nightsvilleentrance_company_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function vid_nightsvilleentrance_child () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_nightsvilleentrance_child" ] = {

      type = "click",
      use_place = "obj_vid_nightsvilleentrance_child",
      room = private.room_objname
  };
  local vid_nightsvilleentrance_child_beg = function ()

    ObjDelete( "obj_vid_nightsvilleentrance_child" );

  end;
  local vid_nightsvilleentrance_child_end = function ()

    ObjSet( "obj_dlg_nightsvilleentrance_child", { input = true } );

  end;

  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "vid_nightsvilleentrance_child", vid_nightsvilleentrance_child_beg, private.room_objname );
  cmn.AddSubscriber( "vid_nightsvilleentrance_child", vid_nightsvilleentrance_child_end, private.room_objname  );
  cmn.AddSubscriber( "vid_nightsvilleentrance_child_beg", vid_nightsvilleentrance_child_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_nightsvilleentrance_child_end", vid_nightsvilleentrance_child_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function vid_nightsvilleentrance_providence () end;
  --------------------------------------------------------------------------------------------  
  
  local vid_nightsvilleentrance_prv_end = function ()

    ObjMultiSet({
    --{"gzz_nightsvilleentrance_dangerousbridge", { input = true, active = true, visible = true }},
    {"obj_nightsvilleentrance_clk_bushes", { input = true }},
    });
    local params = { "right" };
    int_slider.Unlock( private.room_objname, params );
   
  end;

  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_nightsvilleentrance_providence", vid_nightsvilleentrance_prv_end, private.room_objname  );
  cmn.AddSubscriber( "vid_nightsvilleentrance_prv_end", vid_nightsvilleentrance_prv_end, private.room_objname  );
 --------------------------------------------------------------------------------------------
  
  local vid_nightsvilleentrance_providence_p2 = function ()

    VidStop( "vid_nightsvilleentrance_providence_p1" );
    ObjSet( "vid_nightsvilleentrance_providence_p2", { playing = true } );    

  end;   

  cmn.AddSubscriber( "vid_nightsvilleentrance_providence_p2", vid_nightsvilleentrance_providence_p2, private.room_objname );
  --------------------------------------------------------------------------------------------
  local vid_nightsvilleentrance_providence_p3 = function ()

    VidStop( "vid_nightsvilleentrance_providence_p2" );
    ObjSet( "vid_nightsvilleentrance_providence_p3", { playing = true } );

  end;   

  cmn.AddSubscriber( "vid_nightsvilleentrance_providence_p3", vid_nightsvilleentrance_providence_p3, private.room_objname );
  --------------------------------------------------------------------------------------------
  local vid_nightsvilleentrance_providence_p4 = function ()

    VidStop( "vid_nightsvilleentrance_providence_p3" );
    VidPlay( "vid_nightsvilleentrance_providence_p4", private.vid_nightsvilleentrance_providence_end );    

  end;   

  cmn.AddSubscriber( "vid_nightsvilleentrance_providence_p4", vid_nightsvilleentrance_providence_p4, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function vid_evidence_4 () end;
  --------------------------------------------------------------------------------------------
  local vid_evidence_4 = function ()

    ObjMultiSet({
     { "obj_dlg_nightsvilleentrance_company", { input = true } },
    });

  end;    
  cmn.AddSubscriber( "vid_evidence_4", vid_evidence_4, private.room_objname );

  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  common_impl.hint.position_slider[ "gzz_nightsvilleentrance_dangerousbridge" ] = { "right" };

  subroom.Define( "zz_entrance" );
  
  function zz_entrance.PreOpen()

    ObjAnimate( "spr_entrance_bush_1", "ang", 1, 0, "",
    { 
      0.0, 0, -0.04, 
      1.6, 0, 0.04,
      3.2, 0, -0.04
    } );

    ObjAnimate( "spr_entrance_bush_2", "ang", 1, 0, "",
    { 
      0.0, 0, -0.04, 
      1.4, 0, 0.04,
      2.8, 0, -0.04
    } );

  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_nightsvilleentrance();

  if ( cmn.IsEventDone( "vid_nightsvilleentrance_child" ) ) then

    int_providence_eye.CheckShow();

    if ( not cmn.IsEventDone( "vid_nightsvilleentrance_providence" ) ) then

      int_button_providence.StartLightProvidence();

    end;

  end;
  int_slider.InitSlider( private.room_objname );

  if cmn.IsEventDone( "win_gate" ) and ng_global.progress[ "std" ][ "opn_nightsvilleentrance" ].left_company ~= 1 then

      private.AnimLeftCompany();

  elseif not cmn.IsEventDone( "win_gate" ) then

     common_impl.PlayAudio( "env", "common/audio/aud_children_env", 1, "", 0 );

  end;

  if ( cmn.IsEventDone( "dlg_nightsvilleentrance_child" ) and ( not cmn.IsEventDone( "get_evidence_2_1" ) ) ) then

    private.get_evidence_2_1();

  end;  
  if ( not cmn.IsEventDone( "vid_nightsvilleentrance_child" ) ) then
    common_impl.PlayTimer( private.vid_nightsvilleentrance_child );
  end;
  common_impl.EnvPlay( { "common/audio/aud_nightsvilleentrance_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.PreOpen()

  interface.InvestigationButtonCheck();
  
  common_impl.MorphItemMorphing();  

end;
--*********************************************************************************************************************
function public.Close()
  
  int_slider.CloseSlider( private.room_objname );

  common_impl.StopAudio( "env", "common/audio/aud_children_env", 1 );

  if ( cmn.IsEventDone( "dlg_nightsvilleentrance_company" ) ) and ( ObjGet( "anm_nightsvilleentrance_kids" ) ) then

    cmn.CallEventHandler( "dlg_nightsvilleentrance_company" );

  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()

  if ( not cmn.IsEventDone( "vid_nightsvilleentrance_providence" ) ) then

    int_button_providence.StopLightProvidence();

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_secateurs()

  local item = "inv_secateurs";

  if ( common.ApplyObj( item, "obj_hole_use_secateurs", true ) ) then

    cmn.CallEventHandler( "use_secateurs_inv" );
    cmn.CallEventHandler( "use_secateurs_beg" );

    ObjSet( "anm_hole_pruner", { alp = 1 } );

    local func_after = function ()

      cmn.SetEventDone( "use_secateurs" );
      cmn.CallEventHandler( "use_secateurs_end" );
      common_impl.Lock( false );

    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_secateurs", 0, "", 0 );

    AnimPlay( "anm_hole_pruner", "DoAnim", func_after );

    return true;

  elseif common.ApplyObj( item, "gzz_nightsvilleentrance_hole", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_hole", nil, { 512, 384 } );

    return true;   

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hairpin()

  local item = "inv_hairpin";

  if ( common.ApplyObj( item, "obj_hole_use_hairpin", true ) ) then

    cmn.CallEventHandler( "use_hairpin_inv" );
    cmn.CallEventHandler( "use_hairpin_beg" );

    local func_after = function ()

      local end_func = function ()

        common_impl.Lock(false);
        cmn.SetEventDone( "use_hairpin" );
        cmn.CallEventHandler( "use_hairpin_end" );

      end;

      ObjSet( "anm_hole_hairpin", { alp = 1 } );
      ObjAnimate( "spr_hole_open_firstaid", "alp", 0, 0, end_func,
      { 
        0.0, 0, 0.0, 
        0.7, 0, 1.0
      } );
    
    end;

    common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_pin", 0, "", 0 );

    AnimPlay( "anm_hole_hairpin", "DoAnim", func_after );

    return true;

  elseif common.ApplyObj( item, "gzz_nightsvilleentrance_hole", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_hole", nil, { 512, 384 } );

    return true;   

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_plates()

  local item = "inv_plates";
  
  if ( common.ApplyObj( item, "obj_dangerousbridge_use_plates", true ) and cmn.IsEventDone( "clk_rope" ) ) then

    cmn.CallEventHandler( "use_plates_inv" );
    cmn.CallEventHandler( "use_plates_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_plates" );
      cmn.CallEventHandler( "use_plates_end" );

      if ( cmn.IsEventDone( "get_pikepole" ) and cmn.IsEventDone( "clk_rope" )) then
        common.CloseSubRoom();
      end;

      common_impl.Lock( false );

    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_boards", 0, "", 0 );

    ObjAnimate( "obj_dangerousbridge_board", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  elseif common.ApplyObj( item, "gzz_nightsvilleentrance_dangerousbridge", false ) and cmn.IsEventDone( "clk_rope" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_dangerousbridge", nil, { 512, 384 } );

    return true; 

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_knife_1()

  local item = "inv_knife";

  if ( common.ApplyObj( item, "obj_dangerousbridge_use_knife", true ) ) then

    interface.InventoryItemRemove( "inv_knife" );
    cmn.CallEventHandler( "use_knife_1_beg" );

    local func_after = function ()

      interface.InventoryItemAdd( "inv_knife" );
      cmn.SetEventDone( "use_knife_1" );
      cmn.CallEventHandler( "use_knife_1_end" );
      common_impl.Lock( false );

    end;

    common_impl.Lock( true );
    
    ObjSet( "obj_dangerousbridge_log", { alp = 0 });
    ObjSet( "anm_dangerousbridge_knife", { alp = 1 });
    AnimPlay( "anm_dangerousbridge_knife", "DoAnim", func_after );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_knife_log", 0, "", 0 );

    return true;

  elseif ( common.ApplyObj( item, "obj_hole_use_secateurs", true ) ) then

    common_impl.ShowBbt( 'bbt_nightsvilleentrance_hole_wrong', 1 );

    return true;

  elseif ( common.ApplyObj( item, "gzz_nightsvilleentrance_dangerousbridge", false ) and ObjGet("gzz_nightsvilleentrance_dangerousbridge").input )  then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_dangerousbridge", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_elf_4()

  local item = "inv_elf_2";

  if ( common.ApplyObj( item, "obj_dangerousbridge_use_elf", true ) ) then

    interface.InventoryItemRemove( "inv_elf_2" );
    cmn.CallEventHandler( "use_elf_4_beg" );
    
    local func_after = function ()

      ObjSet( "spr_dangerousbridge_elf", { alp = 1 } );
      interface.InventoryItemAdd( "inv_elf_2", "spr_dangerousbridge_elf" );
      cmn.SetEventDone( "use_elf_4" );
      cmn.CallEventHandler( "use_elf_4_end" );
      common_impl.Lock( false );

    end;

    common_impl.Lock( true );
    interface.InventoryItemRemove( "inv_elf_2" );
    VidPlay( "vid_dangerousbridge_elf", func_after );

    common_impl.PlayAudio( "sfx", "common/audio/aud_dangerousbridge_elf", 0, "", 0 );

    return true;

  elseif common.ApplyObj( item, "gzz_nightsvilleentrance_dangerousbridge", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_dangerousbridge", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_mechanismpart()

  local item = "inv_mechanismpart";

  if ( common.ApplyObj( item, "obj_entrance_use_mechanismpart", true ) ) then

    cmn.CallEventHandler( "use_mechanismpart_inv" );
    cmn.CallEventHandler( "use_mechanismpart_beg" );

    local func_after = function ()

      cmn.SetEventDone( "use_mechanismpart" );
      cmn.CallEventHandler( "use_mechanismpart_end" );
      common.CloseSubRoom();
      cmn.GotoRoom( "mg_gate" );
      common_impl.Lock( false ); 

    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_gear", 0, "", 0 );

    ObjAnimate( "spr_entrance_detail", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  elseif common.ApplyObj( item, "gzz_nightsvilleentrance_entrance", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_entrance", nil, { 512, 384 } );

    return true;  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_providence_carrot()

 local item = "inv_prv_carrot";

  if ( ObjIntersect( item, "obj_nightsvilleentrance_use_prv_item_1" ) and int_providence.show ) then

    cmn.CallEventHandler( "use_providence_carrot_inv" );
    cmn.CallEventHandler( "use_providence_carrot_beg" );
    

    local func_after = function ()

      common_impl.Lock(false);
      cmn.CallEventHandler( "use_providence_carrot_end" );

      if cmn.IsEventDone( "clk_providence_stick" ) and cmn.IsEventDone( "clk_providence_rope" ) 
       and cmn.IsEventDone( "clk_providence_bone" ) then

        int_button_providence.StopActiveProvidence();
        private.anim_providence( function() cmn.SetEventDone( "use_providence_carrot" ); end );

      else

        cmn.SetEventDone( "use_providence_carrot" );

      end;

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_providence_carrot", 0, "", 0 );

    ObjAnimate( "spr_nightsvilleentrance_prv_carrot_used", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );


    ObjAnimate( "spr_nightsvilleentrance_prv_carrot_light", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.get_prv_carrot()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );

  cmn.SetEventDone( "get_prv_carrot" );
  cmn.CallEventHandler( "get_prv_carrot" );

end;
--------------------------------------------------------------------------------------------
function private.get_prv_carrot_silhouette()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );

  cmn.SetEventDone( "get_prv_carrot_silhouette" );
  cmn.CallEventHandler( "get_prv_carrot_silhouette" );

end;
--------------------------------------------------------------------------------------------
function private.get_knife()
  
  iOS_RateMe();
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_knife" );
  cmn.CallEventHandler( "get_knife" );

end;
--------------------------------------------------------------------------------------------
function private.get_file()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_file" );
  cmn.CallEventHandler( "get_file" );

end;
--------------------------------------------------------------------------------------------
function private.get_bandage()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_bandage" );
  cmn.CallEventHandler( "get_bandage" );
  if ( cmn.IsEventDone("get_medicine") and common_impl.IsGetCoin("get_coin_11") ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_medicine()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_medicine" );
  cmn.CallEventHandler( "get_medicine" );
  if ( cmn.IsEventDone("get_bandage") and common_impl.IsGetCoin("get_coin_11") ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_pikepole()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_pikepole" );
  cmn.CallEventHandler( "get_pikepole" );

end;
--------------------------------------------------------------------------------------------
function private.get_evidence_2_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page", 0, "", 0 );

  local func_end = function ()

    ObjSet( "spr_nightsvilleentrance_evidence_2_1", { alp = 1 } );
  
    interface.InvestigationButtonItemAdd( "evidence_2_1", "spr_nightsvilleentrance_evidence_2_1", function() interface.KeyTaskAdd( 'save_dog' ); end  );

    cmn.SetEventDone( "get_evidence_2_1" );
    cmn.CallEventHandler( "get_evidence_2_1" );
  
  end;

  
  ObjSet( "spr_nightsvilleentrance_evidence_2_1", { alp = 0 } );
  interface.DialogEvidenceShow( "evidence_2_1", func_end );

end;
--------------------------------------------------------------------------------------------
function private.get_mechanismpart()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  common_impl.PlayAudio( "sfx", "common/audio/aud_interactive_end", 0, "", 0 );

  cmn.SetEventDone( "get_mechanismpart" );
  cmn.CallEventHandler( "get_mechanismpart" );
 
  ObjDelete( "obj_nightsvilleentrance_company_mmg" );

end;
--------------------------------------------------------------------------------------------
function private.get_coin11()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_11");
    cmn.CallEventHandler("get_coin_11");

    if ( cmn.IsEventDone( "get_medicine" ) and cmn.IsEventDone( "get_bandage" ) ) then
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_hole_coin", func_after ); 

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_providence_rope()

  cmn.CallEventHandler( "clk_providence_rope_beg" );

  local func_after = function ()

    common_impl.Lock(false);

    cmn.CallEventHandler( "clk_providence_rope_end" );

    if cmn.IsEventDone( "clk_providence_stick" ) and cmn.IsEventDone( "use_providence_carrot" ) 
       and cmn.IsEventDone( "clk_providence_bone" ) then

      private.anim_providence( function() cmn.SetEventDone( "clk_providence_rope" ); end );
     

    else 

      if ( cmn.IsEventDone( "clk_providence_stick" ) and cmn.IsEventDone( "clk_providence_bone" ) and
      ( not cmn.IsEventDone( "get_prv_carrot" ) or cmn.IsEventDone( "use_providence_carrot" ) ) ) then

        int_button_providence.StopActiveProvidence();

      end;

      cmn.SetEventDone( "clk_providence_rope" );

    end;

  end;
  
  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_collar", 0, "", 0 );
  ObjSet( "spr_nightsvilleentrance_prv_rope", { alp = 0 } );
  ObjAnimate( "spr_nightsvilleentrance_prv_rope_used", "alp", 0, 0, func_after, { 0, 0, 0, 0.1, 0, 0, 0.3, 0, 1 } );

end;
--------------------------------------------------------------------------------------------
function private.clk_providence_bone()

  cmn.CallEventHandler( "clk_providence_bone_beg" );

  local func_after = function ()

    common_impl.Lock(false);

    cmn.CallEventHandler( "clk_providence_bone_end" );

    if cmn.IsEventDone( "clk_providence_stick" ) and cmn.IsEventDone( "use_providence_carrot" ) 
       and cmn.IsEventDone( "clk_providence_rope" ) then

      private.anim_providence( function() cmn.SetEventDone( "clk_providence_bone" ); end );
      
    else 

      if ( cmn.IsEventDone( "clk_providence_stick" ) and cmn.IsEventDone( "clk_providence_rope" ) and
      ( not cmn.IsEventDone( "get_prv_carrot" ) or cmn.IsEventDone( "use_providence_carrot" ) ) ) then

        int_button_providence.StopActiveProvidence();

      end;

      cmn.SetEventDone( "clk_providence_bone" );

    end;

  end;
  
  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_bone", 0, "", 0 );
  ObjSet( "spr_nightsvilleentrance_prv_bone", { alp = 0 } );
  ObjAnimate( "spr_nightsvilleentrance_prv_bone_used", "alp", 0, 0, func_after, { 0, 0, 0, 0.1, 0, 0, 0.3, 0, 1 } );

end;
--------------------------------------------------------------------------------------------
function private.clk_providence_stick()

  cmn.CallEventHandler( "clk_providence_stick_beg" );

  local func_after = function ()

    common_impl.Lock(false);

    cmn.CallEventHandler( "clk_providence_stick_end" );

    if cmn.IsEventDone( "clk_providence_bone" ) and cmn.IsEventDone( "use_providence_carrot" ) 
       and cmn.IsEventDone( "clk_providence_rope" ) then

      private.anim_providence( function() cmn.SetEventDone( "clk_providence_stick" ); end );
 
    else 

      if ( cmn.IsEventDone( "clk_providence_bone" ) and cmn.IsEventDone( "clk_providence_rope" ) and
      ( not cmn.IsEventDone( "get_prv_carrot" ) or cmn.IsEventDone( "use_providence_carrot" ) ) ) then

        int_button_providence.StopActiveProvidence();

      end;

      cmn.SetEventDone( "clk_providence_stick" );

    end;

  end;

  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_knife", 0, "", 0 );
  ObjSet( "spr_nightsvilleentrance_prv_stick", { alp = 0 } );
  ObjAnimate( "spr_nightsvilleentrance_prv_stick_used", "alp", 0, 0, func_after, { 0, 0, 0, 0.1, 0, 0, 0.3, 0, 1 } );

end;
--------------------------------------------------------------------------------------------
function private.anim_providence( func_execute )

  common_impl.ShowBbt( "bbt_providence_allitems" );

  int_button_providence.StopActiveProvidence();

  local array_objects = {
    "spr_nightsvilleentrance_prv_carrot_used",
    "spr_nightsvilleentrance_prv_bone_used",
    "spr_nightsvilleentrance_prv_rope_used",
    "spr_nightsvilleentrance_prv_stick_used" }

  local func_end = function()

    for i = 1, #array_objects do
      ObjAttach( array_objects[ i ], "rm_nightsvilleentrance_providence" );
      ObjSet( array_objects[ i ], { alp = 1 } );
    end;
    common_impl.Lock( false );    
    private.vid_nightsvilleentrance_providence( func_execute );

  end;
  
  common_impl.Lock( true );
  for i = 1, #array_objects do
     common_impl.PlayEffectHO( array_objects[ i ], func_end, 3, "assets/interface/resources/effect_mask" );
     func_end = nil;
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_ready", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.clk_hole_bag()

  cmn.CallEventHandler( "clk_hole_bag_beg" );

  local func_after = function ()

    common_impl.Lock(false);
    cmn.SetEventDone( "clk_hole_bag" );
    cmn.CallEventHandler( "clk_hole_bag_end" );

  end;
  
  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_clothes", 0, "", 0 );

  ObjAnimate( "spr_hole_open_bag", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

end;
--------------------------------------------------------------------------------------------
function private.clk_log()

  cmn.CallEventHandler( "clk_log_beg" );

  local func_after = function ()

    common_impl.Lock(false);
    cmn.SetEventDone( "clk_log" );
    cmn.CallEventHandler( "clk_log_end" );

  end;
  
  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_use_log_sharp", 0, "", 0 );

  ObjAnimate( "obj_dangerousbridge_log", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );

  ObjAnimate( "obj_dangerousbridge_log_2", "alp", 0, 0, func_after,
    {
      0.0, 0, 0.0,
      0.3, 0, 1.0
    } );

end;
--------------------------------------------------------------------------------------------
function private.clk_rope()

  cmn.CallEventHandler( "clk_rope_beg" );

  local func_after = function ()

    common_impl.Lock(false);
    cmn.SetEventDone( "clk_rope" );
    cmn.CallEventHandler( "clk_rope_end" );
    if ( cmn.IsEventDone( "get_pikepole" ) and cmn.IsEventDone( "use_plates" )) then
      common.CloseSubRoom();
    end;

  end;
  
  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_rope", 0, "", 0 );


--
  ObjAnimate( "spr_dangerousbridge_rope_4", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

  ObjAnimate( "obj_dangerousbridge_bridge_broken_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );

  ObjAnimate( "obj_dangerousbridge_bridge", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );    

end;
--*********************************************************************************************************************
function private.clk_bushes()

  local func_after = function ( )

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_nightsvilleentrance_bushes" );
    cmn.CallEventHandler( "clk_nightsvilleentrance_bushes" );

  end;
  
  ObjSet( "anm_nightsvilleentrance_bushes", { alp = 0, active = false } );
  ObjSet( "anm_nightsvilleentrance_bushes_unlock", { alp = 1 } );
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_weed_near_nightsville_door", 0, "", 0 );
  AnimPlay( "anm_nightsvilleentrance_bushes_unlock", "DoAnim", func_after )

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-------------------------------------------------------------------------------------
function private.drag_rope ()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_nightsvilleentrance_prv_rope", { pos_z = 10 } );

end;
-------------------------------------------------------------------------------------
function private.drop_rope ()

  local item = "spr_nightsvilleentrance_prv_rope";

  ObjSet( item, { pos_z = 0 } );

  if ( ObjIntersect( item, "obj_nightsvilleentrance_prv_item_1" ) ) then

    private.clk_providence_rope();

  end;

end;
-------------------------------------------------------------------------------------
function private.drag_bone ()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_nightsvilleentrance_prv_bone", { pos_z = 10 } );

end;
-------------------------------------------------------------------------------------
function private.drop_bone ()

  local item = "spr_nightsvilleentrance_prv_bone";

  ObjSet( item, { pos_z = 0 } );

  if ( ObjIntersect( item, "obj_nightsvilleentrance_prv_item_2" ) ) then

    private.clk_providence_bone();

  end;

end;
-------------------------------------------------------------------------------------
function private.drag_stick ()

   common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_nightsvilleentrance_prv_stick", { pos_z = 10 } );

end;
-------------------------------------------------------------------------------------
function private.drop_stick ()

  local item = "spr_nightsvilleentrance_prv_stick";

  ObjSet( item, { pos_z = 0 } );

  if ( ObjIntersect( item, "obj_nightsvilleentrance_prv_item_3" ) ) then

    private.clk_providence_stick();

  end;

end;

function private.clk_door()

    local func_after = function()

      common_impl.Lock(false);
      common_impl.ShowBbt( 'bbt_entrance_use_mechanismpart' );

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_touch_big_wood", 0, "", 0 );

    common_impl.Lock(true);
    ObjAnimate( "spr_entrance_door_1", "pos_x", 0, 0, func_after,
    { 
      0.0, 0, 121, 
      0.3, 0, 123,
      0.6, 0, 121
    } );

    ObjAnimate( "spr_entrance_door_2", "pos_x", 0, 0, "",
    { 
      0.0, 0, -34, 
      0.3, 0, -36,
      0.6, 0, -34,
    } );

end;
--*********************************************************************************************************************
function private.ClickDlgPaper( number )
  
   local func_after = function()

      common_impl.Lock( false );

      ObjSet( "spr_nightsvilleentrance_child_paper_"..number,  { input = false } );

      if number <= 2 then
  
        ObjSet( "spr_nightsvilleentrance_child_paper_"..( number + 1 ), { input = true } );

      else

        ObjSet( "obj_nightsvilleentrance_child_mmg", { input = false, pos_z = 1,alp = 0 } ); 
        ObjAttach( "obj_nightsvilleentrance_child_mmg", "obj_nightsvilleentrance_child" );

        common_impl.PlayAudio( "sfx", "common/audio/aud_interactive_end", 0, "", 0 );

        common_impl.continue_visible = false;
        common_impl.frases = { 2,3,4 }; 
        common_impl.dial_icons = { 'owlman', 'nightsville', 'oliver' };
        common_impl.DialogCharacterShowDialogQuestions( 3 ); 
     
      end;
      
      
   end;
     
   common_impl.Lock( true );
    
   if number <= 2 then

     ObjAnimate( "spr_nightsvilleentrance_child_paper_"..number, "alp", 0, 0, func_after, { 0,0,1, 0.1,0,0 } );
     ObjAnimate( "spr_nightsvilleentrance_child_paper_"..( number + 1 ), "alp", 0, 0, "", { 0,0,0, 0.1,0,1 } );
     common_impl.PlayAudio( "sfx", "common/audio/aud_paper_open", 0, "", 0 );

   else
    
     ObjAnimate( "spr_nightsvilleentrance_child_paper_"..number, "alp", 0, 0, func_after, { 0,0,1, 0.3,0,0 } );
     ObjAnimate( "spr_nightsvilleentrance_child_paper_"..number, "scale_xy", 0, 0, "", { 0,0,1,1, 0.3,0,1.1,1.1 } );
     common_impl.PlayAudio( "sfx", "common/audio/aud_paper_close", 0, "", 0 );

   end;
    

end;    
--*********************************************************************************************************************
function private.ShowDlgPaper()

   ObjSet( "anm_nightsvilleentrance_child", { alp = 1 } );
   ObjSet( "anm_nightsvilleentrance_child_2", { alp = 0 } );

   common_impl.DialogCharacterMmgShow( 'child', 550, 400 );

end;
--*********************************************************************************************************************
function private.ShowDlgClock()

   ObjSet( "anm_nightsvilleentrance_child", { alp = 1 } );
   ObjSet( "anm_nightsvilleentrance_child_clock", { alp = 0 } );

   common_impl.DialogCharacterMmgShow( 'child', 350, 300, nil, 2 );

end;
--*********************************************************************************************************************
function private.HideDlgClock()

  common_impl.DialogCharacterMmgHide( 'child', nil, 2  );

  common_impl.DialogCharacterHide();

end;
--*********************************************************************************************************************
function private.ClkDlgClock()

  local func_after = function()

      common_impl.Lock( false );

      ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = private.HideDlgClock } );
    
      ObjSet( "spr_nightsvilleentrance_child_clock", { input = false } );

  end;

  common_impl.Lock( true );

  ObjAnimate( "spr_nightsvilleentrance_child_clock", "alp", 0, 0, func_after, { 0,0,1, 0.3,0,0 } );
  ObjAnimate( "spr_nightsvilleentrance_child_clock_open", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_child_clock", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.ClkCompanyDialPart( number )

  local func_after = function()

      common_impl.Lock( false );
      private.company_state[number] = private.company_state[number] + 1;

      if private.company_state[number] == 13 then

        private.company_state[number] = 3;

      end;
    
      private.CompanyDialCheckWin();
      
  end;
  
  common_impl.Lock( true );
  
  local coords = ObjGet( "spr_nightsvilleentrance_company_text_"..number );
  local anim_coords = { { 3.4, 20.4 }, { 4.3, 21 }, { 4.9, 20.8 } };

  if private.company_state[number] == 12 then 
    
    coords.pos_x = private.company_coords[number][1];
    coords.pos_y = private.company_coords[number][2];

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_jack_amulet_wheel", 0, "", 0 );
  
  ObjAnimate( "spr_nightsvilleentrance_company_text_"..number, "pos_xy", 0, 0, func_after, { 0,0,coords.pos_x,coords.pos_y, 0.3,0, ( coords.pos_x - anim_coords[number][1] ), ( coords.pos_y - anim_coords[number][2] ) } );


end;
--*********************************************************************************************************************
function private.CompanyDialCheckWin( )

  local win = { 3, 5, 8 }
  local count = 0;

  for i = 1, 3 do

      if  private.company_state[i] == win[i] then

        count = count + 1;
     
      end;

  end;

  if count == 3 then

    common_impl.PlayAudio( "sfx", "common/audio/aud_jack_amulet_win", 0, "", 0 );

    ObjSet( "obj_nightsvilleentrance_company_mmg_open", { alp = 1, input = true } );
    ObjSet( "anm_nightsvilleentrance_company_giars_1", { alp = 0 } );
    ObjSet( "obj_nightsvilleentrance_company_mmg_clk", { input = false } );
    ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = private.ClkCompanyWheel } );
    ObjSet( "spr_nightsvilleentrance_company_wheel", { event_mdown = private.ClkCompanyWheel } );
    
  end;  

end;
--*********************************************************************************************************************
function private.ClkCompanyWheel()
  
  ObjSet( "spr_nightsvilleentrance_company_wheel", { alp = 1 } );
  ObjSet( "anm_nightsvilleentrance_company_giars_2", { alp = 1 } );

  common_impl.DialogCharacterHide();

end;
--*********************************************************************************************************************
function private.ClkCompanyDialMmg()

  common_impl.DialogCharacterMmgShow( "company", 400, 350  );

  ObjSet( "anm_nightsvilleentrance_company_child_wheel", { alp = 0 } );
  ObjSet( "anm_nightsvilleentrance_company_child", { alp = 1 } );

  private.company_state = { 2, 2, 1 };
  private.company_coords = { { -24, 44 }, { 22, 48 }, { 64, 50 } };

end;
-------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )

  if dlg_name == "child" then

    ObjSet( "anm_nightsvilleentrance_kid", { alp = 0 });

    if count_txt == 1 then 

       common_impl.continue_visible = false;
       common_impl.frases = { 1 }; 
       common_impl.dial_icons = { 'drawing' };
       common_impl.DialogCharacterShowDialogQuestions( 1 ); 

    elseif count_txt == 2 then 

       common_impl.continue_visible = false;
       ObjSet( "obj_int_dialog_character_input", { event_mdown = private.ShowDlgPaper } );
       ObjSet( "anm_nightsvilleentrance_child", { alp = 0 } );
       ObjSet( "anm_nightsvilleentrance_child_2", { alp = 1 } );
       common_impl.PlayAudio( "sfx", "common/audio/aud_get_to_us", 0, "", 0 );

    elseif count_txt == 3 then 

      common_impl.continue_visible = false;
      common_impl.DialogCharacterShowDialogQuestions( 2, private.dialog_voices_time[ common_impl.dialog_character_select ]  );
     
    elseif count_txt == 4 then 

      common_impl.continue_visible = false;
      common_impl.DialogCharacterShowDialogQuestions( 1, private.dialog_voices_time[ common_impl.dialog_character_select ]  ); 

    elseif count_txt == 6 then 
  
      ObjSet( "obj_int_dialog_character_input", { event_mdown = private.ShowDlgClock } );

      ObjSet( "anm_nightsvilleentrance_child", { alp = 0 } );
      ObjSet( "anm_nightsvilleentrance_child_clock", { alp = 1 } );
    
    end;
  
  end;

  if dlg_name == "company" then

    ObjSet( "anm_nightsvilleentrance_kid", { alp = 0 });

    if count_txt == 1 then

       common_impl.continue_visible = false; 
       common_impl.frases = { 1 }; 
       common_impl.dial_icons = { 'hare' };
       common_impl.DialogCharacterShowDialogQuestions( 1, 2 ); 

    elseif count_txt == 2 then

       common_impl.continue_visible = false;
       common_impl.frases = { 2 }; 
       common_impl.dial_icons = { 'videotape' };
       common_impl.DialogCharacterShowDialogQuestions( 1, 5 ); 

    elseif count_txt == 4 then 

       common_impl.continue_visible = true;
       ObjSet( "anm_nightsvilleentrance_company_child", { alp = 0 } );
       ObjSet( "anm_nightsvilleentrance_company_child_wheel", { alp = 1 } );
       common_impl.PlayAudio( "sfx", "common/audio/aud_get_to_us", 0, "", 0 );
       ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = private.ClkCompanyDialMmg } );
  
    end;
  
  end;

end;
--------------------------------------------------------------------------------------------
function private.vid_nightsvilleentrance_child()

  cmn.CallEventHandler( "vid_nightsvilleentrance_child_beg" );
  ObjSet( "vid_nightsvilleentrance_child", { alp = 1, active = true, input = false, visible = true } );
  ObjSet( private.room_objname, { input = false } );
  ObjAttach( "vid_nightsvilleentrance_child", private.room_objname );
  
  local func_after = function ( skip )

    common_impl.ShowBbt( 'bbt_nightsvilleentrance_bad_child' );

    interface.DialogVideoHide();
    ObjSet( private.room_objname, { input = true } );
    cmn.SetEventDone( "vid_nightsvilleentrance_child" );
    cmn.CallEventHandler( "vid_nightsvilleentrance_child_end" );
    interface.KeyTaskDone( "goto_nightsville" ,true, function () int_providence_eye.CheckShow();int_button_providence.StartLightProvidence(); end );
    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment3_mus", 0, "", 0 );
    
    if skip then

       common_impl.StopAudio( "sfx", "common/audio/aud_nightsvilleentrance_child", 0.5 );

    end;

  end;

  --common_impl.StopTimer();

  common_impl.StopAllMus();

  interface.DialogVideoShow( "vid_nightsvilleentrance_child", 1, function() func_after( 'skip' ); end, 3 );
  common_impl.PlayAudio( "sfx", "common/audio/aud_nightsvilleentrance_child", 0, "", 0.5 );
  VidPlay( "vid_nightsvilleentrance_child", function() func_after( nil ); end ); 

end;
--*********************************************************************************************************************
function private.dlg_nightsvilleentrance_child()

  ObjAttach( "dlg_nightsvilleentrance_child", private.room_objname );
  private.dialog_voices_time = { 1, 4, 7, 7 };
  common_impl.DialogCharacterStart( "child", 7, nil, nil, true, "dlg_nightsvilleentrance_child_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_nightsvilleentrance_child_end()

  cmn.SetEventDone( "dlg_nightsvilleentrance_child" );
  cmn.CallEventHandler( "dlg_nightsvilleentrance_child_end" );

  ObjSet( "obj_nightsvilleentrance_child_mmg", { input = false, pos_z = 1,alp = 0 } ); 
  ObjAttach( "obj_nightsvilleentrance_child_mmg", "obj_nightsvilleentrance_child" );
  ObjSet( "obj_nightsvilleentrance_child_mmg_2", { input = false, pos_z = 1,alp = 0 } ); 
  ObjAttach( "obj_nightsvilleentrance_child_mmg_2", "obj_nightsvilleentrance_child" );
  ObjSet( "anm_nightsvilleentrance_kid", { alp = 1 });
  ObjSet( "obj_int_dialog_character", { alp = 1 } );  
  private.get_evidence_2_1();

end;
--*********************************************************************************************************************
function private.dlg_nightsvilleentrance_company()

  ObjAttach( "dlg_nightsvilleentrance_company", private.room_objname ); 
  common_impl.DialogCharacterStart( "company", 5, nil, nil, true, "dlg_nightsvilleentrance_company_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_nightsvilleentrance_company_end()

  int_investigation_button.ChangeInvestigation();

  cmn.SetEventDone( "dlg_nightsvilleentrance_company" );
  cmn.CallEventHandler( "dlg_nightsvilleentrance_company_end" );
  ObjSet( "anm_nightsvilleentrance_kid", { alp = 1 });

  local page_content9 = {1, 1, 1};
  common_impl.AddBookmarkDiary( 9, 1, page_content9);

  private.get_mechanismpart();

  ObjSet( "obj_int_dialog_character", { alp = 1 } ); 

end;
--*********************************************************************************************************************
function private.vid_nightsvilleentrance_providence( func_execute )

  interface.BBTHide();

  private.func_providence = func_execute;

  int_button_providence.StopLightProvidence();
  
  common_impl.StopAllMus();
  common_impl.PlayAudio( "sfx", "common/audio/aud_nightsvilleentrance_providence_p1", 0, "", 0 );

  VidPlay( "vid_nightsvilleentrance_providence_p1", "" ); 
  common_impl.PlayAudio( "mus", "common/audio/aud_providence_mus", 1, "", 0.5 ); 
  interface.DialogVideoShow( "vid_nightsvilleentrance_providence", 1, function() private.vid_nightsvilleentrance_providence_end(); end , 3, 4 ); 

end;

function private.vid_nightsvilleentrance_providence_end( )

    common_impl.Lock( false );
    common_impl.StopAudio( "sfx", "common/audio/aud_nightsvilleentrance_providence_p6", 0.2 );
    int_providence.Hide();
    int_slider.InitSlider( private.room_objname );
    interface.DialogVideoHide();
    common_impl.StopAudio( "mus", "common/audio/aud_providence_mus", 1 ); 
    AnimPlay( "anm_nightsvilleentrance_slider_unlock", "DoAnim", "");

    cmn.SetEventDone( "vid_nightsvilleentrance_providence" );
    cmn.CallEventHandler( "vid_nightsvilleentrance_prv_end" );

    common_impl.PlayAudio( "mus", "common/audio/aud_enigma_mus", 0, "", 0 );

    common_impl.ShowBbt( 'bbt_providence_level2_1_end' );
  
    int_slider.InitSlider( private.room_objname );

    if ( private.func_providence ) then

      private.func_providence();
      private.func_providence = nil;

    end;
  
end;
--*********************************************************************************************************************
function private.opn_nightsvilleentrance()

  if not ( cmn.IsEventDone( "opn_nightsvilleentrance" ) ) then

    cmn.SetEventDone( "opn_nightsvilleentrance" );
    ng_global.progress[ "std" ][ "opn_nightsvilleentrance" ].show_attack = 0;
    ng_global.progress[ "std" ][ "opn_nightsvilleentrance" ].left_company = 0;

  end;

  cmn.CallEventHandler( "opn_nightsvilleentrance" ); 

end;
--*********************************************************************************************************************
function private.first_gate_to_nightsville()

  if ng_global.progress[ "std" ][ "opn_nightsvilleentrance" ].show_attack == 0 then

    ng_global.progress[ "std" ][ "opn_nightsvilleentrance" ].show_attack = 1;
    rm_nightsville.vid_nightsville_attack();

  end;

end;
--*********************************************************************************************************************
function private.anm_log()

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_log_bridge", 0, "", 0 );

  AnimPlay( "anm_dangerousbridge_false_use", "DoAnim", function() common_impl.Lock( false ); end );

  common_impl.ShowBbt( 'bbt_dangerousbridge_use_knife' );

end;
--*********************************************************************************************************************
function private.anm_branches()

  common_impl.ShowBbt( 'bbt_hole_use_secateurs' );
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_nightsvilleentrance_bush", 0, "", 0 );
  AnimPlay( "anm_hole_pruner_2", "DoAnim", function() common_impl.Lock( false ); end );  

end;
--*********************************************************************************************************************
function private.CoverAnimation()

  local func_end = function ()

    common_impl.Lock(false);
    common_impl.ShowBbt( 'bbt_hole_clk_aid' );

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_medicine_chest_cover", 0, "", 0 );

  ObjAnimate( "spr_hole_cover_firstaid", "pos_xy", 0, 0, func_end,
    { 
      0.0, 0, -4, -24, 
      0.2, 0, -8, -24,
      0.6, 0, -2, -24,
      0.8, 0, -4, -24,
    } );

end;
--*********************************************************************************************************************
function private.AnimLeftCompany()

  common_impl.ShowBbt( 'bbt_nightsvilleentrance_left_company' );

  ng_global.progress[ "std" ][ "opn_nightsvilleentrance" ].left_company = 1;

  local func_end = function ()
    
    common_impl.Lock(false);
    ObjSet("anm_hightsvilleentrance_bushes_1", {alp = 1});
    ObjSet( "anm_hightsvilleentrance_bushes_1", { active = true } )
    AnimPlay( "anm_hightsvilleentrance_bushes_1","DoAnim","" );
    ObjSet("anm_hightsvilleentrance_bushes_2", {alp = 0});
    cmn.CallEventHandler("update_performance_mode_nightsvilleentrance");

  end;

  common_impl.Lock(true);  

   AnimStop( "anm_hightsvilleentrance_bushes_1" );
   ObjSet("anm_hightsvilleentrance_bushes_1", {alp = 0});
   ObjSet("anm_hightsvilleentrance_bushes_2", { active = true } );
   AnimPlay( "anm_hightsvilleentrance_bushes_2", "DoAnim", func_end );

end;
