-- name=rm_office_2
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_office_2";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_setofdrawers_2", "room_hub" );
  ObjAttach( "zz_floor_2", "room_hub" );
  ObjAttach( "zz_chest_2", "room_hub" );

  private.Init_Subroom();
  private.Init_Anims();

  private.coord_mas = {};
  private.chest_obj = 0;
  
  ObjMultiSet( {
  { "spr_chest_2_coin",{event_mdown = function() private.get_coin7() end } },
  { "spr_setofdrawers_2_coin",{event_mdown = function() private.get_coin8() end } },
  { "spr_office_2_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_5" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  { "obj_office_2_window_clk", { event_mdown = function() common_impl.ShowBbt( 'bbt_office_window_clk' ) end;} },
 } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_office_2 = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    { 
      "gzz_office_2_setofdrawers_2",
      "gzz_office_2_chest_2",
    }
    for i = 1, #gates do
    
      local name = gates[ i ];
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx =

      {
        private.room_objname,
        "zz_setofdrawers_2",
        "zz_floor_2",
        "zz_chest_2"
      
      };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_office_2", update_game_mode_office_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_office_2 = function ()
    
    local effects_table = 
    {
      "obj_office_2_anim" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_office_2", update_performance_mode_office_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  ----------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function opn_office () end;
  --------------------------------------------------------------------------------------------
  local opn_office_2_map = function ()

    common_impl.VisitMapRoom( "office" );

  end;
  cmn.AddSubscriber( "opn_office_2", opn_office_2_map, nil );
----------------------------------------------------------------------------------------------
  -- function get_coins () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_7 = function ()

    ObjDelete( "obj_chest_2_coin" );
    ObjDelete( "gzz_office_2_chest_2" );

  end;
  cmn.AddSubscriber( "get_coin_7", get_collect_coin_7, private.room_objname );
  --------------------------------------------------------------------------------------------
  local get_collect_coin_8 = function ()

    ObjDelete( "obj_setofdrawers_2_coin" );
    ObjDelete( "gzz_office_2_setofdrawers_2" );

  end;
  cmn.AddSubscriber( "get_coin_8", get_collect_coin_8, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_5 = function ()
  
    ObjDelete( "obj_office_2_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_5", get_collect_morph_item_1_5, private.room_objname );

--*********************************************************************************************************************
end;
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()

  --int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

  private.opn_office_2();

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.EnvPlay( { "common/audio/aud_office_env" }, "", 0.5 );
  common_impl.MorphItemMorphing();

  interface.InvestigationButtonCheck();

end;
--*********************************************************************************************************************
function public.Close()

  --common_impl.StopAudio( "env", "common/audio/aud_office_env", 0.2 );

  int_slider.CloseSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreClose()

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_coin7()


  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_7");
    cmn.CallEventHandler("get_coin_7");
    common.CloseSubRoom();

  end;
    
  common_impl.PlayEffectHO( "spr_chest_2_coin", func_after );

end;
--------------------------------------------------------------------------------------------
function private.get_coin8()
  
  local func_after = function ()

    common_impl.GetCoinDone("get_coin_8");
    cmn.CallEventHandler("get_coin_8");
    common.CloseSubRoom();

  end;

  common_impl.PlayEffectHO( "spr_setofdrawers_2_coin", func_after );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_office_2 ()

   cmn.CallEventHandler( "opn_office_2" );  

end;
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------
--********************************************************************************************************************
function private.Init_Subroom()

end;
--********************************************************************************************************************
--*********************************************************************************************************************
function private.Init_Anims ()

  ObjAnimate( "spr_office_2_light_window", "alp", 1, 0, "",
  { 
    0.0, 0, 1.0, 
    1.3, 0, 0.5,
    2.6, 0, 1.0
  } );

  ObjAnimate( "spr_office_2_lamplight", "alp", 1, 0, "",
  { 
    0.0, 0, 1.0, 
    0.6, 0, 0.5,
    1.2, 0, 1.0
  } );

  ObjAnimate( "spr_office_2_chandelier", "ang", 1, 0, "",
  { 
    0.0, 3, -0.1, 
    3.0, 3, 0.1,
    6.0, 3, -0.1
  } );

end;
