-- name=rm_pier_2
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_pier_2";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_hut_2", "room_hub" );
  ObjAttach( "zz_storage_2", "room_hub" );
  ObjAttach( "zz_gates_2", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet( {
    { "spr_hut_2_hoisthandle", { event_mdown = private.get_hoisthandle } },
    { "spr_hut_2_oilcan", { event_mdown = private.get_oilcan } },
    { "spr_gates_2_emblemelement1", { event_mdown = private.get_emblemelement1 } },    
    { "spr_gates_2_corkscrew", { event_mdown = private.get_corkscrew } },
    { "vid_pier_2_elf", { event_mdown = private.get_elf } },
    { "obj_storage_2_clk_heck", { event_mdown = function () private.clk_heck(); end } },
    { "obj_storage_2_use_oilcan", { event_mdown = function () private.clk_grille() end } },
    { "obj_storage_2_clk_hoisthandle", { event_mdown = function () private.clk_hoisthandle() end } },
    { "obj_storage_2_clk_stock", { event_mdown = function() common_impl.ShowBbt( 'bbt_storage_2_clk_stock' ); end } },
    { "obj_gates_2_use_workinggasolinesaw", { event_mdown = function () private.clk_latch(); common_impl.ShowBbt( 'bbt_use_workinggasolinesaw' ); end } },    
    { "obj_pier_2_clk_poster", { event_mdown = function () common_impl.NoteScale( "open", "spr_pier_2_poster" ); common_impl.ShowBbt( 'bbt_pier_clk_poster', 1 ); end } },    
    { "spr_pier_2_poster_big", { event_mdown = function () common_impl.NoteScale( "close", "spr_pier_2_poster" ) end } },    
    { "spr_pier_2_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_1_1" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_pier_2_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_1" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
 } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_pier = function ()
    
    local table_multiset = {};
    local visible_sparkle_area = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
      visible_sparkle_area = false;
    end;
    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    local gates = 
    {
    }
    for i = 1, #gates do
    
      local name = gates[ i ]
      if ( common.GetObjectPrefix( name ) == "gho" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
      elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
        table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
      end;

    end;

    local mas_parent_gfx = 

      {
        private.room_objname,
        "zz_hut_2",
        "zz_storage_2",
        "zz_gates_2"
      
      };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );


    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset );
    end;

  end;
  cmn.AddSubscriber( "update_game_mode_pier", update_game_mode_pier, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_pier_2 = function ()
    
    local effects_table = 
    {
      "obj_pier_2_anim" 
    }

    local active = true;
    if ( GetPerformanceMode() == 1 ) then
      active = false;
    end;

    for i = 1, #effects_table do
      ObjSet( effects_table[ i ], { active = active } )
    end;

  end;
  cmn.AddSubscriber( "update_performance_mode_pier_2", update_performance_mode_pier_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_pier () end;
  --------------------------------------------------------------------------------------------
  local opn_pier_2_map = function ()

    common_impl.VisitMapRoom( "pier" );

  end;

  local opn_pier_2_end = function ()

  end;

  cmn.AddSubscriber( "opn_pier_2", opn_pier_2_map, nil );
  cmn.AddSubscriber( "opn_pier_2_map", opn_pier_2_map, nil );
  cmn.AddSubscriber( "opn_pier_2", opn_pier_2_end, private.room_objname );
  cmn.AddSubscriber( "opn_pier_2_end", opn_pier_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
 --------------------------------------------------------------------------------------------
  -- function get_collect_item_1_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_1_1 = function ()
  
    ObjDelete( "obj_pier_2_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_1_1", get_collect_item_1_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_1 = function ()
  
    ObjDelete( "obj_pier_2_morph" );

  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_1", get_collect_morph_item_1_1, private.room_objname );
  --------------------------------------------------------------------------------------------

  local opn_pier_2_map = function ()

    --common_impl.VisitMapRoom( "pier_2" );

  end;
  cmn.AddSubscriber( "opn_pier_2", opn_pier_2_map, nil );
  --------------------------------------------------------------------------------------------  

end;
--*********************************************************************************************************************
function private.opn_pier_2()
 
   cmn.CallEventHandler( "opn_pier_2" ); 

end;
--*********************************************************************************************************************
function public.Load()
  
  ObjAnimate("obj_storage_2_boat", "ang", 1, 0, "", { 0, 3, -0.01,     1.5, 3, 0.01,    3, 3, -0.01 });

end;
--********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_hut_2" );
  
  function zz_hut_2.PreOpen()

  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_pier_2();

  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

  ObjAnimate( "spr_gates_2_light", "alp", 1, 0, "",
  { 
    0.0, 0, 1.0, 
    0.5, 0, 0.5,
    1.0, 0, 1.0
  } );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing( );

  common_impl.EnvPlay( { "common/audio/aud_pier_env" }, "", 0.5 );

  ObjSet( "spr_pier_2_poster_big", { input = 0, alp = 0 } );
  ObjSet( "spr_pier_2_poster", { alp = 1 } );

  if common_impl.pier_2 then

    common_impl.pier_2.note = "close";

  else 

    common_impl.pier_2 = {}
    common_impl.pier_2.note = "close";

  end;

end;
--*********************************************************************************************************************
function public.Close()
  --common_impl.StopAudio( "env", "common/audio/aud_pier_2_env", 0.2 );
end;
--*********************************************************************************************************************
function public.PreClose()
end;