-- name=ho_hos
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "hos" );
  game.relations[ "ho_hos" ].exitroom = "rm_pier_3";
  private.count = 0;
  --------------------------------------------------------------------------------------------------
  local table_multiset = {};

  table.insert( table_multiset, { "spr_hos_balloon", { event_mdown = function() private.TaskComplete( 'balloon' ) end } } );
  table.insert( table_multiset, { "spr_hos_barrel", { event_mdown = function() private.TaskComplete( 'barrel' ) end } } );
  table.insert( table_multiset, { "spr_hos_bell", { event_mdown = function() private.TaskComplete( 'bell' ) end } } );
  table.insert( table_multiset, { "spr_hos_box", { event_mdown = function() private.TaskComplete( 'box' ) end } } );
  table.insert( table_multiset, { "obj_hos_dart", { event_mdown = function() private.TaskComplete( 'dart' ) end } } );
  table.insert( table_multiset, { "spr_hos_hook", { event_mdown = function() private.TaskComplete( 'hook' ) end } } );
  table.insert( table_multiset, { "spr_hos_jug", { event_mdown = function() private.TaskComplete( 'jug' ) end } } );
  table.insert( table_multiset, { "spr_hos_mask", { event_mdown = function() private.TaskComplete( 'mask' ) end } } );
  table.insert( table_multiset, { "spr_hos_skull", { event_mdown = function() private.TaskComplete( 'skull' ) end } } );
  table.insert( table_multiset, { "spr_hos_statuette", { event_mdown = function() private.TaskComplete( 'statuette' ) end } } );
  table.insert( table_multiset, { "spr_hos_anchor", { event_mdown = function() private.TaskComplete( 'anchor' ) end } } );
  table.insert( table_multiset, { "spr_hos_brick", { event_mdown = function() private.TaskComplete( 'brick' ) end } } );
  table.insert( table_multiset, { "spr_hos_brick_1", { event_mdown = function() private.TaskComplete( 'brick', 'spr_hos_brick_1' ) end } } );
  table.insert( table_multiset, { "spr_hos_tongue_2", { event_startdrag = function() private.GetItem( 'tongue_2' ) end, event_dragdrop = function() private.unmark_bell() end } } );
  table.insert( table_multiset, { "spr_hos_knife", { event_startdrag = function() private.GetItem( 'knife' ) end, event_dragdrop = function() private.unmark_feet() end } } );
  table.insert( table_multiset, { "spr_hos_part_1", { event_startdrag = function() private.GetItem( 'part_1' ) end, event_dragdrop = function() private.unmark_knife('part_1') end } } );
  table.insert( table_multiset, { "spr_hos_part_2", { event_startdrag = function() private.GetItem( 'part_2' ) end, event_dragdrop = function() private.unmark_knife('part_2') end } } );
  table.insert( table_multiset, { "tmr_hos_moves", { endtrig = function() private.MovesFeet() end } } );

  ObjMultiSet( table_multiset );

  common_impl.hint[ "win_hos" ] = {
      type = "win",
      room = "rm_pier_3",
      zz = "ho_hos",
      zz_gate = "gho_pier_3_hos"
  };
  
  local win_hos_func = function ()

    if ( cmn.IsEventDone( "win_hos" ) ) then

      common_impl.LockMapRoom( "pier", false );

    end;

  end;
  cmn.AddSubscriber( "win_hos", win_hos_func );
  --------------------------------------------------------------------------------------------------
  local unmark_bell = function () 
   
    ObjSet( "spr_hos_tongue_1", { alp = 1 } );
    ObjSet( "spr_hos_bell", { input = true } ); 
    ObjDelete( "spr_hos_tongue_2" );
    ObjDelete( "obj_hos_use_tongue_2" ); 

  end;

  cmn.AddSubscriber( "unmark_bell", unmark_bell, "ho_hos" );  
  --------------------------------------------------------------------------------------------------
  local unmark_feet = function () 

    ObjDelete( "spr_hos_feet" );
    ObjDelete( "obj_hos_use_knife" );
    ObjDelete( "anm_hos_use_knife" );

  end;

  cmn.AddSubscriber( "unmark_feet", unmark_feet, "ho_hos" );  
  --------------------------------------------------------------------------------------------------
  local unmark_knife = function () 
   
    ObjDelete( "spr_hos_closed");
    ObjDelete( "obj_hos_use_part");
    ObjDelete( "spr_hos_part_1" );
    ObjDelete( "spr_hos_part_2" );
    ObjSet( "spr_hos_open", { alp = 1 } );
    ObjSet( "obj_hos_use_knife", { input = true } );
    ObjDelete( "txt_hos_task_1");

    ObjAttach( "txt_hos_task", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel", { alp = 0 } );
    ObjSet( "txt_hos_task", { alp = 1, param0 = "1" } );
    ObjSet( "spr_hos_knife", { input = true } );

  end;

  cmn.AddSubscriber( "unmark_knife", unmark_knife, "ho_hos" ); 
  --------------------------------------------------------------------------------------------------
  local start_hos_func = function ()

    if ( cmn.IsEventStart( "win_hos" ) ) then

      local ho_found = ng_global.progress[ "std" ][ "win_hos" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
      end;

    end;

    if not cmn.IsEventDone( "win_hos" ) then

      if cmn.IsUnmarkedTask( "hos", "bell" ) then
          unmark_bell();
      end;

      if cmn.IsUnmarkedTask( "hos", "knife" ) then
          unmark_knife();
      end;

    end;

  end;
  cmn.AddSubscriber( "win_hos", start_hos_func, "ho_hos" ); 

  local end_hos_rm = function ()
  
    if ( cmn.IsEventDone( "win_hos" ) ) then
      ObjDelete( "anm_square_3_citizens_2" );
    end;

  end; 

  cmn.AddSubscriber( "win_hos", start_hos_func, "ho_hos" );  
  cmn.AddSubscriber( "win_hos", end_hos_rm, "rm_square_3" );  

  --------------------------------------------------------------------------------------------
  -- function vid_pier_3_attack () end;
  --------------------------------------------------------------------------------------------
  local vid_hos_attack_inv = function ()

    interface.InventoryItemRemove( "inv_elf_3" );
    interface.InventoryItemRemove( "inv_hexkey" );
    interface.InventoryItemRemove( "inv_brokengasolinesaw3" );

  end;
  local vid_hos_attack_beg = function ()

  end;
  local vid_hos_attack_end = function ()  

    ObjSet( "ho_hos", { color_r = 1, color_g = 1, color_b = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_hos_attack", vid_hos_attack_beg, private.room_objname );
  cmn.AddSubscriber( "vid_hos_attack", vid_hos_attack_end, private.room_objname  );
  cmn.AddSubscriber( "vid_hos_attack", vid_hos_attack_inv  );
  cmn.AddSubscriber( "vid_hos_attack_beg", vid_hos_attack_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_hos_attack_end", vid_hos_attack_end, private.room_objname  );
  cmn.AddSubscriber( "vid_hos_attack_end", vid_hos_attack_inv  );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()
    
  int_slider.InitSlider( "ho_hos" );

  if cmn.IsEventDone( "opn_hos" ) then

    common_impl.PlayAudio( "mus", "common/audio/aud_danger1_mus", 1, "", 0.5 );
    common_impl.PlayAudio( "env", "common/audio/aud_ho_hos_env", 1 );

  else

    private.vid_hos_attack();
    cmn.InitHo( "hos" );
    cmn.SetEventDone( "opn_hos" );
    cmn.SetMarkedTask( "hos", "bell" );
    cmn.SetMarkedTask( "hos", "knife" );
    ng_global.progress["std"]["win_hos"].objects = 13;
    ng_global.progress["std"]["win_hos"].count = 0;
    ng_global.progress["std"]["win_hos"].anim = false;
    ng_global.progress["std"]["win_hos"].part_1 = false;
    ng_global.progress["std"]["win_hos"].part_2 = false;
 
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "balloon",          1, 0, { { "spr_hos_balloon" } } );
  interface.TaskPanelTaskAdd( ho_items, "barrel",          1, 0, { { "spr_hos_barrel" } } );
  interface.TaskPanelTaskAdd( ho_items, "bell",          1, 1, {  { "spr_hos_tongue_2", "obj_hos_use_tongue_2" } ,{ "spr_hos_bell" } } );
  interface.TaskPanelTaskAdd( ho_items, "box",          1, 0, { { "spr_hos_box" } } );
  interface.TaskPanelTaskAdd( ho_items, "dart",          1, 0, { { "obj_hos_dart" } } );
  interface.TaskPanelTaskAdd( ho_items, "hook",          1, 0, { { "spr_hos_hook" } } );
  interface.TaskPanelTaskAdd( ho_items, "jug",          1, 0, { { "spr_hos_jug" } } );
  interface.TaskPanelTaskAdd( ho_items, "mask",          1, 0, { { "spr_hos_mask" } } );
  interface.TaskPanelTaskAdd( ho_items, "skull",          1, 0, { { "spr_hos_skull" } } );
  interface.TaskPanelTaskAdd( ho_items, "statuette",          1, 0, { { "spr_hos_statuette" } } );
  interface.TaskPanelTaskAdd( ho_items, "anchor",          1, 0, { { "spr_hos_anchor" } } );
  interface.TaskPanelTaskAdd( ho_items, "brick",          2, 0, { { "spr_hos_brick" },{ "spr_hos_brick_1" } } );
  --
  interface.TaskPanelTaskAdd( ho_items, "knife",          1, 1, { { "obj_hos_use_part", "spr_hos_part_2" }, { "obj_hos_use_part", "spr_hos_part_1" }, { "spr_hos_knife", "obj_hos_use_knife" } } );

  interface.TaskPanelShow( ho_items );

  if ng_global.progress["std"]["win_hos"].objects == 0  then

    ObjAttach( "txt_hos_task_1", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel", { alp = 0 } );
    ObjSet( "txt_hos_task_1", { alp = 1, param0 = "1" } );
    ObjSet( "spr_hos_part_1", { input = true } );
    ObjSet( "spr_hos_part_2", { input = true } );
    ObjSet( "obj_hos_use_part", { input = true } );

  end;

  if ( not ng_global.progress["std"]["win_hos"].anim ) then

    local count  =  0;

    for i = 1, #ng_global.progress[ "std" ][ "win_hos" ].found do
   
      if ( ng_global.progress[ "std" ][ "win_hos" ].found[ i ][ "task" ] == "brick" ) then
          count = count + 1;
      end

    end;

    if ( count == 2 ) then

      local func_after = function()

        common_impl.Lock( false );
        ng_global.progress["std"]["win_hos"].anim = true;

      end;

      common_impl.Lock( true );

      ObjSet( "vid_hos_elf_static", { alp = 0 });
      ObjSet( "vid_hos_elf_up", { active = true, alp = 1 });

      VidPlay( "vid_hos_elf_up", func_after );

    end;

  else 

    ObjDelete( "vid_hos_elf_static");
    ObjDelete( "vid_hos_elf_up");

  end;

  if ( ng_global.progress["std"]["win_hos"].part_1 ) then

    ObjDelete( "spr_hos_part_1" );
    ObjSet( "spr_hos_part_1_1", { alp = 1 });
    ObjSet( "obj_hos_use_part", { event_mdown = function() common_impl.ShowBbt( 'bbt_hos_use_part_2', 1 ); end });
  elseif( ng_global.progress["std"]["win_hos"].part_2 ) then

    ObjDelete( "spr_hos_part_2" );
    ObjSet( "spr_hos_part_2_1", { alp = 1 });
    ObjSet( "obj_hos_use_part", { event_mdown = function() common_impl.ShowBbt( 'bbt_hos_use_part_2', 1 ); end });

  end;

  interface.InvestigationButtonCheck();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Open ()
  
  common_impl.VisitMapRoom( "pier" );
  common_impl.PassingHoStart();  

end;
--*********************************************************************************************************************
function public.Close ()

  common_impl.PassingHoStop();

  common_impl.StopAudio( "mus", "common/audio/aud_danger1_mus", 1, "", 1 );

  common_impl.StopAudio( "env", "common/audio/aud_ho_hos_env", 0.5 );

end;
--*********************************************************************************************************************
function private.vid_hos_attack()

  cmn.CallEventHandler( "vid_hos_attack_beg" );
  ObjSet( "vid_hosattack", { alp = 1, active = true, input = false, visible = true } );
  
  local func_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_hos_attack" );
    cmn.CallEventHandler( "vid_hos_attack_end" );
    common_impl.ShowBbt( 'bbt_vid_hos_attack', 1 );

    common_impl.PlayAudio( "mus", "common/audio/aud_danger1_mus", 1, "", 0.5 );
    common_impl.PlayAudio( "env", "common/audio/aud_ho_hos_env", 1 );

    if skip then

      SndStop( "assets/levels/common/audio/aud_hos_attack", 0.5 );
      common_impl.StopAudio( "voc", "common/audio/aud_hos_attack_voc", 0 );

    end;

  end;
  common_impl.StopAllMus();
  SetSoundVolume( "group",  GetSoundVolume( "sfx" ) );
  SndPlay( "assets/levels/common/audio/aud_hos_attack", "group", 0, 0, 0.5 );
  common_impl.PlayAudio( "voc", "common/audio/aud_hos_attack_voc", 0 );
  interface.DialogVideoShow( "vid_hos_attack", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_hos_attack", function() func_after( nil ); end ); 

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();
  ObjDetach( "txt_hos_task");
  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  int_taskpanel_impl.sound_clk_play = true;
  
end;
--*********************************************************************************************************************
function private.TaskComplete( task_name, object_name )
 
  local object = "";

  if object_name then

    object = tostring( object_name );

  else

    object = "spr_hos_"..task_name;

  end;
 
  ObjSet( object, { pos_z = 1 } );

  int_taskpanel_impl.sound_clk_play = false;

  cmn.HoTaskFind( object, task_name );

  ng_global.progress["std"]["win_hos"].objects = ng_global.progress["std"]["win_hos"].objects - 1;

  if ( task_name == 'brick' ) then
  
    ng_global.progress["std"]["win_hos"].count = ng_global.progress["std"]["win_hos"].count + 1;

    if ( ng_global.progress["std"]["win_hos"].count == 2 ) then

      local func_after = function()

        common_impl.Lock( false );
        ng_global.progress["std"]["win_hos"].anim = true;

      end;

      common_impl.Lock( true );

      ObjSet( "vid_hos_elf_static", { alp = 0 });
      ObjSet( "vid_hos_elf_up", { active = true, alp = 1 });

      VidPlay( "vid_hos_elf_up", func_after );

      common_impl.PlayAudio( "sfx", "common/audio/aud_ho_hos_net", 0, "", 0 );

    end;

  end;

  if ng_global.progress["std"]["win_hos"].objects == 0 then

    ObjAttach( "txt_hos_task_1", "int_taskpanel_impl");
    ObjSet( "obj_int_taskpanel", { alp = 0 } );
    ObjSet( "txt_hos_task_1", { alp = 1, param0 = "1" } );
    ObjSet( "spr_hos_part_1", { input = true } );
    ObjSet( "spr_hos_part_2", { input = true } );
    ObjSet( "obj_hos_use_part", { input = true } );

  end;

end;
--*********************************************************************************************************************
function private.GetItem( name )
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_hos_"..name, { pos_z = 20 } );

end;
--*********************************************************************************************************************
function private.unmark_bell() 
 
  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_hos_tongue_2", "obj_hos_use_tongue_2" ) ) then

    common_impl.Lock(true);
    
    ObjSet( "spr_hos_tongue_2", { alp = 0 } );

    local func_after = function()

      common_impl.Lock(false);
  
      cmn.UnmarkTask( "hos", "bell" );
      cmn.CallEventHandler( "unmark_bell" );

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_ho_hos_bell", 0, "", 0 );
    
    ObjAnimate( "spr_hos_tongue_1", "alp", 0, 0, func_after, { 0,3,0,  0.4,3,1 } );
   
  else

    ObjSet( "spr_hos_tongue_2", { pos_z = 0 } );
        
  end;

end;
--*********************************************************************************************************************
function private.unmark_feet() 
 
  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_hos_knife", "obj_hos_use_knife" ) ) then

    local func_after = function()

      common_impl.Lock( false );
      private.TaskComplete( 'knife' );

    end;

    common_impl.Lock( true );
    ObjSet( "spr_hos_knife", { alp = 0, pos_y = 1000 } );
    AnimPlay( "anm_hos_use_knife", "DoAnim", func_after );

    common_impl.PlayAudio( "sfx", "common/audio/aud_ho_hos_knife", 0, "", 0 );

  else

    ObjSet( "spr_hos_knife", { pos_z = 0 } );
        
  end;

end;
--*********************************************************************************************************************
function private.unmark_knife( name ) 
 
  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_hos_"..name, "obj_hos_use_part" ) ) then

    common_impl.Lock( true ); 

    ObjSet( "spr_hos_"..name, { alp = 0, input = false } );

    local func_after = function()

      common_impl.Lock( false );

      if ( name == "part_1" ) then
        ng_global.progress["std"]["win_hos"].part_1 = true;
        ObjDelete( "spr_hos_"..name );
        ObjSet( "obj_hos_use_part", { event_mdown = function() common_impl.ShowBbt( 'bbt_hos_use_part_2', 1 ); end });
      elseif ( name == "part_2" ) then
        ng_global.progress["std"]["win_hos"].part_2 = true;
        ObjDelete( "spr_hos_"..name );
        ObjSet( "obj_hos_use_part", { event_mdown = function() common_impl.ShowBbt( 'bbt_hos_use_part_2', 1 ); end });
      end;

      if ( ng_global.progress["std"]["win_hos"].part_1 == true 
        and ng_global.progress["std"]["win_hos"].part_2 == true ) then

        cmn.UnmarkTask( "hos", "knife" );
        cmn.CallEventHandler( "unmark_knife" );

      end;

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_ho_hos_bell", 0, "", 0 );

    if ( ng_global.progress["std"]["win_hos"].part_1 == true or ng_global.progress["std"]["win_hos"].part_2 == true ) then

      ObjAnimate( "spr_hos_"..name.."_1", "alp", 0, 0, "", 
      { 
        0.0,0,0,
        0.3,0,1
      } );

      ObjAnimate( "spr_hos_closed", "alp", 0, 0, "", 
      { 
        0.0,0,1,
        0.3,0,1,
        0.6,0,0
      } );

      ObjAnimate( "spr_hos_open", "alp", 0, 0, func_after, 
      { 
        0.0,0,0,
        0.3,0,0,
        0.6,0,1
      } );

    else 

      ObjAnimate( "spr_hos_"..name.."_1", "alp", 0, 0, func_after, 
      { 
        0.0,0,0,
        0.3,0,1 
      } );

    end;
   
  else

    ObjSet( "spr_hos_"..name, { pos_z = 0 } );
        
  end;

end;
--*********************************************************************************************************************
--Win
--*********************************************************************************************************************
function public.PlayHoVideo( ho_name )

  ObjSet( "vid_hos_surfacing", { alp = 1, active = true, input = false, visible = true } );
  
  local func_after = function ( skip )

    interface.DialogVideoHide();
    ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].done = 1;
    cmn.CallEventHandler( "unmark_feet" );
    cmn.CallEventHandler( "win_"..ho_name, GetCurrentRoom() );
    common_impl.PlayAudio( "mus", "common/audio/aud_adventure2_mus", 0, "", 0 );
    common_impl.ShowBbt( 'bbt_pier_3_start' );

    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_hos_surfacing", 0.5 );

    end;

  end;

  common_impl.StopAllMus();
  common_impl.PlayAudio( "sfx", "common/audio/aud_hos_surfacing", 0, "", 0 );
  interface.DialogVideoShow( "vid_hos_surfacing", 1, function() func_after ( 'skip' ); end, 3 );
  VidPlay( "vid_hos_surfacing", function() func_after ( nil ); end );
 
  cmn.GotoRoom( "rm_pier_3" );
end;
--*********************************************************************************************************************
function private.MovesFeet()

  local pos = GetGameCursorPos();
  local x_cur = pos[ 1 ];
  local y_cur = pos[ 2 ];

  local pos_x = ObjGet( "spr_hos_feet" ).pos_x;
  local pos_y = ObjGet( "spr_hos_feet" ).pos_y;
  local ang = ObjGet( "spr_hos_rope" ).ang;

  local func_after = function ()

    ObjSet( "tmr_hos_moves", { playing = true, time = 0.2, endtrig = private.MovesFeet() } );

  end;
  
  if ( x_cur <= 512 and y_cur < 384 ) then

    ObjAnimate( "spr_hos_feet", "pos_xy", 0, 0, func_after, 
    {
      0.0, 0, pos_x, pos_y,
      1.2, 0, -198, 761
    } );

    ObjAnimate("spr_hos_rope", "ang", 0, 0, "", 
    { 
      0.0,3,ang,
      1.2,3,-0.02
    });

  elseif( x_cur >= 512 and y_cur < 384 ) then

    ObjAnimate( "spr_hos_feet", "pos_xy", 0, 0, func_after, 
    {
      0.0, 0, pos_x, pos_y,
      1.2, 0, -128, 761
    } );

    ObjAnimate("spr_hos_rope", "ang", 0, 0, "", 
    { 
      0.0,3,ang,
      1.2,3,-0.02
    });

  elseif( x_cur < 512 and y_cur >= 384 ) then

    ObjAnimate( "spr_hos_feet", "pos_xy", 0, 0, func_after, 
    {
      0.0, 0, pos_x, pos_y,
      1.2, 0, -198, 781
    } );

    ObjAnimate("spr_hos_rope", "ang", 0, 0, "", 
    { 
      0.0,3,ang,
      1.2,3,0.02
    });

  elseif( x_cur > 512 and y_cur >= 384 ) then

    ObjAnimate( "spr_hos_feet", "pos_xy", 0, 0, func_after, 
    {
      0.0, 0, pos_x, pos_y,
      1.2, 0, -128, 781
    } );

    ObjAnimate("spr_hos_rope", "ang", 0, 0, "", 
    { 
      0.0,3,ang,
      1.2,3,0.02
    });

  end;

end;
--*********************************************************************************************************************
function private.AnimFish_2()

  local func_end = function()

    ObjAnimate( "anm_hos_fish_2", "pos_x", 0, 0, private.AnimFish_2, 
    {
      0,   0, 940,  
      80, 0, -230
    } );

  end;

  ObjAnimate( "anm_hos_fish_2", "pos_x", 0, 0, func_end, 
  {
    0,   0, 1260,  
    30, 0, 940
  } );

end;
--*********************************************************************************************************************
function private.AnimFish_3()

  local func_end = function()

    ObjAnimate( "anm_hos_fish_3", "pos_x", 0, 0, private.AnimFish_3, 
    {
      0,   0, 562,  
      80, 0, 1290
    } );

  end;

  ObjAnimate( "anm_hos_fish_3", "pos_x", 0, 0, func_end, 
  {
    0,   0, -230,  
    30, 0, 562
  } );

end;
--*********************************************************************************************************************
function private.AnimFish_4()

  local func_end = function()

    ObjAnimate( "anm_hos_fish_4", "pos_x", 0, 0, private.AnimFish_4, 
    {
      0,   0, 76,  
      80, 0, 1280
    } );

  end;

  ObjAnimate( "anm_hos_fish_4", "pos_x", 0, 0, func_end, 
  {
    0,   0, -230,  
    40, 0, 76
  } );

end;
--*********************************************************************************************************************
ObjAnimate("spr_hos_algae_1", "ang", 1, 0, "", { 0,3,-0.02, 2.1,3,0.01, 4.2,3,-0.02 });
ObjAnimate("spr_hos_algae_2", "ang", 1, 0, "", { 0,3,0.02, 2,3,-0.01, 4,3,0.02 });
ObjAnimate("spr_hos_algae_3", "pos_xy", 1, 0, "", { 0,0,-82,204, 1.4,0,-79,201, 2.8,0,-82,204 });
ObjAnimate("spr_hos_algae_4", "pos_xy", 1, 0, "", { 0,0,-107,351, 1.7,0,-104,348, 3.4,0,-107,351 });
ObjAnimate("spr_hos_algae_5", "ang", 1, 0, "", { 0,3,-0.02, 2.4,3,0.02, 4.8,3,-0.02 });

ObjAnimate("spr_hos_algae_6", "scale_xy", 1, 0, "", { 0,0,1,1, 2,0,1.02,1.02, 4,0,1,1 });
ObjAnimate("spr_hos_algae_7", "scale_xy", 1, 0, "", { 0,0,1,1, 2,0,1.02,1.02, 4,0,1,1 });

ObjAnimate("spr_hos_light", "alp", 1, 0, "", { 0,0,1, 1.8,0,0.5, 3.6,0,1 });

--*********************************************************************************************************************
ObjAnimate( "anm_hos_fish_1", "pos_x", 1, 0, "", 
{
  0,   0, -265,  
  70, 0, 1290
} ); 

ObjAnimate( "anm_hos_fish_2", "pos_x", 0, 0, private.AnimFish_2, 
{
  0,   0, 940,  
  80, 0, -230
} ); 

ObjAnimate( "anm_hos_fish_3", "pos_x", 0, 0, private.AnimFish_3, 
{
  0,   0, 562,  
  80, 0, 1290
} ); 

ObjAnimate( "anm_hos_fish_4", "pos_x", 0, 0, private.AnimFish_4, 
{
  0,   0, 76,  
  80, 0, 1280
} ); 