-- name=ho_intable
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "intable" );
  game.relations[ "ho_intable" ].exitroom = "rm_wincards";
  --------------------------------------------------------------------------------------------------
  
  ObjMultiSet( {
  --
  { "spr_intable_ashtray", { event_mdown = function() private.TaskComplete( 'ashtray' ) end } },
  { "spr_intable_cassette", { event_mdown = function() private.TaskComplete( 'cassette' ) end } },
  { "spr_intable_dice", { event_mdown = function() private.TaskComplete( 'dice' ) end } },
  { "spr_intable_flag", { event_mdown = function() private.TaskComplete( 'flag' ) end } },
  { "spr_intable_glue", { event_mdown = function() private.TaskComplete( 'glue' ) end } },
  { "spr_intable_key", { event_mdown = function() private.TaskComplete( 'key' ) end } },
  { "spr_intable_lantern", { event_mdown = function() private.TaskComplete( 'lantern' ) end } },
  { "spr_intable_mouse", { event_mdown = function() private.TaskComplete( 'mouse' ) end } },
  { "spr_intable_playing_cards", { event_mdown = function() private.TaskComplete( 'playing_cards' ) end } },
  { "spr_intable_policebadge", { event_mdown = function() private.TaskComplete( 'policebadge' ) end } },
  { "spr_intable_letter", { event_mdown = function() private.TaskComplete( 'letter' ) end } },
  { "spr_intable_sticker_girl", { event_mdown = function() private.TaskComplete( 'sticker_girl' ) end } },
  { "spr_intable_peak", { event_startdrag = function() private.GetItem( 'peak' ) end, event_dragdrop = function() private.unmark_cards() end  } },
  { "obj_intable_clk_cassette", { event_mdown = function() private.unmark_cassette() end  } }
  } );
  
  common_impl.hint[ "win_intable" ] = {
      type = "win",
      room = "rm_wincards",
      zz = "ho_intable",
      zz_gate = "gho_wincards_intable"
  };
  
  local win_intable_func = function ()

    if ( cmn.IsEventDone( "win_intable" ) ) then
      interface.InventoryItemAdd( "inv_vicehandle", "spr_intable_win" );
    end;

  end;
  cmn.AddSubscriber( "win_intable", win_intable_func );
  --------------------------------------------------------------------------------------------------
  local unmark_cards = function () 
   
    ObjSet( "spr_intable_cover_1", { alp = 1 } );
    ObjDelete( "spr_intable_cover" );
    ObjDelete( "spr_intable_peak_shadow" );
    ObjDelete( "spr_intable_peak" );
    ObjDelete( "obj_intable_use_peak" );
    ObjSet( "spr_intable_playing_cards", { input = true } ); 

  end;

  cmn.AddSubscriber( "unmark_cards", unmark_cards, "ho_intable" );  
  --------------------------------------------------------------------------------------------------
  local unmark_cassette = function () 
   
    ObjSet( "spr_intable_open_cassette", { alp = 1, input = true } );
    ObjDelete( "obj_intable_clk_cassette" );
    ObjSet( "spr_intable_cassette", { input = true } ); 

  end;

  cmn.AddSubscriber( "unmark_cassette", unmark_cassette, "ho_intable" );  
  --------------------------------------------------------------------------------------------------
  local start_intable_func = function ()

    if ( cmn.IsEventStart( "win_intable" ) ) then
     
      local ho_found = ng_global.progress[ "std" ][ "win_intable" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
      end;

    end;

   if not cmn.IsEventDone( "win_intable" ) then

      if cmn.IsUnmarkedTask( "intable", "playing_cards" ) then
          unmark_cards();
      end;

      if cmn.IsUnmarkedTask( "intable", "cassette" ) then
          unmark_cassette();
      end;

    end;


  end;
  cmn.AddSubscriber( "win_intable", start_intable_func, "ho_intable" );  
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "opn_intable" ) ) then
  
    cmn.InitHo( "intable" );
    cmn.SetEventDone( "opn_intable" );
    cmn.SetMarkedTask( "intable", "playing_cards" );
    cmn.SetMarkedTask( "intable", "cassette" );
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "ashtray",          1, 0, { { "spr_intable_ashtray" } } );
  interface.TaskPanelTaskAdd( ho_items, "cassette",          1, 1, { { "obj_intable_clk_cassette" }, { "spr_intable_cassette" } } );
  interface.TaskPanelTaskAdd( ho_items, "dice",          1, 0, { { "spr_intable_dice" } } );
  interface.TaskPanelTaskAdd( ho_items, "flag",          1, 0, { { "spr_intable_flag" } } );
  interface.TaskPanelTaskAdd( ho_items, "glue",          1, 0, { { "spr_intable_glue" } } );
  interface.TaskPanelTaskAdd( ho_items, "key",          1, 0, { { "spr_intable_key" } } );
  interface.TaskPanelTaskAdd( ho_items, "lantern",          1, 0, { { "spr_intable_lantern" } } );
  interface.TaskPanelTaskAdd( ho_items, "mouse",          1, 0, { { "spr_intable_mouse" } } );
  interface.TaskPanelTaskAdd( ho_items, "playing_cards",          1, 1, { { "obj_intable_use_peak", "spr_intable_peak" }, { "spr_intable_playing_cards" } } );
  interface.TaskPanelTaskAdd( ho_items, "policebadge",          1, 0, { { "spr_intable_policebadge" } } );
  interface.TaskPanelTaskAdd( ho_items, "letter",          1, 0, { { "spr_intable_letter" } } );
  interface.TaskPanelTaskAdd( ho_items, "sticker_girl",          1, 0, { { "spr_intable_sticker_girl" } } );
 

  interface.TaskPanelShow( ho_items );

  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Open()

  common_impl.VisitMapRoom( "wincards" );
  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close()

  common_impl.PassingHoStop();
  
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.TaskComplete( task_name, object_name )
 
  local object = "";

  if object_name then

    object = tostring( object_name );

  else

    object = "spr_intable_"..task_name;

  end;
 
  ObjSet( object, { pos_z = 1 } );

  cmn.HoTaskFind( object, task_name );

end;
--*********************************************************************************************************************
function private.GetItem( name )
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_intable_"..name, { pos_z = 20 } );
  ObjSet( "spr_intable_"..name.."_shadow", { alp = 0 } );

end;
--*********************************************************************************************************************
function private.unmark_cards() 
 
  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_intable_peak", "obj_intable_use_peak" ) ) then

    common_impl.Lock(true);
    
    ObjSet( "spr_intable_peak", { alp = 0 } );

    local func_after = function()

      common_impl.Lock( false );

      cmn.UnmarkTask( "intable", "playing_cards" );
      cmn.CallEventHandler( "unmark_cards" );

    end;
    
    ObjAnimate( "spr_intable_peak_1", "alp", 0, 0, "", { 0,0,0,  0.3,0,1 } );
    ObjAnimate( "spr_intable_cover", "alp", 0, 0, func_after, { 0,0,1, 0.3,0,1, 0.6,0,0 } );  
    ObjAnimate( "spr_intable_cover_1", "alp", 0, 0, "", { 0,0,0, 0.3,0,0, 0.6,0,1 } );
   
  else

    ObjSet( "spr_intable_peak", { pos_z = 0 } );
    ObjSet( "spr_intable_peak_shadow", { alp = 1 } );
        
  end;

end;
--*********************************************************************************************************************
function private.unmark_cassette() 

  common_impl.Lock( true );

  local func_after = function()

    common_impl.Lock( false );

    cmn.UnmarkTask( "intable", "cassette" );
    cmn.CallEventHandler( "unmark_cassette" );

  end;
  
  ObjAnimate( "spr_intable_open_cassette", "alp", 0, 0, func_after, { 0,0,0,  0.3,0,1 } );

end;