-- name=ho_ladder
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ladder" );
  game.relations[ "ho_ladder" ].exitroom = "rm_hallway";
  private.tasks = { "", "" };
  --------------------------------------------------------------------------------------------------
  
  ObjMultiSet( {
  
  { "spr_ladder_binoculars_1", { event_mdown = function() private.ClkTask( 'binoculars', 'binoculars_1' ) end } },
  { "spr_ladder_binoculars_2", { event_mdown = function() private.ClkTask( 'binoculars', 'binoculars_2' ) end } },
  { "spr_ladder_candlestick_1", { event_mdown = function() private.ClkTask( 'candlestick', 'candlestick_1' ) end } },
  { "spr_ladder_candlestick_2", { event_mdown = function() private.ClkTask( 'candlestick', 'candlestick_2' ) end } },
  { "spr_ladder_cat_1", { event_mdown = function() private.ClkTask( 'cat', 'cat_1' ) end } },
  { "spr_ladder_cat_2", { event_mdown = function() private.ClkTask( 'cat', 'cat_2' ) end } },
  { "spr_ladder_key_1", { event_mdown = function() private.ClkTask( 'key', 'key_1' ) end } },
  { "spr_ladder_key_2", { event_mdown = function() private.ClkTask( 'key', 'key_2' ) end } },
  { "spr_ladder_hat_1", { event_mdown = function() private.ClkTask( 'hat', 'hat_1' ) end } },
  { "spr_ladder_hat_2", { event_mdown = function() private.ClkTask( 'hat', 'hat_2' ) end } },
  { "spr_ladder_brush_1", { event_mdown = function() private.ClkTask( 'brush', 'brush_1' ) end } },
  { "spr_ladder_brush_2", { event_mdown = function() private.ClkTask( 'brush', 'brush_2' ) end } },
  { "spr_ladder_hammer_1", { event_mdown = function() private.ClkTask( 'hammer', 'hammer_1' ) end } },
  { "spr_ladder_hammer_2", { event_mdown = function() private.ClkTask( 'hammer', 'hammer_2' ) end } },
  { "spr_ladder_staircase_1", { event_mdown = function() private.ClkTask( 'staircase', 'staircase_1' ) end } },
  { "spr_ladder_staircase_2", { event_mdown = function() private.ClkTask( 'staircase', 'staircase_2' ) end } },
    
  } );
  
  common_impl.hint[ "win_ladder" ] = {
      type = "win",
      room = "rm_hallway",
      zz = "ho_ladder",
      zz_gate = "gho_hallway_ladder"
  };
  
  local win_ladder_func = function ()

    if ( cmn.IsEventDone( "win_ladder" ) ) then
      interface.InventoryItemAdd( "inv_chamberkey", "spr_ladder_win" );
    end;

  end;

  local win_ladder_loc = function ()

    if ( cmn.IsEventDone( "win_ladder" ) ) then
      ObjDelete( "gho_hallway_ladder" );
    end;

  end;

  cmn.AddSubscriber( "win_ladder", win_ladder_func );
  cmn.AddSubscriber( "win_ladder", win_ladder_loc );
  --------------------------------------------------------------------------------------------------
  local start_ladder_func = function ()

    if ( cmn.IsEventStart( "win_ladder" ) ) then
      
      local ho_found = ng_global.progress[ "std" ][ "win_ladder" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
      end;

    end;

    ObjSet( "txt_ladder_tasklist", { param0 = ng_global.progress[ "std" ][ "win_ladder" ].counter } );

  end;
  cmn.AddSubscriber( "win_ladder", start_ladder_func, "ho_ladder" );  

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  interface.InvestigationButtonCheck ();
  
  if ( not cmn.IsEventDone( "opn_ladder" ) ) then
  
    cmn.InitHo( "ladder" );
    cmn.SetEventDone( "opn_ladder" );
    ng_global.progress[ "std" ][ "win_ladder" ].counter = 8;
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "binoculars",          1, 0, { { "spr_ladder_binoculars_1", "spr_ladder_binoculars_2"  } } );
  interface.TaskPanelTaskAdd( ho_items, "binoculars_2",          1, 0, { { "spr_ladder_binoculars_2", "spr_ladder_binoculars_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "candlestick",          1, 0, { { "spr_ladder_candlestick_1", "spr_ladder_candlestick_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "candlestick_2",          1, 0, { { "spr_ladder_candlestick_2", "spr_ladder_candlestick_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "cat",          1, 0, { { "spr_ladder_cat_1", "spr_ladder_cat_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "cat_2",          1, 0, { { "spr_ladder_cat_2", "spr_ladder_cat_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "hat",          1, 0, { { "spr_ladder_hat_1", "spr_ladder_hat_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "hat_2",          1, 0, { { "spr_ladder_hat_2", "spr_ladder_hat_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "key",          1, 0, { { "spr_ladder_key_1", "spr_ladder_key_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "key_2",          1, 0, { { "spr_ladder_key_2", "spr_ladder_key_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "brush",          1, 0, { { "spr_ladder_brush_1", "spr_ladder_brush_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "brush_2",          1, 0, { { "spr_ladder_brush_1", "spr_ladder_brush_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "hammer",          1, 0, { { "spr_ladder_hammer_1", "spr_ladder_hammer_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "hammer_2",          1, 0, { { "spr_ladder_hammer_1", "spr_ladder_hammer_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "staircase",          1, 0, { { "spr_ladder_staircase_1", "spr_ladder_staircase_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "staircase_2",          1, 0, { { "spr_ladder_staircase_2", "spr_ladder_staircase_1" } } );
  
  interface.TaskPanelShow( ho_items );
  int_taskpanel_impl.HideTextPanel( "ladder" );

  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Open()

  common_impl.VisitMapRoom( "hallway" );
  common_impl.PassingHoStart();
  int_slider.InitSlider( "ho_ladder" );

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.Close()

  common_impl.PassingHoStop();

  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

  int_taskpanel_impl.ShowTextPanel( "ladder" )

  interface.InvestigationButtonCheck ();
  
end;
--*********************************************************************************************************************
function public.HoComplete()
 
  common_impl.PassingHoWin();

  int_taskpanel_impl.sound_play = true;  

  interface.InvestigationButtonCheck ();
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.ClkTask( task_name, object_name )

  local object =  "spr_ladder_"..object_name.."_light";

  if private.tasks[1] ~= "" then

    if task_name == private.tasks[1] and private.tasks[2] ~= object_name  then

      int_taskpanel_impl.sound_play = true;
      private.TaskComplete( task_name, "spr_ladder_"..task_name.."_1" );

      int_taskpanel_impl.sound_play = false;
      private.TaskComplete( task_name.."_2" );

      ng_global.progress[ "std" ][ "win_ladder" ].counter = ng_global.progress[ "std" ][ "win_ladder" ].counter - 1;

      ObjSet( "txt_ladder_tasklist", { param0 = ng_global.progress[ "std" ][ "win_ladder" ].counter } );

    elseif task_name == private.tasks[1] and private.tasks[2] == object_name  then

      common_impl.PlayAudio( "sfx", "common/audio/aud_ho_ladder_click", 0, "", 0 ); 

      ObjSet( object, { alp = 0 } ); 

    else
     
      ObjSet( "spr_ladder_"..private.tasks[1].."_1_light", { alp = 0 } ); 
      ObjSet( "spr_ladder_"..private.tasks[1].."_2_light", { alp = 0 } );

      common_impl.PlayAudio( "sfx", "common/audio/aud_ho_ladder_wrong", 0, "", 0 ); 
         
    end;

     private.tasks[1] = "";
     private.tasks[2] = "";

     ObjSet( "spr_ladder_"..private.tasks[1].."_1_light", { alp = 0 } ); 
     ObjSet( "spr_ladder_"..private.tasks[1].."_2_light", { alp = 0 } );
    

  else

    common_impl.PlayAudio( "sfx", "common/audio/aud_ho_ladder_click", 0, "", 0 ); 

    private.tasks[1] = task_name;
    private.tasks[2] = object_name;

    ObjSet( object, { alp = 1 } );  
    
  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.TaskComplete( task_name, object_name )

  local object = "";

  if object_name then

    object = tostring( object_name );

  else

    object = "spr_ladder_"..task_name;

  end;
  
  ObjSet( object, { pos_z = 1 } );

  cmn.HoTaskFind( object, task_name );
  
end;

--*********************************************************************************************************************
ObjAnimate( "spr_ladder_chain_1", "ang", 1, 0, "", {  0,3,-0.04, 2,3,0.04, 4,3,-0.04  } );
ObjAnimate( "spr_ladder_chain_2", "ang", 1, 0, "", {  0,3,0.03, 3,3,-0.03, 6,3,0.03  } );
ObjAnimate( "spr_ladder_light", "alp", 1, 0, "", {  0,3,0, 2,3,1, 4,3,0  } );