-- name=mg_bottles
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_bottles";
  
  private.InitMas();

  ObjMultiSet({ 
    { "spr_bottles_tap",      { event_mdown = private.get_tap }},
    { "spr_bottles_safe",     { event_mdown = private.clk_tap_bottles }},

    { "obj_bottles_area_1",   { event_mdown = function () private.TurnBottles(private.Path1) end; }},
    { "obj_bottles_area_2",   { event_mdown = function () private.TurnBottles(private.Path2) end; }},
    { "obj_bottles_area_3",   { event_mdown = function () private.TurnBottles(private.Path3) end; }},
    { "obj_bottles_area_4",   { event_mdown = function () private.TurnBottles(private.Path4) end; }},
    { "obj_bottles_area_5",   { event_mdown = function () private.TurnBottles(private.Path5) end; }},
    { "obj_bottles_area_6",   { event_mdown = function () private.TurnBottles(private.Path6) end; }},
    { "obj_bottles_area_7",   { event_mdown = function () private.TurnBottles(private.Path7) end; }},

  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_bottles = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 

      {
        private.room_objname,
      };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_bottles", update_game_mode_bottles, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_tap_bottles () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_tap_bottles" ] = {
    type = "click",
    use_place = "spr_bottles_safe",
    room = private.room_objname,
    zz = "mg_bottles",
    zz_gate = "gmg_wincards_bottles"
  };


  local clk_tap_bottles_beg = function ()
  
  end;
  local clk_tap_bottles_end = function ()

    ObjDelete("spr_bottles_safe");
    ObjDelete("spr_wincards_winshelf_mg_cover");

    ObjSet("spr_bottles_tap", { active = true, input = true, visible = true });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_tap_bottles", clk_tap_bottles_beg, private.room_objname );
  cmn.AddSubscriber( "clk_tap_bottles", clk_tap_bottles_end, private.room_objname );
  cmn.AddSubscriber( "clk_tap_bottles_beg", clk_tap_bottles_beg, private.room_objname );
  cmn.AddSubscriber( "clk_tap_bottles_end", clk_tap_bottles_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_tap () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tap" ] = {
    type = "get",
    get_obj = "spr_bottles_tap",
    room = "rm_wincards",
    zz = "mg_bottles",
    zz_gate = "gmg_wincards_bottles"
  };
    
  local get_tap_inv = function ()
  
    interface.InventoryItemAdd( "inv_tap", "spr_bottles_tap" );
  
  end;
  
  local get_tap_closezz = function ()
  
    ObjDelete( "spr_wincards_winshelf_faucet_inv" );

    ObjDelete( "gfx_bottles_tap" );
    ObjDelete( "spr_bottles_faucet_shadow" );
    --ObjDelete( "gzz_bottles_bottles" );
  
  end;
  
  cmn.AddSubscriber( "get_tap", get_tap_inv );
  cmn.AddSubscriber( "get_tap", get_tap_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_bottles () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_bottles" ] = {
    type = "win",
    room = "rm_wincards",
    zz = "mg_bottles",
    zz_gate = "gmg_wincards_bottles"
  };

  local win_bottles = function ()

    if ( cmn.IsEventDone( "win_bottles" ) ) then 
      
      ObjSet("spr_bottles_safe", { input = true });

      ObjDelete("anm_bottles_mg_bottles_win");
      ObjDelete("spr_bottles_empty_shelves" );
      ObjDelete("obj_bottles_bottle_shelf"  );
      ObjDelete("obj_bottles_bottles"       );
      ObjDelete("obj_bottles_lables"        );
      ObjDelete("obj_bottles_area"          );

      ObjSet("obj_bottles_win",  { alp = 1 }); 

      ObjDelete("spr_wincards_winshelf_mg_bottles");
      ObjDelete("spr_wincards_winshelf_bottle"    );

    else

      private.MasNumbers = ng_global.progress[ "std" ][ "win_bottles" ].mas_pos;
      private.MasRB = ng_global.progress[ "std" ][ "win_bottles" ].mas_color;
      
      local k=0;

      for i=1,5 do
        for j=1,5 do
          
          if (private.MasNumbers[i][j]~=0) then
 
            k = k + 1;   
            ObjSet("spr_bottles_bottle_"..private.MasNumbers[i][j], { pos_x=private.BottlesPositions[k][1], pos_y=private.BottlesPositions[k][2] });

            --------------------------------------------------------------------------------------------------------------------------------------
            for z=1,6 do
              if (private.MasNumbers[i][j] == private.lables[z]) then

                ObjSet("anm_bottles_lable_"..private.lables[z], { pos_x=private.BottlesPositions[k][1], pos_y=private.BottlesPositions[k][2] } );

              end;
            end;
            --------------------------------------------------------------------------------------------------------------------------------------

          end;

        end;
      end;

    end;

  end;

  cmn.AddSubscriber( "win_bottles", win_bottles, private.room_objname );
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function private.InitMas()

  --стартовые позиции 
  private.StartNumbers = {{  0,  1,  2,  3,  0 },
                          {  4,  5,  6,  7,  0 },
                          {  8,  9, 10, 11, 12 },
                          { 13, 14, 15, 16,  0 },
                          {  0, 17, 18, 19,  0 }};

  private.StartRB = {{  0,  0,  0,  0,  0 },
                     {  1,  0,  1,  0,  0 },
                     {  0,  2,  0,  0,  0 },
                     {  0,  0,  0,  2,  0 },
                     {  0,  1,  2,  0,  0 }};
  ----------------------------------------------------
  --win позиции 
  private.MasNumbersWin = { {   0,  1,  2,  3,  0 },
                            {   5,  9,  4,  7,  0 },
                            {   8,  6, 10, 16, 11 },
                            {  12, 18, 17, 13,  0 },
                            {   0, 14, 15, 19,  0 } };

  private.MasRBWin = {{  0,  0,  0,  0,  0 },
                      {  0,  2,  1,  0,  0 },
                      {  0,  1,  0,  2,  0 },
                      {  0,  2,  1,  0,  0 },
                      {  0,  0,  0,  0,  0 }};
  ----------------------------------------------------
  -- позиции
  private.BottlesPositions = { { 412, 130 },
                               { 545, 132 },
                               { 680, 131 },

                               { 353, 244 },
                               { 480, 245 },
                               { 613, 243 },
                               { 743, 243 },

                               { 283, 364 },
                               { 413, 358 },
                               { 551, 361 },
                               { 678, 362 },
                               { 807, 361 },

                               { 347, 475 },
                               { 480, 475 },
                               { 614, 476 },
                               { 744, 473 },

                               { 416, 587 },
                               { 551, 586 },
                               { 681, 587 },
                             };
  ----------------------------------------------------
  private.MasNumbers = { {  0,  1,  2,  3,  0 },
                         {  4,  5,  6,  7,  0 },
                         {  8,  9, 10, 11, 12 },
                         { 13, 14, 15, 16,  0 },
                         {  0, 17, 18, 19,  0 } };

  -- название спрайтов: / синие: 4, 6, 17 ; красные: 9, 16, 18 /
  -- синие - 1, красные - 2
  private.MasRB = {{  0,  0,  0,  0,  0 },
                   {  1,  0,  1,  0,  0 },
                   {  0,  2,  0,  0,  0 },
                   {  0,  0,  0,  2,  0 },
                   {  0,  1,  2,  0,  0 }};
  ----------------------------------------------------
  private.Path1 = {{1,2},{1,3},{2,3},{3,3},{3,2},{2,1}};
  private.Path2 = {{1,3},{1,4},{2,4},{3,4},{3,3},{2,2}};

  private.Path3 = {{2,1},{2,2},{3,3},{4,2},{4,1},{3,1}};
  private.Path4 = {{2,2},{2,3},{3,4},{4,3},{4,2},{3,2}};
  private.Path5 = {{2,3},{2,4},{3,5},{4,4},{4,3},{3,3}};

  private.Path6 = {{3,2},{3,3},{4,3},{5,3},{5,2},{4,1}};
  private.Path7 = {{3,3},{3,4},{4,4},{5,4},{5,3},{4,2}};
  ----------------------------------------------------

  private.lables = {4,6,9,16,17,18};
  
end;
--*********************************************************************************************************************
function public.Open() 

  common_impl.VisitMapRoom( "wincards" );

  if not cmn.IsEventDone( "win_bottles" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();

    local win_flag = private.CheckBottles();
    if win_flag then

      private.Win();

    end;

  end;

  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_bottles" ) ) then

    ng_global.progress[ "std" ][ "win_bottles" ].mas_pos = private.StartNumbers;
    ng_global.progress[ "std" ][ "win_bottles" ].mas_color = private.StartRB;

  end;
  
  interface.InvestigationButtonCheck();
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_bottles" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_tap()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_tap" );
  cmn.CallEventHandler( "get_tap" );

  cmn.GotoRoom( "rm_wincards" );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS CLK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_tap_bottles()

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_bottles_open", 0, "", 0 );

    cmn.SetEventDone( "clk_tap_bottles" );
    cmn.CallEventHandler( "clk_tap_bottles" );
  
end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()

  for i=1,5 do
    for j=1,5 do
      private.MasNumbers[i][j] = private.StartNumbers[i][j];
      private.MasRB[i][j] = private.StartRB[i][j];
    end;
  end;

  ng_global.progress[ "std" ][ "win_bottles" ].mas_pos = private.MasNumbers;
  ng_global.progress[ "std" ][ "win_bottles" ].mas_color = private.MasRB;

  for i=1,5 do
    for j=1,5 do

      if (private.MasNumbers[i][j]~=0) then 

        local k = private.MasNumbers[i][j];
        ObjSet("spr_bottles_bottle_"..private.MasNumbers[i][j], { pos_x=private.BottlesPositions[k][1], pos_y=private.BottlesPositions[k][2] });

        --------------------------------------------------------------------------------------------------------------------------------------
        for z=1,6 do
          if (private.MasNumbers[i][j] == private.lables[z]) then

            ObjSet("anm_bottles_lable_"..private.lables[z], { pos_x=private.BottlesPositions[k][1], pos_y=private.BottlesPositions[k][2] } );

          end;
        end;
        --------------------------------------------------------------------------------------------------------------------------------------
       
      end;

    end;
  end;

end;
--*********************************************************************************************************************
function public.Skip()
port.skip_mg = true;
  for i=1,5 do
    for j=1,5 do

      private.MasNumbers[i][j] = private.MasNumbersWin[i][j];
      private.MasRB[i][j] = private.MasRBWin[i][j];

    end;
  end;

  ng_global.progress[ "std" ][ "win_bottles" ].mas_pos = private.MasNumbers;
  ng_global.progress[ "std" ][ "win_bottles" ].mas_color = private.MasRB;

  local k=0;

  for i=1,5 do
    for j=1,5 do
      
      if (private.MasNumbers[i][j]~=0) then 

        k = k + 1;   
        ObjSet("spr_bottles_bottle_"..private.MasNumbers[i][j], { pos_x=private.BottlesPositions[k][1], pos_y=private.BottlesPositions[k][2] });

        --------------------------------------------------------------------------------------------------------------------------------------
        for z=1,6 do
          if (private.MasNumbers[i][j] == private.lables[z]) then

            ObjSet("anm_bottles_lable_"..private.lables[z], { pos_x=private.BottlesPositions[k][1], pos_y=private.BottlesPositions[k][2] } );

          end;
        end;
        --------------------------------------------------------------------------------------------------------------------------------------

      end;

    end;
  end;

  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_bottles" );
  cmn.CallEventHandler( "win_bottles" );
  common_impl.PassingMgWin();

end;
--*********************************************************************************************************************
function private.Win()

  local func_after = function ()

    common_impl.Lock(false);

    private.WinEnd();

  end;

  common_impl.Lock(true);

  ObjMultiSet({ 
    { "spr_bottles_empty_shelves",  { alp = 0 }},
    { "obj_bottles_bottle_shelf",   { alp = 0 }},
    { "obj_bottles_bottles",        { alp = 0 }},
    { "obj_bottles_lables",         { alp = 0 }},
    { "anm_bottles_mg_bottles_win", { alp = 1 }},
  });

  AnimPlay( "anm_bottles_mg_bottles_win", "DoAnim", func_after )

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_bottles_win", 0, "", 0 );

end;
--*********************************************************************************************************************
-- поворот ( передаем массив )
function private.TurnBottles( num )  

  local func_after = function ()

    common_impl.Lock(false);

    for i=1,6 do

      ObjAttach( "spr_bottles_bottle_"..private.MasNumbers[num[i][1]][num[i][2]],  "obj_bottles_bottles"  );

    end;

    for i=6,2, -1 do

      temp = private.MasNumbers[num[i][1]][num[i][2]];
      private.MasNumbers[num[i][1]][num[i][2]] = private.MasNumbers[num[i-1][1]][num[i-1][2]];
      private.MasNumbers[num[i-1][1]][num[i-1][2]] = temp;

    end;

    for i=6,2, -1 do

      temp = private.MasRB[num[i][1]][num[i][2]];
      private.MasRB[num[i][1]][num[i][2]] = private.MasRB[num[i-1][1]][num[i-1][2]];
      private.MasRB[num[i-1][1]][num[i-1][2]] = temp;

    end;

    local win_flag = private.CheckBottles();
    if win_flag then

      private.Win();

    else
 
      ng_global.progress[ "std" ][ "win_bottles" ].mas_pos = private.MasNumbers;
      ng_global.progress[ "std" ][ "win_bottles" ].mas_color = private.MasRB;

    end;

  end;
  --------------------------------------------------------------------------
  local mastempFrist = {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}};
  local mastempNext =  {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}};
  local tempNumMas;
----------------------------------------------------------------------------
  for i = 1, 6 do 

    tempNumMas = private.MasNumbers[num[i][1]][num[i][2]];

    mastempFrist[i][1] = ObjGet("spr_bottles_bottle_"..tempNumMas ).pos_x;
    mastempFrist[i][2] = ObjGet("spr_bottles_bottle_"..tempNumMas ).pos_y;

  end;

  for i = 1, 6 do

    if (i == 6) then
      mastempNext[i][1] = mastempFrist[1][1]; 
      mastempNext[i][2] = mastempFrist[1][2];
    else
      mastempNext[i][1] = mastempFrist[i+1][1]; 
      mastempNext[i][2] = mastempFrist[i+1][2];
    end;

  end;
  
  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_bottles_rotate", 0, "", 0 );

  for i =1,6 do

    ObjAttach( "spr_bottles_bottle_"..private.MasNumbers[num[i][1]][num[i][2]],  "obj_bottles_main_attach"  );

    --------------------------------------------------------------------------------
    for j =1,6 do

      if(private.MasNumbers[num[i][1]][num[i][2]]==private.lables[j]) then

        local posx1=ObjGet("anm_bottles_lable_"..private.lables[j] ).pos_x;
        local posy1=ObjGet("anm_bottles_lable_"..private.lables[j] ).pos_y;
        
        ObjAnimate( "anm_bottles_lable_"..private.lables[j], "pos_xy", 0, 0, "",
        {
          0.0, 0, posx1, posy1,
          0.6, 0, mastempNext[i][1], mastempNext[i][2],
        } );

      end;

    end;
    --------------------------------------------------------------------------------

    ObjAnimate( "spr_bottles_bottle_"..private.MasNumbers[num[i][1]][num[i][2]], "pos_xy", 0, 0, func_after,
    {
      0.0, 0, mastempFrist[i][1], mastempFrist[i][2],
      0.6, 0, mastempNext[i][1],  mastempNext[i][2],
    } );

    func_after = "";

  end;

end;
--*********************************************************************************************************************
function private.CheckBottles()

  for i=1,5 do
    for j=1,5 do

      if not (private.MasRB[i][j]==private.MasRBWin[i][j]) then

        return false;

      end;

    end;
  end;
  
  return true;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************