-- name=mg_superpuzzle_3
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_superpuzzle_3";

  -----------------------------
  
  local  table_multiset = {};

  for i = 1,3 do

    table.insert( table_multiset, { "spr_superpuzzle_3_block_1_left_"..i, { event_mdown = function() private.Clk_Flap( "left" ) end }  } );
    table.insert( table_multiset, { "spr_superpuzzle_3_block_1_right_"..i, { event_mdown = function() private.Clk_Flap( "right" ) end }  } );

    table.insert( table_multiset, { "spr_superpuzzle_3_block_2_button_"..i, { event_dragdrop = function () private.block_2_button_dragdrop(i) end }  } );
    table.insert( table_multiset, { "spr_superpuzzle_3_block_2_button_"..i, { event_startdrag = function () private.block_2_button_startdrag(i) end }  } );

    table.insert( table_multiset, { "obj_superpuzzle_3_block_4_button_"..i, { event_mdown = function() private.PuszzleClk_1( i ) end }  } );

    table.insert( table_multiset, { "obj_superpuzzle_3_block_5_line_"..i, { event_mdown = function() private.CounterClick( i ) end }  } );

  end;

  for i = 1,6 do

    table.insert( table_multiset, { "spr_superpuzzle_3_block_3_top_bulb_"..i, { event_mdown = function() private.Bulb_Take( i, 'top' ) end }  } );
    table.insert( table_multiset, { "spr_superpuzzle_3_block_3_bottom_bulb_"..i, { event_mdown = function() private.Bulb_Take( i, 'bottom' ) end }  } );

  end;

  for i = 1,11 do

    table.insert( table_multiset, { "spr_superpuzzle_3_block_6_tile_"..i, { event_mdown = function() private.Clk_Tile_6( i ) end }  } );
    table.insert( table_multiset, { "spr_superpuzzle_3_block_7_tile_"..i, { event_mdown = function() private.Clk_Tile_7( i ) end  }  } );

  end;

  table.insert( table_multiset, { "obj_superpuzzle_3_block_4_button_4", { event_mdown = function() private.PuszzleClk_2( 4 ) end }  } );
  table.insert( table_multiset, { "obj_superpuzzle_3_block_4_button_5", { event_mdown = function() private.PuszzleClk_2( 5 ) end }  } );

  table.insert( table_multiset, { "spr_superpuzzle_3_button_hint", { 
    event_mdown  = private.PuszzleHintClk,
    event_menter = private.PuszzleHintEnter,
    event_mleave = private.PuszzleHintLeave
  } } );

  ObjMultiSet( table_multiset );

  --------------------------------------------------------------------------------------------
  -- function win_superpuzzle_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_superpuzzle_3" ] = {
    type = "win",
    room = "rm_secretroom",
    zz = "mg_superpuzzle_3",
    zz_gate = "gmg_secretroom_superpuzzle3"
  };

  local win_superpuzzle_3 = function ()

    local table_multiset = {};

    private.flap = ng_global.progress[ "std" ][ "win_superpuzzle_3" ].flap;
    private.bulb = ng_global.progress[ "std" ][ "win_superpuzzle_3" ].bulb;
    private.laser = ng_global.progress[ "std" ][ "win_superpuzzle_3" ].laser;
    private.puzzle = ng_global.progress[ "std" ][ "win_superpuzzle_3" ].puzzle;
    private.counter = ng_global.progress[ "std" ][ "win_superpuzzle_3" ].counter;
    private.tile_6 = ng_global.progress[ "std" ][ "win_superpuzzle_3" ].tile_6;
    private.tile_7 = ng_global.progress[ "std" ][ "win_superpuzzle_3" ].tile_7;

    if ( cmn.IsEventDone( "win_superpuzzle_3" ) ) then 
 
      --

    else

      --

    end;

    -----------------------------
    -----------------------------

    if ( private.flap.win ) then

      private.FlapWinSet();
      
    end;

    for i = 1, 3  do

      ObjSet( "spr_superpuzzle_3_block_1_left_"..i,    { input = false, alp = 0 } ); 
      ObjSet( "spr_superpuzzle_3_block_1_right_"..i,    { input = false, alp = 0 } ); 

    end;

    ObjSet( "spr_superpuzzle_3_block_1_left_"..private.flap.cur_left,    { input = true, alp = 1 } ); 
    ObjSet( "spr_superpuzzle_3_block_1_right_".. private.flap.cur_right,    { input = true, alp = 1 } ); 

    -----------------------------
    -----------------------------

    if ( private.laser.win ) then

      private.LaserWinSet();
      
    end;

    for i = 1, #private.laser.buttons_pos - 1 do
    
      private.stand_num_pos_block( "spr_superpuzzle_3_block_2_button_"..i, private.laser.buttons_pos[i][1] - 1, private.laser.buttons_pos[i][2] - 1 );

    end;

    private.block_2_make_laser();

    -----------------------------
    -----------------------------

    if ( private.bulb.win ) then

      private.BulbWinSet();
      
    end;

    for i = 1, 6 do

      local j = private.bulb.top[i];
      local k = private.bulb.bottom[i];

      ObjSet( "spr_superpuzzle_3_block_3_top_bulb_"..j , { pos_x = private.bulb_x[i] });   
      ObjSet( "spr_superpuzzle_3_block_3_bottom_bulb_"..k , { pos_x = private.bulb_x[i] }); 

      if ( private.bulb.top[i] == private.bulb.bottom[i]) then

          ObjSet( "spr_superpuzzle_3_block_3_light_"..private.bulb.top[i], { alp = 1, pos_x = private.bulb_color_x[i]});

      else 

          ObjSet( "spr_superpuzzle_3_block_3_light_"..private.bulb.top[i], { alp = 0 });

      end;

    end;

    local bulb_get_top;
    local bulb_get_bottom;

    if private.bulb.get_top ~= 0 then

      bulb_get_top = private.bulb.get_top;
      ObjSet( "spr_superpuzzle_3_block_3_top_bulb_"..bulb_get_top, { scale_x = 1.2, scale_y = 1.2, pos_z = 5; });

    end;

    if private.bulb.get_bottom ~= 0 then

      bulb_get_bottom = private.bulb.get_bottom;
      ObjSet( "spr_superpuzzle_3_block_3_bottom_bulb_"..bulb_get_bottom, { scale_x = 1.2, scale_y = 1.2, pos_z = 5; });

    end;
    -----------------------------
    -----------------------------

    if ( private.puzzle.win ) then

      private.PuszzleWinSet();
      
    end;

    for i = 1, 4  do

      ObjSet( "spr_superpuzzle_3_block_4_puzzle_"..private.puzzle.mas_1[i], { pos_x = private.puzzle_pos[i][1], pos_y = private.puzzle_pos[i][2], ang = private.puzzle.mas_angles_1[i] });
      ObjAttach( "spr_superpuzzle_3_block_4_puzzle_"..private.puzzle.mas_1[i], "obj_superpuzzle_3_block_4_romb_1");

      ObjSet( "spr_superpuzzle_3_block_4_puzzle_"..private.puzzle.mas_2[i], { pos_x = private.puzzle_pos[i][1], pos_y = private.puzzle_pos[i][2], ang = private.puzzle.mas_angles_2[i] });
      ObjAttach( "spr_superpuzzle_3_block_4_puzzle_"..private.puzzle.mas_2[i], "obj_superpuzzle_3_block_4_romb_2");

      ObjSet( "spr_superpuzzle_3_block_4_puzzle_"..private.puzzle.mas_3[i], { pos_x = private.puzzle_pos[i][1], pos_y = private.puzzle_pos[i][2], ang = private.puzzle.mas_angles_3[i] });
      ObjAttach( "spr_superpuzzle_3_block_4_puzzle_"..private.puzzle.mas_3[i], "obj_superpuzzle_3_block_4_romb_3");

    end;

    ObjSet( "obj_superpuzzle_3_block_4_romb_1", { ang = private.puzzle_angl [ private.puzzle.angl_1 ] });
    ObjSet( "obj_superpuzzle_3_block_4_romb_2", { ang = private.puzzle_angl [ private.puzzle.angl_2 ] });
    ObjSet( "obj_superpuzzle_3_block_4_romb_3", { ang = private.puzzle_angl [ private.puzzle.angl_3 ] });
    
    -----------------------------
    -----------------------------

    if ( private.counter.win ) then

      private.CounterWinSet();
      
    end;
    
    for i = 1, 3  do

      for j = 1, 6  do

        ObjSet( "spr_superpuzzle_3_block_5_counter_"..i.."_"..private.counter.state[i][j], { pos_x = private.counter_x[j] } );

      end;

    end;

    if ( private.counter.state[ 1 ][ 5 ] == 1 ) then

      ObjSet( "spr_superpuzzle_3_block_5_light_1", { alp = 1 });

    end;

    if ( private.counter.state[ 2 ][ 5 ] == 5 ) then

      ObjSet( "spr_superpuzzle_3_block_5_light_2", { alp = 1 });

    end;

    if ( private.counter.state[ 3 ][ 5 ] == 6 ) then

      ObjSet( "spr_superpuzzle_3_block_5_light_3", { alp = 1 });

    end;

    -----------------------------
    -----------------------------

    if ( private.tile_6.win ) then

      private.Tile_6_WinSet();
      
    end;

    for i = 1, 11  do

      if i == 3 or i == 4 or i == 5 or i == 6 or i == 9 or i == 11 then

        if private.tile_6.state[i] == 1 then

          ObjSet( "spr_superpuzzle_3_block_6_tile_"..i,    { ang = 0 } );

        else

          ObjSet( "spr_superpuzzle_3_block_6_tile_"..i,    { ang =  -1.578 } );

        end;

      else

        ObjSet( "spr_superpuzzle_3_block_6_tile_"..i,    { ang =  -1.578 * private.tile_6.state[i]; } );  

      end;

    end;

    -----------------------------
    -----------------------------

    if ( private.tile_7.win ) then

      private.Tile_7_WinSet();
      
    end;

    for i = 1, 11  do

      if i == 2 or i == 3 or i == 6 or i == 7 or i == 10 or i == 11 then

        if private.tile_7.state[i] == 1 then

          ObjSet( "spr_superpuzzle_3_block_7_tile_"..i,    { ang = 0 } );

        else

          ObjSet( "spr_superpuzzle_3_block_7_tile_"..i,    { ang =  -1.578 } );

        end;

      else

        ObjSet( "spr_superpuzzle_3_block_7_tile_"..i,    { ang =  -1.578 * private.tile_7.state[i]; } );  

      end;

    end;

    -----------------------------
    -----------------------------

  end;

  cmn.AddSubscriber( "win_superpuzzle_3", win_superpuzzle_3, private.room_objname );

  -----------------------------
  --Mmg flap var
  -----------------------------
  private.flap = {};
  private.flap.cur_left = 1;
  private.flap.cur_right = 2;

  -----------------------------
  --Mmg laser var
  -----------------------------
  private.laser = {};
  private.laser.buttons_pos = { { 5,2 }, { 3 ,3 }, { 5, 4 }, { 5,3 }};

  -----------------------------
  --Mmg bulb var
  -----------------------------
  private.bulb = {};
  private.bulb.top = { 6, 4, 2, 1, 5, 3 };
  private.bulb.bottom = { 1, 5, 2, 6, 4, 3 };
  private.bulb.get_top = 0; 
  private.bulb.get_bottom = 0;
  private.bulb_x = { 66, 118, 171, 222, 272, 326 };
  private.bulb_color_x = { 63, 120, 169, 221, 276, 323 };
  -----------------------------
  --Mmg puzzle var
  -----------------------------
  private.puzzle = {};
  private.puzzle.mas_1 = { 5, 2, 7, 12 };
  private.puzzle.mas_2 = { 1, 10, 3, 8 };
  private.puzzle.mas_3 = { 9, 6, 11, 4 };
  private.puzzle.angl_1 = 1;
  private.puzzle.angl_2 = 1;
  private.puzzle.angl_3 = 1;
  private.puzzle.mas_angles_1 = { 0, 0, 0, 0 };
  private.puzzle.mas_angles_2 = { 0, 0, 0, 0 };
  private.puzzle.mas_angles_3 = { 0, 0, 0, 0 };

  private.puzzle_angl  = { 0, -1.578, -3.156, -4.734, -6.312 };
  private.puzzle_pos_angl = { 3, 4, 1, 2 };
  private.puzzle_pos_angl_2 = { 1, 2, 3, 4 };
  private.puzzle_pos = {
    { -25, 0  },
    {  0, 25  },
    {  25, 0  },
    {  0, -25  }
  }

  -----------------------------
  --Mmg counter var
  -----------------------------
  private.counter = {};
  private.counter.state = {
    { 1, 2, 3, 4, 5, 6 },
    { 6, 4, 2, 5, 1, 3 },
    { 5, 6, 3, 4, 2, 1 }
  };
  private.counter_finish = {
    { 3, 4, 5, 6, 1, 2 },
    { 3, 6, 4, 2, 5, 1 },
    { 4, 2, 1, 5, 6, 3 }
  };
  private.counter_x = { 0, 70, 138, 210, 278, 348 };

  -----------------------------
  --Mmg tile_6
  -----------------------------
  private.tile_6 = {};
  private.tile_6.state = { 2, 3, 1, 1, 0, 0, 0, 3, 1, 2, 0 };
  private.tile_6_finish = { 0, 0, 0, 0, 0, 0, 3, 1, 0, 2, 1 };

  -----------------------------
  --Mmg tile_7
  -----------------------------
  private.tile_7 = {};
  private.tile_7.state = { 0, 0, 1, 0, 3, 1, 0, 1, 1, 1, 1 };
  private.tile_7_finish = { 1, 0, 0, 2, 0, 0, 0, 2, 0, 0, 0 };

end;
--*********************************************************************************************************************
function public.Open() 

  common_impl.VisitMapRoom( "secretroom" );

  if not cmn.IsEventDone( "win_superpuzzle_3" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
  int_slider.InitSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_superpuzzle_3" ) ) then

    ng_global.progress[ "std" ][ "win_superpuzzle_3" ].flap = private.flap;
    ng_global.progress[ "std" ]["win_superpuzzle_3"].bulb = private.bulb;
    ng_global.progress[ "std" ][ "win_superpuzzle_3" ].laser = private.laser;
    ng_global.progress[ "std" ][ "win_superpuzzle_3" ].puzzle = private.puzzle;
    ng_global.progress[ "std" ][ "win_superpuzzle_3" ].counter = private.counter;
    ng_global.progress[ "std" ][ "win_superpuzzle_3" ].tile_6 = private.tile_6;
    ng_global.progress[ "std" ][ "win_superpuzzle_3" ].tile_7 = private.tile_7;

  end;
  
  interface.InvestigationButtonCheck();
  
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_superpuzzle_3" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()

  if ( private.flap.reset and not private.flap.win ) then
    private.FlapResetSet();
  end;
  if ( private.bulb.reset and not private.bulb.win ) then
    private.BulbResetSet();
  end;
  if ( private.laser.reset and not private.laser.win ) then
    private.LaserResetSet();
  end;
  if ( private.counter.reset and not private.counter.win ) then
    private.CounterResetSet();
  end;
  if ( private.puzzle.reset and not private.puzzle.win ) then
    private.PuszzleResetSet();
  end;
  if ( private.tile_6.reset and not private.tile_6.win ) then
    private.Tile_6_ResetSet()
  end;
  if ( private.tile_7.reset and not private.tile_7.win ) then
    private.Tile_7_ResetSet()
  end;

end;
--*********************************************************************************************************************
function public.Skip()
port.skip_mg = true;
  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_superpuzzle_3" );
  cmn.CallEventHandler( "win_superpuzzle_3" );
  common_impl.PassingMgWin();
  cmn.GotoRoom( "rm_secretroom" );

end;
--*********************************************************************************************************************
function private.Win()

  private.WinEnd();

end;
--*********************************************************************************************************************
-- function *** Mmg Flap ***() end
--*********************************************************************************************************************
  function private.Clk_Flap( current )
    
    local func_after = function()

       if ( current == "left" ) then

         private.flap.cur_left = private.flap.cur_left + 1;

         if ( private.flap.cur_left == 4 ) then

           private.flap.cur_left = 1;

           ObjSet( "spr_superpuzzle_3_block_1_left_3", { input = false , alp = 0 });
           ObjSet( "spr_superpuzzle_3_block_1_left_1", { input = true , alp = 1 });

         else 

           ObjSet( "spr_superpuzzle_3_block_1_left_"..private.flap.cur_left, { input = true , alp = 1 });
           ObjSet( "spr_superpuzzle_3_block_1_left_"..private.flap.cur_left - 1, { input = false , alp = 0 });

         end;

       else 

         private.flap.cur_right = private.flap.cur_right + 1;

         if ( private.flap.cur_right == 4 ) then

           private.flap.cur_right = 1;

           ObjSet( "spr_superpuzzle_3_block_1_right_3", { input = false , alp = 0 });
           ObjSet( "spr_superpuzzle_3_block_1_right_1", { input = true , alp = 1 });

         else 

           ObjSet( "spr_superpuzzle_3_block_1_right_"..private.flap.cur_right, { input = true , alp = 1 });
           ObjSet( "spr_superpuzzle_3_block_1_right_"..private.flap.cur_right - 1, { input = false , alp = 0 });

         end;

       end;

      if ( private.CheckFlapWin() ) then

        private.FlapWin();
        common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_win_combination", 0, "", 0 );

      else 

        common_impl.Lock( false );
        ng_global.progress[ "std" ][ "win_superpuzzle_3" ].flap = private.flap;

      end

    end;

    common_impl.Lock( true );

    private.flap.reset = true;

    if ( current == "left" ) then

      local num = private.flap.cur_left;

      if ( num == 3 ) then

        ObjAnimate( "spr_superpuzzle_3_block_1_left_3", "alp", 0, 0, "",
        { 
          0.0, 0, 1, 
          0.3, 0, 0
        } );

        ObjAnimate( "spr_superpuzzle_3_block_1_left_1", "alp", 0, 0, func_after,
        { 
          0.0, 0, 0, 
          0.3, 0, 1
        } );

      else 

        ObjAnimate( "spr_superpuzzle_3_block_1_left_"..num, "alp", 0, 0, "",
        { 
          0.0, 0, 1, 
          0.3, 0, 0
        } );

        ObjAnimate( "spr_superpuzzle_3_block_1_left_"..num + 1, "alp", 0, 0, func_after,
        { 
          0.0, 0, 0, 
          0.3, 0, 1
        } );

      end;

    else 

      local num = private.flap.cur_right;

      if ( num == 3 ) then

        ObjAnimate( "spr_superpuzzle_3_block_1_right_3", "alp", 0, 0, "",
        { 
          0.0, 0, 1, 
          0.3, 0, 0
        } );

        ObjAnimate( "spr_superpuzzle_3_block_1_right_1", "alp", 0, 0, func_after,
        { 
          0.0, 0, 0, 
          0.3, 0, 1
        } );

      else 

        ObjAnimate( "spr_superpuzzle_3_block_1_right_"..num, "alp", 0, 0, "",
        { 
          0.0, 0, 1, 
          0.3, 0, 0
        } );

        ObjAnimate( "spr_superpuzzle_3_block_1_right_"..num + 1, "alp", 0, 0, func_after,
        { 
          0.0, 0, 0, 
          0.3, 0, 1
        } );

      end;

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_center_click", 0, "", 0 );

  end;

  --*********************************************************************************************************************
  function private.CheckFlapWin()
  
    local win = false;

      if ( private.flap.cur_left == private.flap.cur_right and private.flap.cur_left == 3 ) then
        win = true;
      end;

    return win;

  end;
  --*********************************************************************************************************************
  function private.FlapWin()
  
    common_impl.Lock( true );

    local func_after = function()

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_open_modul", 0, "", 0 );
      private.FlapAnim_2( 5 );
      private.FlapAnim_3( 3 );

    end;

    ObjAnimate( "spr_superpuzzle_3_block_1_circle", "scale_xy", 0, 0, func_after,
    { 
      0.0, 0, 0.9, 0.9,
      0.3, 0, 1, 1
    } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_center_win", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.FlapAnim_2( number )

    local number = number;
    ObjSet( "spr_superpuzzle_3_gate_2_shadow", { alp = 0 });

    local func_after_rec = function()

      ObjSet( "spr_superpuzzle_3_gate_2_"..number, { alp = 0 });
      number = number - 1;
      private.FlapAnim_2( number );

    end;

    local func_after = function()

      common_impl.Lock( false );
      ObjSet( "spr_superpuzzle_3_gate_2_1", { alp = 0 });
      ObjSet( "obj_superpuzzle_3_gate_2_open", { alp = 1 });

      private.flap.win = true;
      ng_global.progress[ "std" ][ "win_superpuzzle_3" ].flap = private.flap;

      private.FlapWinSet();

    end;

    if ( number > 1 ) then

      ObjAnimate( "spr_superpuzzle_3_gate_2_"..number, "pos_y", 0, 0, func_after_rec,
      { 
        0.0, 0, ObjGet( "spr_superpuzzle_3_gate_2_"..number ).pos_y,
        0.3, 0, ObjGet( "spr_superpuzzle_3_gate_2_"..number - 1 ).pos_y
      } );
      
    else 

      ObjAnimate( "spr_superpuzzle_3_gate_2_"..number, "pos_y", 0, 0, func_after,
      { 
        0.0, 0, ObjGet( "spr_superpuzzle_3_gate_2_"..number ).pos_y,
        0.3, 0, 37
      } );

    end;

  end;
  --*********************************************************************************************************************
  function private.FlapAnim_3( number )

    local number = number;
    ObjSet( "spr_superpuzzle_3_gate_3_shadow", { alp = 0 });

    local func_after_rec = function()

      ObjSet( "spr_superpuzzle_3_gate_3_"..number, { alp = 0 });
      number = number - 1;
      private.FlapAnim_3( number );

    end;

    local func_after = function()

      ObjSet( "spr_superpuzzle_3_gate_3_1", { alp = 0 });
      ObjSet( "obj_superpuzzle_3_gate_3_open", { alp = 1 });

    end;

    if ( number > 1 ) then

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_open_curtains", 0, "", 0 );

      ObjAnimate( "spr_superpuzzle_3_gate_3_"..number, "pos_y", 0, 0, func_after_rec,
      { 
        0.0, 0, ObjGet( "spr_superpuzzle_3_gate_3_"..number ).pos_y,
        0.3, 0, ObjGet( "spr_superpuzzle_3_gate_3_"..number - 1 ).pos_y
      } );
      
    else 

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_open_curtains", 0, "", 0 );

      ObjAnimate( "spr_superpuzzle_3_gate_3_"..number, "pos_y", 0, 0, func_after,
      { 
        0.0, 0, ObjGet( "spr_superpuzzle_3_gate_3_"..number ).pos_y,
        0.3, 0, 665
      } );

    end;

  end;
  --*********************************************************************************************************************
  function private.FlapWinSet()

    ObjSet( "obj_superpuzzle_3_block_1",    {  input = false } ); 

    for i = 1, 2  do

      ObjSet( "spr_superpuzzle_3_block_1_left_"..i, {  alp = 0 } ); 
      ObjSet( "spr_superpuzzle_3_block_1_right_"..i, {  alp = 0 }  );

    end;
    
    ObjSet( "spr_superpuzzle_3_block_1_left_3",{  alp = 1 } ); 
    ObjSet( "spr_superpuzzle_3_block_1_right_3",{ alp = 1 } ); 
    ObjSet( "spr_superpuzzle_3_block_1_circle",{ scale_x = 1, scale_y = 1 } ); 

    -- 2 and 3 blocks
    ObjSet( "obj_superpuzzle_3_block_2",{ input = true } ); 
    ObjSet( "obj_superpuzzle_3_block_3",{ input = true } ); 
    ObjSet( "obj_superpuzzle_3_gate_2_open", { alp = 1 });
    ObjSet( "obj_superpuzzle_3_gate_3_open", { alp = 1 });
    ObjDelete( "obj_superpuzzle_3_gate_2_close" );
    ObjDelete( "obj_superpuzzle_3_gate_3_close" );

  end;
  --*********************************************************************************************************************
  function private.FlapResetSet ()

    private.flap.cur_left = 1;
    private.flap.cur_right = 2;

    private.flap.reset = false;
    private.flap.win = false;

    ng_global.progress[ "std" ][ "win_superpuzzle_3" ].flap = private.flap;

    for i = 1, 3  do

      ObjSet( "spr_superpuzzle_3_block_1_left_"..i,    { input = false, alp = 0 } ); 
      ObjSet( "spr_superpuzzle_3_block_1_right_"..i,    { input = false, alp = 0 } ); 

    end;

    ObjSet( "spr_superpuzzle_3_block_1_left_"..private.flap.cur_left,    { input = true, alp = 1 } ); 
    ObjSet( "spr_superpuzzle_3_block_1_right_".. private.flap.cur_right,    { input = true, alp = 1 } ); 

    ObjSet( "spr_superpuzzle_3_block_1_circle",{ scale_x = 0.9, scale_y = 0.9 } ); 
    
  end;
--*********************************************************************************************************************
-- function *** Mmg Laser ***() end
--*********************************************************************************************************************
  function private.block_2_button_dragdrop( num )

    ObjAttach( "spr_superpuzzle_3_block_2_button_"..num, "obj_superpuzzle_3_block_2" );

    local pos_xy = GetGameCursorPos();
    
    if  tostring(GetPlatform()) == "android" then
     pos_xy[2] = pos_xy[2] - 100;
    elseif tostring(GetPlatform()) == "ios" then
      if port.isTablet() == 0 then
        pos_xy[2] = pos_xy[2] - 75;
      else
        pos_xy[2] = pos_xy[2] - 50;
      end;
    end;
    
    
    local pos_parent_x = ObjGet("obj_superpuzzle_3_block_2").pos_x;
    local pos_parent_y = ObjGet("obj_superpuzzle_3_block_2").pos_y;

    local step = 53;
    local shift_xy = 28;

    local cur_pos_x = pos_xy[1] - pos_parent_x;
    local cur_pos_y = pos_xy[2] - pos_parent_y;

    local  numpos_x = math.floor (cur_pos_x/step);
    local  numpos_y = math.floor (cur_pos_y/step);

    local flag = true;

    if ( numpos_y > -1 and numpos_y < 5 and numpos_x > -1 and numpos_x < 5 ) then 

      for i = 1, 4 do
        
        if ( private.laser.buttons_pos[i][1] == ( numpos_x + 1 ) ) and ( private.laser.buttons_pos[i][2] == ( numpos_y + 1 ) ) then
          
          flag = false;
          
          break;

        end;

      end;

    else
      
     flag = false; 

    end;

    private.laser.reset = true;

    if ObjIntersect( "spr_superpuzzle_3_block_2_button_"..num, "obj_superpuzzle_3_block_2" ) and flag then

      private.stand_num_pos_block( "spr_superpuzzle_3_block_2_button_"..num, numpos_x, numpos_y );
      private.laser.buttons_pos[num][1] = numpos_x + 1;
      private.laser.buttons_pos[num][2] = numpos_y + 1;
      private.block_2_make_laser();
      ObjSet( "spr_superpuzzle_3_block_2_button_"..num,{ pos_z = 0 });

    else

      private.laser.buttons_pos[num][1] = private.block_2_but_cur_pos[1];
      private.laser.buttons_pos[num][2] = private.block_2_but_cur_pos[2];
      private.block_2_make_laser();
      ObjSet( "spr_superpuzzle_3_block_2_button_"..num,{ pos_z = 0 });

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_laser_set", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.block_2_button_startdrag( num )

    ObjSet( "spr_superpuzzle_3_block_2_button_"..num, {  pos_z = 5 } );
    ObjAttach( "spr_superpuzzle_3_block_2_button_"..num, "obj_superpuzzle_3_block_pos_z" );

    private.block_2_but_cur_pos = { private.laser.buttons_pos[num][1], private.laser.buttons_pos[num][2] };

    private.laser.buttons_pos[num][1] = 0;
    private.laser.buttons_pos[num][2] = 0;
    private.block_2_make_laser();

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_laser_get", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.block_2_make_laser()
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_laser_change", 0, "", 0 );

    local k = 1;

    while ( true ) do
    
    if ObjGet( "spr_superpuzzle_3_block_2_laser"..k ) then

      ObjDelete( "spr_superpuzzle_3_block_2_laser"..k );

      k = k + 1;

    else

      break;
    
    end;

    end;

    local flag_laser_blocked = true;
    
    for i = 1,#private.laser.buttons_pos do

      if ( private.laser.buttons_pos[i][1] == 4 and private.laser.buttons_pos[i][2] == 3 ) then

        flag_laser_blocked = false;
        break;

      end;

    end;

    if ( flag_laser_blocked )then

      private.laser_coord = {} ;  

      local num_pos_x = 5;
      local num_pos_y = 3;

      local next_num_pos_x = 5;
      local next_num_pos_y = 3;

      local inc_y = 1;
      local inc_x = -1;
      local noun = true;
      local laser_way = {};

      while ( #private.laser_coord < 5 and  num_pos_x > 0 and num_pos_x < 6  and num_pos_y > 0  and num_pos_y < 6  ) do

        if noun == true then 

        next_num_pos_x = next_num_pos_x + inc_x;
        
        else

        next_num_pos_y = next_num_pos_y + inc_y;

        end;
        
        noun = not noun;

      if ( not private.button_is_place( next_num_pos_x, next_num_pos_y ) ) then
          
        num_pos_x = next_num_pos_x;
        num_pos_y = next_num_pos_y;
        table.insert( laser_way , { num_pos_x, num_pos_y });

        else
        
        table.insert( private.laser_coord , { num_pos_x, num_pos_y, next_num_pos_x, next_num_pos_y  });

        if ( next_num_pos_y ~= num_pos_y ) then 
          
          inc_y = -1*inc_y;
          next_num_pos_y = num_pos_y;

        else

          inc_x = -1*inc_x;
          next_num_pos_x = num_pos_x;

        end;    

        end;

      end; 
      
      local flag_f = true;
      
      if ( not private.laser_is_looped() ) then
      
        table.insert( private.laser_coord , { laser_way[#laser_way-1][1], laser_way[#laser_way-1][2], laser_way[#laser_way][1], laser_way[#laser_way][2]  });
        
      end; 


      local mas_laser_coord = private.create_laser_coord();

      for i = 1, #mas_laser_coord - 1 do

      ObjDelete("spr_superpuzzle_3_block_2_laser"..i);

      private.create_laser( "spr_superpuzzle_3_block_2_laser"..i , mas_laser_coord[i][1], mas_laser_coord[i][2], mas_laser_coord[i+1][1],mas_laser_coord[i+1][2] );

      end;

      if ( private.laser_check_win() ) then

        private.Laser_WinAnim();
        common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_win_combination", 0, "", 0 );

      else 

        ng_global.progress[ "std" ][ "win_superpuzzle_3" ].laser = private.laser;

      end;

    else -- если рядом с лазером

      ng_global.progress[ "std" ][ "win_superpuzzle_3" ].laser = private.laser;

    end;

  end;
  --*********************************************************************************************************************
  function private.button_is_place(num_pos_x,num_pos_y )

    for i = 1, 4 do

    if ( private.laser.buttons_pos[i][1] == num_pos_x ) and ( private.laser.buttons_pos[i][2] == num_pos_y ) then

      return true;

    end;

    end;

    return false;  

  end;
  --*********************************************************************************************************************
  function private.LaserParams ( x_1,  y_1, x_2, y_2 )

    local a = x_2 - x_1;
    local b = y_2 - y_1;

    local length = math.sqrt( b*b + a*a );  

    local ang = - math.atan2( b, a );
    return { length = length, ang = ang };

  end
  --*********************************************************************************************************************
  function private.create_laser( laser_name, pos_x1, pos_y1, pos_x2 ,pos_y2 )
 
    ObjCreate( laser_name, "spr" );
    ObjAttach( laser_name, "obj_superpuzzle_3_block_2" );  

    local laser_params = private.LaserParams( pos_x1, pos_y1, pos_x2, pos_y2 );

    ObjSet( laser_name,
    {

     res = "assets/levels/level3/mg_superpuzzle_3/layers/block_2/laser_line",
     pos_x = ( pos_x1 + pos_x2 )/2,
     pos_y = ( pos_y1 + pos_y2 )/2,
     pos_z = -5;
     ang = laser_params.ang, 
     scale_x = laser_params.length/2,
     input = false;

    } );

  end;
  --*********************************************************************************************************************
  function private.create_laser_coord()

    local mas_coord = {};
    
    table.insert( mas_coord , { 212, 132.5 } );

    for i = 1,#private.laser_coord do

    table.insert( mas_coord , { ( private.laser_coord[i][1]+private.laser_coord[i][3] ) / 2 * 53 - 26.5, ( private.laser_coord[i][2]+private.laser_coord[i][4] ) / 2 * 53 - 26.5 } );

    end;

    return mas_coord;

  end;
  --*********************************************************************************************************************
  function private.stand_num_pos_block( num_spr, num_pos_x, num_pos_y )

    local step = 53;
    local shift_xy = 28;
    local numpos_x = num_pos_x;
    local numpos_y = num_pos_y;
    local cur_pos_x = numpos_x*step + shift_xy;
    local cur_pos_y = numpos_y*step + shift_xy;

    ObjSet( num_spr, { pos_x = cur_pos_x  , pos_y = cur_pos_y } );

  end;
  --*********************************************************************************************************************
  function private.laser_is_looped()

   if #private.laser_coord > 1 then 

     local num_pos_x = private.laser_coord[1][1];
     local num_pos_y = private.laser_coord[1][2];
     local next_num_pos_x = private.laser_coord[1][3];
     local next_num_pos_y = private.laser_coord[1][4];

     for i = 2, #private.laser_coord  do

     if ( num_pos_x == private.laser_coord[i][1] and num_pos_y == private.laser_coord[i][2] and
       next_num_pos_x == private.laser_coord[i][3] and next_num_pos_y == private.laser_coord[i][4] ) then
      
       return true; 
     
     end;

     end;

   end;

    return false;
    
  end;
  --*********************************************************************************************************************
  function private.laser_check_win()
   
    local len = #private.laser_coord 

     if ( 5 == private.laser_coord[len][1] and 2 == private.laser_coord[len][2] and
     6 == private.laser_coord[len][3] and 2 == private.laser_coord[len][4] ) then
     
     return true;

     else
      
     return false;

     end;

  end;
  --*********************************************************************************************************************
  function private.Laser_WinAnim()

    local func_after = function()

      common_impl.Lock( false );

      private.laser.win = true;

      ng_global.progress[ "std" ][ "win_superpuzzle_3" ].laser = private.laser;

      private.LaserWinSet ();

    end;

    if ( private.laser.win ) then

      common_impl.Lock( false );
      private.LaserWinSet();

    else 

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_open_curtains", 0, "", 0 );
      ObjAnimate( "spr_superpuzzle_3_gate_4", "pos_y", 0, 0, func_after,
      { 
        0.0, 0, ObjGet( "spr_superpuzzle_3_gate_4" ).pos_y,
        0.5, 0, -167
      } );

    end;

  end;
  --*********************************************************************************************************************
  function private.LaserWinSet ()

    local table_multiset = {};

    table.insert( table_multiset, { "obj_superpuzzle_3_block_2", { input = false } } );

    --4 blocks
    table.insert( table_multiset, { "obj_superpuzzle_3_block_4", { input = true } } );

    ObjMultiSet( table_multiset );

    ObjDelete( "spr_superpuzzle_3_gate_4" );

  end;
  --*********************************************************************************************************************
  function private.LaserResetSet ()

    private.laser.buttons_pos = { { 5,2 }, { 3 ,3 }, { 5, 4 }, { 5,3 }};
    private.laser.reset = false;
    private.laser.win = false;
    ng_global.progress[ "std" ][ "win_superpuzzle_3" ].laser = private.laser;

    for i = 1, #private.laser.buttons_pos - 1 do
    
    private.stand_num_pos_block( "spr_superpuzzle_3_block_2_button_"..i, private.laser.buttons_pos[i][1] - 1, private.laser.buttons_pos[i][2] - 1 );

    end;

    private.block_2_make_laser();

  end;
--*********************************************************************************************************************
-- function *** Mmg Bulb ***() end
--*********************************************************************************************************************
  function private.Bulb_Take( number, current )

    local flag_top;
    local first_bulb_top;
    local flag_bottom;
    local first_bulb_bottom;

    for i = 1,6 do

      if ObjGet("spr_superpuzzle_3_block_3_top_bulb_"..i).scale_x > 1.2 then 

          flag_top = true;
          first_bulb_top = i;
              
      end; 

      if ObjGet("spr_superpuzzle_3_block_3_bottom_bulb_"..i).scale_x > 1.2 then 

          flag_bottom = true;
          first_bulb_bottom = i;
              
      end; 

    end; 

    private.bulb.reset = true;

    if flag_top or flag_bottom then

      if flag_top and current == "top" then 

        if number == first_bulb_top then 
            
            local func_after = function()

              common_impl.Lock( false );
              private.bulb.get_bottom = 0;
              private.bulb.get_top = 0;

            end;

            common_impl.Lock( true );
          
            ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number , "scale_x", 0, 0, "", 
            {          
                0.0, 0,  1.2, 
                0.3, 0,  1       
            });

            ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number , "scale_y", 0, 0, "", 
            {          
                0.0, 0,  1.2, 
                0.3, 0,  1     
            }); 

            ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number , "pos_z", 0, 0, func_after, 
            {          
                0.0, 0,  ObjGet( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number ).pos_z, 
                0.3, 0,  0     
            });  

            common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_circle_set", 0, "", 0 );

        else

            private.Bulb_Move( first_bulb_top, number, current );

        end; 

      elseif flag_bottom and current == "bottom" then

        if number == first_bulb_bottom then 
          
            local func_after = function()

              common_impl.Lock( false );
              private.bulb.get_bottom = 0;
              private.bulb.get_top = 0;

            end;

            common_impl.Lock( true );
          
            ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number , "scale_x", 0, 0, "", 
            {          
                0.0, 0,  1.2, 
                0.3, 0,  1       
            });

            ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number , "scale_y", 0, 0, "", 
            {          
                0.0, 0,  1.2, 
                0.3, 0,  1     
            }); 

            ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number , "pos_z", 0, 0, func_after, 
            {          
                0.0, 0,  ObjGet( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number ).pos_z, 
                0.3, 0,  0     
            });  

            common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_circle_set", 0, "", 0 );

        else

            private.Bulb_Move( first_bulb_bottom, number, current );

        end;

      elseif flag_bottom and current == "top" then 

        private.Bulb_Not_Scale( first_bulb_bottom, "bottom" );

      elseif flag_top and current == "bottom" then 

        private.Bulb_Not_Scale( first_bulb_top, "top" );

      end;
            
    else 

      common_impl.Lock( true );

      local func_after = function()

        private.Bulb_Get( number, current );

      end;
      
      ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number , "scale_x", 0, 0, "", 
      {          
          0.0, 0,  1, 
          0.3, 0,  1.2       
      });

      ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number , "scale_y", 0, 0, "", 
      {          
          0.0, 0,  1, 
          0.3, 0,  1.2      
      }); 

      ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number , "pos_z", 0, 0, func_after, 
      {          
          0.0, 0,  ObjGet("spr_superpuzzle_3_block_3_"..current.."_bulb_"..number).pos_z, 
          0.3, 0,  50     
      });  
    
      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_circle_select", 0, "", 0 );

    end; 

  end;
  --*********************************************************************************************************************
  function private.Bulb_Not_Scale( first_bulb, current )

    local func_after = function()

      common_impl.Lock( false );
      private.bulb.get_bottom = 0;
      private.bulb.get_top = 0;

    end;

    common_impl.Lock( true );

    ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..first_bulb , "scale_x", 0, 0, "", 
    {          
        0.0, 0,  1.2, 
        0.3, 0,  1       
    });

    ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..first_bulb , "scale_y", 0, 0, "", 
    {          
        0.0, 0,  1.2, 
        0.3, 0,  1     
    }); 

    ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..first_bulb , "pos_z", 0, 0, func_after, 
    {          
        0.0, 0,  ObjGet( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..first_bulb ).pos_z, 
        0.3, 0,  0     
    }); 

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_circle_set", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.Bulb_Get( number, current )
    
    if ( current == "top" ) then
      private.bulb.get_top = number;
    else 
      private.bulb.get_bottom = number;
    end;

    common_impl.Lock( false );

  end;
  --*********************************************************************************************************************
  function private.Bulb_Move( first_bulb, number, current )

    common_impl.Lock( true );

    local func_after =  function()

      private.Bulb_Move_1( first_bulb, number, current );

    end;

    ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number , "scale_x", 0, 0, "", 
    {          
        0.0, 0,  1, 
        0.3, 0,  1.2       
    });

    ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number , "scale_y", 0, 0, func_after, 
    {          
        0.0, 0,  1, 
        0.3, 0,  1.2  
    });

    ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number , "pos_z", 0, 0, "", 
    {          
        0.0, 0,  ObjGet("spr_superpuzzle_3_block_3_"..current.."_bulb_"..number).pos_z, 
        0.3, 0,  51     
    });  

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_circle_select", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.Bulb_Move_1( first_bulb, number, current )

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_circle_move", 0, "", 0 );

    local first_bulb_pos_x = ObjGet( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..first_bulb ).pos_x

    ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..first_bulb , "pos_x", 0, 0, "", 
    {          
        0.0, 0,  ObjGet( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..first_bulb ).pos_x, 
        0.3, 0,  ObjGet( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number ).pos_x      
    }); 

    ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number , "pos_x", 0, 0, "", 
    {          
        0.0, 0,  ObjGet( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number ).pos_x, 
        0.3, 0,  first_bulb_pos_x  
    }); 


    if ( current == "top") then

        local place_1, place_2;

        for i = 1, 6 do

          if private.bulb.top[i] == first_bulb then 

            place_1 = i; 

          end;

          if private.bulb.top[i] == number then 

            place_2 = i;

          end;

        end;

        cup = private.bulb.top[ place_1 ];
        
        private.bulb.top[ place_1 ]= private.bulb.top[ place_2 ];

        private.bulb.top[ place_2 ]= cup;

    else 

        local place_1, place_2;

        for i = 1, 6 do

          if private.bulb.bottom[i] == first_bulb then 

            place_1 = i; 

          end;

          if private.bulb.bottom[i] == number then 

            place_2 = i;

          end;

        end;

        cup = private.bulb.bottom[ place_1 ];
        
        private.bulb.bottom[ place_1 ]= private.bulb.bottom[ place_2 ];

        private.bulb.bottom[ place_2 ]= cup;

    end;

    local func_after = function()

        private.Bulb_Move_2( current );

    end;

    ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..first_bulb , "scale_x", 0, 0, "", 
    {          
        0.0, 0,  1.2, 
        0.3, 0,  1       
    });

    ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..first_bulb , "scale_y", 0, 0, "", 
    {          
        0.0, 0,  1.2, 
        0.3, 0,  1      
    }); 

    ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..first_bulb , "pos_z", 0, 0, "", 
    {          
        0.0, 0,  ObjGet( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..first_bulb ).pos_z, 
        0.3, 0,  0     
    }); 

    ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number , "scale_x", 0, 0, "", 
    {          
        0.0, 0,  1.2, 
        0.3, 0,  1       
    });

    ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number , "scale_y", 0, 0, "", 
    {          
        0.0, 0,  1.2, 
        0.3, 0,  1      
    }); 

    ObjAnimate( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number , "pos_z", 0, 0, func_after, 
    {          
        0.0, 0,  ObjGet( "spr_superpuzzle_3_block_3_"..current.."_bulb_"..number ).pos_z, 
        0.3, 0,  0     
    });

  end;
  --*********************************************************************************************************************
  function private.Bulb_Move_2( current )

    if ( private.CheckWin() ) then

      private.Bulb_WinAnim();
      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_win_combination", 0, "", 0 );

    else 

      common_impl.Lock( false);

      for i = 1, 6 do

        if ( private.bulb.top[i] == private.bulb.bottom[i]) then

          ObjSet( "spr_superpuzzle_3_block_3_light_"..private.bulb.top[i], { alp = 1, pos_x = private.bulb_color_x[i]});
          common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_circle_line_on", 0, "", 0 );

        else 

          ObjSet( "spr_superpuzzle_3_block_3_light_"..private.bulb.top[i], { alp = 0 });
          common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_circle_line_off", 0, "", 0 );

        end;

      end;

      if ( current == "top" ) then

        private.bulb.get_top = 0;

      else 

        private.bulb.get_bottom = 0;

      end;

      ng_global.progress["std"]["win_superpuzzle_3"].bulb = private.bulb;

    end;
   
  end;
  --*********************************************************************************************************************
  function private.CheckWin()

    local win = true;
    for i = 1, 6 do

      if ( private.bulb.top[i] ~= private.bulb.bottom[i]) then

        win = false;

      end;

    end;

    return win;

  end;
  --*********************************************************************************************************************
  function private.Bulb_WinAnim()

    local func_after = function()

      common_impl.Lock( false );

      private.bulb.win = true;
      private.bulb.get_top = 0;
      private.bulb.get_bottom = 0;

      ng_global.progress["std"]["win_superpuzzle_3"].bulb = private.bulb;

      private.BulbWinSet ();

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_open_curtains", 0, "", 0 );

    ObjAnimate( "spr_superpuzzle_3_gate_5", "pos_y", 0, 0, func_after,
    { 
      0.0, 0, ObjGet( "spr_superpuzzle_3_gate_5" ).pos_y,
      0.5, 0, 260
    } );

    for i = 1, 6 do

      ObjSet( "spr_superpuzzle_3_block_3_light_"..private.bulb.top[i], { alp = 1, pos_x = private.bulb_color_x[i]});

    end;

  end;
  --*********************************************************************************************************************
  function private.BulbWinSet ()

    for i = 1, 6 do

      ObjSet( "spr_superpuzzle_3_block_3_light_"..private.bulb.top[i], { alp = 1, pos_x = private.bulb_color_x[i]});
      ObjSet( "spr_superpuzzle_3_block_3_top_bulb_"..private.bulb.top[i], {  scale_x = 1, scale_y = 1, pos_x = private.bulb_x[i]});
      ObjSet( "spr_superpuzzle_3_block_3_bottom_bulb_"..private.bulb.top[i], {  scale_x = 1, scale_y = 1, pos_x = private.bulb_x[i]});

    end;

    local table_multiset = {};

    table.insert( table_multiset, { "obj_superpuzzle_3_block_3", { input = false } } );
    --5 blocks
    table.insert( table_multiset, { "obj_superpuzzle_3_block_5", { input = true } } );

    ObjMultiSet( table_multiset );

    ObjDelete( "spr_superpuzzle_3_gate_5" );

  end;
  --*********************************************************************************************************************
  function private.BulbResetSet ()

    local table_multiset = {};

    private.bulb.top = { 6, 4, 2, 1, 5, 3 };
    private.bulb.bottom = { 1, 5, 2, 6, 4, 3 };
    private.bulb.win = false;
    private.bulb.reset = false;
    private.bulb.get_top = 0; 
    private.bulb.get_bottom = 0; 

    ng_global.progress["std"]["win_superpuzzle_3"].bulb = private.bulb;

    for i = 1, 6 do
                      
      table.insert( table_multiset, { "spr_superpuzzle_3_block_3_top_bulb_"..private.bulb.top[ i ], { pos_x = private.bulb_x[i] } } );
      table.insert( table_multiset, { "spr_superpuzzle_3_block_3_bottom_bulb_"..private.bulb.bottom[ i ], { pos_x = private.bulb_x[i] } } );
      table.insert( table_multiset, { "spr_superpuzzle_3_block_3_light_"..i, { alp = 0 } } );

    end;

    table.insert( table_multiset, { "spr_superpuzzle_3_block_3_light_2", { alp = 1 } } );
    table.insert( table_multiset, { "spr_superpuzzle_3_block_3_light_3", { alp = 1 } } );

    if ( #table_multiset > 0 ) then

      ObjMultiSet( table_multiset );

    end;

  end;
--*********************************************************************************************************************
-- function *** Mmg Puzzle ***() end
--*********************************************************************************************************************
  function private.PuszzleClk_1 ( number )

    local number = tonumber( number );
    local angl;

    local func_after = function()

       common_impl.Lock( false );

       if ( number == 1 ) then
         
         private.puzzle.angl_1 = private.puzzle.angl_1 + 1;

         if ( private.puzzle.angl_1 == 5 ) then

            private.puzzle.angl_1 = 1;

         end;

      elseif number == 2 then
         
         private.puzzle.angl_2 = private.puzzle.angl_2 + 1;

         if ( private.puzzle.angl_2 == 5 ) then

            private.puzzle.angl_2 = 1;

         end;

      else 
         
         private.puzzle.angl_3 = private.puzzle.angl_3 + 1;

         if ( private.puzzle.angl_3 == 5 ) then

            private.puzzle.angl_3 = 1;

         end;

      end;

    end;

    common_impl.Lock( true );

    private.puzzle.reset = true;

    if ( number == 1 ) then
      angl = private.puzzle.angl_1;
    elseif( number == 2 ) then
      angl = private.puzzle.angl_2;
    else 
      angl = private.puzzle.angl_3;
    end;

    ObjAnimate( "obj_superpuzzle_3_block_4_romb_"..number, "ang", 0, 0, func_after,
    { 
      0.0, 0, private.puzzle_angl [ angl ], 
      0.3, 0, private.puzzle_angl [ angl + 1]
    } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_symbols_rotate", 0, "", 0 );

  end;
--*********************************************************************************************************************
  function private.PuszzleClk_2( number )

    local elem_1;
    local elem_2;

    local pos_1;
    local pos_2;

    local elem_1_x;
    local elem_1_y;
    local elem_2_x;
    local elem_2_y;

    common_impl.Lock( true );

    private.puzzle.reset = true;

    local func_after = function()

      local func_after_2 = function()

        if ( private.CheckPuszzleWin() ) then

          private.PuszzleWinAnim( 5 )
          common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_win_combination", 0, "", 0 );

        else 

          common_impl.Lock( false );

          ObjSet( "obj_superpuzzle_3_block_4_romb_"..number, { ang = 0 });

          ng_global.progress[ "std" ][ "win_superpuzzle_3" ].puzzle = private.puzzle;

        end;

      end;

      if ( number == 4 ) then

        local chis = private.puzzle.mas_2[ pos_2 ];
        private.puzzle.mas_2[ pos_2 ] = private.puzzle.mas_1[ pos_1 ];
        private.puzzle.mas_1[ pos_1 ] = chis;

        elem_1 = private.puzzle.mas_1[ pos_1 ];
        elem_2 = private.puzzle.mas_2[ pos_2 ];

        local sm_1 = private.puzzle.angl_2 - 1;
        local sm_2 = private.puzzle.angl_1 - 1;

        local current_f1 = pos_1 - sm_1;
        local current_f2 = pos_2 - sm_2;

        if ( current_f1 <= 0 ) then
          current_f1 = 4 + current_f1;
        end;

        if ( current_f2 <= 0 ) then
          current_f2 = 4 + current_f2;
        end;

        local ang_1 = ObjGet( "spr_superpuzzle_3_block_4_puzzle_"..elem_1 ).ang - 1.57 * ( 1 - current_f1 ) - private.puzzle_angl [  private.puzzle.angl_2 ];
        local ang_2 = ObjGet( "spr_superpuzzle_3_block_4_puzzle_"..elem_2 ).ang - 1.57 * ( 3 - current_f2 ) - private.puzzle_angl [  private.puzzle.angl_1 ];

        private.puzzle.mas_angles_1[ pos_1 ] = ang_1;
        private.puzzle.mas_angles_2[ pos_2 ] = ang_2;

        ObjSet( "spr_superpuzzle_3_block_4_puzzle_"..elem_1, { pos_x = elem_1_x, pos_y = elem_1_y, ang = ang_1 });
        ObjSet( "spr_superpuzzle_3_block_4_puzzle_"..elem_2, { pos_x = elem_2_x, pos_y = elem_2_y, ang = ang_2 });

        ObjAttach( "spr_superpuzzle_3_block_4_puzzle_"..elem_1, "obj_superpuzzle_3_block_4_romb_1");
        ObjAttach( "spr_superpuzzle_3_block_4_puzzle_"..elem_2, "obj_superpuzzle_3_block_4_romb_2");

      else

        local chis = private.puzzle.mas_3[ pos_2 ];
        private.puzzle.mas_3[ pos_2 ] = private.puzzle.mas_2[ pos_1 ];
        private.puzzle.mas_2[ pos_1 ] = chis;

        elem_1 = private.puzzle.mas_2[ pos_1 ];
        elem_2 = private.puzzle.mas_3[ pos_2 ];

        local sm_1 = private.puzzle.angl_3 - 1;
        local sm_2 = private.puzzle.angl_2 - 1;

        local current_f1 = pos_1 - sm_1;
        local current_f2 = pos_2 - sm_2;

        if ( current_f1 <= 0 ) then
          current_f1 = 4 + current_f1;
        end;

        if ( current_f2 <= 0 ) then
          current_f2 = 4 + current_f2;
        end;

        local ang_1 = ObjGet( "spr_superpuzzle_3_block_4_puzzle_"..elem_1 ).ang - 1.57 * ( 1 - current_f1 ) - private.puzzle_angl [  private.puzzle.angl_3 ];
        local ang_2 = ObjGet( "spr_superpuzzle_3_block_4_puzzle_"..elem_2 ).ang - 1.57 * ( 3 - current_f2 ) - private.puzzle_angl [  private.puzzle.angl_2 ];

        private.puzzle.mas_angles_2[ pos_1 ] = ang_1;
        private.puzzle.mas_angles_3[ pos_2 ] = ang_2;

        ObjSet( "spr_superpuzzle_3_block_4_puzzle_"..elem_1, { pos_x = elem_1_x, pos_y = elem_1_y, ang = ang_1 });
        ObjSet( "spr_superpuzzle_3_block_4_puzzle_"..elem_2, { pos_x = elem_2_x, pos_y = elem_2_y, ang = ang_2 });

        ObjAttach( "spr_superpuzzle_3_block_4_puzzle_"..elem_1, "obj_superpuzzle_3_block_4_romb_2");
        ObjAttach( "spr_superpuzzle_3_block_4_puzzle_"..elem_2, "obj_superpuzzle_3_block_4_romb_3");

      end;

      ObjAnimate( "spr_superpuzzle_3_block_4_puzzle_"..elem_1, "scale_xy", 0, 0, "",
      { 
        0.0, 0, 1.2, 1.2,
        0.3, 0, 1, 1
      } );

      ObjAnimate( "spr_superpuzzle_3_block_4_puzzle_"..elem_2, "scale_xy", 0, 0, func_after_2,
      { 
        0.0, 0, 1.2, 1.2,
        0.3, 0, 1, 1
      } );

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_symbols_move", 0, "", 0 );

    end;

    if ( number == 4 ) then

      pos_1 = private.puzzle_pos_angl[ private.puzzle.angl_1 ];
      pos_2 = private.puzzle_pos_angl_2[ private.puzzle.angl_2 ];

      elem_1 = private.puzzle.mas_1[ pos_1 ];
      elem_2 = private.puzzle.mas_2[ pos_2 ];

      elem_1_x = ObjGet( "spr_superpuzzle_3_block_4_puzzle_"..elem_1 ).pos_x;
      elem_1_y = ObjGet( "spr_superpuzzle_3_block_4_puzzle_"..elem_1 ).pos_y;

      elem_2_x = ObjGet( "spr_superpuzzle_3_block_4_puzzle_"..elem_2 ).pos_x;
      elem_2_y = ObjGet( "spr_superpuzzle_3_block_4_puzzle_"..elem_2 ).pos_y;

      ObjSet( "spr_superpuzzle_3_block_4_puzzle_"..elem_1, { pos_x = - 46, pos_y = 0, ang = ObjGet( "spr_superpuzzle_3_block_4_puzzle_"..elem_1 ).ang + private.puzzle_angl [ private.puzzle.angl_1 ] });
      ObjSet( "spr_superpuzzle_3_block_4_puzzle_"..elem_2, { pos_x = 46, pos_y = 0, ang = ObjGet( "spr_superpuzzle_3_block_4_puzzle_"..elem_2 ).ang + private.puzzle_angl [ private.puzzle.angl_2 ]  });

    else 

      pos_1 = private.puzzle_pos_angl[ private.puzzle.angl_2 ];
      pos_2 = private.puzzle_pos_angl_2[ private.puzzle.angl_3 ];

      elem_1 = private.puzzle.mas_2[ pos_1 ];
      elem_2 = private.puzzle.mas_3[ pos_2 ];

      elem_1_x = ObjGet( "spr_superpuzzle_3_block_4_puzzle_"..elem_1 ).pos_x;
      elem_1_y = ObjGet( "spr_superpuzzle_3_block_4_puzzle_"..elem_1 ).pos_y;

      elem_2_x = ObjGet( "spr_superpuzzle_3_block_4_puzzle_"..elem_2 ).pos_x;
      elem_2_y = ObjGet( "spr_superpuzzle_3_block_4_puzzle_"..elem_2 ).pos_y;

      ObjSet( "spr_superpuzzle_3_block_4_puzzle_"..elem_1, { pos_x = - 46, pos_y = 0, ang = ObjGet( "spr_superpuzzle_3_block_4_puzzle_"..elem_1 ).ang + private.puzzle_angl [ private.puzzle.angl_2 ] });
      ObjSet( "spr_superpuzzle_3_block_4_puzzle_"..elem_2, { pos_x = 46, pos_y = 0, ang = ObjGet( "spr_superpuzzle_3_block_4_puzzle_"..elem_2 ).ang + private.puzzle_angl [ private.puzzle.angl_3 ]  });

    end;

    ObjAttach( "spr_superpuzzle_3_block_4_puzzle_"..elem_1, "obj_superpuzzle_3_block_4_romb_"..number );
    ObjAttach( "spr_superpuzzle_3_block_4_puzzle_"..elem_2, "obj_superpuzzle_3_block_4_romb_"..number );

    ObjAnimate( "spr_superpuzzle_3_block_4_puzzle_"..elem_1, "scale_xy", 0, 0, "",
    { 
      0.0, 0, 1, 1,
      0.3, 0, 1.2, 1.2
    } );

    ObjAnimate( "spr_superpuzzle_3_block_4_puzzle_"..elem_2, "scale_xy", 0, 0, "",
    { 
      0.0, 0, 1, 1,
      0.3, 0, 1.2, 1.2
    } );

    ObjAnimate( "obj_superpuzzle_3_block_4_romb_"..number, "ang", 0, 0, func_after,
    { 
      0.0, 0, 0, 
      0.3, 0, 0,
      0.6, 0, -3.14
    } );

  end;
  --*********************************************************************************************************************
  function private.CheckPuszzleWin()

    local win = true;

    for i = 1, 4 do

      if ( private.puzzle.mas_1[i] > 4 ) then

        win = false;

      end;

      if ( private.puzzle.mas_2[i] > 8 ) then

        win = false;

      end;

    end;

    return win;

  end;
  --*********************************************************************************************************************
  function private.PuszzleWinAnim( number )

    local number = number;
    ObjSet( "spr_superpuzzle_3_gate_6_shadow", { alp = 0 });

    local func_after_rec = function()

      ObjSet( "spr_superpuzzle_3_gate_6_"..number, { alp = 0 });
      number = number - 1;
      private.PuszzleWinAnim( number );

    end;

    local func_after = function()

      common_impl.Lock( false );

      ObjSet( "spr_superpuzzle_3_gate_6_1", { alp = 0 });
      ObjSet( "obj_superpuzzle_3_gate_6_open", { alp = 1 });

      private.puzzle.win = true;

      ng_global.progress[ "std" ][ "win_superpuzzle_3" ].puzzle = private.puzzle;

      private.PuszzleWinSet();

    end;

    if ( number > 1 ) then

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_open_curtains", 0, "", 0 );

      ObjAnimate( "spr_superpuzzle_3_gate_6_"..number, "pos_y", 0, 0, func_after_rec,
      { 
        0.0, 0, ObjGet( "spr_superpuzzle_3_gate_6_"..number ).pos_y,
        0.3, 0, ObjGet( "spr_superpuzzle_3_gate_6_"..number - 1 ).pos_y
      } );
      
    else 

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_open_curtains", 0, "", 0 );

      ObjAnimate( "spr_superpuzzle_3_gate_6_"..number, "pos_y", 0, 0, func_after,
      { 
        0.0, 0, ObjGet( "spr_superpuzzle_3_gate_6_"..number ).pos_y,
        0.3, 0, 42
      } );

    end;

  end;
  --*********************************************************************************************************************
  function private.PuszzleWinSet ()

    local table_multiset = {};

    table.insert( table_multiset, { "obj_superpuzzle_3_block_4", { input = false } } );
    --6 blocks
    table.insert( table_multiset, { "obj_superpuzzle_3_block_6", { input = true } } );
    table.insert( table_multiset, { "obj_superpuzzle_3_gate_6_open", { alp = 1 } } );

    ObjMultiSet( table_multiset );

    ObjDelete( "obj_superpuzzle_3_gate_6_close" );

  end;
  --*********************************************************************************************************************
  function private.PuszzleResetSet ()

    private.puzzle.mas_1 = { 5, 2, 7, 12 };
    private.puzzle.mas_2 = { 1, 10, 3, 8 };
    private.puzzle.mas_3 = { 9, 6, 11, 4 };
    private.puzzle.angl_1 = 1;
    private.puzzle.angl_2 = 1;
    private.puzzle.angl_3 = 1;
    private.puzzle.mas_angles_1 = { 0, 0, 0, 0 };
    private.puzzle.mas_angles_2 = { 0, 0, 0, 0 };
    private.puzzle.mas_angles_3 = { 0, 0, 0, 0 };

    private.puzzle.win = false;
    private.puzzle.reset = false;

    ng_global.progress[ "std" ][ "win_superpuzzle_3" ].puzzle = private.puzzle;

    for i = 1, 4  do

      ObjSet( "spr_superpuzzle_3_block_4_puzzle_"..private.puzzle.mas_1[i], { pos_x = private.puzzle_pos[i][1], pos_y = private.puzzle_pos[i][2], ang = private.puzzle.mas_angles_1[i] });
      ObjAttach( "spr_superpuzzle_3_block_4_puzzle_"..private.puzzle.mas_1[i], "obj_superpuzzle_3_block_4_romb_1");

      ObjSet( "spr_superpuzzle_3_block_4_puzzle_"..private.puzzle.mas_2[i], { pos_x = private.puzzle_pos[i][1], pos_y = private.puzzle_pos[i][2], ang = private.puzzle.mas_angles_2[i] });
      ObjAttach( "spr_superpuzzle_3_block_4_puzzle_"..private.puzzle.mas_2[i], "obj_superpuzzle_3_block_4_romb_2");

      ObjSet( "spr_superpuzzle_3_block_4_puzzle_"..private.puzzle.mas_3[i], { pos_x = private.puzzle_pos[i][1], pos_y = private.puzzle_pos[i][2], ang = private.puzzle.mas_angles_3[i] });
      ObjAttach( "spr_superpuzzle_3_block_4_puzzle_"..private.puzzle.mas_3[i], "obj_superpuzzle_3_block_4_romb_3");

    end;

    ObjSet( "obj_superpuzzle_3_block_4_romb_1", { ang = private.puzzle_angl [ private.puzzle.angl_1 ] });
    ObjSet( "obj_superpuzzle_3_block_4_romb_2", { ang = private.puzzle_angl [ private.puzzle.angl_2 ] });
    ObjSet( "obj_superpuzzle_3_block_4_romb_3", { ang = private.puzzle_angl [ private.puzzle.angl_3 ] });
    
  end;
--*********************************************************************************************************************
-- function *** Mmg Counter ***() end
--*********************************************************************************************************************
  function private.CounterClick( num )

    common_impl.Lock( true );

    local first;

    local func_after = function()

      local sum = private.counter.state[ tonumber(num) ][1];
      for i = 1, 5  do
        private.counter.state[ tonumber(num)][i] = private.counter.state[ tonumber(num) ][i+1] 
      end;
      private.counter.state[ tonumber(num)][6] = sum;
      
      private.CheckCounterLight( num );

      if ( private.CheckCounterWin() ) then

        private.CounterWinAnim( 5 );
        common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_win_combination", 0, "", 0 );

      else 

        common_impl.Lock( false );
        ObjSet( "spr_superpuzzle_3_block_5_counter_"..num.."_"..first, { pos_x = private.counter_x[6] } );
        ng_global.progress[ "std" ][ "win_superpuzzle_3" ].counter = private.counter;

      end;

    end;

    private.counter.reset = true;

    for  i = 1, 6  do

      if ( i ~= 1 ) then

        ObjAnimate( "spr_superpuzzle_3_block_5_counter_"..num.."_"..private.counter.state[ tonumber(num) ][i], "pos_x",0,0, "",
        { 
          0.0, 0,ObjGet( "spr_superpuzzle_3_block_5_counter_"..num.."_"..private.counter.state[ tonumber(num) ][i]).pos_x,
          0.3, 0, private.counter_x[i-1]
        } );

      else 

        first = private.counter.state[ tonumber(num) ][i];
        ObjAnimate( "spr_superpuzzle_3_block_5_counter_"..num.."_"..private.counter.state[ tonumber(num) ][i], "pos_x",0,0, "",
        { 
          0.0, 0,ObjGet( "spr_superpuzzle_3_block_5_counter_"..num.."_"..private.counter.state[ tonumber(num) ][i]).pos_x,
          0.3, 0, -70
        } );

      end;

    end;

    ObjSet( "tmr_superpuzzle_3_block_5_anim", { playing = true, time = 0.3, endtrig = func_after });

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_line_move", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.CheckCounterWin()

    local win = true;

    for i = 1, 3 do

      for j = 1, 6 do

        if (  private.counter.state[i][j] ~= private.counter_finish[i][j] ) then

          win = false;
          break;

        end;

      end;

    end;

    return win;

  end;
  --*********************************************************************************************************************
  function private.CheckCounterLight( num )

    local cc = true;

    for j = 1, 6  do

      if ( private.counter.state[ tonumber(num)][j] ~= private.counter_finish[ tonumber(num)][j]) then

        cc = false;
        break;

      end;

    end;

    if ( cc ) then

      ObjSet( "spr_superpuzzle_3_block_5_light_"..tonumber(num), { alp = 1 });
      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_line_true", 0, "", 0 );

    else 

      ObjSet( "spr_superpuzzle_3_block_5_light_"..tonumber(num), { alp = 0 });
      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_line_false", 0, "", 0 );

    end;

  end;
  --*********************************************************************************************************************
  function private.CounterWinAnim( number )

    local number = number;
    ObjSet( "spr_superpuzzle_3_gate_7_shadow", { alp = 0 });

    local func_after_rec = function()

      ObjSet( "spr_superpuzzle_3_gate_7_"..number, { alp = 0 });
      number = number - 1;
      private.CounterWinAnim( number );

    end;

    local func_after = function()

      common_impl.Lock( false );

      ObjSet( "spr_superpuzzle_3_gate_7_1", { alp = 0 });
      ObjSet( "obj_superpuzzle_3_gate_7_open", { alp = 1 });

      private.counter.win = true;

      ng_global.progress[ "std" ][ "win_superpuzzle_3" ].counter = private.counter;

      private.CounterWinSet();

    end;

    if ( number > 1 ) then


      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_open_curtains", 0, "", 0 );

      ObjAnimate( "spr_superpuzzle_3_gate_7_"..number, "pos_y", 0, 0, func_after_rec,
      { 
        0.0, 0, ObjGet( "spr_superpuzzle_3_gate_7_"..number ).pos_y,
        0.3, 0, ObjGet( "spr_superpuzzle_3_gate_7_"..number - 1 ).pos_y
      } );
      
    else 

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_open_curtains", 0, "", 0 );

      ObjAnimate( "spr_superpuzzle_3_gate_7_"..number, "pos_y", 0, 0, func_after,
      { 
        0.0, 0, ObjGet( "spr_superpuzzle_3_gate_7_"..number ).pos_y,
        0.3, 0, 608
      } );

    end;

  end;
  --*********************************************************************************************************************
  function private.CounterWinSet()

    ObjSet( "obj_superpuzzle_3_block_5",{  input = false } ); 

    for i = 1, 3  do

      ObjSet( "spr_superpuzzle_3_block_5_light_"..i, { alp = 1 });

      for j = 1, 6  do

        ObjSet( "spr_superpuzzle_3_block_5_counter_"..i.."_"..private.counter.state[i][j], { pos_x = private.counter_x[j] } );

      end;

    end;

    -- 7 blocks
    ObjSet( "obj_superpuzzle_3_block_7",{ input = true } ); 
    ObjSet( "obj_superpuzzle_3_gate_7_open", { alp = 1 });
    ObjDelete( "obj_superpuzzle_3_gate_7_close" );

  end;
  --*********************************************************************************************************************
  function private.CounterResetSet ()

    private.counter.state = {
      { 1, 2, 3, 4, 5, 6 },
      { 6, 4, 2, 5, 1, 3 },
      { 5, 6, 3, 4, 2, 1 }
    };

    private.counter.win = false;
    private.counter.reset = false;

    ng_global.progress[ "std" ][ "win_superpuzzle_3" ].counter = private.counter; 
    
    for i = 1, 3  do

      ObjSet( "spr_superpuzzle_3_block_5_light_"..i, { alp = 0 });

      for j = 1, 6  do

        ObjSet( "spr_superpuzzle_3_block_5_counter_"..i.."_"..private.counter.state[i][j], { pos_x = private.counter_x[j] } );

      end;

    end;

  end;
--*********************************************************************************************************************
-- function *** Mmg Tile_6 ***() end
--*********************************************************************************************************************
  function private.Clk_Tile_6( dir )

    common_impl.Lock( true );

    private.tile_6.reset = true;

    local xx = private.tile_6.state[ dir ];
    local ang_1 = 0;
    local ang_2 = 0;
    local ang_pi = -1.578;

    if dir == 3 or dir == 4 or dir == 5 or dir == 6 or dir == 9 or dir == 11 then

      if xx == 1 then

        private.tile_6.state[ dir ] = 0;
        ang_1 = 0;
        ang_2 = ang_pi;

      else

        private.tile_6.state[ dir ] = 1;
        ang_1 = ang_pi;
        ang_2 = 0;

      end;

    else

      if xx == 3 then

        private.tile_6.state[ dir ] = 0;
        ang_1 = - ang_pi;
        ang_2 = 0;

      else

        private.tile_6.state[ dir ] = xx + 1;
        ang_1 = ang_pi*xx;
        ang_2 = ang_pi*( xx + 1 );
        
      end;

    end;

    local func_after = function()

      if ( private.Check_Tile_6_Win() ) then

        private.Tile_6_WinAnim();

      else 
   
        common_impl.Lock( false );
        ng_global.progress[ "std" ][ "win_superpuzzle_3" ].tile_6 = private.tile_6;

      end;

    end;

    ObjAnimate( "spr_superpuzzle_3_block_6_tile_"..dir, "ang", 0, 0, func_after, 
    { 
      0.0, 1, ang_1,
      0.3, 0, ang_2 
    } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_squares_rotate", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.Check_Tile_6_Win()

    local win = true;

    for j = 1, 11 do

      if ( j == 3 or j == 4 or j == 6 or j == 9 ) then

      else

        if ( private.tile_6.state[j] ~= private.tile_6_finish[j] ) then

          win = false;
          break;

        end;

      end;

    end;

    return win;

  end;
  --*********************************************************************************************************************
  function private.Tile_6_WinAnim()

    local func_after = function()

      common_impl.Lock( false );

      private.tile_6.win = true;

      ng_global.progress[ "std" ][ "win_superpuzzle_3" ].tile_6 = private.tile_6;

      private.Tile_6_WinSet();

      if ( private.tile_7.win ) then

        private.Win();

      end;

    end;

    ObjAnimate( "spr_superpuzzle_3_block_6_counter", "pos_xy", 0, 0, func_after, 
    { 
      0.0, 0, 935, 283,
      0.3, 0, 878, 283, 
      0.6, 0, 820, 283, 
      0.9, 0, 820, 224, 
      1.2, 0, 878, 224, 
      1.5, 0, 878, 166,
      1.8, 0, 878, 108, 
      2.1, 0, 820, 108
    } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_win_combination", 0, "", 0 );
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_squares_win_up", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.Tile_6_WinSet()

    ObjSet( "obj_superpuzzle_3_block_6",    {  input = false } ); 
    ObjSet( "spr_superpuzzle_3_block_6_counter",    {  pos_x = 820, pos_y = 108 } ); 

  end;
  --*********************************************************************************************************************
  function private.Tile_6_ResetSet ()

    private.tile_6.state = { 2, 3, 1, 1, 0, 0, 0, 3, 1, 2, 0 };

    private.tile_6.win = false;
    private.tile_6.reset = false;

    ng_global.progress[ "std" ][ "win_superpuzzle_3" ].tile_6 = private.tile_6;

    for i = 1, 11  do

      if i == 3 or i == 4 or i == 5 or i == 6 or i == 9 or i == 11 then

        if private.tile_6.state[i] == 1 then

          ObjSet( "spr_superpuzzle_3_block_6_tile_"..i,    { ang = 0 } );

        else

          ObjSet( "spr_superpuzzle_3_block_6_tile_"..i,    { ang =  -1.578 } );

        end;

      else

        ObjSet( "spr_superpuzzle_3_block_6_tile_"..i,    { ang =  -1.578 * private.tile_6.state[i]; } );  

      end;

    end;
    
  end;
--*********************************************************************************************************************
-- function *** Mmg Tile_7 ***() end
--*********************************************************************************************************************
  function private.Clk_Tile_7( dir )

    common_impl.Lock( true );

    private.tile_7.reset = true;

    local xx = private.tile_7.state[ dir ];
    local ang_1 = 0;
    local ang_2 = 0;
    local ang_pi = -1.578;

    if dir == 2 or dir == 3 or dir == 6 or dir == 7 or dir == 10 or dir == 11 then

      if xx == 1 then

        private.tile_7.state[ dir ] = 0;
        ang_1 = 0;
        ang_2 = ang_pi;

      else

        private.tile_7.state[ dir ] = 1;
        ang_1 = ang_pi;
        ang_2 = 0;

      end;

    else

      if xx == 3 then

        private.tile_7.state[ dir ] = 0;
        ang_1 = - ang_pi;
        ang_2 = 0;

      else

        private.tile_7.state[ dir ] = xx + 1;
        ang_1 = ang_pi*xx;
        ang_2 = ang_pi*( xx + 1 );
        
      end;

    end;

    local func_after = function()

      if ( private.Check_Tile_7_Win() ) then

        private.Tile_7_WinAnim();

      else 
   
        common_impl.Lock( false );
        ng_global.progress[ "std" ][ "win_superpuzzle_3" ].tile_7 = private.tile_7;

      end;

    end;

    ObjAnimate( "spr_superpuzzle_3_block_7_tile_"..dir, "ang", 0, 0, func_after, 
    { 
      0.0, 1, ang_1,
      0.3, 0, ang_2 
    } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_squares_rotate", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.Check_Tile_7_Win()

    local win = true;

    for j = 1, 11 do

      if ( j == 2 or j == 3 or j == 6 or j == 7 or  j == 10 or j == 11 ) then

      else

        if ( private.tile_7.state[j] ~= private.tile_7_finish[j] ) then

          win = false;
          break;

        end;

      end;

    end;

    return win;

  end;
  --*********************************************************************************************************************
  function private.Tile_7_WinAnim()

    local func_after = function()

      common_impl.Lock( false );

      private.tile_7.win = true;

      ng_global.progress[ "std" ][ "win_superpuzzle_3" ].tile_7 = private.tile_7;

      private.Tile_7_WinSet();

      if ( private.tile_6.win ) then

        private.Win();

      end;

    end;

    ObjAnimate( "spr_superpuzzle_3_block_7_counter", "pos_xy", 0, 0, func_after, 
    { 
      0.0, 0, 938, 554,
      0.3, 0, 938, 496, 
      0.6, 0, 880, 496, 
      0.9, 0, 880, 438, 
      1.2, 0, 822, 438, 
      1.5, 0, 822, 379
    } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_win_combination", 0, "", 0 );
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_superpuzzle_3_squares_win_down", 0, "", 0 );

  end;
  --*********************************************************************************************************************
  function private.Tile_7_WinSet()

    ObjSet( "obj_superpuzzle_3_block_7",    {  input = false } ); 
    ObjSet( "spr_superpuzzle_3_block_7_counter",    {  pos_x = 822, pos_y = 379 } ); 

  end;
  --*********************************************************************************************************************
  function private.Tile_7_ResetSet ()

    private.tile_7.state = { 0, 0, 1, 0, 3, 1, 0, 1, 1, 1, 1 };

    private.tile_7.win = false;
    private.tile_7.reset = false;

    ng_global.progress[ "std" ][ "win_superpuzzle_3" ].tile_7 = private.tile_7;

    for i = 1, 11  do

      if i == 2 or i == 3 or i == 6 or i == 7 or i == 10 or i == 11 then

        if private.tile_7.state[i] == 1 then

          ObjSet( "spr_superpuzzle_3_block_7_tile_"..i,    { ang = 0 } );

        else

          ObjSet( "spr_superpuzzle_3_block_7_tile_"..i,    { ang =  -1.578 } );

        end;

      else

        ObjSet( "spr_superpuzzle_3_block_7_tile_"..i,    { ang =  -1.578 * private.tile_7.state[i]; } );  

      end;

    end;
    
  end;
--*********************************************************************************************************************
-- function *** Puszzle Hint ***() end
--*********************************************************************************************************************
  function private.PuszzleHintClk ()

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

    end;

    local postfix = private.GetHintPostfix();

    interface.DialogShow( "ifo_superpuzzle_3_hint_"..postfix );

    ObjAnimate( "spr_superpuzzle_3_button_hint", "alp", 0, 0, func_end, { 0,3,0,  0.05,3,1, 0.15,3,1, 0.02,3,0 } );

  end;
--*********************************************************************************************************************
  function private.PuszzleHintEnter ()

    common_impl.SetCursor( CURSOR_HAND );
    ObjSet( "spr_superpuzzle_3_puzzle_hint_light", { alp = 1 } );

  end;
--*********************************************************************************************************************
  function private.PuszzleHintLeave ()

    common_impl.SetCursor( CURSOR_DEFAULT );
    ObjSet( "spr_superpuzzle_3_puzzle_hint_light", { alp = 0 } );

  end;
--*********************************************************************************************************************
  function private.GetHintPostfix ()

    local postfix;

    if     ( not private.flap.win )  then postfix = "1";
    elseif ( not private.laser.win ) then postfix = "2";
    elseif ( not private.bulb.win )  then postfix = "5";
    elseif ( not private.puzzle.win )  then postfix = "3";
    elseif ( not private.counter.win ) then postfix = "6";
    elseif ( not private.tile_6.win )  then postfix = "4";
    elseif ( not private.tile_7.win )  then postfix = "7";
    end;

    return postfix;

  end;
--*********************************************************************************************************************