-- name=level3_inv
--*********************************************************************************************************************
function public.Init()

  if port.isPortable() == 1 then
    port.InventoryPopupInit("level3_inv_hub");
    port.VideoResizeInRoom("level3_inv");
  end;

  private.init_candle();
  private.init_porcelainowl();
  private.init_photoalbum();
  private.init_glasscutter();
  private.init_hammerdrill();
  private.init_statuepiece();
  private.init_brokengasolinesaw3();

  public.deploy_inventory = {

    { "candle",             { "use_lighter"         }, "get_litcandle"          },
    { "porcelainowl",       { "use_porcelainkey"    }, "get_lockpiece"          },
    { "photoalbum",         { "use_glasspiece_2"    }, "get_evidence_3_2"       },
    { "glasscutter",        { "use_glasscutterpart" }, "get_workingglasscutter" },
    { "hammerdrill",        { "use_drillbit"        }, "get_workingdrill"       },
    { "statuepiece",        { "use_gluedbrush"      }, "get_statue"             },
    { "brokengasolinesaw3", { "use_fuelsawchain"    }, "get_workingfuelsaw"     },

  };

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_level3_inv_deploy = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    common_impl.TurnChildGfx( {"level3_inv_deploy" }, "level3_inv_deploy", visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_level3_inv_deploy", update_game_mode_level3_inv_deploy, nil );

end;
--*********************************************************************************************************************
function private.StringDivide(string)  

  local table = {}
  local id = 1
  local il = 1
  for i = 1, string.len(string) do
    if string.sub(string,i,i) == "_" then
      table[id] = string.sub(string,il,i-1)
      il = i+1
      id = id + 1
    end
    if i == string.len(string) then
      table[id] = string.sub(string,il,i)
      il = i+1
      id = id + 1
    end
  end
  return table;

end;
--*********************************************************************************************************************
function private.ObjIntersectCheck( obj_to_apply, obj_to_check, obj_complex_inv )

  local obj_complex_inv = obj_complex_inv or "deploy_inv_"..private.StringDivide( obj_to_check )[2];  
  return interface.GetCurrentInv() == obj_complex_inv and ObjIntersect( obj_to_apply, obj_to_check );

end;
--*********************************************************************************************************************
-- function *** porcelainowl *** () end;
--*********************************************************************************************************************
function private.init_candle()

  common_impl.hint[ "use_lighter" ] = {
      type = "use",
      inv_obj = "inv_lighter",
      use_place = "obj_candle_use_lighter",
      room = "int_deploy_inv",
      zz = "deploy_inv_candle",
      zz_gate = "inv_candle"
  };
  function use_lighter_inv ()

    interface.InventoryItemRemove( "inv_lighter" );

  end;
  function use_lighter_inv_end ()

    --ObjSet( "inv_lighter", { res = "assets/levels/level3/inv_deploy/inv_lighter/inv/inv_lighter_2" } );

  end;
  function use_lighter_beg ()

    ObjDelete( "obj_candle_use_lighter" );

  end;
  function use_lighter_end ()

    ObjDelete( "vid_candle_lighter" );
    ObjSet( "vid_candle_lighter_looped", { alp = 1, playing = true } );
    ObjSet( "spr_deploy_candle_candle_add", { alp = 1 } );
    ObjSet( "spr_deploy_candle_candle_light", { alp = 1 } );
    ObjSet( "spr_deploy_candle_litcandle", { input = true } );
    ObjSet( "gfx_deploy_candle_litcandle", { active = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lighter", use_lighter_beg, "inv_candle" );
  cmn.AddSubscriber( "use_lighter", use_lighter_inv );
  cmn.AddSubscriber( "use_lighter", use_lighter_inv_end );
  cmn.AddSubscriber( "use_lighter", use_lighter_end, "inv_candle" );
  cmn.AddSubscriber( "use_lighter_inv", use_lighter_inv );
  cmn.AddSubscriber( "use_lighter_inv_end", use_lighter_inv_end );
  cmn.AddSubscriber( "use_lighter_beg", use_lighter_beg, "inv_candle" );
  cmn.AddSubscriber( "use_lighter_end", use_lighter_end, "inv_candle" );

  -------------------------------------------------------------------------------------------
  common_impl.hint[ "get_litcandle" ] = {
      type = "get",
      get_obj = "spr_deploy_candle_litcandle",
      room = "int_deploy_inv",
      zz = "deploy_inv_candle",
      zz_gate = "inv_candle"
  };
  function get_litcandle_inv ()

    interface.InventoryItemRemove( "inv_candle" );
    interface.InventoryItemAdd( "inv_litcandle", "spr_deploy_candle_litcandle" );
    ObjDelete( "gfx_deploy_candle_litcandle" );

  end;
  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_litcandle", get_litcandle_inv );
  -------------------------------------------------------------------------------------------

  ObjSet( "spr_deploy_candle_litcandle", { event_mdown = level3_inv.get_litcandle });

end;

function public.get_litcandle()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_litcandle" );
  cmn.CallEventHandler( "get_litcandle", "inv_candle" );
  common_impl.HideDeployInv();

end;
function public.use_lighter()

  local item = "inv_lighter";

  if private.ObjIntersectCheck( item, "obj_candle_use_lighter" ) then

    cmn.CallEventHandler( "use_lighter_beg", "inv_candle" );
    cmn.CallEventHandler( "use_lighter_inv" );

    local func_end = function ()

      common_impl.Lock(false);
      
      cmn.SetEventDone( "use_lighter" );
      cmn.CallEventHandler( "use_lighter_end", "inv_candle" );
      cmn.CallEventHandler( "use_lighter_inv_end" );

    end;

    common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_lighter", 0, "", 0 );
    ObjSet( "vid_candle_lighter", { alp = 1 });
    VidPlay( "vid_candle_lighter", func_end );

    ObjAnimate( "spr_deploy_candle_candle_light", "alp", 0, 0, "",
    { 
      0.0, 0, 0, 
      2.6, 0, 0,
      2.9, 0, 1
    } );

    ObjAnimate( "spr_deploy_candle_candle_add", "alp", 0, 0, "",
    { 
      0.0, 0, 0, 
      2.6, 0, 0,
      2.9, 0, 1
    } );

    return true;

  end;

end;

--*********************************************************************************************************************
-- function *** porcelainowl *** () end;
--*********************************************************************************************************************
function private.init_porcelainowl()

  common_impl.hint[ "use_porcelainkey" ] = {
      type = "use",
      inv_obj = "inv_porcelainkey",
      use_place = "obj_porcelainowl_use_porcelainkey",
      room = "int_deploy_inv",
      zz = "deploy_inv_porcelainowl",
      zz_gate = "inv_porcelainowl"
  };
  function use_porcelainkey_inv ()

    interface.InventoryItemRemove( "inv_porcelainkey" );

  end;
  function use_porcelainkey_inv_end ()

    --ObjSet( "inv_porcelainkey", { res = "assets/levels/level3/inv_deploy/inv_porcelainkey/inv/inv_porcelainkey_2" } );

  end;
  function use_porcelainkey_beg ()

    ObjDelete( "obj_porcelainowl_use_porcelainkey" );

  end;
  function use_porcelainkey_end ()

    ObjSet( "obj_deploy_porcelianowl_paw", { active = true, input = true } );
    ObjSet( "obj_deploy_porcelianowl_feather", { alp = 1, pos_x = -56, pos_y = -190 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_porcelainkey", use_porcelainkey_beg, "inv_porcelainowl" );
  cmn.AddSubscriber( "use_porcelainkey", use_porcelainkey_inv );
  cmn.AddSubscriber( "use_porcelainkey", use_porcelainkey_inv_end );
  cmn.AddSubscriber( "use_porcelainkey", use_porcelainkey_end, "inv_porcelainowl" );
  cmn.AddSubscriber( "use_porcelainkey_inv", use_porcelainkey_inv );
  cmn.AddSubscriber( "use_porcelainkey_inv_end", use_porcelainkey_inv_end );
  cmn.AddSubscriber( "use_porcelainkey_beg", use_porcelainkey_beg, "inv_porcelainowl" );
  cmn.AddSubscriber( "use_porcelainkey_end", use_porcelainkey_end, "inv_porcelainowl" );
  
  -------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lockpiece" ] = {
      type = "get",
      get_obj = "spr_deploy_porcelianowl_paw",
      room = "int_deploy_inv",
      zz = "deploy_inv_porcelainowl",
      zz_gate = "inv_porcelainowl"
  };
  function get_lockpiece_inv ()

    interface.InventoryItemAdd( "inv_lockpiece", "spr_deploy_porcelianowl_paw" );
    interface.InventoryItemRemove( "inv_porcelainowl" );
    ObjDelete( "gfx_deploy_porcelianowl_paw" );
    ObjDelete( "spr_deploy_porcelianowl_paw_shadow" );

  end;
  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_lockpiece", get_lockpiece_inv );
  -------------------------------------------------------------------------------------------
  ObjSet( "spr_deploy_porcelianowl_paw", { event_mdown = level3_inv.get_lockpiece });

end;

function public.get_lockpiece()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_lockpiece" );
  cmn.CallEventHandler( "get_lockpiece", "inv_lockpiece" );
  common_impl.HideDeployInv();

end;
function public.use_porcelainkey()

  local item = "inv_porcelainkey";

  if private.ObjIntersectCheck( item, "obj_porcelainowl_use_porcelainkey" ) then

    cmn.CallEventHandler( "use_porcelainkey_beg", "inv_porcelainowl" );
    cmn.CallEventHandler( "use_porcelainkey_inv" );

    local func_end = function ()


      local func_end_2 = function ()

        common_impl.Lock(false);

        cmn.SetEventDone( "use_porcelainkey" );
        cmn.CallEventHandler( "use_porcelainkey_end", "inv_porcelainowl" );
        cmn.CallEventHandler( "use_porcelainkey_inv_end" );

      end;

      common_impl.PlayAudio( "sfx", "common/audio/aud_porcelainowl_open", 0, "", 0 );

      ObjAnimate( "obj_deploy_porcelianowl_cover", "alp", 0, 0, func_end_2,
      { 
        0.0, 0, 1, 
        0.3, 0, 1,
        0.6, 0, 0
      } );

      ObjAnimate( "obj_deploy_porcelianowl_cover", "pos_y", 0, 0, "",
      { 
        0.0, 0, 0, 
        0.6, 0, -170
      } );

    end;

    common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_porcelainkey", 0, "", 0 );

    ObjAnimate( "obj_deploy_porcelianowl_feather", "alp", 0, 0, "",
    { 
      0.0, 0, 0, 
      0.3, 0, 1
    } );

    ObjAnimate( "obj_deploy_porcelianowl_feather", "pos_xy", 0, 0, func_end,
    { 
      0.0, 0, -89,-262, 
      0.3, 0, -89,-262,
      0.8, 0, -56,-190,
      1.0, 0, -56,-190  
    } );

    return true;

  end;

end;


--*********************************************************************************************************************
-- function *** photoalbum *** () end;
--*********************************************************************************************************************
function private.init_photoalbum()

  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_evidence_3_2" ] = {
      type = "get",
      get_obj = "obj_deploy_photoalbum_photo",
      room = "int_deploy_inv",
      zz = "deploy_inv_photoalbum",
      zz_gate = "inv_photoalbum"
  };
  -------------------------------------------------------------------------------------------
  function get_evidence_3_2_inv()

    --interface.InventoryItemRemove( "inv_photoalbum" );
    --interface.InventoryItemAdd( "inv_dcn_framedpicture", "obj_photoalbum_picture" );
    --ObjDelete( "gfx_deploy_picture" );

  end;
  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_evidence_3_2", get_evidence_3_2_inv );
   --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_prv_photoalbum" ] = {
      type = "get",
      get_obj = "obj_deploy_photoalbum_photo",
      room = "int_deploy_inv",
      zz = "deploy_inv_photoalbum",
      zz_gate = "inv_photoalbum"
  };
  -------------------------------------------------------------------------------------------
  function get_prv_photoalbum()

    interface.InventoryItemRemove( "inv_photoalbum" );
    interface.ProvidePanelItemAdd( "inv_prv_photoalbum", "obj_deploy_photoalbum" );
    ObjDelete( "gfx_deploy_photo" );

  end;
  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_prv_photoalbum", get_prv_photoalbum );
   --------------------------------------------------------------------------------------------

  common_impl.hint[ "use_glasspiece_2" ] = {
      type = "use",
      inv_obj = "inv_glasspiece",
      use_place = "obj_photoalbum_use_glasspiece",
      room = "int_deploy_inv",
      zz = "deploy_inv_photoalbum",
      zz_gate = "inv_photoalbum"
  };
  function use_glasspiece_2_inv ()

    interface.InventoryItemRemove( "inv_glasspiece" );

  end;
  function use_glasspiece_2_inv_end ()

    --ObjSet( "inv_glasspiece", { res = "assets/levels/level3/inv_deploy/inv_glasspiece/inv/inv_glasspiece_2" } );

  end;
  function use_glasspiece_2_beg ()

    ObjDelete( "obj_photoalbum_use_glasspiece" );

  end;
  function use_glasspiece_2_end ()

    --if ( not cmn.IsEventDone( "" ) ) then 
       --ObjSet( "spr_photoalbum_plus_light", { alp = 0 } );
    --end;
    ObjDelete( "obj_deploy_photoalbum_glasspiece" );
    ObjSet( "obj_deploy_photoalbum_photo", { pos_y = 10, ang = - 0.01, input = true } );
    ObjSet( "gfx_deploy_photo", { active = true, visible = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_glasspiece_2", use_glasspiece_2_beg, "inv_photoalbum" );
  cmn.AddSubscriber( "use_glasspiece_2", use_glasspiece_2_inv );
  cmn.AddSubscriber( "use_glasspiece_2", use_glasspiece_2_inv_end );
  cmn.AddSubscriber( "use_glasspiece_2", use_glasspiece_2_end, "inv_photoalbum" );
  cmn.AddSubscriber( "use_glasspiece_2_inv", use_glasspiece_2_inv );
  cmn.AddSubscriber( "use_glasspiece_2_inv_end", use_glasspiece_2_inv_end );
  cmn.AddSubscriber( "use_glasspiece_2_beg", use_glasspiece_2_beg, "inv_photoalbum" );
  cmn.AddSubscriber( "use_glasspiece_2_end", use_glasspiece_2_end, "inv_photoalbum" );

  ObjSet( "obj_deploy_photoalbum_photo", { event_mdown = public.get_evidence_3_2 } );

end;

function public.use_glasspiece()

  local item = "inv_glasspiece";

  if private.ObjIntersectCheck( item, "obj_photoalbum_use_glasspiece" ) then

    cmn.CallEventHandler( "use_glasspiece_2_beg", "inv_photoalbum" );
    cmn.CallEventHandler( "use_glasspiece_2_inv" );

    local func_end = function ()

      common_impl.Lock(false);
      
      cmn.SetEventDone( "use_glasspiece_2" );
      cmn.CallEventHandler( "use_glasspiece_2_end", "inv_photoalbum" );
      cmn.CallEventHandler( "use_glasspiece_2_inv_end" );
      --public.get_evidence_3_2()

    end;

    common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_glasspiece_2", 0, "", 0 );

    ObjAnimate( "obj_deploy_photoalbum_glasspiece", "alp", 0, 0, "",
    { 
      0.0, 0, 0, 
      0.3, 0, 1,
      1.9, 0, 1,
      2.1, 0, 0
    } );

    ObjAnimate( "obj_deploy_photoalbum_glasspiece", "pos_xy", 0, 0, "",
    { 
      0.0, 0, -201, -93,
      0.3, 0, -201, -93,
      0.7, 0, -39,  -130,
      1.1, 0,  12,  -7,
      1.5, 0, -162, 36,
      1.9, 0, -201, -93
    } );

    ObjAnimate( "obj_deploy_photoalbum_photo", "pos_xy", 0, 0, "",
    { 
      0.0, 0, 0, 0,
      1.9, 0, 0, 0,
      2.2, 0, 0, 10,
    } );
    ObjAnimate( "obj_deploy_photoalbum_photo", "ang", 0, 0, func_end,
    { 
      0.0, 0, 0,
      1.9, 0, 0,
      2.2, 0, -0.01
    } );

    return true;

  end;

end;


function public.get_evidence_3_2()

  local func_end = function ()

    ObjSet( "obj_deploy_photoalbum_photo", { pos_x = 512, pos_y = 384 } );
    ObjSet( "obj_deploy_photoalbum", { pos_x = 512, pos_y = 384 } );
    interface.InvestigationButtonItemAdd( "evidence_3_2", "obj_deploy_photoalbum_photo" );
    cmn.SetEventDone( "get_evidence_3_2" );
    cmn.CallEventHandler( "get_evidence_3_2", "inv_photoalbum" );
    cmn.SetEventDone( "get_prv_photoalbum" );
    cmn.CallEventHandler( "get_prv_photoalbum", "inv_photoalbum" );

    common_impl.HideDeployInv();

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_turn_page", 0, "", 0 );

  ObjSet( "spr_nightsvilleentrance_evidence_3_2", { alp = 0 } );
  interface.DialogEvidenceShow( "evidence_3_2", func_end );

end;
--*********************************************************************************************************************
-- function *** glasscutter *** () end;
--*********************************************************************************************************************
function private.init_glasscutter()

  -------------------------------------------------------------------------------------------
  common_impl.hint[ "get_workingglasscutter" ] = {
      type = "get",
      get_obj = "obj_deploy_glasscuter",
      room = "int_deploy_inv",
      zz = "deploy_inv_glasscutter",
      zz_gate = "inv_glasscutter"
  };
  function get_workingglasscutter_inv ()

    interface.InventoryItemRemove( "inv_glasscutter" );
    interface.InventoryItemAdd( "inv_workingglasscutter", "obj_deploy_glasscuter" );
    ObjDelete( "gfx_deploy_glasscuter" );

  end;
  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_workingglasscutter", get_workingglasscutter_inv );
  -------------------------------------------------------------------------------------------
  common_impl.hint[ "use_glasscutterpart" ] = {
      type = "use",
      inv_obj = "inv_glasscutterpart",
      use_place = "obj_glasscutter_use_glasscutterpart",
      room = "int_deploy_inv",
      zz = "deploy_inv_glasscutter",
      zz_gate = "inv_glasscutter"
  };
  function use_glasscutterpart_inv ()

    interface.InventoryItemRemove( "inv_glasscutterpart" );

  end;
  function use_glasscutterpart_inv_end ()

    --ObjSet( "inv_glasscutterpart", { res = "assets/levels/level3/inv_deploy/inv_glasscutterpart/inv/inv_glasscutterpart_2" } );

  end;
  function use_glasscutterpart_beg ()

    ObjDelete( "obj_glasscutter_use_glasscutterpart" );

  end;
  function use_glasscutterpart_end ()

    ObjSet( "spr_deploy_glasscuterpart", { alp = 1 } );
    ObjSet( "obj_deploy_glasscuter", { input = true } );
    ObjSet( "gfx_deploy_glasscuter", { active = true } );

    --if ( not cmn.IsEventDone( "" ) ) then 
       --ObjSet( "spr_glasscutter_plus_light", { alp = 0 } );
    --end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_glasscutterpart", use_glasscutterpart_beg, "inv_glasscutter" );
  cmn.AddSubscriber( "use_glasscutterpart", use_glasscutterpart_inv );
  cmn.AddSubscriber( "use_glasscutterpart", use_glasscutterpart_inv_end );
  cmn.AddSubscriber( "use_glasscutterpart", use_glasscutterpart_end, "inv_glasscutter" );
  cmn.AddSubscriber( "use_glasscutterpart_inv", use_glasscutterpart_inv );
  cmn.AddSubscriber( "use_glasscutterpart_inv_end", use_glasscutterpart_inv_end );
  cmn.AddSubscriber( "use_glasscutterpart_beg", use_glasscutterpart_beg, "inv_glasscutter" );
  cmn.AddSubscriber( "use_glasscutterpart_end", use_glasscutterpart_end, "inv_glasscutter" );  
  --------------------------------------------------------------------------------------------
  ObjSet( "obj_deploy_glasscuter", { event_mdown = public.get_workingglasscutter } );

end;
--*********************************************************************************************************************
function public.get_workingglasscutter()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_workingglasscutter" );
  cmn.CallEventHandler( "get_workingglasscutter", "inv_glasscutter" );
  common_impl.HideDeployInv();

end;
--*********************************************************************************************************************
function public.use_glasscutterpart()

  local item = "inv_glasscutterpart";

  if private.ObjIntersectCheck( item, "obj_glasscutter_use_glasscutterpart" ) then

    cmn.CallEventHandler( "use_glasscutterpart_beg", "inv_glasscutter" );
    cmn.CallEventHandler( "use_glasscutterpart_inv" );

    local func_end = function ()

      common_impl.Lock(false);
      
      cmn.SetEventDone( "use_glasscutterpart" );
      cmn.CallEventHandler( "use_glasscutterpart_end", "inv_glasscutter" );
      cmn.CallEventHandler( "use_glasscutterpart_inv_end" );
    
    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_blade", 0, "", 0 );

    ObjAnimate( "spr_deploy_glasscuterpart", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0, 
      0.4, 0, 1,
    } );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** hammerdrill *** () end;
--*********************************************************************************************************************
function private.init_hammerdrill()

  -------------------------------------------------------------------------------------------
  common_impl.hint[ "get_workingdrill" ] = {
      type = "get",
      get_obj = "obj_hammerdrill_workingdrill",
      room = "int_deploy_inv",
      zz = "deploy_inv_hammerdrill",
      zz_gate = "inv_hammerdrill"
  };
  function get_workingdrill_inv ()

    interface.InventoryItemRemove( "inv_hammerdrill" );
    interface.InventoryItemAdd( "inv_workingdrill", "obj_hammerdrill_workingdrill" );
    ObjDelete( "gfx_deploy_hammerdrill" );

  end;
  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_workingdrill", get_workingdrill_inv );
  -------------------------------------------------------------------------------------------
  common_impl.hint[ "use_drillbit" ] = {
      type = "use",
      inv_obj = "inv_drillbit",
      use_place = "obj_hammerdrill_use_drillbit",
      room = "int_deploy_inv",
      zz = "deploy_inv_hammerdrill",
      zz_gate = "inv_hammerdrill"
  };
  function use_drillbit_inv ()

    interface.InventoryItemRemove( "inv_drillbit" );

  end;
  function use_drillbit_inv_end ()

    --ObjSet( "inv_drillbit", { res = "assets/levels/level3/inv_deploy/inv_drillbit/inv/inv_drillbit_2" } );

  end;
  function use_drillbit_beg ()

    ObjDelete( "obj_hammerdrill_use_drillbit" );

  end;
  function use_drillbit_end ()

    ObjMultiSet({ 
      { "obj_hammerdrill_workingdrill",     { input = true     }},
      { "gfx_deploy_hammerdrill",     { active = true    }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_drillbit", use_drillbit_beg, "inv_hammerdrill" );
  cmn.AddSubscriber( "use_drillbit", use_drillbit_inv );
  cmn.AddSubscriber( "use_drillbit", use_drillbit_inv_end );
  cmn.AddSubscriber( "use_drillbit", use_drillbit_end, "inv_hammerdrill" );
  cmn.AddSubscriber( "use_drillbit_inv", use_drillbit_inv );
  cmn.AddSubscriber( "use_drillbit_inv_end", use_drillbit_inv_end );
  cmn.AddSubscriber( "use_drillbit_beg", use_drillbit_beg, "inv_hammerdrill" );
  cmn.AddSubscriber( "use_drillbit_end", use_drillbit_end, "inv_hammerdrill" );  
  --------------------------------------------------------------------------------------------
  ObjSet( "obj_hammerdrill_workingdrill", { event_mdown = public.get_workingdrill } );

end;
--*********************************************************************************************************************
function public.get_workingdrill()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_workingdrill" );
  cmn.CallEventHandler( "get_workingdrill", "inv_hammerdrill" );
  common_impl.HideDeployInv();

end;
--*********************************************************************************************************************
function public.use_drillbit()

  local item = "inv_drillbit";

  if private.ObjIntersectCheck( item, "obj_hammerdrill_use_drillbit" ) then

    cmn.CallEventHandler( "use_drillbit_beg", "inv_hammerdrill" );
    cmn.CallEventHandler( "use_drillbit_inv" );

    local func_end = function ()

      common_impl.Lock(false);
      
      cmn.SetEventDone( "use_drillbit" );
      cmn.CallEventHandler( "use_drillbit_end", "inv_hammerdrill" );
      cmn.CallEventHandler( "use_drillbit_inv_end" );
    
    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_drillbit", 0, "", 0 );

    ObjAnimate( "spr_deploy_hammerdrill_drillbit", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0, 
      0.4, 0, 1,
    } );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** statuepiece *** () end;
--*********************************************************************************************************************
function private.init_statuepiece()

  -------------------------------------------------------------------------------------------
  common_impl.hint[ "get_statue" ] = {
      type = "get",
      get_obj = "obj_deploy_statuepiece",
      room = "int_deploy_inv",
      zz = "deploy_inv_statuepiece",
      zz_gate = "inv_statuepiece"
  };
  function get_statue_inv ()

    interface.InventoryItemRemove( "inv_statuepiece" );
    interface.InventoryItemAdd( "inv_statue", "obj_deploy_statuepiece" );
    ObjDelete( "gfx_deploy_statue" );

  end;
  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_statue", get_statue_inv );
  -------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gluedbrush" ] = {
      type = "use",
      inv_obj = "inv_gluedbrush",
      use_place = "obj_statuepiece_use_gluedbrush",
      room = "int_deploy_inv",
      zz = "deploy_inv_statuepiece",
      zz_gate = "inv_statuepiece"
  };
  function use_gluedbrush_inv ()

    interface.InventoryItemRemove( "inv_gluedbrush" );

  end;
  function use_gluedbrush_inv_end ()

    --ObjSet( "inv_gluedbrush", { res = "assets/levels/level3/inv_deploy/inv_gluedbrush/inv/inv_gluedbrush_2" } );

  end;
  function use_gluedbrush_beg ()

    ObjDelete( "obj_statuepiece_use_gluedbrush" );

  end;
  function use_gluedbrush_end ()

    ObjDelete( "spr_deploy_statuepiece_brush" );

    ObjSet( "spr_deploy_statuepiece_glue", { alp = 1 } );
    ObjSet( "obj_deploy_statuepiece", { input = true } );
    ObjSet( "gfx_deploy_statuepiece", { active = true } );
    --if ( not cmn.IsEventDone( "" ) ) then 
       --ObjSet( "spr_statuepiece_plus_light", { alp = 0 } );
    --end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gluedbrush", use_gluedbrush_beg, "inv_statuepiece" );
  cmn.AddSubscriber( "use_gluedbrush", use_gluedbrush_inv );
  cmn.AddSubscriber( "use_gluedbrush", use_gluedbrush_inv_end );
  cmn.AddSubscriber( "use_gluedbrush", use_gluedbrush_end, "inv_statuepiece" );
  cmn.AddSubscriber( "use_gluedbrush_inv", use_gluedbrush_inv );
  cmn.AddSubscriber( "use_gluedbrush_inv_end", use_gluedbrush_inv_end );
  cmn.AddSubscriber( "use_gluedbrush_beg", use_gluedbrush_beg, "inv_statuepiece" );
  cmn.AddSubscriber( "use_gluedbrush_end", use_gluedbrush_end, "inv_statuepiece" );  
  --------------------------------------------------------------------------------------------
  ObjSet( "obj_deploy_statuepiece", { event_mdown = public.get_statue } );

end;
--*********************************************************************************************************************
function public.get_statue()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_statue" );
  cmn.CallEventHandler( "get_statue", "inv_statuepiece" );
  common_impl.HideDeployInv();

end;
--*********************************************************************************************************************
function public.use_gluedbrush()

  local item = "inv_gluedbrush";

  if private.ObjIntersectCheck( item, "obj_statuepiece_use_gluedbrush" ) then

    cmn.CallEventHandler( "use_gluedbrush_beg", "inv_statuepiece" );
    cmn.CallEventHandler( "use_gluedbrush_inv" );

    local func_end = function ()

      common_impl.Lock(false);
      
      cmn.SetEventDone( "use_gluedbrush" );
      cmn.CallEventHandler( "use_gluedbrush_end", "inv_statuepiece" );
      cmn.CallEventHandler( "use_gluedbrush_inv_end" );
    
    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_gluedbrush", 0, "", 0 );

    ObjAnimate( "spr_deploy_statuepiece_glue", "alp", 0, 0, "",
    { 
      0.0, 0, 0, 
      0.3, 0, 0,
      1.0, 0, 1,
    } );

    ObjAnimate( "spr_deploy_statuepiece_brush", "alp", 0, 0, "",
    { 
      0.0, 0, 0, 
      0.3, 0, 1,
      1.0, 0, 1,
      1.3, 0, 0
    } );

    ObjAnimate( "spr_deploy_statuepiece_brush", "pos_xy", 0, 0, "",
    { 
      0.0, 0, -106, 59,
      0.3, 0, -106, 59,
      1.0, 0, -120, 265
    } );

    ObjAnimate( "spr_deploy_statuepiece_1", "pos_xy", 0, 0, func_end,
    { 
      0.0, 0, -162, -31,
      1.3, 0, -162, -31,
      1.6, 0, -117, -30,
    } );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** brokengasolinesaw3 *** () end;
--*********************************************************************************************************************
function private.init_brokengasolinesaw3()

  -------------------------------------------------------------------------------------------
  common_impl.hint[ "get_workingfuelsaw" ] = {
      type = "get",
      get_obj = "spr_deploy_brokengasolinesaw3",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokengasolinesaw3",
      zz_gate = "inv_brokengasolinesaw3"
  };
  function get_workingfuelsaw_inv ()

    interface.InventoryItemRemove( "inv_brokengasolinesaw3" );
    interface.InventoryItemAdd( "inv_workingfuelsaw", "spr_deploy_brokengasolinesaw3" );
    ObjDelete( "gfx_deploy_workingfuelsaw" );

  end;
  -------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "get_workingfuelsaw", get_workingfuelsaw_inv );
  -------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fuelsawchain" ] = {
      type = "use",
      inv_obj = "inv_fuelsawchain",
      use_place = "obj_brokengasolinesaw3_use_fuelsawchain",
      room = "int_deploy_inv",
      zz = "deploy_inv_brokengasolinesaw3",
      zz_gate = "inv_brokengasolinesaw3"
  };
  function use_fuelsawchain_inv ()

    interface.InventoryItemRemove( "inv_fuelsawchain" );

  end;
  function use_fuelsawchain_inv_end ()

    --ObjSet( "inv_fuelsawchain", { res = "assets/levels/level3/inv_deploy/inv_brokengasolinesaw3/inv/inv_fuelsawchain_2" } );

  end;
  function use_fuelsawchain_beg ()

    ObjDelete( "obj_brokengasolinesaw3_use_fuelsawchain" );


  end;
  function use_fuelsawchain_end ()

    ObjSet( "spr_deploy_brokengasolinesaw_chain_2", { alp = 1 } );
    ObjDelete( "spr_deploy_brokengasolinesaw_brokenchain_3" )
    ObjDelete( "spr_deploy_brokengasolinesaw_brokenchain_3_1" );
    ObjSet( "obj_deploy_brokengasolinesaw3_bbt", { event_mdown = public.get_workingfuelsaw, event_menter = function() common_impl.SetCursor( CURSOR_GET ) end } );
    ObjSet( "gfx_deploy_brokengasolinesaw_brokenchain_3", {active = true } );
    --if ( not cmn.IsEventDone( "" ) ) then 
       --ObjSet( "spr_workingfuelsawpiece_plus_light", { alp = 0 } );
    --end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fuelsawchain", use_fuelsawchain_beg, "inv_brokengasolinesaw3" );
  cmn.AddSubscriber( "use_fuelsawchain", use_fuelsawchain_inv );
  cmn.AddSubscriber( "use_fuelsawchain", use_fuelsawchain_inv_end );
  cmn.AddSubscriber( "use_fuelsawchain", use_fuelsawchain_end, "inv_brokengasolinesaw3" );
  cmn.AddSubscriber( "use_fuelsawchain_inv", use_fuelsawchain_inv );
  cmn.AddSubscriber( "use_fuelsawchain_inv_end", use_fuelsawchain_inv_end );
  cmn.AddSubscriber( "use_fuelsawchain_beg", use_fuelsawchain_beg, "inv_brokengasolinesaw3" );
  cmn.AddSubscriber( "use_fuelsawchain_end", use_fuelsawchain_end, "inv_brokengasolinesaw3" );  
  --------------------------------------------------------------------------------------------
  ObjAnimate( "spr_deploy_brokengasolinesaw_brokenchain_3_1", "ang", 1, 0, "", { 0,0,-0.01, 1.5,0,0.05, 3,0,-0.01 } );

end;
--*********************************************************************************************************************
function public.get_workingfuelsaw()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  cmn.SetEventDone( "get_workingfuelsaw" );
  cmn.CallEventHandler( "get_workingfuelsaw", "inv_workingfuelsawpiece" );
  common_impl.HideDeployInv();

end;
--*********************************************************************************************************************
function public.use_fuelsawchain()

  local item = "inv_fuelsawchain";

  if private.ObjIntersectCheck( item, "obj_brokengasolinesaw3_use_fuelsawchain" ) then

    cmn.CallEventHandler( "use_fuelsawchain_beg", "inv_brokengasolinesaw3" );
    cmn.CallEventHandler( "use_fuelsawchain_inv" );

    local func_end = function ()

      common_impl.Lock(false);
      
      cmn.SetEventDone( "use_fuelsawchain" );
      cmn.CallEventHandler( "use_fuelsawchain_end", "inv_brokengasolinesaw3" );
      cmn.CallEventHandler( "use_fuelsawchain_inv_end" );
    
    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_waterside_worksaw", 0, "", 0 );

    ObjAnimate( "spr_deploy_brokengasolinesaw_chain_2", "alp", 0, 0, func_end,
    { 
      0.0, 0, 0, 
      0.4, 0, 1,
    } );
    ObjAnimate( "spr_deploy_brokengasolinesaw_brokenchain_3", "alp", 0, 0, "",
    { 
      0.0, 0, 1, 
      0.4, 0, 0,
    } );
    ObjAnimate( "spr_deploy_brokengasolinesaw_brokenchain_3_1", "alp", 0, 0, "",
    { 
      0.0, 0, 1, 
      0.4, 0, 0,
    } );
    return true;

  end;

end;