-- name=rm_chamber
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_chamber";

   private.book_cond = { 1, 3, 2, 5, 6, 4 };
   private.book_get = 0; 
   private.coord_x = { -23, 22, 71, 119, 164, 213 };
   private.reset_x = { -23, 71, 22, 213, 119, 164 };
   private.win = { 5, 6, 2, 3, 1, 4 };

   private.evidence_mmg_coords = { { { -136, -128 }, { -26, -128 }, { 84, -128 } },  
                                    { { -136, -18  }, { -26, -18  }, { 84, -18  } },
                                    { { -136,  92  }, { -26,  92  }, { 84,  92  } } };

   private.evidence_mmg_state = { { 5, 1, 7 },
                                   { 2, 4, 8 },
                                   { 6, 3, 0 } };

   private.evidence_mmg_win =   { { 1, 2, 3 },
                                   { 4, 5, 6 },
                                   { 7, 8, 0 } };
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_window", "room_hub" );
  ObjAttach( "zz_bookcabinet", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({   
    { "spr_window_prv_figurine",      { event_mdown = private.get_prv_figurine      }},
    { "spr_window_glasspiece",   { event_mdown = private.get_glasspiece        }},
    { "spr_bookcabinet_opener",       { event_mdown = private.get_opener            }},
    { "spr_bookcabinet_photoalbum",   { event_mdown = private.get_photoalbum        }},
    --
    { "obj_chamber_prv_item_1",   { event_mdown = function() int_providence.Thinking( "providence_1", "obj_chamber_prv_item_1" ) end }},
    { "obj_chamber_prv_item_2",   { event_mdown = function() int_providence.Thinking( "providence_2", "obj_chamber_prv_item_2" ) end }},

    { "spr_chamber_prv_chair",        { event_mdown = private.clk_providence_chair  }},
    { "spr_chamber_prv_curtain",      { event_mdown = private.clk_providence_curtain  }},
    { "obj_chamber_use_prv_item_1",   { event_mdown = private.get_prv_photoalbum_silhouette }},
    { "obj_chamber_use_prv_item_2",   { event_mdown = private.get_prv_figurine_silhouette }},
    --
    { "obj_chamber_clk_hatch",          { event_mdown = private.clk_hatch             }},
    { "obj_dlg_chamber_owlman",         { event_mdown = private.dlg_chamber_owlman    }},
    { "obj_dlg_chamber_owlman_focus",   { event_mdown = private.dlg_chamber_owlman    }},
    { "obj_dlg_chamber_owlman_2",       { event_mdown = private.dlg_chamber_owlman_2  }},
    { "obj_dlg_chamber_owlman_2_focus", { event_mdown = private.dlg_chamber_owlman_2  }},

    { "obj_window_clk_hatchhandle",     { event_mdown = function() private.clk_hatchhandle() end }},

    { "spr_bookcabinet_book_1",   { event_mdown = function() private.Book_Take( 1 ) end }},
    { "spr_bookcabinet_book_2",   { event_mdown = function() private.Book_Take( 2 ) end }},
    { "spr_bookcabinet_book_3",   { event_mdown = function() private.Book_Take( 3 ) end }},
    { "spr_bookcabinet_book_4",   { event_mdown = function() private.Book_Take( 4 ) end }},
    { "spr_bookcabinet_book_5",   { event_mdown = function() private.Book_Take( 5 ) end }},
    { "spr_bookcabinet_book_6",   { event_mdown = function() private.Book_Take( 6 ) end }},

    { "obj_window_use_hatchhandle",     { event_mdown = function () private.AnimationPartlock();  common_impl.ShowBbt( 'bbt_window_use_hatchhandle' ); end }},

    { "spr_bookcabinet_coin",           { event_mdown = private.get_collect_coin_25 }},
    { "spr_window_coin",                { event_mdown = private.get_collect_coin_26 }},
   
  });

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_chamber = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_chamber_window",
    "gzz_chamber_bookcabinet"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_window",
      "zz_bookcabinet",
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_chamber", update_game_mode_chamber, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_chamber = function ()

  local effects_table = 
  {
    "obj_chamber_anim",
    "anm_chamber_dial_owlman",
    "anm_window_blind",
    "anm_window_window",
    "vid_chambler_fire",
    "anm_window_statuette",
    "anm_chamber_curtain3",
    "anm_chamber_curtain1",
    "anm_chamber_curtain2",  
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_chamber", update_performance_mode_chamber, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_chamber () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_chamber" ] = {
    type = "click",
    use_place = "grm_hallway_chamber",
    room = "rm_hallway",
    zz = "slider_left"
  };

  local opn_chamber_map = function ()

    common_impl.VisitMapRoom( "chamber" );

  end;
  cmn.AddSubscriber( "opn_chamber", opn_chamber_map );
  
--------------------------------------------------------------------------------------------
  -- function get_prv_photoalbum_silhouette () end;
  --------------------------------------------------------------------------------------------
  local get_prv_photoalbum_silhouette_inv = function ()
  
    interface.ProvidePanelSilhouetteAdd( "inv_prv_photoalbum", "spr_chamber_prv_photoalbum_silhouette" );

  end;
  
  local get_prv_photoalbum_silhouette_closezz = function ()

    ObjSet( "spr_chamber_prv_photoalbum_silhouette", { alp = 1 } );    
    ObjSet( "obj_chamber_use_prv_item_1", { event_mdown = function() int_providence.Thinking( "providence_prv_item_1", "obj_chamber_use_prv_item_1" ) end } )

  end;

  local get_prv_photoalbum_silhouette_notadd = function ()

    ObjSet( "obj_chamber_use_prv_item_1", { event_mdown = function() int_providence.Thinking( "providence_prv_item_1", "obj_chamber_use_prv_item_1" ) end } )

  end;
  
  cmn.AddSubscriber( "get_prv_photoalbum_silhouette", get_prv_photoalbum_silhouette_inv );
  cmn.AddSubscriber( "get_prv_photoalbum_silhouette", get_prv_photoalbum_silhouette_closezz, private.room_objname );
  cmn.AddSubscriber( "get_prv_photoalbum", get_prv_photoalbum_silhouette_notadd, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function get_prv_figurine_silhouette () end;
  --------------------------------------------------------------------------------------------
  local get_prv_figurine_silhouette_inv = function ()
  
    interface.ProvidePanelSilhouetteAdd( "inv_prv_figurine", "spr_chamber_prv_figurine_silhouette" );

  end;
  
  local get_prv_figurine_silhouette_closezz = function ()

    ObjSet( "spr_chamber_prv_figurine_silhouette", { alp = 1 } );    
    ObjSet( "obj_chamber_use_prv_item_2", { event_mdown = function() int_providence.Thinking( "providence_prv_item_2", "obj_chamber_use_prv_item_2" ) end } )

  end;

  local get_prv_figurine_silhouette_notadd = function ()

    ObjSet( "obj_chamber_use_prv_item_2", { event_mdown = function() int_providence.Thinking( "providence_prv_item_2", "obj_chamber_use_prv_item_2" ) end } )

  end;
  
  cmn.AddSubscriber( "get_prv_figurine_silhouette", get_prv_figurine_silhouette_inv );
  cmn.AddSubscriber( "get_prv_figurine_silhouette", get_prv_figurine_silhouette_closezz, private.room_objname );
  cmn.AddSubscriber( "get_prv_figurine", get_prv_figurine_silhouette_notadd, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_prv_figurine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_prv_figurine" ] = {
    type = "get",
    get_obj = "spr_window_prv_figurine",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_chamber_window"
  };
    
  local get_prv_figurine_inv = function ()
  
    interface.ProvidePanelItemAdd( "inv_prv_figurine", "spr_window_prv_figurine" );
  
  end;
  
  local get_prv_figurine_closezz = function ()
  
    ObjDelete( "gfx_window_prv_figurine" );
    ObjDelete( "spr_window_prv_figurine_shadow" );

    if common_impl.IsGetCoin( "get_coin_26" ) then

      ObjDelete( "gzz_chamber_window" );

    end;

  end;
  
  cmn.AddSubscriber( "get_prv_figurine", get_prv_figurine_inv );
  cmn.AddSubscriber( "get_prv_figurine", get_prv_figurine_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_glasspiece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_glasspiece" ] = {
    type = "get",
    get_obj = "spr_window_glasspiece",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_chamber_window"
  };
    
  local get_glasspiece_inv = function ()
  
    interface.InventoryItemAdd( "inv_glasspiece", "spr_window_glasspiece" );
    ObjSet( "spr_photoalbum_plus_light", { alp = 1 } );
  
  end;
  
  local get_glasspiece_closezz = function ()
  
    ObjDelete( "spr_chamber_window_glass"     );
    ObjDelete( "gfx_window_glasspiece"        );
    ObjDelete( "spr_window_glasspiece_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_glasspiece", get_glasspiece_inv );
  cmn.AddSubscriber( "get_glasspiece", get_glasspiece_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_opener () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_opener" ] = {
    type = "get",
    get_obj = "spr_bookcabinet_opener",
    room = private.room_objname,
    zz = "zz_bookcabinet",
    zz_gate = "gzz_chamber_bookcabinet"
  };
    
  local get_opener_inv = function ()
  
    interface.InventoryItemAdd( "inv_opener", "spr_bookcabinet_opener" );
  
  end;
  
  local get_opener_closezz = function ()
  
    ObjDelete( "gfx_bookcabinet_opener" );
    ObjDelete( "spr_bookcabinet_opener_shadow" );

    if cmn.IsEventDone( "get_photoalbum" ) and
      common_impl.IsGetCoin( "get_coin_25" ) and
      cmn.IsEventDone( "get_opener" ) then

      ObjDelete( "gzz_chamber_bookcabinet" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_opener", get_opener_inv );
  cmn.AddSubscriber( "get_opener", get_opener_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_photoalbum () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_photoalbum" ] = {
    type = "get",
    get_obj = "spr_bookcabinet_photoalbum",
    room = private.room_objname,
    zz = "zz_bookcabinet",
    zz_gate = "gzz_chamber_bookcabinet"
  };
    
  local get_photoalbum_inv = function ()
  
    interface.InventoryItemAdd( "inv_photoalbum", "spr_bookcabinet_photoalbum" );
    ObjSet( "inv_photoalbum", { drag = false });

  end;
  
  local get_photoalbum_closezz = function ()

    ObjDelete( "spr_bookcabinet_photoalbum_shadow" );  
    ObjDelete( "gfx_bookcabinet_photoalbum" );

    if cmn.IsEventDone( "get_photoalbum" ) and
      common_impl.IsGetCoin( "get_coin_25" ) and
      cmn.IsEventDone( "get_opener" ) then

      ObjDelete( "gzz_chamber_bookcabinet" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_photoalbum", get_photoalbum_inv );
  cmn.AddSubscriber( "get_photoalbum", get_photoalbum_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_25 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_25 = function ()
 
    ObjDelete( "obj_bookcabinet_coin" );

    if cmn.IsEventDone( "get_photoalbum" ) and
      common_impl.IsGetCoin( "get_coin_25" ) and
      cmn.IsEventDone( "get_opener" ) then

      ObjDelete( "gzz_chamber_bookcabinet" );

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_25", get_collect_coin_25, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_26 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_26 = function ()
 
    ObjDelete( "obj_window_coin" );

    if cmn.IsEventDone( "get_prv_figurine" ) then

      ObjDelete( "gzz_chamber_window" );

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_26", get_collect_coin_26, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function win_evidence_3_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_evidence_3_3" ] = {
    type = "get",
    get_obj = "spr_flowerbed_evidence_3_3",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_mansion_flowerbed"
  };
    
  local win_evidence_3_3_inv = function ()
  
  end;
  
  local win_evidence_3_3_closezz = function ()

    if not cmn.IsEventDone( "win_evidence_3_3" ) then

      if cmn.IsEventStart( "win_evidence_3_3" ) then

        if ng_global.progress[ "std" ] [ "win_evidence_3_3" ].state then

          DbgTrace( "enter1 "..#ng_global.progress[ "std" ] [ "win_evidence_3_3" ].state );
          --DbgTrace( "enter1 "..#ng_global.progress[ "std" ] [ "win_evidence_3_3" ].state[i] );
          local coord_mas = { }
          local start_x = -136;
          local start_y = -128;
          local step = 110;
          for i = 1,3 do

            coord_mas[i] = {};

            for j = 1,3 do

              coord_mas[i][j] = { start_x + step * ( j - 1 ), start_y + step * ( i - 1 ) }
              if ng_global.progress[ "std" ] [ "win_evidence_3_3" ].state[i][j] ~= 0 then

                DbgTrace( "spr_evidence_evidence_3_3_box_part_"..ng_global.progress[ "std" ] [ "win_evidence_3_3" ].state[i][j] );
                DbgTrace( coord_mas[i][j][1].."    "..coord_mas[i][j][2] );
                ObjSet( "spr_evidence_evidence_3_3_box_part_"..ng_global.progress[ "std" ] [ "win_evidence_3_3" ].state[i][j], { pos_x = coord_mas[i][j][1], pos_y = coord_mas[i][j][2] } );

              end;

              private.evidence_mmg_state[i][j] = ng_global.progress[ "std" ] [ "win_evidence_3_3" ].state[i][j];

            end;

          end;

        end;

      end;

    else

      ObjDelete( "spr_chamber_evidence_3_3" );

    end;

  end;
  
  cmn.AddSubscriber( "win_evidence_3_3", win_evidence_3_3_inv );
  cmn.AddSubscriber( "win_evidence_3_3", win_evidence_3_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_9 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_9" ] = {
    type = "use",
    inv_obj = "inv_elf_3",
    use_place = "obj_window_use_elf",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_chamber_window"
  };
  local use_elf_9_inv = function ()
  
    --interface.InventoryItemRemove( "inv_elf" );
  
  end;
  local use_elf_9_beg = function ()
  
    ObjDelete( "obj_window_use_elf" );
  
  end;
  local use_elf_9_end = function ()

    ObjDelete( "anm_window_statuette" );
    ObjMultiSet({ 
      { "spr_window_prv_figurine",     { input = true, alp = 1 }},
      { "spr_window_prv_figurine_shadow",     { alp = 1 }},
      { "gfx_window_prv_figurine",     { active = true                         }}
    });

    ObjDelete( "vid_window_use_elf_9" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_9", use_elf_9_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_9", use_elf_9_inv );
  cmn.AddSubscriber( "use_elf_9", use_elf_9_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_9_inv", use_elf_9_inv, private.room_objname );
  cmn.AddSubscriber( "use_elf_9_beg", use_elf_9_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_9_end", use_elf_9_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hatchhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hatchhandle" ] = {
    type = "use",
    inv_obj = "inv_hatchhandle",
    use_place = "obj_window_use_hatchhandle",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_chamber_window"
  };
  local use_hatchhandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_hatchhandle" );
  
  end;
  local use_hatchhandle_beg = function ()
  
    ObjDelete( "obj_window_use_hatchhandle" );
  
  end;
  local use_hatchhandle_end = function ()

    ObjMultiSet({   
      { "obj_window_clk_hatchhandle", { input = true } },
      { "spr_window_hatchhandle_shadow", { alp = 1   } },
      { "spr_window_hatchhandle",        { alp = 1   } },
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hatchhandle", use_hatchhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_hatchhandle", use_hatchhandle_inv );
  cmn.AddSubscriber( "use_hatchhandle", use_hatchhandle_end, private.room_objname );
  cmn.AddSubscriber( "use_hatchhandle_inv", use_hatchhandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_hatchhandle_beg", use_hatchhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_hatchhandle_end", use_hatchhandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_book () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_book" ] = {
    type = "use",
    inv_obj = "inv_book",
    use_place = "obj_bookcabinet_use_book",
    room = private.room_objname,
    zz = "zz_bookcabinet",
    zz_gate = "gzz_chamber_bookcabinet"
  };
  local use_book_inv = function ()
  
    interface.InventoryItemRemove( "inv_book" );
  
  end;
  local use_book_beg = function ()
  
    ObjDelete( "obj_bookcabinet_use_book" );
  
  end;
  local use_book_end = function ()

    ObjSet( "spr_bookcabinet_book_6", { alp = 1 });
    ObjSet( "obj_bookcabinet_mmg", { input = true });
    ObjSet( "spr_chamber_book", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_book", use_book_beg, private.room_objname );
  cmn.AddSubscriber( "use_book", use_book_inv );
  cmn.AddSubscriber( "use_book", use_book_end, private.room_objname );
  cmn.AddSubscriber( "use_book_inv", use_book_inv, private.room_objname );
  cmn.AddSubscriber( "use_book_beg", use_book_beg, private.room_objname );
  cmn.AddSubscriber( "use_book_end", use_book_end, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function use_providence_figurine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_providence_figurine" ] = {
    type = "use",
    inv_obj = "inv_prv_figurine",
    use_place = "obj_chamber_use_prv_item_2",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"
  };
  local use_providence_figurine_inv = function ()
  
    interface.ProvidePanelItemRemove( "inv_prv_figurine" );
  
  end;
  local use_providence_figurine_beg = function ()
  
    ObjDelete( "obj_chamber_use_prv_item_2" );
  
  end;
  local use_providence_figurine_end = function ()
  
    ObjSet( "spr_chamber_prv_figurine_used", { alp = 1 } );
    ObjSet( "spr_chamber_owl", { visible = true } );
    ObjDelete( "spr_chamber_prv_figurine_light" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_providence_figurine", use_providence_figurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_figurine", use_providence_figurine_inv );
  cmn.AddSubscriber( "use_providence_figurine", use_providence_figurine_end, private.room_objname );
  cmn.AddSubscriber( "use_providence_figurine_inv", use_providence_figurine_inv, private.room_objname );
  cmn.AddSubscriber( "use_providence_figurine_beg", use_providence_figurine_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_figurine_end", use_providence_figurine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_providence_photoalbum () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_providence_photoalbum" ] = {
    type = "use",
    inv_obj = "inv_prv_photoalbum",
    use_place = "obj_chamber_use_prv_item_1",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"
  };
  local use_providence_photoalbum_inv = function ()
  
    interface.ProvidePanelItemRemove( "inv_prv_photoalbum" );
  
  end;
  local use_providence_photoalbum_beg = function ()
  
    ObjDelete( "obj_chamber_use_prv_item_1" );
  
  end;
  local use_providence_photoalbum_end = function ()

    ObjSet( "spr_chamber_prv_photoalbum_used", { alp = 1 } );
    ObjSet( "spr_chamber_album", { visible = true } );
    ObjDelete( "spr_chamber_prv_photoalbum_light" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_providence_photoalbum", use_providence_photoalbum_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_photoalbum", use_providence_photoalbum_inv );
  cmn.AddSubscriber( "use_providence_photoalbum", use_providence_photoalbum_end, private.room_objname );
  cmn.AddSubscriber( "use_providence_photoalbum_inv", use_providence_photoalbum_inv, private.room_objname );
  cmn.AddSubscriber( "use_providence_photoalbum_beg", use_providence_photoalbum_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_photoalbum_end", use_providence_photoalbum_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_hatch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_hatch" ] = {
    type = "click",
    use_place = "obj_chamber_clk_hatch",
    room = private.room_objname,
    zz = "slider_up"        
  };
  local clk_hatch_beg = function ()
  
    ObjDelete(  "obj_chamber_clk_hatch" );
  
  end;
  local clk_hatch_end = function ()
  
    ObjDelete( "spr_chamber_line" );
    ObjSet( "spr_chamber_stairs", { alp = 1 });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_hatch", clk_hatch_beg, private.room_objname );
  cmn.AddSubscriber( "clk_hatch", clk_hatch_end, private.room_objname );
  cmn.AddSubscriber( "clk_hatch_beg", clk_hatch_beg, private.room_objname );
  cmn.AddSubscriber( "clk_hatch_end", clk_hatch_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_hatchhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_hatchhandle" ] = {
    type = "click",
    use_place = "obj_window_clk_hatchhandle",
    room = private.room_objname,
    zz = "zz_window",
    zz_gate = "gzz_chamber_window"    
  };

  local clk_hatchhandle = function ()

    ObjMultiSet({   
      { "obj_window_use_elf",      { input = true, active = true }},
      { "anm_chamber_curtain2", { visible = true }},
    });
    ObjDelete( "obj_window_window" );
    ObjDelete( "obj_window_clk_hatchhandle" );
    ObjDelete( "anm_chamber_curtain1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_hatchhandle", clk_hatchhandle, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_providence_chair () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_providence_chair" ] = {
    type = "click",    
    use_place = "spr_chamber_prv_chair",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"    
  };
  local clk_providence_chair_beg = function ()
  
    ObjDelete(  "obj_chamber_prv_item_1" );
  
  end;
  local clk_providence_chair_end = function ()

    ObjDelete( "spr_chamber_prv_chair"       );
    ObjDelete( "spr_chamber_prv_chair_light" );
    ObjSet( "spr_chamber_prv_chair_used", { alp = 1     });    
    ObjSet( "spr_chamber_chair", { pos_x = 445 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_providence_chair", clk_providence_chair_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_chair", clk_providence_chair_end, private.room_objname );
  cmn.AddSubscriber( "clk_providence_chair_beg", clk_providence_chair_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_chair_end", clk_providence_chair_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_providence_curtain () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_providence_curtain" ] = {
    type = "click",    
    use_place = "spr_chamber_prv_curtain",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"  
  };
  local clk_providence_curtain_beg = function ()
  
    ObjDelete(  "obj_chamber_prv_item_2" );
  
  end;
  local clk_providence_curtain_end = function ()
  
    ObjDelete( "spr_chamber_prv_curtain"       );
    ObjDelete( "spr_chamber_prv_curtain_light" );    
    ObjDelete( "anm_chamber_curtain3" );    
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_providence_curtain", clk_providence_curtain_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_curtain", clk_providence_curtain_end, private.room_objname );
  cmn.AddSubscriber( "clk_providence_curtain_beg", clk_providence_curtain_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_curtain_end", clk_providence_curtain_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_chamber_owlman () end;
  --------------------------------------------------------------------------------------------
  local vid_chamber_owlman_beg = function ()

  end;
  local vid_chamber_owlman_end = function ()  

    ObjSet( "obj_dlg_chamber_owlman", { active = true, input = true} );    
    int_slider.Lock( private.room_objname );
    ObjSet( "obj_chamber_dial_owlman", { visible = true } );
    ObjDelete( "obj_chamber_fireplace" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_chamber_owlman", vid_chamber_owlman_beg, private.room_objname );
  cmn.AddSubscriber( "vid_chamber_owlman", vid_chamber_owlman_end, private.room_objname  );
  cmn.AddSubscriber( "vid_chamber_owlman_beg", vid_chamber_owlman_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_chamber_owlman_end", vid_chamber_owlman_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
 --------------------------------------------------------------------------------------------
  -- function dlg_chamber_owlman () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_chamber_owlman" ] = {

      type = "click",
      use_place = "obj_dlg_chamber_owlman_focus",
      room = private.room_objname
  };

  local dlg_chamber_owlman_end = function ()

    ObjDelete( "obj_dlg_chamber_owlman" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_chamber_owlman", dlg_chamber_owlman_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_chamber_owlman_end", dlg_chamber_owlman_end, private.room_objname  );


 --------------------------------------------------------------------------------------------
  -- function dlg_chamber_owlman_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_chamber_owlman_2" ] = {

      type = "click",
      use_place = "obj_dlg_chamber_owlman_2_focus",
      room = private.room_objname
  };

  local dlg_chamber_owlman_2_end = function ()

    ObjDelete( "obj_dlg_chamber_owlman_2" );

  end;

  local dlg_chamber_owlman_2_map = function ()

    local lock_rooms = { "mansion", "hallway", "chamber" };

    for j = 1, #lock_rooms do

      common_impl.LockMapRoom( lock_rooms[j], true );

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_chamber_owlman_2", dlg_chamber_owlman_2_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_chamber_owlman_2_end", dlg_chamber_owlman_2_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_chamber_owlman_2_end", dlg_chamber_owlman_2_map, private.room_objname  );
  cmn.AddSubscriber( "dlg_chamber_owlman_2", dlg_chamber_owlman_2_map  );
  --------------------------------------------------------------------------------------------
  -- function clk_providence_chamber () end;
  --------------------------------------------------------------------------------------------
  local clk_providence_chamber = function ()
              
    if ( not cmn.IsEventDone( "clk_providence_chair" ) or not cmn.IsEventDone( "clk_providence_curtain" ) 
         or ( cmn.IsEventDone( "get_prv_photoalbum" ) and not cmn.IsEventDone( "use_providence_photoalbum" ) )
         or ( cmn.IsEventDone( "get_prv_figurine" ) and not cmn.IsEventDone( "use_providence_figurine" ) ) ) then

        int_button_providence.StartActiveProvidence();

    end;
  
  end;
  
  cmn.AddSubscriber( "clk_providence_chamber", clk_providence_chamber, private.room_objname );
 
 --------------------------------------------------------------------------------------------
  -- function vid_chamber_providence () end;
  --------------------------------------------------------------------------------------------  
  
  local vid_chamber_prv_end = function ()

    ObjMultiSet({   
      { "obj_chamber_clk_hatch", { active = true, input = true }},
    });

    local params = { "up" };
    int_slider.Unlock( private.room_objname, params );
        
  end;

  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_chamber_providence", vid_chamber_prv_end, private.room_objname  );
  cmn.AddSubscriber( "vid_chamber_prv_end", vid_chamber_prv_end, private.room_objname  );
 --------------------------------------------------------------------------------------------
  
  local vid_chamber_providence_p2 = function ()

    VidStop( "vid_chamber_providence_p1" );
    ObjSet( "vid_chamber_providence_p2", { playing = true } );    

  end;   

  cmn.AddSubscriber( "vid_chamber_providence_p2", vid_chamber_providence_p2, private.room_objname );
  --------------------------------------------------------------------------------------------
  local vid_chamber_providence_p3 = function ()

    VidStop( "vid_chamber_providence_p2" );
    ObjSet( "vid_chamber_providence_p3", { playing = true } );

  end;   

  cmn.AddSubscriber( "vid_chamber_providence_p3", vid_chamber_providence_p3, private.room_objname );
  --------------------------------------------------------------------------------------------
  local vid_chamber_providence_p4 = function ()

    VidStop( "vid_chamber_providence_p3" );
    VidPlay( "vid_chamber_providence_p4", private.vid_chamber_providence_end );    

  end;   

  cmn.AddSubscriber( "vid_chamber_providence_p4", vid_chamber_providence_p4, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function win_bookcabinet () end;
  --------------------------------------------------------------------------------------------  
  common_impl.hint[ "win_bookcabinet" ] = {
      type = "win",    
      room = private.room_objname,
      use_place = "obj_bookcabinet_mmg",
      zz_gate = "gzz_chamber_bookcabinet",
      zz = "zz_bookcabinet"
  };

  local win_bookcabinet = function ()

      if ( cmn.IsEventDone( "win_bookcabinet" ) ) then  

        ObjDelete( "obj_bookcabinet_shalf" );
        ObjDelete( "spr_bookcabinet_over_shadow" );
        ObjDelete( "spr_bookcabinet_over" );
        ObjDelete( "obj_bookcabinet_mmg" );
        ObjSet( "obj_bookcabinet_opener", { input = true, active = true });
        ObjSet( "spr_bookcabinet_photoalbum", { input = true, active = true });
        ObjDelete( "spr_chamber_books_mmg" )

      else 

          for i = 1, 6 do

            private.book_cond[i] = ng_global.progress["std"]["win_bookcabinet"].book_cond[i];
            local j = private.book_cond[i];

            ObjSet( "spr_bookcabinet_book_"..j , { pos_x = private.coord_x[i] });   
                
          end;
          
          local book_get;
          
          if ng_global.progress["std"]["win_bookcabinet"].book_get ~= 0 then

            book_get = ng_global.progress["std"]["win_bookcabinet"].book_get;
            ObjSet( "spr_bookcabinet_book_"..book_get , { scale_x = 1.2, scale_y = 1.2, pos_z = 50; });

          end;

      end;

  end;

  cmn.AddSubscriber( "win_bookcabinet", win_bookcabinet, private.room_objname );
  --------------------------------------------------------------------------------------------
  local vid_evidence_6_func = function ()

    ObjSet( "obj_dlg_chamber_owlman_2", { input = true, active = true } );

  end;   

  cmn.AddSubscriber( "vid_evidence_6", vid_evidence_6_func, private.room_objname );
  --------------------------------------------------------------------------------------------
  
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  common_impl.hint.position_slider[ "gzz_chamber_window" ] = { "mid" };
  common_impl.hint.position_slider[ "gzz_chamber_bookcabinet" ] = { "mid" };

  subroom.Define( "zz_bookcabinet" );
  --------------------------------------------------------------------------------------------
  function zz_bookcabinet.PreOpen ()

    if ( cmn.IsEventDone( "use_book" ) and not cmn.IsEventDone( "win_bookcabinet" )) then

      cmn.MiniGameShow( "bookcabinet" );
      common_impl.PassingMgStart( "bookcabinet" )

    end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_bookcabinet.PreClose()

    if ( cmn.IsEventStart( "win_bookcabinet" ) and not cmn.IsEventDone( "win_bookcabinet" ) ) then

      cmn.MiniGameHide( "bookcabinet" );
      common_impl.PassingMgStop( "bookcabinet" )

    end;

  end;

  subroom.Define( "zz_window" );
  --------------------------------------------------------------------------------------------
  function zz_window.PreOpen ()
    
    if cmn.IsEventDone( "clk_hatchhandle" ) then

      common_impl.PlayAudio( "env", "common/audio/aud_window_env", 1, "", 0 );

    end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_window.PreClose()

    common_impl.StopAudio( "env", "common/audio/aud_window_env", 1 );

  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_chamber();

  int_providence_eye.CheckShow();

  if ( not cmn.IsEventDone( "vid_chamber_providence" ) ) then

    int_button_providence.StartLightProvidence();

  end;

  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  interface.InvestigationButtonCheck();
  common_impl.EnvPlay( { "common/audio/aud_chamber_env" }, "", 0.5 ); 
  
end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreClose()

  if ( not cmn.IsEventDone( "vid_chamber_providence" ) ) then

    int_button_providence.StopLightProvidence();

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_elf_9()

  local item = "inv_elf_3";

  if ( common.ApplyObj( item, "obj_window_use_elf", true )  and cmn.IsEventDone( "clk_hatchhandle" ) ) then

    cmn.CallEventHandler( "use_elf_9_inv" );
    cmn.CallEventHandler( "use_elf_9_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_elf_9" );
      cmn.CallEventHandler( "use_elf_9_end" );
      ObjSet( "spr_window_figurine_elf", { alp = 1 });
      interface.InventoryItemAdd( "inv_elf_3", "spr_window_figurine_elf" );

    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_window_elf", 0, "", 0 );
    interface.InventoryItemRemove( "inv_elf_3" );

    ObjSet( "anm_window_statuette", { alp = 0 } );
    ObjSet( "vid_window_use_elf_9", { alp = 1, playing = true, endtrig = func_after } );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_chamber_window", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_window", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hatchhandle()

  local item = "inv_hatchhandle";

  if ( common.ApplyObj( item, "obj_window_use_hatchhandle", true ) ) then

    cmn.CallEventHandler( "use_hatchhandle_inv" );
    cmn.CallEventHandler( "use_hatchhandle_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_hatchhandle" );
      cmn.CallEventHandler( "use_hatchhandle_end" );
    --common.CloseSubRoom();;
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_hatchhandle", 0, "", 0 );
  
    ObjAnimate( "spr_window_hatchhandle", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );
    ObjAnimate( "spr_window_hatchhandle_shadow", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );
    --ObjAnimate( "spr_window_window", "alp", 0, 0, "",
    --{ 
    --  0.0, 0, 1.0, 
    --  0.3, 0, 1.0,
    --  0.6, 0, 0.0
    --} );
    --ObjAnimate( "spr_window_window_open", "alp", 0, 0, "",
    --{ 
    --  0.0, 0, 0.0, 
    --  0.3, 0, 0.0,
    --  0.6, 0, 1.0
    --} );

  return true;
  
  elseif common.ApplyObj( item, "gzz_chamber_window", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_window", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_book()

  local item = "inv_book";

  if ( common.ApplyObj( item, "obj_bookcabinet_use_book", true ) ) then

    cmn.CallEventHandler( "use_book_inv" );
    cmn.CallEventHandler( "use_book_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_book" );
      cmn.CallEventHandler( "use_book_end" );

      cmn.MiniGameShow( "bookcabinet" );
      common_impl.PassingMgStart( "bookcabinet" )
      
      ng_global.progress["std"]["win_bookcabinet"].book_cond = private.book_cond;
      ng_global.progress["std"]["win_bookcabinet"].book_get = private.book_get; 

    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_book", 0, "", 0 );
  
    ObjAnimate( "spr_bookcabinet_book_6", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_chamber_bookcabinet", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bookcabinet", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_providence_figurine()

  local item = "inv_prv_figurine";

  if ( ObjIntersect( item, "obj_chamber_use_prv_item_2") and int_providence.show ) then

    cmn.CallEventHandler( "use_providence_figurine_inv" );
    cmn.CallEventHandler( "use_providence_figurine_beg" );
    
    local func_after = function ()

      common_impl.Lock(false);
      cmn.CallEventHandler( "use_providence_figurine_end" );

      if cmn.IsEventDone( "clk_providence_chair" ) and cmn.IsEventDone( "clk_providence_curtain" ) and 
          cmn.IsEventDone( "use_providence_photoalbum" ) then

          private.anim_providence( function() cmn.SetEventDone( "use_providence_figurine" ); end );

      else 

        if ( cmn.IsEventDone( "clk_providence_chair" ) and cmn.IsEventDone( "clk_providence_curtain" ) and             
            (cmn.IsEventDone( "use_providence_figurine" ) or not cmn.IsEventDone( "get_prv_photoalbum" ) )) then
          int_button_providence.StopActiveProvidence();
        end;

        cmn.SetEventDone( "use_providence_figurine" );

      end;

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_providence_figurine", 0, "", 0 );

    ObjAnimate( "spr_chamber_prv_figurine_used", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_providence_photoalbum()

  local item = "inv_prv_photoalbum";

  if ( ObjIntersect( item, "obj_chamber_use_prv_item_1" ) and int_providence.show ) then

    cmn.CallEventHandler( "use_providence_photoalbum_inv" );
    cmn.CallEventHandler( "use_providence_photoalbum_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.CallEventHandler( "use_providence_photoalbum_end" );

      if cmn.IsEventDone( "clk_providence_chair" ) and cmn.IsEventDone( "clk_providence_curtain" ) and 
          cmn.IsEventDone( "use_providence_figurine" ) then

          private.anim_providence( function() cmn.SetEventDone( "use_providence_photoalbum" ); end );

      else 

        if ( cmn.IsEventDone( "clk_providence_chair" ) and cmn.IsEventDone( "clk_providence_curtain" ) and             
            ( cmn.IsEventDone( "use_providence_photoalbum" ) or not cmn.IsEventDone( "get_prv_figurine" ) )) then
          int_button_providence.StopActiveProvidence();
        end;

        cmn.SetEventDone( "use_providence_photoalbum" );

      end;

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_providence_photoalbum", 0, "", 0 );

    ObjAnimate( "spr_chamber_prv_photoalbum_used", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_prv_figurine()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_prv_figurine" );
  cmn.CallEventHandler( "get_prv_figurine" );

  if common_impl.IsGetCoin( "get_coin_26" ) then

    common.CloseSubRoom();

  end;
  

end;
--------------------------------------------------------------------------------------------
function private.get_glasspiece()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_glasspiece" );
  cmn.CallEventHandler( "get_glasspiece" );

end;
--------------------------------------------------------------------------------------------
function private.get_opener()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_opener" );
  cmn.CallEventHandler( "get_opener" );

  if cmn.IsEventDone( "get_photoalbum" ) and common_impl.IsGetCoin( "get_coin_25" ) 
   and cmn.IsEventDone( "get_opener" ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_photoalbum()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_photoalbum" );
  cmn.CallEventHandler( "get_photoalbum" );

  if cmn.IsEventDone( "get_photoalbum" ) and common_impl.IsGetCoin( "get_coin_25" ) 
     and cmn.IsEventDone( "get_opener" ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_prv_photoalbum_silhouette()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );
  cmn.SetEventDone( "get_prv_photoalbum_silhouette" );
  cmn.CallEventHandler( "get_prv_photoalbum_silhouette" );

end;
--------------------------------------------------------------------------------------------
function private.get_prv_figurine_silhouette()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );
  cmn.SetEventDone( "get_prv_figurine_silhouette" );
  cmn.CallEventHandler( "get_prv_figurine_silhouette" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_providence_chair()

  cmn.CallEventHandler( "clk_providence_chair_beg" );

  local func_after = function ()

    common_impl.Lock(false);

    cmn.CallEventHandler( "clk_providence_chair_end" );

    if cmn.IsEventDone( "clk_providence_curtain" ) and cmn.IsEventDone( "use_providence_figurine" ) 
       and cmn.IsEventDone( "use_providence_photoalbum" ) then

      private.anim_providence( function() cmn.SetEventDone( "clk_providence_chair" ); end );

    else 

      if ( cmn.IsEventDone( "clk_providence_curtain" ) and
      ( not cmn.IsEventDone( "get_prv_figurine" ) or cmn.IsEventDone( "use_providence_figurine" ) ) and
      ( not cmn.IsEventDone( "get_prv_photoalbum" ) or cmn.IsEventDone( "use_providence_photoalbum" ) ) ) then

        int_button_providence.StopActiveProvidence();

      end;

      cmn.SetEventDone( "clk_providence_chair" );

    end;

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_chair", 0, "", 0 );
  
  ObjAnimate( "spr_chamber_prv_chair_used", "alp", 0, 0, func_after, { 0, 0, 0, 0.3, 0, 1 } );
  ObjAnimate( "spr_chamber_prv_chair", "alp", 0, 0, func_after, { 0, 0, 1, 0.3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.clk_providence_curtain()

  cmn.CallEventHandler( "clk_providence_curtain_beg" );
  
  local func_after = function ()

    common_impl.Lock(false);

    cmn.CallEventHandler( "clk_providence_curtain_end" );

    if cmn.IsEventDone( "clk_providence_chair" ) and cmn.IsEventDone( "use_providence_figurine" ) 
       and cmn.IsEventDone( "use_providence_photoalbum" ) then

      private.anim_providence( function() cmn.SetEventDone( "clk_providence_curtain" ); end );

    else 

      if ( cmn.IsEventDone( "clk_providence_chair" ) and
      ( not cmn.IsEventDone( "get_prv_figurine" ) or cmn.IsEventDone( "use_providence_figurine" ) ) and
      ( not cmn.IsEventDone( "get_prv_photoalbum" ) or cmn.IsEventDone( "use_providence_photoalbum" ) ) ) then

        int_button_providence.StopActiveProvidence();

      end;

      cmn.SetEventDone( "clk_providence_curtain" );

    end;

  end;

  common_impl.Lock(true);  

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_curtain", 0, "", 0 );

  ObjAnimate( "spr_chamber_prv_curtain", "alp", 0, 0, func_after, { 0, 0, 1, 0.3, 0, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.anim_providence( func_execute )

  common_impl.ShowBbt( "bbt_providence_allitems" );

  int_button_providence.StopActiveProvidence();

  local array_objects = {    
    "spr_chamber_prv_figurine_used",
    "spr_chamber_prv_photoalbum_used",
    "spr_chamber_prv_chair_used" }

  local func_end = function()

    for i = 1, #array_objects do
      ObjAttach( array_objects[ i ], "obj_chamber_providence" );
      ObjSet( array_objects[ i ], { alp = 1 } );
    end;
    common_impl.Lock( false );    
    private.vid_chamber_providence( func_execute );

  end;
  
  common_impl.Lock( true );
  for i = 1, #array_objects do
    common_impl.PlayEffectHO( array_objects[ i ], func_end, 3, "assets/interface/resources/effect_mask" );
    func_end = nil;
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_ready", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.vid_chamber_providence( func_execute )

  interface.BBTHide();

  private.func_providence = func_execute;

  int_button_providence.StopLightProvidence();
  
  common_impl.StopAllMus();
  common_impl.PlayAudio( "mus", "common/audio/aud_providence_mus", 1, "", 0.5 ); 
  common_impl.PlayAudio( "sfx", "common/audio/aud_chamber_providence_p1", 0, "", 0 );

  VidPlay( "vid_chamber_providence_p1", "" ); 
  interface.DialogVideoShow( "vid_chamber_providence", 1, function() private.vid_chamber_providence_end(); end , 3, 4 ); 

end;

function private.vid_chamber_providence_end( )

    common_impl.Lock( false );
    common_impl.StopAudio( "sfx", "common/audio/aud_chamber_providence_p4", 0.2 );
    int_providence.Hide();
    interface.DialogVideoHide();

    cmn.SetEventDone( "vid_chamber_providence" );
    cmn.CallEventHandler( "vid_chamber_prv_end" );

    common_impl.ShowBbt( 'bbt_providence_level3_2_end' );

    int_slider.InitSlider( private.room_objname );
    
    if ( private.func_providence ) then

      private.func_providence();
      private.func_providence = nil;

    end;

    common_impl.StopAudio( "mus", "common/audio/aud_providence_mus", 1 ); 
    common_impl.PlayAudio( "mus", "common/audio/aud_enigma_mus", 0, "", 0 );
  
end;
--------------------------------------------------------------------------------------------
function private.clk_hatch()

  cmn.CallEventHandler( "clk_hatch_beg" );

  local func_after = function ()

    common_impl.Lock( false );
    cmn.CallEventHandler( "clk_hatch_end" );
    private.vid_chamber_owlman();

  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_rope_ladder", 0, "", 0 );
  
  ObjAnimate( "spr_chamber_line", "pos_y", 0, 0, "", 
  { 
    0.0, 0, -56, 
    0.5, 0, -16
  } );

  ObjAnimate( "spr_chamber_line", "alp", 0, 0, "", 
  { 
    0.0, 0, 1, 
    0.5, 0, 1,
    0.8, 0, 0
  } );

  ObjAnimate( "spr_chamber_stairs", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 0, 
    0.5, 0, 0,
    0.8, 0, 1
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_hatchhandle()

  --cmn.CallEventHandler( "clk_hatch_beg" );

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_hatchhandle" );
    cmn.CallEventHandler( "clk_hatchhandle" );

    common_impl.PlayAudio( "env", "common/audio/aud_window_env", 1, "", 0 );

  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_hatchhandle", 0, "", 0 );
  
  ObjAnimate( "spr_window_partlock", "pos_xy", 0, 0, "", 
  { 
    0.0, 3, 156, 121, 
    0.4, 3, 145, 123
  } );
  ObjAnimate( "obj_window_window", "alp", 0, 0, func_after, 
  { 
    0.0, 3, 1, 
    0.4, 3, 1,
    0.8, 3, 0
  } );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
-----------------------------------------------------------------------------------------------------------------------
function private.get_collect_coin_25()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_25" );
    cmn.CallEventHandler( "get_coin_25" );

    if cmn.IsEventDone( "get_photoalbum" ) and
      common_impl.IsGetCoin( "get_coin_25" ) and
      cmn.IsEventDone( "get_opener" ) then

      common.CloseSubRoom();

    end;    

  end;

  common_impl.PlayEffectHO( "spr_bookcabinet_coin", func_after ); 

end;
-----------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
function private.get_collect_coin_26()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_26" );
    cmn.CallEventHandler( "get_coin_26" );

    if cmn.IsEventDone( "get_prv_figurine" ) then

      common.CloseSubRoom();

    end;    

  end;

  common_impl.PlayEffectHO( "spr_window_coin", func_after ); 

end;
-----------------------------------------------------------------------------------------------------------------------
function private.opn_chamber()

  if not ( cmn.IsEventDone( "opn_chamber" ) ) then

    cmn.SetEventDone( "opn_chamber" );

  end;
  
  cmn.CallEventHandler( "opn_chamber" ); 

end;
-----------------------------------------------------------------------------------------------------------------------
function private.vid_chamber_owlman()

  cmn.CallEventHandler( "vid_chamber_owlman_beg" );
  ObjSet( "vid_chamber_owlman", { alp = 1, active = true, input = false, visible = true } );
  
  local func_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_chamber_owlman" );
    cmn.CallEventHandler( "vid_chamber_owlman_end" ); 
    cmn.SetEventDone( "clk_hatch" );   
    common_impl.ShowBbt( 'bbt_vid_chamber_owlman', 1 );
    ObjSet( "obj_chamber_center", { pos_x = 0, pos_y = 0 } );
    ObjSet( "rm_chamber_providence", { pos_x = 0, pos_y = 0 } );
    int_slider.InitSlider( private.room_objname );
    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment3_mus", 0, "", 0 );

    interface.KeyTaskDone( "find_owlman", true );    

    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_chamber_owlman", 0.5 );
      common_impl.StopAudio( "voc", "common/audio/aud_chamber_owlman_voc", 0.5 );

    end;

  end;

  common_impl.StopAllMus();
  common_impl.PlayAudio( "sfx", "common/audio/aud_chamber_owlman", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/aud_chamber_owlman_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_chamber_owlman", 1, function() func_after ( 'skip' ); end, 3 );
  VidPlay( "vid_chamber_owlman", function() func_after ( nil ); end ); 
  
end;
-----------------------------------------------------------------------------------------------------------------------
function private.dlg_chamber_owlman()
  
  ObjAttach( "dlg_chamber_owlman", private.room_objname );
  common_impl.continue_visible = false; 
  common_impl.dialog_character_loc = "obj_chamber_dial_owlman";
  private.dialog_voices_time = { 15, 11, 12 };
  common_impl.DialogCharacterStart( "owlman", 6, nil, nil, true, "dlg_chamber_owlman_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_chamber_owlman_end()
  
   local func_end = function ()

    int_investigation_button.Show( true );
    interface.InvestigationButtonItemAdd( "evidence_3_3", "spr_evidence_evidence_3_3_notebook" );
    if tostring(GetPlatform()) == "android" then
      int_strategy_guide_impl.interface_hide = true;
    end;
    cmn.SetEventDone( "get_evidence_3_3" );
    cmn.SetEventDone( "win_evidence_3_3" );
    cmn.SetEventDone( "get_evidence_3_3" );
    cmn.CallEventHandler( "win_evidence_3_3" );
    cmn.SetEventDone( "dlg_chamber_owlman" );
    cmn.CallEventHandler( "dlg_chamber_owlman_end" );

  end;

  interface.DialogEvidenceShow( "evidence_3_3_progress", func_end );

   ObjSet( "int_dialog_evidence_exit",{ input = false } );
   ObjSet( "int_dialog_evidence", { pos_z = 8 } );

end;

-----------------------------------------------------------------------------------------------------------------------
function private.dlg_chamber_owlman_2()
  
  ObjAttach( "dlg_chamber_owlman_2", private.room_objname );
  common_impl.continue_visible = false; 
  common_impl.dialog_character_loc = "obj_chamber_dial_owlman";
  common_impl.DialogCharacterStart( "owlman_2", 2, nil, nil, true, "dlg_chamber_owlman_2_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_chamber_owlman_2_end()
  
  cmn.SetEventDone( "dlg_chamber_owlman_2" );
  cmn.CallEventHandler( "dlg_chamber_owlman_2_end" );

  int_investigation_button.ChangeInvestigation();

  cmn.GotoRoom( 'ho_hos' );
  
end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if dlg_name == "owlman" then

    if count_txt == 1 then 

      common_impl.continue_visible = false; 
      common_impl.frases = { 1, 2, 3 }; 
      common_impl.dial_icons = { 'oliver', 'nightsville', 'owlman' };
      common_impl.DialogCharacterShowDialogQuestions( 3, 8 ); 
    
    elseif count_txt == 2 then 

      common_impl.continue_visible = false; 
      common_impl.DialogCharacterShowDialogQuestions( 2, private.dialog_voices_time[ common_impl.dialog_character_select ] ); 
    
    elseif count_txt == 3 then 

      common_impl.continue_visible = false; 
      common_impl.DialogCharacterShowDialogQuestions( 1, private.dialog_voices_time[ common_impl.dialog_character_select ] ); 

    elseif count_txt == 4 then 

      common_impl.continue_visible = true; 

    elseif count_txt == 5 then

      ObjSet( "anm_chamber_owlman_box", { alp = 1 } );
      ObjSet( "anm_chamber_owlman", { alp = 0 } );
      common_impl.PlayAudio( "sfx", "common/audio/aud_get_to_us", 0, "", 0 );
    
    end;
  
  end;  

  if dlg_name == "owlman_2" then
  
  end;

end;
--*********************************************************************************************************************
function public.StartEvidenceMmg()

    local table_multiset = {};

    table.insert( table_multiset, { "spr_evidence_evidence_3_3_box_cover", { input = true } } );
    table.insert( table_multiset, { "obj_evidence_evidence_3_3_progress_clk",{ input = false } } );

    for i = 1, 8 do

      table.insert( table_multiset, { "spr_evidence_evidence_3_3_box_part_"..i, { event_mdown = function() private.ClkEvidencePart( i ); end } } );
        
    end;

    ObjMultiSet( table_multiset );

    cmn.MiniGameShow( "evidence_3_3" );
    ObjSet( "int_button_guide", { alp = 1, input = true } );
    ObjSet( "int_button_menu", { alp = 1, input = true } );
    if tostring(GetPlatform()) == "android" then
      int_strategy_guide_impl.interface_hide = false;
    end;
    common_impl.PassingMgStart( "evidence_3_3" );
    
end;
--*********************************************************************************************************************
function private.ClkEvidencePart( num )

  local func_after = function()

    common_impl.Lock( false );

    private.CheckEvidenceMmg( num );

  end;

  local posx = ObjGet( "spr_evidence_evidence_3_3_box_part_"..num ).pos_x;
  local posy = ObjGet( "spr_evidence_evidence_3_3_box_part_"..num ).pos_y;

  local posxNew;
  local posyNew;
  
  local posi;
  local posj;

  for i = 1, 3 do
    for j = 1, 3 do

      if ( private.evidence_mmg_state[ i ][ j ] == num ) then

         posi = i;
         posj = j;

      elseif ( private.evidence_mmg_state[ i ][ j ] == 0 ) then

         posi_null = i;
         posj_null = j;
         DbgTrace( i );
         DbgTrace( j );

      end;

    end;
  end;
  
  if ( ( math.abs( posi - posi_null ) == 1 ) and ( ( posj - posj_null ) == 0 ) ) or
     ( ( math.abs( posj - posj_null ) == 1 ) and ( ( posi - posi_null ) == 0 ) ) then

    posxNew = private.evidence_mmg_coords[ posi_null ][ posj_null ][ 1 ];
    posyNew = private.evidence_mmg_coords[ posi_null ][ posj_null ][ 2 ];

  end

  if ( not ( posxNew and posyNew ) ) then return; end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_statue_move", 0, "", 0 );

  common_impl.Lock( true );

  ObjAnimate( "spr_evidence_evidence_3_3_box_part_"..num, "pos_xy", 0, 0, func_after,
  { 
    0.0, 0,    posx,    posy,
    0.3, 0, posxNew, posyNew,
  } ); 

end;
--------------------------------------------------------------------------------------------------------------
function private.CheckEvidenceMmg( num )

  local posi, posj, posi_null, posj_null;
  local tmp_array = {};

  for i = 1, 3 do
    
    tmp_array[ i ] = {};

    for j = 1, 3 do

      tmp_array[ i ][ j ] =  private.evidence_mmg_state[ i ][ j ];

      if ( tmp_array[ i ][ j ] == num ) then

         posi = i;
         posj = j;

      elseif ( tmp_array[ i ][ j ] == 0 ) then

        posi_null = i;
        posj_null = j;

      end;

    end;
  end;

  tmp_array[ posi ][ posj ] = 0;
  tmp_array[ posi_null ][ posj_null ] = num;

  local count = 0;
  
  for i = 1, 3 do

    for j = 1, 3 do

      if ( tmp_array[ i ][ j ] ==  private.evidence_mmg_win[ i ][ j ] ) then
          
        count = count + 1;

      end;

    end;

  end;
  
  if ( count == 9 ) then

    private.WinEvidenceMmg();
   
  else

    if not ng_global.progress[ "std" ] [ "win_evidence_3_3" ].state then

      ng_global.progress[ "std" ] [ "win_evidence_3_3" ].state = {}
      for i = 1,3 do
        ng_global.progress[ "std" ] [ "win_evidence_3_3" ].state[i] = {}
        for j = 1,3 do

          ng_global.progress[ "std" ] [ "win_evidence_3_3" ].state[i][j] = private.evidence_mmg_state[i][j];

        end;
      end;

    end; 

    ng_global.progress[ "std" ] [ "win_evidence_3_3" ].state[ posi ][ posj ] = 0;
    ng_global.progress[ "std" ] [ "win_evidence_3_3" ].state[ posi_null ][ posj_null ] = num;

    private.evidence_mmg_state[ posi ][ posj ] = 0;
    private.evidence_mmg_state[ posi_null ][ posj_null ] = num;

  end;

end;
--------------------------------------------------------------------------------------------------------------
function private.WinEvidenceMmg()
  
  local func_after = function()
    
    common_impl.Lock( false );
    
    ObjSet( "spr_evidence_evidence_3_3_paper", { input = true, event_mdown =function() public.ClkEvidencePaper(); end, event_menter = function() common_impl.SetCursor( CURSOR_LOUPE ); end,
    DbgTrace("WinEvidenceMmg - func_after");                                                                             event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ); end } );
    ObjSet( "int_button_guide", { alp = 0, input = false } );
    ObjSet( "int_button_menu", { alp = 0, input = false } );
    
     if tostring(GetPlatform()) == "android" then
         int_strategy_guide_impl.interface_hide = true;
     end;
    
  end;

  cmn.MiniGameHide( "evidence_3_3" );
  common_impl.PassingMgWin( "evidence_3_3" );
  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_books_win", 0, "", 0 );

  ObjSet( "spr_evidence_evidence_3_3_box_cover", { input = false } );

  ObjAnimate( "spr_evidence_evidence_3_3_box_cover", "pos_xy", 0, 0, func_after, { 0,3,16,17, 0.7,3,-218,-43 } );
  ObjAnimate( "spr_evidence_evidence_3_3_box_cover", "alp", 0, 0, "", { 0,0,1, 0.5,0,1, 0.7,0,0 } );
  
end;
--------------------------------------------------------------------------------------------------------------
function public.ClkEvidencePaper()

  local func_after = function()

    common_impl.Lock( false );
    DbgTrace("ClkEvidencePaper - func_after");
    ObjSet( "obj_evidence_evidence_3_3_progress_clk", { input = true } );
    --cmn.SetEventDone( "win_evidence_3_3" );
    --cmn.SetEventDone( "get_evidence_3_3" );
    --cmn.CallEventHandler( "win_evidence_3_3" );
    --cmn.SetEventDone( "dlg_chamber_owlman" );
    --cmn.CallEventHandler( "dlg_chamber_owlman_end" );
    
  end;

  common_impl.Lock( true );
  DbgTrace("ClkEvidencePaper");
  ObjAnimate( "spr_evidence_evidence_3_3_notebook", "scale_xy", 0, 0, func_after, { 0,0,0,0, 0.3,0,1,1 } );
  ObjAnimate( "spr_evidence_evidence_3_3_paper_shadow", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
  ObjAnimate( "spr_evidence_evidence_3_3_paper", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
  ObjAnimate( "spr_evidence_evidence_3_3_box", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );

  common_impl.PlayAudio( "sfx", "common/audio/aud_paper_open", 0, "", 0 );

end;
--*********************************************************************************************************************
-----------------------------MMG---------------------------------------------------
-----------------------------------------------------------------------------------
--*********************************************************************************************************************
function private.Book_Take( number )

  local flag ;
  local first_book;

  for i = 1,6 do

    if ObjGet("spr_bookcabinet_book_"..i).scale_x > 1.2 then 

        flag = true;
        first_book = i;
            
    end;  

  end; 

  if flag then 

    if number == first_book then 
        
      local func_after = function()

        common_impl.Lock( false );
        ng_global.progress["std"]["win_bookcabinet"].book_get = 0;

      end;

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_books_back", 0, "", 0 );
    
      ObjAnimate( "spr_bookcabinet_book_"..number , "scale_x", 0, 0, "", 
      {          
          0.0, 0,  1.2, 
          0.3, 0,  1       
      });

      ObjAnimate( "spr_bookcabinet_book_"..number , "scale_y", 0, 0, "", 
      {          
          0.0, 0,  1.2, 
          0.3, 0,  1     
      }); 

      ObjAnimate( "spr_bookcabinet_book_"..number , "pos_z", 0, 0, func_after, 
      {          
          0.0, 0,  ObjGet( "spr_bookcabinet_book_"..number ).pos_z, 
          0.3, 0,  0     
      });  

    else

       private.Book_Move( first_book, number );

    end;         

  else 

    common_impl.Lock( true );

    local func_after = function()

      private.Book_Get( number );

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_books_front", 0, "", 0 );
    
    ObjAnimate( "spr_bookcabinet_book_"..number , "scale_x", 0, 0, "", 
    {          
        0.0, 0,  1, 
        0.3, 0,  1.2       
    });

    ObjAnimate( "spr_bookcabinet_book_"..number , "scale_y", 0, 0, "", 
    {          
        0.0, 0,  1, 
        0.3, 0,  1.2      
    }); 

    ObjAnimate( "spr_bookcabinet_book_"..number , "pos_z", 0, 0, func_after, 
    {          
        0.0, 0,  ObjGet("spr_bookcabinet_book_"..number).pos_z, 
        0.3, 0,  50     
    });  
  
  end; 

end;
-----------------------------------------------------------------------------------
function private.Book_Get( number )
  
  ng_global.progress["std"]["win_bookcabinet"].book_get = number;

  common_impl.Lock( false );

end;
------------------------------------------------------------------------------------------
function private.Book_Move( first_book, number )

  common_impl.Lock( true );

  local func_after =  function()

    private.Book_Move_1( first_book, number );

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_books_front", 0, "", 0 );

  ObjAnimate( "spr_bookcabinet_book_"..number , "scale_x", 0, 0, "", 
  {          
      0.0, 0,  1, 
      0.3, 0,  1.2       
  });

  ObjAnimate( "spr_bookcabinet_book_"..number , "scale_y", 0, 0, func_after, 
  {          
      0.0, 0,  1, 
      0.3, 0,  1.2  
  });

  ObjAnimate( "spr_bookcabinet_book_"..number , "pos_z", 0, 0, "", 
  {          
      0.0, 0,  ObjGet("spr_bookcabinet_book_"..number).pos_z, 
      0.3, 0,  51     
  });  

end;
------------------------------------------------------------------------------------------
function private.Book_Move_1( first_book, number )

  local first_book_pos_x = ObjGet( "spr_bookcabinet_book_"..first_book ).pos_x

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_books_move", 0, "", 0 );

  ObjAnimate( "spr_bookcabinet_book_"..first_book , "pos_x", 0, 0, "", 
  {          
      0.0, 0,  ObjGet( "spr_bookcabinet_book_"..first_book ).pos_x, 
      0.3, 0,  ObjGet( "spr_bookcabinet_book_"..number ).pos_x      
  }); 

  ObjAnimate( "spr_bookcabinet_book_"..number , "pos_x", 0, 0, "", 
  {          
      0.0, 0,  ObjGet( "spr_bookcabinet_book_"..number ).pos_x, 
      0.3, 0,  first_book_pos_x  
  }); 


  local place_1, place_2;

  for i = 1, 6 do

    if private.book_cond[i] == first_book then 

      place_1 = i; 

    end;

    if private.book_cond[i] == number then 

      place_2 = i;

    end;

  end;

  cup = private.book_cond[ place_1 ];
  
  private.book_cond[ place_1 ]= private.book_cond[ place_2 ];

  private.book_cond[ place_2 ]= cup;

  local func_after = function()

    private.Book_Move_2();

  end;

  ObjAnimate( "spr_bookcabinet_book_"..first_book , "scale_x", 0, 0, "", 
  {          
      0.0, 0,  1.2, 
      0.3, 0,  1       
  });

  ObjAnimate( "spr_bookcabinet_book_"..first_book , "scale_y", 0, 0, "", 
  {          
      0.0, 0,  1.2, 
      0.3, 0,  1      
  }); 

  ObjAnimate( "spr_bookcabinet_book_"..first_book , "pos_z", 0, 0, "", 
  {          
      0.0, 0,  ObjGet( "spr_bookcabinet_book_"..first_book ).pos_z, 
      0.3, 0,  0     
  }); 

  ObjAnimate( "spr_bookcabinet_book_"..number , "scale_x", 0, 0, "", 
  {          
      0.0, 0,  1.2, 
      0.3, 0,  1       
  });

  ObjAnimate( "spr_bookcabinet_book_"..number , "scale_y", 0, 0, "", 
  {          
      0.0, 0,  1.2, 
      0.3, 0,  1      
  }); 

  ObjAnimate( "spr_bookcabinet_book_"..number , "pos_z", 0, 0, func_after, 
  {          
      0.0, 0,  ObjGet( "spr_bookcabinet_book_"..number ).pos_z, 
      0.3, 0,  0     
  });

end;
------------------------------------------------------------------------------------------
function private.Book_Move_2()

  if ( private.CheckWin() ) then

    private.Book_Win_Anim();

  else 

    common_impl.Lock( false);
    ng_global.progress["std"]["win_bookcabinet"].book_cond = private.book_cond;
    ng_global.progress["std"]["win_bookcabinet"].book_get = 0;

  end;
 
end;
------------------------------------------------------------------------------------------
function private.CheckWin()

  local win = true;
  for i = 1, 6 do

    if ( private.book_cond[i] ~= private.win[i]) then

      win = false;

    end;

  end;

  return win;

end;
------------------------------------------------------------------------------------------
function private.Book_Win_Anim()

  local func_after = function()

    private.Book_Win();
    common_impl.Lock( false );

  end;

  common_impl.Lock( true ); 

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_books_win", 0, "", 0 );  

  ObjAnimate( "obj_bookcabinet_mmg", "alp", 0, 0, func_after,
  { 
    0.0, 0, 1,
    0.3, 0, 0
  } );

  ObjAnimate( "obj_bookcabinet_shalf", "alp", 0, 0, "",
  { 
    0.0, 0, 1,
    0.3, 0, 0
  } );

  ObjAnimate( "spr_bookcabinet_over", "alp", 0, 0, "",
  { 
    0.0, 0, 1,
    0.3, 0, 0
  } );

  ObjAnimate( "spr_bookcabinet_over_shadow", "alp", 0, 0, "",
  { 
    0.0, 0, 1,
    0.3, 0, 0
  } );

end;
------------------------------------------------------------------------------------------
function private.Book_Win()

  common_impl.Lock( false );
  cmn.MiniGameHide( "bookcabinet" );
  cmn.SetEventDone( "win_bookcabinet" );
  cmn.CallEventHandler( "win_bookcabinet" );
  common_impl.PassingMgWin( "bookcabinet" );
  
end;
------------------------------------------------------------------------------------------
function public.Skip( event )

  local mg_name = common.GetCurrentSubRoom();
  
  if ( mg_name == "zz_bookcabinet" ) then

    for i = 1, 6  do
      
      local j = private.win[i];

      ObjSet( "spr_bookcabinet_book_"..j , { pos_x = private.coord_x[i] });   

    end;

    if ng_global.progress["std"]["win_bookcabinet"].book_get ~= 0 then

      book_get = ng_global.progress["std"]["win_bookcabinet"].book_get;
      ObjSet( "spr_bookcabinet_book_"..book_get,{ scale_x = 1, scale_y = 1 });

    end;

    local func_after = function()

      private.Book_Win_Anim();

    end;

    common_impl.Lock( true );
    ObjAnimate( "obj_bookcabinet_mmg", "alp", 0, 0, func_after, 
    { 
      0.0, 0, 1,
      0.8, 0, 1
    } );

  elseif ( event == "win_evidence_3_3" ) then

    private.WinEvidenceMmg();

  end;

end;
-----------------------------------------------------------------------------------
function public.Reset( event )

  local mg_name = common.GetCurrentSubRoom();
  
  if ( mg_name == "zz_bookcabinet" ) then

    for i = 1, 6  do

      ObjSet("spr_bookcabinet_book_"..i,{ pos_x = private.reset_x[i], alp = 1, input = true });

    end;

    if ng_global.progress["std"]["win_bookcabinet"].book_get ~= 0 then

      book_get = ng_global.progress["std"]["win_bookcabinet"].book_get;
      ObjSet( "spr_bookcabinet_book_"..book_get , { scale_x = 1, scale_y = 1, pos_z = 0; });

    end;

    private.book_cond = { 1, 3, 2, 5, 6, 4 };
    private.book_get = 0; 
    ng_global.progress["std"]["win_bookcabinet"].book_cond = private.book_cond;
    ng_global.progress["std"]["win_bookcabinet"].book_get = private.book_get; 

  elseif ( event == "win_evidence_3_3" ) then

    local table_multiset = {};


    private.evidence_mmg_state = { { 5, 1, 7 },
                                   { 2, 4, 8 },
                                   { 6, 3, 0 } };

    ng_global.progress[ "std" ] [ "win_evidence_3_3" ].state = { { 5, 1, 7 },
                                                               { 2, 4, 8 },
                                                               { 6, 3, 0 } };
    for i = 1, 3 do

      for j = 1, 3 do

      table.insert( table_multiset, { "spr_evidence_evidence_3_3_box_part_"..private.evidence_mmg_state[i][j], { pos_x = private.evidence_mmg_coords[i][j][1], pos_y = private.evidence_mmg_coords[i][j][2] } } );
  
      end;

    end
      
    ObjMultiSet( table_multiset );

  end;

end;
--*********************************************************************************************************************
function private.AnimationPartlock()

  local func_after = function ()

    common_impl.Lock(false);

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_very_small_metall", 0, "", 0 );

  ObjAnimate( "spr_window_partlock", "pos_xy",0, 0, func_after,
             { 0.0,0, 156, 121, 
               0.3,0, 153, 122,
               0.6,0, 156, 121,
            } ) ; 
end;
--*********************************************************************************************************************