-- name=rm_fork_3
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_fork_3";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_waterside", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_waterside_fullhat",    { event_mdown = private.get_fullhat             }},
    { "spr_waterside_stick",      { event_mdown = private.get_stick               }},

    { "obj_vid_fork_3_gathering", { event_mdown = private.vid_fork_3_gathering    }},
    { "obj_dlg_fork_3_mary",      { event_mdown = private.dlg_fork_3_mary         }},
    { "obj_dlg_fork_3_mary_focus",{ event_mdown = private.dlg_fork_3_mary         }},
    { "obj_dlg_fork_3_ending",    { event_mdown = private.dlg_fork_3_ending         }},
    { "obj_dlg_fork_3_ending_focus", { event_mdown = private.dlg_fork_3_ending         }},
    { "spr_waterside_metal_note",    { event_mdown = function() common_impl.NoteScale( 'open', 'spr_waterside_metal_note' ); common_impl.ShowBbt( 'bbt_shore_metal_note', 1 ); end } },
    { "spr_waterside_metal_note_big",{ event_mdown = function() common_impl.NoteScale( 'close','spr_waterside_metal_note' ); end } },
    { "spr_pointer_3_coin", { event_mdown = private.get_coin1 } },
    { "spr_pickuptruck_3_coin", { event_mdown = private.get_coin2 } },
    { "spr_waterside_coin", { event_mdown = private.get_coin3 } },
    { "spr_fork_3_handcuffs_1", { event_mdown = function() private.ClkHandcuffs( 1 ); end  } },
    { "spr_fork_3_handcuffs_2", { event_mdown = function() private.ClkHandcuffs( 2 ); end  } },
    { "obj_fork_3_handcuffs", { event_startdrag = private.StartDragHandcuffs, event_dragdrop = private.DropHandcuffs  } },
    { "obj_fork_3_ending_clk_bag", { event_mdown =  private.OpenDialBag  } },
    { "spr_fork_3_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_2" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },

  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_fork_3 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_fork_3_pickuptruck_3",
    "gzz_fork_3_pointer_3",
    "gzz_fork_3_waterside"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_waterside", 
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_fork_3", update_game_mode_fork_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_fork_3 = function ()

  local effects_table = 
  {
    "obj_fork_3_anims",
    "anm_fork_3_mary_big",
    "obj_waterside_anims",
    "anm_waterside_crows_static",
    "vid_waterside_water",
    "anm_fork_3_policeman",
    "anm_fork_3_mary_loc",
    "anm_fork_3_citizens",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_fork_3", update_performance_mode_fork_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_fork_3 () end;
  --------------------------------------------------------------------------------------------
  local opn_fork_3_map = function ()

    common_impl.VisitMapRoom( "fork" );

  end;
  cmn.AddSubscriber( "opn_fork_3", opn_fork_3_map );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_2 = function ()
  
    ObjDelete( "obj_fork_3_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_2", get_collect_morph_item_1_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_hos () end;
  --------------------------------------------------------------------------------------------
  local win_hos_loc = function ()

    if port.isPortable() == 1 then
        port.GrmEventLightOff("grm_fork_3_nightsvilleentrance_3_focus");
    end;

    ObjDelete( "spr_fork_3_bush_2" );    
    ObjDelete( "grm_fork_3_nightsvilleentrance_3" );
    ObjDelete( "obj_waterside_chest" );
    ObjDelete( "anm_fork_3_shore_open" ); 
    ObjMultiSet( { 
      { "spr_fork_3_smoke", { visible = true } },
      { "spr_fork_3_smoke_1", { visible = true } },
      { "spr_fork_3_fire", { visible = true } },
      { "spr_fork_3_fire_1", { visible = true } },
      { "obj_fork_3_mary_big", { visible = true } },
      { "anm_fork_3_citizens", { visible = true } },
      { "anm_fork_3_policeman", { visible = true } },
      { "obj_waterside_use_elf_11", { input = true } },
      { "spr_waterside_log", { visible = true } },
      { "spr_waterside_stick", { visible = true } },
      { "obj_waterside_birds", { visible = true } },
      { "gzz_fork_3_waterside", { input = true, active = true } },
      { "obj_vid_fork_3_gathering", { input = true } } } );

  end;
 cmn.AddSubscriber( "win_hos", win_hos_loc, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coins () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_1 = function ()
 
    ObjDelete( "obj_pointer_3_coin" );
    ObjDelete( "gzz_fork_3_pointer_3" );
    
  end;
  cmn.AddSubscriber( "get_coin_1", get_collect_coin_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  local get_collect_coin_2 = function ()

    ObjDelete( "obj_pickuptruck_3_coin" );
    ObjDelete( "gzz_fork_3_pickuptruck_3" );
 
  end;
  cmn.AddSubscriber( "get_coin_2", get_collect_coin_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  local get_collect_coin_3 = function ()

    ObjDelete( "obj_waterside_coin" );

    if ( cmn.IsEventDone( "get_fullhat" )    and 
         cmn.IsEventDone( "get_stick"  ))    then

      ObjDelete( "gzz_fork_3_waterside" );

    end;
    if ( not cmn.IsEventDone( "win_hos" ) ) then
      ObjSet( "gzz_fork_3_waterside", { input = false, visible = false } )
    end;

  end;
  cmn.AddSubscriber( "get_coin_3", get_collect_coin_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fullhat () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fullhat" ] = {
    type = "get",
    get_obj = "spr_waterside_fullhat",
    room = private.room_objname,
    zz = "zz_waterside",
    zz_gate = "gzz_fork_3_waterside"
  };
    
  local get_fullhat_inv = function ()
  
    interface.InventoryItemAdd( "inv_fullhat", "spr_waterside_fullhat" );
  
  end;
  
  local get_fullhat_closezz = function ()
  
    ObjDelete( "gfx_waterside_fullhat" );
    ObjDelete( "vid_waterside_hat" );

    if ( cmn.IsEventDone( "get_coin_3" )    and 
         cmn.IsEventDone( "get_stick"  ))    then

      ObjDelete( "gzz_fork_3_waterside" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_fullhat", get_fullhat_inv );
  cmn.AddSubscriber( "get_fullhat", get_fullhat_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stick () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stick" ] = {
    type = "get",
    get_obj = "spr_waterside_stick",
    room = private.room_objname,
    zz = "zz_waterside",
    zz_gate = "gzz_fork_3_waterside"
  };
    
  local get_stick_inv = function ()
  
    interface.InventoryItemAdd( "inv_stick", "spr_waterside_stick" );
  
  end;
  
  local get_stick_closezz = function ()
  
    ObjDelete( "gfx_waterside_stick" );

    if ( cmn.IsEventDone( "get_fullhat" )    and 
         cmn.IsEventDone( "get_coin_3"  ))    then

      ObjDelete( "gzz_fork_3_waterside" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_stick", get_stick_inv );
  cmn.AddSubscriber( "get_stick", get_stick_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_11 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_11" ] = {
    type = "use",
    inv_obj = "inv_elf_3",
    use_place = "obj_waterside_use_elf_11",
    room = private.room_objname,
    zz = "zz_waterside",
    zz_gate = "gzz_fork_3_waterside"
  };
  local use_elf_11_inv = function ()
  
    --interface.InventoryItemRemove( "inv_elf_3" );
  
  end;
  local use_elf_11_beg = function ()
  
    ObjDelete( "obj_waterside_use_elf_11" );
  
  end;
  local use_elf_11_end = function ()
  
    ObjDelete( "obj_waterside_birds" );
    ObjDelete( "vid_waterside_use_elf_11" );

    ObjMultiSet({ 
      { "obj_waterside_use_hat",            { active = true, input = true }},
      { "obj_waterside_use_workingfuelsaw", { active = true, input = true }}
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_11", use_elf_11_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_11", use_elf_11_inv );
  cmn.AddSubscriber( "use_elf_11", use_elf_11_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_11_inv", use_elf_11_inv, private.room_objname );
  cmn.AddSubscriber( "use_elf_11_beg", use_elf_11_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_11_end", use_elf_11_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hat () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hat" ] = {
    type = "use",
    inv_obj = "inv_hat",
    use_place = "obj_waterside_use_hat",
    room = private.room_objname,
    zz = "zz_waterside",
    zz_gate = "gzz_fork_3_waterside"
  };
  local use_hat_inv = function ()
  
    interface.InventoryItemRemove( "inv_hat" );
  
  end;
  local use_hat_beg = function ()
  
    ObjDelete( "obj_waterside_use_hat" );
  
  end;
  local use_hat_end = function ()

    ObjDelete( "spr_waterside_over_water" );
    ObjSet( "spr_waterside_fullhat", { alp = 1, active = true, input = true});

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hat", use_hat_beg, private.room_objname );
  cmn.AddSubscriber( "use_hat", use_hat_inv );
  cmn.AddSubscriber( "use_hat", use_hat_end, private.room_objname );
  cmn.AddSubscriber( "use_hat_inv", use_hat_inv, private.room_objname );
  cmn.AddSubscriber( "use_hat_beg", use_hat_beg, private.room_objname );
  cmn.AddSubscriber( "use_hat_end", use_hat_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_workingfuelsaw () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_workingfuelsaw" ] = {
    type = "use",
    inv_obj = "inv_workingfuelsaw",
    use_place = "obj_waterside_use_workingfuelsaw",
    room = private.room_objname,
    zz = "zz_waterside",
    zz_gate = "gzz_fork_3_waterside"
  };
  local use_workingfuelsaw_inv = function ()
  
    interface.InventoryItemRemove( "inv_workingfuelsaw" );
  
  end;
  local use_workingfuelsaw_beg = function ()
  
    ObjDelete( "obj_waterside_use_workingfuelsaw" );
  
  end;
  local use_workingfuelsaw_end = function ()
  
    ObjSet( "spr_waterside_stick", { active = true, input = true, ang = -0.68, pos_x = 82, pos_y = -45, alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_workingfuelsaw", use_workingfuelsaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_workingfuelsaw", use_workingfuelsaw_inv );
  cmn.AddSubscriber( "use_workingfuelsaw", use_workingfuelsaw_end, private.room_objname );
  cmn.AddSubscriber( "use_workingfuelsaw_inv", use_workingfuelsaw_inv, private.room_objname );
  cmn.AddSubscriber( "use_workingfuelsaw_beg", use_workingfuelsaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_workingfuelsaw_end", use_workingfuelsaw_end, private.room_objname );

 --------------------------------------------------------------------------------------------
  -- function vid_fork_3_gathering () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_fork_3_gathering" ] = {

      type = "click",
      use_place = "obj_vid_fork_3_gathering",
      room = private.room_objname
  };
  local vid_fork_3_gathering_beg = function ()

    ObjDelete( "obj_vid_fork_3_gathering" );

  end;
  local vid_fork_3_gathering_end = function ()

    ObjSet( "obj_dlg_fork_3_mary", { active = true, input = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_fork_3_gathering", vid_fork_3_gathering_beg, private.room_objname );
  cmn.AddSubscriber( "vid_fork_3_gathering", vid_fork_3_gathering_end, private.room_objname  );
  cmn.AddSubscriber( "vid_fork_3_gathering_beg", vid_fork_3_gathering_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_fork_3_gathering_end", vid_fork_3_gathering_end, private.room_objname  );
  --------------------------------------------------------------------------------------------

  --------------------------------------------------------------------------------------------
  -- function vid_fork_3_autro () end;
  --------------------------------------------------------------------------------------------
  local vid_fork_3_autro_beg = function ()

  end;
  local vid_fork_3_autro_end = function ()  

    ObjDelete( "anm_fork_3_citizens" );
    ObjDelete( "spr_fork_3_mary_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_fork_3_autro", vid_fork_3_autro_beg, private.room_objname );
  cmn.AddSubscriber( "vid_fork_3_autro", vid_fork_3_autro_end, private.room_objname  );
  cmn.AddSubscriber( "vid_fork_3_autro_beg", vid_fork_3_autro_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_fork_3_autro_end", vid_fork_3_autro_end, private.room_objname  );
  --------------------------------------------------------------------------------------------

  --------------------------------------------------------------------------------------------
  -- function dlg_fork_3_mary () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_fork_3_mary" ] = {

      type = "click",
      use_place = "obj_dlg_fork_3_mary_focus",
      room = private.room_objname
  };

  local dlg_fork_3_mary_beg = function ()

    ObjDelete( "obj_fork_3_mary_big" );

  end;
  local dlg_fork_3_mary_end = function ()

    ObjSet( "anm_fork_3_mary_loc", { alp = 1 } );
    ObjSet( "obj_dlg_fork_3_ending_bbt", { input = true } );

    ObjDelete( "obj_dlg_fork_3_mary" );
    ObjDelete( "anm_fork_3_mary_walk" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_fork_3_mary", dlg_fork_3_mary_beg, private.room_objname  );
  cmn.AddSubscriber( "dlg_fork_3_mary", dlg_fork_3_mary_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_fork_3_mary_beg", dlg_fork_3_mary_beg, private.room_objname  );
  cmn.AddSubscriber( "dlg_fork_3_mary_end", dlg_fork_3_mary_end, private.room_objname  );
   --------------------------------------------------------------------------------------------
  -- function dlg_fork_3_ending() end;
  --------------------------------------------------------------------------------------------
  local dlg_secretroom_oliver = function ()

    ObjSet( "obj_dlg_fork_3_ending", { input = true } );
    ObjDelete( "obj_dlg_fork_3_ending_bbt" );
    
  end;

  cmn.AddSubscriber( "dlg_secretroom_oliver", dlg_secretroom_oliver, private.room_objname  );
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_fork_3_ending" ] = {

      type = "click",
      use_place = "obj_dlg_fork_3_ending_focus",
      room = private.room_objname
  };

  local dlg_fork_3_ending_end = function ()

    ObjDelete( "obj_dlg_fork_3_ending" );
    ObjDelete( "anm_fork_3_policeman" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_fork_3_ending", dlg_fork_3_ending_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_fork_3_ending_end", dlg_fork_3_ending_end, private.room_objname  );

  -------------------------------------------------------------------------------------------
  -- function vid_evidence_7 () end;
  --------------------------------------------------------------------------------------------
  local vid_evidence_7 = function ()

    ObjSet( "obj_dlg_fork_3_ending", { input = true } );

  end;   

  cmn.AddSubscriber( "vid_evidence_7", vid_evidence_7, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  common_impl.hint.position_slider[ "gzz_fork_3_waterside" ] = { "right" };

  subroom.Define( "zz_waterside" );

  function zz_waterside.PreOpen()

    common_impl.fork_3 = {}
    common_impl.fork_3.note = "close";

    if not cmn.IsEventDone( "use_elf_11" ) then

      common_impl.PlayAudio( "sfx", "common/audio/aud_crows_env", 1, "", 0 );

    end;
    
  end;

  function zz_waterside.PreClose()

    common_impl.fork_3 = {}
    common_impl.fork_3.note = "close";
    common_impl.StopAudio( "sfx", "common/audio/aud_crows_env", 0.5 );
        
  end;
  function zz_waterside.Close()

    common_impl.fork_3.note = "close";
    ObjSet( "spr_waterside_metal_note_big", { input = 0, alp = 0 } );
    ObjSet( "spr_waterside_metal_note", { alp = 1 } );

  end;
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_fork_3();
  
  int_providence_eye.CheckShow();

  if ( cmn.IsEventDone( "win_hos" ) and not cmn.IsEventDone( "vid_fork_3_gathering" ) ) then
    common_impl.PlayTimer( private.vid_fork_3_gathering );
  end;

  if ( cmn.IsEventDone( "win_hos" ) and cmn.IsEventDone( "dlg_fork_3_ending" ) ) then
      private.vid_fork_3_autro();
  end;

  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.MorphItemMorphing();
  interface.InvestigationButtonCheck();

  common_impl.EnvPlay( { "common/audio/aud_fork_env" }, "", 0.5 );  

end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;

--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_elf_11()

  local item = "inv_elf_3";

  if ( common.ApplyObj( item, "obj_waterside_use_elf_11", true ) ) and common_impl.fork_3.note == "close" then

    cmn.CallEventHandler( "use_elf_11_inv" );
    cmn.CallEventHandler( "use_elf_11_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_elf_11" );
      cmn.CallEventHandler( "use_elf_11_end" );
      ObjSet( "spr_waterside_elf_11", { alp = 1 } );
      interface.InventoryItemAdd( "inv_elf_3", "spr_waterside_elf_11" );

    end;

  common_impl.Lock( true );

  common_impl.StopAudio( "env", "common/audio/aud_crows_env", 0.5 );
  
  ObjAnimate( "obj_waterside_birds", "alp", 0, 0, "",
  { 

    0.0, 0, 1.0, 
    0.3, 0, 0.0

  } );

  interface.InventoryItemRemove( "inv_elf_3" );

  common_impl.PlayAudio( "sfx", "common/audio/aud_waterside_elf", 0, "", 0 );

  ObjSet( "vid_waterside_use_elf_11", { active = true, alp = 1, playing = true, endtrig = func_after } );

  return true;
  
  elseif common.ApplyObj( item, "gzz_fork_3_waterside", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_waterside", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hat()

  local item = "inv_hat";

  if ( common.ApplyObj( item, "obj_waterside_use_hat", true ) and cmn.IsEventDone( "use_elf_11" )) and common_impl.fork_3.note == "close" then

    cmn.CallEventHandler( "use_hat_inv" );
    cmn.CallEventHandler( "use_hat_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_hat" );
      cmn.CallEventHandler( "use_hat_end" );
      private.get_fullhat();
    
    end;

    common_impl.Lock( true );
    
    ObjSet( "vid_waterside_hat", { active = true, alp = 1 });
    VidPlay( "vid_waterside_hat", func_after );
    ObjAnimate( "spr_waterside_over_water", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      2.3, 0, 1.0, 
      2.6, 0, 0.0
    } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_hat", 0, "", 0 );

    return true;

  elseif common.ApplyObj( item, "gzz_fork_3_waterside", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_waterside", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_workingfuelsaw()

  local item = "inv_workingfuelsaw";

  if ( common.ApplyObj( item, "obj_waterside_use_workingfuelsaw", true ) and cmn.IsEventDone( "use_elf_11" )) and common_impl.fork_3.note == "close" then

    cmn.CallEventHandler( "use_workingfuelsaw_inv" );
    cmn.CallEventHandler( "use_workingfuelsaw_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_workingfuelsaw" );
      cmn.CallEventHandler( "use_workingfuelsaw_end" );
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_use_chainsaw", 0, "", 0 );
  ObjSet( "vid_waterside_worksaw", { active = true, alp = 1 });
  ObjSet( "spr_waterside_stick", { alp = 0 });
  VidPlay( "vid_waterside_worksaw", func_after );

  ObjSet( "tmr_waterside_anim", { playing = true, time = 3.6, endtrig = "ObjSet( 'spr_waterside_stick', { active = true, alp = 1, ang = -0.68, pos_x = 82, pos_y = -45 });" });

  return true;
  
  elseif common.ApplyObj( item, "gzz_fork_3_waterside", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_waterside", nil, { 512, 384 } );

  return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
function private.get_coin1()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_1");
    cmn.CallEventHandler("get_coin_1");
    common.CloseSubRoom();

  end;

  common_impl.PlayEffectHO( "spr_pointer_3_coin", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_coin2()

  local func_after = function ()

    common_impl.GetCoinDone("get_coin_2");
    cmn.CallEventHandler("get_coin_2");
    common.CloseSubRoom();

  end;

  common_impl.PlayEffectHO( "spr_pickuptruck_3_coin", func_after );
  
end;
--------------------------------------------------------------------------------------------
function private.get_coin3()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_3" );
    cmn.CallEventHandler( "get_coin_3" );

    if ( cmn.IsEventDone( "get_fullhat" )    and 
         cmn.IsEventDone( "get_stick"  ))    then
      common.CloseSubRoom();
    end;

  end;
    
  common_impl.PlayEffectHO( "spr_waterside_coin", func_after );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.get_fullhat()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_fullhat" );
  cmn.CallEventHandler( "get_fullhat" );

  if ( cmn.IsEventDone( "get_coin_3" )   and 
       cmn.IsEventDone( "get_stick"  ))   then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_stick()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_stick" );
  cmn.CallEventHandler( "get_stick" );

  if ( cmn.IsEventDone( "get_fullhat" )   and 
       cmn.IsEventDone( "get_coin_3"  ))   then
    common.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_fork_3()

  if not ( cmn.IsEventDone( "opn_fork_3" ) ) then
    cmn.SetEventDone( "opn_fork_3" );
  end;
  
  cmn.CallEventHandler( "opn_fork_3" ); 

end;
-----------------------------------------------------------------------------------------------------------------------

function private.vid_fork_3_gathering()

  cmn.CallEventHandler( "vid_fork_3_gathering_beg" );
  ObjSet( "vid_fork_3_gathering", { alp = 1, active = true, input = false, visible = true } );
  
  local func_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_fork_3_gathering" );
    cmn.CallEventHandler( "vid_fork_3_gathering_end" );
    common_impl.ShowBbt( 'bbt_vid_fork_3_gathering', 1 );
    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment2_mus", 0, "", 0 );

    if skip then
  
      common_impl.StopAudio( "sfx", "common/audio/aud_fork_3_gathering", 0.5 );
      common_impl.StopAudio( "voc", "common/audio/aud_fork_3_gathering_voc", 0.5 );

    end;

  end;

  common_impl.StopTimer();

  common_impl.StopAllMus();
  common_impl.PlayAudio( "sfx", "common/audio/aud_fork_3_gathering", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/aud_fork_3_gathering_voc", 0, "", 0 );
  interface.DialogVideoShow( "vid_fork_3_gathering", 1, function() func_after ( 'skip' ); end, 3 );
  VidPlay( "vid_fork_3_gathering", function() func_after ( nil ); end ); 
 
end;
--------------------------------------------------------------------------------------------
function private.vid_fork_3_autro()

  cmn.CallEventHandler( "vid_fork_3_autro_beg" );
  ObjSet( "vid_fork_3_autro", { alp = 1, active = true, input = false, visible = true } );
  
  local func_after = function ( skip )

    iOS_RegisterGameplay("level_4"); 
  
    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_fork_3_autro" );
    cmn.CallEventHandler( "vid_fork_3_autro_end" );
  
      
  
    common.GotoRoom( "rm_credits" );

    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_fork_3_autro", 0.5 );
      common_impl.StopAudio( "voc", "common/audio/aud_fork_3_autro_voc", 0.5 );

    end;

  end;

  common_impl.StopAllMus();
  interface.DialogVideoShow( "vid_fork_3_autro", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_fork_3_autro", function() func_after( nil ); end ); 
  common_impl.PlayAudio( "sfx", "common/audio/aud_fork_3_autro", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/aud_fork_3_autro_voc", 0, "", 0 );
  
end;
--------------------------------------------------------------------------------------------
function private.dlg_fork_3_mary()

  cmn.CallEventHandler( "dlg_fork_3_mary_beg" );

  ObjAttach( "dlg_fork_3_mary", private.room_objname );
  common_impl.continue_visible = false; 
  common_impl.dialog_character_loc = "obj_fork_3_mary_big";
  common_impl.DialogCharacterStart( "mary", 5, nil, nil, true, "dlg_fork_3_mary_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_fork_3_mary_end()

  local func_after = function ()

    common_impl.Lock( false );
  
    cmn.SetEventDone( "dlg_fork_3_mary" );
    cmn.CallEventHandler( "dlg_fork_3_mary_end" );

    int_investigation_button.Show( true );
    interface.KeyTaskAdd( 'examine_home' );

  end;

  common_impl.Lock( true );

  ObjSet( "anm_fork_3_mary_walk", { alp = 1 } );
  AnimPlay( "anm_fork_3_mary_walk", "DoAnim", func_after )
  common_impl.PlayAudio( "sfx", "common/audio/aud_mary_go_away", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.dlg_fork_3_ending()

  ObjAttach( "dlg_fork_3_ending", private.room_objname );
  common_impl.continue_visible = true;
  common_impl.DialogCharacterStart( "ending", 7, nil, nil, true, "dlg_fork_3_ending_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_fork_3_ending_end()

  cmn.SetEventDone( "dlg_fork_3_ending" );
  cmn.CallEventHandler( "dlg_fork_3_ending_end" );

  private.vid_fork_3_autro();

  int_investigation_button.ChangeInvestigation();

end;
--*********************************************************************************************************************
function private.StartDragHandcuffs()

  local new_coords = GetGameCursorPos();
  local old_coords = ObjGet( "obj_fork_3_handcuffs" );
  
  ObjAnimate( "obj_fork_3_handcuffs", "pos_xy", 0, 0, "", { 0,0,old_coords.pos_x,old_coords.pos_y, 0.2,0,( new_coords[1] + 250 ),new_coords[2] } );
  ObjAnimate( "obj_fork_3_handcuffs", "scale_xy", 0, 0, "", { 0,0,1,1, 0.2,0,0.5,0.5 } );

  common_impl.DialogCharacterChangeCharacters( "ending", nil, "sheriff"  );
  ObjSet( "obj_fork_3_ending_sheriff", { pos_y = -26 } );

end;
--*********************************************************************************************************************
function private.DropHandcuffs()

  if ObjIntersect( "obj_fork_3_handcuffs", "obj_fork_3_use_handcuffs" ) then

    ObjSet( "obj_fork_3_handcuffs", { alp = 0 } );

    common_impl.DialogCharacterHide();
  
  end;  

end;
--*********************************************************************************************************************
function private.ClkHandcuffs( number )

  local func_after = function()

    common_impl.Lock( false );

    ObjSet( "spr_fork_3_handcuffs_"..number, { input = false }  );

    if ObjGet( "spr_fork_3_handcuffs_"..( 3 - number ) ).input == false then

      local func_after_2 = function()

        common_impl.Lock( false );

        ObjSet( "obj_fork_3_handcuffs", { drag = true, event_menter = function() common_impl.SetCursor( CURSOR_GET ); end,
                                                       event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ); end  } );

        ObjSet( "obj_fork_3_use_handcuffs", { input = true } );

      end;

      common_impl.Lock( true );
      
      ObjAnimate( "rm_fork_3", "scale_xy", 0, 0, func_after_2, { 0,0,1,1, 1.4,0,1.3,1.3, 2.0,0,1.3,1.3, 3.0,1.4,1,1,  } );
      ObjAnimate( "rm_fork_3", "pos_xy", 0, 0, "", { 0,0,0,0, 1.4,0,-150,-240, 2.0,0,-150,-240, 3.0,1.4,0,0, } );

    end;

  end;

  local ang = { -1.65, 2.28 };
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_handcuffs_open", 0, "", 0 );

  ObjAnimate( "spr_fork_3_handcuffs_"..number, "ang", 0, 0, func_after, { 0,0,0, 0.3,0,ang[number] } );

end;
--*********************************************************************************************************************
function private.ClkClues( number )

  local sounds = { 'pager', 'paper', 'plan' };

  local func_after = function()

    common_impl.Lock( false );

    if number ~= 3 then

      ObjSet( "obj_fork_3_ending_clk_bag", { event_mdown = function() private.ClkClues( number + 1 ); end  } );

    else 

      ObjSet( "obj_fork_3_ending_clk_bag", { input = false  } );
      ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = private.HideEndingMmg } );   
     
  
    end;

  end;
  
  local obj = "spr_fork_3_ending_clue_"..number;

  if ObjGet( obj ) then

    common_impl.Lock( true );

    local func_middle = function()

     ObjSet( obj, { pos_z = number } );

     ObjAnimate( obj, "pos_xy", 0, 0, func_after, { 0.0,3,ObjGet( obj ).pos_x ,private.clues_coords[number][1],
                                                    0.4,3,private.clues_coords[number][2],private.clues_coords[number][3]  } );  

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_clues_"..sounds[number], 0, "", 0 );

    ObjAnimate( obj, "pos_xy", 0, 0, func_middle, { 0.0,3,ObjGet( obj ).pos_x, ObjGet( obj ).pos_y, 
                                                   0.4,3,ObjGet( obj ).pos_x ,private.clues_coords[number][1] } );  

  end;

end;
--*********************************************************************************************************************
function private.OpenDialBag()

  local func_after = function()

    common_impl.Lock( false );

    ObjSet( "obj_fork_3_ending_clk_bag", { event_mdown = function() private.ClkClues( 1 ); end  } );

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_clues_package", 0, "", 0 );

  ObjAnimate( "spr_fork_3_ending_bag_close", "alp", 0, 0, func_after, { 0,0,1, 0.3,0,0 } );
  ObjAnimate( "spr_fork_3_ending_bag_open",  "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );

end;
--*********************************************************************************************************************
function private.StartEndingMmg()

  local func_after = function()

    common_impl.Lock( false );
    ObjSet( "int_dialog_character_impl", { input = true } );

  end;

  common_impl.DialogCharacterMmgShow( "ending", 250, 0, nil  );
  
  common_impl.Lock( true );

  private.clues_coords = { { -396, 349, -22 }, { -522, 377, -16 }, { -547, 411, -6 } }; -- 1 pos_y up, 2 pos_x end, 3 pos_y end

  ObjAnimate( "obj_fork_3_ending_sheriff", "color_rgb", 0, 0, func_after, { 0,0,1,1,1, 0.3,0,0.5,0.5,0.5 } );
  ObjAnimate( "obj_fork_3_ending_sheriff", "scale_xy", 0, 0, "", { 0,0,1.05,1.05, 0.3,0,1,1 } );
  ObjAnimate( "obj_fork_3_ending_mother_with_oliver", "color_rgb", 0, 0, "", { 0,0,0.4,0.4,0.4, 0.3,0,0.5,0.5,0.5 } );
  ObjAnimate( "obj_fork_3_ending_mmg", "color_rgb", 0, 0, "", { 0,0,0.4,0.4,0.4, 0.3,0,1,1,1 } );
  ObjAnimate( "obj_int_dialog_character", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );

  ObjSet( "spr_fork_3_ending_sheriff_over", { alp = 0 } );

end;
--*********************************************************************************************************************
function private.StartEndingMmg2()

  local func_after = function()

    common_impl.Lock( false );

  end;

  common_impl.DialogCharacterMmgShow( "ending", 250, 0, nil, 2  );
  common_impl.DialogCharacterChangeCharacters( "ending", "mother_with_oliver", "sheriff"  );
  common_impl.StopAllVoc();
  common_impl.DialogCharacterStopAllVid();

  common_impl.Lock( true );

  ObjAnimate( "obj_fork_3_ending_sheriff", "color_rgb", 0, 0, func_after, { 0,0,0.4,0.4,0.4, 0.3,0,0.5,0.5,0.5 } );
  ObjAnimate( "obj_fork_3_ending_sheriff", "scale_xy", 0, 0, "", { 0,0,1,1, 0.3,0,1,1 } );
  ObjAnimate( "obj_fork_3_ending_mother_with_oliver", "color_rgb", 0, 0, "", { 0,0,1,1,1, 0.3,0,0.5,0.5,0.5 } );
  ObjAnimate( "obj_fork_3_ending_mmg_2", "color_rgb", 0, 0, "", { 0,0,0.4,0.4,0.4, 0.3,0,1,1,1 } );
  ObjAnimate( "obj_int_dialog_character", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );

  ObjSet( "spr_fork_3_ending_sheriff_over", { alp = 0 } );

end;
--*********************************************************************************************************************
function private.HideEndingMmg()

   common_impl.DialogCharacterMmgHide( "ending", nil );
   common_impl.DialogCharacterContinueClick( true );
   --ObjSet( "obj_int_dialog_character_input", { event_mdown = function() int_dialog_character.ContinueClick( false ) end } );
   ObjSet( "int_dialog_character_impl", { input = true } );
   ObjSet( "obj_int_dialog_character",{ alp = 1 } );

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if dlg_name == "mary" then

    if count_txt == 1 then 

      common_impl.continue_visible = false; 
      common_impl.frases = { 1 }; 
      common_impl.dial_icons = { 'fire' };
      common_impl.DialogCharacterShowDialogQuestions( 1, 2 ); 
    
    elseif count_txt == 2 then 

      common_impl.continue_visible = false; 
      common_impl.frases = { 2 }; 
      common_impl.dial_icons = { 'sheriff' };
      common_impl.DialogCharacterShowDialogQuestions( 1, 4 ); 
    
    elseif count_txt == 3 then 

      common_impl.continue_visible = true; 

    end;

  elseif dlg_name == "ending" then

    if count_txt == 1 then 
      
      common_impl.DialogCharacterChangeCharacters( "ending", nil , "mother_with_oliver" );
      common_impl.continue_visible = true; 
      ObjSet( "anm_fork_3_policeman", { alp = 0 } ); 

    elseif count_txt == 2 then 
     
      common_impl.DialogCharacterChangeCharacters( "ending", "mother_with_oliver" , "sheriff" );
      common_impl.continue_visible = false; 
      common_impl.frases = { 1, 3 }; 
      common_impl.dial_icons = { 'sheriff' };
      common_impl.DialogCharacterShowDialogQuestions( 1, 6 ); 

     elseif count_txt == 3 then 
     
      common_impl.continue_visible = false; 
      common_impl.frases = { 2, 10 }; 
      common_impl.dial_icons = { 'clues' };
      common_impl.DialogCharacterShowDialogQuestions( 1, 3 ); 

     elseif count_txt == 4 then

      common_impl.StopAllVoc();
      common_impl.DialogCharacterStopAllVid();
      private.StartEndingMmg();   
      ObjSet( "obj_int_dialog_character_input", { input = false } );  

    elseif count_txt == 5 then 

      common_impl.DialogCharacterChangeCharacters( "ending", "sheriff", "mother_with_oliver"  );
      common_impl.continue_visible = true; 
      ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = private.StartEndingMmg2 } );      

    end;
  
  end;  

end;
--*********************************************************************************************************************