-- name=rm_glade_3
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_glade_3";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_mailbox", "room_hub" );
  ObjAttach( "zz_trap", "room_hub" );
  
  ObjMultiSet({ 
    { "spr_trap_3_coin",             { event_mdown = private.get_coin12 } },
    { "spr_mailbox_3_coin",          { event_mdown = private.get_coin13 } },

    { "spr_glade_3_collect_item",    { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_2_1" );     end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_glade_3_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_2" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },

  });

  ObjAnimate( "spr_glade_3_treehouse_3_open_light", "alp", 1, 0, "", { 0, 0, 1,   3, 0, 0,   6, 0, 1 } );
  ObjAnimate( "spr_glade_3_house", "alp", 1, 0, "", { 0, 0, 1,   2.5, 0, 0,   5, 0, 1 } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_glade_3 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_glade_3_mailbox_3",
    "gzz_glade_3_trap_3"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_glade_3", update_game_mode_glade_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_glade_3 = function ()

  local effects_table = 
  {
    "obj_glade_3_anim",
    "anm_trap_3_treeshadow",
    "anm_trap_3_grass",
  }
  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_glade_3", update_performance_mode_glade_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_glade () end;
  --------------------------------------------------------------------------------------------
  local opn_glade_3_map = function ()

    common_impl.VisitMapRoom( "glade" );

  end;

  cmn.AddSubscriber( "opn_glade_3", opn_glade_3_map, nil );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_2_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_2_1 = function ()
  
    ObjDelete( "obj_glade_3_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_2_1", get_collect_item_2_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_2 = function ()
  
    ObjDelete( "obj_glade_3_morph" );
    ObjDelete( "spr_glade_3_morph_over" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_2", get_collect_morph_item_2_2, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_coins () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_12 = function ()
 
    ObjDelete( "obj_trap_3_coin" );
    ObjDelete( "gzz_glade_3_trap_3" );
  
  end;
  cmn.AddSubscriber( "get_coin_12", get_collect_coin_12, private.room_objname );
  --------------------------------------------------------------------------------------------
  local get_collect_coin_13 = function ()
 
    ObjDelete( "obj_mailbox_3_coin" ); 
    ObjDelete( "gzz_glade_3_mailbox_3" );

  end;
  cmn.AddSubscriber( "get_coin_13", get_collect_coin_13, private.room_objname );
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Open()

  private.opn_glade_3();
  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();  

  interface.InvestigationButtonCheck();

  common_impl.EnvPlay( { "common/audio/aud_glade_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_coin12()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_12");
    cmn.CallEventHandler("get_coin_12");
    common.CloseSubRoom();
   

  end;

  common_impl.PlayEffectHO( "spr_trap_3_coin", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_coin13()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_13");
    cmn.CallEventHandler("get_coin_13");
    common.CloseSubRoom();


  end;

  common_impl.PlayEffectHO( "spr_mailbox_3_coin", func_after ); 

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_glade_3()

  cmn.CallEventHandler( "opn_glade_3" );

end;
--*********************************************************************************************************************
  