-- name=rm_hallway
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_hallway";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_staging", "room_hub" );
  ObjAttach( "zz_wall", "room_hub" );
  ObjAttach( "zz_tent", "room_hub" );
  private.Init_Subroom();
  
  private.positions = { 0, 0 };
  private.str1= "";
  private.str2= "";

  ObjMultiSet({ 

    {"obj_hallway_hall_az",       { event_mdown = function() private.animHall();    end; }},
    {"obj_wall_use_tongs",        { event_mdown = function() private.animChisel();  common_impl.ShowBbt( 'bbt_wall_use_tongs' );         end; }},
    {"obj_wall_use_workingdrill", { event_mdown = function() private.animStone();   common_impl.ShowBbt( 'bbt_wall_use_workingdrill' );  end; }},
    {"obj_staging_use_chisel",    { event_mdown = function() private.animBoxDoor(); common_impl.ShowBbt( 'bbt_staging_use_chisel' );     end; }},

    { "spr_staging_tongs",                { event_mdown = private.get_tongs              }},
    { "spr_staging_bottle_substance_a",   { event_mdown = private.get_bottle_substance_a }},
    { "spr_staging_drillbit",             { event_mdown = private.get_drillbit           }},
    { "spr_staging_gluedbrush",           { event_mdown = private.get_gluedbrush         }},
    { "spr_wall_chisel",                  { event_mdown = private.get_chisel             }},
    { "spr_wall_stone",                   { event_mdown = private.get_stone              }},
    { "spr_wall_bottle_substance_v",      { event_mdown = private.get_bottle_substance_v }},
    { "spr_wall_statuepiece",             { event_mdown = private.get_statuepiece        }},

    { "spr_tent_hatchhandle",             { event_mdown = private.get_hatchhandle        }},
    { "spr_tent_book",                    { event_mdown = private.get_book               }},
    --
    { "obj_hallway_prv_item_1",   { event_mdown = function() int_providence.Thinking( "providence_1", "obj_hallway_prv_item_1" ) end }},

    { "spr_hallway_prv_cape",        { event_startdrag = private.drag_cape, event_dragdrop = private.drop_cape  }},
    { "obj_hallway_use_prv_item_1", { event_mdown = private.get_prv_curtainrope_silhouette }},
    { "obj_hallway_use_prv_item_2", { event_mdown = private.get_prv_flowerpot_silhouette }},
    --

    { "spr_tent_bolt_1_1", {  event_mdown = function() private.GetNumber( "1_1" ); end; }},
    { "spr_tent_bolt_2_1", {  event_mdown = function() private.GetNumber( "2_1" ); end; }},
    { "spr_tent_bolt_3_1", {  event_mdown = function() private.GetNumber( "3_1" ); end; }},
    { "spr_tent_bolt_4_1", {  event_mdown = function() private.GetNumber( "4_1" ); end; }},
    { "spr_tent_bolt_5_1", {  event_mdown = function() private.GetNumber( "5_1" ); end; }},

    { "spr_tent_bolt_1",   {  event_mdown = function() private.GetNumber( "1" ); end; }},
    { "spr_tent_bolt_2",   {  event_mdown = function() private.GetNumber( "2" ); end; }},
    { "spr_tent_bolt_3",   {  event_mdown = function() private.GetNumber( "3" ); end; }},
    { "spr_tent_bolt_4",   {  event_mdown = function() private.GetNumber( "4" ); end; }},
    { "spr_tent_bolt_5",   {  event_mdown = function() private.GetNumber( "5" ); end; }},

    { "spr_staging_coin",           { event_mdown = private.get_collect_coin_22 }},
    { "spr_wall_coin",              { event_mdown = private.get_collect_coin_23 }},
    { "spr_tent_coin",              { event_mdown = private.get_collect_coin_24 }},
    { "spr_hallway_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_3_2" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },


  });

  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_hallway = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gho_hallway_ladder",
    "gzz_hallway_staging",
    "gzz_hallway_wall",
    "gzz_hallway_tent"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_staging",
      "zz_wall",
      "zz_tent"
    
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_hallway", update_game_mode_hallway, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_hallway = function ()

  local effects_table = 
  {
    "obj_hallway_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_hallway", update_performance_mode_hallway, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_hallway () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_hallway" ] = {
    type = "click",
    use_place = "grm_mansion_hallway",
    room = "rm_mansion"
  };    

  local opn_hallway_map = function ()

    common_impl.VisitMapRoom( "hallway" );

    ObjSet( "obj_int_map_back_2_paper_2", { visible = true } );
    ObjDelete( "obj_map_screen_2_mine_1" );
    ObjDelete( "obj_map_screen_2_mine_2" );
    ObjDelete( "anm_map_screen_2_mine_1" );

  end;
  cmn.AddSubscriber( "opn_hallway", opn_hallway_map );

  local opn_hallway_winho = function ()

    if cmn.IsEventDone( "win_ladder" ) then

      ObjDelete( "gho_hallway_ladder" );

    end;

  end;
  cmn.AddSubscriber( "opn_hallway", opn_hallway_winho );
  cmn.AddSubscriber( "opn_hallway_winho", opn_hallway_winho );
  cmn.AddSubscriber( "opn_hallway", opn_hallway_map );
  cmn.AddSubscriber( "opn_hallway_map", opn_hallway_map );

  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_3_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_3_2 = function ()
  
    ObjDelete( "obj_hallway_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_3_2", get_collect_morph_item_3_2, private.room_objname );


 --------------------------------------------------------------------------------------------
  -- function get_prv_curtainrope_silhouette () end;
  --------------------------------------------------------------------------------------------
  local get_prv_curtainrope_silhouette_inv = function ()
  
    interface.ProvidePanelSilhouetteAdd( "inv_prv_curtainrope", "spr_hallway_prv_curtainrope_silhouette" );

  end;
  
  local get_prv_curtainrope_silhouette_closezz = function ()

    ObjSet( "spr_hallway_prv_curtainrope_silhouette", { alp = 1 } );    
    ObjSet( "obj_hallway_use_prv_item_1", { event_mdown = function() int_providence.Thinking( "providence_prv_item_1", "obj_hallway_use_prv_item_1" ) end } )

  end;

  local get_prv_curtainrope_silhouette_notadd = function ()

    ObjSet( "obj_hallway_use_prv_item_1", { event_mdown = function() int_providence.Thinking( "providence_prv_item_1", "obj_hallway_use_prv_item_1" ) end } )

  end;
  
  cmn.AddSubscriber( "get_prv_curtainrope_silhouette", get_prv_curtainrope_silhouette_inv );
  cmn.AddSubscriber( "get_prv_curtainrope_silhouette", get_prv_curtainrope_silhouette_closezz, private.room_objname );
  cmn.AddSubscriber( "get_prv_curtainrope", get_prv_curtainrope_silhouette_notadd, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function get_prv_flowerpot_silhouette () end;
  --------------------------------------------------------------------------------------------
  local get_prv_flowerpot_silhouette_inv = function ()
  
    interface.ProvidePanelSilhouetteAdd( "inv_prv_flowerpot", "spr_hallway_prv_flowerpot_silhouette" );

  end;
  
  local get_prv_flowerpot_silhouette_closezz = function ()

    ObjSet( "spr_hallway_prv_flowerpot_silhouette", { alp = 1 } );    
    ObjSet( "obj_hallway_use_prv_item_2", { event_mdown = function() int_providence.Thinking( "providence_prv_item_2", "obj_hallway_use_prv_item_2" ) end } )

  end;

  local get_prv_flowerpot_silhouette_notadd = function ()

    ObjSet( "obj_hallway_use_prv_item_2", { event_mdown = function() int_providence.Thinking( "providence_prv_item_2", "obj_hallway_use_prv_item_2" ) end } )

  end;
  
  cmn.AddSubscriber( "get_prv_flowerpot_silhouette", get_prv_flowerpot_silhouette_inv );
  cmn.AddSubscriber( "get_prv_flowerpot_silhouette", get_prv_flowerpot_silhouette_closezz, private.room_objname );
  cmn.AddSubscriber( "get_prv_flowerpot", get_prv_flowerpot_silhouette_notadd, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tongs () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tongs" ] = {
    type = "get",
    get_obj = "spr_staging_tongs",
    room = private.room_objname,
    zz = "zz_staging",
    zz_gate = "gzz_hallway_staging"
  };
    
  local get_tongs_inv = function ()
  
    interface.InventoryItemAdd( "inv_tongs", "spr_staging_tongs" );
  
  end;
  
  local get_tongs_closezz = function ()
  
    ObjDelete("spr_hallway_staging_inv_1");
    ObjDelete( "gfx_staging_tongs" );
    ObjDelete( "spr_staging_tongs_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_tongs", get_tongs_inv );
  cmn.AddSubscriber( "get_tongs", get_tongs_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bottle_substance_a () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bottle_substance_a" ] = {
    type = "get",
    get_obj = "spr_staging_bottle_substance_a",
    room = private.room_objname,
    zz = "zz_staging",
    zz_gate = "gzz_hallway_staging"
  };
    
  local get_bottle_substance_a_inv = function ()
  
    interface.InventoryItemAdd( "inv_bottle_substance_a", "spr_staging_bottle_substance_a" );
  
  end;
  
  local get_bottle_substance_a_closezz = function ()
  
    ObjDelete( "spr_hallway_staging_bottle_1" );

    ObjDelete( "gfx_staging_bottle_substance_a" );
    ObjDelete( "spr_staging_bottle_a_shadow" );
    --ObjDelete( "gzz_hallway_staging" );
  
  end;
  
  cmn.AddSubscriber( "get_bottle_substance_a", get_bottle_substance_a_inv );
  cmn.AddSubscriber( "get_bottle_substance_a", get_bottle_substance_a_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_drillbit () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_drillbit" ] = {
    type = "get",
    get_obj = "spr_staging_drillbit",
    room = private.room_objname,
    zz = "zz_staging",
    zz_gate = "gzz_hallway_staging"
  };
    
  local get_drillbit_inv = function ()
  
    interface.InventoryItemAdd( "inv_drillbit", "spr_staging_drillbit" );
    ObjSet( "spr_hammerdrill_plus_light", { alp = 1 } );
  
  end;
  
  local get_drillbit_closezz = function ()
  
    ObjDelete( "spr_hallway_staging_borer" );
    ObjDelete( "gfx_staging_drillbit" );
    ObjDelete( "spr_staging_drillbit_shadow" );
    --ObjDelete( "gzz_hallway_staging" );
  
  end;
  
  cmn.AddSubscriber( "get_drillbit", get_drillbit_inv );
  cmn.AddSubscriber( "get_drillbit", get_drillbit_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gluedbrush () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gluedbrush" ] = {
    type = "get",
    get_obj = "spr_staging_gluedbrush",
    room = private.room_objname,
    zz = "zz_staging",
    zz_gate = "gzz_hallway_staging"
  };
    
  local get_gluedbrush_inv = function ()
  
    interface.InventoryItemAdd( "inv_gluedbrush", "spr_staging_gluedbrush" );
    ObjSet( "spr_statuepiece_plus_light", { alp = 1 } );  

  end;
  
  local get_gluedbrush_closezz = function ()
  
    ObjDelete( "gfx_staging_gluedbrush" );

    if ( common_impl.IsGetCoin( "get_coin_22" ) ) then

      ObjDelete( "gzz_hallway_staging" );

    end;  

  end;
  
  cmn.AddSubscriber( "get_gluedbrush", get_gluedbrush_inv );
  cmn.AddSubscriber( "get_gluedbrush", get_gluedbrush_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chisel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chisel" ] = {
    type = "get",
    get_obj = "spr_wall_chisel",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_hallway_wall"
  };
    
  local get_chisel_inv = function ()
  
    interface.InventoryItemAdd( "inv_chisel", "spr_wall_chisel" );
  
  end;
  
  local get_chisel_closezz = function ()
  
    ObjDelete( "spr_hallway_wall_chisel" );
    ObjDelete( "gfx_wall_chisel" );
    --ObjDelete( "gzz_hallway_wall" );
  
  end;
  
  cmn.AddSubscriber( "get_chisel", get_chisel_inv );
  cmn.AddSubscriber( "get_chisel", get_chisel_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stone () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stone" ] = {
    type = "get",
    get_obj = "spr_wall_stone",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_hallway_wall"
  };
    
  local get_stone_inv = function ()
  
    interface.InventoryItemAdd( "inv_stone", "spr_wall_stone" );
  
  end;
  
  local get_stone_closezz = function ()
  
    ObjDelete( "gfx_wall_stone" );
    ObjDelete( "spr_wall_stone_shadow" );

    ObjMultiSet({ 
      { "spr_wall_statuepiece",            { input = true     }},
      { "gfx_wall_statuepiece",            { active = true    }},
      { "spr_wall_bottle_substance_v",     { input = true     }},
      { "gfx_wall_bottle_substance_v",     { active = true    }},

      { "spr_hallway_wall_hole",   { alp = 1          }},
      { "spr_hallway_wall_bottle", { alp = 1          }},
    });

    if cmn.IsEventDone( "get_bottle_substance_v" ) and
    cmn.IsEventDone( "get_stone" ) and
    common_impl.IsGetCoin( "get_coin_23" ) and
    cmn.IsEventDone( "get_statuepiece" ) then

      ObjDelete( "gzz_hallway_wall" );

    end;

  end;
  
  cmn.AddSubscriber( "get_stone", get_stone_inv );
  cmn.AddSubscriber( "get_stone", get_stone_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bottle_substance_v () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bottle_substance_v" ] = {
    type = "get",
    get_obj = "spr_wall_bottle_substance_v",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_hallway_wall"
  };
    
  local get_bottle_substance_v_inv = function ()
  
    interface.InventoryItemAdd( "inv_bottle_substance_v", "spr_wall_bottle_substance_v" );
  
  end;
  
  local get_bottle_substance_v_closezz = function ()  

    ObjDelete( "spr_hallway_wall_bottle" );

    ObjDelete( "gfx_wall_bottle_substance_v" );
    ObjDetach( "spr_wall_bottle_shadow" );
    --ObjDelete( "gzz_hallway_wall" );
    if cmn.IsEventDone( "get_bottle_substance_v" ) and
    cmn.IsEventDone( "get_stone" ) and
    common_impl.IsGetCoin( "get_coin_23" ) and
    cmn.IsEventDone( "get_statuepiece" ) then

      ObjDelete( "gzz_hallway_wall" );

    end;

  end;
  
  cmn.AddSubscriber( "get_bottle_substance_v", get_bottle_substance_v_inv );
  cmn.AddSubscriber( "get_bottle_substance_v", get_bottle_substance_v_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_statuepiece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_statuepiece" ] = {
    type = "get",
    get_obj = "spr_wall_statuepiece",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_hallway_wall"
  };
    
  local get_statuepiece_inv = function ()
  
    interface.InventoryItemAdd( "inv_statuepiece", "spr_wall_statuepiece" );
    ObjSet( "inv_statuepiece", { drag = false });
  
  end;
  
  local get_statuepiece_closezz = function ()

    ObjDelete( "gfx_wall_statuepiece" );
    ObjDelete( "spr_wall_statue_shadow2" );
    ObjDelete( "spr_wall_statue_shadow1" );
    --ObjDelete( "gzz_hallway_wall" );
    if cmn.IsEventDone( "get_bottle_substance_v" ) and
    common_impl.IsGetCoin( "get_coin_23" ) and
    cmn.IsEventDone( "get_stone" ) and
    cmn.IsEventDone( "get_statuepiece" ) then

      ObjDelete( "gzz_hallway_wall" );

    end;

  end;
  
  cmn.AddSubscriber( "get_statuepiece", get_statuepiece_inv );
  cmn.AddSubscriber( "get_statuepiece", get_statuepiece_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hatchhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hatchhandle" ] = {
    type = "get",
    get_obj = "spr_tent_hatchhandle",
    room = private.room_objname,
    zz = "zz_tent",
    zz_gate = "gzz_hallway_tent"
  };
    
  local get_hatchhandle_inv = function ()
  
    interface.InventoryItemAdd( "inv_hatchhandle", "spr_tent_hatchhandle" );
  
  end;
  
  local get_hatchhandle_closezz = function ()
  
    ObjDelete( "gfx_tent_hatchhandle" );
    ObjDelete( "spr_hallway_tent_inv" );
    
    if ( common_impl.IsGetCoin( "get_coin_24" ) ) then
    
      ObjDelete( "gzz_hallway_tent" );  

    end;  

  end;
  
  cmn.AddSubscriber( "get_hatchhandle", get_hatchhandle_inv );
  cmn.AddSubscriber( "get_hatchhandle", get_hatchhandle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_book () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_book" ] = {
    type = "get",
    get_obj = "spr_tent_book",
    room = private.room_objname,
    zz = "zz_tent",
    zz_gate = "gzz_hallway_tent"
  };
    
  local get_book_inv = function ()
  
    interface.InventoryItemAdd( "inv_book", "spr_tent_book" );
  
  end;
  
  local get_book_closezz = function ()

    ObjDelete( "spr_hallway_tent_book" );    

    ObjDelete( "spr_tent_book_shadow" );
    ObjDelete( "gfx_tent_book" );
    --ObjDelete( "gzz_hallway_tent" );

  end;

  cmn.AddSubscriber( "get_book", get_book_inv );
  cmn.AddSubscriber( "get_book", get_book_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_22 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_22 = function ()
 
    ObjDelete( "obj_staging_coin" );

    if cmn.IsEventDone( "get_gluedbrush" ) then
    
      ObjDelete( "gzz_hallway_staging" );

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_22", get_collect_coin_22, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_23 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_23 = function ()
 
    ObjDelete( "obj_wall_coin" );

    if cmn.IsEventDone( "get_bottle_substance_v" ) and
    cmn.IsEventDone( "get_stone" ) and
    common_impl.IsGetCoin( "get_coin_23" ) and
    cmn.IsEventDone( "get_statuepiece" ) then

      ObjDelete( "gzz_hallway_wall" );

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_23", get_collect_coin_23, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_24 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_24 = function ()
 
    ObjDelete( "obj_tent_coin" );

    if ( cmn.IsEventDone( "get_hatchhandle" ) ) then

      ObjDelete( "gzz_hallway_tent" );

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_24", get_collect_coin_24, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_chisel () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chisel" ] = {
    type = "use",
    inv_obj = "inv_chisel",
    use_place = "obj_staging_use_chisel",
    room = private.room_objname,
    zz = "zz_staging",
    zz_gate = "gzz_hallway_staging"
  };
  local use_chisel_inv = function ()

    --interface.InventoryItemRemove( "inv_chisel" );

  end;
  local use_chisel_beg = function ()

    ObjDelete( "spr_staging_box_door"   );
    ObjDelete( "spr_staging_box_door_2" );

    ObjDelete( "obj_staging_use_chisel" );

  end;
  local use_chisel_end = function ()

    ObjMultiSet({ 
      { "obj_staging_openbox",   { input = true, active = true  }},
    });

    ObjDelete( "spr_hallway_staging_cover" );
    ObjDelete( "anm_staging_chisel" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chisel", use_chisel_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel", use_chisel_inv );
  cmn.AddSubscriber( "use_chisel", use_chisel_end, private.room_objname );
  cmn.AddSubscriber( "use_chisel_inv", use_chisel_inv, private.room_objname );
  cmn.AddSubscriber( "use_chisel_beg", use_chisel_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel_end", use_chisel_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_brush () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_brush" ] = {
    type = "use",
    inv_obj = "inv_brush",
    use_place = "obj_staging_use_brush",
    room = private.room_objname,
    zz = "zz_staging",
    zz_gate = "gzz_hallway_staging"
  };
  local use_brush_inv = function ()
  
    interface.InventoryItemRemove( "inv_brush" );
  
  end;
  local use_brush_beg = function ()

    ObjDelete( "obj_staging_use_brush" );

  end;
  local use_brush_end = function ()

    ObjMultiSet({
      { "spr_staging_gluedbrush",   { input = true, alp = 1  }},
      { "spr_staging_brush_glue",   { alp = 1 }},
      { "gfx_staging_gluedbrush",   { active = true    }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_brush", use_brush_beg, private.room_objname );
  cmn.AddSubscriber( "use_brush", use_brush_inv );
  cmn.AddSubscriber( "use_brush", use_brush_end, private.room_objname );
  cmn.AddSubscriber( "use_brush_inv", use_brush_inv, private.room_objname );
  cmn.AddSubscriber( "use_brush_beg", use_brush_beg, private.room_objname );
  cmn.AddSubscriber( "use_brush_end", use_brush_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bottle_substance_a () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bottle_substance_a" ] = {
    type = "use",
    inv_obj = "inv_bottle_substance_a",
    use_place = "obj_staging_use_bottle_substance_a",
    room = private.room_objname,
    zz = "zz_staging",
    zz_gate = "gzz_hallway_staging"
  };
  local use_bottle_substance_a_inv = function ()
  
    interface.InventoryItemRemove( "inv_bottle_substance_a" );
  
  end;
  local use_bottle_substance_a_beg = function ()
  
    ObjDelete( "obj_staging_use_bottle_substance_a" );
  
  end;
  local use_bottle_substance_a_end = function ()

    ObjMultiSet({ 
      
      --{ "spr_staging_glue_a",   { alp = 1 }},
      { "obj_staging_use_bottle_substance_b",   { input = true, visible = true }},
      { "vid_staging_use_bottle_substance_a", { alp = 1, playing = false, frame = 152 } },
    });
    --ObjDelete( "vid_staging_use_bottle_substance_a" );
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bottle_substance_a", use_bottle_substance_a_beg, private.room_objname );
  cmn.AddSubscriber( "use_bottle_substance_a", use_bottle_substance_a_inv );
  cmn.AddSubscriber( "use_bottle_substance_a", use_bottle_substance_a_end, private.room_objname );
  cmn.AddSubscriber( "use_bottle_substance_a_inv", use_bottle_substance_a_inv, private.room_objname );
  cmn.AddSubscriber( "use_bottle_substance_a_beg", use_bottle_substance_a_beg, private.room_objname );
  cmn.AddSubscriber( "use_bottle_substance_a_end", use_bottle_substance_a_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bottle_substance_b () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bottle_substance_b" ] = {
    type = "use",
    inv_obj = "inv_bottle_substance_b",
    use_place = "obj_staging_use_bottle_substance_b",
    room = private.room_objname,
    zz = "zz_staging",
    zz_gate = "gzz_hallway_staging"
  };
  local use_bottle_substance_b_inv = function ()
  
    interface.InventoryItemRemove( "inv_bottle_substance_b" );
  
  end;
  local use_bottle_substance_b_beg = function ()
  
    ObjDelete( "obj_staging_use_bottle_substance_b" );
    ObjDelete( "vid_staging_use_bottle_substance_a" )
  end;
  local use_bottle_substance_b_end = function ()

    ObjMultiSet({ 
     
      --{ "spr_staging_glue_b",   { alp = 1 }},
      { "obj_staging_use_bottle_substance_v",   { input = true, visible = true }},
      { "vid_staging_use_bottle_substance_b", { alp = 1, playing = false, frame = 152 } },
    });

    --ObjDelete( "vid_staging_use_bottle_substance_b" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bottle_substance_b", use_bottle_substance_b_beg, private.room_objname );
  cmn.AddSubscriber( "use_bottle_substance_b", use_bottle_substance_b_inv );
  cmn.AddSubscriber( "use_bottle_substance_b", use_bottle_substance_b_end, private.room_objname );
  cmn.AddSubscriber( "use_bottle_substance_b_inv", use_bottle_substance_b_inv, private.room_objname );
  cmn.AddSubscriber( "use_bottle_substance_b_beg", use_bottle_substance_b_beg, private.room_objname );
  cmn.AddSubscriber( "use_bottle_substance_b_end", use_bottle_substance_b_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bottle_substance_v () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bottle_substance_v" ] = {
    type = "use",
    inv_obj = "inv_bottle_substance_v",
    use_place = "obj_staging_use_bottle_substance_v",
    room = private.room_objname,
    zz = "zz_staging",
    zz_gate = "gzz_hallway_staging"
  };
  local use_bottle_substance_v_inv = function ()
  
    interface.InventoryItemRemove( "inv_bottle_substance_v" );
  
  end;
  local use_bottle_substance_v_beg = function ()
  
    ObjDelete( "obj_staging_use_bottle_substance_v" );
    ObjDelete( "vid_staging_use_bottle_substance_b" )
  end;
  local use_bottle_substance_v_end = function ()

    ObjMultiSet({ 
     
      --{ "spr_staging_glue_v",    { alp = 1 }},
      { "obj_staging_use_brush", { input = true, visible = true  }},
      { "vid_staging_use_bottle_substance_v", { alp = 1, playing = false, frame = 152 } },  
    });
    
    --ObjDelete( "vid_staging_use_bottle_substance_v" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bottle_substance_v", use_bottle_substance_v_beg, private.room_objname );
  cmn.AddSubscriber( "use_bottle_substance_v", use_bottle_substance_v_inv );
  cmn.AddSubscriber( "use_bottle_substance_v", use_bottle_substance_v_end, private.room_objname );
  cmn.AddSubscriber( "use_bottle_substance_v_inv", use_bottle_substance_v_inv, private.room_objname );
  cmn.AddSubscriber( "use_bottle_substance_v_beg", use_bottle_substance_v_beg, private.room_objname );
  cmn.AddSubscriber( "use_bottle_substance_v_end", use_bottle_substance_v_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bottle_substance_a" ] = {
    type = "use",
    inv_obj = "inv_bottle_substance_a",
    use_place = "obj_staging_use_bottle_substance_a",
    room = private.room_objname,
    zz = "zz_staging",
    zz_gate = "gzz_hallway_staging"
  };
  local use_bottle_substance_a_inv = function ()
  
    interface.InventoryItemRemove( "inv_bottle_substance_a" );
  
  end;
  local use_bottle_substance_a_beg = function ()
  
    ObjDelete( "obj_staging_use_bottle_substance_a" );
  
  end;
  local use_bottle_substance_a_end = function ()

    if cmn.IsEventDone( "use_bottle_substance_a" ) and
    cmn.IsEventDone( "use_bottle_substance_b" ) and
    cmn.IsEventDone( "use_bottle_substance_v" ) then

      ObjSet( "obj_staging_use_brush", { input = true } );

    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bottle_substance_a", use_bottle_substance_a_beg, private.room_objname );
  cmn.AddSubscriber( "use_bottle_substance_a", use_bottle_substance_a_inv );
  cmn.AddSubscriber( "use_bottle_substance_a", use_bottle_substance_a_end, private.room_objname );
  cmn.AddSubscriber( "use_bottle_substance_a_inv", use_bottle_substance_a_inv, private.room_objname );
  cmn.AddSubscriber( "use_bottle_substance_a_beg", use_bottle_substance_a_beg, private.room_objname );
  cmn.AddSubscriber( "use_bottle_substance_a_end", use_bottle_substance_a_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tongs () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tongs" ] = {
    type = "use",
    inv_obj = "inv_tongs",
    use_place = "obj_wall_use_tongs",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_hallway_wall"
  };
  local use_tongs_inv = function ()
  
    interface.InventoryItemRemove( "inv_tongs" );
  
  end;
  local use_tongs_beg = function ()
  
    ObjDelete( "obj_wall_use_tongs" );
  
  end;
  local use_tongs_end = function ()
  
    ObjSet( "spr_wall_chisel", { input = true } );
    ObjSet( "obj_wall_use_workingdrill", { input = true } );
    ObjSet( "gfx_wall_chisel", { active = true } );

    ObjDelete( "anm_wall_use_tongs" );
    ObjSet( "spr_wall_stone", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tongs", use_tongs_beg, private.room_objname );
  cmn.AddSubscriber( "use_tongs", use_tongs_inv );
  cmn.AddSubscriber( "use_tongs", use_tongs_end, private.room_objname );
  cmn.AddSubscriber( "use_tongs_inv", use_tongs_inv, private.room_objname );
  cmn.AddSubscriber( "use_tongs_beg", use_tongs_beg, private.room_objname );
  cmn.AddSubscriber( "use_tongs_end", use_tongs_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_workingdrill () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_workingdrill" ] = {
    type = "use",
    inv_obj = "inv_workingdrill",
    use_place = "obj_wall_use_workingdrill",
    room = private.room_objname,
    zz = "zz_wall",
    zz_gate = "gzz_hallway_wall"
  };
  local use_workingdrill_inv = function ()
  
    interface.InventoryItemRemove( "inv_workingdrill" );
  
  end;
  local use_workingdrill_beg = function ()
  
    ObjDelete( "obj_wall_use_workingdrill" );
  
  end;
  local use_workingdrill_end = function ()

    ObjDelete( "spr_wall_over" );
    ObjDelete( "vid_wall_perforator" );

    ObjMultiSet({ 
      { "spr_wall_stone",          { input =  true, alp = 1 }},
      { "gfx_wall_stone",          { active = true    }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_workingdrill", use_workingdrill_beg, private.room_objname );
  cmn.AddSubscriber( "use_workingdrill", use_workingdrill_inv );
  cmn.AddSubscriber( "use_workingdrill", use_workingdrill_end, private.room_objname );
  cmn.AddSubscriber( "use_workingdrill_inv", use_workingdrill_inv, private.room_objname );
  cmn.AddSubscriber( "use_workingdrill_beg", use_workingdrill_beg, private.room_objname );
  cmn.AddSubscriber( "use_workingdrill_end", use_workingdrill_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_glasspiece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_glasspiece" ] = {
    type = "use",
    inv_obj = "inv_glasspiece",
    use_place = "obj_tent_use_glasspiece",
    room = private.room_objname,
    zz = "zz_tent",
    zz_gate = "gzz_hallway_tent"
  };
  local use_glasspiece_beg = function ()

    ObjDelete( "obj_tent_use_glasspiece" );

  end;
  local use_glasspiece_end = function ()

    ObjMultiSet({ 
      { "spr_tent_book",     { input = true     }},
      { "gfx_tent_book",     { active = true    }},

      { "obj_tent_open_tarpaulin", { active = true, input = true}},
      { "spr_hallway_tent_book",   { alp = 1 }},
    });

    ObjDelete( "spr_hallway_tent_tent"    );
    ObjDelete( "obj_tent_close_tarpaulin" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_glasspiece", use_glasspiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_glasspiece", use_glasspiece_end, private.room_objname );
  cmn.AddSubscriber( "use_glasspiece_beg", use_glasspiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_glasspiece_end", use_glasspiece_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_opener () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_opener" ] = {
    type = "use",
    inv_obj = "inv_opener",
    use_place = "obj_tent_use_opener",
    room = private.room_objname,
    zz = "zz_tent",
    zz_gate = "gzz_hallway_tent"
  };
  local use_opener_inv = function ()
  
    interface.InventoryItemRemove( "inv_opener" );
  
  end;
  local use_opener_beg = function ()
  
    ObjDelete( "obj_tent_use_opener" );
  
  end;
  local use_opener_end = function ()
  
    ObjMultiSet({ 
      --{ "spr_tent_hatchhandle",  { input = true          }},
      { "gfx_tent_hatchhandle",  { active = true         }},

      { "spr_tent_jar_upset",    { alp = 1               }},
      { "spr_tent_hatchhandle",  { alp = 1               }},
      { "obj_tent_mmg",          { alp = 1, input = true }},

      { "spr_hallway_tent_pot_open", { alp = 1 }},
      { "spr_hallway_tent_pairs",    { alp = 1 }},
    });
  
    ObjDelete( "spr_hallway_tent_pot" ); 
 
    ObjDelete( "spr_tent_opener"    );
    ObjDelete( "obj_tent_close_jar" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_opener", use_opener_beg, private.room_objname );
  cmn.AddSubscriber( "use_opener", use_opener_inv );
  cmn.AddSubscriber( "use_opener", use_opener_end, private.room_objname );
  cmn.AddSubscriber( "use_opener_inv", use_opener_inv, private.room_objname );
  cmn.AddSubscriber( "use_opener_beg", use_opener_beg, private.room_objname );
  cmn.AddSubscriber( "use_opener_end", use_opener_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_providence_flowerpot () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_providence_flowerpot" ] = {
    type = "use",
    inv_obj = "inv_prv_flowerpot",
    use_place = "obj_hallway_use_prv_item_2",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"
  };
  local use_providence_flowerpot_inv = function ()
  
    interface.ProvidePanelItemRemove( "inv_prv_flowerpot" );
  
  end;
  local use_providence_flowerpot_beg = function ()
  
    ObjDelete( "obj_hallway_use_prv_item_2" );
  
  end;
  local use_providence_flowerpot_end = function ()
  
    ObjMultiSet( { 
      { "spr_hallway_prv_flowerpot_used", { alp = 1 } },
      { "spr_hallway_pot", { visible = true } },
      { "spr_hallway_pot_shadow", { visible = true } },
      { "spr_hallway_prv_flowerpot_used_shadow", { alp = 1 } } } );
    ObjDelete( "spr_hallway_prv_flowerpot_light" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_providence_flowerpot", use_providence_flowerpot_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_flowerpot", use_providence_flowerpot_inv );
  cmn.AddSubscriber( "use_providence_flowerpot", use_providence_flowerpot_end, private.room_objname );
  cmn.AddSubscriber( "use_providence_flowerpot_inv", use_providence_flowerpot_inv, private.room_objname );
  cmn.AddSubscriber( "use_providence_flowerpot_beg", use_providence_flowerpot_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_flowerpot_end", use_providence_flowerpot_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_providence_curtainrope () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_providence_curtainrope" ] = {
    type = "use",
    inv_obj = "inv_prv_curtainrope",
    use_place = "obj_hallway_use_prv_item_1",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"
  };
  local use_providence_curtainrope_inv = function ()
  
    interface.ProvidePanelItemRemove( "inv_prv_curtainrope" );
  
  end;
  local use_providence_curtainrope_beg = function ()
  
    ObjDelete( "obj_hallway_use_prv_item_1" );
  
  end;
  local use_providence_curtainrope_end = function ()

    ObjSet( "spr_hallway_prv_curtainrope_used", { alp = 1 } );
    ObjSet( "spr_hallway_prv_curtain2", { alp = 1 } );
    ObjDelete( "spr_hallway_prv_curtainrope_light" );
    ObjDelete( "spr_hallway_prv_curtain1" );
    ObjSet( "spr_hallway_curtain_open", { visible = true } );
    ObjDelete( "obj_hallway_hall_az" );
    ObjDelete( "anm_hallway_hall_az" );
    ObjDelete( "anm_hallway_hall_az_click" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_providence_curtainrope", use_providence_curtainrope_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_curtainrope", use_providence_curtainrope_inv );
  cmn.AddSubscriber( "use_providence_curtainrope", use_providence_curtainrope_end, private.room_objname );
  cmn.AddSubscriber( "use_providence_curtainrope_inv", use_providence_curtainrope_inv, private.room_objname );
  cmn.AddSubscriber( "use_providence_curtainrope_beg", use_providence_curtainrope_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_curtainrope_end", use_providence_curtainrope_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chamberkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chamberkey" ] = {
    type = "use",
    inv_obj = "inv_chamberkey",
    use_place = "obj_hallway_use_chamberkey",
    zz = "slider_left",
    room = private.room_objname
  };
  local use_chamberkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_chamberkey" );
  
  end;
  local use_chamberkey_beg = function ()
  
    ObjDelete( "obj_hallway_use_chamberkey" );
  
  end;
  local use_chamberkey_end = function ()
  
    ObjSet( "grm_hallway_chamber", { input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_hallway_chamber_focus");
    end;
    ObjSet( "spr_hallway_open_chamber", { visible = true, alp = 1 } );
    ObjDelete( "spr_hallway_key" );
    ObjDelete( "spr_hallway_key_over" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chamberkey", use_chamberkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_chamberkey", use_chamberkey_inv );
  cmn.AddSubscriber( "use_chamberkey", use_chamberkey_end, private.room_objname );
  cmn.AddSubscriber( "use_chamberkey_inv", use_chamberkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_chamberkey_beg", use_chamberkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_chamberkey_end", use_chamberkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_providence_cape () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_providence_cape" ] = {
    type = "use",
    inv_obj = "spr_hallway_prv_cape",
    use_place = "obj_hallway_prv_item_1",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"    
  };
  local clk_providence_cape_beg = function ()
  
    ObjDelete(  "obj_hallway_prv_item_1" );
  
  end;
  local clk_providence_cape_end = function ()

    ObjDelete( "spr_hallway_prv_cape" );
    ObjDelete( "spr_hallway_prv_cape_light" );
    ObjSet( "spr_hallway_prv_cape_used", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_providence_cape", clk_providence_cape_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_cape", clk_providence_cape_end, private.room_objname );
  cmn.AddSubscriber( "clk_providence_cape_beg", clk_providence_cape_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_cape_end", clk_providence_cape_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function win_bolts () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_bolts" ] = {

      type = "win",    
      room = private.room_objname,
      zz_gate = "gzz_hallway_tent",
      zz = "zz_hallway"

  };

  local win_bolts = function ()

      if ( cmn.IsEventDone( "win_bolts" ) ) then  
        ObjSet( "spr_tent_hatchhandle" , { input = true, active = true });

        for i=1,5 do
           ObjDelete( "spr_tent_bolt_"..i       );
           ObjDelete( "spr_tent_bolt_"..i.."_1" );
        end;

        ObjDelete( "spr_hallway_tent_pairs");
        ObjSet( "spr_hallway_tent_pairs_1", { alp = 1 });
        ObjSet( "spr_hallway_tent_inv",     { alp = 1 });      

      end;

 end;
 cmn.AddSubscriber( "win_bolts", win_bolts, private.room_objname );  

  --------------------------------------------------------------------------------------------
  -- function clk_providence_hallway () end;
  --------------------------------------------------------------------------------------------
  local clk_providence_hallway = function ()
              
    if ( not cmn.IsEventDone( "clk_providence_cape" ) or ( cmn.IsEventDone( "get_prv_curtainrope" ) and not cmn.IsEventDone( "use_providence_curtainrope" ) )
         or ( cmn.IsEventDone( "get_prv_flowerpot" ) and not cmn.IsEventDone( "use_providence_flowerpot" ) ) ) then

        int_button_providence.StartActiveProvidence();

    end;
  
  end;
  
  cmn.AddSubscriber( "clk_providence_hallway", clk_providence_hallway, private.room_objname );
 
 --------------------------------------------------------------------------------------------
  -- function vid_hallway_providence () end;
  --------------------------------------------------------------------------------------------  
  
  local vid_hallway_prv_end = function ()

    ObjSet( "gho_hallway_ladder", { active = true, input = true } );
    ObjDelete( "obj_hallway_clk_ladder" );
    local params = { 'left' };
    int_slider.Unlock( private.room_objname, params );
   
  end;

  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_hallway_providence", vid_hallway_prv_end, private.room_objname  );
  cmn.AddSubscriber( "vid_hallway_prv_end", vid_hallway_prv_end, private.room_objname  );
 --------------------------------------------------------------------------------------------
  
  local vid_hallway_providence_p2 = function ()

    VidStop( "vid_hallway_providence_p1" );
    ObjSet( "vid_hallway_providence_p2", { playing = true } );    

  end;   

  cmn.AddSubscriber( "vid_hallway_providence_p2", vid_hallway_providence_p2, private.room_objname );
  --------------------------------------------------------------------------------------------
  local vid_hallway_providence_p3 = function ()

    VidStop( "vid_hallway_providence_p2" );
    ObjSet( "vid_hallway_providence_p3", { playing = true } );

  end;   

  cmn.AddSubscriber( "vid_hallway_providence_p3", vid_hallway_providence_p3, private.room_objname );
  --------------------------------------------------------------------------------------------
  local vid_hallway_providence_p4 = function ()

    VidStop( "vid_hallway_providence_p3" );
    VidPlay( "vid_hallway_providence_p4", private.vid_hallway_providence_end );    

  end;   

  cmn.AddSubscriber( "vid_hallway_providence_p4", vid_hallway_providence_p4, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_tent" );
  --------------------------------------------------------------------------------------------
  function zz_tent.PreOpen()

    if ( cmn.IsEventDone( "use_opener" ) and not cmn.IsEventDone( "win_bolts" )) then

        cmn.MiniGameShow( "bolts" );
        common_impl.PassingMgStart( "bolts" );

    end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_tent.PreClose()

    cmn.MiniGameHide( "bolts" );
    common_impl.PassingMgStop( "bolts" );

  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_hallway();

  int_providence_eye.CheckShow();

  if ( not cmn.IsEventDone( "vid_hallway_providence" ) ) then

    int_button_providence.StartLightProvidence();

  end;

  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.MorphItemMorphing();
  interface.InvestigationButtonCheck();

  common_impl.EnvPlay( { "common/audio/aud_hallway_env" }, "", 0.5 ); 
  
end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreClose()

  if ( not cmn.IsEventDone( "vid_hallway_providence" ) ) then

    int_button_providence.StopLightProvidence();

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_chisel()

  local item = "inv_chisel";

  if ( common.ApplyObj( item, "obj_staging_use_chisel", true ) ) then

    cmn.CallEventHandler( "use_chisel_inv" );
    cmn.CallEventHandler( "use_chisel_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_chisel" );
      cmn.CallEventHandler( "use_chisel_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_chisel", 0, "", 0 );
  
    AnimPlay( "anm_staging_chisel", "DoAnim", func_after );

    return true;
  
  elseif common.ApplyObj( item, "gzz_hallway_staging", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_staging", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_brush()

  local item = "inv_brush";

  if ( common.ApplyObj( item, "obj_staging_use_brush", true ) and cmn.IsEventDone( "use_bottle_substance_v" )) then

    cmn.CallEventHandler( "use_brush_inv" );
    cmn.CallEventHandler( "use_brush_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_brush" );
      cmn.CallEventHandler( "use_brush_end" );
    
    end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_use_brush", 0, "", 0 );
  
    ObjAnimate( "spr_staging_gluedbrush", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 1.0
    } );

    ObjAnimate( "spr_staging_brush_glue", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.0,
      0.6, 0, 1.0,
    } );


  return true;

  elseif ( common.ApplyObj( item, "obj_staging_use_brush", true ) ) and
    ( not cmn.IsEventDone( "use_bottle_substance_a" ) or
    not cmn.IsEventDone( "use_bottle_substance_b" ) or
    not cmn.IsEventDone( "use_bottle_substance_v" ) ) then

    common_impl.ShowBbt( 'bbt_staging_use_brush_wrong', 1 );

    return true;
  
  elseif common.ApplyObj( item, "gzz_hallway_staging", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_staging", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bottle_substance_b()

  local item = "inv_bottle_substance_b";

  if ( common.ApplyObj( item, "obj_staging_use_bottle_substance_b", true ) ) then

    if cmn.IsEventDone( "use_bottle_substance_a" )  then

      cmn.CallEventHandler( "use_bottle_substance_b_inv" );
      cmn.CallEventHandler( "use_bottle_substance_b_beg" );

      local func_after = function ()
    
        common_impl.Lock( false );
        cmn.SetEventDone( "use_bottle_substance_b" );
        cmn.CallEventHandler( "use_bottle_substance_b_end" );
      --common.CloseSubRoom();;
      
      end;

      common_impl.Lock( true );
      common_impl.PlayAudio( "sfx", "common/audio/aud_use_bottle_substance", 0, "", 0 );

    ObjSet( "vid_staging_use_bottle_substance_b", { alp = 1, playing = true, endtrig = func_after } );

    else 

      common_impl.ShowBbt( "bbt_hallway_use_bottle_wrong", 1 );

    end;

    return true;
  
  elseif common.ApplyObj( item, "gzz_hallway_staging", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_staging", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bottle_substance_v()

  local item = "inv_bottle_substance_v";

  if ( common.ApplyObj( item, "obj_staging_use_bottle_substance_v", true ) ) then

    if cmn.IsEventDone( "use_bottle_substance_b" )  then

      cmn.CallEventHandler( "use_bottle_substance_v_inv" );
      cmn.CallEventHandler( "use_bottle_substance_v_beg" );

      local func_after = function ()
    
        common_impl.Lock( false );
        cmn.SetEventDone( "use_bottle_substance_v" );
        cmn.CallEventHandler( "use_bottle_substance_v_end" );
      --common.CloseSubRoom();;
      
      end;

      common_impl.Lock( true );
      common_impl.PlayAudio( "sfx", "common/audio/aud_use_bottle_substance", 0, "", 0 );

      ObjSet( "vid_staging_use_bottle_substance_v", { alp = 1, playing = true, endtrig = func_after } );

    else 

      common_impl.ShowBbt( "bbt_hallway_use_bottle_wrong", 1 );

    end;

    return true;
  
  elseif common.ApplyObj( item, "gzz_hallway_staging", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_staging", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bottle_substance_a()

  local item = "inv_bottle_substance_a";

  if ( common.ApplyObj( item, "obj_staging_use_bottle_substance_a", true ) ) then

    cmn.CallEventHandler( "use_bottle_substance_a_inv" );
    cmn.CallEventHandler( "use_bottle_substance_a_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_bottle_substance_a" );
      cmn.CallEventHandler( "use_bottle_substance_a_end" );
    --common.CloseSubRoom();;
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_bottle_substance", 0, "", 0 );

    ObjSet( "vid_staging_use_bottle_substance_a", { alp = 1, playing = true, endtrig = func_after } );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_hallway_staging", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_staging", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tongs()

  local item = "inv_tongs";

  if ( common.ApplyObj( item, "obj_wall_use_tongs", true ) ) then

    cmn.CallEventHandler( "use_tongs_inv" );
    cmn.CallEventHandler( "use_tongs_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_tongs" );
      cmn.CallEventHandler( "use_tongs_end" );
      private.get_chisel();
    
    end;

    common_impl.Lock( true );

    --ObjSet( "anm_wall_use_tongs", { alp = 1 } );
    ObjSet( "spr_wall_chisel", { pos_y = 315 } );
    AnimPlay( "anm_wall_use_tongs", "DoAnim", func_after );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_tongs", 0, "", 0 );

    return true;
  
  elseif common.ApplyObj( item, "gzz_hallway_wall", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wall", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_workingdrill()

  local item = "inv_workingdrill";

  if ( common.ApplyObj( item, "obj_wall_use_workingdrill", true ) ) then

    cmn.CallEventHandler( "use_workingdrill_inv" );
    cmn.CallEventHandler( "use_workingdrill_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_workingdrill" );
      cmn.CallEventHandler( "use_workingdrill_end" );
      private.get_stone();

    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_workingdrill", 0, "", 0 );
    ObjSet( "vid_wall_perforator", { active = true, alp = 1 });
    ObjSet( "spr_wall_stone", { alp = 0 });
    ObjSet( "spr_wall_over", { alp = 0 });
    ObjSet( "spr_wall_stone_shadow", { alp = 0 });


    VidPlay( "vid_wall_perforator", func_after );

    return true;
  
  elseif ( common.ApplyObj( item, "obj_flowerbed_use_stone", true ) ) then

    common_impl.ShowBbt( 'bbt_flowerbed_use_workingdrill_wrong', 1 );

    return true;
  
  elseif common.ApplyObj( item, "gzz_hallway_wall", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_wall", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_glasspiece()

  local item = "inv_glasspiece";

  if ( common.ApplyObj( item, "obj_tent_use_glasspiece", true ) ) then

    interface.InventoryItemRemove( "inv_glasspiece" );
    cmn.CallEventHandler( "use_glasspiece_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_glasspiece" );
      cmn.CallEventHandler( "use_glasspiece_end" );
      interface.InventoryItemAdd( "inv_glasspiece");

    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_glasspiece", 0, "", 0 );

    AnimPlay( "anm_tent_cordage", "DoAnim", func_after );

    return true;
  
  elseif common.ApplyObj( item, "gzz_hallway_tent", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tent", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_opener()

  local item = "inv_opener";

  if ( common.ApplyObj( item, "obj_tent_use_opener", true ) ) then

    cmn.CallEventHandler( "use_opener_inv" );
    cmn.CallEventHandler( "use_opener_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_opener" );
      cmn.CallEventHandler( "use_opener_end" );

      cmn.MiniGameShow( "bolts" );
      common_impl.PassingMgStart( "bolts" );

      ng_global.progress["std"]["win_bolts"].boltsPlayer = {0,0,0,0,0};
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_opener", 0, "", 0 );

    AnimPlay( "anm_tent_jar", "DoAnim", func_after );


  return true;
  
  elseif common.ApplyObj( item, "gzz_hallway_tent", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tent", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_providence_flowerpot()

  local item = "inv_prv_flowerpot";

  if ( ObjIntersect( item, "obj_hallway_use_prv_item_2") and int_providence.show ) then

    cmn.CallEventHandler( "use_providence_flowerpot_inv" );
    cmn.CallEventHandler( "use_providence_flowerpot_beg" );
    
    local func_after = function ()

      common_impl.Lock(false);
      cmn.CallEventHandler( "use_providence_flowerpot_end" );

      if cmn.IsEventDone( "clk_providence_cape" ) and cmn.IsEventDone( "use_providence_curtainrope" ) then

          private.anim_providence( function() cmn.SetEventDone( "use_providence_flowerpot" ); end );

      else 

        if ( cmn.IsEventDone( "clk_providence_cape" ) and (cmn.IsEventDone( "use_providence_flowerpot" ) or not cmn.IsEventDone( "get_prv_curtainrope" ) )) then
          int_button_providence.StopActiveProvidence();
        end;

        cmn.SetEventDone( "use_providence_flowerpot" );

      end;

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_providence_flowerpot", 0, "", 0 );

    ObjAnimate( "spr_hallway_prv_flowerpot_used", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_hallway_prv_flowerpot_used_shadow", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_providence_curtainrope()

  local item = "inv_prv_curtainrope";

  if ( ObjIntersect( item, "obj_hallway_use_prv_item_1" ) and int_providence.show ) then

    cmn.CallEventHandler( "use_providence_curtainrope_inv" );
    cmn.CallEventHandler( "use_providence_curtainrope_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.CallEventHandler( "use_providence_curtainrope_end" );

      if cmn.IsEventDone( "clk_providence_cape" ) and cmn.IsEventDone( "use_providence_flowerpot" ) then

          private.anim_providence( function() cmn.SetEventDone( "use_providence_curtainrope" ); end );

      else 

        if ( cmn.IsEventDone( "clk_providence_cape" ) and (cmn.IsEventDone( "use_providence_curtainrope" ) or not cmn.IsEventDone( "get_prv_flowerpot" ) )) then
          int_button_providence.StopActiveProvidence();
        end;

        cmn.SetEventDone( "use_providence_curtainrope" );

      end;

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_providence_curtainrope", 0, "", 0 );

    ObjAnimate( "spr_hallway_prv_curtainrope_used", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_hallway_prv_curtain2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_hallway_prv_curtain1", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );

    return true;  

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_chamberkey()

  local item = "inv_chamberkey";

  if ( common.ApplyObj( item, "obj_hallway_use_chamberkey", false ) ) then

    cmn.CallEventHandler( "use_chamberkey_inv" );
    cmn.CallEventHandler( "use_chamberkey_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_chamberkey" );
      cmn.CallEventHandler( "use_chamberkey_end" );
        
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_chamberkey", 0, "", 0 );

    ObjAnimate( "spr_hallway_key", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 0.0
    } );

    ObjAnimate( "spr_hallway_key_over", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 1.0,
      0.6, 0, 0.0
    } );

    ObjAnimate( "spr_hallway_open_chamber", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.0, 
      0.6, 0, 1.0
    } );
  
    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_tongs()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_tongs" );
  cmn.CallEventHandler( "get_tongs" );

end;
--------------------------------------------------------------------------------------------
function private.get_bottle_substance_a()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  cmn.SetEventDone( "get_bottle_substance_a" );
  cmn.CallEventHandler( "get_bottle_substance_a" );

end;
--------------------------------------------------------------------------------------------
function private.get_drillbit()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_drillbit" );
  cmn.CallEventHandler( "get_drillbit" );

end;
--------------------------------------------------------------------------------------------
function private.get_gluedbrush()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_gluedbrush" );
  cmn.CallEventHandler( "get_gluedbrush" );

  if ( common_impl.IsGetCoin( "get_coin_22" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_chisel()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_chisel" );
  cmn.CallEventHandler( "get_chisel" );

end;
--------------------------------------------------------------------------------------------
function private.get_stone()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_stone" );
  cmn.CallEventHandler( "get_stone" );

  if cmn.IsEventDone( "get_bottle_substance_v" ) and
  cmn.IsEventDone( "get_stone" ) and
  common_impl.IsGetCoin( "get_coin_23" ) and
  cmn.IsEventDone( "get_statuepiece" ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_bottle_substance_v()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_bottle_substance_v" );
  cmn.CallEventHandler( "get_bottle_substance_v" );

  if cmn.IsEventDone( "get_bottle_substance_v" ) and
  cmn.IsEventDone( "get_stone" ) and
  common_impl.IsGetCoin( "get_coin_23" ) and
  cmn.IsEventDone( "get_statuepiece" ) then

    common.CloseSubRoom();

  end;
end;
--------------------------------------------------------------------------------------------
function private.get_statuepiece()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_statuepiece" );
  cmn.CallEventHandler( "get_statuepiece" );

  if cmn.IsEventDone( "get_bottle_substance_v" ) and
  cmn.IsEventDone( "get_stone" ) and
  common_impl.IsGetCoin( "get_coin_23" ) and
  cmn.IsEventDone( "get_statuepiece" ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_hatchhandle()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_hatchhandle" );
  cmn.CallEventHandler( "get_hatchhandle" );

  if ( common_impl.IsGetCoin( "get_coin_24" ) ) then
    
    common.CloseSubRoom();  

  end; 


end;
--------------------------------------------------------------------------------------------
function private.get_book()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_book" );
  cmn.CallEventHandler( "get_book" );

end;
--------------------------------------------------------------------------------------------
function private.get_prv_curtainrope_silhouette()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );
  cmn.SetEventDone( "get_prv_curtainrope_silhouette" );
  cmn.CallEventHandler( "get_prv_curtainrope_silhouette" );

end;
--------------------------------------------------------------------------------------------
function private.get_prv_flowerpot_silhouette()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );
  cmn.SetEventDone( "get_prv_flowerpot_silhouette" );
  cmn.CallEventHandler( "get_prv_flowerpot_silhouette" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_providence_cape()

  cmn.CallEventHandler( "clk_providence_cape_beg" );

  local func_after = function ()

    common_impl.Lock(false);

    cmn.CallEventHandler( "clk_providence_cape_end" );

    if cmn.IsEventDone( "use_providence_flowerpot" ) 
       and cmn.IsEventDone( "use_providence_curtainrope" ) then

      private.anim_providence( function() cmn.SetEventDone( "clk_providence_cape" ); end );

    else 

      if (( not cmn.IsEventDone( "get_prv_flowerpot" ) or cmn.IsEventDone( "use_providence_flowerpot" ) ) and
      ( not cmn.IsEventDone( "get_prv_curtainrope" ) or cmn.IsEventDone( "use_providence_curtainrope" ) ) ) then

        int_button_providence.StopActiveProvidence();

      end;

      cmn.SetEventDone( "clk_providence_cape" );

    end;

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_cape", 0, "", 0 );

  ObjSet( "spr_hallway_prv_cape", { alp = 0 } );
  ObjAnimate( "spr_hallway_prv_cape_used", "alp", 0, 0, func_after, { 0, 0, 0, 0.1, 0, 0, 0.3, 0, 1 } );

end;
--------------------------------------------------------------------------------------------
function private.anim_providence( func_execute )

  common_impl.ShowBbt( "bbt_providence_allitems" );

  int_button_providence.StopActiveProvidence();

  local array_objects = {
    "spr_hallway_prv_flowerpot_used",
    "spr_hallway_prv_curtainrope_used",
    "spr_hallway_prv_cape_used" }

  local func_end = function()

    for i = 1, #array_objects do
      ObjAttach( array_objects[ i ], "obj_hallway_providence_center" );
      ObjSet( array_objects[ i ], { alp = 1 } );
    end;
    common_impl.Lock( false );    
    private.vid_hallway_providence( func_execute );

  end;
  
  common_impl.Lock( true );
  for i = 1, #array_objects do
    common_impl.PlayEffectHO( array_objects[ i ], func_end, 3, "assets/interface/resources/effect_mask" );
    func_end = nil;
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_ready", 0, "", 0 );

end;
-------------------------------------------------------------------------------------
function private.drag_cape ()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_hallway_prv_cape", { pos_z = 10 } );

end;
-------------------------------------------------------------------------------------
function private.drop_cape ()

  local item = "spr_hallway_prv_cape";

  ObjSet( item, { pos_z = 0 } );

  if ( ObjIntersect( item, "obj_hallway_prv_item_1" ) or ObjIntersect( "obj_hallway_cape_apply", "obj_hallway_prv_item_1" ) ) then

    private.clk_providence_cape();

  end;

end;
--*********************************************************************************************************************
function private.vid_hallway_providence( func_execute )

  interface.BBTHide();

  private.func_providence = func_execute;

  int_button_providence.StopLightProvidence();
  
  common_impl.StopAllMus();
  common_impl.PlayAudio( "mus", "common/audio/aud_providence_mus", 1, "", 0.5 ); 
  common_impl.PlayAudio( "sfx", "common/audio/aud_hallway_providence_p1", 0, "", 0 );

  VidPlay( "vid_hallway_providence_p1", "" ); 
  interface.DialogVideoShow( "vid_hallway_providence", 1, function() private.vid_hallway_providence_end(); end , 3, 4 ); 

end;

function private.vid_hallway_providence_end( )

    common_impl.Lock( false );
    common_impl.StopAudio( "sfx", "common/audio/aud_hallway_providence_p4", 0.2 );
    int_providence.Hide();
    interface.DialogVideoHide();

    cmn.SetEventDone( "vid_hallway_providence" );
    cmn.CallEventHandler( "vid_hallway_prv_end" );

    common_impl.ShowBbt( 'bbt_providence_level3_1_end' );
    int_slider.InitSlider( private.room_objname );
    
    if ( private.func_providence ) then

      private.func_providence();
      private.func_providence = nil;

    end;

    common_impl.StopAudio( "mus", "common/audio/aud_providence_mus", 1 );
    common_impl.PlayAudio( "mus", "common/audio/aud_enigma_mus", 0, "", 0 ); 
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
-----------------------------------------------------------------------------------------------------------------------
function private.get_collect_coin_22()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_22" );
    cmn.CallEventHandler( "get_coin_22" );

    if cmn.IsEventDone( "get_gluedbrush" ) then
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_staging_coin", func_after ); 

end;
-----------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
function private.get_collect_coin_23()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_23" );
    cmn.CallEventHandler( "get_coin_23" );

      
    if cmn.IsEventDone( "get_bottle_substance_v" ) and
       cmn.IsEventDone( "get_stone" ) and
       common_impl.IsGetCoin( "get_coin_23" ) and
       cmn.IsEventDone( "get_statuepiece" ) then

      common.CloseSubRoom();

    end;   

  end;

  common_impl.PlayEffectHO( "spr_wall_coin", func_after ); 

end;
-----------------------------------------------------------------------------------------------------------------------
function private.get_collect_coin_24()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_24" );
    cmn.CallEventHandler( "get_coin_24" );

    if cmn.IsEventDone( "get_hatchhandle" ) then
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_tent_coin", func_after ); 

end;
-----------------------------------------------------------------------------------------------------------------------
function private.opn_hallway()

  if not ( cmn.IsEventDone( "opn_hallway" ) ) then
    cmn.SetEventDone( "opn_hallway" );
    common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0, "", 0 );
  end;
  
  cmn.CallEventHandler( "opn_hallway_map" ); 

end;
-----------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
function private.animStone()

  local func_after = function ()

    common_impl.Lock( false );

  end;
  
  common_impl.Lock( true );


  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_big_stone", 0, "", 0 );

  ObjAnimate( "spr_wall_stone", "ang", 0, 0, func_after,
  { 
    0.0, 0, 0.0, 
    0.2, 0, 0.02,
    0.4, 0, 0.0
  } );
  
end;
-----------------------------------------------------------------------------------------------------------------------
function private.animChisel()

  local func_after = function ()

    common_impl.Lock( false );

  end;
  
  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_very_small_metall", 0, "", 0 );

  ObjAnimate( "spr_wall_chisel", "pos_xy", 0, 0, func_after,
  { 
    0.0, 0, 81, -45, 
    0.2, 0, 84, -47,
    0.4, 0, 81, -45,
  } );

end;
-----------------------------------------------------------------------------------------------------------------------
function private.animHall()

  local func_after = function ()

    common_impl.Lock( false );

    AnimStop( "anm_hallway_hall_az_click" );
    AnimPlay( "anm_hallway_hall_az", "DoAnim", func_after );

    ObjSet( "anm_hallway_hall_az_click", { alp = 0 } );
    ObjSet( "anm_hallway_hall_az",       { alp = 1 } ); 

  end;
  
  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_curtains", 0, "", 0 );

  ObjSet( "anm_hallway_hall_az",       { alp = 0 } );
  ObjSet( "anm_hallway_hall_az_click", { alp = 1 } );    

  AnimStop( "anm_hallway_hall_az" );
  AnimPlay( "anm_hallway_hall_az_click", "DoAnim", func_after );
  
  
end;
-----------------------------------------------------------------------------------------------------------------------
function private.animBoxDoor()

  local func_after = function ()

    common_impl.Lock( false );

  end;
  
  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_small_wood", 0, "", 0 );

  ObjAnimate( "spr_staging_box_door", "scale_xy", 0, 0, func_after,
  { 
    0.0, 0, 1, 1, 
    0.2, 0, 1.02, 1.02,
    0.4, 0, 1, 1,
  } );
  ObjAnimate( "spr_staging_box_door_2", "scale_xy", 0, 0, "",
  { 
    0.0, 0, 1, 1, 
    0.2, 0, 1.02, 1.02,
    0.4, 0, 1, 1,
  } );

end;

-----------------------------------------------------------------------------------------------------------------------
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG *** () end;
--*********************************************************************************************************************
function private.win_bolts ()

  cmn.MiniGameHide( "bolts" );
  cmn.SetEventDone( "win_bolts" );
  cmn.CallEventHandler( "win_bolts" );
  common_impl.PassingMgWin( "bolts" );
  
end;
--------------------------------------------------------------------------------------------------------------
function public.Skip ( event )

  ng_global.progress["std"]["win_bolts"].boltsPlayer = { 1, 1, 1, 1, 1 };
  for i=1,5 do
     ObjSet("spr_tent_bolt_"..i,       { alp = 0, input = false });
     ObjSet("spr_tent_bolt_"..i.."_1", { alp = 0, input = false });
     ObjSet("spr_tent_twain_"..i,      { alp = 1 });
  end;

  private.Check ();

end;
--------------------------------------------------------------------------------------------------------------
function public.Reset ( event )

  ng_global.progress["std"]["win_bolts"].boltsPlayer = { 0, 0, 0, 0, 0 };
  for i=1,5 do
     ObjSet("spr_tent_bolt_"..i,       { alp = 1, input = true });
     ObjSet("spr_tent_bolt_"..i.."_1", { alp = 1, input = true });
     ObjSet("spr_tent_twain_"..i,      { alp = 0 });
  end;
 
end;
--------------------------------------------------------------------------------------------------------------
function private.GetNumber( str )
 
  ObjSet("spr_tent_add_bolt_"..str, { alp = 1 });

  local lenght = string.len(str);

  if lenght == 1 then

     private.str1 = str; 

    if ( private.positions[1]~=0 ) then

      if private.positions[1] == private.str1 then

        ObjSet("spr_tent_add_bolt_"..private.str1, { alp = 0 });
        common_impl.PlayAudio( "sfx", "common/audio/aud_mg_bolts_click", 0, "", 0 );
              
      else

        ObjSet("spr_tent_add_bolt_"..private.str1, { alp = 0 });
        ObjSet("spr_tent_add_bolt_"..private.positions[1], { alp = 0 });
        common_impl.PlayAudio( "sfx", "common/audio/aud_mg_bolts_wrong", 0, "", 0 );

      end;

       private.positions[2] = 0;
       private.positions[1] = 0;

    else

      private.positions[1] = tonumber(str);
      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_bolts_click", 0, "", 0 );
 
    end;

   
  elseif lenght == 3 then

    private.str2 = str; 
  
    if ( private.positions[2]~=0 ) then

      if private.positions[2] == tonumber(string.sub(str,1,1)) then

        ObjSet("spr_tent_add_bolt_"..private.str2, { alp = 0 });
        common_impl.PlayAudio( "sfx", "common/audio/aud_mg_bolts_click", 0, "", 0 );
              
      else

        ObjSet("spr_tent_add_bolt_"..private.str2, { alp = 0 });
        ObjSet("spr_tent_add_bolt_"..private.positions[2].."_1", { alp = 0 });
        common_impl.PlayAudio( "sfx", "common/audio/aud_mg_bolts_wrong", 0, "", 0 );

      end;

       private.positions[2] = 0;
       private.positions[1] = 0;

    else

      private.positions[2] = tonumber(string.sub(str,1,1));
      common_impl.PlayAudio( "sfx", "common/audio/aud_mg_bolts_click", 0, "", 0 );
 
    end;

  end;

  if ( private.positions[1]~=0 and private.positions[2]~= 0 ) then

     if private.positions[1] == private.positions[2] then
        
        common_impl.PlayAudio( "sfx", "common/audio/aud_mg_bolts_true", 0, "", 0 );
        local i = private.positions[1];
        ng_global.progress["std"]["win_bolts"].boltsPlayer[i] = 1;

        ObjSet("spr_tent_add_bolt_"..private.str1, { alp = 0 });
        ObjSet("spr_tent_add_bolt_"..private.str2, { alp = 0 });

        ObjSet("spr_tent_bolt_"..private.str1, { alp = 0, input = false });
        ObjSet("spr_tent_bolt_"..private.str2, { alp = 0, input = false });

        ObjSet("spr_tent_twain_"..i, { alp = 1 });
     
     else
      
        common_impl.PlayAudio( "sfx", "common/audio/aud_mg_bolts_wrong", 0, "", 0 );
        ObjSet("spr_tent_add_bolt_"..private.str1, { alp = 0 });
        ObjSet("spr_tent_add_bolt_"..private.str2, { alp = 0 });

     end;

      private.positions[1]=0;
      private.positions[2]=0;

      private.Check();

  end;

end;
--------------------------------------------------------------------------------------------------------------
function private.Check()

  local count = 0;

  for i = 1,5 do

    if ng_global.progress["std"]["win_bolts"].boltsPlayer[i] == 1 then

      count = count + 1;

    end;

  end;

  if count == 5 then

    private.win_bolts();

  end;

end;
--*********************************************************************************************************************