-- name=rm_mansion
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_mansion";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_flowerbed", "room_hub" );
  ObjAttach( "zz_porch", "room_hub" );
  ObjAttach( "zz_statue", "room_hub" );
  private.Init_Subroom();
  
  private.countElements = 9;
  private.winStatueMas = { { 8, 7, 6, },
                           { 5, 4, 3, },
                           { 0, 2, 1  } };

  private.firstStatueMas = { { 8, 6, 0, },
                             { 4, 7, 3, },
                             { 5, 2, 1  } };

  private.statuePositions = { { { -19 , -36 }, {  27 , -30 }, {  73 , -25 }, },
                              { { -25 ,   6 }, {  21 ,  12 }, {  68 ,  21 }, },
                              { { -27 ,  53 }, {  15 ,  59 }, {  63 ,  60 }  } };

  private.start_animations();  

  ObjMultiSet({ 
    { "spr_flowerbed_kidrake",            { event_mdown = private.get_kidrake             }},
    { "spr_flowerbed_evidence_3_1",       { event_mdown = private.get_evidence_3_1        }},
    { "spr_flowerbed_porcelainowl",       { event_mdown = private.get_porcelainowl        }},
    { "spr_flowerbed_brush",              { event_mdown = private.get_brush               }},
    { "spr_flowerbed_bottle_substance_b", { event_mdown = private.get_bottle_substance_b  }},
    { "spr_flowerbed_prv_flowerpot",      { event_mdown = private.get_prv_flowerpot       }},
    { "spr_porch_hammerdrill",            { event_mdown = private.get_hammerdrill         }},
    { "spr_porch_stonesword",             { event_mdown = private.get_stonesword          }},
    { "spr_statue_porcelainkey",          { event_mdown = private.get_porcelainkey        }},
    { "spr_statue_prv_curtainrope",       { event_mdown = private.get_prv_curtainrope     }},

    { "obj_vid_mansion_owlman",           { event_mdown = private.vid_mansion_owlman      }},

    { "obj_flowerbed_use_elf",            { event_mdown = function () private.AnimationOwl();          common_impl.ShowBbt( 'bbt_flowerbed_use_elf' ); end }},
    { "obj_flowerbed_use_chisel",         { event_mdown = function () private.AnimationPaint();          end }},
    { "obj_porch_use_kidrake",            { event_mdown = function () private.AnimationBoard();        common_impl.ShowBbt( 'bbt_porch_use_kidrake' ); end }},
    { "spr_statue_shield",                { event_mdown = function () private.AnimationStatueShield(); common_impl.ShowBbt( 'bbt_manson_shield' );     end }},

    { "spr_statue_mmg_1",       { event_mdown = function () private.ChangePosition( 1 ); end }},
    { "spr_statue_mmg_2",       { event_mdown = function () private.ChangePosition( 2 ); end }},
    { "spr_statue_mmg_3",       { event_mdown = function () private.ChangePosition( 3 ); end }},
    { "spr_statue_mmg_4",       { event_mdown = function () private.ChangePosition( 4 ); end }},
    { "spr_statue_mmg_5",       { event_mdown = function () private.ChangePosition( 5 ); end }},
    { "spr_statue_mmg_6",       { event_mdown = function () private.ChangePosition( 6 ); end }},
    { "spr_statue_mmg_7",       { event_mdown = function () private.ChangePosition( 7 ); end }},
    { "spr_statue_mmg_8",       { event_mdown = function () private.ChangePosition( 8 ); end }},

    { "spr_statue_coin",           { event_mdown = private.get_collect_coin_20 }},
    { "spr_flowerbed_coin",        { event_mdown = private.get_collect_coin_21 }},
    { "obj_mansion_clk_owl",        { event_mdown = private.ClkOwl }},
    
    { "spr_mansion_collect_item",    { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_3_1" );     end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_mansion_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_3_1" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
 
  });
  
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mansion = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_mansion_flowerbed",
    "gzz_mansion_statue",
    "gzz_mansion_porch"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_flowerbed",
      "zz_porch",
      "zz_statue"
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_mansion", update_game_mode_mansion, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_mansion = function ()

  local effects_table = 
  {
    "obj_mansion_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_mansion", update_performance_mode_mansion, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_mansion () end;
  --------------------------------------------------------------------------------------------
  local opn_mansion_map = function ()

    common_impl.VisitMapRoom( "mansion" );

  end;

  local opn_mansion_lock_map = function ()

   local lock_rooms = { "nightsvilleentrance", "nightsville", "glade", "mineentrance", "mine_1", "mine_2",
                        "pier", "square", "fork", "livingroom", "office", "basement", "abandoneddistrict" };

    for j = 1, #lock_rooms do

      common_impl.LockMapRoom( lock_rooms[j], true );

    end;
  
  end;

  cmn.AddSubscriber( "opn_mansion", opn_mansion_map );
  cmn.AddSubscriber( "opn_mansion_map", opn_mansion_map );
  cmn.AddSubscriber( "opn_mansion", opn_mansion_lock_map );
  cmn.AddSubscriber( "opn_mansion_lock_map", opn_mansion_lock_map );

  --------------------------------------------------------------------------------------------
  -- function get_collect_item_3_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_3_1 = function ()
  
    ObjDelete( "obj_mansion_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_3_1", get_collect_item_3_1, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_3_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_3_1 = function ()
  
    ObjDelete( "obj_mansion_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_3_1", get_collect_morph_item_3_1, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_kidrake () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_kidrake" ] = {
    type = "get",
    get_obj = "spr_flowerbed_kidrake",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_mansion_flowerbed"
  };
    
  local get_kidrake_inv = function ()
  
    interface.InventoryItemAdd( "inv_kidrake", "spr_flowerbed_kidrake" );
  
  end;
  
  local get_kidrake_closezz = function ()
  
    ObjDelete( "gfx_flowerbed_kidrake" );
    ObjDelete( "spr_flowerbed_rake_shadow" );

    ObjDelete( "spr_mansion_rake" );
  
  end;
  
  cmn.AddSubscriber( "get_kidrake", get_kidrake_inv );
  cmn.AddSubscriber( "get_kidrake", get_kidrake_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_evidence_3_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_evidence_3_1" ] = {
    type = "get",
    get_obj = "spr_flowerbed_evidence_3_1",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_mansion_flowerbed"
  };
    
  local get_evidence_3_1_inv = function ()
  
    --
  
  end;
  
  local get_evidence_3_1_closezz = function ()
  
    ObjDelete( "gfx_flowerbed_evidence_3_1" );
    ObjDelete( "spr_flowerbed_evidence_3_1" );
    ObjDelete( "spr_flowerbed_letter_shadow" );


    if cmn.IsEventDone( "get_prv_flowerpot" ) and
       cmn.IsEventDone( "get_brush" ) and
       common_impl.IsGetCoin( "get_coin_21" ) and
       cmn.IsEventDone( "get_bottle_substance_b" ) then

      ObjDelete( "gzz_mansion_flowerbed" );

    end;    
  
  end;
  
  cmn.AddSubscriber( "get_evidence_3_1", get_evidence_3_1_inv );
  cmn.AddSubscriber( "get_evidence_3_1", get_evidence_3_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_porcelainowl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_porcelainowl" ] = {
    type = "get",
    get_obj = "spr_flowerbed_porcelainowl",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_mansion_flowerbed"
  };
    
  local get_porcelainowl_inv = function ()
  
    interface.InventoryItemAdd( "inv_porcelainowl", "spr_flowerbed_porcelainowl" );
    ObjSet( "inv_porcelainowl", { drag = false });
 
  end;
  
  local get_porcelainowl_closezz = function ()
  
    ObjDelete( "gfx_flowerbed_porcelainowl" );
    ObjDelete( "spr_flowerbed_owl_light" );
  
  end;
  
  cmn.AddSubscriber( "get_porcelainowl", get_porcelainowl_inv );
  cmn.AddSubscriber( "get_porcelainowl", get_porcelainowl_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brush () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brush" ] = {
    type = "get",
    get_obj = "spr_flowerbed_brush",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_mansion_flowerbed"
  };
    
  local get_brush_inv = function ()
  
    interface.InventoryItemAdd( "inv_brush", "spr_flowerbed_brush" );
  
  end;
  
  local get_brush_closezz = function ()
  
    ObjDelete( "gfx_flowerbed_brush" );
    ObjDelete( "spr_flowerbed_brush_shadow" );

    ObjDelete( "spr_mansion_items" );

    if cmn.IsEventDone( "get_prv_flowerpot" ) and
       common_impl.IsGetCoin( "get_coin_21" ) and
       cmn.IsEventDone( "get_evidence_3_1" ) and
       cmn.IsEventDone( "get_bottle_substance_b" ) then

      ObjDelete( "gzz_mansion_flowerbed" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_brush", get_brush_inv );
  cmn.AddSubscriber( "get_brush", get_brush_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bottle_substance_b () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bottle_substance_b" ] = {
    type = "get",
    get_obj = "spr_flowerbed_bottle_substance_b",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_mansion_flowerbed"
  };
    
  local get_bottle_substance_b_inv = function ()
  
    interface.InventoryItemAdd( "inv_bottle_substance_b", "spr_flowerbed_bottle_substance_b" );
  
  end;
  
  local get_bottle_substance_b_closezz = function ()
  
    ObjDelete( "gfx_flowerbed_bottle_substance_b" );
    ObjDelete( "spr_flowerbed_bottle_shadow" );

    ObjDelete( "spr_mansion_items" );

    if cmn.IsEventDone( "get_brush" ) and
       cmn.IsEventDone( "get_evidence_3_1" ) and
       common_impl.IsGetCoin( "get_coin_21" ) and
       cmn.IsEventDone( "get_prv_flowerpot" ) then

      ObjDelete( "gzz_mansion_flowerbed" );

    end;

  end;
  
  cmn.AddSubscriber( "get_bottle_substance_b", get_bottle_substance_b_inv );
  cmn.AddSubscriber( "get_bottle_substance_b", get_bottle_substance_b_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_prv_flowerpot () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_prv_flowerpot" ] = {
    type = "get",
    get_obj = "spr_flowerbed_prv_flowerpot",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_mansion_flowerbed"
  };
    
  local get_prv_flowerpot_inv = function ()
  
    interface.ProvidePanelItemAdd( "inv_prv_flowerpot", "spr_flowerbed_prv_flowerpot" );
  
  end;
  
  local get_prv_flowerpot_closezz = function ()
  
    ObjDelete( "gfx_flowerbed_prv_flowerpot" );

    if cmn.IsEventDone( "get_brush" ) and
       common_impl.IsGetCoin( "get_coin_21" ) and
       cmn.IsEventDone( "get_evidence_3_1" ) and
       cmn.IsEventDone( "get_bottle_substance_b" ) then

      ObjDelete( "gzz_mansion_flowerbed" );

    end;

    ObjDelete( "spr_flowerbed_pot_shadow" );
    ObjDelete( "spr_flowerbed_over_pot" );
    ObjDelete( "spr_mansion_pot" );
  
  end;
  
  cmn.AddSubscriber( "get_prv_flowerpot", get_prv_flowerpot_inv );
  cmn.AddSubscriber( "get_prv_flowerpot", get_prv_flowerpot_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hammerdrill () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hammerdrill" ] = {
    type = "get",
    get_obj = "obj_porch_hammerdrill",
    room = private.room_objname,
    zz = "zz_porch",
    zz_gate = "gzz_mansion_porch"
  };
    
  local get_hammerdrill_inv = function ()
  
    interface.InventoryItemAdd( "inv_hammerdrill", "spr_porch_hammerdrill" );
    ObjSet( "inv_hammerdrill", { drag = false });
  
  end;
  
  local get_hammerdrill_closezz = function ()
  
    ObjDelete( "gfx_porch_hammerdrill" );
    ObjDelete( "obj_porch_hammerdrill" );
    ObjDelete( "spr_porch_hammerdrill_shadow"  );
    ObjDelete( "spr_mansion_porch_hammerdrill" );
  
  end;
  
  cmn.AddSubscriber( "get_hammerdrill", get_hammerdrill_inv );
  cmn.AddSubscriber( "get_hammerdrill", get_hammerdrill_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_stonesword () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_stonesword" ] = {
    type = "get",
    get_obj = "spr_porch_stonesword",
    room = private.room_objname,
    zz = "zz_porch",
    zz_gate = "gzz_mansion_porch"
  };
    
  local get_stonesword_inv = function ()
  
    interface.InventoryItemAdd( "inv_stonesword", "spr_porch_stonesword" );
  
  end;
  
  local get_stonesword_closezz = function ()
  
    ObjDelete( "gfx_porch_stonesword" );
    ObjDelete( "spr_porch_sword_ov" );
    --ObjDelete( "gzz_mansion_porch" );
  
  end;
  
  cmn.AddSubscriber( "get_stonesword", get_stonesword_inv );
  cmn.AddSubscriber( "get_stonesword", get_stonesword_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_porcelainkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_porcelainkey" ] = {
    type = "get",
    get_obj = "spr_statue_porcelainkey",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_mansion_statue"
  };
    
  local get_porcelainkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_porcelainkey", "spr_statue_porcelainkey" );
    ObjSet( "spr_porcelainowl_plus_light", { alp = 1 } );
  
  end;
  
  local get_porcelainkey_closezz = function ()
  
    ObjDelete( "gfx_statue_porcelainkey" );
    ObjDelete( "spr_statue_porcelainkey_shadow" );
    ObjDelete( "spr_mansion_statue_feather" );
  
  end;
  
  cmn.AddSubscriber( "get_porcelainkey", get_porcelainkey_inv );
  cmn.AddSubscriber( "get_porcelainkey", get_porcelainkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_prv_curtainrope () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_prv_curtainrope" ] = {
    type = "get",
    get_obj = "spr_statue_prv_curtainrope",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_mansion_statue"
  };
    
  local get_prv_curtainrope_inv = function ()
  
    interface.ProvidePanelItemAdd( "inv_prv_curtainrope", "spr_statue_prv_curtainrope" );
  
  end;
  
  local get_prv_curtainrope_closezz = function ()
  
    ObjDelete( "gfx_statue_prv_curtainrope" );
    ObjDelete( "spr_statue_prv_curtainrope_shadow" );
    ObjDelete( "spr_mansion_statue_rope" );
    
    if common_impl.IsGetCoin( "get_coin_20" ) then

      ObjDelete( "gzz_mansion_statue" );
      

    end;
  
  end;
  
  cmn.AddSubscriber( "get_prv_curtainrope", get_prv_curtainrope_inv );
  cmn.AddSubscriber( "get_prv_curtainrope", get_prv_curtainrope_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_20 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_20 = function ()
 
    ObjDelete( "obj_statue_coin" );

    if cmn.IsEventDone( "get_prv_curtainrope" ) then

      ObjDelete( "gzz_mansion_statue" );

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_20", get_collect_coin_20, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_21 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_21 = function ()
 
    ObjDelete( "obj_flowerbed_coin" );

  if cmn.IsEventDone( "get_prv_flowerpot" ) and
     cmn.IsEventDone( "get_brush" ) and
     cmn.IsEventDone( "get_evidence_3_1" ) and
     cmn.IsEventDone( "get_bottle_substance_b" ) then

    ObjDelete( "gzz_mansion_flowerbed" );

  end;
    
  end;
  cmn.AddSubscriber( "get_coin_21", get_collect_coin_21, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_elf_8 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_8" ] = {
    type = "use",
    inv_obj = "inv_elf_3",
    use_place = "obj_flowerbed_use_elf",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_mansion_flowerbed"
  };

  local use_elf_8_beg = function ()
  
    ObjDelete( "obj_flowerbed_use_elf" );
  
  end;
  local use_elf_8_end = function ()
  
    ObjMultiSet({ 
      { "spr_flowerbed_porcelainowl", { input = true  }},
      { "gfx_flowerbed_porcelainowl", { active = true }},
    });

    ObjDelete( "spr_flowerbed_soil_1" );
    ObjDelete( "vid_flowerbed_use_elf_8" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_8", use_elf_8_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_8", use_elf_8_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_8_beg", use_elf_8_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_8_end", use_elf_8_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chisel_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chisel_2" ] = {
    type = "use",
    inv_obj = "inv_chisel",
    use_place = "obj_flowerbed_use_chisel",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_mansion_flowerbed"
  };
  local use_chisel_2_inv = function ()
  
    if cmn.IsEventDone( "use_chisel_3" ) then

      interface.InventoryItemRemove( "inv_chisel" );

    end;
  
  end;
  local use_chisel_2_beg = function ()
  
    ObjDelete( "obj_flowerbed_use_chisel" );
     
  end;
  local use_chisel_2_end = function ()

    ObjMultiSet({ 
      { "spr_flowerbed_brush",              { input = true, pos_x = -51, pos_y = 118, drawoff_x = 0, drawoff_y = 0 } },
      { "spr_flowerbed_brush_shadow",       { pos_x = -55, pos_y = 137 } },
      { "gfx_flowerbed_brush",              { active = true    } },
      { "spr_flowerbed_bottle_substance_b", { input = true, pos_x = -68, pos_y = 40, ang = -0.65, drawoff_x = 0, drawoff_y = 0 } },
      { "gfx_flowerbed_bottle_substance_b", { active = true    } },
      { "obj_flowerbed_chisel_used",        { alp = 1, input = true } }
    });

    ObjDelete( "anm_flowerbed_use_chisel" )

  end;
  local use_chisel_2_inv_end = function ()

    if not cmn.IsEventDone( "use_chisel_3" ) then

      interface.InventoryItemAdd( "inv_chisel", "spr_flowerbed_chisel_get" );
  
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chisel_2", use_chisel_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel_2", use_chisel_2_inv );
  cmn.AddSubscriber( "use_chisel_2", use_chisel_2_inv_end );
  cmn.AddSubscriber( "use_chisel_2", use_chisel_2_end, private.room_objname );
  cmn.AddSubscriber( "use_chisel_2_inv",     use_chisel_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_chisel_2_inv_end", use_chisel_2_inv_end, private.room_objname );
  cmn.AddSubscriber( "use_chisel_2_beg",     use_chisel_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel_2_end",     use_chisel_2_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function use_chisel_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chisel_3" ] = {
    type = "use",
    inv_obj = "inv_chisel",
    use_place = "obj_flowerbed_use_chisel_2",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_mansion_flowerbed"
  };
  local use_chisel_3_inv = function ()

    --if cmn.IsEventDone( "use_chisel_2" ) then

      interface.InventoryItemRemove( "inv_chisel" );

    --end;

  end;
  local use_chisel_3_beg = function ()

    ObjDelete( "obj_flowerbed_use_chisel_2" );
  
  end;
  local use_chisel_3_end = function ()

    ObjMultiSet({ 
      { "obj_flowerbed_use_stone", { input = true , visible = true, alp = 1 }},
      { "spr_flowerbed_chisel",    { alp = 1 }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chisel_3", use_chisel_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel_3", use_chisel_3_inv );
  cmn.AddSubscriber( "use_chisel_3", use_chisel_3_end, private.room_objname );
  cmn.AddSubscriber( "use_chisel_3_inv", use_chisel_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_chisel_3_beg", use_chisel_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_chisel_3_end", use_chisel_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_stone () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stone" ] = {
    type = "use",
    inv_obj = "inv_stone",
    use_place = "obj_flowerbed_use_stone",
    room = private.room_objname,
    zz = "zz_flowerbed",
    zz_gate = "gzz_mansion_flowerbed"
  };
  local use_stone_inv = function ()
  
    interface.InventoryItemRemove( "inv_stone" );
  
  end;
  local use_stone_beg = function ()
  
    ObjDelete( "obj_flowerbed_use_stone" );
    ObjDelete( "spr_flowerbed_over_pot" );
    ObjDelete( "spr_flowerbed_pot_shadow" );
  
  end;
  local use_stone_end = function ()
  
    ObjMultiSet({ 
      { "spr_flowerbed_prv_flowerpot",     { input = true, ang = -0.47, pos_x = 89, pos_y = -148, alp = 1 } },
      { "gfx_flowerbed_prv_flowerpot",     { active = true    } },
    });

    ObjDelete( "spr_flowerbed_stone" );
    ObjDelete( "spr_flowerbed_chisel" );
    ObjDelete( "anm_flowerbed_use_stone" );
  
  end;
  local use_stone_end_inv = function ()

    if not cmn.IsEventDone( "use_chisel_2" ) then

      interface.InventoryItemAdd( "inv_chisel" );      

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stone", use_stone_beg, private.room_objname );
  cmn.AddSubscriber( "use_stone", use_stone_inv );
  cmn.AddSubscriber( "use_stone", use_stone_end, private.room_objname );
  cmn.AddSubscriber( "use_stone_inv", use_stone_inv, private.room_objname );
  cmn.AddSubscriber( "use_stone_beg", use_stone_beg, private.room_objname );
  cmn.AddSubscriber( "use_stone_end", use_stone_end, private.room_objname );
  cmn.AddSubscriber( "use_stone_end", use_stone_end_inv );
  cmn.AddSubscriber( "use_stone", use_stone_end_inv );
  --------------------------------------------------------------------------------------------
  -- function use_kidrake () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_kidrake" ] = {
    type = "use",
    inv_obj = "inv_kidrake",
    use_place = "obj_porch_use_kidrake",
    room = private.room_objname,
    zz = "zz_porch",
    zz_gate = "gzz_mansion_porch"
  };
  local use_kidrake_inv = function ()
  
    interface.InventoryItemRemove( "inv_kidrake" );
  
  end;
  local use_kidrake_beg = function ()
  
    ObjDelete( "obj_porch_use_kidrake" );
  
  end;
  local use_kidrake_end = function ()
  
    ObjMultiSet({ 
      { "spr_porch_stonesword", { input = true  }},
      { "gfx_porch_stonesword", { active = true }},
    });

    ObjDelete( "anm_porch_use_kidrake" );

    ObjDelete( "spr_mansion_porch_cant_overlap" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_kidrake", use_kidrake_beg, private.room_objname );
  cmn.AddSubscriber( "use_kidrake", use_kidrake_inv );
  cmn.AddSubscriber( "use_kidrake", use_kidrake_end, private.room_objname );
  cmn.AddSubscriber( "use_kidrake_inv", use_kidrake_inv, private.room_objname );
  cmn.AddSubscriber( "use_kidrake_beg", use_kidrake_beg, private.room_objname );
  cmn.AddSubscriber( "use_kidrake_end", use_kidrake_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lockpiece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lockpiece" ] = {
    type = "use",
    inv_obj = "inv_lockpiece",
    use_place = "obj_porch_use_lockpiece",
    room = private.room_objname,
    zz = "zz_porch",
    zz_gate = "gzz_mansion_porch"
  };
  local use_lockpiece_inv = function ()
  
    interface.InventoryItemRemove( "inv_lockpiece" );
  
  end;
  local use_lockpiece_beg = function ()
  
    ObjDelete( "obj_porch_use_lockpiece" );
  
  end;
  local use_lockpiece_end = function ()

    ObjSet( "grm_mansion_hallway", { input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_mansion_hallway_focus");
    end;
    ObjDelete( "gzz_mansion_porch" );
    ObjSet( "spr_mansion_door_open", { alp = 1 } );

 
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lockpiece", use_lockpiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpiece", use_lockpiece_inv );
  cmn.AddSubscriber( "use_lockpiece", use_lockpiece_end, private.room_objname );
  cmn.AddSubscriber( "use_lockpiece_inv", use_lockpiece_inv, private.room_objname );
  cmn.AddSubscriber( "use_lockpiece_beg", use_lockpiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpiece_end", use_lockpiece_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_stonesword () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stonesword" ] = {
    type = "use",
    inv_obj = "inv_stonesword",
    use_place = "obj_statue_use_stonesword",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_mansion_statue"
  };
  local use_stonesword_inv = function ()
  
    interface.InventoryItemRemove( "inv_stonesword" );
  
  end;
  local use_stonesword_beg = function ()
  
    ObjDelete( "obj_statue_use_stonesword" );
  
  end;
  local use_stonesword_end = function ()
  
    ObjMultiSet(
    { 
      { "spr_statue_sword",    { alp = 1 } },
      { "spr_statue_mmg_back", { alp = 1 } },
      { "obj_statue_mmg",      { input = true } },
      { "spr_statue_shield_open", { alp = 1 } }
    });

    ObjDelete( "spr_statue_shield" );

    ObjDelete( "spr_mansion_shield_1" );
    ObjSet( "spr_mansion_shield_2", { alp = 1 } );
    ObjSet( "spr_mansion_sword", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stonesword", use_stonesword_beg, private.room_objname );
  cmn.AddSubscriber( "use_stonesword", use_stonesword_inv );
  cmn.AddSubscriber( "use_stonesword", use_stonesword_end, private.room_objname );
  cmn.AddSubscriber( "use_stonesword_inv", use_stonesword_inv, private.room_objname );
  cmn.AddSubscriber( "use_stonesword_beg", use_stonesword_beg, private.room_objname );
  cmn.AddSubscriber( "use_stonesword_end", use_stonesword_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_statue () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_statue" ] = {
    type = "use",
    inv_obj = "inv_statue",
    use_place = "obj_statue_use_statue",
    room = private.room_objname,
    zz = "zz_statue",
    zz_gate = "gzz_mansion_statue"
  };
  local use_statue_inv = function ()
  
    interface.InventoryItemRemove( "inv_statue" );
  
  end;
  local use_statue_beg = function ()
  
    ObjDelete( "obj_statue_use_statue" );
    ObjSet( "spr_statue_door_over", { alp = 1 } );
  
  end;
  local use_statue_end = function ()
  
    ObjMultiSet(
    { 
      { "spr_statue_nishe_2",     { input = true, alp = 1 } },
      { "gfx_statue_prv_curtainrope", { active = true } },
      { "spr_mansion_statue_rope", { alp = 1 } }
    });

    ObjDelete( "spr_statue_door" );
    ObjDelete( "spr_mansion_statue_cover" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_statue", use_statue_beg, private.room_objname );
  cmn.AddSubscriber( "use_statue", use_statue_inv );
  cmn.AddSubscriber( "use_statue", use_statue_end, private.room_objname );
  cmn.AddSubscriber( "use_statue_inv", use_statue_inv, private.room_objname );
  cmn.AddSubscriber( "use_statue_beg", use_statue_beg, private.room_objname );
  cmn.AddSubscriber( "use_statue_end", use_statue_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function vid_mansion_owlman () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_mansion_owlman" ] = {

      type = "click",
      use_place = "obj_vid_mansion_owlman",
      room = private.room_objname
  };
  local vid_mansion_owlman_beg = function ()

    ObjDelete( "obj_vid_mansion_owlman" );

  end;
  local vid_mansion_owlman_end = function ()

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_mansion_owlman", vid_mansion_owlman_beg, private.room_objname );
  cmn.AddSubscriber( "vid_mansion_owlman", vid_mansion_owlman_end, private.room_objname  );
  cmn.AddSubscriber( "vid_mansion_owlman_beg", vid_mansion_owlman_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_mansion_owlman_end", vid_mansion_owlman_end, private.room_objname  );
  --------------------------------------------------------------------------------------------

  --------------------------------------------------------------------------------------------
  -- function win_statue () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_statue" ] = {

      type = "win",    
      room = private.room_objname,
      use_place = "spr_statue_mmg_back",
      zz_gate = "gzz_mansion_statue",
      zz = "zz_statue"

  };

  local win_statue = function ()

      if ( cmn.IsEventDone( "win_statue" ) ) then  
        
        ObjDelete("obj_statue_mmg"     );
        ObjDelete("spr_statue_mmg_back");

        ObjMultiSet(
        { 
          { "spr_statue_door_over",           { alp = 1               }},
          { "spr_statue_door",                { alp = 1               }},
          { "spr_statue_porcelainkey",        { alp = 1, input = true }},
          { "gfx_statue_porcelainkey",        { active = true         }},
          { "spr_statue_porcelainkey_shadow", { alp = 1               }},
          { "obj_statue_use_statue",          { input = true }},
          { "spr_mansion_statue_feather",     { alp = 1 }}

        });
  
        ObjDelete( "spr_mansion_statue_mmg" );

      end;

 end;

 cmn.AddSubscriber( "win_statue", win_statue, private.room_objname );  

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_statue" );
  --------------------------------------------------------------------------------------------
  function zz_statue.PreOpen()

    if ( cmn.IsEventDone( "use_stonesword" ) and not cmn.IsEventDone( "win_statue" )) then

        cmn.MiniGameShow( "statue" );
        common_impl.PassingMgStart( "statue" );

        for i = 1,3 do
          for j = 1,3 do
            if (ng_global.progress["std"]["win_statue"].PlayerPositions[i][j]~=0) then
              
              posxNew = private.statuePositions[i][j][1];
              posyNew = private.statuePositions[i][j][2];
              ObjSet("spr_statue_mmg_"..ng_global.progress["std"]["win_statue"].PlayerPositions[i][j], {pos_x=posxNew, pos_y=posyNew} );

            end;
          end;
        end;
        
    end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_statue.PreClose()

    cmn.MiniGameHide( "statue" );
    common_impl.PassingMgStop( "statue" );

  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_mansion();
  
  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );
  
  if ( not cmn.IsEventDone( "vid_mansion_owlman" ) ) then
    common_impl.PlayTimer( private.vid_mansion_owlman );
  end;

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();

  common_impl.MorphItemMorphing();
  interface.InvestigationButtonCheck();

  common_impl.EnvPlay( { "common/audio/aud_mansion_env" }, "", 0.5 );  
  
end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_elf_8()

  local item = "inv_elf_3";

  if ( not cmn.IsEventDone( "get_kidrake" ) ) then

    --AK> add bbt wrongapply "please, get rake"
    return true;

  end;

  if ( common.ApplyObj( item, "obj_flowerbed_use_elf", true ) ) then

    --cmn.CallEventHandler( "use_elf_8_inv" );
    interface.InventoryItemRemove( "inv_elf_3" );
    cmn.CallEventHandler( "use_elf_8_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      --interface.InventoryItemAdd( "inv_elf_3", "vid_flowerbed_use_elf_8" );
      ObjSet( "spr_flowerbed_elf", { alp = 1 } );
      interface.InventoryItemAdd( "inv_elf_3", "spr_flowerbed_elf" );
      cmn.SetEventDone( "use_elf_8" );
      cmn.CallEventHandler( "use_elf_8_end" );
    
    end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_flowerbed_elf", 0, "", 0 );
  
  ObjAnimate( "spr_flowerbed_soil_1", "alp", 0, 0, "",
  { 

    0.0, 0, 1.0, 
    2.0, 0, 1.0,
    3.5, 0, 0.0

  } );

  ObjSet( "vid_flowerbed_use_elf_8", { alp = 1, playing = true, endtrig = func_after } );

  return true;
  
  elseif common.ApplyObj( item, "gzz_mansion_flowerbed", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_flowerbed", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_chisel()

  local item = "inv_chisel";

  if ( common.ApplyObj( item, "obj_flowerbed_use_chisel", true )  ) then

    cmn.CallEventHandler( "use_chisel_2_inv" );
    cmn.CallEventHandler( "use_chisel_2_beg" );

    local func_after = function ()
    
      common_impl.Lock( false );
      cmn.SetEventDone( "use_chisel_2" );
      cmn.CallEventHandler( "use_chisel_2_end" );
      cmn.CallEventHandler( "use_chisel_2_inv_end" );

    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_chisel_2", 0, "", 0 );

    ObjSet( "obj_flowerbed_chisel_used", { alp = 0 } );
    ObjSet( "anm_flowerbed_use_chisel", { alp = 1 } );
    
    AnimPlay( "anm_flowerbed_use_chisel", "DoAnim", func_after )
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_mansion_flowerbed", false )  then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_flowerbed", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_chisel_2()

  local item = "inv_chisel";

  if ( common.ApplyObj( item, "obj_flowerbed_use_chisel_2", true ) ) then

    if ( cmn.IsEventDone( "get_stone" ) ) then    

      cmn.CallEventHandler( "use_chisel_3_inv" );
      cmn.CallEventHandler( "use_chisel_3_beg" );

      local func_after = function ()
    
        common_impl.Lock( false );
        cmn.SetEventDone( "use_chisel_3" );
        cmn.CallEventHandler( "use_chisel_3_end" );

      end;

      common_impl.Lock( true );
      common_impl.PlayAudio( "sfx", "common/audio/aud_use_chisel_3", 0, "", 0 );      
      ObjAnimate( "spr_flowerbed_chisel", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0,
      } );

    else

      common_impl.ShowBbt( 'bbt_use_chisel_wrong', 1 );

    end;

  return true;
  
  elseif common.ApplyObj( item, "gzz_mansion_flowerbed", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_flowerbed", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_stone()

  local item = "inv_stone";

  if ( common.ApplyObj( item, "obj_flowerbed_use_stone", true ) and cmn.IsEventDone( "use_chisel_3" ) ) then

    cmn.CallEventHandler( "use_stone_inv" );
    cmn.CallEventHandler( "use_stone_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_stone" );
      cmn.CallEventHandler( "use_stone_end" );
      private.get_prv_flowerpot();
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_stone", 0, "", 0 );

    ObjSet( "spr_flowerbed_chisel", { alp = 0 } );
    ObjSet( "spr_flowerbed_prv_flowerpot", { alp = 0 } );
    ObjSet( "anm_flowerbed_use_stone", { alp = 1 } );
    AnimPlay( "anm_flowerbed_use_stone", "DoAnim", func_after );


  return true;

  elseif ( common.ApplyObj( item, "obj_flowerbed_use_stone", true ) and not cmn.IsEventDone( "use_chisel_3" ) ) then

    common_impl.ShowBbt( 'bbt_flowerbed_use_stone_wrong', 1 );

    return true;
  
  elseif common.ApplyObj( item, "gzz_mansion_flowerbed", false )and cmn.IsEventDone( "use_chisel_3" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_flowerbed", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_kidrake()

  local item = "inv_kidrake";


  if ( common.ApplyObj( item, "obj_porch_use_kidrake", true ) ) then

    cmn.CallEventHandler( "use_kidrake_inv" );
    cmn.CallEventHandler( "use_kidrake_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_kidrake" );
      cmn.CallEventHandler( "use_kidrake_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_kidrake", 0, "", 0 );
  
    --ObjAnimate( "spr_porch_rake", "alp", 0, 0, func_after,
    --{ 
    --  0.0, 0, 0.0, 
    --  0.3, 0, 1.0,
    --  0.6, 0, 0.0
    --} );
    --ObjAnimate( "spr_porch_sword_over_2", "alp", 0, 0, "",
    --{ 
    --  0.0, 0, 1.0, 
    --  0.3, 0, 1.0,
    --  0.6, 0, 0.0
    --} );

    AnimPlay( "anm_porch_use_kidrake", "DoAnim", func_after );

  return true;
  
  elseif common.ApplyObj( item, "gzz_mansion_porch", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_porch", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lockpiece()

  local item = "inv_lockpiece";

  if ( common.ApplyObj( item, "obj_porch_use_lockpiece", true ) and cmn.IsEventDone( "get_hammerdrill" ) ) then

    cmn.CallEventHandler( "use_lockpiece_inv" );
    cmn.CallEventHandler( "use_lockpiece_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_lockpiece" );
      cmn.CallEventHandler( "use_lockpiece_end" );
      common.CloseSubRoom();

    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_lockpiece", 0, "", 0 );
  
    ObjAnimate( "spr_porch_amulet", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );
    ObjAnimate( "spr_porch_amulet_shadow", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );
    ObjAnimate( "obj_porch_closed_door", "ang", 0, 0, "",
    { 
      0.0, 0, 0.0,
      0.6, 0, 0.0,
      0.9, 0, -0.1
    } );
    ObjAnimate( "obj_porch_closed_door", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0,
      0.9, 0, 1.0,
      1.3, 0, 0.0,
    } );
    ObjAnimate( "spr_porch_open_door", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0,
      0.9, 0, 0.0,
      1.3, 0, 1.0,
    } );
  
  return true;
  
  elseif ( common.ApplyObj( item, "gzz_mansion_porch", false ) and cmn.IsEventDone( "get_hammerdrill" ) )  then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_porch", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_stonesword()

  local item = "inv_stonesword";

  if ( common.ApplyObj( item, "obj_statue_use_stonesword", true ) ) then

    cmn.CallEventHandler( "use_stonesword_inv" );
    cmn.CallEventHandler( "use_stonesword_beg" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_stonesword" );
      cmn.CallEventHandler( "use_stonesword_end" );

      cmn.MiniGameShow( "statue" );
      common_impl.PassingMgStart( "statue" );

      ng_global.progress["std"]["win_statue"].PlayerPositions = { { 8, 6, 0, },
                                                                  { 4, 7, 3, },
                                                                  { 5, 2, 1  } };
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_stonesword", 0, "", 0 );
    
    ObjAnimate( "spr_statue_sword", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    ObjAnimate( "spr_statue_shield", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 1.0,
      0.6, 0, 0.0
    } );

    ObjAnimate( "spr_statue_shield_open", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.0,
      0.6, 0, 1.0
    } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_mansion_statue", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_statue", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_statue()

  local item = "inv_statue";

  if ( common.ApplyObj( item, "obj_statue_use_statue", true ) ) and ( cmn.IsEventDone( "win_statue" ) ) then

    cmn.CallEventHandler( "use_statue_inv" );
    cmn.CallEventHandler( "use_statue_beg" );

    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_statue" );
      cmn.CallEventHandler( "use_statue_end" );
    --common.CloseSubRoom();;
      
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_statuepiece", 0, "", 0 );
    
    ObjAnimate( "spr_statue_tree", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 1.0,
      0.9, 0, 1.0

    } );
    ObjAnimate( "spr_statue_door", "pos_xy", 0, 0, func_after,
    { 
      0.0, 0, 23, 18, 
      0.3, 0, 23, 18,
      0.9, 0, -4, 159,
    } );

    --[[ObjAnimate( "spr_statue_nishe_2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.0,
      0.6, 0, 0.0,
      0.9, 0, 1.0
    } );]]
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_mansion_statue", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_statue", nil, { 512, 384 } );

  return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_kidrake()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_kidrake" );
  cmn.CallEventHandler( "get_kidrake" );

end;
--------------------------------------------------------------------------------------------
function private.get_evidence_3_1()

  --common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  local func_end = function ()

    ObjSet( "spr_mansion_evidence_3_1", { pos_x = 512, pos_y = 384 } );
    interface.InvestigationButtonItemAdd( "evidence_3_1", "spr_flowerbed_evidence_3_1" );

    cmn.SetEventDone( "get_evidence_3_1" );
    cmn.CallEventHandler( "get_evidence_3_1" );

    if cmn.IsEventDone( "get_prv_flowerpot" ) and
       cmn.IsEventDone( "get_brush" ) and
       common_impl.IsGetCoin( "get_coin_21" ) and
       cmn.IsEventDone( "get_bottle_substance_b" ) then

      common.CloseSubRoom();

    end;

  end;
    
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  interface.DialogEvidenceShow( "evidence_3_1", func_end );
  common_impl.HideDeployInv();  

end;
--------------------------------------------------------------------------------------------
function private.get_porcelainowl()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_porcelainowl" );
  cmn.CallEventHandler( "get_porcelainowl" );

end;
--------------------------------------------------------------------------------------------
function private.get_brush()

  common_impl.PlayAudio( "sfx", "common/audio/aud_paper_open", 0, "", 0 );
  
  cmn.SetEventDone( "get_brush" );
  cmn.CallEventHandler( "get_brush" );

  if cmn.IsEventDone( "get_prv_flowerpot" ) and
     cmn.IsEventDone( "get_evidence_3_1" ) and
     common_impl.IsGetCoin( "get_coin_21" ) and
     cmn.IsEventDone( "get_bottle_substance_b" ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_bottle_substance_b()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_bottle_substance_b" );
  cmn.CallEventHandler( "get_bottle_substance_b" );

  if cmn.IsEventDone( "get_prv_flowerpot" ) and
     cmn.IsEventDone( "get_brush" ) and
     common_impl.IsGetCoin( "get_coin_21" ) and
     cmn.IsEventDone( "get_evidence_3_1" ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_prv_flowerpot()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_prv_flowerpot" );
  cmn.CallEventHandler( "get_prv_flowerpot" );

  if cmn.IsEventDone( "get_evidence_3_1" ) and
     cmn.IsEventDone( "get_brush" ) and
     common_impl.IsGetCoin( "get_coin_21" ) and
     cmn.IsEventDone( "get_bottle_substance_b" ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_hammerdrill()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_hammerdrill" );
  cmn.CallEventHandler( "get_hammerdrill" );

end;
--------------------------------------------------------------------------------------------
function private.get_stonesword()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_stonesword" );
  cmn.CallEventHandler( "get_stonesword" );

end;
--------------------------------------------------------------------------------------------
function private.get_porcelainkey()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_porcelainkey" );
  cmn.CallEventHandler( "get_porcelainkey" );

end;
--------------------------------------------------------------------------------------------
function private.get_prv_curtainrope()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_prv_curtainrope" );
  cmn.CallEventHandler( "get_prv_curtainrope" );

  if common_impl.IsGetCoin( "get_coin_20" ) then

    common.CloseSubRoom();

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
-----------------------------------------------------------------------------------------------------------------------
function private.get_collect_coin_20()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_20");
    cmn.CallEventHandler("get_coin_20");

    if cmn.IsEventDone( "get_prv_curtainrope" ) then
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_statue_coin", func_after ); 

end;
-----------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
function private.get_collect_coin_21()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_21");
    cmn.CallEventHandler("get_coin_21");

  if cmn.IsEventDone( "get_prv_flowerpot" ) and
     cmn.IsEventDone( "get_brush" ) and
     cmn.IsEventDone( "get_bottle_substance_b" ) then

    common.CloseSubRoom();

  end;    

  end;

  common_impl.PlayEffectHO( "spr_flowerbed_coin", func_after ); 

end;
-----------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
function private.opn_mansion()

  if not ( cmn.IsEventDone( "opn_mansion" ) ) then

    cmn.SetEventDone( "opn_mansion" );
    cmn.CallEventHandler( "opn_mansion_lock_map" ); 
    int_investigation_button.Show( true );

  end;
  
  cmn.CallEventHandler( "opn_mansion_map" ); 

end;
-----------------------------------------------------------------------------------------------------------------------
function private.vid_mansion_owlman()

  cmn.CallEventHandler( "vid_mansion_owlman_beg" );
  ObjSet( "vid_mansion_owlman", { alp = 1, active = true, input = false, visible = true } );
  
  local func_after = function ( skip )

    common_impl.AddPageDiary( 8 );

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_mansion_owlman" );
    cmn.CallEventHandler( "vid_mansion_owlman_end" );
    common_impl.ShowBbt( 'bbt_vid_mansion_owlman', 1 );

    interface.KeyTaskDone( "house_owlman", true );
    interface.KeyTaskAdd( 'find_owlman' );

    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment1_mus", 0, "", 0 );
 

    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_mansion_owlman", 0.5 );

    end;

  end;

  common_impl.StopTimer();

  common_impl.StopAllMus();
  interface.DialogVideoShow( "vid_mansion_owlman", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_mansion_owlman", function() func_after( nil ); end ); 
  common_impl.PlayAudio( "sfx", "common/audio/aud_mansion_owlman", 0, "", 0 );

end;
--*********************************************************************************************************************
-- function *** MMG Statue *** () end;
--*********************************************************************************************************************
function private.win_statue()

  cmn.MiniGameHide( "statue" );
  cmn.SetEventDone( "win_statue" );
  cmn.CallEventHandler( "win_statue" );
  common_impl.PassingMgWin( "statue" );

end;
--------------------------------------------------------------------------------------------------------------
function public.Skip ( event )

  for i = 1,3 do
    for j = 1,3 do
      ng_global.progress[ "std" ][ "win_statue" ].PlayerPositions[ i ][ j ] = private.winStatueMas[i][j];

      if ( ng_global.progress[ "std" ][ "win_statue" ].PlayerPositions[ i ][ j ]~=0 ) then
        
        posxNew = private.statuePositions[ i ][ j ][ 1 ];
        posyNew = private.statuePositions[ i ][ j ][ 2 ];
        ObjSet( "spr_statue_mmg_"..ng_global.progress[ "std" ][ "win_statue" ].PlayerPositions[ i ][ j ], { pos_x = posxNew, pos_y = posyNew } );

      end;
    end;
  end;

   private.WinAnim();

end;
--------------------------------------------------------------------------------------------------------------
function public.Reset ( event )

  for i = 1,3 do
    for j = 1,3 do
      ng_global.progress["std"]["win_statue"].PlayerPositions[ i ][ j ] = private.firstStatueMas[ i ][ j ];

      if ( ng_global.progress["std"]["win_statue"].PlayerPositions[ i ][ j ]~=0 ) then
        
        posxNew = private.statuePositions[i][j][1];
        posyNew = private.statuePositions[i][j][2];
        ObjSet( "spr_statue_mmg_"..ng_global.progress[ "std" ][ "win_statue" ].PlayerPositions[ i ][ j ], { pos_x = posxNew, pos_y = posyNew } );

      end;
    end;
  end;


end;
--------------------------------------------------------------------------------------------------------------
function private.ChangePosition ( num )

  local func_after = function ()

    private.Check( num );

  end;

  local posx = ObjGet( "spr_statue_mmg_"..num ).pos_x;
  local posy = ObjGet( "spr_statue_mmg_"..num ).pos_y;

  local posxNew;
  local posyNew;
  
  local posi;
  local posj;

  for i = 1, 3 do
    for j = 1, 3 do

      if ( ng_global.progress[ "std" ][ "win_statue" ].PlayerPositions[ i ][ j ] == num ) then

         posi = i;
         posj = j;

      elseif ( ng_global.progress[ "std" ][ "win_statue" ].PlayerPositions[ i ][ j ] == 0 ) then

         posi_null = i;
         posj_null = j;

      end;

    end;
  end;
  
  if ( ( math.abs( posi - posi_null ) == 1 ) and ( ( posj - posj_null ) == 0 ) ) or
     ( ( math.abs( posj - posj_null ) == 1 ) and ( ( posi - posi_null ) == 0 ) ) then

    posxNew = private.statuePositions[ posi_null ][ posj_null ][ 1 ];
    posyNew = private.statuePositions[ posi_null ][ posj_null ][ 2 ];

  end

  if ( not ( posxNew and posyNew ) ) then return; end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_statue_move", 0, "", 0 );

  ObjAnimate( "spr_statue_mmg_"..num, "pos_xy", 0, 0, func_after,
  { 
    0.0, 0,    posx,    posy,
    0.3, 0, posxNew, posyNew,
  } ); 

end;
--------------------------------------------------------------------------------------------------------------
function private.Check ( num )

  --[[local offset = { { -1, 0 }, { 1, 0 }, { 0, -1 }, { 0, 1 } };
  for i = 1, #offset do
    
    local i_cur = posi + offset[ i ][ 1 ];
    local j_cur = posj + offset[ i ][ 2 ];

    if ( i_cur > 0 ) and ( i_cur <= 3 ) and 
       ( j_cur > 0 ) and ( j_cur <= 3 ) and
       ( ng_global.progress[ "std" ][ "win_statue" ].PlayerPositions[ i_cur ][ j_cur ] == 0 ) then

        ng_global.progress[ "std" ][ "win_statue" ].PlayerPositions[ i_cur ][ j_cur ] = num;
        ng_global.progress[ "std" ][ "win_statue" ].PlayerPositions[ posi ][ posj ] = 0;

    end;

  end;]]

  local posi, posj, posi_null, posj_null;
  local tmp_array = {};

  for i = 1, 3 do
    
    tmp_array[ i ] = {};

    for j = 1, 3 do

      tmp_array[ i ][ j ] = ng_global.progress[ "std" ][ "win_statue" ].PlayerPositions[ i ][ j ]

      if ( tmp_array[ i ][ j ] == num ) then

         posi = i;
         posj = j;

      elseif ( tmp_array[ i ][ j ] == 0 ) then

        posi_null = i;
        posj_null = j;

      end;

    end;
  end;

  tmp_array[ posi ][ posj ] = 0;
  tmp_array[ posi_null ][ posj_null ] = num;

  local count = 0;
  
  for i = 1, 3 do

    for j = 1, 3 do

      if ( tmp_array[ i ][ j ] == private.winStatueMas[ i ][ j ] ) then
          
        count = count + 1;

      end;

    end;

  end;
  
  if ( count == 9 ) then

    private.WinAnim();
    
  else

    ng_global.progress[ "std" ][ "win_statue" ].PlayerPositions[ posi ][ posj ] = 0;
    ng_global.progress[ "std" ][ "win_statue" ].PlayerPositions[ posi_null ][ posj_null ] = num;

  end;

end;
--------------------------------------------------------------------------------------------------------------
function private.WinAnim ()

  local func_after = function ()

    common_impl.Lock( false );
    private.win_statue(); 

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_statue_win", 0, "", 0 );
 
  ObjAnimate( "obj_statue_mmg", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1,
    0.3, 0, 0 
  } ) ; 


end;

--*********************************************************************************************************************
-- function *** ANIMATIONS *** () end;
--*********************************************************************************************************************
function private.start_animations ()

  ObjAnimate( "spr_mansion_branch", "ang", 1, 0, "", 
  {  
    0.0,  3, 0, 
    5.0,  3, 0.02,
    9.5,  3, 0,
    11.8, 3, 0.015,
    15.9, 3, 0
  } );

  ObjAnimate( "spr_mansion_bush", "ang", 1, 0, "", 
  {  
    0.0,  3, 0.02,
    5.2,  3, -0.02,
    10.4, 3, 0.02
  } );

  ObjAnimate( "spr_mansion_grass", "ang", 1, 0, "", 
  {  
    0.0, 3, -0.02,
    4.0, 3, 0.02,
    8.0, 3, -0.02
  } );

  ObjAnimate( "spr_flowerbed_grass", "ang", 1, 0, "", 
  {  
    0.0, 3, 0,
    5.0, 3, -0.02,
    9.5, 3, 0
  } );

  ObjAnimate( "spr_flowerbed_grass_1", "ang", 1, 0, "", 
  {  
    0.0, 3, 0,
    4.0, 3, 0.03,
    8.0, 3, 0,
    11.0, 3, 0.025,
    14.0, 3, 0
  } );

end;
------------------------------------------------------------
function private.AnimationStatueShield ()

  local func_after = function ()

    common_impl.Lock(false);

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_statue_shield", 0, "", 0 );

  ObjAnimate( "spr_statue_shield", "ang",0, 0, func_after,
             { 0.0,0, 0, 
               0.2,0, -0.03, 
               0.4,0, 0,
               0.6,0, 0.03, 
               0.8,0, 0, 
            } ) ; 

end;
------------------------------------------------------------
------------------------------------------------------------
function private.AnimationBoard ()

  local func_after = function ()

    common_impl.Lock(false);

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_small_wood", 0, "", 0 );

  ObjAnimate( "anm_porch_use_kidrake", "ang",0, 0, func_after,
             { 0.0,0, 0, 
               0.3,0, 0.01, 
               0.6,0, 0,
            } ) ; 
end;
------------------------------------------------------------
------------------------------------------------------------
function private.AnimationOwl ()

  local func_after = function ()

    common_impl.Lock(false);

  end;

  common_impl.Lock(true);
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_books", 0, "", 0 );

  ObjAnimate( "spr_flowerbed_porcelainowl", "pos_xy",0, 0, func_after,
             { 0.0,0, 116, 117, 
               0.3,0, 113, 114,
               0.6,0, 116, 117,
            } ) ; 
end;
------------------------------------------------------------
function private.ClkOwl ()

  local func_after = function ()

    common_impl.Lock(false);
    ObjSet( "anm_mansion_owl", { res = "assets/levels/level3/rm_mansion/anims/anm_manson_owl" } );
    AnimPlay( "anm_mansion_owl", "DoAnim", "" );

  end;

  common_impl.Lock(true);
  common_impl.ShowBbt( 'bbt_manson_owl' );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_owl_mansion", 0, "", 0 );

  ObjSet( "anm_mansion_owl", { res = "assets/levels/level3/rm_mansion/anims/anm_manson_owl_click" } );
  AnimPlay( "anm_mansion_owl", "DoAnim", func_after );

end;
------------------------------------------------------------
function private.AnimationPaint ()

  local func_after = function ()

    common_impl.Lock(false);

  end;

  common_impl.ShowBbt( 'bbt_flowerbed_use_chisel' );
  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_rope", 0, "", 0 );

  ObjAnimate( "spr_flowerbed_brush", "ang",0, 0, "",
  { 0.0,  0, 0, 
    0.15, 0, -0.02,
    0.3,  0, 0,
  } ) ; 

  ObjAnimate( "spr_flowerbed_bottle_substance_b", "ang", 0, 0, func_after,
  { 0.0,  0, 0, 
    0.15, 0, 0.1,
    0.35, 3, -0.05,
    0.5,  3, 0
  } ) ; 

end;
------------------------------------------------------------