-- name=rm_mine_1_3
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_mine_1_3";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  
  ObjMultiSet({ 

    {"spr_controlunit_3_coin",   { event_mdown = private.get_coin18 } },
    {"spr_winch_3_coin",         { event_mdown = private.get_coin19 } },

    { "spr_mine_1_3_collect_item",    { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_2_3" );     end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_mine_1_3_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_5" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
 

  });
    ObjAnimate( "spr_mine_1_3_wire2", "ang", 1, 0, "", { 
    0, 0, 0, 
    2, 1, 0.05,
    6, 3, -0.05,
    8, 2, 0 } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mine_1_3 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_mine_1_3_winch_3",
    "gzz_mine_1_3_controlunit_3"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_mine_1_3", update_game_mode_mine_1_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_mine_1_3 = function ()

  local effects_table = 
  {
    "obj_mine_1_3_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_mine_1_3", update_performance_mode_mine_1_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_mine_1_3 () end;
  --------------------------------------------------------------------------------------------
  local opn_mine_1_3_map = function ()

    common_impl.VisitMapRoom( "mine_1" );
  
  end;
  
  cmn.AddSubscriber( "opn_mine_1_3", opn_mine_1_3_map ); 
  cmn.AddSubscriber( "opn_mine_1_3_map", opn_mine_1_3_map ); 
  --------------------------------------------------------------------------------------------
  -- function beg_level3 () end;
  --------------------------------------------------------------------------------------------
  local beg_level3 = function ()

    ObjSet( "spr_int_panel_providence", { alp = 1 } );
    interface.InventoryItemAdd( "inv_elf_3" );
    interface.InventoryItemAdd( "inv_map" );
    interface.InventoryItemAdd( "inv_hexkey" );
    interface.InventoryItemAdd( "inv_brokengasolinesaw3" );
    ObjSet( "inv_brokengasolinesaw3", { drag = false });
    common_impl.VisitMapRoom( "mine_2" );
    common_impl.LockMapRoom( "mine_2", true );
    --ObjSet( "inv_brokengasolinesaw3", { drag = false });

  end;
  cmn.AddSubscriber( "beg_level3", beg_level3 );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_2_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_2_3 = function ()
  
    ObjDelete( "obj_mine_1_3_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_2_3", get_collect_item_2_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_5 = function ()
  
    ObjDelete( "obj_mine_1_3_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_5", get_collect_morph_item_2_5, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_coins () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_18 = function ()
 
    ObjDelete( "obj_controlunit_3_coin" );
    ObjDelete( "gzz_mine_1_3_controlunit_3" );

  end;
  cmn.AddSubscriber( "get_coin_18", get_collect_coin_18, private.room_objname );
  --------------------------------------------------------------------------------------------
  local get_collect_coin_19 = function ()
 
    ObjDelete( "obj_winch_3_coin" );
    ObjDelete( "gzz_mine_1_3_winch_3" );
    
  end;
  cmn.AddSubscriber( "get_coin_19", get_collect_coin_19, private.room_objname );
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_mine_1_3();
  
  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();

  if ( not cmn.IsEventDone( "beg_level3" ) ) then

    cmn.SetEventDone( "beg_level3" );
    cmn.CallEventHandler( "beg_level3" );

    common_impl.UpdateGameMode( ng_global.gamemode );

  end;

  common_impl.MorphItemMorphing();
  interface.InvestigationButtonCheck();

  common_impl.EnvPlay( { "common/audio/aud_mine1_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_coin18()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_18");
    cmn.CallEventHandler("get_coin_18");
    common.CloseSubRoom();
  
  end;

  common_impl.PlayEffectHO( "spr_controlunit_3_coin", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_coin19()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_19");
    cmn.CallEventHandler("get_coin_19");
    common.CloseSubRoom();
     
  end;

  common_impl.PlayEffectHO( "spr_winch_3_coin", func_after ); 

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_mine_1_3()
  
  if not ( cmn.IsEventDone( "opn_mine_1_3" ) ) then

    local open_rooms = { "pier_3", "square_3", "fork_3", "livingroom_3", "office_3", "basement_3", "abandoneddistrict_3",
                          "mine_2_3", "mineentrance_3", "glade_3", "nightsvilleentrance_3", "nightsville_3", "mine_1_3"  };

    for i = 1, #open_rooms do

      cmn.SetEventDone( "opn_"..open_rooms[i] );
      cmn.CallEventHandler( "opn_"..open_rooms[i] );
   
    end;

    interface.KeyTaskAdd( 'house_owlman' ); 
    
  end;
  
  cmn.CallEventHandler( "opn_mine_1_3_map" ); 

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--                                             Light_Animations
--*********************************************************************************************************************
ObjAnimate( "spr_mine_1_3_light_small_1", "alp", 1, 0, "", 

  { 
    0.0, 3, 1.0, 
    0.3, 3, 0.2, 
    4.0, 3, 1.0, 
    4.0, 3, 0.0, 
    4.1, 3, 0.6, 
    4.2, 3, 0.0, 
    4.3, 3, 0.1, 
    7.4, 3, 1.0, 
    7.6, 3, 0.6, 
    8.0, 3, 1.0, 

  });

ObjAnimate( "spr_mine_1_3_light_small_2", "alp", 1, 0, "", 

  { 
    0.0, 3, 1.0, 
    2.0, 3, 0.1, 
    4.1, 3, 1.0, 
    6.0, 3, 0.3, 
    8.1, 3, 0.9, 
    9.2, 3, 0.3, 
    15.3, 3, 1.0, 

  });

ObjAnimate( "spr_mine_1_3_light_great_1", "alp", 1, 0, "", 

  { 
     0.0, 3, 1.0, 
     4.0, 3, 0.1, 
     7.1, 3, 1.0, 
    16.0, 3, 0.3, 
    21.1, 3, 0.9, 
    23.2, 3, 0.3, 
    25.3, 3, 1.0, 

  });

ObjAnimate( "spr_mine_1_3_light_great_2", "alp", 1, 0, "", 

  { 
    0.0, 3, 1.0, 
    7.0, 3, 1.0,
    7.1, 3, 0.0,
    7.2, 3, 1.0, 
    7.3, 3, 0.0, 
    7.4, 3, 1.0, 
    7.5, 3, 0.0,
    7.6, 3, 1.0, 
    7.7, 3, 0.0,
    7.8, 3, 1.0, 
   15.4, 3, 1.0,   

  });

--*********************************************************************************************************************
--*********************************************************************************************************************