-- name=rm_mineentrance_3
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_mineentrance_3";
  --------------------------------------------------------------------------------------------
  ObjMultiSet({ 
    { "spr_cart_3_coin",                 { event_mdown = private.get_coin16 } },
    { "spr_trailr_3_coin",               { event_mdown = private.get_coin17 } },

    { "spr_mineentrance_3_collect_item",    { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_2_2" );     end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_mineentrance_3_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_4" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
 
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_mineentrance_3 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_mineentrance_3_cart_3",
    "gzz_mineentrance_3_trailr_3"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_mineentrance_3", update_game_mode_mineentrance_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_mineentrance_3 = function ()

  local effects_table = 
  {
    "obj_mineentrance_3_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_mineentrance_3", update_performance_mode_mineentrance_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_mineentrance_3 () end;
  --------------------------------------------------------------------------------------------
  local opn_mineentrance_3_map = function ()

    common_impl.VisitMapRoom( "mineentrance" );

  end;
  cmn.AddSubscriber( "opn_mineentrance_3", opn_mineentrance_3_map );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_2_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_2_2 = function ()
  
    ObjDelete( "obj_mineentrance_3_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_2_2", get_collect_item_2_2, private.room_objname );
   --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_4 = function ()
  
    ObjDelete( "obj_mineentrance_3_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_4", get_collect_morph_item_2_4, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_coins () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_16 = function ()
 
    ObjDelete( "obj_cart_3_coin" );
    ObjDelete( "gzz_mineentrance_3_cart_3" );
    
  end;
  cmn.AddSubscriber( "get_coin_16", get_collect_coin_16, private.room_objname );
  --------------------------------------------------------------------------------------------
  local get_collect_coin_17 = function ()
 
    ObjDelete( "obj_trailr_3_coin" );
    ObjDelete( "gzz_mineentrance_3_trailr_3" );
  
  end;
  cmn.AddSubscriber( "get_coin_17", get_collect_coin_17, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Open()

  private.opn_mineentrance_3();
  
  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();

  common_impl.MorphItemMorphing();
  interface.InvestigationButtonCheck();

  common_impl.EnvPlay( { "common/audio/aud_mineentrance_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_coin16()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_16");
    cmn.CallEventHandler("get_coin_16");

    common.CloseSubRoom();
    
  end;

  common_impl.PlayEffectHO( "spr_cart_3_coin", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_coin17()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_17");
    cmn.CallEventHandler("get_coin_17");

    common.CloseSubRoom();
      
  end;

  common_impl.PlayEffectHO( "spr_trailr_3_coin", func_after ); 

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_mineentrance_3()
  
  cmn.CallEventHandler( "opn_mineentrance_3" ); 

end;
--*********************************************************************************************************************