-- name=rm_nightsville_3
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_nightsville_3";
  --------------------------------------------------------------------------------------------
  
  ObjMultiSet({ 

    { "spr_fireequipment_3_coin", { event_mdown = private.get_coin14 } },
    { "spr_pavement_3_coin", { event_mdown = private.get_coin15 } },
    { "spr_nightsville_3_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
 
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_nightsville_3 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gmg_nightsville_3_pathfind",
    "gzz_nightsville_3_fireequipment_3",
    "gzz_nightsville_3_pavement_3"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_nightsville_3", update_game_mode_nightsville_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_nightsville_3 = function ()

  local effects_table = 
  {
    "anm_nightsville_3_light",
    "anm_pavement_3_crab_static",
    "anm_pavement_3_grass"     
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_nightsville_3", update_performance_mode_nightsville_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_nightsville_3 () end;
  --------------------------------------------------------------------------------------------
  local opn_nightsville_3_map = function ()

    common_impl.VisitMapRoom( "nightsville" );

  end;
  cmn.AddSubscriber( "opn_nightsville_3", opn_nightsville_3_map );
  local win_pathfind_loc = function ()

    if cmn.IsEventDone( "win_pathfind" ) then

      ObjSet( "grm_nightsville_3_mansion", { input = true, active = true, visible = true } );
      ObjDelete( "gmg_nightsville_3_pathfind" );
      if port.isPortable() == 1 then
          port.GrmEventLightOn("grm_nightsville_3_mansion_focus");
      end;
    end;

  end;
  cmn.AddSubscriber( "win_pathfind", win_pathfind_loc );
  --------------------------------------------------------------------------------------------
  -- function use_map () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_map" ] = {
    type = "use",
    inv_obj = "inv_map",
    use_place = "obj_nightsville_3_use_map",
    room = private.room_objname
  };
  local use_map_inv = function ()
  
    interface.InventoryItemRemove( "inv_map" );
  
  end;
  local use_map_beg = function ()
  
    ObjDelete( "obj_nightsville_3_use_map" );
  
  end;
  local use_map_end = function ()
  
    ObjMultiSet({ 
      { "gmg_nightsville_3_pathfind", { input = true, active = true } },
      { "grm_nightsville_3_pathfind_focus", { alp = 1 } },
      { "spr_nightsville_3_map", { alp = 1 } }
    });
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_nightsville_3_pathfind_focus");
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_map", use_map_beg, private.room_objname );
  cmn.AddSubscriber( "use_map", use_map_inv );
  cmn.AddSubscriber( "use_map", use_map_end, private.room_objname );
  cmn.AddSubscriber( "use_map_inv", use_map_inv, private.room_objname );
  cmn.AddSubscriber( "use_map_beg", use_map_beg, private.room_objname );
  cmn.AddSubscriber( "use_map_end", use_map_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_coins () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_14 = function ()
 
    ObjDelete( "obj_fireequipment_3_coin" );
    ObjDelete( "gzz_nightsville_3_fireequipment_3" );
    
  end;
  cmn.AddSubscriber( "get_coin_14", get_collect_coin_14, private.room_objname );
  --------------------------------------------------------------------------------------------
  local get_collect_coin_15 = function ()
 
    ObjDelete( "obj_pavement_3_coin" );
    ObjDelete( "gzz_nightsville_3_pavement_3" );
       
  end;
  cmn.AddSubscriber( "get_coin_15", get_collect_coin_15, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_3 = function ()
  
    ObjDelete( "obj_nightsville_3_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_3", get_collect_morph_item_2_3, private.room_objname );
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Open()

  private.opn_nightsville_3();
  
  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.MorphItemMorphing();
  interface.InvestigationButtonCheck();
  if ( cmn.IsEventDone( "use_map" ) and not cmn.IsEventDone( "win_pathfind" ) ) then

    ObjAnimate( "grm_nightsville_3_pathfind_focus", "alp", 1, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.6,
      0.6, 0, 1.0
    } );

  end;

  common_impl.EnvPlay( { "common/audio/aud_nightsville_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_map()

  local item = "inv_map";

  if ( common.ApplyObj( item, "obj_nightsville_3_use_map", false ) ) then

    cmn.CallEventHandler( "use_map_inv" );
    cmn.CallEventHandler( "use_map_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_map" );
      cmn.CallEventHandler( "use_map_end" );
      ObjAnimate( "grm_nightsville_3_pathfind_focus", "alp", 1, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.6,
        0.6, 0, 1.0
      } );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_map", 0, "", 0 );
  
    ObjAnimate( "spr_nightsville_3_map", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
    return true;
  
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_coin14()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_14");
    cmn.CallEventHandler("get_coin_14");
    common.CloseSubRoom();
   
  end;

  common_impl.PlayEffectHO( "spr_fireequipment_3_coin", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_coin15()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_15");
    cmn.CallEventHandler("get_coin_15");
    common.CloseSubRoom();

  end;

  common_impl.PlayEffectHO( "spr_pavement_3_coin", func_after ); 

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_nightsville_3()
    
  cmn.CallEventHandler( "opn_nightsville_3" );

end;
--*********************************************************************************************************************