-- name=rm_nightsvilleentrance_3
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_nightsvilleentrance_3";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_hole_3", "room_hub" );
  
  ObjMultiSet({ 
    { "spr_hole_3_coin",                            { event_mdown = private.get_coin11 } },
    { "grm_nightsvilleentrance_3_nightsville_3" ,     { event_mdown = function() cmn.GotoRoom( 'rm_nightsville_3' ); end }},
    { "spr_nightsvilleentrance_3_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_2_1" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
 
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_nightsvilleentrance_3 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_nightsvilleentrance_3_hole_3"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_nightsvilleentrance_3", update_game_mode_nightsvilleentrance_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_nightsvilleentrance_3 = function ()

  local effects_table = 
  {
    "obj_nightsvilleentrance_3_anim",
    "anm_nightsvilleentrance_3_bushes_open",
    "anm_hightsvilleentrance_3_bushes_1",
    "anm_hightsvilleentrance_3_bushes_2",
    "anm_nightsvilleentrance_3_anim",
    "anm_hole_3_foliage",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_nightsvilleentrance_3", update_performance_mode_nightsvilleentrance_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_nightsvilleentrance () end;
  --------------------------------------------------------------------------------------------
  local opn_nightsvilleentrance_3_map = function ()

    common_impl.VisitMapRoom( "nightsvilleentrance" );

  end;
  cmn.AddSubscriber( "opn_nightsvilleentrance_3", opn_nightsvilleentrance_3_map, nil );
  --------------------------------------------------------------------------------------------
  -- function get_coins () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_11 = function ()
 
    ObjDelete( "obj_hole_3_coin" );     
    ObjDelete( "gzz_nightsvilleentrance_3_hole_3" );
  
  end;
  cmn.AddSubscriber( "get_coin_11", get_collect_coin_11, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_2_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_2_1 = function ()
  
    ObjDelete( "obj_nightsvilleentrance_3_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_2_1", get_collect_morph_item_2_1, private.room_objname );
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_nightsvilleentrance();
--
--  int_providence_eye.CheckShow();


  int_slider.InitSlider( private.room_objname );


end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.MorphItemMorphing(); 
  common_impl.EnvPlay( { "common/audio/aud_nightsvilleentrance_env" }, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close()
  
  int_slider.CloseSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreClose()


end;

--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_coin11()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_11" );
    cmn.CallEventHandler( "get_coin_11" );
    common.CloseSubRoom();   
  
  end;
  
  common_impl.PlayEffectHO( "spr_hole_3_coin", func_after ); 
  
end;
-------------------------------------------------------------------------------------
--*********************************************************************************************************************
function private.opn_nightsvilleentrance()

  cmn.CallEventHandler( "opn_nightsvilleentrance_3" );

end;
--*********************************************************************************************************************