-- name=rm_pier_3
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_pier_3";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_things", "room_hub" );
  ObjAttach( "zz_boat", "room_hub" );
  ObjAttach( "zz_gateway", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_things_fuelsaw", { event_mdown = private.get_fuelsaw }},
    { "spr_things_tweezers", { event_mdown = private.get_tweezers }},
    { "spr_things_hexkey", { event_mdown = private.get_hexkey }},
    { "spr_things_burner", { event_mdown = private.get_burner }},
    { "spr_boat_crowbar_4", { event_mdown = private.get_crowbar_4 }},
    { "vid_pier_3_elf", { event_mdown = private.get_elf }},
    { "spr_things_sack_close", { event_mdown = private.get_bag_2 }},
    { "obj_things_clk_bag", { event_mdown = private.clk_bag }},
    { "obj_boat_use_elf", { event_mdown = private.clk_boat } },
    { "obj_pier_3_clk_poster", { event_mdown = function () common_impl.NoteScale( "open", "spr_pier_3_poster" ); common_impl.ShowBbt( 'bbt_pier_clk_poster', 1 ); end } },    
    { "spr_pier_3_poster_big", { event_mdown = function () common_impl.NoteScale( "close", "spr_pier_3_poster" ) end } },    
    { "spr_pier_3_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_1" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "obj_things_use_crowbar_4", { event_mdown = private.clk_lock } },
    { "spr_pier_3_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_1_1" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },

  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_pier_3 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_pier_3_things",
    "gzz_pier_3_boat",
    "gzz_pier_3_gateway"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_things",
      "zz_boat",
      "zz_gateway"
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_pier_3", update_game_mode_pier_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_pier_3 = function ()

  local effects_table = 
  {
    "obj_pier_3_anim",
    "anm_boat_boat",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_pier_3", update_performance_mode_pier_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_pier_3 () end;
  --------------------------------------------------------------------------------------------
  local opn_pier_3_map = function ()

    common_impl.VisitMapRoom( "pier" );

  end;
 cmn.AddSubscriber( "opn_pier_3", opn_pier_3_map );
 --------------------------------------------------------------------------------------------
  -- function get_collect_item_1_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_1_1 = function ()
  
    ObjDelete( "obj_pier_3_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_1_1", get_collect_item_1_1, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function win_hos () end;
  --------------------------------------------------------------------------------------------
  local win_hos_loc = function ()

    ObjDelete( "spr_pier_3_boat_1" );    
    ObjMultiSet( { 
      { "spr_pier_3_boat_2", { visible = true } },
      { "spr_pier_3_closed_gate", { visible = true } },
      { "spr_pier_3_open_gate", { visible = false } },
      { "spr_pier_3_cordage", { visible = true } },
      { "vid_pier_3_elf", { visible = true, input = true } },
      { "gzz_pier_3_things", { active = true, input = true } },
      { "gzz_pier_3_boat", { active = true,  input = true } },
      { "gzz_pier_3_gateway", { active = true, input = true } },
      { "grm_pier_3_fork_3", { visible = false, input = false } },
      { "obj_pier_3_zz_things", { visible = true } } } );

    if port.isPortable() == 1 then
        port.GrmEventLightOff("grm_pier_3_fork_3_focus");
    end;
    

  end;
 cmn.AddSubscriber( "win_hos", win_hos_loc, private.room_objname );
   --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_1 = function ()
  
    ObjDelete( "obj_pier_3_morph" );

  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_1", get_collect_morph_item_1_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_burner () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_burner" ] = {
    type = "get",
    get_obj = "spr_things_burner",
    room = private.room_objname,
    zz = "zz_things",
    zz_gate = "gzz_pier_3_things"
  };
    
  local get_burner_inv = function ()
  
    interface.InventoryItemAdd( "inv_burner", "spr_things_burner" );
  
  end;
  
  local get_burner_closezz = function ()
  
    ObjDelete( "gfx_things_burner" );
    ObjDelete( "spr_pier_3_burner" );

    if cmn.IsEventDone( "get_bag_2" ) then

      ObjDelete( "gzz_pier_3_things" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_burner", get_burner_inv );
  cmn.AddSubscriber( "get_burner", get_burner_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bag_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bag_2" ] = {
    type = "get",
    get_obj = "spr_things_sack_close",
    room = private.room_objname,
    zz = "zz_things",
    zz_gate = "gzz_pier_3_things"
  };
    
  local get_bag_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_tweezers_2", "spr_things_sack_close" );
    interface.InventoryItemAdd( "inv_hexkey", "" );
    interface.InventoryItemAdd( "inv_brokengasolinesaw3", "" );
    ObjMultiSet({ 
      { "inv_brokengasolinesaw3", { drag = false }},
    });

  end;
  
  local get_bag_2_closezz = function ()

    ObjDelete( "gfx_things_sack" );
    ObjDelete( "spr_things_sack_shadow" );
    ObjDelete( "spr_pier_3_bag" );
    if cmn.IsEventDone( "get_burner" ) then

      ObjDelete( "gzz_pier_3_things" );

    end;

  end;

  cmn.AddSubscriber( "get_bag_2", get_bag_2_inv );
  cmn.AddSubscriber( "get_bag_2", get_bag_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_crowbar_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_crowbar_4" ] = {
    type = "get",
    get_obj = "spr_boat_crowbar_4",
    room = private.room_objname,
    zz = "zz_boat",
    zz_gate = "gzz_pier_3_boat"
  };
    
  local get_crowbar_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_crowbar_4", "spr_boat_crowbar_4" );
  
  end;
  
  local get_crowbar_4_closezz = function ()
  
    ObjDelete( "gfx_boat_crowbar_4" );
    ObjDelete( "gzz_pier_3_boat" );
  
  end;
  
  cmn.AddSubscriber( "get_crowbar_4", get_crowbar_4_inv );
  cmn.AddSubscriber( "get_crowbar_4", get_crowbar_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_elf () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_elf_3" ] = {
    type = "get",
    get_obj = "vid_pier_3_elf",
    room = private.room_objname
  };
    
  local get_elf_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_elf_3", "vid_pier_3_elf" );
  
  end;
  
  local get_elf_3_closezz = function ()
  
    ObjDelete( "gfx_pier_3_elf" );
    ObjDelete( "vid_pier_3_elf_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_elf_3", get_elf_3_inv );
  cmn.AddSubscriber( "get_elf_3", get_elf_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_crowbar_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_crowbar_4" ] = {
    type = "use",
    inv_obj = "inv_crowbar_4",
    use_place = "obj_things_use_crowbar_4",
    room = private.room_objname,
    zz = "zz_things",
    zz_gate = "gzz_pier_3_things"
  };
  local use_crowbar_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_crowbar_4" );
  
  end;
  local use_crowbar_4_beg = function ()

    ObjDelete( "spr_things_lock_1" );
    ObjDelete( "obj_things_use_crowbar_4" );
  
  end;
  local use_crowbar_4_end = function ()
      
    ObjMultiSet({ 
      { "obj_things_open",       { alp = 1, input = true     }},
      { "gfx_things_burner",     { active = true    }},
      { "spr_pier_3_box_open",     { visible = true    }},
    });

    ObjDelete( "spr_things_lock_1" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_crowbar_4", use_crowbar_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_4", use_crowbar_4_inv );
  cmn.AddSubscriber( "use_crowbar_4", use_crowbar_4_end, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_4_inv", use_crowbar_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_4_beg", use_crowbar_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_crowbar_4_end", use_crowbar_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_elf_10 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_elf_10" ] = {
    type = "use",
    inv_obj = "inv_elf_3",
    use_place = "obj_boat_use_elf",
    room = private.room_objname,
    zz = "zz_boat",
    zz_gate = "gzz_pier_3_boat"
  };
  local use_elf_10_inv = function ()
  
    --interface.InventoryItemRemove( "inv_elf_3" );
  
  end;
  local use_elf_10_beg = function ()
  
    ObjDelete( "obj_boat_use_elf" );
    ObjDelete( "spr_boat_crowbar_4_1" );    

  end;
  local use_elf_10_end = function ()
  
    ObjSet( "spr_boat_crowbar_4", { input = true, active = true, visible = true } );
    ObjSet( "spr_boat_crowbar_4_sh", { visible = true } );
    ObjDelete( "vid_boat_use_elf_10" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_elf_10", use_elf_10_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_10", use_elf_10_inv );
  cmn.AddSubscriber( "use_elf_10", use_elf_10_end, private.room_objname );
  cmn.AddSubscriber( "use_elf_10_inv", use_elf_10_inv, private.room_objname );
  cmn.AddSubscriber( "use_elf_10_beg", use_elf_10_beg, private.room_objname );
  cmn.AddSubscriber( "use_elf_10_end", use_elf_10_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_burner () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_burner" ] = {
    type = "use",
    inv_obj = "inv_burner",
    use_place = "obj_gateway_use_burner",
    room = private.room_objname,
    zz = "zz_gateway",
    zz_gate = "gzz_pier_3_gateway"
  };
  local use_burner_inv = function ()
  
    interface.InventoryItemRemove( "inv_burner" );

    local lock_rooms = { "square", "fork", "livingroom", "office", "basement", "abandoneddistrict" };

      for j = 1, #lock_rooms do

        common_impl.LockMapRoom( lock_rooms[j], false );

      end;
  
  end;
  local use_burner_beg = function ()
  
    ObjDelete( "obj_gateway_use_burner" );
  
  end;
  local use_burner_end = function ()
  
    ObjSet( "grm_pier_3_fork_3", { input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_pier_3_fork_3_focus");
    end;
    ObjDelete( "gzz_pier_3_gateway" );
    ObjSet( "spr_pier_3_open_gate", { visible = true } );
    ObjSet( "spr_gateway_rope_2", { alp = 1 } );
    ObjDelete( "spr_pier_3_closed_gate" );
    ObjDelete( "spr_pier_3_cordage" );
    ObjDelete( "vid_gateway_burner" );
    ObjDelete( "spr_gateway_rope_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_burner", use_burner_beg, private.room_objname );
  cmn.AddSubscriber( "use_burner", use_burner_inv );
  cmn.AddSubscriber( "use_burner", use_burner_end, private.room_objname );
  cmn.AddSubscriber( "use_burner_inv", use_burner_inv, private.room_objname );
  cmn.AddSubscriber( "use_burner_beg", use_burner_beg, private.room_objname );
  cmn.AddSubscriber( "use_burner_end", use_burner_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_bag () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_bag" ] = {
    type = "click",
    use_place = "spr_things_sack",
    room = private.room_objname,
    zz = "zz_things",
    zz_gate = "gzz_pier_3_things"
  };
  local clk_bag_beg = function ()

    ObjDelete( "obj_things_clk_bag" );

  end;
  local clk_bag_end = function ()

    ObjMultiSet({ 
      { "spr_things_sack_close", { event_mdown = private.get_bag_2, input = true }},
      { "spr_things_sack", { alp = 1 }},
      { "gfx_things_sack", { active = true }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_bag", clk_bag_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bag", clk_bag_end, private.room_objname );
  cmn.AddSubscriber( "clk_bag_beg", clk_bag_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bag_end", clk_bag_end, private.room_objname );


end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
end;
--*********************************************************************************************************************
function public.Open()

  common_impl.EnvPlay( { "common/audio/aud_pier_env" }, "", 0.5 );

  private.opn_pier_3();
  
  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();
  interface.InvestigationButtonCheck();

  if common_impl.pier_3 then

    common_impl.pier_3.note = "close";

  else 

    common_impl.pier_3 = {}
    common_impl.pier_3.note = "close";

  end;

end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_crowbar_4()

  local item = "inv_crowbar_4";

  if ( common.ApplyObj( item, "obj_things_use_crowbar_4", true ) ) then

    cmn.CallEventHandler( "use_crowbar_4_inv" );
    cmn.CallEventHandler( "use_crowbar_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_crowbar_4" );
      cmn.CallEventHandler( "use_crowbar_4_end" );
    --common.CloseSubRoom();
    
  end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_crowbar_things", 0, "", 0 );

    ObjSet( "anm_things_use_crowbar_4", { playing = true, alp = 1, endtrig = func_after } );

    return true;
  
  elseif common.ApplyObj( item, "gzz_pier_3_things", false ) and common_impl.pier_3.note == "close" then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_things", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_elf_10()

  local item = "inv_elf_3";

  if ( common.ApplyObj( item, "obj_boat_use_elf", true ) ) then

    cmn.CallEventHandler( "use_elf_10_inv" );
    cmn.CallEventHandler( "use_elf_10_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_elf_10" );
      cmn.CallEventHandler( "use_elf_10_end" );
      interface.InventoryItemAdd( "inv_elf_3", "spr_boat_crowbar_4_elf" );
    --common.CloseSubRoom();

      ObjSet( "spr_boat_crowbar_4_elf", { alp = 1 });
      
    end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_boat_elf", 0, "", 0 );

  interface.InventoryItemRemove( "inv_elf_3" );

  ObjSet( "vid_boat_use_elf_10", { alp = 1, playing = true, endtrig = func_after } );

  return true;
  
  elseif common.ApplyObj( item, "gzz_pier_3_boat", false ) and common_impl.pier_3.note == "close" then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_boat", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_burner()

  local item = "inv_burner";

  if ( common.ApplyObj( item, "obj_gateway_use_burner", true ) ) then

    cmn.CallEventHandler( "use_burner_inv" );
    cmn.CallEventHandler( "use_burner_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );

      interface.KeyTaskDone( "get_out", true );      

      cmn.SetEventDone( "use_burner" );
      cmn.CallEventHandler( "use_burner_end" );
      common.CloseSubRoom();
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_gateway_burner", 0, "", 0 );

    ObjSet( "spr_gateway_rope_1", { alp = 0 });
    ObjSet( "vid_gateway_burner", { active = true, alp = 1 });

    VidPlay( "vid_gateway_burner", func_after );

    return true;
  
  elseif common.ApplyObj( item, "gzz_pier_3_gateway", false ) and common_impl.pier_3.note == "close" then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_gateway", nil, { 512, 384 } );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_fuelsaw()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_fuelsaw" );
  cmn.CallEventHandler( "get_fuelsaw" );

end;
--------------------------------------------------------------------------------------------
function private.get_tweezers()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_tweezers" );
  cmn.CallEventHandler( "get_tweezers" );

end;
--------------------------------------------------------------------------------------------
function private.get_hexkey()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_hexkey" );
  cmn.CallEventHandler( "get_hexkey" );

end;
--------------------------------------------------------------------------------------------
function private.get_burner()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  if cmn.IsEventDone( "get_bag_2" ) then

    common.CloseSubRoom();

  end;  
  cmn.SetEventDone( "get_burner" );
  cmn.CallEventHandler( "get_burner" );

end;
--------------------------------------------------------------------------------------------
function private.get_crowbar_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_crowbar_4" );
  cmn.CallEventHandler( "get_crowbar_4" );
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_elf()

  common_impl.AddPageDiary( 10 );

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_elf_3" );
  cmn.CallEventHandler( "get_elf_3" );

  interface.KeyTaskAdd( 'get_out' ); 

end;
--------------------------------------------------------------------------------------------
function private.get_bag_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  if cmn.IsEventDone( "get_burner" ) then

    common.CloseSubRoom();

  end;
  cmn.SetEventDone( "get_bag_2" );
  cmn.CallEventHandler( "get_bag_2" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_bag()

  local func_after = function ()

    cmn.SetEventDone( "clk_bag" );
    cmn.CallEventHandler( "clk_bag_end" );

    common_impl.Lock( false )

  end;

  cmn.CallEventHandler( "clk_bag_beg" )

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_bag", 0, "", 0 );

  ObjAnimate( "spr_things_sack", "alp", 0,0, func_after, { 0,3,0, 0.4,3,1 } );

end;
--------------------------------------------------------------------------------------------
function private.clk_lock()

  local func_after = function ()

    common_impl.Lock( false );
    common_impl.ShowBbt( 'bbt_things_use_crowbar' );

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_things", 0, "", 0 );

  common_impl.Lock( true );

  ObjAnimate( "spr_things_lock_1", "pos_y", 0,0, func_after, 
  { 
    0.0, 0, -31,
    0.3, 0, -33,
    0.6, 0, -31
  } );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_pier_3()
  
  cmn.CallEventHandler( "opn_pier_3" ); 

end;
--*********************************************************************************************************************