-- name=rm_secretroom
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_secretroom";
  --------------------------------------------------------------------------------------------
  private.tumb_win = { 2, 1, 3 };
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_workbench", "room_hub" );
  ObjAttach( "zz_grizzlyskin", "room_hub" );
  ObjAttach( "zz_pictures", "room_hub" );

  private.right_coord = {};

  private.right_coord[1] = { { 97, -134 }, { 112, 95 }, { -57, 103 }, { -71, -90 } };
  private.right_coord[2] = { { 97, -134 }, { -88, 95 }, { 79, 103 }, { -71, -90 } };

  private.picture_start_pos = { { -254, - 62 }, { 268, -147 }, { -215 , 150 }, { 262, 161 } };
  private.Init_Subroom();
  

  table_multiset = {};

  ObjMultiSet({ 

    { "spr_workbench_gnomefragment",  { event_mdown = private.get_gnomefragment }},
    { "spr_workbench_button_2",       { event_mdown = private.get_button_2      }},
    { "spr_workbench_awl",            { event_mdown = private.get_awl           }},
    { "spr_workbench_evidence_3_5",   { event_mdown = private.get_evidence_3_5  }},
    { "spr_secretroom_evidence_3_6",   { event_mdown = private.get_evidence_3_6  }},
    { "spr_grizzlyskin_gear_3",       { event_mdown = private.get_gear_3        }},
    { "spr_grizzlyskin_framedphoto",  { event_mdown = private.get_framedphoto   }},
    { "spr_breaker_lighter_night",       { event_mdown = private.get_lighter       }},
    --
    { "obj_secretroom_prv_item_1",    { event_mdown = function() int_providence.Thinking( "providence_1", "obj_secretroom_prv_item_1" ) end }},
    { "obj_secretroom_prv_item_2",    { event_mdown = function() int_providence.Thinking( "providence_2", "obj_secretroom_prv_item_2" ) end }},

    { "spr_secretroom_prv_plate",      { event_startdrag = private.drag_plate, event_dragdrop = private.drop_plate  }},
    { "spr_secretroom_prv_towldummy",  { event_startdrag = private.drag_towldummy, event_dragdrop = private.drop_towldummy  }},
    { "obj_secretroom_use_prv_item_1", { event_mdown = private.get_prv_gnomehead_silhouette }},
    { "obj_secretroom_use_prv_item_2", { event_mdown = private.get_prv_gun_silhouette }},
    --
    { "obj_workbench_clk_vicehandle",  { event_mdown = private.clk_vicehandle }},
    { "obj_dlg_secretroom_oliver",     { event_mdown = private.dlg_secretroom_oliver }},
    { "obj_dlg_secretroom_oliver_focus",{ event_mdown = private.dlg_secretroom_oliver }},
    { "obj_workbench_use_vicehandle", { event_mdown = private.clk_button_2 }},
    { "obj_breaker_clk_switch_1",     { event_mdown = private.clk_switch_1 }},
    { "obj_breaker_tumb_1",     { event_mdown = function() private.ClkItem( 1 ) end }},
    { "obj_breaker_tumb_2",     { event_mdown = function() private.ClkItem( 2 ) end }},
    { "obj_breaker_tumb_3",     { event_mdown = function() private.ClkItem( 3 ) end }},
    { "obj_grizzlyskin_clk_bearskin",     { event_mdown = private.clk_bearskin  }},
    { "obj_grizzlyskin_use_tweezers",     { event_mdown = private.clk_gear  }},
    { "spr_secretroom_oliver_paper_1" ,   { event_mdown = function() private.ClickDlgPaper( 1 ) end }},
    { "spr_secretroom_oliver_paper_2" ,   { event_mdown = function() private.ClickDlgPaper( 2 ) end }},
    { "spr_secretroom_oliver_paper_3" ,   { event_mdown = function() private.ClickDlgPaper( 3 ) end }},
    { "obj_workbench_clk_leaves",           { event_mdown = private.clk_leaves }},

    { "spr_grizzlyskin_coin",           { event_mdown = private.get_collect_coin_30 }},
    { "spr_workbench_coin",             { event_mdown = private.get_collect_coin_31 }},
    { "obj_grizzlyskin_use_awl",        { event_mdown = private.grizzlyskin_cup_1_clk }},
    { "obj_secretroom_oliver_clk_1" ,   { event_mdown = private.oliver_clk_1 } },
    { "obj_secretroom_oliver_clk_2" ,   { event_mdown = private.oliver_clk_2 } },

    { "spr_secretroom_collect_item",    { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_3_3" );     end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_secretroom_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_3_6" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },

  });

    for i = 1,4 do
      
      table.insert( table_multiset ,{ "spr_picture_p"..i, { event_dragdrop = function () private.picture_drop( i ) end,
         event_startdrag = function () ObjSet( "spr_picture_p"..i, { pos_z = 5 } ); common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 ); end } } );

    end;
    
    ObjMultiSet(table_multiset);
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_secretroom = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gmg_secretroom_superpuzzle3",
    "gzz_secretroom_workbench",
    "gzz_secretroom_grizzlyskin",
    "gzz_secretroom_pictures",
    "gzz_secretroom_breaker"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_workbench",
      "zz_grizzlyskin",
      "zz_pictures"
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_secretroom", update_game_mode_secretroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_secretroom = function ()

  local effects_table = 
  {
    "anm_secretroom_light",
    "anm_secretroom_web",
    "anm_secretroom_dust",
    "anm_secretroom_oliver_loc",
    "anm_secretroom_oliver_sits1",
    "anm_secretroom_oliver_sits3"
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_secretroom", update_performance_mode_secretroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_secretroom () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_secretroom" ] = {
    type = "click",
    use_place = "grm_wincards_secretroom",
    room = "rm_wincards"
  };

  local opn_secretroom_map = function ()

    common_impl.VisitMapRoom( "secretroom" );

  end;
  cmn.AddSubscriber( "opn_secretroom", opn_secretroom_map );
  local win_superpuzzle_3_loc = function ()

    if cmn.IsEventDone( "win_superpuzzle_3" ) then

      ObjDelete( "gmg_secretroom_superpuzzle3" );
      ObjDelete( "spr_secretroom_puzzle"       );
      
    end;

    --ObjSet( "obj_dlg_secretroom_oliver", { input = true } );

  end;
  cmn.AddSubscriber( "win_superpuzzle_3", win_superpuzzle_3_loc, private.room_objname );

  local opn_secretroom_door = function ()

    ObjSet( "anm_secretroom_walls", { frame = 192 } );
    ObjSet( "obj_secretroom_oliver_clk_1", { input = true } );

  end;
  cmn.AddSubscriber( "opn_secretroom_door", opn_secretroom_door );
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_3_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_3_3 = function ()
  
    ObjDelete( "obj_secretroom_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_3_3", get_collect_item_3_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_3_6 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_3_6 = function ()
  
    ObjDelete( "obj_secretroom_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_3_6", get_collect_morph_item_3_6, private.room_objname );

 --------------------------------------------------------------------------------------------
  -- function get_prv_gnomehead_silhouette () end;
  --------------------------------------------------------------------------------------------
  local get_prv_gnomehead_silhouette_inv = function ()
  
    interface.ProvidePanelSilhouetteAdd( "inv_prv_gnomehead", "spr_secretroom_prv_gnomehead_silhouette" );

  end;
  
  local get_prv_gnomehead_silhouette_closezz = function ()

    ObjSet( "spr_secretroom_prv_gnomehead_silhouette", { alp = 1 } );    
    ObjSet( "obj_secretroom_use_prv_item_1", { event_mdown = function() int_providence.Thinking( "providence_prv_item_1", "obj_secretroom_use_prv_item_1" ) end } )

  end;

  local get_prv_gnomehead_silhouette_notadd = function ()

    ObjSet( "obj_secretroom_use_prv_item_1", { event_mdown = function() int_providence.Thinking( "providence_prv_item_1", "obj_secretroom_use_prv_item_1" ) end } )

  end;
  
  cmn.AddSubscriber( "get_prv_gnomehead_silhouette", get_prv_gnomehead_silhouette_inv );
  cmn.AddSubscriber( "get_prv_gnomehead_silhouette", get_prv_gnomehead_silhouette_closezz, private.room_objname );
  cmn.AddSubscriber( "get_prv_gnomehead", get_prv_gnomehead_silhouette_notadd, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function get_prv_gun_silhouette () end;
  --------------------------------------------------------------------------------------------
  local get_prv_gun_silhouette_inv = function ()
  
    interface.ProvidePanelSilhouetteAdd( "inv_prv_gun", "spr_secretroom_prv_gun_silhouette" );

  end;
  
  local get_prv_gun_silhouette_closezz = function ()

    ObjSet( "spr_secretroom_prv_gun_silhouette", { alp = 1 } );    
    ObjSet( "obj_secretroom_use_prv_item_2", { event_mdown = function() int_providence.Thinking( "providence_prv_item_2", "obj_secretroom_use_prv_item_2" ) end } )

  end;

  local get_prv_gun_silhouette_notadd = function ()

    ObjSet( "obj_secretroom_use_prv_item_2", { event_mdown = function() int_providence.Thinking( "providence_prv_item_2", "obj_secretroom_use_prv_item_2" ) end } )

  end;
  
  cmn.AddSubscriber( "get_prv_gun_silhouette", get_prv_gun_silhouette_inv );
  cmn.AddSubscriber( "get_prv_gun_silhouette", get_prv_gun_silhouette_closezz, private.room_objname );
  cmn.AddSubscriber( "get_prv_gun", get_prv_gun_silhouette_notadd, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_gnomefragment () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gnomefragment" ] = {
    type = "get",
    get_obj = "spr_workbench_gnomefragment",
    room = private.room_objname,
    zz = "zz_workbench",
    zz_gate = "gzz_secretroom_workbench"
  };
    
  local get_gnomefragment_inv = function ()
  
    interface.InventoryItemAdd( "inv_gnomefragment", "spr_workbench_gnomefragment" );
  
  end;
  
  local get_gnomefragment_closezz = function ()
  
    ObjDelete( "gfx_workbench_gnomefragment" );
    --ObjDelete( "gzz_secretroom_workbench" );
  
  end;
  
  cmn.AddSubscriber( "get_gnomefragment", get_gnomefragment_inv );
  cmn.AddSubscriber( "get_gnomefragment", get_gnomefragment_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_button_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_button_2" ] = {
    type = "get",
    get_obj = "spr_workbench_button_2",
    room = private.room_objname,
    zz = "zz_workbench",
    zz_gate = "gzz_secretroom_workbench"
  };
    
  local get_button_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_button_2", "spr_workbench_button_2" );
  
  end;
  
  local get_button_2_closezz = function ()
  
    ObjDelete( "gfx_workbench_button_2"   );
    ObjDelete( "spr_secretroom_button"    );

    if ( common_impl.IsGetCoin( "get_coin_31" ) ) and cmn.IsEventDone( "get_evidence_3_5" ) then

      ObjDelete( "gzz_secretroom_workbench" );

    end;

  end;
  
  cmn.AddSubscriber( "get_button_2", get_button_2_inv );
  cmn.AddSubscriber( "get_button_2", get_button_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_awl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_awl" ] = {
    type = "get",
    get_obj = "spr_workbench_awl",
    room = private.room_objname,
    zz = "zz_workbench",
    zz_gate = "gzz_secretroom_workbench"
  };
    
  local get_awl_inv = function ()
  
    interface.InventoryItemAdd( "inv_awl", "spr_workbench_awl" );
  
  end;
  
  local get_awl_closezz = function ()
  
    ObjDelete( "spr_workbench_screwdriver_sh" );
    ObjDelete( "gfx_workbench_awl" );
    --ObjDelete( "gzz_secretroom_workbench" );
    ObjDelete( "spr_secretroom_awl" );
  
  end;
  
  cmn.AddSubscriber( "get_awl", get_awl_inv );
  cmn.AddSubscriber( "get_awl", get_awl_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_evidence_3_5 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_evidence_3_5" ] = {
    type = "get",
    get_obj = "spr_workbench_evidence_3_5",
    room = private.room_objname,
    zz = "zz_workbench",
    zz_gate = "gzz_secretroom_workbench"
  };
    
  local get_evidence_3_5_inv = function ()
  
    --
  
  end;
  
  local get_evidence_3_5_closezz = function ()
  
    ObjDelete( "spr_workbench_board_sh" );
    ObjDelete( "gfx_workbench_evidence_3_5" );
    ObjDelete( "spr_workbench_evidence_3_5" );
    ObjDelete( "spr_secretroom_planetable" );
    ObjSet( "obj_workbench_clk_leaves", { input = true } ); 
   
  end;
  
  cmn.AddSubscriber( "get_evidence_3_5", get_evidence_3_5_inv );
  cmn.AddSubscriber( "get_evidence_3_5", get_evidence_3_5_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_evidence_3_6 () end;
  --------------------------------------------------------------------------------------------
  local get_evidence_3_6_closezz = function ()

  
  end;
  
  cmn.AddSubscriber( "get_evidence_3_6", get_evidence_3_6_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gear_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gear_3" ] = {
    type = "get",
    get_obj = "spr_grizzlyskin_gear_3",
    room = private.room_objname,
    zz = "zz_grizzlyskin",
    zz_gate = "gzz_secretroom_grizzlyskin"
  };
    
  local get_gear_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_gear_3", "spr_grizzlyskin_gear_3" );
    
  end;
  
  local get_gear_3_closezz = function ()

    ObjDelete( "gfx_grizzlyskin_gear_3"  );
    ObjDelete("spr_secretroom_detai_shad");
    ObjDelete("spr_secretroom_detail"    );

    ObjDelete( "spr_grizzlyskin_detail_3_over"   );
    ObjDelete( "spr_grizzlyskin_detail_3_shadow" );

    ObjSet( "obj_grizzlyskin_use_awl", { input = true } );

  end;
  
  cmn.AddSubscriber( "get_gear_3", get_gear_3_inv );
  cmn.AddSubscriber( "get_gear_3", get_gear_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_framedphoto () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_framedphoto" ] = {
    type = "get",
    get_obj = "spr_grizzlyskin_framedphoto",
    room = private.room_objname,
    zz = "zz_grizzlyskin",
    zz_gate = "gzz_secretroom_grizzlyskin"
  };
    
  local get_framedphoto_inv = function ()
  
    interface.InventoryItemAdd( "inv_framedphoto", "spr_grizzlyskin_framedphoto" );
  
  end;
  
  local get_framedphoto_closezz = function ()
  
    ObjDelete( "gfx_grizzlyskin_framedphoto" );
    ObjDelete( "spr_secretroom_grizzlyskin_picture" );

    if ( common_impl.IsGetCoin( "get_coin_30" ) ) then

      ObjDelete( "gzz_secretroom_grizzlyskin" );

    end;
    
  end;
  
  cmn.AddSubscriber( "get_framedphoto", get_framedphoto_inv );
  cmn.AddSubscriber( "get_framedphoto", get_framedphoto_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_30 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_30 = function ()
 
    ObjDelete( "obj_grizzlyskin_coin" );

    if cmn.IsEventDone( "get_framedphoto" )  then

      ObjDelete( "gzz_secretroom_grizzlyskin" );

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_30", get_collect_coin_30, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_31 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_31 = function ()
 
    ObjDelete( "obj_workbench_coin" );

    if cmn.IsEventDone( "get_button_2" ) and cmn.IsEventDone( "get_evidence_3_5" )  then

      --ObjDelete( "gzz_secretroom_workbench" );

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_31", get_collect_coin_31, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_lighter () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lighter" ] = {
    type = "get",
    get_obj = "spr_breaker_lighter_night",
    room = private.room_objname,
    zz = "zz_breaker",
    zz_gate = "gzz_secretroom_breaker"
  };
    
  local get_lighter_inv = function ()
  
    interface.InventoryItemAdd( "inv_lighter", "spr_breaker_lighter_night" );
    ObjSet( "spr_candle_plus_light", { alp = 1 } );
  
  end;
  
  local get_lighter_closezz = function ()
  
    ObjDelete( "gfx_breaker_lighter" );
    ObjDelete( "spr_breaker_lighter_night_shadow" );

    ObjDelete( "spr_secretroom_lighter" );
  
  end;
  
  cmn.AddSubscriber( "get_lighter", get_lighter_inv );
  cmn.AddSubscriber( "get_lighter", get_lighter_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_vicehandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_vicehandle" ] = {
    type = "use",
    inv_obj = "inv_vicehandle",
    use_place = "obj_workbench_use_vicehandle",
    room = private.room_objname,
    zz = "zz_workbench",
    zz_gate = "gzz_secretroom_workbench"
  };
  local use_vicehandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_vicehandle" );
  
  end;

  local use_vicehandle_beg = function ()
  
    ObjDelete( "obj_workbench_use_vicehandle" );
  
  end;

  local use_vicehandle_end = function ()
  
    ObjMultiSet({ 

      { "spr_workbench_handle",          { alp = 1      }},
      { "obj_workbench_clk_vicehandle",  { input = true }},
      { "spr_secretroom_uphandle",       { alp = 1      }}, 
  
    });
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_vicehandle", use_vicehandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_vicehandle", use_vicehandle_inv );
  cmn.AddSubscriber( "use_vicehandle", use_vicehandle_end, private.room_objname );
  cmn.AddSubscriber( "use_vicehandle_inv", use_vicehandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_vicehandle_beg", use_vicehandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_vicehandle_end", use_vicehandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tweezers () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tweezers2" ] = {
    type = "use",
    inv_obj = "inv_tweezers_2",
    use_place = "obj_grizzlyskin_use_tweezers",
    room = private.room_objname,
    zz = "zz_grizzlyskin",
    zz_gate = "gzz_secretroom_grizzlyskin"
  };
  local use_tweezers_inv = function ()
  
    interface.InventoryItemRemove( "inv_tweezers_2" );
  
  end;
  local use_tweezers_beg = function ()

    ObjDelete( "obj_grizzlyskin_use_tweezers" );

    ObjMultiSet({
      { "spr_grizzlyskin_gear_3",          { alp = 0 }},
      { "spr_grizzlyskin_detail_3_shadow", { alp = 0 }},
      { "anm_grizzlyskin_tweezers1",       { alp = 1 }},
    });
  
  end;
  local use_tweezers_end = function ()
  
    ObjMultiSet({
      { "spr_grizzlyskin_gear_3",          { input = true, alp = 1,pos_x=33,pos_y=50 }},
      { "spr_grizzlyskin_detail_3_shadow", { alp = 1                }},
      { "gfx_grizzlyskin_gear_3",          { active = true          }},

    });

    ObjDelete( "anm_grizzlyskin_tweezers1" );  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tweezers2", use_tweezers_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers2", use_tweezers_inv );
  cmn.AddSubscriber( "use_tweezers2", use_tweezers_end, private.room_objname );
  cmn.AddSubscriber( "use_tweezers2_inv", use_tweezers_inv, private.room_objname );
  cmn.AddSubscriber( "use_tweezers2_beg", use_tweezers_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers2_end", use_tweezers_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ring () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ring_2" ] = {
    type = "use",
    inv_obj = "inv_ring_2",
    use_place = "obj_grizzlyskin_use_ring",
    room = private.room_objname,
    zz = "zz_grizzlyskin",
    zz_gate = "gzz_secretroom_grizzlyskin"
  };
  local use_ring_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_ring_2" );
  
  end;
  local use_ring_2_beg = function ()
  
    ObjDelete( "obj_grizzlyskin_use_ring" );
  
  end;
  local use_ring_2_end = function ()

    ObjMultiSet({
      { "spr_grizzlyskin_framedphoto",     { input = true     }},
      { "gfx_grizzlyskin_framedphoto",     { active = true    }},
      { "spr_secretroom_grizzlyskin_picture", { alp = 1   }}

    });

    ObjDelete( "spr_secretroom_cup_1"  );
    ObjDelete( "spr_grizzlyskin_ring"  );
    ObjDelete( "spr_grizzlyskin_cup_2" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ring_2", use_ring_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_ring_2", use_ring_2_inv );
  cmn.AddSubscriber( "use_ring_2", use_ring_2_end, private.room_objname );
  cmn.AddSubscriber( "use_ring_2_inv", use_ring_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_ring_2_beg", use_ring_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_ring_2_end", use_ring_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_awl () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_awl" ] = {
    type = "use",
    inv_obj = "inv_awl",
    use_place = "obj_grizzlyskin_use_awl",
    room = private.room_objname,
    zz = "zz_grizzlyskin",
    zz_gate = "gzz_secretroom_grizzlyskin"
  };
  local use_awl_inv = function ()
  
    interface.InventoryItemRemove( "inv_awl" );
  
  end;
  local use_awl_beg = function ()

    ObjDelete( "obj_grizzlyskin_use_awl" );
  
  end;
  local use_awl_end = function ()

    ObjMultiSet({ 
      { "obj_grizzlyskin_use_ring",    { input = true }},
      { "spr_grizzlyskin_cup_1_open",  { alp = 1      }},
      { "spr_secretroom_cup_3_shadow", { alp = 1      }},
      { "spr_secretroom_cup_3",        { alp = 1      }},
      { "spr_secretroom_cup_1",        { alp = 1      }},

    });

    ObjDelete( "spr_secretroom_cup_2" );
    ObjDelete( "anm_grizzlyskin_awl1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_awl", use_awl_beg, private.room_objname );
  cmn.AddSubscriber( "use_awl", use_awl_inv );
  cmn.AddSubscriber( "use_awl", use_awl_end, private.room_objname );
  cmn.AddSubscriber( "use_awl_inv", use_awl_inv, private.room_objname );
  cmn.AddSubscriber( "use_awl_beg", use_awl_beg, private.room_objname );
  cmn.AddSubscriber( "use_awl_end", use_awl_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hexkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hexkey" ] = {
    type = "use",
    inv_obj = "inv_hexkey",
    use_place = "obj_pictures_use_hexkey",
    room = private.room_objname,
    zz = "zz_pictures",
    zz_gate = "gzz_secretroom_pictures"
  };
  local use_hexkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_hexkey" );
  
  end;
  local use_hexkey_beg = function ()
  
    ObjDelete( "obj_pictures_use_hexkey" );
    ObjDelete( "gzz_secretroom_pictures" );
  
  end;
  local use_hexkey_end = function ()
  
    ObjDelete( "spr_pictures_over_puzzle" );
    ObjDelete( "spr_secretroom_lock"      );
    ObjDelete( "vid_pictures_hex" );

    ObjMultiSet({ 
      { "spr_secretroom_puzzle_over",       {  alp = 0 }},
      { "gmg_secretroom_superpuzzle3", { input = true, active = true, visible = true }},
    }); 
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hexkey", use_hexkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_hexkey", use_hexkey_inv );
  cmn.AddSubscriber( "use_hexkey", use_hexkey_end, private.room_objname );
  cmn.AddSubscriber( "use_hexkey_inv", use_hexkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_hexkey_beg", use_hexkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_hexkey_end", use_hexkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_framedphoto () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_framedphoto" ] = {
    type = "use",
    inv_obj = "inv_framedphoto",
    use_place = "obj_pictures_use_framedphoto",
    room = private.room_objname,
    zz = "zz_pictures",
    zz_gate = "gzz_secretroom_pictures"
  };
  local use_framedphoto_inv = function ()
  
    interface.InventoryItemRemove( "inv_framedphoto" );
  
  end;
  local use_framedphoto_beg = function ()
  
    ObjDelete( "obj_pictures_use_framedphoto" );
  
  end;

  local use_framedphoto_end = function ()

  local table_multiset = {};
  
    for i = 1,4 do
      
      table.insert( table_multiset ,{ "spr_picture_p"..i, { input = true } } );

    end; 

    table.insert( table_multiset ,{ "spr_picture_picture",      { alp = 1 } } );
    table.insert( table_multiset ,{ "spr_secretroom_pictures3", { alp = 1 } } );

    ObjMultiSet( table_multiset );

    --ObjSet( "spr_pictures_key", { input = true, visible = true, active = true } );

    --{ "obj_pictures_use_hexkey",  { input = true }},

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_framedphoto", use_framedphoto_beg, private.room_objname );
  cmn.AddSubscriber( "use_framedphoto", use_framedphoto_inv );
  cmn.AddSubscriber( "use_framedphoto", use_framedphoto_end, private.room_objname );
  cmn.AddSubscriber( "use_framedphoto_inv", use_framedphoto_inv, private.room_objname );
  cmn.AddSubscriber( "use_framedphoto_beg", use_framedphoto_beg, private.room_objname );
  cmn.AddSubscriber( "use_framedphoto_end", use_framedphoto_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_litcandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_litcandle" ] = {
    type = "use",
    inv_obj = "inv_litcandle",
    use_place = "obj_breaker_use_litcandle",
    room = private.room_objname,
    zz = "zz_breaker",
    zz_gate = "gzz_secretroom_breaker"
  };
  local use_litcandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_litcandle" );
  
  end;
  local use_litcandle_beg = function ()
  
    ObjDelete( "obj_breaker_use_litcandle" );
  
  end;
  local use_litcandle_end = function ()

    ObjMultiSet({ 
      { "zz_breaker",  { res = "assets/levels/level3/rm_secretroom/zz_breaker/back_light" }},
      { "spr_breaker_candel",  { alp = 1 }},
      { "obj_breaker_switch_1",  { alp = 1 }},
      { "obj_breaker_mmg",  { alp = 1, input = true }},
      { "vid_breaker_candle",  { playing = true }},
    });

    ObjDelete( "spr_breaker_back_light" );
    ObjDelete( "obj_breaker_switch_1_night" );  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_litcandle", use_litcandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_litcandle", use_litcandle_inv );
  cmn.AddSubscriber( "use_litcandle", use_litcandle_end, private.room_objname );
  cmn.AddSubscriber( "use_litcandle_inv", use_litcandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_litcandle_beg", use_litcandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_litcandle_end", use_litcandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_providence_gun () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_providence_gun" ] = {
    type = "use",
    inv_obj = "inv_prv_gun",
    use_place = "obj_secretroom_use_prv_item_2",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"
  };
  local use_providence_gun_inv = function ()
  
    interface.ProvidePanelItemRemove( "inv_prv_gun" );
  
  end;
  local use_providence_gun_beg = function ()
  
    ObjDelete( "obj_secretroom_use_prv_item_2" );
  
  end;
  local use_providence_gun_end = function ()
  
    ObjSet( "spr_secretroom_gun",          { visible = true });
    ObjSet( "spr_secretroom_prv_gun_used", { alp = 1 });    
    ObjDelete( "spr_secretroom_prv_gun_light" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_providence_gun", use_providence_gun_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_gun", use_providence_gun_inv );
  cmn.AddSubscriber( "use_providence_gun", use_providence_gun_end, private.room_objname );
  cmn.AddSubscriber( "use_providence_gun_inv", use_providence_gun_inv, private.room_objname );
  cmn.AddSubscriber( "use_providence_gun_beg", use_providence_gun_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_gun_end", use_providence_gun_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_providence_gnomehead () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_providence_gnomehead" ] = {
    type = "use",
    inv_obj = "inv_prv_gnomehead",
    use_place = "obj_secretroom_use_prv_item_1",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"
  };
  local use_providence_gnomehead_inv = function ()
  
    interface.ProvidePanelItemRemove( "inv_prv_gnomehead" );
  
  end;
  local use_providence_gnomehead_beg = function ()
  
    ObjDelete( "obj_secretroom_use_prv_item_1" );
  
  end;
  local use_providence_gnomehead_end = function ()

    ObjSet( "spr_secretroom_head",               { visible = true });
    ObjSet( "spr_secretroom_prv_gnomehead_used", { alp = 1 });
    --ObjSet( "spr_secretroom_gnomehead", { alp = 1 } );
    ObjDelete( "spr_secretroom_prv_gnomehead_light" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_providence_gnomehead", use_providence_gnomehead_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_gnomehead", use_providence_gnomehead_inv );
  cmn.AddSubscriber( "use_providence_gnomehead", use_providence_gnomehead_end, private.room_objname );
  cmn.AddSubscriber( "use_providence_gnomehead_inv", use_providence_gnomehead_inv, private.room_objname );
  cmn.AddSubscriber( "use_providence_gnomehead_beg", use_providence_gnomehead_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_gnomehead_end", use_providence_gnomehead_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_vicehandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_vicehandle" ] = {
    type = "click",
    use_place = "obj_workbench_clk_vicehandle",
    room = private.room_objname,
    zz = "zz_workbench",
    zz_gate = "gzz_secretroom_workbench"    
  };
  local clk_vicehandle_beg = function ()
  
    ObjDelete(  "obj_workbench_clk_vicehandle" );
  
  end;
  local clk_vicehandle_end = function ()
  
    ObjMultiSet({
      { "spr_workbench_handledown", { alp = 1 }},
      { "spr_workbench_button_2",   { alp = 1, input = true, active = true }},

    });

    ObjDelete( "spr_workbench_handle"    );
    ObjDelete( "spr_workbench_groove"    );
    ObjDelete( "spr_secretroom_uphandle" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_vicehandle", clk_vicehandle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_vicehandle", clk_vicehandle_end, private.room_objname );
  cmn.AddSubscriber( "clk_vicehandle_beg", clk_vicehandle_beg, private.room_objname );
  cmn.AddSubscriber( "clk_vicehandle_end", clk_vicehandle_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_switch_1() end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_switch_1" ] = {
    type = "click",
    use_place = "obj_breaker_clk_switch_1",
    room = private.room_objname,
    zz = "zz_breaker",
    zz_gate = "gzz_secretroom_breaker"    
  };
  local clk_switch_1_beg = function ()
  
    ObjDelete(  "obj_breaker_clk_switch_1" );
  
  end;
  local clk_switch_1_end = function ()

    ObjDelete( "obj_breaker_switch_1" );
    ObjDelete( "spr_secretroom_back_over" );
    ObjDelete(  "gzz_secretroom_breaker" );
    
      ObjMultiSet({
        { "gzz_secretroom_workbench", { input = true, active = true }},
        --{ "gzz_secretroom_grizzlyskin", { input = true, visible = true, active = true }},
        { "gzz_secretroom_pictures", { input = true, active = true }},
        { "obj_secretroom_use_prv_gnomehead", { input = true, visible = true, active = true }},
        { "obj_secretroom_use_prv_gun", { input = true, visible = true, active = true }},
        { "obj_secretroom_clk_sightplate", { input = true, visible = true, active = true }},
        { "obj_secretroom_clk_sightowldummy", { input = true, visible = true, active = true }},
        { "obj_breaker_switch_2", { alp = 1 }},
        { "obj_secretroom_collect", { input = true, visible = true }},
        { "obj_secretroom_morph", { input = true, visible = true }},
      });

  end;
  local clk_switch_1_winecards = function ()

    ObjDelete( "grm_wincards_secretroom_black" );

  end;

  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_switch_1", clk_switch_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_switch_1", clk_switch_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_switch_1", clk_switch_1_winecards, "rm_wincards" );
  cmn.AddSubscriber( "clk_switch_1_beg", clk_switch_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_switch_1_end", clk_switch_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_switch_1_end", clk_switch_1_winecards, "rm_wincards" );
  --------------------------------------------------------------------------------------------
  -- function clk_bearskin() end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_bearskin" ] = {
    type = "click",
    use_place = "obj_grizzlyskin_clk_bearskin",
    room = private.room_objname,
    zz = "zz_grizzlyskin",
    zz_gate = "gzz_secretroom_grizzlyskin"    
  };
  local clk_bearskin_beg = function ()
  
    ObjDelete(  "obj_grizzlyskin_clk_bearskin" );
  
  end;
  local clk_bearskin_end = function ()

  ObjMultiSet({

    { "obj_grizzlyskin_skin1", { alp = 1 }},
    { "obj_grizzlyskin_use_tweezers", { input = true } },

    { "spr_secretroom_over" , { alp = 1 }},
    { "spr_secretroom_box" ,  { alp = 1 }},
    { "spr_secretroom_cup_2", { alp = 1 }},

    { "spr_secretroom_detai_shad",    { alp = 1 }},
    { "spr_secretroom_detail",        { alp = 1 }},
    { "spr_secretroom_scin",          { alp = 1 }},
    { "spr_secretroom_shadow",        { alp = 1 }},

  });

  ObjDelete( "obj_grizzlyskin_skin2" )

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_bearskin", clk_bearskin_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bearskin", clk_bearskin_end, private.room_objname );
  cmn.AddSubscriber( "clk_bearskin_beg", clk_bearskin_beg, private.room_objname );
  cmn.AddSubscriber( "clk_bearskin_end", clk_bearskin_end, private.room_objname );

 --------------------------------------------------------------------------------------------
 --------------------------------------------------------------------------------------------
  -- function clk_providence_plate () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_providence_plate" ] = {
    type = "use",
    inv_obj = "spr_secretroom_prv_plate",
    use_place = "obj_secretroom_prv_item_1",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"    
  };
  local clk_providence_plate_beg = function ()
  
    ObjDelete(  "obj_secretroom_prv_item_1" );
  
  end;
  local clk_providence_plate_end = function ()

    ObjDelete( "spr_secretroom_prv_plate" );
    ObjDelete( "spr_secretroom_plate_1" );
    ObjDelete( "spr_secretroom_prv_plate_light" );
    ObjSet( "spr_secretroom_prv_plate_used", { alp = 1 });
    ObjSet( "spr_secretroom_plate",          { visible = true });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_providence_plate", clk_providence_plate_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_plate", clk_providence_plate_end, private.room_objname );
  cmn.AddSubscriber( "clk_providence_plate_beg", clk_providence_plate_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_plate_end", clk_providence_plate_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_providence_towldummy () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_providence_towldummy" ] = {
    type = "use",
    inv_obj = "spr_secretroom_prv_towldummy",
    use_place = "obj_secretroom_prv_item_2",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"  
  };
  local clk_providence_towldummy_beg = function ()
  
    ObjDelete(  "obj_secretroom_prv_item_2" );
  
  end;
  local clk_providence_towldummy_end = function ()
  
    ObjDelete( "spr_secretroom_prv_towldummy" );
    ObjDelete( "spr_secretroom_owl_1" );
    ObjDelete( "spr_secretroom_prv_towldummy_light" );
    ObjSet( "spr_secretroom_prv_towldummy_used", { alp = 1 });
    ObjSet( "spr_secretroom_owl",                { visible = true });
    ObjSet( "spr_secretroom_prv_towldummy_shadow", { pos_x = 633 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_providence_towldummy", clk_providence_towldummy_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_towldummy", clk_providence_towldummy_end, private.room_objname );
  cmn.AddSubscriber( "clk_providence_towldummy_beg", clk_providence_towldummy_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_towldummy_end", clk_providence_towldummy_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_providence_secretroom () end;
  --------------------------------------------------------------------------------------------
  local clk_providence_secretroom = function ()
              
    if ( not cmn.IsEventDone( "clk_providence_plate" ) or not cmn.IsEventDone( "clk_providence_towldummy" ) 
         or ( cmn.IsEventDone( "get_prv_gnomehead" ) and not cmn.IsEventDone( "use_providence_gnomehead" ) )
         or ( cmn.IsEventDone( "get_prv_gun" ) and not cmn.IsEventDone( "use_providence_gun" ) ) ) then

        int_button_providence.StartActiveProvidence();

    end;
  
  end;
  
  cmn.AddSubscriber( "clk_providence_secretroom", clk_providence_secretroom, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_oliver_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_oliver_1" ] = {
    type = "click",
    use_place = "obj_secretroom_oliver_clk_1",
    room = private.room_objname    
  };


  local clk_oliver_1 = function ()

  ObjMultiSet({

    { "obj_oliver_sits_untie", { alp = 1 }},
    { "obj_secretroom_oliver_clk_2", { input = true } },

  });

    ObjDelete( "obj_secretroom_oliver_sits1" );
    ObjDelete("obj_secretroom_oliver_clk_1");

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_oliver_1", clk_oliver_1, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_oliver_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_oliver_2" ] = {
    type = "click",
    use_place = "obj_secretroom_oliver_clk_2",
    room = private.room_objname    
  };

  local clk_oliver_2 = function ()

  ObjMultiSet({

    { "obj_secretroom_oliver_sits3", { alp = 1 }},
    { "obj_dlg_secretroom_oliver", { input = true } },
    { "anm_secretroom_oliver_sits3" , { playing = true } }

  });

    ObjDelete( "obj_oliver_sits_untie" );
    ObjDelete("obj_secretroom_oliver_clk_2");

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_oliver_2", clk_oliver_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function vid_secretroom_providence () end;
  --------------------------------------------------------------------------------------------  
  
  local vid_secretroom_prv_end = function ()

    ObjSet( "gzz_secretroom_grizzlyskin", { active = true, input = true } );
   
  end;

  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_secretroom_providence", vid_secretroom_prv_end, private.room_objname  );
  cmn.AddSubscriber( "vid_secretroom_prv_end", vid_secretroom_prv_end, private.room_objname  );
 --------------------------------------------------------------------------------------------
 --------------------------------------------------------------------------------------------
  
  local vid_secretroom_providence_p2 = function ()

    VidStop( "vid_secretroom_providence_p1" );
    ObjSet( "vid_secretroom_providence_p2", { playing = true } );    

  end;   

  cmn.AddSubscriber( "vid_secretroom_providence_p2", vid_secretroom_providence_p2, private.room_objname );
  --------------------------------------------------------------------------------------------
  local vid_secretroom_providence_p3 = function ()

    VidStop( "vid_secretroom_providence_p2" );
    ObjSet( "vid_secretroom_providence_p3", { playing = true } );

  end;   

  cmn.AddSubscriber( "vid_secretroom_providence_p3", vid_secretroom_providence_p3, private.room_objname );
  --------------------------------------------------------------------------------------------
  local vid_secretroom_providence_p4 = function ()

    VidStop( "vid_secretroom_providence_p3" );
    VidPlay( "vid_secretroom_providence_p4", private.vid_secretroom_providence_end );

  end;   

  cmn.AddSubscriber( "vid_secretroom_providence_p4", vid_secretroom_providence_p4, private.room_objname );

  -------------------------------------------------------------------------------------------
  -- function win_pictures () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_pictures" ] = {
    type = "win",
    room = private.room_objname,    
    zz = "zz_pictures",
    zz_gate = "gzz_secretroom_pictures"
};

  local win_pictures = function ()

    local table_multiset = {};

    private.current_pos = {};

    local nst = ng_global.progress[ "std" ][ "win_pictures" ].num_state;

    if cmn.IsEventDone( "win_pictures" ) then

      ObjDelete( "obj_picture_mmg" );
      ObjDelete( "spr_secretroom_pictures2" );
      ObjDelete( "spr_secretroom_pictures3" );

      table.insert( table_multiset ,{ "spr_secretroom_lock",      { alp = 1      }});
      table.insert( table_multiset ,{ "obj_pictures_use_hexkey",  { input = true }});
      table.insert( table_multiset ,{ "vid_pictures_hex",  { alp = 1, active = true }});

    else
      
      for i = 1,4 do
      
        if ( ng_global.progress[ "std" ][ "win_pictures" ].current_pos[i] ) then 

          private.current_pos[i] = true;

          table.insert( table_multiset ,{ "spr_picture_p"..i, { pos_x = private.right_coord[nst][i][1],pos_y = private.right_coord[nst][i][2], input = false  }});

        else

          private.current_pos[i] = false;

        end;

      end;

    end;

    if ( table_multiset[1] ) then

      ObjMultiSet(table_multiset);

    end;

  end;
  
  cmn.AddSubscriber( "win_pictures", win_pictures, private.room_objname );
  -------------------------------------------------------------------------------------------
  -- function win_superpuzzle_3 () end;
  --------------------------------------------------------------------------------------------
  --[[local win_superpuzzle_3 = function ()

    ObjSet( "obj_dlg_secretroom_oliver", { input = true } );

  end;   

  cmn.AddSubscriber( "win_superpuzzle_3", win_superpuzzle_3, private.room_objname );
]]
  --------------------------------------------------------------------------------------------
  -- function dlg_secretroom_oliver () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_secretroom_oliver" ] = {

      type = "click",
      use_place = "obj_dlg_secretroom_oliver_focus",
      room = private.room_objname
  };

  local dlg_secretroom_oliver_end = function ()

    ObjDelete( "obj_dlg_secretroom_oliver" );
    --ObjDelete( "obj_secretroom_oliver_loc" );
    common_impl.Collectibles2_unlock_crs( "Oliver_Johnson" );
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_secretroom_oliver", dlg_secretroom_oliver_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_secretroom_oliver_end", dlg_secretroom_oliver_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function win_breaker () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_breaker" ] = {
    type = "win",
    room = private.room_objname,    
    zz = "zz_breaker",
    zz_gate = "gzz_secretroom_breaker"
};

  local win_breaker = function ()
    
    if ( cmn.IsEventDone( "win_breaker" ) ) then

      ObjSet( "spr_breaker_green_light", { alp = 1 } );
      ObjDelete( "obj_breaker_mmg_down" );  
      for i = 1, 3  do
        ObjDelete( "obj_breaker_tumb_"..i );
        ObjSet( "obj_breaker_tumb_up_"..i, { alp = 1 } );
      end;
      ObjSet( "spr_secretroom_green_add_over", { alp = 1 } );

    else 
      
      for i = 1,3 do

        if ng_global.progress["std"]["win_breaker"].pressed[i] ~= 0 then
         
           ObjSet( "obj_breaker_tumb_"..ng_global.progress["std"]["win_breaker"].pressed[i], { input = 0 });
           ObjSet( "obj_breaker_tumb_up_"..ng_global.progress["std"]["win_breaker"].pressed[i], { alp = 1 });
           ObjSet( "obj_breaker_tumb_down_"..ng_global.progress["std"]["win_breaker"].pressed[i], { alp = 0 });
           
        else  

           ObjSet( "obj_breaker_tumb_"..ng_global.progress["std"]["win_breaker"].pressed[i], { input = 1 });

        end;

      end;

    end;

  end;

  cmn.AddSubscriber( "win_breaker", win_breaker, private.room_objname  );

end;
--*********************************************************************************************************************
  function public.Load()

  

  end;
--*********************************************************************************************************************
function private.Init_Subroom()

 subroom.Define( "zz_breaker" );
  --------------------------------------------------------------------------------------------
  function zz_breaker.PreOpen ()

    if ( cmn.IsEventDone( "use_litcandle" ) and not cmn.IsEventDone( "win_breaker" )) then

      cmn.MiniGameShow( "breaker" );
      common_impl.PassingMgStart( "breaker" )

    end;

    if ( cmn.IsEventDone( "win_breaker" ) and not cmn.IsEventDone( "clk_switch_1" )) then

      ObjAnimate( "spr_breaker_green_light", "alp", 1, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.6,
        0.6, 0, 1.0
      } );

    end;

  end;
  --------------------------------------------------------------------------------------------
  function zz_breaker.PreClose()

    if ( cmn.IsEventStart( "win_breaker" ) and not cmn.IsEventDone( "win_breaker" ) ) then

      cmn.MiniGameHide( "breaker" );
      common_impl.PassingMgStop( "breaker" )

    end;

  end;
  --------------------------------------------------------------------------------------------
  subroom.Define( "zz_pictures" );

  function zz_pictures.PreOpen()

    if ( not ng_global.progress[ "std" ][ "win_pictures" ].current_pos ) then

      ng_global.progress[ "std" ][ "win_pictures" ].current_pos = { false, false, false, false };

      ng_global.progress[ "std" ][ "win_pictures" ].num_state = 1;
 
      private.current_pos = { false, false, false, false };      

    end;
    
    if ( not cmn.IsEventDone( "win_pictures" ) and cmn.IsEventDone( "use_framedphoto" ) ) then

       cmn.MiniGameShow( "pictures" ); 
       common_impl.PassingMgStart( "pictures" );

    end;

  end;
  
  function zz_pictures.PreClose()
    
    if ( not cmn.IsEventDone( "win_pictures" ) ) then

      cmn.MiniGameHide( "pictures" );
      common_impl.PassingMgStop( "pictures" );

    end; 

  end;

  function zz_pictures.Close()
    
   if ( cmn.IsEventDone( "use_hexkey" ) ) then

     cmn.GotoRoom( "mg_superpuzzle_3" );

   end;

  end;

end;
--*********************************************************************************************************************
function public.Open()

 if cmn.IsEventDone( "win_superpuzzle_3" ) and not cmn.IsEventDone( "opn_secretroom_door" ) then

   local func_after = function ()

     common_impl.Lock( false );
     cmn.SetEventDone( "opn_secretroom_door" );
     cmn.CallEventHandler( "opn_secretroom_door" );

   end;

   common_impl.Lock( true );

   AnimPlay( "anm_secretroom_walls", "DoAnim", func_after );

   common_impl.PlayAudio( "sfx", "common/audio/aud_secretroom_walls", 0, "", 0 );

 end;

  private.opn_secretroom();
  
  int_providence_eye.CheckShow();

  if ( not cmn.IsEventDone( "vid_secretroom_providence" ) ) then

    int_button_providence.StartLightProvidence();

  end;

  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();

  common_impl.MorphItemMorphing();
  interface.InvestigationButtonCheck();
  common_impl.EnvPlay( { "common/audio/aud_secretroom_env" }, "", 0.5 ); 

  if cmn.IsEventDone( "clk_switch_1" ) then

    common_impl.PlayAudio( "env", "common/audio/aud_secretroom_light_env", 1, "", 0 );

  end;
    
end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreClose()

  if ( not cmn.IsEventDone( "vid_secretroom_providence" ) ) then

    int_button_providence.StopLightProvidence();

  end;

  common_impl.StopAudio( "env", "common/audio/aud_secretroom_light_env", 0.5 );

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_vicehandle()

  local item = "inv_vicehandle";

  if ( common.ApplyObj( item, "obj_workbench_use_vicehandle", true ) ) then

    cmn.CallEventHandler( "use_vicehandle_inv" );
    cmn.CallEventHandler( "use_vicehandle_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_vicehandle" );
      cmn.CallEventHandler( "use_vicehandle_end" );
      --common.CloseSubRoom();
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_vicehandle", 0, "", 0 );
  
    ObjAnimate( "spr_workbench_handle", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );

  return true;
  
  elseif common.ApplyObj( item, "gzz_secretroom_workbench", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_workbench", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tweezers()

  local item = "inv_tweezers_2";
 
  if ( common.ApplyObj( item, "obj_grizzlyskin_use_tweezers", true ) and cmn.IsEventDone( "clk_bearskin" ) ) then

    cmn.CallEventHandler( "use_tweezers2_inv" );
    cmn.CallEventHandler( "use_tweezers2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_tweezers2" );
      cmn.CallEventHandler( "use_tweezers2_end" );

      private.get_gear_3();

     end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_tweezers", 0, "", 0 );
    
    AnimPlay("anm_grizzlyskin_tweezers1","DoAnim",func_after);

    return true;
  
  elseif common.ApplyObj( item, "gzz_secretroom_grizzlyskin", false ) and cmn.IsEventDone( "clk_bearskin" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_grizzlyskin", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ring()

  local item = "inv_ring_2";

  if ( common.ApplyObj( item, "obj_grizzlyskin_use_ring", true ) and cmn.IsEventDone( "use_awl" ) ) and
    cmn.IsEventDone( "use_awl" ) then

    cmn.CallEventHandler( "use_ring_2_inv" );
    cmn.CallEventHandler( "use_ring_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_ring_2" );
      cmn.CallEventHandler( "use_ring_2_end" );
    --common.CloseSubRoom();
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_use_ring", 0, "", 0 );
  
    ObjAnimate( "spr_grizzlyskin_ring", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 0.0,

    } );

    ObjAnimate( "spr_grizzlyskin_cup_2", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 1.0,
      0.6, 0, 0.0,

    } );
  
  return true;
  
  elseif ( common.ApplyObj( item, "gzz_secretroom_grizzlyskin", false ) and cmn.IsEventDone( "use_awl" ) ) then

    --interface.ObjDoNotDrop( item );

    cmn.GotoSubRoom( "zz_grizzlyskin", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_awl()

  local item = "inv_awl";

  if ( common.ApplyObj( item, "obj_grizzlyskin_use_awl", true ) and cmn.IsEventDone( "get_gear_3" ) ) then

    cmn.CallEventHandler( "use_awl_inv" );
    cmn.CallEventHandler( "use_awl_beg" );

    local func_end = function ()
    
      common_impl.Lock( false );
      cmn.SetEventDone( "use_awl" );
      cmn.CallEventHandler( "use_awl_end" );
      --common.CloseSubRoom();;

    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_awl", 0, "", 0 );

    AnimPlay("anm_grizzlyskin_awl1","DoAnim",func_end);
  
  return true;
  
  elseif ( common.ApplyObj( item, "gzz_secretroom_grizzlyskin", false ) and cmn.IsEventDone( "get_gear_3" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_grizzlyskin", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_hexkey()

  local item = "inv_hexkey";

  if ( common.ApplyObj( item, "obj_pictures_use_hexkey", true )  and  cmn.IsEventDone( "win_pictures" ) ) then

    cmn.CallEventHandler( "use_hexkey_inv" );
    cmn.CallEventHandler( "use_hexkey_beg" );

    local func_after = function ()
  
      local func_after_2 = function ()

        common_impl.Lock( false );
        cmn.SetEventDone( "use_hexkey" );
        cmn.CallEventHandler( "use_hexkey_end" );
        common.CloseSubRoom();

      end;

      ObjAnimate( "vid_pictures_hex", "alp", 0, 0, "",
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );

      ObjAnimate( "spr_pictures_over_puzzle", "alp", 0, 0, func_after_2,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
    
    end;

    common_impl.Lock( true );
    VidPlay( "vid_pictures_hex", func_after );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_hexkey", 0, "", 0 );

  return true;
  
  elseif ( common.ApplyObj( item, "gzz_secretroom_pictures", false ) and  cmn.IsEventDone( "win_pictures" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pictures", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_framedphoto()

  local item = "inv_framedphoto";

  if ( common.ApplyObj( item, "obj_pictures_use_framedphoto", true ) ) then

    cmn.CallEventHandler( "use_framedphoto_inv" );
    cmn.CallEventHandler( "use_framedphoto_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_framedphoto" );
      cmn.CallEventHandler( "use_framedphoto_end" );
      private.current_pos = {false, false, false, false};
      cmn.MiniGameShow( "pictures" );
      common_impl.PassingMgStart( "pictures" );

    --common.CloseSubRoom();
    
    end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_use_framedphoto", 0, "", 0 );
  
    ObjAnimate( "spr_picture_picture", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_secretroom_pictures", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_pictures", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_litcandle()

  local item = "inv_litcandle";

  if ( common.ApplyObj( item, "obj_breaker_use_litcandle", true ) ) then

    cmn.CallEventHandler( "use_litcandle_inv" );
    cmn.CallEventHandler( "use_litcandle_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_litcandle" );
      cmn.CallEventHandler( "use_litcandle_end" );

      cmn.MiniGameShow( "breaker" );
      common_impl.PassingMgStart( "breaker" );

      ng_global.progress["std"]["win_breaker"].pressed = { 0, 0, 0 };
      ng_global.progress["std"]["win_breaker"].used = 1;

    end;

    common_impl.Lock( true );

   common_impl.PlayAudio( "sfx", "common/audio/aud_use_litcandle", 0, "", 0 );

    ObjAnimate( "spr_breaker_back_light", "alp", 0, 0, func_after,
    { 

      0.0, 0, 0.0, 
      0.5, 0, 1.0

    } );

    ObjAnimate( "spr_breaker_candel", "alp", 0, 0, "",
    { 

      0.0, 0, 0.0, 
      0.5, 0, 1.0

    } );


    ObjAnimate( "obj_breaker_switch_1", "alp", 0, 0, "",
    { 

      0.0, 0, 0.0, 
      0.5, 0, 1.0

    } );



    ObjAnimate( "obj_breaker_mmg", "alp", 0, 0, "",
    { 

      0.0, 0, 0.0, 
      0.5, 0, 1.0

    } );

    return true;

  elseif common.ApplyObj( item, "gzz_secretroom_breaker", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_breaker", nil, { 512, 384 } );

    return true;
  
  end;

end;
--------------------------------------------------------------------------------------------
function public.use_providence_gun()

  local item = "inv_prv_gun";

  if ( ObjIntersect( item, "obj_secretroom_use_prv_item_2") and int_providence.show ) then

    cmn.CallEventHandler( "use_providence_gun_inv" );
    cmn.CallEventHandler( "use_providence_gun_beg" );
    
    local func_after = function ()

      common_impl.Lock(false);
      cmn.CallEventHandler( "use_providence_gun_end" );

      if cmn.IsEventDone( "clk_providence_plate" ) and cmn.IsEventDone( "clk_providence_towldummy" ) and 
          cmn.IsEventDone( "use_providence_gnomehead" ) then

          private.anim_providence( function() cmn.SetEventDone( "use_providence_gun" ); end );

      else 

        if ( cmn.IsEventDone( "clk_providence_plate" ) and cmn.IsEventDone( "clk_providence_towldummy" ) and             
            (cmn.IsEventDone( "use_providence_gun" ) or not cmn.IsEventDone( "get_prv_gnomehead" ) )) then
          int_button_providence.StopActiveProvidence();
        end;

        cmn.SetEventDone( "use_providence_gun" );

      end;

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_providence_gun", 0, "", 0 );

    ObjAnimate( "spr_secretroom_prv_gun_used", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_providence_gnomehead()

  local item = "inv_prv_gnomehead";

  if ( ObjIntersect( item, "obj_secretroom_use_prv_item_1" ) and int_providence.show ) then

    cmn.CallEventHandler( "use_providence_gnomehead_inv" );
    cmn.CallEventHandler( "use_providence_gnomehead_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.CallEventHandler( "use_providence_gnomehead_end" );

      if cmn.IsEventDone( "clk_providence_plate" ) and cmn.IsEventDone( "clk_providence_towldummy" ) and 
          cmn.IsEventDone( "use_providence_gun" ) then

          private.anim_providence( function() cmn.SetEventDone( "use_providence_gnomehead" ); end );

      else 

        if ( cmn.IsEventDone( "clk_providence_plate" ) and cmn.IsEventDone( "clk_providence_towldummy" ) and             
            (cmn.IsEventDone( "use_providence_gnomehead" ) or not cmn.IsEventDone( "get_prv_gun" ) )) then
          int_button_providence.StopActiveProvidence();
        end;

        cmn.SetEventDone( "use_providence_gnomehead" );

      end;

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_providence_gnomehead", 0, "", 0 );

    ObjAnimate( "spr_secretroom_prv_gnomehead_used", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_gnomefragment()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_gnomefragment" );
  cmn.CallEventHandler( "get_gnomefragment" );

end;
--------------------------------------------------------------------------------------------
function private.get_button_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_button_2" );
  cmn.CallEventHandler( "get_button_2" );
  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_awl()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_awl" );
  cmn.CallEventHandler( "get_awl" );

end;
--------------------------------------------------------------------------------------------
function private.get_evidence_3_5()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  local func_end = function ()

    --ObjSet( "spr_mansion_evidence_3_3", { pos_x = 512, pos_y = 384 } );
    interface.InvestigationButtonItemAdd( "evidence_3_5", "spr_workbench_evidence_3_5" );
    cmn.SetEventDone( "get_evidence_3_5" );
    cmn.CallEventHandler( "get_evidence_3_5" );
  
  end;

  interface.DialogEvidenceShow( "evidence_3_5", func_end );

end;
--------------------------------------------------------------------------------------------
function private.get_evidence_3_6()

--  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
--
--  local func_end = function ()
--
--    --ObjSet( "spr_mansion_evidence_3_3", { pos_x = 512, pos_y = 384 } );
--    interface.InvestigationButtonItemAdd( "evidence_3_5", "spr_workbench_evidence_3_5" );
--    cmn.SetEventDone( "get_evidence_3_5" );
--    cmn.CallEventHandler( "get_evidence_3_5" );
--  
--  end;
--
--  interface.DialogEvidenceShow( "evidence_3_5", func_end );

end;
--------------------------------------------------------------------------------------------
function private.get_gear_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_gear_3" );
  cmn.CallEventHandler( "get_gear_3" );

end;
--------------------------------------------------------------------------------------------
function private.get_framedphoto()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_framedphoto" );
  cmn.CallEventHandler( "get_framedphoto" );
  
  if ( common_impl.IsGetCoin( "get_coin_30" ) ) then

    common.CloseSubRoom();

  end;

end;
-----------------------------------------------------------------------------------------------------------------------
function private.get_collect_coin_30()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_30" );
    cmn.CallEventHandler( "get_coin_30" );

    if ( cmn.IsEventDone( "get_framedphoto" ) ) then

      common.CloseSubRoom();

    end;
        
  end;

  common_impl.PlayEffectHO( "spr_grizzlyskin_coin", func_after ); 

end;
-----------------------------------------------------------------------------------------------------------------------\
function private.get_collect_coin_31()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_31" );
    cmn.CallEventHandler( "get_coin_31" );

    if cmn.IsEventDone( "get_button_2" )  then

      common.CloseSubRoom();

    end;
        
  end;

  common_impl.PlayEffectHO( "spr_workbench_coin", func_after ); 

end;
-----------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
function private.get_lighter()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_lighter" );
  cmn.CallEventHandler( "get_lighter" );

end;
--------------------------------------------------------------------------------------------
function private.get_prv_gnomehead_silhouette()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );
  cmn.SetEventDone( "get_prv_gnomehead_silhouette" );
  cmn.CallEventHandler( "get_prv_gnomehead_silhouette" );

end;
--------------------------------------------------------------------------------------------
function private.get_prv_gun_silhouette()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );
  cmn.SetEventDone( "get_prv_gun_silhouette" );
  cmn.CallEventHandler( "get_prv_gun_silhouette" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.oliver_clk_1()

  local endfunc = function ()

    common_impl.Lock( false );

    cmn.SetEventDone( "clk_oliver_1" );
    cmn.CallEventHandler( "clk_oliver_1" );
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_remove_rope", 0, "", 0 );
  ObjAnimate( "obj_oliver_sits_untie", "alp", 0, 0, endfunc, { 0, 0, 0, 0.4, 3, 1 } );
  ObjAnimate( "anm_secretroom_oliver_sits1", "alp", 0, 0, "", { 0, 0, 1, 0.4, 3, 0 } );
 
end;
--------------------------------------------------------------------------------------------
function private.oliver_clk_2()

  local endfunc = function ()

    cmn.SetEventDone( "clk_oliver_2" );
    cmn.CallEventHandler( "clk_oliver_2" );
    common_impl.Lock( false );
    ObjSet( "obj_secretroom_oliver_sits2", { alp = 0 } );

  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_remove_rope", 0, "", 0 );
  ObjSet( "anm_secretroom_oliver_sits2", { playing = true, endtrig = endfunc } );
  ObjAnimate( "obj_secretroom_oliver_sits2", "alp", 0, 0, "", { 0, 0, 0, 0.4, 3, 1 } );
  ObjAnimate( "obj_oliver_sits_untie", "alp", 0, 0, "", { 0, 0, 1, 0.4, 3, 0 } );

end;
--------------------------------------------------------------------------------------------
function private.clk_leaves()

  local endfunc = function ()

    common_impl.Lock( false );
    common_impl.ShowBbt( 'bbt_secretroom_leaves', 1 );

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_feather", 0, "", 0 );

  AnimPlay( "anm_workbench_leaves", "DoAnim", endfunc );

end;
--------------------------------------------------------------------------------------------
function private.clk_bearskin()

  local endfunc = function ()

    cmn.SetEventDone( "clk_bearskin" );
    cmn.CallEventHandler( "clk_bearskin" ); 
    common_impl.Lock( false );

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_bearskin", 0, "", 0 );

  ObjAnimate( "obj_grizzlyskin_skin2", "alp", 0, 0, endfunc, { 0, 3, 1, 0.4, 3, 0});
  ObjAnimate( "obj_grizzlyskin_skin1", "alp", 0, 0, "", { 0, 3, 0, 0.4, 3, 1});  

end;
--------------------------------------------------------------------------------------------
function private.clk_gear()

  local endfunc = function ()

    cmn.SetEventDone( "clk_bearskin" );
    cmn.CallEventHandler( "clk_bearskin" ); 
    common_impl.Lock( false );

  end;

  common_impl.Lock( true );

  common_impl.ShowBbt( 'bbt_grizzlyskin_use_tweezers' );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_very_small_metall", 0, "", 0 );

  ObjAnimate( "spr_grizzlyskin_gear_3", "ang", 0, 0, endfunc, { 0, 3, 0, 0.1, 3, -0.06, 0.2, 3, 0, 0.3, 3, -0.05, 0.4, 3, 0 } );
   
end;
--------------------------------------------------------------------------------------------
function private.clk_button_2()

  local endfunc = function ()

    common_impl.Lock( false );
    common_impl.ShowBbt( 'bbt_workbench_use_vicehandle' );

  end;

  common_impl.Lock( true );

  local posx = ObjGet( "spr_workbench_button_2" ).pos_x;
  local posy = ObjGet( "spr_workbench_button_2" ).pos_y;
  local temp_pos_x = posx + 2;
  local temp_pos_y = posy - 2;

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_very_small_metall", 0, "", 0 );

  ObjAnimate( "spr_workbench_button_2", "pos_xy", 0, 0, endfunc, { 
              0.0, 3, posx      , posy,
              0.2, 3, temp_pos_x, temp_pos_y,
              0.4, 3, posx     , posy
            });

end;
--------------------------------------------------------------------------------------------
function private.clk_switch_1()

  common_impl.Lock( true );

  local func_after = function ()

    common_impl.Lock( false );
    common_impl.ShowBbt( 'bbt_secretroom_clk_switch_1' );

  end;

  if ( cmn.IsEventDone( "win_breaker" )) then

    cmn.CallEventHandler( "clk_switch_1_beg" );

    local func_after_2 = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "clk_switch_1" );
      cmn.CallEventHandler( "clk_switch_1_end" );
      common.CloseSubRoom();

      common_impl.PlayAudio( "env", "common/audio/aud_secretroom_light_env", 1, "", 0 );

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_breaker_touch_breaker", 0, "", 0 );

    ObjAnimate( "obj_breaker_switch_1", "alp", 0, 0, func_after_2, 
    { 
      0.0, 0, 1, 
      0.3, 0, 0
    } );

    ObjAnimate( "obj_breaker_switch_2", "alp", 0, 0, "", 
    { 
      0.0, 0, 0, 
      0.3, 0, 1
    } );

  elseif ( not cmn.IsEventDone( "win_breaker" ) and cmn.IsEventDone( "use_litcandle" )) then

    common_impl.PlayAudio( "sfx", "common/audio/aud_touch_breaker", 0, "", 0 ); 
  
    ObjAnimate( "obj_breaker_switch_1", "ang", 0, 0, func_after, 
    { 
      0.0, 0, 0, 
      0.3, 0, -0.05,
      0.6, 0, 0
    } );

  else 

    common_impl.PlayAudio( "sfx", "common/audio/aud_touch_breaker", 0, "", 0 );

    ObjAnimate( "obj_breaker_switch_1_night", "ang", 0, 0, func_after, 
    { 
      0.0, 0, 0, 
      0.3, 0, -0.05,
      0.6, 0, 0
    } );

  end;

end;


--------------------------------------------------------------------------------------------
function private.clk_vicehandle()

  cmn.CallEventHandler( "clk_vicehandle_beg" );

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_vicehandle" );
    cmn.CallEventHandler( "clk_vicehandle_end" );
  
  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_vicehandle", 0, "", 0 );
  
    ObjAnimate( "spr_workbench_handle", "alp", 0, 0, func_after,
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0,
    } );

    ObjAnimate( "spr_workbench_groove", "alp", 0, 0, func_after,
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );

    ObjAnimate( "spr_workbench_handledown", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0

    } );

    ObjAnimate( "obj_workbench_bench", "pos_xy", 0, 0, "",
    { 
      0.0, 0, 0, 0,
      0.3, 0, -5, 5
    } );


end;
--------------------------------------------------------------------------------------------
function private.clk_providence_plate()

  cmn.CallEventHandler( "clk_providence_plate_beg" );

  local func_after = function ()

    common_impl.Lock(false);

    cmn.CallEventHandler( "clk_providence_plate_end" );

    if cmn.IsEventDone( "clk_providence_towldummy" ) and cmn.IsEventDone( "use_providence_gun" ) 
       and cmn.IsEventDone( "use_providence_gnomehead" ) then

      private.anim_providence( function() cmn.SetEventDone( "clk_providence_plate" ); end );

    else 

      if ( cmn.IsEventDone( "clk_providence_towldummy" ) and
      ( not cmn.IsEventDone( "get_prv_gun" ) or cmn.IsEventDone( "use_providence_gun" ) ) and
      ( not cmn.IsEventDone( "get_prv_gnomehead" ) or cmn.IsEventDone( "use_providence_gnomehead" ) ) ) then

        int_button_providence.StopActiveProvidence();

      end;

      cmn.SetEventDone( "clk_providence_plate" );

    end;

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_plate", 0, "", 0 );

  ObjSet( "spr_secretroom_prv_plate", { alp = 0 } );
  ObjAnimate( "spr_secretroom_prv_plate_used", "alp", 0, 0, func_after, { 0, 0, 0, 0.1, 0, 0, 0.3, 0, 1 } );

end;
--------------------------------------------------------------------------------------------
function private.clk_providence_towldummy()

  cmn.CallEventHandler( "clk_providence_towldummy_beg" );
  
  local func_after = function ()

    common_impl.Lock(false);

    cmn.CallEventHandler( "clk_providence_towldummy_end" );

    if cmn.IsEventDone( "clk_providence_plate" ) and cmn.IsEventDone( "use_providence_gun" ) 
       and cmn.IsEventDone( "use_providence_gnomehead" ) then

      private.anim_providence( function() cmn.SetEventDone( "clk_providence_towldummy" ); end );

    else 

      if ( cmn.IsEventDone( "clk_providence_plate" ) and
      ( not cmn.IsEventDone( "get_prv_gun" ) or cmn.IsEventDone( "use_providence_gun" ) ) and
      ( not cmn.IsEventDone( "get_prv_gnomehead" ) or cmn.IsEventDone( "use_providence_gnomehead" ) ) ) then

        int_button_providence.StopActiveProvidence();

      end;

      cmn.SetEventDone( "clk_providence_towldummy" );

    end;

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_towldummy", 0, "", 0 );

  ObjSet( "spr_secretroom_prv_towldummy", { alp = 0 } );
  ObjAnimate( "spr_secretroom_prv_towldummy_used", "alp", 0, 0, func_after, { 0, 0, 0, 0.1, 0, 0, 0.3, 0, 1 } );

end;
--------------------------------------------------------------------------------------------
function private.anim_providence( func_execute )

  common_impl.ShowBbt( "bbt_providence_allitems" );

  int_button_providence.StopActiveProvidence();

  local array_objects = {
    "spr_secretroom_prv_towldummy_used",
    "spr_secretroom_prv_gun_used",
    "spr_secretroom_prv_gnomehead_used",
    "spr_secretroom_prv_plate_used" }

  local func_end = function()

    for i = 1, #array_objects do
      ObjAttach( array_objects[ i ], "rm_secretroom_providence" );
      ObjSet( array_objects[ i ], { alp = 1 } );
    end;
    common_impl.Lock( false );    
    private.vid_secretroom_providence( func_execute );

  end;
  
  common_impl.Lock( true );
  for i = 1, #array_objects do
    common_impl.PlayEffectHO( array_objects[ i ], func_end, 3, "assets/interface/resources/effect_mask" );
    func_end = nil;
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_ready", 0, "", 0 );

end;
-------------------------------------------------------------------------------------
function private.drag_plate ()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_secretroom_prv_plate", { pos_z = 10 } );

end;
-------------------------------------------------------------------------------------
function private.drop_plate ()

  local item = "spr_secretroom_prv_plate";

  ObjSet( item, { pos_z = 0 } );

  if ( ObjIntersect( item, "obj_secretroom_prv_item_1" ) ) then

    private.clk_providence_plate();

  end;

end;
-------------------------------------------------------------------------------------
function private.drag_towldummy ()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_secretroom_prv_towldummy", { pos_z = 10 } );

  ObjSet( "spr_secretroom_prv_towldummy_shadow", { visible = false } );

end;
-------------------------------------------------------------------------------------
function private.drop_towldummy ()

  local item = "spr_secretroom_prv_towldummy";

  ObjSet( item, { pos_z = 0 } );
  ObjSet( "spr_secretroom_prv_towldummy_shadow", { visible = true } );

  if ( ObjIntersect( item, "obj_secretroom_prv_item_2" ) ) then

    private.clk_providence_towldummy();

    ObjSet( "spr_secretroom_prv_towldummy_shadow", { pos_x = 633 } );
    
  end;

end;
--*********************************************************************************************************************
function private.vid_secretroom_providence( func_execute )

  interface.BBTHide();

  private.func_providence = func_execute;

  int_button_providence.StopLightProvidence();
  
  common_impl.StopAllMus();
  common_impl.PlayAudio( "sfx", "common/audio/aud_secretroom_providence_p1", 0, "", 0 );
  common_impl.PlayAudio( "mus", "common/audio/aud_providence_mus", 1, "", 0.5 ); 

  VidPlay( "vid_secretroom_providence_p1", "" ); 
  interface.DialogVideoShow( "vid_secretroom_providence", 1, function() private.vid_secretroom_providence_end(); end , 3, 4 ); 

end;

function private.vid_secretroom_providence_end( )

    common_impl.Lock( false );
    common_impl.StopAudio( "sfx", "common/audio/aud_secretroom_providence_p4", 0.2 );
    int_providence.Hide();
    VidStop( "vid_secretroom_providence_p4" );
    interface.DialogVideoHide();
  
    cmn.SetEventDone( "vid_secretroom_providence" );
    cmn.CallEventHandler( "vid_secretroom_prv_end" );

    common_impl.ShowBbt( 'bbt_providence_level3_4_end' );
    
    if ( private.func_providence ) then

      private.func_providence();
      private.func_providence = nil;

    end;

    common_impl.StopAudio( "mus", "common/audio/aud_providence_mus", 1, "", 0.5 ); 
    common_impl.PlayAudio( "mus", "common/audio/aud_enigma_mus", 0, "", 0 );
  
end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.grizzlyskin_cup_1_clk()
  
  common_impl.Lock( true );

  local endfunc = function ()

    common_impl.Lock( false );
    common_impl.ShowBbt( 'bbt_grizzlyskin_use_awl' );

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_stash_handle", 0, "", 0 );

  ObjAnimate( "anm_grizzlyskin_awl1", "pos_x", 0, 1, endfunc, 
  {
    0.0, 3, 0, 
    0.2, 3, 2,
    0.4, 3, 0,
 
  });

end;
---------------------------------------------------------------------------------------------------------
function private.pictures_reset()

  ng_global.progress[ "std" ][ "win_pictures" ].current_pos = { false, false, false, false }; 
  private.current_pos = { false, false, false, false };
  ng_global.progress[ "std" ][ "win_pictures" ].num_state = 1;

end;
--------------------------------------------------------------------------------------------------------------
function private.picture_is_right_drop(num)

  local variation_mas = {};
  local variation1 = { 1, 2, 3, 4 };
  local variation2 = { 1, 3, 2, 4 };

  local variation = variation1;

  if ( ng_global.progress[ "std" ][ "win_pictures" ].num_state == 1 ) then

    if ( ( num == 2 and ObjGet("spr_picture_p3").input == true ) or (  num == 3 and ObjGet("spr_picture_p2").input == true ) ) then
      
      if (( common.ApplyObj( "obj_picture_drop3", "spr_picture_p2", true )) or (( common.ApplyObj( "obj_picture_drop2", "spr_picture_p3", true )))) then

        ng_global.progress[ "std" ][ "win_pictures" ].num_state = 2;
        variation = variation2;

      end;
      
    end;

  elseif ng_global.progress[ "std" ][ "win_pictures" ].num_state == 2 then

    variation = variation2;

  end;

  if common.ApplyObj( "obj_picture_drop"..variation[num], "spr_picture_p"..num, true ) then
 
    return true;

  else

    return false;
  
  end;

end;
--------------------------------------------------------------------------------------------------------------
function private.picture_drop(num)

  if ( private.picture_is_right_drop(num) ) then

    local nst = ng_global.progress[ "std" ][ "win_pictures" ].num_state;

    ObjSet( "spr_picture_p"..num, { input = false, pos_x = private.right_coord[nst][num][1], pos_y = private.right_coord[nst][num][2], pos_z = 0 });

    private.picture_right_anim(num);

  else

    private.picture_wrong_anim(num);

  end;
  
end;
--------------------------------------------------------------------------------------------------------------
function private.picture_wrong_anim(num)

  local endfunc = function ()

    --common_impl.Lock( false );

  end;

  --common_impl.Lock( true );

  endfunc = nil;

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_pictures_wrong", 0, "", 0 );

  ObjAnimate( "spr_picture_p"..num, "color_g", 0, 0, endfunc, { 0, 3, 1, 0.15, 3, 0.5, 0.3, 3, 1 });
  ObjAnimate( "spr_picture_p"..num, "color_b", 0, 0, "",      { 0, 3, 1, 0.15, 3, 0.5, 0.3, 3, 1 });

end;
--------------------------------------------------------------------------------------------------------------
function private.picture_right_anim(num)

  local endfunc = function()

    private.current_pos[num] = true;

    if ( not private.pictures_CheckWin() ) then
        
      private.Save_pos_pictures(num);

    else

      private.Win_pictures();

    end;

  end;
    
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_pictures_right", 0, "", 0 );

  ObjAnimate( "spr_picture_p"..num, "color_r", 0, 0, endfunc, { 0, 3, 1, 0.15, 3, 0.5, 0.3, 3, 1 });
  ObjAnimate( "spr_picture_p"..num, "color_b", 0, 0, "",      { 0, 3, 1, 0.15, 3, 0.5, 0.3, 3, 1 });

end;
--------------------------------------------------------------------------------------------------------------
function private.Save_pos_pictures(num)
        
  ng_global.progress[ "std" ][ "win_pictures" ].current_pos[num] = private.current_pos[num];

end;
--------------------------------------------------------------------------------------------------------------
function private.Win_pictures()
  
  common_impl.PassingMgWin( "pictures" );
  cmn.MiniGameHide( "pictures" );
  local endfunc = function ()

    private.Win_end_pictures();  

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_pictures_win", 0, "", 0 );
  common_impl.Lock( true );
  ObjAnimate( "obj_picture_mmg", "pos_y", 0, 1, endfunc, { 0, 3, 0, 3, 3, 600});
  ObjSet( "vid_pictures_hex", { alp = 1, active = true });
  
end;
--------------------------------------------------------------------------------------------------------------
function private.Win_end_pictures()
  
  common_impl.Lock( false );
  cmn.SetEventDone( "win_pictures" );
  cmn.CallEventHandler( "win_pictures" );

end;
--------------------------------------------------------------------------------------------------------------
function private.pictures_CheckWin()

  for i = 1,4 do

    if private.current_pos[i] == false then
      
      return false;

    end;

  end;

  return true;

end;
--------------------------------------------------------------------------------------------------------------
function private.opn_secretroom()

  if not ( cmn.IsEventDone( "opn_secretroom" ) ) then

    cmn.SetEventDone( "opn_secretroom" );
    common_impl.PlayAudio( "mus", "common/audio/aud_scary_mus", 0, "", 0 );

  end;
  
  cmn.CallEventHandler( "opn_secretroom" ); 

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.dlg_secretroom_oliver()

  ObjAttach( "dlg_secretroom_oliver", private.room_objname );
  common_impl.continue_visible = false; 
  common_impl.dialog_character_loc = "obj_secretroom_oliver_loc";
  private.dialog_voices_time = { 5, 6, 8 };
  common_impl.DialogCharacterStart( "oliver", 6, nil, nil, true, "dlg_secretroom_oliver_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_secretroom_oliver_end()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  local func_end = function ()

    --ObjSet( "spr_mansion_evidence_3_3", { pos_x = 512, pos_y = 384 } );
    interface.InvestigationButtonItemAdd( "evidence_3_6", "spr_secretroom_evidence_3_6" );
    cmn.SetEventDone( "dlg_secretroom_oliver" );
    cmn.CallEventHandler( "dlg_secretroom_oliver_end" );
    cmn.SetEventDone( "get_evidence_3_6" );
    interface.KeyTaskDone( "examine_home", true );
    interface.KeyTaskAdd( 'arrest_sheriff' );
    ObjSet( "obj_int_dialog_character", { alp = 1 } );  
  
  end;

  interface.DialogEvidenceShow( "evidence_3_6", func_end );

end;
--*********************************************************************************************************************
function private.ClickDlgPaper( number )
  
   local func_after = function()

      common_impl.Lock( false );

      ObjSet( "spr_secretroom_oliver_paper_"..number,  { input = false } );

      if number <= 2 then
  
        ObjSet( "spr_secretroom_oliver_paper_"..( number + 1 ), { input = true } );

      else

        common_impl.DialogCharacterMmgHide( 'oliver' );
        common_impl.DialogCharacterHide();
     
      end;
      
   end;
     
   common_impl.Lock( true );
    
   if number <= 2 then

     ObjAnimate( "spr_secretroom_oliver_paper_"..number, "alp", 0, 0, func_after, { 0,0,1, 0.1,0,0 } );
     ObjAnimate( "spr_secretroom_oliver_paper_"..( number + 1 ), "alp", 0, 0, "", { 0,0,0, 0.1,0,1 } );
     common_impl.PlayAudio( "sfx", "common/audio/aud_paper_open", 0, "", 0 );

   else
    
     ObjAnimate( "spr_secretroom_oliver_paper_"..number, "alp", 0, 0, func_after, { 0,0,1, 0.3,0,0 } );
     ObjAnimate( "spr_secretroom_oliver_paper_"..number, "scale_xy", 0, 0, "", { 0,0,1,1, 0.3,0,1.1,1.1 } );
     common_impl.PlayAudio( "sfx", "common/audio/aud_paper_close", 0, "", 0 );

   end;
    

end;    
--*********************************************************************************************************************
function private.ShowDlgPaper()

    ObjSet( "anm_secretroom_oliver", { alp = 1 } );
    ObjSet( "anm_secretroom_oliver_2", { alp = 0 } );

   common_impl.DialogCharacterMmgShow( 'oliver', 300, 350 );

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if dlg_name == "oliver" then
  
    if count_txt == 1 then 

      common_impl.continue_visible = false;
      common_impl.frases = { 1, 2, 3 }; 
      common_impl.dial_icons = { 'owlman', 'kidnapping', 'nightsville' };
      common_impl.DialogCharacterShowDialogQuestions( 3, 3  );

    elseif count_txt == 2 then 

      common_impl.continue_visible = false;
      common_impl.DialogCharacterShowDialogQuestions( 2, private.dialog_voices_time[ common_impl.dialog_character_select ]  );

     elseif count_txt == 3 then 

      common_impl.continue_visible = false;
      common_impl.DialogCharacterShowDialogQuestions( 1, private.dialog_voices_time[ common_impl.dialog_character_select ]  );
     
    elseif count_txt == 5 then 

      ObjSet( "anm_secretroom_oliver", { alp = 0 } );
      ObjSet( "anm_secretroom_oliver_2", { alp = 1 } );
      ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = private.ShowDlgPaper } );
      common_impl.PlayAudio( "sfx", "common/audio/aud_get_to_us", 0, "", 0 );
        
    end;

  end;  

end;
--*********************************************************************************************************************
-----------------------------MMG---------------------------------------------------
-----------------------------------------------------------------------------------
--*********************************************************************************************************************
function private.ClkItem( num )
  
  common_impl.Lock( true );

  if private.tumb_win[ ng_global.progress["std"]["win_breaker"].used ] == tonumber( num ) then

    local func_after = function ()

      common_impl.Lock( false );

      ObjSet( "obj_breaker_tumb_"..num, { input = false });

      ng_global.progress["std"]["win_breaker"].pressed[ ng_global.progress["std"]["win_breaker"].used ] = num;
      ng_global.progress["std"]["win_breaker"].used = ng_global.progress["std"]["win_breaker"].used + 1;

      if ng_global.progress["std"]["win_breaker"].used == 4 then 

        private.Win();

      end;

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_breaker_tumb_up", 0, "", 0 );

    ObjAnimate( "obj_breaker_tumb_down_"..num, "alp", 0, 0, "", 
    { 
      0.0,0,1,  
      0.3,0,0
    });
    
    ObjAnimate( "obj_breaker_tumb_up_"..num, "alp", 0, 0, func_after, 
    { 
      0.0,0,0,  
      0.3,0,1
    });

  else 

    local func_after = function ()

      public.Reset();

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_breaker_tumb_up", 0, "", 0 );

    ObjAnimate( "obj_breaker_tumb_down_"..num, "alp", 0, 0, "", 
    { 
      0.0,0,1,  
      0.3,0,0
    });

    ObjAnimate( "obj_breaker_tumb_up_"..num, "alp", 0, 0, func_after, 
    { 
      0.0,0,0,  
      0.3,0,1
    });

  end;

end;
-----------------------------------------------------------------------------------
function public.Skip( event )

  local mg_name = common.GetCurrentSubRoom();
  
  if ( mg_name == "zz_breaker" ) then

    for i = 1, 3 do

      ObjSet( "obj_breaker_tumb_up_"..i, { alp = 1 });
      ObjSet( "obj_breaker_tumb_down_"..i, { alp = 0 });

    end;

    private.Win();

  elseif ( mg_name == "zz_pictures" ) then
  
  local nst = ng_global.progress[ "std" ][ "win_pictures" ].num_state;

    for i = 1,4 do

      if ( ObjGet( "spr_picture_p"..i ).input ) then

        ObjSet( "spr_picture_p"..i, { input = false } );

        local circles = math.random( 1,3 ); 

        local endfunc = function ()

          common_impl.Lock( false );          
          private.Win_pictures();

        end;
        
        common_impl.Lock( true );

        ObjAnimate( "spr_picture_p"..i, "ang", 0, 0, endfunc, { 0, 3, 0, 2, 3, 6.28*circles });

        endfunc = nil;

        local pos_x = ObjGet( "spr_picture_p"..i ).pos_x;
         
        local pos_y = ObjGet( "spr_picture_p"..i ).pos_y;

        ObjAnimate( "spr_picture_p"..i, "pos_xy", 0, 0, "", { 0, 3, pos_x, pos_y, 2, 3, private.right_coord[nst][i][1], private.right_coord[nst][i][2] });
        
      end;

    end;

  end;
end;
-----------------------------------------------------------------------------------
function public.Reset( event )

  local mg_name = common.GetCurrentSubRoom();
  
  if ( mg_name == "zz_breaker" ) then

    common_impl.Lock( false );

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_breaker_tumb_down", 0, "", 0 );

    for i = 1,3 do

      ObjSet( "obj_breaker_tumb_"..i, { input = true });
      ObjSet( "obj_breaker_tumb_up_"..i, { alp = 0 });
      ObjSet( "obj_breaker_tumb_down_"..i, { alp = 1 });
      
    end;

    ng_global.progress["std"]["win_breaker"].used = 1;
    ng_global.progress["std"]["win_breaker"].pressed = { 0, 0, 0 };
    private.reset = 0;

 elseif ( mg_name == "zz_pictures" ) then
  
    for i = 1,4 do

      if ( not ObjGet( "spr_picture_p"..i ).input ) then

        ObjSet( "spr_picture_p"..i, { input = true } );

        local circles = math.random( 1,3 ); 

        local endfunc = function ()

          common_impl.Lock( false );          
          private.pictures_reset();

        end;
        
        common_impl.Lock( true );

        ObjAnimate( "spr_picture_p"..i, "ang", 0, 0, endfunc, { 0, 3, 0, 2, 3, 6.28*circles });

        endfunc = nil;

        local pos_x = ObjGet( "spr_picture_p"..i ).pos_x;
         
        local pos_y = ObjGet( "spr_picture_p"..i ).pos_y;

        ObjAnimate( "spr_picture_p"..i, "pos_xy", 0, 0, "", { 0, 3, pos_x, pos_y, 2, 3, private.picture_start_pos[i][1], private.picture_start_pos[i][2] });

      end;

    end;

  end;

end;
-----------------------------------------------------------------------------------
function private.Win ()
  
  common_impl.Lock( false);
  PlaySfx( "assets/levels/common/audio/aud_mg_win", 0, 0 );
  cmn.MiniGameHide( "breaker" );
  cmn.SetEventDone( "win_breaker" );
  cmn.CallEventHandler( "win_breaker" );
  common_impl.PassingMgWin( "breaker" );

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_breaker_win", 0, "", 0 );

  ObjAnimate( "spr_breaker_green_light", "alp", 1, 0, "",
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.6,
    0.6, 0, 1.0
  } );

end;
