-- name=rm_sheriffshouse
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_sheriffshouse";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_gardengnome", "room_hub" );
  ObjAttach( "zz_cellarwindow", "room_hub" );
  ObjAttach( "zz_barn", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_gardengnome_carkeys", { event_mdown = private.get_carkeys }},
    { "spr_gardengnome_bottle", { event_mdown = private.get_bottleofwine }},
    { "spr_gardengnome_valve", { event_mdown = private.get_valve }},
    { "spr_gardengnome_prv_gnomehead", { event_mdown = private.get_prv_gnomehead }},
    { "spr_barn_gloveboxhandle", { event_mdown = private.get_gloveboxhandle }},
    { "spr_barn_glasscutter", { event_mdown = private.get_glasscutter }},
    { "spr_barn_prv_fuellamp", { event_mdown = private.get_prv_fuellamp }},
    { "spr_barn_button_1", { event_mdown = private.get_button_1 }},
    { "obj_cellarwindow_clk_handle", { event_mdown = private.clk_handle_3 }},
    { "obj_barn_use_lockpick", { event_mdown = private.AnmCastle }},
    
    { "spr_barn_coin",           { event_mdown = private.get_collect_coin_27 }},
    { "spr_gardengnome_coin",    { event_mdown = private.get_collect_coin_28 }},

    { "spr_sheriffshouse_collect_item",    { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_3_2" );     end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_sheriffshouse_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_3_4" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },

  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_sheriffshouse = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gmg_sheriffshouse_",
    "gzz_sheriffshouse_gardengnome",
    "gzz_sheriffshouse_cellarwindow",
    "gzz_sheriffshouse_barn"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_gardengnome",
      "zz_cellarwindow",
      "zz_barn"
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_sheriffshouse", update_game_mode_sheriffshouse, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_sheriffshouse = function ()

  local effects_table = 
  {
    "obj_sheriffshouse_anim", 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_sheriffshouse", update_performance_mode_sheriffshouse, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_sheriffshouse () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_sheriffshouse" ] = {
    type = "click",
    use_place = "grm_square_3_sheriffshouse",
    room = "rm_square_3"
  };

  local opn_sheriffshouse_map = function ()

    common_impl.VisitMapRoom( "sheriffshouse" );

  end;
  cmn.AddSubscriber( "opn_sheriffshouse", opn_sheriffshouse_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_3_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_3_2 = function ()
  
    ObjDelete( "obj_sheriffshouse_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_3_2", get_collect_item_3_2, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_3_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_3_4 = function ()
  
    ObjDelete( "obj_sheriffshouse_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_3_4", get_collect_morph_item_3_4, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_carkeys () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_carkeys" ] = {
    type = "get",
    get_obj = "spr_gardengnome_carkeys",
    room = private.room_objname,
    zz = "zz_gardengnome",
    zz_gate = "gzz_sheriffshouse_gardengnome"
  };
    
  local get_carkeys_inv = function ()
  
    interface.InventoryItemAdd( "inv_carkeys", "spr_gardengnome_carkeys" );
  
  end;
  
  local get_carkeys_closezz = function ()
  
    ObjDelete( "gfx_gardengnome_carkeys" );
    ObjDelete( "spr_gardengnome_carkey_cap" );
    ObjDelete( "spr_sheriffshouse_gardengnome_carkey" );

    if cmn.IsEventDone( "get_prv_gnomehead" ) and cmn.IsEventDone( "get_valve" )
    and cmn.IsEventDone( "get_bottleofwine" ) and common_impl.IsGetCoin( "get_coin_28" ) then

      ObjDelete( "gzz_sheriffshouse_gardengnome" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_carkeys", get_carkeys_inv );
  cmn.AddSubscriber( "get_carkeys", get_carkeys_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bottleofwine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bottleofwine" ] = {
    type = "get",
    get_obj = "spr_gardengnome_bottle",
    room = private.room_objname,
    zz = "zz_gardengnome",
    zz_gate = "gzz_sheriffshouse_gardengnome"
  };
    
  local get_bottleofwine_inv = function ()
  
    interface.InventoryItemAdd( "inv_bottleofwine", "spr_gardengnome_bottle" );
  
  end;
  
  local get_bottleofwine_closezz = function ()
  
    ObjDelete( "gfx_gardengnome_bottle" );
    ObjDelete( "spr_gardengnome_bottle_shadow" );
    ObjDelete( "spr_sheriffshouse_gardengnome_bottle" );

    if cmn.IsEventDone( "get_prv_gnomehead" ) and cmn.IsEventDone( "get_valve" )
    and cmn.IsEventDone( "get_carkeys" ) and common_impl.IsGetCoin( "get_coin_28" ) then

      ObjDelete( "gzz_sheriffshouse_gardengnome" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_bottleofwine", get_bottleofwine_inv );
  cmn.AddSubscriber( "get_bottleofwine", get_bottleofwine_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_valve () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_valve" ] = {
    type = "get",
    get_obj = "spr_gardengnome_valve",
    room = private.room_objname,
    zz = "zz_gardengnome",
    zz_gate = "gzz_sheriffshouse_gardengnome"
  };
    
  local get_valve_inv = function ()
  
    interface.InventoryItemAdd( "inv_valve", "spr_gardengnome_valve" );
  
  end;
  
  local get_valve_closezz = function ()
  
    ObjDelete( "gfx_gardengnome_valve" );
    ObjDelete( "spr_gardengnome_valve_shadow" );
    ObjDelete( "spr_sheriffshouse_gardengnome_valve" );

    if cmn.IsEventDone( "get_prv_gnomehead" ) and cmn.IsEventDone( "get_bottleofwine" )
    and cmn.IsEventDone( "get_carkeys" ) and common_impl.IsGetCoin( "get_coin_28" ) then

      ObjDelete( "gzz_sheriffshouse_gardengnome" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_valve", get_valve_inv );
  cmn.AddSubscriber( "get_valve", get_valve_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_prv_gnomehead () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_prv_gnomehead" ] = {
    type = "get",
    get_obj = "spr_gardengnome_prv_gnomehead",
    room = private.room_objname,
    zz = "zz_gardengnome",
    zz_gate = "gzz_sheriffshouse_gardengnome"
  };
    
  local get_prv_gnomehead_inv = function ()
  
    interface.ProvidePanelItemAdd( "inv_prv_gnomehead", "spr_gardengnome_prv_gnomehead" );
  
  end;
  
  local get_prv_gnomehead_closezz = function ()
  
    ObjDelete( "gfx_gardengnome_prv_gnomehead" );
    ObjDelete( "spr_sheriffshouse_gardengnome_head_2" );

    if cmn.IsEventDone( "get_bottleofwine" ) and cmn.IsEventDone( "get_valve" )
    and cmn.IsEventDone( "get_carkeys" ) and common_impl.IsGetCoin( "get_coin_28" ) then

      ObjDelete( "gzz_sheriffshouse_gardengnome" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_prv_gnomehead", get_prv_gnomehead_inv );
  cmn.AddSubscriber( "get_prv_gnomehead", get_prv_gnomehead_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gloveboxhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gloveboxhandle" ] = {
    type = "get",
    get_obj = "spr_barn_gloveboxhandle",
    room = private.room_objname,
    zz = "zz_barn",
    zz_gate = "gzz_sheriffshouse_barn"
  };
    
  local get_gloveboxhandle_inv = function ()
  
    interface.InventoryItemAdd( "inv_gloveboxhandle", "spr_barn_gloveboxhandle" );
  
  end;
  
  local get_gloveboxhandle_closezz = function ()
  
    ObjDelete( "gfx_barn_gloveboxhandle" );
    ObjDelete( "spr_barn_doorknob_shadow" );

    if ( cmn.IsEventDone( "get_button_1" ) and cmn.IsEventDone( "get_glasscutter" ) and cmn.IsEventDone( "get_prv_fuellamp" ) and common_impl.IsGetCoin( "get_coin_27" ) ) then

      ObjDelete( "gzz_sheriffshouse_barn" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_gloveboxhandle", get_gloveboxhandle_inv );
  cmn.AddSubscriber( "get_gloveboxhandle", get_gloveboxhandle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_glasscutter () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_glasscutter" ] = {
    type = "get",
    get_obj = "spr_barn_glasscutter",
    room = private.room_objname,
    zz = "zz_barn",
    zz_gate = "gzz_sheriffshouse_barn"
  };
    
  local get_glasscutter_inv = function ()

    interface.InventoryItemAdd( "inv_glasscutter", "spr_barn_glasscutter" );
    ObjSet( "inv_glasscutter", { drag = false });

  end;
  
  local get_glasscutter_closezz = function ()
  
    ObjDelete( "gfx_barn_glasscutter" );
    ObjDelete( "spr_barn_glasscutter_shadow" );
    ObjDelete( "spr_sheriffshouse_barn_glasscutter" );

    if ( cmn.IsEventDone( "get_button_1" ) and cmn.IsEventDone( "get_gloveboxhandle" ) and cmn.IsEventDone( "get_prv_fuellamp" ) and common_impl.IsGetCoin( "get_coin_27" ) ) then

      ObjDelete( "gzz_sheriffshouse_barn" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_glasscutter", get_glasscutter_inv );
  cmn.AddSubscriber( "get_glasscutter", get_glasscutter_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_prv_fuellamp () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_prv_fuellamp" ] = {
    type = "get",
    get_obj = "spr_barn_prv_fuellamp",
    room = private.room_objname,
    zz = "zz_barn",
    zz_gate = "gzz_sheriffshouse_barn"
  };
    
  local get_prv_fuellamp_inv = function ()
  
    interface.ProvidePanelItemAdd( "inv_prv_fuellamp", "spr_barn_prv_fuellamp" );
  
  end;
  
  local get_prv_fuellamp_closezz = function ()
  
    ObjDelete( "gfx_barn_prv_fuellamp" );
    ObjDelete( "spr_barn_lamp_2_shadow" );
    ObjDelete( "spr_sheriffshouse_barn_lamp" );
    ObjDelete( "spr_barn_lamp_over" );

    if ( cmn.IsEventDone( "get_button_1" ) and cmn.IsEventDone( "get_gloveboxhandle" ) and cmn.IsEventDone( "get_glasscutter" ) and common_impl.IsGetCoin( "get_coin_27" ) ) then

      ObjDelete( "gzz_sheriffshouse_barn" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_prv_fuellamp", get_prv_fuellamp_inv );
  cmn.AddSubscriber( "get_prv_fuellamp", get_prv_fuellamp_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_button_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_button_1" ] = {
    type = "get",
    get_obj = "spr_barn_button_1",
    room = private.room_objname,
    zz = "zz_barn",
    zz_gate = "gzz_sheriffshouse_barn"
  };
    
  local get_button_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_button_1", "spr_barn_button_1" );
  
  end;
  
  local get_button_1_closezz = function ()
  
    ObjDelete( "gfx_barn_button_1" );
    ObjDelete( "spr_barn_button_shadow" );
    ObjDelete( "spr_sheriffshouse_barn_button" );

    if ( cmn.IsEventDone( "get_prv_fuellamp" ) and cmn.IsEventDone( "get_gloveboxhandle" ) and cmn.IsEventDone( "get_glasscutter" ) and common_impl.IsGetCoin( "get_coin_27" ) ) then

      ObjDelete( "gzz_sheriffshouse_barn" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_button_1", get_button_1_inv );
  cmn.AddSubscriber( "get_button_1", get_button_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_penknife () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_penknife" ] = {
    type = "use",
    inv_obj = "inv_penknife",
    use_place = "obj_gardengnome_use_penknife",
    room = private.room_objname,
    zz = "zz_gardengnome",
    zz_gate = "gzz_sheriffshouse_gardengnome"
  };
  local use_penknife_inv = function ()
  
    interface.InventoryItemRemove( "inv_penknife" );
  
  end;
  local use_penknife_beg = function ()
  
    ObjDelete( "obj_gardengnome_use_penknife" );
  
  end;
  local use_penknife_end = function ()
  
    ObjDelete( "spr_gardengnome_knife" );
    ObjDelete( "spr_gardengnome_belt_1" );
    ObjDelete( "spr_gardengnome_basket_close" );
    ObjDelete( "spr_sheriffshouse_gardengnome_cover_1" );
    ObjDelete( "anm_gardengnome_knife" );

    ObjMultiSet(
    { 
      { "spr_gardengnome_basket_open",     { alp = 1   } },
      { "spr_gardengnome_belt_2",     { alp = 1    } },
      { "obj_gardengnome_bottle",     { input = true, active = true  } },
      { "spr_sheriffshouse_gardengnome_cover_2",     { alp = 1 } }
    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_penknife", use_penknife_beg, private.room_objname );
  cmn.AddSubscriber( "use_penknife", use_penknife_inv );
  cmn.AddSubscriber( "use_penknife", use_penknife_end, private.room_objname );
  cmn.AddSubscriber( "use_penknife_inv", use_penknife_inv, private.room_objname );
  cmn.AddSubscriber( "use_penknife_beg", use_penknife_beg, private.room_objname );
  cmn.AddSubscriber( "use_penknife_end", use_penknife_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gnomefragment () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gnomefragment" ] = {
    type = "use",
    inv_obj = "inv_gnomefragment",
    use_place = "obj_gardengnome_use_gnomefragment",
    room = private.room_objname,
    zz = "zz_gardengnome",
    zz_gate = "gzz_sheriffshouse_gardengnome"
  };
  local use_gnomefragment_inv = function ()
  
    interface.InventoryItemRemove( "inv_gnomefragment" );
  
  end;
  local use_gnomefragment_beg = function ()
  
    ObjDelete( "obj_gardengnome_use_gnomefragment" );
  
  end;
  local use_gnomefragment_end = function ()
  
    ObjDelete( "spr_gardengnome_head_close" );
    ObjDelete( "spr_sheriffshouse_gardengnome_head_1" );

    ObjMultiSet({ 
      { "spr_gardengnome_valve",     { input = true, active = true } },
      { "spr_gardengnome_prv_gnomehead", { input = true, alp = 1 } },
      { "spr_gardengnome_beltbuckle", { alp = 1 } },
      { "spr_sheriffshouse_gardengnome_buckle", { alp = 1 } },
      { "spr_sheriffshouse_gardengnome_head_2", { alp = 1 } }
    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gnomefragment", use_gnomefragment_beg, private.room_objname );
  cmn.AddSubscriber( "use_gnomefragment", use_gnomefragment_inv );
  cmn.AddSubscriber( "use_gnomefragment", use_gnomefragment_end, private.room_objname );
  cmn.AddSubscriber( "use_gnomefragment_inv", use_gnomefragment_inv, private.room_objname );
  cmn.AddSubscriber( "use_gnomefragment_beg", use_gnomefragment_beg, private.room_objname );
  cmn.AddSubscriber( "use_gnomefragment_end", use_gnomefragment_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_fullhat () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_fullhat" ] = {
    type = "use",
    inv_obj = "inv_fullhat",
    use_place = "obj_cellarwindow_use_fullhat",
    room = private.room_objname,
    zz = "zz_cellarwindow",
    zz_gate = "gzz_sheriffshouse_cellarwindow"
  };
  local use_fullhat_inv = function ()
  
    interface.InventoryItemRemove( "inv_fullhat" );
  
  end;
  local use_fullhat_beg = function ()
  
    ObjDelete( "obj_cellarwindow_use_fullhat" );
  
  end;
  local use_fullhat_end = function ()

    ObjDelete( "vid_cellarwindow_fire"  );
    ObjDelete( "vid_cellarwindow_hat"  );
    ObjDelete( "vid_sheriffshouse_fire"  );

    ObjDelete( "spr_sheriffshouse_cellarwindow_open_add" );

    ObjSet( "obj_cellarwindow_use_workingglasscutter", { input = true, visible = true, active = true });
    ObjSet( "zz_cellarwindow", { res="assets/levels/level3/rm_sheriffshouse/zz_cellarwindow/layers/back2"  });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_fullhat", use_fullhat_beg, private.room_objname );
  cmn.AddSubscriber( "use_fullhat", use_fullhat_inv );
  cmn.AddSubscriber( "use_fullhat", use_fullhat_end, private.room_objname );
  cmn.AddSubscriber( "use_fullhat_inv", use_fullhat_inv, private.room_objname );
  cmn.AddSubscriber( "use_fullhat_beg", use_fullhat_beg, private.room_objname );
  cmn.AddSubscriber( "use_fullhat_end", use_fullhat_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_workingglasscutter () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_workingglasscutter" ] = {
    type = "use",
    inv_obj = "inv_workingglasscutter",
    use_place = "obj_cellarwindow_use_workingglasscutter",
    room = private.room_objname,
    zz = "zz_cellarwindow",
    zz_gate = "gzz_sheriffshouse_cellarwindow"
  };
  local use_workingglasscutter_inv = function ()
  
    interface.InventoryItemRemove( "inv_workingglasscutter" );
  
  end;
  local use_workingglasscutter_beg = function ()
  
    ObjDelete( "obj_cellarwindow_use_workingglasscutter" );

  end;
  local use_workingglasscutter_end = function ()
  
    ObjDelete( "anm_cellarwindow_anim_glass1" );
    ObjMultiSet({ 
      { "obj_cellarwindow_open", { alp = 1 } },
      { "obj_cellarwindow_clk_handle", { input = true } }
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_workingglasscutter", use_workingglasscutter_beg, private.room_objname );
  cmn.AddSubscriber( "use_workingglasscutter", use_workingglasscutter_inv );
  cmn.AddSubscriber( "use_workingglasscutter", use_workingglasscutter_end, private.room_objname );
  cmn.AddSubscriber( "use_workingglasscutter_inv", use_workingglasscutter_inv, private.room_objname );
  cmn.AddSubscriber( "use_workingglasscutter_beg", use_workingglasscutter_beg, private.room_objname );
  cmn.AddSubscriber( "use_workingglasscutter_end", use_workingglasscutter_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_lockpick () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lockpick" ] = {
    type = "use",
    inv_obj = "inv_lockpick",
    use_place = "obj_barn_use_lockpick",
    room = private.room_objname,
    zz = "zz_barn",
    zz_gate = "gzz_sheriffshouse_barn"
  };
  local use_lockpick_inv = function ()
  
    interface.InventoryItemRemove( "inv_lockpick" );
  
  end;
  local use_lockpick_beg = function ()
  
    ObjDelete( "obj_barn_use_lockpick" );
  
  end;
  local use_lockpick_end = function ()
  
    ObjMultiSet({ 
      { "spr_barn_glasscutter",        { input = true     } },
      { "obj_barn_coin",               { input = true     } },
      { "gfx_barn_glasscutter",        { active = true    } },
      { "spr_barn_gloveboxhandle",     { input = true     } },
      { "gfx_barn_gloveboxhandle",     { active = true    } },
      { "spr_barn_door_2",             { alp = 1 } },
      { "obj_barn_use_stick",          { input = true } },
      { "spr_sheriffshouse_barn_door_2", { alp = 1 } },
      { "spr_sheriffshouse_barn_heck", { alp = 1 } }
    });

    ObjDelete( "spr_barn_door_1" );
    ObjDelete( "spr_sheriffshouse_barn_door_1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lockpick", use_lockpick_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpick", use_lockpick_inv );
  cmn.AddSubscriber( "use_lockpick", use_lockpick_end, private.room_objname );
  cmn.AddSubscriber( "use_lockpick_inv", use_lockpick_inv, private.room_objname );
  cmn.AddSubscriber( "use_lockpick_beg", use_lockpick_beg, private.room_objname );
  cmn.AddSubscriber( "use_lockpick_end", use_lockpick_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_stick () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_stick" ] = {
    type = "use",
    inv_obj = "inv_stick",
    use_place = "obj_barn_use_stick",
    room = private.room_objname,
    zz = "zz_barn",
    zz_gate = "gzz_sheriffshouse_barn"
  };
  local use_stick_inv = function ()
  
    interface.InventoryItemRemove( "inv_stick" );
  
  end;
  local use_stick_beg = function ()
  
    ObjDelete( "obj_barn_use_stick" );
  
  end;
  local use_stick_end = function ()

    ObjMultiSet({ 
      { "spr_barn_prv_fuellamp",     { input = true, alp = 1 } },
      { "spr_barn_lamp_2_shadow",    { alp = 1 } },
      { "gfx_barn_prv_fuellamp",     { active = true    } },
      { "spr_barn_button_1",         { input = true, alp = 1 } },
      { "spr_barn_button_shadow",    { alp = 1 } },
      { "gfx_barn_button_1",         { active = true    } },
      { "spr_sheriffshouse_barn_lamp",{ alp = 1 } },
      { "spr_sheriffshouse_barn_button",{ alp = 1 } }
    });

    ObjDelete( "anm_barn_use_stick" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_stick", use_stick_beg, private.room_objname );
  cmn.AddSubscriber( "use_stick", use_stick_inv );
  cmn.AddSubscriber( "use_stick", use_stick_end, private.room_objname );
  cmn.AddSubscriber( "use_stick_inv", use_stick_inv, private.room_objname );
  cmn.AddSubscriber( "use_stick_beg", use_stick_beg, private.room_objname );
  cmn.AddSubscriber( "use_stick_end", use_stick_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_handle_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_handle_3" ] = {
    type = "click",
    use_place = "obj_cellarwindow_clk_handle",
    room = private.room_objname,
    zz = "zz_cellarwindow",
    zz_gate = "gzz_sheriffshouse_cellarwindow"
  };
  local clk_handle_3_beg = function ()
  
    ObjDelete( "obj_cellarwindow_clk_handle" );
  
  end;
  local clk_handle_3_end = function ()
  
    ObjDelete( "obj_cellarwindow_open" );
    ObjSet( "spr_cellarwindow_open", { alp = 1 } );
    ObjSet( "spr_sheriffshouse_cellarwindow_open", { alp = 1 } );
    ObjSet( "grm_sheriffshouse_wincards", { input = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_sheriffshouse_wincards_focus");
    end;
    ObjDelete( "gzz_sheriffshouse_cellarwindow" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_handle_3", clk_handle_3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_handle_3", clk_handle_3_end, private.room_objname );
  cmn.AddSubscriber( "clk_handle_3_beg", clk_handle_3_beg, private.room_objname );
  cmn.AddSubscriber( "clk_handle_3_end", clk_handle_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_27 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_27 = function ()
 
    ObjDelete( "obj_barn_coin" );

    if ( cmn.IsEventDone( "get_button_1" ) and
         cmn.IsEventDone( "get_glasscutter" ) and 
         cmn.IsEventDone( "get_prv_fuellamp" ) and  
         cmn.IsEventDone( "get_gloveboxhandle" ) ) then

      ObjDelete( "gzz_sheriffshouse_barn" );

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_27", get_collect_coin_27, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_28 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_28 = function ()
 
    ObjDelete( "obj_gardengnome_coin" );

    if cmn.IsEventDone( "get_bottleofwine" ) and cmn.IsEventDone( "get_valve" )
    and cmn.IsEventDone( "get_carkeys" ) and cmn.IsEventDone( "get_prv_gnomehead" )  then

      ObjDelete( "gzz_sheriffshouse_gardengnome" );

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_28", get_collect_coin_28, private.room_objname );
  --------------------------------------------------------------------------------------------

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_cellarwindow" );
  --------------------------------------------------------------------------------------------
  function zz_cellarwindow.Open ()

    if not ( cmn.IsEventDone( "use_fullhat" ) ) then
 
      common_impl.PlayAudio( "env", "common/audio/aud_sheriffshouse_fire_zz_env", 1 );
      common_impl.StopAudio( "env", "common/audio/aud_sheriffshouse_fire_loc_env", 1 );

    end;

  end;

  --------------------------------------------------------------------------------------------
  function zz_cellarwindow.Close ()

    if ( cmn.IsEventDone( "use_fullhat" ) ) then
      ObjDelete( "anm_cellarwindow_anim_fog" );
    
    else

      common_impl.StopAudio( "env", "common/audio/aud_sheriffshouse_fire_zz_env", 1 );
      common_impl.PlayAudio( "env", "common/audio/aud_sheriffshouse_fire_loc_env", 1 );

    end;

  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_sheriffshouse();
  
  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();

  common_impl.MorphItemMorphing();
  interface.InvestigationButtonCheck();

  common_impl.EnvPlay( { "common/audio/aud_sheriffshouse_env" }, "", 0.5 ); 

  if not cmn.IsEventDone( "use_fullhat" ) then

    common_impl.PlayAudio( "env", "common/audio/aud_sheriffshouse_fire_loc_env", 1 );

  end;
  
end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );
  common_impl.StopAudio( "env", "common/audio/aud_sheriffshouse_fire_loc_env", 1 );
  
end;
--*********************************************************************************************************************
function public.PreClose()

  
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_penknife()

  local item = "inv_penknife";

  if ( common.ApplyObj( item, "obj_gardengnome_use_penknife", true ) ) then

    cmn.CallEventHandler( "use_penknife_inv" );
    cmn.CallEventHandler( "use_penknife_beg" );

    local func_after = function ()
  
      local func_after2 = function ()

        common_impl.Lock( false );
        cmn.SetEventDone( "use_penknife" );
        cmn.CallEventHandler( "use_penknife_end" );

      end;

      ObjAnimate( "spr_gardengnome_basket_open", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      ObjAnimate( "spr_gardengnome_basket_close", "alp", 0, 0, func_after2,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );

    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_penknife", 0, "", 0 );

    ObjSet( "anm_gardengnome_knife", { alp = 1 });
    ObjSet( "spr_gardengnome_belt_1", { alp = 0 });
    AnimPlay( "anm_gardengnome_knife", "DoAnim", func_after );

    return true;
  
  elseif common.ApplyObj( item, "gzz_sheriffshouse_gardengnome", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_gardengnome", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_gnomefragment()

  local item = "inv_gnomefragment";

  if ( common.ApplyObj( item, "obj_gardengnome_use_gnomefragment", true ) ) then

    cmn.CallEventHandler( "use_gnomefragment_inv" );
    cmn.CallEventHandler( "use_gnomefragment_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_gnomefragment" );
      cmn.CallEventHandler( "use_gnomefragment_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_gnomefragment", 0, "", 0 );
  
    ObjAnimate( "spr_gardengnome_beltbuckle", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
    ObjAnimate( "spr_gardengnome_head_close", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 1.0,
      0.6, 0, 0.0
    } );

    ObjAnimate( "spr_gardengnome_prv_gnomehead", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.0,
      0.6, 0, 1.0
    } );

  return true;
  
  elseif common.ApplyObj( item, "gzz_sheriffshouse_gardengnome", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_gardengnome", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_fullhat()

  local item = "inv_fullhat";

  if ( common.ApplyObj( item, "obj_cellarwindow_use_fullhat", true ) ) then

    cmn.CallEventHandler( "use_fullhat_inv" );
    cmn.CallEventHandler( "use_fullhat_beg" );

    local func_after = function ()      

      common_impl.Lock( false );
      cmn.SetEventDone( "use_fullhat" );
      cmn.CallEventHandler( "use_fullhat_end" );  

      common_impl.StopAudio( "env", "common/audio/aud_sheriffshouse_fire_zz_env", 1 );    

      --AnimPlay( "anm_cellarwindow_anim_fog", "DoAnim", function() ObjDelete( "anm_cellarwindow_anim_fog" ) end );

    end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_use_fullhat", 0, "", 0 );

  ObjSet( "vid_cellarwindow_fire", { alp = 0 } );
  ObjSet( "vid_cellarwindow_hat", { active = true, visible = true, alp = 1 } );
  
  VidPlay( "vid_cellarwindow_hat", func_after );

--  ObjAnimate( "spr_cellarwindow_hat", "alp", 0, 0, func_after,
--  { 
--    0.0, 0, 0.0,
--    0.3, 0, 1.0,
--    0.6, 0, 0.0
--  });
--
--  ObjAnimate( "obj_cellarwindow_anim_fire", "alp", 0, 0, "",
--  { 
--    0.0, 0, 1.0, 
--    0.3, 0, 1.0,
--    0.6, 0, 0.0
--  });
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_sheriffshouse_cellarwindow", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cellarwindow", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_workingglasscutter()

  local item = "inv_workingglasscutter";

  if ( common.ApplyObj( item, "obj_cellarwindow_use_workingglasscutter", true ) and cmn.IsEventDone( "use_fullhat" ) ) then

    cmn.CallEventHandler( "use_workingglasscutter_inv" );
    cmn.CallEventHandler( "use_workingglasscutter_beg" );

    local func_after = function ()
  
      local func_after_2 = function ()

        common_impl.Lock( false );
        cmn.SetEventDone( "use_workingglasscutter" );
        cmn.CallEventHandler( "use_workingglasscutter_end" );

      end;
    
      ObjAnimate( "obj_cellarwindow_open", "alp", 0, 0, func_after_2,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0, 
      } );

    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_workingglasscutter", 0, "", 0 );

    AnimPlay( "anm_cellarwindow_anim_glass1", "DoAnim", func_after );

  return true;
  
  elseif common.ApplyObj( item, "gzz_sheriffshouse_cellarwindow", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cellarwindow", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lockpick()

  local item = "inv_lockpick";

  if ( common.ApplyObj( item, "obj_barn_use_lockpick", true ) ) then

    cmn.CallEventHandler( "use_lockpick_inv" );
    cmn.CallEventHandler( "use_lockpick_beg" );

    local func_after = function ()
  
      local func_after_end = function ()

        common_impl.Lock( false );
        cmn.SetEventDone( "use_lockpick" );
        cmn.CallEventHandler( "use_lockpick_end" );

      end;

      ObjAnimate( "spr_barn_door_1", "alp", 0, 0, func_after_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0, 
      } );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_lockpick", 0, "", 0 );

    AnimPlay( "anm_barn_castle_1", "DoAnim", func_after );

    return true;
  
  elseif common.ApplyObj( item, "gzz_sheriffshouse_barn", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_barn", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_stick()

  local item = "inv_stick";

  if ( common.ApplyObj( item, "obj_barn_use_stick", true ) ) then

    cmn.CallEventHandler( "use_stick_inv" );
    cmn.CallEventHandler( "use_stick_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_stick" );
      cmn.CallEventHandler( "use_stick_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_stick", 0, "", 0 );
    
    AnimPlay( "anm_barn_use_stick", "DoAnim", func_after );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_sheriffshouse_barn", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_barn", nil, { 512, 384 } );

  return true;

  end;

end;

function private.clk_handle_3()

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "clk_handle_3" );
      cmn.CallEventHandler( "clk_handle_3_end" );

      if cmn.IsEventDone( "use_workingglasscutter" ) then

        common.CloseSubRoom();

      end;

    end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_sheriff_window", 0, "", 0 );
  
  ObjAnimate( "spr_cellarwindow_door_handle", "ang", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.3, 0, 0.2
  });

  ObjAnimate( "obj_cellarwindow_open", "alp", 0, 0, func_after,
  { 
    0.0, 0, 1, 
    0.3, 0, 1,
    0.6, 0, 0
  });

  ObjAnimate( "spr_cellarwindow_open", "alp", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.3, 0, 0,
    0.6, 0, 1
  });

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_carkeys()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_carkeys" );
  cmn.CallEventHandler( "get_carkeys" );

  if cmn.IsEventDone( "get_valve" ) and cmn.IsEventDone( "get_prv_gnomehead" )
  and cmn.IsEventDone( "get_bottleofwine" ) and common_impl.IsGetCoin( "get_coin_28" ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_bottleofwine()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_bottleofwine" );
  cmn.CallEventHandler( "get_bottleofwine" );

  if cmn.IsEventDone( "get_valve" ) and cmn.IsEventDone( "get_prv_gnomehead" )
  and cmn.IsEventDone( "get_carkeys" ) and common_impl.IsGetCoin( "get_coin_28" ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_valve()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  iOS_RateMe();

  cmn.SetEventDone( "get_valve" );
  cmn.CallEventHandler( "get_valve" );

  if cmn.IsEventDone( "get_bottleofwine" ) and cmn.IsEventDone( "get_prv_gnomehead" )
  and cmn.IsEventDone( "get_carkeys" ) and common_impl.IsGetCoin( "get_coin_28" ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_prv_gnomehead()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_prv_gnomehead" );
  cmn.CallEventHandler( "get_prv_gnomehead" );

  if cmn.IsEventDone( "get_bottleofwine" ) and cmn.IsEventDone( "get_valve" )
  and cmn.IsEventDone( "get_carkeys" ) and common_impl.IsGetCoin( "get_coin_28" ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_gloveboxhandle()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_gloveboxhandle" );
  cmn.CallEventHandler( "get_gloveboxhandle" );

  if ( cmn.IsEventDone( "get_prv_fuellamp" ) and cmn.IsEventDone( "get_gloveboxhandle" ) and 
       cmn.IsEventDone( "get_glasscutter" ) and cmn.IsEventDone( "get_button_1" ) and common_impl.IsGetCoin( "get_coin_27" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_glasscutter()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_glasscutter" );
  cmn.CallEventHandler( "get_glasscutter" );

  if ( cmn.IsEventDone( "get_prv_fuellamp" ) and cmn.IsEventDone( "get_gloveboxhandle" ) and 
       cmn.IsEventDone( "get_glasscutter" ) and cmn.IsEventDone( "get_button_1" ) and common_impl.IsGetCoin( "get_coin_27" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_prv_fuellamp()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_prv_fuellamp" );
  cmn.CallEventHandler( "get_prv_fuellamp" );

  if ( cmn.IsEventDone( "get_prv_fuellamp" ) and cmn.IsEventDone( "get_gloveboxhandle" ) 
       and cmn.IsEventDone( "get_glasscutter" ) and cmn.IsEventDone( "get_button_1" ) and common_impl.IsGetCoin( "get_coin_27" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_button_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_button_1" );
  cmn.CallEventHandler( "get_button_1" );

  if ( cmn.IsEventDone( "get_prv_fuellamp" ) and cmn.IsEventDone( "get_gloveboxhandle" ) 
       and cmn.IsEventDone( "get_glasscutter" ) and cmn.IsEventDone( "get_button_1" ) and common_impl.IsGetCoin( "get_coin_27" ) ) then

    common.CloseSubRoom();

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
-----------------------------------------------------------------------------------------------------------------------
function private.get_collect_coin_27()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_27" );
    cmn.CallEventHandler( "get_coin_27" );

    if ( cmn.IsEventDone( "get_button_1" ) and
         cmn.IsEventDone( "get_glasscutter" ) and 
         cmn.IsEventDone( "get_prv_fuellamp" ) and  
         cmn.IsEventDone( "get_gloveboxhandle" ) ) then

      common.CloseSubRoom();

    end;
        
  end;

  common_impl.PlayEffectHO( "spr_barn_coin", func_after ); 

end;
-----------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------
function private.get_collect_coin_28()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_28" );
    cmn.CallEventHandler( "get_coin_28" );

    if cmn.IsEventDone( "get_bottleofwine" ) and cmn.IsEventDone( "get_valve" )
    and cmn.IsEventDone( "get_carkeys" ) and cmn.IsEventDone( "get_prv_gnomehead" )  then

      common.CloseSubRoom();

    end;    

  end;

  common_impl.PlayEffectHO( "spr_gardengnome_coin", func_after ); 

end;
-----------------------------------------------------------------------------------------------------------------------
function private.opn_sheriffshouse()

  if not ( cmn.IsEventDone( "opn_sheriffshouse" ) ) then
    common_impl.PlayAudio( "mus", "common/audio/aud_scary_mus", 0, "", 0 );
    cmn.SetEventDone( "opn_sheriffshouse" );
  end;
  
  cmn.CallEventHandler( "opn_sheriffshouse" ); 

end;
--*********************************************************************************************************************
function private.AnmCastle()

  common_impl.ShowBbt( 'bbt_barn_use_lockpick' );
  common_impl.Lock( true );
  ObjAnimate( "anm_barn_castle_1", "pos_y", 0, 0, function() common_impl.Lock( false ); end,
  { 
    0.0, 3, ObjGet( "anm_barn_castle_1" ).pos_y, 
    0.15, 3, ObjGet( "anm_barn_castle_1" ).pos_y - 2,
    0.3, 3, ObjGet( "anm_barn_castle_1" ).pos_y,
    0.45, 3, ObjGet( "anm_barn_castle_1" ).pos_y - 2,
    0.6, 3, ObjGet( "anm_barn_castle_1" ).pos_y,
  } );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_barn_lock", 0, "", 0.2 );

end;
--*********************************************************************************************************************

ObjAnimate( "spr_sheriffshouse_branch_big", "ang", 1, 0, "",
{ 
  0.0, 3, 0.02, 
  2.5, 3, 0.0,
  5.0, 3, 0.02,
} );

ObjAnimate( "spr_sheriffshouse_branch_under1", "ang", 1, 0, "",
{ 
  0.0, 3, -0.02, 
  2.8, 3, 0.02,
  5.6, 3, -0.02,
} );

ObjAnimate( "spr_sheriffshouse_bush3", "ang", 1, 0, "",
{ 
  0.0, 3, -0.02, 
  2.1, 3, 0.02,
  4.2, 3, -0.02,
} );

ObjAnimate( "spr_sheriffshouse_bush1", "pos_xy", 1, 0, "",
{ 
  0.0, 0, 1135,563,
  2.5, 0, 1132,566,
  5.0, 0, 1135,563
} );

