-- name=rm_square_3
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_square_3";
  private.car_purse = "close";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_machine", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_machine_hat",                { event_mdown = private.get_hat          }},
    { "spr_machine_close_door",         { event_mdown = private.ClickCarHandle   }},
    { "spr_machine_evidence_3_4",       { event_mdown = private.get_evidence_3_4 }},
    { "spr_machine_lockpick",           { event_mdown = private.get_lockpick     }},
    { "spr_machine_purse_small",        { event_mdown = function () private.PurseOpen(); common_impl.ShowBbt( 'bbt_car_clk_purse' ); end; }},
    { "obj_machine_clk_doorknob",       { event_mdown = private.clk_doorknob     }},
    { "spr_machine_purse_big",          { event_mdown = private.PurseClose       }},
    { "obj_machine_use_carkeys",        { event_mdown = function () common_impl.ShowBbt( 'bbt_car_clk_door' );private.ClickCarHandle(); end }},
    { "spr_machine_glasscutterpart",    { event_mdown = private.get_glasscutterpart }},
    { "spr_machine_cheque",             { event_mdown = function () common_impl.NoteScale( "open", "spr_machine_cheque" ); end  }},
    { "spr_machine_cheque_big",         { event_mdown = function () common_impl.NoteScale( "close", "spr_machine_cheque" ) end  }},
    { "spr_machine_driver_license",     { event_mdown = function () common_impl.NoteScale( "open", "spr_machine_driver_license" ); common_impl.ShowBbt( 'bbt_machine_driver_license', 1 ); end }},
    { "spr_machine_driver_license_big", { event_mdown = function () common_impl.NoteScale( "close", "spr_machine_driver_license" ) end }},
    { "obj_square_3_poster_clk",        { event_mdown = function () common_impl.NoteScale( "open", "grd_square_3_poster" ); common_impl.ShowBbt( 'bbt_square_poster_clk', 1 ); end }},
    { "spr_square_3_poster_big",        { event_mdown = function () common_impl.NoteScale( "close", "grd_square_3_poster" ) end }},
    { "spr_square_3_poster_big1",       { event_mdown = function () common_impl.NoteScale( "close", "grd_square_3_poster" ) end }},
    { "spr_garage_3_coin",              { event_mdown = function() private.get_coin4() end }},
    { "obj_square_3_clk_garage_3_open", { event_mdown = private.clk_open_garage_3 }},
    { "spr_machine_coin",               { event_mdown = private.get_coin_32 }},
    { "spr_square_3_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },

  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_square_3 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_square_3_garage_3",
    "gzz_square_3_machine"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_machine",
    
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_square_3", update_game_mode_square_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_square_3 = function ()

  local effects_table = 
  {
    "obj_square_3_anim",
    "grd_square_3_poster",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_square_3", update_performance_mode_square_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_square_3 () end;
  --------------------------------------------------------------------------------------------
  local opn_square_3_map = function ()

    common_impl.VisitMapRoom( "square" );

  end;
  cmn.AddSubscriber( "opn_square_3", opn_square_3_map );
  --------------------------------------------------------------------------------------------
  -- function get_coins () end;
  --------------------------------------------------------------------------------------------
  local get_coin_4 = function ()

     ObjDelete( "obj_garage_3_coin" );
     ObjDelete( "gzz_square_3_garage_3" );
     ObjSet( "obj_square_3_clk_garage_3_open", { input = true } );

  end;

  cmn.AddSubscriber( "get_coin_4", get_coin_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_hos () end;
  --------------------------------------------------------------------------------------------
  local win_hos_loc = function ()
    
    if port.isPortable() == 1 then
        port.GrmEventLightOff("grm_square_3_abandoneddistrict_3_focus");
    end;
    
    ObjDelete( "grm_square_3_abandoneddistrict_3" );    
    ObjDelete( "spr_square_3_index" );
    ObjDelete( "spr_square_3_index_shadow" );
    ObjDelete( "anm_square_3_door_open_static" );
    ObjDelete( "obj_square_3_dlg_characters" );
    ObjDelete( "obj_square_3_citizens_police_bbt" );
    ObjMultiSet( { 
      { "grm_square_3_sheriffshouse", { input = true, active = true } },
      { "spr_square_3_burner1", { visible = true } },
      { "spr_square_3_burner2", { visible = true } },
      { "spr_square_3_distance", { visible = true } },
      { "obj_square_3_clk_burned", { input = true } },
      { "spr_square_3_garage", { visible = true } },
      { "obj_square_3_morph", { pos_x = 320, pos_y = 24 }  },
      { "spr_square_3_back", { res = "assets/levels/level3/rm_square_3/back" } } } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_square_3_sheriffshouse_focus");
    end;
  end;
  cmn.AddSubscriber( "win_hos", win_hos_loc, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hat () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hat" ] = {
    type = "get",
    get_obj = "spr_machine_hat",
    room = private.room_objname,
    zz = "zz_machine",
    zz_gate = "gzz_square_3_machine"
  };
    
  local get_hat_inv = function ()
  
    interface.InventoryItemAdd( "inv_hat", "spr_machine_hat" );
  
  end;
  
  local get_hat_closezz = function ()
  
    ObjDelete( "gfx_machine_hat" );
    ObjDelete( "spr_machine_hat_shadow" );
    ObjSet( "spr_machine_evidence_3_4", { input = true } );
  
  end;
  
  cmn.AddSubscriber( "get_hat", get_hat_inv );
  cmn.AddSubscriber( "get_hat", get_hat_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_evidence_3_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_evidence_3_4" ] = {
    type = "get",
    get_obj = "spr_machine_evidence_3_4",
    room = private.room_objname,
    zz = "zz_machine",
    zz_gate = "gzz_square_3_machine"
  };
    
  local get_evidence_3_4_inv = function ()
  
    ObjDelete( "spr_machine_evidence_3_4" )    
  
  end;
  
  local get_evidence_3_4_closezz = function ()
  
    ObjDelete( "gfx_machine_evidence_3_4" );
    ObjDelete( "spr_machine_pager_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_evidence_3_4", get_evidence_3_4_inv );
  cmn.AddSubscriber( "get_evidence_3_4", get_evidence_3_4_closezz, private.room_objname );
   --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_3 = function ()
  
    ObjDelete( "obj_square_3_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_3", get_collect_morph_item_1_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_lockpick () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_lockpick" ] = {
    type = "get",
    get_obj = "spr_machine_purse_small",
    room = private.room_objname,
    zz = "zz_machine",
    zz_gate = "gzz_square_3_machine"
  };
    
  local get_lockpick_inv = function ()
  
    interface.InventoryItemAdd( "inv_lockpick", "spr_machine_lockpick" );
  
  end;
  
  local get_lockpick_closezz = function ()
  
    ObjDelete( "gfx_machine_lockpick" );
    ObjDelete( "spr_machine_lockpick_shadow" );
    ObjDelete( "spr_machine_lockpick_shadow_up" );
  
  end;
  
  cmn.AddSubscriber( "get_lockpick", get_lockpick_inv );
  cmn.AddSubscriber( "get_lockpick", get_lockpick_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_glasscutterpart () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_glasscutterpart" ] = {
    type = "get",
    get_obj = "spr_machine_glasscutterpart",
    room = private.room_objname,
    zz = "zz_machine",
    zz_gate = "gzz_square_3_machine"
  };
    
  local get_glasscutterpart_inv = function ()
  
    interface.InventoryItemAdd( "inv_glasscutterpart", "spr_machine_glasscutterpart" );
    ObjSet( "spr_glasscutter_plus_light", { alp = 1 } );

  end;
  
  local get_glasscutterpart_closezz = function ()
  
    ObjDelete( "gfx_machine_glasscutterpart" );
    ObjDelete( "spr_machine_glasscutterpart_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_glasscutterpart", get_glasscutterpart_inv );
  cmn.AddSubscriber( "get_glasscutterpart", get_glasscutterpart_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  local get_coin_32 = function ()
 
    ObjDelete( "obj_machine_coin" );
    
  end;
  cmn.AddSubscriber( "get_coin_32", get_coin_32, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_carkeys () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_carkeys" ] = {
    type = "use",
    inv_obj = "inv_carkeys",
    use_place = "obj_machine_use_carkeys",
    room = private.room_objname,
    zz = "zz_machine",
    zz_gate = "gzz_square_3_machine"
  };
  local use_carkeys_inv = function ()
  
    interface.InventoryItemRemove( "inv_carkeys" );
  
  end;
  local use_carkeys_beg = function ()
  
    ObjDelete( "obj_machine_use_carkeys" );
  
  end;
  local use_carkeys_end = function ()

    ObjMultiSet({ 
    { "obj_machine_open_car", { input = true, visible = true, active = true }},
    { "spr_square_3_machine_open", { alp = 1 }}
    });

    ObjDelete( "obj_machine_close_car" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_carkeys", use_carkeys_beg, private.room_objname );
  cmn.AddSubscriber( "use_carkeys", use_carkeys_inv );
  cmn.AddSubscriber( "use_carkeys", use_carkeys_end, private.room_objname );
  cmn.AddSubscriber( "use_carkeys_inv", use_carkeys_inv, private.room_objname );
  cmn.AddSubscriber( "use_carkeys_beg", use_carkeys_beg, private.room_objname );
  cmn.AddSubscriber( "use_carkeys_end", use_carkeys_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gloveboxhandle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gloveboxhandle" ] = {
    type = "use",
    inv_obj = "inv_gloveboxhandle",
    use_place = "obj_machine_use_gloveboxhandle",
    room = private.room_objname,
    zz = "zz_machine",
    zz_gate = "gzz_square_3_machine"
  };
  local use_gloveboxhandle_inv = function ()
  
    interface.InventoryItemRemove( "inv_gloveboxhandle" );
  
  end;
  local use_gloveboxhandle_beg = function ()
  
    ObjDelete( "obj_machine_use_gloveboxhandle" );
  
  end;
  local use_gloveboxhandle_end = function ()
  
    ObjSet( "obj_machine_box_open", { input = true, alp = 1 } );
    ObjDelete( "spr_machine_doorknob_new" );
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gloveboxhandle", use_gloveboxhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_gloveboxhandle", use_gloveboxhandle_inv );
  cmn.AddSubscriber( "use_gloveboxhandle", use_gloveboxhandle_end, private.room_objname );
  cmn.AddSubscriber( "use_gloveboxhandle_inv", use_gloveboxhandle_inv, private.room_objname );
  cmn.AddSubscriber( "use_gloveboxhandle_beg", use_gloveboxhandle_beg, private.room_objname );
  cmn.AddSubscriber( "use_gloveboxhandle_end", use_gloveboxhandle_end, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function clk_doorknob () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_doorknob" ] = {
    type = "click",
    use_place = "obj_machine_clk_doorknob",
    room = private.room_objname,
    zz = "zz_machine",
    zz_gate = "gzz_square_3_machine"
  };
  local clk_doorknob_beg = function ()
  
    ObjDelete( "obj_machine_clk_doorknob" );
  
  end;
  local clk_doorknob_end = function ()
  
    ObjSet( "spr_machine_doorknob_old_broken", { alp = 1 } );
    ObjSet( "obj_machine_use_gloveboxhandle", { input = true } );
    ObjDelete( "spr_machine_doorknob_old" );  
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_doorknob", clk_doorknob_beg, private.room_objname );
  cmn.AddSubscriber( "clk_doorknob", clk_doorknob_end, private.room_objname );
  cmn.AddSubscriber( "clk_doorknob_beg", clk_doorknob_beg, private.room_objname );
  cmn.AddSubscriber( "clk_doorknob_end", clk_doorknob_end, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_machine" );

  function zz_machine.PreOpen()

    common_impl.StopAudio( "sfx", "common/audio/aud_cat_and_crows", 1 );
    AnimStop( "anm_square_3_cat" ); 
    
  end;

  function zz_machine.PreClose()

   if ObjGet( "obj_machine_purse_open" ).scale_x == 1 then

     private.PurseClose();

   end;

    ObjMultiSet( {

   { "spr_machine_cheque", { input = true, alp = 1 } },
   { "spr_machine_driver_license", { input = true, alp = 1 } },
   { "spr_machine_cheque_big", { input = false, scale_x = 0, scale_y = 0 }},
   { "spr_machine_driver_license_big", { input = false, scale_x = 0, scale_y = 0 } }

    } );

  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_square_3();
  
  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  if common_impl.square_3 then

    common_impl.square_3.note = "close";

  else 

    common_impl.square_3 = {}
    common_impl.square_3.note = "close";

  end;

  private.Play_anm_cat();
  common_impl.MorphItemMorphing();
  interface.InvestigationButtonCheck();

  common_impl.EnvPlay( { "common/audio/aud_square_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );
  common_impl.StopAudio( "sfx", "common/audio/aud_cat_and_crows", 1 );
  AnimStop( "anm_square_3_cat" ); 
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_carkeys()

  local item = "inv_carkeys";

  if ( common.ApplyObj( item, "obj_machine_use_carkeys", true ) ) then

    cmn.CallEventHandler( "use_carkeys_inv" );
    cmn.CallEventHandler( "use_carkeys_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_carkeys" );
      cmn.CallEventHandler( "use_carkeys_end" );
       
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_use_carkeys", 0, "", 0 );
  
    ObjAnimate( "spr_machine_key", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.2, 0, 1.0
    } );

    ObjAnimate( "spr_machine_key_shadow", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.0,
      0.5, 0, 1.0
    } );

    ObjAnimate( "spr_machine_key", "pos_xy", 0, 0, "",
    { 
      0.0, 0, 79, 239,
      0.2, 0, 79, 239,     
      0.5, 0, 96, 207,
    } );

     ObjAnimate( "spr_machine_door_handle", "scale_x", 0, 0, "",
    { 
      0.0, 0, 1, 
      0.6, 0, 1,
      1.0, 0, 0.7,
      1.4, 0, 1
    } );

    ObjAnimate( "obj_machine_close_car", "alp", 0, 0, func_after,
    { 
      0.0, 0, 1.0, 
      1.6, 0, 1.0,
      1.8, 0, 0.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_square_3_machine", false ) and common_impl.square_3.note == "close" then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_machine", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_gloveboxhandle()

  local item = "inv_gloveboxhandle";

  if ( common.ApplyObj( item, "obj_machine_use_gloveboxhandle", true ) and cmn.IsEventDone( "clk_doorknob" ) and private.car_purse == "close" ) then

    cmn.CallEventHandler( "use_gloveboxhandle_inv" );
    cmn.CallEventHandler( "use_gloveboxhandle_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_gloveboxhandle" );
      cmn.CallEventHandler( "use_gloveboxhandle_end" );
    --common.CloseSubRoom();;
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_use_gloveboxhandle", 0, "", 0 );
  
    ObjAnimate( "spr_machine_doorknob_new", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 0.0
    } );

    ObjAnimate( "obj_machine_box_open", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.0,
      0.6, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_square_3_machine", false ) and cmn.IsEventDone( "clk_doorknob" ) and common_impl.square_3.note == "close" then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_machine", nil, { 512, 384 } );

  return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_coin4()

  local func_after = function ()
  
    common_impl.GetCoinDone("get_coin_4");
    cmn.CallEventHandler("get_coin_4");
    common.CloseSubRoom();

  end;
  
  common_impl.PlayEffectHO( "spr_garage_3_coin", func_after );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.get_coin_32()

  local func_after = function ()
  
    common_impl.GetCoinDone( "get_coin_32" );
    cmn.CallEventHandler( "get_coin_32" );

  end;
  
  common_impl.PlayEffectHO( "spr_machine_coin", func_after );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.get_hat()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjAnimate( "spr_machine_hat", "ang", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, -3.14
    } );
  
  cmn.SetEventDone( "get_hat" );
  cmn.CallEventHandler( "get_hat" );

end;
--------------------------------------------------------------------------------------------
function private.get_evidence_3_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  local func_end = function ()

    --ObjSet( "spr_mansion_evidence_3_3", { pos_x = 512, pos_y = 384 } );
    interface.InvestigationButtonItemAdd( "evidence_3_4", "spr_machine_evidence_3_4" );
    cmn.SetEventDone( "get_evidence_3_4" );
    cmn.CallEventHandler( "get_evidence_3_4" );
  
  end;

  interface.DialogEvidenceShow( "evidence_3_4", func_end );

end;
--------------------------------------------------------------------------------------------
function private.get_lockpick()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_lockpick" );
  cmn.CallEventHandler( "get_lockpick" );

end;
--------------------------------------------------------------------------------------------
function private.get_glasscutterpart()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_glasscutterpart" );
  cmn.CallEventHandler( "get_glasscutterpart" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_doorknob()

  cmn.CallEventHandler( "clk_doorknob_beg" );

  local func_after = function ()

    common_impl.Lock(false);
    cmn.SetEventDone( "clk_doorknob" );
    cmn.CallEventHandler( "clk_doorknob_end" );
  
  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_doorknob", 0, "", 0 );  

  ObjAnimate( "spr_machine_doorknob_old", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1.0,
    0.3, 0, 0.0
  } );


  ObjAnimate( "spr_machine_doorknob_old_broken", "alp", 0, 0, "", 
  { 
    0.0, 0, 0.0,
    0.3, 0, 1.0
  } );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_square_3()

  if not ( cmn.IsEventDone( "opn_square_3" ) ) then
    cmn.SetEventDone( "opn_square_3" );
  end;
  
  cmn.CallEventHandler( "opn_square_3" ); 

end;
--*********************************************************************************************************************
-------------------------------------------------------------------------------------
function private.PurseOpen()

  local func_after = function()

    common_impl.Lock(false);

    ObjSet( "obj_machine_purse_open", { input = true } );
    ObjSet( "spr_machine_purse_small", { input = false } );
    common_impl.hint[ "get_lockpick" ].get_obj = "spr_machine_lockpick";
    private.car_purse = "open";
 
  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_wallet_zoom_in", 0, "", 0 );

  ObjAnimate( "obj_machine_purse_open", "scale_xy", 0, 0, func_after, { 0,0,0,0, 0.3,0,1,1 } );
  ObjAnimate( "obj_machine_purse_open", "pos_xy", 0, 0, "", { 0,0,86,-55, 0.3,0,0,0 } );
  ObjAnimate( "spr_machine_purse_small", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
  ObjAnimate( "spr_machine_purse_small_shadow", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );

end;
-------------------------------------------------------------------------------------
function private.PurseClose()

  local func_after = function()

    common_impl.Lock(false);

    ObjSet( "obj_machine_purse_open", { input = false } );
    ObjSet( "spr_machine_purse_small", { input = true } );
    common_impl.hint[ "get_lockpick" ].get_obj = "spr_machine_purse_small";
    private.car_purse = "close";
 
  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_wallet_zoom_out", 0, "", 0 );

  ObjAnimate( "obj_machine_purse_open", "scale_xy", 0, 0, func_after, { 0,0,1,1, 0.3,0,0,0 } );
  ObjAnimate( "obj_machine_purse_open", "pos_xy", 0, 0, "", { 0,0,0,0, 0.3,0,86,-55 } );
  ObjAnimate( "spr_machine_purse_small", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
  ObjAnimate( "spr_machine_purse_small_shadow", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );

end;
----------------------------------------------------------------------------------------
function private.clk_open_garage_3()

  local trg_after = function ()

    common_impl.Lock( false);
    common_impl.ShowBbt( 'bbt_square_open_garage', 1 );

  end;

  common_impl.Lock(true);
  AnimPlay( "anm_square_3_garage_3_open", "DoAnim", trg_after ); 
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_garage_door_open", 0, "", 0 );
 
end;
------------------------------------------------------------------------------------
function private.Play_anm_cat()

  local table_multiset = {};

  table.insert( table_multiset, { "anm_square_3_cat", { playing = false, visible = false } } );

  local chance = math.random(1,10);

    if ( chance == 1) then

      table.insert( table_multiset,  { "anm_square_3_cat", { playing = true, frame = 1, visible = true } } );
      common_impl.PlayAudio( "sfx", "common/audio/aud_cat_and_crows", 0, "", 0 );

    end;

  ObjMultiSet(table_multiset);

end;
--*********************************************************************************************************************
-------------------------------------------------------------------------------------
function private.ClickCarHandle()

  ObjSet( "spr_machine_close_door", { input = 0 } )

  local func_after = function()

    common_impl.Lock(false);
    ObjSet( "spr_machine_close_door", { input = 1 } )    

  end;

  common_impl.Lock(true);
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_police_car_handle", 0, "", 0 );
  ObjAnimate( "spr_machine_door_handle", "scale_x", 0, 0, func_after, { 0,0,1, 0.2,0,0.8, 0.4,0,1 } );
  ObjAnimate( "spr_machine_door_handle_shadow", "pos_y", 0, 0, "", { 0,0,198, 0.2,0,204, 0.4,0,198 } );

end;
--**********************************************************************************************************************
--**********************************************************************************************************************
--                                         Light     Anims
--**********************************************************************************************************************
--**********************************************************************************************************************
ObjAnimate( "spr_square_3_burner1", "alp", 1, 0, "", 

  { 
    0.0, 3, 1.0, 
    1.3, 1, 0.5, 
    2.0, 3, 1.0,  
    3.3, 0, 0.1, 
    4.4, 3, 1.0, 
    5.6, 1, 0.6, 
    6.0, 3, 1.0, 

  });

ObjAnimate( "spr_square_3_burner2", "alp", 1, 0, "", 

  { 
    0.0, 1, 0.0, 
    1.0, 2, 0.6, 
    2.1, 3, 1.0, 
    3.0, 0, 0.3, 
    4.1, 1, 0.9, 
    5.2, 2, 0.3, 
    6.3, 3, 1.0, 
    7.0, 1, 0.0,
  });

ObjAnimate( "spr_square_3_distance", "alp", 1, 0, "", 

  { 
     1.0, 1, 0.5, 
     2.0, 2, 0.9, 
     3.1, 3, 1.0, 
     4.0, 1, 0.0, 
     5.0, 3, 0.9, 
     6.2, 1, 0.2, 
     7.5, 0, 0.5, 

  });

ObjAnimate( "spr_square_3_garage", "alp", 1, 0, "", 

  { 
    0.0, 1, 1.0, 
    1.0, 2, 0.7,
    2.1, 3, 0.4,
    5.2, 3, 1.0, 
    6.3, 2, 0.5, 
    6.4, 1, 0.7, 
    7.5, 0, 0.8,
    9.9, 2, 1.0, 
   10.7, 3, 0.6,
   11.8, 1, 1.0, 
   12.4, 0, 1.0,   

  });
--**********************************************************************************************************************
--**********************************************************************************************************************