-- name=rm_wincards
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_wincards";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_winetable", "room_hub" );
  ObjAttach( "zz_drawercabinet", "room_hub" );
  ObjAttach( "zz_winshelf", "room_hub" );
  ObjAttach( "zz_barrel", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_winetable_candle",                { event_mdown = private.get_candle         }},
    { "spr_winetable_fuelsawchain",          { event_mdown = private.get_fuelsawchain   }},
    { "spr_winetable_ring",                  { event_mdown = private.get_ring           }},

    { "spr_drawercabinet_prv_handcuffs", { event_mdown = private.get_prv_handcuffs  }},
    { "spr_drawercabinet_gear_1",        { event_mdown = private.get_gear_1         }},
    { "spr_drawercabinet_gear_2",        { event_mdown = private.get_gear_2         }},
    { "spr_drawercabinet_prv_gun",       { event_mdown = private.get_prv_gun        }},

    { "obj_wincards_prv_item_1",   { event_mdown = function() int_providence.Thinking( "providence_1", "obj_wincards_prv_item_1" ) end }},
    { "obj_wincards_prv_item_2",   { event_mdown = function() int_providence.Thinking( "providence_2", "obj_wincards_prv_item_2" ) end }},

    { "obj_winetable_use_gear_1",   { event_mdown = function() private.clk_owl() end }},
    { "obj_winetable_use_gear_2",   { event_mdown = function() private.clk_owl() end }},
    { "obj_winetable_use_gear_3",   { event_mdown = function() private.clk_owl() end }},

    { "spr_wincards_prv_armchair",       { event_startdrag = private.drag_armchair, event_dragdrop = private.drop_armchair  }},
    { "spr_wincards_prv_stairs",         { event_startdrag = private.drag_stairs, event_dragdrop = private.drop_stairs  }},
    { "obj_wincards_use_prv_item_1",     { event_mdown = private.get_prv_handcuffs_silhouette }},
    { "obj_wincards_use_prv_item_2",     { event_mdown = private.get_prv_fuellamp_silhouette }},
    --
    { "spr_winshelf_penknife",           { event_mdown = private.get_penknife       }},

    { "obj_barrel_clk_tap",              { event_mdown = private.clk_tap            }},

    { "obj_drawercabinet_clk_button_1",  { event_mdown = private.clk_button_1       }},
    { "obj_drawercabinet_clk_button_2",  { event_mdown = private.clk_button_2       }},

    { "spr_drawercabinet_coin",           { event_mdown = private.get_collect_coin_29 }},
    { "spr_wincards_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_3_5" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },


  });

  --------------------------------------------------------------------------------------------

    ObjAnimate( "spr_barrel_light_1_dodge", "alp", 1, 0, "", {
       0, 3, 1,
       3, 3, 0.5,
       6, 3, 1 } );

    ObjAnimate( "spr_barrel_light_2_add", "alp", 1, 0, "", {
       0, 3, 1,
       3, 3, 0.5,
       6, 3, 1 } );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_wincards = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates =
  {
    "gho_wincards_intable",
    "gmg_wincards_bottles",
    "gzz_wincards_winetable",
    "gzz_wincards_winshelf",
    "gzz_wincards_barrel",
    "gzz_wincards_drawercabinet"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_winetable",
      "zz_drawercabinet",
      "zz_winshelf",
      "zz_barrel",
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_wincards", update_game_mode_wincards, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_wincards = function ()

  local effects_table = 
  {
    "obj_wincards_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_wincards", update_performance_mode_wincards, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_wincards () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_wincards" ] = {
    type = "click",
    use_place = "grm_sheriffshouse_wincards",
    room = "rm_sheriffshouse"
  };

  local opn_wincards_map = function ()

    common_impl.VisitMapRoom( "wincards" );
    ObjSet( "obj_int_map_back_1_paper", { visible = true } );

  end;
  local win_wincards_ho = function ()

    if cmn.IsEventDone( "win_intable" ) then

      ObjDelete( "gho_wincards_intable" );
      ObjSet( "gzz_wincards_winetable", { input = true, active = true } );

    end;

  end;
  cmn.AddSubscriber( "opn_wincards", opn_wincards_map );
  cmn.AddSubscriber( "opn_wincards", win_wincards_ho, private.room_objname );
 --------------------------------------------------------------------------------------------
  local get_tap_loc = function ()

    ObjDelete( "gmg_wincards_bottles" );

  end;
  cmn.AddSubscriber( "get_tap", get_tap_loc, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function get_prv_handcuffs_silhouette () end;
  --------------------------------------------------------------------------------------------
  local get_prv_handcuffs_silhouette_inv = function ()
  
    interface.ProvidePanelSilhouetteAdd( "inv_prv_handcuffs", "spr_wincards_prv_handcuffs_silhouette" );

  end;
  
  local get_prv_handcuffs_silhouette_closezz = function ()

    ObjSet( "spr_wincards_prv_handcuffs_silhouette", { alp = 1 } );    
    ObjSet( "obj_wincards_use_prv_item_1", { event_mdown = function() int_providence.Thinking( "providence_prv_item_1", "obj_wincards_use_prv_item_1" ) end } )

  end;

  local get_prv_handcuffs_silhouette_notadd = function ()

    ObjSet( "obj_wincards_use_prv_item_1", { event_mdown = function() int_providence.Thinking( "providence_prv_item_1", "obj_wincards_use_prv_item_1" ) end } )

  end;
  
  cmn.AddSubscriber( "get_prv_handcuffs_silhouette", get_prv_handcuffs_silhouette_inv );
  cmn.AddSubscriber( "get_prv_handcuffs_silhouette", get_prv_handcuffs_silhouette_closezz, private.room_objname );
  cmn.AddSubscriber( "get_prv_handcuffs", get_prv_handcuffs_silhouette_notadd, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function get_prv_fuellamp_silhouette () end;
  --------------------------------------------------------------------------------------------
  local get_prv_fuellamp_silhouette_inv = function ()
  
    interface.ProvidePanelSilhouetteAdd( "inv_prv_fuellamp", "spr_wincards_prv_fuellamp_silhouette" );

  end;
  
  local get_prv_fuellamp_silhouette_closezz = function ()

    ObjSet( "spr_wincards_prv_fuellamp_silhouette", { alp = 1 } );    
    ObjSet( "obj_wincards_use_prv_item_2", { event_mdown = function() int_providence.Thinking( "providence_prv_item_2", "obj_wincards_use_prv_item_2" ) end } )

  end;

  local get_prv_fuellamp_silhouette_notadd = function ()

    ObjSet( "obj_wincards_use_prv_item_2", { event_mdown = function() int_providence.Thinking( "providence_prv_item_2", "obj_wincards_use_prv_item_2" ) end } )

  end;
  
  cmn.AddSubscriber( "get_prv_fuellamp_silhouette", get_prv_fuellamp_silhouette_inv );
  cmn.AddSubscriber( "get_prv_fuellamp_silhouette", get_prv_fuellamp_silhouette_closezz, private.room_objname );
  cmn.AddSubscriber( "get_prv_fuellamp", get_prv_fuellamp_silhouette_notadd, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_candle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_candle" ] = {
    type = "get",
    get_obj = "spr_winetable_candle",
    room = private.room_objname,
    zz = "zz_winetable",
    zz_gate = "gzz_wincards_winetable"
  };
    
  local get_candle_inv = function ()
  
    interface.InventoryItemAdd( "inv_candle", "spr_winetable_candle" );
    ObjSet( "inv_candle", { drag = false } );
  
  end;
  
  local get_candle_closezz = function ()
  
    ObjDelete("spr_hallway_winetable_candle");
    ObjDelete("spr_winetable_candle_shadow");
    ObjDelete( "gfx_winetable_candle" );
  
  end;
  
  cmn.AddSubscriber( "get_candle", get_candle_inv );
  cmn.AddSubscriber( "get_candle", get_candle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fuelsawchain () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fuelsawchain" ] = {
    type = "get",
    get_obj = "obj_winetable_fuelsawchain",
    room = private.room_objname,
    zz = "zz_winetable",
    zz_gate = "gzz_wincards_winetable"
  };
    
  local get_fuelsawchain_inv = function ()

    ObjDelete( "spr_winetable_fuelsawchain_sh" );
    interface.InventoryItemAdd( "inv_fuelsawchain", "spr_winetable_fuelsawchain" );
  
  end;
  
  local get_fuelsawchain_closezz = function ()
  
    ObjDelete( "gfx_winetable_fuelsawchain" );
    ObjDelete( "spr_wincards_winetable_gasolinesaw" );
    ObjDelete( "obj_winetable_fuelsawchain" );
  
  end;
  
  cmn.AddSubscriber( "get_fuelsawchain", get_fuelsawchain_inv );
  cmn.AddSubscriber( "get_fuelsawchain", get_fuelsawchain_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ring_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ring_2" ] = {
    type = "get",
    get_obj = "spr_winetable_ring",
    room = private.room_objname,
    zz = "zz_winetable",
    zz_gate = "gzz_wincards_winetable"
  };
    
  local get_ring_2_inv = function ()

    interface.InventoryItemAdd( "inv_ring_2", "spr_winetable_ring" );
  
  end;
  
  local get_ring_2_closezz = function ()
  
    ObjDelete( "gfx_winetable_ring" );
    ObjDelete( "gzz_wincards_winetable" );
    ObjDelete( "spr_wincards_winetable_ring" );
  
  end;
  
  cmn.AddSubscriber( "get_ring_2", get_ring_2_inv );
  cmn.AddSubscriber( "get_ring_2", get_ring_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_prv_handcuffs () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_prv_handcuffs" ] = {
    type = "get",
    get_obj = "spr_drawercabinet_prv_handcuffs",
    room = private.room_objname,
    zz = "zz_drawercabinet",
    zz_gate = "gzz_wincards_drawercabinet"
  };
    
  local get_prv_handcuffs_inv = function ()
  
    interface.ProvidePanelItemAdd( "inv_prv_handcuffs", "spr_drawercabinet_prv_handcuffs" );
  
  end;
  
  local get_prv_handcuffs_closezz = function ()
  
    ObjDelete( "gfx_drawercabinet_prv_handcuffs" );
    --ObjDelete( "gzz_wincards_drawercabinet" );
  
  end;
  
  cmn.AddSubscriber( "get_prv_handcuffs", get_prv_handcuffs_inv );
  cmn.AddSubscriber( "get_prv_handcuffs", get_prv_handcuffs_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gear_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gear_1" ] = {
    type = "get",
    get_obj = "spr_drawercabinet_gear_1",
    room = private.room_objname,
    zz = "zz_drawercabinet",
    zz_gate = "gzz_wincards_drawercabinet"
  };
    
  local get_gear_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_gear_1", "spr_drawercabinet_gear_1" );
  
  end;
  
  local get_gear_1_closezz = function ()
  
    ObjDelete( "gfx_drawercabinet_gear_1" );
    --ObjDelete( "gzz_wincards_drawercabinet" );
  
  end;
  
  cmn.AddSubscriber( "get_gear_1", get_gear_1_inv );
  cmn.AddSubscriber( "get_gear_1", get_gear_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_gear_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_gear_2" ] = {
    type = "get",
    get_obj = "spr_drawercabinet_gear_2",
    room = private.room_objname,
    zz = "zz_drawercabinet",
    zz_gate = "gzz_wincards_drawercabinet"
  };
    
  local get_gear_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_gear_2", "spr_drawercabinet_gear_2" );
  
  end;
  
  local get_gear_2_closezz = function ()
  
    ObjDelete( "gfx_drawercabinet_gear_2" );
    if cmn.IsEventDone( "get_prv_gun" )  and common_impl.IsGetCoin( "get_coin_29" ) then

      ObjDelete( "gzz_wincards_drawercabinet" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_gear_2", get_gear_2_inv );
  cmn.AddSubscriber( "get_gear_2", get_gear_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_prv_gun () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_prv_gun" ] = {
    type = "get",
    get_obj = "spr_drawercabinet_prv_gun",
    room = private.room_objname,
    zz = "zz_drawercabinet",
    zz_gate = "gzz_wincards_drawercabinet"
  };
    
  local get_prv_gun_inv = function ()
  
    interface.ProvidePanelItemAdd( "inv_prv_gun", "spr_drawercabinet_prv_gun" );
  
  end;
  
  local get_prv_gun_closezz = function ()
  
    ObjDelete( "gfx_drawercabinet_prv_gun" );

    if cmn.IsEventDone( "get_gear_2" ) and common_impl.IsGetCoin( "get_coin_29" ) then

      ObjDelete( "gzz_wincards_drawercabinet" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_prv_gun", get_prv_gun_inv );
  cmn.AddSubscriber( "get_prv_gun", get_prv_gun_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_penknife () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_penknife" ] = {
    type = "get",
    get_obj = "spr_winshelf_penknife",
    room = private.room_objname,
    zz = "zz_winshelf",
    zz_gate = "gzz_wincards_winshelf"
  };
    
  local get_penknife_inv = function ()
  
    interface.InventoryItemAdd( "inv_penknife", "spr_winshelf_penknife" );
  
  end;
  
  local get_penknife_closezz = function ()
  
    ObjDelete( "gfx_winshelf_penknife" );
    ObjDelete( "spr_winshelf_penknife_shadow" );
    ObjDelete( "spr_winshelf_penknife_over" );
    ObjDelete( "spr_winshelf_penknife_over_2" );
    ObjDelete( "spr_wincards_winshelf_knife" );
    ObjSet( "obj_winshelf_use_bottleofwine", { input = true });

  end;
  
  cmn.AddSubscriber( "get_penknife", get_penknife_inv );
  cmn.AddSubscriber( "get_penknife", get_penknife_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_29 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_29 = function ()
 
    ObjDelete( "obj_drawercabinet_coin" );

    if cmn.IsEventDone( "get_gear_2" ) and cmn.IsEventDone( "get_prv_gun" ) then

      ObjDelete( "gzz_wincards_drawercabinet" );

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_29", get_collect_coin_29, private.room_objname );
   --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_3_5 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_3_5 = function ()
  
    ObjDelete( "obj_wincards_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_3_5", get_collect_morph_item_3_5, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function use_valve () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_valve" ] = {
    type = "use",
    inv_obj = "inv_valve",
    use_place = "obj_winetable_use_valve",
    room = private.room_objname,
    zz = "zz_winetable",
    zz_gate = "gzz_wincards_winetable"
  };
  local use_valve_inv = function ()
  
    interface.InventoryItemRemove( "inv_valve" );
  
  end;
  local use_valve_beg = function ()
    
    ObjDelete( "obj_winetable_use_valve" );
  
  end;
  local use_valve_end = function ()
    
    ObjMultiSet({

    { "gho_wincards_intable", { input = true, active = true } }, 
    { "gzz_wincards_winetable", { input = false, visible = false, active = false } },
    { "spr_winetable_handle", { alp = 1 } },
    { "spr_wincards_intable_ho", { alp = 1 } }

    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_valve", use_valve_beg, private.room_objname );
  cmn.AddSubscriber( "use_valve", use_valve_inv );
  cmn.AddSubscriber( "use_valve", use_valve_end, private.room_objname );
  cmn.AddSubscriber( "use_valve_inv", use_valve_inv, private.room_objname );
  cmn.AddSubscriber( "use_valve_beg", use_valve_beg, private.room_objname );
  cmn.AddSubscriber( "use_valve_end", use_valve_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gear_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gear_1" ] = {
    type = "use",
    inv_obj = "inv_gear_1",
    use_place = "obj_winetable_use_gear_1",
    room = private.room_objname,
    zz = "zz_winetable",
    zz_gate = "gzz_wincards_winetable"
  };
  local use_gear_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_gear_1" );
  
  end;
  local use_gear_1_beg = function ()
  
    ObjDelete( "obj_winetable_use_gear_1" );
  
  end;
  local use_gear_1_end = function ()

    ObjSet( "spr_winetable_cogwheel1", { alp = 1 } );
    ObjSet( "spr_wincards_winetable_ring_1", { alp = 1 } );

    if cmn.IsEventDone( "use_gear_2" ) and
      cmn.IsEventDone( "use_gear_3" ) then

      private.After_use_all_gears();

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gear_1", use_gear_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_gear_1", use_gear_1_inv );
  cmn.AddSubscriber( "use_gear_1", use_gear_1_end, private.room_objname );
  cmn.AddSubscriber( "use_gear_1_inv", use_gear_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_gear_1_beg", use_gear_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_gear_1_end", use_gear_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gear_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gear_2" ] = {
    type = "use",
    inv_obj = "inv_gear_2",
    use_place = "obj_winetable_use_gear_2",
    room = private.room_objname,
    zz = "zz_winetable",
    zz_gate = "gzz_wincards_winetable"
  };
  local use_gear_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_gear_2" );
  
  end;
  local use_gear_2_beg = function ()
  
    ObjDelete( "obj_winetable_use_gear_2" );
  
  end;
  local use_gear_2_end = function ()

    ObjSet( "spr_winetable_cogwheel2", { alp = 1 } );
    ObjSet( "spr_wincards_winetable_ring_2", { alp = 1 } );

    if cmn.IsEventDone( "use_gear_1" ) and
      cmn.IsEventDone( "use_gear_3" ) then

      private.After_use_all_gears()

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gear_2", use_gear_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_gear_2", use_gear_2_inv );
  cmn.AddSubscriber( "use_gear_2", use_gear_2_end, private.room_objname );
  cmn.AddSubscriber( "use_gear_2_inv", use_gear_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_gear_2_beg", use_gear_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_gear_2_end", use_gear_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_gear_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_gear_3" ] = {
    type = "use",
    inv_obj = "inv_gear_3",
    use_place = "obj_winetable_use_gear_3",
    room = private.room_objname,
    zz = "zz_winetable",
    zz_gate = "gzz_wincards_winetable"
  };
  local use_gear_3_inv = function ()
  
    interface.InventoryItemRemove( "inv_gear_3" );
  
  end;
  local use_gear_3_beg = function ()
  
    ObjDelete( "obj_winetable_use_gear_3" );
  
  end;
  local use_gear_3_end = function ()
  
    ObjSet( "spr_winetable_cogwheel3", { alp = 1 } );
    ObjSet( "spr_wincards_winetable_ring_3", { alp = 1 } );

    if cmn.IsEventDone( "use_gear_1" ) and
      cmn.IsEventDone( "use_gear_2" ) then

      private.After_use_all_gears ()

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_gear_3", use_gear_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_gear_3", use_gear_3_inv );
  cmn.AddSubscriber( "use_gear_3", use_gear_3_end, private.room_objname );
  cmn.AddSubscriber( "use_gear_3_inv", use_gear_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_gear_3_beg", use_gear_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_gear_3_end", use_gear_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_button_1" ] = {
    type = "use",
    inv_obj = "inv_button_1",
    use_place = "obj_drawercabinet_use_button_1",
    room = private.room_objname,
    zz = "zz_drawercabinet",
    zz_gate = "gzz_wincards_drawercabinet"
  };
  local use_button_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_button_1" );
  
  end;
  local use_button_1_beg = function ()
  
    ObjDelete( "obj_drawercabinet_use_button_1" );
  
  end;
  local use_button_1_end = function ()

    ObjMultiSet({ 
      { "spr_drawercabinet_button1",         { alp = 1 }},
      { "spr_drawercabinet_button1_overlap", { alp = 1 }},
      { "spr_wincards_drawercabinet_button1", { alp = 1 }},
      { "obj_drawercabinet_clk_button_1",    { input = true, visible = true, active = true }}
    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_button_1", use_button_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_1", use_button_1_inv );
  cmn.AddSubscriber( "use_button_1", use_button_1_end, private.room_objname );
  cmn.AddSubscriber( "use_button_1_inv", use_button_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_button_1_beg", use_button_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_1_end", use_button_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_button_2" ] = {
    type = "use",
    inv_obj = "inv_button_2",
    use_place = "obj_drawercabinet_use_button_2",
    room = private.room_objname,
    zz = "zz_drawercabinet",
    zz_gate = "gzz_wincards_drawercabinet"
  };
  local use_button_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_button_2" );
  
  end;
  local use_button_2_beg = function ()
  
    ObjDelete( "obj_drawercabinet_use_button_2" );
  
  end;
  local use_button_2_end = function ()

    ObjMultiSet({ 
      { "spr_drawercabinet_button2",         { alp = 1 }},
      { "spr_drawercabinet_button2_overlap", { alp = 1 }},
      { "spr_wincards_drawercabinet_button2", { alp = 1 }},
      { "obj_drawercabinet_clk_button_2",    { input = true, visible = true, active = true }}
    });  

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_button_2", use_button_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_2", use_button_2_inv );
  cmn.AddSubscriber( "use_button_2", use_button_2_end, private.room_objname );
  cmn.AddSubscriber( "use_button_2_inv", use_button_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_button_2_beg", use_button_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_2_end", use_button_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bottleofwine () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bottleofwine" ] = {
    type = "use",
    inv_obj = "inv_bottleofwine",
    use_place = "obj_winshelf_use_bottleofwine",
    room = private.room_objname,
    zz = "zz_winshelf",
    zz_gate = "gzz_wincards_winshelf"
  };
  local use_bottleofwine_inv = function ()
  
    interface.InventoryItemRemove( "inv_bottleofwine" );
  
  end;
  local use_bottleofwine_beg = function ()
  
    ObjDelete( "obj_winshelf_use_bottleofwine" );
  
  end;
  local use_bottleofwine_end = function ()
  
    ObjSet( "gmg_wincards_bottles", { input = true, active = true } );  
    ObjSet( "obj_winshelf_bottleofwine", { alp = 1 } );
    ObjSet( "spr_wincards_winshelf_bottle", { alp = 1 } );
    ObjDelete( "gzz_wincards_winshelf" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bottleofwine", use_bottleofwine_beg, private.room_objname );
  cmn.AddSubscriber( "use_bottleofwine", use_bottleofwine_inv );
  cmn.AddSubscriber( "use_bottleofwine", use_bottleofwine_end, private.room_objname );
  cmn.AddSubscriber( "use_bottleofwine_inv", use_bottleofwine_inv, private.room_objname );
  cmn.AddSubscriber( "use_bottleofwine_beg", use_bottleofwine_beg, private.room_objname );
  cmn.AddSubscriber( "use_bottleofwine_end", use_bottleofwine_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tap () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tap" ] = {
    type = "use",
    inv_obj = "inv_tap",
    use_place = "obj_barrel_use_tap",
    room = private.room_objname,
    zz = "zz_barrel",
    zz_gate = "gzz_wincards_barrel"
  };
  local use_tap_inv = function ()
  
    interface.InventoryItemRemove( "inv_tap" );
  
  end;
  local use_tap_beg = function ()
  
    ObjDelete( "obj_barrel_use_tap" );

  end;
  local use_tap_end = function ()
  
    ObjMultiSet({ 
      { "spr_barrel_faucet",  { alp = 1 }},
      { "spr_wincards_winshelf_faucet",  { alp = 1 }},
      { "obj_barrel_clk_tap", { input = true, visible = true }}
    });

    ObjDelete( "spr_barrel_light_1_dodge" );
    ObjDelete( "spr_barrel_light_2_add"   );
    ObjDelete( "spr_wincards_barrel_barrel_add" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tap", use_tap_beg, private.room_objname );
  cmn.AddSubscriber( "use_tap", use_tap_inv );
  cmn.AddSubscriber( "use_tap", use_tap_end, private.room_objname );
  cmn.AddSubscriber( "use_tap_inv", use_tap_inv, private.room_objname );
  cmn.AddSubscriber( "use_tap_beg", use_tap_beg, private.room_objname );
  cmn.AddSubscriber( "use_tap_end", use_tap_end, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function use_providence_fuellamp () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_providence_fuellamp" ] = {
    type = "use",
    inv_obj = "inv_prv_fuellamp",
    use_place = "obj_wincards_use_prv_item_2",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"
  };
  local use_providence_fuellamp_inv = function ()
  
    interface.ProvidePanelItemRemove( "inv_prv_fuellamp" );
  
  end;
  local use_providence_fuellamp_beg = function ()
  
    ObjDelete( "obj_wincards_use_prv_item_2" );
  
  end;
  local use_providence_fuellamp_end = function ()
  
    ObjSet( "spr_wincards_prv_fuellamp_used", { alp = 1 } );
    --ObjSet( "spr_wincards_fuellamp", { alp = 1 } );
    ObjDelete( "spr_wincards_prv_fuellamp_light" );
    ObjSet( "spr_wincards_lamp", { visible = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_providence_fuellamp", use_providence_fuellamp_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_fuellamp", use_providence_fuellamp_inv );
  cmn.AddSubscriber( "use_providence_fuellamp", use_providence_fuellamp_end, private.room_objname );
  cmn.AddSubscriber( "use_providence_fuellamp_inv", use_providence_fuellamp_inv, private.room_objname );
  cmn.AddSubscriber( "use_providence_fuellamp_beg", use_providence_fuellamp_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_fuellamp_end", use_providence_fuellamp_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_providence_handcuffs () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_providence_handcuffs" ] = {
    type = "use",
    inv_obj = "inv_prv_handcuffs",
    use_place = "obj_wincards_use_prv_item_1",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"
  };
  local use_providence_handcuffs_inv = function ()
  
    interface.ProvidePanelItemRemove( "inv_prv_handcuffs" );
  
  end;
  local use_providence_handcuffs_beg = function ()
  
    ObjDelete( "obj_wincards_use_prv_item_1" );
  
  end;
  local use_providence_handcuffs_end = function ()

    ObjSet( "spr_wincards_prv_handcuffs_used", { alp = 1 } );
    --ObjSet( "spr_wincards_handcuffs", { alp = 1 } );
    ObjDelete( "spr_wincards_prv_handcuffs_light" );
    ObjSet( "spr_wincards_handcuffs", { visible = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_providence_handcuffs", use_providence_handcuffs_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_handcuffs", use_providence_handcuffs_inv );
  cmn.AddSubscriber( "use_providence_handcuffs", use_providence_handcuffs_end, private.room_objname );
  cmn.AddSubscriber( "use_providence_handcuffs_inv", use_providence_handcuffs_inv, private.room_objname );
  cmn.AddSubscriber( "use_providence_handcuffs_beg", use_providence_handcuffs_beg, private.room_objname );
  cmn.AddSubscriber( "use_providence_handcuffs_end", use_providence_handcuffs_end, private.room_objname );
 --------------------------------------------------------------------------------------------
  -- function clk_providence_armchair () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_providence_armchair" ] = {
    type = "use",
    inv_obj = "spr_wincards_prv_armchair",
    use_place = "obj_wincards_prv_item_1",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"    
  };
  local clk_providence_armchair_beg = function ()
  
    ObjDelete(  "obj_wincards_prv_item_1" );
  
  end;
  local clk_providence_armchair_end = function ()

    ObjDelete( "spr_wincards_prv_armchair" );
    ObjDelete( "spr_wincards_prv_armchair_light" );
    ObjDelete( "spr_wincards_chair1" );
    ObjSet( "spr_wincards_prv_armchair_used", { alp = 1 } );
    ObjSet( "spr_wincards_chair2", { visible = true } );
    ObjSet( "obj_wincards_morph", { pos_x = 426, pos_y = -4 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_providence_armchair", clk_providence_armchair_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_armchair", clk_providence_armchair_end, private.room_objname );
  cmn.AddSubscriber( "clk_providence_armchair_beg", clk_providence_armchair_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_armchair_end", clk_providence_armchair_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_providence_stairs () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_providence_stairs" ] = {
    type = "use",
    inv_obj = "spr_wincards_prv_stairs",
    use_place = "obj_wincards_prv_item_2",
    room = private.room_objname,
    zz = "int_button_providence",
    zz_gate = "obj_int_button_providence"  
  };
  local clk_providence_stairs_beg = function ()
  
    ObjDelete(  "obj_wincards_prv_item_2" );
  
  end;
  local clk_providence_stairs_end = function ()
  
    ObjDelete( "spr_wincards_prv_stairs" );
    ObjDelete( "spr_wincards_prv_stairs_light" );
    ObjSet( "spr_wincards_prv_stairs_used", { alp = 1 } );
    ObjDelete( "spr_wincards_stairs1" );
    ObjSet( "spr_wincards_stairs2", { visible = true } );
    ObjSet( "spr_barrel_ladder", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_providence_stairs", clk_providence_stairs_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_stairs", clk_providence_stairs_end, private.room_objname );
  cmn.AddSubscriber( "clk_providence_stairs_beg", clk_providence_stairs_beg, private.room_objname );
  cmn.AddSubscriber( "clk_providence_stairs_end", clk_providence_stairs_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_tap () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_tap" ] = {
    type = "click",
    use_place = "obj_barrel_clk_tap",
    room = private.room_objname,
    zz = "zz_barrel",
    zz_gate = "gzz_wincards_barrel"    
  };
  local clk_tap_beg = function ()
  
    ObjDelete( "obj_barrel_clk_tap"  );
    ObjDelete( "gzz_wincards_barrel" );
  
  end;
  local clk_tap_end = function ()
  
    ObjMultiSet({ 
      { "spr_barrel_cap_open_shadow", { alp = 1 }},
      { "spr_barrel_cap_open",        { alp = 1 }},
      { "grm_wincards_secretroom",    { input = true, active = true }},
      { "grm_wincards_secretroom_black", { alp = 1 }},
      { "spr_wincards_barrel_barrel_op2",    { alp = 1 }}
    });
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_wincards_secretroom_focus");
    end;
    ObjDelete( "spr_barrel_faucet" );
    ObjDelete( "spr_barrel_faucet_turn" );
    ObjDelete( "spr_barrel_cap" );
    ObjDelete( "spr_wincards_winshelf_faucet" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_tap", clk_tap_beg, private.room_objname );
  cmn.AddSubscriber( "clk_tap", clk_tap_end, private.room_objname );
  cmn.AddSubscriber( "clk_tap_beg", clk_tap_beg, private.room_objname );
  cmn.AddSubscriber( "clk_tap_end", clk_tap_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function clk_providence_wincards () end;
  --------------------------------------------------------------------------------------------
  local clk_providence_wincards = function ()
              
    if ( not cmn.IsEventDone( "clk_providence_armchair" ) or not cmn.IsEventDone( "clk_providence_stairs" ) 
         or ( cmn.IsEventDone( "get_prv_handcuffs" ) and not cmn.IsEventDone( "use_providence_handcuffs" ) )
         or ( cmn.IsEventDone( "get_prv_fuellamp" ) and not cmn.IsEventDone( "use_providence_fuellamp" ) ) ) then

        int_button_providence.StartActiveProvidence();

    end;
  
  end;
  
  cmn.AddSubscriber( "clk_providence_wincards", clk_providence_wincards, private.room_objname );
 
  --------------------------------------------------------------------------------------------
  -- function clk_button_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_button_1" ] = {
    type = "click",
    use_place = "obj_drawercabinet_clk_button_1",
    room = private.room_objname,
    zz = "zz_drawercabinet",
    zz_gate = "gzz_wincards_drawercabinet"    
  };
  local clk_button_1_beg = function ()
  
    ObjDelete( "obj_drawercabinet_clk_button_1" );
  
  end;
  local clk_button_1_end = function ()

    ObjMultiSet({ 
      { "spr_drawercabinet_prv_handcuffs",  { input = true     }},
      { "gfx_drawercabinet_prv_handcuffs",  { active = true    }},
      { "spr_drawercabinet_gear_1",         { input = true     }},
      { "gfx_drawercabinet_gear_1",         { active = true    }},
      { "obj_drawercabinet_box1",           { alp = 1          }},
      { "spr_wincards_drawercabinet_box_1", { alp = 1          }}

    });

    ObjDelete( "spr_wincards_drawercabinet_button1" );
    ObjDelete( "spr_drawercabinet_button1" );
    ObjDelete( "spr_drawercabinet_button1_shadow" );
    ObjDelete( "spr_drawercabinet_button1_overlap" );
      
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_button_1", clk_button_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_button_1", clk_button_1_end, private.room_objname );
  cmn.AddSubscriber( "clk_button_1_beg", clk_button_1_beg, private.room_objname );
  cmn.AddSubscriber( "clk_button_1_end", clk_button_1_end, private.room_objname );

 --------------------------------------------------------------------------------------------
  -- function clk_button_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_button_2" ] = {
    type = "click",
    use_place = "obj_drawercabinet_clk_button_2",
    room = private.room_objname,
    zz = "zz_drawercabinet",
    zz_gate = "gzz_wincards_drawercabinet"    
  };
  local clk_button_2_beg = function ()
  
    ObjDelete( "obj_drawercabinet_clk_button_2" );
  
  end;
  local clk_button_2_end = function ()
      
    ObjMultiSet({ 
      { "spr_drawercabinet_prv_gun", { input = true     }},
      { "gfx_drawercabinet_prv_gun", { active = true    }},
      { "spr_drawercabinet_gear_2",  { input = true     }},
      { "gfx_drawercabinet_gear_2",  { active = true    }},
      { "obj_drawercabinet_box2",    { alp = 1          }},
      { "obj_wincards_drawercabinet_box_2",    { alp = 1          }}
    });

    ObjDelete( "spr_wincards_drawercabinet_button2" );
    ObjDelete( "spr_drawercabinet_button2" );
    ObjDelete( "spr_drawercabinet_button2_shadow" );
    ObjDelete( "spr_drawercabinet_button2_overlap" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_button_2", clk_button_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_button_2", clk_button_2_end, private.room_objname );
  cmn.AddSubscriber( "clk_button_2_beg", clk_button_2_beg, private.room_objname );
  cmn.AddSubscriber( "clk_button_2_end", clk_button_2_end, private.room_objname );

 --------------------------------------------------------------------------------------------
  -- function vid_wincards_providence () end;
  --------------------------------------------------------------------------------------------  
  
  local vid_wincards_prv_end = function ()

    ObjSet( "gzz_wincards_winshelf", { active = true, input = true } );
   
  end;

  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_wincards_providence", vid_wincards_prv_end, private.room_objname  );
  cmn.AddSubscriber( "vid_wincards_prv_end", vid_wincards_prv_end, private.room_objname  );
 --------------------------------------------------------------------------------------------
  
  local vid_wincards_providence_p2 = function ()

    VidStop( "vid_wincards_providence_p1" );
    ObjSet( "vid_wincards_providence_p2", { playing = true } );    

  end;   

  cmn.AddSubscriber( "vid_wincards_providence_p2", vid_wincards_providence_p2, private.room_objname );
  --------------------------------------------------------------------------------------------
  local vid_wincards_providence_p3 = function ()

    VidStop( "vid_wincards_providence_p2" );
    ObjSet( "vid_wincards_providence_p3", { playing = true } );

  end;   

  cmn.AddSubscriber( "vid_wincards_providence_p3", vid_wincards_providence_p3, private.room_objname );
  --------------------------------------------------------------------------------------------
  local vid_wincards_providence_p4 = function ()

    VidStop( "vid_wincards_providence_p3" );
    VidPlay( "vid_wincards_providence_p4", private.vid_wincards_providence_end );    

  end;   

  cmn.AddSubscriber( "vid_wincards_providence_p4", vid_wincards_providence_p4, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_winetable" );
  --------------------------------------------------------------------------------------------
  function zz_winetable.PreOpen()

    AnimStop( "anm_wincards_mouse" );
    common_impl.StopAudio( "sfx", "common/audio/aud_wincards_mouse", 1 );
 
  end;
 --------------------------------------------------------------------------------------------

  subroom.Define( "zz_drawercabinet" );
  --------------------------------------------------------------------------------------------
  function zz_drawercabinet.PreOpen()

    AnimStop( "anm_wincards_mouse" );
    common_impl.StopAudio( "sfx", "common/audio/aud_wincards_mouse", 1 );
 
  end;
 --------------------------------------------------------------------------------------------

  subroom.Define( "zz_winshelf" );
  --------------------------------------------------------------------------------------------
  function zz_winshelf.PreOpen()

    AnimStop( "anm_wincards_mouse" );
    common_impl.StopAudio( "sfx", "common/audio/aud_wincards_mouse", 1 );
 
  end;
 --------------------------------------------------------------------------------------------

  subroom.Define( "zz_barrel" );
  --------------------------------------------------------------------------------------------
  function zz_barrel.PreOpen()

    AnimStop( "anm_wincards_mouse" );
    common_impl.StopAudio( "sfx", "common/audio/aud_wincards_mouse", 1 );
 
  end;
 --------------------------------------------------------------------------------------------
  

end;
--*********************************************************************************************************************
function public.Open()

  local chance = math.random( 1,5 );

  if chance == 3 then
       
    AnimPlay( "anm_wincards_mouse", "DoAnim", "" );
    common_impl.PlayAudio( "sfx", "common/audio/aud_wincards_mouse", 0, "", 0 );

  end;

  private.opn_wincards();
  
  int_providence_eye.CheckShow();

  if ( not cmn.IsEventDone( "vid_wincards_providence" ) ) then

    int_button_providence.StartLightProvidence();

  end;

  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.MorphItemMorphing();
  interface.InvestigationButtonCheck();

  common_impl.EnvPlay( { "common/audio/aud_wincards_env" }, "", 0.5 ); 
  
end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );

  AnimStop( "anm_wincards_mouse" );
  common_impl.StopAudio( "sfx", "common/audio/aud_wincards_mouse", 1 );

end;
--*********************************************************************************************************************
function public.PreClose()

  if ( not cmn.IsEventDone( "vid_wincards_providence" ) ) then

    int_button_providence.StopLightProvidence();

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_valve()

  local item = "inv_valve";

  if ( common.ApplyObj( item, "obj_winetable_use_valve", true ) ) then

    cmn.CallEventHandler( "use_valve_inv" );
    cmn.CallEventHandler( "use_valve_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_valve" );
      cmn.CallEventHandler( "use_valve_end" );
      common.CloseSubRoom();
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_use_valve", 0, "", 0 );
  
    ObjAnimate( "spr_winetable_handle", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_wincards_winetable", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_winetable", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_gear_1()

  local item = "inv_gear_1";

  if ( common.ApplyObj( item, "obj_winetable_use_gear_1", true ) ) then

    cmn.CallEventHandler( "use_gear_1_inv" );
    cmn.CallEventHandler( "use_gear_1_beg" );

    local func_after = function ()

      local endfunc = function ()

        cmn.SetEventDone( "use_gear_1" );
        cmn.CallEventHandler( "use_gear_1_end" );

      end;


      common_impl.Lock( false );

      if cmn.IsEventDone( "use_gear_2" ) and
         cmn.IsEventDone( "use_gear_3" ) then

        private.PlayAnimOwl( endfunc );

      else

        endfunc();

      end;

  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_use_owl_gear", 0, "", 0 );
  
    ObjAnimate( "spr_winetable_cogwheel1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_wincards_winetable", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_winetable", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_gear_2()

  local item = "inv_gear_2";

  if ( common.ApplyObj( item, "obj_winetable_use_gear_2", true ) ) then

    cmn.CallEventHandler( "use_gear_2_inv" );
    cmn.CallEventHandler( "use_gear_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );

      local endfunc = function ()

        cmn.SetEventDone( "use_gear_2" );
        cmn.CallEventHandler( "use_gear_2_end" );

      end;

      if cmn.IsEventDone( "use_gear_1" ) and
         cmn.IsEventDone( "use_gear_3" ) then

        private.PlayAnimOwl( endfunc );
      else
        endfunc();      
      end;
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_use_owl_gear", 0, "", 0 );
  
    ObjAnimate( "spr_winetable_cogwheel2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_wincards_winetable", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_winetable", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_gear_3()

  local item = "inv_gear_3";

  if ( common.ApplyObj( item, "obj_winetable_use_gear_3", true ) ) then

    cmn.CallEventHandler( "use_gear_3_inv" );
    cmn.CallEventHandler( "use_gear_3_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      local endfunc = function ()

        cmn.SetEventDone( "use_gear_3" );
        cmn.CallEventHandler( "use_gear_3_end" );

      end;
      if cmn.IsEventDone( "use_gear_1" ) and
         cmn.IsEventDone( "use_gear_2" ) then

          private.PlayAnimOwl( endfunc );
      else
        endfunc();
      end;
    
  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_use_owl_gear", 0, "", 0 );
  
    ObjAnimate( "spr_winetable_cogwheel3", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_wincards_winetable", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_winetable", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_button_1()

  local item = "inv_button_1";

  if ( common.ApplyObj( item, "obj_drawercabinet_use_button_1", true ) ) then

    cmn.CallEventHandler( "use_button_1_inv" );
    cmn.CallEventHandler( "use_button_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_button_1" );
      cmn.CallEventHandler( "use_button_1_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_button", 0, "", 0 );
  
    ObjAnimate( "spr_drawercabinet_button1", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );
    ObjAnimate( "spr_drawercabinet_button1_overlap", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_wincards_drawercabinet", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_drawercabinet", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_button_2()

  local item = "inv_button_2";

  if ( common.ApplyObj( item, "obj_drawercabinet_use_button_2", true ) ) then

    cmn.CallEventHandler( "use_button_2_inv" );
    cmn.CallEventHandler( "use_button_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_button_2" );
      cmn.CallEventHandler( "use_button_2_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_button", 0, "", 0 );
  
    ObjAnimate( "spr_drawercabinet_button2", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );
    ObjAnimate( "spr_drawercabinet_button2_overlap", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );

  return true;
  
  elseif common.ApplyObj( item, "gzz_wincards_drawercabinet", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_drawercabinet", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bottleofwine()

  local item = "inv_bottleofwine";

  if ( common.ApplyObj( item, "obj_winshelf_use_bottleofwine", true ) ) then

    cmn.CallEventHandler( "use_bottleofwine_inv" );
    cmn.CallEventHandler( "use_bottleofwine_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_bottleofwine" );
      cmn.CallEventHandler( "use_bottleofwine_end" );
      common.CloseSubRoom();
      cmn.GotoRoom( "mg_bottles" );
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_bottle", 0, "", 0 );
  
    ObjAnimate( "obj_winshelf_bottleofwine", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_wincards_winshelf", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_winshelf", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tap()

  local item = "inv_tap";

  if ( common.ApplyObj( item, "obj_barrel_use_tap", true ) ) then

    cmn.CallEventHandler( "use_tap_inv" );
    cmn.CallEventHandler( "use_tap_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_tap" );
      cmn.CallEventHandler( "use_tap_end" );
      --common.CloseSubRoom();
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_tap", 0, "", 0 );
  
    ObjAnimate( "spr_barrel_faucet", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_barrel_light_1_dodge", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
    ObjAnimate( "spr_barrel_light_2_add",   "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
  
  return true;
  
  elseif common.ApplyObj( item, "gzz_wincards_barrel", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_barrel", nil, { 512, 384 } );

  return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_providence_fuellamp()

  local item = "inv_prv_fuellamp";

  if ( ObjIntersect( item, "obj_wincards_use_prv_item_2") and int_providence.show ) then

    cmn.CallEventHandler( "use_providence_fuellamp_inv" );
    cmn.CallEventHandler( "use_providence_fuellamp_beg" );
    
    local func_after = function ()

      common_impl.Lock(false);
      cmn.CallEventHandler( "use_providence_fuellamp_end" );

      if cmn.IsEventDone( "clk_providence_armchair" ) and cmn.IsEventDone( "clk_providence_stairs" ) and 
          cmn.IsEventDone( "use_providence_handcuffs" ) then

          private.anim_providence( function() cmn.SetEventDone( "use_providence_fuellamp" ); end );

      else 

        if ( cmn.IsEventDone( "clk_providence_armchair" ) and cmn.IsEventDone( "clk_providence_stairs" ) and             
            (cmn.IsEventDone( "use_providence_fuellamp" ) or not cmn.IsEventDone( "get_prv_handcuffs" ) )) then
          int_button_providence.StopActiveProvidence();
        end;

        cmn.SetEventDone( "use_providence_fuellamp" );

      end;

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_providence_burner", 0, "", 0 );

    ObjAnimate( "spr_wincards_prv_fuellamp_used", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_providence_handcuffs()

  local item = "inv_prv_handcuffs";

  if ( ObjIntersect( item, "obj_wincards_use_prv_item_1" ) and int_providence.show ) then

    cmn.CallEventHandler( "use_providence_handcuffs_inv" );
    cmn.CallEventHandler( "use_providence_handcuffs_beg" );

    local func_after = function ()

      common_impl.Lock(false);
      cmn.CallEventHandler( "use_providence_handcuffs_end" );

      if cmn.IsEventDone( "clk_providence_armchair" ) and cmn.IsEventDone( "clk_providence_stairs" ) and 
          cmn.IsEventDone( "use_providence_fuellamp" ) then

          private.anim_providence( function() cmn.SetEventDone( "use_providence_handcuffs" ); end );

      else 

        if ( cmn.IsEventDone( "clk_providence_armchair" ) and cmn.IsEventDone( "clk_providence_stairs" ) and             
            (cmn.IsEventDone( "use_providence_handcuffs" ) or not cmn.IsEventDone( "get_prv_fuellamp" ) )) then
          int_button_providence.StopActiveProvidence();
        end;

        cmn.SetEventDone( "use_providence_handcuffs" );

      end;

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_providence_handcuffs", 0, "", 0 );

    ObjAnimate( "spr_wincards_prv_handcuffs_used", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

    return true;  

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_candle()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_candle" );
  cmn.CallEventHandler( "get_candle" );

end;
--------------------------------------------------------------------------------------------
function private.get_fuelsawchain()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_fuelsawchain" );
  cmn.CallEventHandler( "get_fuelsawchain" );

end;
--------------------------------------------------------------------------------------------
function private.get_ring()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  common.CloseSubRoom();
  cmn.SetEventDone( "get_ring_2" );
  cmn.CallEventHandler( "get_ring_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_prv_handcuffs()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_prv_handcuffs" );
  cmn.CallEventHandler( "get_prv_handcuffs" );

end;
--------------------------------------------------------------------------------------------
function private.get_gear_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_gear_1" );
  cmn.CallEventHandler( "get_gear_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_gear_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_gear_2" );
  cmn.CallEventHandler( "get_gear_2" );

  if ( cmn.IsEventDone( "get_prv_gun" ) and common_impl.IsGetCoin( "get_coin_29" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_prv_gun()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_prv_gun" );
  cmn.CallEventHandler( "get_prv_gun" );

  if ( cmn.IsEventDone( "get_gear_2" ) and common_impl.IsGetCoin( "get_coin_29" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_penknife()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_penknife" );
  cmn.CallEventHandler( "get_penknife" );

end;
-----------------------------------------------------------------------------------------------------------------------
function private.get_collect_coin_29()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_29" );
    cmn.CallEventHandler( "get_coin_29" );

    if cmn.IsEventDone( "get_prv_gun" ) and cmn.IsEventDone( "get_gear_2" )  then

      common.CloseSubRoom();

    end;    

  end;

  common_impl.PlayEffectHO( "spr_drawercabinet_coin", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.get_prv_handcuffs_silhouette()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );
  cmn.SetEventDone( "get_prv_handcuffs_silhouette" );
  cmn.CallEventHandler( "get_prv_handcuffs_silhouette" );

end;
--------------------------------------------------------------------------------------------
function private.get_prv_fuellamp_silhouette()

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_get_empty", 0, "", 0 );
  cmn.SetEventDone( "get_prv_fuellamp_silhouette" );
  cmn.CallEventHandler( "get_prv_fuellamp_silhouette" );

end;
-----------------------------------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_owl()

  common_impl.Lock( true );

  local func_after = function()

    common_impl.Lock( false );
    common_impl.ShowBbt( 'bbt_winetable_use_gear_1' );

  end

  AnimPlay( "anm_table_owl_2", "DoAnim", func_after );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_owl_wings", 0, "", 0 );

end;

function private.clk_tap()

  cmn.CallEventHandler( "clk_tap_beg" );

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_tap" );
    cmn.CallEventHandler( "clk_tap_end" );
    common.CloseSubRoom();
  
  end;
  
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_tap", 0, "", 0 );
  
  ObjAnimate( "spr_barrel_faucet", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0,
    0.6, 0, 0.0,
    0.9, 0, 0.0
  } );
  ObjAnimate( "spr_barrel_faucet_turn", "alp", 0, 0, "", 
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0,
    0.6, 0, 0.0,
    0.9, 0, 0.0
  } );

  ObjAnimate( "spr_barrel_cap", "alp", 0, 0, "", 
  { 
    0.0, 0, 1.0, 
    0.3, 0, 1.0,
    0.6, 0, 0.0,
    0.9, 0, 0.0
  } );
  ObjAnimate( "spr_barrel_cap_open_shadow", "alp", 0, 0, "", 
  { 
    0.0, 0, 0.0, 
    0.3, 0, 0.0,
    0.6, 0, 1.0,
    0.9, 0, 1.0
  } );
  ObjAnimate( "spr_barrel_cap_open", "alp", 0, 0, "", 
  { 
    0.0, 0, 0.0, 
    0.3, 0, 0.0,
    0.6, 0, 1.0,
    0.9, 0, 1.0
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_providence_armchair()

  cmn.CallEventHandler( "clk_providence_armchair_beg" );

  local func_after = function ()

    common_impl.Lock(false);

    cmn.CallEventHandler( "clk_providence_armchair_end" );

    if cmn.IsEventDone( "clk_providence_stairs" ) and cmn.IsEventDone( "use_providence_fuellamp" ) 
       and cmn.IsEventDone( "use_providence_handcuffs" ) then

      private.anim_providence( function() cmn.SetEventDone( "clk_providence_armchair" ); end );

    else 

      if ( cmn.IsEventDone( "clk_providence_stairs" ) and
      ( not cmn.IsEventDone( "get_prv_fuellamp" ) or cmn.IsEventDone( "use_providence_fuellamp" ) ) and
      ( not cmn.IsEventDone( "get_prv_handcuffs" ) or cmn.IsEventDone( "use_providence_handcuffs" ) ) ) then

        int_button_providence.StopActiveProvidence();

      end;

      cmn.SetEventDone( "clk_providence_armchair" );

    end;

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_armchair", 0, "", 0 );

  ObjSet( "spr_wincards_prv_armchair", { alp = 0 } );
  ObjAnimate( "spr_wincards_prv_armchair_used", "alp", 0, 0, func_after, { 0, 0, 0, 0.1, 0, 0, 0.3, 0, 1 } );

end;
--------------------------------------------------------------------------------------------
function private.clk_providence_stairs()

  cmn.CallEventHandler( "clk_providence_stairs_beg" );
  
  local func_after = function ()

    common_impl.Lock(false);

    cmn.CallEventHandler( "clk_providence_stairs_end" );

    if cmn.IsEventDone( "clk_providence_armchair" ) and cmn.IsEventDone( "use_providence_fuellamp" ) 
       and cmn.IsEventDone( "use_providence_handcuffs" ) then

      private.anim_providence( function() cmn.SetEventDone( "clk_providence_stairs" ); end );

    else 

      if ( cmn.IsEventDone( "clk_providence_armchair" ) and
      ( not cmn.IsEventDone( "get_prv_fuellamp" ) or cmn.IsEventDone( "use_providence_fuellamp" ) ) and
      ( not cmn.IsEventDone( "get_prv_handcuffs" ) or cmn.IsEventDone( "use_providence_handcuffs" ) ) ) then

        int_button_providence.StopActiveProvidence();

      end;

      cmn.SetEventDone( "clk_providence_stairs" );

    end;

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_stairs", 0, "", 0 );

  common_impl.Lock(true);
  ObjSet( "spr_wincards_prv_stairs", { alp = 0 } );
  ObjAnimate( "spr_wincards_prv_stairs_used", "alp", 0, 0, func_after, { 0, 0, 0, 0.1, 0, 0, 0.3, 0, 1 } );

end;
--------------------------------------------------------------------------------------------
function private.clk_button_1()

  cmn.CallEventHandler( "clk_button_1_beg" );

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_button_1" );
    cmn.CallEventHandler( "clk_button_1_end" );
  
  end;
  
  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_button", 0, "", 0 );

    ObjAnimate( "spr_drawercabinet_button1", "pos_xy", 0, 0, func_after,
    { 
      0.0, 0, 48, 62, 
      0.3, 0, 44, 59,
      0.6, 0, 44, 59,
    } );
    ObjAnimate( "spr_drawercabinet_button1", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 1.0,
      0.6, 0, 0.0
    } );
    ObjAnimate( "spr_drawercabinet_button1_shadow", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 0.0
    } );
    ObjAnimate( "spr_drawercabinet_button1_overlap", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 1.0,
      0.6, 0, 0.0
    } );
    ObjAnimate( "obj_drawercabinet_box1", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.0,
      0.6, 0, 1.0
    } );
  

end;
--------------------------------------------------------------------------------------------
function private.clk_button_2()

  cmn.CallEventHandler( "clk_button_2_beg" );

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_button_2" );
    cmn.CallEventHandler( "clk_button_2_end" );
  
  end;
  
  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_button", 0, "", 0 );

    ObjAnimate( "spr_drawercabinet_button2", "pos_xy", 0, 0, func_after,
    { 
      0.0, 0, 36, -119, 
      0.3, 0, 32, -119,
      0.6, 0, 32, -119,
    } );
    ObjAnimate( "spr_drawercabinet_button2", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 1.0,
      0.6, 0, 0.0
    } );
    ObjAnimate( "spr_drawercabinet_button2_overlap", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 1.0,
      0.6, 0, 0.0
    } );
    ObjAnimate( "spr_drawercabinet_button2_shadow", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 1.0,
      0.6, 0, 0.0
    } );
    ObjAnimate( "obj_drawercabinet_box2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 0.0,
      0.6, 0, 1.0
    } );

end;
--------------------------------------------------------------------------------------------
function private.anim_providence( func_execute )

  common_impl.ShowBbt( "bbt_providence_allitems" );

  int_button_providence.StopActiveProvidence();

  local array_objects = {
    "spr_wincards_prv_stairs_used",
    "spr_wincards_prv_fuellamp_used",
    "spr_wincards_prv_handcuffs_used",
    "spr_wincards_prv_armchair_used" }

  local func_end = function()

    for i = 1, #array_objects do
      ObjAttach( array_objects[ i ], "rm_wincards_providence" );
      ObjSet( array_objects[ i ], { alp = 1 } );
    end;
    common_impl.Lock( false );    
    private.vid_wincards_providence( func_execute );

  end;
  
  common_impl.Lock( true );
  for i = 1, #array_objects do
    common_impl.PlayEffectHO( array_objects[ i ], func_end, 3, "assets/interface/resources/effect_mask" );
    func_end = nil;
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_providence_ready", 0, "", 0 );

end;
-------------------------------------------------------------------------------------
function private.drag_armchair ()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_wincards_prv_armchair", { pos_z = 10 } );

end;
-------------------------------------------------------------------------------------
function private.drop_armchair ()

  local item = "spr_wincards_prv_armchair";

  ObjSet( item, { pos_z = 0 } );

  if ( ObjIntersect( item, "obj_wincards_prv_item_1" ) ) then

    private.clk_providence_armchair();

  end;

end;
-------------------------------------------------------------------------------------
function private.drag_stairs ()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_wincards_prv_stairs", { pos_z = 10 } );

  ObjSet( "spr_wincards_prv_stairs_mirror", { visible = false } );

end;
-------------------------------------------------------------------------------------
function private.drop_stairs ()

  local item = "spr_wincards_prv_stairs";

  ObjSet( item, { pos_z = 0 } );

  if ( ObjIntersect( item, "obj_wincards_prv_item_2" ) ) then

    private.clk_providence_stairs();

  else 

    ObjSet( "spr_wincards_prv_stairs_mirror", { visible = true } );

  end;

end;
--*********************************************************************************************************************
function private.vid_wincards_providence( func_execute )

  interface.BBTHide();

  private.func_providence = func_execute;

  int_button_providence.StopLightProvidence();
  
  common_impl.StopAllMus();
  common_impl.PlayAudio( "sfx", "common/audio/aud_wincards_providence_p1", 0, "", 0 );
  common_impl.PlayAudio( "mus", "common/audio/aud_providence_mus", 1, "", 0.5 ); 

  VidPlay( "vid_wincards_providence_p1", "" ); 
  interface.DialogVideoShow( "vid_wincards_providence", 1, function() private.vid_wincards_providence_end(); end , 3, 4 ); 

end;

function private.vid_wincards_providence_end( )

  local func_after = function ()

    common_impl.Lock( false );

    cmn.SetEventDone( "vid_wincards_providence" );
    cmn.CallEventHandler( "vid_wincards_prv_end" );

    common_impl.ShowBbt( 'bbt_providence_level3_3_end' );

    if ( private.func_providence ) then

      private.func_providence();
      private.func_providence = nil;

    end;
    
  end; 
  
  common_impl.StopAudio( "mus", "common/audio/aud_providence_mus", 1 ); 
  common_impl.StopAudio( "sfx", "common/audio/aud_wincards_providence_p4", 0.2 ); 
  common_impl.PlayAudio( "mus", "common/audio/aud_enigma_mus", 0, "", 0 );
 
  ObjAnimate( private.room_objname, "scale_xy", 0, 0, "",
    { 
      0.0, 1, 1.0,1.0, 
      1.0, 1, 1.3,1.3,
      1.4, 3, 1.3,1.3,
      2.4, 3, 1.0,1.0
    } );
    
    ObjAnimate( private.room_objname, "pos_xy", 0, 0, func_after,
    { 
      0.0, 1, 0.0,0.0, 
      1.0, 1, -350,-50,
      1.4, 3, -350,-50,
      2.4, 3, 0,0
    } );

    local tmr_after = function()

      common_impl.PlayAudio( "sfx", "common/audio/aud_zoom_out", 0, "", 0 );

    end;

    ObjSet( "tmr_wincards_zoomout_snd", { playing = true, time = 1.4, endtrig = tmr_after } ); 

    int_providence.Hide();
    interface.DialogVideoHide();

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.After_use_all_gears ()

  ObjMultiSet({ 

    { "spr_winetable_ring",     { input = true, pos_x = 25, pos_y = 136 }},
    { "gfx_winetable_ring",     { active = true    }},
    { "spr_winetable_ring_sh", { alp = 1 } },
    { "spr_wincards_winetable_ring", { pos_y = 501 } },
    { "anm_table_owl", { frame = 151 } },
  
});

end;
--*********************************************************************************************************************
function private.opn_wincards()

  if not ( cmn.IsEventDone( "opn_wincards" ) ) then
    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment3_mus", 0, "", 0 );
    cmn.SetEventDone( "opn_wincards" );
  end;
  
  cmn.CallEventHandler( "opn_wincards" ); 

end;
--*********************************************************************************************************************
function private.PlayAnimOwl( endfunc )

  local func_end = function ()

    if ( endfunc ) then

      common_impl.Lock( false ); 

      endfunc();

    end;     

    --ObjAnimate( "spr_winetable_ring", "pos_xy", 0, 0, func_after, { 0, 1, -20, -27, 1, 1, -18, 149 } );
    --ObjAnimate( "spr_winetable_ring_sh", "alp", 0, 0, "", { 0, 0, 0, 0.7, 0, 0, 1, 0, 1 } );

  end;
  
  local func_after = function ()
    
    ObjSet( "spr_winetable_ring", { alp = 1, pos_x = 25, pos_y = 136 } );
    ObjDelete( "tmr_table_anim_ring" );

  end;

  ObjCreate( "tmr_table_anim_ring", "timer" );  
  ObjAttach( "tmr_table_anim_ring", "zz_winetable" );
  ObjSet( "tmr_table_anim_ring", { playing = true, time = 2.4999, endtrig = func_after } )

  common_impl.Lock( true );
  ObjSet( "spr_winetable_ring", { alp = 0 } );
  ObjSet( "obj_table_owl", { alp = 0 } );
  ObjSet( "anm_table_owl", { alp = 1 } );
  AnimPlay( "anm_table_owl", "DoAnim", func_end );
 
  common_impl.PlayAudio( "sfx", "common/audio/aud_owl_gears_anim", 0, "", 0 );

end;
--*********************************************************************************************************************
