-- name=ho_pharmacybit
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "pharmacybit" );
  game.relations[ "ho_pharmacybit" ].exitroom = "rm_livingroom_4";
  --------------------------------------------------------------------------------------------------
  
  ObjMultiSet( {
   
  { "spr_pharmacybit_abacus", { event_mdown = function() private.TaskComplete( 'abacus', 4 ) end } },
  { "spr_pharmacybit_ginger_root", { event_mdown = function() private.TaskComplete( 'ginger_root', 4 ) end } },
  { "spr_pharmacybit_pipette", { event_mdown = function() private.TaskComplete( 'pipette', 4 ) end } },
  { "spr_pharmacybit_plummet", { event_mdown = function() private.TaskComplete( 'plummet', 3 ) end } },
  { "spr_pharmacybit_scoop", { event_mdown = function() private.TaskComplete( 'scoop', 3 ) end } },
  { "spr_pharmacybit_directory", { event_mdown = function() private.TaskComplete( 'directory', 3 ) end } },
  { "spr_pharmacybit_warner", { event_mdown = function() private.TaskComplete( 'warner', 2 ) end } },
  { "spr_pharmacybit_formula", { event_mdown = function() private.TaskComplete( 'formula', 2 ) end } },
  { "spr_pharmacybit_scissors", { event_mdown = function() private.TaskComplete( 'scissors', 2 ) end } },
  { "spr_pharmacybit_stethoscope", { event_mdown = function() private.TaskComplete( 'stethoscope', 1 ) end } },
  { "spr_pharmacybit_syringe", { event_mdown = function() private.TaskComplete( 'syringe', 1 ) end } },
  { "spr_pharmacybit_thermometer", { event_mdown = function() private.TaskComplete( 'thermometer', 1 ) end } },
  { "spr_pharmacybit_weezers", { event_mdown = function() private.TaskComplete( 'weezers' ) end } },
  { "spr_pharmacybit_taskpanel_crystal_1", { event_startdrag = function() private.GetCrystal( 1 ) end ,event_dragdrop = function() private.UseItem( 1 ) end } },
  { "spr_pharmacybit_taskpanel_crystal_2", { event_startdrag = function() private.GetCrystal( 2 ) end ,event_dragdrop = function() private.UseItem( 2 ) end } },
  { "spr_pharmacybit_taskpanel_crystal_3", { event_startdrag = function() private.GetCrystal( 3 ) end ,event_dragdrop = function() private.UseItem( 3 ) end } },
  { "spr_pharmacybit_taskpanel_crystal_4", { event_startdrag = function() private.GetCrystal( 4 ) end ,event_dragdrop = function() private.UseItem( 4 ) end } }  
  
  } );
  
  --*************************************
  --------------------------------------------------------------------------------------------------
  private.taskpanel = 
  {
    { "spr_pharmacybit_stethoscope",  "spr_pharmacybit_syringe",      "spr_pharmacybit_thermometer" },
    { "spr_pharmacybit_warner",       "spr_pharmacybit_formula",      "spr_pharmacybit_scissors" },
    { "spr_pharmacybit_plummet",      "spr_pharmacybit_scoop",        "spr_pharmacybit_directory" },
    { "spr_pharmacybit_abacus",       "spr_pharmacybit_ginger_root",  "spr_pharmacybit_pipette" }
  }
  --------------------------------------------------------------------------------------------------

  common_impl.hint[ "win_pharmacybit" ] = {
      type = "win",
      room = "rm_livingroom_4",
      zz = "ho_pharmacybit",
      zz_gate = "gho_livingroom_4_pharmacybit"
  };
  local win_pharmacybit_func = function ()

    if ( cmn.IsEventDone( "win_pharmacybit" ) ) then
      interface.InventoryItemAdd( "inv_tweezers_4", "spr_pharmacybit_win" );
      ObjDelete( "gho_livingroom_4_pharmacybit" );
    end;

  end;

  --------------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_pharmacybit", win_pharmacybit_func );
  --------------------------------------------------------------------------------------------------

  local win_pharmacybit_func = function ()

    local table_multiset = {};
    if ( not cmn.IsEventDone( "win_stock" ) ) then

      local ho_progress = ng_global.progress[ "ext" ][ "win_pharmacybit" ];
      for key, value in pairs( private.taskpanel ) do

        local flag_complete = true;
        for i = 1, #private.taskpanel[ key ] do

          if ( not ho_progress.items[ private.taskpanel[ key ][ i ] ] ) then
            flag_complete = false;
            break;
          end;

        end;

        if ( ho_progress.parts[ key ] )then
          
          ObjDelete( "obj_pharmacybit_taskpanel_crystal_"..key );
                   
          table.insert( table_multiset, { "spr_pharmacybit_used_crystal_"..key, { alp = 1 } } );
                
        elseif ( flag_complete ) then

          table.insert( table_multiset, { "spr_pharmacybit_taskpanel_crystal_"..key, { input = true } } );
          table.insert( table_multiset, { "spr_pharmacybit_used_crystal_"..key.."_hint", { input = true } } );         
          ObjDelete( "spr_pharmacybit_taskpanel_part_crystal_"..key );         
         
        end;

      end;

      if private.CheckWeezers() == true then

        table.insert( table_multiset, { "spr_pharmacybit_weezers", { input = true } } );
        table.insert( table_multiset, { "txt_pharmacybit_taskpanel", { alp = 1 } } );
        table.insert( table_multiset, { "spr_pharmacybit_weezers", { pos_x = 439, pos_y = 471 } } );

      end;

      for j = 1, #ng_global.progress["ext"]["win_pharmacybit"].found do

        local name = tostring( ng_global.progress[ "ext" ][ "win_pharmacybit" ].found[ j ][ "task" ] );
       
        ObjDelete( "spr_pharmacybit_taskpanel_"..name.."_pro" );
        ObjDelete( "spr_pharmacybit_"..name );
        ObjDelete( "spr_pharmacybit_"..name.."_shadow" );

      end;

    end;
    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset )
    end;

  end;
  --------------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "win_pharmacybit", win_pharmacybit_func, "ho_pharmacybit" );
  --------------------------------------------------------------------------------------------------
  local start_pharmacybit_func = function ()

    if ( cmn.IsEventStart( "win_pharmacybit" ) ) then
     
      local ho_found = ng_global.progress[ "ext" ][ "win_pharmacybit" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
        ObjDelete( ho_found[ i ][ "object" ].."_shadow" );
      end; 

    end;

  end;
  cmn.AddSubscriber( "win_pharmacybit", start_pharmacybit_func, "ho_pharmacybit" );  
  --------------------------------------------------------------------------------------------
  -- function opn_pharmacybit () end;
  --------------------------------------------------------------------------------------------
  local opn_pharmacybit = function ()

    --

  end;

  cmn.AddSubscriber( "opn_pharmacybit", opn_pharmacybit, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()
  
  int_slider.InitSlider( "ho_pharmacybit" );
  if ( not cmn.IsEventDone( "opn_pharmacybit" ) ) then
  
    cmn.InitHo( "pharmacybit" );
    cmn.SetEventDone( "opn_pharmacybit" );

    ng_global.progress["ext"]["win_pharmacybit"].items = {};
    ng_global.progress["ext"]["win_pharmacybit"].parts = {};
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "stethoscope",          1, 0, { { "spr_pharmacybit_stethoscope" } } );
  interface.TaskPanelTaskAdd( ho_items, "syringe",          1, 0, { { "spr_pharmacybit_syringe" } } );
  interface.TaskPanelTaskAdd( ho_items, "thermometer",          1, 0, { { "spr_pharmacybit_thermometer" } } );
  interface.TaskPanelTaskAdd( ho_items, "warner",          1, 0, { { "spr_pharmacybit_warner" } } );
  interface.TaskPanelTaskAdd( ho_items, "formula",          1, 0, { { "spr_pharmacybit_formula" } } );
  interface.TaskPanelTaskAdd( ho_items, "scissors",          1, 0, { { "spr_pharmacybit_scissors" } } );
  interface.TaskPanelTaskAdd( ho_items, "plummet",          1, 0, { { "spr_pharmacybit_plummet" } } );
  interface.TaskPanelTaskAdd( ho_items, "scoop",          1, 0, { { "spr_pharmacybit_scoop" } } );
  interface.TaskPanelTaskAdd( ho_items, "directory",          1, 0, { { "spr_pharmacybit_directory" } } );
  interface.TaskPanelTaskAdd( ho_items, "abacus",          1, 0, { { "spr_pharmacybit_abacus" } } );
  interface.TaskPanelTaskAdd( ho_items, "ginger_root",          1, 0, { { "spr_pharmacybit_ginger_root" } } );
  interface.TaskPanelTaskAdd( ho_items, "pipette",          1, 0, { { "spr_pharmacybit_pipette" } } );

  interface.TaskPanelTaskAdd( ho_items, "crystal_1",          1, 0, { { "spr_pharmacybit_taskpanel_crystal_1", "spr_pharmacybit_used_crystal_1_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "crystal_2",          1, 0, { { "spr_pharmacybit_taskpanel_crystal_2", "spr_pharmacybit_used_crystal_2_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "crystal_3",          1, 0, { { "spr_pharmacybit_taskpanel_crystal_3", "spr_pharmacybit_used_crystal_3_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "crystal_4",          1, 0, { { "spr_pharmacybit_taskpanel_crystal_4", "spr_pharmacybit_used_crystal_4_hint" } } );

  interface.TaskPanelTaskAdd( ho_items, "weezers",          1, 0, { { "spr_pharmacybit_weezers" } } );

  interface.TaskPanelShow( ho_items );

  int_taskpanel_impl.HideTextPanel( "pharmacybit" );
 
  ObjSet( "obj_pharmacybit_taskpanel", { visible = true, input = true, pos_z = 1, pos_x = -190, pos_y = 37 } );  
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Open()
  
  common_impl.VisitMapRoom( "livingroom" );
  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  common_impl.PassingHoStop();
 
end;
--*********************************************************************************************************************
function public.Close()

  int_taskpanel_impl.ShowTextPanel( "pharmacybit" );
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 1 );

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();
  
end;
-------------------------------------------------------------------------
function private.check_task( obj, part )

  local ho_progress = ng_global.progress[ ng_global.currentprogress ][ "win_pharmacybit" ];
  
  ho_progress.items[ obj ] = true;
  local flag_complete = true;
  for i = 1, #private.taskpanel[ part ] do

    if ( not ho_progress.items[ private.taskpanel[ part ][ i ] ] ) then

      flag_complete = false;
      break;

    end;

  end;

  if ( flag_complete ) then    
    
    local func_after = function()
    
      --common_impl.Lock(false);

      ObjSet( "spr_pharmacybit_taskpanel_crystal_"..part, { input = true } );
      ObjSet( "spr_pharmacybit_used_crystal_"..part.."_hint", { input = true } );      

    end;

    --common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_ho_panel_off", 0, "", 0 );

    ObjAnimate( "spr_pharmacybit_taskpanel_part_crystal_"..part, "pos_y", 0, 0, func_after, { 0,0,10, 1.0,0,110 } );
 
  end;
  
end;

--*********************************************************************************************************************
function private.TaskComplete( task_name, part )
 
  local object = "spr_pharmacybit_"..task_name;
 
  ObjSet( object, { pos_z = 1 } );
  ObjDelete( object.."_shadow" );

  cmn.HoTaskFind( object, task_name );

  if part then

    private.check_task( "spr_pharmacybit_"..task_name, part )   

    ObjAnimate( "spr_pharmacybit_taskpanel_"..task_name.."_pro", "alp", 0, 0, func_after, { 0,3,1,  0.8,3,0 } );

  end;
  
end;
--*********************************************************************************************************************
-------------------------------------------------------------------------------------
function private.GetCrystal( number )

  common_impl.SetCursor( CURSOR_NULL );

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  local item = "obj_pharmacybit_taskpanel_crystal_"..number;
  
  ObjSet( item, { pos_z = 5 } );

end;
-------------------------------------------------------------------------------------
function private.UseItem( number )

  local item = "spr_pharmacybit_taskpanel_crystal_"..number;
  
  if ( ObjIntersect( item, "obj_pharmacybit_use_crystal" ) ) then

    ObjDelete( item );
    
    common_impl.SetCursor( CURSOR_DEFAULT );

    local func_after = function()

      common_impl.Lock(false);
      cmn.HoTaskFind( "spr_pharmacybit_used_crystal_"..number.."_hint", "crystal_"..number, true );
      ng_global.progress[ ng_global.currentprogress ][ "win_pharmacybit" ].parts[ number ] = true;

      if private.CheckWeezers() == true then

        private.drop_tweezers();
       
      end;
    
    end;

    common_impl.Lock(true);

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_crystal", 0, "", 0 );
  
    ObjAnimate( "spr_pharmacybit_used_crystal_"..number, "alp", 0, 0, func_after, 
    { 
      0.0,  0,  0,
      0.3,  0,  1
    } );      
  
  else

    ObjSet( "obj_pharmacybit_taskpanel_crystal_"..number, { pos_z = 1 } );
   
  end;

end;
-------------------------------------------------------------------------------------
function private.CheckWeezers()

  local counter = 0;

  for i = 1, #ng_global.progress[ ng_global.currentprogress ][ "win_pharmacybit" ].parts do

    if ng_global.progress[ ng_global.currentprogress ][ "win_pharmacybit" ].parts[i] == true then

      counter = counter + 1;

    else

      return false;

    end;   

  end;

  if counter == 4 then

    return true;
  
  end;

end;
----------------------------------------------------------------------------
function private.drop_tweezers()
  
  local endfunc = function ()

    ObjSet( "spr_pharmacybit_weezers", { input = true } );
    ObjSet( "txt_pharmacybit_taskpanel", { alp = 1 } );  

  end;
  common_impl.PlayAudio( "sfx", "common/audio/aud_win_crystal", 0, "", 0 );
  ObjDelete( "obj_pharmacybit_use_crystal" );
  ObjAnimate( "spr_pharmacybit_weezers", "pos_xy", 0, 0, endfunc, { 0.0, 1, 453, 108, 
                                                                    1.0, 1, 439, 471});
end;
