-- name=ho_rucksack
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "rucksack" );
  game.relations[ "ho_rucksack" ].exitroom = "rm_sheriffshouse_4";
  --------------------------------------------------------------------------------------------------
  
  ObjMultiSet( {
    { "spr_rucksack_apple",           { event_mdown = function() private.TaskComplete( 'apple' )           end } },
    { "spr_rucksack_bicyclebell",     { event_mdown = function() private.TaskComplete( 'bicyclebell' )     end } },
    { "spr_rucksack_bow_tie",         { event_mdown = function() private.TaskComplete( 'bow_tie' )         end } },
    { "spr_rucksack_candy",           { event_mdown = function() private.TaskComplete( 'candy' )           end } },
    { "spr_rucksack_colored_pencils", { event_mdown = function() private.TaskComplete( 'colored_pencils' ) end } },
    { "spr_rucksack_fork",            { event_mdown = function() private.TaskComplete( 'fork' )            end } },
    { "spr_rucksack_matches",         { event_mdown = function() private.TaskComplete( 'matches' )         end } },
    { "spr_rucksack_penknife",        { event_mdown = function() private.TaskComplete( 'penknife' )        end } },
    { "spr_rucksack_post_stamp",      { event_mdown = function() private.TaskComplete( 'post_stamp' )      end } },
    { "spr_rucksack_ruler",           { event_mdown = function() private.TaskComplete( 'ruler' )           end } },
    { "spr_rucksack_slingshot",       { event_mdown = function() private.TaskComplete( 'slingshot' )       end } },
    { "spr_rucksack_artifact",        { event_mdown = function() private.TaskComplete( 'artifact' )       end } },
  } );
  
  common_impl.hint[ "win_rucksack" ] = {
      type = "win",
      room = "rm_sheriffshouse_4",
      zz = "ho_rucksack",
      zz_gate = "gho_sheriffshouse_4_rucksack"
  };
  
  local win_rucksack_func = function ()

    if ( cmn.IsEventDone( "win_rucksack" ) ) then

      interface.InventoryItemAdd( "inv_artifact", "spr_rucksack_win" );
      ObjSet( "inv_artifact", { drag = false } );
      ObjDelete( "gho_sheriffshouse_4_rucksack" );

    end;

  end;
  cmn.AddSubscriber( "win_rucksack", win_rucksack_func );
  --------------------------------------------------------------------------------------------------
  local start_rucksack_func = function ()

    if ( cmn.IsEventStart( "win_rucksack" ) ) then

      local ho_found = ng_global.progress[ "ext" ][ "win_rucksack" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
        -------------------------------------------------------------
        if ( tostring(ho_found[ i ][ "task" ]) == 'bicyclebell' or 
             tostring(ho_found[ i ][ "task" ]) == 'bow_tie'     or 
             tostring(ho_found[ i ][ "task" ]) == 'candy'       or 
             tostring(ho_found[ i ][ "task" ]) == 'slingshot'  
           ) then
          ObjDelete( ho_found[ i ][ "object" ].."_shadow" );
        end;
        -------------------------------------------------------------
      end;

    end;

  end;
  cmn.AddSubscriber( "win_rucksack", start_rucksack_func, "ho_rucksack" );  

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  int_slider.InitSlider( "ho_rucksack" );
  if ( not cmn.IsEventDone( "opn_rucksack" ) ) then
  
    cmn.InitHo( "rucksack" );
    cmn.SetEventDone( "opn_rucksack" );
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "apple",            1, 0, { { "spr_rucksack_apple"           } } );
  interface.TaskPanelTaskAdd( ho_items, "bicyclebell",      1, 0, { { "spr_rucksack_bicyclebell"     } } );
  interface.TaskPanelTaskAdd( ho_items, "bow_tie",          1, 0, { { "spr_rucksack_bow_tie"         } } );
  interface.TaskPanelTaskAdd( ho_items, "candy",            1, 0, { { "spr_rucksack_candy"           } } );
  interface.TaskPanelTaskAdd( ho_items, "colored_pencils",  1, 0, { { "spr_rucksack_colored_pencils" } } );
  interface.TaskPanelTaskAdd( ho_items, "fork",             1, 0, { { "spr_rucksack_fork"            } } );
  interface.TaskPanelTaskAdd( ho_items, "matches",          1, 0, { { "spr_rucksack_matches"         } } );
  interface.TaskPanelTaskAdd( ho_items, "penknife",         1, 0, { { "spr_rucksack_penknife"        } } );
  interface.TaskPanelTaskAdd( ho_items, "post_stamp",       1, 0, { { "spr_rucksack_post_stamp"      } } );
  interface.TaskPanelTaskAdd( ho_items, "ruler",            1, 0, { { "spr_rucksack_ruler"           } } );
  interface.TaskPanelTaskAdd( ho_items, "slingshot",        1, 0, { { "spr_rucksack_slingshot"       } } );
  interface.TaskPanelTaskAdd( ho_items, "artifact",         1, 0, { { "spr_rucksack_artifact"        } } );
  interface.TaskPanelShow( ho_items );

  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Open()
  
  common_impl.VisitMapRoom( "sheriffshouse" );
  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 1 );

end;
--*********************************************************************************************************************
function public.Close()

  common_impl.PassingHoStop();

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();
  
end;
--**************************************************************************************************************
function private.TaskComplete( task_name, object_name )
 
  local object = "";

  if object_name then

    object = tostring( object_name );

  else

    object = "spr_rucksack_"..task_name;

  end;
 
  ObjSet( object, { pos_z = 1 } );
  cmn.HoTaskFind( object, task_name );

  ------------------------------------------------------
  if ( task_name == 'bicyclebell' or 
       task_name == 'bow_tie'     or 
       task_name == 'candy'       or 
       task_name == 'slingshot'  
     ) then
    ObjDelete( "spr_rucksack_"..task_name.."_shadow" );
  end;
  ------------------------------------------------------

end;
--*********************************************************************************************************************