-- name=ho_wagonette
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "wagonette" );
  game.relations[ "ho_wagonette" ].exitroom = "rm_swamp";
  --------------------------------------------------------------------------------------------------
  
  ObjMultiSet( {
  
  { "spr_wagonette_hat_1", { event_mdown = function() private.TaskComplete( 'hat_1', 1 ) end } },
  { "spr_wagonette_hat_2", { event_mdown = function() private.TaskComplete( 'hat_2', 1 ) end } },
  { "spr_wagonette_hat_3", { event_mdown = function() private.TaskComplete( 'hat_3', 1 ) end } },
  { "spr_wagonette_hat_4", { event_mdown = function() private.TaskComplete( 'hat_4', 1 ) end } },
  { "spr_wagonette_musical_horn_1", { event_mdown = function() private.TaskComplete( 'musical_horn_1', 2 ) end } },
  { "spr_wagonette_musical_horn_2", { event_mdown = function() private.TaskComplete( 'musical_horn_2', 2 ) end } },
  { "spr_wagonette_musical_horn_3", { event_mdown = function() private.TaskComplete( 'musical_horn_3', 2 ) end } },
  { "spr_wagonette_musical_horn_4", { event_mdown = function() private.TaskComplete( 'musical_horn_4', 2 ) end } },
  { "spr_wagonette_picture_1", { event_mdown = function() private.TaskComplete( 'picture_1', 3 ) end } },
  { "spr_wagonette_picture_2", { event_mdown = function() private.TaskComplete( 'picture_2', 3 ) end } },
  { "spr_wagonette_picture_3", { event_mdown = function() private.TaskComplete( 'picture_3', 3 ) end } },
  { "spr_wagonette_picture_4", { event_mdown = function() private.TaskComplete( 'picture_4', 3 ) end } },
  { "spr_wagonette_toad_1", { event_mdown = function() private.TaskComplete( 'toad_1', 4 ) end } },  
  { "spr_wagonette_toad_2", { event_mdown = function() private.TaskComplete( 'toad_2', 4 ) end } },
  { "spr_wagonette_toad_3", { event_mdown = function() private.TaskComplete( 'toad_3', 4 ) end } },
  { "spr_wagonette_toad_4", { event_mdown = function() private.TaskComplete( 'toad_4', 4 ) end } },
  { "spr_wagonette_sticks", { event_mdown = function() private.HoComplete() end } },
  { "spr_wagonette_chest_closed", { event_mdown = function() common_impl.ShowBbt( 'bbt_wagonnete_use_chestpiece', 1 ) end } },
  } );

  private.taskpanel = { 'hat', 'musical_horn', 'picture', 'toad' };
  --*************************************
  
  common_impl.hint[ "win_wagonette" ] = {
      type = "win",
      room = "rm_swamp",
      zz = "ho_wagonette",
      zz_gate = "gho_swamp_wagonette"
  };
  
  local win_wagonette_func = function ()

    if ( cmn.IsEventDone( "win_wagonette" ) ) then
      interface.InventoryItemAdd( "inv_bowdrill", "spr_wagonette_win" );
      ObjDelete( "gho_swamp_wagonette" );
    end;

  end;
  cmn.AddSubscriber( "win_wagonette", win_wagonette_func );
  --------------------------------------------------------------------------------------------------
  local start_wagonette_func = function ()

    if ( cmn.IsEventStart( "win_wagonette" ) ) then

      local ho_found = ng_global.progress[ "ext" ][ "win_wagonette" ].found;

      for i = 1, #ho_found, 1 do
        ObjDelete( ho_found[ i ][ "object" ] );
      end;

    end;

  end;
  cmn.AddSubscriber( "win_wagonette", start_wagonette_func, "ho_wagonette" );  
  --------------------------------------------------------------------------------------------
  -- function opn_wagonette () end;
  --------------------------------------------------------------------------------------------
  local opn_wagonette = function ()

    --

  end;

  cmn.AddSubscriber( "opn_wagonette", opn_wagonette, private.room_objname );


end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  int_slider.InitSlider( "ho_wagonette" );
  if ( not cmn.IsEventDone( "opn_wagonette" ) ) then
  
    cmn.InitHo( "wagonette" );
    cmn.SetEventDone( "opn_wagonette" );
    ng_global.progress["ext"]["win_wagonette"].task_count = { 0, 0, 0, 0 };
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "hat_1",                  1, 0, { { "spr_wagonette_hat_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "hat_2",                  1, 0, { { "spr_wagonette_hat_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "hat_3",                  1, 0, { { "spr_wagonette_hat_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "hat_4",                  1, 0, { { "spr_wagonette_hat_4" } } );
  interface.TaskPanelTaskAdd( ho_items, "musical_horn_1",         1, 0, { { "spr_wagonette_musical_horn_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "musical_horn_2",         1, 0, { { "spr_wagonette_musical_horn_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "musical_horn_3",         1, 0, { { "spr_wagonette_musical_horn_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "musical_horn_4",         1, 0, { { "spr_wagonette_musical_horn_4" } } );
  interface.TaskPanelTaskAdd( ho_items, "picture_1",              1, 0, { { "spr_wagonette_picture_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "picture_2",              1, 0, { { "spr_wagonette_picture_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "picture_3",              1, 0, { { "spr_wagonette_picture_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "picture_4",              1, 0, { { "spr_wagonette_picture_4" } } );
  interface.TaskPanelTaskAdd( ho_items, "toad_1",                 1, 0, { { "spr_wagonette_toad_1" } } );
  interface.TaskPanelTaskAdd( ho_items, "toad_2",                 1, 0, { { "spr_wagonette_toad_2" } } );
  interface.TaskPanelTaskAdd( ho_items, "toad_3",                 1, 0, { { "spr_wagonette_toad_3" } } );
  interface.TaskPanelTaskAdd( ho_items, "toad_4",                 1, 0, { { "spr_wagonette_toad_4" } } );
  interface.TaskPanelTaskAdd( ho_items, "sticks",                 1, 0, { { "spr_wagonette_chest_closed", "spr_wagonette_chestpiece" }, { "spr_wagonette_sticks" } } );
  interface.TaskPanelShow( ho_items );

  int_taskpanel_impl.HideTextPanel( "wagonette" );
 
  ObjSet( "obj_wagonette_taskpanel", { visible = true, input = true, pos_z = 1, pos_x = 0, pos_y = 37 } );  
  
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

  local table_multiset = {};
  table.insert( table_multiset, { "spr_wagonette_chestpiece", 
    {
      event_startdrag = function() private.GetItem() end, 
      event_dragdrop = function() private.UsePiece() end } }
    );

  for i = 1, 4 do

    if ng_global.progress["ext"]["win_wagonette"].task_count[i] ~= 4 then

       table.insert( table_multiset, { "txt_wagonette_taskpanel", { text = 'str_wagonette_taskpanel_'..i, param0 = 4 - ng_global.progress["ext"]["win_wagonette"].task_count[i] } } );

       for j = 1, 4 do

         if private.IsFound( private.taskpanel[i].."_"..j ) ~= true then

            table.insert( table_multiset, { "spr_wagonette_"..private.taskpanel[i].."_"..j, { input = true } } );

         end;
      
       end;

       break;

    end;

  end;

  if ng_global.progress["ext"]["win_wagonette"].task_count[4] == 4 then

    if ng_global.progress["ext"]["win_wagonette"].task_count[5] == 1 then

      ObjSet( "obj_wagonette_chest_opened", { input = true , alp = 1 } );
      table.insert( table_multiset, { "spr_wagonette_sticks", { input = true } } );
      ObjDelete( "spr_wagonette_chest_closed" );
      ObjDelete( "spr_wagonette_chestpiece" );
      table.insert( table_multiset, { "txt_wagonette_taskpanel", { text = 'str_wagonette_taskpanel_bow' } } );

    else

      ObjSet( "spr_wagonette_chestpiece", { input = true } );
      table.insert( table_multiset, { "txt_wagonette_taskpanel", { text = 'str_wagonette_taskpanel_chest' } } );
      table.insert( table_multiset, { "spr_wagonette_chest_closed", { input = true } } );

    end;

  end;

  if ( #table_multiset > 0 ) then
     ObjMultiSet( table_multiset )
  end;  

end;
--*********************************************************************************************************************
function public.Open()
  
 -- common_impl.VisitMapRoom( "swamp" );
  common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.Close()

  common_impl.PassingHoStop();
  int_taskpanel_impl.ShowTextPanel( "wagonette" );

end;
--*********************************************************************************************************************
function public.PreClose()
 
  interface.TaskPanelHide();
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus",  0.5 );

end;
--*********************************************************************************************************************
function public.HoComplete()

  common_impl.PassingHoWin();
  
end;
--*********************************************************************************************************************
function private.IsFound( task_name )

  local task_name = tostring( task_name );

  local ho_found = ng_global.progress[ "ext" ][ "win_wagonette" ].found;
  local task_found = false;
        
        for i = 1, #ho_found, 1 do
          
          local task = ho_found[ i ][ "task" ];

          if task == task_name then
             task_found = true;
             break;
          end;

        end;

   return task_found;  

end;
--*********************************************************************************************************************
function private.TaskComplete( task_name, task_number )
 
  local object = "spr_wagonette_"..task_name;
 
  ObjSet( object, { pos_z = 1 } );

  cmn.HoTaskFind( object, task_name );

  local table_multiset = {};

  ng_global.progress["ext"]["win_wagonette"].task_count[task_number] = ng_global.progress["ext"]["win_wagonette"].task_count[task_number] + 1;

  table.insert( table_multiset, { "txt_wagonette_taskpanel", { param0 = 4 -  ng_global.progress["ext"]["win_wagonette"].task_count[task_number] } } );

  if ng_global.progress["ext"]["win_wagonette"].task_count[task_number] == 4 and task_number ~= 4 then

    for i = 1, 4 do

      table.insert( table_multiset, { "spr_wagonette_"..private.taskpanel[task_number+1].."_"..i, { input = true } } );

    end;

    local func_after = function()

     ObjSet( "txt_wagonette_taskpanel", { text = 'str_wagonette_taskpanel_'..( task_number + 1 ), param0 = 4 }  );

      ObjAnimate( "int_taskpanel_impl", "pos_y", 0, 0, function() common_impl.Lock( false ); end,
    {
      0.0, 2, 888,
      0.2, 2, 888,
      0.8, 2, 688
    } );

    end;

    common_impl.Lock( true );

      ObjSet( "txt_wagonette_taskpanel", { text = " " }  );

      ObjAnimate( "int_taskpanel_impl", "pos_y", 0, 0, func_after,
    {
      0.0, 2, 688,
      0.6, 2, 888
    } );

  elseif ng_global.progress["ext"]["win_wagonette"].task_count[task_number] == 4 and task_number == 4 then

    table.insert( table_multiset, { "spr_wagonette_chestpiece", { input = true } } );
    table.insert( table_multiset, { "txt_wagonette_taskpanel", { text = 'str_wagonette_taskpanel_chest' } } );
    table.insert( table_multiset, { "spr_wagonette_chest_closed", { input = true } } );

  end;

   if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset )
   end;   

end;
--*********************************************************************************************************************
function private.UsePiece( )

  if ( common.ApplyObj( "spr_wagonette_chestpiece", "spr_wagonette_chest_closed" ) ) then

    local func_after = function()

      common_impl.Lock( false );
      local table_multiset = {}
      ng_global.progress["ext"]["win_wagonette"].task_count[5] = 1;
      table.insert( table_multiset, { "txt_wagonette_taskpanel", { text = 'str_wagonette_taskpanel_bow' } } );
      table.insert( table_multiset, { "spr_wagonette_chest_closed", { input = false } } );
      table.insert( table_multiset, { "obj_wagonette_chest_opened", { input = true } } );
      table.insert( table_multiset, { "spr_wagonette_sticks", { input = true } } );
      ObjMultiSet(  table_multiset );
    end;

    ObjDelete( "spr_wagonette_chestpiece" )

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_wagonette_use_amulet", 0, "", 0 );
    ObjAnimate( "spr_wagonette_chest_chestpiece", "alp", 0, 0, "",
    {
      0.0, 2, 0,
      0.3, 2, 1
    } );
    ObjAnimate( "spr_wagonette_chest_closed", "alp", 0, 0, "",
    {
      0.0, 3, 1,
      0.3, 3, 1,
      0.6, 3, 0
    } );
    ObjAnimate( "obj_wagonette_chest_opened", "alp", 0, 0, func_after,
    {
      0.0, 3, 0,
      0.3, 3, 0,
      0.6, 3, 1
    } );

  else 

    ObjSet( "spr_wagonette_chestpiece", { pos_z = 0 } );

  end;

end;

function private.HoComplete( )

  ObjSet( object, { pos_z = 1 } );

  cmn.HoTaskFind( "spr_wagonette_sticks", "sticks" );
  table.insert( table_multiset, { "txt_wagonette_taskpanel", { text = 'str_wagonette_taskpanel_complete' } } );

end;
function private.GetItem()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 ); 

--  if ObjGet( "spr_intent_"..name.."_shadow" ) then
--
--    ObjSet( "spr_intent_"..name.."_shadow", { alp = 0  } );
--
--  end;

    ObjSet( spr_wagonette_chestpiece, { pos_z = 20 } );
  
end;