-- name=mg_amplification
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_amplification";
  
  ObjMultiSet({ 
   
    { "spr_amplification_lantern_button_1", { event_mdown = function() private.ClkButton( 'left' ); end, event_menter = function() private.ButtonEnter( 1 ); end,
                                               event_mleave = function() private.ButtonLeave( 1 ); end   } },
    { "spr_amplification_lantern_button_3", { event_mdown = function() private.ClkButton( 'right' ); end, event_menter = function() private.ButtonEnter( 3 ); end,
                                               event_mleave = function() private.ButtonLeave( 3 ); end   } },
    { "spr_amplification_lantern_button_2", { event_mdown = function() private.ClkButton( 'middle' ); end, event_menter = function() private.ButtonEnter( 2 ); end,
                                               event_mleave = function() private.ButtonLeave( 2 ); end   } },
    { "spr_amplification_lantern_button_4", { event_mdown = function() private.ClkButtonDown( 'left' ); end, event_menter = function() private.ButtonEnter( 4 ); end,
                                               event_mleave = function() private.ButtonLeave( 4 ); end   } },
    { "spr_amplification_lantern_button_6", { event_mdown = function() private.ClkButtonDown( 'right' ); end, event_menter = function() private.ButtonEnter( 6 ); end,
                                               event_mleave = function() private.ButtonLeave( 6 ); end   } },
    { "spr_amplification_lantern_button_5", { event_mdown = function() private.ClkButtonDown( 'middle' ); end, event_menter = function() private.ButtonEnter( 5 ); end,
                                               event_mleave = function() private.ButtonLeave( 5 ); end   } },
    { "obj_amplification_lantern_clk_lantern", { event_mdown = private.ClkLanternRotate } },
  });
  
  private.numbers = { 4, 3, 2, 1, 8, 7, 6, 5 }
  private.resources = { };
  private.win = { { 7, 8, 8, 7 },
                  { 5, 6, 4, 3 },
                  { 1, 2, 2, 1 },
                  { 3, 4, 6, 5 } };

  private.win_2 = { { 8, 7, 7, 8 },
                  { 6, 5, 1, 2 },
                  { 4, 3, 3, 4 },
                  { 2, 1, 5, 6 } };

  --------------------------------------------------------------------------------------------
  -- function get_enhacnedmagiclantern () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_enhacnedmagiclantern" ] = {
    type = "get",
    get_obj = "obj_amplification_lantern",
    room = private.room_objname
  };
    
  local get_enhacnedmagiclantern_inv = function ()
  
    interface.InventoryItemAdd( "inv_enhacnedmagiclantern", "obj_amplification_lantern" );
    interface.InventoryItemRemove( "inv_extinctlantern3" );
    ObjDelete( "gfx_amplification_lantern" );
  
  end;

  cmn.AddSubscriber( "get_enhacnedmagiclantern", get_enhacnedmagiclantern_inv );
   --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_amplification = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;

    local mas_parent_gfx = 

      {
        private.room_objname,
      };

    common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_amplification", update_game_mode_amplification, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_amplification () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_amplification" ] = {
    type = "win",
    room = "int_deploy_inv",
    zz = "deploy_inv_extinctlantern2",
    zz_gate = "inv_extinctlantern3",
    
  };

  local win_amplification = function ()

    local table_multiset = {}; 

    if ( cmn.IsEventDone( "win_amplification" ) ) then  

        table.insert( table_multiset, { "obj_amplification_lantern", { event_mdown = private.get_enhacnedmagiclantern, event_menter = function() common_impl.SetCursor( CURSOR_GET ) end,
                                                                       event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } } );
        table.insert( table_multiset, { "gfx_amplification_lantern", { active = true } } );
        table.insert( table_multiset, { "obj_amplification_lantern_buttons", { input = false } } );
        table.insert( table_multiset, { "spr_amplification_lantern_light", { active = true, visible = true } } );
        table.insert( table_multiset, { "vid_amplification_lantern_light", { active = true, visible = true, playing = true } } );
        table.insert( table_multiset, { "anm_amplification_light", { alp = 1, playing = true } } );
        table.insert( table_multiset, { "spr_amplification_lantern_light_2", { alp = 1 } } );
        ObjDelete( "obj_amplification_lantern_clk_lantern" );
    
    else

      local types = { "left", "right" };  

      local current_state = ng_global.progress[ "ext" ][ "win_amplification" ].current_state; 

      for i = 1, #types do

        for j = 1, 2 do

          local res1 = ng_global.progress[ "ext" ][ "win_amplification" ].state[current_state][ types[i].."_"..j ];
          local res2 = ng_global.progress[ "ext" ][ "win_amplification" ].state_2[current_state][ types[i].."_"..j ];

          table.insert( table_multiset, { "spr_amplification_lantern_"..types[i].."_part_"..j, { res = "assets/levels/levelext/mg_amplification/layers/mg_22/"..res1 } } );
          table.insert( table_multiset, { "spr_amplification_lantern_"..types[i].."_part_down_"..j, { res = "assets/levels/levelext/mg_amplification/layers/mg_2/"..res2 } } );
        
        end;

      end;

      table.insert( table_multiset, { "spr_amplification_knob_1", { alp = 0 } } );
      table.insert( table_multiset, { "spr_amplification_knob_"..current_state, { alp = 1 } } );

       local alp_center = 0;
       local alp_side = 1;
       if ( current_state % 2 == 0 ) then
        alp_center = 1;
        alp_side = 0;
       end;

      table.insert( table_multiset, { "spr_amplification_lantern_decor_center", { alp = alp_center } } );
      table.insert( table_multiset, { "spr_amplification_lantern_decor_left", { alp = alp_side } } );
      table.insert( table_multiset, { "spr_amplification_lantern_decor_right", { alp = alp_side } } );

    end;

    ObjMultiSet(table_multiset);

  end;

  cmn.AddSubscriber( "win_amplification", win_amplification, private.room_objname );
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
-- function *** OPEN, CLOSE MG *** () end;
--*********************************************************************************************************************
  function public.Open() 

    if not cmn.IsEventDone( "win_amplification" ) then

      cmn.MiniGameShow();
      common_impl.PassingMgStart();
    
    end;
    
    int_slider.InitSlider( private.room_objname );
    
    
  end;
  --*********************************************************************************************************************
  function public.PreOpen()

    if ( not cmn.IsEventStart( "win_amplification" ) ) then

      ng_global.progress[ "ext" ][ "win_amplification" ].state = { { [ "left_1" ] = 6, [ "left_2" ] = 8, [ "right_1" ] = 6, [ "right_2" ] = 8 },
                                                                    { [ "left_1" ] = 7, [ "left_2" ] = 5, [ "right_1" ] = 1, [ "right_2" ] = 2 },
                                                                    { [ "left_1" ] = 4, [ "left_2" ] = 3, [ "right_1" ] = 3, [ "right_2" ] = 4 },
                                                                    { [ "left_1" ] = 2, [ "left_2" ] = 1, [ "right_1" ] = 7, [ "right_2" ] = 5 }
                                                                             };

      ng_global.progress[ "ext" ][ "win_amplification" ].state_2 = { { [ "left_1" ] = 6, [ "left_2" ] = 8, [ "right_1" ] = 6, [ "right_2" ] = 8 },
                                                                    { [ "left_1" ] = 7, [ "left_2" ] = 5, [ "right_1" ] = 1, [ "right_2" ] = 2 },
                                                                    { [ "left_1" ] = 4, [ "left_2" ] = 3, [ "right_1" ] = 3, [ "right_2" ] = 4 },
                                                                    { [ "left_1" ] = 2, [ "left_2" ] = 1, [ "right_1" ] = 7, [ "right_2" ] = 5 }
                                                                             };

      ng_global.progress[ "ext" ][ "win_amplification" ].current_state = 1;

    end;

    if levelext_inv.amplification_prevroom ~= "empty" then

      ng_global.progress[ "ext" ][ "win_amplification" ].exitroom = levelext_inv.amplification_prevroom;

    end;
    
    local exitroom = common.GetObjectName ( ng_global.progress[ "ext" ][ "win_amplification" ].exitroom );
    ObjSet( "grm_amplification_room", 
    { 
      event_mdown = function () cmn.GotoRoom( "rm_"..exitroom ) end,
      event_menter = function () common_impl.GateMouseEnter( CURSOR_DOWN, exitroom, "grm_amplification_room" ) end,
      event_mleave = function () common_impl.GateMouseLeave( "grm_amplification_room" ) end
    } );  
  
    common_impl.VisitMapRoom( exitroom );
    --interface.InvestigationButtonCheck();
    
  end;
  --*********************************************************************************************************************
  function public.Close()
  end;
  --*********************************************************************************************************************
  function public.PreClose()

    if not cmn.IsEventDone( "win_amplification" ) then

      cmn.MiniGameHide();
      common_impl.PassingMgStop();

    end;
    
  end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
  function private.get_enhacnedmagiclantern()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
    
    cmn.SetEventDone( "get_enhacnedmagiclantern" );
    cmn.CallEventHandler( "get_enhacnedmagiclantern" );

    local exitroom = ng_global.progress[ "ext" ][ "win_amplification" ].exitroom;
    cmn.GotoRoom( exitroom );

  end;
--*********************************************************************************************************************
-- function *** SKIP, RESET, WIN FUNC*** () end;
--*********************************************************************************************************************
  function public.Reset()

    ng_global.progress[ "ext" ][ "win_amplification" ].state =  { { [ "left_1" ] = 6, [ "left_2" ] = 8, [ "right_1" ] = 6, [ "right_2" ] = 8 },
                                                                    { [ "left_1" ] = 7, [ "left_2" ] = 5, [ "right_1" ] = 1, [ "right_2" ] = 2 },
                                                                    { [ "left_1" ] = 4, [ "left_2" ] = 3, [ "right_1" ] = 3, [ "right_2" ] = 4 },
                                                                    { [ "left_1" ] = 2, [ "left_2" ] = 1, [ "right_1" ] = 7, [ "right_2" ] = 5 }
                                                                             };

    ng_global.progress[ "ext" ][ "win_amplification" ].state_2 =  { { [ "left_1" ] = 6, [ "left_2" ] = 8, [ "right_1" ] = 6, [ "right_2" ] = 8 },
                                                                    { [ "left_1" ] = 7, [ "left_2" ] = 5, [ "right_1" ] = 1, [ "right_2" ] = 2 },
                                                                    { [ "left_1" ] = 4, [ "left_2" ] = 3, [ "right_1" ] = 3, [ "right_2" ] = 4 },
                                                                    { [ "left_1" ] = 2, [ "left_2" ] = 1, [ "right_1" ] = 7, [ "right_2" ] = 5 }
                                                                             };

    ng_global.progress[ "ext" ][ "win_amplification" ].current_state = 1;

    local types = { "left", "right" };  

    local table_multiset = {};  

    for i = 1, #types do

      for j = 1, 2 do

        local res1 = ng_global.progress[ "ext" ][ "win_amplification" ].state[1][ types[i].."_"..j ];
        local res2 = ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1][ types[i].."_"..j ];

        table.insert( table_multiset, { "spr_amplification_lantern_"..types[i].."_part_"..j, { res = "assets/levels/levelext/mg_amplification/layers/mg_22/"..res1 } } );
        table.insert( table_multiset, { "spr_amplification_lantern_"..types[i].."_part_down_"..j, { res = "assets/levels/levelext/mg_amplification/layers/mg_2/"..res2 } } );
      
      end;

    end;
  
  table.insert( table_multiset, { "spr_amplification_knob_1", { alp = 1 } } );
    for i = 2, 4 do
      table.insert( table_multiset, { "spr_amplification_knob_"..i, { alp = 0 } } );
    end;
    table.insert( table_multiset, { "spr_amplification_lantern_decor_center", { alp = 0 } } );
    table.insert( table_multiset, { "spr_amplification_lantern_decor_left", { alp = 1 } } );
    table.insert( table_multiset, { "spr_amplification_lantern_decor_right", { alp = 1 } } );

    ObjMultiSet(table_multiset);


  end;
  --*********************************************************************************************************************
  function public.Skip()
    port.skip_mg = true;
    local current_state = ng_global.progress[ "ext" ][ "win_amplification" ].current_state;

    local table_multiset = {};  

    table.insert( table_multiset, { "spr_amplification_lantern_left_part_1", { res = "assets/levels/levelext/mg_amplification/layers/mg_22/"..private.win[current_state][1] } } );
    table.insert( table_multiset, { "spr_amplification_lantern_left_part_2", { res = "assets/levels/levelext/mg_amplification/layers/mg_22/"..private.win[current_state][2] } } );
    table.insert( table_multiset, { "spr_amplification_lantern_right_part_1", { res = "assets/levels/levelext/mg_amplification/layers/mg_22/"..private.win[current_state][3] } } );
    table.insert( table_multiset, { "spr_amplification_lantern_right_part_2", { res = "assets/levels/levelext/mg_amplification/layers/mg_22/"..private.win[current_state][4] } } );

    table.insert( table_multiset, { "spr_amplification_lantern_left_part_down_1", { res = "assets/levels/levelext/mg_amplification/layers/mg_2/"..private.win_2[current_state][1] } } );
    table.insert( table_multiset, { "spr_amplification_lantern_left_part_down_2", { res = "assets/levels/levelext/mg_amplification/layers/mg_2/"..private.win_2[current_state][2] } } );
    table.insert( table_multiset, { "spr_amplification_lantern_right_part_down_1", { res = "assets/levels/levelext/mg_amplification/layers/mg_2/"..private.win_2[current_state][3] } } );
    table.insert( table_multiset, { "spr_amplification_lantern_right_part_down_2", { res = "assets/levels/levelext/mg_amplification/layers/mg_2/"..private.win_2[current_state][4] } } );
 
    ObjMultiSet(table_multiset);

    private.Win();

  end;
  --*********************************************************************************************************************
  function private.Win()

    cmn.MiniGameHide();
    cmn.SetEventDone( "win_amplification" );
    cmn.CallEventHandler( "win_amplification" );
    common_impl.PassingMgWin();
    common_impl.PlayAudio( "sfx", "common/audio/aud_magic_lantern_win", 0, "", 0 );

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER FUNC *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.ButtonEnter( number )

  ObjSet( "spr_amplification_lantern_button_"..number.."_focus", { alp = 1 } );

  common_impl.SetCursor( CURSOR_HAND );

end;
--*********************************************************************************************************************
function private.ButtonLeave( number )

  ObjSet( "spr_amplification_lantern_button_"..number.."_focus", { alp = 0 } );

  common_impl.SetCursor( CURSOR_DEFAULT );

end;
--*********************************************************************************************************************
function private.ClkButton( type )

   common_impl.Lock( true );

   local current_state = ng_global.progress[ "ext" ][ "win_amplification" ].current_state;

   if type ~= "middle" then
  
       for i = 1, 2 do
      
        private.resources[i] = ng_global.progress[ "ext" ][ "win_amplification" ].state[current_state][type.."_"..i];

       end;

       for j = 1, 2 do

          local func_after = function()

              local func_after_2 = function()

                  common_impl.Lock( false );

                  ng_global.progress[ "ext" ][ "win_amplification" ].state[current_state][ type.."_"..j ] = tonumber( string.sub( private.resources[ 3 - j ], -1 ) ); 

                  if type == "right" then

                    if current_state ~= 4 then

                      ng_global.progress[ "ext" ][ "win_amplification" ].state[current_state+1][ "left_"..j ] = private.numbers[ tonumber( string.sub( private.resources[ 3 - j ], -1 ) )];

                    else

                      ng_global.progress[ "ext" ][ "win_amplification" ].state[1][ "left_"..j ] = private.numbers[tonumber( string.sub( private.resources[ 3 - j ], -1 ) )];

                    end; 

                  else

                    if current_state ~= 1 then

                      ng_global.progress[ "ext" ][ "win_amplification" ].state[current_state-1][ "right_"..j ] = private.numbers[ tonumber( string.sub( private.resources[ 3 - j ], -1 ) )];

                    else

                      ng_global.progress[ "ext" ][ "win_amplification" ].state[4][ "right_"..j ] = private.numbers[tonumber( string.sub( private.resources[ 3 - j ], -1 ) )];

                    end; 

                  end; 

                  if j == 2 then private.CheckWin(); end;

             end;

         
            ObjSet( "spr_amplification_lantern_"..type.."_part_"..j, { res = "assets/levels/levelext/mg_amplification/layers/mg_22/"..private.resources[ 3 - j ] } );

            ObjAnimate( "spr_amplification_lantern_"..type.."_part_"..j, "alp", 0, 0, func_after_2, { 0,0,0, 0.2,0,1 } );

          end;

          common_impl.Lock( true );

          ObjAnimate( "spr_amplification_lantern_"..type.."_part_"..j, "alp", 0, 0, func_after, { 0,0,1, 0.2,0,0 } );
    
       end;

    else

      private.resources[1] =  ng_global.progress[ "ext" ][ "win_amplification" ].state[current_state][ "left_2" ]
      private.resources[2] =  ng_global.progress[ "ext" ][ "win_amplification" ].state[current_state][ "right_1" ]

      local func_after = function()

         local func_after_2 = function()

            common_impl.Lock( false );

            ng_global.progress[ "ext" ][ "win_amplification" ].state[current_state][ "left_2" ] = private.numbers[ tonumber( private.resources[2] ) ]; 
            ng_global.progress[ "ext" ][ "win_amplification" ].state[current_state][ "right_1" ] = private.numbers[ tonumber( private.resources[1] ) ]; 

            if current_state == 4 then

               ng_global.progress[ "ext" ][ "win_amplification" ].state[1][ "left_1" ] = tonumber( private.resources[1] ) ;
               ng_global.progress[ "ext" ][ "win_amplification" ].state[3][ "right_2" ] = tonumber( private.resources[2] ) ;

            elseif current_state == 1 then

               ng_global.progress[ "ext" ][ "win_amplification" ].state[2][ "left_1" ] = tonumber( private.resources[1] ) ;
               ng_global.progress[ "ext" ][ "win_amplification" ].state[4][ "right_2" ] = tonumber( private.resources[2] ) ;            

            else

               ng_global.progress[ "ext" ][ "win_amplification" ].state[current_state+1][ "left_1" ] = tonumber( private.resources[1] );
               ng_global.progress[ "ext" ][ "win_amplification" ].state[current_state-1][ "right_2" ] = tonumber( private.resources[2] );

            end;

            private.CheckWin();
       
         end;
     
         ObjSet( "spr_amplification_lantern_left_part_2", { res = "assets/levels/levelext/mg_amplification/layers/mg_22/"..private.numbers[ tonumber(private.resources[2]) ] } );
         ObjSet( "spr_amplification_lantern_right_part_1", { res = "assets/levels/levelext/mg_amplification/layers/mg_22/"..private.numbers[ tonumber(private.resources[1]) ] } );

         ObjAnimate( "spr_amplification_lantern_left_part_2", "alp", 0, 0, func_after_2, { 0,0,0, 0.2,0,1 } );
         ObjAnimate( "spr_amplification_lantern_right_part_1", "alp", 0, 0, "", { 0,0,0, 0.2,0,1 } );
    
      end;

         common_impl.Lock( true );

         ObjAnimate( "spr_amplification_lantern_left_part_2", "alp", 0, 0, func_after, { 0,0,1, 0.2,0,0 } );
         ObjAnimate( "spr_amplification_lantern_right_part_1", "alp", 0, 0, "", { 0,0,1, 0.2,0,0 } );
     
    end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_magic_lantern_click", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.ClkLanternRotate()
 
  local current_state = ng_global.progress[ "ext" ][ "win_amplification" ].current_state;

  local new_state = current_state + 1;
  if ( new_state >= 5 ) then
    new_state = 1;
  end;

  local diamond_loc = { { "right" }, { "right", "left" }, { "right", "left" }, { "left" } };

  local right_state = {};
  local next_state = {};

  local right_state_2 = {};
  local next_state_2 = {};

        local func_after_2 = function()

          common_impl.Lock( false );

          if ng_global.progress[ "ext" ][ "win_amplification" ].current_state ~= 4 then

             ng_global.progress[ "ext" ][ "win_amplification" ].current_state = ng_global.progress[ "ext" ][ "win_amplification" ].current_state + 1;

          else

             ng_global.progress[ "ext" ][ "win_amplification" ].current_state = 1;

          end;

          local current_state_2 = ng_global.progress[ "ext" ][ "win_amplification" ].current_state;

          for j = 1, 2 do

            ng_global.progress[ "ext" ][ "win_amplification" ].state[current_state_2]["left_"..j] = tonumber( private.numbers[right_state[j]] );
            ng_global.progress[ "ext" ][ "win_amplification" ].state[current_state_2]["right_"..j] = tonumber( next_state[j] );

            ng_global.progress[ "ext" ][ "win_amplification" ].state_2[current_state_2]["left_"..j] = tonumber( private.numbers[right_state_2[j]] );
            ng_global.progress[ "ext" ][ "win_amplification" ].state_2[current_state_2]["right_"..j] = tonumber( next_state_2[j] );

          end;

          if current_state_2 ~= 4 then

            ng_global.progress[ "ext" ][ "win_amplification" ].state[current_state_2+1]["left_1"] = tonumber( private.numbers[next_state[1]] );
            ng_global.progress[ "ext" ][ "win_amplification" ].state[current_state_2+1]["left_2"] = tonumber( private.numbers[next_state[2]] );

            ng_global.progress[ "ext" ][ "win_amplification" ].state_2[current_state_2+1]["left_1"] = tonumber( private.numbers[next_state_2[1]] );
            ng_global.progress[ "ext" ][ "win_amplification" ].state_2[current_state_2+1]["left_2"] = tonumber( private.numbers[next_state_2[2]] );
  
          else

            ng_global.progress[ "ext" ][ "win_amplification" ].state[1]["left_1"] = tonumber( private.numbers[next_state[1]] );
            ng_global.progress[ "ext" ][ "win_amplification" ].state[1]["left_2"] = tonumber( private.numbers[next_state[2]] );

            ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1]["left_1"] = tonumber( private.numbers[next_state_2[1]] );
            ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1]["left_2"] = tonumber( private.numbers[next_state_2[2]] );

          end;

        end;


         for i = 1, 2 do

           right_state[i] = ng_global.progress[ "ext" ][ "win_amplification" ].state[current_state]["right_"..i];
           right_state_2[i] = ng_global.progress[ "ext" ][ "win_amplification" ].state_2[current_state]["right_"..i];
          
           if current_state ~= 4 then

             next_state[i] = ng_global.progress[ "ext" ][ "win_amplification" ].state[current_state+1]["right_"..i];
             next_state_2[i] = ng_global.progress[ "ext" ][ "win_amplification" ].state_2[current_state+1]["right_"..i];

           else

             next_state[i] = ng_global.progress[ "ext" ][ "win_amplification" ].state[1]["right_"..i];
             next_state_2[i] = ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1]["right_"..i];

           end;   
               
           ObjSet( "spr_amplification_lantern_left_part_"..i, { res = "assets/levels/levelext/mg_amplification/layers/mg_22/"..tonumber( private.numbers[right_state[i]] ) } );
           ObjSet( "spr_amplification_lantern_right_part_"..i, { res = "assets/levels/levelext/mg_amplification/layers/mg_22/"..tonumber( next_state[i] ) } ); 

           ObjSet( "spr_amplification_lantern_left_part_down_"..i, { res = "assets/levels/levelext/mg_amplification/layers/mg_2/"..tonumber( private.numbers[right_state_2[i]] ) } );
           ObjSet( "spr_amplification_lantern_right_part_down_"..i, { res = "assets/levels/levelext/mg_amplification/layers/mg_2/"..tonumber( next_state_2[i] ) } ); 

           ObjAnimate( "spr_amplification_lantern_right_part_"..i, "alp", 0, 0, "", { 0,0,1, 0.2,0,1 } );
           ObjAnimate( "spr_amplification_lantern_right_part_down_"..i, "alp", 0, 0, "", { 0,0,1, 0.2,0,1 } );
  
         end;

          ObjAnimate( "spr_amplification_lantern_left_part_1", "alp", 0, 0, func_after_2, { 0,0,1, 0.1,0,1 } );
          ObjAnimate( "spr_amplification_lantern_left_part_2", "alp", 0, 0, "", { 0,0,1, 0.1,0,1 } );
        
          ObjAnimate( "spr_amplification_lantern_left_part_down_1", "alp", 0, 0, "", { 0,0,1, 0.1,0,1 } );
          ObjAnimate( "spr_amplification_lantern_left_part_down_2", "alp", 0, 0, "", { 0,0,1, 0.1,0,1 } );
            
       
   for i = 1, 4 do

    local name = "spr_amplification_knob_"..i;
    local alp = ObjGet( name ).alp;
    local alp_new = 0;
    if ( i == new_state ) then
      alp_new = 1;
    end;

    ObjSet( name, { alp = alp_new } );

   end;
  
   local alp_center = 0;
   local alp_side = 1;
   if ( new_state % 2 == 0 ) then
    alp_center = 1;
    alp_side = 0;
   end;

  ObjSet( "spr_amplification_lantern_decor_center", { alp = alp_center } );
  ObjSet( "spr_amplification_lantern_decor_left", { alp = alp_side } );
  ObjSet( "spr_amplification_lantern_decor_right", { alp = alp_side } );

  common_impl.PlayAudio( "sfx", "common/audio/aud_magic_lantern_rotate", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.ClkButtonDown( type )

   common_impl.Lock( true );

   local current_state = ng_global.progress[ "ext" ][ "win_amplification" ].current_state;

   if type ~= "middle" then
  
       for i = 1, 2 do
      
        private.resources[i] = ng_global.progress[ "ext" ][ "win_amplification" ].state_2[current_state][type.."_"..i];

       end;

       for j = 1, 2 do

          local func_after = function()

              local func_after_2 = function()

                  common_impl.Lock( false );

                  ng_global.progress[ "ext" ][ "win_amplification" ].state_2[current_state][ type.."_"..j ] = tonumber( string.sub( private.resources[ 3 - j ], -1 ) ); 

                  if type == "right" then

                    if current_state ~= 4 then

                      ng_global.progress[ "ext" ][ "win_amplification" ].state_2[current_state+1][ "left_"..j ] = private.numbers[ tonumber( string.sub( private.resources[ 3 - j ], -1 ) )];

                    else

                      ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1][ "left_"..j ] = private.numbers[tonumber( string.sub( private.resources[ 3 - j ], -1 ) )];

                    end; 

                  else

                    if current_state ~= 1 then

                      ng_global.progress[ "ext" ][ "win_amplification" ].state_2[current_state-1][ "right_"..j ] = private.numbers[ tonumber( string.sub( private.resources[ 3 - j ], -1 ) )];

                    else

                      ng_global.progress[ "ext" ][ "win_amplification" ].state_2[4][ "right_"..j ] = private.numbers[tonumber( string.sub( private.resources[ 3 - j ], -1 ) )];

                    end; 

                  end; 

                  if j == 2 then private.CheckWin(); end;

             end;
         
            ObjSet( "spr_amplification_lantern_"..type.."_part_down_"..j, { res = "assets/levels/levelext/mg_amplification/layers/mg_2/"..private.resources[ 3 - j ] } );

            ObjAnimate( "spr_amplification_lantern_"..type.."_part_down_"..j, "alp", 0, 0, func_after_2, { 0,0,0, 0.2,0,1 } );

          end;

          common_impl.Lock( true );

          ObjAnimate( "spr_amplification_lantern_"..type.."_part_down_"..j, "alp", 0, 0, func_after, { 0,0,1, 0.2,0,0 } );
    
       end;

    else

      private.resources[1] =  ng_global.progress[ "ext" ][ "win_amplification" ].state_2[current_state][ "left_2" ]
      private.resources[2] =  ng_global.progress[ "ext" ][ "win_amplification" ].state_2[current_state][ "right_1" ]

      local func_after = function()

         local func_after_2 = function()

            common_impl.Lock( false );

            ng_global.progress[ "ext" ][ "win_amplification" ].state_2[current_state][ "left_2" ] = private.numbers[ tonumber( private.resources[2] ) ]; 
            ng_global.progress[ "ext" ][ "win_amplification" ].state_2[current_state][ "right_1" ] = private.numbers[ tonumber( private.resources[1] ) ]; 

            if current_state == 4 then

               ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1][ "left_1" ] = tonumber( private.resources[1] ) ;
               ng_global.progress[ "ext" ][ "win_amplification" ].state_2[3][ "right_2" ] = tonumber( private.resources[2] ) ;

            elseif current_state == 1 then

               ng_global.progress[ "ext" ][ "win_amplification" ].state_2[2][ "left_1" ] = tonumber( private.resources[1] ) ;
               ng_global.progress[ "ext" ][ "win_amplification" ].state_2[4][ "right_2" ] = tonumber( private.resources[2] ) ;            

            else

               ng_global.progress[ "ext" ][ "win_amplification" ].state_2[current_state+1][ "left_1" ] = tonumber( private.resources[1] );
               ng_global.progress[ "ext" ][ "win_amplification" ].state_2[current_state-1][ "right_2" ] = tonumber( private.resources[2] );

            end;

            private.CheckWin();
       
         end;
     
         ObjSet( "spr_amplification_lantern_left_part_down_2", { res = "assets/levels/levelext/mg_amplification/layers/mg_2/"..private.numbers[ tonumber(private.resources[2]) ] } );
         ObjSet( "spr_amplification_lantern_right_part_down_1", { res = "assets/levels/levelext/mg_amplification/layers/mg_2/"..private.numbers[ tonumber(private.resources[1]) ] } );

         ObjAnimate( "spr_amplification_lantern_left_part_down_2", "alp", 0, 0, func_after_2, { 0,0,0, 0.2,0,1 } );
         ObjAnimate( "spr_amplification_lantern_right_part_down_1", "alp", 0, 0, "", { 0,0,0, 0.2,0,1 } );
    
      end;

         common_impl.Lock( true );

         ObjAnimate( "spr_amplification_lantern_left_part_down_2", "alp", 0, 0, func_after, { 0,0,1, 0.2,0,0 } );
         ObjAnimate( "spr_amplification_lantern_right_part_down_1", "alp", 0, 0, "", { 0,0,1, 0.2,0,0 } );
     
    end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_magic_lantern_click", 0, "", 0 );

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.CheckWin()

    local step1 = false;
    local step2 = false; 
    
    if ng_global.progress[ "ext" ][ "win_amplification" ].state[1][ "left_1" ]  == private.win[1][1] and
       ng_global.progress[ "ext" ][ "win_amplification" ].state[1][ "left_2" ]  == private.win[1][2] and
       ng_global.progress[ "ext" ][ "win_amplification" ].state[1][ "right_1" ] == private.win[1][3] and
       ng_global.progress[ "ext" ][ "win_amplification" ].state[1][ "right_2" ] == private.win[1][4] then
      
       if ng_global.progress[ "ext" ][ "win_amplification" ].state[3][ "left_1" ]  == private.win[3][1] and
          ng_global.progress[ "ext" ][ "win_amplification" ].state[3][ "left_2" ]  == private.win[3][2] and
          ng_global.progress[ "ext" ][ "win_amplification" ].state[3][ "right_1" ] == private.win[3][3] and
          ng_global.progress[ "ext" ][ "win_amplification" ].state[3][ "right_2" ] == private.win[3][4] then
          
          step1 = true;
            
       end;

    end;  
      
    if ng_global.progress[ "ext" ][ "win_amplification" ].state[1][ "left_1" ]  == private.win[3][1] and
       ng_global.progress[ "ext" ][ "win_amplification" ].state[1][ "left_2" ]  == private.win[3][2] and
       ng_global.progress[ "ext" ][ "win_amplification" ].state[1][ "right_1" ] == private.win[3][3] and
       ng_global.progress[ "ext" ][ "win_amplification" ].state[1][ "right_2" ] == private.win[3][4] then
      
      if ng_global.progress[ "ext" ][ "win_amplification" ].state[3][ "left_1" ]  == private.win[1][1] and
         ng_global.progress[ "ext" ][ "win_amplification" ].state[3][ "left_2" ]  == private.win[1][2] and
         ng_global.progress[ "ext" ][ "win_amplification" ].state[3][ "right_1" ] == private.win[1][3] and
         ng_global.progress[ "ext" ][ "win_amplification" ].state[3][ "right_2" ] == private.win[1][4] then
          
          step1 = true;
            
       end;

    end; 
      
    if ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1][ "left_1" ]  == private.win_2[1][1] and
       ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1][ "left_2" ]  == private.win_2[1][2] and
       ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1][ "right_1" ] == private.win_2[1][3] and
       ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1][ "right_2" ] == private.win_2[1][4] then
              
       if ng_global.progress[ "ext" ][ "win_amplification" ].state_2[3][ "left_1" ]  == private.win_2[3][1] and
          ng_global.progress[ "ext" ][ "win_amplification" ].state_2[3][ "left_2" ]  == private.win_2[3][2] and
          ng_global.progress[ "ext" ][ "win_amplification" ].state_2[3][ "right_1" ] == private.win_2[3][3] and
          ng_global.progress[ "ext" ][ "win_amplification" ].state_2[3][ "right_2" ] == private.win_2[3][4] then

          step2 = true;
             
        end;

    end;  
      
    if ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1][ "left_1" ]  == private.win_2[3][1] and
       ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1][ "left_2" ]  == private.win_2[3][2] and
       ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1][ "right_1" ] == private.win_2[3][3] and
       ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1][ "right_2" ] == private.win_2[3][4] then
              
       if ng_global.progress[ "ext" ][ "win_amplification" ].state_2[3][ "left_1" ]  == private.win_2[1][1] and
          ng_global.progress[ "ext" ][ "win_amplification" ].state_2[3][ "left_2" ]  == private.win_2[1][2] and
          ng_global.progress[ "ext" ][ "win_amplification" ].state_2[3][ "right_1" ] == private.win_2[1][3] and
          ng_global.progress[ "ext" ][ "win_amplification" ].state_2[3][ "right_2" ] == private.win_2[1][4] then

          step2 = true;
             
        end;

    end;

    if ng_global.progress[ "ext" ][ "win_amplification" ].state[1][ "left_1" ]  == 3 and
       ng_global.progress[ "ext" ][ "win_amplification" ].state[1][ "left_2" ]  == 4 and
       ng_global.progress[ "ext" ][ "win_amplification" ].state[1][ "right_1" ] == 6 and
       ng_global.progress[ "ext" ][ "win_amplification" ].state[1][ "right_2" ] == 5 then
      
      if ng_global.progress[ "ext" ][ "win_amplification" ].state[3][ "left_1" ]  == 5 and
         ng_global.progress[ "ext" ][ "win_amplification" ].state[3][ "left_2" ]  == 6 and
         ng_global.progress[ "ext" ][ "win_amplification" ].state[3][ "right_1" ] == 4 and
         ng_global.progress[ "ext" ][ "win_amplification" ].state[3][ "right_2" ] == 3 then

         step1 = true;
          
       end;

    end;
     
    if ng_global.progress[ "ext" ][ "win_amplification" ].state[3][ "left_1" ]  == 3 and
       ng_global.progress[ "ext" ][ "win_amplification" ].state[3][ "left_2" ]  == 4 and
       ng_global.progress[ "ext" ][ "win_amplification" ].state[3][ "right_1" ] == 6 and
       ng_global.progress[ "ext" ][ "win_amplification" ].state[3][ "right_2" ] == 5 then
      
      if ng_global.progress[ "ext" ][ "win_amplification" ].state[1][ "left_1" ]  == 5 and
         ng_global.progress[ "ext" ][ "win_amplification" ].state[1][ "left_2" ]  == 6 and
         ng_global.progress[ "ext" ][ "win_amplification" ].state[1][ "right_1" ] == 4 and
         ng_global.progress[ "ext" ][ "win_amplification" ].state[1][ "right_2" ] == 3 then

         step1 = true;
          
       end;

    end;
     
    if ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1][ "left_1" ]  == 3 and
       ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1][ "left_2" ]  == 4 and
       ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1][ "right_1" ] == 6 and
       ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1][ "right_2" ] == 5 then
              
       if ng_global.progress[ "ext" ][ "win_amplification" ].state_2[3][ "left_1" ]  == 5 and
          ng_global.progress[ "ext" ][ "win_amplification" ].state_2[3][ "left_2" ]  == 6 and
          ng_global.progress[ "ext" ][ "win_amplification" ].state_2[3][ "right_1" ] == 4 and
          ng_global.progress[ "ext" ][ "win_amplification" ].state_2[3][ "right_2" ] == 3 then

          step2 = true;    
      
       end;

    end; 
      
    if ng_global.progress[ "ext" ][ "win_amplification" ].state_2[3][ "left_1" ]  == 3 and
       ng_global.progress[ "ext" ][ "win_amplification" ].state_2[3][ "left_2" ]  == 4 and
       ng_global.progress[ "ext" ][ "win_amplification" ].state_2[3][ "right_1" ] == 6 and
       ng_global.progress[ "ext" ][ "win_amplification" ].state_2[3][ "right_2" ] == 5 then
              
       if ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1][ "left_1" ]  == 5 and
          ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1][ "left_2" ]  == 6 and
          ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1][ "right_1" ] == 4 and
          ng_global.progress[ "ext" ][ "win_amplification" ].state_2[1][ "right_2" ] == 3 then

          step2 = true;    
      
       end;

    end;

    if step1 == true and step2 == true then     
       private.Win();
    end;
        
end;
--*********************************************************************************************************************
ObjAnimate( "spr_amplification_lantern_light", "alp", 1, 0, "", { 0,0,0.2, 2,0,1, 4,0,0.2 } );
--*********************************************************************************************************************
