-- name=mg_bossfight
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_bossfight";
  local table_multiset = {};
  private.g1_done_sym = {};
  private.clone_names = 0;
  private.ball_count = 0;
  private.amn_clone_names = 0;

  for i = 1,5 do

    table.insert( table_multiset , { "obj_bossfight_clk_firstgame_"..i.."_1", { event_mdown = function () private.sumbol_clk( i, true ) end, 
                                                                                event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
                                                                                event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end } }  );

    table.insert( table_multiset , { "obj_bossfight_clk_firstgame_"..i, { event_mdown = function () private.sumbol_clk( i, false ) end,
                                                                          event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
                                                                          event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end } }  );


  end;

  for i = 1,3 do 

        table.insert( table_multiset , { "obj_bossfight_anims_ball_"..i, { event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
                                                                           event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end } }  );
  end;

  ObjMultiSet(table_multiset);
  --------------------------------------------------------------------------------------------
  -- function win_bossfight () end;
  --------------------------------------------------------------------------------------------
  local win_bossfight = function ()

    local table_multiset = {};

    if ( cmn.IsEventDone( "win_bossfight" ) ) then  

      ObjSet( "obj_swampmasterdwelling_use_victoryartifact2", { input = true, active = true } );

    else

      private.g1_done_sym = ng_global.progress["ext"]["win_bossfight"].g1_done_sym;

      if ( #private.g1_done_sym == 5 ) then
        
        table.insert( table_multiset, { "obj_bossfight_clk_obj", { input = false } } );
        table.insert( table_multiset, { "obj_bossfight_anims_balls", { input = true, visible = true } } );
        private.ball_count = ng_global.progress["ext"]["win_bossfight"].ball_count;

        local cur_pos_x = private.Get_pos_bar();

        table.insert( table_multiset, { "spr_bossfight_energy", { croprect_w = cur_pos_x } } );
        table.insert( table_multiset, { "spr_bossfight_energy_over", { pos_x = cur_pos_x*0.95 } } );
        table.insert( table_multiset, { "anm_bossfight_swampmaster2", { active = true, visible = true } } );
        table.insert( table_multiset, { "anm_bossfight_swampmaster1", { active = false, visible = false } } );

      else

      end;

      for i = 1, #private.g1_done_sym do

        table.insert( table_multiset, { "obj_bossfight_symbol_"..private.g1_done_sym[i], { alp = 0, active = false } } );
        table.insert( table_multiset, { "obj_bossfight_symbol_"..private.g1_done_sym[i].."_1", { alp = 0, active = false } } );
        table.insert( table_multiset, { "anm_bossfight_light_"..private.g1_done_sym[i], { alp = 0, active = false } } );
        table.insert( table_multiset, { "anm_bossfight_light_"..private.g1_done_sym[i].."_1", { alp = 0, active = false } } );

      end;
       
    end;

  if ( table_multiset[1] ) then

    ObjMultiSet( table_multiset );

  end;

  end;

  local win_bossfight_del_gmg = function ()

  if ( cmn.IsEventDone( "win_bossfight" ) ) then  

    ObjDelete( "gmg_swampmasterdwelling_bossfight" );
    ObjDelete( "anm_swampmasterdwelling_master" );
    ObjSet( "anm_swampmasterdwelling_master_end", { alp = 1, playing = true } );
    ObjSet( "obj_swampmasterdwelling_use_victoryartifact2", { input = true } );

  end;

  end;

  cmn.AddSubscriber( "win_bossfight", win_bossfight, private.room_objname );
  cmn.AddSubscriber( "win_bossfight", win_bossfight_del_gmg, "rm_swampmasterdwelling" );
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open() 

  common_impl.VisitMapRoom( "swampmasterdwelling" );
  
  if not cmn.IsEventDone( "win_bossfight" ) then

    cmn.MiniGameShow();
    common_impl.PassingMgStart();
  
  end;
  
  int_slider.InitSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventStart( "win_bossfight" ) ) then

    ng_global.progress[ "ext" ][ "win_bossfight" ].state = {};
    ng_global.progress["ext"]["win_bossfight"].g1_done_sym = {};
    ng_global.progress["ext"]["win_bossfight"].ball_count = 0;
        
    private.g1_done_sym = {};
    private.clone_names = 0;
    private.ball_count = 0;

  end;

  common_impl.EnvPlay( { "common/audio/aud_bossfight_env" }, "", 0.5 );
  
  --interface.InvestigationButtonCheck();

  if ( not private.CheckWinSymbols() ) then
    
    private.g1_anm_circle();

  else
    
    ObjSet( "tmr_bossfight_g2_circle", { active = true , playing = true, time = 3.2, endtrig = function () private.g2_anm_circle() end });
    common_impl.PlayAudio( "sfx", "common/audio/aud_bossfight_start_drop_balls", 0, "", 0 );

  end;

  for i = 1, #game.room_names do

    if ( common.GetObjectPrefix(game.room_names[i]) == "rm" ) then

      common_impl.LockMapRoom( common.GetObjectName(game.room_names[i]), true );

    end;

  end;

end;
--*********************************************************************************************************************
function public.Close()

  

end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_bossfight" ) then

    cmn.MiniGameHide();
    common_impl.PassingMgStop();

  end;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()

  local endfunc = function ()

    ObjSet( "anm_bossfight_swampmaster2", { visible = false, active = false } );
    ObjSet( "tmr_bossfight_for_g1", { active = true , playing = true, time = 4, endtrig = function () private.g1_anm_circle() end });
    ObjSet( "obj_bossfight_clk_obj", { input = true } );
    ObjSet( "tmr_bossfight_g2_circle", { active = false });
    ObjSet( "tmr_bossfight_for_g2", { active = false });
    ObjSet( "tmr_bossfight_g2_circle_sound", { active = false });

  end;
   
  local table_multiset = {};

  for i = 1, 5 do

    ObjStopAnimate( "obj_bossfight_symbol_"..i, "scale_xy" );
    ObjStopAnimate( "obj_bossfight_symbol_"..i.."_1", "scale_xy");

    ObjStopAnimate( "obj_bossfight_symbol_"..i, "alp" );
    ObjStopAnimate( "obj_bossfight_symbol_"..i.."_1", "alp");

    table.insert( table_multiset, { "obj_bossfight_symbol_"..i, { alp = 0.5, scale_x = 0.5, scale_y = 0.5, active = true } } );
    table.insert( table_multiset, { "obj_bossfight_symbol_"..i.."_1", { alp = 0.5, scale_x = 0.5, scale_y = 0.5, active = true } } );
    table.insert( table_multiset, { "anm_bossfight_light_"..i, { alp = 0, active = true } } );
    table.insert( table_multiset, { "anm_bossfight_light_"..i.."_1", { alp = 0, active = true } } );
    table.insert( table_multiset, { "obj_bossfight_clk_firstgame_"..i.."_1", { input = false } } );
    table.insert( table_multiset, { "obj_bossfight_clk_firstgame_"..i, { input = false } } );

  end;


  ObjAnimate("obj_bossfight_anims_symbols", "alp", 0, 0, endfunc, {0, 3, 0, 0.3, 3, 1});
  ObjAnimate("obj_bossfight_anims_light", "alp", 0, 0, "", {0, 3, 0, 0.3, 3, 1});

  if ( #private.g1_done_sym == 5 ) then   

    ObjSet( "anm_bossfight_swampmaster1", { visible = true, active = true } );
    ObjAnimate("anm_bossfight_swampmaster1", "alp", 0, 0, "", {0, 3, 0, 0.3, 3, 1});
    ObjAnimate("anm_bossfight_swampmaster2", "alp", 0, 0, "", {0, 3, 1, 0.3, 3, 0});
    
  end;

  table.insert( table_multiset, { "obj_bossfight_anims_balls", { input = false, visible = false } } );

  ObjMultiSet( table_multiset );

  ng_global.progress["ext"]["win_bossfight"].g1_done_sym = {};

  private.g1_done_sym = {};

  private.ball_count = 0;

  ng_global.progress["ext"]["win_bossfight"].ball_count = 0;

  private.Set_progress_bar();

end;
--*********************************************************************************************************************
function public.Skip()
port.skip_mg = true;
  private.Win();

end;
--*********************************************************************************************************************
function private.WinEnd()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_bossfight" );
  cmn.CallEventHandler( "win_bossfight" );  
  common_impl.PassingMgWin();
  cmn.GotoRoom( "rm_swampmasterdwelling" );

  for i = 1, #game.room_names do

    if ( common.GetObjectPrefix(game.room_names[i]) == "rm" ) then

      common_impl.LockMapRoom( common.GetObjectName(game.room_names[i]), false );

    end;

  end;

end;
--*********************************************************************************************************************
function private.Win()

  local endfunc = function ()

    private.WinEnd();

    common_impl.Lock( false );

  end;

  common_impl.Lock( true );
  
  ObjMultiSet({

      { "tmr_bossfight_for_g1", { active = false } },
      { "tmr_bossfight_for_g2", { active = false } },

  });

  ObjSet( "anm_bossfight_win_hit", { frame = 0, playing = true, endtrig = endfunc } );
  common_impl.PlayAudio( "sfx", "common/audio/aud_bossfight_win_hit", 0, "", 0 );
 
end;
--*********************************************************************************************************************
function private.g1_anm_circle()

  private.g1_cur_num_symbol = nil;

  local random_symbols = {};

  function private.get_rand_sym()

    while ( true ) do 
      
       local num = math.random( 1,5 );
        
        if not common_impl.ExistInArr( random_symbols, num ) then

          table.insert( random_symbols, num);

          return num;

        end;    

    end;

  end;

  ObjSet( "tmr_bossfight_for_g1", { active = true , playing = true, time = 4,endtrig = function () private.g1_anm_circle() end });

  for i = 1, #private.g1_done_sym do

    table.insert(random_symbols, private.g1_done_sym[i] )

  end;

  local table_multiset = {};

  for i = 1, 5 do
  
    table.insert( table_multiset, { "obj_bossfight_clk_firstgame_"..i.."_1", { input = false } } );
    table.insert( table_multiset, { "obj_bossfight_clk_firstgame_"..i, { input = false } } );
    table.insert( table_multiset, { "anm_bossfight_light_"..i, { alp = 0 } } );
    table.insert( table_multiset, { "anm_bossfight_light_"..i.."_1", { alp = 0 } } );

  end;

  local cur_sym = private.get_rand_sym();

  local endfunc = function ()

    common_impl.Lock( false );

  end;

  common_impl.Lock( true );

  local block_input = function ()

    for i = 1, 5 do
    
      table.insert( table_multiset, { "obj_bossfight_clk_firstgame_"..i.."_1", { input = false } } );
      table.insert( table_multiset, { "obj_bossfight_clk_firstgame_"..i, { input = false } } );

    end;
  
    ObjAnimate( "obj_bossfight_symbol_"..cur_sym.."_1", "scale_xy", 0, 0, "", { 0, 3, 1, 1,    0.3, 3, 0.5, 0.5 } );    

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_bossfight_sym_apear", 0, "", 0 );

  ObjAnimate( "anm_bossfight_light_"..cur_sym, "alp", 0, 0, endfunc,  { 0, 3, 0, 0.4, 3, 1, 1.2, 3, 0 } );
  ObjAnimate( "anm_bossfight_light_"..cur_sym.."_1", "alp", 0, 0, "", { 0, 3, 0, 0.4, 3, 1, 1.2, 3, 0 } );
  ObjAnimate( "obj_bossfight_symbol_"..cur_sym, "alp", 0, 0, "",       { 0, 3, 0.5,    0.3, 3, 1,     3.7, 3, 1,    4.0, 3, 0.3  } );
  ObjAnimate( "obj_bossfight_symbol_"..cur_sym.."_1", "alp", 0, 0, "", { 0, 3, 0.5,    0.3, 3, 1,     3.7, 3, 1,    4.0, 3, 0.3  } );
  ObjAnimate( "obj_bossfight_symbol_"..cur_sym, "scale_xy", 0, 0, "",       { 0, 3, 0.5, 0.5,    0.3, 3, 1, 1,    3.7, 3, 1, 1,     4.0, 3, 0.5, 0.5 } );
  ObjAnimate( "obj_bossfight_symbol_"..cur_sym.."_1", "scale_xy", 0, 0, block_input, { 0, 3, 0.5, 0.5,    0.3, 3, 1, 1,    3.7, 3, 1, 1 } );

  table.insert( table_multiset, { "obj_bossfight_clk_firstgame_"..cur_sym.."_1", { input = true } } );
  table.insert( table_multiset, { "obj_bossfight_clk_firstgame_"..cur_sym, { input = true } } );

  local other_sym_1 = "";
  local other_sym_2 = "";

  if ( #private.g1_done_sym < 4 ) then

    other_sym_1 = private.get_rand_sym();

    if ( #private.g1_done_sym == 3 ) then

      other_sym_2 = other_sym_1;      

    else

      other_sym_2 = private.get_rand_sym();

    end;

    table.insert( table_multiset, { "obj_bossfight_clk_firstgame_"..other_sym_2.."_1", { input = true } } );
    table.insert( table_multiset, { "obj_bossfight_clk_firstgame_"..other_sym_1, { input = true } } );

    ObjAnimate( "anm_bossfight_light_"..other_sym_1, "alp", 0, 0, "",       { 0, 3, 0,    0.4, 3, 1,    1.2, 3, 0 } );
    ObjAnimate( "anm_bossfight_light_"..other_sym_2.."_1", "alp", 0, 0, "", { 0, 3, 0,    0.4, 3, 1,    1.2, 3, 0 } );

    ObjAnimate( "obj_bossfight_symbol_"..other_sym_1, "alp", 0, 0, "",       { 0, 3, 0.5,    0.3, 3, 1,     3.7, 3, 1,    4.0, 3, 0.3  } );
    ObjAnimate( "obj_bossfight_symbol_"..other_sym_2.."_1", "alp", 0, 0, "", { 0, 3, 0.5,    0.3, 3, 1,     3.7, 3, 1,    4.0, 3, 0.3  } );

    ObjAnimate( "obj_bossfight_symbol_"..other_sym_1, "scale_xy", 0, 0, "",       { 0, 3, 0.5, 0.5,    0.3, 3, 1, 1,    3.7, 3, 1, 1,     4.0, 3, 0.5, 0.5 } );
    ObjAnimate( "obj_bossfight_symbol_"..other_sym_2.."_1", "scale_xy", 0, 0, "", { 0, 3, 0.5, 0.5,    0.3, 3, 1, 1,    3.7, 3, 1, 1,     4.0, 3, 0.5, 0.5 } );

  end;

  ObjMultiSet( table_multiset );  

end;
--*********************************************************************************************************************
function private.sumbol_clk( num, postfix )

  common_impl.PlayAudio( "sfx", "common/audio/aud_bossfight_clk_sym", 0, "", 0 );

  local symbol_name = "anm_bossfight_light_"..num

    if ( postfix ) then

      symbol_name = symbol_name.."_1";
    
    end;

  if not private.g1_cur_num_symbol then

    ObjSet(symbol_name, { alp = 1});

    private.g1_symbol_name = symbol_name;
    private.g1_cur_num_symbol = num;
    private.g1_cur_postfix_symbol = postfix;

  elseif private.g1_cur_num_symbol == num then

    if ( private.g1_cur_postfix_symbol ~= postfix ) then

      private.Right_symbols_anim( num );
      
    else   
    
      ObjSet( symbol_name, { alp = 0 });
      private.g1_cur_num_symbol = nil;

    end;

   else

     ObjSet( private.g1_symbol_name, { alp = 0});
     private.Wrong_symbols_anim( );
   
  end;

end;
--*********************************************************************************************************************
function private.Right_symbols_anim( num )

  table.insert( private.g1_done_sym, num );


  if ( private.CheckWinSymbols() ) then

    private.SymbolsWinAnim();
    ObjSet( "tmr_bossfight_for_g1", { active = false } );

  else
    
    private.SaveSymbols();

  end;

  private.g1_cur_num_symbol = nil;


  local endfunc = function ()

    common_impl.Lock( false );

    ObjSet( "obj_bossfight_clk_firstgame_"..num.."_1", { input = false });
    ObjSet( "obj_bossfight_clk_firstgame_"..num, { input = false });
    ObjSet( "obj_bossfight_symbol_"..num, { active = false } );
    ObjSet( "obj_bossfight_symbol_"..num.."_1", { active = false } );
    ObjSet( "anm_bossfight_light_"..num, { active = false } );
    ObjSet( "anm_bossfight_light_"..num.."_1", { active = false } );
    
  end;

  common_impl.Lock( true );

  
  ObjAnimate( "obj_bossfight_symbol_"..num, "alp", 0, 0, endfunc, { 0, 3, 1, 0.4, 3, 1, 0.8, 3, 0 });
  ObjAnimate( "obj_bossfight_symbol_"..num.."_1", "alp", 0, 0, "", { 0, 3, 1, 0.4, 3, 1, 0.8, 3, 0});
  ObjAnimate( "anm_bossfight_light_"..num, "alp", 0, 0, "", { 0, 3, 1, 0.4, 3, 1, 0.8, 3, 0 });
  ObjAnimate( "anm_bossfight_light_"..num.."_1", "alp", 0, 0, "", { 0, 3, 1, 0.4, 3, 1, 0.8, 3, 0 });
  common_impl.PlayAudio( "sfx", "common/audio/aud_bossfight_right_sym", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.Wrong_symbols_anim() 

  private.g1_cur_num_symbol = nil;
  private.boss_hit();

  common_impl.PlayAudio( "sfx", "common/audio/aud_bossfight_wrong_sym", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.CheckWinSymbols()

  if ( #private.g1_done_sym == 5 ) then

    return true;

  else
    
    return false;

  end;

end;
--*********************************************************************************************************************
function private.SaveSymbols()

  ng_global.progress["ext"]["win_bossfight"].g1_done_sym = private.g1_done_sym;

end;
--*********************************************************************************************************************
function private.SymbolsWinAnim()

  private.SaveSymbols();
  private.Init_game2();

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME 2 *** () end;
--*********************************************************************************************************************
function private.Init_game2()
  
  local endfunc = function ()

    ObjSet( "anm_bossfight_swampmaster1", { visible = false, active = false } );
    common_impl.Lock( false );

  end;
  
  common_impl.Lock( true );
  ObjSet( "obj_bossfight_anims_balls", { input = true, visible = true } );
  ObjSet( "anm_bossfight_swampmaster2", { visible = true, active = true, frame = 0 } );
  ObjAnimate("anm_bossfight_swampmaster2", "alp", 0, 0, endfunc, {0, 3, 0, 0.3, 3, 1});
  ObjAnimate("anm_bossfight_swampmaster1", "alp", 0, 0, "", {0, 3, 1, 0.3, 3, 0});
  ObjSet( "tmr_bossfight_g2_circle", { active = true , playing = true, time = 3.2, endtrig = function () private.g2_anm_circle() end });
  common_impl.PlayAudio( "sfx", "common/audio/aud_bossfight_start_drop_balls", 0, "", 0 );

end; 
--*********************************************************************************************************************
function private.g2_anm_circle( )
  
  ObjSet( "tmr_bossfight_g2_circle_sound", { active = true , playing = true, time = 3.283, endtrig = function () common_impl.PlayAudio( "sfx", "common/audio/aud_bossfight_start_drop_balls", 0, "", 0 ); end });
  ObjSet( "tmr_bossfight_g2_circle", { active = true , playing = true, time = 10, endtrig = function () private.g2_anm_circle() end });
  private.drop_balls( 4 );

end;
--*********************************************************************************************************************
function private.drop_balls( num )
  
  if ( num ~= 0 ) then 
    
    ObjSet( "tmr_bossfight_for_g2", { active = true , playing = true, time = 1, endtrig = function () private.drop_balls( num - 1 ) end });

    local color = math.random( 1,3 );

    local step = 25;
    
    local speed = 0.029 + math.random(1,10)/1000;
    
    local mas_animations = { 
                             { 0, 0, 0, 0,    
                               speed*9, 0, 5*step , -4*step,   
                               speed*15, 0, 10*step, -5*step,
                               speed*22, 0, 12*step, -5*step, 
                               speed*28, 0, 12*step, -3*step,   
                               speed*50, 0, 5*step, 8*step,   
                               speed*90, 0, -12*step, 25*step },

                             { 0, 0, 0 ,0,    
                               speed*9, 0, -5*step , -4*step,   
                               speed*15, 0, -10*step, -5*step,
                               speed*22, 0, -12*step, -5*step, 
                               speed*28, 0, -12*step, -3*step,   
                               speed*50, 0, -5*step, 8*step,   
                               speed*90, 0, 12*step, 25*step },
--
                             { 0, 0, 0, 0,    
                               speed*9, 0, -4*step , 3*step,   
                               speed*15, 0, -8*step, 7*step,
                               speed*22, 0, -9*step, 9*step, 
                               speed*28, 0, -8*step, 11*step,   
                               speed*50, 0, -3*step, 12*step,   
                               speed*85, 0,  9*step, 10*step, 
                               speed*135, 0, 30*step, 4*step },

                             { 0, 0, 0, 0,    
                               speed*9, 0, 4*step , 3*step,   
                               speed*15, 0, 8*step, 7*step,
                               speed*22, 0, 9*step, 9*step, 
                               speed*28, 0, 8*step, 11*step,   
                               speed*50, 0, 3*step, 12*step,   
                               speed*85, 0,  -9*step, 10*step, 
                               speed*135, 0,  -30*step, 4*step },


    };

    if private.clone_names > 15 then 
    
      private.clone_names = 0;

    end;

    private.clone_names = private.clone_names + 1;

    ObjClone( "obj_bossfight_anims_ball_"..color, "_"..private.clone_names, true, "obj_bossfight_anims_balls" );
    
    local obj_name = "obj_bossfight_anims_ball_"..color.."_"..private.clone_names;

    ObjSet( obj_name, { pos_z = num, pos_x = 738, pos_y = 163, input = true, visible = true, event_mdown = function () private.ball_clk( color, obj_name ) end } );
    ObjAnimate( obj_name, "pos_xy", 0, 1, function () ObjDelete( obj_name ) end, mas_animations[ math.random( 1, #mas_animations ) ] );
    ObjAnimate( obj_name, "scale_xy", 0, 0, "",  { 0, 0, 0.6,0.6,   speed*50.2, 0, 1.5, 1.5  } );
    common_impl.PlayAudio( "sfx", "common/audio/aud_bossfight_drop_ball", 0, "", 0 );

  end;

end;

--*********************************************************************************************************************
--*********************************************************************************************************************
function private.ball_clk( ball_color, ball_name )
  
  if ( ball_color == 2 ) then

    private.ball_count = private.ball_count + 1;
    common_impl.PlayAudio( "sfx", "common/audio/aud_bossfight_clk_greenball", 0, "", 0 );
    private.Set_progress_bar();

    if ( private.CheckWinBalls() ) then

      private.Win();
 
      ObjSet("obj_bossfight_anims_balls", { input = false } );

    else

      private.SaveProgressBalls();

    end;

  elseif ( ball_color == 1) then

    private.ball_count = private.ball_count - 1;
    common_impl.PlayAudio( "sfx", "common/audio/aud_bossfight_clk_redball", 0, "", 0 );
    private.boss_hit();

    if ( private.ball_count < 0 ) then
    
      private.ball_count = 0;
      
    end;  

    private.SaveProgressBalls();

    private.Set_progress_bar();

  else

    common_impl.PlayAudio( "sfx", "common/audio/aud_bossfight_clk_whiteball", 0, "", 0 );

  end;

  ObjSet( ball_name, { input = false } );

  ObjAnimate( ball_name, "alp", 0, 0, "", { 0, 1, 1, 0.3, 1, 0 });

end
--*********************************************************************************************************************
function private.CheckWinBalls()

  if ( private.ball_count > 7 ) then

    return true;
  
  else
    
    return false;

  end;
 
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.SaveProgressBalls()

  ng_global.progress["ext"]["win_bossfight"].ball_count = private.ball_count;

end;
--*********************************************************************************************************************
function private.Set_progress_bar()


  local bar_crop_w = ObjGet( "spr_bossfight_energy" ).croprect_w;

  local over_pos_x = ObjGet( "spr_bossfight_energy_over" ).pos_x;
  
  cur_pos_x = private.Get_pos_bar();

  ObjAnimate( "spr_bossfight_energy", "croprect_w", 0, 0, "", { 0, 1, bar_crop_w, 0.3, 1, cur_pos_x });
  ObjAnimate( "spr_bossfight_energy_over", "pos_x", 0, 0, "", { 0, 1, over_pos_x, 0.3, 1, cur_pos_x*0.95 });

end;
--*********************************************************************************************************************
function private.Get_pos_bar()

  local step = 224/8;
  
  return step*private.ball_count + 1;

end;
--*********************************************************************************************************************
function private.boss_hit()

  ObjClone( "anm_bossfight_boos_hit", "_"..private.amn_clone_names, true , "obj_bossfight_boos_hit");

  local objname = "anm_bossfight_boos_hit_"..private.amn_clone_names;

  local endfunc = function ()

    ObjDelete( objname );

  end;
  
   ObjSet( objname, { playing = true, endtig = endfunc } )
  
  private.amn_clone_names = private.amn_clone_names + 1;

  if ( private.amn_clone_names  > 10 ) then
  
    private.amn_clone_names = 0;

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************