-- name=mg_mounds
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_mounds";
  
  ObjMultiSet({
     { "itm_mounds_board_1", { event_startdrag = function () private.MoundsStartDragItems( 'board_1' ) end, event_dragdrop = function () private.MoundsDropItems( 'board_1' ) end; } },
     { "itm_mounds_board_2", { event_startdrag = function () private.MoundsStartDragItems( 'board_2' ) end, event_dragdrop = function () private.MoundsDropItems( 'board_2' ) end; } },
     { "itm_mounds_board_3", { event_startdrag = function () private.MoundsStartDragItems( 'board_3' ) end, event_dragdrop = function () private.MoundsDropItems( 'board_3' ) end; } },
     { "itm_mounds_board_4", { event_startdrag = function () private.MoundsStartDragItems( 'board_4' ) end, event_dragdrop = function () private.MoundsDropItems( 'board_4' ) end; } },
     { "itm_mounds_board_5", { event_startdrag = function () private.MoundsStartDragItems( 'board_5' ) end, event_dragdrop = function () private.MoundsDropItems( 'board_5' ) end; } },
     { "itm_mounds_board_6", { event_startdrag = function () private.MoundsStartDragItems( 'board_6' ) end, event_dragdrop = function () private.MoundsDropItems( 'board_6' ) end; } },
     { "itm_mounds_board_7", { event_startdrag = function () private.MoundsStartDragItems( 'board_7' ) end, event_dragdrop = function () private.MoundsDropItems( 'board_7' ) end; } },
  });
  
  private.pos_boards = { -39, 37, 118, 201, 280, 361, 435 };

  private.checks = {     --таблица смежных применений, индексированы относительно имени доски
    { "1", "1_empty", "9_empty" },
    { "2", "4_empty", "2_empty", "1_empty" },
    { "3", "4_empty", "2_empty", "5_empty", "6_empty" },
    { "4", "6_empty", "8_empty", "7_empty", "3_empty", "2_empty", "1_empty" },
    { "5", "8_empty", "9_empty", "3_empty" },
    { "6", "9_empty", "8_empty", "7_empty" },
    { "7", "7_empty" }
  };
 
  private.ObjInputDisable();
  for i = 1, #private.checks[ 1 ] do
    ObjSet( "obj_mounds_board_"..private.checks[ 1 ][ i ], { input = true } );
  end;
  --------------------------------------------------------------------------------------------
  -- function win_mounds () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_mounds" ] = {
    type = "win",
    room = "rm_swamp",
    zz = "mg_mounds",
    zz_gate = "gmg_swamp_mounds"
  };
  local win_mounds = function ()

    if ( cmn.IsEventDone( "win_mounds" ) ) then  

      ObjDelete( "gmg_swamp_mounds" );

    else

      local key = 0;
      for i = 1, 7 do

        if ng_global.progress[ "ext" ][ "win_mounds" ].state[ i ] == 1 then

          ObjMultiSet({
            { "spr_mounds_board_"..i, { alp = 1 } },
            { "spr_mounds_board_"..i.."_shadow", { alp = 1 } },
            { "obj_mounds_board_"..i, { input = false } },
            { "itm_mounds_board_"..i, { alp = 0 } }
          });

          ObjDetach( "itm_mounds_board_"..i );
          ObjDetach( "itm_mounds_board_"..i.."_light" );

          key = key + 1;

          private.ObjInputDisable();

          if i ~= 7 then
            for j = 1, #private.checks[ i + 1 ] do
              local name = "obj_mounds_board_"..private.checks[ i + 1 ][ j ];
              ObjSet( name, { input = true } );
            end;
          end;

        end;

      end;

      for i = 1, ( 7 - key ) do

        ObjSet( "itm_mounds_board_"..( i + key ), { pos_x = private.pos_boards[ i ] } );
        ObjSet( "itm_mounds_board_"..( i + key ).."_light", { pos_x = private.pos_boards[ i ] } );

      end;

    end;

  end;
  ---------------------------------------------------------------------------------------------
  local start_mounds_func = function ()

    if ( not cmn.IsEventDone( "win_mounds" ) ) then
             
      --

    end;

  end;   
  ---------------------------------------------------------------------------------------------
  local win_mounds_loc = function ()

    if ( cmn.IsEventDone( "win_mounds" ) ) then
      ObjDelete( "anm_swamp_robin_mg" );   
      ObjSet( "anm_swamp_robin_loc", { alp = 1, playing = true });  
    end;

  end;   

  cmn.AddSubscriber( "win_mounds", win_mounds );
  cmn.AddSubscriber( "win_mounds", start_mounds_func, "mg_mounds" );
  cmn.AddSubscriber( "win_mounds", win_mounds_loc, "rm_swamp" );

  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_mounds = function ()

  local effects_table = 
  {
    "obj_mounds_layers_2",
    "vid_mounds_sink_swamp",
    "spr_mounds_fog"
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_mounds", update_performance_mode_mounds, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  
  private.MoundsAnimation();

end;
--*********************************************************************************************************************
-- function *** OPEN, CLOSE MG *** () end;
--*********************************************************************************************************************
  function public.Open() 

  common_impl.VisitMapRoom( "swamp" );

    if not cmn.IsEventDone( "win_mounds" ) then

      cmn.MiniGameShow();
      common_impl.PassingMgStart();
    
    end;
    
    int_slider.InitSlider( private.room_objname );
    
  end;
  --*********************************************************************************************************************
  function public.PreOpen()

    if ( not cmn.IsEventStart( "win_mounds" ) ) then

      ng_global.progress[ "ext" ][ "win_mounds" ].state = { 0, 0, 0, 0, 0, 0, 0 };
      ng_global.progress[ "ext" ][ "win_mounds" ].boards_array = {};

    end;

    --interface.InvestigationButtonCheck();

    local items = {};
    interface.TaskPanelShow( items );
    int_taskpanel_impl.HideTextPanel( "mounds" );
    common_impl.EnvPlay( { "common/audio/aud_mounds_env" }, "", 0.5 );
    ObjSet( "obj_mounds_taskpanel", { active = true, visible = true, input = true, pos_z = 1, pos_x = -190, pos_y = 37 } ); 
    
  end;
  --*********************************************************************************************************************
  function public.Close()

    common_impl.StopAudio( "env", "common/audio/aud_mounds_env", 0.2 );

  end;
  --*********************************************************************************************************************
  function public.PreClose()

    if not cmn.IsEventDone( "win_mounds" ) then

      interface.TaskPanelHide();
      cmn.MiniGameHide();
      common_impl.PassingMgStop();

    else

      int_taskpanel_impl.ShowTextPanel( "mounds" );

    end;
    
  end;
--*********************************************************************************************************************
-- function *** SKIP, RESET, WIN FUNC*** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function public.Reset()
   
    common_impl.Lock( true );

    for i = 1, 9 do

      ObjAnimate( "spr_mounds_sink_tussock_"..i, "alp", 0, 0, "", 
      { 
        0.0, 0, ObjGet( "spr_mounds_sink_tussock_"..i ).alp, 
        0.2, 0, 1 
      } );      

      ObjAnimate( "spr_mounds_sink_reflect_"..i, "alp", 0, 0, "", 
      { 
        0.0, 0, ObjGet( "spr_mounds_sink_reflect_"..i ).alp, 
        0.2, 0, 1 
      } );  

      ObjAnimate( "vid_mounds_sink_tussock_"..i, "alp", 0, 0, "", 
      { 
        0.0, 0, ObjGet( "vid_mounds_sink_tussock_"..i ).alp, 
        0.2, 0, 0 
      } );  

    end;


    for j = 1, 6 do

      ObjAnimate( "spr_mounds_board_"..j, "alp", 0, 0, "", 
      { 
        0.0, 0, ObjGet( "spr_mounds_board_"..j ).alp, 
        0.3, 0, 0 
      } );

      ObjAnimate( "spr_mounds_board_"..j.."_shadow", "alp", 0, 0, "", 
      { 
        0.0, 0, ObjGet( "spr_mounds_board_"..j.."_shadow" ).alp, 
        0.3, 0, 0 
      } );

    end;

    ObjAnimate( "spr_mounds_board_7", "alp", 0, 0, "", 
    { 
      0.0, 0, ObjGet( "spr_mounds_board_7" ).alp, 
      0.3, 0, 0 
    } );

    ObjAnimate( "spr_mounds_board_7_shadow", "alp", 0, 0, private.ResetEnd, 
    { 
      0.0, 0, ObjGet( "spr_mounds_board_7_shadow" ).alp, 
      0.3, 0, 0 
    } );

  end;
  --*********************************************************************************************************************
  function private.ResetEnd()
    
    ng_global.progress[ "ext" ][ "win_mounds" ].boards_array = {}; 
    local mounds_items = {};

    for i = 1, 7 do
        
      if ng_global.progress[ "ext" ][ "win_mounds" ].state[ i ] == 1 then

        ObjAttach( "itm_mounds_board_"..i, "obj_mounds_taskpanel" );
        ObjAttach( "itm_mounds_board_"..i.."_light", "obj_mounds_taskpanel" );

      end;

      ObjMultiSet({
        { "obj_mounds_board_"..i, { input = true } },
        { "spr_mounds_board_"..i, { alp = 0 } },
        { "spr_mounds_board_"..i.."_shadow", { alp = 0 } },
        { "itm_mounds_board_"..i, { alp = 1, pos_x = private.pos_boards[ i ] } },
        { "itm_mounds_board_"..i.."_light", { alp = 1, pos_x = private.pos_boards[ i ] } }
      });

    end;

    private.ObjInputDisable();

    for i = 1, #private.checks[ 1 ] do
      ObjSet( "obj_mounds_board_"..private.checks[ 1 ][ i ], { input = true } );
    end;

    ng_global.progress[ "ext" ][ "win_mounds" ].state = { 0, 0, 0, 0, 0, 0, 0 };    

    common_impl.Lock( false );

  end;
  --*********************************************************************************************************************
  function public.Skip()
    port.skip_mg = true;
    interface.TaskPanelHide();
    common_impl.Lock( true );

    local tme = 0.0;

    local func_after = function()

      private.Win( 'skip' );

    end;

    local endfunc = function ( tmr_name )

      common_impl.PlayAudio( "sfx", "common/audio/aud_mounds_drop" );
      ObjDelete( tmr_name );
  
    end;

    for i = 1, 6 do

      if ng_global.progress[ "ext" ][ "win_mounds" ].state[ i ] == 0 then

        tme = tme + 0.3;

        ObjCreate( "tmr_mounds_anim_board"..i, "timer" );  
        ObjAttach( "tmr_mounds_anim_board"..i, "mg_mounds" );
        ObjSet( "tmr_mounds_anim_board"..i, { playing = true, time = tme - 0.05, endtrig = function () endfunc( "tmr_mounds_anim_board"..i ) end; } );       

        ObjAnimate( "spr_mounds_board_"..i, "alp", 0, 0, "", 
        { 
          0.0,       0, 0.0, 
          tme,       0, 0.0,
          tme + 0.3, 0, 1.0,
          tme + 0.6, 0, 1.0 
     
        } );

        ObjAnimate( "spr_mounds_board_"..i.."_shadow", "alp", 0, 0, "", 
        {
          0.0,       0, 0.0, 
          tme,       0, 0.0,
          tme + 0.3, 0, 1.0,
          tme + 0.6, 0, 1.0
        } );
                        
      end;

    end;

    tme = tme + 0.3;

    ObjCreate( "tmr_mounds_anim_last_board", "timer" );  
    ObjAttach( "tmr_mounds_anim_last_board", "mg_mounds" );
    ObjSet( "tmr_mounds_anim_last_board", { playing = true, time = tme - 0.05, endtrig = function () endfunc( "tmr_mounds_anim_last_board" ) end; } ); 

    ObjAnimate( "spr_mounds_board_7", "alp", 0, 0, "", 
    { 
      0.0,       0, 0.0, 
      tme,       0, 0.0,
      tme + 0.3, 0, 1.0,
      tme + 0.6, 0, 1.0      
    } );

    ObjAnimate( "spr_mounds_board_7_shadow", "alp", 0, 0, func_after, 
    {
      0.0,       0, 0.0, 
      tme,       0, 0.0,
      tme + 0.3, 0, 1.0,
      tme + 0.6, 0, 1.0
    } );

  end;
  --*********************************************************************************************************************
  function private.WinEnd()

    common_impl.Lock( false );
    cmn.MiniGameHide();
    cmn.SetEventDone( "win_mounds" );
    cmn.CallEventHandler( "win_mounds" );
    cmn.CallEventHandler( "win_mounds_loc" );
    common_impl.PassingMgWin();
    cmn.GotoRoom( "rm_swamp" );

  end;
  --*********************************************************************************************************************
  function private.Win( is_skip )
    
    if not is_skip then

      interface.TaskPanelHide();

    end;

    private.WinEnd();

  end;
  --*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER FUNC *** () end;
--*********************************************************************************************************************
  function private.ObjInputDisable()

    for i = 1, 7 do
      ObjSet( "obj_mounds_board_"..i, { input = false } );
    end;
    for i = 1, 9 do
      ObjSet( "obj_mounds_board_"..i.."_empty", { input = false } );
    end;  

  end;
--*********************************************************************************************************************
  function private.MoundsStartDragItems( in_name )

    local item_name = "itm_mounds_"..in_name;
    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx" );
    ObjSet( item_name, { scale_x = 1.0, scale_y = 1.0 } );

  end;
--*********************************************************************************************************************
  function private.MoundsDropItems( in_name )

    local item_name        = "itm_mounds_"..in_name;
    local item_object_name = "obj_"..common.GetObjectName( item_name );
    local spr_item_name = "spr_"..common.GetObjectName( item_name );
    local spr_item_name_shadow = "spr_"..common.GetObjectName( item_name ).."_shadow";
    local number_item_name = tonumber( common.GetObjectName( in_name ) );
    local item_empty_name = "vid_mounds_sink_tussock_"..number_item_name;
    common_impl.PlayAudio( "sfx", "common/audio/aud_mounds_drop" );
    if ( ApplyObj( item_name, item_object_name ) ) then
      
      if ( ( number_item_name - 1 ) > 0 and ng_global.progress[ "ext" ][ "win_mounds" ].state[ number_item_name - 1 ] == 1 ) or
        ( number_item_name == 1 ) then
        
        common_impl.Lock( true );

        ng_global.progress[ "ext" ][ "win_mounds" ].start = 1;

        --ANIMATION SHOW BOARD
        local item_use = { item = item_name, object = item_object_name };

        table.insert( ng_global.progress[ "ext" ][ "win_mounds" ].boards_array, item_use );
        ng_global.progress[ "ext" ][ "win_mounds" ].state[ number_item_name ] = 1;
        
        ObjSet( item_name, { alp = 0, scale_x = 0.7, scale_y = 0.7 } );
        ObjDetach( item_name );
        ObjDetach( item_name.."_light" );

        ObjSet( item_object_name, { input = false } );    

        ObjAnimate( spr_item_name, "alp", 0, 0, "", 
        { 
          0.0, 0, 0, 
          0.3, 0, 1 
        } );

        ObjAnimate( spr_item_name_shadow, "alp", 0, 0, private.MoundsDropEndItems, 
        { 
          0.0, 0, 0, 
          0.3, 0, 1 
        } );

        --ANIMATION CHANGE POSITION INV OBJECT
        for i = number_item_name, 6 do

          local cur_name = "itm_mounds_board_"..( i + 1 );
          local cur_pos = ObjGet( cur_name ).pos_x;

          ObjAnimate( cur_name, "pos_x", 0, 0, "", 
          { 
            0.0, 3, cur_pos, 
            0.3, 3, private.pos_boards[ ( i + 1 - number_item_name ) ] 
          } );

          ObjAnimate( cur_name.."_light", "pos_x", 0, 0, "", 
          { 
            0.0, 3, cur_pos, 
            0.3, 3, private.pos_boards[ ( i + 1 - number_item_name ) ] 
          } );

        end;

        return;
      
      else     
        
        ObjSet( item_name, { scale_x = 0.7, scale_y = 0.7 } );
    
      end;

    else
            
      ObjSet( item_name, { scale_x = 0.7, scale_y = 0.7 } );
      
    end;    

    for i = 1, 9 do

      local drop_name = "obj_mounds_board_"..i.."_empty";
      if ( ApplyObj( item_name, drop_name ) and ObjGet( drop_name ).input ) then
        
        common_impl.Lock( true );
        --ANIMATION SINK TUSSOCK
        
        ObjAnimate( "spr_mounds_sink_tussock_"..i, "alp", 0, 0, "", 
        { 
          0.0, 0, 1, 
          0.2, 0, 0 
        } );

        ObjAnimate( "spr_mounds_sink_reflect_"..i, "alp", 0, 0, "", 
        { 
          0.0, 0, 1, 
          0.2, 0, 0 
        } );

        ObjAnimate( "vid_mounds_sink_tussock_"..i, "alp", 0, 0, "", 
        { 
          0.0, 0, 0, 
          0.2, 0, 1 
        } );

        VidPlay( "vid_mounds_sink_tussock_"..i, public.Reset );
        common_impl.PlayAudio( "sfx", "common/audio/aud_mounds_drop_wrong" );
        return;
        
      end;

    end;

    common_impl.WrongApply();

  end;
  -------------------------------------------------------------------------------------
  function private.MoundsDropEndItems()

    common_impl.Lock( false );

    local win = true;
    for i = 1, 7 do

      if ng_global.progress[ "ext" ][ "win_mounds" ].state[ i ] == 0 then

        win = false;
        break;

      else

        private.ObjInputDisable();

        if i ~= 7 then
          for key = 1, #private.checks[ i + 1 ] do
            ObjSet( "obj_mounds_board_"..private.checks[ i + 1 ][ key ], { input = true } );
          end;        
        end;

      end;

    end;

    if win then
  
      private.Win();
  
    end;
    
  end;
--*********************************************************************************************************************
  function private.MoundsAnimation()
    
    ObjAnimate( "spr_mounds_fog", "alp", 1, 0, "", 
    {
      0.0, 0, 1.0, 
      1.8, 0, 0.5,
      2.9, 0, 0.9,
      4.0, 3, 0.45, 
      5.7, 2, 1.0
    } ); 

    ObjAnimate( "spr_mounds_branch_1", "ang", 1, 0, "", 
    {
      0.0, 3, -0.04,  
      4.0, 3, 0.03,
      7.0, 3, -0.04
    } ); 

    ObjAnimate( "spr_mounds_branch_2", "ang", 1, 0, "", 
    {
      0.0, 3, 0.03,  
      4.4, 3, -0.02,
      7.0, 3, 0.03
    } ); 

    ObjAnimate( "spr_mounds_branch_3", "ang", 1, 0, "", 
    {
      0.0, 3, -0.04,  
      4.8, 3, 0.02,
      7.0, 3, -0.04
    } ); 

    ObjAnimate( "spr_mounds_bushes_1", "ang", 1, 0, "", 
    {
      0.0, 3, 0.02,  
      3.0, 3, -0.02,
      6.0, 3, 0.02
    } ); 

    ObjAnimate( "spr_mounds_bushes_2", "ang", 1, 0, "", 
    {
      0.0, 3, 0.02,  
      4.0, 3, -0.02,
      8.0, 3, 0.02
    } ); 

  end;
--*********************************************************************************************************************
