-- name=levelext

function public.Start ( param )


  --  interface.WidgetAdd( InterfaceWidget_Pause, 10000000 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 12 );

  if IsCollectorsEdition() then

    interface.WidgetAdd( InterfaceWidget_BtnGuide, 13 );

  end;

  interface.WidgetAdd( InterfaceWidget_BtnHint, 9  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 12 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 10 );

  interface.WidgetAdd( InterfaceWidget_Effects, 11 );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 7 );

  interface.WidgetAdd( InterfaceWidget_DialogHo );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8);

  interface.WidgetAdd( InterfaceWidget_ItemPanel );
  interface.WidgetAdd( InterfaceWidget_Popup );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog );

  interface.WidgetAdd( InterfaceWidget_DialogVideo );
  interface.WidgetAdd( InterfaceWidget_DialogStory );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 8 );

  if (tostring(GetPlatform())~= "ios") then
    interface.WidgetAdd( InterfaceWidget_StrategyGuide );
  end;
  
  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial );

  interface.WidgetAdd( InterfaceWidget_Map, 26  );

  interface.PanelNotificationAdd();
  interface.DeployInvAdd( 9 );
  interface.DialogHintAdd();
  interface.PanelProvideAdd( 10 );
  interface.BtnProvideAdd( 0 );
  interface.EvidenceAdd( 18 );
  interface.DialogEvidenceAdd( 20 );
  interface.InvestigationButtonAdd( 17 ); 
  interface.SliderAdd( -1 );
  interface.ProvideAdd( 8 );
  interface.ButtonTaskAdd( 1 );
  interface.DialogTaskAdd( 20 );  
  interface.DiaryAdd( 28 );
  interface.ProvideEyeAdd( 30 );
  
  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    interface.BtnCollectibles2Add( 25 );
    interface.BtnCollectiblesAdd( 25 );
    interface.AchievementsAdd( 25 );
    interface.BtnMorphAdd( 25 );

  end;

  private.Init();
  ModLoad( "assets/levels/levelext/mod_levelext_inv" );
  levelext_inv.Init();

  common.LevelLoad( "levelext", "ext", "rm_fork_4", param, private.menu_moduls );
  common_impl.SetCollectEventDone();
  common_impl.SetMorphEventDone();

  common_impl.Collectibles2CoinsLoad();
  common_impl.UpdatePerformanceMode();

  private.TutorialSetParams();
  interface.KeyUpdate();

  --event_show_investigation = "beg_levelext";

  --interface.InvestigationButtonCheck();
  
  --interface.PanelProvideShow();
  
end;
    
function private.Init ()

  game = {};
  game.room_names =
  {
  "rm_fork_4"
  ,"rm_square_4"
  ,"rm_livingroom_4"
  ,"ho_pharmacybit"
  ,"rm_abandoneddistrict_4"
  ,"rm_swamp"
  ,"ho_wagonette"
  ,"mg_mounds"
  ,"mg_extinctlantern"
  ,"mg_amplification"
  ,"rm_sheriffshouse_4"
  ,"rm_deathtrap"
  ,"ho_rucksack"
  ,"rm_forgottenbastille"
  ,"ho_intent"
  ,"rm_swampmasterdwelling"
  ,"mg_bossfight"
  };

  game.progress_names_room =
  {
   { "beg_levelext"                             }

  ,{ "opn_fork_4"                               }
  ,{ "see_introext"                             }
  ,{ "vid_fork_4_escape",                       "rm_fork_4",                { "opn_fork_4"                           }}
  ,{ "dlg_fork_4_danger_4",                     "rm_fork_4",                { "vid_fork_4_escape"                    }}
  ,{ "vid_fork_4_tonightsville_4",              "rm_fork_4",                { "dlg_fork_4_danger_4"                  }}

  ,{ "get_chip_4",                              "rm_fork_4",                { "vid_fork_4_tonightsville_4"           }}
  ,{ "use_chip_4",                              "rm_fork_4",                { "get_chip_4"                           }}
  ,{ "win_motorcycle",                          "rm_fork_4",                { "use_chip_4"                           }}
  ,{ "get_blade",                               "rm_fork_4",                { "win_motorcycle"                       }}
  ,{ "use_blade",                               "rm_fork_4",                { "get_blade"                            }}
  ,{ "get_owl_4",                               "rm_fork_4",                { "use_blade"                            }}
  ,{ "use_owl_4_1",                             "rm_fork_4",                { "get_owl_4"                            }}
  ,{ "clk_wiered",                              "rm_fork_4",                { "use_owl_4_1"                          }}
  ,{ "get_armsaw",                              "rm_fork_4",                { "clk_wiered"                           }}
  ,{ "get_valve_4",                             "rm_fork_4",                { "clk_wiered"                           }}
  ,{ "use_armsaw",                              "rm_fork_4",                { "get_armsaw"                           }}

  ,{ "opn_square_4",                            "rm_fork_4",                { "use_armsaw"                           }}
  ,{ "vid_square_4_oldman",                     "rm_square_4",              { "opn_square_4"                         }}
  ,{ "get_wrench_4",                            "rm_square_4",              { "vid_square_4_oldman"                  }}
  ,{ "use_wrench_4",                            "rm_fork_4",                { "get_wrench_4"                         }}
  ,{ "get_oar",                                 "rm_fork_4",                { "use_wrench_4"                         }}
  ,{ "use_oar",                                 "rm_square_4",              { "get_oar"                              }}
  ,{ "get_nailpuller_4",                        "rm_square_4",              { "use_oar"                              }}
  ,{ "get_bagpiece_1",                          "rm_square_4",              { "opn_square_4"                         }}
  ,{ "use_nailpuller_4",                        "rm_square_4",              { "get_nailpuller_4"                     }}

  ,{ "opn_livingroom_4",                        "rm_square_4",              { "use_nailpuller_4"                     }}
  ,{ "clk_zz_toys",                             "rm_livingroom_4",          { "opn_livingroom_4"                     }}
  ,{ "clk_zz_cupboard_4",                       "rm_livingroom_4",          { "opn_livingroom_4"                     }}
  ,{ "clk_zz_firstaidkit",                      "rm_livingroom_4",          { "opn_livingroom_4"                     }}
  ,{ "use_owl_4_2",                             "rm_livingroom_4",          { "get_owl_4", "clk_zz_cupboard_4"       }}
  ,{ "get_case",                                "rm_livingroom_4",          { "use_owl_4_2"                          }}
  ,{ "get_button_4",                            "rm_livingroom_4",          { "use_owl_4_2"                          }}
  ,{ "use_button_4",                            "rm_livingroom_4",          { "get_button_4", "clk_zz_toys"          }}
  ,{ "clk_switcher",                            "rm_livingroom_4",          { "use_button_4"                         }}
  ,{ "get_caduseus",                            "rm_livingroom_4",          { "clk_switcher"                         }}
  ,{ "get_bagpiece_2",                          "rm_livingroom_4",          { "clk_switcher"                         }}
  ,{ "get_boxpiece",                            "rm_livingroom_4",          { "clk_switcher"                         }}
  ,{ "use_caduseus",                            "rm_livingroom_4",          { "get_caduseus", "clk_zz_firstaidkit"   }}
  ,{ "opn_pharmacybit"                          }
  ,{ "win_pharmacybit",                         "rm_livingroom_4",          { "use_caduseus"                      }}

  ,{ "use_boxpiece",                            }
  ,{ "win_case"                                 }
  ,{ "get_toolkey",                             }
  ,{ "use_toolkey",                             "rm_square_4",              { "get_toolkey"                          }}
  ,{ "clk_garage_key",                             "rm_square_4",           { "use_toolkey"                          }}
  ,{ "get_pruners",                             "rm_square_4",              { "clk_garage_key"                          }}
  ,{ "get_bagpiece_3",                          "rm_square_4",              { "clk_garage_key"                          }}
  ,{ "use_pruners",                             "rm_square_4",              { "get_pruners"                          }}
  ,{ "use_bagpiece_1",                          "rm_square_4",              { "get_bagpiece_1", "use_pruners"                       }}
  ,{ "use_bagpiece_2",                          "rm_square_4",              { "get_bagpiece_2", "use_pruners"                       }}
  ,{ "use_bagpiece_3",                          "rm_square_4",              { "get_bagpiece_3", "use_pruners"                       }}
  ,{ "get_clip_4",                              "rm_square_4",              { "use_bagpiece_1", "use_bagpiece_2",
                                                                              "use_bagpiece_3"                       }}
  ,{ "get_awl_4",                               "rm_square_4",              { "use_bagpiece_1", "use_bagpiece_2",
                                                                              "use_bagpiece_3"                       }}
  ,{ "clk_clip_4",                              }
  ,{ "get_unbentclip",                          }
  ,{ "use_unbentclip",                          "rm_fork_4",                { "get_unbentclip"                       }}
  ,{ "get_salammoniacbottle",                   "rm_fork_4",                { "use_unbentclip"                       }}
  ,{ "use_tweezers_4",                          "rm_fork_4",                { "get_salammoniacbottle"                }}
  ,{ "get_tweezerscotton",                      "rm_fork_4",                { "use_tweezers_4"                       }}
  ,{ "use_awl_4",                               }
  ,{ "get_salammoniac",                         }
  ,{ "use_salammoniac",                         }
  ,{ "get_salammoniaccotton",                   }
  ,{ "use_salammoniaccotton",                   "rm_square_4",              { "get_salammoniaccotton"                }} 
  -- диалог Старца, отдает фонарь
  ,{ "win_extinctlantern",                      "mg_extinctlantern"         }
  ,{ "get_magiclantern_1"                       }
  ,{ "use_magiclantern_1",                      "rm_square_4",              { "get_magiclantern_1"                   }}
  --,{ "get_extinctlantern2",                     "rm_square_4",              { "use_magiclantern_1"                   }}

  ,{ "opn_abandoneddistrict_4",                 "rm_square_4",              { "use_magiclantern_1"                   }}
  ,{ "vid_abandoneddistrict_4_robintrouble",    "rm_abandoneddistrict_4",   { "opn_abandoneddistrict_4"              }}
  ,{ "use_owl_4_3",                             "rm_abandoneddistrict_4",   { "vid_abandoneddistrict_4_robintrouble" }}
  ,{ "get_shopemblem",                          "rm_abandoneddistrict_4",   { "use_owl_4_3" }}
  ,{ "get_bluntsawdisk",                        "rm_abandoneddistrict_4",   { "vid_abandoneddistrict_4_robintrouble" }}
  ,{ "get_brace",                               "rm_abandoneddistrict_4",   { "vid_abandoneddistrict_4_robintrouble" }}
  ,{ "use_shopemblem",                          "rm_abandoneddistrict_4",   { "get_shopemblem"                       }}
  ,{ "win_shop_4",                              "rm_abandoneddistrict_4",   { "use_shopemblem"                       }}
  ,{ "get_van",                                 "rm_abandoneddistrict_4",   { "win_shop_4"                           }}
  ,{ "get_ring_4",                              "rm_abandoneddistrict_4",   { "win_shop_4"                           }}
  ,{ "use_van",                                 "rm_livingroom_4",          { "get_van"                              }}
  ,{ "get_nippers_4",                           "rm_livingroom_4",          { "use_van"                              }}
  ,{ "get_file_4",                              "rm_livingroom_4",          { "use_van"                              }}
  ,{ "get_auger",                               "rm_livingroom_4",          { "use_van"                              }}
  ,{ "use_nippers_4_1",                         "rm_abandoneddistrict_4",   { "get_nippers_4"                        }}
  ,{ "get_knife_4",                             "rm_abandoneddistrict_4",   { "use_nippers_4_1"                      }}
  ,{ "get_brokendisksaw",                       "rm_abandoneddistrict_4",   { "use_nippers_4_1"                      }}
  ,{ "use_file_4",                              }
  ,{ "get_sawdisk",                             }
  ,{ "use_ring_4",                              "rm_livingroom_4",          { "get_ring_4"                           }}
  ,{ "get_bottle_4",                            "rm_livingroom_4",          { "use_ring_4"                           }}
  ,{ "use_auger",                               }
  ,{ "get_workingbrace",                        }
  ,{ "use_workingbrace",                        "rm_fork_4",                { "get_workingbrace"                     }}
  ,{ "use_bottle_4",                            "rm_fork_4",                { "use_workingbrace"                     }}
  ,{ "get_fuelbottle",                          "rm_fork_4",                { "use_bottle_4"                         }}
  ,{ "use_sawdisk",                             }
  ,{ "use_fuelbottle",                          }
  ,{ "get_disksaw",                             }
  ,{ "use_disksaw",                             "rm_abandoneddistrict_4",   { "get_disksaw"                          }}

  ,{ "opn_swamp"                                }
  ,{ "get_collect_morph_item_4_1" }
  ,{ "get_collect_item_4_1"                     }
  ,{ "vid_swamp_willowhisps",                   "rm_swamp",                 { "opn_swamp"                            }}
  ,{ "get_chopper",                             "rm_swamp",                 { "vid_swamp_willowhisps"                }}
  ,{ "use_nippers_4_2",                         "rm_swamp",                 { "opn_swamp", "get_nailpuller_4"        }}
  ,{ "opn_wagonette",                           }
  ,{ "win_wagonette",                           "rm_swamp",                 { "use_nippers_4_2"                        }}
  ,{ "get_chump",                               "rm_swamp",                 { "opn_swamp"                            }}
  ,{ "use_knife_4",                             "rm_swamp",                 { "opn_swamp", "get_knife_4"             }}
  ,{ "get_drymoss",                             "rm_swamp",                 { "use_knife_4"                          }}
  ,{ "use_chump",                               "rm_abandoneddistrict_4",   { "get_chump"                            }}
  ,{ "use_chopper",                             "rm_abandoneddistrict_4",   { "use_chump", "get_chopper"             }}

  ,{ "get_splinter",                            "rm_abandoneddistrict_4",   { "use_chump", "use_chopper"             }}
  ,{ "use_wood_4",                              "rm_abandoneddistrict_4",   { "use_chopper"                           }}
  ,{ "use_drymoss",                             "rm_abandoneddistrict_4",   { "get_drymoss", "use_wood_4"            }}
  ,{ "use_bowdrill",                            "rm_abandoneddistrict_4",   { "use_drymoss", "win_wagonette"         }}

  --,{ "win_fire_4",                              "rm_abandoneddistrict_4",   { "use_wood_4", "use_drymoss", "use_bowdrill" }} --DR пока не ммг
  ,{ "use_splinter",                            "rm_abandoneddistrict_4",   { "get_splinter", "use_bowdrill"                         }}
  --,{ "get_litchip",                             "rm_abandoneddistrict_4",   { "use_splinter"                         }}
  
  ,{ "clk_extinctlantern2_open",                             }
  ,{ "use_litchip",                             }
  ,{ "clk_extinctlantern2_close",                             }
  ,{ "get_magiclantern_2"                       }
  ,{ "use_magiclantern_2",                      "rm_swamp",                 { "get_magiclantern_2"                   }}
  ,{ "win_mounds",                              "rm_swamp",                 { "use_magiclantern_2" }}
  ,{ "vid_swamp_salvationrobin"                 }

  ,{ "dlg_swamp_newtask",                       "rm_swamp",                 { "win_mounds" }}
  ,{ "use_seeker_1",                            "rm_swamp",                 { "dlg_swamp_newtask"                            }}
  ,{ "get_charmpiece_1",                        "rm_swamp",                 { "use_seeker_1"                          }}
  ,{ "use_seeker_2",                            "rm_abandoneddistrict_4",   { "dlg_swamp_newtask"                            }}
  ,{ "get_charmpiece_2",                        "rm_abandoneddistrict_4",   { "use_seeker_2"                          }}
  ,{ "use_seeker_3",                            "rm_livingroom_4",          { "dlg_swamp_newtask"                            }}
  ,{ "get_charmpiece_3",                        "rm_livingroom_4",          { "use_seeker_3"                          }}
  ,{ "use_seeker_4",                            "rm_square_4",              { "dlg_swamp_newtask"                            }}
  ,{ "get_charmpiece_4",                        "rm_square_4",              { "use_seeker_4"                          }}
  ,{ "use_seeker_5",                            "rm_fork_4",                { "dlg_swamp_newtask"                            }}
  ,{ "get_charmpiece_5",                        "rm_fork_4",                { "use_seeker_5"                          }}
  ,{ "use_charmpiece_1",                        }
  ,{ "use_charmpiece_2",                        }
  ,{ "use_charmpiece_3",                        }
  ,{ "use_charmpiece_4",                        }
  ,{ "use_charmpiece_5",                        }
  ,{ "get_lightcharm",                          }
  ,{ "vid_evilspirit_scare",                    "rm_square_4"               }

  ,{ "use_lightcharm",                          "rm_square_4",              { "get_lightcharm"                        }}
  ,{ "opn_sheriffshouse_4",                     "rm_square_4",              { "use_lightcharm"                             }}
  ,{ "opn_deathtrap",                           "rm_sheriffshouse_4",       { "opn_sheriffshouse_4"                             }}
  ,{ "get_collect_item_4_2"                     }
  ,{ "get_collect_morph_item_4_2" }
  ,{ "get_cash",                                "rm_deathtrap",             { "opn_deathtrap"                         }}
  ,{ "use_cash_1",                              "rm_abandoneddistrict_4",   { "get_cash"                              }}
  ,{ "use_cash_2",                              "rm_abandoneddistrict_4",   { "get_cash"                              }}
  ,{ "get_brokentank",                          "rm_abandoneddistrict_4",   { "use_cash_1"                            }}
  ,{ "get_hammer_4",                            "rm_abandoneddistrict_4",   { "use_cash_2"                            }}
  ,{ "use_valve_4",                             }
  ,{ "get_nitrogentank",                        }
  ,{ "use_nitrogentank",                        "rm_deathtrap",             { "get_nitrogentank"                      }}
  ,{ "get_torch",                               "rm_deathtrap",             { "use_nitrogentank"                      }}
  ,{ "get_powersymbol_1",                       "rm_deathtrap",             { "use_nitrogentank"                      }}
  ,{ "use_hammer_4",                            "rm_deathtrap",             { "use_nitrogentank", "get_hammer_4"      }}
  ,{ "get_shopkey",                             "rm_deathtrap",             { "use_hammer_4"                          }}
  ,{ "use_shopkey",                             "rm_abandoneddistrict_4",   { "get_shopkey"                           }}
  ,{ "get_firetorch",                           "rm_abandoneddistrict_4",   { "use_shopkey"                           }}
  ,{ "get_clownpiece",                          "rm_abandoneddistrict_4",   { "use_shopkey"                           }}
  ,{ "get_matches_4",                           "rm_abandoneddistrict_4",   { "use_shopkey"                           }}
  ,{ "use_matches_4_1",                         }
  ,{ "get_burningfire",                         }
  ,{ "use_burningfire",                         "rm_deathtrap",             { "get_burningfire"                       }}
  ,{ "use_owl_4_4",                             "rm_deathtrap",             { "use_burningfire"                       }} 
  
  ,{ "use_clownpiece",                          "rm_livingroom_4",          { "get_clownpiece"                        }}
  ,{ "get_net_4",                               "rm_livingroom_4",          { "use_clownpiece"                        }}
  ,{ "use_matches_4_2",                         }
  ,{ "get_burningtorch",                        }
  ,{ "use_burningtorch_1",                      "rm_deathtrap",             { "get_burningtorch"                      }}
  ,{ "use_net_4",                               "rm_deathtrap",             { "use_burningtorch_1", "get_net_4"       }}
  ,{ "get_powersymbol_3",                       "rm_deathtrap",             { "use_net_4"                             }}

  ,{ "vid_sheriffshouse_4_handmarshes",         "rm_sheriffshouse_4",       { "opn_sheriffshouse_4"                   }}
  ,{ "use_powersymbol_1",                       "rm_sheriffshouse_4",       { "vid_sheriffshouse_4_handmarshes", 
                                                                              "get_powersymbol_1"                     }}
  ,{ "use_powersymbol_2",                       "rm_sheriffshouse_4",       { "vid_sheriffshouse_4_handmarshes", 
                                                                              "use_owl_4_4"                     }}
  ,{ "use_powersymbol_3",                       "rm_sheriffshouse_4",       { "vid_sheriffshouse_4_handmarshes", 
                                                                              "get_powersymbol_3"                     }}
  ,{ "vid_sheriffshouse_4_exemption",           }

  ,{ "opn_rucksack"                             }
  ,{ "win_rucksack",                            "rm_sheriffshouse_4",       { "vid_sheriffshouse_4_exemption"                          }}
  ,{ "dlg_sheriffshouse_4_simpleton",           "rm_sheriffshouse_4",       { "win_rucksack"                          }}
  ,{ "dlg_sheriffshouse_4_simpleton_2",         "rm_sheriffshouse_4",       { "dlg_sheriffshouse_4_simpleton"         }}
  ,{ "use_amplifier",                           "mg_amplification"          }
  ,{ "win_amplification",                       }
  ,{ "get_enhacnedmagiclantern",                }
  ,{ "get_scrap",                               "rm_sheriffshouse_4",       { "get_enhacnedmagiclantern"              }}
  ,{ "get_revolver_4",                          "rm_sheriffshouse_4",       { "get_enhacnedmagiclantern"              }}
  ,{ "get_leakybucket",                         "rm_sheriffshouse_4",       { "get_enhacnedmagiclantern"              }}
  ,{ "use_enhacnedmagiclantern",                "rm_deathtrap",             { "get_enhacnedmagiclantern"              }}

  ,{ "opn_forgottenbastille",                   "rm_deathtrap",             { "use_enhacnedmagiclantern"              }}
  ,{ "get_collect_item_4_3"                     }
  ,{ "get_collect_morph_item_4_3" }
  ,{ "vid_forgottenbastille_powerdarkness",     "rm_forgottenbastille",     { "opn_forgottenbastille"                 }}
  ,{ "get_silverbullet",                        "rm_forgottenbastille",     { "opn_forgottenbastille"                 }}
  ,{ "get_silverblade",                         "rm_forgottenbastille",     { "opn_forgottenbastille"                 }}
  ,{ "use_scrap",                               "rm_forgottenbastille",     { "get_scrap"                             }}
  ,{ "get_cannonball",                          "rm_forgottenbastille",     { "use_scrap"                             }}
  ,{ "get_cover",                               "rm_forgottenbastille",     { "use_scrap"                             }}
  ,{ "get_armysymbol",                          "rm_forgottenbastille",     { "use_scrap"                             }}
  ,{ "use_armysymbol",                          "rm_forgottenbastille",     { "get_armysymbol"                        }}
  ,{ "clk_tent",                                "rm_forgottenbastille",     { "use_armysymbol"                        }}

  ,{ "opn_intent"                               }
  ,{ "win_intent",                              "rm_forgottenbastille",     { "clk_tent"                            }}
  ,{ "use_cover",                               }
  ,{ "get_bucket_4",                            }
  ,{ "use_bucket_4",                            "rm_sheriffshouse_4",       { "get_bucket_4"                          }}
  ,{ "get_bucketgunpowder",                     "rm_sheriffshouse_4",       { "use_bucket_4"                          }}
  ,{ "use_bucketgunpowder",                     "rm_forgottenbastille",     { "get_bucketgunpowder"                   }}
  ,{ "use_wick",                                "rm_forgottenbastille",     { "win_intent",  
                                                                              "use_bucketgunpowder"                   }}
  ,{ "use_cannonball",                          "rm_forgottenbastille",     { "get_cannonball", "use_wick"                        }}
  ,{ "use_burningtorch_2",                      "rm_forgottenbastille",     { "get_burningtorch", "use_wick"          }}
  ,{ "use_silverbullet",                        }
  ,{ "clk_loadedgun_4",                         }
  ,{ "get_loadedgun_4",                         }

  ,{ "opn_swampmasterdwelling",                 "rm_forgottenbastille",     { "use_burningtorch_2"          }}
  ,{ "get_collect_morph_item_4_4" }
  ,{ "vid_swampmasterdwelling_ghosts",          "rm_swampmasterdwelling",   { "opn_swampmasterdwelling"               }}

  ,{ "use_loadedgun_4",                         "rm_swampmasterdwelling",   { "get_loadedgun_4"                       }}
  ,{ "use_silverblade",                         "rm_swampmasterdwelling",   { "get_silverblade"                       }}

  ,{ "get_artifactpiece_1",                     "rm_swampmasterdwelling",   { "use_loadedgun_4"                       }}
  ,{ "get_artifactpiece_2",                     "rm_swampmasterdwelling",   { "use_silverblade"                       }}
  ,{ "use_artifactpiece_1",                     }
  ,{ "use_artifactpiece_2",                     }
  ,{ "get_victoryartifact",                     }
  ,{ "use_victoryartifact1",                    "rm_swampmasterdwelling",   { "get_victoryartifact"                   }}

  ,{ "opn_bossfight"                            }
  ,{ "win_bossfight",                           "rm_swampmasterdwelling",   { "opn_bossfight"                         }}
  ,{ "use_victoryartifact2",                    "rm_swampmasterdwelling",   { "get_victoryartifact", "opn_bossfight"  }}
  ,{ "get_collect_item_1_3"                     }
  ,{ "get_collect_item_3_2"                     }
  ,{ "get_collect_morph_item_1_2" }
  ,{ "get_collect_morph_item_1_3" }
  ,{ "get_collect_morph_item_1_4" }
  ,{ "get_collect_morph_item_1_7" }
  ,{ "get_collect_morph_item_3_4" }

  };
  
  game.progress_names = {};
  for i = 1, #game.progress_names_room do
    game.progress_names[ i ] = game.progress_names_room[ i ][ 1 ];
  end;
  
  game.relations = {};
  
  private.menu_moduls = {
    "rm_credits"
  }

  if ( IsCollectorsEdition() or IsSurveyEdition() ) then

    local menu_moduls_ce = {
      "rm_collectibles2",
      "rm_collectibles",
      "rm_achievements",
    }
    for i = 1, #menu_moduls_ce do
      table.insert( private.menu_moduls, menu_moduls_ce[ i ] );
    end;

  end;

  common_impl.CheckPrgRules();

end;

function private.TutorialSetParams()
--[[
if not ng_global.progress[ "std" ][ "see_tutorial" ] then

  ng_global.progress[ "std" ][ "see_tutorial" ] = {};
  ng_global.progress[ "std" ][ "see_tutorial" ].done  = 0;
  ng_global.progress[ "std" ][ "see_tutorial" ].start = 0;
  ng_global.progress[ "std" ][ "see_tutorial" ].state = {};
  ng_global.progress[ "std" ][ "see_tutorial" ].state.no  = 0;
  ng_global.progress[ "std" ][ "see_tutorial" ].state.currentpage = "tutorial_page_1";
  ng_global.progress[ "std" ][ "see_tutorial" ].func = function()
    --
  end;]]

end;

