-- name=levelext_inv
--*********************************************************************************************************************
function public.Init ()




  private.init_clip_4();
  private.init_artifact();
  private.init_bluntsawdisk();
  private.init_case();
  private.init_brace();
  private.init_brokendisksaw();
  private.init_brokenlightcharm();
  private.init_brokentank();
  private.init_extinctlantern();
  private.init_extinctlantern2();
  private.init_extinctlantern3();
  private.init_firetorch();
  private.init_leakybucket();
  private.init_revolver_4();
  private.init_salammoniacbottle();
  private.init_torch();
  private.init_tweezerscotton();
  private.init_seeker();
  
  public.deploy_inventory = {
    { "clip_4",            { "clk_clip_4" },  "get_unbentclip"  },
    { "artifact",            { "use_artifactpiece_1", "use_artifactpiece_2" },  "get_victoryartifact"  },
    { "bluntsawdisk",        { "use_file_4", },  "get_sawdisk"  },
    { "case",            { "use_boxpiece", "win_case" },  "get_toolkey"  },
    { "brace",            { "use_auger" },  "get_workingbrace"  },
    { "brokendisksaw",            { "use_sawdisk", "use_fuelbottle" },  "get_disksaw"  },
    { "brokenlightcharm",            { "use_charmpiece_1", "use_charmpiece_2", "use_charmpiece_3", "use_charmpiece_4", "use_charmpiece_5" },  "get_lightcharm"  },
    { "brokentank",            { "use_valve_4" },  "get_nitrogentank"  },
    { "extinctlantern2",            { "clk_extinctlantern2_close" },  "get_magiclantern_2"  },
    { "firetorch",            { "use_matches_4_1" },  "get_burningfire"  },
    { "leakybucket",            { "use_cover" },  "get_bucket_4"  },
    { "revolver_4",            { "use_silverbullet" },  "get_loadedgun_4"  },
    { "salammoniacbottle", { "use_awl_4"  },  "get_salammoniac" },
    { "torch", { "use_matches_4_2"  },  "get_burningtorch" },
    { "tweezerscotton", { "use_salammoniac"  },  "get_salammoniaccotton" },
    
  };

  ObjMultiSet({
    { "inv_seeker", { event_mdown = private.SeekerDown, event_drag = private.SeekerDrag, event_dragdrop = private.SeekerDragDrop } },
    { "obj_extinctlantern2_open_clk", { event_mdown = private.open_extinctlantern } },
    { "obj_extinctlantern2_close_clk", { event_mdown = private.close_extinctlantern } },
    
  });

  
  if port.isPortable() == 1 then
    port.InventoryPopupInit("levelext_inv_hub");
    port.VideoResizeInRoom("levelext_inv");
  end;
  --------------------------------------------------------------------------------------------
    -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_levelext_inv_deploy = function ()

    local visible_sparkle_ho = true;  
    if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
      visible_sparkle_ho = false;
    end;
    common_impl.TurnChildGfx( {"levelext_inv_deploy" }, "levelext_inv_deploy", visible_sparkle_ho );

  end;
  cmn.AddSubscriber( "update_game_mode_levelext_inv_deploy", update_game_mode_levelext_inv_deploy, nil );
  
end;
--*********************************************************************************************************************
function private.StringDivide(string)  

  local table = {}
  local id = 1
  local il = 1
  for i = 1, string.len(string) do
    if string.sub(string,i,i) == "_" then
      table[id] = string.sub(string,il,i-1)
      il = i+1
      id = id + 1
    end
    if i == string.len(string) then
      table[id] = string.sub(string,il,i)
      il = i+1
      id = id + 1
    end
  end
  return table;

end;
--*********************************************************************************************************************
function private.ObjIntersectCheck( obj_to_apply, obj_to_check, obj_complex_inv )

  local obj_complex_inv = obj_complex_inv or "deploy_inv_"..private.StringDivide( obj_to_check )[2];  

  return interface.GetCurrentInv() == obj_complex_inv and ObjIntersect( obj_to_apply, obj_to_check );
 
end;
--*********************************************************************************************************************
-- function *** clip_4 *** () end;
--*********************************************************************************************************************
  function private.init_clip_4()

    ObjMultiSet({ 
      { "obj_clip_4_click", { event_mdown = public.clk_clip_4 }},
      { "spr_deploy_clip_4_unbentclip", { event_mdown = public.get_unbentclip }},
    });  
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_clip_4" ] = {
        type = "click",
        use_place = "obj_clip_4_click",
        room = "int_deploy_inv",
        zz = "deploy_inv_clip_4",
        zz_gate = "inv_clip_4"
    };
    function clk_clip_4_click_inv ()

        ObjSet( "inv_clip_4", { res = "assets/levels/levelext/inv_deploy/inv_clip_4/inv/inv_unbentclip" } );

    end;

    function clk_clip_4_click ()

      ObjDelete( "obj_clip_4_click" );
      ObjDelete( "spr_deploy_clip_4_clip" );
      ObjMultiSet({ 
        { "spr_deploy_clip_4_unbentclip",     { input = true     }},
        { "gfx_deploy_clip_4_unbentclip",     { active = true    }},
      });

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_clip_4", clk_clip_4_click, "inv_clip_4" );
    cmn.AddSubscriber( "clk_clip_4", clk_clip_4_click_inv );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_unbentclip" ] = {
        type = "get",
        get_obj = "spr_deploy_clip_4_unbentclip",
        room = "int_deploy_inv",
        zz = "deploy_inv_clip_4",
        zz_gate = "inv_clip_4"
    };
    function get_unbentclip_inv ()

      interface.InventoryItemRemove( "inv_clip_4" );
      interface.InventoryItemAdd( "inv_unbentclip", "spr_deploy_clip_4_unbentclip" );

    end;
    function get_unbentclip_deploy ()

      ObjDelete( "gfx_deploy_clip_4_unbentclip" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_unbentclip", get_unbentclip_inv );
    cmn.AddSubscriber( "get_unbentclip", get_unbentclip_deploy, "inv_clip_4" );
    -------------------------------------------------------------------------------------------

  end;
  --*********************************************************************************************************************
  function public.get_unbentclip()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_unbentclip" );
    cmn.CallEventHandler( "get_unbentclip", "inv_clip_4" );
    common_impl.HideDeployInv();

  end;
  --*********************************************************************************************************************
  function public.clk_clip_4()

    local func_end = function ()

      common_impl.Lock(false);
      
      cmn.SetEventDone( "clk_clip_4" );
      cmn.CallEventHandler( "clk_clip_4", "inv_clip_4" );
    
    end;

    common_impl.Lock(true);
    common_impl.PlayAudio( "sfx", "common/audio/aud_touch_clip", 0, "", 0 );
    ObjAnimate( "spr_deploy_clip_4_clip", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
    ObjAnimate( "spr_deploy_clip_4_unbentclip", "alp", 0, 0, func_end, { 0,0,0, 0.3,0,1 } );

  end;
--*********************************************************************************************************************
-- function *** artifact *** () end;
--*********************************************************************************************************************
  function private.init_artifact()

    common_impl.hint[ "use_artifactpiece_1" ] = {
        type = "use",
        inv_obj = "inv_artifactpiece_1",
        use_place = "obj_artifact_use_artifactpiece_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_artifact",
        zz_gate = "inv_artifact"
    };
    function use_artifactpiece_1_inv ()

      interface.InventoryItemRemove( "inv_artifactpiece_1" );

    end;
    function use_artifactpiece_1_inv_end ()

      if not cmn.IsEventDone( "use_artifactpiece_2" ) then

        ObjSet( "inv_artifact", { res = "assets/levels/levelext/inv_deploy/inv_artifact/inv/inv_artifact_3" } );

      else

        ObjSet( "inv_artifact", { res = "assets/levels/levelext/inv_deploy/inv_artifact/inv/inv_victoryartifact" } );

      end;

    end;
    function use_artifactpiece_1_beg ()

      ObjDelete( "obj_artifact_use_artifactpiece_1" );

    end;
    function use_artifactpiece_1_end ()

      ObjSet( "spr_deploy_artifact_wing_1", { alp = 1 });
      if cmn.IsEventDone( "use_artifactpiece_2" ) then
        ObjSet( "spr_deploy_artifact_victoryartifact", { input = true } );
        ObjSet( "gfx_deploy_artifact_victoryartifact", { active = true } );
      end;

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_artifactpiece_1", use_artifactpiece_1_beg, "inv_artifact" );
    cmn.AddSubscriber( "use_artifactpiece_1", use_artifactpiece_1_inv );
    cmn.AddSubscriber( "use_artifactpiece_1", use_artifactpiece_1_inv_end );
    cmn.AddSubscriber( "use_artifactpiece_1", use_artifactpiece_1_end, "inv_artifact" );
    cmn.AddSubscriber( "use_artifactpiece_1_inv", use_artifactpiece_1_inv );
    cmn.AddSubscriber( "use_artifactpiece_1_inv_end", use_artifactpiece_1_inv_end );
    cmn.AddSubscriber( "use_artifactpiece_1_beg", use_artifactpiece_1_beg, "inv_artifact" );
    cmn.AddSubscriber( "use_artifactpiece_1_end", use_artifactpiece_1_end, "inv_artifact" );
      -------------------------------------------------------------------------------------------

    common_impl.hint[ "use_artifactpiece_2" ] = {
        type = "use",
        inv_obj = "inv_artifactpiece_2",
        use_place = "obj_artifact_use_artifactpiece_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_artifact",
        zz_gate = "inv_artifact"
    };
    function use_artifactpiece_2_inv ()

      interface.InventoryItemRemove( "inv_artifactpiece_2" );

    end;
    function use_artifactpiece_2_inv_end ()

      if not cmn.IsEventDone( "use_artifactpiece_1" ) then

        ObjSet( "inv_artifact", { res = "assets/levels/levelext/inv_deploy/inv_artifact/inv/inv_artifact_2" } );

      else

        ObjSet( "inv_artifact", { res = "assets/levels/levelext/inv_deploy/inv_artifact/inv/inv_victoryartifact" } );

      end;

    end;
    function use_artifactpiece_2_beg ()

      ObjDelete( "obj_artifact_use_artifactpiece_2" );

    end;
    function use_artifactpiece_2_end ()

      ObjSet( "spr_deploy_artifact_wing_2", { alp = 1 });
      if cmn.IsEventDone( "use_artifactpiece_1" ) then
        ObjSet( "spr_deploy_artifact_victoryartifact", { input = true } );
        ObjSet( "gfx_deploy_artifact_victoryartifact", { active = true } );
      end;

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_artifactpiece_2", use_artifactpiece_2_beg, "inv_artifact" );
    cmn.AddSubscriber( "use_artifactpiece_2", use_artifactpiece_2_inv );
    cmn.AddSubscriber( "use_artifactpiece_2", use_artifactpiece_2_inv_end );
    cmn.AddSubscriber( "use_artifactpiece_2", use_artifactpiece_2_end, "inv_artifact" );
    cmn.AddSubscriber( "use_artifactpiece_2_inv", use_artifactpiece_2_inv );
    cmn.AddSubscriber( "use_artifactpiece_2_inv_end", use_artifactpiece_2_inv_end );
    cmn.AddSubscriber( "use_artifactpiece_2_beg", use_artifactpiece_2_beg, "inv_artifact" );
    cmn.AddSubscriber( "use_artifactpiece_2_end", use_artifactpiece_2_end, "inv_artifact" );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_victoryartifact" ] = {
        type = "get",
        get_obj = "spr_deploy_artifact_victoryartifact",
        room = "int_deploy_inv",
        zz = "deploy_inv_artifact",
        zz_gate = "inv_artifact"
    };
    function get_victoryartifact_inv ()

      interface.InventoryItemAdd( "inv_victoryartifact", "spr_deploy_artifact_victoryartifact" );
      interface.InventoryItemRemove( "inv_artifact" );
      ObjDelete( "gfx_deploy_artifact_victoryartifact" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_victoryartifact", get_victoryartifact_inv );
    -------------------------------------------------------------------------------------------
    ObjSet( "spr_deploy_artifact_victoryartifact", { event_mdown = levelext_inv.get_victoryartifact });

  end;

  function public.get_victoryartifact()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_victoryartifact" );
    cmn.CallEventHandler( "get_victoryartifact", "inv_victoryartifact" );
    common_impl.HideDeployInv();

  end;
  function public.use_artifactpiece_1()

    local item = "inv_artifactpiece_1";

    if private.ObjIntersectCheck( item, "obj_artifact_use_artifactpiece_1" ) then

      cmn.CallEventHandler( "use_artifactpiece_1_beg", "inv_artifact" );
      cmn.CallEventHandler( "use_artifactpiece_1_inv" );

      local func_end = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_artifactpiece_1" );
        cmn.CallEventHandler( "use_artifactpiece_1_end", "inv_artifact" );
        cmn.CallEventHandler( "use_artifactpiece_1_inv_end" );

      end;

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_use_artifactpiece", 0, "", 0 );

      ObjAnimate( "spr_deploy_artifact_wing_1", "alp", 0, 0, func_end, 
      { 
        0.0,0,0,
        0.3,0,1
      } );

      return true;

    end;

  end;
  function public.use_artifactpiece_2()

    local item = "inv_artifactpiece_2";

    if private.ObjIntersectCheck( item, "obj_artifact_use_artifactpiece_2" ) then

      cmn.CallEventHandler( "use_artifactpiece_2_beg", "inv_artifact" );
      cmn.CallEventHandler( "use_artifactpiece_2_inv" );

      local func_end = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_artifactpiece_2" );
        cmn.CallEventHandler( "use_artifactpiece_2_end", "inv_artifact" );
        cmn.CallEventHandler( "use_artifactpiece_2_inv_end" );

      end;

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_use_artifactpiece", 0, "", 0 );

      ObjAnimate( "spr_deploy_artifact_wing_2", "alp", 0, 0, func_end, 
      { 
        0.0,0,0,
        0.3,0,1
      } );

      return true;

    end;

  end;
--*********************************************************************************************************************
-- function *** bluntsawdisk *** () end;
--*********************************************************************************************************************
  function private.init_bluntsawdisk()

    common_impl.hint[ "use_file_4" ] = {
        type = "use",
        inv_obj = "inv_file_4",
        use_place = "obj_bluntsawdisk_use_file_4",
        room = "int_deploy_inv",
        zz = "deploy_inv_bluntsawdisk",
        zz_gate = "inv_bluntsawdisk"
    };
    function use_file_4_inv ()

      interface.InventoryItemRemove( "inv_file_4" );

    end;
    function use_file_4_inv_end ()

      ObjSet( "inv_bluntsawdisk", { res = "assets/levels/levelext/inv_deploy/inv_bluntsawdisk/inv/inv_sawdisk" } );

    end;
    function use_file_4_beg ()

      ObjDelete( "obj_bluntsawdisk_use_file_4" );

    end;
    function use_file_4_end ()

      ObjDelete( "spr_deploy_bluntsawdisk_bluntsawdisk" );
      ObjDelete( "anm_deploy_bluntsawdisk_disk" );

      ObjSet( "spr_deploy_bluntsawdisk_sawdisk", { input = true, alp = 1 } );
      ObjSet( "gfx_deploy_bluntsawdisk_sawdisk", { active = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_file_4", use_file_4_beg, "inv_bluntsawdisk" );
    cmn.AddSubscriber( "use_file_4", use_file_4_inv );
    cmn.AddSubscriber( "use_file_4", use_file_4_inv_end );
    cmn.AddSubscriber( "use_file_4", use_file_4_end, "inv_bluntsawdisk" );
    cmn.AddSubscriber( "use_file_4_inv", use_file_4_inv );
    cmn.AddSubscriber( "use_file_4_inv_end", use_file_4_inv_end );
    cmn.AddSubscriber( "use_file_4_beg", use_file_4_beg, "inv_bluntsawdisk" );
    cmn.AddSubscriber( "use_file_4_end", use_file_4_end, "inv_bluntsawdisk" );
    
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_sawdisk" ] = {
        type = "get",
        get_obj = "spr_deploy_bluntsawdisk_sawdisk",
        room = "int_deploy_inv",
        zz = "deploy_inv_bluntsawdisk",
        zz_gate = "inv_bluntsawdisk"
    };
    function get_sawdisk_inv ()

      interface.InventoryItemAdd( "inv_sawdisk", "spr_deploy_bluntsawdisk_sawdisk" );
      interface.InventoryItemRemove( "inv_bluntsawdisk" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_sawdisk", get_sawdisk_inv );
    -------------------------------------------------------------------------------------------
    ObjSet( "spr_deploy_bluntsawdisk_sawdisk", { event_mdown = levelext_inv.get_sawdisk });

  end;

  function public.get_sawdisk()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_sawdisk" );
    cmn.CallEventHandler( "get_sawdisk", "inv_sawdisk" );
    common_impl.HideDeployInv();

  end;
  function public.use_file_4()

    local item = "inv_file_4";

    if private.ObjIntersectCheck( item, "obj_bluntsawdisk_use_file_4" ) then

      cmn.CallEventHandler( "use_file_4_beg", "inv_bluntsawdisk" );
      cmn.CallEventHandler( "use_file_4_inv" );

      local func_end = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_file_4" );
        cmn.CallEventHandler( "use_file_4_end", "inv_bluntsawdisk" );
        cmn.CallEventHandler( "use_file_4_inv_end" );

      end;

      common_impl.Lock( true );

       common_impl.PlayAudio( "sfx", "common/audio/aud_use_file_4", 0, "", 0 );

      ObjSet( "spr_deploy_bluntsawdisk_bluntsawdisk", { alp = 0 });
      ObjSet( "anm_deploy_bluntsawdisk_disk", { alp = 1 });
      AnimPlay( "anm_deploy_bluntsawdisk_disk", "DoAnim", func_end );

      return true;

    end;

  end;
--*********************************************************************************************************************
-- function *** case *** () end;
--*********************************************************************************************************************
  function private.init_case()

    private.pos_mas = { { 1, -123, 0 }, { 118, -20, 4.78 }, { 76, 88, 3.55 }, { -69, 99, 2.52 }, { -120, -26, 1.26 } };
    private.start_pos = { 1, 4, 5, 3, 2 };
    private.first_obj = 0;
    --выигрышная позиция = 1,2,3,4,5
    local table_multiset = {};
    for i = 1, 5 do

       local name = "spr_deploy_case_list_"..i;
       table.insert( table_multiset, { name, 
                  {  
                    event_menter = function () common_impl.SetCursor( CURSOR_HAND ) end,
                    event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ) end,
                    event_mdown = function () public.clk_boxpiece( i ) end
                  } } );

    end;

    ObjMultiSet( table_multiset );

    common_impl.hint[ "use_boxpiece" ] = {
        type = "use",
        inv_obj = "inv_boxpiece",
        use_place = "obj_case_use_boxpiece",
        room = "int_deploy_inv",
        zz = "deploy_inv_case",
        zz_gate = "inv_case"
    };
    function use_boxpiece_inv ()

      interface.InventoryItemRemove( "inv_boxpiece" );

    end;
    function use_boxpiece_inv_end ()

      --

    end;
    function use_boxpiece_beg ()

      ObjDelete( "obj_case_use_boxpiece" );

    end;
    function use_boxpiece_end ()

      ObjMultiSet({ 
        { "spr_deploy_case_list_1",         { alp = 1 }},
        { "spr_deploy_case_list_1_shadow",  { input = true  }},
        { "spr_deploy_case_list_1_light",  { active = true }},
        { "obj_deploy_case_mmg", { input = true }},
      });

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_boxpiece", use_boxpiece_beg, "inv_case" );
    cmn.AddSubscriber( "use_boxpiece", use_boxpiece_inv );
    cmn.AddSubscriber( "use_boxpiece", use_boxpiece_inv_end );
    cmn.AddSubscriber( "use_boxpiece", use_boxpiece_end, "inv_case" );
    cmn.AddSubscriber( "use_boxpiece_inv", use_boxpiece_inv );
    cmn.AddSubscriber( "use_boxpiece_inv_end", use_boxpiece_inv_end );
    cmn.AddSubscriber( "use_boxpiece_beg", use_boxpiece_beg, "inv_case" );
    cmn.AddSubscriber( "use_boxpiece_end", use_boxpiece_end, "inv_case" );
    --*********************************************************************************************************************
    common_impl.hint[ "win_case" ] = {
        type = "win",
        use_place = "spr_deploy_case_box",
        room = "int_deploy_inv",
        zz = "deploy_inv_case",
        zz_gate = "inv_case"
    };

    local win_case = function ()  

      if cmn.IsEventDone( "win_case" ) then

        ObjSet( "spr_deploy_case_toolkey", { input = true } ); 
        ObjSet( "gfx_deploy_case_toolkey", { active = true } ); 
        ObjDelete( "spr_deploy_case_box_cover" );

      elseif ng_global.progress["ext"]["win_case"].start == 1 then

        for i = 1,5 do

          ObjSet( "spr_deploy_case_list_"..ng_global.progress["ext"]["win_case"].current_pos[i], 
            { ang   = private.pos_mas[i][3],
              pos_x = private.pos_mas[i][1],
              pos_y = private.pos_mas[i][2],
            } );

        end;

      end;

    end;

    local win_case_inv_end = function ()

      ObjSet( "inv_case", { res = "assets/levels/levelext/inv_deploy/inv_case/inv/inv_case2" } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "win_case", win_case, "inv_case" );
    cmn.AddSubscriber( "win_case", win_case_inv_end );
    --------------------------------------------------------------------------------------------
    ObjSet( "spr_deploy_case_toolkey", { event_mdown = levelext_inv.get_toolkey });
    ObjSet( "inv_case", { event_mdown = function() private.show_case() end });
    --------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_toolkey" ] = {
        type = "get",
        get_obj = "spr_deploy_case_toolkey",
        room = "int_deploy_inv",
        zz = "deploy_inv_case",
        zz_gate = "inv_case"
    };
    function get_toolkey_inv ()

      interface.InventoryItemAdd( "inv_toolkey", "spr_deploy_case_toolkey" );
      interface.InventoryItemRemove( "inv_case" );

    end;
    function get_toolkey_deploy ()

      ObjDelete( "gfx_deploy_case_toolkey" );
      ObjDelete( "spr_deploy_case_toolkey_shadow" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_toolkey", get_toolkey_inv );
    cmn.AddSubscriber( "get_toolkey", get_toolkey_deploy, "inv_case" );
    -------------------------------------------------------------------------------------------
    ObjSet( "spr_deploy_case_toolkey", { event_mdown = levelext_inv.get_toolkey });

  end;
  --------------------------------------------------------------------------------------------
  function public.get_toolkey()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_toolkey" );
    cmn.CallEventHandler( "get_toolkey", "inv_case" );
    common_impl.HideDeployInv();

  end;
  --------------------------------------------------------------------------------------------
  function private.show_case()

    if ( not cmn.IsEventDone( "win_case" ) and cmn.IsEventDone( "use_boxpiece" ) ) then
      cmn.MiniGameShow( 'case' );
      common_impl.PassingMgStart( 'case' );
    end;
    common_impl.ShowDeployInv('inv_case');

  end;
  --------------------------------------------------------------------------------------------
  -------------------------------------------------------------------------------------------
  function public.use_boxpiece()

    local item = "inv_boxpiece";

    if private.ObjIntersectCheck( item, "obj_case_use_boxpiece" ) then

      cmn.CallEventHandler( "use_boxpiece_beg", "inv_case" );
      cmn.CallEventHandler( "use_boxpiece_inv" );

      local func_end = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_boxpiece" );
        cmn.CallEventHandler( "use_boxpiece_end", "inv_case" );
        cmn.CallEventHandler( "use_boxpiece_inv_end" );

        cmn.MiniGameShow( 'case' );
        common_impl.PassingMgStart( "case" );
        ng_global.progress["ext"]["win_case"].current_pos = { 1, 4, 5, 3, 2 };

      end;

      common_impl.Lock( true );
      ObjAnimate( "spr_deploy_case_list_1", "alp", 0, 0, func_end, { 0,0,0, 0.3,0,1 } );
      ObjAnimate( "spr_deploy_case_list_1_shadow", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
      ObjAnimate( "spr_deploy_case_list_1_light", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
      common_impl.PlayAudio( "sfx", "common/audio/aud_flower_amulet_insert", 0, "", 0 );

      return true;

    end;

  end;

  function public.clk_boxpiece( number )

    --common_impl.PlayAudio( "sfx", "common/audio/aud_mg_casket_mosaic_click", 0, "", 0 );

    number = tonumber( number );

    local pos_1 = 0;
    local pos_2 = 0;
    for i = 1,5 do

      if ng_global.progress["ext"]["win_case"].current_pos[i] == number then

        pos_1 = i;

      end; 

      if ng_global.progress["ext"]["win_case"].current_pos[i] == private.first_obj then

        pos_2 = i;

      end; 

    end;

    local func_after_1 = function ()

      local func_after_2 = function ()

        common_impl.Lock( false );
        local count = 0;
        local win_flag = false;
        for i = 1,5 do

          if ng_global.progress["ext"]["win_case"].current_pos[i] == i then

            count = count + 1;

          end;

        end;

        if count == 3 then

          if pos_1 == private.first_obj and pos_2 == number then

            win_flag = true;

          end;

        end;

        if not win_flag then

          ng_global.progress["ext"]["win_case"].current_pos[pos_1] = private.first_obj
          ng_global.progress["ext"]["win_case"].current_pos[pos_2] = number

        else

          private.WinCase();

        end;

        private.first_obj = 0;

      end;

      ObjSet( "spr_deploy_case_list_"..number, 
            { ang   = private.pos_mas[pos_2][3],
              pos_x = private.pos_mas[pos_2][1],
              pos_y = private.pos_mas[pos_2][2],
            } );

      ObjSet( "spr_deploy_case_list_"..private.first_obj, 
            { ang   = private.pos_mas[pos_1][3],
              pos_x = private.pos_mas[pos_1][1],
              pos_y = private.pos_mas[pos_1][2],
            } );

      --DbgTrace( private.first_obj.."  "..number );

      ObjAnimate( "spr_deploy_case_list_"..number, "alp", 0, 0, func_after_2, { 0,0,0, 0.3,0,1 } );
      ObjAnimate( "spr_deploy_case_list_"..pos_1.."_shadow", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
      ObjAnimate( "spr_deploy_case_list_"..pos_1.."_light", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
      ObjAnimate( "spr_deploy_case_list_"..private.first_obj, "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
      ObjAnimate( "spr_deploy_case_list_"..pos_2.."_shadow", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
      ObjAnimate( "spr_deploy_case_list_"..pos_2.."_light", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
      ObjAnimate( "spr_deploy_case_list_"..number.."_focus", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
      ObjAnimate( "spr_deploy_case_list_"..private.first_obj.."_focus", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );

    end;
--    for i = 1,5 do
--
--      if ng_global.progress["ext"]["win_case"].current_pos[i] == number then
--
--        pos = i;
--        break;
--
--      end; 
--
--    end;

    if private.first_obj == 0 then

      private.first_obj = number;
      common_impl.Lock( true );
      ObjAnimate( "spr_deploy_case_list_"..number.."_focus", "alp", 0, 0, function() common_impl.Lock( false ); end, { 0,0,0, 0.3,0,1 } );

      common_impl.PlayAudio( "sfx", "common/audio/aud_flower_amulet_click", 0, "", 0 );

    elseif private.first_obj == number then

      private.first_obj = 0;
      common_impl.Lock( true );
      ObjAnimate( "spr_deploy_case_list_"..number.."_focus", "alp", 0, 0, function() common_impl.Lock( false ); end, { 0,0,1, 0.3,0,0 } );
      common_impl.PlayAudio( "sfx", "common/audio/aud_flower_amulet_click", 0, "", 0 );

    else 

      common_impl.PlayAudio( "sfx", "common/audio/aud_flower_amulet_move", 0, "", 0 );

      common_impl.Lock( true );
      ObjAnimate( "spr_deploy_case_list_"..number, "alp", 0, 0, func_after_1, { 0,0,1, 0.3,0,0 } );
      ObjAnimate( "spr_deploy_case_list_"..pos_1.."_shadow", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
      ObjAnimate( "spr_deploy_case_list_"..pos_1.."_light", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
      ObjAnimate( "spr_deploy_case_list_"..private.first_obj, "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
      ObjAnimate( "spr_deploy_case_list_"..pos_2.."_shadow", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
      ObjAnimate( "spr_deploy_case_list_"..pos_2.."_light", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
      ObjAnimate( "spr_deploy_case_list_"..number.."_focus", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
    end;

  end;

  function private.WinCase()

    common_impl.PlayAudio( "sfx", "common/audio/aud_flower_amulet_win", 0, "", 0 );
    common_impl.Lock( true );
    ObjAnimate( "spr_deploy_case_box_cover", "alp", 0, 0, private.WinCaseEnd, { 0,0,1, 0.3,0,1, 0.6,3,0 } );
    ObjAnimate( "spr_deploy_case_box_cover", "pos_xy", 0, 0, "", { 0,0,-7,-34, 0.6,3,-100, -300 } );

  end;

  function private.WinCaseEnd()

    common_impl.Lock( false );
    cmn.MiniGameHide( "case" );
    common_impl.PassingMgWin( "case" );
    cmn.SetEventDone( "win_case" );
    cmn.CallEventHandler( "win_case", "inv_case" );

  end;
--*********************************************************************************************************************
-- function *** brace *** () end;
--*********************************************************************************************************************
  function private.init_brace()

    common_impl.hint[ "use_auger" ] = {
        type = "use",
        inv_obj = "inv_auger",
        use_place = "obj_brace_use_auger",
        room = "int_deploy_inv",
        zz = "deploy_inv_brace",
        zz_gate = "inv_brace"
    };
    function use_auger_inv ()

      interface.InventoryItemRemove( "inv_auger" );

    end;
    function use_auger_inv_end ()

      ObjSet( "inv_brace", { res = "assets/levels/levelext/inv_deploy/inv_brace/inv/inv_workingbrace" } );

    end;
    function use_auger_beg ()

      ObjDelete( "obj_brace_use_auger" );

    end;
    function use_auger_end ()

      ObjMultiSet({ 
        { "spr_deploy_brace_auger",         { alp = 1, pos_x = -149, pos_y = 115 }},
        { "spr_deploy_brace_workingbrace",  { input = true  }},
        { "gfx_deploy_brace_workingbrace",  { active = true }},
      });

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_auger", use_auger_beg, "inv_brace" );
    cmn.AddSubscriber( "use_auger", use_auger_inv );
    cmn.AddSubscriber( "use_auger", use_auger_inv_end );
    cmn.AddSubscriber( "use_auger", use_auger_end, "inv_brace" );
    cmn.AddSubscriber( "use_auger_inv", use_auger_inv );
    cmn.AddSubscriber( "use_auger_inv_end", use_auger_inv_end );
    cmn.AddSubscriber( "use_auger_beg", use_auger_beg, "inv_brace" );
    cmn.AddSubscriber( "use_auger_end", use_auger_end, "inv_brace" );
    
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_workingbrace" ] = {
        type = "get",
        get_obj = "obj_deploy_brace",
        room = "int_deploy_inv",
        zz = "deploy_inv_brace",
        zz_gate = "inv_brace"
    };
    function get_workingbrace_inv ()

      interface.InventoryItemAdd( "inv_workingbrace", "obj_deploy_brace" );
      interface.InventoryItemRemove( "inv_brace" );

    end;
    function get_workingbrace_deploy ()

      ObjDelete( "gfx_deploy_brace_workingbrace" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_workingbrace", get_workingbrace_inv );
    cmn.AddSubscriber( "get_workingbrace", get_workingbrace_deploy, "inv_brace" );
    -------------------------------------------------------------------------------------------
    ObjSet( "spr_deploy_brace_workingbrace", { event_mdown = levelext_inv.get_workingbrace });

  end;

  function public.get_workingbrace()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_workingbrace" );
    cmn.CallEventHandler( "get_workingbrace", "inv_workingbrace" );
    common_impl.HideDeployInv();

  end;
  function public.use_auger()

    local item = "inv_auger";

    if private.ObjIntersectCheck( item, "obj_brace_use_auger" ) then

      cmn.CallEventHandler( "use_auger_beg", "inv_brace" );
      cmn.CallEventHandler( "use_auger_inv" );

      local func_end = function ()

        common_impl.Lock(false);

        cmn.SetEventDone( "use_auger" );
        cmn.CallEventHandler( "use_auger_end", "inv_brace" );
        cmn.CallEventHandler( "use_auger_inv_end" );

      end;

      common_impl.Lock(true);
      
       common_impl.PlayAudio( "sfx", "common/audio/aud_use_auger_4", 0, "", 0 );
      ObjAnimate( "spr_deploy_brace_auger", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
      ObjAnimate( "spr_deploy_brace_auger", "pos_xy", 0, 0, func_end, { 0,0,-207,157, 0.3,3,-207,157, 0.8,0,-149,115 } );
      return true;

    end;

  end;
--*********************************************************************************************************************
-- function *** brokendisksaw *** () end;
--*********************************************************************************************************************
  function private.init_brokendisksaw()

    common_impl.hint[ "get_disksaw" ] = {
        type = "get",
        get_obj = "spr_deploy_brokendisksaw_brokendisksaw",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokendisksaw",
        zz_gate = "inv_brokendisksaw"
    };

    function get_disksaw_inv ()

      interface.InventoryItemRemove( "inv_brokendisksaw" );
      interface.InventoryItemAdd( "inv_disksaw", "obj_deploy_brokendisksaw" );

    end;
    function get_disksaw_deploy ()

      ObjDelete( "gfx_deploy_brokendisksaw_brokendisksaw" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_disksaw", get_disksaw_inv );
    cmn.AddSubscriber( "get_disksaw", get_disksaw_deploy, "inv_brokendisksaw" );
    -------------------------------------------------------------------------------------------
    ObjSet( "spr_deploy_brokendisksaw_brokendisksaw", { event_mdown = levelext_inv.get_disksaw });
    --------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_sawdisk" ] = {
        type = "use",
        inv_obj = "inv_sawdisk",
        use_place = "obj_brokendisksaw_use_sawdisk",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokendisksaw",
        zz_gate = "inv_brokendisksaw"
    };
    function use_sawdisk_inv ()

      interface.InventoryItemRemove( "inv_sawdisk" );
    
    end;
    function use_sawdisk_inv_end ()

      ObjSet( "inv_brokendisksaw", { res = "assets/levels/levelext/inv_deploy/inv_brokendisksaw/inv/inv_disksaw" } );

    end;
    function use_sawdisk_beg ()

      ObjDelete( "obj_brokendisksaw_use_sawdisk" );

    end;
    function use_sawdisk_end ()
      
      if cmn.IsEventDone( "use_fuelbottle" ) then

        ObjMultiSet({ 
          { "spr_deploy_brokendisksaw_brokendisksaw",     { input = true     }},
          { "gfx_deploy_brokendisksaw_brokendisksaw",     { active = true    }},
        });

      end;

      ObjSet( "spr_deploy_brokendisksaw_disk", { alp = 1 } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_sawdisk", use_sawdisk_beg, "inv_brokendisksaw");
    cmn.AddSubscriber( "use_sawdisk", use_sawdisk_inv );
    cmn.AddSubscriber( "use_sawdisk", use_sawdisk_inv_end );
    cmn.AddSubscriber( "use_sawdisk", use_sawdisk_end, "inv_brokendisksaw" );
    cmn.AddSubscriber( "use_sawdisk_inv", use_sawdisk_inv );
    cmn.AddSubscriber( "use_sawdisk_beg", use_sawdisk_beg, "inv_brokendisksaw" );
    cmn.AddSubscriber( "use_sawdisk_end", use_sawdisk_end, "inv_brokendisksaw" );
    cmn.AddSubscriber( "use_sawdisk_end", use_sawdisk_inv_end );
    --------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_fuelbottle" ] = {
        type = "use",
        inv_obj = "inv_fuelbottle",
        use_place = "obj_brokendisksaw_use_fuelbottle",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokendisksaw",
        zz_gate = "inv_brokendisksaw"
    };
    function use_fuelbottle_inv ()

      interface.InventoryItemRemove( "inv_fuelbottle" );

    end;
    function use_fuelbottle_beg ()

      ObjDelete( "obj_brokendisksaw_use_fuelbottle" );

    end;
    function use_fuelbottle_end ()
      
      if cmn.IsEventDone( "use_sawdisk" ) then

        ObjMultiSet({ 
          { "spr_deploy_brokendisksaw_brokendisksaw",     { input = true     }},
          { "gfx_deploy_brokendisksaw_brokendisksaw",     { active = true    }},
        });

      end;

      ObjSet( "spr_deploy_brokendisksaw_cap", { alp = 1 } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_fuelbottle", use_fuelbottle_beg, "inv_brokendisksaw");
    cmn.AddSubscriber( "use_fuelbottle", use_fuelbottle_inv );
    cmn.AddSubscriber( "use_fuelbottle", use_fuelbottle_end, "inv_brokendisksaw" );
    cmn.AddSubscriber( "use_fuelbottle_inv", use_fuelbottle_inv );
    cmn.AddSubscriber( "use_fuelbottle_beg", use_fuelbottle_beg, "inv_brokendisksaw" );
    cmn.AddSubscriber( "use_fuelbottle_end", use_fuelbottle_end, "inv_brokendisksaw" );
    --------------------------------------------------------------------------------------------
    --------------------------------------------------------------------------------------------
  end;

  --------------------------------------------------------------------------------------------
  function public.get_disksaw()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_disksaw" );
    cmn.CallEventHandler( "get_disksaw", "inv_brokendisksaw" );
    common_impl.HideDeployInv();

  end;
  --------------------------------------------------------------------------------------------
  function public.use_sawdisk()

    local item = "inv_sawdisk";

    if ( private.ObjIntersectCheck( item, "obj_brokendisksaw_use_sawdisk" ) )  then

      common_impl.Lock( true );
      cmn.CallEventHandler( "use_sawdisk_inv" );
      cmn.CallEventHandler( "use_sawdisk_beg", "inv_brokendisksaw" );

      local func_end = function ()

        common_impl.Lock( false );
        cmn.SetEventDone( "use_sawdisk" );
        cmn.CallEventHandler( "use_sawdisk_end", "inv_brokendisksaw" );
        
      end;

      common_impl.PlayAudio( "sfx", "common/audio/aud_brokendisksaw_sawdisk", 0, "", 0 );
      common_impl.Lock( true );
      ObjAnimate( "spr_deploy_brokendisksaw_disk", "alp", 0, 0, func_end, { 0,0,0, 0.3,0,1 } );

      return true;

    end;

  end;
  --------------------------------------------------------------------------------------------
  function public.use_fuelbottle()

    local item = "inv_fuelbottle";

    if ( private.ObjIntersectCheck( item, "obj_brokendisksaw_use_fuelbottle" ) )  then

      cmn.CallEventHandler( "use_fuelbottle_inv" );
      cmn.CallEventHandler( "use_fuelbottle_beg", "inv_brokendisksaw" );

      local func_end = function ()

        common_impl.Lock( false );
        cmn.SetEventDone( "use_fuelbottle" );
        cmn.CallEventHandler( "use_fuelbottle_end", "inv_brokendisksaw" );
        
      end;

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_brokendisksaw_fuelbottle", 0, "", 0 );
      ObjAnimate( "spr_deploy_brokendisksaw_cap", "alp", 0, 0, "", 
      { 
        0.0,0,1,
        0.3,0,0,
        5.5,0,0,
        5.8,0,1
      } );

      VidPlay( "vid_deploy_brokendisksaw_bottle", func_end );

      return true;

    end;

  end;
--*********************************************************************************************************************
-- function *** brokenlightcharm *** () end;
--*********************************************************************************************************************
  function private.init_brokenlightcharm()

    common_impl.hint[ "use_charmpiece_1" ] = {
        type = "use",
        inv_obj = "inv_charmpiece_1",
        use_place = "obj_brokenlightcharm_use_charmpiece",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokenlightcharm",
        zz_gate = "inv_brokenlightcharm"
    };
    function use_charmpiece_1_inv ()

      interface.InventoryItemRemove( "inv_charmpiece_1" );

    end;
    function use_charmpiece_1_inv_end ()

      ObjSet( "inv_brokenlightcharm_piece_1", { alp = 1 } );

    end;
    function use_charmpiece_1_beg ()

      if cmn.IsEventDone( "use_charmpiece_2" ) and
        cmn.IsEventDone( "use_charmpiece_3" ) and
        cmn.IsEventDone( "use_charmpiece_4" ) and
        cmn.IsEventDone( "use_charmpiece_5" ) then

        ObjDelete( "obj_brokenlightcharm_use_charmpiece" );

      end;


    end;
    function use_charmpiece_1_end ()

      if cmn.IsEventDone( "use_charmpiece_2" ) and
        cmn.IsEventDone( "use_charmpiece_3" ) and
        cmn.IsEventDone( "use_charmpiece_4" ) and
        cmn.IsEventDone( "use_charmpiece_5" ) then

        ObjMultiSet({ 
          { "spr_deploy_brokenlightcharm_charm", { input = true }},
          { "gfx_deploy_brokenlightcharm_charm", { active = true }},
        });

      end;

      ObjSet( "spr_deploy_brokenlightcharm_charm_part_1", { alp = 1 } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_charmpiece_1", use_charmpiece_1_beg, "inv_brokenlightcharm" );
    cmn.AddSubscriber( "use_charmpiece_1", use_charmpiece_1_inv );
    cmn.AddSubscriber( "use_charmpiece_1", use_charmpiece_1_inv_end );
    cmn.AddSubscriber( "use_charmpiece_1", use_charmpiece_1_end, "inv_brokenlightcharm" );
    cmn.AddSubscriber( "use_charmpiece_1_inv", use_charmpiece_1_inv );
    cmn.AddSubscriber( "use_charmpiece_1_inv_end", use_charmpiece_1_inv_end );
    cmn.AddSubscriber( "use_charmpiece_1_beg", use_charmpiece_1_beg, "inv_brokenlightcharm" );
    cmn.AddSubscriber( "use_charmpiece_1_end", use_charmpiece_1_end, "inv_brokenlightcharm" );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_charmpiece_2" ] = {
        type = "use",
        inv_obj = "inv_charmpiece_2",
        use_place = "obj_brokenlightcharm_use_charmpiece",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokenlightcharm",
        zz_gate = "inv_brokenlightcharm"
    };
    function use_charmpiece_2_inv ()

      interface.InventoryItemRemove( "inv_charmpiece_2" );

    end;
    function use_charmpiece_2_inv_end ()

      ObjSet( "inv_brokenlightcharm_piece_2", { alp = 1 } );

    end;
    function use_charmpiece_2_beg ()

      if cmn.IsEventDone( "use_charmpiece_1" ) and
        cmn.IsEventDone( "use_charmpiece_3" ) and
        cmn.IsEventDone( "use_charmpiece_4" ) and
        cmn.IsEventDone( "use_charmpiece_5" ) then

        ObjDelete( "obj_brokenlightcharm_use_charmpiece" );

      end;

    end;
    function use_charmpiece_2_end ()

      if cmn.IsEventDone( "use_charmpiece_1" ) and
        cmn.IsEventDone( "use_charmpiece_3" ) and
        cmn.IsEventDone( "use_charmpiece_4" ) and
        cmn.IsEventDone( "use_charmpiece_5" ) then

        ObjMultiSet({ 
          { "spr_deploy_brokenlightcharm_charm", { input = true }},
          { "gfx_deploy_brokenlightcharm_charm", { active = true }},
        });

      end;

      ObjSet( "spr_deploy_brokenlightcharm_charm_part_2", { alp = 1 } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_charmpiece_2", use_charmpiece_2_beg, "inv_brokenlightcharm" );
    cmn.AddSubscriber( "use_charmpiece_2", use_charmpiece_2_inv );
    cmn.AddSubscriber( "use_charmpiece_2", use_charmpiece_2_inv_end );
    cmn.AddSubscriber( "use_charmpiece_2", use_charmpiece_2_end, "inv_brokenlightcharm" );
    cmn.AddSubscriber( "use_charmpiece_2_inv", use_charmpiece_2_inv );
    cmn.AddSubscriber( "use_charmpiece_2_inv_end", use_charmpiece_2_inv_end );
    cmn.AddSubscriber( "use_charmpiece_2_beg", use_charmpiece_2_beg, "inv_brokenlightcharm" );
    cmn.AddSubscriber( "use_charmpiece_2_end", use_charmpiece_2_end, "inv_brokenlightcharm" );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_charmpiece_3" ] = {
        type = "use",
        inv_obj = "inv_charmpiece_3",
        use_place = "obj_brokenlightcharm_use_charmpiece",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokenlightcharm",
        zz_gate = "inv_brokenlightcharm"
    };
    function use_charmpiece_3_inv ()

      interface.InventoryItemRemove( "inv_charmpiece_3" );

    end;
    function use_charmpiece_3_inv_end ()

      ObjSet( "inv_brokenlightcharm_piece_3", { alp = 1 } );

    end;
    function use_charmpiece_3_beg ()

      if cmn.IsEventDone( "use_charmpiece_1" ) and
        cmn.IsEventDone( "use_charmpiece_2" ) and
        cmn.IsEventDone( "use_charmpiece_4" ) and
        cmn.IsEventDone( "use_charmpiece_5" ) then

        ObjDelete( "obj_brokenlightcharm_use_charmpiece" );

      end;


    end;
    function use_charmpiece_3_end ()

      if cmn.IsEventDone( "use_charmpiece_1" ) and
        cmn.IsEventDone( "use_charmpiece_2" ) and
        cmn.IsEventDone( "use_charmpiece_4" ) and
        cmn.IsEventDone( "use_charmpiece_5" ) then

        ObjMultiSet({ 
          { "spr_deploy_brokenlightcharm_charm", { input = true }},
          { "gfx_deploy_brokenlightcharm_charm", { active = true }},
        });

      end;

      ObjSet( "spr_deploy_brokenlightcharm_charm_part_3", { alp = 1 } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_charmpiece_3", use_charmpiece_3_beg, "inv_brokenlightcharm" );
    cmn.AddSubscriber( "use_charmpiece_3", use_charmpiece_3_inv );
    cmn.AddSubscriber( "use_charmpiece_3", use_charmpiece_3_inv_end );
    cmn.AddSubscriber( "use_charmpiece_3", use_charmpiece_3_end, "inv_brokenlightcharm" );
    cmn.AddSubscriber( "use_charmpiece_3_inv", use_charmpiece_3_inv );
    cmn.AddSubscriber( "use_charmpiece_3_inv_end", use_charmpiece_3_inv_end );
    cmn.AddSubscriber( "use_charmpiece_3_beg", use_charmpiece_3_beg, "inv_brokenlightcharm" );
    cmn.AddSubscriber( "use_charmpiece_3_end", use_charmpiece_3_end, "inv_brokenlightcharm" );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_charmpiece_4" ] = {
        type = "use",
        inv_obj = "inv_charmpiece_4",
        use_place = "obj_brokenlightcharm_use_charmpiece",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokenlightcharm",
        zz_gate = "inv_brokenlightcharm"
    };
    function use_charmpiece_4_inv ()

      interface.InventoryItemRemove( "inv_charmpiece_4" );

    end;
    function use_charmpiece_4_inv_end ()

      ObjSet( "inv_brokenlightcharm_piece_4", { alp = 1 } );

    end;
    function use_charmpiece_4_beg ()

      if cmn.IsEventDone( "use_charmpiece_1" ) and
        cmn.IsEventDone( "use_charmpiece_2" ) and
        cmn.IsEventDone( "use_charmpiece_3" ) and
        cmn.IsEventDone( "use_charmpiece_5" ) then

        ObjDelete( "obj_brokenlightcharm_use_charmpiece" );

      end;

    end;
    function use_charmpiece_4_end ()

      if cmn.IsEventDone( "use_charmpiece_1" ) and
        cmn.IsEventDone( "use_charmpiece_2" ) and
        cmn.IsEventDone( "use_charmpiece_3" ) and
        cmn.IsEventDone( "use_charmpiece_5" ) then

        ObjMultiSet({ 
          { "spr_deploy_brokenlightcharm_charm", { input = true }},
          { "gfx_deploy_brokenlightcharm_charm", { active = true }},
        });

      end;

      ObjSet( "spr_deploy_brokenlightcharm_charm_part_4", { alp = 1 } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_charmpiece_4", use_charmpiece_4_beg, "inv_brokenlightcharm" );
    cmn.AddSubscriber( "use_charmpiece_4", use_charmpiece_4_inv );
    cmn.AddSubscriber( "use_charmpiece_4", use_charmpiece_4_inv_end );
    cmn.AddSubscriber( "use_charmpiece_4", use_charmpiece_4_end, "inv_brokenlightcharm" );
    cmn.AddSubscriber( "use_charmpiece_4_inv", use_charmpiece_4_inv );
    cmn.AddSubscriber( "use_charmpiece_4_inv_end", use_charmpiece_4_inv_end );
    cmn.AddSubscriber( "use_charmpiece_4_beg", use_charmpiece_4_beg, "inv_brokenlightcharm" );
    cmn.AddSubscriber( "use_charmpiece_4_end", use_charmpiece_4_end, "inv_brokenlightcharm" );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "use_charmpiece_5" ] = {
        type = "use",
        inv_obj = "inv_charmpiece_5",
        use_place = "obj_brokenlightcharm_use_charmpiece",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokenlightcharm",
        zz_gate = "inv_brokenlightcharm"
    };
    function use_charmpiece_5_inv ()

      interface.InventoryItemRemove( "inv_charmpiece_5" );

    end;
    function use_charmpiece_5_inv_end ()

      ObjSet( "inv_brokenlightcharm_piece_5", { alp = 1 } );

    end;
    function use_charmpiece_5_beg ()

      if cmn.IsEventDone( "use_charmpiece_1" ) and
        cmn.IsEventDone( "use_charmpiece_2" ) and
        cmn.IsEventDone( "use_charmpiece_3" ) and
        cmn.IsEventDone( "use_charmpiece_4" ) then

        ObjDelete( "obj_brokenlightcharm_use_charmpiece" );

      end;


    end;
    function use_charmpiece_5_end ()

      if cmn.IsEventDone( "use_charmpiece_1" ) and
        cmn.IsEventDone( "use_charmpiece_2" ) and
        cmn.IsEventDone( "use_charmpiece_3" ) and
        cmn.IsEventDone( "use_charmpiece_4" ) then

        ObjMultiSet({ 
          { "spr_deploy_brokenlightcharm_charm", { input = true }},
          { "gfx_deploy_brokenlightcharm_charm", { active = true }},
        });

      end;

      ObjSet( "spr_deploy_brokenlightcharm_charm_part_5", { alp = 1 } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_charmpiece_5", use_charmpiece_5_beg, "inv_brokenlightcharm" );
    cmn.AddSubscriber( "use_charmpiece_5", use_charmpiece_5_inv );
    cmn.AddSubscriber( "use_charmpiece_5", use_charmpiece_5_inv_end );
    cmn.AddSubscriber( "use_charmpiece_5", use_charmpiece_5_end, "inv_brokenlightcharm" );
    cmn.AddSubscriber( "use_charmpiece_5_inv", use_charmpiece_5_inv );
    cmn.AddSubscriber( "use_charmpiece_5_inv_end", use_charmpiece_5_inv_end );
    cmn.AddSubscriber( "use_charmpiece_5_beg", use_charmpiece_5_beg, "inv_brokenlightcharm" );
    cmn.AddSubscriber( "use_charmpiece_5_end", use_charmpiece_5_end, "inv_brokenlightcharm" );
    -------------------------------------------------------------------------------------------
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_lightcharm" ] = {
        type = "get",
        get_obj = "spr_deploy_brokenlightcharm_charm",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokenlightcharm",
        zz_gate = "inv_brokenlightcharm"
    };
    function get_lightcharm_inv ()

      interface.InventoryItemAdd( "inv_lightcharm", "spr_deploy_brokenlightcharm_charm" );
      interface.InventoryItemRemove( "inv_brokenlightcharm" );

    end;
    function get_lightcharm_deploy ()

      ObjDelete( "gfx_deploy_brokenlightcharm_charm" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_lightcharm", get_lightcharm_deploy );
    cmn.AddSubscriber( "get_lightcharm", get_lightcharm_inv );
    -------------------------------------------------------------------------------------------
    ObjSet( "spr_deploy_brokenlightcharm_charm", { event_mdown = levelext_inv.get_lightcharm });

  end;

  function public.get_lightcharm()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_lightcharm" );
    cmn.CallEventHandler( "get_lightcharm", "inv_lightcharm" );
    common_impl.HideDeployInv();

  end;
  function public.use_charmpiece_1()

    local item = "inv_charmpiece_1";

    if private.ObjIntersectCheck( item, "obj_brokenlightcharm_use_charmpiece" ) then

      cmn.CallEventHandler( "use_charmpiece_1_beg", "inv_brokenlightcharm" );
      cmn.CallEventHandler( "use_charmpiece_1_inv" );

      local func_end = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_charmpiece_1" );
        cmn.CallEventHandler( "use_charmpiece_1_end", "inv_brokenlightcharm" );
        cmn.CallEventHandler( "use_charmpiece_1_inv_end" );

      end;

      common_impl.Lock( true );
      ObjAnimate( "spr_deploy_brokenlightcharm_charm_part_1", "alp", 0, 0, func_end, { 0,0,0, 0.3,0,1 } );
      common_impl.PlayAudio( "sfx", "common/audio/aud_use_charmpiece", 0, "", 0 );
      return true;

    end;

  end;
  function public.use_charmpiece_2()

    local item = "inv_charmpiece_2";

    if private.ObjIntersectCheck( item, "obj_brokenlightcharm_use_charmpiece" ) then

      cmn.CallEventHandler( "use_charmpiece_2_beg", "inv_brokenlightcharm" );
      cmn.CallEventHandler( "use_charmpiece_2_inv" );

      local func_end = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_charmpiece_2" );
        cmn.CallEventHandler( "use_charmpiece_2_end", "inv_brokenlightcharm" );
        cmn.CallEventHandler( "use_charmpiece_2_inv_end" );

      end;

      common_impl.Lock( true );
      ObjAnimate( "spr_deploy_brokenlightcharm_charm_part_2", "alp", 0, 0, func_end, { 0,0,0, 0.3,0,1 } );

      common_impl.PlayAudio( "sfx", "common/audio/aud_use_charmpiece", 0, "", 0 );
      return true;

    end;

  end;
  function public.use_charmpiece_3()

    local item = "inv_charmpiece_3";

    if private.ObjIntersectCheck( item, "obj_brokenlightcharm_use_charmpiece" ) then

      cmn.CallEventHandler( "use_charmpiece_3_beg", "inv_brokenlightcharm" );
      cmn.CallEventHandler( "use_charmpiece_3_inv" );

      local func_end = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_charmpiece_3" );
        cmn.CallEventHandler( "use_charmpiece_3_end", "inv_brokenlightcharm" );
        cmn.CallEventHandler( "use_charmpiece_3_inv_end" );

      end;

      common_impl.Lock( true );
      ObjAnimate( "spr_deploy_brokenlightcharm_charm_part_3", "alp", 0, 0, func_end, { 0,0,0, 0.3,0,1 } );

       common_impl.PlayAudio( "sfx", "common/audio/aud_use_charmpiece", 0, "", 0 );
      return true;

    end;

  end;
  function public.use_charmpiece_4()

    local item = "inv_charmpiece_4";

    if private.ObjIntersectCheck( item, "obj_brokenlightcharm_use_charmpiece" ) then

      cmn.CallEventHandler( "use_charmpiece_4_beg", "inv_brokenlightcharm" );
      cmn.CallEventHandler( "use_charmpiece_4_inv" );

      local func_end = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_charmpiece_4" );
        cmn.CallEventHandler( "use_charmpiece_4_end", "inv_brokenlightcharm" );
        cmn.CallEventHandler( "use_charmpiece_4_inv_end" );

      end;

      common_impl.Lock( true );
      ObjAnimate( "spr_deploy_brokenlightcharm_charm_part_4", "alp", 0, 0, func_end, { 0,0,0, 0.3,0,1 } );

       common_impl.PlayAudio( "sfx", "common/audio/aud_use_charmpiece", 0, "", 0 );
      return true;

    end;

  end;
  function public.use_charmpiece_5()

    local item = "inv_charmpiece_5";

    if private.ObjIntersectCheck( item, "obj_brokenlightcharm_use_charmpiece" ) then

      cmn.CallEventHandler( "use_charmpiece_5_beg", "inv_brokenlightcharm" );
      cmn.CallEventHandler( "use_charmpiece_5_inv" );

      local func_end = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_charmpiece_5" );
        cmn.CallEventHandler( "use_charmpiece_5_end", "inv_brokenlightcharm" );
        cmn.CallEventHandler( "use_charmpiece_5_inv_end" );

      end;

      common_impl.Lock( true );
      ObjAnimate( "spr_deploy_brokenlightcharm_charm_part_5", "alp", 0, 0, func_end, { 0,0,0, 0.3,0,1 } );

      common_impl.PlayAudio( "sfx", "common/audio/aud_use_charmpiece", 0, "", 0 );
      return true;

    end;

  end;
--*********************************************************************************************************************
-- function *** brokentank *** () end;
--*********************************************************************************************************************
  function private.init_brokentank()

    common_impl.hint[ "use_valve_4" ] = {
        type = "use",
        inv_obj = "inv_valve_4",
        use_place = "obj_brokentank_use_valve_4",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokentank",
        zz_gate = "inv_brokentank"
    };
    function use_valve_4_inv ()

      interface.InventoryItemRemove( "inv_valve_4" );

    end;
    function use_valve_4_inv_end ()

      ObjSet( "inv_brokentank", { res = "assets/levels/levelext/inv_deploy/inv_brokentank/inv/inv_nitrogentank" } );

    end;
    function use_valve_4_beg ()

      ObjDelete( "obj_brokentank_use_valve_4" );

    end;
    function use_valve_4_end ()

      ObjDelete( "spr_deploy_brokentank_brokentank" );
      ObjMultiSet({ 
        { "spr_deploy_brokentank_nitrogentank",  { input = true  }},
        { "gfx_deploy_brokentank_nitrogentank",  { active = true }},
        { "spr_deploy_brokentank_valve",  { alp = 1 }},
      });

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_valve_4", use_valve_4_beg, "inv_brokentank" );
    cmn.AddSubscriber( "use_valve_4", use_valve_4_inv );
    cmn.AddSubscriber( "use_valve_4", use_valve_4_inv_end );
    cmn.AddSubscriber( "use_valve_4", use_valve_4_end, "inv_brokentank" );
    cmn.AddSubscriber( "use_valve_4_inv", use_valve_4_inv );
    cmn.AddSubscriber( "use_valve_4_inv_end", use_valve_4_inv_end );
    cmn.AddSubscriber( "use_valve_4_beg", use_valve_4_beg, "inv_brokentank" );
    cmn.AddSubscriber( "use_valve_4_end", use_valve_4_end, "inv_brokentank" );
    
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_nitrogentank" ] = {
        type = "get",
        get_obj = "spr_deploy_brokentank_nitrogentank",
        room = "int_deploy_inv",
        zz = "deploy_inv_brokentank",
        zz_gate = "inv_brokentank"
    };
    function get_nitrogentank_inv ()

      interface.InventoryItemAdd( "inv_nitrogentank", "spr_deploy_brokentank_nitrogentank" );
      interface.InventoryItemRemove( "inv_brokentank" );

    end;
    function get_nitrogentank_deploy ()

      ObjDelete( "gfx_deploy_brokentank_nitrogentank" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_nitrogentank", get_nitrogentank_inv );
    cmn.AddSubscriber( "get_nitrogentank", get_nitrogentank_deploy );
    -------------------------------------------------------------------------------------------
    ObjSet( "spr_deploy_brokentank_nitrogentank", { event_mdown = levelext_inv.get_nitrogentank });

  end;

  function public.get_nitrogentank()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_nitrogentank" );
    cmn.CallEventHandler( "get_nitrogentank", "inv_nitrogentank" );
    common_impl.HideDeployInv();

  end;
  function public.use_valve_4()

    local item = "inv_valve_4";

    if private.ObjIntersectCheck( item, "obj_brokentank_use_valve_4" ) then

      cmn.CallEventHandler( "use_valve_4_beg", "inv_brokentank" );
      cmn.CallEventHandler( "use_valve_4_inv" );

      local func_end = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_valve_4" );
        cmn.CallEventHandler( "use_valve_4_end", "inv_brokentank" );
        cmn.CallEventHandler( "use_valve_4_inv_end" );

      end;

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_use_valve_4", 0, "", 0 );
      ObjAnimate( "spr_deploy_brokentank_valve", "alp", 0, 0, func_end, { 0,0,0, 0.3,0,1 } );

      return true;

    end;

  end;
--*********************************************************************************************************************
-- function *** extinctlantern for MG_EXTINCTLANTERN *** () end;
--*********************************************************************************************************************
  function private.init_extinctlantern()

    public.extinctlantern_prevroom = "empty";
    ObjSet( "inv_extinctlantern", { event_mdown = function() public.GotoMgLantern() end });
    --------------------------------------------------------------------------------------------
    function public.GotoMgLantern()
        
        common.CloseSubRoom();
        public.extinctlantern_prevroom = GetCurrentRoom();

        local inv_name = interface.GetCurrentInv();
        if ( inv_name ~= "" ) then

          interface.DeployInvHide();   

        end;

        --Проверка на то, если кликнуть на инв объект фонаря, находясь в самой МГ. Если так, то выходим из МГ.
        if public.extinctlantern_prevroom == "mg_extinctlantern" then

          cmn.GotoRoom( ng_global.progress[ "ext" ][ "win_extinctlantern" ].exitroom );
          return;

        end;
        ------------------------------------------------------
        cmn.GotoRoom( "mg_extinctlantern" );

    end;

  end;
--*********************************************************************************************************************
-- function *** extinctlantern2 *** () end;
--*********************************************************************************************************************
  function private.init_extinctlantern2()
  
    ObjAnimate( "spr_deploy_extinctlantern2_light", "alp", 1, 0, "", { 0,0,0.5, 2,0,1, 4,0,0.5 } );

      common_impl.hint[ "clk_extinctlantern2_open" ] = {
        type = "click",
        use_place = "obj_extinctlantern2_open_clk",
        room = "int_deploy_inv",
        zz = "deploy_inv_extinctlantern2",
        zz_gate = "inv_extinctlantern2"
    };


    function clk_extinctlantern2_open ()

      ObjDelete( "obj_extinctlantern2_open_clk" );
      
      ObjMultiSet({
        { "obj_extinctlantern2_use_litchip", { input = true } },
        { "spr_deploy_extinctlantern2_close", { alp = 0 } }, 
        { "spr_deploy_extinctlantern2_open", { alp = 1 } }, 

      })

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_extinctlantern2_open", clk_extinctlantern2_open );
    -------------------------------------------------------------------------------------------

      common_impl.hint[ "clk_extinctlantern2_close" ] = {
        type = "click",
        use_place = "obj_extinctlantern2_close_clk",
        room = "int_deploy_inv",
        zz = "deploy_inv_extinctlantern2",
        zz_gate = "inv_extinctlantern2"
    };


    function clk_extinctlantern2_close ()

      ObjDelete( "obj_extinctlantern2_open_clk" );
      
      ObjMultiSet({
          
        { "spr_deploy_extinctlantern2_close", { alp = 1 } }, 
        { "spr_deploy_extinctlantern2_open", { alp = 0 } }, 
        { "obj_deploy_extinctlantern2_magiclantern_2", { active = true, input = true, alp = 1} },
      })

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_extinctlantern2_close", clk_extinctlantern2_close );
    -------------------------------------------------------------------------------------------

    common_impl.hint[ "use_litchip" ] = {
        type = "use",
        inv_obj = "inv_litchip",
        use_place = "obj_extinctlantern2_use_litchip",
        room = "int_deploy_inv",
        zz = "deploy_inv_extinctlantern2",
        zz_gate = "inv_extinctlantern2"
    };
    function use_litchip_inv ()

      interface.InventoryItemRemove( "inv_litchip" );

    end;
    function use_litchip_inv_end ()

      ObjDelete("vid_deploy_extinctlantern2_use_litchip");

    end;
    function use_litchip_beg ()

      ObjDelete( "obj_extinctlantern2_use_litchip" );

    end;

    function use_litchip_end ()

      ObjMultiSet({

        { "obj_extinctlantern2_close_clk", { input = true } }, 
        { "vid_deploy_extinctlantern2_use_litchip_loop", { playing = true, looped = true, alp = 1 } },
        { "spr_deploy_extinctlantern2_light", { active = true, visible = true } },
        --{ "spr_extinctlantern2_lantern_light_2", { alp = 1 } },
        { "anm_extinctlantern2_light", { alp = 1 } },
      } );

      ObjDelete( "spr_deploy_extinctlantern2_extinctlantern2" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_litchip", use_litchip_beg, "inv_extinctlantern2" );
    cmn.AddSubscriber( "use_litchip", use_litchip_inv );
    cmn.AddSubscriber( "use_litchip", use_litchip_inv_end );
    cmn.AddSubscriber( "use_litchip", use_litchip_end, "inv_extinctlantern2" );
    cmn.AddSubscriber( "use_litchip_inv", use_litchip_inv );
    cmn.AddSubscriber( "use_litchip_inv_end", use_litchip_inv_end );
    cmn.AddSubscriber( "use_litchip_beg", use_litchip_beg, "inv_extinctlantern2" );
    cmn.AddSubscriber( "use_litchip_end", use_litchip_end, "inv_extinctlantern2" );
    
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_magiclantern_2" ] = {
        type = "get",
        get_obj = "obj_deploy_extinctlantern2_magiclantern_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_extinctlantern2",
        zz_gate = "inv_extinctlantern2"
    };
    function get_magiclantern_2_inv ()

      interface.InventoryItemAdd( "inv_magiclantern_2", "obj_deploy_extinctlantern2" );
      interface.InventoryItemRemove( "inv_extinctlantern2" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_magiclantern_2", get_magiclantern_2_inv );
    -------------------------------------------------------------------------------------------
    ObjSet( "obj_deploy_extinctlantern2_magiclantern_2", { event_mdown = levelext_inv.get_magiclantern_2 });

  end;

  function public.get_magiclantern_2()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_magiclantern_2" );
    cmn.CallEventHandler( "get_magiclantern_2", "inv_magiclantern_2" );
    common_impl.HideDeployInv();

  end;
  ------------------------------------------------------------------------------------------------
  function private.open_extinctlantern()

    local endfunc = function ()

      common_impl.Lock( false );

      cmn.SetEventDone( "clk_extinctlantern2_open" );
      cmn.CallEventHandler( "clk_extinctlantern2_open" );

    end;
    
    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_lantern_open", 0, "", 0 );
    ObjAnimate( "spr_deploy_extinctlantern2_open", "alp", 0, 0, endfunc, { 0, 3, 0, 0.4, 3, 1 });
    ObjAnimate( "spr_deploy_extinctlantern2_close", "alp", 0, 0, "",      { 0, 3, 1, 0.4, 3, 0 });
 
  end;
  ------------------------------------------------------------------------------------------------
  function private.close_extinctlantern()

    local endfunc = function ()

      common_impl.Lock( false );
      
      cmn.SetEventDone( "clk_extinctlantern2_close" );
      cmn.CallEventHandler( "clk_extinctlantern2_close" );

    end;
    
    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_lantern_close", 0, "", 0 );
    ObjAnimate( "spr_deploy_extinctlantern2_close", "alp", 0, 0, endfunc, { 0, 3, 0, 0.4, 3, 1 });
    ObjAnimate( "spr_deploy_extinctlantern2_open", "alp", 0, 0, "",      { 0, 3, 1, 0.4, 3, 0 });  
    
 
  end;
  ------------------------------------------------------------------------------------------------
  function public.use_litchip()

    local item = "inv_litchip";

    if private.ObjIntersectCheck( item, "obj_extinctlantern2_use_litchip" ) and cmn.IsEventDone( "clk_extinctlantern2_open" ) then

      cmn.CallEventHandler( "use_litchip_beg", "inv_extinctlantern2" );
      cmn.CallEventHandler( "use_litchip_inv" );

      local func_end = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_litchip" );
        cmn.CallEventHandler( "use_litchip_end", "inv_extinctlantern2" );
        cmn.CallEventHandler( "use_litchip_inv_end" );

      end;

      common_impl.Lock( true );

      ObjSet( "vid_deploy_extinctlantern2_use_litchip", { playing = true, endtrig = func_end, alp = 1 } );
      common_impl.PlayAudio( "sfx", "common/audio/aud_use_litchip", 0, "", 0 );
      --ObjAnimate( "spr_extinctlantern2_lantern_light_2", "alp", 0, 0, "", { 0,3,0, 5.6,3,0, 6.2,3,1 });
      ObjAnimate( "anm_extinctlantern2_light", "alp", 0, 0, "", { 0,3,0, 5.6,3,0, 6.2,3,1 });
 
      return true;

    end;

  end;
--*********************************************************************************************************************
-- function *** extinctlantern3 for MG_AMPLIFICATION *** () end;
--*********************************************************************************************************************
  function private.init_extinctlantern3()

    common_impl.hint[ "use_amplifier" ] = {
    type = "use",
    inv_obj = "inv_amplifier",
    use_place = "obj_deploy_inv_extinctlantern_3_use_amplifier",
    room = "int_deploy_inv",
    zz = "deploy_inv_extinctlantern3",
    zz_gate = "inv_extinctlantern3"

    };
    function use_amplifier_inv ()

      interface.InventoryItemRemove( "inv_amplifier" );

    end;
    function use_amplifier_inv_end ()


    end;
    function use_amplifier_beg ()

      ObjDelete( "obj_deploy_inv_extinctlantern_3_use_amplifier" );

    end;
    function use_amplifier_end ()
      
      ObjSet( "inv_extinctlantern3", { event_mdown = function() public.GotoMgAmplification() end });

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_amplifier", use_amplifier_beg, "inv_extinctlantern3");
    cmn.AddSubscriber( "use_amplifier", use_amplifier_inv );
    cmn.AddSubscriber( "use_amplifier", use_amplifier_inv_end );
    cmn.AddSubscriber( "use_amplifier", use_amplifier_end );
    cmn.AddSubscriber( "use_amplifier_inv", use_amplifier_inv );
    cmn.AddSubscriber( "use_amplifier_inv_end", use_amplifier_inv_end, "inv_extinctlantern3" );
    cmn.AddSubscriber( "use_amplifier_beg", use_amplifier_beg, "inv_extinctlantern3" );
    cmn.AddSubscriber( "use_amplifier_end", use_amplifier_end );

    public.amplification_prevroom = "empty";
    --------------------------------------------------------------------------------------------
    function public.GotoMgAmplification()

      common.CloseSubRoom();          

        local inv_name = interface.GetCurrentInv();
        if ( inv_name ~= "" ) then

          interface.DeployInvHide();   

        end;

        public.amplification_prevroom = GetCurrentRoom();

        --Проверка на то, если кликнуть на инв объект фонаря, находясь в самой МГ. Если так, то выходим из МГ.
        if public.amplification_prevroom == "mg_amplification" then

          cmn.GotoRoom( ng_global.progress[ "ext" ][ "win_amplification" ].exitroom );
          return;

        end;
        ------------------------------------------------------
        cmn.GotoRoom( "mg_amplification" );

    end;

  end;
--------------------------------------------------------------------------------------------
  function public.use_amplifier()

    local item = "inv_amplifier";

    if private.ObjIntersectCheck( item, "obj_deploy_inv_extinctlantern_3_use_amplifier", "deploy_inv_extinctlantern3") then

      cmn.CallEventHandler( "use_amplifier_beg");
      cmn.CallEventHandler( "use_amplifier_inv" );

      local func_end = function ()

        common_impl.Lock( false );
        cmn.SetEventDone( "use_amplifier" );
        cmn.CallEventHandler( "use_amplifier_end" );
        cmn.CallEventHandler( "use_amplifier_inv_end" );
        public.GotoMgAmplification();
        interface.DeployInvHide();
      end;

      common_impl.Lock( true );

      ObjAnimate( "spr_deploy_extinctlantern_3_button_4", "alp", 0, 0, func_end, { 0, 3, 0, 0.4, 3, 1 });
      
      ObjAnimate( "spr_deploy_extinctlantern_3_button_5", "alp", 0, 0, "", { 0, 3, 0, 0.4, 3, 1 });

      ObjAnimate( "spr_deploy_extinctlantern_3_button_6", "alp", 0, 0, "", { 0, 3, 0, 0.4, 3, 1 });
      
      ObjAnimate( "obj_deploy_extinctlantern_3_parts_down", "alp", 0, 0, "", { 0, 3, 0, 0.4, 3, 1 });

      ObjAnimate( "spr_deploy_extinctlantern_3_emerald", "alp", 0, 0, "", { 0, 3, 0, 0.4, 3, 1 });
      
      common_impl.PlayAudio( "sfx", "common/audio/aud_magic_lantern_stone", 0, "", 0 );

      return true;

    end;

  end;
--*********************************************************************************************************************
-- function *** firetorch *** () end;
--*********************************************************************************************************************
  function private.init_firetorch()
  
    common_impl.hint[ "use_matches_4_1" ] = {
        type = "use",
        inv_obj = "inv_matches_4",
        use_place = "obj_firetorch_use_matches_4_1",
        room = "int_deploy_inv",
        zz = "deploy_inv_firetorch",
        zz_gate = "inv_firetorch"
    };
    function use_matches_4_1_inv ()

      if cmn.IsEventDone( "use_matches_4_2" ) then
        interface.InventoryItemRemove( "inv_matches_4" );
      end;

    end;
    function use_matches_4_1_inv_end ()

      ObjSet( "inv_firetorch", { res = "assets/levels/levelext/inv_deploy/inv_firetorch/inv/inv_burningfire" } );

    end;
    function use_matches_4_1_beg ()

      ObjDelete( "obj_firetorch_use_matches_4_1" );

    end;
    function use_matches_4_1_end ()

      ObjSet( "spr_deploy_firetorch_burningfire",     { active = true, input = true, alp = 1 } );      
      ObjSet( "vid_deploy_firetouch_fire", { active = true, visible = true, playing = true } );
      ObjDelete( "vid_deploy_firetouch_matches" );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_matches_4_1", use_matches_4_1_beg, "inv_firetorch" );
    cmn.AddSubscriber( "use_matches_4_1", use_matches_4_1_inv );
    cmn.AddSubscriber( "use_matches_4_1", use_matches_4_1_inv_end );
    cmn.AddSubscriber( "use_matches_4_1", use_matches_4_1_end, "inv_firetorch" );
    cmn.AddSubscriber( "use_matches_4_1_inv", use_matches_4_1_inv );
    cmn.AddSubscriber( "use_matches_4_1_inv_end", use_matches_4_1_inv_end );
    cmn.AddSubscriber( "use_matches_4_1_beg", use_matches_4_1_beg, "inv_firetorch" );
    cmn.AddSubscriber( "use_matches_4_1_end", use_matches_4_1_end, "inv_firetorch" );
    
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_burningfire" ] = {
        type = "get",
        get_obj = "spr_deploy_firetorch_burningfire",
        room = "int_deploy_inv",
        zz = "deploy_inv_firetorch",
        zz_gate = "inv_firetorch"
    };
    function get_burningfire_inv ()

      interface.InventoryItemAdd( "inv_burningfire", "spr_deploy_firetorch_burningfire" );
      interface.InventoryItemRemove( "inv_firetorch" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_burningfire", get_burningfire_inv );
    -------------------------------------------------------------------------------------------
    ObjSet( "spr_deploy_firetorch_burningfire", { event_mdown = levelext_inv.get_burningfire });
    ObjSet( "inv_firetorch", { event_mdown = private.Openfiretorch } );

  end;
  
  function private.Openfiretorch()

    common_impl.ShowDeployInv('inv_firetorch');
    
    if cmn.IsEventDone( "use_matches_4_1" ) then

      common_impl.PlayAudio( "env", "common/audio/aud_burning_flare", 1, "", 0.5 );

    end;


  end;

  function public.get_burningfire()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
    common_impl.StopAudio( "env", "common/audio/aud_burning_flare", 0.2 );
    cmn.SetEventDone( "get_burningfire" );
    cmn.CallEventHandler( "get_burningfire", "inv_burningfire" );
    common_impl.HideDeployInv();
    

  end;
  function public.use_matches_4_1()

    local item = "inv_matches_4";

    if private.ObjIntersectCheck( item, "obj_firetorch_use_matches_4_1" ) then

      cmn.CallEventHandler( "use_matches_4_1_beg", "inv_firetorch" );
      cmn.CallEventHandler( "use_matches_4_1_inv" );

      local func_end = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_matches_4_1" );
        cmn.CallEventHandler( "use_matches_4_1_end", "inv_firetorch" );
        cmn.CallEventHandler( "use_matches_4_1_inv_end" );
        common_impl.PlayAudio( "env", "common/audio/aud_burning_flare", 1, "", 0.5 );
        
      end;

      common_impl.Lock( true );
            
      ObjSet( "vid_deploy_firetouch_matches", { visible = true } );
      VidPlay( "vid_deploy_firetouch_matches", func_end );
      common_impl.PlayAudio( "sfx", "common/audio/aud_use_matches_4_1", 0, "", 0 );

      return true;

    end;

  end;
--*********************************************************************************************************************
-- function *** leakybucket *** () end;
--*********************************************************************************************************************
  function private.init_leakybucket()

    common_impl.hint[ "use_cover" ] = {
        type = "use",
        inv_obj = "inv_cover",
        use_place = "obj_leakybucket_use_cover",
        room = "int_deploy_inv",
        zz = "deploy_inv_leakybucket",
        zz_gate = "inv_leakybucket"
    };
    function use_cover_inv ()

      interface.InventoryItemRemove( "inv_cover" );

    end;
    function use_cover_inv_end ()

      ObjSet( "inv_leakybucket", { res = "assets/levels/levelext/inv_deploy/inv_leakybucket/inv/inv_bucket_4" } );

    end;
    function use_cover_beg ()

      ObjDelete( "obj_leakybucket_use_cover" );

    end;
    function use_cover_end ()

      ObjDelete( "spr_deploy_leakybucket_leakybucket" );
      ObjMultiSet({ 
        { "spr_deploy_leakybucket_bucket_4",     { input = true     }},
        { "gfx_deploy_leakybucket_bucket_4",     { active = true    }},
        { "spr_deploy_leakybucket_cork",     { alp = 1 }},
        { "spr_deploy_leakybucket_cork_over",{ alp = 1 }},
        { "spr_deploy_leakybucket_cork_2",   { alp = 1 }},
      });

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_cover", use_cover_beg, "inv_leakybucket" );
    cmn.AddSubscriber( "use_cover", use_cover_inv );
    cmn.AddSubscriber( "use_cover", use_cover_inv_end );
    cmn.AddSubscriber( "use_cover", use_cover_end, "inv_leakybucket" );
    cmn.AddSubscriber( "use_cover_inv", use_cover_inv );
    cmn.AddSubscriber( "use_cover_inv_end", use_cover_inv_end );
    cmn.AddSubscriber( "use_cover_beg", use_cover_beg, "inv_leakybucket" );
    cmn.AddSubscriber( "use_cover_end", use_cover_end, "inv_leakybucket" );
    
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_bucket_4" ] = {
        type = "get",
        get_obj = "spr_deploy_leakybucket_bucket_4",
        room = "int_deploy_inv",
        zz = "deploy_inv_leakybucket",
        zz_gate = "inv_leakybucket"
    };
    function get_bucket_4_inv ()

      interface.InventoryItemAdd( "inv_bucket_4", "obj_deploy_leakybucket" );
      interface.InventoryItemRemove( "inv_leakybucket" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_bucket_4", get_bucket_4_inv );
    -------------------------------------------------------------------------------------------
    ObjSet( "spr_deploy_leakybucket_bucket_4", { event_mdown = levelext_inv.get_bucket_4 });

  end;

  function public.get_bucket_4()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_bucket_4" );
    cmn.CallEventHandler( "get_bucket_4", "inv_bucket_4" );
    common_impl.HideDeployInv();

  end;
  function public.use_cover()

    local item = "inv_cover";

    if private.ObjIntersectCheck( item, "obj_leakybucket_use_cover" ) then

      cmn.CallEventHandler( "use_cover_beg", "inv_leakybucket" );
      cmn.CallEventHandler( "use_cover_inv" );

      local func_end = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_cover" );
        cmn.CallEventHandler( "use_cover_end", "inv_leakybucket" );
        cmn.CallEventHandler( "use_cover_inv_end" );

      end;

      common_impl.Lock( true );

       common_impl.PlayAudio( "sfx", "common/audio/aud_touch_bucket_lid", 0, "", 0 );
      ObjAnimate( "spr_deploy_leakybucket_cork", "alp", 0, 0, "", 
      {
        0.0,0,0,
        0.3,0,1
      });
      ObjAnimate( "spr_deploy_leakybucket_cork_shadow", "alp", 0, 0, "", 
      {
        0.0,0,0,
        0.6,0,0,
        1.0,0,1
      });
      ObjAnimate( "spr_deploy_leakybucket_cork_2", "alp", 0, 0, "", 
      {
        0.0,0,0,
        0.3,0,1
      });
      ObjAnimate( "spr_deploy_leakybucket_cork", "pos_xy", 0, 0, func_end, 
      {
        0,0, 25,-200,
        1,0,-30,23
      });
      --ObjAnimate( "spr_deploy_leakybucket_cork_2", "pos_xy", 0, 0, func_end, 
      --{
      --  1,0, 25,-192,
      --  1,0,-27,17
      --});

      return true;

    end;

  end;
--*********************************************************************************************************************
-- function *** revolver_4 *** () end;
--*********************************************************************************************************************
  function private.init_revolver_4()

    common_impl.hint[ "use_silverbullet" ] = {
        type = "use",
        inv_obj = "inv_silverbullet",
        use_place = "obj_revolver_4_use_silverbullet",
        room = "int_deploy_inv",
        zz = "deploy_inv_revolver_4",
        zz_gate = "inv_revolver_4"
    };
    function use_silverbullet_inv ()

      interface.InventoryItemRemove( "inv_silverbullet" );

    end;
    function use_silverbullet_inv_end ()

      --ObjSet( "inv_revolver_4", { res = "assets/levels/levelext/inv_deploy/inv_revolver_4/inv/inv_loadedgun_4" } );

    end;
    function use_silverbullet_beg ()

      ObjDelete( "obj_revolver_4_use_silverbullet" );

    end;
    function use_silverbullet_end ()

      ObjDelete( "spr_deploy_revolver_4_revolver" );
      ObjMultiSet({ 
        { "spr_deploy_revolver_4_bullet",     { alp = 1,      }},
        { "obj_deploy_revolver_4_clk_open",     { input = true,      }},
      });

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_silverbullet", use_silverbullet_beg, "inv_revolver_4" );
    cmn.AddSubscriber( "use_silverbullet", use_silverbullet_inv );
    cmn.AddSubscriber( "use_silverbullet", use_silverbullet_inv_end );
    cmn.AddSubscriber( "use_silverbullet", use_silverbullet_end, "inv_revolver_4" );
    cmn.AddSubscriber( "use_silverbullet_inv", use_silverbullet_inv );
    cmn.AddSubscriber( "use_silverbullet_inv_end", use_silverbullet_inv_end );
    cmn.AddSubscriber( "use_silverbullet_beg", use_silverbullet_beg, "inv_revolver_4" );
    cmn.AddSubscriber( "use_silverbullet_end", use_silverbullet_end, "inv_revolver_4" );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_loadedgun_4" ] = {
        type = "get",
        get_obj = "spr_deploy_revolver_4_loadedgun_4",
        room = "int_deploy_inv",
        zz = "deploy_inv_revolver_4",
        zz_gate = "inv_revolver_4"
    };
    function get_loadedgun_4_inv ()

      interface.InventoryItemAdd( "inv_loadedgun_4", "spr_deploy_revolver_4_loadedgun_4" );
      interface.InventoryItemRemove( "inv_revolver_4" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_loadedgun_4", get_loadedgun_4_inv );
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "clk_loadedgun_4" ] = {
        type = "click",
        use_place = "obj_deploy_revolver_4_clk_open",
        room = "int_deploy_inv",
        zz = "deploy_inv_revolver_4",
        zz_gate = "inv_revolver_4"
    };
    function clk_loadedgun_4_inv_end ()

      ObjSet( "inv_revolver_4", { res = "assets/levels/levelext/inv_deploy/inv_revolver_4/inv/inv_loadedgun_4" } );

    end;

    function clk_loadedgun_4_beg ()

      ObjDelete( "obj_deploy_revolver_4_clk_open" );

    end;
    function clk_loadedgun_4_end ()

      ObjDelete( "spr_deploy_revolver_4_open" );
      ObjMultiSet({ 
       { "spr_deploy_revolver_4_close",     { alp = 1 }},
       { "spr_deploy_revolver_4_loadedgun_4",     { input = true     }},
       { "gfx_deploy_revolver_4_loadedgun_4",     { active = true    }},
      });

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "clk_loadedgun_4", clk_loadedgun_4_inv_end );
    cmn.AddSubscriber( "clk_loadedgun_4", clk_loadedgun_4_beg, "inv_revolver_4" );
    cmn.AddSubscriber( "clk_loadedgun_4", clk_loadedgun_4_end, "inv_revolver_4" );
    cmn.AddSubscriber( "clk_loadedgun_4_inv", clk_loadedgun_4_inv_end );
    cmn.AddSubscriber( "clk_loadedgun_4_beg", clk_loadedgun_4_beg, "inv_revolver_4" );
    cmn.AddSubscriber( "clk_loadedgun_4_end", clk_loadedgun_4_end, "inv_revolver_4" );
    -------------------------------------------------------------------------------------------
    ObjSet( "spr_deploy_revolver_4_loadedgun_4", { event_mdown = levelext_inv.get_loadedgun_4 });
    ObjSet( "obj_deploy_revolver_4_clk_open", { event_mdown = levelext_inv.clk_loadedgun_4 });

  end;

  function public.get_loadedgun_4()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_loadedgun_4" );
    cmn.CallEventHandler( "get_loadedgun_4", "inv_loadedgun_4" );
    common_impl.HideDeployInv();

  end;
  function public.use_silverbullet()

    local item = "inv_silverbullet";

    if private.ObjIntersectCheck( item, "obj_revolver_4_use_silverbullet", "deploy_inv_revolver_4" ) then

      cmn.CallEventHandler( "use_silverbullet_beg", "inv_revolver_4" );
      cmn.CallEventHandler( "use_silverbullet_inv" );

      local func_end = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_silverbullet" );
        cmn.CallEventHandler( "use_silverbullet_end", "inv_revolver_4" );
        cmn.CallEventHandler( "clk_loadedgun_4_inv_end" );

      end;

      common_impl.Lock( true );
      common_impl.PlayAudio( "sfx", "common/audio/aud_use_silverbullet", 0, "", 0 );
      ObjAnimate( "spr_deploy_revolver_4_bullet", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
      ObjAnimate( "spr_deploy_revolver_4_bullet", "pos_xy", 0, 0, func_end, { 0,0,-121,-30, 0.3,0,-121,-30, 1.0,0,17,-38 } );

      return true;

    end;

  end;
  function public.clk_loadedgun_4()

    cmn.CallEventHandler( "clk_loadedgun_4_beg", "inv_revolver_4" );

    local func_end = function ()

      common_impl.Lock( false );

      cmn.SetEventDone( "clk_loadedgun_4" );
      cmn.CallEventHandler( "clk_loadedgun_4_end", "inv_revolver_4" );
      cmn.CallEventHandler( "clk_loadedgun_4_inv" );

    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_click_revolver_4", 0, "", 0 );
    ObjAnimate( "spr_deploy_revolver_4_open", "alp", 0, 0, func_end, { 0,0,1, 0.3,0,0 } );
    ObjAnimate( "spr_deploy_revolver_4_close", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );

    return true;

  end;
--*********************************************************************************************************************
-- function *** salammoniacbottle *** () end;
--*********************************************************************************************************************
  function private.init_salammoniacbottle()

    common_impl.hint[ "use_awl_4" ] = {
        type = "use",
        inv_obj = "inv_awl_4",
        use_place = "obj_salammoniacbottle_use_awl_4",
        room = "int_deploy_inv",
        zz = "deploy_inv_salammoniacbottle",
        zz_gate = "inv_salammoniacbottle"
    };
    function use_awl_4_inv ()

      interface.InventoryItemRemove( "inv_awl_4" );

    end;
    function use_awl_4_inv_end ()

      ObjSet( "inv_salammoniacbottle", { res = "assets/levels/levelext/inv_deploy/inv_salammoniacbottle/inv/inv_salammoniac" } );

    end;
    function use_awl_4_beg ()

      ObjDelete( "obj_salammoniacbottle_use_awl_4" );

    end;
    function use_awl_4_end ()

      ObjDelete( "anm_deploy_salammoniacbottle_awl" );

      ObjMultiSet({ 
        { "spr_deploy_salammoniacbottle_salammoniac",     { input = true, alp = 1 }},
        { "gfx_deploy_salammoniacbottle_salammoniac",     { active = true    }},
        { "spr_deploy_salammoniacbottle_hole",     { alp = 1    }},
      });      

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_awl_4", use_awl_4_beg, "inv_salammoniacbottle" );
    cmn.AddSubscriber( "use_awl_4", use_awl_4_inv );
    cmn.AddSubscriber( "use_awl_4", use_awl_4_inv_end );
    cmn.AddSubscriber( "use_awl_4", use_awl_4_end, "inv_salammoniacbottle" );
    cmn.AddSubscriber( "use_awl_4_inv", use_awl_4_inv );
    cmn.AddSubscriber( "use_awl_4_inv_end", use_awl_4_inv_end );
    cmn.AddSubscriber( "use_awl_4_beg", use_awl_4_beg, "inv_salammoniacbottle" );
    cmn.AddSubscriber( "use_awl_4_end", use_awl_4_end, "inv_salammoniacbottle" );
    
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_salammoniac" ] = {
        type = "get",
        get_obj = "spr_deploy_salammoniacbottle_salammoniac",
        room = "int_deploy_inv",
        zz = "deploy_inv_salammoniacbottle",
        zz_gate = "inv_salammoniacbottle"
    };
    function get_salammoniac_inv ()

      interface.InventoryItemAdd( "inv_salammoniac", "spr_deploy_salammoniacbottle_salammoniac" );
      interface.InventoryItemRemove( "inv_salammoniacbottle" );

    end;
    function get_salammoniac_deploy ()

      ObjDelete( "gfx_deploy_salammoniacbottle_salammoniac" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_salammoniac", get_salammoniac_inv );
    cmn.AddSubscriber( "get_salammoniac", get_salammoniac_deploy, "inv_salammoniacbottle" );
    -------------------------------------------------------------------------------------------
    ObjSet( "spr_deploy_salammoniacbottle_salammoniac", { event_mdown = levelext_inv.get_salammoniac });

  end;

  function public.get_salammoniac()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_salammoniac" );
    cmn.CallEventHandler( "get_salammoniac", "inv_salammoniac" );
    common_impl.HideDeployInv();

  end;

  function public.use_awl_4()

    local item = "inv_awl_4";

    if private.ObjIntersectCheck( item, "obj_salammoniacbottle_use_awl_4" ) then

      cmn.CallEventHandler( "use_awl_4_beg", "inv_salammoniacbottle" );
      cmn.CallEventHandler( "use_awl_4_inv" );

      local func_end = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_awl_4" );
        cmn.CallEventHandler( "use_awl_4_end", "inv_salammoniacbottle" );
        cmn.CallEventHandler( "use_awl_4_inv_end" );

      end;

      common_impl.Lock( true );
      common_impl.PlayAudio( "sfx", "common/audio/aud_use_awl_salmiac", 0, "", 0 );
      ObjSet( "spr_deploy_salammoniacbottle_salammoniac", { alp = 0 });
      ObjSet( "anm_deploy_salammoniacbottle_awl", { alp = 1 });
      AnimPlay( "anm_deploy_salammoniacbottle_awl", "DoAnim", func_end );

      return true;

    end;

  end;
--*********************************************************************************************************************
-- function *** torch *** () end;
--*********************************************************************************************************************
  function private.init_torch()

    common_impl.hint[ "use_matches_4_2" ] = {
        type = "use",
        inv_obj = "inv_matches_4",
        use_place = "obj_torch_use_matches_4_2",
        room = "int_deploy_inv",
        zz = "deploy_inv_torch",
        zz_gate = "inv_torch"
    };
    function use_matches_4_2_inv ()

      if cmn.IsEventDone( "use_matches_4_1" ) then
        interface.InventoryItemRemove( "inv_matches_4" );
      end;

    end;
    function use_matches_4_2_inv_end ()

      ObjSet( "inv_torch", { res = "assets/levels/levelext/inv_deploy/inv_torch/inv/inv_burningtorch" } );

    end;
    function use_matches_4_2_beg ()

      ObjDelete( "obj_torch_use_matches_4_2" );

    end;
    function use_matches_4_2_end ()

      ObjSet( "spr_deploy_torch_burningtorch", { input = true, alp = 1 } );
      ObjSet( "gfx_deploy_torch_burningtorch", { active = true, alp = 1 } );
      ObjDelete( "vid_torch_matches" );
      ObjSet( "vid_torch_fire", { visible = true, active = true, playing = true } );

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_matches_4_2", use_matches_4_2_beg, "inv_torch" );
    cmn.AddSubscriber( "use_matches_4_2", use_matches_4_2_inv );
    cmn.AddSubscriber( "use_matches_4_2", use_matches_4_2_inv_end );
    cmn.AddSubscriber( "use_matches_4_2", use_matches_4_2_end, "inv_torch" );
    cmn.AddSubscriber( "use_matches_4_2_inv", use_matches_4_2_inv );
    cmn.AddSubscriber( "use_matches_4_2_inv_end", use_matches_4_2_inv_end );
    cmn.AddSubscriber( "use_matches_4_2_beg", use_matches_4_2_beg, "inv_torch" );
    cmn.AddSubscriber( "use_matches_4_2_end", use_matches_4_2_end, "inv_torch" );
    
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_burningtorch" ] = {
        type = "get",
        get_obj = "spr_deploy_torch_burningtorch",
        room = "int_deploy_inv",
        zz = "deploy_inv_torch",
        zz_gate = "inv_torch"
    };
    function get_burningtorch_inv ()

      interface.InventoryItemAdd( "inv_burningtorch", "obj_deploy_torch" );
      interface.InventoryItemRemove( "inv_torch" );

    end;
    function get_burningtorch_deploy ()

      ObjDelete( "gfx_deploy_torch_burningtorch" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_burningtorch", get_burningtorch_inv );
    cmn.AddSubscriber( "get_burningtorch", get_burningtorch_deploy, "inv_torch" );
    -------------------------------------------------------------------------------------------
    ObjSet( "spr_deploy_torch_burningtorch", { event_mdown = levelext_inv.get_burningtorch });
    ObjSet( "inv_torch", { event_mdown = private.open_torch } )

  end;

  function private.open_torch()

    if cmn.IsEventDone( "use_matches_4_2" ) then

      common_impl.PlayAudio( "env", "common/audio/aud_torch_env", 1, "", 0.5 );
  
    end;

    common_impl.ShowDeployInv('inv_torch');

  end;

  function public.get_burningtorch()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
    common_impl.StopAudio( "env", "common/audio/aud_torch_env", 0.2 );
    cmn.SetEventDone( "get_burningtorch" );
    cmn.CallEventHandler( "get_burningtorch", "inv_burningtorch" );
    common_impl.HideDeployInv();

  end;

  function public.use_matches_4_2()

    local item = "inv_matches_4";

    if private.ObjIntersectCheck( item, "obj_torch_use_matches_4_2" ) then

      cmn.CallEventHandler( "use_matches_4_2_beg", "inv_torch" );
      cmn.CallEventHandler( "use_matches_4_2_inv" );

      local func_end = function ()

        common_impl.Lock( false );
        common_impl.PlayAudio( "env", "common/audio/aud_torch_env", 1, "", 0.5 );
        cmn.SetEventDone( "use_matches_4_2" );
        cmn.CallEventHandler( "use_matches_4_2_end", "inv_torch" );
        cmn.CallEventHandler( "use_matches_4_2_inv_end" );

      end;

      common_impl.Lock( true );

      common_impl.PlayAudio( "sfx", "common/audio/aud_use_matches_4_2", 0, "", 0 );
      ObjSet( "vid_torch_matches", { visible = true } );
      VidPlay( "vid_torch_matches", func_end );

      return true;

    end;

  end;
--*********************************************************************************************************************
-- function *** tweezerscotton *** () end;
--*********************************************************************************************************************
  function private.init_tweezerscotton()

    common_impl.hint[ "use_salammoniac" ] = {
        type = "use",
        inv_obj = "inv_salammoniac",
        use_place = "obj_tweezerscotton_use_salammoniac",
        room = "int_deploy_inv",
        zz = "deploy_inv_tweezerscotton",
        zz_gate = "inv_tweezerscotton"
    };
    function use_salammoniac_inv ()

      interface.InventoryItemRemove( "inv_salammoniac" );

    end;
    function use_salammoniac_inv_end ()

      ObjSet( "inv_tweezerscotton", { res = "assets/levels/levelext/inv_deploy/inv_tweezerscotton/inv/inv_salammoniaccotton" } );

    end;
    function use_salammoniac_beg ()

      ObjDelete( "obj_tweezerscotton_use_salammoniac" );

    end;
    function use_salammoniac_end ()

      ObjDelete( "spr_deploy_tweezerscotton_ammonia" );
      ObjDelete( "spr_deploy_tweezerscotton_drop" );
      ObjMultiSet({ 
        { "spr_deploy_tweezerscotton_tweezerscotton",     { input = true     }},
        { "gfx_deploy_tweezerscotton_tweezerscotton",     { active = true    }},
      });

    end;
    --------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "use_salammoniac", use_salammoniac_beg, "inv_tweezerscotton" );
    cmn.AddSubscriber( "use_salammoniac", use_salammoniac_inv );
    cmn.AddSubscriber( "use_salammoniac", use_salammoniac_inv_end );
    cmn.AddSubscriber( "use_salammoniac", use_salammoniac_end, "inv_tweezerscotton" );
    cmn.AddSubscriber( "use_salammoniac_inv", use_salammoniac_inv );
    cmn.AddSubscriber( "use_salammoniac_inv_end", use_salammoniac_inv_end );
    cmn.AddSubscriber( "use_salammoniac_beg", use_salammoniac_beg, "inv_tweezerscotton" );
    cmn.AddSubscriber( "use_salammoniac_end", use_salammoniac_end, "inv_tweezerscotton" );
    
    -------------------------------------------------------------------------------------------
    common_impl.hint[ "get_salammoniaccotton" ] = {
        type = "get",
        get_obj = "spr_deploy_tweezerscotton_tweezerscotton",
        room = "int_deploy_inv",
        zz = "deploy_inv_tweezerscotton",
        zz_gate = "inv_tweezerscotton"
    };
    function get_salammoniaccotton_inv ()

      interface.InventoryItemAdd( "inv_salammoniaccotton", "spr_deploy_tweezerscotton_tweezerscotton" );
      interface.InventoryItemRemove( "inv_tweezerscotton" );

    end;
    function get_salammoniaccotton_deploy ()

      ObjDelete( "gfx_deploy_tweezerscotton_tweezerscotton" );

    end;
    -------------------------------------------------------------------------------------------
    cmn.AddSubscriber( "get_salammoniaccotton", get_salammoniaccotton_inv );
    cmn.AddSubscriber( "get_salammoniaccotton", get_salammoniaccotton_deploy, "inv_tweezerscotton" );
    -------------------------------------------------------------------------------------------
    ObjSet( "spr_deploy_tweezerscotton_tweezerscotton", { event_mdown = levelext_inv.get_salammoniaccotton });

  end;

  function public.get_salammoniaccotton()

    common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

    cmn.SetEventDone( "get_salammoniaccotton" );
    cmn.CallEventHandler( "get_salammoniaccotton", "inv_salammoniaccotton" );
    common_impl.HideDeployInv();

  end;
  function public.use_salammoniac()

    local item = "inv_salammoniac";

    if private.ObjIntersectCheck( item, "obj_tweezerscotton_use_salammoniac" ) then

      cmn.CallEventHandler( "use_salammoniac_beg", "inv_tweezerscotton" );
      cmn.CallEventHandler( "use_salammoniac_inv" );

      local func_end = function ()

        common_impl.Lock( false );

        cmn.SetEventDone( "use_salammoniac" );
        cmn.CallEventHandler( "use_salammoniac_end", "inv_tweezerscotton" );
        cmn.CallEventHandler( "use_salammoniac_inv_end" );

      end;

      common_impl.Lock( true );
      common_impl.PlayAudio( "sfx", "common/audio/aud_use_salmiac", 0, "", 0 );
      ObjAnimate( "spr_deploy_tweezerscotton_ammonia", "alp", 0, 0, func_end, { 0,0,0, 0.3,0,1, 1,3,1, 1.3,3,0 } );
      ObjAnimate( "spr_deploy_tweezerscotton_drop", "alp", 0, 0, "", { 0,0,0, 0.3,0,1, 1,3,1, 1.3,3,0 } );
      ObjAnimate( "spr_deploy_tweezerscotton_drop", "pos_y", 0, 0, "", { 0,0,10, 0.3,0,10, 1,0,100 } );

      return true;

    end;

  end;
--*********************************************************************************************************************
-- function *** SEEKER *** () end;
--*********************************************************************************************************************
  function private.init_seeker()

    public.seeker_var = {};
    public.seeker_var.list = {

      [ "seeker_1" ] = { loc = "rm_swamp",               func = function () rm_swamp.use_seeker_1() end; },  
      [ "seeker_2" ] = { loc = "rm_abandoneddistrict_4", func = function () rm_abandoneddistrict_4.use_seeker_2() end; },
      [ "seeker_3" ] = { loc = "rm_livingroom_4",        func = function () rm_livingroom_4.use_seeker_3() end; },
      [ "seeker_4" ] = { loc = "rm_square_4",            func = function () rm_square_4.use_seeker_4() end; },
      [ "seeker_5" ] = { loc = "rm_fork_4",              func = function () rm_fork_4.use_seeker_5() end; },

    };
    
    public.seeker_var.current_arrow = "";
    public.seeker_var.massive = {};
    public.seeker_var.current_objfind = "";
    public.seeker_var.flag = 0;

    ObjAnimate( "spr_seeker_circle", "ang",1,0,"", { 0,0,0,    10,0,6.28 } );

  end;

  function private.SeekerDown() -- клик по инв. inv_seeker
    

    common_impl.PlayAudio( "sfx", "common/audio/aud_detector_on", 0, "", 0 );
    common_impl.PlayAudio( "env", "common/audio/aud_detector_env", 1, "", 0.5 );

    public.seeker_var.flag_stopdrag = true; 
    
    ObjMultiSet({
        { "spr_seeker", { visible = 0 } },
        { "obj_seeker_big", { visible = 1 } }
    });

    common.CloseSubRoom();

    local inv_name = interface.GetCurrentInv();
    if ( inv_name ~= "" ) then

      interface.DeployInvHide();   

    end;
  
    ---формирование массива massive из индексов (постфиксов seeker_1)
    local k = 1;
    for obj, array in pairs( public.seeker_var.list ) do
  
      local index = string.len( obj );
      local arrow = tonumber( string.sub( obj, 8 , index ) );
      public.seeker_var.massive[ k ] = arrow;
      k = k + 1;
      
    end;
    
    ---сортировка массива massive
    for i = 1, #public.seeker_var.massive - 1 do
  
      for j = 1, #public.seeker_var.massive - i do
  
        if public.seeker_var.massive[ j ] > public.seeker_var.massive[ j + 1 ] then 
  
            local t = public.seeker_var.massive[ j ];
            public.seeker_var.massive[ j ] = public.seeker_var.massive[ j + 1 ];
            public.seeker_var.massive[ j + 1 ] = t;
  
        end;
        
      end;
  
    end;
  
    local objfind = "empty";

    local current_room = GetCurrentRoom();
    --local name_room = common.GetObjectName( current_room );
    
    --если находимся в текущей комнате - проверка на скрытый объект локации
    for i = 1, #public.seeker_var.massive, 1 do

      local index = public.seeker_var.massive[ i ];
      
      if public.seeker_var.list[ "seeker_"..index ].loc == current_room and
         not cmn.IsEventDone( "use_seeker_"..index ) then

        objfind = "seeker_"..index;
        break;

      end;

    end;

    --если в комнате вообще ничего нет
    if objfind == "empty" then
      for i = 1, #public.seeker_var.massive do
        if not cmn.IsEventDone( "use_seeker_"..public.seeker_var.massive[ i ] ) then
          objfind = "seeker_"..public.seeker_var.massive[ i ];
          break;
        end;
      end; 
    end;
    
    public.seeker_var.current_arrow = private.FindArrow( objfind );--запоминается здесь, чтобы каждый раз в драге не искать с какой стрелкой пересекаться
    public.seeker_var.current_objfind = objfind;
  --public.seeker_var.current_collect = ld.FindCollect();
    
  --  ld.PlayAudio("env", "common/audio/aud_detector_env", 1);

  end;
  ---------------------------------------------------------------------------------------------------
  function private.SeekerDragDrop() -- бросание инв. inv_seeker

    ObjMultiSet({
        { "spr_seeker", { visible = 1 } },
        { "obj_seeker_big", { visible = 0 } }
    });
    if ( public.seeker_var.flag == 1 )  then --дропнули во время анимации

      public.seeker_var.flag_stopdrag = false; 

    end;

    common_impl.StopAudio( "env", "common/audio/aud_detector_env", 0.2 );

  end;
  ---------------------------------------------------------------------------------------------------
  function private.ApplyObjSeekerCheck( obj1, obj2 )  
      
    if ApplyObj( obj1, obj2 ) and ObjGet( obj2 ).active then

      return true

    else 

      return false  

    end;

  end;
  ---------------------------------------------------------------------------------------------------
  function private.CreateFxBoom()

    local func_end = function ()

      ObjDelete( "pfx_seeker_boom" );

    end;

    local position = {};
    local room = GetCurrentRoom();
    position.pos_x = ObjGet( public.seeker_var.current_arrow ).pos_x;
    position.pos_y = ObjGet( public.seeker_var.current_arrow ).pos_y;

    ObjCreate( "pfx_seeker_boom", "partsys_pm" );
    ObjAttach( "pfx_seeker_boom", room );
    ObjSet( "pfx_seeker_boom", 
    {
      active = true,
      input = false,
      res = "assets/levels/common/fx/pfx_boom/pfx_boom",
      pos_x = position.pos_x,
      pos_y = position.pos_y,
      pos_z = 1000
    } );
  
    ObjAnimate( "pfx_seeker_boom", "alp", 0, 0, func_end, 
    { 
      0.0, 0, 1.0, 
      1.2, 0, 1.0,
      1.4, 0, 0.0
    } );

  end;
  ---------------------------------------------------------------------------------------------------
  function private.SeekerDrag() -- таскание инв. inv_seeker
    
    if public.seeker_var.current_arrow ~= "" and private.ApplyObjSeekerCheck( "obj_seeker_center", public.seeker_var.current_arrow )then    

      local key = 0;

      if not cmn.IsEventDone( "use_"..public.seeker_var.current_objfind ) and public.seeker_var.flag == 0 then

        public.seeker_var.flag = 1;     
        common_impl.Lock( true );     
        ObjMultiSet({
            { public.seeker_var.current_arrow, {  visible = 1, input = 1 } },
            { "inv_seeker", { input = false } }
        });

        private.CreateFxBoom();

        common_impl.PlayAudio( "sfx", "common/audio/aud_detector_show", 0, "", 0 );
     
        ObjAnimate( public.seeker_var.current_arrow, "alp", 0, 0, private.SeekerDragEnd, 
        { 
          0.0, 0, 0.0, 
          0.2, 0, 1.0,
          1.4, 0, 1.0
        } ); 

        key = 1;

      end;

      local autohide = interface.InventoryAutoHideGet();
      if ( autohide == 0  and ng_global.progress[ ng_global.currentprogress ].common.buttonlock == 0 ) then

        interface.InventoryAutoHideSet( 1 );

      end;

      if key == 1 then
        
        ObjAnimate( "spr_seeker_circle_2", "scale_xy", 0, 0, "", 
        { 
          0.0, 0,  1.0, 1.0,
          0.6, 3,  0.7, 0.7, 
          0.8, 3,  1.0, 1.0
        } );    
   
      end;

    end;

  end;
  ---------------------------------------------------------------------------------------------------
  function private.SeekerDragEnd() -- таскание инв. inv_seeker

    common_impl.Lock( false );   
    ObjMultiSet({
        { "obj_seeker_big", { input = false, visible = false } },
        { "inv_seeker", { input = true } }
    });
    public.seeker_var.flag = 0;

    public.seeker_var.list[ public.seeker_var.current_objfind ].func();

    --if ( public.seeker_var.flag_stopdrag ) then
    
    --ObjStopDrag( "inv_seeker" );
    --end;

  end;
  --------------------------------------------------------------------------------------
  function private.FindArrow( objfind )--поиск стрелки, которая указывает нам на объект поиска(или самого объекта)

    if objfind ~= "" then
      local current_room = GetCurrentRoom();
      local array_objfind = public.seeker_var.list[ objfind ];

      if current_room == array_objfind[ "loc" ] then --мы в локации, где спрятан объект поиска
         --остался сам объект
        return "obj_"..common.GetObjectName( current_room ).."_"..objfind;

      else 

        return "";

      end;

    else
    
      return "";

    end;

  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Skip( event )

  if ( event == "win_case" ) then

    local anm_after = function ()

      local func_after = function() private.WinCase() end;

      for i = 1,5 do

        ObjSet( "spr_deploy_case_list_"..i, 
              { ang   = private.pos_mas[i][3],
                pos_x = private.pos_mas[i][1],
                pos_y = private.pos_mas[i][2],
              } );

        ObjAnimate( "spr_deploy_case_list_"..i, "alp", 0, 0, func_after, { 0,0,0, 0.3,0,1 } );
        ObjAnimate( "spr_deploy_case_list_"..i.."_shadow", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );
        ObjAnimate( "spr_deploy_case_list_"..i.."_light", "alp", 0, 0, "", { 0,0,0, 0.3,0,1 } );

        func_after = ""

      end;

    end

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_flower_amulet_move", 0, "", 0 );
    common_impl.PlayAudio( "sfx", "common/audio/aud_flower_amulet_move", 0, "", 0 );

    for i = 1,5 do

      ObjAnimate( "spr_deploy_case_list_"..i, "alp", 0, 0, anm_after, { 0,0,1, 0.3,0,0 } );
      ObjAnimate( "spr_deploy_case_list_"..i.."_shadow", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
      ObjAnimate( "spr_deploy_case_list_"..i.."_light", "alp", 0, 0, "", { 0,0,1, 0.3,0,0 } );
      anm_after = ""

    end;
  

  end;

end;
--******************************************************************************************************
function public.Reset( event )

  if ( event == "win_case" ) then

    ng_global.progress["ext"]["win_case"].current_pos = { 1, 4, 5, 3, 2 };
    for i = 1,5 do

      ObjSet( "spr_deploy_case_list_"..ng_global.progress["ext"]["win_case"].current_pos[i], 
            { ang   = private.pos_mas[i][3],
              pos_x = private.pos_mas[i][1],
              pos_y = private.pos_mas[i][2],
            } );

    end;

    private.first_obj = 0;

  end;  

end;
--*********************************************************************************************************************
--*********************************************************************************************************************