-- name=rm_abandoneddistrict_4
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_abandoneddistrict_4";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_fire_4", "room_hub" );
  ObjAttach( "zz_shop_4", "room_hub" );
  ObjAttach( "zz_truck",  "room_hub" );
  ObjAttach( "zz_blockage", "room_hub" );
  private.Init_Subroom();
  
  private.start_state = { 1, 2, 3 };

  ObjMultiSet({ 
    --{ "spr_fire_4_litchip",       { event_mdown = private.get_litchip       }},
    { "spr_fire_4_bluntsawdisk",  { event_mdown = private.get_bluntsawdisk  }},
    { "spr_fire_4_brace",         { event_mdown = private.get_brace         }},
    { "spr_fire_4_wood_4",        { event_startdrag = private.drag_wood_4, event_dragdrop = private.drop_wood_4   }},
    { "spr_fire_4_splinter",      { event_mdown = private.get_splinter      }},
    { "spr_shop_4_ring_4",        { event_mdown = private.get_ring_4        }},
    { "spr_shop_4_van",           { event_mdown = private.get_van           }},
    { "spr_shop_4_clownpiece",    { event_mdown = private.get_clownpiece    }},
    { "spr_shop_4_firetorch",     { event_mdown = private.get_firetorch     }},
    { "spr_shop_4_matches_4",     { event_mdown = private.get_matches_4     }},
    { "spr_truck_knife_4",        { event_mdown = private.get_knife_4       }},
    { "spr_truck_brokendisksaw",  { event_mdown = private.get_brokendisksaw }},
    { "spr_truck_brokentank",     { event_mdown = private.get_brokentank    }},
    { "spr_truck_hammer_4",       { event_mdown = private.get_hammer_4      }},

    { "obj_truck_use_nippers_4",  { event_mdown = private.ChainClick      }},

    { "obj_vid_abandoneddistrict_4_robintrouble",       { event_mdown = private.vid_abandoneddistrict_4_robintrouble }},
    { "obj_vid_abandoneddistrict_4_robintrouble_focus", { event_mdown = private.vid_abandoneddistrict_4_robintrouble }},
 
    { "spr_abandoneddistrict_4_shopemblem",   { event_mdown = private.get_shopemblem   }},
    { "spr_abandoneddistrict_4_charmpiece_2", { event_mdown = private.get_charmpiece_2 }},
  
    { "spr_fire_4_coin",        { event_mdown = private.get_collect_coin_38 }},
    { "spr_truck_coin",         { event_mdown = private.get_collect_coin_39 }},
    { "spr_abandoneddistrict_4_collect_item", { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_1_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_abandoneddistrict_4_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_7" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
  
 });

  for i = 1, 3 do

    ObjSet( "spr_shop_4_circle_"..i, 
    {
      event_menter = function () private.CircleEnter( i ); end,
      event_mleave = function () private.CircleLeave( i ); end,
      event_mdown = function () private.CircleClick( i ); end
    } );

  end;
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_abandoneddistrict_4 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_abandoneddistrict_4_fire_4",
    "gzz_abandoneddistrict_4_shop_4",
    "gzz_abandoneddistrict_4_truck",
    "gzz_abandoneddistrict_4_blockage",
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_fire_4",
      "zz_shop_4",
      "zz_truck",
      "zz_blockage",
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_abandoneddistrict_4", update_game_mode_abandoneddistrict_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_abandoneddistrict_4 = function ()

  local effects_table = 
  {
    "anm_abandoneddistrict_robin",
    "spr_shop_4_lamp_2",
    "spr_shop_4_lamp_1", 
    "anm_abandoneddistrict_anims",
    "anm_abandoneddistrict_branch",
    "spr_shop_4_lamp_1",
    "spr_shop_4_lamp_2",
    "anm_abandoneddistrict_4_flies",
    "anm_truck_branch",
    "spr_fire_4_fire_light",
    "spr_fire_4_fire_2_light",
    "anm_fire_4_fire2",
    
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_abandoneddistrict_4", update_performance_mode_abandoneddistrict_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_abandoneddistrict_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_abandoneddistrict_4" ] = {
    type = "click",
    use_place = "grm_square_4_abandoneddistrict_4",
    room = "rm_square_4"
  };


  local opn_abandoneddistrict_4_map = function ()

    common_impl.VisitMapRoom( "abandoneddistrict_4" );

  end;
  cmn.AddSubscriber( "opn_abandoneddistrict_4", opn_abandoneddistrict_4_map );

  --------------------------------------------------------------------------------------------
  -- function get_collect_item_1_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_1_3 = function ()
  
    ObjDelete( "obj_abandoneddistrict_4_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_1_3", get_collect_item_1_3, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_7 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_7 = function ()
  
    ObjDelete( "obj_abandoneddistrict_4_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_7", get_collect_morph_item_1_7, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_litchip () end;
  --------------------------------------------------------------------------------------------
--  common_impl.hint[ "get_litchip" ] = {
--    type = "get",
--    get_obj = "spr_fire_4_litchip",
--    room = private.room_objname,
--    zz = "zz_fire_4",
--    zz_gate = "gzz_abandoneddistrict_4_fire_4"
--  };
--    
--  local get_litchip_inv = function ()
--  
--    interface.InventoryItemAdd( "inv_litchip", "spr_fire_4_litchip" );
--  
--  end;
--  
--  local get_litchip_closezz = function ()
--  
--    ObjDelete( "gfx_fire_4_litchip" );
--    
--    if ( common_impl.IsGetCoin( "get_coin_38" ) ) then 
--
--      ObjDelete( "gzz_abandoneddistrict_4_fire_4" );
--    
--    end;
--  
--  end;
--  
--  cmn.AddSubscriber( "get_litchip", get_litchip_inv );
--  cmn.AddSubscriber( "get_litchip", get_litchip_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bluntsawdisk () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bluntsawdisk" ] = {
    type = "get",
    get_obj = "spr_fire_4_bluntsawdisk",
    room = private.room_objname,
    zz = "zz_fire_4",
    zz_gate = "gzz_abandoneddistrict_4_fire_4"
  };
    
  local get_bluntsawdisk_inv = function ()
  
    interface.InventoryItemAdd( "inv_bluntsawdisk", "spr_fire_4_bluntsawdisk" );
    ObjSet( "inv_bluntsawdisk", { drag = false } );
  
  end;
  
  local get_bluntsawdisk_closezz = function ()
  
    ObjDelete( "gfx_fire_4_bluntsawdisk" );
    ObjDelete( "spr_fire_4_bluntsawdisk_shadow" );
    ObjDelete( "spr_abandoneddistrict_4_fire_4_disk" );
  
  end;
  
  cmn.AddSubscriber( "get_bluntsawdisk", get_bluntsawdisk_inv );
  cmn.AddSubscriber( "get_bluntsawdisk", get_bluntsawdisk_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brace () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brace" ] = {
    type = "get",
    get_obj = "spr_fire_4_brace",
    room = private.room_objname,
    zz = "zz_fire_4",
    zz_gate = "gzz_abandoneddistrict_4_fire_4"
  };
    
  local get_brace_inv = function ()
  
    interface.InventoryItemAdd( "inv_brace", "spr_fire_4_brace" );
    ObjSet( "inv_brace", { drag = false } );
  
  end;
  
  local get_brace_closezz = function ()
  
    ObjDelete( "gfx_fire_4_brace" );
    ObjDelete( "spr_fire_4_brace_shadow" );
    ObjDelete( "spr_abandoneddistrict_4_fire_4_brace" );
  
  end;
  
  cmn.AddSubscriber( "get_brace", get_brace_inv );
  cmn.AddSubscriber( "get_brace", get_brace_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_splinter () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_splinter" ] = {
    type = "get",
    get_obj = "spr_fire_4_splinter",
    room = private.room_objname,
    zz = "zz_fire_4",
    zz_gate = "gzz_abandoneddistrict_4_fire_4"
  };
    
  local get_splinter_inv = function ()
  
    interface.InventoryItemAdd( "inv_splinter", "spr_fire_4_splinter" );
  
  end;
  
  local get_splinter_closezz = function ()
  
    ObjDelete( "spr_fire_4_splinter_shadow" );
    ObjDelete( "gfx_fire_4_splinter" );
    --ObjDelete( "gzz_abandoneddistrict_4_fire_4" );
  
  end;
  
  cmn.AddSubscriber( "get_splinter", get_splinter_inv );
  cmn.AddSubscriber( "get_splinter", get_splinter_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_ring_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_ring_4" ] = {
    type = "get",
    get_obj = "spr_shop_4_ring_4",
    room = private.room_objname,
    zz = "zz_shop_4",
    zz_gate = "gzz_abandoneddistrict_4_shop_4"
  };
    
  local get_ring_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_ring_4", "spr_shop_4_ring_4" );
  
  end;
  
  local get_ring_4_closezz = function ()
  
    ObjDelete( "gfx_shop_4_ring_4" );
    ObjDelete( "spr_shop_4_ring_4_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_ring_4", get_ring_4_inv );
  cmn.AddSubscriber( "get_ring_4", get_ring_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_van () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_van" ] = {
    type = "get",
    get_obj = "spr_shop_4_van",
    room = private.room_objname,
    zz = "zz_shop_4",
    zz_gate = "gzz_abandoneddistrict_4_shop_4"
  };
    
  local get_van_inv = function ()
  
    interface.InventoryItemAdd( "inv_van", "spr_shop_4_van" );
  
  end;
  
  local get_van_closezz = function ()
  
    ObjDelete( "gfx_shop_4_van" );
    ObjDelete( "spr_shop_4_van_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_van", get_van_inv );
  cmn.AddSubscriber( "get_van", get_van_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_clownpiece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_clownpiece" ] = {
    type = "get",
    get_obj = "spr_shop_4_clownpiece",
    room = private.room_objname,
    zz = "zz_shop_4",
    zz_gate = "gzz_abandoneddistrict_4_shop_4"
  };
    
  local get_clownpiece_inv = function ()
  
    interface.InventoryItemAdd( "inv_clownpiece", "spr_shop_4_clownpiece" );
  
  end;
  
  local get_clownpiece_closezz = function ()
  
    ObjDelete( "gfx_shop_4_clownpiece" );
    ObjDelete( "spr_shop_4_clownpiece_shadow" );

    if cmn.IsEventDone( "get_firetorch" ) and cmn.IsEventDone( "get_matches_4" ) then
      ObjDelete( "gzz_abandoneddistrict_4_shop_4" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_clownpiece", get_clownpiece_inv );
  cmn.AddSubscriber( "get_clownpiece", get_clownpiece_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_firetorch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_firetorch" ] = {
    type = "get",
    get_obj = "spr_shop_4_firetorch",
    room = private.room_objname,
    zz = "zz_shop_4",
    zz_gate = "gzz_abandoneddistrict_4_shop_4"
  };
    
  local get_firetorch_inv = function ()
  
    interface.InventoryItemAdd( "inv_firetorch", "spr_shop_4_firetorch" );
    ObjSet( "inv_firetorch", { drag = false } );
  
  end;
  
  local get_firetorch_closezz = function ()
  
    ObjDelete( "gfx_shop_4_firetorch" );
    ObjDelete( "spr_shop_4_firetorch_shadow" );
    ObjDelete( "spr_shop_4_firetorch_over" );
    ObjDelete( "spr_shop_4_firetorch_light" );
    ObjDelete( "spr_abandoneddistrict_4_firetorch" );

    if cmn.IsEventDone( "get_clownpiece" ) and cmn.IsEventDone( "get_matches_4" ) then
      ObjDelete( "gzz_abandoneddistrict_4_shop_4" );
    end;
   
  end;
  
  cmn.AddSubscriber( "get_firetorch", get_firetorch_inv );
  cmn.AddSubscriber( "get_firetorch", get_firetorch_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_matches_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_matches_4" ] = {
    type = "get",
    get_obj = "spr_shop_4_matches_4",
    room = private.room_objname,
    zz = "zz_shop_4",
    zz_gate = "gzz_abandoneddistrict_4_shop_4"
  };
    
  local get_matches_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_matches_4", "spr_shop_4_matches_4" );
  
  end;
  
  local get_matches_4_closezz = function ()
  
    ObjDelete( "gfx_shop_4_matches_4" );
    ObjDelete( "spr_shop_4_matches_shadow" );

    if cmn.IsEventDone( "get_clownpiece" ) and cmn.IsEventDone( "get_firetorch" ) then
      ObjDelete( "gzz_abandoneddistrict_4_shop_4" );
    end;
    
  end;
  
  cmn.AddSubscriber( "get_matches_4", get_matches_4_inv );
  cmn.AddSubscriber( "get_matches_4", get_matches_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_knife_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_knife_4" ] = {
    type = "get",
    get_obj = "spr_truck_knife_4",
    room = private.room_objname,
    zz = "zz_truck",
    zz_gate = "gzz_abandoneddistrict_4_truck"
  };
    
  local get_knife_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_knife_4", "spr_truck_knife_4" );
  
  end;
  
  local get_knife_4_closezz = function ()
  
    ObjDelete( "gfx_truck_knife_4" );
    ObjDelete( "spr_truck_knife_4_shadow" );
    ObjDelete( "spr_abandoneddistrict_4_truck_knife" );
  
  end;
  
  cmn.AddSubscriber( "get_knife_4", get_knife_4_inv );
  cmn.AddSubscriber( "get_knife_4", get_knife_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokendisksaw () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokendisksaw" ] = {
    type = "get",
    get_obj = "spr_truck_brokendisksaw",
    room = private.room_objname,
    zz = "zz_truck",
    zz_gate = "gzz_abandoneddistrict_4_truck"
  };
    
  local get_brokendisksaw_inv = function ()
  
    interface.InventoryItemAdd( "inv_brokendisksaw", "spr_truck_brokendisksaw" );
    ObjSet( "inv_brokendisksaw", { drag = false } );
  
  end;
  
  local get_brokendisksaw_closezz = function ()
  
    ObjDelete( "gfx_truck_brokendisksaw" );
    ObjDelete( "spr_truck_brokendisksaw_shadow" );
    ObjDelete( "spr_truck_brokendisksaw_over" );
    ObjSet( "obj_truck_use_cash_2", { input = true });
    ObjDelete( "spr_abandoneddistrict_4_truck_brokendisksaw" );

  end;
  
  cmn.AddSubscriber( "get_brokendisksaw", get_brokendisksaw_inv );
  cmn.AddSubscriber( "get_brokendisksaw", get_brokendisksaw_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_brokentank () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_brokentank" ] = {
    type = "get",
    get_obj = "spr_truck_brokentank",
    room = private.room_objname,
    zz = "zz_truck",
    zz_gate = "gzz_abandoneddistrict_4_truck"
  };
    
  local get_brokentank_inv = function ()
  
    interface.InventoryItemAdd( "inv_brokentank", "spr_truck_brokentank" );
    ObjSet( "inv_brokentank", { drag = false } );
  
  end;
  
  local get_brokentank_closezz = function ()
  
    ObjDelete( "gfx_truck_brokentank" );
    ObjDelete( "spr_truck_brokentank_shadow" );
    ObjDelete( "spr_abandoneddistrict_4_truck_ballon" );

    if cmn.IsEventDone( "get_hammer_4" ) and common_impl.IsGetCoin( "get_coin_39" ) then
      ObjDelete( "gzz_abandoneddistrict_4_truck" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_brokentank", get_brokentank_inv );
  cmn.AddSubscriber( "get_brokentank", get_brokentank_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_hammer_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_hammer_4" ] = {
    type = "get",
    get_obj = "spr_truck_hammer_4",
    room = private.room_objname,
    zz = "zz_truck",
    zz_gate = "gzz_abandoneddistrict_4_truck"
  };
    
  local get_hammer_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_hammer_4", "spr_truck_hammer_4" );
  
  end;
  
  local get_hammer_4_closezz = function ()
  
    ObjDelete( "gfx_truck_hammer_4" );
    ObjDelete( "spr_truck_hammer_4_shadow" );
    ObjDelete( "spr_abandoneddistrict_4_truck_hammer" );

    if cmn.IsEventDone( "get_brokentank" ) and common_impl.IsGetCoin( "get_coin_39" ) then
      ObjDelete( "gzz_abandoneddistrict_4_truck" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_hammer_4", get_hammer_4_inv );
  cmn.AddSubscriber( "get_hammer_4", get_hammer_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_shopemblem () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_shopemblem" ] = {
    type = "get",
    get_obj = "spr_abandoneddistrict_4_shopemblem",
    room = private.room_objname
  };
    
  local get_shopemblem_inv = function ()
  
    interface.InventoryItemAdd( "inv_shopemblem", "spr_abandoneddistrict_4_shopemblem" );
  
  end;
  
  local get_shopemblem_closezz = function ()
  
    ObjDelete( "gfx_abandoneddistrict_4_shopemblem" );
    ObjDelete( "spr_abandoneddistrict_4_shopemblem_cap" );
    ObjDelete( "spr_abandoneddistrict_4_shopemblem_add" );

  end;
  
  cmn.AddSubscriber( "get_shopemblem", get_shopemblem_inv );
  cmn.AddSubscriber( "get_shopemblem", get_shopemblem_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_charmpiece_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_charmpiece_2" ] = {
    type = "get",
    get_obj = "obj_abandoneddistrict_4_seeker_2",
    room = private.room_objname
  };
    
  local get_charmpiece_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_charmpiece_2", "obj_abandoneddistrict_4_seeker_2" );
  
  end;
  
  local get_charmpiece_2_closezz = function ()
  
    ObjDelete( "gfx_abandoneddistrict_4_charmpiece_2" );
    ObjDelete( "spr_abandoneddistrict_4_charmpiece_cap" );
  
  end;
  
  cmn.AddSubscriber( "get_charmpiece_2", get_charmpiece_2_inv );
  cmn.AddSubscriber( "get_charmpiece_2", get_charmpiece_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_38 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_38 = function ()
 
    ObjDelete( "obj_fire_4_coin" );

    if cmn.IsEventDone( "use_splinter" ) then

      ObjDelete( "gzz_abandoneddistrict_4_fire_4" );
      if cmn.IsEventDone( "use_magiclantern_2" ) then
        ObjSet( "obj_abandoneddistrict_4_fire_4_fireend", { input = true } );
      end;

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_38", get_collect_coin_38, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_39 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_39 = function ()
 
    ObjDelete( "obj_truck_coin" );

    if cmn.IsEventDone( "get_hammer_4" ) and cmn.IsEventDone( "get_brokentank" )  then

      ObjDelete( "gzz_abandoneddistrict_4_truck" );

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_39", get_collect_coin_39, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_chump () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chump" ] = {
    type = "use",
    inv_obj = "inv_chump",
    use_place = "obj_fire_4_use_chump",
    room = private.room_objname,
    zz = "zz_fire_4",
    zz_gate = "gzz_abandoneddistrict_4_fire_4"
  };
  local use_chump_inv = function ()
  
    interface.InventoryItemRemove( "inv_chump" );
  
  end;
  local use_chump_beg = function ()
  
    ObjDelete( "obj_fire_4_use_chump" );
  
  end;
  local use_chump_end = function ()
  
    ObjSet( "obj_fire_4_use_chopper", { input = true } );
    ObjSet( "spr_fire_4_log", { alp = 1 } );
    ObjSet( "spr_fire_4_log_shadow", { alp = 1 } );
    ObjSet( "spr_abandoneddistrict_4_fire_4_log", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chump", use_chump_beg, private.room_objname );
  cmn.AddSubscriber( "use_chump", use_chump_inv );
  cmn.AddSubscriber( "use_chump", use_chump_end, private.room_objname );
  cmn.AddSubscriber( "use_chump_inv", use_chump_inv, private.room_objname );
  cmn.AddSubscriber( "use_chump_beg", use_chump_beg, private.room_objname );
  cmn.AddSubscriber( "use_chump_end", use_chump_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chopper () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chopper" ] = {
    type = "use",
    inv_obj = "inv_chopper",
    use_place = "obj_fire_4_use_chopper",
    room = private.room_objname,
    zz = "zz_fire_4",
    zz_gate = "gzz_abandoneddistrict_4_fire_4"
  };
  local use_chopper_inv = function ()
  
    interface.InventoryItemRemove( "inv_chopper" );
  
  end;
  local use_chopper_beg = function ()
  
    ObjDelete( "obj_fire_4_use_chopper" );
  
  end;
  local use_chopper_end = function ()
  
    ObjMultiSet({ 
      { "spr_fire_4_wood_4",     { input = true }},
      { "gfx_fire_4_wood_4",     { active = true }},
      { "obj_fire_4_log_wood",     { alp = 1 }},
      { "spr_fire_4_splinter",     { input = true }},
      { "gfx_fire_4_splinter",     { active = true }},
      { "obj_fire_4_splinter",     { alp = 1 }},
      { "spr_abandoneddistrict_4_fire_4_wood_1",     { alp = 1 }}
    });

    ObjDelete( "spr_fire_4_log" );
    ObjDelete( "spr_fire_4_log_shadow" );
    ObjDelete( "spr_abandoneddistrict_4_fire_4_log" );
    ObjDelete( "anm_fire_4_firewood" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chopper", use_chopper_beg, private.room_objname );
  cmn.AddSubscriber( "use_chopper", use_chopper_inv );
  cmn.AddSubscriber( "use_chopper", use_chopper_end, private.room_objname );
  cmn.AddSubscriber( "use_chopper_inv", use_chopper_inv, private.room_objname );
  cmn.AddSubscriber( "use_chopper_beg", use_chopper_beg, private.room_objname );
  cmn.AddSubscriber( "use_chopper_end", use_chopper_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_drymoss () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_drymoss" ] = {
    type = "use",
    inv_obj = "inv_drymoss",
    use_place = "obj_fire_4_use_drymoss",
    room = private.room_objname,
    zz = "zz_fire_4",
    zz_gate = "gzz_abandoneddistrict_4_fire_4"
  };
  local use_drymoss_inv = function ()
  
    interface.InventoryItemRemove( "inv_drymoss" );
  
  end;
  local use_drymoss_beg = function ()
  
    ObjDelete( "obj_fire_4_use_drymoss" );
  
  end;
  local use_drymoss_end = function ()
  
    ObjSet( "obj_fire_4_use_bowdrill", { input = true } );
    ObjSet( "spr_fire_4_mos", { alp = 1 } );
    ObjSet( "spr_abandoneddistrict_4_fire_4_moss", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_drymoss", use_drymoss_beg, private.room_objname );
  cmn.AddSubscriber( "use_drymoss", use_drymoss_inv );
  cmn.AddSubscriber( "use_drymoss", use_drymoss_end, private.room_objname );
  cmn.AddSubscriber( "use_drymoss_inv", use_drymoss_inv, private.room_objname );
  cmn.AddSubscriber( "use_drymoss_beg", use_drymoss_beg, private.room_objname );
  cmn.AddSubscriber( "use_drymoss_end", use_drymoss_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bowdrill () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bowdrill" ] = {
    type = "use",
    inv_obj = "inv_bowdrill",
    use_place = "obj_fire_4_use_bowdrill",
    room = private.room_objname,
    zz = "zz_fire_4",
    zz_gate = "gzz_abandoneddistrict_4_fire_4"
  };
  local use_bowdrill_inv = function ()
  
    interface.InventoryItemRemove( "inv_bowdrill" );
  
  end;
  local use_bowdrill_beg = function ()
  
    ObjDelete( "obj_fire_4_use_bowdrill" );
  
  end;
  local use_bowdrill_end = function ()
  
    ObjSet( "obj_fire_4_use_splinter", { input = true } );
    ObjSet( "obj_fire_4_fire_2_light", { alp = 1, active = true } );
    ObjSet( "spr_fire_4_fire_light", { alp = 1 } );
    ObjSet( "anm_fire_4_fire2", { alp = 1, active = true } );
    ObjSet( "vid_abandoneddistrict_4_fire_4_fire", { alp = 1 } );
    --ObjSet( "spr_abandoneddistrict_4_fire_4_fire_1", { alp = 1 } );
    --ObjSet( "spr_abandoneddistrict_4_fire_4_fire_1_add", { alp = 1 } );
    ObjDelete( "anm_fire_4_fire" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bowdrill", use_bowdrill_beg, private.room_objname );
  cmn.AddSubscriber( "use_bowdrill", use_bowdrill_inv );
  cmn.AddSubscriber( "use_bowdrill", use_bowdrill_end, private.room_objname );
  cmn.AddSubscriber( "use_bowdrill_inv", use_bowdrill_inv, private.room_objname );
  cmn.AddSubscriber( "use_bowdrill_beg", use_bowdrill_beg, private.room_objname );
  cmn.AddSubscriber( "use_bowdrill_end", use_bowdrill_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shopemblem () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_shopemblem" ] = {
    type = "use",
    inv_obj = "inv_shopemblem",
    use_place = "obj_shop_4_use_shopemblem",
    room = private.room_objname,
    zz = "zz_shop_4",
    zz_gate = "gzz_abandoneddistrict_4_shop_4"
  };
  local use_shopemblem_inv = function ()
  
    interface.InventoryItemRemove( "inv_shopemblem" );
  
  end;
  local use_shopemblem_beg = function ()
  
    ObjDelete( "obj_shop_4_use_shopemblem" );
  
  end;
  local use_shopemblem_end = function ()
  
    ObjSet( "obj_shop_4_minigame", { input = true, visible = true, active = true } );
    ObjSet( "spr_shop_4_used_key", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_shopemblem", use_shopemblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_shopemblem", use_shopemblem_inv );
  cmn.AddSubscriber( "use_shopemblem", use_shopemblem_end, private.room_objname );
  cmn.AddSubscriber( "use_shopemblem_inv", use_shopemblem_inv, private.room_objname );
  cmn.AddSubscriber( "use_shopemblem_beg", use_shopemblem_beg, private.room_objname );
  cmn.AddSubscriber( "use_shopemblem_end", use_shopemblem_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_shopkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_shopkey" ] = {
    type = "use",
    inv_obj = "inv_shopkey",
    use_place = "obj_shop_4_use_shopkey",
    room = private.room_objname,
    zz = "zz_shop_4",
    zz_gate = "gzz_abandoneddistrict_4_shop_4"
  };
  local use_shopkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_shopkey" );
  
  end;
  local use_shopkey_beg = function ()
  
    ObjDelete( "obj_shop_4_use_shopkey" );
  
  end;
  local use_shopkey_end = function ()
  
    ObjSet( "obj_shop_4_open_shop", { alp = 1, input = true } );
    ObjDelete( "spr_shop_4_cover" );

    ObjSet( "spr_abandoneddistrict_4_shop_4_op", { alp = 1 } );
    ObjDelete( "spr_abandoneddistrict_4_shop_4_cover" );

    ObjSet( "spr_shop_4_firetorch", { input = true, active = true, alp = 1 } );
    ObjSet( "spr_shop_4_clownpiece", { input = true, active = true, alp = 1 } );
    ObjSet( "spr_shop_4_matches_4", { input = true, active = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_shopkey", use_shopkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_shopkey", use_shopkey_inv );
  cmn.AddSubscriber( "use_shopkey", use_shopkey_end, private.room_objname );
  cmn.AddSubscriber( "use_shopkey_inv", use_shopkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_shopkey_beg", use_shopkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_shopkey_end", use_shopkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_nippers_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_nippers_4_1" ] = {
    type = "use",
    inv_obj = "inv_nippers_4",
    use_place = "obj_truck_use_nippers_4",
    room = private.room_objname,
    zz = "zz_truck",
    zz_gate = "gzz_abandoneddistrict_4_truck"
  };
  local use_nippers_4_1_inv = function ()
  
    if cmn.IsEventDone( "use_nippers_4_2" ) then
      interface.InventoryItemRemove( "inv_nippers_4" );
    end;
  
  end;
  local use_nippers_4_1_beg = function ()
  
    ObjDelete( "obj_truck_use_nippers_4" );
  
  end;
  local use_nippers_4_1_end = function ()
  
    ObjDelete( "obj_truck_doors_shadow" );
    ObjDelete( "anm_truck_chain" );
    ObjDelete( "anm_truck_chain_static" );

    ObjMultiSet({ 

      { "obj_truck_doors_open",       { alp = 1 }},
      { "obj_truck_brokendisksaw",    { input = true, active = true }},
      { "obj_truck_knife_4",          { input = true, active = true }},
      { "obj_truck_coin",             { input = true, active = true }},
      { "obj_truck_use_cash_1",       { input = true }},
      { "spr_abandoneddistrict_4_truck_back",  { alp = 1 }},
      { "spr_abandoneddistrict_4_truck_doors", { alp = 1 }},

    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_nippers_4_1", use_nippers_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_nippers_4_1", use_nippers_4_1_inv );
  cmn.AddSubscriber( "use_nippers_4_1", use_nippers_4_1_end, private.room_objname );
  cmn.AddSubscriber( "use_nippers_4_1_inv", use_nippers_4_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_nippers_4_1_beg", use_nippers_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_nippers_4_1_end", use_nippers_4_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cash_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cash_1" ] = {
    type = "use",
    inv_obj = "inv_cash",
    use_place = "obj_truck_use_cash_1",
    room = private.room_objname,
    zz = "zz_truck",
    zz_gate = "gzz_abandoneddistrict_4_truck"
  };
  local use_cash_1_inv = function ()
  
    if cmn.IsEventDone( "use_cash_2" ) then
      interface.InventoryItemRemove( "inv_cash" );
    end;  

  end;
  local use_cash_1_beg = function ()
  
    ObjDelete( "obj_truck_use_cash_1" );
  
  end;
  local use_cash_1_end = function ()
  
    ObjDelete( "obj_truck_mounting_1" );
    ObjDelete( "obj_truck_mounting_2" );
    ObjDelete( "vid_truck_coin_1" );
    ObjSet( "spr_truck_mounting_open_1", { alp = 1 } );
    ObjSet( "spr_truck_mounting_open_2", { alp = 1 } );
    ObjSet( "obj_truck_doors_open", { input = true } );
    ObjSet( "obj_truck_brokentank", { input = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cash_1", use_cash_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_cash_1", use_cash_1_inv );
  cmn.AddSubscriber( "use_cash_1", use_cash_1_end, private.room_objname );
  cmn.AddSubscriber( "use_cash_1_inv", use_cash_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_cash_1_beg", use_cash_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_cash_1_end", use_cash_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cash_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cash_2" ] = {
    type = "use",
    inv_obj = "inv_cash",
    use_place = "obj_truck_use_cash_2",
    room = private.room_objname,
    zz = "zz_truck",
    zz_gate = "gzz_abandoneddistrict_4_truck"
  };
  local use_cash_2_inv = function ()
  
    if cmn.IsEventDone( "use_cash_1" ) then
      interface.InventoryItemRemove( "inv_cash" );
    end;  

  end;
  local use_cash_2_beg = function ()
  
    ObjDelete( "obj_truck_use_cash_2" );
  
  end;
  local use_cash_2_end = function ()
  
    ObjDelete( "vid_truck_coin_2" );
    ObjSet( "spr_truck_hammer_4", { input = true, active = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cash_2", use_cash_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_cash_2", use_cash_2_inv );
  cmn.AddSubscriber( "use_cash_2", use_cash_2_end, private.room_objname );
  cmn.AddSubscriber( "use_cash_2_inv", use_cash_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_cash_2_beg", use_cash_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_cash_2_end", use_cash_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_disksaw () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_disksaw" ] = {
    type = "use",
    inv_obj = "inv_disksaw",
    use_place = "obj_blockage_use_disksaw",
    room = private.room_objname,
    zz = "zz_blockage",
    zz_gate = "gzz_abandoneddistrict_4_blockage"
  };
  local use_disksaw_inv = function ()
  
    interface.InventoryItemRemove( "inv_disksaw" );
  
  end;
  local use_disksaw_beg = function ()
  
    ObjDelete( "obj_blockage_use_disksaw" );
  
  end;
  local use_disksaw_end = function ()
  
    ObjDelete( "gzz_abandoneddistrict_4_blockage" );
    --ObjDelete( "vid_blockage_disksaw" );
    ObjSet( "grm_abandoneddistrict_4_swamp", { input = true, active = true } );
    ObjSet( "spr_abandoneddistrict_4_blockage", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_disksaw", use_disksaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_disksaw", use_disksaw_inv );
  cmn.AddSubscriber( "use_disksaw", use_disksaw_end, private.room_objname );
  cmn.AddSubscriber( "use_disksaw_inv", use_disksaw_inv, private.room_objname );
  cmn.AddSubscriber( "use_disksaw_beg", use_disksaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_disksaw_end", use_disksaw_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_seeker_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_seeker_2" ] = {
    type = "use",
    inv_obj = "inv_seeker",
    use_place = "obj_abandoneddistrict_4_seeker_2",
    room = private.room_objname
  };
  local use_seeker_2_inv = function ()
  
    if ( cmn.IsEventDone( "use_seeker_1") and cmn.IsEventDone( "use_seeker_4") and
    cmn.IsEventDone( "use_seeker_3") and cmn.IsEventDone( "use_seeker_5")) then

      interface.InventoryItemRemove( "inv_seeker" );

    end;
  
  end;
  local use_seeker_2_beg = function ()
  
    --
  
  end;
  local use_seeker_2_end = function ()
  
    ObjSet( "obj_abandoneddistrict_4_seeker_2", { input = true, visible = true, active = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_seeker_2", use_seeker_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_seeker_2", use_seeker_2_inv );
  cmn.AddSubscriber( "use_seeker_2", use_seeker_2_end, private.room_objname );
  cmn.AddSubscriber( "use_seeker_2_inv", use_seeker_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_seeker_2_beg", use_seeker_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_seeker_2_end", use_seeker_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_owl_4_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_owl_4_3" ] = {
    type = "use",
    inv_obj = "inv_owl_4",
    use_place = "obj_abandoneddistrict_4_use_owl_4_3",
    room = private.room_objname,
    --zz = "zz_fire_4",
    --zz_gate = "gzz_abandoneddistrict_4_fire_4"
  };
  local use_owl_4_3_inv = function ()
  
    --interface.InventoryItemRemove( "inv_owl_4" );
  
  end;
  local use_owl_4_3_beg = function ()
  
    ObjDelete( "obj_abandoneddistrict_4_use_owl_4_3" );
    ObjDelete( "anm_abandoneddistrict_raven" );
  
  end;
  local use_owl_4_3_end = function ()
  
    ObjSet( "obj_abandoneddistrict_4_shopemblem", { alp = 1 } );    
    ObjSet( "spr_abandoneddistrict_4_shopemblem", { input = true, active = true, alp = 1 } );    
    ObjDelete( "anm_abandoneddistrict_owl" );
    ObjSet( "anm_abandoneddistrict_branch", { playing = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_owl_4_3", use_owl_4_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_owl_4_3", use_owl_4_3_inv );
  cmn.AddSubscriber( "use_owl_4_3", use_owl_4_3_end, private.room_objname );
  cmn.AddSubscriber( "use_owl_4_3_inv", use_owl_4_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_owl_4_3_beg", use_owl_4_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_owl_4_3_end", use_owl_4_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_splinter () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_splinter" ] = {
    type = "use",
    inv_obj = "inv_splinter",
    use_place = "obj_fire_4_use_splinter",
    room = private.room_objname,
    zz = "zz_fire_4",
    zz_gate = "gzz_abandoneddistrict_4_fire_4"
  };
  local use_splinter_inv = function ()
  
    interface.InventoryItemRemove( "inv_splinter" );
  
  end;
  local use_splinter_beg = function ()
  
    ObjDelete( "obj_fire_4_use_splinter" );
  
  end;
  local use_splinter_end = function ()
  
    ObjSet( "obj_fire_4_litchip", { alp = 1 } );
    interface.InventoryItemAdd( "inv_litchip", "obj_fire_4_litchip" );
    
    ObjDelete( "anm_fire_4_splinter" );
    if ( common_impl.IsGetCoin( "get_coin_38" ) ) then 

      ObjDelete( "gzz_abandoneddistrict_4_fire_4" );
      
    end;
  
  end;
  local use_splinter_fire = function ()
  
    ObjDelete( "spr_abandoneddistrict_4_fire_4_fire_1" );
    ObjDelete( "spr_abandoneddistrict_4_fire_4_fire_1_add" );
    ObjDelete( "spr_abandoneddistrict_4_fire_4_moss" );
    ObjDelete( "spr_abandoneddistrict_4_fire_4_wood_2" );
    ObjSet( "spr_abandoneddistrict_4_fire_4_fire_2_add", { alp = 0.5 } );
    ObjSet( "spr_abandoneddistrict_4_fire_4_fire_3_add", { alp = 0.5 } );
    ObjSet( "spr_fire_4_bonfire", { alp = 1 } );
    ObjDelete( "anm_fire_4_fire2" );
    ObjDelete( "spr_fire_4_fire_light" );
    ObjDelete( "obj_fire_4_fire_2_light" );
    ObjDelete( "vid_abandoneddistrict_4_fire_4_fire" );
    --ObjDelete( "obj_fire_4_fire_2_light" );
    ObjSet( "obj_fire_4_fireend", { input = 1 } )
    if ( common_impl.IsGetCoin( "get_coin_38" ) ) then 

      ObjSet( "obj_abandoneddistrict_4_fire_4_fireend", { input = true } );
      
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_splinter", use_splinter_beg, private.room_objname );
  cmn.AddSubscriber( "use_splinter", use_splinter_inv );
  cmn.AddSubscriber( "use_splinter", use_splinter_end );
  cmn.AddSubscriber( "use_splinter_inv", use_splinter_inv, private.room_objname );
  cmn.AddSubscriber( "use_splinter_beg", use_splinter_beg, private.room_objname );
  cmn.AddSubscriber( "use_splinter_end", use_splinter_end, private.room_objname );
  cmn.AddSubscriber( "use_splinter", use_splinter_fire, private.room_objname );
  cmn.AddSubscriber( "use_splinter_fire", use_splinter_fire, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wood_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wood_4" ] = {
    type = "use",
    inv_obj = "spr_fire_4_wood_4",
    use_place = "obj_fire_4_use_wood_4",
    room = private.room_objname,
    zz = "zz_fire_4",
    zz_gate = "gzz_abandoneddistrict_4_fire_4"
  };
  local use_wood_4_end = function ()

    ObjDelete( "obj_fire_4_use_wood_4" );
    ObjDelete( "spr_abandoneddistrict_4_fire_4_wood_1" );
    ObjDelete( "spr_fire_4_log_wood_4_shadow" );
    ObjDelete( "gfx_fire_4_wood_4" );
    ObjDelete( "spr_fire_4_wood_4" );
    ObjSet( "obj_fire_4_use_drymoss", { input = true } );
    ObjSet( "spr_fire_4_log_wood_used", { alp = 1 } );
    ObjSet( "spr_abandoneddistrict_4_fire_4_wood_2", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wood_4", use_wood_4_end, private.room_objname );
  cmn.AddSubscriber( "use_wood_4_end", use_wood_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_shop_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_shop_4" ] = {

      type = "win",    
      room = private.room_objname,
      use_place = "spr_shop_4_van",
      zz_gate = "gzz_abandoneddistrict_4_shop_4",
      zz = "zz_shop_4"

  };

  local win_shop_4 = function ()

      if ( cmn.IsEventDone( "win_shop_4" ) ) then  

        ObjDelete( "obj_shop_4_minigame" );
        ObjDelete( "spr_abandoneddistrict_4_shop_4_door_1" );

        ObjSet( "spr_shop_4_van", { active = true, input = true, visible = true } );
        ObjSet( "spr_shop_4_ring_4", { active = true, input = true, visible = true } );
        ObjSet( "obj_shop_4_use_shopkey", { input = true, active = true } );
        ObjSet( "spr_abandoneddistrict_4_shop_4_door_2", { alp = 1 } );

      else
        
        for i = 1, 3 do

          ObjSet( "spr_shop_4_circle_"..i, { ang = ng_global.progress[ "ext" ][ "win_shop_4" ].state[ i ] * math.pi/2 } );

        end;

      end;
  end;
  cmn.AddSubscriber( "win_shop_4", win_shop_4, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function win_fire_4 () end;
  --------------------------------------------------------------------------------------------
--  common_impl.hint[ "win_fire_4" ] = {
--
--      type = "win",    
--      room = private.room_objname,
--      use_place = "spr_fire_4_van",
--      zz_gate = "gzz_abandoneddistrict_4_fire_4",
--      zz = "zz_fire_4"
--
--  };
--
--  local win_fire_4 = function ()
--
--      if ( cmn.IsEventDone( "win_fire_4" ) ) then  
--
--        ObjSet( "obj_fire_4_use_splinter", { input = true } );
--
--      else
--        
--      --
--
--      end;
--  end;
--  cmn.AddSubscriber( "win_fire_4", win_fire_4, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function vid_abandoneddistrict_4_robintrouble () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_abandoneddistrict_4_robintrouble" ] = {

      type = "click",
      use_place = "obj_vid_abandoneddistrict_4_robintrouble",
      room = private.room_objname
  };
  local vid_abandoneddistrict_4_robintrouble_beg = function ()

    ObjDelete( "obj_vid_abandoneddistrict_4_robintrouble" );

  end;
  local vid_abandoneddistrict_4_robintrouble_end = function ()

    ObjDelete( "anm_abandoneddistrict_robin" );

  end;

  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "vid_abandoneddistrict_4_robintrouble", vid_abandoneddistrict_4_robintrouble_beg, private.room_objname );
  cmn.AddSubscriber( "vid_abandoneddistrict_4_robintrouble", vid_abandoneddistrict_4_robintrouble_end, private.room_objname  );
  cmn.AddSubscriber( "vid_abandoneddistrict_4_robintrouble_beg", vid_abandoneddistrict_4_robintrouble_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_abandoneddistrict_4_robintrouble_end", vid_abandoneddistrict_4_robintrouble_end, private.room_objname  );


  ObjAnimate( "spr_fire_4_fire_2_light", "alp", 1, 0, "", 
  {
    0.0,    0, 1.0,
    0.15,   0, 0.7,
    0.25,   0, 1.0,
    0.3,    0, 0.75,
    0.4,    0, 0.25,
    0.6,    0, 0.75,
    0.7,    0, 0.4,
    0.8,    0, 0.22,
    1.0,    0, 1.0,
    1.2,    0, 0.6,
    1.3,    0, 1.0,
    1.5,    0, 0.25,
    1.66,   0, 1.0,
    1.8,    0, 0.52,
    2.0,    0, 0.4,
    2.2,    0, 0.8,
    2.3,    0, 1.0,
    2.5,    0, 0.42,
    2.66,   0, 0.64,
    2.8,    0, 0.96,
    3.0,    0, 1.0,
    3.15,   0, 0.22,
    3.3,    0, 1.0,
    3.4,    0, 0.78,
    3.5,    0, 1.0
  } );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_shop_4" );
  
  function zz_shop_4.PreOpen()

    if ( not ng_global.progress[ "ext" ][ "win_shop_4" ].state ) then

      ng_global.progress[ "ext" ][ "win_shop_4" ].state = {};

      for i = 1, 3 do

        ng_global.progress[ "ext" ][ "win_shop_4" ].state[ i ] = private.start_state[ i ];
        ObjSet( "spr_shop_4_circle_"..i, { ang = private.start_state[ i ] * math.pi/2 } );

      end;

    end;

    if ( cmn.IsEventDone( "use_shopemblem" )) and not cmn.IsEventDone( "win_shop_4" ) then
    
      cmn.MiniGameShow( 'shop_4' );
      common_impl.PassingMgStart( "shop_4" );
      
    end;

  end;

  function zz_shop_4.PreClose()

    if ( cmn.IsEventDone( "use_shopemblem" )) and not cmn.IsEventDone( "win_shop_4" ) then

      cmn.MiniGameHide( 'shop_4' );
      common_impl.PassingMgStop( "shop_4" )

    end;

  end;

  subroom.Define( "zz_fire_4" );
  
  function zz_fire_4.PreOpen()

    --if ( cmn.IsEventDone( "use_bowdrill" )) and not cmn.IsEventDone( "win_fire_4" ) then
    --
    --  cmn.MiniGameShow( 'fire_4' );
      --common_impl.PassingMgStart( "fire_4" )
      
    --end;
    

  end;

  function zz_fire_4.PreClose()

--    if ( cmn.IsEventDone( "use_bowdrill" )) and not cmn.IsEventDone( "win_fire_4" ) then
--
--      cmn.MiniGameHide( 'fire_4' );
      --common_impl.PassingMgStop( "fire_4" )

    --end;

    if cmn.IsEventDone( "use_bowdrill" ) then

      common_impl.StopAudio( "env", "common/audio/aud_fire_4_fire_zz", 0.2 );
      common_impl.PlayAudio( "env", "common/audio/aud_fire_4_fire_loc", 1, "", 0 );    

    end;

  end;

  subroom.Define( "zz_truck" );

  function zz_truck.PreOpen()

    if cmn.IsEventDone( "use_bowdrill" ) then

      common_impl.StopAudio( "env", "common/audio/aud_fire_4_fire_loc", 0.2 );
      common_impl.PlayAudio( "env", "common/audio/aud_fire_4_fire_zz", 1, "", 0 );

    end;

  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_abandoneddistrict_4();
  
  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();
  --interface.InvestigationButtonCheck();

  common_impl.EnvPlay( { "common/audio/aud_abandoneddistrict_4_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_chump()

  local item = "inv_chump";

  if ( common.ApplyObj( item, "obj_fire_4_use_chump", true ) ) then

    cmn.CallEventHandler( "use_chump_inv" );
    cmn.CallEventHandler( "use_chump_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_chump" );
      cmn.CallEventHandler( "use_chump_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_chump", 0, "", 0 );
  
    ObjAnimate( "spr_fire_4_log", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_fire_4_log_shadow", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_abandoneddistrict_4_fire_4", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fire_4", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_chopper()

  local item = "inv_chopper";

  if ( common.ApplyObj( item, "obj_fire_4_use_chopper", true ) and cmn.IsEventDone( "use_chump" ) ) then

    cmn.CallEventHandler( "use_chopper_inv" );
    cmn.CallEventHandler( "use_chopper_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_chopper" );
      cmn.CallEventHandler( "use_chopper_end" );
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_chopper", 0, "", 0 );
  
    ObjMultiSet({
      { "spr_fire_4_log",        { alp = 0 } },
      { "spr_fire_4_log_shadow", { alp = 0 } },
      { "anm_fire_4_firewood", { alp = 1, active = true } }
    });

    ObjAnimate( "obj_fire_4_splinter", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      1.0, 0, 0.0,
      1.2, 0, 1.0
    } );
    
    AnimPlay( "anm_fire_4_firewood", "DoAnim", func_after );

    return true;
  
  elseif common.ApplyObj( item, "obj_fire_4_use_chump", true ) then

      common_impl.ShowBbt( 'bbt_fire_4_use_chopper_wrong', 1 );

    return true;    

  elseif ( common.ApplyObj( item, "gzz_abandoneddistrict_4_fire_4", false ) and cmn.IsEventDone( "use_chump" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fire_4", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_drymoss()

  local item = "inv_drymoss";

  if ( common.ApplyObj( item, "obj_fire_4_use_drymoss", true ) and cmn.IsEventDone( "use_wood_4" ) ) then

    cmn.CallEventHandler( "use_drymoss_inv" );
    cmn.CallEventHandler( "use_drymoss_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_drymoss" );
      cmn.CallEventHandler( "use_drymoss_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_drymoss", 0, "", 0 );
  
    ObjAnimate( "spr_fire_4_mos", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
    return true;
  
  elseif ( common.ApplyObj( item, "obj_fire_4_use_wood_4", true ) ) then

    common_impl.ShowBbt( 'bbt_fire_4_use_drymoss_wrong', 1 );

    return true;

  elseif ( common.ApplyObj( item, "gzz_abandoneddistrict_4_fire_4", false ) and cmn.IsEventDone( "use_wood_4" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fire_4", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bowdrill()

  local item = "inv_bowdrill";

  if ( common.ApplyObj( item, "obj_fire_4_use_bowdrill", true ) and cmn.IsEventDone( "use_drymoss" ) ) then

    cmn.CallEventHandler( "use_bowdrill_inv" );
    cmn.CallEventHandler( "use_bowdrill_beg" );
     
    local func_after = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "use_bowdrill" );
      cmn.CallEventHandler( "use_bowdrill_end" );
      --cmn.MiniGameShow( "fire_4" );
      --common_impl.PassingMgStart( "fire_4" );
       common_impl.PlayAudio( "env", "common/audio/aud_fire_4_fire_zz", 1, "", 0 );

    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_bowdrill", 0, "", 0 );

  
    ObjSet( "anm_fire_4_fire", { alp = 1, active = true } );
    ObjSet( "anm_fire_4_fire2", { active = true } );  

    ObjSet( "obj_fire_4_fire_2_light", { active = true } );

    ObjAnimate( "obj_fire_4_fire_2_light", "alp", 0, 0, "",
    { 
      0.0, 0, 0,
      3.2, 0, 0,
      3.5, 0, 1
    } );     

    ObjAnimate( "anm_fire_4_fire2", "alp", 0, 0, "", 
    { 
      0.0, 0, 0,
      3.2, 0, 0,
      3.5, 0, 1
    } );

    AnimPlay( "anm_fire_4_fire", "DoAnim", func_after );

    return true;

  elseif ( common.ApplyObj( item, "obj_fire_4_use_drymoss", true ) ) then

    common_impl.ShowBbt( 'bbt_fire_4_use_bowdrill_wrong', 1 );

    return true;

  elseif ( common.ApplyObj( item, "gzz_abandoneddistrict_4_fire_4", false ) and cmn.IsEventDone( "use_drymoss" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fire_4", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_shopemblem()

  local item = "inv_shopemblem";

  if ( common.ApplyObj( item, "obj_shop_4_use_shopemblem", true ) ) then

    cmn.CallEventHandler( "use_shopemblem_inv" );
    cmn.CallEventHandler( "use_shopemblem_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_shopemblem" );
      cmn.CallEventHandler( "use_shopemblem_end" );
      cmn.MiniGameShow( "shop_4" );
      common_impl.PassingMgStart( "shop_4" );
    
    end;

    common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_use_emblem_shop", 0, "", 0 );
  
    ObjAnimate( "spr_shop_4_used_key", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_abandoneddistrict_4_shop_4", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shop_4", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_shopkey()

  local item = "inv_shopkey";

  if ( common.ApplyObj( item, "obj_shop_4_use_shopkey", true ) ) then

    cmn.CallEventHandler( "use_shopkey_inv" );
    cmn.CallEventHandler( "use_shopkey_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_shopkey" );
      cmn.CallEventHandler( "use_shopkey_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_shopkey", 0, "", 0 );

    ObjAnimate( "spr_shop_4_key", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.4, 0, 1.0
    } );

    ObjAnimate( "spr_shop_4_key_shadow", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.4, 0, 1.0
    } );

    ObjAnimate( "spr_shop_4_key", "pos_y", 0, 0, "",
    { 
      0.0, 0, 11, 
      0.4, 0, 11,
      0.7, 0, 11,
      1.0, 3, 3
    } );

    ObjAnimate( "spr_shop_4_key_shadow", "pos_y", 0, 0, "",
    { 
      0.0, 0, 20, 
      0.4, 0, 20,
      0.7, 0, 20,
      1.0, 3, 16
    } );

    ObjAnimate( "spr_shop_4_cover", "alp", 0, 0, func_after, 
    {
      0.0, 0, 1,
      1.0, 0, 1, 
      1.3, 0, 0
    } );

    ObjAnimate( "obj_shop_4_open_shop", "alp", 0, 0, "", 
    {
      0.0, 0, 0, 
      1.2, 0, 0, 
      1.3, 0, 1
    } );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_abandoneddistrict_4_shop_4", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shop_4", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_nippers_4_1()

  local item = "inv_nippers_4";

  if ( common.ApplyObj( item, "obj_truck_use_nippers_4", true ) ) then

    cmn.CallEventHandler( "use_nippers_4_1_inv" );
    cmn.CallEventHandler( "use_nippers_4_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_nippers_4_1" );
      cmn.CallEventHandler( "use_nippers_4_1_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_nippers_van", 0, "", 0 );

    AnimPlay( "anm_truck_chain", "DoAnim", func_after );

    return true;
  
  elseif common.ApplyObj( item, "gzz_abandoneddistrict_4_truck", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_truck", nil, { 512, 384 } );
    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_cash_1()

  local item = "inv_cash";

  if ( common.ApplyObj( item, "obj_truck_use_cash_1", true ) ) then

    cmn.CallEventHandler( "use_cash_1_inv" );
    cmn.CallEventHandler( "use_cash_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_cash_1" );
      cmn.CallEventHandler( "use_cash_1_end" );

    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_cash_1", 0, "", 0 );
    VidPlay( "vid_truck_coin_1", func_after );

    ObjAnimate( "obj_truck_mounting_1", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      2.9, 0, 1.0,
      3.2, 0, 0.0
    } );

    ObjAnimate( "obj_truck_mounting_2", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      5.7, 0, 1.0,
      6.0, 0, 0.0
    } );

    ObjAnimate( "spr_truck_mounting_open_1", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      2.9, 0, 0.0,
      3.2, 0, 1.0
    } );

    ObjAnimate( "spr_truck_mounting_open_2", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      5.7, 0, 0.0,
      6.0, 0, 1.0
    } );

    return true;
  
  elseif common.ApplyObj( item, "gzz_abandoneddistrict_4_truck", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_truck", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_cash_2()

  local item = "inv_cash";

  if ( common.ApplyObj( item, "obj_truck_use_cash_2", true ) ) then

    cmn.CallEventHandler( "use_cash_2_inv" );
    cmn.CallEventHandler( "use_cash_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_cash_2" );
      cmn.CallEventHandler( "use_cash_2_end" );
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_cash_2", 0, "", 0 );

    VidPlay( "vid_truck_coin_2", func_after);  
 
    return true;
  
  elseif common.ApplyObj( item, "gzz_abandoneddistrict_4_truck", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_truck", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_disksaw()

  local item = "inv_disksaw";

  if ( common.ApplyObj( item, "obj_blockage_use_disksaw", true ) ) then

    cmn.CallEventHandler( "use_disksaw_inv" );
    cmn.CallEventHandler( "use_disksaw_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_disksaw" );
      cmn.CallEventHandler( "use_disksaw_end" );
      common.CloseSubRoom();
    
    end;

    common_impl.Lock( true );
    ObjSet( "vid_blockage_disksaw", { active = true, alp = 1 });
    VidPlay( "vid_blockage_disksaw", func_after );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_disksaw", 0, "", 0 );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_abandoneddistrict_4_blockage", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_blockage", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_seeker_2()

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "use_seeker_2" );
    cmn.CallEventHandler( "use_seeker_2_end" );
    cmn.CallEventHandler( "use_seeker_2_inv" );

  end;

  common_impl.Lock( true );
  func_after();

  return true;

end;
--------------------------------------------------------------------------------------------
function public.use_owl_4_3()

  local item = "inv_owl_4";

  if ( common.ApplyObj( item, "obj_abandoneddistrict_4_use_owl_4_3" ) ) and cmn.IsEventDone( "vid_abandoneddistrict_4_robintrouble" ) then

    cmn.CallEventHandler( "use_owl_4_3_inv" );
    cmn.CallEventHandler( "use_owl_4_3_beg" );

    local func_after = function ()
  
      local func_end = function()
        common_impl.Lock( false );
        cmn.SetEventDone( "use_owl_4_3" );
        cmn.CallEventHandler( "use_owl_4_3_end" );
      end;
      ObjAnimate( "obj_abandoneddistrict_4_shopemblem", "alp", 0, 0, func_end, { 0,0,0, 0.2,0,1 } );
      ObjAnimate( "anm_abandoneddistrict_owl", "alp", 0, 0, "", { 0,0,1, 0.2,0,0 } );
    
    end;

    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_owl_crow", 0, "", 0 );
  
    ObjSet( "anm_abandoneddistrict_owl", { visible = true } );
    AnimPlay( "anm_abandoneddistrict_owl", "DoAnim", func_after );
    
  
    return true;
  
  else

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_splinter()

  local item = "inv_splinter";

  if ( common.ApplyObj( item, "obj_fire_4_use_splinter", true ) and cmn.IsEventDone( "use_bowdrill" ) ) then

    cmn.CallEventHandler( "use_splinter_inv" );
    cmn.CallEventHandler( "use_splinter_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_splinter" );
      cmn.CallEventHandler( "use_splinter_end" );

      if ( common_impl.IsGetCoin( "get_coin_38" ) ) then 

        common.CloseSubRoom();

      end;   
 
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_splinter", 0, "", 0 );
  
    ObjSet( "anm_fire_4_splinter", { alp = 1, active = true } );
    AnimPlay( "anm_fire_4_splinter", "DoAnim", func_after );

    return true;
  
  elseif ( common.ApplyObj( item, "gzz_abandoneddistrict_4_fire_4", false ) and cmn.IsEventDone( "use_bowdrill" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_fire_4", nil, { 512, 384 } );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
--function private.get_litchip()
--
--  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
--  
--  cmn.SetEventDone( "get_litchip" );
--  cmn.CallEventHandler( "get_litchip" );
--
--  if ( common_impl.IsGetCoin( "get_coin_38" ) ) then 
--
--    common.CloseSubRoom();
--
--  end;
--
--end;
--------------------------------------------------------------------------------------------
function private.get_bluntsawdisk()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_bluntsawdisk" );
  cmn.CallEventHandler( "get_bluntsawdisk" );

end;
--------------------------------------------------------------------------------------------
function private.get_brace()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_brace" );
  cmn.CallEventHandler( "get_brace" );

end;
--------------------------------------------------------------------------------------------
function private.get_splinter()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_splinter" );
  cmn.CallEventHandler( "get_splinter" );

end;
--------------------------------------------------------------------------------------------
function private.get_ring_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_ring_4" );
  cmn.CallEventHandler( "get_ring_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_van()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_van" );
  cmn.CallEventHandler( "get_van" );

end;
--------------------------------------------------------------------------------------------
function private.get_clownpiece()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_clownpiece" );
  cmn.CallEventHandler( "get_clownpiece" );

  if cmn.IsEventDone( "get_matches_4" ) and cmn.IsEventDone( "get_firetorch" ) then
    common.CloseSubRoom();
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_firetorch()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_firetorch" );
  cmn.CallEventHandler( "get_firetorch" );

  if cmn.IsEventDone( "get_clownpiece" ) and cmn.IsEventDone( "get_matches_4" ) then
    common.CloseSubRoom();
  end;
 
end;
--------------------------------------------------------------------------------------------
function private.get_matches_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_matches_4" );
  cmn.CallEventHandler( "get_matches_4" );

  if cmn.IsEventDone( "get_clownpiece" ) and cmn.IsEventDone( "get_firetorch" ) then
    common.CloseSubRoom();
  end;
 
end;
--------------------------------------------------------------------------------------------
function private.get_knife_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_knife_4" );
  cmn.CallEventHandler( "get_knife_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_brokendisksaw()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_brokendisksaw" );
  cmn.CallEventHandler( "get_brokendisksaw" );

end;
--------------------------------------------------------------------------------------------
function private.get_brokentank()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_brokentank" );
  cmn.CallEventHandler( "get_brokentank" );

  if cmn.IsEventDone( "get_hammer_4" ) and common_impl.IsGetCoin( "get_coin_39" ) then
    common.CloseSubRoom();
  end;
  
end;
--------------------------------------------------------------------------------------------
function private.get_hammer_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_hammer_4" );
  cmn.CallEventHandler( "get_hammer_4" );

  if cmn.IsEventDone( "get_brokentank" ) and common_impl.IsGetCoin( "get_coin_39" ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_shopemblem()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_shopemblem" );
  cmn.CallEventHandler( "get_shopemblem" );

end;
--------------------------------------------------------------------------------------------
function private.get_charmpiece_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_charmpiece_2" );
  cmn.CallEventHandler( "get_charmpiece_2" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.drag_wood_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  ObjSet( "spr_fire_4_wood_4", { pos_z = 10 } );
  ObjSet( "spr_fire_4_log_wood_4_shadow", { alp = 0 } );

end;
--------------------------------------------------------------------------------------------
function private.drop_wood_4()

  local item = "spr_fire_4_wood_4";

  if ( common.ApplyObj( item, "obj_fire_4_use_wood_4" ) ) then

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_wood_4" );
      cmn.CallEventHandler( "use_wood_4_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_wood_4", 0, "", 0 );

    ObjSet( item, { alp = 0 } );

    ObjAnimate( "spr_fire_4_log_wood_used", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );

  else

    ObjSet( item, { pos_z = 0 } );
    ObjSet( "spr_fire_4_log_wood_4_shadow", { alp = 1 } );

  end;

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_abandoneddistrict_4()

  if not ( cmn.IsEventDone( "opn_abandoneddistrict_4" ) ) then
    cmn.SetEventDone( "opn_abandoneddistrict_4" );
  end;
  
  cmn.CallEventHandler( "opn_abandoneddistrict_4" ); 

end;
--*********************************************************************************************************************
function private.get_collect_coin_38()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_38" );
    cmn.CallEventHandler( "get_coin_38" );

    if cmn.IsEventDone( "use_splinter" ) then
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_fire_4_coin", func_after ); 

end;
--*********************************************************************************************************************
function private.get_collect_coin_39()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_39" );
    cmn.CallEventHandler( "get_coin_39" );

    if cmn.IsEventDone( "get_hammer_4" ) and cmn.IsEventDone( "get_brokentank" )  then

      common.CloseSubRoom();

    end;    

  end;

  common_impl.PlayEffectHO( "spr_truck_coin", func_after ); 

end;
--*********************************************************************************************************************
function private.vid_abandoneddistrict_4_robintrouble()

  cmn.CallEventHandler( "vid_abandoneddistrict_4_robintrouble_beg" );
  ObjSet( "vid_abandoneddistrict_4_robintrouble", { alp = 1, active = true, input = false, visible = true } );

  local widget_settings = {}

  if IsCollectorsEdition() then

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnGuide,
      InterfaceWidget_BtnMenu
    }

  else

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnMenu
    }

  end;
  
  local func_after = function ( skip )

    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_abandoneddistrict_4_robintrouble", 0.2 );
      
    end;
    
    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_abandoneddistrict_4_robintrouble" );
    cmn.CallEventHandler( "vid_abandoneddistrict_4_robintrouble_end" );
    common_impl.StopAudio( "voc", "common/audio/aud_abandoneddistrict_4_robintrouble_voc", 0.2 );
    common_impl.ShowBbt( 'bbt_abandoneddistrict_4_after_robintrouble', 1 );

    common_impl.PlayAudio( "mus", "common/audio/aud_scary_mus", 0, "", 0 );

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

  end;

  for i = 1, #widget_settings do

    interface.WidgetSetVisible( widget_settings[i], 0 );

  end;

  common_impl.StopAllMus();
  interface.DialogVideoShow( "vid_abandoneddistrict_4_robintrouble", 1, function() func_after( 'skip' ); end, 3 );
  common_impl.PlayAudio( "sfx", "common/audio/aud_abandoneddistrict_4_robintrouble", 0, "", 0.5 );
  VidPlay( "vid_abandoneddistrict_4_robintrouble", function() func_after( nil ); end ); 
  common_impl.PlayAudio( "voc", "common/audio/aud_abandoneddistrict_4_robintrouble_voc", 0, "", 0 );

end;
--*********************************************************************************************************************
----------------------------------------------------------------
function private.win_shop_4()

  common_impl.Lock( true );

  local func_after = function ()

    common_impl.Lock( false );
    PlaySfx( "assets/levels/common/audio/aud_mg_win", 0, 0 );
    cmn.MiniGameHide( "shop_4" );
    cmn.SetEventDone( "win_shop_4" );
    cmn.CallEventHandler( "win_shop_4" );
    common_impl.PassingMgWin( "shop_4" )

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_shop_win", 0, "", 0.5 );
  ObjAnimate( "obj_shop_4_minigame", "alp", 0, 0, func_after, { 0, 0, 1, 0.4, 0, 0 } );

end;
-----------------------------------------------------------------
function private.win_fire_4()

  common_impl.Lock( true );
  local func_after = function ()

    common_impl.Lock(false);
    PlaySfx( "assets/levels/common/audio/aud_mg_win", 0, 0 );
    cmn.MiniGameHide( "fire_4" );
    cmn.SetEventDone( "win_fire_4" );
    cmn.CallEventHandler( "win_fire_4" );
    common_impl.PassingMgWin( "fire_4" );

  end;
    
  func_after();

end;
--********************************************************************************************************************
function public.Reset( event )


  if cmn.IsEventDone( "use_shopemblem" ) and not cmn.IsEventDone( "win_shop_4" ) then

    for i = 1, 3 do

      ng_global.progress[ "ext" ][ "win_shop_4" ].state[ i ] = private.start_state[ i ];
      ObjSet( "spr_shop_4_circle_"..i, { ang = private.start_state[ i ] * math.pi/2 } );

    end;
    
  end;

  if cmn.IsEventDone( "use_bowdrill" ) and not cmn.IsEventDone( "win_fire_4" ) then

    --
    
  end;  

end;
-----------------------------------------------------------------
function public.Skip( event ) 

  if cmn.IsEventDone( "use_shopemblem" ) and not cmn.IsEventDone( "win_shop_4" ) then

    common_impl.Lock( true );
    
    local func_end = function () 
      --
    end;
  
    for i = 1, 3 do

      if ( i == 3 ) then

        func_end = private.win_shop_4;

      end;

      ObjAnimate( "spr_shop_4_circle_"..i, "ang", 0, 0, func_end, { 0, 0, ObjGet( "spr_shop_4_circle_"..i ).ang, 0.4, 3, 0 } );

    end;

   --private.win_shop_4();

  end;

  if cmn.IsEventDone( "use_bowdrill" ) and not cmn.IsEventDone( "win_fire_4" ) then

    common_impl.Lock( true );
    private.win_fire_4();

  end;

end;
-------------------------------------------------------------------------------------
function private.ChainClick ()

  common_impl.Lock( true );

  local func_after = function () 

    common_impl.Lock( false ); 
    common_impl.ShowBbt( 'bbt_truck_use_nippers_4' );
    ObjSet( "anm_truck_chain_static", { alp = 0 });
    ObjSet( "anm_truck_chain", { alp = 1 });

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_van_backdoor", 0, "", 0.5 );
  ObjSet( "anm_truck_chain_static", { alp = 1 });
  ObjSet( "anm_truck_chain", { alp = 0 });
  AnimPlay( "anm_truck_chain_static", "DoAnim", func_after );

end;
--********************************************************************************************************************
-- function *** MMG SHOP *** () end;
--********************************************************************************************************************
function private.CircleEnter ( id )

  ObjSet( "spr_shop_4_circle_"..id.."_light", { alp = 0.7 } );  
  common_impl.SetCursor( CURSOR_HAND );

end;
--********************************************************************************************************************
function private.CircleLeave ( id )

  ObjSet( "spr_shop_4_circle_"..id.."_light", { alp = 0 } );
  common_impl.SetCursor( CURSOR_DEFAULT );

end;
--********************************************************************************************************************
function private.CircleClick( id )

  common_impl.Lock( true );

  local neighbors = { 2, 3, 1 };

  local func_check = function ()

    local tmp_check = {};
    local flag_win  = true;
    for i = 1, 3 do

      tmp_check[ i ] = ng_global.progress[ "ext" ][ "win_shop_4" ].state[ i ];

    end;

    tmp_check[ id ] = ( tmp_check[ id ] + 2 ) % 4;
    tmp_check[ neighbors[ id ] ] = ( tmp_check[ neighbors[ id ] ] + 3 ) % 4;

    for i = 1, 3 do

      if ( tmp_check[ i ] ~= 0 ) then

        flag_win = false;
        break;

      end;

    end

    if ( flag_win ) then

      private.win_shop_4();

    else

      for i = 1, 3 do

        ng_global.progress[ "ext" ][ "win_shop_4" ].state[ i ] = tmp_check[ i ];
        common_impl.Lock( false );

      end;

    end;

  end;

  local start_ang = ObjGet( "spr_shop_4_circle_"..id ).ang;
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_shop_click", 0, "", 0.5 );
  ObjAnimate( "spr_shop_4_circle_"..id, "ang", 0, 0, "", 
  { 
    0, 0, start_ang,
    0.3, 0, start_ang + math.pi 
  } );

  start_ang = ObjGet( "spr_shop_4_circle_"..neighbors[ id ] ).ang;
  ObjAnimate( "spr_shop_4_circle_"..neighbors[ id ], "ang", 0, 0, func_check, 
  { 
    0, 0, start_ang,
    0.3, 0, start_ang - math.pi/2 
  } );

end;
--********************************************************************************************************************
-- function LightAnimation() end;
--********************************************************************************************************************
ObjAnimate( "spr_shop_4_lamp_2", "alp", 1, 0, "", 

  { 
    0.0, 3, 1.0, 
    1.0, 3, 0.2, 
    2.1, 3, 1.0, 
    4.0, 3, 0.2, 
    6.1, 3, 0.9, 
    7.2, 3, 0.1, 
    8.3, 3, 1.0, 

  });

ObjAnimate( "spr_shop_4_lamp_1", "alp", 1, 0, "", 

  { 
    0.0, 3, 1.0, 
    1.5, 3, 0.1, 
    1.1, 3, 1.0, 
    1.5, 3, 0.2, 
    2.0, 3, 0.9, 
    3.0, 3, 0.1, 
    4.3, 3, 1.0, 
    

  });

--********************************************************************************************************************
--********************************************************************************************************************
--********************************************************************************************************************
--********************************************************************************************************************



