-- name=rm_deathtrap
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_deathtrap";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_livetree", "room_hub" );
  ObjAttach( "zz_tower", "room_hub" );
  ObjAttach( "zz_merman", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_livetree_shopkey", { event_mdown = private.get_shopkey }},
    { "spr_livetree_cash", { event_mdown = private.get_cash }},
    { "spr_livetree_torch", { event_mdown = private.get_torch }},
    { "spr_livetree_powersymbol_1", { event_mdown = private.get_powersymbol_1 }},   
    { "obj_livetree_use_nitrogentank", { event_mdown = private.clk_livetree }},
    { "obj_merman_clk_frog", { event_mdown = function() private.ClkFrog() end }},
    { "spr_deathtrap_collect_item",    { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_4_2" );     end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_deathtrap_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_4_2" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
 
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_deathtrap = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_deathtrap_livetree",
    "gzz_deathtrap_tower",
    "gzz_deathtrap_merman"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_livetree",
      "zz_tower",
      "zz_merman",
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_deathtrap", update_game_mode_deathtrap, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_deathtrap = function ()

  local effects_table = 
  {
    "anm_deathtrap_bubles"
    ,"anm_deathtrap_merman" 
    ,"anm_deathtrap_treeman" 
    ,"anm_deathtrap_anims"
    ,"spr_tower_light",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_deathtrap", update_performance_mode_deathtrap, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_deathtrap () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_deathtrap" ] = {
    type = "click",
    use_place = "grm_sheriffshouse_4_deathtrap",
    room = "rm_sheriffshouse_4"
  };

  local opn_deathtrap_map = function ()

    common_impl.VisitMapRoom( "deathtrap" );

  end;
  cmn.AddSubscriber( "opn_deathtrap", opn_deathtrap_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_4_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_4_2 = function ()
  
    ObjDelete( "obj_deathtrap_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_4_2", get_collect_item_4_2, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4_2 = function ()
  
    ObjDelete( "obj_deathtrap_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_4_2", get_collect_morph_item_4_2, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_shopkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_shopkey" ] = {
    type = "get",
    get_obj = "spr_livetree_shopkey",
    room = private.room_objname,
    zz = "zz_livetree",
    zz_gate = "gzz_deathtrap_livetree"
  };
    
  local get_shopkey_inv = function ()
  
    interface.InventoryItemAdd( "inv_shopkey", "spr_livetree_shopkey" );
  
  end;
  
  local get_shopkey_closezz = function ()
  
    ObjDelete( "gfx_livetree_shopkey" );
    ObjDelete( "spr_livetree_shopkey_shadow" );
    ObjDelete( "anm_livetree_use_hammer" );

    if cmn.IsEventDone( "get_torch" ) and cmn.IsEventDone( "get_powersymbol_1" ) then
      ObjDelete( "gzz_deathtrap_livetree" );
    end;  

  end;
  
  cmn.AddSubscriber( "get_shopkey", get_shopkey_inv );
  cmn.AddSubscriber( "get_shopkey", get_shopkey_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cash () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cash" ] = {
    type = "get",
    get_obj = "spr_livetree_cash",
    room = private.room_objname,
    zz = "zz_livetree",
    zz_gate = "gzz_deathtrap_livetree"
  };
    
  local get_cash_inv = function ()
  
    interface.InventoryItemAdd( "inv_cash", "spr_livetree_cash" );
  
  end;
  
  local get_cash_closezz = function ()
  
    ObjDelete( "gfx_livetree_cash" );
    ObjDelete( "spr_livetree_cash_shadow" );
    ObjDelete( "spr_deathtrap_livetree_coin" );

    if cmn.IsEventDone( "get_shopkey" ) and cmn.IsEventDone( "get_powersymbol_1" ) and cmn.IsEventDone( "get_torch" ) then
      ObjDelete( "gzz_deathtrap_livetree" );
    end;  
  
  end;
  
  cmn.AddSubscriber( "get_cash", get_cash_inv );
  cmn.AddSubscriber( "get_cash", get_cash_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_torch () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_torch" ] = {
    type = "get",
    get_obj = "spr_livetree_torch",
    room = private.room_objname,
    zz = "zz_livetree",
    zz_gate = "gzz_deathtrap_livetree"
  };
    
  local get_torch_inv = function ()
  
    interface.InventoryItemAdd( "inv_torch", "spr_livetree_torch" );
    ObjSet( "inv_torch", { drag = false } );
  
  end;
  
  local get_torch_closezz = function ()
  
    ObjDelete( "gfx_livetree_torch" );
    ObjDelete( "spr_livetree_torch_shadow" );
    ObjDelete( "spr_deathtrap_livetree_torch" );

    if cmn.IsEventDone( "get_shopkey" ) and cmn.IsEventDone( "get_powersymbol_1" ) and cmn.IsEventDone( "get_cash" ) then
      ObjDelete( "gzz_deathtrap_livetree" );
    end;  
  
  end;
  
  cmn.AddSubscriber( "get_torch", get_torch_inv );
  cmn.AddSubscriber( "get_torch", get_torch_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_powersymbol_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_powersymbol_1" ] = {
    type = "get",
    get_obj = "spr_livetree_powersymbol_1",
    room = private.room_objname,
    zz = "zz_livetree",
    zz_gate = "gzz_deathtrap_livetree"
  };
    
  local get_powersymbol_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_powersymbol_1", "spr_livetree_powersymbol_1" );
  
  end;
  
  local get_powersymbol_1_closezz = function ()
  
    ObjDelete( "gfx_livetree_powersymbol_1" );
    ObjDelete( "spr_deathtrap_livetree_symbol" );

    if cmn.IsEventDone( "get_torch" ) and cmn.IsEventDone( "get_shopkey" ) and cmn.IsEventDone( "get_cash" ) then
      ObjDelete( "gzz_deathtrap_livetree" );
    end;  
  
  end;
  
  cmn.AddSubscriber( "get_powersymbol_1", get_powersymbol_1_inv );
  cmn.AddSubscriber( "get_powersymbol_1", get_powersymbol_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_powersymbol_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_powersymbol_3" ] = {
    type = "get",
    get_obj = "spr_merman_powersymbol_3",
    room = private.room_objname,
    zz = "zz_merman",
    zz_gate = "gzz_deathtrap_merman"
  };
    
  local get_powersymbol_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_powersymbol_3", "spr_merman_powersymbol_3" );
  
  end;
  
  local get_powersymbol_3_closezz = function ()
  
    ObjDelete( "gfx_merman_powersymbol_3" );
    ObjDelete( "gzz_deathtrap_merman" );
    ObjDelete( "spr_merman_powersymbol_3_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_powersymbol_3", get_powersymbol_3_inv );
  cmn.AddSubscriber( "get_powersymbol_3", get_powersymbol_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_hammer_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_hammer_4" ] = {
    type = "use",
    inv_obj = "inv_hammer_4",
    use_place = "obj_livetree_use_hammer_4",
    room = private.room_objname,
    zz = "zz_livetree",
    zz_gate = "gzz_deathtrap_livetree"
  };
  local use_hammer_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_hammer_4" );
  
  end;
  local use_hammer_4_beg = function ()
  
    ObjDelete( "obj_livetree_use_hammer_4" );
  
  end;
  local use_hammer_4_end = function ()
  
    ObjSet( "spr_livetree_shopkey", { input = true, active = true } );
    ObjSet( "gfx_livetree_shopkey", { active = true } );
    --ObjDelete( "anm_livetree_use_hammer" );
    ObjSet( "spr_livetree_shopkey", { pos_x = -62, pos_y = 93, ang = -0.52 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_hammer_4", use_hammer_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_4", use_hammer_4_inv );
  cmn.AddSubscriber( "use_hammer_4", use_hammer_4_end, private.room_objname );
  cmn.AddSubscriber( "use_hammer_4_inv", use_hammer_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_hammer_4_beg", use_hammer_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_hammer_4_end", use_hammer_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_nitrogentank () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_nitrogentank" ] = {
    type = "use",
    inv_obj = "inv_nitrogentank",
    use_place = "obj_livetree_use_nitrogentank",
    room = private.room_objname,
    zz = "zz_livetree",
    zz_gate = "gzz_deathtrap_livetree"
  };
  local use_nitrogentank_inv = function ()
  
    interface.InventoryItemRemove( "inv_nitrogentank" );
  
  end;
  local use_nitrogentank_beg = function ()
  
    ObjDelete( "obj_livetree_use_nitrogentank" );
  
  end;
  local use_nitrogentank_end = function ()
  
    ObjDelete( "spr_livetree_nitrogen" );

    ObjMultiSet({ 
      { "obj_livetree_torch", { input = true, active = true }},
      { "spr_livetree_powersymbol_1", { input = true, active = true }},
      { "obj_livetree_use_hammer_4", { input = true }},
      { "spr_livetree_man_ice", { alp = 1 }},
      { "anm_deathtrap_treeman", { active = false } },
      { "spr_livetree_shopkey", { alp = 0 } },
      { "anm_livetree_use_hammer", { alp = 1 } },
      { "spr_deathtrap_livetree_ice", { alp = 1 } }
    });

    ObjDelete( "anm_livetree_clk_static" );
    ObjDelete( "anm_livetree_static" );
    ObjDelete( "vid_livetree_use_nitrogentank" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_nitrogentank", use_nitrogentank_beg, private.room_objname );
  cmn.AddSubscriber( "use_nitrogentank", use_nitrogentank_inv );
  cmn.AddSubscriber( "use_nitrogentank", use_nitrogentank_end, private.room_objname );
  cmn.AddSubscriber( "use_nitrogentank_inv", use_nitrogentank_inv, private.room_objname );
  cmn.AddSubscriber( "use_nitrogentank_beg", use_nitrogentank_beg, private.room_objname );
  cmn.AddSubscriber( "use_nitrogentank_end", use_nitrogentank_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_owl_4_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_owl_4_4" ] = {
    type = "use",
    inv_obj = "inv_owl_4",
    use_place = "obj_tower_use_owl_4_4",
    room = private.room_objname,
    zz = "zz_tower",
    zz_gate = "gzz_deathtrap_tower"
  };
  local use_owl_4_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_owl_4" );
  
  end;
  local use_owl_4_4_beg = function ()
  
    ObjDelete( "obj_tower_use_owl_4_4" );
  
  end;
  local use_owl_4_4_end = function ()
  
    ObjSet( "spr_tower_powersymbol_2", { active = true, alp = 1, visible = true } );
    interface.InventoryItemAdd( "inv_powersymbol_2" );
    ObjDelete( "spr_deathtrap_tower_strength" );
    ObjDelete( "anm_tower_owl" );

  end; 
  local use_owl_4_4_merman = function ()
  
    ObjDelete( "spr_tower_powersymbol_2_shadow" );
    ObjDelete( "gzz_deathtrap_tower" );
    ObjSet( "gzz_deathtrap_merman", { input = true, active = true } );
    ObjDelete( "anm_deathtrap_bubles" );
    ObjSet( "anm_deathtrap_merman", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_owl_4_4", use_owl_4_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_owl_4_4", use_owl_4_4_inv );
  cmn.AddSubscriber( "use_owl_4_4", use_owl_4_4_end );
  cmn.AddSubscriber( "use_owl_4_4", use_owl_4_4_merman, private.room_objname );
  cmn.AddSubscriber( "use_owl_4_4_inv", use_owl_4_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_owl_4_4_beg", use_owl_4_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_owl_4_4_end", use_owl_4_4_end );
  cmn.AddSubscriber( "use_owl_4_4_merman", use_owl_4_4_merman, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_burningfire () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_burningfire" ] = {
    type = "use",
    inv_obj = "inv_burningfire",
    use_place = "obj_tower_use_burningfire",
    room = private.room_objname,
    zz = "zz_tower",
    zz_gate = "gzz_deathtrap_tower"
  };
  local use_burningfire_inv = function ()
  
    interface.InventoryItemRemove( "inv_burningfire" );
  
  end;

  local use_burningfire_beg = function ()

    ObjDelete( "tmr_tower_bat" );
    ObjDelete( "obj_tower_use_burningfire" );
  
  end;

  local use_burningfire_end = function ()

    ObjDelete( "obj_tower_bat" );
    ObjSet( "obj_tower_use_owl_4_4", { input = true } );
    ObjDelete("obj_tower_bat4");
    ObjDelete( "anm_tower_tower_fire" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_burningfire", use_burningfire_beg, private.room_objname );
  cmn.AddSubscriber( "use_burningfire", use_burningfire_inv );
  cmn.AddSubscriber( "use_burningfire", use_burningfire_end, private.room_objname );
  cmn.AddSubscriber( "use_burningfire_inv", use_burningfire_inv, private.room_objname );
  cmn.AddSubscriber( "use_burningfire_beg", use_burningfire_beg, private.room_objname );
  cmn.AddSubscriber( "use_burningfire_end", use_burningfire_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_net_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_net_4" ] = {
    type = "use",
    inv_obj = "inv_net_4",
    use_place = "obj_merman_use_net_4",
    room = private.room_objname,
    zz = "zz_merman",
    zz_gate = "gzz_deathtrap_merman"
  };
  local use_net_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_net_4" );
  
  end;
  local use_net_4_beg = function ()
  
    ObjDelete( "obj_merman_use_net_4" );
    ObjDelete( "anm_merman_static_2" );
  
  end;
  local use_net_4_end = function ()
  
    ObjSet( "spr_merman_powersymbol_3", { input = true } );
    ObjSet( "gfx_merman_powersymbol_3", { active = true } );
    ObjDelete( "anm_merman_net" );    
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_net_4", use_net_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_net_4", use_net_4_inv );
  cmn.AddSubscriber( "use_net_4", use_net_4_end, private.room_objname );
  cmn.AddSubscriber( "use_net_4_inv", use_net_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_net_4_beg", use_net_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_net_4_end", use_net_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_burningtorch_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_burningtorch_1" ] = {
    type = "use",
    inv_obj = "inv_burningtorch",
    use_place = "obj_merman_use_burningtorch",
    room = private.room_objname,
    zz = "zz_merman",
    zz_gate = "gzz_deathtrap_merman"
  };
  local use_burningtorch_1_inv = function ()
  
    if cmn.IsEventDone( "use_burningtorch_2" ) then
      interface.InventoryItemRemove( "inv_burningtorch" );
    end;  
  
  end;
  local use_burningtorch_1_beg = function ()
  
    ObjDelete( "obj_merman_use_burningtorch" );
  
  end;
  local use_burningtorch_1_end = function ()
  
    ObjSet( "obj_merman_use_net_4", { input = true, visible = true  } );    
    ObjSet( "anm_merman_static_2", { visible = true } );
    ObjDelete( "anm_merman_static" );    
    ObjDelete( "anm_deathtrap_merman" );
    ObjDelete( "vid_merman_torch" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_burningtorch_1", use_burningtorch_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_burningtorch_1", use_burningtorch_1_inv );
  cmn.AddSubscriber( "use_burningtorch_1", use_burningtorch_1_end, private.room_objname );
  cmn.AddSubscriber( "use_burningtorch_1_inv", use_burningtorch_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_burningtorch_1_beg", use_burningtorch_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_burningtorch_1_end", use_burningtorch_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_enhacnedmagiclantern () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_enhacnedmagiclantern" ] = {
    type = "use",
    inv_obj = "inv_enhacnedmagiclantern",
    use_place = "obj_deathtrap_use_enhacnedmagiclantern",
    room = private.room_objname,
  };
  local use_enhacnedmagiclantern_inv = function ()
  
    interface.InventoryItemRemove( "inv_enhacnedmagiclantern" );
  
  end;
  local use_enhacnedmagiclantern_beg = function ()
  
    ObjDelete( "obj_deathtrap_use_enhacnedmagiclantern" );
  
  end;
  local use_enhacnedmagiclantern_end = function ()
  
    ObjSet( "grm_deathtrap_forgottenbastille", { input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_deathtrap_forgottenbastille_focus");
    end;
    ObjDelete( "anm_deathtrap_fog_lantern" );
    ObjDelete( "anm_deathtrap_fog" );
    ObjDelete( "anm_deathtrap_fog_dissapear" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_enhacnedmagiclantern", use_enhacnedmagiclantern_beg, private.room_objname );
  cmn.AddSubscriber( "use_enhacnedmagiclantern", use_enhacnedmagiclantern_inv );
  cmn.AddSubscriber( "use_enhacnedmagiclantern", use_enhacnedmagiclantern_end, private.room_objname );
  cmn.AddSubscriber( "use_enhacnedmagiclantern_inv", use_enhacnedmagiclantern_inv, private.room_objname );
  cmn.AddSubscriber( "use_enhacnedmagiclantern_beg", use_enhacnedmagiclantern_beg, private.room_objname );
  cmn.AddSubscriber( "use_enhacnedmagiclantern_end", use_enhacnedmagiclantern_end, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function vid_deathtrap_showmerman () end;
  --------------------------------------------------------------------------------------------
  --common_impl.hint[ "vid_deathtrap_showmerman" ] = {
  --  type = "use",
  --  inv_obj = "inv_enhacnedmagiclantern",
  --  use_place = "obj_deathtrap_use_enhacnedmagiclantern",
  --  room = private.room_objname,
  --};
--  local vid_deathtrap_showmerman_beg = function ()
--  
--    --ObjDelete( "obj_deathtrap_use_enhacnedmagiclantern" );
--  
--  end;
--  local vid_deathtrap_showmerman_end = function ()
--  
--    ObjSet( "gzz_deathtrap_merman", { input = true, active = true, visible } );
--    ObjDelete( "anm_deathtrap_bubles" );
--    ObjSet( "anm_deathtrap_merman", { alp = 1 } );
--  
--  end;
--  --------------------------------------------------------------------------------------------
--  cmn.AddSubscriber( "vid_deathtrap_showmerman", vid_deathtrap_showmerman_beg, private.room_objname );
--  cmn.AddSubscriber( "vid_deathtrap_showmerman", vid_deathtrap_showmerman_end, private.room_objname );
--  cmn.AddSubscriber( "vid_deathtrap_showmerman_beg", vid_deathtrap_showmerman_beg, private.room_objname );
--  cmn.AddSubscriber( "vid_deathtrap_showmerman_end", vid_deathtrap_showmerman_end, private.room_objname );
--
end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_livetree" );
  
  function zz_livetree.PreOpen()

    ObjAnimate( "spr_livetree_light", "alp", 1, 0, "",
    { 
      0.0, 0, 1.0, 
      0.4, 0, 0.5,
      0.8, 0, 1.0
    } );

  end;

  subroom.Define( "zz_tower" );

  function zz_tower.Close()

    if cmn.IsEventDone( "use_owl_4_4" ) and not cmn.IsEventDone( "vid_deathtrap_showmerman" ) then

      --private.vid_deathtrap_showmerman();

    end;

    if not cmn.IsEventDone( "use_burningfire" ) then

      common_impl.StopAudio( "env", "common/audio/aud_bats_env", 0.2 );

    end;  


  end;

  function zz_tower.PreOpen()

    private.bat_fly();

    if not cmn.IsEventDone( "use_burningfire" ) then
    
      common_impl.PlayAudio( "env", "common/audio/aud_bats_env", 1, "", 0.5 );

    end;  

  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_deathtrap();
  
  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();
  --interface.InvestigationButtonCheck();

  common_impl.EnvPlay( { "common/audio/aud_deathtrap_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_hammer_4()

  local item = "inv_hammer_4";

  if ( common.ApplyObj( item, "obj_livetree_use_hammer_4", true ) and cmn.IsEventDone( "use_nitrogentank" ) ) then

    cmn.CallEventHandler( "use_hammer_4_inv" );
    cmn.CallEventHandler( "use_hammer_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_hammer_4" );
      cmn.CallEventHandler( "use_hammer_4_end" );
    --common.CloseSubRoom();;
    
    end;

    common_impl.Lock( true );
    ObjSet( "anm_livetree_use_hammer", { alp = 1 } );
    ObjSet( "spr_livetree_shopkey", { alp = 0 } );
    AnimPlay( "anm_livetree_use_hammer", "DoAnim", func_after );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_hammer_4", 0, "", 0 );
  
    return true;
  
  elseif ( common.ApplyObj( item, "gzz_deathtrap_livetree", false ) and cmn.IsEventDone( "use_nitrogentank" ) ) then
 
    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_livetree", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_nitrogentank()

  local item = "inv_nitrogentank";

  if ( common.ApplyObj( item, "obj_livetree_use_nitrogentank", true ) ) then

    cmn.CallEventHandler( "use_nitrogentank_inv" );
    cmn.CallEventHandler( "use_nitrogentank_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_nitrogentank" );
      cmn.CallEventHandler( "use_nitrogentank_end" );
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_nitrogentank", 0, "", 0 );
  
--    ObjAnimate( "spr_livetree_nitrogen", "pos_xy", 0, 0, func_after,
--    { 
--      0.0, 0, -309, 133, 
--      0.5, 0, -115, 82,
--      0.8, 0, -115, 82,
--      1.3, 0, -309, 133
--    } );
--  
--    ObjAnimate( "spr_livetree_man_ice", "alp", 0, 0, "",
--    { 
--      0.0, 0, 0, 
--      0.5, 0, 0,
--      0.8, 0, 1
--    } );
--
--    ObjAnimate( "anm_livetree_use_hammer", "alp", 0, 0, "",
--    { 
--      0.0, 0, 0, 
--      0.5, 0, 0,
--      0.8, 0, 1
--    } );
--
--    ObjAnimate( "spr_livetree_shopkey", "alp", 0, 0, "",
--    { 
--      0.0, 0, 1, 
--      0.5, 0, 1,
--      0.8, 0, 0
--    } );

    ObjAnimate( "anm_livetree_static", "alp", 0, 0, "",
    { 
      0.0, 0, 1, 
      0.3, 0, 0,
    } );
    ObjAnimate( "anm_livetree_use_hammer", "alp", 0, 0, "",
    { 
      0.0, 0, 0,
      2.7, 0, 0,
      3.2, 0, 1,
    } );


    ObjSet( "anm_livetree_static", { alp = 0 } );
    ObjSet( "vid_livetree_use_nitrogentank", { alp = 1 } );
    VidPlay( "vid_livetree_use_nitrogentank", func_after );


    return true;
  
  elseif common.ApplyObj( item, "gzz_deathtrap_livetree", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_livetree", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function private.vid_deathtrap_showmerman()

  ObjSet( "vid_deathtrap_showmerman", { alp = 1, active = true, input = false, visible = true } );

  local widget_settings = {}

  if IsCollectorsEdition() then

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnGuide,
      InterfaceWidget_BtnMenu
    }

  else

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnMenu
    }

  end;
  
  local func_after = function ( skip )

    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_deathtrap_showmerman_loc", 0.2 );
      
    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment2_mus", 0, "", 0 );

    interface.DialogVideoHide();
    cmn.SetEventDone( "use_owl_4_4" );
    cmn.CallEventHandler( "use_owl_4_4_merman" );

    common_impl.ShowBbt( 'bbt_deathtrap_after_showmerman', 1 );

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

  end;

  for i = 1, #widget_settings do

    interface.WidgetSetVisible( widget_settings[i], 0 );

  end;

  common_impl.StopAllMus();
  interface.DialogVideoShow( "vid_deathtrap_showmerman", 1, function() func_after( 'skip' ); end, 3 );
  common_impl.PlayAudio( "sfx", "common/audio/aud_deathtrap_showmerman_loc", 0, "", 0.5 );
  VidPlay( "vid_deathtrap_showmerman", function() func_after( nil ) end );

end;
--*********************************************************************************************************************
function public.use_owl_4_4()

  local item = "inv_owl_4";

  if ( common.ApplyObj( item, "obj_tower_use_owl_4_4", true ) and cmn.IsEventDone( "use_burningfire" ) ) then

    cmn.CallEventHandler( "use_owl_4_4_inv" );
    cmn.CallEventHandler( "use_owl_4_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_owl_4_4" );
      cmn.CallEventHandler( "use_owl_4_4_end" );
      common.CloseSubRoom();
      private.vid_deathtrap_showmerman();
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_owl_4_4", 0, "", 0 );    
    ObjSet( "anm_tower_owl", { playing = true, alp = 1, endtrig = func_after } );
    ObjSet( "tmr_tower_owl", { active = true, playing = true,  time = 1.0, endtrig = function ()   ObjSet( "anm_tower_sign", { alp = 0 } )   end  });

    return true;
  
  elseif ( common.ApplyObj( item, "gzz_deathtrap_tower", false ) and cmn.IsEventDone( "use_burningfire" ) ) then

    --interface.ObjDoNotDrop( item );

    cmn.GotoSubRoom( "zz_tower", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_burningfire()

  local item = "inv_burningfire";

  if ( common.ApplyObj( item, "obj_tower_use_burningfire", true ) ) then

    cmn.CallEventHandler( "use_burningfire_inv" );
    cmn.CallEventHandler( "use_burningfire_beg" );

    local func_after = function ()

        cmn.SetEventDone( "use_burningfire" );
        cmn.CallEventHandler( "use_burningfire_end" );
        common_impl.Lock( false );       

    end;

    common_impl.Lock( true );

    common_impl.StopAudio( "env", "common/audio/aud_bats_env", 0.2 );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_burningfire", 0, "", 0 );

    ObjAnimate( "obj_tower_bat", "alp", 0, 0, "",
    { 

      0.0, 0, 1.0, 
      0.3, 0, 0.0,

    } );
    
    ObjSet( "anm_tower_tower_fire", { playing = true, alp = 1, endtrig = func_after } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_deathtrap_tower", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tower", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_net_4()

  local item = "inv_net_4";

  if ( common.ApplyObj( item, "obj_merman_use_net_4", true ) and cmn.IsEventDone( "use_burningtorch_1" ) ) then

    cmn.CallEventHandler( "use_net_4_inv" );
    cmn.CallEventHandler( "use_net_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_net_4" );
      cmn.CallEventHandler( "use_net_4_end" );
      ObjSet( "obj_merman_powersymbol_3", { visible = true } );
      private.get_powersymbol_3();

    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_net_4", 0, "", 0 );
    
    ObjSet( "anm_merman_net", { visible = true } );
    AnimPlay( "anm_merman_net", "DoAnim", func_after );
    
  
    return true;
  
  elseif ( common.ApplyObj( item, "gzz_deathtrap_merman", false ) and cmn.IsEventDone( "use_burningtorch_1" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_merman", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_burningtorch_1()

  local item = "inv_burningtorch";

  if ( common.ApplyObj( item, "obj_merman_use_burningtorch", true ) and cmn.IsEventDone( "use_owl_4_4" ) ) then

    cmn.CallEventHandler( "use_burningtorch_1_inv" );
    cmn.CallEventHandler( "use_burningtorch_1_beg" );

    local func_after = function ()

      local func_end = function ()
    
        common_impl.Lock( false );
        cmn.SetEventDone( "use_burningtorch_1" );
        cmn.CallEventHandler( "use_burningtorch_1_end" );
      
      end;

      ObjAnimate( "vid_merman_torch", "alp", 0, 0, func_end,
      { 
        0.0, 0, 1,       
        0.2, 0, 0
      } );

    end;

    local func_torch = function()

      common_impl.Lock( true );
      ObjSet( "vid_merman_torch", { visible = true } );    
      ObjAnimate( "anm_merman_static", "alp", 0, 0, "",
      { 
        0.0, 0, 1, 
        0.2, 0, 0
      } );
      ObjSet( "anm_merman_static_2", { visible = true } );
      ObjAnimate( "anm_merman_static_2", "alp", 0, 0, "",
      { 
        0.0, 0, 0,       
        0.2, 0, 1
      } );
      ObjAnimate( "vid_merman_torch", "alp", 0, 0, function() VidPlay( "vid_merman_torch", func_after ); end,
      { 
        0.0, 0, 0, 
        0.2, 0, 1
      } );
      --common_impl.PlayAudio( "sfx", "common/audio/aud_use_burningtorch_1", 0, "", 0 );

    end;

    if ( ObjGet( "anm_merman_frog" ) ) then

      private.ClkFrog( func_torch );

    else

      func_torch();
    
    end;
  
    return true;
  
  elseif ( common.ApplyObj( item, "gzz_deathtrap_merman", false ) and cmn.IsEventDone( "use_owl_4_4" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_merman", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_enhacnedmagiclantern()

  local item = "inv_enhacnedmagiclantern";

  if ( common.ApplyObj( item, "obj_deathtrap_use_enhacnedmagiclantern" ) ) then

    cmn.CallEventHandler( "use_enhacnedmagiclantern_inv" );
    cmn.CallEventHandler( "use_enhacnedmagiclantern_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_enhacnedmagiclantern" );
      cmn.CallEventHandler( "use_enhacnedmagiclantern_end" );
    
    end;

    common_impl.Lock( true );  
  
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_magiclantern_1", 0, "", 0 );
  
    ObjSet( "anm_deathtrap_fog_lantern", { visible = true } );    
    ObjSet( "anm_deathtrap_fog_dissapear", { visible = true } );    
    ObjAnimate( "anm_deathtrap_fog", "alp", 0, 0, "",
    { 
      0.0, 0, 1, 
      1.7, 0, 1,
      2.0, 0, 0
    } );
    AnimPlay( "anm_deathtrap_fog_lantern", "DoAnim", "" );
    AnimPlay( "anm_deathtrap_fog_dissapear", "DoAnim", func_after );
    return true;
  
  else

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_shopkey()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );

  ObjSet( "spr_livetree_shopkey", { alp = 1 } );

  cmn.SetEventDone( "get_shopkey" );
  cmn.CallEventHandler( "get_shopkey" );

  if cmn.IsEventDone( "get_torch" ) and cmn.IsEventDone( "get_powersymbol_1" ) then
    common.CloseSubRoom();
  end;  

end;
--------------------------------------------------------------------------------------------
function private.get_cash()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_cash" );
  cmn.CallEventHandler( "get_cash" );

end;
--------------------------------------------------------------------------------------------
function private.get_torch()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_torch" );
  cmn.CallEventHandler( "get_torch" );

  if cmn.IsEventDone( "get_shopkey" ) and cmn.IsEventDone( "get_powersymbol_1" ) then
    common.CloseSubRoom();
  end;  

end;
--------------------------------------------------------------------------------------------
function private.get_powersymbol_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_powersymbol_1" );
  cmn.CallEventHandler( "get_powersymbol_1" );

  if cmn.IsEventDone( "get_torch" ) and cmn.IsEventDone( "get_shopkey" ) then
    common.CloseSubRoom();
  end;  

end;
--------------------------------------------------------------------------------------------
function private.get_powersymbol_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_powersymbol_3" );
  cmn.CallEventHandler( "get_powersymbol_3" );

  common.CloseSubRoom();

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.ClkFrog ( func_end )

  local func_after = function ()

    common_impl.Lock( false );
    ObjDelete( "anm_merman_frog_clk" );
    if ( func_end ) then
      func_end();
    end;

  end;
  common_impl.Lock( true );
  ObjDelete( "obj_merman_clk_frog" );
  ObjDelete( "anm_merman_frog" );  
  ObjSet( "anm_merman_frog_clk", { visible = true } );
  AnimPlay( "anm_merman_frog_clk", "DoAnim", func_after );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_frog_4", 0, "", 0 );

end;
--*********************************************************************************************************************
function private.clk_livetree ()

  local func_after = function ()

    common_impl.Lock( false );
    ObjSet( "anm_livetree_clk_static", { alp = 0 } );
    ObjSet( "anm_livetree_static", { alp = 1 } );
    common_impl.ShowBbt( 'bbt_livetree_use_nitrogentank' );

  end;
  
  ObjSet( "anm_livetree_clk_static", { alp = 1 } );
  ObjSet( "anm_livetree_static", { alp = 0 } );

  AnimPlay( "anm_livetree_clk_static", "DoAnim", func_after );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_treeman", 0, "", 0 );
  common_impl.Lock( true );

end;
--*********************************************************************************************************************
function private.opn_deathtrap()

  if not ( cmn.IsEventDone( "opn_deathtrap" ) ) then
    cmn.SetEventDone( "opn_deathtrap" );
  end;
  
  cmn.CallEventHandler( "opn_deathtrap" ); 

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** AnimBat *** () end;
--*********************************************************************************************************************
function private.bat_fly()

  if not cmn.IsEventDone( "use_burningfire" ) then

    local time = 1.5 + math.random( 1,10 )/10;

    local num_anim_1 = math.random( 1,6 );
    local num_anim_2 = math.random( 1,6 );

    if (( num_anim_1 == num_anim_2 ) or ( num_anim_2 == 1 ) ) then -- SS чтобы реже летали №1 и обе разные.

      private.bat_fly();

    else

      ObjSet( "tmr_tower_bat", {  playing = true, time = time, endtrig = function () private.bat_fly() end });   
      
      AnimPlay( "anm_tower_bat_"..num_anim_1, "DoAnim", "" );
      AnimPlay( "anm_tower_bat_"..num_anim_2, "DoAnim", "" );

    end;


  end;

end;
--*********************************************************************************************************************
ObjAnimate( "spr_tower_light", "alp", 1, 0, "", 

  { 
    0.0, 3, 1.0, 
    3.3, 3, 0.2, 
    6.0, 3, 1.0, 
    9.0, 3, 0.0, 
    12.1, 3, 0.6, 
    13.2, 3, 0.0, 
    14.3, 3, 0.1, 
    15.4, 3, 1.0, 

  });
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************
--*********************************************************************************************************************