-- name=rm_forgottenbastille
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_forgottenbastille";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_cannon", "room_hub" );
  ObjAttach( "zz_supplies", "room_hub" );
  ObjAttach( "zz_tent_4", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_cannon_silverbullet", { event_mdown = private.get_silverbullet }},
    { "spr_cannon_silverblade", { event_mdown = private.get_silverblade }},
    { "spr_supplies_cannonball", { event_mdown = private.get_cannonball }},
    { "spr_supplies_cover", { event_mdown = private.get_cover }},
    { "spr_supplies_armysymbol", { event_mdown = private.get_armysymbol }},
    { "obj_supplies_use_scrap", { event_mdown = private.clk_cover }},
    { "obj_tent_use_armysymbol", { event_mdown = private.clk_gate }},
    { "obj_tent_4_clk_tent", { event_mdown = private.clk_tent }},
    { "obj_vid_forgottenbastille_powerdarkness", { event_mdown = private.vid_forgottenbastille_powerdarkness } },
    { "obj_vid_forgottenbastille_powerdarkness_focus", { event_mdown = private.vid_forgottenbastille_powerdarkness } },
    { "spr_supplies_coin",        { event_mdown = private.get_collect_coin_41 }},
    { "spr_forgottenbastille_collect_item",    { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_4_3" );     end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_forgottenbastille_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_4_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },

  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_forgottenbastille = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_forgottenbastille_tent",
    "gzz_forgottenbastille_supplies",
    "gzz_forgottenbastille_cannon",
    "gho_forgottenbastille_intent"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_cannon",
      "zz_supplies",
      "zz_tent_4"
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_forgottenbastille", update_game_mode_forgottenbastille, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_forgottenbastille = function ()

  local effects_table = 
  {
    "anm_forgottenbastille_fog",
    "anm_forgottenbastille_foreground",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_forgottenbastille", update_performance_mode_forgottenbastille, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_forgottenbastille () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_forgottenbastille" ] = {
    type = "click",
    use_place = "grm_deathtrap_forgottenbastille",
    room = "rm_deathtrap"
  };

  local opn_forgottenbastille_map = function ()

    common_impl.VisitMapRoom( "forgottenbastille" );

  end;
  cmn.AddSubscriber( "opn_forgottenbastille", opn_forgottenbastille_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_4_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_4_3 = function ()
  
    ObjDelete( "obj_forgottenbastille_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_4_3", get_collect_item_4_3, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4_3 = function ()
  
    ObjDelete( "obj_forgottenbastille_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_4_3", get_collect_morph_item_4_3, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_silverbullet () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_silverbullet" ] = {
    type = "get",
    get_obj = "spr_cannon_silverbullet",
    room = private.room_objname,
    zz = "zz_cannon",
    zz_gate = "gzz_forgottenbastille_cannon"
  };
    
  local get_silverbullet_inv = function ()
  
    interface.InventoryItemAdd( "inv_silverbullet", "spr_cannon_silverbullet" );
  
  end;
  
  local get_silverbullet_closezz = function ()
  
    ObjDelete( "gfx_cannon_silverbullet" );
    ObjDelete( "spr_cannon_silverbullet_shadow" );
  
    if cmn.IsEventDone( "get_silverblade" ) and cmn.IsEventDone( "use_burningtorch_2" ) then
  
      ObjDelete( "gzz_forgottenbastille_cannon" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_silverbullet", get_silverbullet_inv );
  cmn.AddSubscriber( "get_silverbullet", get_silverbullet_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_silverblade () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_silverblade" ] = {
    type = "get",
    get_obj = "spr_cannon_silverblade",
    room = private.room_objname,
    zz = "zz_cannon",
    zz_gate = "gzz_forgottenbastille_cannon"
  };
    
  local get_silverblade_inv = function ()
  
    interface.InventoryItemAdd( "inv_silverblade", "spr_cannon_silverblade" );
  
  end;
  
  local get_silverblade_closezz = function ()
  
    ObjDelete( "gfx_cannon_silverblade" );
    ObjDelete( "spr_cannon_silverblade_shadow" );
    ObjDelete( "spr_cannon_silverblade_over" );

    if cmn.IsEventDone( "get_silverbullet" ) and cmn.IsEventDone( "use_burningtorch_2" ) then
  
      ObjDelete( "gzz_forgottenbastille_cannon" );

    end;

  end;
  
  cmn.AddSubscriber( "get_silverblade", get_silverblade_inv );
  cmn.AddSubscriber( "get_silverblade", get_silverblade_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cannonball () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cannonball" ] = {
    type = "get",
    get_obj = "spr_supplies_cannonball",
    room = private.room_objname,
    zz = "zz_supplies",
    zz_gate = "gzz_forgottenbastille_supplies"
  };
    
  local get_cannonball_inv = function ()
  
    interface.InventoryItemAdd( "inv_cannonball", "spr_supplies_cannonball" );
  
  end;
  
  local get_cannonball_closezz = function ()
  
    ObjDelete( "gfx_supplies_cannonball" );
    ObjDelete( "spr_supplies_cannonball_shadow" );

    if cmn.IsEventDone( "get_cover" ) and cmn.IsEventDone( "get_armysymbol" ) and common_impl.IsGetCoin( "get_coin_41" )  then
      ObjDelete( "gzz_forgottenbastille_supplies" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_cannonball", get_cannonball_inv );
  cmn.AddSubscriber( "get_cannonball", get_cannonball_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_cover () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_cover" ] = {
    type = "get",
    get_obj = "spr_supplies_cover",
    room = private.room_objname,
    zz = "zz_supplies",
    zz_gate = "gzz_forgottenbastille_supplies"
  };
    
  local get_cover_inv = function ()
  
    interface.InventoryItemAdd( "inv_cover", "spr_supplies_cover" );
  
  end;
  
  local get_cover_closezz = function ()
  
    ObjDelete( "gfx_supplies_cover" );
    ObjDelete( "spr_supplies_cover_shadow" );

    if cmn.IsEventDone( "get_cannonball" ) and cmn.IsEventDone( "get_armysymbol" ) and common_impl.IsGetCoin( "get_coin_41" ) then
      ObjDelete( "gzz_forgottenbastille_supplies" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_cover", get_cover_inv );
  cmn.AddSubscriber( "get_cover", get_cover_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_armysymbol () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_armysymbol" ] = {
    type = "get",
    get_obj = "spr_supplies_armysymbol",
    room = private.room_objname,
    zz = "zz_supplies",
    zz_gate = "gzz_forgottenbastille_supplies"
  };
    
  local get_armysymbol_inv = function ()
  
    interface.InventoryItemAdd( "inv_armysymbol", "spr_supplies_armysymbol" );
  
  end;
  
  local get_armysymbol_closezz = function ()
  
    ObjDelete( "gfx_supplies_armysymbol" );
    ObjDelete( "spr_supplies_armysymbol_shadow" );

    if cmn.IsEventDone( "get_cannonball" ) and cmn.IsEventDone( "get_cover" ) and common_impl.IsGetCoin( "get_coin_41" ) then
      ObjDelete( "gzz_forgottenbastille_supplies" );
    end;

  end;
  
  cmn.AddSubscriber( "get_armysymbol", get_armysymbol_inv );
  cmn.AddSubscriber( "get_armysymbol", get_armysymbol_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_41 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_41 = function ()
 
    ObjDelete( "obj_supplies_coin" );

    if cmn.IsEventDone( "get_cannonball" ) and cmn.IsEventDone( "get_cover" ) and cmn.IsEventDone( "get_armysymbol" ) then

      ObjDelete( "gzz_forgottenbastille_supplies" );

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_41", get_collect_coin_41, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_burningtorch_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_burningtorch_2" ] = {
    type = "use",
    inv_obj = "inv_burningtorch",
    use_place = "obj_cannon_use_burningtorch_2",
    room = private.room_objname,
    zz = "zz_cannon",
    zz_gate = "gzz_forgottenbastille_cannon"
  };
  local use_burningtorch_2_inv = function ()
  
    if cmn.IsEventDone( "use_burningtorch_1" ) then
      interface.InventoryItemRemove( "inv_burningtorch" );
    end;  

  end;
  local use_burningtorch_2_beg = function ()
  
    ObjDelete( "obj_cannon_use_burningtorch_2" );
  
  end;
  local use_burningtorch_2_end = function ()

    if cmn.IsEventDone( "get_silverblade" ) and cmn.IsEventDone( "get_silverbullet" ) then
  
      ObjDelete( "gzz_forgottenbastille_cannon" );

    end;

    ObjSet( "grm_forgottenbastille_swampmasterdwelling", { input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_forgottenbastille_swampmasterdwelling_focus");
    end;
    ObjSet( "spr_forgottenbastille_open_gate", { visible = true } );
    ObjSet( "spr_cannon_fire_add", { alp = 1 } );
    ObjSet( "spr_cannon_wick_add", { alp = 1 } );
    ObjDelete( "spr_cannon_torch" );    
    ObjDelete( "anm_forgottenbastille_cannon_core" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_burningtorch_2", use_burningtorch_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_burningtorch_2", use_burningtorch_2_inv );
  cmn.AddSubscriber( "use_burningtorch_2", use_burningtorch_2_end, private.room_objname );
  cmn.AddSubscriber( "use_burningtorch_2_inv", use_burningtorch_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_burningtorch_2_beg", use_burningtorch_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_burningtorch_2_end", use_burningtorch_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bucketgunpowder () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bucketgunpowder" ] = {
    type = "use",
    inv_obj = "inv_bucketgunpowder",
    use_place = "obj_cannon_use_bucketgunpowder",
    room = private.room_objname,
    zz = "zz_cannon",
    zz_gate = "gzz_forgottenbastille_cannon"
  };
  local use_bucketgunpowder_inv = function ()
  
    interface.InventoryItemRemove( "inv_bucketgunpowder" );
  
  end;
  local use_bucketgunpowder_beg = function ()
  
    ObjDelete( "obj_cannon_use_bucketgunpowder" );
  
  end;
  local use_bucketgunpowder_end = function ()
  
    ObjSet( "obj_cannon_use_wick", { input = true } );
    ObjDelete( "anm_cannon_use_bucket" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bucketgunpowder", use_bucketgunpowder_beg, private.room_objname );
  cmn.AddSubscriber( "use_bucketgunpowder", use_bucketgunpowder_inv );
  cmn.AddSubscriber( "use_bucketgunpowder", use_bucketgunpowder_end, private.room_objname );
  cmn.AddSubscriber( "use_bucketgunpowder_inv", use_bucketgunpowder_inv, private.room_objname );
  cmn.AddSubscriber( "use_bucketgunpowder_beg", use_bucketgunpowder_beg, private.room_objname );
  cmn.AddSubscriber( "use_bucketgunpowder_end", use_bucketgunpowder_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wick () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wick" ] = {
    type = "use",
    inv_obj = "inv_wick",
    use_place = "obj_cannon_use_wick",
    room = private.room_objname,
    zz = "zz_cannon",
    zz_gate = "gzz_forgottenbastille_cannon"
  };
  local use_wick_inv = function ()
  
    interface.InventoryItemRemove( "inv_wick" );
  
  end;
  local use_wick_beg = function ()
  
    ObjDelete( "obj_cannon_use_wick" );
  
  end;
  local use_wick_end = function ()
  
    ObjSet( "spr_cannon_wick", { alp = 1 } );

    if ( cmn.IsEventDone("use_cannonball") ) then
      ObjSet( "obj_cannon_use_burningtorch_2", { input = true } );
    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wick", use_wick_beg, private.room_objname );
  cmn.AddSubscriber( "use_wick", use_wick_inv );
  cmn.AddSubscriber( "use_wick", use_wick_end, private.room_objname );
  cmn.AddSubscriber( "use_wick_inv", use_wick_inv, private.room_objname );
  cmn.AddSubscriber( "use_wick_beg", use_wick_beg, private.room_objname );
  cmn.AddSubscriber( "use_wick_end", use_wick_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_cannonball () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_cannonball" ] = {
    type = "use",
    inv_obj = "inv_cannonball",
    use_place = "obj_cannon_use_cannonball",
    room = private.room_objname,
    zz = "zz_cannon",
    zz_gate = "gzz_forgottenbastille_cannon"
  };
  local use_cannonball_inv = function ()
  
    interface.InventoryItemRemove( "inv_cannonball" );
  
  end;
  local use_cannonball_beg = function ()
  
    ObjDelete( "obj_cannon_use_cannonball" );
  
  end;
  local use_cannonball_end = function ()
  
    ObjDelete( "spr_cannon_core" );
    ObjDelete( "spr_cannon_core_shadow" );

    if ( cmn.IsEventDone("use_wick") ) then

      ObjSet( "obj_cannon_use_burningtorch_2", { input = true } );

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_cannonball", use_cannonball_beg, private.room_objname );
  cmn.AddSubscriber( "use_cannonball", use_cannonball_inv );
  cmn.AddSubscriber( "use_cannonball", use_cannonball_end, private.room_objname );
  cmn.AddSubscriber( "use_cannonball_inv", use_cannonball_inv, private.room_objname );
  cmn.AddSubscriber( "use_cannonball_beg", use_cannonball_beg, private.room_objname );
  cmn.AddSubscriber( "use_cannonball_end", use_cannonball_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_scrap () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_scrap" ] = {
    type = "use",
    inv_obj = "inv_scrap",
    use_place = "obj_supplies_use_scrap",
    room = private.room_objname,
    zz = "zz_supplies",
    zz_gate = "gzz_forgottenbastille_supplies"
  };
  local use_scrap_inv = function ()
  
    interface.InventoryItemRemove( "inv_scrap" );
  
  end;
  local use_scrap_beg = function ()
  
    ObjDelete( "obj_supplies_use_scrap" );
  
  end;
  local use_scrap_end = function ()

    ObjDelete( "anm_supplies_cover" );

    ObjMultiSet({ 
      { "spr_supplies_armysymbol",     { input = true     }},
      { "gfx_supplies_armysymbol",     { active = true    }},
      { "spr_supplies_cannonball",     { input = true     }},
      { "gfx_supplies_cannonball",     { active = true    }},
      { "spr_supplies_cover",     { input = true     }},
      { "gfx_supplies_cover",     { active = true    }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_scrap", use_scrap_beg, private.room_objname );
  cmn.AddSubscriber( "use_scrap", use_scrap_inv );
  cmn.AddSubscriber( "use_scrap", use_scrap_end, private.room_objname );
  cmn.AddSubscriber( "use_scrap_inv", use_scrap_inv, private.room_objname );
  cmn.AddSubscriber( "use_scrap_beg", use_scrap_beg, private.room_objname );
  cmn.AddSubscriber( "use_scrap_end", use_scrap_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_armysymbol () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_armysymbol" ] = {
    type = "use",
    inv_obj = "inv_armysymbol",
    use_place = "obj_tent_use_armysymbol",
    room = private.room_objname,
    zz = "zz_tent_4",
    zz_gate = "gzz_forgottenbastille_tent"
  };
  local use_armysymbol_inv = function ()
  
    interface.InventoryItemRemove( "inv_armysymbol" );
  
  end;
  local use_armysymbol_beg = function ()
  
    ObjDelete( "obj_tent_use_armysymbol" );
  
  end;
  local use_armysymbol_end = function ()

    ObjSet( "obj_tent_4_clk_tent", { input = true } );
    ObjDelete( "anm_tent_4_amuletkey" );
    ObjDelete( "spr_forgottenbastille_tent_4_cage" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_armysymbol", use_armysymbol_beg, private.room_objname );
  cmn.AddSubscriber( "use_armysymbol", use_armysymbol_inv );
  cmn.AddSubscriber( "use_armysymbol", use_armysymbol_end, private.room_objname );
  cmn.AddSubscriber( "use_armysymbol_inv", use_armysymbol_inv, private.room_objname );
  cmn.AddSubscriber( "use_armysymbol_beg", use_armysymbol_beg, private.room_objname );
  cmn.AddSubscriber( "use_armysymbol_end", use_armysymbol_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_tent () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_tent" ] = {
    type = "click",
    use_place = "obj_tent_4_clk_tent",
    room = private.room_objname,
    zz = "zz_tent_4",
    zz_gate = "gzz_forgottenbastille_tent"
  };
  local clk_tent = function ()
  
    ObjDelete( "gzz_forgottenbastille_tent" );
    ObjSet( "gho_forgottenbastille_intent", { input = true, active = true } );
    ObjSet( "spr_forgottenbastille_tent_4_tent", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_tent", clk_tent, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_forgottenbastille_powerdarkness () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_forgottenbastille_powerdarkness" ] = {

      type = "click",
      use_place = "obj_vid_forgottenbastille_powerdarkness",
      room = private.room_objname
  };
  local vid_forgottenbastille_powerdarkness_beg = function ()

    ObjDelete( "obj_vid_forgottenbastille_powerdarkness" );

  end;
  local vid_forgottenbastille_powerdarkness_end = function ()

    --

  end;

  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "vid_forgottenbastille_powerdarkness", vid_forgottenbastille_powerdarkness_beg, private.room_objname );
  cmn.AddSubscriber( "vid_forgottenbastille_powerdarkness", vid_forgottenbastille_powerdarkness_end, private.room_objname  );
  cmn.AddSubscriber( "vid_forgottenbastille_powerdarkness_beg", vid_forgottenbastille_powerdarkness_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_forgottenbastille_powerdarkness_end", vid_forgottenbastille_powerdarkness_end, private.room_objname  );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_forgottenbastille();
  
  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );
  
  if ( not cmn.IsEventDone( "vid_forgottenbastille_powerdarkness" ) ) then

    common_impl.PlayTimer( private.vid_forgottenbastille_powerdarkness );

  end;

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();
  common_impl.MorphItemMorphing();
  --interface.InvestigationButtonCheck();

  common_impl.EnvPlay( { "common/audio/aud_forgottenbastille_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_burningtorch_2()

  local item = "inv_burningtorch";

  if ( common.ApplyObj( item, "obj_cannon_use_burningtorch_2", true ) and cmn.IsEventDone( "use_cannonball" ) and cmn.IsEventDone( "use_wick" )) then

    cmn.CallEventHandler( "use_burningtorch_2_inv" );
    cmn.CallEventHandler( "use_burningtorch_2_beg" );

    local func_after = function ()
  
      local func_end = function()
        common_impl.Lock( false );
        cmn.SetEventDone( "use_burningtorch_2" );
        cmn.CallEventHandler( "use_burningtorch_2_end" );
        interface.KeyTaskDone( true );
        ObjSet( "anm_forgottenbastille_cannon", { visible = true } );
      end;
      local func_lock = function()

        common_impl.Lock( true )

      end;

      local func_sound_play = function()
    
        common_impl.PlayAudio( "sfx", "common/audio/aud_use_burningtorch_2_2", 0, "", 0 );
        AnimPlay( "anm_forgottenbastille_cannon_core", "DoAnim", func_end );
        ObjSet( "tmr_forgottenbastille_anim_sound", { playing = false  } );

      end;

      common.CloseSubRoom();
    
      ObjSet( "tmr_forgottenbastille_anim_sound", { playing = true, time = 0.2, endtrig = func_sound_play } );
      ObjSet( "tmr_forgottenbastille_cannon", { playing = true, time = 0.000001, endtrig = func_lock } );
      ObjSet( "anm_forgottenbastille_cannon", { visible = false } );
      ObjSet( "anm_forgottenbastille_cannon_core", { active = true, visible = true } );
      ObjSet( "spr_cannon_wick", { alp = 1 } );
      ObjSet( "anm_cannon_use_firetorch", { alp = 0 } );
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_burningtorch_2", 0, "", 0 );

    ObjSet( "anm_cannon_use_firetorch", { alp = 1 } );
    ObjSet( "spr_cannon_wick", { alp = 0 } );
    AnimPlay( "anm_cannon_use_firetorch", "DoAnim", func_after );


    return true;


  elseif ( common.ApplyObj( item, "obj_cannon_use_wick", true ) ) then

    common_impl.ShowBbt( 'bbt_cannon_use_burningtorch_wrong', 1 );

    return true;  


  elseif ( common.ApplyObj( item, "gzz_forgottenbastille_cannon", false ) and cmn.IsEventDone( "use_cannonball" ) and cmn.IsEventDone( "use_wick" )) then

    ----interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cannon", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bucketgunpowder()

  local item = "inv_bucketgunpowder";

  if ( common.ApplyObj( item, "obj_cannon_use_bucketgunpowder", true ) ) then

    cmn.CallEventHandler( "use_bucketgunpowder_inv" );
    cmn.CallEventHandler( "use_bucketgunpowder_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_bucketgunpowder" );
      cmn.CallEventHandler( "use_bucketgunpowder_end" );
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_cannon_powder", 0, "", 0 );
 
    AnimPlay( "anm_cannon_use_bucket", "DoAnim", func_after );

    return true;
  
  elseif common.ApplyObj( item, "gzz_forgottenbastille_cannon", false ) then

    ----interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cannon", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_wick()

  local item = "inv_wick";

  if ( common.ApplyObj( item, "obj_cannon_use_wick", true ) and cmn.IsEventDone( "use_bucketgunpowder" ) ) then

    cmn.CallEventHandler( "use_wick_inv" );
    cmn.CallEventHandler( "use_wick_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_wick" );
      cmn.CallEventHandler( "use_wick_end" );
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_cannon_fuse", 0, "", 0 );
  
    ObjAnimate( "spr_cannon_wick", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
    return true;
  
  elseif ( common.ApplyObj( item, "obj_cannon_use_bucketgunpowder", true ) ) then

    common_impl.ShowBbt( 'bbt_cannon_use_wick_wrong', 1 );

    return true;

  elseif ( common.ApplyObj( item, "obj_cannon_use_cannonball", true ) ) then

    common_impl.ShowBbt( 'bbt_cannon_use_wick_wrong', 1 );

    return true;  


  elseif ( common.ApplyObj( item, "gzz_forgottenbastille_cannon", false ) and cmn.IsEventDone( "use_bucketgunpowder" ) ) then

    ----interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cannon", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_cannonball()

  local item = "inv_cannonball";

  if ( common.ApplyObj( item, "obj_cannon_use_cannonball", true ) ) then

    cmn.CallEventHandler( "use_cannonball_inv" );
    cmn.CallEventHandler( "use_cannonball_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_cannonball" );
      cmn.CallEventHandler( "use_cannonball_end" );
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_cannon_kernel", 0, "", 0 );
  
    ObjAnimate( "spr_cannon_core", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
    ObjAnimate( "spr_cannon_core_shadow", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 0, 0.0
    } );

    ObjAnimate( "spr_cannon_core", "pos_xy", 0, 0, func_after,
    { 
      0.0, 0, 187, 59, 
      0.3, 0, 187, 59, 
      0.7, 0, 155, 45
    } );

    return true;
  
  elseif ( common.ApplyObj( item, "gzz_forgottenbastille_cannon", false ) ) then

    ----interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cannon", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_scrap()

  local item = "inv_scrap";

  if ( common.ApplyObj( item, "obj_supplies_use_scrap", true ) ) then

    cmn.CallEventHandler( "use_scrap_inv" );
    cmn.CallEventHandler( "use_scrap_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_scrap" );
      cmn.CallEventHandler( "use_scrap_end" );
    
    end;

    common_impl.Lock( true );
    --func_after();
  common_impl.PlayAudio( "sfx", "common/audio/aud_use_wick", 0, "", 0 );
  
    --ObjAnimate( "spr", "alp", 0, 0, func_after,
    --{ 
    --  0.0, 0, 0.0, 
    --  0.3, 0, 1.0
    --} );

    AnimPlay( "anm_supplies_cover", "DoAnim", func_after );

    return true;
  
  elseif common.ApplyObj( item, "gzz_forgottenbastille_supplies", false ) and cmn.IsEventDone( "vid_forgottenbastille_powerdarkness" ) then

    ----interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_supplies", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_armysymbol()

  local item = "inv_armysymbol";

  if ( common.ApplyObj( item, "obj_tent_use_armysymbol", true ) ) then

    cmn.CallEventHandler( "use_armysymbol_inv" );
    cmn.CallEventHandler( "use_armysymbol_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_armysymbol" );
      cmn.CallEventHandler( "use_armysymbol_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_armysymbol", 0, "", 0 );

    AnimPlay( "anm_tent_4_amuletkey", "DoAnim", func_after );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_forgottenbastille_tent", false ) then

    ----interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tent_4", nil, { 512, 384 } );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_silverbullet()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_silverbullet" );
  cmn.CallEventHandler( "get_silverbullet" );

  if cmn.IsEventDone( "get_silverblade" ) and cmn.IsEventDone( "use_burningtorch_2" ) then

     common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_silverblade()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_silverblade" );
  cmn.CallEventHandler( "get_silverblade" );

  if cmn.IsEventDone( "get_silverbullet" ) and cmn.IsEventDone( "use_burningtorch_2" ) then

     common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_cannonball()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_cannonball" );
  cmn.CallEventHandler( "get_cannonball" );

  if cmn.IsEventDone( "get_cover" ) and cmn.IsEventDone( "get_armysymbol" ) and common_impl.IsGetCoin( "get_coin_41" ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_cover()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_cover" );
  cmn.CallEventHandler( "get_cover" );

  if cmn.IsEventDone( "get_cannonball" ) and cmn.IsEventDone( "get_armysymbol" ) and common_impl.IsGetCoin( "get_coin_41" ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_armysymbol()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_armysymbol" );
  cmn.CallEventHandler( "get_armysymbol" );

  if cmn.IsEventDone( "get_cannonball" ) and cmn.IsEventDone( "get_cover" ) and common_impl.IsGetCoin( "get_coin_41" ) then
    common.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_cover()

  common_impl.Lock( true );

  local func_end = function ()

    common_impl.Lock( false );
    common_impl.ShowBbt( 'bbt_supplies_use_scrap' );

  end;

  local posx = ObjGet( "anm_supplies_cover" ).pos_x;
  local posy = ObjGet( "anm_supplies_cover" ).pos_y;
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_medium_wood", 0, "", 0 );

  ObjAnimate("anm_supplies_cover", "pos_xy", 0, 0, func_end, 
  {
    0.0, 0, posx, posy,
    0.2, 0, posx - 2, posy - 2,
    0.4, 0, posx, posy
  });

end;
function private.clk_gate()

  common_impl.Lock( true );

  local func_end = function ()

    common_impl.Lock( false );
    common_impl.ShowBbt( 'bbt_tent_use_armysymbol' );

  end;

  local posx = ObjGet( "anm_tent_4_amuletkey" ).pos_x;
  local posy = ObjGet( "anm_tent_4_amuletkey" ).pos_y;

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_small_metal", 0, "", 0 );

  ObjAnimate("anm_tent_4_amuletkey", "pos_xy", 0, 0, func_end, 
  {
    0.0, 0, posx, posy,
    0.2, 0, posx - 2, posy,
    0.4, 0, posx, posy
  });

end;
function private.clk_tent()

  local func_end = function ()

    cmn.SetEventDone( "clk_tent" );
    cmn.CallEventHandler( "clk_tent" );
    common.CloseSubRoom();

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_tent_click_tent", 0, "", 0 );

  ObjAnimate("spr_tent_4_outdoor_tent", "alp", 0, 0, func_end, 
  {
    0.0, 0, 0,
    0.3, 0, 1,
  });

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.get_collect_coin_41()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_41" );
    cmn.CallEventHandler( "get_coin_41" );

    if cmn.IsEventDone( "get_cannonball" ) and cmn.IsEventDone( "get_cover" ) and cmn.IsEventDone( "get_armysymbol" ) then

      common.CloseSubRoom();

    end;    

  end;

  common_impl.PlayEffectHO( "spr_supplies_coin", func_after ); 

end;
--*********************************************************************************************************************
function private.opn_forgottenbastille()

  if not ( cmn.IsEventDone( "opn_forgottenbastille" ) ) then
    cmn.SetEventDone( "opn_forgottenbastille" );
  end;
  
  cmn.CallEventHandler( "opn_forgottenbastille" ); 

end;
--*********************************************************************************************************************
function private.vid_forgottenbastille_powerdarkness()

  cmn.CallEventHandler( "vid_forgottenbastille_powerdarkness_beg" );
  ObjSet( "vid_forgottenbastille_powerdarkness", { alp = 1, active = true, input = false, visible = true } );

  local widget_settings = {}

  if IsCollectorsEdition() then

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnGuide,
      InterfaceWidget_BtnMenu
    }

  else

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnMenu
    }

  end;
  
  local func_after = function ( skip )

    if ( skip ) then 

      common_impl.StopAudio( "sfx", "common/audio/aud_forgottenbastille_powerdarkness", 0.2 );

    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment3_mus", 0, "", 0 );

    interface.DialogVideoHide();
    common_impl.AddPageDiary( 17 );
    cmn.SetEventDone( "vid_forgottenbastille_powerdarkness" );
    cmn.CallEventHandler( "vid_forgottenbastille_powerdarkness_end" );
    common_impl.ShowBbt( 'bbt_forgottenbastille_after_powerdarkness', 1 );

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

  end;

  for i = 1, #widget_settings do

    interface.WidgetSetVisible( widget_settings[i], 0 );

  end;
  common_impl.StopAllMus();
  interface.DialogVideoShow( "vid_forgottenbastille_powerdarkness", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_forgottenbastille_powerdarkness", function() func_after( nil ); end ); 
  SetSoundVolume( "group_aud_forgottenbastille_powerdarkness",  GetSoundVolume( "sfx" ) );
  SndPlay( "assets/levels/common/audio/aud_forgottenbastille_powerdarkness", "group_aud_forgottenbastille_powerdarkness", 0, 0, 0.5 );

end;
--*********************************************************************************************************************
