-- name=rm_fork_4
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_fork_4";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_bridge_4", "room_hub" );
  ObjAttach( "zz_motorcycle", "room_hub" );
  ObjAttach( "zz_tree_4", "room_hub" );
  ObjAttach( "zz_shore_4", "room_hub" );
  private.Init_Subroom();

  private.moto_start = { 1,2,3 };

  ObjMultiSet({ 
    { "spr_bridge_4_chip_4",              { event_mdown = private.get_chip_4 }},
    { "spr_motorcycle_blade",             { event_mdown = private.get_blade }},
    { "spr_motorcycle_salammoniacbottle", { event_mdown = private.get_salammoniacbottle }},
    { "spr_motorcycle_tweezerscotton",    { event_mdown = private.get_tweezerscotton }},
    { "spr_motorcycle_fuelbottle",        { event_mdown = private.get_fuelbottle }},
    { "obj_tree_4_get_owl",               { event_mdown = private.get_owl_4 }},
    { "spr_shore_4_armsaw",               { event_mdown = private.get_armsaw }},
    { "spr_shore_4_valve_4",              { event_mdown = private.get_valve_4 }},
    { "spr_shore_4_oar",                  { event_mdown = private.get_oar }},
    { "spr_fork_4_charmpiece_5",          { event_mdown = private.get_charmpiece_5 }},
    { "obj_shore_4_wierd_clk",            { event_mdown = private.clk_wiered }},
    { "obj_vid_fork_4_escape",            { event_mdown = private.vid_fork_4_escape } },
    { "obj_vid_fork_4_escape_focus",      { event_mdown = private.vid_fork_4_escape } },
    { "obj_vid_fork_4_tonightsville_4",   { event_mdown = private.vid_fork_4_tonightsville_4 } },
    { "obj_vid_fork_4_tonightsville_4_focus", { event_mdown = private.vid_fork_4_tonightsville_4 } },
    { "obj_dlg_fork_4_danger_4",          { event_mdown = private.dlg_fork_4_danger_4 } },
    { "obj_dlg_fork_4_danger_4_focus",    { event_mdown = private.dlg_fork_4_danger_4 } },
    { "obj_tree_4_use_blade",             { event_mdown = private.clk_owl_4 } },
    { "spr_motorcycle_coin",              { event_mdown = private.get_collect_coin_33 }},
    { "spr_shore_4_metal_note",           { event_mdown = function() common_impl.NoteScale( 'open', 'spr_shore_4_metal_note' ); common_impl.ShowBbt( 'bbt_shore_4_metal_note', 1 ); end } },
    { "spr_shore_4_metal_note_big",       { event_mdown = function() common_impl.NoteScale( 'close','spr_shore_4_metal_note' ); end } },
    { "obj_shore_4_use_wrench_4",         { event_mdown = private.BoatClk }},
    { "obj_motorcycle_use_workingbrace",         { event_mdown = private.clk_patch }},
    { "obj_motorcycle_use_unbentclip",         { event_mdown = private.clk_lock }},
    { "spr_fork_4_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_2" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "obj_motorcycle_mmg_clk_1", { event_mdown = function() private.clk_symbol( 1 ) end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "obj_motorcycle_mmg_clk_2", { event_mdown = function() private.clk_symbol( 2 ) end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "obj_motorcycle_mmg_clk_3", { event_mdown = function() private.clk_symbol( 3 ) end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "obj_bridge_4_use_armsaw",  { event_mdown = private.clk_dust } },
    { "obj_shore_4_use_owl_4_1",  { event_mdown = private.clk_use_owl } }
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_fork_4 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_fork_4_bridge_4",
    "gzz_fork_4_motorcycle",
    "gzz_fork_4_tree_4",
    "gzz_fork_4_shore_4"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_hut",
      "zz_storage",
      "zz_gates"
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_fork_4", update_game_mode_fork_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_fork_4 = function ()

  local effects_table = 
  {
    "obj_fork_4_anim",
    "vid_shore_4_water",
    "obj_shore_4_anim",
    "anm_fork_4_anims",
    "",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_fork_4", update_performance_mode_fork_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_fork_4 () end;
  --------------------------------------------------------------------------------------------
  local opn_fork_4_map = function ()

    common_impl.VisitMapRoom( "fork_4" );

  end;

  local opn_fork_4_end = function ()

  --

  end;

  cmn.AddSubscriber( "opn_fork_4", opn_fork_4_map, nil );
  cmn.AddSubscriber( "opn_fork_4_map", opn_fork_4_map, nil );
  cmn.AddSubscriber( "opn_fork_4", opn_fork_4_end, private.room_objname );
  cmn.AddSubscriber( "opn_fork_4_end", opn_fork_4_end, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function beg_levelext () end;
  --------------------------------------------------------------------------------------------
  local beg_levelext = function ()

    ObjSet( "obj_int_inventory_task", { alp = 0, input = false } );

  end;
  cmn.AddSubscriber( "beg_levelext", beg_levelext );  
  --------------------------------------------------------------------------------------------
  -- function get_chip_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chip_4" ] = {
    type = "get",
    get_obj = "spr_bridge_4_chip_4",
    room = private.room_objname,
    zz = "zz_bridge_4",
    zz_gate = "gzz_fork_4_bridge_4"
  };
    
  local get_chip_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_chip_4", "spr_bridge_4_chip_4" );
  
  end;
  
  local get_chip_4_closezz = function ()
  
    ObjDelete( "gfx_bridge_4_chip_4" );
    ObjDelete( "spr_bridge_4_chip_4_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_chip_4", get_chip_4_inv );
  cmn.AddSubscriber( "get_chip_4", get_chip_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_blade () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_blade" ] = {
    type = "get",
    get_obj = "spr_motorcycle_blade",
    room = private.room_objname,
    zz = "zz_motorcycle",
    zz_gate = "gzz_fork_4_motorcycle"
  };
    
  local get_blade_inv = function ()
  
    interface.InventoryItemAdd( "inv_blade", "spr_motorcycle_blade" );
  
  end;
  
  local get_blade_closezz = function ()
  
    ObjDelete( "gfx_motorcycle_blade" );
    ObjDelete( "spr_motorcycle_blade_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_blade", get_blade_inv );
  cmn.AddSubscriber( "get_blade", get_blade_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_salammoniacbottle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_salammoniacbottle" ] = {
    type = "get",
    get_obj = "spr_motorcycle_salammoniacbottle",
    room = private.room_objname,
    zz = "zz_motorcycle",
    zz_gate = "gzz_fork_4_motorcycle"
  };
    
  local get_salammoniacbottle_inv = function ()
  
    interface.InventoryItemAdd( "inv_salammoniacbottle", "spr_motorcycle_salammoniacbottle" );
    ObjSet( "inv_salammoniacbottle", { drag = false });
  
  end;
  
  local get_salammoniacbottle_closezz = function ()
  
    ObjDelete( "gfx_motorcycle_salammoniacbottle" );
    ObjDelete( "spr_motorcycle_salammoniacbottle_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_salammoniacbottle", get_salammoniacbottle_inv );
  cmn.AddSubscriber( "get_salammoniacbottle", get_salammoniacbottle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_tweezerscotton () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_tweezerscotton" ] = {
    type = "get",
    get_obj = "obj_motorcycle_tweezers",
    room = private.room_objname,
    zz = "zz_motorcycle",
    zz_gate = "gzz_fork_4_motorcycle"
  };
    
  local get_tweezerscotton_inv = function ()
  
    interface.InventoryItemAdd( "inv_tweezerscotton", "obj_motorcycle_tweezers" );
    ObjSet( "inv_tweezerscotton", { drag = false });
  
  end;
  
  local get_tweezerscotton_closezz = function ()
  
    ObjDelete( "gfx_motorcycle_tweezerscotton" );
    --ObjDelete( "gzz_fork_4_motorcycle" );
  
  end;
  
  cmn.AddSubscriber( "get_tweezerscotton", get_tweezerscotton_inv );
  cmn.AddSubscriber( "get_tweezerscotton", get_tweezerscotton_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_fuelbottle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_fuelbottle" ] = {
    type = "get",
    get_obj = "spr_motorcycle_fuelbottle",
    room = private.room_objname,
    zz = "zz_motorcycle",
    zz_gate = "gzz_fork_4_motorcycle"
  };
    
  local get_fuelbottle_inv = function ()
  
    interface.InventoryItemAdd( "inv_fuelbottle", "spr_motorcycle_fuelbottle" );
  
  end;
  
  local get_fuelbottle_closezz = function ()
  
    ObjDelete( "gfx_motorcycle_fuelbottle" );

    if ( common_impl.IsGetCoin( "get_coin_33" ) ) then

      ObjDelete( "gzz_fork_4_motorcycle" );

    end;

  end;
  
  cmn.AddSubscriber( "get_fuelbottle", get_fuelbottle_inv );
  cmn.AddSubscriber( "get_fuelbottle", get_fuelbottle_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_33 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_33 = function ()
 
    ObjDelete( "obj_motorcycle_coin" );

    if cmn.IsEventDone( "get_fuelbottle" ) then

      ObjDelete( "gzz_fork_4_motorcycle" );

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_33", get_collect_coin_33, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_2 = function ()
  
    ObjDelete( "obj_fork_4_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_2", get_collect_morph_item_1_2, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_owl_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_owl_4" ] = {
    type = "get",
    get_obj = "spr_tree_4_owl_4",
    room = private.room_objname,
    zz = "zz_tree_4",
    zz_gate = "gzz_fork_4_tree_4"
  };
    
  local get_owl_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_owl_4", "spr_tree_4_owl_4" );
  
  end;
  
  local get_owl_4_closezz = function ()
  
    ObjDelete( "gfx_tree_4_owl_4" );
    ObjDelete( "anm_tree_4_owl_free" );
    ObjDelete( "obj_tree_4_get_owl" );

    ObjDelete( "gzz_fork_4_tree_4" );
    ObjDelete( "spr_fork_4_tree_4_owl" );

  end;
  
  cmn.AddSubscriber( "get_owl_4", get_owl_4_inv );
  cmn.AddSubscriber( "get_owl_4", get_owl_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_armsaw () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_armsaw" ] = {
    type = "get",
    get_obj = "spr_shore_4_armsaw",
    room = private.room_objname,
    zz = "zz_shore_4",
    zz_gate = "gzz_fork_4_shore_4"
  };
    
  local get_armsaw_inv = function ()
  
    interface.InventoryItemAdd( "inv_armsaw", "spr_shore_4_armsaw" );
  
  end;
  
  local get_armsaw_closezz = function ()
  
    ObjDelete( "gfx_shore_4_armsaw" );
    ObjDelete( "spr_shore_4_saw_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_armsaw", get_armsaw_inv );
  cmn.AddSubscriber( "get_armsaw", get_armsaw_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_valve_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_valve_4" ] = {
    type = "get",
    get_obj = "spr_shore_4_valve_4",
    room = private.room_objname,
    zz = "zz_shore_4",
    zz_gate = "gzz_fork_4_shore_4"
  };
    
  local get_valve_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_valve_4", "spr_shore_4_valve_4" );
  
  end;
  
  local get_valve_4_closezz = function ()
  
    ObjDelete( "gfx_shore_4_valve_4" );

    if cmn.IsEventDone( "get_oar" ) then

      ObjDelete( "gzz_fork_4_shore_4" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_valve_4", get_valve_4_inv );
  cmn.AddSubscriber( "get_valve_4", get_valve_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_oar () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_oar" ] = {
    type = "get",
    get_obj = "spr_shore_4_oar",
    room = private.room_objname,
    zz = "zz_shore_4",
    zz_gate = "gzz_fork_4_shore_4"
  };
    
  local get_oar_inv = function ()
  
    interface.InventoryItemAdd( "inv_oar", "spr_shore_4_oar" );
  
  end;
  
  local get_oar_closezz = function ()
  
    ObjDelete( "gfx_shore_4_oar" );
    ObjDelete( "spr_shore_4_oar_shadow" );

    if cmn.IsEventDone( "get_valve_4" ) then

      ObjDelete( "gzz_fork_4_shore_4" );

    end;
  
  end;
  
  cmn.AddSubscriber( "get_oar", get_oar_inv );
  cmn.AddSubscriber( "get_oar", get_oar_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_charmpiece_5 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_charmpiece_5" ] = {
    type = "get",
    get_obj = "obj_fork_4_seeker_5",
    room = private.room_objname
  };
    
  local get_charmpiece_5_inv = function ()
  
    interface.InventoryItemAdd( "inv_charmpiece_5", "obj_fork_4_seeker_5" );
  
  end;
  
  local get_charmpiece_5_closezz = function ()
  
    ObjDelete( "gfx_fork_4_charmpiece_5" );
    ObjDelete( "spr_fork_4_charmpiece_5_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_charmpiece_5", get_charmpiece_5_inv );
  cmn.AddSubscriber( "get_charmpiece_5", get_charmpiece_5_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_armsaw () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_armsaw" ] = {
    type = "use",
    inv_obj = "inv_armsaw",
    use_place = "obj_bridge_4_use_armsaw",
    room = private.room_objname,
    zz = "zz_bridge_4",
    zz_gate = "gzz_fork_4_bridge_4"
  };
  local use_armsaw_inv = function ()
  
    interface.InventoryItemRemove( "inv_armsaw" );
  
  end;
  local use_armsaw_beg = function ()

    ObjDelete( "anm_bridge_4_bridge_static" )
    ObjDelete( "obj_bridge_4_use_armsaw" );
    ObjDelete( "spr_bridge_4_brd2" );
    ObjDelete( "spr_bridge_4_brd1" );
  
  end;
  local use_armsaw_end = function ()
  
    ObjDelete( "gzz_fork_4_bridge_4" );
    ObjSet( "grm_fork_4_square_4", { input = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_fork_4_square_4_focus");
    end;
    ObjSet( "obj_bridge_4_boards_2", { alp = 1 } );
    ObjDelete( "anm_bridge_4_use_armsaw" );
    ObjSet( "spr_fork_4_bridge_4_layer_1", { alp = 1 } );
    ObjDelete( "spr_fork_4_bridge_4_layer_2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_armsaw", use_armsaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_armsaw", use_armsaw_inv );
  cmn.AddSubscriber( "use_armsaw", use_armsaw_end, private.room_objname );
  cmn.AddSubscriber( "use_armsaw_inv", use_armsaw_inv, private.room_objname );
  cmn.AddSubscriber( "use_armsaw_beg", use_armsaw_beg, private.room_objname );
  cmn.AddSubscriber( "use_armsaw_end", use_armsaw_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_chip_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_chip_4" ] = {
    type = "use",
    inv_obj = "inv_chip_4",
    use_place = "obj_motorcycle_use_chip_4",
    room = private.room_objname,
    zz = "zz_motorcycle",
    zz_gate = "gzz_fork_4_motorcycle"
  };
  local use_chip_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_chip_4" );
  
  end;
  local use_chip_4_beg = function ()
  
    ObjDelete( "obj_motorcycle_use_chip_4" );
  
  end;
  local use_chip_4_end = function ()
  
    ObjSet( "obj_motorcycle_mmg_under_3_lines", { alp = 1 } );
    ObjSet( "obj_motorcycle_mmg_under_3", { alp = 1 } );
    ObjSet( "obj_motorcycle_mmg", { input = true } );
    ObjDelete( "spr_motorcycle_mmg_cap" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_chip_4", use_chip_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_chip_4", use_chip_4_inv );
  cmn.AddSubscriber( "use_chip_4", use_chip_4_end, private.room_objname );
  cmn.AddSubscriber( "use_chip_4_inv", use_chip_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_chip_4_beg", use_chip_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_chip_4_end", use_chip_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_unbentclip () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_unbentclip" ] = {
    type = "use",
    inv_obj = "inv_unbentclip",
    use_place = "obj_motorcycle_use_unbentclip",
    room = private.room_objname,
    zz = "zz_motorcycle",
    zz_gate = "gzz_fork_4_motorcycle"
  };
  local use_unbentclip_inv = function ()
  
    interface.InventoryItemRemove( "inv_unbentclip" );
  
  end;
  local use_unbentclip_beg = function ()
  
    ObjDelete( "obj_motorcycle_use_unbentclip" );
  
  end;
  local use_unbentclip_end = function ()
  
    ObjSet( "spr_motorcycle_salammoniacbottle", { input = true, active = true, alp = 1 } );
    ObjSet( "obj_motorcycle_use_tweezers_4", { input = true } );
    ObjSet( "obj_motorcycle_bag_2_open" , { alp = 1, input = true} );
    ObjSet( "spr_fork_4_motorcycle_insaid_open", { alp = 1 } );
    ObjDelete( "spr_motorcycle_lock" );
    ObjDelete( "anm_motorcucle_open_case" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_unbentclip", use_unbentclip_beg, private.room_objname );
  cmn.AddSubscriber( "use_unbentclip", use_unbentclip_inv );
  cmn.AddSubscriber( "use_unbentclip", use_unbentclip_end, private.room_objname );
  cmn.AddSubscriber( "use_unbentclip_inv", use_unbentclip_inv, private.room_objname );
  cmn.AddSubscriber( "use_unbentclip_beg", use_unbentclip_beg, private.room_objname );
  cmn.AddSubscriber( "use_unbentclip_end", use_unbentclip_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_tweezers_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_tweezers_4" ] = {
    type = "use",
    inv_obj = "inv_tweezers_4",
    use_place = "obj_motorcycle_use_tweezers_4",
    room = private.room_objname,
    zz = "zz_motorcycle",
    zz_gate = "gzz_fork_4_motorcycle"
  };
  local use_tweezers_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_tweezers_4" );
  
  end;
  local use_tweezers_4_beg = function ()
  
    ObjDelete( "obj_motorcycle_use_tweezers_4" );
  
  end;
  local use_tweezers_4_end = function ()
  
    ObjSet( "spr_motorcycle_tweezerscotton", { input = true, active = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_tweezers_4", use_tweezers_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_4", use_tweezers_4_inv );
  cmn.AddSubscriber( "use_tweezers_4", use_tweezers_4_end, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_4_inv", use_tweezers_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_4_beg", use_tweezers_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_tweezers_4_end", use_tweezers_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_workingbrace () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_workingbrace" ] = {
    type = "use",
    inv_obj = "inv_workingbrace",
    use_place = "obj_motorcycle_use_workingbrace",
    room = private.room_objname,
    zz = "zz_motorcycle",
    zz_gate = "gzz_fork_4_motorcycle"
  };
  local use_workingbrace_inv = function ()
  
    interface.InventoryItemRemove( "inv_workingbrace" );
  
  end;
  local use_workingbrace_beg = function ()
  
    ObjDelete( "obj_motorcycle_use_workingbrace" );
    ObjDelete( "anm_motorcucle_drop" );
  
  end;
  local use_workingbrace_end = function ()
  
    ObjSet( "obj_motorcycle_use_bottle_4", { input = true } );
    ObjDelete( "spr_motorcycle_patch" );
    ObjSet( "anm_motorcucle_drop", { playing = true } );
    ObjSet( "vid_motorcycle_oil", { playing = true, alp = 1 } );
    ObjDelete( "vid_motorcycle_use_brace" );
    ObjDelete( "spr_fork_4_motorcycle_cover" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_workingbrace", use_workingbrace_beg, private.room_objname );
  cmn.AddSubscriber( "use_workingbrace", use_workingbrace_inv );
  cmn.AddSubscriber( "use_workingbrace", use_workingbrace_end, private.room_objname );
  cmn.AddSubscriber( "use_workingbrace_inv", use_workingbrace_inv, private.room_objname );
  cmn.AddSubscriber( "use_workingbrace_beg", use_workingbrace_beg, private.room_objname );
  cmn.AddSubscriber( "use_workingbrace_end", use_workingbrace_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bottle_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bottle_4" ] = {
    type = "use",
    inv_obj = "inv_bottle_4",
    use_place = "obj_motorcycle_use_bottle_4",
    room = private.room_objname,
    zz = "zz_motorcycle",
    zz_gate = "gzz_fork_4_motorcycle"
  };
  local use_bottle_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_bottle_4" );
  
  end;
  local use_bottle_4_beg = function ()
  
    ObjDelete( "obj_motorcycle_use_bottle_4" );
  
  end;
  local use_bottle_4_end = function ()
  
    ObjSet( "spr_motorcycle_fuelbottle", { input = true, active = true, alp = 1 } );
    ObjDelete( "vid_motorcycle_use_bottle" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bottle_4", use_bottle_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_bottle_4", use_bottle_4_inv );
  cmn.AddSubscriber( "use_bottle_4", use_bottle_4_end, private.room_objname );
  cmn.AddSubscriber( "use_bottle_4_inv", use_bottle_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_bottle_4_beg", use_bottle_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_bottle_4_end", use_bottle_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_blade () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_blade" ] = {
    type = "use",
    inv_obj = "inv_blade",
    use_place = "obj_tree_4_use_blade",
    room = private.room_objname,
    zz = "zz_tree_4",
    zz_gate = "gzz_fork_4_tree_4"
  };
  local use_blade_inv = function ()
  
    interface.InventoryItemRemove( "inv_blade" );
  
  end;
  local use_blade_beg = function ()
  
    ObjDelete( "obj_tree_4_use_blade" );
  
  end;
  local use_blade_end = function ()

    ObjDelete( "anm_tree_4_owl_wired" );
    ObjDelete( "anm_tree_4_owl_click" );
    ObjDelete( "anm_tree_4_owl_use_blade" );

    ObjSet( "anm_tree_4_owl_free", { alp = 1, playing = true } );
    ObjSet( "obj_tree_4_get_owl", { input = true } );
    ObjSet( "gfx_tree_4_owl_4", { active = true } );

    ObjDelete( "spr_fork_4_tree_4_wires" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_blade", use_blade_beg, private.room_objname );
  cmn.AddSubscriber( "use_blade", use_blade_inv );
  cmn.AddSubscriber( "use_blade", use_blade_end, private.room_objname );
  cmn.AddSubscriber( "use_blade_inv", use_blade_inv, private.room_objname );
  cmn.AddSubscriber( "use_blade_beg", use_blade_beg, private.room_objname );
  cmn.AddSubscriber( "use_blade_end", use_blade_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_owl_4_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_owl_4_1" ] = {
    type = "use",
    inv_obj = "inv_owl_4",
    use_place = "obj_shore_4_use_owl_4_1",
    room = private.room_objname,
    zz = "zz_shore_4",
    zz_gate = "gzz_fork_4_shore_4"
  };
  local use_owl_4_1_inv = function ()
  
    --interface.InventoryItemRemove( "inv_owl_4" );
  
  end;
  local use_owl_4_1_beg = function ()
  
    ObjDelete( "obj_shore_4_use_owl_4_1" );
  
  end;
  local use_owl_4_1_end = function ()
  
    ObjDelete( "obj_shore_4_wierd_0" );
    ObjDelete( "amn_shore_4_rope" );

    ObjMultiSet({ 
      { "obj_shore_4_wierd_1", { alp = 1 }},
      { "obj_shore_4_wierd_clk", { input = true }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_owl_4_1", use_owl_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_owl_4_1", use_owl_4_1_inv );
  cmn.AddSubscriber( "use_owl_4_1", use_owl_4_1_end, private.room_objname );
  cmn.AddSubscriber( "use_owl_4_1_inv", use_owl_4_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_owl_4_1_beg", use_owl_4_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_owl_4_1_end", use_owl_4_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_wrench_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_wrench_4" ] = {
    type = "use",
    inv_obj = "inv_wrench_4",
    use_place = "obj_shore_4_use_wrench_4",
    room = private.room_objname,
    zz = "zz_shore_4",
    zz_gate = "gzz_fork_4_shore_4"
  };
  local use_wrench_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_wrench_4" );
  
  end;
  local use_wrench_4_beg = function ()
  
    ObjDelete( "obj_shore_4_use_wrench_4" );
  
  end;
  local use_wrench_4_end = function ()
  
    ObjSet( "spr_shore_4_oar", { input = true } );
    ObjDelete( "anm_shore_4_use_wrench" );
    ObjDelete( "spr_shore_4_screw" );
    ObjDelete( "spr_shore_4_oar_over_anm" );

    ObjMultiSet({

      { "spr_shore_4_oar", { input = true }},
      { "gfx_shore_4_oar", { active = true }},
      { "spr_shore_4_oar_over", { alp = 1 }}

    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_wrench_4", use_wrench_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrench_4", use_wrench_4_inv );
  cmn.AddSubscriber( "use_wrench_4", use_wrench_4_end, private.room_objname );
  cmn.AddSubscriber( "use_wrench_4_inv", use_wrench_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_wrench_4_beg", use_wrench_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_wrench_4_end", use_wrench_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_seeker_5 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_seeker_5" ] = {
    type = "use",
    inv_obj = "inv_seeker",
    use_place = "obj_fork_4_seeker_5",
    room = private.room_objname
  };
  local use_seeker_5_inv = function ()
  
    if ( cmn.IsEventDone( "use_seeker_1") and cmn.IsEventDone( "use_seeker_2") and
    cmn.IsEventDone( "use_seeker_3") and cmn.IsEventDone( "use_seeker_4")) then

      interface.InventoryItemRemove( "inv_seeker" );

    end;
  
  end;
  local use_seeker_5_beg = function ()
  
    --
  
  end;
  local use_seeker_5_end = function ()
  
    ObjSet( "obj_fork_4_seeker_5", { input = true, visible = true, active = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_seeker_5", use_seeker_5_beg, private.room_objname );
  cmn.AddSubscriber( "use_seeker_5", use_seeker_5_inv );
  cmn.AddSubscriber( "use_seeker_5", use_seeker_5_end, private.room_objname );
  cmn.AddSubscriber( "use_seeker_5_inv", use_seeker_5_inv, private.room_objname );
  cmn.AddSubscriber( "use_seeker_5_beg", use_seeker_5_beg, private.room_objname );
  cmn.AddSubscriber( "use_seeker_5_end", use_seeker_5_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function win_motorcycle () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_motorcycle" ] = {

      type = "win",    
      room = private.room_objname,
      use_place = "spr_motorcycle_blade",
      zz_gate = "gzz_fork_4_motorcycle",
      zz = "zz_motorcycle"

  };
  local win_motorcycle = function ()

      if ( cmn.IsEventDone( "win_motorcycle" ) ) then  

        ObjMultiSet({ 
          { "spr_motorcycle_blade",     { input = true     }},
          { "gfx_motorcycle_blade",     { active = true    }},
          { "obj_motorcycle_bag_open",     { alp = 1, input = true    }},
          { "obj_motorcycle_use_unbentclip", { input = true }},
          { "spr_fork_4_motorcycle_open", { alp = 1 }},
        });
        ObjDelete( "obj_motorcycle_mmg" );

      elseif ( cmn.IsEventStart( "win_motorcycle" ) ) then
        
        for i = 1,3 do

          ObjSet( "spr_motorcycle_mmg_symbol_"..i.."_"..i, { alp = 0 } );
          ObjSet( "spr_motorcycle_mmg_symbol_"..i.."_"..ng_global.progress[ "ext" ][ "win_motorcycle" ].current[i], { alp = 1 } );
 
        end;

      end;

  end;
  cmn.AddSubscriber( "win_motorcycle", win_motorcycle, private.room_objname );  
  --------------------------------------------------------------------------------------------
  -- function see_introext () end;
  --------------------------------------------------------------------------------------------
  local see_introext = function ()

    ObjSet( "rm_fork_4", { color_r = 1, color_g = 1, color_b = 1 } );
    ObjSet( "obj_vid_fork_4_escape", { input = true } );

  end;

  cmn.AddSubscriber( "see_introext", see_introext, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_wiered () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_wiered" ] = {

      type = "click",
      room = private.room_objname,
      use_place = "obj_shore_4_wierd_clk",
      zz_gate = "gzz_fork_4_shore_4",
      zz = "zz_shore_4"
  };

  local clk_wiered_beg = function ()

    ObjDelete( "obj_shore_4_wierd_clk" );
      
  end;
  local clk_wiered_end = function ()

    ObjDelete( "obj_shore_4_boat_1" );
    ObjDelete( "spr_fork_4_shore_4_boat_1" );
    ObjMultiSet({
      { "obj_shore_4_boat_2", { alp = 1 }},
      { "spr_shore_4_armsaw", { input = true }},
      { "gfx_shore_4_armsaw", { active = true }},
      { "spr_shore_4_valve_4", { input = true }},
      { "gfx_shore_4_valve_4", { active = true }},
      { "obj_shore_4_use_wrench_4", { input = true }},
      { "spr_fork_4_shore_4_boat_2", { alp = 1 }}
    });
      
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_wiered", clk_wiered_beg, private.room_objname  );
  cmn.AddSubscriber( "clk_wiered", clk_wiered_end, private.room_objname  );
  cmn.AddSubscriber( "clk_wiered_end", clk_wiered_beg, private.room_objname  );
  cmn.AddSubscriber( "clk_wiered_end", clk_wiered_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function dlg_fork_4_danger_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_fork_4_danger_4" ] = {

      type = "click",
      use_place = "obj_dlg_fork_4_danger_4_focus",
      room = private.room_objname
  };

  local dlg_fork_4_danger_4_end = function ()

    ObjDelete( "obj_dlg_fork_4_danger_4" );
    ObjSet( "obj_vid_fork_4_tonightsville_4", { input = true } );
    ObjSet( "anm_fork_4_oliver", { alp = 1 } );
      
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_fork_4_danger_4", dlg_fork_4_danger_4_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_fork_4_danger_4_end", dlg_fork_4_danger_4_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function vid_fork_4_escape () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_fork_4_escape" ] = {

      type = "click",
      use_place = "obj_vid_fork_4_escape",
      room = private.room_objname
  };
  local vid_fork_4_escape_beg = function ()

    ObjDelete( "obj_vid_fork_4_escape" );

  end;
  local vid_fork_4_escape_end = function ()

    ObjMultiSet({ 
      { "obj_dlg_fork_4_danger_4", { input = true }},
      { "anm_fork_4_oliver", { alp = 1 }}
    });

  end;

  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "vid_fork_4_escape", vid_fork_4_escape_beg, private.room_objname );
  cmn.AddSubscriber( "vid_fork_4_escape", vid_fork_4_escape_end, private.room_objname  );
  cmn.AddSubscriber( "vid_fork_4_escape_beg", vid_fork_4_escape_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_fork_4_escape_end", vid_fork_4_escape_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function vid_fork_4_tonightsville_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_fork_4_tonightsville_4" ] = {

      type = "click",
      use_place = "obj_vid_fork_4_tonightsville_4",
      room = private.room_objname
  };
  local vid_fork_4_tonightsville_4_beg = function ()

    ObjDelete( "obj_vid_fork_4_tonightsville_4" );

  end;
  local vid_fork_4_tonightsville_4_end = function ()

    ObjMultiSet({ 
      { "obj_fork_4_gates", { input = true, active = true } },
      { "obj_int_inventory_task", { alp = 1, input = true } },
    });
    ObjDelete( "spr_fork_4_open_door" );
    ObjDelete( "anm_fork_4_oliver" );

  end;

  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "vid_fork_4_tonightsville_4", vid_fork_4_tonightsville_4_beg, private.room_objname );
  cmn.AddSubscriber( "vid_fork_4_tonightsville_4", vid_fork_4_tonightsville_4_end, private.room_objname  );
  cmn.AddSubscriber( "vid_fork_4_tonightsville_4_beg", vid_fork_4_tonightsville_4_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_fork_4_tonightsville_4_end", vid_fork_4_tonightsville_4_end, private.room_objname  );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  common_impl.hint.position_slider[ "gzz_fork_4_shore_4" ] = { "right" };

  subroom.Define( "zz_motorcycle" );
  
  function zz_motorcycle.PreOpen()

    if ( cmn.IsEventDone( "use_chip_4" )) and not cmn.IsEventDone( "win_motorcycle" ) then
    
      cmn.MiniGameShow( 'motorcycle' );
      common_impl.PassingMgStart( "motorcycle" )
      
    end;

    if cmn.IsEventDone("use_workingbrace") then
    
      common_impl.PlayAudio( "env", "common/audio/aud_fuel_env", 1, "", 0 );

    end;

  end;

  function zz_motorcycle.PreClose()

    if ( cmn.IsEventDone( "use_chip_4" )) and not cmn.IsEventDone( "win_motorcycle" ) then

      cmn.MiniGameHide( 'motorcycle' );
      common_impl.PassingMgStop( "motorcycle" )

    end;

    if cmn.IsEventDone("use_workingbrace") then
   
      common_impl.StopAudio( "env", "common/audio/aud_fuel_env", 0.2 );

    end;

  end;

  subroom.Define( "zz_tree_4" );
  
  function zz_tree_4.PreOpen()

    ObjAnimate( "spr_tree_4_owl_4_eyes", "alp", 1, 0, "",
    { 
      0.0, 0, 0.0, 
      0.4, 0, 1.0,
      1.4, 0, 1.0,
      1.8, 0, 0.0,
      2.8, 0, 0.0
    } );

    ObjAnimate( "spr_tree_4_light_add", "alp", 1, 0, "",
    { 
      0.0, 0, 1.0, 
      0.4, 0, 0.5,
      0.8, 0, 1.0
    } );

    if not cmn.IsEventDone( "get_owl_4" ) then

      common_impl.PlayAudio( "env", "common/audio/aud_fork_4_owl_zz_env", 1, "", 0 );

    end;

    common_impl.StopAudio( "env", "common/audio/aud_fork_4_owl_loc_env", 0.2 );

  end;

  function zz_tree_4.Close()

    if not cmn.IsEventDone( "get_owl_4" ) then

      common_impl.PlayAudio( "env", "common/audio/aud_fork_4_owl_loc_env", 1, "", 0 );

    end;
    common_impl.StopAudio( "env", "common/audio/aud_fork_4_owl_zz_env", 0.2 );

  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_fork_4();
  if ( cmn.IsEventDone( "see_introext") ) then
    int_slider.InitSlider( private.room_objname );
  end;
  
end;
--*********************************************************************************************************************
function public.PreOpen()

  if ( not cmn.IsEventDone( "beg_levelext" ) ) then

    cmn.SetEventDone( "beg_levelext" );
    cmn.CallEventHandler( "beg_levelext" );
    ng_global.progress[ "std" ].common.gamewin = true --DR хренотень для того, чтобы в плэйчоисе отображался доп

  end;

  if ( not cmn.IsEventDone( "see_introext" ) ) then

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[ i ], 0 );

    end;

    ObjSet( "rm_fork_4", { color_r = 0, color_g = 0, color_b = 0 } );
    ObjAttach( "tmr_fork_4_introext", private.room_objname);
    ObjSet( "tmr_fork_4_introext",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.SeeIntroExt(); end
    } );

  else
    
    common_impl.EnvPlay( { "common/audio/aud_fork_4_env" }, "", 0.5 );

    if not cmn.IsEventDone( "get_owl_4" ) then

      common_impl.PlayAudio( "env", "common/audio/aud_fork_4_owl_loc_env", 1, "", 0 );

    end;

  end;

  common_impl.MorphItemMorphing();
  --interface.InvestigationButtonCheck();
  
end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreClose()

  common_impl.StopAudio( "env", "common/audio/aud_fork_4_owl_loc_env", 0.5 );

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_armsaw()

  local item = "inv_armsaw";

  if ( common.ApplyObj( item, "obj_bridge_4_use_armsaw", true ) ) then

    cmn.CallEventHandler( "use_armsaw_inv" );
    cmn.CallEventHandler( "use_armsaw_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_armsaw" );
      cmn.CallEventHandler( "use_armsaw_end" );
      common.CloseSubRoom();
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_armsaw", 0, "", 0 );
  
    --ObjAnimate( "obj_bridge_4_boards_2", "alp", 0, 0, "",
    --{ 
    --  0.0, 0, 0.0, 
    --  0.4, 0, 1.0
    --} );
    --  ObjAnimate( "obj_bridge_4_boards_1", "alp", 0, 0, func_after,
    --{ 
    --  0.0, 0, 1.0, 
    --  0.4, 0, 0.0
    --} );

    ObjSet( "anm_bridge_4_use_armsaw", { playing = true, frame = 0, alp = 1, endtrig = func_after } );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_fork_4_bridge_4", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_bridge_4", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_chip_4()

  local item = "inv_chip_4";

  if ( common.ApplyObj( item, "obj_motorcycle_use_chip_4", true ) ) then

    cmn.CallEventHandler( "use_chip_4_inv" );
    cmn.CallEventHandler( "use_chip_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_chip_4" );
      cmn.CallEventHandler( "use_chip_4_end" );
      ng_global.progress[ "ext" ][ "win_motorcycle" ].current = { 1, 2, 3 };
      cmn.MiniGameShow( "motorcycle" );
      common_impl.PassingMgStart( "motorcycle" );
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_chip_4", 0, "", 0 );

    ObjAnimate( "obj_motorcycle_mmg_under_3_lines", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "obj_motorcycle_mmg_under_3", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_motorcycle_mmg_cap", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      0.3, 0, 0.0
    } );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_fork_4_motorcycle", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_motorcycle", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_unbentclip()

  local item = "inv_unbentclip";

  if ( common.ApplyObj( item, "obj_motorcycle_use_unbentclip", true ) ) then

    cmn.CallEventHandler( "use_unbentclip_inv" );
    cmn.CallEventHandler( "use_unbentclip_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_unbentclip" );
      cmn.CallEventHandler( "use_unbentclip_end" );
    --common.CloseSubRoom();;
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_clip", 0, "", 0 );
    ObjSet( "anm_motorcucle_open_case", { alp = 1 } );
    --ObjAnimate( "spr_motorcycle_clip", "alp", 0, 0, "",
    --{ 
    --  0.0, 0, 0.0, 
    --  0.3, 0, 1.0,
    --  0.6, 0, 0.0
    --} );
    --ObjAnimate( "obj_motorcycle_bag_2_open", "alp", 0, 0, func_after,
    --{ 
    --  0.0, 0, 0.0, 
    --  0.3, 0, 0.0,
    --  0.6, 0, 0.0
    --} );
    AnimPlay( "anm_motorcucle_open_case", "DoAnim", func_after );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_fork_4_motorcycle", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_motorcycle", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_tweezers_4()

  local item = "inv_tweezers_4";

  if ( common.ApplyObj( item, "obj_motorcycle_use_tweezers_4", true ) and cmn.IsEventDone( "use_unbentclip" ) ) then

    cmn.CallEventHandler( "use_tweezers_4_inv" );
    cmn.CallEventHandler( "use_tweezers_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_tweezers_4" );
      cmn.CallEventHandler( "use_tweezers_4_end" );
      private.get_tweezerscotton();
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_pliers_cotton", 0, "", 0 );
  
    ObjAnimate( "spr_motorcycle_tweezerscotton", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "spr_motorcycle_tweezerscotton_over", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
    ObjAnimate( "obj_motorcycle_tweezers", "pos_y", 0, 0, "",
    { 
      0.0, 0, 0, 
      0.3, 0, -50
    } );

    return true;
  
  elseif common.ApplyObj( item, "gzz_fork_4_motorcycle", false ) and cmn.IsEventDone( "use_unbentclip" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_motorcycle", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_workingbrace()

  local item = "inv_workingbrace";

  if ( common.ApplyObj( item, "obj_motorcycle_use_workingbrace", true ) ) then

    cmn.CallEventHandler( "use_workingbrace_inv" );
    cmn.CallEventHandler( "use_workingbrace_beg" );

    local vid_after = function ()

      local func_after = function ()
    
        common_impl.Lock( false );
        cmn.SetEventDone( "use_workingbrace" );
        cmn.CallEventHandler( "use_workingbrace_end" );
        common_impl.PlayAudio( "env", "common/audio/aud_fuel_env", 1, "", 0 );
      end;

      ObjSet( "vid_motorcycle_use_brace", { alp = 0 } );
      ObjSet( "spr_motorcycle_patch_over", { alp = 1 } );
      ObjAnimate( "spr_motorcycle_patch", "alp", 0, 0, "",
      { 
         0.0, 0, 1.0, 
         0.7, 0, 1.0,
         1,0, 0, 0.0
       } );
      ObjAnimate( "vid_motorcycle_oil", "alp", 0, 0, "",
      { 
         0.0, 0, 0.0, 
         0.5, 0, 0.0,
         1,0, 0, 1.0
       } );
       ObjAnimate( "spr_motorcycle_patch", "pos_xy", 0, 0, func_after,
       { 
         0.0, 0, -10, -187 ,
         1.0, 0, -60, -250
       } );
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_workingbrace", 0, "", 0 );
    VidPlay( "vid_motorcycle_use_brace", vid_after );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_fork_4_motorcycle", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_motorcycle", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bottle_4()

  local item = "inv_bottle_4";

  if ( common.ApplyObj( item, "obj_motorcycle_use_bottle_4", true ) ) and cmn.IsEventDone( "use_workingbrace" ) then

    cmn.CallEventHandler( "use_bottle_4_inv" );
    cmn.CallEventHandler( "use_bottle_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_bottle_4" );
      cmn.CallEventHandler( "use_bottle_4_end" );
      private.get_fuelbottle();
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_bottle_4", 0, "", 0 );
  
    ObjSet( "vid_motorcycle_use_bottle", { alp = 1 } );
    VidPlay( "vid_motorcycle_use_bottle", func_after );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_fork_4_motorcycle", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_motorcycle", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_blade()

  local item = "inv_blade";

  if ( common.ApplyObj( item, "obj_tree_4_use_blade", true ) ) then

    cmn.CallEventHandler( "use_blade_inv" );
    cmn.CallEventHandler( "use_blade_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_blade" );
      cmn.CallEventHandler( "use_blade_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_blade_owl", 0, "", 0 );
    common_impl.StopAudio( "env", "common/audio/aud_fork_4_owl_zz_env", 0.2 );

    ObjSet( "anm_tree_4_owl_wired", { alp = 0 });
    ObjSet( "anm_tree_4_owl_use_blade", { alp = 1 });
    AnimPlay( "anm_tree_4_owl_use_blade", "DoAnim", func_after );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_fork_4_tree_4", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_tree_4", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_owl_4_1()

  local item = "inv_owl_4";

  if ( common.ApplyObj( item, "obj_shore_4_use_owl_4_1", true ) ) then

    cmn.CallEventHandler( "use_owl_4_1_inv" );
    cmn.CallEventHandler( "use_owl_4_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_owl_4_1" );
      cmn.CallEventHandler( "use_owl_4_1_end" );
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_owl_4_rope", 0, "", 0 );
    ObjSet( "amn_shore_4_rope", { alp = 1 });
    ObjSet( "obj_shore_4_wierd_0", { alp = 0 });

    AnimPlay( "amn_shore_4_rope", "DoAnim", func_after );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_fork_4_shore_4", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shore_4", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_wrench_4()

  local item = "inv_wrench_4";

  if ( common.ApplyObj( item, "obj_shore_4_use_wrench_4", true ) and cmn.IsEventDone( "clk_wiered" ) ) then

    cmn.CallEventHandler( "use_wrench_4_inv" );
    cmn.CallEventHandler( "use_wrench_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_wrench_4" );
      cmn.CallEventHandler( "use_wrench_4_end" );
    
    end;

    common_impl.Lock( true );
    
    ObjSet( "anm_shore_4_use_wrench", { alp = 1 } );
    ObjSet( "spr_shore_4_screw", { alp =0 } );
    ObjSet( "spr_shore_4_oar_over_anm", { alp = 0 } );
    AnimPlay( "anm_shore_4_use_wrench", "DoAnim", func_after );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_wrench", 0, "", 0 );
    return true;
  
  elseif common.ApplyObj( item, "gzz_fork_4_shore_4", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_shore_4", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_seeker_5()

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "use_seeker_5" );
    cmn.CallEventHandler( "use_seeker_5_end" );
    cmn.CallEventHandler( "use_seeker_5_inv" );
  
  end;

  common_impl.Lock( true );
  func_after();
  
  return true;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_chip_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_chip_4" );
  cmn.CallEventHandler( "get_chip_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_blade()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_blade" );
  cmn.CallEventHandler( "get_blade" );

end;
--------------------------------------------------------------------------------------------
function private.get_salammoniacbottle()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_salammoniacbottle" );
  cmn.CallEventHandler( "get_salammoniacbottle" );

end;
--------------------------------------------------------------------------------------------
function private.get_tweezerscotton()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_tweezerscotton" );
  cmn.CallEventHandler( "get_tweezerscotton" );

end;
--------------------------------------------------------------------------------------------
function private.get_fuelbottle()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_fuelbottle" );
  cmn.CallEventHandler( "get_fuelbottle" );

  if ( common_impl.IsGetCoin( "get_coin_33" ) ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_owl_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  ObjSet( "anm_tree_4_owl_free", { alp = 0 });
  ObjSet( "spr_tree_4_owl_4", { alp = 1 });

  common_impl.StopAudio( "env", "common/audio/aud_fork_4_owl_zz_env", 0.2 );

  cmn.SetEventDone( "get_owl_4" );
  cmn.CallEventHandler( "get_owl_4" );
  common_impl.ShowBbt( 'bbt_fork_4_get_owl', 1 );

  common.CloseSubRoom();

end;
--------------------------------------------------------------------------------------------
function private.get_armsaw()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_armsaw" );
  cmn.CallEventHandler( "get_armsaw" );

  if cmn.IsEventDone( "get_valve_4" )and cmn.IsEventDone( "get_oar" ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_valve_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_valve_4" );
  cmn.CallEventHandler( "get_valve_4" );

  if cmn.IsEventDone( "get_oar" ) and cmn.IsEventDone( "get_armsaw" ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_oar()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_oar" );
  cmn.CallEventHandler( "get_oar" );

  if cmn.IsEventDone( "get_valve_4" )and cmn.IsEventDone( "get_armsaw" ) then

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_charmpiece_5()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_charmpiece_5" );
  cmn.CallEventHandler( "get_charmpiece_5" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_wiered()

  local func_after  = function()

    common_impl.Lock(false);
    cmn.SetEventDone( "clk_wiered" );
    cmn.CallEventHandler( "clk_wiered_end" );

  end;

  cmn.CallEventHandler( "clk_wiered_beg" );

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_wierd", 0, "", 0.5 );

  ObjAnimate( "obj_shore_4_wierd_1", "alp", 0, 0, "",
  { 
    0.0, 0, 1.0, 
    0.3, 0, 0.0
  } );  
  ObjAnimate( "obj_shore_4_wierd_2", "alp", 0, 0, "",
  { 
    0.0, 0, 0.0, 
    0.3, 0, 1.0,
  } );
  ObjAnimate( "obj_shore_4_boat_1", "alp", 0, 0, "",
  { 
    0.0, 0, 1.0,
    0.6, 0, 1.0,
    1.0, 0, 0.0
  } );  
  ObjAnimate( "obj_shore_4_boat_2", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0.0,
    0.6, 0, 0.0,
    1.0, 0, 1.0,
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_owl_4()

  local func_after  = function()

    common_impl.Lock( false );
    ObjSet( "anm_tree_4_owl_wired", { alp = 1 });
    ObjSet( "anm_tree_4_owl_click", { alp = 0 });
    common_impl.ShowBbt( 'bbt_tree_4_use_blade' );
    common_impl.PlayAudio( "env", "common/audio/aud_fork_4_owl_zz_env", 0.2 );

  end;

  common_impl.Lock( true );

  ObjSet( "anm_tree_4_owl_wired", { alp = 0 });
  ObjSet( "anm_tree_4_owl_click", { alp = 1 });
  AnimPlay( "anm_tree_4_owl_click", "DoAnim", func_after );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_owl", 0, "", 0.5 );
  common_impl.StopAudio( "env", "common/audio/aud_fork_4_owl_zz_env", 0.2 );

end;
function private.clk_symbol( number )

  number = tonumber( number );
  local current = ng_global.progress[ "ext" ][ "win_motorcycle" ].current[number]
  flag_change = false
  while( true ) do

    local symbol = current + 1;

    if ObjGet( "spr_motorcycle_mmg_symbol_"..number.."_"..symbol ) then

      private.anim_change( number, symbol );
      break;

    elseif current == 5 then

      current = 1;

    else

      current = current + 1;

    end;

  end

end;

function private.anim_change( number, symbol )

  local start_anim_pos_1_x = ObjGet( "spr_motorcycle_mmg_symbol_"..number.."_"..symbol ).pos_x;
  local start_anim_pos_1_y = ObjGet( "spr_motorcycle_mmg_symbol_"..number.."_"..symbol ).pos_y;
  local start_anim_pos_2_x = ObjGet( "spr_motorcycle_mmg_symbol_"..number.."_"..ng_global.progress[ "ext" ][ "win_motorcycle" ].current[number] ).pos_x;
  local start_anim_pos_2_y = ObjGet( "spr_motorcycle_mmg_symbol_"..number.."_"..ng_global.progress[ "ext" ][ "win_motorcycle" ].current[number] ).pos_y;
  local spr_prev = "spr_motorcycle_mmg_symbol_"..number.."_"..ng_global.progress[ "ext" ][ "win_motorcycle" ].current[number];

  local func_after = function ()

    ObjSet( spr_prev, { pos_x = start_anim_pos_2_x, pos_y = start_anim_pos_2_y, alp = 0 } );
    ObjSet( "obj_motorcycle_mmg_under_"..number.."_lines", { pos_x = 0, pos_y = 0 } );
    local flag_win = true;

    for i = 1,3 do

      if ng_global.progress[ "ext" ][ "win_motorcycle" ].current[i] ~= 5 then

        if i ~= number or symbol ~= 5 then 

          flag_win = false;
          common_impl.Lock( false );

        end;

      end;

    end;

    if flag_win then

      private.win_motorcycle()

    else

      ng_global.progress[ "ext" ][ "win_motorcycle" ].current[number] = symbol;

    end;

  end;

  common_impl.Lock( true );

  local diff_1_x = ObjGet( "spr_motorcycle_mmg_under_"..number.."_line_1" ).pos_x - ObjGet( "spr_motorcycle_mmg_under_"..number.."_line_2" ).pos_x;
  local diff_1_y = ObjGet( "spr_motorcycle_mmg_under_"..number.."_line_1" ).pos_y - ObjGet( "spr_motorcycle_mmg_under_"..number.."_line_2" ).pos_y;
  ObjSet( "spr_motorcycle_mmg_symbol_"..number.."_"..symbol, { alp = 1 } );

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_motorcycle_click", 0, "", 0.5 );

  ObjAnimate( "obj_motorcycle_mmg_under_"..number.."_lines", "pos_xy", 0, 0, "",
  { 
    0.0, 0, 0,0,
    0.5, 0, diff_1_x, diff_1_y
  } );
  ObjAnimate( "spr_motorcycle_mmg_symbol_"..number.."_"..symbol, "pos_xy", 0, 0, "",
  { 
    0.0, 0, start_anim_pos_2_x - diff_1_x, start_anim_pos_2_y - diff_1_y,
    0.5, 0, start_anim_pos_2_x           , start_anim_pos_2_y
  } );

  ObjAnimate( spr_prev, "pos_xy", 0, 0, func_after,
  { 
    0.0, 0, start_anim_pos_1_x           , start_anim_pos_1_y,
    0.5, 0, start_anim_pos_1_x + diff_1_x, start_anim_pos_1_y + diff_1_y
  } );

--  ObjAnimate( "spr_motorcycle_mmg_symbol_"..number.."_"..ng_global.progress[ "ext" ][ "win_motorcycle" ].current[number], "pos_xy", 0, 0, func_after,
--  { 
--    0.0, 0, 0.0,
--    0.3, 0, 1.0,
--  } );
--
--  ObjAnimate( "spr_motorcycle_mmg_symbol_"..number.."_"..ng_global.progress[ "ext" ][ "win_motorcycle" ].current[number], "alp", 0, 0, func_after,
--  { 
--    0.0, 0, 1.0,
--    0.3, 0, 0.0,
--  } );

end;
--*********************************************************************************************************************
function private.clk_patch()

  local func_after  = function()

    common_impl.Lock(false);
    common_impl.ShowBbt( 'bbt_motorcycle_use_workingbrace' );

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_very_small_metall", 0, "", 0 );

  ObjAnimate( "spr_motorcycle_patch", "pos_xy", 0, 0, func_after,
  { 
    0.0, 0, -10, - 187, 
    0.2, 0, -11, - 186,
    0.4, 0, -10, - 187
  } );

end;
--*********************************************************************************************************************
function private.clk_lock()

  local func_after  = function()

    common_impl.Lock(false);
    common_impl.ShowBbt( 'bbt_motorcycle_use_unbentclip' );

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_broken_zipper", 0, "", 0 );

  ObjAnimate( "spr_motorcycle_lock", "pos_xy", 0, 0, func_after,
  { 
    0.0, 0, 172, 165, 
    0.2, 0, 171, 164,
    0.0, 0, 172, 165, 
  } );

end;
--*********************************************************************************************************************
function private.clk_use_owl()

  if ( cmn.IsEventDone("get_owl_4") ) then
    common_impl.ShowBbt( 'bbt_shore_4_use_owl_4_1' );
  else 
    common_impl.ShowBbt( 'bbt_shore_4_not_use_owl_4_1' );
  end;

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************

--*********************************************************************************************************************
function private.clk_dust()

  common_impl.ShowBbt( 'bbt_bridge_4_use_armsaw' );
  
  local endfunc = function ()
  
    common_impl.Lock( false );

    ObjMultiSet({

    { "anm_bridge_4_bridge_dust_click", { alp = 0 } },

  });

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_bridge_plank", 0, "", 0 );

  ObjMultiSet({

    { "anm_bridge_4_bridge_dust_click", { frame = 0, playing = true, endtrig = endfunc, alp = 1 } },

  });


  ObjAnimate( "spr_bridge_4_brd1", "ang", 0, 0, "", { 0.00, 3,  0.00, 
                                                      0.15, 3,  0.03,
                                                      0.30, 3,  0.00,
                                                      0.45, 3,  0.02, 
                                                      0.60, 3,  0.00  } );

  ObjAnimate( "spr_bridge_4_brd2", "ang", 0, 0, "", { 0.00, 3,  0.00, 
                                                      0.15, 3, -0.03,
                                                      0.30, 3,  0.00,
                                                      0.45, 3, -0.02, 
                                                      0.60, 3,  0.00  } );

end;
--*********************************************************************************************************************
function private.get_collect_coin_33()

  local func_after = function ()
    
    common_impl.GetCoinDone("get_coin_33");
    cmn.CallEventHandler("get_coin_33");

    if cmn.IsEventDone( "get_fuelbottle" ) then

      common.CloseSubRoom();

    end;    

  end;

  common_impl.PlayEffectHO( "spr_motorcycle_coin", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.opn_fork_4()

  if not ( cmn.IsEventDone( "opn_fork_4" ) ) then
    cmn.SetEventDone( "opn_fork_4" );
  end;

  cmn.CallEventHandler( "opn_fork_4" ); 

end;
--------------------------------------------------------------------------------------------
function private.SeeIntroExt()

  ObjDelete( "tmr_fork_4_introext" ); 
  ObjSet( "vid_fork_4_introext", { alp = 1, active = true, visible = true } );
  ObjAttach( "vid_fork_4_introext", "rm_fork_4" );

  local func_after = function ( skip )

    interface.DialogVideoHide();
    common_impl.ShowBbt( "bbt_fork_4_afterintroext" );
    cmn.SetEventDone( "see_introext" );
    cmn.CallEventHandler( "see_introext" );
    int_slider.InitSlider( private.room_objname );

    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_fork_4_introext", 0.2 );      

    end;

    common_impl.StopAudio( "voc", "common/audio/aud_fork_4_introext_voc", 0.2 );
    common_impl.EnvPlay( { "common/audio/aud_fork_4_env" }, "", 0.5 );
    common_impl.PlayAudio( "env", "common/audio/aud_fork_4_owl_loc_env", 1, "", 0 );

    local func_after = function()

      cmn.CallEventHandler( "opn_fork_4_end" ); 

      ObjSet( "obj_fork_4_gates", { input = true } );
      --common_impl.AddPageDiary( 1 );

    end;
  
    cmn.SetEventDone( "opn_fork_4" ); 
    func_after();

    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment3_mus", 0, "", 0 );

    --interface.KeyTaskAdd( "goto_willowswille", true, function () common_impl.TutorialShow( "tutorial_page_1" ); end );

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_fork_4_introext", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/aud_fork_4_introext_voc", 0, "", 0 );
  common_impl.StopAllMus();

  common_impl.PlayAudio( "sfx", "common/audio/aud_fork_4_introext", 0, "", 0.5 );
  interface.DialogVideoShow( "vid_fork_4_introext", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_fork_4_introext", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
function private.vid_fork_4_escape()

  cmn.CallEventHandler( "vid_fork_4_escape_beg" );
  ObjSet( "vid_fork_4_escape", { alp = 1, active = true, input = false, visible = true } );

  local widget_settings = {}

  if IsCollectorsEdition() then

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnGuide,
      InterfaceWidget_BtnMenu
    }

  else

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnMenu
    }

  end;
  
  local trg_after = function ( skip )
    
    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_fork_4_escape" );
    cmn.CallEventHandler( "vid_fork_4_escape_end" );

    common_impl.ShowBbt( 'bbt_fork_4_after_escape', 1 );

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_fork_4_escape", 0.5 );

    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment2_mus", 0, "", 0 );

  end;

  for i = 1, #widget_settings do

    interface.WidgetSetVisible( widget_settings[i], 0 );

  end;

  common_impl.StopAllMus();
  interface.DialogVideoShow( "vid_fork_4_escape", 1, function() trg_after( 'skip' ); end, 3 );
  common_impl.PlayAudio( "sfx", "common/audio/aud_fork_4_escape", 0, "", 0.5 );
  VidPlay( "vid_fork_4_escape", function() trg_after( nil ); end ); 

end;
--*********************************************************************************************************************
function private.vid_fork_4_tonightsville_4()

  cmn.CallEventHandler( "vid_fork_4_tonightsville_4_beg" );
  ObjSet( "vid_fork_4_tonightsville_4", { alp = 1, active = true, input = false, visible = true } );

  local widget_settings = {}

  if IsCollectorsEdition() then

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnGuide,
      InterfaceWidget_BtnMenu
    }

  else

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnMenu
    }

  end;
  
  local trg_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_fork_4_tonightsville_4" );
    cmn.CallEventHandler( "vid_fork_4_tonightsville_4_end" );

    common_impl.ShowBbt( 'bbt_fork_4_after_tonightsville_4', 1 );

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

    interface.KeyTaskAdd( 'goto_willowsville' ); 

    if ( skip ) then

      common_impl.StopAudio( "sfx", "common/audio/aud_fork_4_tonightsville_4", 0.5 );

    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_adventure2_mus", 0, "", 0 );

  end;

  for i = 1, #widget_settings do

    interface.WidgetSetVisible( widget_settings[i], 0 );

  end;

  common_impl.StopAllMus();
  interface.DialogVideoShow( "vid_fork_4_tonightsville_4", 1, function() trg_after( 'skip' ); end, 3 );
  common_impl.PlayAudio( "sfx", "common/audio/aud_fork_4_tonightsville_4", 0, "", 0.5 );
  VidPlay( "vid_fork_4_tonightsville_4", function() trg_after( nil ); end ); 

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.dlg_fork_4_danger_4()

  ObjAttach( "dlg_fork_4_danger_4", private.room_objname );
  common_impl.continue_visible = false; 
  ObjSet( "anm_fork_4_oliver", { alp = 0 });
  --common_impl.dialog_character_loc = "obj_fork_4_danger_4_characters";
  common_impl.DialogCharacterStart( "danger_4", 3, nil, nil, true, "dlg_fork_4_danger_4_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_fork_4_danger_4_end()

  common_impl.AddPageDiary( 12 );

  cmn.SetEventDone( "dlg_fork_4_danger_4" );
  cmn.CallEventHandler( "dlg_fork_4_danger_4_end" );

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if dlg_name == "danger_4" then
  
    if count_txt == 1 then 

      common_impl.continue_visible = false;
      common_impl.frases = { 1 }; 
      common_impl.dial_icons = { 'nightsville' };
      common_impl.DialogCharacterShowDialogQuestions( 1, 7 );
      
    end;

  end;  

end;
--********************************************************************************************************************
----------------------------------------------------------------
function private.win_motorcycle()

  common_impl.Lock( true );

  local func_after = function ()

    common_impl.Lock(false);
    PlaySfx( "assets/levels/common/audio/aud_mg_win", 0, 0 );
    cmn.MiniGameHide( "motorcycle" );
    cmn.SetEventDone( "win_motorcycle" );
    cmn.CallEventHandler( "win_motorcycle" );
    common_impl.PassingMgWin( "motorcycle" )

  end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_motorcycle_win", 0, "", 0.5 );
    
    ObjAnimate( "obj_motorcycle_bag_open", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
    } );

end;
-----------------------------------------------------------------
function public.Reset( event )


  if cmn.IsEventDone( "use_chip_4" ) and not cmn.IsEventDone( "win_motorcycle" ) then

    for i = 1,3 do

      ObjSet( "spr_motorcycle_mmg_symbol_"..i.."_"..ng_global.progress[ "ext" ][ "win_motorcycle" ].current[i], { alp = 0 } );
      ObjSet( "spr_motorcycle_mmg_symbol_"..i.."_"..i, { alp = 1 } );
 
    end;

    ng_global.progress[ "ext" ][ "win_motorcycle" ].current = { 1, 2, 3 };
    
  end;
  

end;
-----------------------------------------------------------------
function public.Skip( event ) 

  if cmn.IsEventDone( "use_chip_4" ) and not cmn.IsEventDone( "win_motorcycle" ) then

    local func_after = function()

      common_impl.Lock(true);
      private.win_motorcycle();

    end;

    for i = 1,3 do

      local number = ng_global.progress[ "ext" ][ "win_motorcycle" ].current[i]

      if number ~= 5 then

        ObjAnimate( "spr_motorcycle_mmg_symbol_"..i.."_"..number, "alp", 0, 0, "",
        { 
          0.0, 0, 1.0, 
          0.3, 0, 0.0,
        } );
        ObjAnimate( "spr_motorcycle_mmg_symbol_"..i.."_5", "alp", 0, 0, func_after,
        { 
          0.0, 0, 0.0, 
          0.3, 0, 1.0,
        } );

        func_after = "";

      end;
 
    end;    

  end;

end;
-------------------------------------------------------------------------------------
function private.BoatClk ()

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_oar", 0, "", 0.5 );

  ObjAnimate( "spr_shore_4_oar", "ang", 0, 0, function () common_impl.Lock( false ); end, 
  {
    0.0, 0, 0.0,
    0.4, 3, 0.04,
    0.9, 2, -0.02,
    1.2, 3, 0.0
  } );

  common_impl.ShowBbt( 'bbt_shore_4_use_wrench_4' );

end;
--********************************************************************************************************************
ObjAnimate( "spr_bridge_4_light_1", "alp", 1, 0, "", { 0,0,1, 2.5,0,0.4, 5,0,1 } );
ObjAnimate( "spr_bridge_4_light_2", "alp", 1, 0, "", { 0,0,0.4, 1,5,1, 3,0,0.4 } );
ObjAnimate( "spr_bridge_4_light_2", "alp", 1, 0, "", { 0,0,0.6, 2,0,1, 4,0,0.6 } );

