-- name=rm_livingroom_4
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_livingroom_4";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_cupboard_4", "room_hub" );
  ObjAttach( "zz_toys", "room_hub" );
  ObjAttach( "zz_firstaidkit", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_cupboard_4_bottle_4", { event_mdown = private.get_bottle_4 }},
    { "spr_cupboard_4_case", { event_mdown = private.get_case }},
    { "spr_cupboard_4_button_4", { event_mdown = private.get_button_4 }},
    { "spr_toys_caduseus", { event_mdown = private.get_caduseus }},
    { "spr_toys_bagpiece_2", { event_mdown = private.get_bagpiece_2 }},
    { "spr_toys_boxpiece", { event_mdown = private.get_boxpiece }},
    { "spr_toys_nippers_4", { event_mdown = private.get_nippers_4 }},
    { "spr_toys_file_4", { event_mdown = private.get_file_4 }},
    { "spr_toys_auger", { event_mdown = private.get_auger }},
    { "spr_toys_net_4", { event_mdown = private.get_net_4 }},
    { "spr_livingroom_4_charmpiece_3", { event_mdown = private.get_charmpiece_3 }},
    { "obj_toys_clk_switcher", { event_mdown = private.clk_switcher }},
    { "spr_livingroom_4_cloth1", { event_mdown = private.clk_zz_toys } },
    { "spr_livingroom_4_cloth2", { event_mdown = private.clk_zz_cupboard_4 } },
    { "spr_livingroom_4_cloth3", { event_mdown = private.clk_zz_firstaidkit } },
    { "obj_toys_use_clownpiece", { event_mdown = private.clk_clown } },
    { "spr_cupboard_4_coin",     { event_mdown = private.get_collect_coin_36 }},
    { "spr_toys_coin",           { event_mdown = private.get_collect_coin_37 }},
    { "spr_livingroom_4_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_4" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_toys_memo", { event_mdown = function () common_impl.NoteScale( "open", "spr_toys_memo" ); common_impl.ShowBbt( 'bbt_toys_clk_memo', 1 ); end } },    
    { "spr_toys_memo_big", { event_mdown = function () common_impl.NoteScale( "close", "spr_toys_memo" ) end } },    

  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_livingroom_4 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_livingroom_4_cupboard_4",
    "gzz_livingroom_4_toys",
    "gzz_livingroom_4_firstaidkit",
    "gho_livingroom_4_pharmacybit"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

  {
    private.room_objname,
    "zz_firstaidkit",
    "zz_toys",
    "zz_cupboard_4"
  };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_livingroom_4", update_game_mode_livingroom_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_livingroom_4 = function ()

  local effects_table = 
  {
    "obj_livingroom_4_anim" 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_livingroom_4", update_performance_mode_livingroom_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_livingroom_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_livingroom_4" ] = {
    type = "click",
    use_place = "grm_square_4_livingroom_4",
    room = "rm_square_4"
  };

  local opn_livingroom_4_map = function ()

    common_impl.VisitMapRoom( "livingroom_4" );

  end;
  cmn.AddSubscriber( "opn_livingroom_4", opn_livingroom_4_map );
  --------------------------------------------------------------------------------------------
  -- function clk_zz_toys () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_zz_toys" ] = {
    type = "click",
    use_place = "spr_livingroom_4_cloth1",
    room = private.room_objname,
  };

  local clk_zz_toys = function ()
  
    ObjDelete( "spr_livingroom_4_cloth1" );  
    ObjSet( "gzz_livingroom_4_toys", { input = true, active = true } );
    ObjMultiSet({ 
      { "gzz_livingroom_4_toys", { input = true, active = true }},               
    });
    
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_zz_toys", clk_zz_toys, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_zz_cupboard_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_zz_cupboard_4" ] = {
    type = "click",
    use_place = "spr_livingroom_4_cloth2",
    room = private.room_objname,
  };

  local clk_zz_cupboard_4 = function ()
  
    ObjDelete( "spr_livingroom_4_cloth2" );  
    ObjSet( "gzz_livingroom_4_cupboard_4", { input = true, active = true } );    

  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_zz_cupboard_4", clk_zz_cupboard_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function clk_zz_firstaidkit () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_zz_firstaidkit" ] = {
    type = "click",
    use_place = "spr_livingroom_4_cloth3",
    room = private.room_objname,
  };

  local clk_zz_firstaidkit = function ()
  
    ObjDelete( "spr_livingroom_4_cloth3" );  
    ObjSet( "gzz_livingroom_4_firstaidkit", { input = true, active = true } );

  end;
  ------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_zz_firstaidkit", clk_zz_firstaidkit, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function get_bottle_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bottle_4" ] = {

    type = "get",
    get_obj = "spr_cupboard_4_bottle_4",
    room = private.room_objname,
    zz = "zz_cupboard_4",
    zz_gate = "gzz_livingroom_4_cupboard_4"

  };
    
  local get_bottle_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_bottle_4", "spr_cupboard_4_bottle_4" );
  
  end;
  
  local get_bottle_4_closezz = function ()

    ObjDelete( "spr_cupboard_4_over_1" );
    ObjDelete( "gfx_cupboard_4_bottle_4" );

    if ( common_impl.IsGetCoin( "get_coin_36" ) ) then

      ObjDelete( "gzz_livingroom_4_cupboard_4" );

    end;

  end;
  
  cmn.AddSubscriber( "get_bottle_4", get_bottle_4_inv );
  cmn.AddSubscriber( "get_bottle_4", get_bottle_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_case () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_case" ] = {
    type = "get",
    get_obj = "spr_cupboard_4_case",
    room = private.room_objname,
    zz = "zz_cupboard_4",
    zz_gate = "gzz_livingroom_4_cupboard_4"
  };
    
  local get_case_inv = function ()
  
    interface.InventoryItemAdd( "inv_case", "spr_cupboard_4_case" );
    ObjSet( "inv_case", { drag = false } );
  
  end;
  
  local get_case_closezz = function ()

    ObjDelete( "spr_livingroom_box" );
    ObjDelete( "spr_cupboard_4_over_box" );
    ObjDelete( "spr_cupboard_4_box_shadow" );
    ObjDelete( "gfx_cupboard_4_case" );    
  
  end;
  
  cmn.AddSubscriber( "get_case", get_case_inv );
  cmn.AddSubscriber( "get_case", get_case_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_button_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_button_4" ] = {
    type = "get",
    get_obj = "spr_cupboard_4_button_4",
    room = private.room_objname,
    zz = "zz_cupboard_4",
    zz_gate = "gzz_livingroom_4_cupboard_4"
  };
    
  local get_button_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_button_4", "spr_cupboard_4_button_4" );
  
  end;
  
  local get_button_4_closezz = function ()
  
    ObjDelete( "gfx_cupboard_4_button_4" );
    ObjDelete( "spr_livingroom_button_4" );
  
  end;
  
  cmn.AddSubscriber( "get_button_4", get_button_4_inv );
  cmn.AddSubscriber( "get_button_4", get_button_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_caduseus () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_caduseus" ] = {
    type = "get",
    get_obj = "spr_toys_caduseus",
    room = private.room_objname,
    zz = "zz_toys",
    zz_gate = "gzz_livingroom_4_toys"
  };
    
  local get_caduseus_inv = function ()
  
    interface.InventoryItemAdd( "inv_caduseus", "spr_toys_caduseus" );
  
  end;
  
  local get_caduseus_closezz = function ()
  
    ObjDelete( "gfx_toys_caduseus" );
    ObjDelete( "spr_toys_caduseus_shadow" );
    ObjDelete( "spr_livingroom_caduseus" );
  
  end;
  
  cmn.AddSubscriber( "get_caduseus", get_caduseus_inv );
  cmn.AddSubscriber( "get_caduseus", get_caduseus_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bagpiece_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bagpiece_2" ] = {
    type = "get",
    get_obj = "spr_toys_bagpiece_2",
    room = private.room_objname,
    zz = "zz_toys",
    zz_gate = "gzz_livingroom_4_toys"
  };
    
  local get_bagpiece_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_bagpiece_2", "spr_toys_bagpiece_2" );
  
  end;
  
  local get_bagpiece_2_closezz = function ()
  
    ObjDelete( "gfx_toys_bagpiece_2" );
    ObjDelete( "spr_toys_bagpiece_2_shadow" );
    ObjDelete( "spr_livingroom_bagpart" );    
  
  end;
  
  cmn.AddSubscriber( "get_bagpiece_2", get_bagpiece_2_inv );
  cmn.AddSubscriber( "get_bagpiece_2", get_bagpiece_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_boxpiece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_boxpiece" ] = {
    type = "get",
    get_obj = "spr_toys_boxpiece",
    room = private.room_objname,
    zz = "zz_toys",
    zz_gate = "gzz_livingroom_4_toys"
  };
    
  local get_boxpiece_inv = function ()
  
    interface.InventoryItemAdd( "inv_boxpiece", "spr_toys_boxpiece" );
  
  end;
  
  local get_boxpiece_closezz = function ()
  
    ObjDelete( "gfx_toys_boxpiece" );
    ObjDelete( "spr_toys_boxpiece_shadow" );
    ObjDelete( "spr_livingroom_case" );
  
  end;
  
  cmn.AddSubscriber( "get_boxpiece", get_boxpiece_inv );
  cmn.AddSubscriber( "get_boxpiece", get_boxpiece_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_nippers_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_nippers_4" ] = {
    type = "get",
    get_obj = "spr_toys_nippers_4",
    room = private.room_objname,
    zz = "zz_toys",
    zz_gate = "gzz_livingroom_4_toys"
  };
    
  local get_nippers_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_nippers_4", "spr_toys_nippers_4" );
  
  end;
  
  local get_nippers_4_closezz = function ()
  
    ObjDelete( "gfx_toys_nippers_4" );
    ObjDelete( "spr_toys_nippers_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_nippers_4", get_nippers_4_inv );
  cmn.AddSubscriber( "get_nippers_4", get_nippers_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_file_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_file_4" ] = {
    type = "get",
    get_obj = "spr_toys_file_4",
    room = private.room_objname,
    zz = "zz_toys",
    zz_gate = "gzz_livingroom_4_toys"
  };
    
  local get_file_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_file_4", "spr_toys_file_4" );
  
  end;
  
  local get_file_4_closezz = function ()
  
    ObjDelete( "gfx_toys_file_4" );
    --ObjDelete( "gzz_livingroom_4_toys" );
  
  end;
  
  cmn.AddSubscriber( "get_file_4", get_file_4_inv );
  cmn.AddSubscriber( "get_file_4", get_file_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_auger () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_auger" ] = {
    type = "get",
    get_obj = "spr_toys_auger",
    room = private.room_objname,
    zz = "zz_toys",
    zz_gate = "gzz_livingroom_4_toys"
  };
    
  local get_auger_inv = function ()
  
    interface.InventoryItemAdd( "inv_auger", "spr_toys_auger" );
  
  end;
  
  local get_auger_closezz = function ()
  
    ObjDelete( "gfx_toys_auger" );
    --ObjDelete( "gzz_livingroom_4_toys" );
  
  end;
  
  cmn.AddSubscriber( "get_auger", get_auger_inv );
  cmn.AddSubscriber( "get_auger", get_auger_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_net_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_net_4" ] = {
    type = "get",
    get_obj = "spr_toys_net_4",
    room = private.room_objname,
    zz = "zz_toys",
    zz_gate = "gzz_livingroom_4_toys"
  };
    
  local get_net_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_net_4", "spr_toys_net_4" );
  
  end;
  
  local get_net_4_closezz = function ()
  
    ObjDelete( "gfx_toys_net_4" );
    ObjDelete( "spr_toys_net_shadow" );
    
    ObjDelete( "spr_livingroom_ner" );

    if ( common_impl.IsGetCoin( "get_coin_37" ) ) then 

      --ObjDelete( "gzz_livingroom_4_toys" );

    end;

  
  
  end;
  
  cmn.AddSubscriber( "get_net_4", get_net_4_inv );
  cmn.AddSubscriber( "get_net_4", get_net_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_charmpiece_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_charmpiece_3" ] = {
    type = "get",
    get_obj = "obj_livingroom_4_seeker_3",
    room = private.room_objname,
  };
    
  local get_charmpiece_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_charmpiece_3", "obj_livingroom_4_seeker_3" );
  
  end;
  
  local get_charmpiece_3_closezz = function ()
  
    ObjDelete( "gfx_livingroom_4_charmpiece_3" );
  
  end;
  
  cmn.AddSubscriber( "get_charmpiece_3", get_charmpiece_3_inv );
  cmn.AddSubscriber( "get_charmpiece_3", get_charmpiece_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_36 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_36 = function ()
 
    ObjDelete( "obj_cupboard_4_coin" );

    if cmn.IsEventDone( "get_bottle_4" ) then

      ObjDelete( "gzz_livingroom_4_cupboard_4" );

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_36", get_collect_coin_36, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_37 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_37 = function ()
 
    ObjDelete( "obj_toys_coin" );

    if cmn.IsEventDone( "get_net_4" ) then

      --ObjDelete( "gzz_livingroom_4_toys" );

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_37", get_collect_coin_37, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_4 = function ()
  
    ObjDelete( "obj_livingroom_4_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_4", get_collect_morph_item_1_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_owl_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_owl_4_2" ] = {
    type = "use",
    inv_obj = "inv_owl_4",
    use_place = "obj_cupboard_4_use_owl_4_2",
    room = private.room_objname,
    zz = "zz_cupboard_4",
    zz_gate = "gzz_livingroom_4_cupboard_4"
  };
  local use_owl_4_2_inv = function ()
  
    --interface.InventoryItemRemove( "inv_owl_4" );
  
  end;
  local use_owl_4_2_beg = function ()
  
    ObjDelete( "obj_cupboard_4_use_owl_4_2" );
  
  end;
  local use_owl_4_2_end = function ()
  
    ObjSet( "spr_cupboard_4_case", { input = true, active = true, alp = 1 } );
    ObjDelete( "anm_cupboard_use_owl" );
    
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_owl_4_2", use_owl_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_owl_4_2", use_owl_4_2_inv );
  cmn.AddSubscriber( "use_owl_4_2", use_owl_4_2_end, private.room_objname );
  cmn.AddSubscriber( "use_owl_4_2_inv", use_owl_4_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_owl_4_2_beg", use_owl_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_owl_4_2_end", use_owl_4_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_ring_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_ring_4" ] = {
    type = "use",
    inv_obj = "inv_ring_4",
    use_place = "obj_cupboard_4_use_ring_4",
    room = private.room_objname,
    zz = "zz_cupboard_4",
    zz_gate = "gzz_livingroom_4_cupboard_4"
  };
  local use_ring_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_ring_4" );
  
  end;
  local use_ring_4_beg = function ()
  
    ObjDelete( "obj_cupboard_4_use_ring_4" );
  
  end;
  local use_ring_4_end = function ()
  
    ObjSet( "spr_livingroom_over_cupboard", { alp = 1 });
    ObjDelete( "anm_cupboard_use_ring" );
    ObjSet( "spr_cupboard_4_bottle_4", { input = true, active = true, alp = 1 } );
    ObjDelete( "spr_cupboard_4_cup" );
    ObjSet( "obj_cupboard_4_bottle", { alp = 1 } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_ring_4", use_ring_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_ring_4", use_ring_4_inv );
  cmn.AddSubscriber( "use_ring_4", use_ring_4_end, private.room_objname );
  cmn.AddSubscriber( "use_ring_4_inv", use_ring_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_ring_4_beg", use_ring_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_ring_4_end", use_ring_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_button_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_button_4" ] = {
    type = "use",
    inv_obj = "inv_button_4",
    use_place = "obj_toys_use_button_4",
    room = private.room_objname,
    zz = "zz_toys",
    zz_gate = "gzz_livingroom_4_toys"
  };
  local use_button_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_button_4" );
  
  end;
  local use_button_4_beg = function ()
  
    ObjDelete( "obj_toys_use_button_4" );
  
  end;
  local use_button_4_end = function ()
  
    ObjMultiSet({ 
      { "obj_toys_clk_switcher",  { input = true  }},
      { "spr_toys_button",        { alp = 1       }},
      { "spr_livingroom_button",  { visible = true       }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_button_4", use_button_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_4", use_button_4_inv );
  cmn.AddSubscriber( "use_button_4", use_button_4_end, private.room_objname );
  cmn.AddSubscriber( "use_button_4_inv", use_button_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_button_4_beg", use_button_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_button_4_end", use_button_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_van () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_van" ] = {
    type = "use",
    inv_obj = "inv_van",
    use_place = "obj_toys_use_van",
    room = private.room_objname,
    zz = "zz_toys",
    zz_gate = "gzz_livingroom_4_toys"
  };
  local use_van_inv = function ()
  
    interface.InventoryItemRemove( "inv_van" );
  
  end;
  local use_van_beg = function ()
  
    ObjDelete( "obj_toys_use_van" );
  
  end;
  local use_van_end = function ()
  
    ObjMultiSet({ 
      { "gfx_toys_nippers_4", { active = true } },
      { "gfx_toys_file_4", { active = true }},
      { "gfx_toys_auger", { active = true }},
      { "obj_toys_wagon_open", { input = true } },
      { "spr_livingroom_cadeus", { visible = true } },
      { "spr_livingroom_bagpart", { visible = true }},
      { "spr_livingroom_case", { visible = true }},
      { "spr_toys_wagon", { alp = 1 }},
      { "spr_toys_wagon", { alp = 1 }},
      { "spr_livingroom_train_open", { visible = true }},
      { "obj_toys_wagon_open", { alp = 1 } },
    });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_van", use_van_beg, private.room_objname );
  cmn.AddSubscriber( "use_van", use_van_inv );
  cmn.AddSubscriber( "use_van", use_van_end, private.room_objname );
  cmn.AddSubscriber( "use_van_inv", use_van_inv, private.room_objname );
  cmn.AddSubscriber( "use_van_beg", use_van_beg, private.room_objname );
  cmn.AddSubscriber( "use_van_end", use_van_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_clownpiece () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_clownpiece" ] = {
    type = "use",
    inv_obj = "inv_clownpiece",
    use_place = "obj_toys_use_clownpiece",
    room = private.room_objname,
    zz = "zz_toys",
    zz_gate = "gzz_livingroom_4_toys"
  };
  local use_clownpiece_inv = function ()
  
    interface.InventoryItemRemove( "inv_clownpiece" );
  
  end;
  local use_clownpiece_beg = function ()
  
    ObjDelete( "obj_toys_use_clownpiece" );
  
  end;
  local use_clownpiece_end = function ()
        
    ObjSet( "spr_livingroom_partclown", { visible = true } );
    ObjDelete( "spr_toys_hand" );
    ObjDelete( "anm_toys_clown" );
    ObjMultiSet({ 
      { "spr_toys_net_4",     { input = true     }},
      { "gfx_toys_net_4",     { active = true    }},
      { "spr_toys_clownpiece",     { alp = 1    }},
      { "anm_toys_use_clownpiece",     { frame = 87, alp = 1 }},
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_clownpiece", use_clownpiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_clownpiece", use_clownpiece_inv );
  cmn.AddSubscriber( "use_clownpiece", use_clownpiece_end, private.room_objname );
  cmn.AddSubscriber( "use_clownpiece_inv", use_clownpiece_inv, private.room_objname );
  cmn.AddSubscriber( "use_clownpiece_beg", use_clownpiece_beg, private.room_objname );
  cmn.AddSubscriber( "use_clownpiece_end", use_clownpiece_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_caduseus () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_caduseus" ] = {
    type = "use",
    inv_obj = "inv_caduseus",
    use_place = "obj_firstaidkit_use_caduseus",
    room = private.room_objname,
    zz = "zz_firstaidkit",
    zz_gate = "gzz_livingroom_4_firstaidkit"
  };
  local use_caduseus_inv = function ()
  
    interface.InventoryItemRemove( "inv_caduseus" );
  
  end;
  local use_caduseus_beg = function ()
  
    ObjDelete( "obj_firstaidkit_use_caduseus" );
  
  end;
  local use_caduseus_end = function ()
  
    ObjSet( "gho_livingroom_4_pharmacybit", { input = true, active = true } );
    ObjDelete( "gzz_livingroom_4_firstaidkit" );
    ObjSet( "spr_livingroom_open_ho", { visible = true });
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_caduseus", use_caduseus_beg, private.room_objname );
  cmn.AddSubscriber( "use_caduseus", use_caduseus_inv );
  cmn.AddSubscriber( "use_caduseus", use_caduseus_end, private.room_objname );
  cmn.AddSubscriber( "use_caduseus_inv", use_caduseus_inv, private.room_objname );
  cmn.AddSubscriber( "use_caduseus_beg", use_caduseus_beg, private.room_objname );
  cmn.AddSubscriber( "use_caduseus_end", use_caduseus_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_seeker_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_seeker_3" ] = {
    type = "use",
    inv_obj = "inv_seeker",
    use_place = "obj_livingroom_4_seeker_3",
    room = private.room_objname,
    --zz = "zz_toys",
    --zz_gate = "gzz_livingroom_4_firstaidkit"
  };
  local use_seeker_3_inv = function ()
  
    if ( cmn.IsEventDone( "use_seeker_1") and cmn.IsEventDone( "use_seeker_2") and
    cmn.IsEventDone( "use_seeker_4") and cmn.IsEventDone( "use_seeker_5")) then

      interface.InventoryItemRemove( "inv_seeker" );

    end;
  
  end;
  local use_seeker_3_beg = function ()
  
    --
  
  end;
  local use_seeker_3_end = function ()
  
    ObjSet( "obj_livingroom_4_seeker_3", { input = true, visible = true, active = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_seeker_3", use_seeker_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_seeker_3", use_seeker_3_inv );
  cmn.AddSubscriber( "use_seeker_3", use_seeker_3_end, private.room_objname );
  cmn.AddSubscriber( "use_seeker_3_inv", use_seeker_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_seeker_3_beg", use_seeker_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_seeker_3_end", use_seeker_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_switcher () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_switcher" ] = {
    type = "click",
    use_place = "obj_toys_clk_switcher",
    room = private.room_objname,
    zz = "zz_toys",
    zz_gate = "gzz_livingroom_4_toys"
  };

  local clk_switcher_beg = function ()
  
    ObjDelete( "obj_toys_clk_switcher" );
  
  end;
  local clk_switcher_end = function ()

    ObjMultiSet({ 
      { "spr_livingroom_caduseus",   { visible = true }},
      { "spr_livingroom_bagpart",   { visible = true }},
      { "spr_livingroom_case", { visible = true }},
      { "spr_toys_caduseus",   { input = true, alp = 1  }},
      { "gfx_toys_caduseus",   { active = true    }},
      { "spr_toys_bagpiece_2", { input = true, alp = 1     }},
      { "gfx_toys_bagpiece_2", { active = true    }},
      { "spr_toys_boxpiece",   { input = true, alp = 1     }},
      { "gfx_toys_boxpiece",   { active = true    }},
      { "spr_toys_button",     { scale_x = -1   }},
      { "obj_toys_use_van",    { input = true }},
      { "vid_toys_train", { frame = 54 } },
      { "spr_livingroom_button",  { scale_x = -1, pos_x = 576 }},
      { "spr_livingroom_train2",  { visible = true }},
    });
    ObjDelete( "spr_livingroom_train1" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_switcher", clk_switcher_beg, private.room_objname );
  cmn.AddSubscriber( "clk_switcher", clk_switcher_end, private.room_objname );
  cmn.AddSubscriber( "clk_switcher_beg", clk_switcher_beg, private.room_objname );
  cmn.AddSubscriber( "clk_switcher_end", clk_switcher_end, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_toys" );
  
  function zz_toys.PreOpen()

    if common_impl.livingroom_4 then

      common_impl.livingroom_4.note = "close";
      ObjSet( "spr_toys_memo_big", { input = 0, alp = 0 } );
      ObjSet( "spr_toys_memo", { alp = 1 } );

    else 

      common_impl.livingroom_4 = {}
      common_impl.livingroom_4.note = "close";

    end;

  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_livingroom_4();
  
  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()


  common_impl.MorphItemMorphing();
  --interface.InvestigationButtonCheck();

  common_impl.EnvPlay( { "common/audio/aud_livingroom_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS CLK *** () end;
--*********************************************************************************************************************
    --{ "spr_livingroom_4_cloth1", { event_mdown = clk_zz_toys } },
    --{ "spr_livingroom_4_cloth2", { event_mdown = clk_zz_cupboard_4 } },
    --{ "spr_livingroom_4_cloth3", { event_mdown = clk_zz_firstaidkit } },
--------------------------------------------------------------------------------------------
function private.clk_zz_toys()


  local func_after = function ()

    common_impl.Lock(false);

    cmn.SetEventDone( "clk_zz_toys" );
    cmn.CallEventHandler( "clk_zz_toys" );

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_cloth", 0, "", 0 );

  ObjAnimate( "spr_livingroom_4_cloth1", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1.0,
    0.3, 0, 0.0
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_zz_cupboard_4()


  local func_after = function ()

    common_impl.Lock(false);

    cmn.SetEventDone( "clk_zz_cupboard_4" );
    cmn.CallEventHandler( "clk_zz_cupboard_4" );

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_cloth", 0, "", 0 );

  ObjAnimate( "spr_livingroom_4_cloth2", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1.0,
    0.3, 0, 0.0
  } );

end;
--------------------------------------------------------------------------------------------
function private.clk_zz_firstaidkit()


  local func_after = function ()

    common_impl.Lock(false);

    cmn.SetEventDone( "clk_zz_firstaidkit" );
    cmn.CallEventHandler( "clk_zz_firstaidkit" );

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_cloth", 0, "", 0 );

  ObjAnimate( "spr_livingroom_4_cloth3", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1.0,
    0.3, 0, 0.0
  } );

end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_owl_4_2()

  local item = "inv_owl_4";

  if ( common.ApplyObj( item, "obj_cupboard_4_use_owl_4_2", true ) ) then

    cmn.CallEventHandler( "use_owl_4_2_inv" );
    cmn.CallEventHandler( "use_owl_4_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_owl_4_2" );
      cmn.CallEventHandler( "use_owl_4_2_end" );
      ObjSet( "spr_cupboard_4_button_4", { alp = 1 } );
      ObjSet( "spr_cupboard_4_case", { alp = 1 } );
      private.get_button_4();
      private.get_case();
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_owl_cupboard", 0, "", 0 );
  
    AnimPlay( "anm_cupboard_use_owl", "DoAnim", func_after );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_livingroom_4_cupboard_4", false ) and cmn.IsEventDone( "clk_zz_cupboard_4" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cupboard_4", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_ring_4()

  local item = "inv_ring_4";

  if ( common.ApplyObj( item, "obj_cupboard_4_use_ring_4", true ) ) then

    cmn.CallEventHandler( "use_ring_4_inv" );
    cmn.CallEventHandler( "use_ring_4_beg" );
    
    local endfunc = function()    

      local func_after = function ()
    
        common_impl.Lock( false );
        cmn.SetEventDone( "use_ring_4" );
        cmn.CallEventHandler( "use_ring_4_end" );
      
      end;

    func_after();
    
    end; 

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_ring_4", 0, "", 0 );
    AnimPlay( "anm_cupboard_use_ring", "DoAnim", endfunc );

    return true;
  
  elseif common.ApplyObj( item, "gzz_livingroom_4_cupboard_4", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cupboard_4", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_button_4()

  local item = "inv_button_4";

  if ( common.ApplyObj( item, "obj_toys_use_button_4", true ) and common_impl.livingroom_4.note == "close" ) then

    cmn.CallEventHandler( "use_button_4_inv" );
    cmn.CallEventHandler( "use_button_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_button_4" );
      cmn.CallEventHandler( "use_button_4_end" );
    --common.CloseSubRoom();;
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_button_railroad", 0, "", 0 );
  
    ObjAnimate( "spr_toys_button", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_livingroom_4_toys", false ) and cmn.IsEventDone( "clk_zz_toys" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_toys", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_van()

  local item = "inv_van";

  if ( common.ApplyObj( item, "obj_toys_use_van", true ) and common_impl.livingroom_4.note == "close" ) then

    cmn.CallEventHandler( "use_van_inv" );
    cmn.CallEventHandler( "use_van_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_van" );
      cmn.CallEventHandler( "use_van_end" );
    --common.CloseSubRoom();;
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_toy_car", 0, "", 0 );
    ObjAnimate( "spr_toys_wagon", "alp", 0, 0, function() common_impl.PlayAudio( "sfx", "common/audio/aud_use_toy_car", 0, "", 0 ) end,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
    ObjAnimate( "obj_toys_wagon_open", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0,
      0.3, 0, 0.0,
      0.6, 0, 1.0
    } );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_livingroom_4_toys", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_toys", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_clownpiece()

  local item = "inv_clownpiece";

  if ( common.ApplyObj( item, "obj_toys_use_clownpiece", true ) and common_impl.livingroom_4.note == "close" ) then

    cmn.CallEventHandler( "use_clownpiece_inv" );
    cmn.CallEventHandler( "use_clownpiece_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_clownpiece" );
      cmn.CallEventHandler( "use_clownpiece_end" );
      --ObjSet( "spr_toys_hand", { alp = 1 } );

    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_clownpiece", 0, "", 0 );
  
    --ObjAnimate( "spr_toys_clownpiece", "alp", 0, 0, func_after,
    --{ 
    --  0.0, 0, 0.0, 
    --  0.3, 0, 1.0
    --} );
    ObjSet( "anm_toys_use_clownpiece", { alp = 1 } );
    ObjSet( "spr_toys_hand", { alp = 0 } );
    AnimPlay( "anm_toys_use_clownpiece", "DoAnim", func_after );

    return true;
  
  elseif common.ApplyObj( item, "gzz_livingroom_4_toys", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_toys", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_caduseus()

  local item = "inv_caduseus";

  if ( common.ApplyObj( item, "obj_firstaidkit_use_caduseus", true ) ) then

    cmn.CallEventHandler( "use_caduseus_inv" );
    cmn.CallEventHandler( "use_caduseus_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_caduseus" );
      cmn.CallEventHandler( "use_caduseus_end" );
      common.CloseSubRoom();
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_caduseus", 0, "", 0 );
  --
    ObjAnimate( "spr_firstaidkit_caduceus", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_livingroom_4_firstaidkit", false ) and cmn.IsEventDone( "clk_zz_firstaidkit" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_firstaidkit", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_seeker_3()

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "use_seeker_3" );
    cmn.CallEventHandler( "use_seeker_3_end" );
    cmn.CallEventHandler( "use_seeker_3_inv" );

  end;

  common_impl.Lock( true );
  func_after();

  return true;
  
end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_bottle_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_bottle_4" );
  cmn.CallEventHandler( "get_bottle_4" );

  if ( common_impl.IsGetCoin( "get_coin_36" ) ) then 

    common.CloseSubRoom();

  end;
 

end;
--------------------------------------------------------------------------------------------
function private.get_case()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_case" );
  cmn.CallEventHandler( "get_case" );

end;
--------------------------------------------------------------------------------------------
function private.get_button_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_button_4" );
  cmn.CallEventHandler( "get_button_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_caduseus()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_caduseus" );
  cmn.CallEventHandler( "get_caduseus" );

end;
--------------------------------------------------------------------------------------------
function private.get_bagpiece_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_bagpiece_2" );
  cmn.CallEventHandler( "get_bagpiece_2" );

end;
--------------------------------------------------------------------------------------------
function private.get_boxpiece()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_boxpiece" );
  cmn.CallEventHandler( "get_boxpiece" );

end;
--------------------------------------------------------------------------------------------
function private.get_nippers_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_nippers_4" );
  cmn.CallEventHandler( "get_nippers_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_file_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_file_4" );
  cmn.CallEventHandler( "get_file_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_auger()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_auger" );
  cmn.CallEventHandler( "get_auger" );

end;
--------------------------------------------------------------------------------------------
function private.get_net_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_net_4" );
  cmn.CallEventHandler( "get_net_4" );

  if ( common_impl.IsGetCoin( "get_coin_37" ) ) then 

    common.CloseSubRoom();

  end;

end;
--------------------------------------------------------------------------------------------
function private.get_charmpiece_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_charmpiece_3" );
  cmn.CallEventHandler( "get_charmpiece_3" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_switcher()

  local func_after_1 = function ()

    local func_after_2 = function ()

      common_impl.Lock( false );
      cmn.SetEventDone( "clk_switcher" );
      cmn.CallEventHandler( "clk_switcher_end" ); 

    end;

    ObjSet( "spr_toys_button", { scale_x = -1 } );
    ObjAnimate( "spr_toys_button", "alp", 0, 0, "", 
    { 
      0.0, 3, 0.0, 
      0.2, 3, 1.0, 
    });

    VidPlay( "vid_toys_train", func_after_2 );

    common_impl.PlayAudio( "sfx", "common/audio/aud_toys_train", 0, "", 0 );

  end;

  common_impl.Lock( true );
  cmn.CallEventHandler( "clk_switcher_beg" );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_button_railroad", 0, "", 0 );

  --видос с паравозиком
  ObjAnimate( "spr_toys_button", "alp", 0, 0, func_after_1, 
  { 
    0.0, 3, 1.0, 
    0.2, 3, 0.0, 
  });


end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.get_collect_coin_36()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_36" );
    cmn.CallEventHandler( "get_coin_36" );

    if cmn.IsEventDone( "get_bottle_4" ) then
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_cupboard_4_coin", func_after ); 

end;
--*********************************************************************************************************************
function private.get_collect_coin_37()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_37" );
    cmn.CallEventHandler( "get_coin_37" );

    if cmn.IsEventDone( "get_net_4" ) then
      common.CloseSubRoom();
    end;    

  end;

  common_impl.PlayEffectHO( "spr_toys_coin", func_after ); 

end;
--*********************************************************************************************************************
function private.opn_livingroom_4()

  if not ( cmn.IsEventDone( "opn_livingroom_4" ) ) then
    cmn.SetEventDone( "opn_livingroom_4" );
  end;
  
  cmn.CallEventHandler( "opn_livingroom_4" ); 

end;
--*********************************************************************************************************************
function private.clk_clown()

  local func_after = function ()
    
    common_impl.Lock( false );
    common_impl.ShowBbt( 'bbt_toys_use_clownpiece' );

  end;

  common_impl.Lock( true );
  AnimPlay( "anm_toys_clk_clown", "DoAnim", func_after );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_clown", 0, "", 0 );

end;
--*********************************************************************************************************************
--                                             Light_Animations
--*********************************************************************************************************************
--*********************************************************************************************************************
ObjAnimate( "spr_livingroom_4_light", "alp", 1, 0, "", 

  { 
    0.0, 3, 1.0, 
    1.0, 3, 0.6, 
    2.1, 3, 1.0, 
    3.0, 3, 0.8, 
    4.1, 3, 0.6, 
    5.2, 3, 0.9, 
    7.3, 3, 1.0, 

  });

ObjAnimate( "spr_firstaidkit_light_add", "alp", 1, 0, "", 

  { 
    0.0, 3, 1.0, 
    1.0, 3, 0.6, 
    2.1, 3, 1.0, 
    3.0, 3, 0.8, 
    4.1, 3, 0.6,
    4.4, 3, 1.0, 

  });


ObjAnimate( "obj_cupboard_4_anims", "alp", 1, 0, "", 

  { 
    0.0, 3, 1.0, 
    1.0, 3, 0.6, 
    2.1, 3, 1.0, 
    3.0, 3, 0.8, 
    4.1, 3, 0.6,
    4.4, 3, 1.0, 

  });


ObjAnimate( "spr_cupboard_4_light_add_2", "alp", 1, 0, "", 

  { 
    0.0, 3, 1.0, 
    1.0, 3, 0.6, 
    4.1, 3, 1.0, 
    5.0, 3, 0.8, 
    7.1, 3, 0.6,
    8.4, 3, 1.0, 

  });


ObjAnimate( "spr_cupboard_4_light_add_1", "alp", 1, 0, "", 

  { 
    0.0, 3, 0.8, 
    1.0, 3, 0.2, 
    3.1, 3, 0.4, 
    5.0, 3, 1.0, 
    5.1, 3, 0.9,
    9.4, 3, 0.8, 

  });


ObjAnimate( "spr_livingroom_4_lighter", "ang", 1, 0, "", 

  { 
    0.0, 3, -0.05, 
    1.0, 3,  0.02, 
    2.0, 3, -0.05, 


  });
--********************************************************************************************************************s
--********************************************************************************************************************