-- name=rm_sheriffshouse_4
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_sheriffshouse_4";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_ruins", "room_hub" );
  private.Init_Subroom();
  private.interactive = {};
  private.interactive.current_progres = 0;
  private.interactive.win_progres = { 4,2,3,1 };
  local table_multiset = {};

  for i = 1,4 do

    table.insert( table_multiset, { "spr_sheriffshouse_4_simpleton_mmg_piece_"..i.."_1", { 
      event_mdown = function() private.InteractiveMmgClk ( i ) end,
      event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end,
      event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end,
     }} );

  end;
  ObjMultiSet( table_multiset );

  ObjMultiSet({ 
    { "spr_ruins_scrap", { event_mdown = private.get_scrap }},
    { "spr_ruins_revolver_4", { event_mdown = private.get_revolver_4 }},
    { "spr_ruins_leakybucket", { event_mdown = private.get_leakybucket }},
    { "spr_ruins_bucketgunpowder", { event_mdown = private.get_bucketgunpowder }},
    { "obj_vid_sheriffshouse_4_exemption", { event_mdown = private.vid_sheriffshouse_4_exemption } },
    { "obj_vid_sheriffshouse_4_exemption_focus", { event_mdown = private.vid_sheriffshouse_4_exemption } },
    { "obj_dlg_sheriffshouse_4_simpleton_2", { event_mdown = public.dlg_sheriffshouse_4_simpleton_2 } },
    { "spr_ruins_coin",        { event_mdown = private.get_collect_coin_40 }},
    { "spr_sheriffshouse_4_collect_item",    { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_3_2" );     end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_sheriffshouse_4_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_3_4" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "obj_sheriffshouse_4_simpleton_2_box_click", { event_mdown = function() private.InteractiveClkOver(); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_sheriffshouse_4_simpleton_mmg_amplifier", { event_mdown = function() private.GetAmplifier(); end, event_menter = function() common_impl.SetCursor( CURSOR_GET ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_sheriffshouse_4_jack_mmg", { event_mdown = function() private.GetPackage(); end, event_menter = function() common_impl.SetCursor( CURSOR_LOUPE ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "obj_sheriffshouse_4_use_powersymbol_1", { event_mdown = function() private.clk_hand( 1 ) end; }},  
    { "obj_sheriffshouse_4_use_powersymbol_2", { event_mdown = function() private.clk_hand( 2 ) end; }},  
    { "obj_sheriffshouse_4_use_powersymbol_3", { event_mdown = function() private.clk_hand( 3 ) end; }}
  });
  --------------------------------------------------------------------------------------------
  -- function Animations () end;
  --------------------------------------------------------------------------------------------
  private.RuinsInitAnimations();
  ObjAnimate( "spr_sheriffshouse_ho_open_light", "alp", 1, 0, "", { 0, 0, 1,  2.0, 0, 0.4,  4.0, 0, 1} );
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_sheriffshouse_4 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gho_sheriffshouse_4_rucksack",
    "gzz_sheriffshouse_4_ruins"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_ruins"
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_sheriffshouse_4", update_game_mode_sheriffshouse_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_sheriffshouse_4 = function ()

  local effects_table = 
  {
    "anm_sheriffhouse_anim_1", 
    "anm_sheriffhouse_anim_2",
    "anm_sheriffhouse_people",
    "anm_sheriffhouse_oldman",
    "anm_sheriffhouse_jack",
    "anm_sheriffhouse_front",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_sheriffshouse_4", update_performance_mode_sheriffshouse_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_sheriffshouse_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_sheriffshouse_4" ] = {
    type = "click",
    use_place = "grm_square_4_sheriffshouse_4",
    room = "rm_square_4"
  };

  local opn_sheriffshouse_4_map = function ()

    common_impl.VisitMapRoom( "sheriffshouse_4" );

  end;
  cmn.AddSubscriber( "opn_sheriffshouse_4", opn_sheriffshouse_4_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_3_2 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_3_2 = function ()
  
    ObjDelete( "obj_sheriffshouse_4_collect" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_3_2", get_collect_item_3_2, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_3_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_3_4 = function ()
  
    ObjDelete( "obj_sheriffshouse_4_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_3_4", get_collect_morph_item_3_4, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_scrap () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_scrap" ] = {
    type = "get",
    get_obj = "spr_ruins_scrap",
    room = private.room_objname,
    zz = "zz_ruins",
    zz_gate = "gzz_sheriffshouse_4_ruins"
  };
    
  local get_scrap_inv = function ()
  
    interface.InventoryItemAdd( "inv_scrap", "spr_ruins_scrap" );
  
  end;
  
  local get_scrap_closezz = function ()
  
    ObjDelete( "gfx_ruins_scrap" );
    ObjDelete( "spr_ruins_scrap_shadow" );
    ObjDelete( "spr_sheriffshouse_4_ruins_scarp" );

    if cmn.IsEventDone( "get_bucketgunpowder" ) and ( cmn.IsEventDone( "get_revolver_4" ) and common_impl.IsGetCoin( "get_coin_40" ) ) then
      ObjDelete( "gzz_sheriffshouse_4_ruins" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_scrap", get_scrap_inv );
  cmn.AddSubscriber( "get_scrap", get_scrap_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_revolver_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_revolver_4" ] = {
    type = "get",
    get_obj = "spr_ruins_revolver_4",
    room = private.room_objname,
    zz = "zz_ruins",
    zz_gate = "gzz_sheriffshouse_4_ruins"
  };
    
  local get_revolver_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_revolver_4", "spr_ruins_revolver_4" );
    ObjSet( "inv_revolver_4", { drag = false } );
  
  end;
  
  local get_revolver_4_closezz = function ()
  
    ObjDelete( "gfx_ruins_revolver_4" );  
    ObjDelete( "spr_ruins_revolver_shadow" );
    ObjDelete( "spr_sheriffshouse_4_ruins_revolver" );

    if cmn.IsEventDone( "get_bucketgunpowder" ) and ( cmn.IsEventDone( "get_scrap" ) and common_impl.IsGetCoin( "get_coin_40" ) ) then
      ObjDelete( "gzz_sheriffshouse_4_ruins" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_revolver_4", get_revolver_4_inv );
  cmn.AddSubscriber( "get_revolver_4", get_revolver_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_leakybucket () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_leakybucket" ] = {
    type = "get",
    get_obj = "spr_ruins_leakybucket",
    room = private.room_objname,
    zz = "zz_ruins",
    zz_gate = "gzz_sheriffshouse_4_ruins"
  };
    
  local get_leakybucket_inv = function ()
  
    interface.InventoryItemAdd( "inv_leakybucket", "spr_ruins_leakybucket" );
    ObjSet( "inv_leakybucket", { drag = false } );
  
  end;
  
  local get_leakybucket_closezz = function ()
  
    ObjDelete( "gfx_ruins_leakybucket" );
    ObjDelete( "spr_ruins_bucket_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_leakybucket", get_leakybucket_inv );
  cmn.AddSubscriber( "get_leakybucket", get_leakybucket_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bucketgunpowder () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bucketgunpowder" ] = {
    type = "get",
    get_obj = "spr_ruins_bucketgunpowder",
    room = private.room_objname,
    zz = "zz_ruins",
    zz_gate = "gzz_sheriffshouse_4_ruins"
  };
    
  local get_bucketgunpowder_inv = function ()
  
    interface.InventoryItemAdd( "inv_bucketgunpowder", "spr_ruins_bucketgunpowder" );
  
  end;
  
  local get_bucketgunpowder_closezz = function ()
  
    ObjDelete( "gfx_ruins_bucketgunpowder" );
    ObjDelete( "spr_ruins_bucketpowder_shadow" );
    ObjDelete( "spr_sheriffshouse_4_ruins_bucket" );

    if cmn.IsEventDone( "get_revolver_4" ) and ( cmn.IsEventDone( "get_scrap" ) and common_impl.IsGetCoin( "get_coin_40" ) ) then
      ObjDelete( "gzz_sheriffshouse_4_ruins" );
    end;
  
  end;
  
  cmn.AddSubscriber( "get_bucketgunpowder", get_bucketgunpowder_inv );
  cmn.AddSubscriber( "get_bucketgunpowder", get_bucketgunpowder_closezz, private.room_objname );
    --------------------------------------------------------------------------------------------
  -- function get_collect_coin_40 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_40 = function ()
 
    ObjDelete( "obj_ruins_coin" );

    if cmn.IsEventDone( "get_revolver_4" ) and  cmn.IsEventDone( "get_scrap" ) and cmn.IsEventDone( "get_bucketgunpowder" )  then

      ObjDelete( "gzz_sheriffshouse_4_ruins" );

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_40", get_collect_coin_40, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function use_powersymbol_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_powersymbol_1" ] = {
    type = "use",
    inv_obj = "inv_powersymbol_1",
    use_place = "obj_sheriffshouse_4_use_powersymbol_1",
    room = private.room_objname
  };
  local use_powersymbol_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_powersymbol_1" );
  
  end;
  local use_powersymbol_1_beg = function ()
  
    ObjDelete( "obj_sheriffshouse_4_use_powersymbol_1" );
  
  end;
  local use_powersymbol_1_end = function ()
  
    ObjDelete( "anm_sheriffhouse_hand_1" );
    ObjDelete( "anm_sheriffhouse_hand_1_amulet" );
    ObjDelete( "anm_sheriffhouse_hand_1_use" );
    ObjDelete( "anm_sheriffhouse_hand_1_click" );

    if cmn.IsEventDone( "use_powersymbol_2" ) and cmn.IsEventDone( "use_powersymbol_3" ) then
      ObjSet( "obj_vid_sheriffshouse_4_exemption", { input = true } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_powersymbol_1", use_powersymbol_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_powersymbol_1", use_powersymbol_1_inv );
  cmn.AddSubscriber( "use_powersymbol_1", use_powersymbol_1_end, private.room_objname );
  cmn.AddSubscriber( "use_powersymbol_1_inv", use_powersymbol_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_powersymbol_1_beg", use_powersymbol_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_powersymbol_1_end", use_powersymbol_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_powersymbol_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_powersymbol_2" ] = {
    type = "use",
    inv_obj = "inv_powersymbol_3",
    use_place = "obj_sheriffshouse_4_use_powersymbol_2",
    room = private.room_objname
  };
  local use_powersymbol_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_powersymbol_3" );
  
  end;
  local use_powersymbol_2_beg = function ()
  
    ObjDelete( "obj_sheriffshouse_4_use_powersymbol_2" );
  
  end;
  local use_powersymbol_2_end = function ()
    
    ObjDelete( "anm_sheriffhouse_hand_2" );
    ObjDelete( "anm_sheriffhouse_hand_2_amulet" );
    ObjDelete( "anm_sheriffhouse_hand_2_use" );
    ObjDelete( "anm_sheriffhouse_hand_2_click" );

    if cmn.IsEventDone( "use_powersymbol_1" ) and cmn.IsEventDone( "use_powersymbol_3" ) then
      ObjSet( "obj_vid_sheriffshouse_4_exemption", { input = true } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_powersymbol_2", use_powersymbol_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_powersymbol_2", use_powersymbol_2_inv );
  cmn.AddSubscriber( "use_powersymbol_2", use_powersymbol_2_end, private.room_objname );
  cmn.AddSubscriber( "use_powersymbol_2_inv", use_powersymbol_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_powersymbol_2_beg", use_powersymbol_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_powersymbol_2_end", use_powersymbol_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_powersymbol_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_powersymbol_3" ] = {
    type = "use",
    inv_obj = "inv_powersymbol_2",
    use_place = "obj_sheriffshouse_4_use_powersymbol_3",
    room = private.room_objname
  };
  local use_powersymbol_3_inv = function ()
  
    interface.InventoryItemRemove( "inv_powersymbol_2" );
  
  end;
  local use_powersymbol_3_beg = function ()
  
    ObjDelete( "obj_sheriffshouse_4_use_powersymbol_3" );
  
  end;
  local use_powersymbol_3_end = function ()
      
    ObjDelete( "anm_sheriffhouse_hand_3" );
    ObjDelete( "anm_sheriffhouse_hand_3_amulet" );
    ObjDelete( "anm_sheriffhouse_hand_3_use" );
    ObjDelete( "anm_sheriffhouse_hand_3_click" );

    if cmn.IsEventDone( "use_powersymbol_1" ) and cmn.IsEventDone( "use_powersymbol_2" ) then
      ObjSet( "obj_vid_sheriffshouse_4_exemption", { input = true } );
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_powersymbol_3", use_powersymbol_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_powersymbol_3", use_powersymbol_3_inv );
  cmn.AddSubscriber( "use_powersymbol_3", use_powersymbol_3_end, private.room_objname );
  cmn.AddSubscriber( "use_powersymbol_3_inv", use_powersymbol_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_powersymbol_3_beg", use_powersymbol_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_powersymbol_3_end", use_powersymbol_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bucket_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bucket_4" ] = {
    type = "use",
    inv_obj = "inv_bucket_4",
    use_place = "obj_ruins_use_bucket_4",
    room = private.room_objname,
    zz = "zz_ruins",
    zz_gate = "gzz_sheriffshouse_4_ruins"
  };
  local use_bucket_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_bucket_4" );
  
  end;
  local use_bucket_4_beg = function ()
  
    ObjDelete( "obj_ruins_use_bucket_4" );
  
  end;
  local use_bucket_4_end = function ()
  
    ObjDelete( "anm_ruins_bucket" );
    ObjSet( "spr_ruins_bucketgunpowder", { input = true, alp = 1 } );
    ObjSet( "gfx_ruins_bucketgunpowder", { active = true, visible = true } );
    ObjSet( "spr_ruins_bucketpowder_shadow", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bucket_4", use_bucket_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_bucket_4", use_bucket_4_inv );
  cmn.AddSubscriber( "use_bucket_4", use_bucket_4_end, private.room_objname );
  cmn.AddSubscriber( "use_bucket_4_inv", use_bucket_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_bucket_4_beg", use_bucket_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_bucket_4_end", use_bucket_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_sheriffshouse_4_handmarshes () end;
  --------------------------------------------------------------------------------------------
  local vid_sheriffshouse_4_handmarshes = function ()

    ObjSet( "rm_sheriffshouse_4", { color_r = 1, color_g = 1, color_b = 1 } );
    ObjSet( "anm_sheriffhouse_anim_2", { alp = 1 } );
    ObjSet( "obj_sheriffshouse_4_collect", { input = true, visible = true } );
    ObjDelete( "anm_sheriffhouse_anim_1" );
    ObjSet( "obj_sheriffshouse_4_hand", { active = true, alp = 1 } );

  end;

  cmn.AddSubscriber( "vid_sheriffshouse_4_handmarshes", vid_sheriffshouse_4_handmarshes, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_sheriffshouse_4_exemption () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_sheriffshouse_4_exemption" ] = {

      type = "click",
      use_place = "obj_vid_sheriffshouse_4_exemption",
      room = private.room_objname
  };
  local vid_sheriffshouse_4_exemption_beg = function ()

    ObjDelete( "obj_vid_sheriffshouse_4_exemption" );

  end;
  local vid_sheriffshouse_4_exemption_end = function ()

    ObjSet( "spr_sheriffshouse_ho_open", { visible = true, active = true } );
    ObjSet( "gho_sheriffshouse_4_rucksack", { input = true, active = true } );
    ObjSet( "gzz_sheriffshouse_4_ruins", { input = true, active = true } );
    ObjSet( "anm_sheriffhouse_people", { alp = 1, playing = true } );
    ObjSet( "anm_sheriffhouse_jack", { alp = 1, playing = true } );

  end;
  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "vid_sheriffshouse_4_exemption", vid_sheriffshouse_4_exemption_beg, private.room_objname );
  cmn.AddSubscriber( "vid_sheriffshouse_4_exemption", vid_sheriffshouse_4_exemption_end, private.room_objname  );
  cmn.AddSubscriber( "vid_sheriffshouse_4_exemption_beg", vid_sheriffshouse_4_exemption_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_sheriffshouse_4_exemption_end", vid_sheriffshouse_4_exemption_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function dlg_sheriffshouse_4_simpleton () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_sheriffshouse_4_simpleton" ] = {

      type = "click",
      use_place = "obj_dlg_sheriffshouse_4_simpleton",
      room = private.room_objname
  };
  
  local dlg_sheriffshouse_4_simpleton_end = function ()

    ObjSet( "obj_dlg_sheriffshouse_4_simpleton_2", { input = true } );
    ObjDelete( "obj_dlg_sheriffshouse_4_simpleton" );
    ObjDelete( "gho_sheriffshouse_4_rucksack" );
    ObjSet( "anm_sheriffhouse_oldman", { alp = 1, playing = true } );
    ObjSet( "anm_sheriffhouse_jack", { alp = 1, playing = true } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_sheriffshouse_4_simpleton", dlg_sheriffshouse_4_simpleton_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_sheriffshouse_4_simpleton_end", dlg_sheriffshouse_4_simpleton_end, private.room_objname  );

  --------------------------------------------------------------------------------------------
  -- function dlg_sheriffshouse_4_simpleton_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_sheriffshouse_4_simpleton_2" ] = {

      type = "click",
      use_place = "obj_dlg_sheriffshouse_4_simpleton_2",
      room = private.room_objname
  };
  local dlg_sheriffshouse_4_simpleton_2_inv = function ()

    ObjDelete( "obj_dlg_sheriffshouse_4_simpleton_2" )
    ObjSet( "spr_sheriffshouse_4_amplifier", { active = true, alp = 1, visible = true } );
    interface.InventoryItemAdd( "inv_amplifier", "spr_sheriffshouse_4_simpleton_mmg_amplifier" );
      
  end;
  local dlg_sheriffshouse_4_simpleton_2_end = function ()

    ObjSet( "anm_sheriffhouse_oldman", { alp = 1, playing = true } );
    ObjSet( "anm_sheriffhouse_jack", { alp = 1, playing = true } );
      
  end;
 
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_sheriffshouse_4_simpleton_2", dlg_sheriffshouse_4_simpleton_2_inv );
  cmn.AddSubscriber( "dlg_sheriffshouse_4_simpleton_2", dlg_sheriffshouse_4_simpleton_2_end, private.room_objname  );
  cmn.AddSubscriber( "dlg_sheriffshouse_4_simpleton_2_inv", dlg_sheriffshouse_4_simpleton_2_inv );
  cmn.AddSubscriber( "dlg_sheriffshouse_4_simpleton_2_end", dlg_sheriffshouse_4_simpleton_2_end, private.room_objname  );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_sheriffshouse_4();
  
  if cmn.IsEventDone( "vid_sheriffshouse_4_exemption" ) then 

    common_impl.PlayAudio( "env", "common/audio/aud_square_people_env", 1, "", 0.5 );

  end;

  if not ( cmn.IsEventDone( "use_powersymbol_1" ) and cmn.IsEventDone( "use_powersymbol_2" ) and cmn.IsEventDone( "use_powersymbol_3" ) ) then

    common_impl.PlayAudio( "env", "common/audio/aud_hands_env", 1, "", 0.5 );

  end;

  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();

  if ( not cmn.IsEventDone( "vid_sheriffshouse_4_handmarshes" ) ) then

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[ i ], 0 );

    end;

    ObjSet( "rm_sheriffshouse_4", { color_r = 0, color_g = 0, color_b = 0 } );
    ObjAttach( "tmr_sheriffshouse_4_handmarshes", private.room_objname);
    ObjSet( "tmr_sheriffshouse_4_handmarshes",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.vid_sheriffshouse_4_handmarshes(); end
    } );

  elseif ( not cmn.IsEventDone( "dlg_sheriffshouse_4_simpleton" ) and cmn.IsEventDone( "win_rucksack" ) ) then

    public.dlg_sheriffshouse_4_simpleton();

  else

    --common_impl.EnvPlay( { "common/audio/aud_fork_4_env" }, "", 0.5 );

  end;


  common_impl.MorphItemMorphing();
  --interface.InvestigationButtonCheck();

  common_impl.EnvPlay( { "common/audio/aud_sheriffshouse_4_env" }, "", 0.5 );
  
end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );

  if cmn.IsEventDone( "vid_sheriffshouse_4_exemption" ) then 

    common_impl.StopAudio( "env", "common/audio/aud_square_people_env", 0.2 );

  end;

  if not ( cmn.IsEventDone( "use_powersymbol_1" ) and cmn.IsEventDone( "use_powersymbol_2" ) and cmn.IsEventDone( "use_powersymbol_3" ) ) then 
 
    common_impl.StopAudio( "env", "common/audio/aud_hands_env", 0.2 );

  end;

end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_powersymbol_1()

  local item = "inv_powersymbol_1";

  if ( common.ApplyObj( item, "obj_sheriffshouse_4_use_powersymbol_1" ) ) then

    if cmn.IsEventDone( "use_powersymbol_2" ) and cmn.IsEventDone( "use_powersymbol_3" ) then
      common_impl.StopAudio( "env", "common/audio/aud_hands_env", 0.2 );
    end;

    cmn.CallEventHandler( "use_powersymbol_1_inv" );
    cmn.CallEventHandler( "use_powersymbol_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_powersymbol_1" );
      cmn.CallEventHandler( "use_powersymbol_1_end" );

    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_powersymbol_1", 0, "", 0 );
  
    ObjMultiSet({ 
      { "anm_sheriffhouse_hand_1",     { alp = 0     }},
      { "anm_sheriffhouse_hand_1_amulet",     { alp = 1    }},
      { "anm_sheriffhouse_hand_1_use",     { alp = 1    }},
    });
    AnimPlay( "anm_sheriffhouse_hand_1_amulet", "DoAnim", "" );
    AnimPlay( "anm_sheriffhouse_hand_1_use", "DoAnim", func_after );
  
    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_powersymbol_2()

  local item = "inv_powersymbol_3";

  if ( common.ApplyObj( item, "obj_sheriffshouse_4_use_powersymbol_2" ) ) then

    if cmn.IsEventDone( "use_powersymbol_1" ) and cmn.IsEventDone( "use_powersymbol_3" ) then
      common_impl.StopAudio( "env", "common/audio/aud_hands_env", 0.2 );
    end;


    cmn.CallEventHandler( "use_powersymbol_2_inv" );
    cmn.CallEventHandler( "use_powersymbol_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_powersymbol_2" );
      cmn.CallEventHandler( "use_powersymbol_2_end" );
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_powersymbol_2", 0, "", 0 );
  
    --ObjAnimate( "anm_sheriffhouse_spearhand2_static", "alp", 0, 0, func_after,
    --{ 
    --  0.0, 0, 1.0, 
    --  0.3, 0, 0.0
    --} );
    ObjMultiSet({ 
      { "anm_sheriffhouse_hand_2",     { alp = 0     }},
      { "anm_sheriffhouse_hand_2_amulet",     { alp = 1    }},
      { "anm_sheriffhouse_hand_2_use",     { alp = 1    }},
    });
    AnimPlay( "anm_sheriffhouse_hand_2_amulet", "DoAnim", "" );
    AnimPlay( "anm_sheriffhouse_hand_2_use", "DoAnim", func_after );
  
    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_powersymbol_3()

  local item = "inv_powersymbol_2";

  if ( common.ApplyObj( item, "obj_sheriffshouse_4_use_powersymbol_3" ) ) then

    cmn.CallEventHandler( "use_powersymbol_3_inv" );
    cmn.CallEventHandler( "use_powersymbol_3_beg" );

    if cmn.IsEventDone( "use_powersymbol_1" ) and cmn.IsEventDone( "use_powersymbol_2" ) then
      common_impl.StopAudio( "env", "common/audio/aud_hands_env", 0.2 );
    end;

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_powersymbol_3" );
      cmn.CallEventHandler( "use_powersymbol_3_end" );
    --common.CloseSubRoom();;
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_powersymbol_3", 0, "", 0 );
  
    ObjMultiSet({ 
      { "anm_sheriffhouse_hand_3",     { alp = 0     }},
      { "anm_sheriffhouse_hand_3_amulet",     { alp = 1    }},
      { "anm_sheriffhouse_hand_3_use",     { alp = 1    }},
    });
    AnimPlay( "anm_sheriffhouse_hand_3_amulet", "DoAnim", "" );
    AnimPlay( "anm_sheriffhouse_hand_3_use", "DoAnim", func_after );
  
    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bucket_4()

  local item = "inv_bucket_4";

  if ( common.ApplyObj( item, "obj_ruins_use_bucket_4", true ) ) then

    cmn.CallEventHandler( "use_bucket_4_inv" );
    cmn.CallEventHandler( "use_bucket_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_bucket_4" );
      cmn.CallEventHandler( "use_bucket_4_end" );
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_cannon_bucket", 0, "", 0 );
    ObjSet( "anm_ruins_bucket", { alp = 1 });
    AnimPlay( "anm_ruins_bucket", "DoAnim", func_after );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_sheriffshouse_4_ruins", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_ruins", nil, { 512, 384 } );

    return true;

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_scrap()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_scrap" );
  cmn.CallEventHandler( "get_scrap" );

end;
--------------------------------------------------------------------------------------------
function private.get_revolver_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_revolver_4" );
  cmn.CallEventHandler( "get_revolver_4" );

  if cmn.IsEventDone( "get_bucketgunpowder" ) and common_impl.IsGetCoin( "get_coin_40" ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_leakybucket()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_leakybucket" );
  cmn.CallEventHandler( "get_leakybucket" );

end;
--------------------------------------------------------------------------------------------
function private.get_bucketgunpowder()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_bucketgunpowder" );
  cmn.CallEventHandler( "get_bucketgunpowder" );

  if cmn.IsEventDone( "get_revolver_4" ) and common_impl.IsGetCoin( "get_coin_40" ) then
    common.CloseSubRoom();
  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_hand( num )

  local num = tonumber( num );

  local sound_mas = { "left", "center", "right" }

  local func_after = function ()

    common_impl.Lock( false );
    ObjSet( "anm_sheriffhouse_hand_"..num, { alp = 1 });
    ObjSet( "anm_sheriffhouse_hand_"..num.."_click", { alp = 0 });
    common_impl.ShowBbt( "bbt_sheriffshouse_4_use_powersymbol_"..num );

  end;

  common_impl.Lock( true );
   
  ObjSet( "anm_sheriffhouse_hand_"..num, { alp = 0 });
  ObjSet( "anm_sheriffhouse_hand_"..num.."_click", { alp = 1 });

  AnimPlay( "anm_sheriffhouse_hand_"..num.."_click", "DoAnim", func_after );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_hand_"..sound_mas[num], 0, "", 0 );

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_sheriffshouse_4()

  if not ( cmn.IsEventDone( "opn_sheriffshouse_4" ) ) then
    cmn.SetEventDone( "opn_sheriffshouse_4" );
  end;
  
  cmn.CallEventHandler( "opn_sheriffshouse_4" ); 

end;
--*********************************************************************************************************************
function private.get_collect_coin_40()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_40" );
    cmn.CallEventHandler( "get_coin_40" );
 
    if cmn.IsEventDone( "get_revolver_4" ) and  cmn.IsEventDone( "get_scrap" ) and cmn.IsEventDone( "get_bucketgunpowder" )  then

      common.CloseSubRoom();

    end;  

  end;

  common_impl.PlayEffectHO( "spr_ruins_coin", func_after ); 

end;
--------------------------------------------------------------------------------------------
function private.vid_sheriffshouse_4_handmarshes()

  ObjDelete( "tmr_sheriffshouse_4_handmarshes" ); 
  ObjSet( "vid_sheriffshouse_4_handmarshes", { alp = 1, active = true, visible = true } );
  ObjAttach( "vid_sheriffshouse_4_handmarshes", "rm_sheriffshouse_4" );

  local func_after = function ( skip )

    interface.DialogVideoHide();
    common_impl.ShowBbt( "bbt_sheriffshouse_4_after_handmarshes" );
    cmn.SetEventDone( "vid_sheriffshouse_4_handmarshes" );
    cmn.CallEventHandler( "vid_sheriffshouse_4_handmarshes" );

    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_sheriffshouse_4_handmarshes", 0.2 );
      
    end;

   -- common_impl.StopAudio( "voc", "common/audio/aud_fork_4_introext_voc", 0.2 );
   -- common_impl.EnvPlay( { "common/audio/aud_fork_4_env" }, "", 0.5 );
   
    local func_after = function()

      ObjSet( "obj_sheriffshouse_4_gates", { input = true } );
      --common_impl.AddPageDiary( 1 );
      interface.KeyTaskAdd( 'save_people' );
      common_impl.PlayAudio( "mus", "common/audio/aud_danger1_mus", 0, "", 0 );
    end;
  
    func_after();
    --common_impl.PlayAudio( "mus", "common/audio/aud_adventure2_mus", 0, "", 0 );

    --interface.KeyTaskAdd( "goto_willowswille", true, function () common_impl.TutorialShow( "tutorial_page_1" ); end );

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_sheriffshouse_4_handmarshes", 0, "", 0 );
  common_impl.StopAllMus();
  interface.DialogVideoShow( "vid_sheriffshouse_4_handmarshes", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_sheriffshouse_4_handmarshes", function() func_after( nil ); end );

end;
--------------------------------------------------------------------------------------------
function public.vid_sheriffshouse_4_banishedstory()

  ObjDelete( "tmr_sheriffshouse_4_banishedstory" ); 
  ObjSet( "vid_sheriffshouse_4_banishedstory", { alp = 1, active = true, visible = true } );
  ObjAttach( "vid_sheriffshouse_4_banishedstory", "rm_sheriffshouse_4" );

  local func_after = function ( skip )

    if ( skip ) then 

      common_impl.StopAudio( "sfx", "common/audio/aud_sheriffshouse_4_banishedstory", 0.2 );

    end;

    common_impl.StopAllMus();

    common_impl.PlayAudio( "mus", "common/audio/aud_enigma_mus", 0, "", 0 );

    common_impl.StopAudio( "voc", "common/audio/aud_sheriffshouse_4_banishedstory_voc", 0.2 );
    interface.DialogVideoHide();
    common_impl.AddPageDiary( 16 );
    common_impl.ShowBbt( "bbt_sheriffshouse_4_after_banishedstory" );
    cmn.SetEventDone( "dlg_sheriffshouse_4_simpleton" );
    cmn.CallEventHandler( "dlg_sheriffshouse_4_simpleton_end" );

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

  end;

  common_impl.StopAllMus();
  common_impl.PlayAudio( "mus", "common/audio/aud_deduction_mus", 0, "", 0 );
  interface.DialogVideoShow( "vid_sheriffshouse_4_banishedstory", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_sheriffshouse_4_banishedstory", function() func_after( nil ); end );
  common_impl.PlayAudio( "sfx", "common/audio/aud_sheriffshouse_4_banishedstory", 0, "", 0 );
  common_impl.PlayAudio( "voc", "common/audio/aud_sheriffshouse_4_banishedstory_voc", 0, "", 0 );  

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.dlg_sheriffshouse_4_jack()

  ObjAttach( "dlg_sheriffshouse_4_jack", private.room_objname );
  common_impl.continue_visible = false; 
  --common_impl.dialog_character_loc = "obj_sheriffshouse_4_jack_characters";
  common_impl.DialogCharacterStart( "jack", 4, nil, nil, true, "dlg_sheriffshouse_4_jack_end" );
  ObjSet( "anm_sheriffhouse_people", { alp = 1, playing = true });

end;
--------------------------------------------------------------------------------------------
function public.dlg_sheriffshouse_4_jack_end()

  if ( not cmn.IsEventDone( "vid_sheriffshouse_4_exemption" )) then

    cmn.SetEventDone( "vid_sheriffshouse_4_exemption" );
    cmn.CallEventHandler( "vid_sheriffshouse_4_exemption_end" );
    ObjSet( "obj_int_dialog_character_input", { event_mdown = "" } );
    ObjSet( "spr_int_dialog_character_bot", { alp = 1 } );
    ObjSet( "txt_int_dialog_character", { alp = 1 } );
    ObjAttach( "obj_sheriffshouse_4_jack_mmg", "obj_sheriffshouse_4_jack_characters" );
    ObjSet( "obj_sheriffshouse_4_jack_mmg", { alp = 0, input = false } );
    cmn.GotoRoom( 'ho_rucksack' );
    ObjSet( "obj_int_dialog_character", { alp  = 1 } ); 

  end;
 
end;
--------------------------------------------------------------------------------------------
function public.dlg_sheriffshouse_4_simpleton()

  ObjAttach( "dlg_sheriffshouse_4_simpleton", private.room_objname );
  common_impl.continue_visible = true;
  ObjSet( "anm_sheriffhouse_jack", { alp = 0 } );
 
  --common_impl.dialog_character_loc = "obj_sheriffshouse_4_simpleton_characters";
  common_impl.DialogCharacterStart( "simpleton", 4, nil, nil, true, "dlg_sheriffshouse_4_simpleton_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_sheriffshouse_4_simpleton_end()

  public.vid_sheriffshouse_4_banishedstory(); 
  ObjSet( "obj_int_dialog_character", { alp  = 1 } );  

end;
--------------------------------------------------------------------------------------------
function public.dlg_sheriffshouse_4_simpleton_2()

  ObjAttach( "dlg_sheriffshouse_4_simpleton_2", private.room_objname );
  common_impl.continue_visible = true; 
  ObjSet( "anm_sheriffhouse_oldman", { alp = 0, playing = false } );
  ObjSet( "anm_sheriffhouse_jack", { alp = 0, playing = false } );
  --common_impl.dialog_character_loc = "obj_sheriffshouse_4_simpleton_characters";
  common_impl.DialogCharacterStart( "simpleton_2", 2, nil, nil, true, "dlg_sheriffshouse_4_simpleton_2_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_sheriffshouse_4_simpleton_2_end()


  if ng_global.progress[ "ext" ][ "win_box" ] then

    cmn.MiniGameHide( "box" );

  end;

  cmn.SetEventDone( "dlg_sheriffshouse_4_simpleton_2" );
  cmn.CallEventHandler( "dlg_sheriffshouse_4_simpleton_2_inv" );
  cmn.CallEventHandler( "dlg_sheriffshouse_4_simpleton_2_end" );

  ObjSet( "spr_int_dialog_character_bot", { alp = 1 } );
  ObjSet( "txt_int_dialog_character", { alp = 1 } );
  ObjAttach( "obj_sheriffshouse_4_simpleton_2_mmg", "obj_sheriffshouse_4_simpleton_2_characters" );
  ObjSet( "obj_sheriffshouse_4_simpleton_2_mmg", { alp = 0, input = false } );
  ObjSet( "obj_int_dialog_character", { alp  = 1 } ); 
  interface.KeyTaskDone( true );
  interface.KeyTaskAdd( "goto_fort" );

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if dlg_name == "jack" then
  
    if count_txt == 1 then 

      common_impl.continue_visible = false;
      common_impl.frases = { 1 }; 
      common_impl.dial_icons = { 'interrogation' };
      common_impl.DialogCharacterShowDialogQuestions( 1, 3 );
     
    elseif count_txt == 2 then 

      common_impl.continue_visible = false;
      common_impl.frases = { 2 }; 
      common_impl.dial_icons = { 'box' };
      common_impl.DialogCharacterShowDialogQuestions( 1, 12 );

    elseif count_txt == 3 then 

      ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = private.ClkJackDial } );
      ObjSet( "anm_sheriffshouse_4_jack_jack_2", { alp = 1 } );
      ObjSet( "anm_sheriffshouse_4_jack_jack", { alp = 0 } ); 
      common_impl.PlayAudio( "sfx", "common/audio/aud_get_to_us", 0, "", 0 );

    end;

  elseif dlg_name == "simpleton" then

    if count_txt == 1 then 

      common_impl.continue_visible = true;
      common_impl.DialogCharacterChangeCharacters( 'simpleton', nil, 'oldman' );

    elseif count_txt == 2 then 

      common_impl.continue_visible = true;
      common_impl.DialogCharacterChangeCharacters( 'simpleton', 'oldman', 'jack' );

    elseif count_txt == 3 then 

      common_impl.continue_visible = true;
      common_impl.DialogCharacterChangeCharacters( 'simpleton', 'jack', 'oldman' );

    end;

  elseif dlg_name == "simpleton_2" then

     if count_txt == 1 then 

      common_impl.continue_visible = true;
      common_impl.DialogCharacterChangeCharacters( 'simpleton_2', nil, 'oldman' );

      --elseif count_txt == 1 then
       ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = private.ClkSimpletonDial } );
       --common_impl.DialogCharacterChangeCharacters( 'simpleton_2', nil, 'mmg' );
       --ObjSet( "obj_sheriffshouse_4_simpleton_2_mmg", { alp = 1 } ); 
       --ObjSet( "obj_int_dialog_character_input", { input = false } );

     end;

  end;  

end;
--*******************************************************************************************************************
function private.ClkSimpletonDial()

  common_impl.DialogCharacterMmgShow( "simpleton_2", 600, 400, nil, nil, nil, "box"  );
  ObjSet( "int_button_guide", { alp = 1, input = true } );
  ObjSet( "int_button_menu", { alp = 1, input = true } );
  common_impl.StopAllVoc();
  common_impl.DialogCharacterStopAllVid();
  ObjAnimate( "obj_sheriffshouse_4_simpleton_2_jack", "color_rgb", 0, 0, "", { 0,0,1,1,1, 0.3,0,0.5,0.5,0.5 } );
  ObjAnimate( "obj_sheriffshouse_4_simpleton_2_oldman", "color_rgb", 0, 0, "", { 0,0,1,1,1, 0.3,0,0.5,0.5,0.5 } );
  ObjAnimate( "obj_sheriffshouse_4_simpleton_2_mmg", "color_rgb", 0, 0, "", { 0,0,0.4,0.4,0.4, 0.3,0,1,1,1 } );
  ObjAnimate( "obj_sheriffshouse_4_simpleton_2_oldman", "scale_xy", 0, 0, "", { 0,0,1.05,1.05, 0.3,0,1,1 } );
  ObjSet( "spr_int_dialog_character_bot", { alp = 0 } );
  ObjSet( "txt_int_dialog_character", { alp = 0 } );
  ObjSet( "anm_sheriffshouse_4_simpleton_2_oldman_2", { alp = 0 } );
  ObjSet( "anm_sheriffshouse_4_simpleton_2_oldman", { alp = 1 } ); 

end;
--*******************************************************************************************************************
function private.ClkJackDial()

  common_impl.DialogCharacterMmgShow( "jack", 800, 400, nil, nil, false  );

  ObjAnimate( "obj_sheriffshouse_4_jack_jack", "color_rgb", 0, 0, "", { 0,0,1,1,1, 0.3,0,0.5,0.5,0.5 } );
  ObjAnimate( "obj_sheriffshouse_4_jack_mmg", "color_rgb", 0, 0, "", { 0,0,0.4,0.4,0.4, 0.3,0,1,1,1 } );
  ObjAnimate( "obj_sheriffshouse_4_simpleton_2_oldman", "scale_xy", 0, 0, "", { 0,0,1.05,1.05, 0.3,0,1,1 } );
  ObjSet( "spr_int_dialog_character_bot", { alp = 0 } );
  ObjSet( "txt_int_dialog_character", { alp = 0 } );
  ObjSet( "anm_sheriffshouse_4_jack_jack_2", { alp = 0 } );
  ObjSet( "anm_sheriffshouse_4_jack_jack", { alp = 1 } ); 

end;
--*******************************************************************************************************************
function private.vid_sheriffshouse_4_exemption()

  cmn.CallEventHandler( "vid_sheriffshouse_4_exemption_beg" );
  ObjSet( "vid_sheriffshouse_4_exemption", { alp = 1, active = true, input = false, visible = true } );
  ObjAttach( "vid_sheriffshouse_4_exemption", "rm_sheriffshouse_4" );

  local widget_settings = {}

  if IsCollectorsEdition() then

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnGuide,
      InterfaceWidget_BtnMenu
    }

  else

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnMenu
    }

  end;
  
  local func_after = function ( skip )

    common_impl.AddPageDiary( 15 );

    interface.DialogVideoHide();
    common_impl.ShowBbt( 'bbt_sheriffshouse_4_after_exemption', 1 );

    for i = 1, #widget_settings do
      interface.WidgetSetVisible( widget_settings[i], 1, true );
    end;

    public.dlg_sheriffshouse_4_jack();

    if skip then

       common_impl.StopAudio( "sfx", "common/audio/aud_sheriffshouse_4_exemption", 0.2 );

    end;
    
    common_impl.PlayAudio( "env", "common/audio/aud_square_people_env", 1, "", 0.5 );
    common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0, "", 0 );

  end;

  for i = 1, #widget_settings do
    interface.WidgetSetVisible( widget_settings[i], 0 );
  end;

  common_impl.StopAllMus();
  interface.DialogVideoShow( "vid_sheriffshouse_4_exemption", 1, function() func_after( 'skip' ) end, 3 );
  common_impl.PlayAudio( "sfx", "common/audio/aud_sheriffshouse_4_exemption", 0, "", 0.5 );
  VidPlay( "vid_sheriffshouse_4_exemption",  function() func_after( nil ) end );  

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.RuinsInitAnimations ()

  ObjAnimate( "spr_ruins_bush", "ang", 1, 0, "", 
  {
    0.0, 3, -0.02,
    0.4, 3, 0.02,
    1.1, 3, -0.02
  } );

  ObjAnimate( "spr_ruins_light_2", "alp", 1, 0, "", 
  {
    0.0, 3, 1,
    1.4, 3, 0.6,
    2.7, 3, 0.9,
    4.0, 3, 0.5,
    5.5, 3, 1
  } );
  
end;
--*********************************************************************************************************************
function private.InteractiveMmgClk( number )

  local func_after = function ()

    if private.interactive.current_progres == 3 then

      private.InteractiveMmgWin();
      ObjSet( "spr_sheriffshouse_4_simpleton_mmg_piece_"..number.."_1", { input = false } );

    else

      private.interactive.current_progres = private.interactive.current_progres + 1;
      common_impl.Lock( false );
      ObjSet( "spr_sheriffshouse_4_simpleton_mmg_piece_"..number.."_1", { input = false } );

    end;

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_interactivebox_click_right", 0, "", 0 );

  if private.interactive.win_progres[ private.interactive.current_progres + 1 ] == tonumber( number ) then

    ObjAnimate( "spr_sheriffshouse_4_simpleton_mmg_piece_"..number.."_1", "alp", 0, 0, func_after, 
    {
      0.0, 3, 1,
      0.3, 3, 0,
    } );

  else 

    func_after = function() public.Reset( 'box' ); common_impl.PlayAudio( "sfx", "common/audio/aud_interactivebox_click_notright", 0, "", 0 ); end;
    ObjAnimate( "spr_sheriffshouse_4_simpleton_mmg_piece_"..number.."_1", "alp", 0, 0, func_after, 
    {
      0.0, 3, 1,
      0.3, 3, 0,
    } );    

  end;

end;
function private.InteractiveMmgWin()

  local func_after = function ()

    common_impl.Lock( false );
    ObjSet( "obj_sheriffshouse_4_simpleton_2_box_click", { input = true } );

  end;

  ObjSet( "anm_sheriffshouse_4_simpleton_2_mmg", { alp = 1 } );
  ObjSet( "obj_sheriffshouse_4_simpleton_mmg_pressed", { alp = 0 } );
  common_impl.PlayAudio( "sfx", "common/audio/aud_interactivebox_win", 0, "", 0 );

  AnimPlay( "anm_sheriffshouse_4_simpleton_2_mmg", "DoAnim", func_after );

end;

function private.InteractiveClkOver()

  local func_after = function ()

    common_impl.Lock( false );
    ObjSet( "spr_sheriffshouse_4_simpleton_mmg_amplifier", { input = true, active = true } );
    ObjSet( "obj_sheriffshouse_4_simpleton_mmg_opened", { input = true } );
    
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_interactivebox_click_button", 0, "", 0 );

  common_impl.Lock( true );
  ObjDelete( "obj_sheriffshouse_4_simpleton_2_box_click" );
  ObjAnimate( "spr_sheriffshouse_4_hasp1", "alp", 0, 0, "", 
  {
     0.0, 3, 1,
     0.3, 3, 0,
  } );
  ObjAnimate( "spr_sheriffshouse_4_simpleton_mmg_button", "alp", 0, 0, "", 
  {
     0.0, 3, 1,
     0.3, 3, 0,
  } );  
  ObjAnimate( "spr_sheriffshouse_4_hasp2", "alp", 0, 0, "", 
  {
     0.0, 3, 0,
     0.3, 3, 1,
     0.6, 3, 0
  } );
  ObjAnimate( "obj_sheriffshouse_4_simpleton_mmg_opened", "alp", 0, 0, "", 
  {
     0.0, 3, 0,
     0.3, 3, 0,
     0.6, 3, 1
  } );
  ObjAnimate( "obj_sheriffshouse_4_simpleton_mmg_over", "alp", 0, 0, func_after, 
  {
     0.0, 3, 1,
     0.3, 3, 1,
     0.6, 3, 0
  } );

end;

function public.Reset ( event )

  if event == 'box' or event == 'win_box' then
    
    local func_after = function ()

      common_impl.Lock( false );
      private.interactive.current_progres = 0;

    end;

      local table_insert = {}

      common_impl.Lock( true );

      for i = 1,4 do

        table.insert( table_insert, { "spr_sheriffshouse_4_simpleton_mmg_piece_"..i.."_1", { 
          input = true
         }} );

        ObjAnimate( "spr_sheriffshouse_4_simpleton_mmg_piece_"..i.."_1", "alp", 0, 0, func_after, 
        {
          0.0, 3, ObjGet( "spr_sheriffshouse_4_simpleton_mmg_piece_"..i.."_1" ).alp,
          0.3, 3, 1,
        } );
        func_after = "";

      end;
      ObjMultiSet( table_insert );

  end;

end;

function private.GetAmplifier( )

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  common_impl.DialogCharacterMmgHide( "simpleton_2", "dlg_sheriffshouse_4_simpleton_2_end"  );     
  common_impl.DialogCharacterHide();  

end;
function private.GetPackage( )

  common_impl.DialogCharacterMmgHide( "simpleton_2", "dlg_sheriffshouse_4_jack_end", nil, false  );     
  common_impl.DialogCharacterHide();  

end;
--*********************************************************************************************************************
function public.Skip( mg_name )

  private.GetAmplifier( )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************