-- name=rm_square_4
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_square_4";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_garage_4", "room_hub" );
  ObjAttach( "zz_entrance_4", "room_hub" );
  ObjAttach( "zz_oldman", "room_hub" );  
  ObjAttach( "zz_evilspirit", "room_hub" );
  private.interactive_mas = { 5,3,2,6,1,4 };
  private.Init_Subroom();
  table_multiset = {}
  for i = 1,5 do

    table.insert( table_multiset, { "spr_square_4_oldman_lamp_"..i, { 
      event_mdown = function() private.ClkInterractiveButton ( i ) end,
      event_menter = function() private.ButtonMouseEnterAnim( i ) end,
      event_mleave = function() private.ButtonMouseLeaveAnim( i ) end,
     }} );

  end;
  ObjMultiSet( table_multiset );
  ObjMultiSet({ 
    { "spr_garage_4_wrench_4", { event_mdown = private.get_wrench_4 }},
    { "spr_garage_4_nailpuller_4", { event_mdown = private.get_nailpuller_4 }},
    { "spr_garage_4_pruners", { event_mdown = private.get_pruners }},
    { "spr_garage_4_bagpiece_3", { event_mdown = private.get_bagpiece_3 }},
    { "spr_entrance_4_bagpiece_1", { event_mdown = private.get_bagpiece_1 }},
    { "spr_oldman_clip_4", { event_mdown = private.get_clip_4 }},
    { "spr_oldman_awl_4", { event_mdown = private.get_awl_4 }},
    { "spr_square_4_charmpiece_4", { event_mdown = private.get_charmpiece_4 }},
    { "obj_garage_4_use_oar", { event_mdown = private.clk_garage }},
    { "obj_evilspirit_use_lightcharm", { event_mdown = private.clk_evilspirit }},
    { "obj_garage_4_clk_garage_key", { event_mdown = private.clk_garage_key }},
    { "obj_vid_square_4_oldman", { event_mdown = private.vid_square_4_oldman } },
    { "obj_vid_square_4_oldman_focus", { event_mdown = private.vid_square_4_oldman } },
    { "spr_oldman_coin",        { event_mdown = private.get_collect_coin_34 }},
    { "spr_garage_4_coin",        { event_mdown = private.get_collect_coin_35 }},
    { "obj_square_4_clk_scare", { event_mdown = private.clk_scare } },
    { "obj_entrance_4_use_nailpuller_4", { event_mdown = private.entrance_clk_desk } },
    { "obj_square_4_oldman_clk_open", { event_mdown = private.oldman_mmg_clk } },
    { "spr_square_4_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_1_3" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_square_4_inv_extinctlantern", { event_mdown = function() private.GetLantern() end } },
    

  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_square_4 = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gzz_square_4_evilspirit",    
    "gzz_square_4_oldman",
    "gzz_square_4_entrance_4",
    "gzz_square_4_garage_4",
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  ObjAttach( "", "room_hub" );
  ObjAttach( "", "room_hub" );
  ObjAttach( "", "room_hub" );  
  ObjAttach( "", "room_hub" );

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_garage_4",
      "zz_entrance_4",
      "zz_oldman",
      "zz_evilspirit"
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;

  cmn.AddSubscriber( "update_game_mode_square_4", update_game_mode_square_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_square_4 = function ()

  local effects_table = 

  {
    "anm_square_4_anims",
    "anm_square_4_odlman",
    "anm_square_4_odlman_2",
    "anm_square_4_odlman_1",
    "anm_square_4_evilspirit",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_square_4", update_performance_mode_square_4, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_square_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_square_4" ] = {
    type = "click",
    use_place = "grm_fork_4_square_4",
    room = "rm_fork_4"
  };

  local opn_square_4_map = function ()

    common_impl.VisitMapRoom( "square_4" );

  end;
  cmn.AddSubscriber( "opn_square_4", opn_square_4_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_wrench_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_wrench_4" ] = {
    type = "get",
    get_obj = "spr_garage_4_wrench_4",
    room = private.room_objname,
    zz = "zz_garage_4",
    zz_gate = "gzz_square_4_garage_4"
  };
    
  local get_wrench_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_wrench_4", "spr_garage_4_wrench_4" );
  
  end;
  
  local get_wrench_4_closezz = function ()
  
    ObjDelete( "gfx_garage_4_wrench_4" );
    ObjDelete( "spr_garage_4_wrench_4_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_wrench_4", get_wrench_4_inv );
  cmn.AddSubscriber( "get_wrench_4", get_wrench_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_nailpuller_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_nailpuller_4" ] = {
    type = "get",
    get_obj = "spr_garage_4_nailpuller_4",
    room = private.room_objname,
    zz = "zz_garage_4",
    zz_gate = "gzz_square_4_garage_4"
  };
    
  local get_nailpuller_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_nailpuller_4", "spr_garage_4_nailpuller_4" );
  
  end;
  
  local get_nailpuller_4_closezz = function ()
  
    ObjDelete( "gfx_garage_4_nailpuller_4" );
    ObjDelete( "spr_garage_4_nailpuller_4_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_nailpuller_4", get_nailpuller_4_inv );
  cmn.AddSubscriber( "get_nailpuller_4", get_nailpuller_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_pruners () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_pruners" ] = {
    type = "get",
    get_obj = "spr_garage_4_pruners",
    room = private.room_objname,
    zz = "zz_garage_4",
    zz_gate = "gzz_square_4_garage_4"
  };
    
  local get_pruners_inv = function ()
  
    interface.InventoryItemAdd( "inv_pruners", "spr_garage_4_pruners" );
  
  end;
  
  local get_pruners_closezz = function ()
  
    ObjDelete( "gfx_garage_4_pruners" );
    
    if cmn.IsEventDone( "get_bagpiece_3" ) and common_impl.IsGetCoin( "get_coin_35" ) then 
      ObjDelete( "gzz_square_4_garage_4" );
    end;

  end;
  
  cmn.AddSubscriber( "get_pruners", get_pruners_inv );
  cmn.AddSubscriber( "get_pruners", get_pruners_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bagpiece_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bagpiece_3" ] = {
    type = "get",
    get_obj = "spr_garage_4_bagpiece_3",
    room = private.room_objname,
    zz = "zz_garage_4",
    zz_gate = "gzz_square_4_garage_4"
  };
    
  local get_bagpiece_3_inv = function ()
  
    interface.InventoryItemAdd( "inv_bagpiece_3", "spr_garage_4_bagpiece_3" );
  
  end;
  
  local get_bagpiece_3_closezz = function ()
  
    ObjDelete( "gfx_garage_4_bagpiece_3" );

    if cmn.IsEventDone( "get_pruners" ) and common_impl.IsGetCoin( "get_coin_35" ) then
      ObjDelete( "gzz_square_4_garage_4" );
    end;

  end;
  
  cmn.AddSubscriber( "get_bagpiece_3", get_bagpiece_3_inv );
  cmn.AddSubscriber( "get_bagpiece_3", get_bagpiece_3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_bagpiece_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_bagpiece_1" ] = {
    type = "get",
    get_obj = "spr_entrance_4_bagpiece_1",
    room = private.room_objname,
    zz = "zz_entrance_4",
    zz_gate = "gzz_square_4_entrance_4"
  };
    
  local get_bagpiece_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_bagpiece_1", "spr_entrance_4_bagpiece_1" );
  
  end;
  
  local get_bagpiece_1_closezz = function ()
  
    ObjDelete( "gfx_entrance_4_bagpiece_1" );
    ObjSet( "obj_entrance_4_use_nailpuller_4", { input = true } );
    ObjDelete( "spr_entrance_4_bagpiece_1_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_bagpiece_1", get_bagpiece_1_inv );
  cmn.AddSubscriber( "get_bagpiece_1", get_bagpiece_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_clip_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_clip_4" ] = {
    type = "get",
    get_obj = "spr_oldman_clip_4",
    room = private.room_objname,
    zz = "zz_oldman",
    zz_gate = "gzz_square_4_oldman"
  };
    
  local get_clip_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_clip_4", "spr_oldman_clip_4" );
    ObjSet( "inv_clip_4", { drag = false });
  
  end;
  
  local get_clip_4_closezz = function ()
  
    ObjDelete( "gfx_oldman_clip_4" );
    --ObjDelete( "gzz_square_4_oldman" );
  
  end;
  
  cmn.AddSubscriber( "get_clip_4", get_clip_4_inv );
  cmn.AddSubscriber( "get_clip_4", get_clip_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_awl_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_awl_4" ] = {
    type = "get",
    get_obj = "spr_oldman_awl_4",
    room = private.room_objname,
    zz = "zz_oldman",
    zz_gate = "gzz_square_4_oldman"
  };
    
  local get_awl_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_awl_4", "spr_oldman_awl_4" );
  
  end;
  
  local get_awl_4_closezz = function ()
  
    ObjDelete( "gfx_oldman_awl_4" );
    --ObjDelete( "gzz_square_4_oldman" );
  
  end;
  
  cmn.AddSubscriber( "get_awl_4", get_awl_4_inv );
  cmn.AddSubscriber( "get_awl_4", get_awl_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_charmpiece_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_charmpiece_4" ] = {
    type = "get",
    get_obj = "obj_square_4_seeker_4",
    room = private.room_objname
  };
    
  local get_charmpiece_4_inv = function ()
  
    interface.InventoryItemAdd( "inv_charmpiece_4", "obj_square_4_seeker_4" );
  
  end;
  
  local get_charmpiece_4_closezz = function ()
  
    ObjDelete( "gfx_square_4_charmpiece_4" );
    ObjDelete( "spr_square_4_charmpiece_4_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_charmpiece_4", get_charmpiece_4_inv );
  cmn.AddSubscriber( "get_charmpiece_4", get_charmpiece_4_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_34 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_34 = function ()
 
    ObjDelete( "obj_oldman_coin" );

    if cmn.IsEventDone( "use_salammoniaccotton" ) then

      ObjDelete( "gzz_square_4_oldman" );

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_34", get_collect_coin_34, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_coin_35 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_coin_35 = function ()
 
    ObjDelete( "obj_garage_4_coin" );

    if ( cmn.IsEventDone( "get_bagpiece_3" ) and cmn.IsEventDone( "get_pruners" ) ) then

      ObjDelete( "gzz_square_4_garage_4" );

    end;
    
  end;
  cmn.AddSubscriber( "get_coin_35", get_collect_coin_35, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_1_3 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_1_3 = function ()
  
    ObjDelete( "obj_square_4_morph" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_1_3", get_collect_morph_item_1_3, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_oar () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_oar" ] = {
    type = "use",
    inv_obj = "inv_oar",
    use_place = "obj_garage_4_use_oar",
    room = private.room_objname,
    zz = "zz_garage_4",
    zz_gate = "gzz_square_4_garage_4"
  };
  local use_oar_inv = function ()
  
    interface.InventoryItemRemove( "inv_oar" );
  
  end;
  local use_oar_beg = function ()
  
    ObjDelete( "obj_garage_4_use_oar" );
  
  end;
  local use_oar_end = function ()

    ObjMultiSet({

      { "spr_garage_4_nailpuller_4", { input = true, active = true } },
      { "obj_garage_4_use_toolkey", { input = true } },
      { "spr_square_4_garage_4_open", { alp = 1 } },

    });

    ObjDelete( "spr_garage_4_garagedoor_overlap" );
    ObjDelete( "anm_garage_4_paddle" )
    

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_oar", use_oar_beg, private.room_objname );
  cmn.AddSubscriber( "use_oar", use_oar_inv );
  cmn.AddSubscriber( "use_oar", use_oar_end, private.room_objname );
  cmn.AddSubscriber( "use_oar_inv", use_oar_inv, private.room_objname );
  cmn.AddSubscriber( "use_oar_beg", use_oar_beg, private.room_objname );
  cmn.AddSubscriber( "use_oar_end", use_oar_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_toolkey () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_toolkey" ] = {
    type = "use",
    inv_obj = "inv_toolkey",
    use_place = "obj_garage_4_use_toolkey",
    room = private.room_objname,
    zz = "zz_garage_4",
    zz_gate = "gzz_square_4_garage_4"
  };
  local use_toolkey_inv = function ()
  
    interface.InventoryItemRemove( "inv_toolkey" );
  
  end;
  local use_toolkey_beg = function ()
  
    ObjDelete( "obj_garage_4_use_toolkey" );
  
  end;
  local use_toolkey_end = function ()

    ObjSet( "obj_garage_4_clk_garage_key", { input = true } );
    ObjSet( "spr_garage_4_key", { alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_toolkey", use_toolkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_toolkey", use_toolkey_inv );
  cmn.AddSubscriber( "use_toolkey", use_toolkey_end, private.room_objname );
  cmn.AddSubscriber( "use_toolkey_inv", use_toolkey_inv, private.room_objname );
  cmn.AddSubscriber( "use_toolkey_beg", use_toolkey_beg, private.room_objname );
  cmn.AddSubscriber( "use_toolkey_end", use_toolkey_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_nailpuller_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_nailpuller_4" ] = {
    type = "use",
    inv_obj = "inv_nailpuller_4",
    use_place = "obj_entrance_4_use_nailpuller_4",
    room = private.room_objname,
    zz = "zz_entrance_4",
    zz_gate = "gzz_square_4_entrance_4"
  };
  local use_nailpuller_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_nailpuller_4" );
  
  end;
  local use_nailpuller_4_beg = function ()
  
    ObjDelete( "obj_entrance_4_use_nailpuller_4" );
  
  end;
  local use_nailpuller_4_end = function ()
  
    ObjDelete( "gzz_square_4_entrance_4" );
    ObjDelete( "anm_entrance_4_desk" );
    ObjDelete( "spr_square_4_entrance_4_close" );

    ObjMultiSet({
      { "grm_square_4_livingroom_4", { input = true, active = true } },
      { "spr_square_4_entrance_4_open", { alp = 1 } },
      { "spr_entrance_open_door", { alp = 1 } }
    } );
  
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_square_4_livingroom_4_focus");
    end;
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_nailpuller_4", use_nailpuller_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_nailpuller_4", use_nailpuller_4_inv );
  cmn.AddSubscriber( "use_nailpuller_4", use_nailpuller_4_end, private.room_objname );
  cmn.AddSubscriber( "use_nailpuller_4_inv", use_nailpuller_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_nailpuller_4_beg", use_nailpuller_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_nailpuller_4_end", use_nailpuller_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_pruners () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_pruners" ] = {
    type = "use",
    inv_obj = "inv_pruners",
    use_place = "obj_oldman_use_pruners",
    room = private.room_objname,
    zz = "zz_oldman",
    zz_gate = "gzz_square_4_oldman"
  };
  local use_pruners_inv = function ()
  
    interface.InventoryItemRemove( "inv_pruners" );
  
  end;
  local use_pruners_beg = function ()
  
    ObjDelete( "obj_oldman_use_pruners" );
  
  end;
  local use_pruners_end = function ()
 
    ObjDelete( "anm_oldman_static" );
    ObjDelete( "anm_oldman_pruners" ); 
    ObjDelete( "spr_oldman_bag_anim" ); 
    ObjDelete( "anm_square_4_odlman" ); 

    ObjMultiSet({ 
      { "obj_oldman_use_bagpiece", { input = true, visible = true }},
      { "obj_oldman_use_salammoniaccotton", { input = true, visible = true }},
      { "obj_oldman_bag", { alp = 1 }},
      { "anm_oldman_static_2", { alp = 1, playing = true }},
      { "anm_square_4_odlman_1", { alp = 1, playing = true }}
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_pruners", use_pruners_beg, private.room_objname );
  cmn.AddSubscriber( "use_pruners", use_pruners_inv );
  cmn.AddSubscriber( "use_pruners", use_pruners_end, private.room_objname );
  cmn.AddSubscriber( "use_pruners_inv", use_pruners_inv, private.room_objname );
  cmn.AddSubscriber( "use_pruners_beg", use_pruners_beg, private.room_objname );
  cmn.AddSubscriber( "use_pruners_end", use_pruners_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bagpiece_3 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bagpiece_3" ] = {
    type = "use",
    inv_obj = "inv_bagpiece_3",
    use_place = "obj_oldman_use_bagpiece",
    room = private.room_objname,
    zz = "zz_oldman",
    zz_gate = "gzz_square_4_oldman"
  };
  local use_bagpiece_3_inv = function ()
  
    interface.InventoryItemRemove( "inv_bagpiece_3" );
  
  end;
  local use_bagpiece_3_beg = function ()
  
    if ( cmn.IsEventDone( "use_bagpiece_1") and cmn.IsEventDone( "use_bagpiece_2") ) then

      ObjDelete( "obj_oldman_use_bagpiece" );

    end;

  end;
  local use_bagpiece_3_end = function ()
  
    ObjSet( "spr_oldman_elem_3", { alp = 1 });

    if cmn.IsEventDone( "use_bagpiece_1" ) and cmn.IsEventDone( "use_bagpiece_2" ) then

      ObjDelete( "spr_oldman_bag_close" );

      ObjMultiSet({ 
        { "spr_oldman_clip_4", { input = true, active = true, alp = 1 }},
        { "spr_oldman_awl_4", { input = true, active = true, alp = 1 }},
        { "obj_oldman_bag", { input = true }}
      });

    end;

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bagpiece_3", use_bagpiece_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_bagpiece_3", use_bagpiece_3_inv );
  cmn.AddSubscriber( "use_bagpiece_3", use_bagpiece_3_end, private.room_objname );
  cmn.AddSubscriber( "use_bagpiece_3_inv", use_bagpiece_3_inv, private.room_objname );
  cmn.AddSubscriber( "use_bagpiece_3_beg", use_bagpiece_3_beg, private.room_objname );
  cmn.AddSubscriber( "use_bagpiece_3_end", use_bagpiece_3_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bagpiece_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bagpiece_1" ] = {
    type = "use",
    inv_obj = "inv_bagpiece_1",
    use_place = "obj_oldman_use_bagpiece",
    room = private.room_objname,
    zz = "zz_oldman",
    zz_gate = "gzz_square_4_oldman"
  };
  local use_bagpiece_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_bagpiece_1" );
  
  end;
  local use_bagpiece_1_beg = function ()
  
    if ( cmn.IsEventDone( "use_bagpiece_2") and cmn.IsEventDone( "use_bagpiece_3") ) then

      ObjDelete( "obj_oldman_use_bagpiece" );

    end;
  
  end;
  local use_bagpiece_1_end = function ()
  
    ObjSet( "spr_oldman_elem_1", { alp = 1 });

    if cmn.IsEventDone( "use_bagpiece_2" ) and cmn.IsEventDone( "use_bagpiece_3" ) then

      ObjDelete( "spr_oldman_bag_close" );

      ObjMultiSet({ 
        { "spr_oldman_clip_4", { input = true, active = true, alp = 1 }},
        { "spr_oldman_awl_4", { input = true, active = true, alp = 1 }},
        { "obj_oldman_bag", { input = true }}
      });

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bagpiece_1", use_bagpiece_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_bagpiece_1", use_bagpiece_1_inv );
  cmn.AddSubscriber( "use_bagpiece_1", use_bagpiece_1_end, private.room_objname );
  cmn.AddSubscriber( "use_bagpiece_1_inv", use_bagpiece_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_bagpiece_1_beg", use_bagpiece_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_bagpiece_1_end", use_bagpiece_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_bagpiece_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_bagpiece_2" ] = {
    type = "use",
    inv_obj = "inv_bagpiece_2",
    use_place = "obj_oldman_use_bagpiece",
    room = private.room_objname,
    zz = "zz_oldman",
    zz_gate = "gzz_square_4_oldman"
  };
  local use_bagpiece_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_bagpiece_2" );
  
  end;
  local use_bagpiece_2_beg = function ()
  
    if ( cmn.IsEventDone( "use_bagpiece_1") and cmn.IsEventDone( "use_bagpiece_3") ) then

      ObjDelete( "obj_oldman_use_bagpiece" );

    end;
  
  end;
  local use_bagpiece_2_end = function ()
  
    ObjSet( "spr_oldman_elem_2", { alp = 1 });

    if cmn.IsEventDone( "use_bagpiece_1" ) and cmn.IsEventDone( "use_bagpiece_3" ) then

      ObjDelete( "spr_oldman_bag_close" );

      ObjMultiSet({ 
        { "spr_oldman_clip_4", { input = true, active = true, alp = 1 }},
        { "spr_oldman_awl_4", { input = true, active = true, alp = 1 }},
        { "obj_oldman_bag", { input = true }}
      });

    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_bagpiece_2", use_bagpiece_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bagpiece_2", use_bagpiece_2_inv );
  cmn.AddSubscriber( "use_bagpiece_2", use_bagpiece_2_end, private.room_objname );
  cmn.AddSubscriber( "use_bagpiece_2_inv", use_bagpiece_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_bagpiece_2_beg", use_bagpiece_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_bagpiece_2_end", use_bagpiece_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_salammoniaccotton () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_salammoniaccotton" ] = {
    type = "use",
    inv_obj = "inv_salammoniaccotton",
    use_place = "obj_oldman_use_salammoniaccotton",
    room = private.room_objname,
    zz = "zz_oldman",
    zz_gate = "gzz_square_4_oldman"
  };
  local use_salammoniaccotton_inv = function ()
  
    interface.InventoryItemRemove( "inv_salammoniaccotton" );
  
  end;
  local use_salammoniaccotton_beg = function ()
  
    ObjDelete( "obj_oldman_use_salammoniaccotton" );
  
  end;
  local use_salammoniaccotton_end = function ()
    
    if common_impl.IsGetCoin( "get_coin_34" ) then

      ObjDelete( "gzz_square_4_oldman" );

    end;

    ObjSet( "spr_square_4_inv_extinctlantern", { active = true, alp = 1 } );
    ObjDelete( "spr_square_4_oldman_man" );
    ObjDelete( "anm_oldman_ammonia" );
    ObjSet( "anm_square_4_odlman_2", { alp = 1 } );
    ObjDelete( "anm_oldman_static_2" );
    ObjDelete( "spr_square_4_inv_extinctlantern_shadow" );
    ObjDelete( "anm_square_4_odlman_1" );

  end;
  local use_salammoniaccotton_inv_add = function ()

    interface.InventoryItemAdd( "inv_extinctlantern", "spr_square_4_inv_extinctlantern" );
    ObjSet( "inv_extinctlantern", { drag = false } );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_salammoniaccotton", use_salammoniaccotton_beg, private.room_objname );
  cmn.AddSubscriber( "use_salammoniaccotton", use_salammoniaccotton_inv );
  cmn.AddSubscriber( "use_salammoniaccotton", use_salammoniaccotton_end );
  cmn.AddSubscriber( "use_salammoniaccotton", use_salammoniaccotton_inv_add );
  cmn.AddSubscriber( "use_salammoniaccotton_inv", use_salammoniaccotton_inv, private.room_objname );
  cmn.AddSubscriber( "use_salammoniaccotton_beg", use_salammoniaccotton_beg, private.room_objname );
  cmn.AddSubscriber( "use_salammoniaccotton_end", use_salammoniaccotton_end );
  cmn.AddSubscriber( "use_salammoniaccotton_end", use_salammoniaccotton_inv_add );
  --------------------------------------------------------------------------------------------
  -- function use_magiclantern_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_magiclantern_1" ] = {
    type = "use",
    inv_obj = "inv_magiclantern_1",
    use_place = "obj_square_4_use_magiclantern_1",
    room = private.room_objname
  };
  local use_magiclantern_1_inv = function ()
  
    interface.InventoryItemRemove( "inv_magiclantern_1" );
  
  end;
  local use_magiclantern_1_beg = function ()
  
    ObjDelete( "obj_square_4_use_magiclantern_1" );
    
  end;
  local use_magiclantern_1_end = function ()

    interface.InventoryItemAdd( "inv_extinctlantern2", "spr_square_4_extinctlantern" );
    ObjSet( "inv_extinctlantern2", { drag = false } );
  
  end;
  local use_magiclantern_1_end_loc = function ()
  
    ObjDelete( "anm_square_4_smoke" ); 
    ObjDelete( "anm_square_4_smoke_lantern" );   
    ObjDelete( "anm_square_4_smoke_dissapear" );
    ObjSet( "spr_square_4_extinctlantern", { alp = 1, active = true } );
    ObjSet( "grm_square_4_abandoneddistrict_4", { input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_square_4_abandoneddistrict_4_focus");
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magiclantern_1", use_magiclantern_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_magiclantern_1", use_magiclantern_1_inv );
  cmn.AddSubscriber( "use_magiclantern_1", use_magiclantern_1_end);
  cmn.AddSubscriber( "use_magiclantern_1", use_magiclantern_1_end_loc);
  cmn.AddSubscriber( "use_magiclantern_1_inv", use_magiclantern_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_magiclantern_1_beg", use_magiclantern_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_magiclantern_1_end", use_magiclantern_1_end );
  cmn.AddSubscriber( "use_magiclantern_1_end", use_magiclantern_1_end_loc );
  --------------------------------------------------------------------------------------------
  -- function use_lightcharm () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_lightcharm" ] = {
    type = "use",
    inv_obj = "inv_lightcharm",
    use_place = "obj_evilspirit_use_lightcharm",
    room = private.room_objname,
    zz = "zz_evilspirit",
    zz_gate = "gzz_square_4_evilspirit"
  };
  local use_lightcharm_inv = function ()
  
    interface.InventoryItemRemove( "inv_lightcharm" );
  
  end;
  local use_lightcharm_beg = function ()
  
    ObjDelete( "obj_evilspirit_use_lightcharm" );
  
  end;
  local use_lightcharm_end = function ()
  
    ObjDelete( "gzz_square_4_evilspirit" );
    ObjDelete( "anm_square_4_evilspirit" );
    ObjDelete( "obj_square_4_evilspirit_light" );
    ObjDelete( "vid_evilspirit_kill" );
    ObjDelete( "anm_evilspirit_hands_1" );
    ObjSet( "grm_square_4_sheriffshouse_4", { input = true, active = true } );
    if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_square_4_sheriffshouse_4_focus");
    end;
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_lightcharm", use_lightcharm_beg, private.room_objname );
  cmn.AddSubscriber( "use_lightcharm", use_lightcharm_inv );
  cmn.AddSubscriber( "use_lightcharm", use_lightcharm_end, private.room_objname );
  cmn.AddSubscriber( "use_lightcharm_inv", use_lightcharm_inv, private.room_objname );
  cmn.AddSubscriber( "use_lightcharm_beg", use_lightcharm_beg, private.room_objname );
  cmn.AddSubscriber( "use_lightcharm_end", use_lightcharm_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function clk_garage_key () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "clk_garage_key" ] = {

      type = "click",
      use_place = "obj_garage_4_clk_garage_key",
      room = private.room_objname,
      zz = "zz_garage_4",
      zz_gate = "gzz_square_4_zz_garage_4"
  };
  local clk_garage_key_beg = function ()

    ObjDelete( "obj_garage_4_clk_garage_key" );

  end;
  local clk_garage_key_end = function ()

    ObjDelete( "obj_garage_4_key" );

    ObjMultiSet({ 
      { "spr_garage_4_bagpiece_3",  { input = true     }},
      { "gfx_garage_4_bagpiece_3",  { active = true    }},
      { "spr_garage_4_pruners",     { input = true     }},
      { "gfx_garage_4_pruners",     { active = true    }}
    });

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "clk_garage_key", clk_garage_key_beg, private.room_objname );
  cmn.AddSubscriber( "clk_garage_key", clk_garage_key_end, private.room_objname  );
  cmn.AddSubscriber( "clk_garage_key_beg", clk_garage_key_beg, private.room_objname );
  cmn.AddSubscriber( "clk_garage_key_end", clk_garage_key_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function vid_square_4_oldman () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_square_4_oldman" ] = {

      type = "click",
      use_place = "obj_vid_square_4_oldman",
      room = private.room_objname
  };
  local vid_square_4_oldman_beg = function ()

    ObjDelete( "obj_vid_square_4_oldman" );

  end;
  local vid_square_4_oldman_end = function ()

    --

  end;

  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "vid_square_4_oldman", vid_square_4_oldman_beg, private.room_objname );
  cmn.AddSubscriber( "vid_square_4_oldman", vid_square_4_oldman_end, private.room_objname  );
  cmn.AddSubscriber( "vid_square_4_oldman_beg", vid_square_4_oldman_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_square_4_oldman_end", vid_square_4_oldman_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function vid_evilspirit_scare () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_evilspirit_scare" ] = {

      type = "click",
      use_place = "obj_square_4_clk_scare",
      room = private.room_objname,
      --zz = "zz_evilspirit",
      --zz_gate = "gzz_square_4_evilspirit"
  };
  local vid_evilspirit_scare_beg = function ()

    ObjDelete( "obj_square_4_clk_scare" );

  end;
  local vid_evilspirit_scare_end = function ()

    ObjDelete( "vid_evilspirit_scare" );
    ObjSet( "obj_square_4_evilspirit", { active = true, visible = true } );

  end;

  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "vid_evilspirit_scare", vid_evilspirit_scare_beg, private.room_objname );
  cmn.AddSubscriber( "vid_evilspirit_scare", vid_evilspirit_scare_end, private.room_objname  );
  cmn.AddSubscriber( "vid_evilspirit_scare_beg", vid_evilspirit_scare_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_evilspirit_scare_end", vid_evilspirit_scare_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function use_seeker_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_seeker_4" ] = {
    type = "use",
    inv_obj = "inv_seeker",
    use_place = "obj_square_4_seeker_4",
    room = private.room_objname
  };
  local use_seeker_4_inv = function ()
  
    if ( cmn.IsEventDone( "use_seeker_1") and cmn.IsEventDone( "use_seeker_2") and
    cmn.IsEventDone( "use_seeker_3") and cmn.IsEventDone( "use_seeker_5")) then

      interface.InventoryItemRemove( "inv_seeker" );

    end;

  end;
  local use_seeker_4_beg = function ()
  
    --
  
  end;
  local use_seeker_4_end = function ()
  
    ObjSet( "obj_square_4_seeker_4", { input = true, visible = true, active = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_seeker_4", use_seeker_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_seeker_4", use_seeker_4_inv );
  cmn.AddSubscriber( "use_seeker_4", use_seeker_4_end, private.room_objname );
  cmn.AddSubscriber( "use_seeker_4_inv", use_seeker_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_seeker_4_beg", use_seeker_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_seeker_4_end", use_seeker_4_end, private.room_objname );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_evilspirit" );
  
  function zz_evilspirit.PreOpen()

    common_impl.StopAudio( "env", "common/audio/aud_evilspirit_zz_env", 0.2 );
    common_impl.PlayAudio( "env", "common/audio/aud_evilspirit_loc_env", 1, "", 0 );

  end;

  function zz_evilspirit.Open()

  end;

  function zz_evilspirit.Close()

    if not cmn.IsEventDone( "use_lightcharm" ) then

      common_impl.StopAudio( "env", "common/audio/aud_evilspirit_loc_env", 0.2 );

    end;
    common_impl.PlayAudio( "env", "common/audio/aud_evilspirit_zz_env", 1, "", 0 );

  end;

  subroom.Define( "zz_oldman" );

  function zz_oldman.PreOpen()

    if ( not cmn.IsEventDone( "use_pruners" ) ) then

      common_impl.StopAudio( "env", "common/audio/aud_old_man_trapped_loc_env", 0.2 );
      common_impl.PlayAudio( "env", "common/audio/aud_old_man_trapped_zz_env", 1, "", 0 );

    end;
    
  end;

  function zz_oldman.Close()

    common_impl.StopAudio( "env", "common/audio/aud_old_man_trapped_zz_env", 0.2 );

    if not cmn.IsEventDone( "use_pruners" ) then

      common_impl.PlayAudio( "env", "common/audio/aud_old_man_trapped_loc_env", 1, "", 0 );

    end;

  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_square_4();
  
  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.MorphItemMorphing();

  if ( not cmn.IsEventDone( "vid_square_4_oldman" ) ) then

    common_impl.PlayTimer( private.vid_square_4_oldman );

  else

  end;

  common_impl.EnvPlay( { "common/audio/aud_square_4_env" }, "", 0.5 );

  if ( not cmn.IsEventDone( "use_magiclantern_1" ) ) then

    common_impl.PlayAudio( "env", "common/audio/aud_smoke_env", 1, "", 0 );

  end;

  if ( not cmn.IsEventDone( "use_pruners" ) ) then

    common_impl.PlayAudio( "env", "common/audio/aud_old_man_trapped_loc_env", 1, "", 0 );

  end;

  if ( not cmn.IsEventDone( "use_lightcharm" ) and cmn.IsEventDone( "vid_evilspirit_scare" ) ) then

    common_impl.PlayAudio( "env", "common/audio/aud_evilspirit_loc_env", 1, "", 0 );

  end;
end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );

  if ( not cmn.IsEventDone( "use_pruners" ) ) then

    common_impl.StopAudio( "env", "common/audio/aud_old_man_trapped_loc_env", 0.2 );

  end;

  if ( not cmn.IsEventDone( "use_lightcharm" ) ) then

    common_impl.StopAudio( "env", "common/audio/aud_evilspirit_loc_env", 0.2 );

  end;

  if ( not cmn.IsEventDone( "use_magiclantern_1" ) ) then

    common_impl.StopAudio( "env", "common/audio/aud_smoke_env", 0.2 );

  end;
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_oar()

  local item = "inv_oar";

  if ( common.ApplyObj( item, "obj_garage_4_use_oar", true ) ) then

    cmn.CallEventHandler( "use_oar_inv" );
    cmn.CallEventHandler( "use_oar_beg" );

    local func_after = function ()
      
      common_impl.Lock( false );
      cmn.SetEventDone( "use_oar" );
      cmn.CallEventHandler( "use_oar_end" );
    --common.CloseSubRoom();;
    
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_oar", 0, "", 0 );
    
    ObjMultiSet({

       { "spr_garage_4_garagedoor_overlap", { alp = 0 } },
       { "anm_garage_4_paddle", { playing = true, endtrig = func_after, alp = 1 }  },

    });
    return true;
  
  elseif common.ApplyObj( item, "gzz_square_4_garage_4", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_garage_4", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_toolkey()

  local item = "inv_toolkey";

  if ( common.ApplyObj( item, "obj_garage_4_use_toolkey", true ) ) then

    cmn.CallEventHandler( "use_toolkey_inv" );
    cmn.CallEventHandler( "use_toolkey_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_toolkey" );
      cmn.CallEventHandler( "use_toolkey_end" );
    --common.CloseSubRoom();;
    
    end;

    common_impl.Lock( true );
    func_after();

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_toolkey", 0, "", 0 );
  
    ObjAnimate( "spr_garage_4_key", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0
    } );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_square_4_garage_4", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_garage_4", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_nailpuller_4()

  local item = "inv_nailpuller_4";

  if ( common.ApplyObj( item, "obj_entrance_4_use_nailpuller_4", true ) and cmn.IsEventDone( "get_bagpiece_1" ) ) then

    cmn.CallEventHandler( "use_nailpuller_4_inv" );
    cmn.CallEventHandler( "use_nailpuller_4_beg" );

    local func_after = function ()
  
      local func_after_end = function ()

        common_impl.Lock( false );
        cmn.SetEventDone( "use_nailpuller_4" );
        cmn.CallEventHandler( "use_nailpuller_4_end" );
        common.CloseSubRoom();

      end;

      ObjAnimate( "spr_entrance_open_door", "alp", 0, 0, func_after_end,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_nailpuller", 0, "", 0 );

    ObjMultiSet({
      
      { "anm_entrance_4_desk_clk", { visible = false } },
      { "anm_entrance_4_desk", { visible = true } },
    
    })

    AnimPlay( "anm_entrance_4_desk", "DoAnim", func_after );

    return true;
  
  elseif ( common.ApplyObj( item, "gzz_square_4_entrance_4", false ) and cmn.IsEventDone( "get_bagpiece_1" ) ) then
 
    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_entrance_4", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_pruners()

  local item = "inv_pruners";

  if ( common.ApplyObj( item, "obj_oldman_use_pruners", true ) ) then

    cmn.CallEventHandler( "use_pruners_inv" );
    cmn.CallEventHandler( "use_pruners_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_pruners" );
      cmn.CallEventHandler( "use_pruners_end" );
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_pruners", 0, "", 0 );

    ObjSet( "anm_oldman_static", { alp = 0 });
    ObjSet( "anm_oldman_pruners", { alp = 1 });
    AnimPlay( "anm_oldman_pruners", "DoAnim", func_after );
    common_impl.StopAudio( "env", "common/audio/aud_old_man_trapped_zz_env", 0.2 );
    ObjAnimate( "spr_oldman_bag_anim", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      2.5, 0, 1.0, 
      2.8, 0, 0.0
    } );
 
    ObjAnimate( "obj_oldman_bag", "alp", 0, 0, "",
    { 
      0.0, 0, 0.0, 
      2.5, 0, 0.0,
      2.8, 0, 1.0
    } );

    return true;
  
  elseif common.ApplyObj( item, "gzz_square_4_oldman", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_oldman", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bagpiece_3()

  local item = "inv_bagpiece_3";

  if ( common.ApplyObj( item, "obj_oldman_use_bagpiece", true ) and cmn.IsEventDone( "use_pruners" ) ) then

    cmn.CallEventHandler( "use_bagpiece_3_inv" );
    cmn.CallEventHandler( "use_bagpiece_3_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_bagpiece_3" );
      cmn.CallEventHandler( "use_bagpiece_3_end" );
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_bagpiece", 0, "", 0 );
  
    if ( cmn.IsEventDone( "use_bagpiece_1" ) and cmn.IsEventDone( "use_bagpiece_2" ) ) then

      common_impl.PlayAudio( "sfx", "common/audio/aud_oldman_bag_open", 0, "", 0 );

      ObjAnimate( "spr_oldman_elem_3", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      ObjAnimate( "spr_oldman_bag_close", "alp", 0, 0, func_after,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 1.0,
        0.6, 0, 0.0
      } );

    else 

      ObjAnimate( "spr_oldman_elem_3", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

    end;
  
    return true;
  
  elseif ( common.ApplyObj( item, "gzz_square_4_oldman", false ) and cmn.IsEventDone( "use_pruners" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_oldman", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bagpiece_1()

  local item = "inv_bagpiece_1";

  if ( common.ApplyObj( item, "obj_oldman_use_bagpiece", true ) and cmn.IsEventDone( "use_pruners" )) then

    cmn.CallEventHandler( "use_bagpiece_1_inv" );
    cmn.CallEventHandler( "use_bagpiece_1_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_bagpiece_1" );
      cmn.CallEventHandler( "use_bagpiece_1_end" );
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_bagpiece", 0, "", 0 );
  
    if ( cmn.IsEventDone( "use_bagpiece_2" ) and cmn.IsEventDone( "use_bagpiece_3" ) ) then

      common_impl.PlayAudio( "sfx", "common/audio/aud_oldman_bag_open", 0, "", 0 );

      ObjAnimate( "spr_oldman_elem_1", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      ObjAnimate( "spr_oldman_bag_close", "alp", 0, 0, func_after,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 1.0,
        0.6, 0, 0.0
      } );

    else 

      ObjAnimate( "spr_oldman_elem_1", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

    end;

    return true;
  
  elseif ( common.ApplyObj( item, "gzz_square_4_oldman", false ) and cmn.IsEventDone( "use_pruners" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_oldman", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_bagpiece_2()

  local item = "inv_bagpiece_2";

  if ( common.ApplyObj( item, "obj_oldman_use_bagpiece", true ) and cmn.IsEventDone( "use_pruners" ) ) then

    cmn.CallEventHandler( "use_bagpiece_2_inv" );
    cmn.CallEventHandler( "use_bagpiece_2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_bagpiece_2" );
      cmn.CallEventHandler( "use_bagpiece_2_end" );
    
    end;

    common_impl.Lock( true );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_bagpiece", 0, "", 0 );
  
    if ( cmn.IsEventDone( "use_bagpiece_1" ) and cmn.IsEventDone( "use_bagpiece_3" ) ) then

      common_impl.PlayAudio( "sfx", "common/audio/aud_oldman_bag_open", 0, "", 0 );

      ObjAnimate( "spr_oldman_elem_2", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

      ObjAnimate( "spr_oldman_bag_close", "alp", 0, 0, func_after,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 1.0,
        0.6, 0, 0.0
      } );

    else 

      ObjAnimate( "spr_oldman_elem_2", "alp", 0, 0, func_after,
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );

    end;
  
    return true;
  
  elseif ( common.ApplyObj( item, "gzz_square_4_oldman", false ) and cmn.IsEventDone( "use_pruners" ) ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_oldman", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_salammoniaccotton()

  local item = "inv_salammoniaccotton";

  if ( common.ApplyObj( item, "obj_oldman_use_salammoniaccotton", true ) ) then

    cmn.CallEventHandler( "use_salammoniaccotton_inv" );
    cmn.CallEventHandler( "use_salammoniaccotton_beg" );
    local func_after = function ()  

      common_impl.AddPageDiary( 13 );

      common_impl.Lock( false );

      common.CloseSubRoom();
    
      ObjSet( "anm_square_4_odlman_1", { alp = 0 } );
      ObjSet( "tmr_square_4_dialog", { playing = true, time = 0.1, endtrig = private.dlg_square_4_oldman } );

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_cotton_with_salmiac", 0, "", 0 );

    common_impl.Lock( true );
    ObjSet( "anm_oldman_static_2", { alp = 0 } );
    ObjSet( "anm_oldman_ammonia", { alp = 1 } );
    AnimPlay( "anm_oldman_ammonia", "DoAnim", func_after );
    
    return true;
  
  elseif common.ApplyObj( item, "gzz_square_4_oldman", false ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_oldman", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_magiclantern()

  local item = "inv_magiclantern_1";

  if ( common.ApplyObj( item, "obj_square_4_use_magiclantern_1", false ) ) then

    cmn.CallEventHandler( "use_magiclantern_1_inv" );
    cmn.CallEventHandler( "use_magiclantern_1_beg" );
    common_impl.StopAudio( "env", "common/audio/aud_smoke_env", 0.2 );
    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_magiclantern_1" );
      cmn.CallEventHandler( "use_magiclantern_1_end" );
          
    end;

    common_impl.Lock( true );
    
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_magiclantern_1", 0, "", 0 );
  
    ObjAnimate( "anm_square_4_smoke", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      2.0, 0, 1.0,
      2.5, 0, 0.0
    } );
    ObjSet( "anm_square_4_smoke_lantern", { visible = true } );
    AnimPlay( "anm_square_4_smoke_lantern", "DoAnim", "" );
    ObjSet( "anm_square_4_smoke_dissapear", { visible = true } );
    AnimPlay( "anm_square_4_smoke_dissapear", "DoAnim", func_after );
    common_impl.PlayAudio( "sfx", "common/audio/aud_magic_lantern_use", 0, "", 0 );
    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_lightcharm()

  local item = "inv_lightcharm";

  if ( common.ApplyObj( item, "obj_evilspirit_use_lightcharm", true ) and cmn.IsEventDone( "vid_evilspirit_scare" ) ) then

    cmn.CallEventHandler( "use_lightcharm_inv" );
    cmn.CallEventHandler( "use_lightcharm_beg" );
    common_impl.StopAudio( "env", "common/audio/aud_evilspirit_zz_env", 0.2 );
    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_lightcharm" );
      cmn.CallEventHandler( "use_lightcharm_end" );
      common.CloseSubRoom();
      interface.KeyTaskDone( true );
      common_impl.ShowBbt( 'bbt_evilspirit_win' );

    end;

    common_impl.Lock( true );

    ObjSet( "vid_evilspirit_kill", { alp = 1 });
    ObjSet( "anm_evilspirit_static", { alp = 0 });

    VidPlay( "vid_evilspirit_kill", func_after )
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_lightcharm", 0, "", 0 );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_square_4_evilspirit", false ) and cmn.IsEventDone( "vid_evilspirit_scare" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_evilspirit", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_seeker_4()

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "use_seeker_4" );
    cmn.CallEventHandler( "use_seeker_4_end" );
    cmn.CallEventHandler( "use_seeker_4_inv" );
  
  end;

  common_impl.Lock( true );
  func_after();

  return true;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_wrench_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_wrench_4" );
  cmn.CallEventHandler( "get_wrench_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_nailpuller_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_nailpuller_4" );
  cmn.CallEventHandler( "get_nailpuller_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_pruners()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_pruners" );
  cmn.CallEventHandler( "get_pruners" );

  if cmn.IsEventDone( "get_bagpiece_3" ) and common_impl.IsGetCoin( "get_coin_35" ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_bagpiece_3()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_bagpiece_3" );
  cmn.CallEventHandler( "get_bagpiece_3" );

  if cmn.IsEventDone( "get_pruners" ) and common_impl.IsGetCoin( "get_coin_35" ) then
    common.CloseSubRoom();
  end;

end;
--------------------------------------------------------------------------------------------
function private.get_bagpiece_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_bagpiece_1" );
  cmn.CallEventHandler( "get_bagpiece_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_clip_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_clip_4" );
  cmn.CallEventHandler( "get_clip_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_awl_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_awl_4" );
  cmn.CallEventHandler( "get_awl_4" );

end;
--------------------------------------------------------------------------------------------
function private.get_charmpiece_4()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_charmpiece_4" );
  cmn.CallEventHandler( "get_charmpiece_4" );

end;
--------------------------------------------------------------------------------------------
function private.GetLantern( )

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  common_impl.DialogCharacterMmgHide( "oldman", "dlg_square_4_oldman_end"  );     
  common_impl.DialogCharacterHide();  

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_garage()

  local func_after = function ()

    common_impl.Lock( false );
    common_impl.ShowBbt( 'bbt_garage_4_use_oar' );

  end;

  local posy = ObjGet( "spr_garage_4_garagedoor_overlap" ).pos_y

  common_impl.Lock( true );
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_garage_door", 0, "", 0.5 );

  ObjAnimate( "spr_garage_4_garagedoor_overlap", "pos_y", 0, 0, func_after,
  { 
    0.0, 0, posy, 
    0.2, 0, posy-5,
    0.4, 0, posy
  } );

end;
--*********************************************************************************************************************
function private.clk_evilspirit()

  local func_after = function ()

    ObjSet( "anm_evilspirit_hands_1", { alp = 1 } );
    ObjSet( "anm_evilspirit_hands_2", { alp = 0 } );
    common_impl.Lock( false );
    common_impl.ShowBbt( 'bbt_evilspirit_use_lightcharm' );

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_evilspirit_attack", 0, "", 0 );

  ObjSet( "anm_evilspirit_hands_1", { alp = 0 } );
  ObjSet( "anm_evilspirit_hands_2", { alp = 1 } );
  AnimPlay( "anm_evilspirit_hands_2", "DoAnim", func_after );

end;
--*********************************************************************************************************************

--*********************************************************************************************************************
function private.clk_garage_key()

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "clk_garage_key" );
    cmn.CallEventHandler( "clk_garage_key_end" );

  end;

  cmn.CallEventHandler( "clk_garage_key_beg" );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_toolkey", 0, "", 0.5 );

  common_impl.Lock( true );

  ObjAnimate( "spr_garage_4_key", "alp", 0, 0, "",
  { 
    0.0, 0, 1, 
    0.3, 0, 0
  } );
  ObjAnimate( "spr_garage_4_key_2", "alp", 0, 0, "",
  { 
    0.0, 0, 0, 
    0.3, 0, 1
  } );
  ObjAnimate( "obj_garage_4_key", "alp", 0, 0, "",
  { 
    0.0, 0, 1,
    0.3, 0, 1,
    0.6, 0, 0
  } );
  ObjAnimate( "spr_garage_4_key_overlap", "alp", 0, 0, "",
  { 
    0.0, 0, 1,
    0.3, 0, 1,
    0.6, 0, 0
  } );
  ObjAnimate( "spr_garage_4_closeddoor_over", "alp", 0, 0, func_after,
  { 
    0.0, 0, 1,
    0.3, 0, 1,
    0.6, 0, 0
  } );

end;
--*********************************************************************************************************************
function private.ClkInterractiveButton( number )

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_casket_mosaic_click", 0, "", 0 );

    local number_1 = private.interactive_mas[ number ];
    local number_2 = private.interactive_mas[ number + 1 ];
    local obj1_posx = ObjGet( "spr_square_4_oldman_chest_section"..number_2 ).pos_x;
    --local obj1_posy = ObjGet( "spr_square_4_oldman_chest_section"..private.first_button ).pos_y;
    local obj2_posx = ObjGet( "spr_square_4_oldman_chest_section"..number_1 ).pos_x;
    --local obj2_posy = ObjGet( "spr_square_4_oldman_chest_section"..number ).pos_y;

    local func_after = function()

      private.first_button = 0;
      local win = true
      for i = 1,5 do

        if ObjGet( "spr_square_4_oldman_chest_section"..i ).pos_x > ObjGet( "spr_square_4_oldman_chest_section"..(i + 1) ).pos_x then

          win = false
          common_impl.Lock( false );
          break;

        end;
        
        
      end;

      if win then

        private.OdlmanMmgWin();

      end;

      local temp = private.interactive_mas[ number ];
      private.interactive_mas[ number ] = private.interactive_mas[ number + 1 ];
      private.interactive_mas[ number + 1 ] = temp;

    end;


    common_impl.Lock( true );
    ObjAnimate( "spr_square_4_oldman_lamp_"..number.."_add", "alp", 0, 0, "",
    { 
      0.0, 0, 1,
      0.3, 0, 0
    } );
    ObjAnimate( "spr_square_4_oldman_chest_section"..number_2, "pos_x", 0, 0, "",
    { 
      0.0, 0, obj1_posx,
      0.3, 0, obj1_posx,
      0.8, 0, obj2_posx
    } );

    ObjAnimate( "spr_square_4_oldman_chest_section"..number_1, "pos_x", 0, 0, func_after,
    { 
      0.0, 0, obj2_posx,
      0.3, 0, obj2_posx,
      0.8, 0, obj1_posx
    } );

--  else
--
--    local func_after = function()
--
--      private.first_button = number;
--
--    end;

    --ObjAnimate( "spr_square_4_oldman_lamp_"..number.."_add", "alp", 0, 0, func_after,
    --{ 
    --  0.0, 0, 1,
    --  0.3, 0, 0
    --} );


  --end;

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.get_collect_coin_34()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_34" );
    cmn.CallEventHandler( "get_coin_34" );

    if ( cmn.IsEventDone( "use_salammoniaccotton" ) ) then
    
      common.CloseSubRoom();

    end;

  end;

  common_impl.PlayEffectHO( "spr_oldman_coin", func_after ); 

end;
--*********************************************************************************************************************
function private.get_collect_coin_35()

  local func_after = function ()
    
    common_impl.GetCoinDone( "get_coin_35" );
    cmn.CallEventHandler( "get_coin_35" );

    if ( cmn.IsEventDone( "get_bagpiece_3" ) and cmn.IsEventDone( "get_pruners" ) ) then
   
      common.CloseSubRoom();

    end;

  end;

  common_impl.PlayEffectHO( "spr_garage_4_coin", func_after ); 

end;
--*********************************************************************************************************************
function private.opn_square_4()

  if not ( cmn.IsEventDone( "opn_square_4" ) ) then
    cmn.SetEventDone( "opn_square_4" );
  end;
  
  cmn.CallEventHandler( "opn_square_4" ); 

end;
--*********************************************************************************************************************
function private.clk_scare()
    
  ObjSet( "vid_evilspirit_scare", { alp = 1, active = true, input = false, visible = true } );
  ObjSet( private.room_objname, { input = false } );
  ObjAttach( "vid_evilspirit_scare", private.room_objname );
  cmn.CallEventHandler( "vid_evilspirit_scare_beg" );  

  local func_after = function ( skip )

    interface.DialogVideoHide();
    ObjSet( private.room_objname, { input = true } );
    cmn.SetEventDone( "vid_evilspirit_scare" );
    cmn.CallEventHandler( "vid_evilspirit_scare_end" );
    common_impl.ShowBbt( 'bbt_evilspirit_after_scare', 1 );
    common_impl.PlayAudio( "env", "common/audio/aud_evilspirit_loc_env", 1, "", 0 );

    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_evilspirit_scare", 0.2 );

    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment1_mus", 0, "", 0 );

  end;
  
  common_impl.StopAllMus();
  common_impl.PlayAudio( "sfx", "common/audio/aud_evilspirit_scare", 0, "", 0.5 );
  interface.DialogVideoShow( "vid_evilspirit_scare", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_evilspirit_scare",  function() func_after( nil ); end ); 

end;
function private.vid_square_4_oldman()

  cmn.CallEventHandler( "vid_square_4_oldman_beg" );
  ObjSet( "vid_square_4_oldman", { alp = 1, active = true, input = false, visible = true } );

  local widget_settings = {}

  if IsCollectorsEdition() then

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnGuide,
      InterfaceWidget_BtnMenu
    }

  else

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnMenu
    }

  end;
  
  local func_after = function ( skip )

    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_area_oulmen_danger", 0.2 );
      
    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_danger1_mus", 0, "", 0 );

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_square_4_oldman" );
    cmn.CallEventHandler( "vid_square_4_oldman_end" );

    common_impl.ShowBbt( 'bbt_square_4_after_oldman', 1 );

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

    interface.KeyTaskDone( true );
    interface.KeyTaskAdd( 'save_oldman' ); 

  end;

  for i = 1, #widget_settings do

    interface.WidgetSetVisible( widget_settings[i], 0 );

  end;
  common_impl.StopAllMus();
  interface.DialogVideoShow( "vid_square_4_oldman", 1, function() func_after( 'skip' ); end, 3 );
  common_impl.PlayAudio( "sfx", "common/audio/aud_area_oulmen_danger", 0, "", 0.5 );
  VidPlay( "vid_square_4_oldman", function() func_after( nil ); end ); 

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.ClkOldmanDial()

  ObjSet( "spr_int_dialog_character_bot", { alp = 0 } );
  ObjSet( "txt_int_dialog_character", { alp = 0 } );

  common_impl.DialogCharacterMmgShow( "oldman", 850, 400, nil, nil, nil, "oldman"  );
  ObjSet( "int_button_guide", { alp = 1, input = true } );
  ObjSet( "int_button_menu", { alp = 1, input = true } );
  ObjAnimate( "obj_square_4_oldman_oldman", "color_rgb", 0, 0, "", { 0,0,1,1,1, 0.3,0,0.5,0.5,0.5 } );
  ObjAnimate( "obj_square_4_oldman_mmg", "color_rgb", 0, 0, "", { 0,0,0.4,0.4,0.4, 0.3,0,1,1,1 } );
--  ObjAnimate( "obj_square_4_oldman_oldman", "scale_xy", 0, 0, "", { 0,0,1.05,1.05, 0.3,0,1,1 } );
--
  ObjSet( "anm_square_4_oldman_2", { alp = 0 } );
  ObjSet( "anm_square_4_oldman_oldman", { alp = 1 } );

end;
--------------------------------------------------------------------------------------------
function private.OdlmanMmgWin()

  ObjSet( "obj_square_4_oldman_clk_open", { input = true } );
  common_impl.Lock( false );

end;
--------------------------------------------------------------------------------------------
function private.oldman_mmg_clk()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_casket_mosaic_win", 0, "", 0 );

  local func_after = function ()

    ObjDelete( "obj_square_4_oldman_clk_open" );
    common_impl.Lock( false );
    ObjSet( "obj_square_4_oldman_chest_section_light", { input = false }  );
    ObjSet( "obj_square_4_oldman_chest_open", { input = true } );

  end;

  common_impl.Lock( true );

  ObjAnimate( "obj_square_4_oldman_chest_open", "alp", 0, 0, func_after,
  {
    0.0, 0, 0.0,
    0.3, 0, 1.0
  } );

end;
--*******************************************************************************************************************
function private.dlg_square_4_oldman()

  ObjAttach( "dlg_square_4_oldman", private.room_objname );
  common_impl.continue_visible = false; 
  ObjSet( "tmr_square_4_dialog", { playing = false } );
  --common_impl.dialog_character_loc = "obj_square_4_oldman_characters";
  common_impl.DialogCharacterStart( "oldman", 4, nil, nil, true, "dlg_square_4_oldman_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_square_4_oldman_end()

  if ng_global.progress[ "ext" ][ "win_oldman" ] then

    cmn.MiniGameHide( "oldman" );

  end;
  cmn.SetEventDone( "use_salammoniaccotton" );
  cmn.CallEventHandler( "use_salammoniaccotton_end" );
  ObjSet( "spr_int_dialog_character_bot", { alp = 1 } );
  ObjSet( "txt_int_dialog_character", { alp = 1 } );
  ObjAttach( "obj_square_4_oldman_mmg", "obj_square_4_oldman_oldman" );
  ObjSet( "obj_square_4_oldman_mmg", { alp = 0, input = false } );
  interface.KeyTaskDone( true );
  interface.KeyTaskAdd( 'save_robin' );
  ObjSet( "obj_int_dialog_character", { alp  = 1 } ); 
  
  common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0, "", 0 );

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if dlg_name == "oldman" then
  
    if count_txt == 1 then 

      common_impl.continue_visible = false;
      common_impl.frases = { 1 }; 
      common_impl.dial_icons = { 'interrogation' };
      common_impl.DialogCharacterShowDialogQuestions( 1, 4 );
     
--    elseif count_txt == 2 then 
--
--      --common_impl.continue_visible = false;
--      --common_impl.frases = { 3 }; 
--      --common_impl.dial_icons = { 'owlman' };
--      --common_impl.DialogCharacterShowDialogQuestions( 1 );

    elseif count_txt == 3 then 

      ObjSet( "anm_square_4_oldman_2", { alp = 1 } );
      ObjSet( "anm_square_4_oldman_oldman", { alp = 0 } );
      common_impl.PlayAudio( "sfx", "common/audio/aud_get_to_us", 0, "", 0 );
      ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = private.ClkOldmanDial } );
        
    end;

  end;  

end;
--********************************************************************************************************************
--******************************************************************************************
function private.ButtonMouseLeaveAnim( button )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_square_4_oldman_lamp_"..button.."_arrow_1_add";
  local obj2 = "spr_square_4_oldman_lamp_"..button.."_arrow_2_add";
  local alp = ObjGet( obj ).alp;
  local tme = alp * 0.5;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );
  ObjAnimate( obj2, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

end;
--******************************************************************************************
function private.ButtonMouseEnterAnim( button )

  SetCursor( CURSOR_HAND );

  local obj = "spr_square_4_oldman_lamp_"..button.."_arrow_1_add";
  local obj2 = "spr_square_4_oldman_lamp_"..button.."_arrow_2_add";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * 0.5;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );
  ObjAnimate( obj2, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

end;
--******************************************************************************************
function private.entrance_clk_desk()

  common_impl.ShowBbt( 'bbt_entrance_4_use_nailpuller_4' );

  local endfunc = function ()

    common_impl.Lock( false );

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_closed_door_plank", 0, "", 0 );

  ObjSet( "anm_entrance_4_desk_clk", { playing = true, endtrig = endfunc } );

end;
--******************************************************************************************
function public.Skip( mg_name )

  private.GetLantern( )

end;
--******************************************************************************************
function public.Reset()

  local param = { 5, 3, 2, 6, 1, 4 };

  local new_pos = -623

  for i = 1,6 do
    private.interactive_mas[ i ] =  param[i];
    ObjSet( "spr_square_4_oldman_chest_section"..param[i], { pos_x = new_pos } );
    new_pos = new_pos + 121

  end;

end;
--******************************************************************************************
ObjAnimate( "spr_garage_4_light", "alp", 1, 0, "", { 0,0,1, 0.8,0,0.5, 1.6,0,1 } );