-- name=rm_swamp
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_swamp";
  --------------------------------------------------------------------------------------------
  ObjAttach( "zz_cart_4", "room_hub" );
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_cart_4_chopper", { event_mdown = private.get_chopper }},
    --{ "spr_swamp_extinctlantern3", { event_mdown = private.get_extinctlantern3 }},
    { "spr_swamp_chump", { event_mdown = private.get_chump }},
    { "spr_swamp_drymoss", { event_mdown = private.get_drymoss }},
    { "spr_swamp_seeker", { event_mdown = private.GetFromBag }},
    { "spr_swamp_brokenlightcharm", { event_mdown = private.GetFromBag }},
    { "spr_swamp_charmpiece_1", { event_mdown = private.get_charmpiece_1 }},
    { "obj_vid_swamp_willowhisps", { event_mdown = private.vid_swamp_willowhisps } },
    { "obj_vid_swamp_willowhisps_focus", { event_mdown = private.vid_swamp_willowhisps } },
    { "obj_dlg_swamp_newtask", { event_mdown = private.dlg_swamp_newtask } },
    { "obj_dlg_swamp_newtask_focus", { event_mdown = private.dlg_swamp_newtask } },
    { "obj_cart_4_use_nippers_4", { event_mdown = private.clk_board } },
    { "obj_swamp_use_magiclantern_2", { event_mdown = private.ClkFirelies } },
    { "obj_swamp_collect_item_input",    { event_mdown = function() common_impl.GetCollectItem( "get_collect_item_4_1" );     end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "spr_swamp_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_4_1" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "obj_swamp_newtask_interactive_clk", { event_mdown = function() private.InteractiveClk_1(); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },

  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_swamp = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gmg_swamp_mounds",
    "gho_swamp_wagonette",
    "gzz_swamp_cart_4"
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,
      "zz_cart_4",
    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_swamp", update_game_mode_swamp, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_swamp = function ()

  local effects_table = 
  {
    "obj_swamp_anim",
    "anm_swamp_rear",
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_swamp", update_performance_mode_swamp, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_swamp () end;
  --------------------------------------------------------------------------------------------
  local opn_swamp_map = function ()

    common_impl.VisitMapRoom( "swamp" );

  end;
  cmn.AddSubscriber( "opn_swamp", opn_swamp_map );
  
  --------------------------------------------------------------------------------------------
  -- function get_collect_item_4_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_item_4_1 = function ()
  
    ObjDelete( "obj_swamp_collect" );
    ObjDelete( "obj_swamp_collect_item_input" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_item_4_1", get_collect_item_4_1, private.room_objname );
  
   --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4_1 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4_1 = function ()
  
    ObjDelete( "obj_swamp_morph" );
    ObjDelete( "spr_swamp_morph_over" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_4_1", get_collect_morph_item_4_1, private.room_objname );

  --------------------------------------------------------------------------------------------
  -- function get_chopper () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chopper" ] = {
    type = "get",
    get_obj = "spr_cart_4_chopper",
    room = private.room_objname,
    zz = "zz_cart_4",
    zz_gate = "gzz_swamp_cart_4"
  };
    
  local get_chopper_inv = function ()
  
    interface.InventoryItemAdd( "inv_chopper", "spr_cart_4_chopper" );
  
  end;
  
  local get_chopper_closezz = function ()
  
    ObjDelete( "gfx_cart_4_chopper" );
    ObjDelete( "spr_cart_4_chopper_shadow" );
    ObjDelete( "spr_swamp_cart_4_axe" );
  
  end;
  
  cmn.AddSubscriber( "get_chopper", get_chopper_inv );
  cmn.AddSubscriber( "get_chopper", get_chopper_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_extinctlantern3 () end;
  --------------------------------------------------------------------------------------------
  --common_impl.hint[ "get_extinctlantern3" ] = {
  --  type = "get",
  --  get_obj = "spr_swamp_extinctlantern3",
  --  room = private.room_objname
  --};
  --  
  --local get_extinctlantern3_inv = function ()
  --
  --  interface.InventoryItemAdd( "inv_extinctlantern3", "spr_swamp_extinctlantern3" );
  --
  --end;
  --
  --local get_extinctlantern3_closezz = function ()
  --
  --  ObjDelete( "gfx_swamp_extinctlantern3" );
  --  --ObjDelete( "gzz_swamp_willowhisps" );
  --
  --end;
  --
  --cmn.AddSubscriber( "get_extinctlantern3", get_extinctlantern3_inv );
  --cmn.AddSubscriber( "get_extinctlantern3", get_extinctlantern3_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_chump () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_chump" ] = {
    type = "get",
    get_obj = "spr_swamp_chump",
    room = private.room_objname,
  };
    
  local get_chump_inv = function ()
  
    interface.InventoryItemAdd( "inv_chump", "spr_swamp_chump" );
  
  end;
  
  local get_chump_closezz = function ()
  
    ObjDelete( "gfx_swamp_chump" );
    ObjDelete( "spr_swamp_chump_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_chump", get_chump_inv );
  cmn.AddSubscriber( "get_chump", get_chump_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_drymoss () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_drymoss" ] = {
    type = "get",
    get_obj = "spr_swamp_drymoss",
    room = private.room_objname
  };
    
  local get_drymoss_inv = function ()
  
    interface.InventoryItemAdd( "inv_drymoss", "spr_swamp_drymoss" );
  
  end;
  
  local get_drymoss_closezz = function ()
  
    ObjDelete( "gfx_swamp_drymoss" );
  
  end;
  
  cmn.AddSubscriber( "get_drymoss", get_drymoss_inv );
  cmn.AddSubscriber( "get_drymoss", get_drymoss_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_charmpiece_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_charmpiece_1" ] = {
    type = "get",
    get_obj = "obj_swamp_seeker_1",
    room = private.room_objname
  };
    
  local get_charmpiece_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_charmpiece_1", "obj_swamp_seeker_1" );
  
  end;
  
  local get_charmpiece_1_closezz = function ()
  
    ObjDelete( "gfx_swamp_charmpiece_1" );
    ObjDelete( "spr_swamp_charmpiece_1_shadow" );
  
  end;
  
  cmn.AddSubscriber( "get_charmpiece_1", get_charmpiece_1_inv );
  cmn.AddSubscriber( "get_charmpiece_1", get_charmpiece_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_nippers_4_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_nippers_4_2" ] = {
    type = "use",
    inv_obj = "inv_nippers_4",
    use_place = "obj_cart_4_use_nippers_4",
    room = private.room_objname,
    zz = "zz_cart_4",
    zz_gate = "gzz_swamp_cart_4"
  };
  local use_nippers_4_2_inv = function ()
  
    if cmn.IsEventDone( "use_nippers_4_1" ) then
      interface.InventoryItemRemove( "inv_nippers_4" );
    end;
    
  end;
  local use_nippers_4_2_beg = function ()
  
    ObjDelete( "obj_cart_4_use_nippers_4" );
    ObjDelete( "anm_cart_4_door_clk" );
  
  end;
  local use_nippers_4_2_end = function ()
  
    ObjMultiSet({ 
      { "gho_swamp_wagonette", { input = true, active = true }},
      { "obj_cart_4_shutters_open", { alp = 1 }},
      { "spr_swamp_cart_4_door_open1", { visible = true }},
      { "spr_swamp_cart_4_door_open2", { visible = true }}
    });

    ObjDelete( "gzz_swamp_cart_4" );
    ObjDelete( "spr_swamp_cart_4_door" );        

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_nippers_4_2", use_nippers_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_nippers_4_2", use_nippers_4_2_inv );
  cmn.AddSubscriber( "use_nippers_4_2", use_nippers_4_2_end, private.room_objname );
  cmn.AddSubscriber( "use_nippers_4_2_inv", use_nippers_4_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_nippers_4_2_beg", use_nippers_4_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_nippers_4_2_end", use_nippers_4_2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_magiclantern_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_magiclantern_2" ] = {
    type = "use",
    inv_obj = "inv_magiclantern_2",
    use_place = "obj_swamp_use_magiclantern_2",
    room = private.room_objname
  };
  local use_magiclantern_2_inv = function ()
  
    interface.InventoryItemRemove( "inv_magiclantern_2" );
  
  end;
  local use_magiclantern_2_beg = function ()
  
    ObjDelete( "obj_swamp_use_magiclantern_2" );
  
  end;
  local use_magiclantern_2_end = function ()
  
    interface.InventoryItemAdd( "inv_extinctlantern3", "spr_swamp_extinctlantern3" );
    ObjSet( "inv_extinctlantern3", { drag = false } );
  
  end;
  local use_magiclantern_2_end_loc = function ()

    ObjSet( "gmg_swamp_mounds", { active = true, input = true } );
    ObjSet( "spr_swamp_extinctlantern3", { active = true, input = true, alp = 1, visible = true } );
    ObjDelete( "obj_swamp_fireflies" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_magiclantern_2", use_magiclantern_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_magiclantern_2", use_magiclantern_2_inv );
  cmn.AddSubscriber( "use_magiclantern_2", use_magiclantern_2_end );
  cmn.AddSubscriber( "use_magiclantern_2", use_magiclantern_2_end_loc, private.room_objname );
  cmn.AddSubscriber( "use_magiclantern_2_inv", use_magiclantern_2_inv, private.room_objname );
  cmn.AddSubscriber( "use_magiclantern_2_beg", use_magiclantern_2_beg, private.room_objname );
  cmn.AddSubscriber( "use_magiclantern_2_end", use_magiclantern_2_end );
  cmn.AddSubscriber( "use_magiclantern_2_end", use_magiclantern_2_end_loc, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_seeker_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_seeker_1" ] = {
    type = "use",
    inv_obj = "inv_seeker",
    use_place = "obj_swamp_seeker_1",
    room = private.room_objname
  };
  local use_seeker_1_inv = function ()
  
    if ( cmn.IsEventDone( "use_seeker_4") and cmn.IsEventDone( "use_seeker_2") and
    cmn.IsEventDone( "use_seeker_3") and cmn.IsEventDone( "use_seeker_5")) then

      interface.InventoryItemRemove( "inv_seeker" );

    end;
  
  end;
  local use_seeker_1_beg = function ()
  
    --
  
  end;
  local use_seeker_1_end = function ()
  
    ObjSet( "obj_swamp_seeker_1", { input = true, visible = true, active = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_seeker_1", use_seeker_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_seeker_1", use_seeker_1_inv );
  cmn.AddSubscriber( "use_seeker_1", use_seeker_1_end, private.room_objname );
  cmn.AddSubscriber( "use_seeker_1_inv", use_seeker_1_inv, private.room_objname );
  cmn.AddSubscriber( "use_seeker_1_beg", use_seeker_1_beg, private.room_objname );
  cmn.AddSubscriber( "use_seeker_1_end", use_seeker_1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_knife_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_knife_4" ] = {
    type = "use",
    inv_obj = "inv_knife_4",
    use_place = "obj_swamp_use_knife_4",
    room = private.room_objname,
    --zz = "zz_swamp",
    --zz_gate = "gzz_swamp_swamp"
  };
  local use_knife_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_knife_4" );
  
  end;
  local use_knife_4_beg = function ()
  
    ObjDelete( "obj_swamp_use_knife_4" );
  
  end;
  local use_knife_4_end = function ()
  
    ObjSet( "spr_swamp_drymoss", { res = "assets/levels/levelext/rm_swamp/anims/moss", input = true, active = true } );
    ObjDelete( "spr_swamp_knife" );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_knife_4", use_knife_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_knife_4", use_knife_4_inv );
  cmn.AddSubscriber( "use_knife_4", use_knife_4_end, private.room_objname );
  cmn.AddSubscriber( "use_knife_4_inv", use_knife_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_knife_4_beg", use_knife_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_knife_4_end", use_knife_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_swamp_willowhisps () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_swamp_willowhisps" ] = {

      type = "click",
      use_place = "obj_vid_swamp_willowhisps",
      room = private.room_objname
  };
  local vid_swamp_willowhisps_beg = function ()

    ObjDelete( "obj_vid_swamp_willowhisps" );

  end;
  local vid_swamp_willowhisps_end = function ()

    --

  end;

  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "vid_swamp_willowhisps", vid_swamp_willowhisps_beg, private.room_objname );
  cmn.AddSubscriber( "vid_swamp_willowhisps", vid_swamp_willowhisps_end, private.room_objname  );
  cmn.AddSubscriber( "vid_swamp_willowhisps_beg", vid_swamp_willowhisps_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_swamp_willowhisps_end", vid_swamp_willowhisps_end, private.room_objname  );
  --------------------------------------------------------------------------------------------
  -- function vid_swamp_salvationrobin () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_swamp_salvationrobin" ] = {

      type = "click",
      use_place = "obj_vid_swamp_salvationrobin",
      room = private.room_objname
  };
  local vid_swamp_salvationrobin_beg = function ()

    ObjDelete( "obj_vid_swamp_salvationrobin" );

  end;
  local vid_swamp_salvationrobin_end = function ()

    ObjSet( "obj_dlg_swamp_newtask", { input = true } );
    ObjSet( "rm_swamp", { color_r = 1, color_g = 1, color_b = 1 } );
    ObjSet( "anm_swamp_oldman", { visible = true, active = true } );

  end;
  local vid_swamp_salvationrobin_loc = function ()

    ObjDelete( "anm_square_4_odlman_2" );

  end;
  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "vid_swamp_salvationrobin", vid_swamp_salvationrobin_beg, private.room_objname );
  cmn.AddSubscriber( "vid_swamp_salvationrobin", vid_swamp_salvationrobin_end, private.room_objname  );
  cmn.AddSubscriber( "vid_swamp_salvationrobin", vid_swamp_salvationrobin_loc, "rm_square_4"  );
  cmn.AddSubscriber( "vid_swamp_salvationrobin_beg", vid_swamp_salvationrobin_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_swamp_salvationrobin_end", vid_swamp_salvationrobin_end, private.room_objname  );
  cmn.AddSubscriber( "vid_swamp_salvationrobin_loc", vid_swamp_salvationrobin_loc, "rm_square_4"  );
  --------------------------------------------------------------------------------------------
  -- function vid_sheriffshouse_4_exemption () end;
  --------------------------------------------------------------------------------------------
  local vid_sheriffshouse_4_exemption_loc = function ()

    ObjDelete( "anm_swamp_oldman" );

  end;

  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "vid_sheriffshouse_4_exemption", vid_sheriffshouse_4_exemption_loc, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function vid_sheriffshouse_4_exemption () end;
  --------------------------------------------------------------------------------------------
  local win_mounds = function ()

    ObjSet( "spr_swamp_mounds", { visible = true } );

  end;
  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "win_mounds", win_mounds, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function dlg_swamp_newtask () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "dlg_swamp_newtask" ] = {

      type = "click",
      use_place = "obj_dlg_swamp_newtask",
      room = private.room_objname
  };

  local dlg_swamp_newtask_end = function ()

    ObjDelete( "obj_dlg_swamp_newtask" );

    ObjSet( "spr_swamp_brokenlightcharm", { active = true, alp = 1 } );
    ObjSet( "spr_swamp_seeker", { active = true, alp = 1 } );
    interface.InventoryItemAdd( "inv_brokenlightcharm", "spr_swamp_brokenlightcharm" );
    interface.InventoryItemAdd( "inv_seeker", "spr_swamp_seeker" );
    ObjSet( "inv_brokenlightcharm", { drag = false } );
      
  end;
  local dlg_swamp_newtask_loc_end = function ()

    ObjDelete( "obj_dlg_swamp_newtask" );
    ObjDelete( "spr_swamp_seeker_shadow" );
    ObjDelete( "spr_swamp_seeker_shadow_2" );
    ObjDelete( "spr_swamp_brokenlightcharm_shadow" );
    ObjDelete( "spr_swamp_brokenlightcharm_shadow_2" );
     
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "dlg_swamp_newtask", dlg_swamp_newtask_end );
  cmn.AddSubscriber( "dlg_swamp_newtask", dlg_swamp_newtask_loc_end );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()

  subroom.Define( "zz_cart_4" );
  --------------------------------------------------------------------------------------------
  function zz_cart_4.PreOpen ()

    ObjAnimate( "spr_cart_4_light_add", "alp", 1, 0, "",
    { 
      0.0, 0, 1, 
      0.6, 0, 0.5,
      1.2, 0, 1
    } );

  end;

end;
--*********************************************************************************************************************
function public.Open()

  private.opn_swamp();
  
  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

  if ( not cmn.IsEventDone( "vid_swamp_willowhisps" ) ) then

    common_impl.PlayTimer( private.vid_swamp_willowhisps );

  end;

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.CollectItemMorphing();

  common_impl.MorphItemMorphing();
  --interface.InvestigationButtonCheck();
  
  if ( not cmn.IsEventDone( "vid_swamp_salvationrobin" ) and cmn.IsEventDone( "win_mounds" ) ) then

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[ i ], 0 );

    end;

    ObjSet( "rm_swamp", { color_r = 0, color_g = 0, color_b = 0 } );
    ObjAttach( "tmr_swamp_salvationrobin", private.room_objname);
    ObjSet( "tmr_swamp_salvationrobin",
    {
      time = 0.001,
      playing = true,
      endtrig = function() private.vid_swamp_salvationrobin(); end
    } );

  end;

  common_impl.EnvPlay( { "common/audio/aud_swamp_env" }, "", 0.5 );
  common_impl.PlayAudio( "env", "common/audio/aud_wagonette_env", 1, "", 0.5 );

end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );
  common_impl.StopAudio( "env", "common/audio/aud_wagonette_env", 0.2 );

end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_nippers_4_2()

  local item = "inv_nippers_4";

  if ( common.ApplyObj( item, "obj_cart_4_use_nippers_4", true ) and cmn.IsEventDone( "get_chopper" )) then

    cmn.CallEventHandler( "use_nippers_4_2_inv" );
    cmn.CallEventHandler( "use_nippers_4_2_beg" );

    local func_after = function ()
  
      local func_after_end = function ()

        common_impl.Lock( false );
        cmn.SetEventDone( "use_nippers_4_2" );
        cmn.CallEventHandler( "use_nippers_4_2_end" );
        common.CloseSubRoom();

      end;

      ObjAnimate( "anm_cart_4_door", "alp", 0, 0, func_after_end,
      { 
        0.0, 0, 1.0, 
        0.3, 0, 0.0
      } );
    
      ObjAnimate( "obj_cart_4_shutters_open", "alp", 0, 0, "",
      { 
        0.0, 0, 0.0, 
        0.3, 0, 1.0
      } );
 
    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_nippers_4_2", 0, "", 0 );

    AnimPlay( "anm_cart_4_door", "DoAnim", func_after );
  
    return true;
  
  elseif common.ApplyObj( item, "gzz_swamp_cart_4", false ) and cmn.IsEventDone( "vid_swamp_willowhisps" ) then

    --interface.ObjDoNotDrop( item );
    cmn.GotoSubRoom( "zz_cart_4", nil, { 512, 384 } );

    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_magiclantern_2()

  local item = "inv_magiclantern_2";

  if ( common.ApplyObj( item, "obj_swamp_use_magiclantern_2" ) ) then

    cmn.CallEventHandler( "use_magiclantern_2_inv" );
    cmn.CallEventHandler( "use_magiclantern_2_beg" );    
    cmn.CallEventHandler( "use_splinter_fire" );

    local func_end = function ()
  
      common_impl.Lock( false );
      cmn.SetEventDone( "use_magiclantern_2" );
      cmn.CallEventHandler( "use_magiclantern_2_end" );
    
    end;

    common_impl.Lock( true );    
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_lantern_swamp", 0, "", 0 );

    ObjSet( "anm_swamp_fireflies_lantern", { visible = true } );      
    AnimPlay( "anm_swamp_fireflies_lantern", "DoAnim", func_end );
  
    ObjAnimate( "anm_swamp_fireflies", "alp", 0, 0, "",
    { 
      0.0, 0, 1.0, 
      1.5, 0, 1.0,
      2.5, 0, 0.0
    } );
    
    return true;

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_seeker_1()

  local func_after = function ()

    common_impl.Lock( false );
    cmn.SetEventDone( "use_seeker_1" );
    cmn.CallEventHandler( "use_seeker_1_end" );
    cmn.CallEventHandler( "use_seeker_1_inv" );

  end;

  common_impl.Lock( true );
  func_after();

  return true;
  
end;
--------------------------------------------------------------------------------------------
function public.use_knife_4()

  local item = "inv_knife_4";

  if ( common.ApplyObj( item, "obj_swamp_use_knife_4" ) ) and cmn.IsEventDone( "vid_swamp_willowhisps" ) then

    cmn.CallEventHandler( "use_knife_4_inv" );
    cmn.CallEventHandler( "use_knife_4_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );
      cmn.CallEventHandler( "use_knife_4_end" );
      private.get_drymoss();

    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_knife_4_1", 0, "", 0 );
  
    ObjAnimate( "spr_swamp_knife", "alp", 0, 0, func_after,
    { 
      0.0, 0, 0.0, 
      0.3, 0, 1.0,
      0.6, 3, 1.0,
      0.8, 0, 0.0
    } );

    ObjAnimate( "spr_swamp_knife", "pos_xy", 0, 0, "",
    { 
      0.0, 0, 914, 478, 
      0.3, 0, 914, 478,
      0.6, 3, 832, 568
    } );
  
    return true;
  
  else

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_chopper()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_chopper" );
  cmn.CallEventHandler( "get_chopper" );

end;
--------------------------------------------------------------------------------------------
--function private.get_extinctlantern3()
--
--  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
--  
--  cmn.SetEventDone( "get_extinctlantern3" );
--  cmn.CallEventHandler( "get_extinctlantern3" );
--
--end;
--------------------------------------------------------------------------------------------
function private.get_chump()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_chump" );
  cmn.CallEventHandler( "get_chump" );

end;
--------------------------------------------------------------------------------------------
function private.get_drymoss()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  cmn.SetEventDone( "use_knife_4" );
  cmn.SetEventDone( "get_drymoss" );
  cmn.CallEventHandler( "get_drymoss" );

end;
--------------------------------------------------------------------------------------------
function private.get_charmpiece_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_charmpiece_1" );
  cmn.CallEventHandler( "get_charmpiece_1" );

end;
--------------------------------------------------------------------------------------------
function private.GetFromBag( )

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  common_impl.DialogCharacterMmgHide( "newtask", ""  );     
  common_impl.DialogCharacterHide();  

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_board()

  local func_after = function()

    common_impl.Lock( false );
    ObjSet( "anm_cart_4_door_clk", { visible = false } );  
    ObjSet( "anm_cart_4_door", { visible = true } );
    
  end;

  common_impl.ShowBbt( 'bbt_cart_4_use_nippers_4' );
  common_impl.PlayAudio( "sfx", "common/audio/aud_boards_window", 0, "", 0 );

  common_impl.Lock( true );

  ObjSet( "anm_cart_4_door_clk", { visible = true } );  
  ObjSet( "anm_cart_4_door", { visible = false } );

  AnimPlay( "anm_cart_4_door_clk", "DoAnim", func_after );


end;
function private.InteractiveClk_1()

  local func_after = function()

    ObjSet( "obj_swamp_newtask_interactive_clk", { event_mdown = function() private.InteractiveClk_2() end } );
    common_impl.Lock( false );

  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_interactivebag_click_1", 0, "", 0 );
  ObjAnimate( "spr_swamp_line_1", "alp", 0, 0, "",
  { 
    0.0, 0, 1, 
    0.3, 0, 0,
  } );
  ObjAnimate( "spr_swamp_line_2", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.3, 0, 1,
  } );

end;
function private.InteractiveClk_2()

  local func_after = function()

    common_impl.Lock( false );
    ObjSet( "obj_swamp_newtask_interactive_clk", { input = false } );
    ObjSet( "obj_swamp_bag_open", { input = true } );
    --ObjSet( "obj_swamp_newtask_interactive_clk", { input = false } );

  end;

  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_interactivebag_click_2", 0, "", 0 );
  ObjAnimate( "spr_swamp_line_2", "alp", 0, 0, "",
  { 
    0.0, 0, 1, 
    0.3, 0, 0,
  } );
  ObjAnimate( "spr_swamp_bag_over_1", "alp", 0, 0, "",
  { 
    0.0, 0, 1, 
    0.3, 0, 0,
  } );
  ObjAnimate( "obj_swamp_bag_open", "alp", 0, 0, func_after,
  { 
    0.0, 0, 0, 
    0.3, 0, 1,
  } );

end;
function private.ClkNewTaskDial()

  ObjSet( "spr_int_dialog_character_bot", { alp = 0 } );
  ObjSet( "txt_int_dialog_character", { alp = 0 } );

  common_impl.DialogCharacterMmgShow( "newtask", 1200, 400  );

  ObjAnimate( "obj_swamp_newtask_oldman", "color_rgb", 0, 0, "", { 0,0,1,1,1, 0.3,0,0.5,0.5,0.5 } );
  ObjAnimate( "obj_swamp_newtask_oldman", "color_rgb", 0, 0, "", { 0,0,1,1,1, 0.3,0,0.5,0.5,0.5 } );
  ObjAnimate( "obj_swamp_newtask_mmg", "color_rgb", 0, 0, "", { 0,0,0.4,0.4,0.4, 0.3,0,1,1,1 } );
  ObjAnimate( "obj_swamp_newtask_oldman", "scale_xy", 0, 0, "", { 0,0,1.05,1.05, 0.3,0,1,1 } );

  ObjSet( "anm_swamp_newtask_oldman_bag", { alp = 0 } );
  ObjSet( "anm_swamp_newtask_oldman", { alp = 1 } ); 

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_swamp()

  if not ( cmn.IsEventDone( "opn_swamp" ) ) then
    cmn.SetEventDone( "opn_swamp" );
  end;
  
  cmn.CallEventHandler( "opn_swamp" ); 

end;
--*********************************************************************************************************************
function private.ClkFirelies()

  local func_end = function()

    ObjSet( "anm_swamp_fireflies_clk", { visible = false } );
    ObjSet( "anm_swamp_fireflies", { visible = true } );
    common_impl.Lock( false );

  end;
  
  common_impl.ShowBbt( 'bbt_swamp_use_magiclantern_2' );
  common_impl.Lock( true );
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_hidden_energy", 0, "", 0 );
  ObjSet( "anm_swamp_fireflies", { visible = false } );
  ObjSet( "anm_swamp_fireflies_clk", { visible = true } );
  AnimPlay( "anm_swamp_fireflies_clk", "DoAnim", func_end );

end;
--*********************************************************************************************************************
function private.vid_swamp_willowhisps()

  cmn.CallEventHandler( "vid_swamp_willowhisps_beg" );
  ObjSet( "vid_swamp_willowhisps", { alp = 1, active = true, input = false, visible = true } );

  local widget_settings = {}

  if IsCollectorsEdition() then

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnGuide,
      InterfaceWidget_BtnMenu
    }

  else

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnMenu
    }

  end;
  
  local func_after = function ( skip )

    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_swamp_willowhisps", 0.2 );
      
    end;

    common_impl.PlayAudio( "mus", "common/audio/aud_adventure2_mus", 0, "", 0 );

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_swamp_willowhisps" );
    cmn.CallEventHandler( "vid_swamp_willowhisps_end" );

    common_impl.ShowBbt( 'bbt_swamp_after_willowhisps', 1 );

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

  end;

  for i = 1, #widget_settings do

    interface.WidgetSetVisible( widget_settings[i], 0 );

  end;

  common_impl.StopAllMus();
  interface.DialogVideoShow( "vid_swamp_willowhisps", 1, function() func_after( 'skip' ); end, 3 );
  common_impl.PlayAudio( "sfx", "common/audio/aud_swamp_willowhisps", 0, "", 0.5 );
  VidPlay( "vid_swamp_willowhisps", function() func_after( nil ); end ); 

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.dlg_swamp_newtask()

  ObjAttach( "dlg_swamp_newtask", private.room_objname );
  common_impl.continue_visible = true; 
  --common_impl.dialog_character_loc = "obj_swamp_newtask_characters";
  common_impl.DialogCharacterStart( "newtask", 4, nil, nil, true, "dlg_swamp_newtask_end" );

end;
--------------------------------------------------------------------------------------------
function public.dlg_swamp_newtask_end()

  cmn.SetEventDone( "dlg_swamp_newtask" );
  cmn.CallEventHandler( "dlg_swamp_newtask" );
  ObjSet( "spr_int_dialog_character_bot", { alp = 1 } );
  ObjSet( "txt_int_dialog_character", { alp = 1 } );
  ObjAttach( "obj_swamp_newtask_mmg", "obj_swamp_newtask_characters" );
  ObjSet( "obj_swamp_newtask_mmg", { alp = 0, input = false } );
  interface.KeyTaskAdd( 'banish_spirit' ); 
  ObjSet( "obj_int_dialog_character", { alp  = 1 } ); 

end;
--*********************************************************************************************************************
function public.SwitchFrase( dlg_name, count_txt )

  if dlg_name == "newtask" then

    if count_txt == 1 then 

      common_impl.DialogCharacterChangeCharacters( 'newtask', nil, 'robin' );
  
    elseif count_txt == 2 then 

      common_impl.continue_visible = false;
      common_impl.frases = { 1 }; 
      common_impl.dial_icons = { 'interrogation' };
      common_impl.DialogCharacterShowDialogQuestions( 1, 6 );
      common_impl.DialogCharacterChangeCharacters( 'newtask', 'robin', 'oldman' );
  
    elseif count_txt == 3 then 

      common_impl.continue_visible = true;

      ObjSet( "anm_swamp_newtask_oldman_bag", { alp = 1 } );
      ObjSet( "anm_swamp_newtask_oldman", { alp = 0 } ); 
      common_impl.PlayAudio( "sfx", "common/audio/aud_get_to_us", 0, "", 0 );
      ObjSet( "obj_int_dialog_character_input", { input = true, event_mdown = private.ClkNewTaskDial } );
                
    end;

  end;  

end;
--*********************************************************************************************************************
function private.vid_swamp_salvationrobin()

  ObjDelete( "tmr_swamp_salvationrobin" ); 
  ObjSet( "vid_swamp_salvationrobin", { alp = 1, active = true, visible = true } );
  ObjAttach( "vid_swamp_salvationrobin", "rm_swamp" );

  local func_after = function ( skip )

    common_impl.AddPageDiary( 14 );

    interface.DialogVideoHide();
    common_impl.ShowBbt( "bbt_swamp_after_salvationrobin" );
    cmn.SetEventDone( "vid_swamp_salvationrobin" );
    cmn.CallEventHandler( "vid_swamp_salvationrobin_end" );
    cmn.CallEventHandler( "vid_swamp_salvationrobin_loc" );

    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_swamp_salvationrobin", 0.2 );
      
    end;
    
    common_impl.PlayAudio( "mus", "common/audio/aud_adventure1_mus", 0, "", 0 );

    --common_impl.StopAudio( "voc", "common/audio/aud_swamp_salvationrobin_voc", 0.2 );
   -- common_impl.EnvPlay( { "common/audio/aud_fork_4_env" }, "", 0.5 );
   
    local func_after = function()

      ObjSet( "obj_swamp_gates", { input = true } );
      --common_impl.AddPageDiary( 1 );

      interface.KeyTaskDone( true ); 
     
    end;
  
    --func_after();
    --common_impl.PlayAudio( "mus", "common/audio/aud_adventure2_mus", 0, "", 0 );
    --interface.KeyTaskAdd( "goto_willowswille", true, function () common_impl.TutorialShow( "tutorial_page_1" ); end );

    local widget_settings = {}

    if IsCollectorsEdition() then

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu
      }

    else

      widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnMenu
      }

    end;

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_swamp_salvationrobin", 0, "", 0 );
  --common_impl.PlayAudio( "voc", "common/audio/aud_swamp_salvationrobin_voc", 0, "", 0 );

  common_impl.StopAllMus();
  interface.DialogVideoShow( "vid_swamp_salvationrobin", 1, function() func_after( 'skip' ); end, 3 );
  VidPlay( "vid_swamp_salvationrobin", function() func_after( nil ); end );

end;
--*********************************************************************************************************************
