-- name=rm_swampmasterdwelling
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_swampmasterdwelling";
  --------------------------------------------------------------------------------------------
  private.Init_Subroom();
  
  ObjMultiSet({ 
    { "spr_swampmasterdwelling_artifactpiece_1", { event_mdown = private.get_artifactpiece_1 }},
    { "spr_swampmasterdwelling_artifactpiece_2", { event_mdown = private.get_artifactpiece_2 }},
    { "obj_vid_swampmasterdwelling_ghosts", { event_mdown = private.vid_swampmasterdwelling_ghosts } },
    { "obj_vid_swampmasterdwelling_ghosts_focus", { event_mdown = private.vid_swampmasterdwelling_ghosts } },
    { "spr_swampmasterdwelling_collect_morph_item", { event_mdown = function() common_impl.GetMorphItem( "get_collect_morph_item_4_4" ); end, event_menter = function() common_impl.SetCursor( CURSOR_HAND ) end, event_mleave = function() common_impl.SetCursor( CURSOR_DEFAULT ) end } },
    { "obj_swampmasterdwelling_use_dog", { event_mdown = private.clk_dogs } }
  });
  --------------------------------------------------------------------------------------------
  -- function UpdateGameMode () end;
  --------------------------------------------------------------------------------------------
  local update_game_mode_swampmasterdwelling = function ()
  
  local table_multiset = {};
  local visible_sparkle_area = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_area" ] ) then    
    visible_sparkle_area = false;
  end;
  local visible_sparkle_ho = true;  
  if ( ng_global.gamemode == 3 and not ng_global.gamemode_custom[ "sparkle_ho" ] ) then    
    visible_sparkle_ho = false;
  end;
  local gates = 
  {
    "gmg_swampmasterdwelling_bossfight",
  };
  for i = 1, #gates do

    local name = gates[ i ];
    if ( common.GetObjectPrefix( name ) == "gho" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_ho } } );
    elseif ( common.GetObjectPrefix( name ) ~= "grm" ) then        
    table.insert( table_multiset, { name, { visible = visible_sparkle_area } } );
    end;

  end;

  local mas_parent_gfx = 

    {
      private.room_objname,

    };

  common_impl.TurnChildGfx( mas_parent_gfx, private.room_objname, visible_sparkle_ho );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

  end;
  cmn.AddSubscriber( "update_game_mode_swampmasterdwelling", update_game_mode_swampmasterdwelling, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function UpdatePerfMode () end;
  --------------------------------------------------------------------------------------------
  local update_performance_mode_swampmasterdwelling = function ()

  local effects_table = 
  {
    "anm_swampmasterdwelling_rear",
    "anm_swampmasterdwelling_first_plane", 
  }

  local active = true;
  if ( GetPerformanceMode() == 1 ) then
    active = false;
  end;

  for i = 1, #effects_table do
    ObjSet( effects_table[ i ], { active = active } )
  end;

  end;
  cmn.AddSubscriber( "update_performance_mode_swampmasterdwelling", update_performance_mode_swampmasterdwelling, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function opn_swampmasterdwelling () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "opn_swampmasterdwelling" ] = {
    type = "click",
    use_place = "grm_forgottenbastille_swampmasterdwelling",
    room = "rm_forgottenbastille"
  };

  local opn_swampmasterdwelling_map = function ()

    common_impl.VisitMapRoom( "swampmasterdwelling" );

  end;
  cmn.AddSubscriber( "opn_swampmasterdwelling", opn_swampmasterdwelling_map );

  --------------------------------------------------------------------------------------------
  -- function get_collect_morph_item_4_4 () end;
  --------------------------------------------------------------------------------------------
  local get_collect_morph_item_4_4 = function ()
  
    ObjDelete( "obj_swampmasterdwelling_morph" );
    ObjDelete( "obj_swampmasterdwelling_morph_input" );
  
  end;
    
  cmn.AddSubscriber( "get_collect_morph_item_4_4", get_collect_morph_item_4_4, private.room_objname );
  
  --------------------------------------------------------------------------------------------
  -- function get_artifactpiece_1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_artifactpiece_1" ] = {
    type = "get",
    get_obj = "spr_swampmasterdwelling_artifactpiece_1",
    room = private.room_objname,
    --zz = "zz_swampmasterdwelling",
    --zz_gate = "gzz_swampmasterdwelling_swampmasterdwelling"
  };
    
  local get_artifactpiece_1_inv = function ()
  
    interface.InventoryItemAdd( "inv_artifactpiece_1", "spr_swampmasterdwelling_artifactpiece_1" );
  
  end;
  
  local get_artifactpiece_1_closezz = function ()
  
    ObjDelete( "gfx_swampmasterdwelling_artifactpiece_1" );

  end;
  
  cmn.AddSubscriber( "get_artifactpiece_1", get_artifactpiece_1_inv );
  cmn.AddSubscriber( "get_artifactpiece_1", get_artifactpiece_1_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function get_artifactpiece_2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "get_artifactpiece_2" ] = {
    type = "get",
    get_obj = "spr_swampmasterdwelling_artifactpiece_2",
    room = private.room_objname,
    --zz = "zz_swampmasterdwelling",
    --zz_gate = "gzz_swampmasterdwelling_swampmasterdwelling"
  };
    
  local get_artifactpiece_2_inv = function ()
  
    interface.InventoryItemAdd( "inv_artifactpiece_2", "spr_swampmasterdwelling_artifactpiece_2" );
  
  end;
  
  local get_artifactpiece_2_closezz = function ()
  
    ObjDelete( "gfx_swampmasterdwelling_artifactpiece_2" );

  end;
  
  cmn.AddSubscriber( "get_artifactpiece_2", get_artifactpiece_2_inv );
  cmn.AddSubscriber( "get_artifactpiece_2", get_artifactpiece_2_closezz, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_silverblade () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_silverblade" ] = {
    type = "use",
    inv_obj = "inv_silverblade",
    use_place = "obj_swampmasterdwelling_use_dog",
    room = private.room_objname
  };
  local use_silverblade_inv = function ()
  
    interface.InventoryItemRemove( "inv_silverblade" );
  
  end;
  local use_silverblade_beg = function ()
  
    if ( cmn.IsEventDone( "use_loadedgun_4" ) ) then

      ObjDelete( "obj_swampmasterdwelling_use_dog" );

    end;

  end;
  local use_silverblade_end = function ()

    if ( not cmn.IsEventDone( "use_loadedgun_4" ) ) then

      ObjSet( "anm_swampmasterdwelling_dog_1", { alp = 1, playing = true });
      ObjSet( "anm_swampmasterdwelling_smoke_1", { alp = 1, playing = true });
      ObjDelete( "anm_swampmasterdwelling_dog_2" );
      ObjDelete( "anm_swampmasterdwelling_smoke_2" );
      ObjDelete( "vid_swampmasterdwelling_silver" );

    else 

      ObjDelete( "vid_swampmasterdwelling_silver_2" );
      ObjDelete( "anm_swampmasterdwelling_dog_2" );
      ObjDelete( "anm_swampmasterdwelling_smoke_2" );
      ObjDelete( "anm_swampmasterdwelling_dog_1" );
      ObjDelete( "anm_swampmasterdwelling_smoke_1" );
      ObjSet( "obj_swampmasterdwelling_use_victoryartifact1", { input = true } );

    end;

    ObjSet( "spr_swampmasterdwelling_artifactpiece_2", { input = true, active = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_silverblade", use_silverblade_beg, private.room_objname );
  cmn.AddSubscriber( "use_silverblade", use_silverblade_inv );
  cmn.AddSubscriber( "use_silverblade", use_silverblade_end, private.room_objname );
  cmn.AddSubscriber( "use_silverblade_inv", use_silverblade_inv, private.room_objname );
  cmn.AddSubscriber( "use_silverblade_beg", use_silverblade_beg, private.room_objname );
  cmn.AddSubscriber( "use_silverblade_end", use_silverblade_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_loadedgun_4 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_loadedgun_4" ] = {
    type = "use",
    inv_obj = "inv_loadedgun_4",
    use_place = "obj_swampmasterdwelling_use_dog",
    room = private.room_objname
  };
  local use_loadedgun_4_inv = function ()
  
    interface.InventoryItemRemove( "inv_loadedgun_4" );
  
  end;
  local use_loadedgun_4_beg = function ()
  
    if ( cmn.IsEventDone( "use_silverblade" ) ) then

      ObjDelete( "obj_swampmasterdwelling_use_dog" );

    end;
  
  end;
  local use_loadedgun_4_end = function ()

    if ( not cmn.IsEventDone( "use_silverblade" ) ) then

      ObjSet( "anm_swampmasterdwelling_dog_2", { alp = 1, playing = true });
      ObjSet( "anm_swampmasterdwelling_smoke_2", { alp = 1, playing = true });
      ObjDelete( "anm_swampmasterdwelling_dog_1" );
      ObjDelete( "anm_swampmasterdwelling_smoke_1" );
      ObjDelete( "vid_swampmasterdwelling_loadedgun" );

    else 

      ObjDelete( "vid_swampmasterdwelling_loadedgun_2" );
      ObjDelete( "anm_swampmasterdwelling_dog_2" );
      ObjDelete( "anm_swampmasterdwelling_smoke_2" );
      ObjDelete( "anm_swampmasterdwelling_dog_1" );
      ObjDelete( "anm_swampmasterdwelling_smoke_1" );
      ObjSet( "obj_swampmasterdwelling_use_victoryartifact1", { input = true } );

    end;

    ObjSet( "spr_swampmasterdwelling_artifactpiece_1", { input = true, active = true, alp = 1 } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_loadedgun_4", use_loadedgun_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_loadedgun_4", use_loadedgun_4_inv );
  cmn.AddSubscriber( "use_loadedgun_4", use_loadedgun_4_end, private.room_objname );
  cmn.AddSubscriber( "use_loadedgun_4_inv", use_loadedgun_4_inv, private.room_objname );
  cmn.AddSubscriber( "use_loadedgun_4_beg", use_loadedgun_4_beg, private.room_objname );
  cmn.AddSubscriber( "use_loadedgun_4_end", use_loadedgun_4_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_victoryartifact1 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_victoryartifact1" ] = {
    type = "use",
    inv_obj = "inv_victoryartifact",
    use_place = "obj_swampmasterdwelling_use_victoryartifact1",
    room = private.room_objname,
    --zz = "zz_swampmasterdwelling",
    --zz_gate = "gzz_swampmasterdwelling_swampmasterdwelling"
  };
  local use_victoryartifact1_inv = function ()
  
    --interface.InventoryItemRemove( "inv_victoryartifact" );
  
  end;
  local use_victoryartifact1_beg = function ()
  
    ObjDelete( "obj_swampmasterdwelling_use_victoryartifact1" );
  
  end;
  local use_victoryartifact1_end = function ()
  
    ObjDelete( "anm_swampmasterdwelling_master_sit" );
    ObjSet( "gmg_swampmasterdwelling_bossfight", { input = true, active = true } );
    ObjSet( "anm_swampmasterdwelling_master", { alp = 1, playing = true } );
  
  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_victoryartifact1", use_victoryartifact1_beg, private.room_objname );
  cmn.AddSubscriber( "use_victoryartifact1", use_victoryartifact1_inv );
  cmn.AddSubscriber( "use_victoryartifact1", use_victoryartifact1_end, private.room_objname );
  cmn.AddSubscriber( "use_victoryartifact1_inv", use_victoryartifact1_inv, private.room_objname );
  cmn.AddSubscriber( "use_victoryartifact1_beg", use_victoryartifact1_beg, private.room_objname );
  cmn.AddSubscriber( "use_victoryartifact1_end", use_victoryartifact1_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  -- function use_victoryartifact2 () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "use_victoryartifact2" ] = {
    type = "use",
    inv_obj = "inv_victoryartifact",
    use_place = "obj_swampmasterdwelling_use_victoryartifact2",
    room = private.room_objname,
    --zz = "zz_swampmasterdwelling",
    --zz_gate = "gzz_swampmasterdwelling_swampmasterdwelling"
  };
  local use_victoryartifact2_inv = function ()
  
    interface.InventoryItemRemove( "inv_victoryartifact" );
  
  end;
  local use_victoryartifact2_beg = function ()
  
    ObjDelete( "obj_swampmasterdwelling_use_victoryartifact2" );
    
  end;
  local use_victoryartifact2_end = function ()
  
    ObjDelete( "anm_swampmasterdwelling_master_end" );
    ObjDelete( "anm_swampmasterdwelling_use_artifact2" );

  end;
  --------------------------------------------------------------------------------------------
  cmn.AddSubscriber( "use_victoryartifact2", use_victoryartifact2_beg, private.room_objname );
  cmn.AddSubscriber( "use_victoryartifact2", use_victoryartifact2_inv );
  cmn.AddSubscriber( "use_victoryartifact2", use_victoryartifact2_end, private.room_objname );
  cmn.AddSubscriber( "use_victoryartifact2_inv", use_victoryartifact2_inv, private.room_objname );
  cmn.AddSubscriber( "use_victoryartifact2_beg", use_victoryartifact2_beg, private.room_objname );
  cmn.AddSubscriber( "use_victoryartifact2_end", use_victoryartifact2_end, private.room_objname );
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  -- function vid_swampmasterdwelling_ghosts () end;
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "vid_swampmasterdwelling_ghosts" ] = {

      type = "click",
      use_place = "obj_vid_swampmasterdwelling_ghosts",
      room = private.room_objname
  };
  local vid_swampmasterdwelling_ghosts_beg = function ()

    ObjDelete( "obj_vid_swampmasterdwelling_ghosts" );

  end;
  local vid_swampmasterdwelling_ghosts_end = function ()

    ObjMultiSet({ 

      { "anm_swampmasterdwelling_smoke_1", { alp = 1, playing = true }},
      { "obj_swampmasterdwelling_use_dog", { input = true }},
      { "rm_swampmasterdwelling", { color_r = 1, color_g = 1, color_b = 1 }},
      { "anm_swampmasterdwelling_dog_1", { visible = true } },
      { "anm_swampmasterdwelling_dog_2", { visible = true } },

    });

  end;

  --------------------------------------------------------------------------------------------

  cmn.AddSubscriber( "vid_swampmasterdwelling_ghosts", vid_swampmasterdwelling_ghosts_beg, private.room_objname );
  cmn.AddSubscriber( "vid_swampmasterdwelling_ghosts", vid_swampmasterdwelling_ghosts_end, private.room_objname  );
  cmn.AddSubscriber( "vid_swampmasterdwelling_ghosts_beg", vid_swampmasterdwelling_ghosts_beg, private.room_objname  );
  cmn.AddSubscriber( "vid_swampmasterdwelling_ghosts_end", vid_swampmasterdwelling_ghosts_end, private.room_objname  );

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function private.Init_Subroom()
end;
--*********************************************************************************************************************
function public.Open()

  private.opn_swampmasterdwelling();
  
  int_providence_eye.CheckShow();
  int_slider.InitSlider( private.room_objname );

  if ( not cmn.IsEventDone( "vid_swampmasterdwelling_ghosts" ) ) then

    common_impl.PlayTimer( private.vid_swampmasterdwelling_ghosts );

  end;

end;
--*********************************************************************************************************************
function public.PreOpen()

  common_impl.MorphItemMorphing();
  --interface.InvestigationButtonCheck();

  common_impl.EnvPlay( { "common/audio/aud_swampmasterdwelling_env" }, "", 0.5 );

  if ( cmn.IsEventDone( "vid_swampmasterdwelling_ghosts" ) and not ( cmn.IsEventDone( "use_silverblade" ) and cmn.IsEventDone( "use_loadedgun_4" ) ) ) then

    common_impl.PlayAudio( "env", "common/audio/aud_hotdogs_env", 1, "", 0.5 );

  end;

end;
--*********************************************************************************************************************
function public.Close()

  int_slider.CloseSlider( private.room_objname );
  
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
-- function *** PROGRESS USE *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.use_silverblade()

  local item = "inv_silverblade";

  if ( common.ApplyObj( item, "obj_swampmasterdwelling_use_dog", false ) ) and cmn.IsEventDone( "vid_swampmasterdwelling_ghosts" ) then

    cmn.CallEventHandler( "use_silverblade_inv" );
    cmn.CallEventHandler( "use_silverblade_beg" );

    local func_after = function ()

      interface.DialogVideoHide();
      common_impl.Lock( false );
      cmn.SetEventDone( "use_silverblade" );
      cmn.CallEventHandler( "use_silverblade_end" );
      common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment1_mus", 0, "", 0 );
      private.get_artifactpiece_2();

      common_impl.StopAudio( "sfx", "common/audio/aud_use_silverblade", 0, "", 0 );

      if ( not cmn.IsEventDone( "use_loadedgun_4" ) ) then 

        common_impl.PlayAudio( "env", "common/audio/aud_hotdogs_env", 1 );

      end;

    end;

    common_impl.Lock( true );
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_silverblade", 0, "", 0 );

    common_impl.StopAllMus();

    common_impl.StopAudio( "env", "common/audio/aud_hotdogs_env", 0.2 );

    if ( not cmn.IsEventDone( "use_loadedgun_4" ) ) then

      ObjSet( "vid_swampmasterdwelling_silver", { alp = 1, active = true, input = false, visible = true } );
      interface.DialogVideoShow( "vid_swampmasterdwelling_silver", 1, func_after, 3 );
      VidPlay( "vid_swampmasterdwelling_silver", func_after );

    else 

      ObjSet( "vid_swampmasterdwelling_silver_2", { alp = 1, active = true, input = false, visible = true } );
      interface.DialogVideoShow( "vid_swampmasterdwelling_silver_2", 1, func_after, 3 );
      VidPlay( "vid_swampmasterdwelling_silver_2", func_after );

    end;
  
    return true;
  
  else

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_loadedgun_4()

  local item = "inv_loadedgun_4";

  if ( common.ApplyObj( item, "obj_swampmasterdwelling_use_dog" ) ) and cmn.IsEventDone( "vid_swampmasterdwelling_ghosts" ) then

    cmn.CallEventHandler( "use_loadedgun_4_inv" );
    cmn.CallEventHandler( "use_loadedgun_4_beg" );

    local func_after = function ()

      interface.DialogVideoHide();
      common_impl.Lock( false );
      cmn.SetEventDone( "use_loadedgun_4" );
      cmn.CallEventHandler( "use_loadedgun_4_end" );

      common_impl.StopAudio( "sfx", "common/audio/aud_use_loadedgun_4", 0.2 );
      
      private.get_artifactpiece_1();
      common_impl.PlayAudio( "mus", "common/audio/aud_danger_moment2_mus", 0, "", 0 );

      if ( not cmn.IsEventDone( "use_silverblade" ) ) then 

        common_impl.PlayAudio( "env", "common/audio/aud_hotdogs_env", 1 );

      end;

    end;

    common_impl.Lock( true );
    
    common_impl.StopAllMus();

    common_impl.StopAudio( "env", "common/audio/aud_hotdogs_env", 0.2 );

    common_impl.PlayAudio( "sfx", "common/audio/aud_use_loadedgun_4", 0, "", 0 );
  
    if ( not cmn.IsEventDone( "use_silverblade" ) ) then

      ObjSet( "vid_swampmasterdwelling_loadedgun", { alp = 1, active = true, input = false, visible = true } );
      interface.DialogVideoShow( "vid_swampmasterdwelling_loadedgun", 1, func_after, 3 );
      VidPlay( "vid_swampmasterdwelling_loadedgun", func_after );

    else 

      ObjSet( "vid_swampmasterdwelling_loadedgun_2", { alp = 1, active = true, input = false, visible = true } );
      interface.DialogVideoShow( "vid_swampmasterdwelling_loadedgun_2", 1, func_after, 3 );
      VidPlay( "vid_swampmasterdwelling_loadedgun_2", func_after );

    end;
  
    return true;
  
  else

  end;

end;
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
function public.use_victoryartifact1()

  local item = "inv_victoryartifact";

  if ( common.ApplyObj( item, "obj_swampmasterdwelling_use_victoryartifact1" ) ) then

    cmn.CallEventHandler( "use_victoryartifact1_inv" );
    cmn.CallEventHandler( "use_victoryartifact1_beg" );

    public.vid_swampmasterdwelling_battle();  

    return true;
  
  else

  end;

end;
--------------------------------------------------------------------------------------------
function public.use_victoryartifact2()

  local item = "inv_victoryartifact";

  if ( common.ApplyObj( item, "obj_swampmasterdwelling_use_victoryartifact2" ) and cmn.IsEventDone( "win_bossfight" ) ) then

    cmn.CallEventHandler( "use_victoryartifact2_inv" );
    cmn.CallEventHandler( "use_victoryartifact2_beg" );

    local func_after = function ()
  
      common_impl.Lock( false );

      public.vid_swampmasterdwelling_outroext();    

    end;

    common_impl.Lock( true );

    ObjSet( "anm_swampmasterdwelling_use_artifact2", { frame = 0, playing = true, endtrig = func_after, alp = 1 } );
     
    common_impl.PlayAudio( "sfx", "common/audio/aud_use_victoryartifact2", 0, "", 0 );
  
    return true;
  
  else

  end;

end;
--*********************************************************************************************************************
-- function *** PROGRESS GET *** () end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.get_artifactpiece_1()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_artifactpiece_1" );
  cmn.CallEventHandler( "get_artifactpiece_1" );

end;
--------------------------------------------------------------------------------------------
function private.get_artifactpiece_2()

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  
  cmn.SetEventDone( "get_artifactpiece_2" );
  cmn.CallEventHandler( "get_artifactpiece_2" );

end;
--*********************************************************************************************************************
-- function *** PROGRESS CLICK *** () end;
--*********************************************************************************************************************
function private.clk_dogs()
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_touch_hotdog", 0, "", 0 );

  common_impl.StopAudio( "env", "common/audio/aud_hotdogs_env", 0.2 );

  local func_after = function()

    common_impl.Lock( false );
    common_impl.ShowBbt( 'bbt_swampmasterdwelling_use_silverblade' );

    common_impl.PlayAudio( "env", "common/audio/aud_hotdogs_env", 1 );

    if ( not cmn.IsEventDone( "use_silverblade" ) and not cmn.IsEventDone( "use_loadedgun_4" ) ) then

      ObjSet( "anm_swampmasterdwelling_dog_2", { alp = 1 });
      ObjSet( "anm_swampmasterdwelling_dog_2_click", { alp = 0 });

    elseif ( cmn.IsEventDone( "use_silverblade" ) ) then

      ObjSet( "anm_swampmasterdwelling_dog_1", { alp = 1 });
      ObjSet( "anm_swampmasterdwelling_dog_1_click", { alp = 0 });

    else 

      ObjSet( "anm_swampmasterdwelling_dog_2", { alp = 1 });
      ObjSet( "anm_swampmasterdwelling_dog_2_click", { alp = 0 });

    end;

  end;

  common_impl.Lock( true );

  if ( not cmn.IsEventDone( "use_silverblade" ) and not cmn.IsEventDone( "use_loadedgun_4" ) ) then

    local func_anim = function()

      ObjSet( "anm_swampmasterdwelling_dog_1", { alp = 1 });
      ObjSet( "anm_swampmasterdwelling_dog_1_click", { alp = 0 });

      ObjSet( "anm_swampmasterdwelling_dog_2", { alp = 0 });
      ObjSet( "anm_swampmasterdwelling_dog_2_click", { alp = 1 });
      AnimPlay( "anm_swampmasterdwelling_dog_2_click", "DoAnim", func_after );

      common_impl.PlayAudio( "sfx", "common/audio/aud_touch_hotdog", 0, "", 0 );

    end;

    ObjSet( "anm_swampmasterdwelling_dog_1", { alp = 0 });
    ObjSet( "anm_swampmasterdwelling_dog_1_click", { alp = 1 });
    AnimPlay( "anm_swampmasterdwelling_dog_1_click", "DoAnim", func_anim );

  elseif ( cmn.IsEventDone( "use_silverblade" ) ) then

    ObjSet( "anm_swampmasterdwelling_dog_1", { alp = 0 });
    ObjSet( "anm_swampmasterdwelling_dog_1_click", { alp = 1 });
    AnimPlay( "anm_swampmasterdwelling_dog_1_click", "DoAnim", func_after );

  else 

    ObjSet( "anm_swampmasterdwelling_dog_2", { alp = 0 });
    ObjSet( "anm_swampmasterdwelling_dog_2_click", { alp = 1 });
    AnimPlay( "anm_swampmasterdwelling_dog_2_click", "DoAnim", func_after );

  end;

end;
--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************
function private.opn_swampmasterdwelling()

  if not ( cmn.IsEventDone( "opn_swampmasterdwelling" ) ) then
    cmn.SetEventDone( "opn_swampmasterdwelling" );
  end;
  
  cmn.CallEventHandler( "opn_swampmasterdwelling" ); 

end;
--*********************************************************************************************************************
function private.vid_swampmasterdwelling_ghosts()

  cmn.CallEventHandler( "vid_swampmasterdwelling_ghosts_beg" );
  ObjSet( "rm_swampmasterdwelling", { color_r = 0, color_g = 0, color_b = 0 } );
  ObjSet( "vid_swampmasterdwelling_ghosts", { alp = 1, active = true, input = false, visible = true } );

  local widget_settings = {}

  if IsCollectorsEdition() then

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnGuide,
      InterfaceWidget_BtnMenu
    }

  else

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnMenu
    }

  end;
  
  local func_after = function ( skip )

    interface.DialogVideoHide();
    cmn.SetEventDone( "vid_swampmasterdwelling_ghosts" );
    cmn.CallEventHandler( "vid_swampmasterdwelling_ghosts_end" );
    interface.KeyTaskAdd( 'defeat_master' );
    common_impl.ShowBbt( 'bbt_swampmasterdwelling_after_ghosts', 1 );

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

    if skip then

      common_impl.StopAudio( "sfx", "common/audio/aud_swampmasterdwelling_ghosts", 0.5 );
      
    end;

    common_impl.PlayAudio( "env", "common/audio/aud_hotdogs_env", 1, "", 0.5 );
    common_impl.PlayAudio( "mus", "common/audio/aud_danger1_mus", 0, "", 0 );
    common_impl.StopAudio( "voc", "common/audio/aud_swampmasterdwelling_ghosts_voc", 0.2 );
    
  end;

  for i = 1, #widget_settings do

    interface.WidgetSetVisible( widget_settings[i], 0 );

  end;
  
  common_impl.StopAllMus();
  interface.DialogVideoShow( "vid_swampmasterdwelling_ghosts", 1, function() func_after( 'skip' ); end, 3 );
  common_impl.PlayAudio( "sfx", "common/audio/aud_swampmasterdwelling_ghosts", 0, "", 0.5 );
  common_impl.PlayAudio( "voc", "common/audio/aud_swampmasterdwelling_ghosts_voc", 0, "", 0 );
  VidPlay( "vid_swampmasterdwelling_ghosts", function() func_after( nil ) end ); 

end;
--*********************************************************************************************************************
function public.vid_swampmasterdwelling_battle()

  ObjSet( "vid_swampmasterdwelling_battle", { alp = 1, active = true, input = false, visible = true } );

  local widget_settings = {}

  if IsCollectorsEdition() then

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnGuide,
      InterfaceWidget_BtnMenu
    }

  else

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnMenu
    }

  end;
  
  local func_ater = function ( skip )
    
    if skip then

       common_impl.StopAudio( "sfx", "common/audio/aud_swampmasterdwelling_battle", 0.2 );
       common_impl.StopAudio( "voc", "common/audio/aud_swampmasterdwelling_battle_voc", 0.2 );

    end;   

    interface.DialogVideoHide();
    cmn.SetEventDone( "use_victoryartifact1" );
    cmn.CallEventHandler( "use_victoryartifact1_end" );
    cmn.GotoRoom( "mg_bossfight" );
    common_impl.ShowBbt( 'bbt_swampmasterdwelling_after_battle', 1 );

    for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;

  end;

  for i = 1, #widget_settings do

    interface.WidgetSetVisible( widget_settings[i], 0 );

  end;

  common_impl.StopAllMus();
  interface.DialogVideoShow( "vid_swampmasterdwelling_battle", 1, function() func_ater( 'skip' ) end, 3 );
  common_impl.PlayAudio( "sfx", "common/audio/aud_swampmasterdwelling_battle", 0, "", 0.5 );
  common_impl.PlayAudio( "voc", "common/audio/aud_swampmasterdwelling_battle_voc", 0, "", 0.5 );
  VidPlay( "vid_swampmasterdwelling_battle", function() func_ater( nil ) end ); 

end;
--*********************************************************************************************************************
function public.vid_swampmasterdwelling_outroext()

  ObjSet( "vid_swampmasterdwelling_outroext", { alp = 1, active = true, input = false, visible = true } );

  --[[local widget_settings = {}

  if IsCollectorsEdition() then

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnGuide,
      InterfaceWidget_BtnMenu
    }

  else

    widget_settings = 
    {
      InterfaceWidget_Inventory,
      InterfaceWidget_BtnHint,
      InterfaceWidget_BtnMap,
      InterfaceWidget_BtnMenu
    }

  end;]]
  
  local func_after = function ( skip )

    if ( skip ) then 

      common_impl.StopAudio( "sfx", "common/audio/aud_swampmasterdwelling_outroext", 0.2 );

    end;

    interface.DialogVideoHide();
    cmn.SetEventDone( "use_victoryartifact2" );
    cmn.CallEventHandler( "use_victoryartifact2_end" );

    --common_impl.ShowBbt( 'bbt_swampmasterdwelling_after_outro', 1 );

    --[[for i = 1, #widget_settings do

      interface.WidgetSetVisible( widget_settings[i], 1, true );

    end;]]

    common.GotoRoom( "rm_credits" );

  end;

  --[[for i = 1, #widget_settings do

    interface.WidgetSetVisible( widget_settings[i], 0 );

  end;]]

  common_impl.StopAllMus();
  interface.DialogVideoShow( "vid_swampmasterdwelling_outroext", 1, function() func_after( 'skip' ) end, 3 );
  VidPlay( "vid_swampmasterdwelling_outroext", function() func_after( nil ) end );
  common_impl.PlayAudio( "sfx", "common/audio/aud_swampmasterdwelling_outroext", 0, "", 0 );
 

end;
--*********************************************************************************************************************
