-- name=ho_hos_scr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "hos_scr" );
  game.relations[ "ho_hos_scr" ].exitroom = "rm_mysteryroom";
  public.found = {};

  private.table_obj = {
    { "balloon", 0, { { "spr_hos_scr_balloon" } } }, 
    { "barrel", 0, { { "spr_hos_scr_barrel" } } }, 
    { "bell", 1, {  { "spr_hos_scr_tongue_2", "obj_hos_scr_use_tongue_2" } ,{ "spr_hos_scr_bell" } } }, 
    { "box", 0, { { "spr_hos_scr_box" } } }, 
    { "dart", 0, { { "obj_hos_scr_dart" } } }, 
    { "hook", 0, { { "spr_hos_scr_hook" } } }, 
    { "jug", 0, { { "spr_hos_scr_jug" } } }, 
    { "mask", 0, { { "spr_hos_scr_mask" } } }, 
    { "skull", 0, { { "spr_hos_scr_skull" } } }, 
    { "statuette", 0, { { "spr_hos_scr_statuette" } } }, 
    { "anchor", 0, { { "spr_hos_scr_anchor" } } }, 
    { "brick", 0, { { "spr_hos_scr_brick" } } }, 
    { "airplane", 0, { { "spr_hos_scr_airplane" } } }, 
    { "boomerang", 0, { { "spr_hos_scr_boomerang" } } }, 
    { "bowl", 0, { { "spr_hos_scr_bowl" } } }, 
    { "fork", 0, { { "spr_hos_scr_fork" } } }, 
    { "hammer", 0, { { "spr_hos_scr_hammer" } } }, 
    { "plunger", 0, { { "spr_hos_scr_plunger" } } }, 
    { "rune", 0, { { "spr_hos_scr_rune" } } }, 
    { "tortoise", 0, { { "spr_hos_scr_tortoise" } } }, 
    { "watch", 0, { { "spr_hos_scr_watch" } } }
  };

  public.ResetInit();
  --------------------------------------------------------------------------------------------------

  local win_hos_scr_func = function ()

    if ( cmn.IsEventDone( "win_hos_scr" ) ) then

      --

    end;

  end;
  cmn.AddSubscriber( "win_hos_scr", win_hos_scr_func );
  --------------------------------------------------------------------------------------------------
  local unmark_bell = function () 
   
    ObjSet( "spr_hos_scr_tongue_1", { alp = 1 } ); 
    ObjSet( "spr_hos_scr_bell", { input = true } ); 
    ObjDetach( "spr_hos_scr_tongue_2" );
    ObjDetach( "obj_hos_scr_use_tongue_2" ); 
    
  end;

  cmn.AddSubscriber( "unmark_bell", unmark_bell, "ho_hos_scr" );  
  --------------------------------------------------------------------------------------------------
  local start_hos_scr_func = function ()

    if ( not cmn.IsEventDone( "win_hos_scr" ) ) then

      local t_gen = ng_global.progress[ "scr" ][ "win_hos_scr" ].t_gen;
      for i = 1, #t_gen do

        ObjSet( "spr_hos_scr_"..t_gen[ i ][ 1 ], { visible = true, input = true, event_mdown = function() private.TaskComplete( t_gen[ i ][ 1 ] ) end } );

      end;

      local ho_found = ng_global.progress[ "scr" ][ "win_hos_scr" ].found;

      for i = 1, #ho_found, 1 do
        ObjDetach( ho_found[ i ][ "object" ] );
      end;

      if cmn.IsUnmarkedTask( "hos_scr", "bell" ) then
          unmark_bell();
      end;

    end;

  end;
  cmn.AddSubscriber( "win_hos_scr", start_hos_scr_func, "ho_hos_scr" ); 

  local end_hos_scr_rm = function ()
  
    if ( cmn.IsEventDone( "win_hos_scr" ) ) then

      --

    end;

  end; 

  cmn.AddSubscriber( "win_hos_scr", start_hos_scr_func, "ho_hos_scr" );    

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Sorting()

  local count = #private.table_obj;
  ng_global.progress[ "scr" ][ "win_hos_scr" ].t_gen = {};  

  for i = ( #private.table_obj ), 1, -1 do

    local temp = private.table_obj[ i ];
    j = math.random( i );
    private.table_obj[ i ] = private.table_obj[ j ];
    private.table_obj[ j ] = temp;

  end;

  for i = 1, 12 do

    ng_global.progress[ "scr" ][ "win_hos_scr" ].t_gen[ i ] = private.table_obj[ i ];
    ObjSet( "spr_hos_scr_"..private.table_obj[ i ][ 1 ], { alp = 1, visible = true, input = true, event_mdown = function() private.TaskComplete( private.table_obj[ i ][ 1 ] ) end } );

    if private.table_obj[ i ][ 1 ] == "bell" then

      ObjSet( "obj_hos_scr_use_tongue_2",  { input = true } );
      ObjSet( "spr_hos_scr_tongue_2",      { input = true, visible = true, alp = 1 } ); 
      ObjSet( "spr_hos_scr_bell", { input = true, visible = true } );

    end;

  end;

end;
--*********************************************************************************************************************
function public.ResetInit()

  local table_multiset = {};

  table.insert( table_multiset, { "spr_hos_scr_balloon",   { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_hos_scr_barrel",    { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_hos_scr_bell",      { visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_hos_scr_box",       { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "obj_hos_scr_dart",      { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_hos_scr_hook",      { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_hos_scr_jug",       { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_hos_scr_mask",      { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_hos_scr_skull",     { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_hos_scr_statuette", { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_hos_scr_anchor",    { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_hos_scr_brick",     { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_hos_scr_tongue_2",  { event_startdrag = function() private.GetItem( 'tongue_2' ) end, event_dragdrop = function() private.unmark_bell() end } } );

  table.insert( table_multiset, { "spr_hos_scr_airplane",  { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_hos_scr_boomerang", { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_hos_scr_bowl",      { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_hos_scr_fork",      { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_hos_scr_hammer",    { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_hos_scr_plunger",   { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_hos_scr_rune",      { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_hos_scr_tortoise",  { input = false, visible = false, pos_z = 1 } } );
  table.insert( table_multiset, { "spr_hos_scr_watch",     { input = false, visible = false, pos_z = 0 } } );

  table.insert( table_multiset, { "spr_hos_scr_tongue_2",      { input = false, visible = false } } );
  table.insert( table_multiset, { "obj_hos_scr_use_tongue_2",  { input = false } } );

  ObjMultiSet( table_multiset );


end;
--*********************************************************************************************************************
function public.ResetStart()

  local ho_found = public.found;

  for key = 1, #ho_found do

    ObjAttach( ho_found[ key ][ "object" ], "obj_hos_scr_objects" );

    ObjSet( ho_found[ key ][ "object" ], { alp = 1 } );

    local pfx_name = "pfx_int_taskpanel_collect_"..ho_found[ key ][ "object" ];

    if ObjGet( pfx_name ) then

      ObjDelete( pfx_name );

    end;

  end;  

  ObjAttach( "spr_hos_scr_tongue_2", "ho_hos_scr" );
  ObjAttach( "obj_hos_scr_use_tongue_2", "ho_hos_scr" );

  local table_multiset = {
    { "spr_hos_scr_tongue_1", { alp = 0 } },
    { "spr_hos_scr_bell", { input = false } },
  }
  ObjMultiSet( table_multiset );  

end;
--*********************************************************************************************************************
function public.PreOpen()
    
  int_slider.InitSlider( "ho_hos_scr" );

  local is_repeat = false;

  if cmn.IsEventDone(  "win_hos_scr" ) and cmn.IsEventStart( "win_hos_scr" )  then

    public.found = ng_global.progress[ "scr" ][ "win_hos_scr" ].found;
    ng_global.progress[ "scr" ][ "opn_hos_scr" ].done = 0;
    
    ng_global.progress[ "scr" ][ "win_hos_scr" ].done = 0;
    ng_global.progress[ "scr" ][ "win_hos_scr" ].start = 0;

    ng_global.progress[ "scr" ][ "win_hos_scr" ].t_gen = {};
    is_repeat = true;

    public.ResetInit();

  end; 

  if ( not cmn.IsEventDone( "opn_hos_scr" ) ) then

    public.Sorting();

    cmn.InitHo( "hos_scr" );
    cmn.SetEventDone( "opn_hos_scr" );
    cmn.SetMarkedTask( "hos_scr", "bell" );

    ng_global.progress["scr"]["win_hos_scr"].count = 0;
    ng_global.progress["scr"]["win_hos_scr"].anim = false;

    ng_global.progress[ "scr" ][ "win_hos_scr" ].timer = { default = 40, time = 40, diff = 20, extra = 0 };
  
  end;

  local ho_items = {};

  local tmp_progress = ng_global.progress[ "scr" ][ "win_hos_scr" ].t_gen;

  for i = 1, 12 do

    interface.TaskPanelTaskAdd( ho_items, tmp_progress[ i ][ 1 ],  1, tmp_progress[ i ][ 2 ], tmp_progress[ i ][ 3 ] );

  end;
  interface.TaskPanelShow( ho_items );

  interface.InvestigationButtonCheck();

  --common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );
  common_impl.PlayAudio( "env", "common/audio/aud_ho_hos_env", 1 );

  if is_repeat then
 
    public.ResetStart();

  end;

    levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  int_button_timer.Hide();

  levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.TutorialShow( "tutorial_page_6_scr" );

  int_button_timer.Show();  
  --common_impl.PassingHoStart();  

end;
--*********************************************************************************************************************
function public.Close ()

  --common_impl.PassingHoStop();
  --common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );
  common_impl.StopAudio( "env", "common/audio/aud_ho_hos_env", 0.5 );

end;
--*********************************************************************************************************************
function public.HoComplete()

  levelscr_inv.HoDeleteWin();
  --common_impl.PassingHoWin();
  rm_mysteryroom.WinTask();

  ObjDetach( "txt_hos_scr_task" );
  ObjSet( "obj_int_taskpanel", { alp = 1 } );
  
end;
--*********************************************************************************************************************
function private.TaskComplete( task_name, object_name )
 
  local object = "";

  if object_name then

    object = tostring( object_name );

  else

    object = "spr_hos_scr_"..task_name;

  end;
 
  ObjSet( object, { pos_z = 1 } );

  cmn.HoTaskFind( object, task_name );

end;
--*********************************************************************************************************************
function private.GetItem( name )
  
  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  ObjSet( "spr_hos_scr_"..name, { pos_z = 20 } );

end;
--*********************************************************************************************************************
function private.unmark_bell() 
 
  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_hos_scr_tongue_2", "obj_hos_scr_use_tongue_2" ) ) then

    common_impl.Lock(true);
    
    ObjSet( "spr_hos_scr_tongue_2", { alp = 0 } );

    local func_after = function()

      common_impl.Lock(false);
  
      cmn.UnmarkTask( "hos_scr", "bell" );
      cmn.CallEventHandler( "unmark_bell" );

    end;
    
    ObjAnimate( "spr_hos_scr_tongue_1", "alp", 0, 0, func_after, { 0,3,0,  0.4,3,1 } );
   
  else

    ObjSet( "spr_hos_scr_tongue_2", { pos_z = 0 } );
        
  end;

end;
--*********************************************************************************************************************
function private.AnimFish_2()

  local func_end = function()

    ObjAnimate( "anm_hos_scr_fish_2", "pos_x", 0, 0, private.AnimFish_2, 
    {
      0,   0, 940,  
      80, 0, -230
    } );

  end;

  ObjAnimate( "anm_hos_scr_fish_2", "pos_x", 0, 0, func_end, 
  {
    0,   0, 1260,  
    30, 0, 940
  } );

end;
--*********************************************************************************************************************
function private.AnimFish_3()

  local func_end = function()

    ObjAnimate( "anm_hos_scr_fish_3", "pos_x", 0, 0, private.AnimFish_3, 
    {
      0,   0, 562,  
      80, 0, 1290
    } );

  end;

  ObjAnimate( "anm_hos_scr_fish_3", "pos_x", 0, 0, func_end, 
  {
    0,   0, -230,  
    30, 0, 562
  } );

end;
--*********************************************************************************************************************
function private.AnimFish_4()

  local func_end = function()

    ObjAnimate( "anm_hos_scr_fish_4", "pos_x", 0, 0, private.AnimFish_4, 
    {
      0,   0, 76,  
      80, 0, 1280
    } );

  end;

  ObjAnimate( "anm_hos_scr_fish_4", "pos_x", 0, 0, func_end, 
  {
    0,   0, -230,  
    40, 0, 76
  } );

end;
--*********************************************************************************************************************
ObjAnimate("spr_hos_scr_algae_1", "ang", 1, 0, "", { 0,3,-0.02, 2.1,3,0.01, 4.2,3,-0.02 });
ObjAnimate("spr_hos_scr_algae_2", "ang", 1, 0, "", { 0,3,0.02, 2,3,-0.01, 4,3,0.02 });
ObjAnimate("spr_hos_scr_algae_3", "pos_xy", 1, 0, "", { 0,0,-82,204, 1.4,0,-79,201, 2.8,0,-82,204 });
ObjAnimate("spr_hos_scr_algae_4", "pos_xy", 1, 0, "", { 0,0,-107,351, 1.7,0,-104,348, 3.4,0,-107,351 });
ObjAnimate("spr_hos_scr_algae_5", "ang", 1, 0, "", { 0,3,-0.02, 2.4,3,0.02, 4.8,3,-0.02 });

ObjAnimate("spr_hos_scr_algae_6", "scale_xy", 1, 0, "", { 0,0,1,1, 2,0,1.02,1.02, 4,0,1,1 });
ObjAnimate("spr_hos_scr_algae_7", "scale_xy", 1, 0, "", { 0,0,1,1, 2,0,1.02,1.02, 4,0,1,1 });

ObjAnimate("spr_hos_scr_light", "alp", 1, 0, "", { 0,0,1, 1.8,0,0.5, 3.6,0,1 });
--*********************************************************************************************************************
ObjAnimate( "anm_hos_scr_fish_1", "pos_x", 1, 0, "", 
{
  0,   0, -265,  
  70, 0, 1290
} ); 

ObjAnimate( "anm_hos_scr_fish_2", "pos_x", 0, 0, private.AnimFish_2, 
{
  0,   0, 940,  
  80, 0, -230
} ); 

ObjAnimate( "anm_hos_scr_fish_3", "pos_x", 0, 0, private.AnimFish_3, 
{
  0,   0, 562,  
  80, 0, 1290
} ); 

ObjAnimate( "anm_hos_scr_fish_4", "pos_x", 0, 0, private.AnimFish_4, 
{
  0,   0, 76,  
  80, 0, 1280
} ); 