-- name=ho_intreehole_scr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "intreehole_scr" );
  game.relations[ "ho_intreehole_scr" ].exitroom = "rm_mysteryroom";
  private.room_objname = "ho_intreehole_scr";
  private.found = {};
  --------------------------------------------------------------------------------------------------

  private.table_obj = {
    { "beetle",          0, { { "spr_intreehole_scr_beetle" } } }, 
    { "bird",            0, { { "spr_intreehole_scr_bird" } } }, 
    { "bow_knot",        0, { { "spr_intreehole_scr_bow_knot" } } }, 
    { "feather",         0, { { "spr_intreehole_scr_feather" } } }, 
    { "flower",          0, { { "spr_intreehole_scr_flower" } } }, 
    { "fragment_mirror", 0, { { "spr_intreehole_scr_fragment_mirror" } } }, 
    { "matches",         0, { { "spr_intreehole_scr_matches" } } }, 
    { "mushroom",        0, { { "spr_intreehole_scr_mushroom" } } }, 
    { "photo",           0, { { "spr_intreehole_scr_photo" } } }, 
    { "pin",             0, { { "spr_intreehole_scr_pin" } } }, 
    { "ring",            0, { { "spr_intreehole_scr_ring" } } }, 
    { "soldier",         0, { { "spr_intreehole_scr_soldier" } } }, 
    { "bolt",            0, { { "spr_intreehole_scr_bolt" } } }, 
    { "brush",           0, { { "spr_intreehole_scr_brush" } } }, 
    { "button",          0, { { "spr_intreehole_scr_button" } } }, 
    { "head",            0, { { "spr_intreehole_scr_head" } } }, 
    { "newring",         0, { { "spr_intreehole_scr_newring" } } }, 
    { "pin_cushion",     0, { { "spr_intreehole_scr_pin_cushion" } } }, 
    { "raspberry",       0, { { "spr_intreehole_scr_raspberry" } } }, 
    { "scissors",        0, { { "spr_intreehole_scr_scissors" } } }, 
    { "thread",          0, { { "spr_intreehole_scr_thread" } } }, 
    { "stone",           0, { { "spr_intreehole_scr_stone1" }, { "spr_intreehole_scr_stone2" }, { "spr_intreehole_scr_stone3" } } }, 
  };

  public.ResetInit();

  local win_intreehole_scr_func = function ()

    if ( cmn.IsEventDone( "win_intreehole_scr" ) ) then

       --

    end;

  end;
  cmn.AddSubscriber( "win_intreehole_scr", win_intreehole_scr_func );
  --------------------------------------------------------------------------------------------------
  local start_intreehole_scr_func = function ()

    if ( cmn.IsEventStart( "win_intreehole_scr" ) ) then

      local t_gen = ng_global.progress[ "scr" ][ "win_intreehole_scr" ].t_gen;
      for i = 1, #t_gen do
        
        if t_gen[ i ][ 1 ] == "stone" then

          ObjSet( "spr_intreehole_scr_stone1", { alp = 1, visible = true, input = true, event_mdown = function() private.TaskComplete( 'stone', 'spr_intreehole_scr_stone1' ) end } );
          ObjSet( "spr_intreehole_scr_stone2", { alp = 1, visible = true, input = true, event_mdown = function() private.TaskComplete( 'stone', 'spr_intreehole_scr_stone2' ) end } );
          ObjSet( "spr_intreehole_scr_stone3", { alp = 1, visible = true, input = true, event_mdown = function() private.TaskComplete( 'stone', 'spr_intreehole_scr_stone3' ) end } );

        else

          ObjSet( "spr_intreehole_scr_"..t_gen[ i ][ 1 ], { visible = true, input = true, event_mdown = function() private.TaskComplete( t_gen[ i ][ 1 ] ) end } );

        end;

      end;

      local ho_found = ng_global.progress[ "scr" ][ "win_intreehole_scr" ].found;

      for i = 1, #ho_found, 1 do
        ObjDetach( ho_found[ i ][ "object" ] );
      end;

    end;

  end;
  cmn.AddSubscriber( "win_intreehole_scr", start_intreehole_scr_func, private.room_objname );  
end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Sorting()

  local count = #private.table_obj;
  ng_global.progress[ "scr" ][ "win_intreehole_scr" ].t_gen = {};  

  for i = ( #private.table_obj ), 1, -1 do

    local temp = private.table_obj[ i ];
    j = math.random( i );
    private.table_obj[ i ] = private.table_obj[ j ];
    private.table_obj[ j ] = temp;

  end;

  for i = 1, 12 do

    ng_global.progress[ "scr" ][ "win_intreehole_scr" ].t_gen[ i ] = private.table_obj[ i ];
    
    if private.table_obj[ i ][ 1 ] == "stone" then

      ObjSet( "spr_intreehole_scr_stone1", { alp = 1, visible = true, input = true, event_mdown = function() private.TaskComplete( 'stone', 'spr_intreehole_scr_stone1' ) end } );
      ObjSet( "spr_intreehole_scr_stone2", { alp = 1, visible = true, input = true, event_mdown = function() private.TaskComplete( 'stone', 'spr_intreehole_scr_stone2' ) end } );
      ObjSet( "spr_intreehole_scr_stone3", { alp = 1, visible = true, input = true, event_mdown = function() private.TaskComplete( 'stone', 'spr_intreehole_scr_stone3' ) end } );

    else

      ObjSet( "spr_intreehole_scr_"..private.table_obj[ i ][ 1 ], { alp = 1, visible = true, input = true, event_mdown = function() private.TaskComplete( private.table_obj[ i ][ 1 ] ) end } );

    end;

  end;

end;
--*********************************************************************************************************************
function public.ResetInit()

  local table_multiset = {};

  table.insert( table_multiset, { "spr_intreehole_scr_beetle",          { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_bird",            { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_bow_knot",        { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_feather",         { input = false, visible = false, pos_z = 1 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_flower",          { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_fragment_mirror", { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_matches",         { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_mushroom",        { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_photo",           { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_pin",             { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_ring",            { input = false, visible = false, pos_z = 1 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_soldier",         { input = false, visible = false, pos_z = 4 } } );
  table.insert( table_multiset, { "obj_intreehole_scr_clk_doll_1",      { event_mdown = function() private.clk_doll( 1 ) end } } );
  table.insert( table_multiset, { "obj_intreehole_scr_clk_doll_2",      { event_mdown = function() private.clk_doll( 2 ) end } } );
  table.insert( table_multiset, { "spr_intreehole_scr_bolt",            { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_brush",           { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_button",          { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_head",            { input = false, visible = false, pos_z = 3 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_newring",         { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_pin_cushion",     { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_raspberry",       { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_scissors",        { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_thread",          { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_stone1",         { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_stone2",         { input = false, visible = false, pos_z = 0 } } );
  table.insert( table_multiset, { "spr_intreehole_scr_stone3",         { input = false, visible = false, pos_z = 0 } } );

  ObjMultiSet( table_multiset );  

end;
--*********************************************************************************************************************
function public.ResetStart()

  local ho_found = private.found;

  for key = 1, #ho_found do

    ObjAttach( ho_found[ key ][ "object" ], "obj_intreehole_scr_objects" );
    ObjSet( ho_found[ key ][ "object" ], { alp = 1 } );

    if ho_found[ key ][ "object" ] == "spr_intreehole_scr_bow_knot" then

      ObjAttach( ho_found[ key ][ "object" ], "ho_intreehole_scr" );

    end;

    local pfx_name = "pfx_int_taskpanel_collect_"..ho_found[ key ][ "object" ];

    if ObjGet( pfx_name ) then

      ObjDelete( pfx_name );

    end;

  end;    

  ObjAttach( "spr_intreehole_scr_soldier", "ho_intreehole_scr" );

end;
--*********************************************************************************************************************
function public.PreOpen()

  local is_repeat = false;

  if cmn.IsEventDone(  "win_intreehole_scr" ) and cmn.IsEventStart( "win_intreehole_scr" )  then

    private.found = ng_global.progress[ "scr" ][ "win_intreehole_scr" ].found;

    ng_global.progress[ "scr" ][ "opn_intreehole_scr" ].done = 0;
    
    ng_global.progress[ "scr" ][ "win_intreehole_scr" ].done = 0;
    ng_global.progress[ "scr" ][ "win_intreehole_scr" ].start = 0;

    ng_global.progress[ "scr" ][ "win_intreehole_scr" ].t_gen = {};  
    is_repeat = true;

    public.ResetInit();

  end; 

  if ( not cmn.IsEventDone( "opn_intreehole_scr" ) ) then

    public.Sorting();
  
    cmn.InitHo( "intreehole_scr" );
    cmn.SetEventDone( "opn_intreehole_scr" );

    ng_global.progress[ "scr" ][ "win_intreehole_scr" ].timer = { default = 30, time = 30, diff = 20, extra = 0 };
  
  end;

  local ho_items = {};

  local tmp_progress = ng_global.progress[ "scr" ][ "win_intreehole_scr" ].t_gen;

  for i = 1, 12 do

    local count = 1;
    if tmp_progress[ i ][ 1 ] == "stone" then
      count = 3;
    end;

    interface.TaskPanelTaskAdd( ho_items, tmp_progress[ i ][ 1 ], count, tmp_progress[ i ][ 2 ], tmp_progress[ i ][ 3 ] );

  end;

  interface.TaskPanelShow( ho_items );

  interface.InvestigationButtonCheck();

  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );
  common_impl.PlayAudio( "env", "common/audio/aud_ho_intreehole_env", 1, "", 0.5 );

  if is_repeat then
 
    public.ResetStart();

  end;

  levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  int_button_timer.Hide();

  common_impl.StopAudio( "env", "common/audio/aud_ho_intreehole_env", 1 );

  levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
function public.Open()

  common_impl.TutorialShow( "tutorial_page_6_scr" );

  int_button_timer.Show();
  --common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.Close()

  --common_impl.PassingHoStop();

  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 0, "", 0.5 );

end;
--*********************************************************************************************************************
function public.HoComplete()

  levelscr_inv.HoDeleteWin();
  --common_impl.PassingHoWin();
  rm_mysteryroom.WinTask();

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name, object_name )

  local object = "";

  if object_name then

    object = tostring( object_name );

  else

    object = "spr_intreehole_scr_"..task_name;

  end;

  cmn.HoTaskFind( object, task_name );
 
end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.clk_doll( number )

  common_impl.ShowBbt( 'bbt_intreehole_scr_clk_dolls', 1 );

  common_impl.PlayAudio( "sfx", "common/audio/aud_ho_intreehole_figure_"..number, 0, "", 0 );
  
  ObjSet( "obj_intreehole_scr_clk_doll_"..number, { input = false } );
  
  local func_after = function()

     ObjSet( "obj_intreehole_scr_clk_doll_"..number, { input = true } );

  end;

  AnimPlay( "anm_intreehole_scr_doll_"..number, "DoAnim", func_after );

end;
--------------------------------------------------------------------------------------------
