-- name=ho_ladder_scr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "ladder_scr" );
  game.relations[ "ho_ladder_scr" ].exitroom = "rm_mysteryroom";
  private.tasks = { "", "" };
  private.found = {};
  --------------------------------------------------------------------------------------------------

  private.table_obj = {
    { "binoculars",         0, { { "spr_ladder_scr_binoculars_1", "spr_ladder_scr_binoculars_2"  } } }, 
    { "candlestick",          0, { { "spr_ladder_scr_candlestick_1", "spr_ladder_scr_candlestick_2" } } }, 
    { "cat",                0, { { "spr_ladder_scr_cat_1", "spr_ladder_scr_cat_2" } } }, 
    { "hat",                0, { { "spr_ladder_scr_hat_1", "spr_ladder_scr_hat_2" } } }, 
    { "key",                0, { { "spr_ladder_scr_key_1", "spr_ladder_scr_key_2" } } }, 
    { "brush",              0, { { "spr_ladder_scr_brush_1", "spr_ladder_scr_brush_2" } } }, 
    { "hammer",             0, { { "spr_ladder_scr_hammer_1", "spr_ladder_scr_hammer_2" } } }, 
    { "staircase",          0, { { "spr_ladder_scr_staircase_1", "spr_ladder_scr_staircase_2" } } }, 
    { "ammunition",         0, { { "spr_ladder_scr_ammunition_1", "spr_ladder_scr_ammunition_2" } } },  
    { "bottle",             0, { { "spr_ladder_scr_bottle_1", "spr_ladder_scr_bottle_2" } } }, 
    { "carbine",            0, { { "spr_ladder_scr_carbine_1", "spr_ladder_scr_carbine_2" } } }, 
    { "fan",                0, { { "spr_ladder_scr_fan_1", "spr_ladder_scr_fan_2" } } }, 
    { "film",               0, { { "spr_ladder_scr_film_1", "spr_ladder_scr_film_2" } } }, 
    { "garmon",             0, { { "spr_ladder_scr_garmon_1", "spr_ladder_scr_garmon_2" } } }, 
    { "gloves",             0, { { "spr_ladder_scr_gloves_1", "spr_ladder_scr_gloves_2" } } }, 
    { "plane",              0, { { "spr_ladder_scr_plane_1", "spr_ladder_scr_plane_2" } } }, 
    { "purse",              0, { { "spr_ladder_scr_purse_1", "spr_ladder_scr_purse_2" } } }, 
    { "sickle",             0, { { "spr_ladder_scr_sickle_1", "spr_ladder_scr_sickle_2" } } }, 
  };

  public.ResetInit();  
  
  local win_ladder_scr_func = function ()

    if ( cmn.IsEventDone( "win_ladder_scr" ) ) then


    end;

  end;

  cmn.AddSubscriber( "win_ladder_scr", win_ladder_scr_func );
  --------------------------------------------------------------------------------------------------
  local start_ladder_scr_func = function ()

    if ( cmn.IsEventStart( "win_ladder_scr" ) ) then

      local t_gen = ng_global.progress[ "scr" ][ "win_ladder_scr" ].t_gen;
      for i = 1, #t_gen do

        ObjSet( "spr_ladder_scr_"..t_gen[ i ][ 1 ].."_1", { visible = true, input = true, event_mdown = function() private.ClkTask( t_gen[ i ][ 1 ], t_gen[ i ][ 1 ].."_1" ) end } );
        ObjSet( "spr_ladder_scr_"..t_gen[ i ][ 1 ].."_2", { visible = true, input = true, event_mdown = function() private.ClkTask( t_gen[ i ][ 1 ], t_gen[ i ][ 1 ].."_2" ) end } );

      end;
      
      local ho_found = ng_global.progress[ "scr" ][ "win_ladder_scr" ].found;

      for i = 1, #ho_found, 1 do
        ObjDetach( ho_found[ i ][ "object" ] );
      end;

    end;

    ObjSet( "txt_ladder_scr_tasklist", { param0 = ng_global.progress[ "scr" ][ "win_ladder_scr" ].counter } );

  end;
  cmn.AddSubscriber( "win_ladder_scr", start_ladder_scr_func, "ho_ladder_scr" );  

end;
--*********************************************************************************************************************
function public.Sorting()

  local count = #private.table_obj;
  ng_global.progress[ "scr" ][ "win_ladder_scr" ].t_gen = {};  

  for i = ( #private.table_obj ), 1, -1 do

    local temp = private.table_obj[ i ];
    j = math.random( i );
    private.table_obj[ i ] = private.table_obj[ j ];
    private.table_obj[ j ] = temp;

  end;

  for i = 1, 8 do

    ng_global.progress[ "scr" ][ "win_ladder_scr" ].t_gen[ i ] = private.table_obj[ i ];
    ObjSet( "spr_ladder_scr_"..private.table_obj[ i ][ 1 ].."_1", { visible = true, input = true, event_mdown = function() private.ClkTask( private.table_obj[ i ][ 1 ], private.table_obj[ i ][ 1 ].."_1" ) end } );
    ObjSet( "spr_ladder_scr_"..private.table_obj[ i ][ 1 ].."_2", { visible = true, input = true, event_mdown = function() private.ClkTask( private.table_obj[ i ][ 1 ], private.table_obj[ i ][ 1 ].."_2" ) end } );

  end;

end;
--*********************************************************************************************************************
function public.ResetInit()

  ObjSet( "txt_ladder_scr_tasklist", { param0 = 8 } );

  ObjMultiSet( {
  
    { "spr_ladder_scr_binoculars_1", { input = false, visible = false } },
    { "spr_ladder_scr_binoculars_2", { input = false, visible = false } },
    { "spr_ladder_scr_candlestick_1", { input = false, visible = false } },
    { "spr_ladder_scr_candlestick_2", { input = false, visible = false } },
    { "spr_ladder_scr_cat_1", { input = false, visible = false } },
    { "spr_ladder_scr_cat_2", { input = false, visible = false } },
    { "spr_ladder_scr_key_1", { input = false, visible = false } },
    { "spr_ladder_scr_key_2", { input = false, visible = false } },
    { "spr_ladder_scr_hat_1", { input = false, visible = false } },
    { "spr_ladder_scr_hat_2", { input = false, visible = false } },
    { "spr_ladder_scr_brush_1", { input = false, visible = false } },
    { "spr_ladder_scr_brush_2", { input = false, visible = false } },
    { "spr_ladder_scr_hammer_1", { input = false, visible = false } },
    { "spr_ladder_scr_hammer_2", { input = false, visible = false } },
    { "spr_ladder_scr_staircase_1", { input = false, visible = false } },
    { "spr_ladder_scr_staircase_2", { input = false, visible = false } },
    { "spr_ladder_scr_ammunition_1", { input = false, visible = false } },
    { "spr_ladder_scr_ammunition_2", { input = false, visible = false } },
    { "spr_ladder_scr_bottle_1", { input = false, visible = false } },
    { "spr_ladder_scr_bottle_2", { input = false, visible = false } },
    { "spr_ladder_scr_carbine_1", { input = false, visible = false } },
    { "spr_ladder_scr_carbine_2", { input = false, visible = false } },
    { "spr_ladder_scr_fan_1", { input = false, visible = false } },
    { "spr_ladder_scr_fan_2", { input = false, visible = false } },
    { "spr_ladder_scr_film_1", { input = false, visible = false } },
    { "spr_ladder_scr_film_2", { input = false, visible = false } },
    { "spr_ladder_scr_garmon_1", { input = false, visible = false } },
    { "spr_ladder_scr_garmon_2", { input = false, visible = false } },
    { "spr_ladder_scr_gloves_1", { input = false, visible = false } },
    { "spr_ladder_scr_gloves_2", { input = false, visible = false } },
    { "spr_ladder_scr_plane_1", { input = false, visible = false } },
    { "spr_ladder_scr_plane_2", { input = false, visible = false } },
    { "spr_ladder_scr_purse_1", { input = false, visible = false } },
    { "spr_ladder_scr_purse_2", { input = false, visible = false } },
    { "spr_ladder_scr_sickle_1", { input = false, visible = false } },
    { "spr_ladder_scr_sickle_2", { input = false, visible = false } },
    
  } );

end;
--*********************************************************************************************************************
function public.ResetStart()

  local ho_found = private.found;
  local name = "";
  
  for key = 1, #ho_found do

    ObjAttach( ho_found[ key ][ "object" ], "obj_ladder_scr_objects" );
    ObjSet( ho_found[ key ][ "object" ], { alp = 1 } );

    if ho_found[ key ][ "object" ] == "spr_ladder_scr_candlestick_1" then
      ObjSet( "spr_ladder_scr_candlestick_1", { pos_z = 4 } );
    elseif ho_found[ key ][ "object" ] == "spr_ladder_scr_hammer_1" then
      ObjSet( "spr_ladder_scr_hammer_1", { pos_z = 3 } );
    elseif ho_found[ key ][ "object" ] == "spr_ladder_scr_plane_2" then
      ObjSet( "spr_ladder_scr_plane_2", { pos_z = 2 } );
    elseif ho_found[ key ][ "object" ] == "spr_ladder_scr_plane_1" then
      ObjSet( "spr_ladder_scr_plane_1", { pos_z = 2 } );
    elseif ho_found[ key ][ "object" ] == "spr_ladder_scr_staircase_2" then
      ObjSet( "spr_ladder_scr_staircase_2", { pos_z = 2 } );
    elseif ho_found[ key ][ "object" ] == "spr_ladder_scr_hat_2" then
      ObjSet( "spr_ladder_scr_hat_2", { pos_z = 2 } );
    end;

    local pfx_name = "pfx_int_taskpanel_collect_"..ho_found[ key ][ "object" ];

    if ObjGet( pfx_name ) then

      ObjDelete( pfx_name );

    end;
        
    ObjSet( ho_found[ key ][ "object" ].."_light", { alp = 0 } );

  end;      

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  local is_repeat = false;

  if cmn.IsEventDone(  "win_ladder_scr" ) and cmn.IsEventStart( "win_ladder_scr" )  then

    private.found = ng_global.progress[ "scr" ][ "win_ladder_scr" ].found;
    private.coord_piece = ng_global.progress["scr"]["win_ladder_scr"].coord;
    ng_global.progress[ "scr" ][ "opn_ladder_scr" ].done = 0;
    
    ng_global.progress[ "scr" ][ "win_ladder_scr" ].done = 0;
    ng_global.progress[ "scr" ][ "win_ladder_scr" ].start = 0;
    ng_global.progress[ "scr" ][ "win_ladder_scr" ].t_gen = {};

    is_repeat = true;

    public.ResetInit();

  end; 

  if ( not cmn.IsEventDone( "opn_ladder_scr" ) ) then

    public.Sorting();
  
    cmn.InitHo( "ladder_scr" );
    cmn.SetEventDone( "opn_ladder_scr" );
    ng_global.progress[ "scr" ][ "win_ladder_scr" ].counter = 8;
    ng_global.progress[ "scr" ][ "win_ladder_scr" ].timer = { default = 60, time = 60, diff = 20, extra = 0 };
  
  end;

  local ho_items = {};

  local tmp_progress = ng_global.progress[ "scr" ][ "win_ladder_scr" ].t_gen;

  for i = 1, 8 do

    interface.TaskPanelTaskAdd( ho_items, tmp_progress[ i ][ 1 ],        1, tmp_progress[ i ][ 2 ], tmp_progress[ i ][ 3 ] );
    interface.TaskPanelTaskAdd( ho_items, tmp_progress[ i ][ 1 ].."_2",  1, tmp_progress[ i ][ 2 ], tmp_progress[ i ][ 3 ] );

  end;

  interface.TaskPanelShow( ho_items );
  int_taskpanel_impl.HideTextPanel( "ladder_scr" );

  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

  if is_repeat then
 
    public.ResetStart();

  end;

  levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
function public.Open()

  common_impl.TutorialShow( "tutorial_page_6_scr" );

  --common_impl.PassingHoStart();
  int_slider.InitSlider( "ho_ladder_scr" );
  int_button_timer.Show();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  int_button_timer.Hide();

  levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
function public.Close()

  --common_impl.PassingHoStop();

  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

  int_taskpanel_impl.ShowTextPanel( "ladder_scr" )

end;
--*********************************************************************************************************************
function public.HoComplete()

  levelscr_inv.HoDeleteWin(); 
  --common_impl.PassingHoWin();
  rm_mysteryroom.WinTask();

  int_taskpanel_impl.sound_play = true;  

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.ClkTask( task_name, object_name )

  local object =  "spr_ladder_scr_"..object_name.."_light";

  if private.tasks[1] ~= "" then

    if task_name == private.tasks[1] and private.tasks[2] ~= object_name  then

      int_taskpanel_impl.sound_play = true;
      private.TaskComplete( task_name, "spr_ladder_scr_"..task_name.."_1" );

      int_taskpanel_impl.sound_play = false;
      private.TaskComplete( task_name.."_2" );

      ng_global.progress[ "scr" ][ "win_ladder_scr" ].counter = ng_global.progress[ "scr" ][ "win_ladder_scr" ].counter - 1;

      ObjSet( "txt_ladder_scr_tasklist", { param0 = ng_global.progress[ "scr" ][ "win_ladder_scr" ].counter } );

    elseif task_name == private.tasks[1] and private.tasks[2] == object_name  then

      common_impl.PlayAudio( "sfx", "common/audio/aud_ho_ladder_click", 0, "", 0 ); 

      ObjSet( object, { alp = 0 } ); 

    else
     
      ObjSet( "spr_ladder_scr_"..private.tasks[1].."_1_light", { alp = 0 } ); 
      ObjSet( "spr_ladder_scr_"..private.tasks[1].."_2_light", { alp = 0 } );

      common_impl.PlayAudio( "sfx", "common/audio/aud_ho_ladder_wrong", 0, "", 0 ); 
         
    end;

     private.tasks[1] = "";
     private.tasks[2] = "";

     ObjSet( "spr_ladder_scr_"..private.tasks[1].."_1_light", { alp = 0 } ); 
     ObjSet( "spr_ladder_scr_"..private.tasks[1].."_2_light", { alp = 0 } );
    

  else

    common_impl.PlayAudio( "sfx", "common/audio/aud_ho_ladder_click", 0, "", 0 ); 

    private.tasks[1] = task_name;
    private.tasks[2] = object_name;

    ObjSet( object, { alp = 1 } );  
    
  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.TaskComplete( task_name, object_name )

  local object = "";

  if object_name then

    object = tostring( object_name );

  else

    object = "spr_ladder_scr_"..task_name;

  end;
  
  ObjSet( object, { pos_z = 1 } );

  cmn.HoTaskFind( object, task_name );
  
end;
--*********************************************************************************************************************
ObjAnimate( "spr_ladder_scr_chain_1", "ang", 1, 0, "", {  0,3,-0.04, 2,3,0.04, 4,3,-0.04  } );
ObjAnimate( "spr_ladder_scr_chain_2", "ang", 1, 0, "", {  0,3,0.03, 3,3,-0.03, 6,3,0.03  } );
ObjAnimate( "spr_ladder_scr_light", "alp", 1, 0, "", {  0,3,0, 2,3,1, 4,3,0  } );
--*********************************************************************************************************************
