-- name=ho_littlehouse_scr
--*********************************************************************************************************************
function public.Init()
  --*********************************************************************************************************************------
  room.Define( "littlehouse_scr" );
  game.relations[ "ho_littlehouse_scr" ].exitroom = "rm_mysteryroom";  

  public.soldiers_to_objects = 
  {
    { "bumerang", "owl", "teeth" },
    { "dreidel", "pencils", "train" },
    { "hat", "slingshot", "sword" },
    { "knife", "snail", "yoyo" }
  }
  public.found = {};

  private.mas_pos = {
    { 953, 566, 2 },
    { 197, 434, 2 },
    { 561, 491, 8 },
    { 717, 206, 8 },
  };

  private.table_obj = {
    { "bumerang",  0, { { "spr_littlehouse_scr_bumerang" } } }, 
    { "dreidel",   0, { { "spr_littlehouse_scr_dreidel" } } }, 
    { "hat",       0, { { "spr_littlehouse_scr_hat" } } }, 
    { "knife",     0, { { "spr_littlehouse_scr_knife" } } }, 
    { "owl",       0, { { "spr_littlehouse_scr_owl" } } }, 
    { "pencils",   0, { { "spr_littlehouse_scr_pencils" } } }, 
    { "slingshot", 0, { { "spr_littlehouse_scr_slingshot" } } }, 
    { "snail",     0, { { "spr_littlehouse_scr_snail" } } }, 
    { "teeth",     0, { { "spr_littlehouse_scr_teeth" } } }, 
    { "train",     0, { { "spr_littlehouse_scr_train" } } }, 
    { "sword",     0, { { "spr_littlehouse_scr_sword" } } }, 
    { "yoyo",      0, { { "spr_littlehouse_scr_yoyo" } } }, 
    { "bell",      0, { { "spr_littlehouse_scr_bell" } } }, 
    { "boom",      0, { { "spr_littlehouse_scr_boom" } } }, 
    { "mask",      0, { { "spr_littlehouse_scr_mask" } } }, 
    { "palette",   0, { { "spr_littlehouse_scr_palette" } } }, 
    { "rhino",     0, { { "spr_littlehouse_scr_rhino" } } }, 
    { "skates",    0, { { "spr_littlehouse_scr_skates" } } }, 
    { "tambourine",0, { { "spr_littlehouse_scr_tambourine" } } }, 
    { "violin",    0, { { "spr_littlehouse_scr_violin" } } } 
  };

  public.ResetInit();


  local table_multiset = {

    { "obj_littlehouse_scr_taskpanel_use_lockpart", { event_mdown = function() common_impl.ShowBbt( 'bbt_littlehouse_scr_use_lockpart' ); end } }

  };
    
  for i = 1, 4 do

    table.insert( table_multiset, { "spr_littlehouse_scr_soldier_"..i, { event_startdrag = function() private.GetSoldier( i ) end, event_dragdrop = function() private.UseSoldier( i ) end } });
    table.insert( table_multiset, { "spr_littlehouse_scr_taskpanel_part_"..i, { event_startdrag = function() private.GetPart( i ) end, event_dragdrop = function() private.UsePart( i ) end } });

  end;

  ObjMultiSet( table_multiset );

--******ANIMS**********************************************************************************************************
  ObjAnimate("spr_littlehouse_scr_plane1", "ang", 1, 0, "", {0.0,0,-0.1,  1.9,3,0.15, 3.8,3,-0.1});
  ObjAnimate("spr_littlehouse_scr_plane2", "ang", 1, 0, "", {0.0,0,0.1,  1.6,3,-0.1, 3.2,3,0.1});
  ObjAnimate("spr_littlehouse_scr_light_1", "alp", 1, 0, "", {0.0,0,1,  0.5,0,0.8,  0.9,0,0.9,  1.2,0,0.7,  1.8,0,1});
  ObjAnimate("spr_littlehouse_scr_light_2", "alp", 1, 0, "", {0.0,0,1,  1.2,0,0.8,  1.5,0,0.7,  2.5,0,1});
--*********************************************************************************************************************
  local win_littlehouse_scr_func = function ()

    if ( cmn.IsEventDone( "win_littlehouse_scr" ) ) then

      --

    else

      local ho_found = ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].found;
      local ho_progress = ng_global.progress[ "scr" ][ "win_littlehouse_scr" ];

      if ho_progress.taskpanel then

        public.soldiers_to_objects = ho_progress.taskpanel;

      end;        

      for count = 1, #ho_found do
        
        ObjDetach( ho_found[ count ][ "object" ] );

        for key = 1, #public.soldiers_to_objects do
          for i = 1, #public.soldiers_to_objects[ key ] do

            --
          
            if ho_found[ count ][ "task" ] == public.soldiers_to_objects[ key ][ i ] then

              ObjDetach( "txt_littlehouse_scr_taskpanel_soldier_"..key.."_task_"..i );
              break;

            end;

          end;
        end;
      end;

      for i = 1, 4 do

        if ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].parts_done[ i ] == 3 then

          ObjSet("spr_littlehouse_scr_taskpanel_part_"..i, {alp = 1, input = true});
          ObjSet("obj_littlehouse_scr_taskpanel_hint_lockpart"..i, {input = true});
          ObjDetach( "obj_littlehouse_scr_taskpanel_soldier_"..i.."_txt" );

        end;

        if ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].parts_used[ i ] == 1 then

          ObjSet( "spr_littlehouse_scr_lockpart_"..i, { alp = 1 } );
          ObjDetach( "obj_littlehouse_scr_taskpanel_hint_lockpart"..i );
          ObjDetach( "spr_littlehouse_scr_taskpanel_part_"..i );

        end;

        if ( ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].soldiers_done[ i ] == 1 ) then

          ObjDetach( "spr_littlehouse_scr_soldier_"..i.."_shadow" );
          ObjDetach( "spr_littlehouse_scr_soldier_"..i );

        end;

        if i ~= 1 then
          if ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].soldier[ i ] == 0 then

            ObjSet( "spr_littlehouse_scr_soldier_"..i, 
            {
              res = "assets/levels/level2/ho_littlehouse/layers/solder"..i,
              pos_x = private.mas_pos[ i ][ 1 ],
              pos_y = private.mas_pos[ i ][ 2 ],
              pos_z = private.mas_pos[ i ][ 3 ],
            } );      
            ObjSet( "spr_littlehouse_scr_soldier_"..i.."_shadow", { res = "assets/levels/level2/ho_littlehouse/layers/solder"..i.."_shadow" } );

          else

            ObjSet( "spr_littlehouse_scr_soldier_"..i, 
            {
              res = ObjGet( "spr_littlehouse_scr_soldier_"..i.."_clone" ).res,
              pos_x = ObjGet( "spr_littlehouse_scr_soldier_"..i.."_clone" ).pos_x,
              pos_y = ObjGet( "spr_littlehouse_scr_soldier_"..i.."_clone" ).pos_y,
              pos_z = ObjGet( "spr_littlehouse_scr_soldier_"..i.."_clone" ).poz_z,
            } );
            ObjSet( "spr_littlehouse_scr_soldier_"..i.."_shadow", { res = "" } );

          end;
        end;

        if ( ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].opened_panel[ i ] == 1 ) then

          ObjSet( "obj_littlehouse_scr_taskpanel_soldier_"..i.."_txt", { alp = 1 } );
          ObjDetach( "obj_littlehouse_scr_taskpanel_hint_soldier"..i );
          ObjDetach( "spr_littlehouse_scr_taskpanel_soldier_"..i );
          ObjDetach( "obj_littlehouse_scr_taskpanel_use_soldier_"..i );
          
          for j = 1, 3 do

            local task = public.soldiers_to_objects[ i ][ j ];
            ObjSet( "spr_littlehouse_scr_"..task,   { input = true, visible = true, event_mdown = function() private.TaskComplete( task, i ) end } );

          end;

        else

          for j = 1, 3 do

            local task = public.soldiers_to_objects[ i ][ j ];
            ObjSet( "spr_littlehouse_scr_"..task,   { input = false, visible = true, event_mdown = function() private.TaskComplete( task, i ) end } );

          end;          

        end;

      end;
            
    end;

  end;
  cmn.AddSubscriber( "win_littlehouse_scr", win_littlehouse_scr_func );

end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.ResetInit()

  local table_multiset = {

    { "spr_littlehouse_scr_bumerang",   { input = false, visible= false } },
    { "spr_littlehouse_scr_dreidel",    { input = false, visible= false } },
    { "spr_littlehouse_scr_hat",        { input = false, visible= false } },
    { "spr_littlehouse_scr_knife",      { input = false, visible= false } },
    { "spr_littlehouse_scr_owl",        { input = false, visible= false } },
    { "spr_littlehouse_scr_pencils",    { input = false, visible= false } },
    { "spr_littlehouse_scr_slingshot",  { input = false, visible= false } },
    { "spr_littlehouse_scr_snail",      { input = false, visible= false } },
    { "spr_littlehouse_scr_teeth",      { input = false, visible= false } },
    { "spr_littlehouse_scr_train",      { input = false, visible= false } },
    { "spr_littlehouse_scr_sword",      { input = false, visible= false } },    
    { "spr_littlehouse_scr_yoyo",       { input = false, visible= false } },
    { "obj_littlehouse_scr_taskpanel_use_lockpart", { event_mdown = function() common_impl.ShowBbt( 'bbt_littlehouse_scr_use_lockpart' ); end } },    
    { "spr_littlehouse_scr_bell",       { input = false, visible= false } },    
    { "spr_littlehouse_scr_boom",       { input = false, visible= false } },    
    { "spr_littlehouse_scr_mask",       { input = false, visible= false } },    
    { "spr_littlehouse_scr_palette",    { input = false, visible= false } },    
    { "spr_littlehouse_scr_rhino",      { input = false, visible= false } },    
    { "spr_littlehouse_scr_skates",     { input = false, visible= false } }, 
    { "spr_littlehouse_scr_tambourine", { input = false, visible= false } }, 
    { "spr_littlehouse_scr_violin",     { input = false, visible= false } }, 

  };
    
  for i = 1, 4 do

    table.insert( table_multiset, { "spr_littlehouse_scr_soldier_"..i, { event_startdrag = function() private.GetSoldier( i ) end, event_dragdrop = function() private.UseSoldier( i ) end } });
    table.insert( table_multiset, { "spr_littlehouse_scr_taskpanel_part_"..i, { event_startdrag = function() private.GetPart( i ) end, event_dragdrop = function() private.UsePart( i ) end } });

  end;

  ObjMultiSet( table_multiset );  

end;
--*********************************************************************************************************************
function public.ResetStart()

  local ho_found = public.found;

  for key = 1, #ho_found do

    ObjAttach( ho_found[ key ][ "object" ], "obj_littlehouse_scr_objs" );
    ObjSet( ho_found[ key ][ "object" ], { alp = 1 } );

    local pfx_name = "pfx_int_taskpanel_collect_spr_littlehouse_scr_"..ho_found[ key ][ "task" ];

    if ObjGet( pfx_name ) then

      ObjDelete( pfx_name );

    end;

    for i = 1, 4 do

      for j = 1, 3 do

        local name = "obj_littlehouse_scr_taskpanel_soldier_"..i.."_txt";
        ObjAttach( "txt_littlehouse_scr_taskpanel_soldier_"..i.."_task_"..j, name );

      end;
          
    end;

  end;  

  for i = 1, 4 do

    ObjAttach( "obj_littlehouse_scr_taskpanel_soldier_"..i.."_txt", "obj_littlehouse_scr_taskpanel_soldier_"..i );
    ObjAttach( "obj_littlehouse_scr_taskpanel_hint_lockpart"..i, "obj_littlehouse_scr_hints" );
    ObjAttach( "obj_littlehouse_scr_taskpanel_hint_soldier"..i, "obj_littlehouse_scr_hints" );
    ObjAttach( "spr_littlehouse_scr_taskpanel_soldier_"..i, "obj_littlehouse_scr_taskpanel_soldier_"..i );
    ObjAttach( "obj_littlehouse_scr_taskpanel_use_soldier_"..i, "obj_littlehouse_scr_taskpanel_use_soldier" );
    ObjAttach( "spr_littlehouse_scr_taskpanel_part_"..i, "obj_littlehouse_scr_taskpanel_soldier_"..i );
        
    for j = 1, 3 do
      task = public.soldiers_to_objects[ i ][ j ]
      if ( ObjGet( "spr_littlehouse_scr_"..task ) ) then
        ObjSet( "spr_littlehouse_scr_"..task, { input = false } );
      end;
    end;

    local table_multiset = {
      { "spr_littlehouse_scr_taskpanel_part_"..i, { alp = 0, input = false } },
      { "obj_littlehouse_scr_taskpanel_hint_lockpart"..i, { input = false } },
      { "spr_littlehouse_scr_soldier_"..i, { input = true, pos_z = 2 } },
      { "spr_littlehouse_scr_soldier_"..i.."_shadow", { visible = true } },
      { "spr_littlehouse_scr_taskpanel_soldier_"..i.."_done", { alp = 0 } },
      { "spr_littlehouse_scr_taskpanel_soldier_"..i, { pos_y = 1 } },
      { "obj_littlehouse_scr_taskpanel_soldier_"..i.."_txt", { alp = 0 } },
      { "spr_littlehouse_scr_lockpart_"..i, { alp = 0 } }
    }

    ObjMultiSet( table_multiset );

    ObjAttach( "spr_littlehouse_scr_soldier_"..i, "ho_littlehouse_scr" );
    ObjAttach( "spr_littlehouse_scr_soldier_"..i.."_shadow", "ho_littlehouse_scr" );
    
  end;

  ObjSet( "obj_littlehouse_scr_chest_open", { alp = 0, input = true } );
  ObjSet( "spr_littlehouse_scr_chest_closed", { alp = 1 } );
  ObjSet( "spr_littlehouse_scr_soldier_3", { pos_z = 8 } );

end;
--*********************************************************************************************************************
function public.Sorting()

  local count = #private.table_obj;
  ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].t_gen = {};
  ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].taskpanel = {};
  ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].soldier = { 0, 0, 0, 0 };

  for i = ( #private.table_obj ), 1, -1 do

    local temp = private.table_obj[ i ];
    j = math.random( i );
    private.table_obj[ i ] = private.table_obj[ j ];
    private.table_obj[ j ] = temp;

  end;

  for i = 2, 4 do

    ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].soldier[ i ] = math.random( 0, 1 );
    if ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].soldier[ i ] == 0 then

      ObjSet( "spr_littlehouse_scr_soldier_"..i, 
      {
        res = "assets/levels/level2/ho_littlehouse/layers/solder"..i,
        pos_x = private.mas_pos[ i ][ 1 ],
        pos_y = private.mas_pos[ i ][ 2 ],
        pos_z = private.mas_pos[ i ][ 3 ],
      } );      
      ObjSet( "spr_littlehouse_scr_soldier_"..i.."_shadow", { res = "assets/levels/level2/ho_littlehouse/layers/solder"..i.."_shadow" } );

    else

      ObjSet( "spr_littlehouse_scr_soldier_"..i, 
      {
        res = ObjGet( "spr_littlehouse_scr_soldier_"..i.."_clone" ).res,
        pos_x = ObjGet( "spr_littlehouse_scr_soldier_"..i.."_clone" ).pos_x,
        pos_y = ObjGet( "spr_littlehouse_scr_soldier_"..i.."_clone" ).pos_y,
        pos_z = ObjGet( "spr_littlehouse_scr_soldier_"..i.."_clone" ).poz_z,
      } );
      ObjSet( "spr_littlehouse_scr_soldier_"..i.."_shadow", { res = "" } );

    end;
    
  end;

  local c_index = 0;
  for key = 1, #public.soldiers_to_objects do

    ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].taskpanel[ key ] = {};

    for i = 1, #public.soldiers_to_objects[ key ] do

      c_index = c_index + 1;
      ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].t_gen[ c_index ] = private.table_obj[ c_index ];

      public.soldiers_to_objects[ key ][ i ] = private.table_obj[ c_index ][ 1 ];
      ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].taskpanel[ key ][ i ] = private.table_obj[ c_index ][ 1 ];

      ObjSet( "spr_littlehouse_scr_"..public.soldiers_to_objects[ key ][ i ], { visible = true, event_mdown = function() private.TaskComplete( public.soldiers_to_objects[ key ][ i ], key ) end } );

    end;

  end;

end;
--*********************************************************************************************************************
function public.PreOpen()

  local is_repeat = false;

  if cmn.IsEventDone(  "win_littlehouse_scr" ) and cmn.IsEventStart( "win_littlehouse_scr" )  then

    public.found = ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].found;
    ng_global.progress[ "scr" ][ "opn_littlehouse_scr" ].done = 0;
    
    ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].done = 0;
    ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].start = 0;

    ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].t_gen = {};
    ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].soldier = { 0, 0, 0, 0 };

    is_repeat = true;

    public.ResetInit();

  end; 

  if ( not cmn.IsEventDone( "opn_littlehouse_scr" ) ) then

    public.Sorting();
  
    cmn.InitHo( "littlehouse_scr" );
    cmn.SetEventDone( "opn_littlehouse_scr" );

    ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].opened_panel   = { 0, 0, 0, 0 };
    ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].soldiers_done  = { 0, 0, 0, 0 };
    ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].parts_done     = { 0, 0, 0, 0 };
    ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].parts_used     = { 0, 0, 0, 0 };

    ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].timer = { default = 60, time = 60, diff = 20, extra = 0 };
  
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "soldier1",           1, 0, { { "spr_littlehouse_scr_soldier_1", "obj_littlehouse_scr_taskpanel_hint_soldier1" } } );
  interface.TaskPanelTaskAdd( ho_items, "soldier2",           1, 0, { { "spr_littlehouse_scr_soldier_2", "obj_littlehouse_scr_taskpanel_hint_soldier2" } } );
  interface.TaskPanelTaskAdd( ho_items, "soldier3",           1, 0, { { "spr_littlehouse_scr_soldier_3", "obj_littlehouse_scr_taskpanel_hint_soldier3" } } );
  interface.TaskPanelTaskAdd( ho_items, "soldier4",           1, 0, { { "spr_littlehouse_scr_soldier_4", "obj_littlehouse_scr_taskpanel_hint_soldier4" } } );
  
  interface.TaskPanelTaskAdd( ho_items, "part1",              1, 0, { { "spr_littlehouse_scr_taskpanel_part_1", "obj_littlehouse_scr_taskpanel_hint_lockpart1" } } );
  interface.TaskPanelTaskAdd( ho_items, "part2",              1, 0, { { "spr_littlehouse_scr_taskpanel_part_2", "obj_littlehouse_scr_taskpanel_hint_lockpart2" } } );
  interface.TaskPanelTaskAdd( ho_items, "part3",              1, 0, { { "spr_littlehouse_scr_taskpanel_part_3", "obj_littlehouse_scr_taskpanel_hint_lockpart3" } } );
  interface.TaskPanelTaskAdd( ho_items, "part4",              1, 0, { { "spr_littlehouse_scr_taskpanel_part_4", "obj_littlehouse_scr_taskpanel_hint_lockpart4" } } );

  local tmp_progress = ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].t_gen;

  for i = 1, 12 do

    interface.TaskPanelTaskAdd( ho_items, tmp_progress[ i ][ 1 ],  1, tmp_progress[ i ][ 2 ], tmp_progress[ i ][ 3 ] );
    
  end;

  for key = 1, #public.soldiers_to_objects do
    for i = 1, #public.soldiers_to_objects[ key ] do

      ObjSet( "txt_littlehouse_scr_taskpanel_soldier_"..key.."_task_"..i, { text = "tsk_littlehouse_scr_"..public.soldiers_to_objects[ key ][ i ] } );

    end;
  end;

  interface.TaskPanelShow( ho_items );
  int_taskpanel_impl.HideTextPanel( "littlehouse_scr" );

  ObjSet( "obj_littlehouse_scr_taskpanel", { visible = true, input = true, pos_z = 1, pos_x = -190, pos_y = 47 } ); 

  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

  interface.InvestigationButtonCheck();

  if is_repeat then
 
    public.ResetStart();

  end;

  levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.TutorialShow( "tutorial_page_6_scr" );
  
  int_button_timer.Show();
  --common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  int_button_timer.Hide();

  levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
function public.Close ()

  --common_impl.PassingHoStop();
  int_taskpanel_impl.ShowTextPanel( "littlehouse_scr" );
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

end;
--*********************************************************************************************************************
function public.HoComplete ()

  levelscr_inv.HoDeleteWin();
  --common_impl.PassingHoWin();
  rm_mysteryroom.WinTask();

  levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function private.TaskComplete ( task_name, part_num )

  local object = "spr_littlehouse_scr_"..task_name;
  
  ObjSet( object, { pos_z = 1 } );

  cmn.HoTaskFind( object, task_name );

  for key = 1, #public.soldiers_to_objects do
    for i = 1, #public.soldiers_to_objects[ key ] do
    
      if task_name == public.soldiers_to_objects[ key ][ i ] then

        ObjDetach( "txt_littlehouse_scr_taskpanel_soldier_"..key.."_task_"..i );
        break;

      end;

    end;
  end;

  ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].parts_done[part_num] = ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].parts_done[part_num] + 1;

  if ( ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].parts_done[part_num] == 3 ) then

    ObjAnimate("spr_littlehouse_scr_taskpanel_part_"..part_num, "alp", 0, 0, "", {0.0,0,0,  0.3,0,1});    
    ObjAnimate("obj_littlehouse_scr_taskpanel_soldier_"..part_num.."_txt", "alp", 0, 0, "", {0.0,0,1,  0.3,0,0});
    ObjSet("spr_littlehouse_scr_taskpanel_part_"..part_num, {input = true});
    ObjSet( "obj_littlehouse_scr_taskpanel_hint_lockpart"..part_num, { input = true } );

  end;
  
end;
--*********************************************************************************************************************
function private.GetSoldier ( num )

  common_impl.PlayAudio("sfx","common/audio/aud_get_inv_sfx");
  ObjAttach("spr_littlehouse_scr_soldier_"..num, "obj_littlehouse_scr_taskpanel");
  ObjSet( "spr_littlehouse_scr_soldier_"..num, { pos_z = 30 } );  
  ObjSet( "spr_littlehouse_scr_soldier_"..num.."_shadow", { visible = false } );  

end;
--*********************************************************************************************************************
function private.UseSoldier ( num )

  common_impl.SetCursor( CURSOR_DEFAULT );
  local use_panel = nil;

  for i = 1, 4 do

    if ( common.ApplyObj( "spr_littlehouse_scr_soldier_"..num, "obj_littlehouse_scr_taskpanel_use_soldier_"..i ) ) then

      use_panel = i;
      break;

    end;

  end;

  if ( use_panel ) then

    common_impl.Lock( true );

    local func_end = function ()

      common_impl.Lock( false );

      cmn.HoTaskFind( "spr_littlehouse_scr_soldier_"..num, "soldier"..num, true );

      ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].soldiers_done[ num ] = 1;
      ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].opened_panel[ use_panel ] = 1;

      private.OpenObjects( num, use_panel );

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_ho_littlehouse_soldier", 0, "", 0 );

    ObjSet( "tmr_littlehouse_scr_sound", { time = 0.3, playing = true, endtrig = "*common_impl.PlayAudio( 'sfx', 'common/audio/aud_ho_panel_off', 0, '', 0 );" } );

    ObjAnimate( "spr_littlehouse_scr_taskpanel_soldier_"..use_panel.."_done", "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.3,0,1
    } );

    ObjAnimate( "spr_littlehouse_scr_taskpanel_soldier_"..use_panel, "pos_y", 0, 0, func_end, 
    {
      0.0,0,1,
      0.3,0,1,
      1.6,0,90
    } );

    ObjAnimate( "obj_littlehouse_scr_taskpanel_soldier_"..use_panel.."_txt", "alp", 0, 0, "", 
    {
      0.0,0,0,
      0.3,0,1
    } );

  else

    local posz = 2;
    if num == 3 then posz = 8 end;

    ObjAttach( "spr_littlehouse_scr_soldier_"..num, "ho_littlehouse_scr");
    ObjSet( "spr_littlehouse_scr_soldier_"..num, { pos_z = posz } );
    ObjSet( "spr_littlehouse_scr_soldier_"..num.."_shadow", { visible = true } ); 

  end;

end;
--*********************************************************************************************************************
function private.OpenObjects ( sold_num, panel_num )

  ObjDetach( "spr_littlehouse_scr_taskpanel_soldier_"..panel_num );
  ObjDetach( "obj_littlehouse_scr_taskpanel_use_soldier_"..panel_num );
  ObjDetach( "obj_littlehouse_scr_taskpanel_hint_soldier"..panel_num);

  ObjSet( "obj_littlehouse_scr_taskpanel_soldier_"..panel_num.."_txt", { alp = 1 } );

  for i = 1, 3 do

    ObjSet( "spr_littlehouse_scr_"..public.soldiers_to_objects[ panel_num ][ i ], { input = true, visible = true, event_mdown = function() private.TaskComplete( public.soldiers_to_objects[ panel_num ][ i ], panel_num ) end } );

  end;

end;
--*********************************************************************************************************************
function private.GetPart ( num )

  common_impl.PlayAudio("sfx","common/audio/aud_get_inv_sfx");
  ObjSet( "spr_littlehouse_scr_taskpanel_part_"..num, { pos_z = 30 } );  

end;
--*********************************************************************************************************************
function private.UsePart ( num )

  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_littlehouse_scr_taskpanel_part_"..num, "obj_littlehouse_scr_taskpanel_use_lockpart" ) ) then

    common_impl.Lock(true);

    local func_end = function ()

      common_impl.Lock(false);

      ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].parts_used[num] = 1;

      local fin = true;

      for i = 1, 4 do

        if (ng_global.progress[ "scr" ][ "win_littlehouse_scr" ].parts_used[ i ] == 0) then

          fin = false;
          break;

        end;

      end;

      if ( fin ) then

        private.WinAnim( num );

      else

        cmn.HoTaskFind( "spr_littlehouse_scr_taskpanel_part_"..num, "part"..num, true );
        ObjDetach("spr_littlehouse_scr_taskpanel_part_"..num);
        ObjDetach("obj_littlehouse_scr_taskpanel_hint_lockpart"..num);

      end;

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_ho_littlehouse_insert", 0, "", 0 );

    ObjSet("spr_littlehouse_scr_taskpanel_part_"..num, {alp = 0});
    ObjAnimate("spr_littlehouse_scr_lockpart_"..num, "alp", 0, 0, func_end, 
    {
      0.0,0,0,
      0.3,0,1
    }); 
    
  else

    ObjSet( "spr_littlehouse_scr_taskpanel_part_"..num, { pos_z = 3 } );
        
  end;
  

end;
--*********************************************************************************************************************
function private.WinAnim( num )

  local func_after = function()

    common_impl.Lock( false );
    cmn.HoTaskFind( "spr_littlehouse_scr_taskpanel_part_"..num, "part"..num, true );    

  end;

  common_impl.Lock( true );

  common_impl.PlayAudio( "sfx", "common/audio/aud_ho_littlehouse_chest_open", 0, "", 0 );
  
  ObjDetach("spr_littlehouse_scr_taskpanel_part_"..num);
  ObjAnimate("spr_littlehouse_scr_chest_closed", "alp", 0, 0, "", {0.0,0,1, 0.3,0,0});
  ObjAnimate("obj_littlehouse_scr_chest_open", "alp", 0, 0, func_after, {0.0,0,0, 0.3,0,1,  0.6,0,1});

end;
--*********************************************************************************************************************
