-- name=ho_stock_scr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "stock_scr" );
  game.relations[ "ho_stock_scr" ].exitroom = "rm_mysteryroom";
  public.found = {};

  private.table_obj = {
    { "tube", 0, { { "spr_stock_scr_tube" } } }, 
    { "boots", 0, { { "spr_stock_scr_boots" } } }, 
    { "screw", 0, { { "spr_stock_scr_screw" } } }, 
    { "ship", 1, { { "spr_stock_scr_hammer", "spr_stock_scr_ship" }, { "spr_stock_scr_ship" } } }, 
    { "float", 0, { { "spr_stock_scr_float" } } },  
    { "starfish", 0, { { "spr_stock_scr_starfish" } } }, 
    { "hat", 0, { { "spr_stock_scr_hat" } } }, 
    { "hook", 0, { { "spr_stock_scr_hook" } } },
    { "net", 0, { { "spr_stock_scr_net" } } }, 
    { "owl", 0,  { { "spr_stock_scr_owl" } } }, 
    { "box", 0, { { "spr_stock_scr_box" } } }, 
    { "harpoon", 1, { { "spr_stock_scr_stalk", "spr_stock_scr_harpoon" }, { "spr_stock_scr_harpoon" } } }, 
    { "balloon", 0, { { "spr_stock_scr_balloon" } } }, 
    { "cap", 0, { { "spr_stock_scr_cap" } } }, 
    { "flippers", 0, { { "spr_stock_scr_flippers" } } }, 
    { "mug", 0, { { "spr_stock_scr_mug" } } },  
    { "newbottle", 0, { { "spr_stock_scr_newbottle" } } }, 
    { "saw", 0, { { "spr_stock_scr_saw" } } }, 
    { "shell", 0, { { "spr_stock_scr_shell" } } }, 
    { "spinning", 0, { { "spr_stock_scr_spinning" } } }, 
    { "newhook", 0, { { "spr_stock_scr_newhook" } } }, 
    { "spoon", 0, { { "spr_stock_scr_spoon" } } }, 
    { "paddle", 0, { { "spr_stock_scr_paddle" } } }
  };

  public.ResetInit();

-----ANIMS----------------------------------------------------------------------------------------
  ObjAnimate( "spr_stock_scr_anim_net", "ang", 1, 0, "", { 0,0,0.02, 2,0,-0.02, 4,0,0.02 } );
  ObjAnimate( "spr_stock_scr_anim_net_1", "ang", 1, 0, "", { 0,0,-0.02, 3,0,0.02, 6,0,-0.02 } );
  ObjAnimate( "spr_stock_scr_rope_2", "ang", 1, 0, "", { 0,0,0.02, 2,0,-0.02, 4,0,0.02 } );
  ObjAnimate( "spr_stock_scr_rope", "ang", 1, 0, "", { 0,0,0.03, 3.5,0,-0.03, 7,0,0.03 } );
  ObjAnimate( "spr_stock_scr_rope_1", "ang", 1, 0, "", { 0,0,-0.03, 2.5,0,0.03, 5,0,-0.03 } );
  ObjAnimate( "spr_stock_scr_bush_4", "ang", 1, 0, "", { 0,0,0.02, 2,0,-0.02, 4,0,0.02 } );
  ObjAnimate( "spr_stock_scr_bush_2", "ang", 1, 0, "", { 0,0,-0.02, 3,0,0.02, 6,0,-0.02 } );

  ObjAnimate( "spr_stock_scr_light_1", "alp", 1, 0, "", { 0,0,0.5, 2,0,1, 4,0,0.5 } );
  ObjAnimate( "spr_stock_scr_light_2", "alp", 1, 0, "", { 0,0,0.5, 2.5,0,1, 5,0,0.5 } );
  ObjAnimate( "spr_stock_scr_light_4", "alp", 1, 0, "", { 0,0,0.5, 3.5,0,1, 7,0,0.5 } );
  ObjAnimate( "spr_stock_scr_light_3", "alp", 1, 0, "", { 0,0,0.5, 1.5,0,1, 3,0,0.5 } );
  ObjAnimate( "spr_stock_scr_light_5", "alp", 1, 0, "", { 0,0,0.5, 3,0,1, 6,0,0.5 } );
--------------------------------------------------------------------------------------------------
  public.taskpanel = 
  {
    canister = { "net",    "owl",      "hat" },
    pen_1 = { "ship",   "screw",    "starfish" },
    pen = { "hook",   "box",      "harpoon" },
    sew = { "tube",   "float",    "boots" }
  }
--------------------------------------------------------------------------------------------------
  private.TASK_COLOR_R = 1;
  private.TASK_COLOR_G = 1;
  private.TASK_COLOR_B = 1;

  private.TASK_MARKED_COLOR_R = 0.7804;
  private.TASK_MARKED_COLOR_G = 0.60392;
  private.TASK_MARKED_COLOR_B = 0.42352;

  private.TASK_COMPLETED_COLOR_R = 0.02745;
  private.TASK_COMPLETED_COLOR_G = 0.09019;
  private.TASK_COMPLETED_COLOR_B = 0.10588;
--------------------------------------------------------------------------------------------------
  local win_stock_scr_func = function ()

    local table_multiset = {};
    if ( not cmn.IsEventDone( "win_stock_scr" ) ) then

      local ho_progress = ng_global.progress[ "scr" ][ "win_stock_scr" ];

      if ho_progress.taskpanel then

        public.taskpanel = ho_progress.taskpanel;

      end;

      for key, value in pairs( public.taskpanel ) do

        local flag_complete = true;
        for i = 1, #public.taskpanel[ key ] do

          if ( not ho_progress.items[ "spr_stock_scr_"..public.taskpanel[ key ][ i ] ] ) then
            flag_complete = false;
            break;
          end;

        end;

        if ( ho_progress.parts[ key ] )then
          
          ObjDetach( "obj_stock_scr_taskpanel_item_"..key );
          if ( key == "canister" ) then   

            ObjDetach( "vid_stock_scr_can" );
            table.insert( table_multiset, { "spr_stock_scr_gasolinesaw_"..key, { alp = 0 } } );     
            table.insert( table_multiset, { "spr_stock_scr_gasolinesaw_cover", { alp = 1 } } );

          else           
            table.insert( table_multiset, { "spr_stock_scr_gasolinesaw_"..key, { alp = 1 } } );
          end;
          ObjDetach( "spr_stock_scr_gasolinesaw_"..key.."_light" );
          
        elseif ( flag_complete ) then

          table.insert( table_multiset, { "spr_stock_scr_taskpanel_item_"..key, { input = true } } );
          table.insert( table_multiset, { "obj_stock_scr_use_item_"..key.."_hint", { input = true } } );       
          ObjDetach( "spr_stock_scr_taskpanel_part_"..key );    
         
        end;

        for i = 1, #public.taskpanel[ key ] do

          ObjSet( "spr_stock_scr_"..public.taskpanel[ key ][ i ],   { visible = true, input = true, event_mdown = function() private.TaskComplete( public.taskpanel[ key ][ i ], key ) end } );

        end;

      end;

      for j = 1, #ng_global.progress["scr"]["win_stock_scr"].found do

        local name = tostring( ng_global.progress[ "scr" ][ "win_stock_scr" ].found[ j ][ "task" ] );
       
        ObjDetach( "spr_stock_scr_"..name );
        ObjDetach( "spr_stock_scr_"..name.."_shadow" );
        

      end;

    else
    
      --     

    end;

    if ( #table_multiset > 0 ) then
      ObjMultiSet( table_multiset )
    end;

  end;
  cmn.AddSubscriber( "win_stock_scr", win_stock_scr_func, "ho_stock_scr" );
  --------------------------------------------------------------------------------------------------
  local win_stock_scr_pier = function ()

    if ( cmn.IsEventDone( "win_stock_scr" ) ) then
      
      --

    end;

  end;
  cmn.AddSubscriber( "win_stock_scr", win_stock_scr_pier, "rm_pier" );
  --------------------------------------------------------------------------------------------------
  local unmark_ship = function () 
   
    ObjDetach( "spr_stock_scr_bottle" );
    ObjDetach( "spr_stock_scr_hammer" );
    ObjDetach( "obj_stock_scr_use_hammer" );
    ObjDetach( "vid_stock_scr_bottle" );

    ObjSet( "spr_stock_scr_bottle_1", { alp = 1, input = true } );

  end;

  cmn.AddSubscriber( "unmark_ship", unmark_ship, "ho_stock_scr" );  
  --------------------------------------------------------------------------------------------------
  local unmark_harpoon = function () 
   
    ObjDetach( "spr_stock_scr_stalk" );
    ObjDetach( "obj_stock_scr_use_stalk" );

    ObjSet( "spr_stock_scr_stalk_2", { alp = 1, input = true } );
    ObjSet( "spr_stock_scr_harpoon", { input = true } );

  end;

  cmn.AddSubscriber( "unmark_harpoon", unmark_harpoon, "ho_stock_scr" );  
  --------------------------------------------------------------------------------------------------
  local start_stock_scr_func = function ()
        
      if not cmn.IsEventDone( "win_stock_scr" ) then
       
        if ( cmn.IsUnmarkedTask( "stock_scr", "ship" ) ) then
          unmark_ship();
        end;

        if ( cmn.IsUnmarkedTask( "stock_scr", "harpoon" ) ) then
          unmark_harpoon();
      
        end;

      end;

  end;    
  
  cmn.AddSubscriber( "win_stock_scr", start_stock_scr_func, "ho_stock_scr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.ResetInit()

  ObjMultiSet( {

  { "spr_stock_scr_tube",     { input = false, visible= false } },
  { "spr_stock_scr_box",      { input = false, visible= false } },
  { "spr_stock_scr_boots",    { input = false, visible= false } },
  { "spr_stock_scr_screw",    { input = false, visible= false } },
  { "spr_stock_scr_float",    { input = false, visible= false } },
  { "spr_stock_scr_starfish", { input = false, visible= false } },
  { "spr_stock_scr_hat",      { input = false, visible= false } },
  { "spr_stock_scr_hook",     { input = false, visible= false } },
  { "spr_stock_scr_net",      { input = false, visible= false } },
  { "spr_stock_scr_owl",      { input = false, visible= false } },
  { "spr_stock_scr_ship",     { input = false, visible= false } },
  { "spr_stock_scr_harpoon",  { input = false, visible= false } },
  { "spr_stock_scr_stalk_2",  { input = false, visible= true  } },
  { "spr_stock_scr_stalk",    { input = false, event_startdrag = function() private.GetItem( 'stalk' ) end, event_dragdrop = function() private.unmark_harpoon() end } },
  { "spr_stock_scr_hammer",   { input = false, event_startdrag = function() private.GetItem( 'hammer' ) end, event_dragdrop = function() private.unmark_ship() end } },
  
  { "spr_stock_scr_balloon",   { input = false, visible= false } },
  { "spr_stock_scr_cap",       { input = false, visible= false } },
  { "spr_stock_scr_flippers",  { input = false, visible= false } },
  { "spr_stock_scr_mug",       { input = false, visible= false } },
  { "spr_stock_scr_newbottle", { input = false, visible= false } },
  { "spr_stock_scr_saw",       { input = false, visible= false } },
  { "spr_stock_scr_shell",     { input = false, visible= false } },
  { "spr_stock_scr_spinning",  { input = false, visible= false } },
  { "spr_stock_scr_newhook",   { input = false, visible= false } },
  { "spr_stock_scr_spoon",     { input = false, visible= false } },
  { "spr_stock_scr_paddle",    { input = false, visible= false } },

  { "spr_stock_scr_taskpanel_item_canister", { event_startdrag = function() private.GetGasolinesawItem( 'canister' ) end ,event_dragdrop = function() private.UseItem( 'canister' ) end } },
  { "spr_stock_scr_taskpanel_item_pen_1", {  event_startdrag = function() private.GetGasolinesawItem( 'pen_1' )  end, event_dragdrop = function() private.UseItem( 'pen_1' ) end } },
  { "spr_stock_scr_taskpanel_item_pen", {  event_startdrag = function() private.GetGasolinesawItem( 'pen' )  end, event_dragdrop = function() private.UseItem( 'pen' ) end } },
  { "spr_stock_scr_taskpanel_item_sew", {  event_startdrag = function() private.GetGasolinesawItem( 'sew' )  end, event_dragdrop = function() private.UseItem( 'sew' ) end } },

  { "obj_stock_scr_use_hammer", { input = false } },
  { "obj_stock_scr_use_stalk",  { input = false } }

  } );  

end;
--*********************************************************************************************************************
function public.ResetStart()

  local ho_found = public.found;

  for key = 1, #public.found do

    if string.find( ho_found[ key ][ "object" ], "_hint" ) then

      ObjAttach( ho_found[ key ][ "object" ], "obj_stock_scr_gasolinesaw_objects" );

    else

      ObjAttach( ho_found[ key ][ "object" ], "obj_stock_scr_objects" );
      ObjSet( ho_found[ key ][ "object" ], { alp = 1 } );

    end;

    local pfx_name = "pfx_int_taskpanel_collect_spr_stock_scr_"..ho_found[ key ][ "task" ];

    if ObjGet( pfx_name ) then

      ObjDelete( pfx_name );

    end;

  end;    

  for key, value in pairs( public.taskpanel ) do

    ObjAttach( "obj_stock_scr_taskpanel_item_"..key, "obj_stock_scr_taskpanel" );
    ObjAttach( "spr_stock_scr_gasolinesaw_"..key.."_light", "obj_stock_scr_gasolinesaw_objects" );
    ObjAttach( "spr_stock_scr_taskpanel_item_"..key, "obj_stock_scr_taskpanel_item_"..key );
    ObjAttach( "spr_stock_scr_taskpanel_part_"..key, "obj_stock_scr_taskpanel_item_"..key );

    ObjSet( "spr_stock_scr_taskpanel_part_"..key, { pos_y = 10 } );
    ObjSet( "spr_stock_scr_gasolinesaw_"..key.."_light", { alp = 1 } );
    ObjSet( "spr_stock_scr_taskpanel_item_"..key, { alp = 1, input = false } );--pos_x = 1, pos_y = 1, scale_x = 0.7, scale_y = 0.7 } );
    
  end;

  ObjAttach( "vid_stock_scr_can", "ho_stock_scr" );
  ObjAttach( "vid_stock_scr_bottle", "ho_stock_scr" );
  ObjAttach( "spr_stock_scr_stalk", "ho_stock_scr" );
  ObjAttach( "obj_stock_scr_use_stalk", "ho_stock_scr" );
  ObjAttach( "obj_stock_scr_use_hammer", "ho_stock_scr" );
  ObjAttach( "spr_stock_scr_hammer", "ho_stock_scr" );
  ObjAttach( "spr_stock_scr_bottle", "obj_stock_scr_objects" );
  ObjAttach( "spr_stock_scr_ship", "spr_stock_scr_bottle_1" );
  ObjAttach( "spr_stock_scr_gasolinesaw_canister", "obj_stock_scr_gasolinesaw_objects" );

  local table_multiset = {
    { "spr_stock_scr_gasolinesaw_sew", { alp = 0 } },
    { "spr_stock_scr_gasolinesaw_cover", { alp = 0 } },
    { "spr_stock_scr_gasolinesaw_pen_1", { alp = 0 } },
    { "spr_stock_scr_gasolinesaw_pen", { alp = 0 } },
    { "vid_stock_scr_can", { alp = 0, frame = 0, active = false } },
    { "vid_stock_scr_bottle", { alp = 0, frame = 0, active = false } },
    { "spr_stock_scr_stalk", { alp = 1 } },
    { "spr_stock_scr_hammer", { alp = 1, pos_z = 0 } },
    { "spr_stock_scr_hammer_shadow", { visible = true, alp = 1 } },
    { "spr_stock_scr_bottle_1", { input = false, alp = 0 } },
    { "spr_stock_scr_bottle", { input = true, alp = 1 } },
    { "spr_stock_scr_ship", { input = true, alp = 1, pos_x = -30, pos_y = -13 } },
    { "spr_stock_scr_gasolinesaw_canister", { alp = 0 } },
    { "spr_stock_scr_stalk_2", { alp = 0, input = false } },
    { "spr_stock_scr_harpoon", { input = false } },
    { "spr_stock_scr_stalk_shadow", { visible = true } },
  }

  ObjMultiSet( table_multiset ); 

end;
--*********************************************************************************************************************
function public.Load()

  

end;
--*********************************************************************************************************************
function public.Sorting()

  local count = #private.table_obj;
  ng_global.progress[ "scr" ][ "win_stock_scr" ].t_gen = {};
  ng_global.progress[ "scr" ][ "win_stock_scr" ].taskpanel = {};

  for i = ( #private.table_obj ), 1, -1 do

    local temp = private.table_obj[ i ];
    j = math.random( i );
    private.table_obj[ i ] = private.table_obj[ j ];
    private.table_obj[ j ] = temp;

  end;

  local c_index = 0;
  for key, value in pairs ( public.taskpanel ) do

    ng_global.progress[ "scr" ][ "win_stock_scr" ].taskpanel[ key ] = {};

    for i = 1, #public.taskpanel[ key ] do

      c_index = c_index + 1;
      ng_global.progress[ "scr" ][ "win_stock_scr" ].t_gen[ c_index ] = private.table_obj[ c_index ];

      public.taskpanel[ key ][ i ] = private.table_obj[ c_index ][ 1 ];
      ng_global.progress[ "scr" ][ "win_stock_scr" ].taskpanel[ key ][ i ] = private.table_obj[ c_index ][ 1 ];

      ObjSet( "spr_stock_scr_"..public.taskpanel[ key ][ i ],   { visible = true, input = true, event_mdown = function() private.TaskComplete( public.taskpanel[ key ][ i ], key ) end } );

      ObjSet( "txt_stock_scr_taskpanel_"..key.."_"..i, 
      { 
        color_r = private.TASK_COLOR_R, 
        color_g = private.TASK_COLOR_G, 
        color_b = private.TASK_COLOR_B 
      } );

    end;

  end;

end;
--*********************************************************************************************************************
function public.PreOpen()

  local is_repeat = false;

  if cmn.IsEventDone(  "win_stock_scr" ) and cmn.IsEventStart( "win_stock_scr" )  then

    public.found = ng_global.progress[ "scr" ][ "win_stock_scr" ].found;
    ng_global.progress[ "scr" ][ "opn_stock_scr" ].done = 0;
    
    ng_global.progress[ "scr" ][ "win_stock_scr" ].done = 0;
    ng_global.progress[ "scr" ][ "win_stock_scr" ].start = 0;

    ng_global.progress[ "scr" ][ "win_stock_scr" ].t_gen = {};
    is_repeat = true;

    public.ResetInit();

  end; 

  if ( not cmn.IsEventDone( "opn_stock_scr" ) ) then

    public.Sorting();

    cmn.InitHo( "stock_scr" );
   
    cmn.SetEventDone( "opn_stock_scr" );
    cmn.SetMarkedTask( "stock_scr", "ship" );
    cmn.SetMarkedTask( "stock_scr", "harpoon" );
    cmn.SetMarkedTask( "stock_scr", "canister" );
    cmn.SetMarkedTask( "stock_scr", "pen_1" );
    cmn.SetMarkedTask( "stock_scr", "pen" );
    cmn.SetMarkedTask( "stock_scr", "sew" );

    ng_global.progress[ "scr" ][ "win_stock_scr" ].items = {};
    ng_global.progress[ "scr" ][ "win_stock_scr" ].parts = {};
    ng_global.progress[ "scr" ][ "win_stock_scr" ].timer = { default = 50, time = 50, diff = 20, extra = 0 };
    
  end;

  local ho_items = {};

  local tmp_progress = ng_global.progress[ "scr" ][ "win_stock_scr" ].t_gen;

  for i = 1, 12 do

    interface.TaskPanelTaskAdd( ho_items, tmp_progress[ i ][ 1 ],  1, tmp_progress[ i ][ 2 ], tmp_progress[ i ][ 3 ] );
    
    if tmp_progress[ i ][ 1 ] == "harpoon" then

      ObjSet( "obj_stock_scr_use_stalk",  { input = true } );
      ObjSet( "spr_stock_scr_stalk", { input = true } );

    elseif tmp_progress[ i ][ 1 ] == "ship" then

      ObjSet( "obj_stock_scr_use_hammer", { input = true } );
      ObjSet( "spr_stock_scr_hammer", { input = true } );

    end;

  end;

  for key, value in pairs ( public.taskpanel ) do

    for i = 1, #public.taskpanel[ key ] do

      ObjSet( "txt_stock_scr_taskpanel_"..key.."_"..i, { text = "tsk_stock_scr_"..public.taskpanel[ key ][ i ] } );

      local unmark = ng_global.progress[ "scr" ][ "win_stock_scr" ].unmark;
      for unkey, value in pairs ( unmark ) do

        if value.done == 0 and public.taskpanel[ key ][ i ] == unkey then

          ObjSet( "txt_stock_scr_taskpanel_"..key.."_"..i, 
          { 
            color_r = private.TASK_MARKED_COLOR_R, 
            color_g = private.TASK_MARKED_COLOR_G, 
            color_b = private.TASK_MARKED_COLOR_B 
          } );          
          break;

        end;

      end;

      for j = 1, #ng_global.progress[ "scr" ][ "win_stock_scr" ].found do

        local name = tostring( ng_global.progress[ "scr" ][ "win_stock_scr" ].found[ j ][ "task" ] );
        if name == public.taskpanel[ key ][ i ] then

          ObjSet( "txt_stock_scr_taskpanel_"..key.."_"..i, 
          { 
            color_r = private.TASK_COMPLETED_COLOR_R, 
            color_g = private.TASK_COMPLETED_COLOR_G, 
            color_b = private.TASK_COMPLETED_COLOR_B 
          } );
          break;
        
        end;        

      end;
      
    end;

  end;

  interface.TaskPanelTaskAdd( ho_items, "canister",     1, 1, { { "spr_stock_scr_taskpanel_item_canister", "obj_stock_scr_use_item_canister_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "pen_1",        1, 1, { { "spr_stock_scr_taskpanel_item_pen_1", "obj_stock_scr_use_item_pen_1_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "pen",          1, 1, { { "spr_stock_scr_taskpanel_item_pen", "obj_stock_scr_use_item_pen_hint" } } );
  interface.TaskPanelTaskAdd( ho_items, "sew",          1, 1, { { "spr_stock_scr_taskpanel_item_sew", "obj_stock_scr_use_item_sew_hint" } } );
  
  interface.TaskPanelShow( ho_items );
  int_taskpanel_impl.HideTextPanel( "stock_scr" );

  ObjSet( "obj_stock_scr_taskpanel", { visible = true, input = true, pos_z = 1, pos_x = -190, pos_y = 37 } );  

  --common_impl.EnvPlay( { "common/audio/aud_pier_env" }, "", 0.5 );
  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );
  
  if is_repeat then
 
    public.ResetStart();

  end;

  levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.TaskPanelHide();
  int_button_timer.Hide();

  levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
function public.Open ()
  
  common_impl.TutorialShow( "tutorial_page_6_scr" );

  int_button_timer.Show();
  --common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.Close ()

  --common_impl.PassingHoStop();
  int_taskpanel_impl.ShowTextPanel( "stock_scr" );
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

end;
--*********************************************************************************************************************
function public.HoComplete()

  levelscr_inv.HoDeleteWin();
  --common_impl.PassingHoWin();
  rm_mysteryroom.WinTask();

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name, part )

  cmn.HoTaskFind( "spr_stock_scr_"..task_name, task_name );

  for key, value in pairs ( public.taskpanel ) do

    for i = 1, #public.taskpanel[ key ] do

      if public.taskpanel[ key ][ i ] == task_name then

        ObjSet( "txt_stock_scr_taskpanel_"..key.."_"..i, 
        { 
          color_r = private.TASK_COMPLETED_COLOR_R, 
          color_g = private.TASK_COMPLETED_COLOR_G, 
          color_b = private.TASK_COMPLETED_COLOR_B 
        } );
        break;

      end;

    end;

  end;

  if ( task_name == "harpoon" or task_name == "ship" ) then

    ObjSet( "spr_stock_scr_"..task_name, { input = false } );

  end;
      
  private.check_task( "spr_stock_scr_"..task_name, part );

end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  common_impl.PlayAudio("sfx","common/audio/aud_get_inv_sfx");
  ObjSet( "spr_stock_scr_"..name, { pos_z = 20 } );
  ObjSet( "spr_stock_scr_"..name.."_shadow", { visible = false } );

end;

--------------------------------------------------------------------------------------
function private.UnmarkTask( ho_name, task )

  local prg = prg.current;

  local event_win_ho = "win_"..ho_name;

  ng_global.progress[ prg ][ event_win_ho ].unmark[ task ].done = 1;
  ng_global.progress[ prg ][ event_win_ho ].start = 1;

end
--------------------------------------------------------------------------------------
function private.UnMark( name )

  for key, value in pairs ( public.taskpanel ) do

    for i = 1, #public.taskpanel[ key ] do

      if public.taskpanel[ key ][ i ] == name then

        ObjSet( "txt_stock_scr_taskpanel_"..key.."_"..i, 
        { 
          color_r = private.TASK_COLOR_R, 
          color_g = private.TASK_COLOR_G, 
          color_b = private.TASK_COLOR_B 
        } );              
        break;

      end;

    end;

  end;     

end;
----------------------------------------------------------------------------

function private.unmark_ship() 
 
  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_stock_scr_hammer", "obj_stock_scr_use_hammer" ) ) then

    common_impl.Lock(true);
    
    ObjSet( "spr_stock_scr_hammer", { alp = 0 } );

    local func_after = function()

      common_impl.Lock(false);
  
      private.UnmarkTask( "stock_scr", "ship" );
      cmn.CallEventHandler( "unmark_ship" );

      private.UnMark( "ship" );

    end;

    common_impl.PlayAudio("sfx","common/audio/aud_ho_stock_hammer");
    ObjSet( "vid_stock_scr_bottle", { active = true, alp = 1 });
    ObjSet( "spr_stock_scr_bottle", {  alp = 0 });
    VidPlay( "vid_stock_scr_bottle", func_after );

  else

    ObjSet( "spr_stock_scr_hammer", { pos_z = 0 } );
    ObjSet( "spr_stock_scr_hammer_shadow", { visible = true } );
        
  end;

end;
----------------------------------------------------------------------------
function private.unmark_harpoon() 
 
  common_impl.SetCursor( CURSOR_DEFAULT );

  if ( common.ApplyObj( "spr_stock_scr_stalk", "obj_stock_scr_use_stalk" ) ) then

    common_impl.Lock(true);
    
    ObjSet( "spr_stock_scr_stalk", { alp = 0 } );

    local func_after = function()

      common_impl.Lock(false);
  
      private.UnmarkTask( "stock_scr", "harpoon" );
      cmn.CallEventHandler( "unmark_harpoon" );

      private.UnMark( "harpoon" );

    end;
    
    ObjAnimate( "spr_stock_scr_stalk_2", "alp", 0, 0, func_after, { 0,3,0,  0.4,3,1 } );
    common_impl.PlayAudio( "sfx","common/audio/aud_ho_stock_peak" );
    
  else

    ObjSet( "spr_stock_scr_stalk", { pos_z = 2 } );
    ObjSet( "spr_stock_scr_stalk_shadow", { visible = true } );
        
  end;

end;
-------------------------------------------------------------------------
-------------------------------------------------------------------------
function private.check_task( obj, part )

  local ho_progress = ng_global.progress[ ng_global.currentprogress ][ "win_stock_scr" ];
  
  ho_progress.items[ obj ] = true;
  local flag_complete = true;

  for i = 1, #public.taskpanel[ part ] do

    if ( not ho_progress.items[ "spr_stock_scr_"..public.taskpanel[ part ][ i ] ] ) then

      flag_complete = false;
      break;

    end;

  end;

  if ( flag_complete ) then    
    
    local func_after = function()
    
      ObjSet( "spr_stock_scr_taskpanel_item_"..part, { input = true } );
      ObjSet( "obj_stock_scr_use_item_"..part.."_hint", { input = true } );      

    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_ho_panel_off", 0, "", 0 );

    ObjAnimate( "spr_stock_scr_taskpanel_part_"..part, "pos_y", 0, 0, func_after, { 0,0,10, 1.3,0,90 } );
  
  end;
  
end;

-------------------------------------------------------------------------------------
function private.GetGasolinesawItem( name )

  common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 );
  local item = "obj_stock_scr_taskpanel_item_"..name;
  
  ObjSet( item, { pos_z = 5 } );

end;
-------------------------------------------------------------------------------------
function private.UseItem( name )

  local item = "spr_stock_scr_taskpanel_item_"..name;
  
  if ( ObjIntersect( item, "obj_stock_scr_use_canister" ) ) then

    ObjDetach( item );
    
    local func_after = function()

      common_impl.Lock(false);
      cmn.HoTaskFind( "spr_stock_scr_gasolinesaw_"..name.."_hint", name, true );
      ng_global.progress[ ng_global.currentprogress ][ "win_stock_scr" ].parts[ name ] = true;

    end;

    common_impl.Lock(true);
    common_impl.PlayAudio("sfx","common/audio/aud_ho_stock_chainsaw_"..name );   

    if ( name == "canister" ) then

      ObjSet( "vid_stock_scr_can", { active = true, alp = 1 });
      VidPlay( "vid_stock_scr_can", "" );
      ObjAnimate( "spr_stock_scr_gasolinesaw_cover", "alp", 0, 0, func_after,
      {
        0.0,  0,  0,
        2.2,  0,  0,
        2.5,  0,  1
      } ); 

      ObjAnimate( "spr_stock_scr_funnel", "alp", 0, 0, "",
      {
        0.0,  0,  0,
        0.1,  0,  1,
        2.0,  0,  1,
        2.1,  0,  0
      } ); 
  
     ObjAnimate( "spr_stock_scr_funnel_over_vid", "alp", 0, 0, "",
      {
        0.0,  0,  0,
        0.1,  0,  1,
        2.0,  0,  1,
        2.1,  0,  0
      } );    

    else 

      ObjAnimate( "spr_stock_scr_gasolinesaw_"..name, "alp", 0, 0, func_after, 
      { 
        0.0,  0,  0,
        0.3,  0,  1
      } );      

    end;
    
    ObjAnimate( "spr_stock_scr_gasolinesaw_"..name.."_light", "alp", 0, 0, "", 
    { 
      0.0,  0,  1,
      0.3,  0,  0
    } ); 
  
  else

    ObjSet( "obj_stock_scr_taskpanel_item_"..name, { pos_z = 1 } );
   
  end;

end;
----------------------------------------------------------------------------
