-- name=ho_trash_scr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "trash_scr" );
  game.relations[ "ho_trash_scr" ].exitroom = "rm_mysteryroom";
  public.found = {};

  private.table_obj = {
    { "dagger" }, 
    { "feather" }, 
    { "flags" }, 
    { "flute" }, 
    { "garland" }, 
    { "lollipop_tail" }, 
    { "handle" }, 
    { "stone" }, 
    { "coin" }, 
    { "glass" }, 
    { "ball", true }, 
    { "ball_baseball", true }, 
    { "block", true }, 
    { "butterfly", true }, 
    { "film_camera", true }, 
    { "jug", true }, 
    { "key", true }, 
    { "snowflake", true }, 
    { "sucker", true }, 
  };

  ObjAnimate( "spr_trash_scr_chicken", "scale_x", 1, 0, "", { 0,0,1, 1.5,0,0.97, 3,0,1 } );
  ObjAnimate( "spr_trash_scr_horse", "scale_x", 1, 0, "", { 0,0,1, 2,0,0.96, 4,0,1 } );
  ObjAnimate( "spr_trash_scr_light", "alp", 1, 0, "", { 0,0,0, 2.5,0,1, 5,0,0 } );
 
  public.ResetInit();
  --------------------------------------------------------------------------------------------
  -- function win_trash_scr () end;
  --------------------------------------------------------------------------------------------
  local win_trash_scr_func = function ()

    if ( cmn.IsEventDone( "win_trash_scr" ) ) then

      --  
            
    end;

  end;
  cmn.AddSubscriber( "win_trash_scr", win_trash_scr_func );
--------------------------------------------------------------------------------------------------
  local start_trash_scr_func = function ()

    if ( not cmn.IsEventDone( "win_trash_scr" ) ) then
             
      common_impl.ProcessHoStart( "trash_scr" );
      local ho_found = ng_global.progress[ "scr" ][ "win_trash_scr" ].found;

      local t_gen = ng_global.progress[ "scr" ][ "win_trash_scr" ].t_gen;
      for i = 1, #t_gen do

        ObjSet( "obj_trash_scr_"..t_gen[ i ][ 1 ], { input = true } );
        ObjSet( "spr_trash_scr_"..t_gen[ i ][ 1 ], { alp = 0 } );

      end;

      for i = 1, #ho_found do

        local name = common.GetObjectName( ho_found[ i ].item );
        ObjSet( "spr_"..name, { alp = 1 } );
        ObjSet( "obj_"..name, { input = false } );

      end;

    end;


  end;    
  
  cmn.AddSubscriber( "win_trash_scr", start_trash_scr_func, "ho_trash_scr" );  

end;
--*********************************************************************************************************************
function public.Sorting()

  local count = #private.table_obj;
  ng_global.progress[ "scr" ][ "win_trash_scr" ].t_gen = {};  

  for i = ( #private.table_obj ), 1, -1 do

    local temp = private.table_obj[ i ];
    j = math.random( i );
    private.table_obj[ i ] = private.table_obj[ j ];
    private.table_obj[ j ] = temp;

  end;

  for i = 1, 12 do

    ng_global.progress[ "scr" ][ "win_trash_scr" ].t_gen[ i ] = private.table_obj[ i ];
    ObjSet( "obj_trash_scr_"..private.table_obj[ i ][ 1 ], { input = true } );
    ObjSet( "spr_trash_scr_"..private.table_obj[ i ][ 1 ], { alp = 0 } );

--    ng_global.progress[ "scr" ][ "win_hos_scr" ].t_gen[ i ] = private.table_obj[ i ];
--    ObjSet( "spr_hos_scr_"..private.table_obj[ i ][ 1 ], { alp = 1, visible = true, input = true, event_mdown = function() private.TaskComplete( private.table_obj[ i ][ 1 ] ) end } );
--
--    if private.table_obj[ i ][ 1 ] == "bell" then
--
--      ObjSet( "obj_hos_scr_use_tongue_2",  { input = true } );
--      ObjSet( "spr_hos_scr_tongue_2",      { input = true, visible = true, alp = 1 } ); 
--      ObjSet( "spr_hos_scr_bell", { input = true, visible = true } );
--
--    end;

  end;

end;
--*********************************************************************************************************************
function public.ResetInit()

  for i = 1, #private.table_obj do

    local table_multiset = {};

    table.insert( table_multiset, { "obj_trash_scr_"..private.table_obj[ i ][ 1 ],   { input = false } } );
    table.insert( table_multiset, { "spr_trash_scr_"..private.table_obj[ i ][ 1 ],   { alp = 0 } } );   
 
    ObjMultiSet( table_multiset );

  end;

end;
--*********************************************************************************************************************
function public.ResetStart()

  local ho_found = public.found;

  for key = 1, #public.found do

    local obj_name = ho_found[ key ][ "object" ];
    local spr_name = "spr_"..common.GetObjectName( obj_name );

    local table_multiset = {
      --{ obj_name, { input = true } },
      { spr_name, { alp = 0 } },
    };

    ObjMultiSet( table_multiset );

  end;    

end;
--*********************************************************************************************************************
function public.PreOpen()

  local is_repeat = false;

  if cmn.IsEventDone(  "win_trash_scr" ) and cmn.IsEventStart( "win_trash_scr" )  then

    public.found = ng_global.progress[ "scr" ][ "win_trash_scr" ].found;
    ng_global.progress[ "scr" ][ "opn_trash_scr" ].done = 0;
    
    ng_global.progress[ "scr" ][ "win_trash_scr" ].done = 0;
    ng_global.progress[ "scr" ][ "win_trash_scr" ].start = 0;
    is_repeat = true;

    public.ItemAdded();

    public.ResetInit();

  end; 

  if ( not cmn.IsEventDone( "opn_trash_scr" ) ) then

    public.Sorting();

    cmn.InitHo( "trash_scr" );

    cmn.SetEventDone( "opn_trash_scr" );    
    ng_global.progress[ "scr" ][ "win_trash_scr" ].timer = { default = 40, time = 40, diff = 20, extra = 0 };
      
  end;

  local ho_items = {};

  local tmp_progress = ng_global.progress[ "scr" ][ "win_trash_scr" ].t_gen;

  for i = 1, 12 do

    interface.ItemPanelItemAdd( ho_items, tmp_progress[ i ][ 1 ] );

  end;
  
  interface.ItemPanelShow( ho_items );

  common_impl.PlayAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

  interface.InvestigationButtonCheck();

  if is_repeat then
 
    public.ResetStart();

  end;

  levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
function public.Open ()

  common_impl.TutorialShow( "tutorial_page_6_scr" );

  int_button_timer.Show();
  --common_impl.PassingHoStart();

end;
--*********************************************************************************************************************
function public.Close ()

  --common_impl.PassingHoStop();

end;
--*********************************************************************************************************************
function public.PreClose()

  interface.ItemPanelHide();
  int_button_timer.Hide();
  common_impl.StopAudio( "mus", "common/audio/aud_ho_mus", 1, "", 0.5 );

  levelscr.InventoryDisable();

end;
--*********************************************************************************************************************
function public.HoComplete()

  levelscr_inv.HoDeleteWin();
  --common_impl.PassingHoWin();
  rm_mysteryroom.WinTask();

end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

  local name = common.GetObjectName( item_name );
  local item_object_name = "obj_"..name;
  local item_spr_name = "spr_"..name;

  ObjSet( item_object_name, { input = false } );

  ObjSet( item_spr_name, { alp = 1 } );

  local aud_name = name;
  for i = 1, #private.table_obj do
    if string.find( name, private.table_obj[ i ][ 1 ] ) and not private.table_obj[ i ][ 2 ] then
      aud_name = "trash_"..private.table_obj[ i ][ 1 ];
      break;
    end;
  end;

  common_impl.PlayAudio( "sfx", "common/audio/aud_ho_"..aud_name, 0, "", 0 );
  
  if ( name == "trash_scr_coin" ) then

    local func_end = function()

      common_impl.Lock(false);
      ObjSet( "obj_trash_scr_gates", { input = true } );

    end;

    common_impl.Lock(true);
    ObjSet( "obj_trash_scr_gates", { input = false } );

    ObjAnimate( "spr_trash_scr_coin_anm", "pos_xy", 0, 0, "", { 
      0,   0, 9, -8, 
      0.2, 0, 9, -8, 
      0.8, 0, 17, 39 
    } );

    ObjAnimate( "spr_trash_scr_coin_anm", "alp", 0, 0, func_end, { 
      0,   0, 0, 
      0.2, 0, 1, 
      0.8, 0, 1,
      1.0, 0, 0 
    } );

  elseif ( name == "trash_scr_handle" ) then

    local func_end = function()

      common_impl.Lock(false);
      ObjSet( "obj_trash_scr_gates", { input = true } );

    end;

    common_impl.Lock(true);
    ObjSet( "obj_trash_scr_gates", { input = false } );

    ObjAnimate( "spr_trash_scr_thermos", "pos_xy", 0, 0, func_end, { 
      0.0, 0, 700, 400, 
      0.4, 0, 700, 400,
      1.0, 0, 622, 442,
      1.7, 0, 622, 442,
      2.3, 0, 700, 390 
    } );

    ObjAnimate( "spr_trash_scr_thermos", "ang", 0, 0, "", { 
      0.0, 0, 0, 
      0.4, 0, 0, 
      1.0, 0, 1.43,
      1.7, 0, 1.43,
      2.3, 0, 0 
    } );

    ObjAnimate( "spr_trash_scr_thermos", "alp", 0, 0, "", { 
      0.0, 0, 1, 
      2.1, 0, 1,
      2.3, 0, 0 
    } );

    ObjAnimate( "spr_trash_scr_coffee_anm", "alp", 0, 0, "", { 
      0.0, 0, 0, 
      1.2, 0, 0,
      1.0, 0, 1,
      1.3, 0, 1,
      1.4, 0, 0       
    } );

    ObjAnimate( "spr_trash_scr_coffee_anm_2", "alp", 0, 0, "", { 
      0.0, 0, 0, 
      1.0, 0, 0,
      1.4, 0, 1,
      1.5, 0, 1,
      1.6, 0, 0       
    } );

    ObjAnimate( "spr_trash_scr_thermos_cover", "pos_y", 0, 0, "", { 
      0,   0, -118, 
      0.3, 0, -161      
    } );

    ObjAnimate( "spr_trash_scr_thermos_cover", "alp", 0, 0, "", { 
      0,   0, 1, 
      0.25, 0, 1,
      0.3, 0, 0      
    } );

    ObjAnimate( "spr_trash_scr_handle", "alp", 0, 0, "", { 
      0,   0, 0, 
      1.4, 0, 0,
      1.6, 0, 1      
    } );

  end;

  interface.ItemPanelTryToComplete();

end;
--*********************************************************************************************************************
function public.ItemAdded()

  for i = 1, #public.found do

    if not ObjGet( public.found[ i ][ "item" ] ) then

      local name = string.sub( public.found[ i ][ "item" ], 15 );
      local res_name = name;
      local res_path = ""
      
      if name == "feather" then
        res_name = "feather_2";
      elseif name == "flags" then
        res_name = "flags_2";
      elseif name == "flute" then
        res_name = "flute_1";
      elseif name == "dagger" then
        res_name = "cherry";
      end;

      res_path = "assets/levels/level1/ho_trash/layers/"..res_name.."_inv";
      for j = 1, #private.table_obj do
  
        if private.table_obj[ j ][ 2 ] and private.table_obj[ j ][ 1 ] == name then

          res_path = "assets/levels/levelscr/ho_trash_scr/layers/"..res_name.."_inv";
          break;

        end;

      end;

      ObjCreate( public.found[ i ][ "item" ], "spr" );
      ObjSet( public.found[ i ][ "item" ], 
      { 
        res = res_path,
        event_menter = function () interface.PopupShow( "pop_trash_scr_"..name ) end,
        event_mleave = function () interface.PopupHide() end,
        event_startdrag = function () common_impl.PlayAudio( "sfx", "common/audio/aud_get_inv_sfx", 0, "", 0 ) end,
        event_dragdrop =  function () cmn.HoItemFind( "itm_trash_scr_"..name ) end,
        inputrect_init = true,
        inputrect_x = -40,
        inputrect_y = -40,
        inputrect_w = 80,
        inputrect_h = 80
      } );

    end;

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------




