-- name=mg_bottles_scr
--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_bottles_scr";
  
  private.InitMas();

  ObjMultiSet({ 
    --{ "spr_bottles_scr_tap",      { event_mdown = private.get_tap }},
    { "spr_bottles_scr_safe",     { event_mdown = private.clk_tap_bottles_scr }},

    { "obj_bottles_scr_area_1",   { event_mdown = function () private.TurnBottles(private.Path1) end; }},
    { "obj_bottles_scr_area_2",   { event_mdown = function () private.TurnBottles(private.Path2) end; }},
    { "obj_bottles_scr_area_3",   { event_mdown = function () private.TurnBottles(private.Path3) end; }},
    { "obj_bottles_scr_area_4",   { event_mdown = function () private.TurnBottles(private.Path4) end; }},
    { "obj_bottles_scr_area_5",   { event_mdown = function () private.TurnBottles(private.Path5) end; }},
    { "obj_bottles_scr_area_6",   { event_mdown = function () private.TurnBottles(private.Path6) end; }},
    { "obj_bottles_scr_area_7",   { event_mdown = function () private.TurnBottles(private.Path7) end; }},

  });
  --------------------------------------------------------------------------------------------
  -- function win_bottles_scr () end;
  --------------------------------------------------------------------------------------------
  local win_bottles_scr = function ()

    if ( cmn.IsEventDone( "win_bottles_scr" ) ) then 
      
      ObjSet("spr_bottles_scr_safe", { input = true });

      ObjDetach("anm_bottles_scr_mg_bottles_scr_win");
      ObjDetach("spr_bottles_scr_empty_shelves" );
      ObjDetach("obj_bottles_scr_bottle_shelf"  );
      ObjDetach("obj_bottles_scr_bottles_scr"       );
      ObjDetach("obj_bottles_scr_lables"        );
      ObjDetach("obj_bottles_scr_area"          );

      ObjSet("obj_bottles_scr_win",  { alp = 1 }); 

    else

      if ng_global.progress[ "scr" ][ "win_bottles_scr" ].numb == 2 then

        private.MasRBWin = private.MasRBWin_2;
        private.MasNumbersWin = private.MasNumbersWin_2;  
      
      elseif ng_global.progress[ "scr" ][ "win_bottles_scr" ].numb == 3 then

        private.MasRBWin = private.MasRBWin_3;
        private.MasNumbersWin = private.MasNumbersWin_3;        

      end;

      private.MasNumbers = ng_global.progress[ "scr" ][ "win_bottles_scr" ].mas_pos;
      private.MasRB = ng_global.progress[ "scr" ][ "win_bottles_scr" ].mas_color;
      
      local k=0;

      for i=1,5 do
        for j=1,5 do
          
          if (private.MasNumbers[i][j]~=0) then
 
            k = k + 1;   
            ObjSet("spr_bottles_scr_bottle_"..private.MasNumbers[i][j], { pos_x=private.BottlesPositions[k][1], pos_y=private.BottlesPositions[k][2] });

            --------------------------------------------------------------------------------------------------------------------------------------
            for z=1,6 do
              if (private.MasNumbers[i][j] == private.lables[z]) then

                ObjSet("anm_bottles_scr_lable_"..private.lables[z], { pos_x=private.BottlesPositions[k][1], pos_y=private.BottlesPositions[k][2] } );

              end;
            end;
            --------------------------------------------------------------------------------------------------------------------------------------

          end;

        end;
      end;

    end;

  end;

  cmn.AddSubscriber( "win_bottles_scr", win_bottles_scr, private.room_objname );
  --------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function private.InitMas()

  --стартовые позиции 
  private.StartNumbers = {{  0,  1,  2,  3,  0 },
                          {  4,  5,  6,  7,  0 },
                          {  8,  9, 10, 11, 12 },
                          { 13, 14, 15, 16,  0 },
                          {  0, 17, 18, 19,  0 }};

  private.StartRB = {{  0,  0,  0,  0,  0 },
                     {  1,  0,  1,  0,  0 },
                     {  0,  2,  0,  0,  0 },
                     {  0,  0,  0,  2,  0 },
                     {  0,  1,  2,  0,  0 }};
  ----------------------------------------------------
  --win позиции 
  private.MasNumbersWin = { {   0,  1,  2,  3,  0 },
                            {   5,  9,  4,  7,  0 },
                            {   8,  6, 10, 16, 11 },
                            {  12, 18, 17, 13,  0 },
                            {   0, 14, 15, 19,  0 } };

  private.MasRBWin = {{  0,  0,  0,  0,  0 },
                      {  0,  2,  1,  0,  0 },
                      {  0,  1,  0,  2,  0 },
                      {  0,  2,  1,  0,  0 },
                      {  0,  0,  0,  0,  0 }};

  private.MasNumbersWin_2 = { {   0,  1,  4,  9,  0 },
                              {   2,  16, 3,  6,  0 },
                              {   5,  7,  17, 18, 8 },
                              {   10, 11, 12, 13, 0 },
                              {   0,  14, 15, 19, 0 } };

  private.MasRBWin_2 = {{  0,  0,  1,  2,  0 },
                        {  0,  2,  0,  1,  0 },
                        {  0,  0,  1,  2,  0 },
                        {  0,  0,  0,  0,  0 },
                        {  0,  0,  0,  0,  0 }};

  private.MasNumbersWin_3 = { {   0,  1,  2,  3,   0  },
                              {   5,  7,  8,  10,  0  },
                              {   11, 12, 9,  16,  13 },
                              {   14, 4,  15, 18,  0  },
                              {   0,  19, 6,  17,  0  } };

  private.MasRBWin_3 = {{  0,  0,  0,  0,  0 },
                        {  0,  0,  0,  0,  0 },
                        {  0,  0,  2,  2,  0 },
                        {  0,  1,  0,  2,  0 },
                        {  0,  0,  1,  1,  0 }};

  ----------------------------------------------------
  -- позиции
  private.BottlesPositions = { { 412, 130 },
                               { 545, 132 },
                               { 680, 131 },

                               { 353, 244 },
                               { 480, 245 },
                               { 613, 243 },
                               { 743, 243 },

                               { 283, 364 },
                               { 413, 358 },
                               { 551, 361 },
                               { 678, 362 },
                               { 807, 361 },

                               { 347, 475 },
                               { 480, 475 },
                               { 614, 476 },
                               { 744, 473 },

                               { 416, 587 },
                               { 551, 586 },
                               { 681, 587 },
                             };
  ----------------------------------------------------
  private.MasNumbers = { {  0,  1,  2,  3,  0 },
                         {  4,  5,  6,  7,  0 },
                         {  8,  9, 10, 11, 12 },
                         { 13, 14, 15, 16,  0 },
                         {  0, 17, 18, 19,  0 } };

  -- название спрайтов: / синие: 4, 6, 17 ; красные: 9, 16, 18 /
  -- синие - 1, красные - 2
  private.MasRB = {{  0,  0,  0,  0,  0 },
                   {  1,  0,  1,  0,  0 },
                   {  0,  2,  0,  0,  0 },
                   {  0,  0,  0,  2,  0 },
                   {  0,  1,  2,  0,  0 }};
  ----------------------------------------------------
  private.Path1 = {{1,2},{1,3},{2,3},{3,3},{3,2},{2,1}};
  private.Path2 = {{1,3},{1,4},{2,4},{3,4},{3,3},{2,2}};

  private.Path3 = {{2,1},{2,2},{3,3},{4,2},{4,1},{3,1}};
  private.Path4 = {{2,2},{2,3},{3,4},{4,3},{4,2},{3,2}};
  private.Path5 = {{2,3},{2,4},{3,5},{4,4},{4,3},{3,3}};

  private.Path6 = {{3,2},{3,3},{4,3},{5,3},{5,2},{4,1}};
  private.Path7 = {{3,3},{3,4},{4,4},{5,4},{5,3},{4,2}};
  ----------------------------------------------------

  private.lables = {4,6,9,16,17,18};
  
end;
--*********************************************************************************************************************
function public.Open() 

  common_impl.TutorialShow( "tutorial_page_6_scr" );

  if not cmn.IsEventDone( "win_bottles_scr" ) then

    cmn.MiniGameShow();
    --common_impl.PassingMgStart();

    local win_flag = private.CheckBottles();
    if win_flag then

      private.Win();

    end;

    int_button_timer.Show();

  end;

  int_slider.InitSlider( private.room_objname );

  common_impl.PlayAudio( "env", "common/audio/aud_wincards_env", 1, "", 0.5 );

end;
--*********************************************************************************************************************
function public.PreOpen()

  local is_repeat = false;

  if cmn.IsEventDone(  "win_bottles_scr" ) and cmn.IsEventStart( "win_bottles_scr" )  then
    
    ng_global.progress[ "scr" ][ "win_bottles_scr" ].done = 0;
    ng_global.progress[ "scr" ][ "win_bottles_scr" ].start = 0;
    is_repeat = true;

  end; 

  if ( not cmn.IsEventStart( "win_bottles_scr" ) ) then

    ng_global.progress[ "scr" ][ "win_bottles_scr" ].mas_pos = private.StartNumbers;
    ng_global.progress[ "scr" ][ "win_bottles_scr" ].mas_color = private.StartRB;
    ng_global.progress[ "scr" ][ "win_bottles_scr" ].timer = { default = 150, time = 150, diff = 30, extra = 0 };
    ng_global.progress[ "scr" ][ "win_bottles_scr" ].numb = 1;

    private.ResetInit();

  end;
  
  interface.InvestigationButtonCheck();

  if ng_global.progress[ "scr" ][ "win_bottles_scr" ].numb == 1 then

    ObjSet( "anm_bottles_scr_mg_bottles_scr",     { alp = 1 } );
    ObjSet( "anm_bottles_scr_mg_bottles_scr_2",   { alp = 0 } );
    ObjSet( "anm_bottles_scr_mg_bottles_scr_3",   { alp = 0 } );

  elseif ng_global.progress[ "scr" ][ "win_bottles_scr" ].numb == 2 then

    ObjSet( "anm_bottles_scr_mg_bottles_scr",     { alp = 0 } );
    ObjSet( "anm_bottles_scr_mg_bottles_scr_2",   { alp = 1 } );
    ObjSet( "anm_bottles_scr_mg_bottles_scr_3",   { alp = 0 } );

  elseif ng_global.progress[ "scr" ][ "win_bottles_scr" ].numb == 3 then

    ObjSet( "anm_bottles_scr_mg_bottles_scr",     { alp = 0 } );
    ObjSet( "anm_bottles_scr_mg_bottles_scr_2",   { alp = 0 } );
    ObjSet( "anm_bottles_scr_mg_bottles_scr_3",   { alp = 1 } );

  end;

  if is_repeat then
 
    public.ResetStart();

  end;

end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_bottles_scr" ) then

    cmn.MiniGameHide();
    --common_impl.PassingMgStop();

  end;

  int_button_timer.Hide();

  common_impl.StopAudio( "env", "common/audio/aud_wincards_env", 1 );

end;
--*********************************************************************************************************************
-- function *** MG *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()

  for i=1,5 do
    for j=1,5 do
      private.MasNumbers[i][j] = private.StartNumbers[i][j];
      private.MasRB[i][j] = private.StartRB[i][j];
    end;
  end;

  ng_global.progress[ "scr" ][ "win_bottles_scr" ].mas_pos = private.MasNumbers;
  ng_global.progress[ "scr" ][ "win_bottles_scr" ].mas_color = private.MasRB;

  for i=1,5 do
    for j=1,5 do

      if (private.MasNumbers[i][j]~=0) then 

        local k = private.MasNumbers[i][j];
        ObjSet("spr_bottles_scr_bottle_"..private.MasNumbers[i][j], { pos_x=private.BottlesPositions[k][1], pos_y=private.BottlesPositions[k][2] });

        --------------------------------------------------------------------------------------------------------------------------------------
        for z=1,6 do
          if (private.MasNumbers[i][j] == private.lables[z]) then

            ObjSet("anm_bottles_scr_lable_"..private.lables[z], { pos_x=private.BottlesPositions[k][1], pos_y=private.BottlesPositions[k][2] } );

          end;
        end;
        --------------------------------------------------------------------------------------------------------------------------------------
       
      end;

    end;
  end;

end;
--*********************************************************************************************************************
function public.Skip()

  for i=1,5 do
    for j=1,5 do

      private.MasNumbers[i][j] = private.MasNumbersWin[i][j];
      private.MasRB[i][j] = private.MasRBWin[i][j];

    end;
  end;

  ng_global.progress[ "scr" ][ "win_bottles_scr" ].mas_pos = private.MasNumbers;
  ng_global.progress[ "scr" ][ "win_bottles_scr" ].mas_color = private.MasRB;

  local k=0;

  for i=1,5 do
    for j=1,5 do
      
      if (private.MasNumbers[i][j]~=0) then 

        k = k + 1;   
        ObjSet("spr_bottles_scr_bottle_"..private.MasNumbers[i][j], { pos_x=private.BottlesPositions[k][1], pos_y=private.BottlesPositions[k][2] });

        --------------------------------------------------------------------------------------------------------------------------------------
        for z=1,6 do
          if (private.MasNumbers[i][j] == private.lables[z]) then

            ObjSet("anm_bottles_scr_lable_"..private.lables[z], { pos_x=private.BottlesPositions[k][1], pos_y=private.BottlesPositions[k][2] } );

          end;
        end;
        --------------------------------------------------------------------------------------------------------------------------------------

      end;

    end;
  end;

  private.Win();

end;
--*********************************************************************************************************************
function private.ResetInit()

  local numb = math.random( 2, 2 );
  ng_global.progress[ "scr" ][ "win_bottles_scr" ].numb = numb;
  
  if numb == 2 then

    private.MasRBWin = private.MasRBWin_2;
    private.MasNumbersWin = private.MasNumbersWin_2;

  elseif numb == 3 then

    private.MasRBWin = private.MasRBWin_3;
    private.MasNumbersWin = private.MasNumbersWin_3;

  end;

end;
--*********************************************************************************************************************
function public.ResetStart()

  ObjAttach( "anm_bottles_scr_mg_bottles_scr_win", private.room_objname );
  ObjAttach( "spr_bottles_scr_empty_shelves", private.room_objname );
  ObjAttach( "obj_bottles_scr_bottle_shelf", private.room_objname );
  ObjAttach( "obj_bottles_scr_bottles_scr", private.room_objname );
  ObjAttach( "obj_bottles_scr_lables", private.room_objname );
  ObjAttach( "obj_bottles_scr_area", private.room_objname );

  ObjMultiSet({ 
    { "spr_bottles_scr_empty_shelves",  { alp = 1 }},
    { "obj_bottles_scr_bottle_shelf",   { alp = 1 }},
    { "obj_bottles_scr_bottles_scr",        { alp = 1 }},
    { "obj_bottles_scr_lables",         { alp = 1 }},
    { "anm_bottles_scr_mg_bottles_scr_win", { alp = 0 }},
    { "obj_bottles_scr_win", { alp = 0 }},
  });

  public.Reset();

end;
--*********************************************************************************************************************
function private.WinEnd()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_bottles_scr" );
  cmn.CallEventHandler( "win_bottles_scr" );
  --common_impl.PassingMgWin();
  
  rm_mysteryroom.WinTask();

  cmn.GotoRoom( "rm_mysteryroom" );

end;
--*********************************************************************************************************************
function private.Win()

  local func_after = function ()

    common_impl.Lock(false);

    private.WinEnd();

  end;

  common_impl.Lock(true);

  ObjMultiSet({ 
    { "spr_bottles_scr_empty_shelves",  { alp = 0 }},
    { "obj_bottles_scr_bottle_shelf",   { alp = 0 }},
    { "obj_bottles_scr_bottles_scr",        { alp = 0 }},
    { "obj_bottles_scr_lables",         { alp = 0 }},
    { "anm_bottles_scr_mg_bottles_scr_win", { alp = 1 }},
  });

  AnimPlay( "anm_bottles_scr_mg_bottles_scr_win", "DoAnim", func_after )

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_bottles_win", 0, "", 0 );

end;
--*********************************************************************************************************************
-- поворот ( передаем массив )
function private.TurnBottles( num )  

  local func_after = function ()

    common_impl.Lock(false);

    for i=1,6 do

      ObjAttach( "spr_bottles_scr_bottle_"..private.MasNumbers[num[i][1]][num[i][2]],  "obj_bottles_scr_bottles_scr"  );

    end;

    for i=6,2, -1 do

      temp = private.MasNumbers[num[i][1]][num[i][2]];
      private.MasNumbers[num[i][1]][num[i][2]] = private.MasNumbers[num[i-1][1]][num[i-1][2]];
      private.MasNumbers[num[i-1][1]][num[i-1][2]] = temp;

    end;

    for i=6,2, -1 do

      temp = private.MasRB[num[i][1]][num[i][2]];
      private.MasRB[num[i][1]][num[i][2]] = private.MasRB[num[i-1][1]][num[i-1][2]];
      private.MasRB[num[i-1][1]][num[i-1][2]] = temp;

    end;

    local win_flag = private.CheckBottles();
    if win_flag then

      private.Win();

    else
 
      ng_global.progress[ "scr" ][ "win_bottles_scr" ].mas_pos = private.MasNumbers;
      ng_global.progress[ "scr" ][ "win_bottles_scr" ].mas_color = private.MasRB;

    end;

  end;
  --------------------------------------------------------------------------
  local mastempFrist = {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}};
  local mastempNext =  {{0,0},{0,0},{0,0},{0,0},{0,0},{0,0}};
  local tempNumMas;
----------------------------------------------------------------------------
  for i = 1, 6 do 

    tempNumMas = private.MasNumbers[num[i][1]][num[i][2]];

    mastempFrist[i][1] = ObjGet("spr_bottles_scr_bottle_"..tempNumMas ).pos_x;
    mastempFrist[i][2] = ObjGet("spr_bottles_scr_bottle_"..tempNumMas ).pos_y;

  end;

  for i = 1, 6 do

    if (i == 6) then
      mastempNext[i][1] = mastempFrist[1][1]; 
      mastempNext[i][2] = mastempFrist[1][2];
    else
      mastempNext[i][1] = mastempFrist[i+1][1]; 
      mastempNext[i][2] = mastempFrist[i+1][2];
    end;

  end;
  
  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_bottles_rotate", 0, "", 0 );

  for i =1,6 do

    ObjAttach( "spr_bottles_scr_bottle_"..private.MasNumbers[num[i][1]][num[i][2]],  "obj_bottles_scr_main_attach"  );

    --------------------------------------------------------------------------------
    for j =1,6 do

      if(private.MasNumbers[num[i][1]][num[i][2]]==private.lables[j]) then

        local posx1=ObjGet("anm_bottles_scr_lable_"..private.lables[j] ).pos_x;
        local posy1=ObjGet("anm_bottles_scr_lable_"..private.lables[j] ).pos_y;
        
        ObjAnimate( "anm_bottles_scr_lable_"..private.lables[j], "pos_xy", 0, 0, "",
        {
          0.0, 0, posx1, posy1,
          0.6, 0, mastempNext[i][1], mastempNext[i][2],
        } );

      end;

    end;
    --------------------------------------------------------------------------------

    ObjAnimate( "spr_bottles_scr_bottle_"..private.MasNumbers[num[i][1]][num[i][2]], "pos_xy", 0, 0, func_after,
    {
      0.0, 0, mastempFrist[i][1], mastempFrist[i][2],
      0.6, 0, mastempNext[i][1],  mastempNext[i][2],
    } );

    func_after = "";

  end;

end;
--*********************************************************************************************************************
function private.CheckBottles()

  for i=1,5 do
    for j=1,5 do

      if not (private.MasRB[i][j]==private.MasRBWin[i][j]) then

        return false;

      end;

    end;
  end;
  
  return true;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************