-- name=mg_safe_scr
--*********************************************************************************************************************
function public.Init()
 
  private.room_objname = "mg_safe_scr";
  private.nums = {2,3,5,7,11,13,17,19,23,29};
  --------------------------------------------------------------------------------------------
  ObjMultiSet({ 
  { "spr_safe_scr_code_1_drag", { event_drag = function() private.Circle_drag("spr_safe_scr_code_1"); end }},
  { "spr_safe_scr_code_1_drag", { event_startdrag = function() private.Circle_startdrag("spr_safe_scr_code_1","spr_safe_scr_code_1_drag"); end  }},
  { "spr_safe_scr_code_1_drag", { event_dragdrop = function() private.Circle_dragdrop("spr_safe_scr_code_1","spr_safe_scr_code_1_drag"); end }},
  { "spr_safe_scr_code_2_drag", { event_drag = function() private.Circle_drag("spr_safe_scr_code_2"); end }},
  { "spr_safe_scr_code_2_drag", { event_startdrag = function() private.Circle_startdrag("spr_safe_scr_code_2","spr_safe_scr_code_2_drag"); end }},
  { "spr_safe_scr_code_2_drag", { event_dragdrop = function() private.Circle_dragdrop("spr_safe_scr_code_2","spr_safe_scr_code_2_drag"); end }},
  { "spr_safe_scr_code_1_drag", { event_menter = function() private.CircleMenter(1); end }},
  { "spr_safe_scr_code_1_drag", { event_mleave = function() private.CircleLeave(1); end }},
  { "spr_safe_scr_code_2_drag", { event_menter = function() private.CircleMenter(2); end }},
  { "spr_safe_scr_code_2_drag", { event_mleave = function() private.CircleLeave(2); end }}, 
  }); 


  for i = 1,3 do

    ObjMultiSet({
    { "spr_safe_scr_gbutton_"..i, { event_mdown = function() private.Gbutton_clk(i); end }},
    { "spr_safe_scr_rbutton_"..i, { event_mdown = function() private.Rbutton_clk(i); end }},
    { "spr_safe_scr_gbutton_"..i, { event_menter = function() private.ButtonMenter("g",i) end}},
    { "spr_safe_scr_rbutton_"..i, { event_menter = function() private.ButtonMenter("r",i) end}},
    { "spr_safe_scr_gbutton_"..i, { event_mleave = function() private.ButtonLeave("g") end}},
    { "spr_safe_scr_rbutton_"..i, { event_mleave = function() private.ButtonLeave("r") end}}
    });

  end;

  local win_safe_scr = function ()

    if ( cmn.IsEventDone( "win_safe_scr" ) ) then

      ObjSet( "obj_safe_scr_mmg_parts", { input = false } );
      ObjSet( "spr_safe_scr_open", { input = true, visible = true } );
      ObjSet( "spr_safe_scr_chestpiece" , { input = true, visible = true } );

    else

      private.LoadMGState();

      private.Gbuttons = {};
      private.Rbuttons = {};

      for i = 1,3 do

        private.Gbuttons[i] = ng_global.progress["scr"]["win_safe_scr"].Gbuttons[i];
        private.Rbuttons[i] = ng_global.progress["scr"]["win_safe_scr"].Rbuttons[i];

      end;

      private.R_win = ng_global.progress["scr"]["win_safe_scr"].R_win;
      private.G_win = ng_global.progress["scr"]["win_safe_scr"].G_win;

    end;

  end;

  cmn.AddSubscriber( "win_safe_scr", win_safe_scr, private.room_objname );
----------------------------------------------------------------------------------------------
end;
--*********************************************************************************************************************
function public.Open () 

  common_impl.TutorialShow( "tutorial_page_6_scr" );

  if ( not cmn.IsEventDone( "win_safe_scr" ) ) then

    cmn.MiniGameShow( "safe_scr" );
    --common_impl.PassingMgStart( "safe_scr" );

    int_button_timer.Show();

  end;

  int_slider.InitSlider( private.room_objname );

  common_impl.PlayAudio( "env", "common/audio/aud_cellar_env", 1, "", 0.5 );

end;
--*********************************************************************************************************************
function public.PreOpen ()

  local is_repeat = false;

  if cmn.IsEventDone(  "win_safe_scr" ) and cmn.IsEventStart( "win_safe_scr" )  then
    
    ng_global.progress[ "scr" ][ "win_safe_scr" ].done = 0;
    ng_global.progress[ "scr" ][ "win_safe_scr" ].start = 0;
    is_repeat = true;

  end; 

  if ( not cmn.IsEventStart( "win_safe_scr" ) ) then

    ng_global.progress[ "scr" ][ "win_safe_scr" ].numb = 1;
    private.ResetInit();

    private.ng_var_Init();
    private.LoadMGState();

  end;

  interface.InvestigationButtonCheck();

  if is_repeat then
 
    public.ResetStart();

  end;

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.PreClose()

  if ( not cmn.IsEventDone( "win_safe_scr" ) ) then

    cmn.MiniGameHide();
    --common_impl.PassingMgStop( "safe_scr" );

  end;

  int_button_timer.Hide();

  common_impl.StopAudio( "env", "common/audio/aud_cellar_env", 1 );
  
end;
function private.GetDefaultState()

  local state = { 0, 0, 0 };

  return state;

end;
--*********************************************************************************************************************
function private.WinEnd()

  cmn.SetEventDone( "win_safe_scr" );
  cmn.CallEventHandler( "win_safe_scr" );
  
  rm_mysteryroom.WinTask();

  cmn.GotoRoom( "rm_mysteryroom" );

end;
--*********************************************************************************************************************
function private.Win(func_after)
  
  cmn.MiniGameHide();
  --common_impl.PassingMgWin( "safe_scr" );

  local func_end = function ()
    
    if ( func_after ) then
      
      func_after();

    end;

    common_impl.Lock(false);

    private.WinEnd(); 

  end;
  
  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_safe_win", 0, "", 0 );
  
  ObjSet( "spr_safe_scr_open", { visible = true } );
  ObjSet( "spr_safe_scr_chestpiece", { visible = true } );
  ObjAnimate( "spr_safe_scr_open_lock", "alp", 0, 0, "", { 0, 1, 0,  1, 1, 0,  1.3, 1, 1} );  
  ObjAnimate( "spr_safe_scr_open", "alp", 0, 0, func_end, { 0, 0, 0,    1.5, 0, 0,  2.0, 1, 1});
  ObjAnimate( "spr_safe_scr_chestpiece", "alp", 0, 0, "", { 0, 0, 0,    1.5, 0, 0,  2.0, 1, 1});

end;
--*********************************************************************************************************************
-- functions *** mg_safe_scr *** () end;
--*********************************************************************************************************************
function private.Circle_startdrag(circle_obj_name,drag_obj_name)

  local num = 2;

  if ( circle_obj_name == "spr_safe_scr_code_1" ) then 
    num = 1; 
  end;

  ObjSet("spr_safe_scr_add_code_"..num,{alp = 1});

  private.coords_begin = GetGameCursorPos();

  private.dragobj_coords = {ObjGet( drag_obj_name).pos_x,ObjGet( drag_obj_name).pos_y};

  ObjSet( drag_obj_name, { pos_x = private.coords_begin[1], pos_y = private.coords_begin[2] } );

  private.start_ang = ObjGet( circle_obj_name ).ang;

  private.atan = math.atan2( private.coords_begin[1] - private.dragobj_coords[1] ,private.coords_begin[2] - private.dragobj_coords[2] );

  private.num_seg = private.seg_number(private.start_ang);

end;
--------------------------------------------------------------------------------------------
function private.Circle_drag(circle_obj_name)
  
  common_impl.SetCursor(CURSOR_HAND);

  private.coords_end = GetGameCursorPos();

  private.coords_end[1] = private.coords_end[1] - ObjGet(circle_obj_name).pos_x;
  private.coords_end[2] = private.coords_end[2] - ObjGet(circle_obj_name).pos_y;

  private.circle_ang = math.atan2( private.coords_end[1],private.coords_end[2] ) - private.atan;

  local cur_ang = ObjGet( circle_obj_name ).ang;
  
  ObjSet( circle_obj_name, { ang = private.circle_ang + private.start_ang  } );

  local num_seg = private.seg_number(private.circle_ang + private.start_ang);
  
  if (  private.num_seg ~= num_seg ) then

    private.num_seg = num_seg;
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_safe_rotate", 0, "", 0 );
   
  end;

end;
--------------------------------------------------------------------------------------------
function private.Circle_dragdrop(circle_obj_name,drag_obj_name)
  
  common_impl.SetCursor(CURSOR_DEFAULT);

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_safe_release", 0, "", 0 );

  ObjSet( drag_obj_name,{ pos_x = private.dragobj_coords[1], pos_y = private.dragobj_coords[2] });

  local objname = circle_obj_name;
  local obj_ang = ObjGet(objname).ang 

  if ( obj_ang > 6.28 ) then obj_ang = obj_ang - 6.28 end;
  if ( obj_ang < 0 ) then obj_ang = obj_ang + 6.28 end;

  num_seg = private.seg_number(obj_ang);

  ObjSet(objname, {ang = num_seg*0.628});

  private.SavePos();

end;
--------------------------------------------------------------------------------------------
function private.SavePos()

  ng_global.progress["scr"]["win_safe_scr"].G_ang = ObjGet("spr_safe_scr_code_1").ang;
  ng_global.progress["scr"]["win_safe_scr"].R_ang = ObjGet("spr_safe_scr_code_2").ang;

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.Gbutton_clk(num)

  common_impl.Lock(true);

  func_after_dasapear = function ()

    func_after_apear  = function () 

      common_impl.Lock(false);

      if ( private.Check_button_win( "g" ) ) then
        
        local func_after_anim = function ()

          private.G_win = true;

          for i = 1 ,3 do

            ObjSet("spr_safe_scr_gbutton_"..i,{ input = false } );
 
          end;

          if ( private.CheckWin() ) then
            
            local func_after_win = function ()

              ng_global.progress["scr"]["win_safe_scr"].Gbuttons[num] = private.Gbuttons[num];
              ng_global.progress["scr"]["win_safe_scr"].G_win = private.G_win;

            end;

            private.Win(func_after_win);

          else

            ng_global.progress["scr"]["win_safe_scr"].Gbuttons[num] = private.Gbuttons[num];
            ng_global.progress["scr"]["win_safe_scr"].G_win = private.G_win;

          end;

        end;   
       
      private.Anim_lock( "g", func_after_anim )

      else

         ng_global.progress["scr"]["win_safe_scr"].Gbuttons[num] = private.Gbuttons[num];

      end;


    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_safe_click", 0, "", 0 );

    private.Gbuttons[num] = private.Gbuttons[num] + 1;

    if  private.Gbuttons[num] > 5 then

      private.Gbuttons[num] = 1;

    end;

    local path_res = "assets/levels/level1/mg_safe/layers/button_";
    
    if ng_global.progress[ "scr" ][ "win_safe_scr" ].numb == 2 then
      path_res = "assets/levels/levelscr/mg_safe_scr/layers/button_";
    elseif ng_global.progress[ "scr" ][ "win_safe_scr" ].numb == 3 then
      path_res = "assets/levels/levelscr/mg_safe_scr/layers/button_";
    end;

    ObjSet("spr_safe_scr_gbutton_"..num,{res = path_res..private.Gbuttons[num]});
    ObjAnimate("spr_safe_scr_gbutton_"..num, "alp", 0, 0, func_after_apear, {0, 3, 0.4, 0.05, 3, 1});

  end;

  ObjAnimate("spr_safe_scr_gbutton_"..num, "alp", 0, 0, func_after_dasapear, {0, 3, 1, 0.05, 3, 0.4});

end;
-----------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------
function private.Rbutton_clk(num)

  common_impl.Lock(true);

  func_after_dasapear = function ()

    func_after_apear  = function () 

      common_impl.Lock(false);

      if ( private.Check_button_win( "r" ) ) then
        
        local func_after_anim = function ()

          private.R_win = true;

          for i = 1 ,3 do

            ObjSet("spr_safe_scr_rbutton_"..i,{input = false});
 
          end;
          
          if ( private.CheckWin() ) then

              local func_after_win = function ()

                ng_global.progress["scr"]["win_safe_scr"].Rbuttons[num] = private.Rbuttons[num];
                ng_global.progress["scr"]["win_safe_scr"].R_win = private.R_win;

              end;

              private.Win(func_after_win);

          else

            ng_global.progress["scr"]["win_safe_scr"].Rbuttons[num] = private.Rbuttons[num];
            ng_global.progress["scr"]["win_safe_scr"].R_win = private.R_win;

          end;

        end;   
       
      private.Anim_lock( "r", func_after_anim )

      else

         ng_global.progress["scr"]["win_safe_scr"].Rbuttons[num] = private.Rbuttons[num];

      end;


    end;

    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_safe_click", 0, "", 0 );

    private.Rbuttons[num] = private.Rbuttons[num] + 1;

    if  private.Rbuttons[num] > 10

    then 

      private.Rbuttons[num] = 1;

    end;

    ObjSet("txt_safe_scr_r"..num,{text = tostring(private.nums[private.Rbuttons[num]])});
    ObjAnimate("spr_safe_scr_rbutton_"..num, "alp", 0, 0, func_after_apear, {0, 3, 0.4, 0.05, 3, 1});

  end;

  ObjAnimate("spr_safe_scr_rbutton_"..num, "alp", 0, 0, func_after_dasapear, {0, 3, 1, 0.05, 3, 0.4});

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.Check_button_win(color)

  local win_mas = private.Gwin_mas;
  local cur_mas = private.Gbuttons;

  if ( color == "r" ) then

    win_mas = private.Rwin_mas;
    cur_mas = private.Rbuttons;
 
  end;

  for i = 1, #win_mas do

    if ( win_mas[i] ~= cur_mas[i] ) then

      return false; 

    end;

  end;

  return true;

end;
--------------------------------------------------------------------------------------------
function private.Anim_lock( color, func_after )

  local func_end = function ()

    common_impl.Lock( false );

    if ( func_after ) then

      func_after();

    end;

  end;

  common_impl.Lock(true);

  common_impl.PlayAudio( "sfx", "common/audio/aud_mg_safe_true", 0, "", 0 );

  --Colors = g and r-------------
  ObjAnimate("spr_safe_scr_"..color.."lock_1", "pos_xy", 0, 1, "", {0, 3, 0,0,   0.5, 3, 0,0, 0.8, 3, -1,68});
  ObjAnimate("spr_safe_scr_"..color.."lock_2", "pos_xy", 0, 1, func_end, {0, 3, 0,0,   0.5, 3, 0,0, 0.8, 3, -1,68});

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.CheckWin()

  if ( private.R_win and private.G_win ) then

    return true;
    
  else 

    return false;
    
  end;

  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.Reset()

  private.ng_var_Init();
  private.LoadMGState();

end;
--*********************************************************************************************************************
function private.ResetInit()

  local numb = math.random( 1, 3 );
  ng_global.progress[ "scr" ][ "win_safe_scr" ].numb = numb;

end;
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.ResetStart()

  ObjMultiSet( {
    { "obj_safe_scr_mmg_parts", { input = true } },
    { "spr_safe_scr_open", { input = false, visible = false } },
    { "spr_safe_scr_chestpiece" , { input = false, visible = false } },
  } );

  public.Reset();

end;
--------------------------------------------------------------------------------------------
function public.Skip()

end;
--------------------------------------------------------------------------------------------
function private.ng_var_Init()

    private.Gbuttons = {};
    private.Rbuttons = {};
    private.R_win = false;
    private.G_win = false;

    private.Gwin_mas = {};
    private.Rwin_mas = {};
    
    if ng_global.progress[ "scr" ][ "win_safe_scr" ].numb == 1 then

      private.Gbuttons = { 3, 1,  4 };
      private.Rbuttons = { 8, 9, 10 };

      private.Gwin_mas = { 5, 2, 2  };
      private.Rwin_mas = { 1, 4, 10 };

    elseif ng_global.progress[ "scr" ][ "win_safe_scr" ].numb == 2 then

      private.Gbuttons = { 2, 5, 3 };
      private.Rbuttons = { 6, 7, 8 };

      private.Gwin_mas = { 5, 3, 1 };
      private.Rwin_mas = { 3, 1, 6 };

    elseif ng_global.progress[ "scr" ][ "win_safe_scr" ].numb == 3 then

      private.Gbuttons = { 1, 3, 2  };
      private.Rbuttons = { 2, 7, 10 };

      private.Gwin_mas = { 4, 2, 5 };
      private.Rwin_mas = { 1, 9, 6 };

    end;

    ng_global.progress["scr"]["win_safe_scr"].Gbuttons = private.Gbuttons;
    ng_global.progress["scr"]["win_safe_scr"].Rbuttons = private.Rbuttons;
    ng_global.progress["scr"]["win_safe_scr"].G_win = private.G_win;
    ng_global.progress["scr"]["win_safe_scr"].R_win = private.R_win;
    ng_global.progress["scr"]["win_safe_scr"].G_ang = 4.396;
    ng_global.progress["scr"]["win_safe_scr"].R_ang = 3.768;
    
    ng_global.progress[ "scr" ][ "win_safe_scr" ].timer = { default = 50, time = 50, diff = 20, extra = 0 };

end;
--------------------------------------------------------------------------------------------
function private.LoadMGState()

  local infix = "";
  local path_res = "assets/levels/level1/mg_safe/layers/";
  local numb = ng_global.progress[ "scr" ][ "win_safe_scr" ].numb;

  if numb == 2 then
    infix = "_2";
    path_res = "assets/levels/levelscr/mg_safe_scr/layers/";
  elseif numb == 3 then
    infix = "_3";
    path_res = "assets/levels/levelscr/mg_safe_scr/layers/";
  end;

  local table_multiset = {};

  for i = 1,3 do

    table.insert( table_multiset, { "txt_safe_scr_r"..i,{text = tostring(private.nums[ng_global.progress["scr"]["win_safe_scr"].Rbuttons[i]])}} );
    table.insert( table_multiset, { "spr_safe_scr_gbutton_"..i,{res = path_res.."button_"..ng_global.progress["scr"]["win_safe_scr"].Gbuttons[i]}} );

  end;

  table.insert( table_multiset, { "spr_safe_scr"..infix.."_code_1", {ang = ng_global.progress["scr"]["win_safe_scr"].G_ang }} );
  table.insert( table_multiset, { "spr_safe_scr_code_2", {ang = ng_global.progress["scr"]["win_safe_scr"].R_ang }} );

  if ( ng_global.progress["scr"]["win_safe_scr"].G_win ) then

    for i =1 ,3 do
      table.insert( table_multiset, { "spr_safe_scr_gbutton_"..i,{input = false } } );
    end;

    table.insert( table_multiset, { "spr_safe_scr_glock_1", {pos_x = 319, pos_y = 178 }} );
    table.insert( table_multiset, { "spr_safe_scr_glock_2", {pos_x = 518, pos_y = 179 }} );

  else 

    for i =1 ,3 do
      table.insert( table_multiset, { "spr_safe_scr_gbutton_"..i,{input = true} } ); 
    end;

    table.insert( table_multiset, { "spr_safe_scr_glock_1", {pos_x = 320, pos_y = 110 }} );
    table.insert( table_multiset, { "spr_safe_scr_glock_2", {pos_x = 519, pos_y = 111 }} );

  end;

  if ( ng_global.progress["scr"]["win_safe_scr"].R_win ) then 

    for i =1 ,3 do
      table.insert( table_multiset, { "spr_safe_scr_rbutton_"..i,{input = false} } );  
    end;

    table.insert( table_multiset,  { "spr_safe_scr_rlock_1", { pos_x = 469, pos_y = 601 } } );
    table.insert( table_multiset,  { "spr_safe_scr_rlock_2", { pos_x = 666, pos_y = 601 } } );

  else
    
    for i =1 ,3 do

      table.insert( table_multiset, { "spr_safe_scr_rbutton_"..i,{input = true} } );
 
    end;

    table.insert( table_multiset,  { "spr_safe_scr_rlock_1", { pos_x = 470, pos_y = 533 } } );
    table.insert( table_multiset,  { "spr_safe_scr_rlock_2", { pos_x = 667, pos_y = 533 } } );

  end;

  ObjMultiSet(table_multiset);

  if numb == 1 then

    ObjMultiSet({
      { "spr_safe_scr_pic_2", { alp = 0 } },
      { "spr_safe_scr_pic_3", { alp = 0 } },
      { "spr_safe_scr_g_over_2", { alp = 0 } },
      { "spr_safe_scr_r_over_2", { alp = 0 } },
      { "spr_safe_scr_g_over_3", { alp = 0 } },
      { "spr_safe_scr_r_over_3", { alp = 0 } },
      { "spr_safe_scr_code_1",   { alp = 1, visible = true } },
      { "spr_safe_scr_2_code_1", { alp = 0, visible = false } },
      { "spr_safe_scr_code_1_drag", { event_drag = function() private.Circle_drag("spr_safe_scr_code_1"); end }},
      { "spr_safe_scr_code_1_drag", { event_startdrag = function() private.Circle_startdrag("spr_safe_scr_code_1","spr_safe_scr_code_1_drag"); end  }},
      { "spr_safe_scr_code_1_drag", { event_dragdrop = function() private.Circle_dragdrop("spr_safe_scr_code_1","spr_safe_scr_code_1_drag"); end }},
      { "spr_safe_scr_code_2_drag", { event_drag = function() private.Circle_drag("spr_safe_scr_code_2"); end }},
      { "spr_safe_scr_code_2_drag", { event_startdrag = function() private.Circle_startdrag("spr_safe_scr_code_2","spr_safe_scr_code_2_drag"); end }},
      { "spr_safe_scr_code_2_drag", { event_dragdrop = function() private.Circle_dragdrop("spr_safe_scr_code_2","spr_safe_scr_code_2_drag"); end }},
      { "spr_safe_scr_code_1_drag", { event_menter = function() private.CircleMenter(1); end }},
      { "spr_safe_scr_code_1_drag", { event_mleave = function() private.CircleLeave(1); end }},
      { "spr_safe_scr_code_2_drag", { event_menter = function() private.CircleMenter(2); end }},
      { "spr_safe_scr_code_2_drag", { event_mleave = function() private.CircleLeave(2); end }},
    });
      
  elseif numb == 2 then

    ObjMultiSet({
      { "spr_safe_scr_pic_2", { alp = 1 } },
      { "spr_safe_scr_pic_3", { alp = 0 } },
      { "spr_safe_scr_g_over_2", { alp = 1 } },
      { "spr_safe_scr_r_over_2", { alp = 1 } },
      { "spr_safe_scr_g_over_3", { alp = 0 } },
      { "spr_safe_scr_r_over_3", { alp = 0 } },
      { "spr_safe_scr_code_1",   { alp = 0, visible = false } },
      { "spr_safe_scr_2_code_1", { alp = 1, visible = true } },
      { "spr_safe_scr_code_1_drag", { event_drag = function() private.Circle_drag("spr_safe_scr_2_code_1"); end }},
      { "spr_safe_scr_code_1_drag", { event_startdrag = function() private.Circle_startdrag("spr_safe_scr_2_code_1","spr_safe_scr_code_1_drag"); end  }},
      { "spr_safe_scr_code_1_drag", { event_dragdrop = function() private.Circle_dragdrop("spr_safe_scr_2_code_1","spr_safe_scr_code_1_drag"); end }},
      { "spr_safe_scr_code_2_drag", { event_drag = function() private.Circle_drag("spr_safe_scr_code_2"); end }},
      { "spr_safe_scr_code_2_drag", { event_startdrag = function() private.Circle_startdrag("spr_safe_scr_code_2","spr_safe_scr_code_2_drag"); end }},
      { "spr_safe_scr_code_2_drag", { event_dragdrop = function() private.Circle_dragdrop("spr_safe_scr_code_2","spr_safe_scr_code_2_drag"); end }},
      { "spr_safe_scr_code_1_drag", { event_menter = function() private.CircleMenter(1); end }},
      { "spr_safe_scr_code_1_drag", { event_mleave = function() private.CircleLeave(1); end }},
      { "spr_safe_scr_code_2_drag", { event_menter = function() private.CircleMenter(2); end }},
      { "spr_safe_scr_code_2_drag", { event_mleave = function() private.CircleLeave(2); end }},
    });

  elseif numb == 3 then

    ObjMultiSet({
      { "spr_safe_scr_pic_2", { alp = 0 } },
      { "spr_safe_scr_pic_3", { alp = 1 } },
      { "spr_safe_scr_g_over_2", { alp = 0 } },
      { "spr_safe_scr_r_over_2", { alp = 0 } },
      { "spr_safe_scr_g_over_3", { alp = 1 } },
      { "spr_safe_scr_r_over_3", { alp = 1 } },
      { "spr_safe_scr_code_1",   { alp = 0, visible = false } },
      { "spr_safe_scr_2_code_1", { alp = 1, visible = true } },
      { "spr_safe_scr_code_1_drag", { event_drag = function() private.Circle_drag("spr_safe_scr_2_code_1"); end }},
      { "spr_safe_scr_code_1_drag", { event_startdrag = function() private.Circle_startdrag("spr_safe_scr_2_code_1","spr_safe_scr_code_1_drag"); end  }},
      { "spr_safe_scr_code_1_drag", { event_dragdrop = function() private.Circle_dragdrop("spr_safe_scr_2_code_1","spr_safe_scr_code_1_drag"); end }},
      { "spr_safe_scr_code_2_drag", { event_drag = function() private.Circle_drag("spr_safe_scr_code_2"); end }},
      { "spr_safe_scr_code_2_drag", { event_startdrag = function() private.Circle_startdrag("spr_safe_scr_code_2","spr_safe_scr_code_2_drag"); end }},
      { "spr_safe_scr_code_2_drag", { event_dragdrop = function() private.Circle_dragdrop("spr_safe_scr_code_2","spr_safe_scr_code_2_drag"); end }},
      { "spr_safe_scr_code_1_drag", { event_menter = function() private.CircleMenter(1); end }},
      { "spr_safe_scr_code_1_drag", { event_mleave = function() private.CircleLeave(1); end }},
      { "spr_safe_scr_code_2_drag", { event_menter = function() private.CircleMenter(2); end }},
      { "spr_safe_scr_code_2_drag", { event_mleave = function() private.CircleLeave(2); end }},
    });

  end;

end;
--------------------------------------------------------------------------------------------
function private.CircleMenter(num)
  common_impl.SetCursor(CURSOR_HAND);
  local name = "spr_safe_scr_add_code_"..num;
  local number = ng_global.progress[ "scr" ][ "win_safe_scr" ].numb;
  if num == 1 and number ~= 1 then
    name = "spr_safe_scr_2_add_code_"..num;
  end;
  ObjSet( name,{alp = 1});
end;
--------------------------------------------------------------------------------------------
function private.CircleLeave(num)

  common_impl.SetCursor(CURSOR_DEFAULT);
  local name = "spr_safe_scr_add_code_"..num;
  local number = ng_global.progress[ "scr" ][ "win_safe_scr" ].numb;
  if num == 1 and number ~= 1 then
    name = "spr_safe_scr_2_add_code_"..num;
  end;
  ObjSet(name,{alp = 0});

end;
--------------------------------------------------------------------------------------------
function private.ButtonMenter(color,num)

  common_impl.SetCursor(CURSOR_HAND);
  ObjSet( "spr_safe_scr_add_"..color.."button",{alp = 1});
  ObjAttach( "spr_safe_scr_add_"..color.."button","spr_safe_scr_"..color.."button_"..num);

end;
--------------------------------------------------------------------------------------------
function private.ButtonLeave(color)

  common_impl.SetCursor(CURSOR_DEFAULT);
  ObjSet( "spr_safe_scr_add_"..color.."button",{alp = 0});

end;
--------------------------------------------------------------------------------------------
function private.seg_number(ang)

  local num_seg = math.floor (ang/0.628);
  local rest = math.fmod (ang, 0.628);
  if ( rest > 0.314 ) then num_seg = num_seg + 1 end;
  return num_seg;

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------