-- name=mg_uppershelf_scr

--*********************************************************************************************************************
function public.Init()

  private.room_objname = "mg_uppershelf_scr";
  private.win_pos_mas = {};
  private.circles_ang_1 = { { -0,   1,2,3,4 },  { -5, 4 } };
  private.circles_ang_2 = { { -0,1, 1,2,3,4 }, { -0.82, 2,3 }, { -4.7, 1  },  { -5.5, 1,2 } };
  private.circles_ang_3 = { { -0,1, 1,2,3,4 }, { -0.8 , 2,3 }, { -1.59, 3 },  { -4.7, 1 }, { -5.5, 1,2 } };

  private.circles_ang_2_1 = { { -0, 1,2,3,4 }, { -0.6, 4 }, { -2.45, 2 } };
  private.circles_ang_2_2 = { { -0,1, 1,2,3,4 }, { -0.8, 3 }, { -1.35, 4 }, { -2.44, 2 }, { -5.48, 2   } };
  private.circles_ang_2_3 = { { -0,1, 1,2,3,4 }, { -0.8, 3 }, { -4.08, 2 }, { -4.6, 4  }, { -5.48, 2,3 } };

  private.circles_ang_3_1 = { { -0, 1,2,3,4 },   { -1.46, 3 },  { -1.65, 1 }, { -2.86, 4 }, { -3.73, 1,4 }, { -5.43, 1,2 } };
  private.circles_ang_3_2 = { { -0,1, 1,2,3,4 }, { -0.68, 3 },  { -1.43, 4 }, { -3.06, 1 }, { -3.73, 4   }, { -4.6, 2    } };
  private.circles_ang_3_3 = { { -0,1, 1,2,3,4 }, { -1.36, 4 },  { -1.65, 1 }, { -2.54, 2 } };

--*********************************************************************************************************************
  local win_uppershelf_scr = function ()

    if ( cmn.IsEventDone( "win_uppershelf_scr" ) ) then  

      --ObjDetach( "obj_uppershelf_scr_mg" );

    else

      local numb = ng_global.progress[ "scr" ][ "win_uppershelf_scr" ].numb;

      local infix = "";
      if numb == 2 then 
        infix = "_2";
      elseif numb == 3 then
        infix = "_3";
      end;

      for i = 1, 3 do

        local mas_name = "circles_ang"..infix.."_"..i;
        ObjSet( "spr_uppershelf_scr"..infix.."_circle_"..i, { ang = private[mas_name][ng_global.progress["scr"]["win_uppershelf_scr"].stage[i]][1] } );

      end;

      for i = 1, 4 do 

        local flag = 0;

        for j = 1, 3 do

          local mas_name = "circles_ang"..infix.."_"..j
          for k = 2, #private[mas_name][ng_global.progress["scr"]["win_uppershelf_scr"].stage[j]] do

            if private[mas_name][ng_global.progress["scr"]["win_uppershelf_scr"].stage[j]][k] == i then

              flag = flag + 1;
              break;

            end;

          end;
        
        end;

        if flag == 3 then 

          ObjSet( "spr_uppershelf_scr"..infix.."_pin_"..i, { alp = 1 } );

        end;

      end;

    end;

  end;
  cmn.AddSubscriber( "win_uppershelf_scr", win_uppershelf_scr, private.room_objname );
--*********************************************************************************************************************
end;
--*********************************************************************************************************************
function public.Open() 

  common_impl.TutorialShow( "tutorial_page_6_scr" );

  common_impl.PlayAudio( "env", "common/audio/aud_pier_env", 1, "", 0.5 );

  if not cmn.IsEventDone( "win_uppershelf_scr" ) then

    cmn.MiniGameShow();
    --common_impl.PassingMgStart();

    int_button_timer.Show();

  end;

  int_slider.InitSlider( private.room_objname );

end;
--*********************************************************************************************************************
function public.PreOpen()

  local is_repeat = false;

  if cmn.IsEventDone(  "win_uppershelf_scr" ) and cmn.IsEventStart( "win_uppershelf_scr" )  then
    
    ng_global.progress[ "scr" ][ "win_uppershelf_scr" ].done = 0;
    ng_global.progress[ "scr" ][ "win_uppershelf_scr" ].start = 0;
    is_repeat = true;

  end; 

  ObjAnimate( "spr_uppershelf_scr_light", "alp", 1, 0, "", {0,0,0, 2,0,1, 4,3,0 });

 if not cmn.IsEventStart( "win_uppershelf_scr" ) then

    ng_global.progress[ "scr" ][ "win_uppershelf_scr" ].stage = { 1, 2, 3 };
    ng_global.progress[ "scr" ][ "win_uppershelf_scr" ].progres = { 1, 0, 1, 1 };
    ng_global.progress[ "scr" ][ "win_uppershelf_scr" ].timer = { default = 21, time = 21, diff = 20, extra = 0 };
    ng_global.progress[ "scr" ][ "win_uppershelf_scr" ].numb = 1;

    private.ResetInit();

  end;

  interface.InvestigationButtonCheck();

  if ng_global.progress[ "scr" ][ "win_uppershelf_scr" ].numb == 1 then

    ObjMultiSet( {
      { "obj_uppershelf_scr_mg",     { alp = 1, input = true,  visible = true  } },
      { "obj_uppershelf_scr_mg_2",   { alp = 0, input = false, visible = false } },
      { "obj_uppershelf_scr_mg_3",   { alp = 0, input = false, visible = false } }
    } );

  elseif ng_global.progress[ "scr" ][ "win_uppershelf_scr" ].numb == 2 then

    ObjMultiSet( {
      { "obj_uppershelf_scr_mg",     { alp = 0, input = false, visible = false  } },
      { "obj_uppershelf_scr_mg_2",   { alp = 1, input = true,  visible = true } },
      { "obj_uppershelf_scr_mg_3",   { alp = 0, input = false, visible = false } }
    } );

  elseif ng_global.progress[ "scr" ][ "win_uppershelf_scr" ].numb == 3 then

    ObjMultiSet( {
      { "obj_uppershelf_scr_mg",     { alp = 0, input = false, visible = false } },
      { "obj_uppershelf_scr_mg_2",   { alp = 0, input = false, visible = false } },
      { "obj_uppershelf_scr_mg_3",   { alp = 1, input = true,  visible = true  } }
    } );

  end;

  if is_repeat then
 
    public.ResetStart();

  end;

end;
--*********************************************************************************************************************
function public.Close()

  common_impl.StopAudio( "env", "common/audio/aud_pier_env", 1 );

end;
--*********************************************************************************************************************
function public.PreClose()

  if not cmn.IsEventDone( "win_uppershelf_scr" ) then

    cmn.MiniGameHide();
    --common_impl.PassingMgStop();

  end;

  int_button_timer.Hide();

end;
--*********************************************************************************************************************
function private.ResetInit()

  local numb = math.random( 1, 3 );
  ng_global.progress[ "scr" ][ "win_uppershelf_scr" ].numb = numb;
  
--  if numb == 1 then
--
--    private.circles_ang_1 = { { -0,   1,2,3,4},  { -5, 4 } };
--    private.circles_ang_2 = { { -0,1, 1,2,3,4 }, { -0.82, 2,3 }, { -4.7, 1 },  { -5.5, 1,2 } };
--    private.circles_ang_3 = { { -0,1, 1,2,3,4 }, { -0.8 , 2,3 }, { -1.59, 3 },  { -4.7, 1 }, { -5.5, 1,2 } };    
--
--  elseif numb == 2 then
--
--    private.circles_ang_1 = private.circles_ang_2_1;
--    private.circles_ang_2 = private.circles_ang_2_2;
--    private.circles_ang_3 = private.circles_ang_2_3;
--
--  elseif numb == 3 then
--
--    private.circles_ang_1 = private.circles_ang_3_1;
--    private.circles_ang_2 = private.circles_ang_3_2;
--    private.circles_ang_3 = private.circles_ang_3_3;
--
--  end;

end;
--*********************************************************************************************************************
function public.ResetStart()

  ObjAttach( "obj_uppershelf_scr_mg", private.room_objname );
  ObjSet( "obj_uppershelf_scr_mg", { alp = 1 } );
  public.Reset();
  
end;
--*********************************************************************************************************************
function private.GetDefaultState()

  local state = { 0, 0, 0 };

  return state;

end;
--*********************************************************************************************************************
function private.WinEnd()

  cmn.MiniGameHide();
  cmn.SetEventDone( "win_uppershelf_scr" );
  cmn.CallEventHandler( "win_uppershelf_scr" );
  --common_impl.PassingMgWin();
  
  rm_mysteryroom.WinTask();

  cmn.GotoRoom( "rm_mysteryroom" );

end;
--*********************************************************************************************************************
function public.Rotate( number )

  local numb = ng_global.progress[ "scr" ][ "win_uppershelf_scr" ].numb;

  local infix = "";
  if numb == 2 then 
    infix = "_2";
  elseif numb == 3 then
    infix = "_3";
  end;

  number = tonumber( number );

  local mas_name = "circles_ang"..infix.."_"..number;

  common_impl.Lock(true);

  local func_after = function ()

    common_impl.Lock(false);
    if private[mas_name][ng_global.progress["scr"]["win_uppershelf_scr"].stage[number] + 1] then

      ng_global.progress["scr"]["win_uppershelf_scr"].stage[number] = ng_global.progress["scr"]["win_uppershelf_scr"].stage[number]+1;

    else

      ng_global.progress["scr"]["win_uppershelf_scr"].stage[number] = 1;
      ObjSet( "spr_uppershelf_scr"..infix.."_circle_"..number, { ang = private[mas_name][ng_global.progress["scr"]["win_uppershelf_scr"].stage[number]][1] } );

    end;

    public.RotateEnd()

  end;
  local start_ang = private[mas_name][ng_global.progress["scr"]["win_uppershelf_scr"].stage[number]][1];
  local end_ang = 0;

  for i = 1,4 do

    if ObjGet( "spr_uppershelf_scr"..infix.."_pin_"..i ).alp ~= 0 then

       ObjAnimate( "spr_uppershelf_scr"..infix.."_pin_"..i, "alp", 0, 0, "", {0, 0, 1, 0.3, 3, 0 });
       common_impl.PlayAudio( "sfx", "common/audio/aud_mg_uppershelf_hide_pintle", 0, "", 0 );

    end;

  end;

  if private[mas_name][ng_global.progress["scr"]["win_uppershelf_scr"].stage[number] + 1] then

    end_ang = private[mas_name][ng_global.progress["scr"]["win_uppershelf_scr"].stage[number] + 1 ][1];

    ObjAnimate( "spr_uppershelf_scr"..infix.."_circle_"..number, "ang", 0, 0, func_after,
    { 
      0.0, 0, start_ang,
      0.3, 0, start_ang,
      1.0, 2, end_ang
    } ); 

--
  else 
    
    end_ang = private[mas_name][1][1] - 6.28;

    ObjAnimate( "spr_uppershelf_scr"..infix.."_circle_"..number, "ang", 0, 0, func_after,
    { 
      0.0, 0, start_ang,
      0.3, 0, start_ang,
      1.0, 2, end_ang
    } ); 

  end;

    if ( number == 2 and ng_global.progress["scr"]["win_uppershelf_scr"].stage[number] == 2 ) or
      ( number == 3 and ng_global.progress["scr"]["win_uppershelf_scr"].stage[number] == 3 ) then

      ObjSet( "tmr_uppershelf_scr_playaudio_turn", { playing = true, time = 0.3, endtrig = "*common_impl.PlayAudio( 'sfx', 'common/audio/aud_mg_uppershelf_rotate_slow', 0, '' );" } );

    else

      ObjSet( "tmr_uppershelf_scr_playaudio_turn", { playing = true, time = 0.3, endtrig = "*common_impl.PlayAudio( 'sfx', 'common/audio/aud_mg_uppershelf_rotate_fast', 0, '' );" } );

    end;


end;
--*********************************************************************************************************************
function public.RotateEnd()

  local numb = ng_global.progress[ "scr" ][ "win_uppershelf_scr" ].numb;

  local infix = "";
  if numb == 2 then 
    infix = "_2";
  elseif numb == 3 then
    infix = "_3";
  end;
  --local anim_flag

  for i = 1,4 do 

    local flag = 0;

    for j = 1, 3 do

      local mas_name = "circles_ang"..infix.."_"..j
      for k = 2,#private[mas_name][ng_global.progress["scr"]["win_uppershelf_scr"].stage[j]] do
        if private[mas_name][ng_global.progress["scr"]["win_uppershelf_scr"].stage[j]][k] == i then

          flag = flag + 1;
          break;

        end;

      end;
    
    end;


        --end;

    if flag == 3 then 

     local func_after =  function ()     
          common_impl.Lock( false );
          
          if ObjGet( "spr_uppershelf_scr"..infix.."_pin_1" ).alp == 1
          and ObjGet( "spr_uppershelf_scr"..infix.."_pin_2" ).alp == 1
          and ObjGet( "spr_uppershelf_scr"..infix.."_pin_3" ).alp == 1
          and ObjGet( "spr_uppershelf_scr"..infix.."_pin_4" ).alp == 1
          and ng_global.progress["scr"]["win_uppershelf_scr"].progres[2] == 0 then

            ObjMultiSet( {
              { "obj_uppershelf_scr_mg",   { input = false} },
              { "obj_uppershelf_scr_mg_2", { input = false} },
              { "obj_uppershelf_scr_mg_3", { input = false} },
            } );

            common_impl.Lock( true );
            public.Check();
            common_impl.PlayAudio( "sfx", "common/audio/aud_mg_uppershelf_true", 0, "", 0 );  

          end;

       end;
     common_impl.Lock( true );
     ObjAnimate( "spr_uppershelf_scr"..infix.."_pin_"..i, "alp", 0, 0, func_after, {0, 0, 0, 0.4, 0, 1 });
     common_impl.PlayAudio( "sfx", "common/audio/aud_mg_uppershelf_show_pintle", 0, "", 0.2 );

    end;

  end;

end;
--*********************************************************************************************************************
function public.Check()

  common_impl.Lock( false );

  for i = 2,2 do

    if ng_global.progress["scr"]["win_uppershelf_scr"].progres[i] == 0 then

       ng_global.progress["scr"]["win_uppershelf_scr"].progres[i] = 1;

    end;

  end;

  local right = 0;

  for i = 1,4 do

    if ng_global.progress["scr"]["win_uppershelf_scr"].progres[i] == 1 then

      right = right + 1;      

    end;

  end;

  if right == 4 then

    local func_after = function ()

      common_impl.Lock( false );
      PlaySfx( "assets/levels/common/audio/aud_mg_win", 0, 0 );
      private.WinEnd();

    end;

    common_impl.Lock( true );
    ObjAnimate( "obj_uppershelf_scr_mg", "alp", 0, 0, func_after, { 0, 0, 1, 0.4, 0, 1 });
    common_impl.PlayAudio( "sfx", "common/audio/aud_mg_uppershelf_win", 0, "", 0.2 );   

  end;

end;
--*********************************************************************************************************************
function public.Skip()

--

end;
--*********************************************************************************************************************
function public.Reset()

  ng_global.progress["scr"]["win_uppershelf_scr"].stage = { 1, 2, 3 };
  ng_global.progress["scr"]["win_uppershelf_scr"].progres = { 1,0,1,1 };

  for i = 1,4 do 

    ObjMultiSet({
      { "spr_uppershelf_scr_pin_"..i,   { alp = 0 } },
      { "spr_uppershelf_scr_2_pin_"..i, { alp = 0 } },
      { "spr_uppershelf_scr_3_pin_"..i, { alp = 0 } }
    });

  end;

  for i = 1, 3 do

    local mas_name = "circles_ang_"..i;
    ObjSet( "spr_uppershelf_scr_circle_"..i, { ang = private[mas_name][ng_global.progress["scr"]["win_uppershelf_scr"].stage[i]][1] } );

    mas_name = "circles_ang_2_"..i;
    ObjSet( "spr_uppershelf_scr_circle_2_"..i, { ang = private[mas_name][ng_global.progress["scr"]["win_uppershelf_scr"].stage[i]][1] } );

    mas_name = "circles_ang_3_"..i;
    ObjSet( "spr_uppershelf_scr_circle_3_"..i, { ang = private[mas_name][ng_global.progress["scr"]["win_uppershelf_scr"].stage[i]][1] } );

  end;

end;
--*********************************************************************************************************************