-- name=rm_achievements
--******************************************************************************************
function public.Init()

  private.updated = {};
  private.COUNT_LIST = 20;

  local table_multiset = {};
  for i = 1, private.COUNT_LIST do

    table.insert( table_multiset, {"spr_achievements_owl"..i, 
       {
         event_menter = function() private.PopupShow( i ); end ,
         event_mleave = function() private.PopupHide() end
       } 
    } );

  end;  

  table.insert( table_multiset, { "obj_achievements_btn_close", { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_DOWN, "anm_achievements_btn_close_focus" ) end, 
      event_mleave = function() private.BtnMouseLeave( "anm_achievements_btn_close_focus" ) end; } } );

  table.insert( table_multiset, { "obj_achievements_btn_exit", { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_HAND, "spr_achievements_btn_exit_focus" ) end, 
      event_mleave = function() private.BtnMouseLeave( "spr_achievements_btn_exit_focus" ) end; } } );

  
  ObjMultiSet( table_multiset );
  
  private.StartAnims();
  
end;
--******************************************************************************************
function public.PreOpen()
   
  local current_room = common.GetCurrentRoom();
  if ( current_room ) then

    common_impl.Lock( false );--разблокировка для карты EE

  end;
  private.Update();

  common_impl.StopAllMus();

  common_impl.EnvPlay( { "common/audio/aud_achievements_env" }, "", 0.5 );

end;
--******************************************************************************************
function public.Close()

  common_impl.StopAudio(  "env", "common/audio/aud_achievements_env", 1 );

  ObjSet( "tmr_common_anm", { active = true } );

  local current_room = common.GetCurrentRoom();

  if ( current_room ) then

    common_impl.ExitBonusRm();

  else

    common_impl.PlayAudio(  "mus", "common/audio/aud_mt8_maintheme_mus", 1 );  
    
  end;

end;
--******************************************************************************************
function private.Update ()

  for i = 1, private.COUNT_LIST do

    local event = common_impl.GetNameAchiev( i );

    if ( not private.updated[ event ] ) then

      if ( ng_global.achievements[ event ].done == 1 ) then

        ObjSet( "spr_achievements_owl"..i, { alp = 1 } );
        ObjSet( "spr_achievements_owl"..i.."_fantom", { alp = 0 } );
        private.updated[ event ] = true;

      end;

    end;

  end;

end;
--******************************************************************************************
function private.BtnMouseEnter( type_cursor, obj )
      
  if ( type_cursor ) then
    SetCursor( type_cursor );
  else
    SetCursor( CURSOR_DEFAULT );
  end;
    
  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,              0, alp, 
    time*( 1 - alp ), 0, 1
  } );

end;
--******************************************************************************************
function private.BtnMouseLeave( obj )
    
  SetCursor( CURSOR_DEFAULT );

  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,        0, alp,
    time * alp, 0,   0 
  });

end;
--******************************************************************************************
function private.BtnCloseMouseDown( )

  local current_room = common.GetCurrentRoom();
  if ( not current_room ) then

    current_room = "rm_extra";

  end;  

  common.GotoRoom( current_room );

end;
--******************************************************************************************
--function --**POPUP**-- () end;
--******************************************************************************************

function private.PopupShow( number )

  SetCursor( CURSOR_LOUPE );

  local title = "pop_achievements_owl_"..number;
  local description = "str_achievements_description_"..common_impl.GetNameAchiev( number );
  
  local position = { 0, 0 };
  local obj_pos = ObjGet( "spr_achievements_owl"..number );
  
  position[ 1 ] = obj_pos.pos_x;
  position[ 2 ] = obj_pos.pos_y;

  private.WindowShow( title, description, position );  

end;
--------------------------------------------------------------------------------------------
function private.PopupHide() 

  private.WindowHide();  
  SetCursor( CURSOR_DEFAULT );

end;

--******************************************************************************************
--function --**ANIMATIONS**-- () end;
--******************************************************************************************
function private.StartAnims ()

  ObjAnimate( "spr_achievements_fog", "alp", 1, 0, "",
  { 
    0.0, 0, 1.0, 
    1.8, 0, 0.5,
    2.9, 0, 0.9,
    4.0, 3, 0.45, 
    5.7, 2, 1.0
  } );

  ObjAnimate( "spr_achievements_light", "alp", 1, 0, "",
  { 
    0.0,  0, 1.0, 
    2.5,  0, 0.6,
    4.8,  0, 0.93,
    7.0,  3, 0.5, 
    9.0,  2, 1.0
  } );

end;
--******************************************************************************************
--function --**Dialog**-- () end;
--******************************************************************************************
function private.WindowShow( dialog_text_title, dialog_text, position )

  --local game_cursor = GetGameCursorPos();
  --local dialog_pos_x = position[ 1 ];
  --local dialog_pos_y = position[ 2 ];
    
  ObjSet( "txt_achievements_window_title", { text = dialog_text_title } );
  ObjSet( "txt_achievements_window", { text = dialog_text } );

  private.GRID_CORNER_W =  58;
  private.GRID_CORNER_H =  58;
  private.GRID_MID_W    =   4;
  private.GRID_MID_H    =   4;

  private.GRID_BORDER_W = 100;
  private.GRID_BORDER_H = 100;

  private.MIN_W = 370;
  private.MAX_W = 500;
  private.MIN_H = 150;
  private.MAX_H = 500;

  private.WindowShow_ANIM_TIME = 0.3;

  local off_x = private.GRID_BORDER_W;
  local off_y = private.GRID_BORDER_H;

  local dialog_w = ObjGet( "txt_achievements_window" ).draw_width + off_x;

  if ( dialog_w < private.MIN_W ) then

    dialog_w = private.MIN_W;

  elseif ( dialog_w > private.MAX_W ) then

    dialog_w = private.MAX_W;

  end;

  local dialog_h = ObjGet( "txt_achievements_window" ).draw_height + off_y;

  if ( dialog_h < private.MIN_H ) then

    dialog_h = private.MIN_H;

  elseif ( dialog_h > private.MAX_H ) then
  
    dialog_h = private.MAX_H;

  end;

  local offset = 50;

  local dialog_pos_x = position[ 1 ] - dialog_w/2 - 90;

  if ( dialog_pos_x < 171 ) then

    dialog_pos_x = position[ 1 ] + dialog_w/2 + 90;
  
  end;
  
  local dialog_pos_y = position[ 2 ] - dialog_h/2;
  if ( dialog_pos_y - dialog_h < 0 ) then

    dialog_pos_y = dialog_h / 2;

  end;

  local grid_corner_w = private.GRID_CORNER_W;
  local grid_corner_h = private.GRID_CORNER_H;

  local grid_mid_w = private.GRID_MID_W;
  local grid_mid_h = private.GRID_MID_H;

  interface.FrameGridSet( "achievements_window",
  {
    grid_w   = dialog_w,
    grid_h   = dialog_h,
    corner_w = grid_corner_w,
    corner_h = grid_corner_h,
    mid_w    = grid_mid_w,
    mid_h    = grid_mid_h
  } );

  ObjSet( "obj_achievements_window",
  {
    active = true, visible = true,
    pos_x = dialog_pos_x, pos_y = dialog_pos_y
  } );

  local event_id = "show";
  
  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.WindowShow_ANIM_TIME;

  ObjAnimate( "obj_achievements_window", "alp", 0, 0, trg,
  {
    0.0, 2, 0,
    tme, 2, 1
  } );

  local pos_x = - dialog_w / 2 + 19;
  local pos_y = dialog_h / 2 - 42;

  ObjSet( "spr_achievements_window_decor_left", { pos_x = pos_x, pos_y = pos_y } );
  ObjSet( "spr_achievements_window_decor_right", { pos_x = - pos_x, pos_y = pos_y } );


end;
--******************************************************************************************
function private.WindowHide( )
  
  ObjSet( "obj_achievements_window", { input = false } );

  local event_id = "hide";  
  local trg = function () private.EventAnimEnd( event_id ); end;
  local tme = private.WindowShow_ANIM_TIME;

  ObjAnimate( "obj_achievements_window", "alp", 0, 0, trg,
  {
    0.0, 2, 1,
    tme, 2, 0
  } );

end;
--******************************************************************************************
function private.EventAnimEnd( event_id )

------------------------------------------------------------------------------------
  if ( event_id == "show" ) then
  
  ObjSet( "obj_achievements_window", { active = true, visible = true } );

------------------------------------------------------------------------------------
  elseif ( event_id == "hide" ) then

  ObjSet( "obj_achievements_window", { active = false, visible = false } );

------------------------------------------------------------------------------------
  end;

end;