-- name=rm_collectibles
--******************************************************************************************
function public.Init ()
-------------------------------------------------------------------------------------------- 
  private.ANIM_TIME = 0.2;
  private.current_item = nil;
  private.count_item = 3;
  private.count_level = 4;
  private.off_y = { [ "1_1" ] = -312, [ "1_2" ] = -328, [ "1_3" ] = -264,
                    [ "2_1" ] = -300, [ "2_2" ] = -318, [ "2_3" ] = -279,
                    [ "3_1" ] = -320, [ "3_2" ] = -284, [ "3_3" ] = -317,
                    [ "4_1" ] = -264, [ "4_2" ] = -310, [ "4_3" ] = -305 };
--------------------------------------------------------------------------------------------
  local table_multiset = {};

  local table_multiset = {};
  for i = 1, private.count_level do

    for j = 1, private.count_item do

      table.insert( table_multiset, { "spr_collectibles_item_"..i.."_"..j, { 
        event_mdown = function() private.ClkItem( i.."_"..j ) end, 
        event_menter = function() SetCursor( CURSOR_HAND ) end, 
        event_mleave = function() SetCursor( CURSOR_DEFAULT ) end; } } );

    end;

  end;

  table.insert( table_multiset, { "spr_collectibles_big_item", { 
      event_mdown = private.ClkBigItem, 
      event_menter = function() SetCursor( CURSOR_HAND ) end, 
      event_mleave = function() SetCursor( CURSOR_DEFAULT ) end; } } );

  table.insert( table_multiset, { "obj_collectibles_btn_close", { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_DOWN, "anm_collectibles_btn_close_focus" ) end, 
      event_mleave = function() private.BtnMouseLeave( "anm_collectibles_btn_close_focus" ) end; } } );

  table.insert( table_multiset, { "obj_collectibles_btn_exit", { 
      event_mdown = private.BtnCloseMouseDown, 
      event_menter = function() private.BtnMouseEnter( CURSOR_HAND, "spr_collectibles_btn_exit_focus" ) end, 
      event_mleave = function() private.BtnMouseLeave( "spr_collectibles_btn_exit_focus" ) end; } } );

  if ( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset );
  end;

end;
--******************************************************************************************
function public.PreOpen ()

  local current_room = common.GetCurrentRoom();
  if ( current_room ) then

    common_impl.Lock( false );--разблокировка для карты EE 

  end;

  local table_multiset = {};
  for i = 1, private.count_level do

    local prg = "std";
    if ( i == private.count_level ) then
      prg = "ext";
    end;
    for j = 1, private.count_item do
    
      local event = "get_collect_item_"..i.."_"..j;
      if ( ng_global.progress[ prg ][ event ] and ng_global.progress[ prg ][ event ].done == 0 )
         or ( not ng_global.progress[ prg ][ event ] ) then

        table.insert( table_multiset, { "obj_collectibles_item_"..i.."_"..j, { input = false, alp = 1 } } );
        table.insert( table_multiset, { "spr_collectibles_item_"..i.."_"..j.."_light", { visible = false } } );
        table.insert( table_multiset, { "spr_collectibles_item_"..i.."_"..j.."_shadow", { visible = false } } );
        table.insert( table_multiset, { "spr_collectibles_item_"..i.."_"..j, { color_r = 0.05, color_g = 0.05, color_b = 0.05 } } );

      else

        table.insert( table_multiset, { "obj_collectibles_item_"..i.."_"..j, { input = true } } );
        table.insert( table_multiset, { "spr_collectibles_item_"..i.."_"..j.."_light", { visible = true } } );
        table.insert( table_multiset, { "spr_collectibles_item_"..i.."_"..j.."_shadow", { visible = true } } );
        table.insert( table_multiset, { "spr_collectibles_item_"..i.."_"..j, { color_r = 1, color_g = 1, color_b = 1 } } );

      end;

    end;

  end;
  
  if( #table_multiset > 0 ) then
    ObjMultiSet( table_multiset ); 
  end;

   common_impl.EnvPlay( { "common/audio/aud_collectibles_env" }, "", 0.5 );

end;
--******************************************************************************************
function public.Open ()

end;
--******************************************************************************************
function public.Close ()
  
  if ( private.current_item ) then

    ObjSet( "obj_collectibles_big_item", { visible = false, input = false } );
    ObjSet( "obj_collectibles_item_"..private.current_item, { alp = 1 } );
    private.current_item = nil;

  end;

  local current_room = common.GetCurrentRoom();

  if ( current_room ) then

    common_impl.ExitBonusRm();
    
  end;

  ObjSet( "tmr_common_anm", { active = true } );

  common_impl.StopAudio(  "env", "common/audio/aud_collectibles_env", 1 );

end;
--******************************************************************************************
function private.ClkItem ( number )

  local table_multiset = {};

  local func_end = function()

    ObjSet( "rm_collectibles", { input = true } );

  end;

  private.current_item = number;

  ObjSet( "rm_collectibles", { input = false } );

  ObjAnimate( "obj_collectibles_item_"..number, "alp", 0, 0, "", { 
    0, 3, 1, 
    private.ANIM_TIME, 3, 0 } );

  table.insert( table_multiset, { "obj_collectibles_big_item", { visible = true, input = true } });
  ObjSet( "spr_collectibles_big_item", { res = ObjGet( "spr_collectibles_item_"..number ).res } );
  table.insert( table_multiset, { "spr_collectibles_big_item", { drawoff_y = private.off_y[ number ] } });

  table.insert( table_multiset, { "txt_collectibles_plate_name", { text = "str_collectibles_name_"..number } });

  common_impl.PlayAudio( "sfx", "common/audio/aud_achievement_zoom_in", 0, "", 0 );

  ObjAnimate( "obj_collectibles_big_item", "alp", 0, 0, func_end, { 
    0, 3, 0, 
    private.ANIM_TIME, 3, 1 } );

  ObjAnimate( "txt_collectibles_plate_name", "alp", 0, 0, func_end, { 
    0, 3, 0, 
    private.ANIM_TIME, 3, 1 } );

  ObjMultiSet( table_multiset );

end;
--******************************************************************************************
function private.ClkBigItem ( )

  local func_end = function()

    ObjSet( "rm_collectibles", { input = true } );
    ObjSet( "obj_collectibles_big_item", { visible = false, input = false } );
    private.current_item = nil;

  end;  

  ObjSet( "rm_collectibles", { input = false } );

  common_impl.PlayAudio( "sfx", "common/audio/aud_achievement_zoom_out", 0, "", 0 );

  ObjAnimate( "obj_collectibles_big_item", "alp", 0, 0, func_end, { 
    0, 3, 1, 
    private.ANIM_TIME, 3, 0 } );

  ObjAnimate( "obj_collectibles_item_"..private.current_item, "alp", 0, 0, "", { 
    0, 3, 0, 
    private.ANIM_TIME, 3, 1 } );
  
  ObjAnimate( "txt_collectibles_plate_name", "alp", 0, 0, func_end, { 
    0, 3, 1, 
    private.ANIM_TIME, 3, 0 } );

end;
--******************************************************************************************
function private.BtnMouseEnter( type_cursor, obj )
      
  if ( type_cursor ) then
    SetCursor( type_cursor );
  else
    SetCursor( CURSOR_DEFAULT );
  end;
    
  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,              0, alp, 
    time*( 1 - alp ), 0, 1
  } );

end;
--******************************************************************************************
function private.BtnMouseLeave( obj )
    
  SetCursor( CURSOR_DEFAULT );

  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,        0, alp,
    time * alp, 0,   0 
  });

end;
--******************************************************************************************
function private.BtnCloseMouseDown( )

  local current_room = common.GetCurrentRoom();
  if ( not current_room ) then

    current_room = "rm_extra";

  end;  

  common.GotoRoom( current_room );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------