-- name=rm_collectibles2
--******************************************************************************************
function public.Init()
-------------------------------------------------------------------------------------------- 
  private.fig_price = {1,4,7,2,7,7,7,6}; -- цены на фигурки
  private.num_chars = 8; -- количество фигурок
  private.num_fig = 0; -- номер текущей фигурки
--------------------------------------------------------------------------------------------
  local table_multiset = {};

  table.insert( table_multiset, {"obj_collectibles2_get_figurine", { event_menter = private.get_fig_menter }} );
  table.insert( table_multiset, {"obj_collectibles2_get_figurine", { event_mleave = private.get_fig_mleave }} );
  table.insert( table_multiset, {"obj_collectibles2_get_figurine", { event_mdown = function () private.get_fig(private.num_fig) end} } );
  table.insert( table_multiset, {"spr_collectibles2_button",       { event_menter = private.button_buy_menter }} );
  table.insert( table_multiset, {"spr_collectibles2_button",       { event_mleave = private.button_buy_mleave }} );
  table.insert( table_multiset, {"spr_collectibles2_button",       { event_mdown = function () private.by_fig(private.num_fig) end }} );

  table.insert( table_multiset, {"obj_collectibles2_btn_exit", { 
    event_mdown = function () private.BtnCloseMouseDown() end, 
    event_menter = function () private.BtnMouseEnter( CURSOR_HAND, "spr_collectibles2_btn_exit_focus" ) end, 
    event_mleave = function () private.BtnMouseLeave( "spr_collectibles2_btn_exit_focus" ) end } } );
  
  for i = 1,private.num_chars do  

    table.insert( table_multiset, {"spr_collectibles2_"..i.."_light", { event_menter = function() private.char_shop_menter(i) end }} );
    table.insert( table_multiset, {"spr_collectibles2_"..i.."_light", { event_mleave = function() private.char_shop_mleave(i) end }} );
    table.insert( table_multiset, {"spr_collectibles2_"..i.."_light", { event_mdown = function() private.char_shop_mdown(i) end }} );
    table.insert( table_multiset, {"spr_collectibles2_bouth_"..i, { event_mdown = 

      function ()
  
        private.Zoom_in( "spr_collectibles2_bouth_"..i, "spr_collectibles2_bouth_"..i.."_big", "str_collectibles2_char_"..i ) 
   
      end; 

    }} );
  end;

  
  ObjMultiSet( table_multiset );

end;
--******************************************************************************************
function public.PreOpen()

  common_impl.EnvPlay( { "common/audio/aud_collectibles_shop_env" }, "", 0.5 );  

  common_impl.StopAllMus();

  ObjSet( "spr_collectibles2_"..private.num_fig.."_light", {alp = 0} );

  ObjSet( "spr_collectibles2_button", {input = false} );

  if private.close_frame then

    private.close_frame();

  end; 

  if not ng_global.collectibles2.bouth_fig then

    ng_global.collectibles2.bouth_fig = {};
    ng_global.collectibles2.not_get_fig = 0;

  end;
  
  private.num_fig = ng_global.collectibles2.not_get_fig;
  
  private.loadstate();

  local current_room = common.GetCurrentRoom();

  if ( current_room ) then

    common_impl.Lock( false );--разблокировка для карты EE
    
  end;

end;
--******************************************************************************************
function public.PreClose()
  
end;
--******************************************************************************************
function public.Close()

  common_impl.StopAudio(  "env", "common/audio/aud_collectibles_shop_env", 1 );

  local current_room = common.GetCurrentRoom();

  if ( current_room ) then

    common_impl.ExitBonusRm();

  else

    common_impl.PlayAudio(  "mus", "common/audio/aud_mt8_maintheme_mus", 1 );  
    
  end;

  ObjSet( "tmr_common_anm", { active = true } );

end;
--******************************************************************************************
--******************************************************************************************
function private.get_fig_menter()
  SetCursor( CURSOR_GET );
end;
--------------------------------------------------------------------------------------------
function private.get_fig_mleave()
  SetCursor( CURSOR_DEFAULT );
end;
--------------------------------------------------------------------------------------------
function private.get_fig(num)
  
  table.insert(ng_global.collectibles2.bouth_fig,num);
  ng_global.collectibles2.not_get_fig = 0;
  local table_multiset = {}; 

  local trg_after = function ()

    ObjSet( "rm_collectibles2", { input = true } );
    ObjSet( "spr_collectibles2_bouth_"..num, { input = true } );

  end;

  table.insert( table_multiset, { "rm_collectibles2", { input = false } } );

  for i = 1,private.num_chars do
    
    if ( ng_global.collectibles2.unlock_crs[i] ) then 

      table.insert( table_multiset, {"spr_collectibles2_"..i.."_light",{input = true}});

    end;

  end;
  
  table.insert( table_multiset, {"obj_collectibles2_get_figurine", {input = false}});
  
  ObjAnimate("spr_collectibles2_bouth_"..num, "alp", 0, 0, trg_after, {0, 3, 0, 0.5, 3, 1});
  ObjAnimate("anm_collectibles2_figurines"..num, "alp", 0, 0, "", {0, 3, 1, 0.5, 3, 0});
  
  ObjMultiSet(table_multiset);

  common_impl.PlayAudio( "sfx", "common/audio/aud_collectibles_shop_set", 0, "", 0 );

end;
--------------------------------------------------------------------------------------------
function private.button_buy_menter()
  SetCursor( CURSOR_HAND );
  ObjSet("spr_collectibles2_button_add", { alp = 1});
end;
--------------------------------------------------------------------------------------------
function private.button_buy_mleave()
  SetCursor( CURSOR_DEFAULT );
  ObjSet("spr_collectibles2_button_add", { alp = 0});
end;
--------------------------------------------------------------------------------------------
function private.char_shop_menter(num)
  if num ~= private.num_fig then
    SetCursor( CURSOR_HAND );
    ObjSet("spr_collectibles2_"..num.."_light", { alp = 1});
  end;
end;
--------------------------------------------------------------------------------------------
function private.char_shop_mleave(num)
  if num ~= private.num_fig then
    ObjSet("spr_collectibles2_"..num.."_light", { alp = 0});
  end;
  SetCursor( CURSOR_DEFAULT );
end;
--------------------------------------------------------------------------------------------
function private.char_shop_mdown(num)
  common_impl.PlayAudio( "sfx", "common/audio/aud_collectibles_shop_click", 0, "", 0 );
  ObjSet("spr_collectibles2_button", {input = true});
  if private.num_fig ~= num then
    ObjSet("spr_collectibles2_"..private.num_fig.."_light", {alp = 0});
    private.num_fig = num;
  end;
  private.init_coins();
end;
--------------------------------------------------------------------------------------------
function private.by_fig(num)

  if ( private.fig_price[num] <= ng_global.collectibles2.coin_count ) then
    ng_global.collectibles2.not_get_fig = num;
    local table_multiset = {};
    
    local trg_after = function ()

      ObjMultiSet({
      { "anm_collectibles2_light1", { alp = 1, active = true } },
      { "anm_collectibles2_light2", { alp = 0, active = false } },
      { "obj_collectibles2_get_figurine", { input = true } },
      { "rm_collectibles2", { input = true } }
      });
      
    end;
    
    local trg_after2 = function ()

      ObjDelete("spr_collectibles2_"..num.."_light");
      ObjDelete("spr_collectibles2_price"..num);
      ObjDelete("spr_collectibles_silhouette_"..num);

    end;
    
    ObjAnimate( "spr_collectibles2_"..num.."_light", "alp", 0, 0, trg_after2, {0, 3, 1, 0.5, 3, 0});
    ObjAnimate( "spr_collectibles2_price"..num, "alp", 0, 0, "", {0, 3, 0, 0.5, 3, 0});
    ObjAnimate( "spr_collectibles_silhouette_"..num, "alp", 0, 0, "", {0, 3, 0, 0.5, 3, 0});

    table.insert( table_multiset, { "rm_collectibles2", { input = false } } );
    table.insert( table_multiset, { "anm_collectibles2_light1",{ alp = 0, active = false } } );
    table.insert( table_multiset, { "anm_collectibles2_light2",{ alp = 1, active = true } } );
    table.insert( table_multiset, { "anm_collectibles2_figurines"..num, { playing = true, alp = 1, endtrig = trg_after } } );
    table.insert( table_multiset, { "spr_collectibles2_button",  {input = false } } );

    common_impl.PlayAudio( "sfx", "common/audio/aud_collectibles_shop_buy", 0, "", 0 );

    for i = 1,private.num_chars do
      table.insert( table_multiset, { "spr_collectibles2_"..i.."_light", { input = false } } );
    end;

    ObjMultiSet(table_multiset);
    private.counted_coins(private.fig_price[num]);

  else

    common_impl.PlayAudio( "sfx", "common/audio/aud_collectibles_shop_wrong", 0, "", 0 );
    private.GrdShowTxt( "txt_collectibles2_need_more_coins" );

  end;
end;
--------------------------------------------------------------------------------------------
function private.init_coins()

  local table_multiset = {};

  local units = math.fmod(ng_global.collectibles2.coin_count,10);
  local tens = math.modf(ng_global.collectibles2.coin_count/10); 
 
  if ng_global.collectibles2.coin_count > 9 then 

    table.insert( table_multiset, {"spr_collectibles2_num_coin_1", {alp = 1, pos_x = -7, pos_y = -13, res = "assets/levels/menu/rm_collectibles2/layers/menu_"..tens}});
    table.insert( table_multiset, {"spr_collectibles2_num_coin_2", {pos_x = 13, pos_y = -13, res = "assets/levels/menu/rm_collectibles2/layers/menu_"..units}});

  else

    table.insert( table_multiset, {"spr_collectibles2_num_coin_1", {alp = 0}});
    table.insert( table_multiset, {"spr_collectibles2_num_coin_2", {pos_x = 0, pos_y = -13, res = "assets/levels/menu/rm_collectibles2/layers/menu_"..units}});

  end;

  ObjMultiSet(table_multiset);

end;
--------------------------------------------------------------------------------------------
function private.counted_coins(price)

  local endtrig1 = function()

    local endtrig2 = function()
    end;

    
    private.init_coins();

    ObjAnimate("obj_collectibles_num_coin", "alp", 0, 0, endtrig2, {0, 3, 0, 0.4, 3, 1});
  end;

  ObjAnimate("obj_collectibles_num_coin", "alp", 0, 0, endtrig1, {0, 3, 1, 0.4, 3, 0});
  ng_global.collectibles2.coin_count = ng_global.collectibles2.coin_count - price;

end;
--------------------------------------------------------------------------------------------
function private.loadstate()

  local table_multiset = {};

  --ng_global.collectibles2.unlock_crs = { false, false, false, false, false, false, false };
  --ng_global.collectibles2.unlock_crs = { true, true, true, true, true, true, true };
  
  for i = 1, #ng_global.collectibles2.unlock_crs do

    if not ( ng_global.collectibles2.unlock_crs[i] ) then 

      table.insert( table_multiset, {"spr_collectibles2_"..i.."_light", { input = false } } );
      table.insert( table_multiset, {"spr_collectibles_silhouette_"..i, { alp = 0.4 } } ); 
      table.insert( table_multiset, {"spr_collectibles2_price"..i, { alp = 0 } } );     

    else
      
      table.insert( table_multiset, {"spr_collectibles2_"..i.."_light", { input = true }} );
      table.insert( table_multiset, {"spr_collectibles_silhouette_"..i, { alp = 1 } } );
      table.insert( table_multiset, {"spr_collectibles2_price"..i, { alp = 1 } } );

    end;

  end;

  if ng_global.collectibles2.not_get_fig > 0 then

    for i = 1,private.num_chars do
      table.insert( table_multiset, {"spr_collectibles2_"..i.."_light",{input = false}} );
    end;

    table.insert( table_multiset, {"spr_collectibles2_button", {input = false}} );
    table.insert( table_multiset, {"obj_collectibles2_get_figurine", {input = true}} );
    table.insert( table_multiset, {"anm_collectibles2_figurines"..ng_global.collectibles2.not_get_fig, {active = true, alp = 1,frame = 91}} );

    ObjDelete("spr_collectibles2_"..ng_global.collectibles2.not_get_fig.."_light" );
    ObjDelete("spr_collectibles2_price"..ng_global.collectibles2.not_get_fig );
    ObjDelete( "spr_collectibles_silhouette_"..ng_global.collectibles2.not_get_fig );

  end;

  for i = 1,#ng_global.collectibles2.bouth_fig do

    table.insert( table_multiset, {"spr_collectibles2_bouth_"..ng_global.collectibles2.bouth_fig[i], {alp = 1, input = true } } );
    ObjDelete( "spr_collectibles2_"..ng_global.collectibles2.bouth_fig[i].."_light" );
    ObjDelete( "spr_collectibles2_price"..ng_global.collectibles2.bouth_fig[i] );
    ObjDelete( "spr_collectibles_silhouette_"..ng_global.collectibles2.bouth_fig[i] );

  end;

  if table_multiset[1] then

    ObjMultiSet( table_multiset );

  end;

  private.init_coins();

end;
--------------------------------------------------------------------------------------------
function private.BtnCloseMouseDown()

  if common.GetCurrentRoom() then 
   
   common.GotoRoom( common.GetCurrentRoom() );

  else

    common.GotoRoom( "rm_extra");

  end;
   
end;
--******************************************************************************************
function private.BtnMouseEnter( type_cursor, obj )
      
  if ( type_cursor ) then
    SetCursor( type_cursor );
  else
    SetCursor( CURSOR_DEFAULT );
  end;
    
  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,              0, alp, 
    time*( 1 - alp ), 0, 1
  } );

end;
--******************************************************************************************
function private.BtnMouseLeave( obj )
    
  SetCursor( CURSOR_DEFAULT );

  local alp = ObjGet( obj ).alp;
  local time = 0.3;
  ObjAnimate( obj, "alp", 0, 0, "", 
  { 
    0.0,        0, alp,
    time * alp, 0,   0 
  });

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function private.Zoom_out( small_obj, big_obj )

  common_impl.PlayAudio( "sfx", "common/audio/aud_achievement_zoom_in", 0, "", 0 );

  local frame = "spr_collectibles2_frame";
  local small_pos_x = ObjGet( small_obj ).pos_x;
  local small_pos_y = ObjGet( small_obj ).pos_y;
  local frame_pos_x = ObjGet( frame ).pos_x;
  local frame_pos_y = ObjGet( frame ).pos_y;
  
  local func_end = function ()

    ObjMultiSet({

      { "rm_collectibles2", { input = true }},
      { big_obj, { alp = 0 } },
      { frame, { alp = 0, input = false, pos_x = frame_pos_x, pos_y = frame_pos_y } },

    });

  end;  

  ObjSet( "rm_collectibles2", { input = false } );

  ObjAnimate( small_obj, "alp", 0, 0, "", 
  { 

    0.0, 0, 0, 
    0.3, 0, 1 

  } );

  ObjAnimate( frame, "pos_xy", 0, 0, "", 
  { 

    0.0, 0, frame_pos_x, frame_pos_y,
    0.3, 0, small_pos_x, small_pos_y
 
  });

  ObjAnimate( frame, "scale_xy", 0, 0, func_end, 
  { 

    0.0, 0, 1, 1,
    0.3, 0, 0, 0

  });
  
  private.close_frame = nil;
  
end;
--------------------------------------------------------------------------------------------
function private.Zoom_in( small_obj, big_obj, text )

  common_impl.PlayAudio( "sfx", "common/audio/aud_achievement_zoom_in", 0, "", 0 );

  local frame = "spr_collectibles2_frame";
  local small_pos_x = ObjGet( small_obj ).pos_x;
  local small_pos_y = ObjGet( small_obj ).pos_y;
  local frame_pos_x = ObjGet( frame ).pos_x;
  local frame_pos_y = ObjGet( frame ).pos_y;

  local end_func = function ()

    ObjMultiSet({
   
      { "rm_collectibles2", { input = true } }, 

      { frame,
        {
          alp = 1, input = true,
          event_mdown = function() private.Zoom_out( small_obj, big_obj ) end,
        }
      },
    });
      
  end;

  ObjMultiSet({

    { big_obj, { alp = 1 } },
    { frame, { alp = 1 } },
    { "rm_collectibles2", { input = false } },
    { "txt_collectibles2_frame", { text = text } },

  });

  
  ObjAnimate( small_obj, "alp", 0, 0, "", 
  { 

    0.0, 0, 1, 
    0.3, 0, 0 

  } );
  
  
  ObjAnimate( frame, "pos_xy", 0, 0, "", 
  { 

    0.0, 0, small_pos_x, small_pos_y,
    0.3, 0, frame_pos_x, frame_pos_y
 
  });

  ObjAnimate( frame, "scale_xy", 0, 0, end_func, 
  { 

    0.0, 0, 0, 0,
    0.3, 0, 1, 1

  });  

  function private.close_frame()
   
    ObjMultiSet({

      { frame, {alp = 0,input = false, pos_x = 531, pos_y = 371 }},
      { small_obj, { alp = 1} },
      { big_obj, { alp = 0} },

    });
    private.close_frame = nil;

  end;

end;
--------------------------------------------------------------------------------------------
function private.GrdShowTxt( txt )

  local game_cursor = GetGameCursorPos();

  ObjSet( "txt_collectibles2_window", { text = txt } );

  private.GRID_BORDER_W = 100;
  private.GRID_BORDER_H = 100;

  private.MIN_W = 370;
  private.MAX_W = 1000;
  private.MIN_H = 150;
  private.MAX_H = 500;

  local off_x = private.GRID_BORDER_W;
  local off_y = private.GRID_BORDER_H;

  local dialog_w = ObjGet( "txt_collectibles2_window" ).draw_width + off_x;

  if ( dialog_w < private.MIN_W ) then

    dialog_w = private.MIN_W;

  elseif ( dialog_w > private.MAX_W ) then

    dialog_w = private.MAX_W;

  end;

  local dialog_h = ObjGet( "txt_collectibles2_window" ).draw_height + off_y;

  if ( dialog_h < private.MIN_H ) then

    dialog_h = private.MIN_H;

  elseif ( dialog_h > private.MAX_H ) then
  
    dialog_h = private.MAX_H;

  end;

  local grid_corner_w = 58;
  local grid_corner_h = 58;
  local grid_mid_w = 4;
  local grid_mid_h = 4;

  interface.FrameGridSet( "collectibles2_window",
  {
    grid_w   = dialog_w,
    grid_h   = dialog_h,
    corner_w = grid_corner_w,
    corner_h = grid_corner_h,
    mid_w    = grid_mid_w,
    mid_h    = grid_mid_h
  } );

  ObjSet( "rm_collectibles2", { input = false } );

  ObjAnimate( "obj_collectibles2_window", "alp", 0, 0, function () ObjSet( "rm_collectibles2", { input = true } ) end,
  {
    0.0, 3, 0,
    0.3, 3, 1,
    1.0, 3, 1,
    1.3, 3, 0
    
  } );



end;
---------------------------------------------------------------------------