-- name=rm_intro
--******************************************************************************************
-- для добавления нового лого достаточно добавить его название в массив private.logo
--******************************************************************************************
private.counter = 0;
private.obj = {"obj_intro_logo_bigfishgames","obj_intro_logo_elephantgames"};
private.activeLogo = 0;
--******************************************************************************************
function public.Init()

  ObjSet( "spr_intro_logo_bigfishgames_bg", 
  { 
    scale_x = (1024 / 256), 
    scale_y = (768 / 192)
  } );

  ObjSet( "spr_intro_logo_elephantgames_bg", 
  { 
    scale_x = 1024 / 2, 
    scale_y = 768 / 2
  } );


  ObjSet( "obj_intro_logo_bigfishgames", 
  { 
  inputrect_w = 1024,
  inputrect_h = 768
  } );

  ObjSet( "obj_intro_logo_elephantgames", 
  { 
  inputrect_w = 1024,
  inputrect_h = 768
  } );
  
  
  DbgTrace("w="..tostring(GetScreenSize().w));
  DbgTrace("h="..tostring(GetScreenSize().h));
  
  local w = GetScreenSize().w;
  local h = GetScreenSize().h;
  
  if w/h > 1.7 then
    ObjSet( "spr_intro_logo_bigfishgames", 
      { 
      scale_x = 0.75,
      scale_y = 1.0625
      } );
    ObjSet( "spr_intro_logo_elephantgames", 
      { 
      scale_x = 0.75,
      scale_y = 1.0625
      } );
  end;
  
  
  room.Define( "rm_intro" );
  ObjSet(private.obj[1], {
    input = false,
    event_mdown = private.IntroLogoHide
  });
  private.UpdateLogoToNextRes();

  MsgSend(Command_Level_Loaded);

end;
--******************************************************************************************
function public.Open()

  private.counter = 1;
  private.IntroLogoShow();

end;
--******************************************************************************************
function private.UpdateLogoToNextRes()
  
  private.counter = private.counter + 1;
  ObjSet(private.obj[private.counter], { alp = 0, active = true });
  
end;
--******************************************************************************************
function private.IntroLogoShow()

  ObjAnimate( private.obj[private.counter], "alp", 0, 0 ,private.IntroLogoActivate, { 0,0,0, 0.8,0,1 } );

end;
--******************************************************************************************
function private.IntroLogoActivate()

  ObjSet( private.obj[private.counter], { input = true } );
  ObjStopAnimate( private.obj[private.counter], "alp" );
  ObjAnimate( private.obj[private.counter], "alp", 0, 0, private.IntroLogoHide, { 0,0,1, 1.5,0,1 } );

end;
--******************************************************************************************
function private.IntroLogoHide()

  local trg = function () 
    private.UpdateLogoToNextRes();
    private.IntroLogoShow(); 
  end;
  if private.counter == #private.obj then
    trg = private.IntroVideoPlay;
  end;
  ObjSet( private.obj[private.counter], { input = false } );
  ObjStopAnimate( private.obj[private.counter], "alp" );
  ObjAnimate( private.obj[private.counter], "alp",0 ,0, trg, { 0,0,1, 0.8,0,0 } );

end;
--******************************************************************************************
function private.IntroVideoPlay()

  interface.DialogVideoShow( "obj_intro_video", 1, function() private.IntroVideoEnd( 'skip' ); end );
  common_impl.PlayAudio( "sfx", "common/audio/aud_preintro", 0, "", 0 );
  VidPlay( "vid_intro_video", function() private.IntroVideoEnd( nil ); end );

end;
--******************************************************************************************
function private.IntroVideoEnd( skip )

  interface.DialogVideoHide();
  ObjAttach( "tmr_intro_videoend", "cmn_timers" );

  if skip then  

    common_impl.StopAudio( "sfx", "common/audio/aud_preintro", 0, "", 0 );
    
  end;

  local funcVideoEnd = function () 
    cmn.GotoRoom('rm_menu'); 
    ObjDelete('tmr_intro_videoend'); 
  end; 
  ObjSet( "tmr_intro_videoend", 
  { 
    endtrig = funcVideoEnd, 
    time = 0.6, 
    playing = true
  } );
  
  if tostring(GetPlatform()) == "ios" or tostring(GetPlatform()) == "android" then
    MsgSend(Command_Level_CanShowLoading);
  end;

end;
--******************************************************************************************