-- name=rm_menu
--******************************************************************************************
function public.Init()

  ObjSet("menu_but_play", 
  {
    event_mdown = private.PlayDown
  });
  
  ObjSet("menu_but_options", 
  {
    event_mdown = private.OptionsDown
  });

  ObjSet("menu_but_extras", 
  {
    event_mdown = private.ExtraDown
  });

  ObjSet("menu_but_profile", 
  {
    event_mdown = private.ProfileDown
  });

  ObjSet("menu_but_moregames", 
  {
    event_mdown = private.MoreGamesDown
  });

  ObjSet("spr_menu_man", 
  {
    event_mdown = private.clk_man,
    event_menter = function () common_impl.SetCursor( CURSOR_LOUPE ); end,
    event_mleave = function () common_impl.SetCursor( CURSOR_DEFAULT ); end
  });

    ObjSet("menu_but_unlock", { event_mdown = private.UnlockDown });
    ObjSet("menu_but_sequel", { event_mdown = private.SneakPeakDown });
    ObjSet("menu_but_save50", { event_mdown = private.Save50Down });
    ObjSet("menu_but_gear", { event_mdown = private.GearClick });
    ObjSet("spr_menu_but_back_button", { event_mdown = private.GearClickClose });
    
    ObjSet("menu_but_support", { event_mdown = function() common.dialog.options.SupportDown(); end });
    ObjSet("menu_but_terms", { event_mdown = function() common.dialog.options.TermsDown(); end });
    ObjSet("menu_but_privacy", { event_mdown = function() common.dialog.options.PolicyDown() end});
    ObjSet("menu_but_credits", { event_mdown = function() common.MenuCredits("credits"); end});
    
    ObjSet("menu_port_hub_sub_menu",{alp=0,input=false,active=false,visible=false});

end;
--******************************************************************************************
local sub_menu_active;  

function private.GearClick()
  
     sub_menu_active = true;
    ObjSet("menu_port_hub_sub_menu",{alp=1,input=true,active=true,visible=true});
    

end;
  
  
function private.GearClickClose()
  
    sub_menu_active = false;
    ObjSet("menu_port_hub_sub_menu",{alp=0,input=false,active=false,visible=false});

end;
--******************************************************************************************

function public.PreOpen()
    
  ObjSet("menu_port_hub_sub_menu",{alp=0,input=false,active=false,visible=false});
  sub_menu_active = false;
  
  ObjSet( "menu_ce_buttons_left",  { active = false, visible = false, input = false } );
  ObjSet( "menu_ce_buttons_right", { active = false, visible = false, input = false } );

  if ( IsCollectorsEdition() ) then

    ObjSet( "menu_ce_buttons_left",  { active = true, visible = true, input = true } );
    ObjSet( "menu_ce_buttons_right", { active = true, visible = true, input = true } );
    ObjSet( "spr_menu_logo_ce",      { visible = true } );

  elseif ( IsSurveyEdition() ) then

    ObjSet( "menu_ce_buttons_left", { active = false, visible = false, input = false } );
    ObjSet( "menu_but_strguide", { active = false, visible = false, input = false } );

  else

    ObjSet( "menu_ce_buttons_left", { active = false, visible = false, input = false } );

  end;

--  if GetPlatform()=="mac" then
--
--    ObjSet( "dialog_options_widescreen", { active = false, visible = false, input = false } );
--
--  end;

  public.SetProfileText( GetCurrentProfile() );
  public.ButtonSetPos();

  common_impl.PlayAudio(  "mus", "common/audio/aud_mt8_maintheme_mus", 1 );

  private.AnimMenu();

  common_impl.EnvPlay( { "common/audio/aud_menu_env" }, "", 0.5 );

  if tostring(GetPlatform()) == "ios" or tostring(GetPlatform()) == "android" then
      iOS_LogEvents(2);
      iOS_ManageAds(1);
        
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
      ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
      ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
      ObjSet("menu_but_save50", {input = 1, visible = 1, active = 1, alp = 1});
      ObjSet("menu_but_sequel", {input = 1, visible = 1, active = 1, alp = 1});
    end;

    if port.isTablet() == 0 then
      if preformance_warning == 0 then
        preformance_warning = 1;
        ObjSet("tmr_menu_performance", {endtrig = function() private.PerformanceWarning(); end, time = 2, playing = 1 });
      end;
    end;

    if iOS_IsiSplashPressed() == 1 then
        ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_save50", {endtrig = function() private.Save50Timer(); end, time = 0.5, playing = 1 });
    end;

    if iOS_IsRated() == 1 then
        ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_sneakpeak", {endtrig = function() private.SneakpeakTimer(); end, time = 0.5, playing = 1 });
    end;

    if iOS_IsBought() == 1 then
        ObjSet("menu_but_unlock", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("tmr_menu_unlock", {endtrig = function() private.UnlockTimer(); end, time = 0.5, playing = 1 });
    end;
  end;


end;
--******************************************************************************************
function public.Open()

  if ( IsCollectorsEdition() ) then

    if ( ng_global.progress[ "std" ].common.gamewin == true ) and
       ( ng_global.progress[ "std" ].common.gamestart == false ) and
         ( not ng_global.bonusunlock ) then

      common.DialogWindowShow( "common", "bonusunlock", false );
      ng_global.bonusunlock = true;

      SaveProfiles();

    elseif ( ng_global.progress[ "ext" ].common.gamewin == true ) and
       ( ng_global.progress[ "ext" ].common.gamestart == false ) and
         ( not ng_global.secretunlock ) then

      common.DialogWindowShow( "common", "secretunlock", false );
      ng_global.secretunlock = true;

      SaveProfiles();

    end;

  end;
  
end;
--******************************************************************************************
function public.SetProfileText ( name )
  

  local obj = "txt_menu_but_profile";
  local profile_name = "";
  if  ( name ~= "ng_noprofiles" )
  and ( name ~= "ng_error" )
  then
  profile_name = name;
  end;
  ObjSet( obj, { text = profile_name } );

end;
--******************************************************************************************
function private.PerformanceWarning()
  iOS_PerformanceWarning();
end;
--******************************************************************************************
function private.Save50Timer()
  if iOS_IsiSplashPressed() == 1 then
    ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
  else
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
        ObjSet("menu_but_save50", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("menu_but_save50", {input = 1, visible = 1, active = 1, alp = 1});
    end;
    ObjSet("tmr_menu_save50", {endtrig = function() private.Save50Timer(); end, time = 0.5, playing = 1 });
  end;
end;
--******************************************************************************************
function private.SneakpeakTimer()
  if iOS_IsRated() == 1 then
    ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
  else
    local connection = 1;
    connection = iOS_InternetConnection();
    if ( connection == 0 ) then
        ObjSet("menu_but_sequel", {input = 0, visible = 0, active = 0, alp = 0});
    else
        ObjSet("menu_but_sequel", {input = 1, visible = 1, active = 1, alp = 1});
    end;
    ObjSet("tmr_menu_sneakpeak", {endtrig = function() private.SneakpeakTimer(); end, time = 0.5, playing = 1 });
  end;
end;
-------------------------ios----------------------------------------
function private.UnlockTimer()
  if iOS_IsBought() == 1 then
    ObjSet("menu_but_unlock", { input = 0, visible = 0, active = 0, alp = 0 });
  else
    ObjSet("tmr_menu_unlock", {endtrig = function() private.UnlockTimer(); end, time = 0.5, playing = 1 });  
  end;
end;
--******************************************************************************************
function private.PlayDown()
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
  common.MenuPlay();
end;
--******************************************************************************************
function private.OptionsDown()
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
  common.MenuOptions();
end;
--******************************************************************************************
function private.QuitDown()
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
  common.MenuQuit();  
end;
--******************************************************************************************
function private.ExtraDown()
    if port.isPortable() == 1 then
    if iOS_IsBought() == 1 then
      common.MenuExtra();
    else
      common.MenuUnlock();
    end;
  else
    common.MenuExtra();
  end;
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
end;
--*************************************ios*****************************************************
function private.Save50Down()
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
  common.MenuSave50();
end;
--*************************************ios*****************************************************
function private.UnlockDown()
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
  common.MenuUnlock();
end;
--*************************************ios*****************************************************
function private.SneakPeakDown()
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
  common.MenuSneakPeak();
end;
--******************************************************************************************
function private.AchDown()
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
  common.MenuAchievements();
end;
--******************************************************************************************
function private.StrguideDown()

    if IsCollectorsEdition() then

      common_impl.ButtonGuide_Click();
      interface.StrategyGuideShow();

    else

      local guide_url = GetGuideUrl();
      OpenBrowser( guide_url );

    end;

end;
--******************************************************************************************
function private.ProfileDown()
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
  common.MenuProfile();
end;
--******************************************************************************************
function private.ShopDown()
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
  common.MenuShop();
end;
--*****************************************************************************************
function private.MoreGamesDown()
  common_impl.PlayAudio( "sfx", "common/audio/aud_click_menu", 0, "", 0 );
  --common.MenuShop();
    iOS_MoreGamesPressed();
  --common.GotoRoom("rm_moregames");
end;
--******************************************************************************************
function private.ButtonMouseEnter( but_name, type )

  common_impl.PlayAudio( "sfx", "common/audio/aud_guidance", 0, "", 0 );
  SetCursor( CURSOR_HAND );

  local type = type or "spr";
  local obj_focus = type.."_menu_but_"..but_name.."_focus";
  local alp = ObjGet( obj_focus ).alp;

  ObjAnimate( obj_focus, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );

end;
--******************************************************************************************
function private.ButtonMouseLeave( but_name, type )

  SetCursor( CURSOR_DEFAULT );

  local type = type or "spr";
  local obj_focus = type.."_menu_but_"..but_name.."_focus";
  local alp = ObjGet( obj_focus ).alp;

  ObjAnimate( obj_focus, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

end;
--******************************************************************************************
function private.AnimMenu()

  ObjAnimate( "spr_menu_light_add", "alp", 1, 0, "", 
  { 
    0.0, 0, 1, 
    0.5, 0, 0.5,
    1.0, 0, 1
  } );

  ObjAnimate( "spr_menu_branch_left1", "ang", 1, 0, "", 
  { 
    0.0, 3, 0.02, 
    1.8, 3, -0.02,
    3.6, 3, 0.02 
  } );

  ObjAnimate( "spr_menu_branch_left1", "pos_y", 1, 0, "", 
  { 
    0.0, 0, -32, 
    1.8, 0, -34,
    3.6, 0, -32
  } );

  ObjAnimate( "spr_menu_branch_left2", "ang", 1, 0, "", 
  { 
    0.0, 3, 0.02, 
    1.7, 3, -0.02,
    3.4, 3, 0.02 
  } );

  ObjAnimate( "spr_menu_branch_left2", "pos_y", 1, 0, "", 
  { 
    0.0, 0, -24, 
    1.7, 0, -26,
    3.4, 0, -24
  } );

  ObjAnimate( "spr_menu_branch_left3", "ang", 1, 0, "", 
  { 
    0.0, 3, 0.02, 
    2.0, 3, -0.02,
    4.0, 3, 0.02 
  } );

  ObjAnimate( "spr_menu_branch_left3", "pos_y", 1, 0, "", 
  { 
    0.0, 0, 9, 
    2.0, 0, 10,
    4.0, 0, 9
  } );

  ObjAnimate( "spr_menu_branch_left4", "ang", 1, 0, "", 
  { 
    0.0, 3, 0.02, 
    2.0, 3, -0.02,
    4.0, 3, 0.02 
  } );

  ObjAnimate( "spr_menu_branch_left4", "pos_y", 1, 0, "", 
  { 
    0.0, 0, -4, 
    2.0, 0, -5,
    4.0, 0, -4
  } );

  ObjAnimate( "spr_menu_branch_right1", "ang", 1, 0, "", 
  { 
    0.0, 3, 0.02, 
    2.0, 3, -0.02,
    4.0, 3, 0.02 
  } );

  ObjAnimate( "spr_menu_branch_right1", "pos_y", 1, 0, "", 
  { 
    0.0, 0, -2, 
    2.0, 0, 0,
    4.0, 0, -2
  } );

  ObjAnimate( "spr_menu_branch_right2", "ang", 1, 0, "", 
  { 
    0.0, 3, 0.02, 
    2.0, 3, -0.02,
    4.0, 3, 0.02 
  } );

  ObjAnimate( "spr_menu_branch_right2", "pos_y", 1, 0, "", 
  { 
    0.0, 0, -2, 
    2.0, 0, 0,
    4.0, 0, -2
  } );

end;
--******************************************************************************************
function private.clk_man()

  local func_after = function()
    common_impl.Lock( false );
    ObjSet( "spr_menu_man", { input = false });
  end;

  common_impl.Lock( true );

  common_impl.PlayAudio(  "sfx", "common/audio/aud_menu_click_owlman", 0 );

  ObjAnimate( "spr_menu_man", "alp", 0, 0, func_after, 
  { 
    0.0, 0, 1, 
    0.3, 0, 0.5,
    0.6, 0, 1,
    0.9, 0, 0
  } );

end;
--******************************************************************************************
function public.ButtonSetPos()

  local offwidth = 0.5 * ( GetAppWidth() - 1024 );

end;
--*****************************************************************************************
